#include "EnmHN4.h"
#include "..\Yam\YK7EffectBullet.h"

K7EnmHN4::K7EnmHN4(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
  K7EnmBoss( enemyid, suffix, pAnchor, prio, K7HN4, 0 )
{
  CopyPCPackMotion( K7KVN );

  // Gʂ̃f[^̃Zbg
  mData.mHp			= 100;								// go
  mData.mWeakID		= NPCWEAKOBJID_RARM;				// _
  mData.mVLossID		= NPCWEAKOBJID_LFOOT;				// ʐѕ
  mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
  mData.mScale		= 1.f;								// 
  WK7RenderObj::SetVfxFlag( false );					// {X͂ɂ傤ɂ؂
  hit_count = 0;
  WK7PLAYERCONTROL->SetPostPlayMotionCallBack(PlayerPostPlayMotionCallBack,(u32)this);
}
K7EnmHN4::~K7EnmHN4()
{
  WK7PLAYERCONTROL->SetPostPlayMotionCallBack(NULL,0);
}
bool K7EnmHN4::PlayerPostPlayMotionCallBack(WK7PlayerControlPlayMotionInfo *pInfo)
{
	if( pInfo->mParam==NULL ){
		return true;
	}
	K7EnmHN4	*pEnemy = (K7EnmHN4 *)pInfo->mParam;
	return pEnemy->_PlayerPostPlayMotionCallBack(pInfo);
}
bool K7EnmHN4::_PlayerPostPlayMotionCallBack(WK7PlayerControlPlayMotionInfo *pInfo)
{
	WK7Model	*pModel;
	if( mpNpcChara==NULL || (pModel = mpNpcChara->GetModel())==NULL ){
		return true;
	}
	switch( common_state ){
	case	0:
		break;
	case	1:
		switch( pInfo->mCommonID ){
		case	WK7MOTION_PCCMN_SHOTNOW:
		case	WK7MOTION_PCCMN_SHOTNOW_LONG:
			// ˌ
			WK7CharaMotion	*pCharaMotion = WK7MotionObj::GetCharaMotion(K7MOTID(K7HN4, 600));
			if( pCharaMotion==NULL ){
				break;
			}
			WK7ModelMotion	*pReloadMotion = pCharaMotion->GetModelMotion();
			if( pReloadMotion==NULL ){
				break;
			}
			pModel->StopMotion();
			pModel->DetachMotion();
			pModel->AttachMotion(pReloadMotion);
			pModel->PlayMotion(pInfo->mStartFrame,pInfo->mHokan,6.0f);
			pModel->SetMotionLoop(pInfo->mLoop);
			mDefMotSpeed = pInfo->mSpeed;
			if( hit_count >= 12 ){
				common_state = 2;
				hit_count = 0;
				WK7PLAYERCONTROL->SetManualVital(0.0f);
			}else{
				WK7PLAYERCONTROL->SetManualVital((12.0f - hit_count) / 12.0f);
			}
			return true;
		}
		break;
	default:
		return true;
	}
	WK7Npc::SetMotionIpFrame(pInfo->mIpFrame);
	PlayCommonMotion(pInfo->mCommonID,pInfo->mLoop,pInfo->mHokan,pInfo->mStartFrame,pInfo->mSpeed);
	WK7Npc::SetMotionIpFrame();
	return true;
}
bool K7EnmHN4::ControlProcess(void)
{
	bool yarareSe = false;
	
	switch( mState ){
	case NPC_STATE_INIT:
	NPC_CTRL_INIT_JUMP:
	StateInit();
	break;
	case NPC_STATE_WAIT:
	case NPC_STATE_WALK:
	case NPC_STATE_RUN:
	case NPC_STATE_TURN:
	case NPC_STATE_ATK:
	case NPC_STATE_DMG:
	case NPC_STATE_DMG_FALL:
	case NPC_STATE_LOSS:
	case NPC_STATE_DIE:
	default:
	break;
	}
	
	switch( common_state ){
	case	0:	//JnOB
		break;
	case	1:	//B
		if( DamageTest()==true ){
#if 0
//			WK7PLAYERCONTROL->PlayDamageEffect();
#else
			Vec pcRot = {0.f, 0.f, 0.f};
			int dmgVoiceNo;
			
			if ( rand()&1 ){
				// _[WOŉo
				WK7PLAYERCONTROL->SetPcDamage(mDamage.mDamPos, 0, 1, -1, 0);
			}else{
				if ( rand()&1 )	dmgVoiceNo = SFX_BOSS_HSM_DEAD_DAMAGE1;
				else			dmgVoiceNo = SFX_BOSS_HSM_DEAD_DAMAGE2;
				
				WK7PLAYERCONTROL->GetRotY(&pcRot.y);
				
				// ̃GtFNg
//				KK7BattleEffectCharaTypeBloodStart(	mDamage.mDamPos, K7KVN );
				
				// Voice
				gpSound->mPlaySE3D( dmgVoiceNo, mDamage.mDamPos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
				
				yarareSe = true;
			}
#endif
			++hit_count;
			Vec		pos;
			WK7JObj	*pJObj;
			Mtx		mtx,invmtx;
			GHM_VEC_SET_XYZ(&pos,0.0f,0.0f,1.0f);
			WK7CAM->GetViewingMtx(mtx);
			MTXInverse  (mtx,invmtx);
			MTXMultVecSR(invmtx,&pos,&pos);
			VECScale    (&pos,&pos,5.0f);
			if( (pJObj=mpNpcChara->GetJObj(K7CHRBONE_WRIST_L))==NULL ){
				VECAdd(&pos,&mDamage.mDamPos,&pos);
			}else{
				Vec		wristpos;
				pJObj->GetWorldPosition(wristpos);
				VECAdd(&pos,&wristpos,&pos);
			}
			CreateBulletEffect(BL_INV_KVN,pos);						// Pr̃iCt͂GtFNg
			gpSound->mPlaySE(SFX_BT_HIT_KNIFE_NO_DAMAGE);			// USE
			
			// UVoice
			if ( yarareSe == false ){
				gpSound->mPlaySE(SFX_BOSS_HSM_DEAD_ATTACK);			// USE
			}
		}
		break;
	case	2:
		if( GetCurrentMotionFrame() >= 28 ){
//			gpSound->mPlaySE(SFX_BOSS_HSM_DEAD_KIME);				//  dead
			common_state = 3;
		}
		break;
	case	3:
//		if( mpNpcChara->GetMotionState()==WK7MODEL_NOANIM ){
//			common_state = 4;
//		}
		break;
	default:
		break;
	}
	
	return false;
}
bool K7EnmHN4::FrameProcess(void)
{
  MotionProcess();
  if( mpNpcChara!=NULL ){
		
	if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
	  // [VXs[hRg[
	  MotionSpeedControl();
			
	  // ŏ̈ʒuZbg̎
	  if( !mFirstPosSet ){

		//̓͓ȂƓȂȂĂB040108
		mpNpcChara->SetVisible(true);
		mHideAlphaNow       = 1.0f;
		mFirstPosSet = 1;
		mpNpcChara->SetPosition(mPosition);
		// ꂪȂƑȂB
		switch( mpNpcChara->GetRenderID() ){
		case	WK7RENDEROBJ_INVALID_RENDERID:
		  //			case	WK7RENDEROBJ_RENDERID_MAX:
		case	WK7RENDEROBJ_RENDERID_DEFAULT:
		  mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
		  mpNpcChara->EnableVfxEffect();
		  break;
		default:
		  break;
		}
	  }

	}
  }
	
  return true;
}




