// nTzCg LbgRs[

#include "EnmHN6.h"
#include "..\Kaw\KK7Effect.h"

K7EnmHN6::K7EnmHN6(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
  K7EnmBoss( enemyid, suffix, pAnchor, prio, K7HN6, 0 )
{
  CopyPCPackMotion( K7CAT );
  // Gʂ̃f[^̃Zbg
  mData.mHp			= 100;								// go
  mData.mWeakID		= NPCWEAKOBJID_RARM;				// _
  mData.mVLossID		= NPCWEAKOBJID_LFOOT;				// ʐѕ
  mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
  mData.mScale		= 1.f;								// 
  WK7RenderObj::SetVfxFlag( false );					// {X͂ɂ傤ɂ؂
  hit_count = 0;
  WK7PLAYERCONTROL->SetPostPlayMotionCallBack(PlayerPostPlayMotionCallBack,(u32)this);
}
K7EnmHN6::~K7EnmHN6()
{
  WK7PLAYERCONTROL->SetPostPlayMotionCallBack(NULL,0);
}
bool K7EnmHN6::PlayerPostPlayMotionCallBack(WK7PlayerControlPlayMotionInfo *pInfo)
{
	if( pInfo->mParam==NULL ){
		return true;
	}
	K7EnmHN6	*pEnemy = (K7EnmHN6 *)pInfo->mParam;
	return pEnemy->_PlayerPostPlayMotionCallBack(pInfo);
}
bool K7EnmHN6::_PlayerPostPlayMotionCallBack(WK7PlayerControlPlayMotionInfo *pInfo)
{
	WK7Model	*pModel;
	if( mpNpcChara==NULL || (pModel = mpNpcChara->GetModel())==NULL ){
		return true;
	}
	switch( common_state ){
	case	0:
	case	1:
		break;
	default:
		return true;
	}
	WK7Npc::SetMotionIpFrame(pInfo->mIpFrame);
	PlayCommonMotion(pInfo->mCommonID,pInfo->mLoop,pInfo->mHokan,pInfo->mStartFrame,pInfo->mSpeed);
	WK7Npc::SetMotionIpFrame();
	return true;
}
bool K7EnmHN6::ControlProcess(void)
{
	Vec myPos;
	bool yarareSe = false;
	
	switch( mState ){
	case NPC_STATE_INIT:
	NPC_CTRL_INIT_JUMP:
	StateInit();
	break;
	case NPC_STATE_WAIT:
	case NPC_STATE_WALK:
	case NPC_STATE_RUN:
	case NPC_STATE_TURN:
	case NPC_STATE_ATK:
	case NPC_STATE_DMG:
	case NPC_STATE_DMG_FALL:
	case NPC_STATE_LOSS:
	case NPC_STATE_DIE:
	default:
	break;
	}
	
	GetPosition(myPos);
	
	switch( common_state ){
	case	0:
		break;
	case	1:
		if( DamageTest() ){
			
#if 0
//			WK7PLAYERCONTROL->PlayDamageEffect();
#else
			Vec pcRot = {0.f, 0.f, 0.f};
			int dmgVoiceNo;
			
			if ( rand()&1 ){
				// _[WOŉo
				WK7PLAYERCONTROL->SetPcDamage(mDamage.mDamPos, 0, 1, -1, 0);
			}else{
				if ( rand()&1 )	dmgVoiceNo = SFX_BOSS_HSM_WHTPEARL_DAMAGE1;
				else			dmgVoiceNo = SFX_BOSS_HSM_WHTPEARL_DAMAGE2;
				
				WK7PLAYERCONTROL->GetRotY(&pcRot.y);
				
				// ̃GtFNg
				KK7BattleEffectCharaTypeBloodStart(	mDamage.mDamPos, K7CAT );
				
				// Voice
				gpSound->mPlaySE3D( dmgVoiceNo, mDamage.mDamPos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
				yarareSe = true;
			}
#endif
			
			if( ++hit_count >= 30 ){
				common_state = 2;
				WK7Npc::SetMotionIpFrame(WK7PLAYER_INTERPOLATE_FRAME);
//				PlayCommonMotion( (u32)WK7MOTION_PCCMN_DIE_F, false, true );
				PlayCommonMotion( (u32)WK7MOTION_NPCCMN_STAND, false, true );
				WK7Npc::SetMotionIpFrame();
				
				// ڋʂ\ゾHP炷
				WK7PLAYERCONTROL->SetManualVital(0.0f);
			}else{
				
				// UVoice
				if ( yarareSe == false ){
					gpSound->mPlaySE( SFX_BOSS_HSM_WHTPEARL_ATTACK );	// rdĐ
				}
				
				// ڋʂ\ゾHP炷
				WK7PLAYERCONTROL->SetManualVital((30.0f-hit_count)/30.0f);
			}
		}
		break;
	default:
		break;
	}
	
	return false;
}
bool K7EnmHN6::FrameProcess(void)
{
  MotionProcess();
  if( mpNpcChara!=NULL ){
		
	if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
	  // [VXs[hRg[
	  MotionSpeedControl();
			
	  // ŏ̈ʒuZbg̎
	  if( !mFirstPosSet ){

		//̓͓ȂƓȂȂĂB040108
		mpNpcChara->SetVisible(true);
		mHideAlphaNow       = 1.0f;
		mFirstPosSet = 1;
		mpNpcChara->SetPosition(mPosition);
		// ꂪȂƑȂB
		switch( mpNpcChara->GetRenderID() ){
		case	WK7RENDEROBJ_INVALID_RENDERID:
		  //			case	WK7RENDEROBJ_RENDERID_MAX:
		case	WK7RENDEROBJ_RENDERID_DEFAULT:
		  mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
		  mpNpcChara->EnableVfxEffect();
		  break;
		default:
		  break;
		}
	  }

	}
  }
	
  return true;
}




