// nTS[h R[eRs[

#include "EnmHN9.h"
#include "..\Kaw\KK7Effect.h"

K7EnmHN9::K7EnmHN9(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
  K7EnmBoss( enemyid, suffix, pAnchor, prio, K7HN9, 0 )
{
  CopyPCPackMotion( K7CYO );
  // Gʂ̃f[^̃Zbg
  mData.mHp			= 100;								// go
  mData.mWeakID		= NPCWEAKOBJID_RARM;				// _
  mData.mVLossID		= NPCWEAKOBJID_LFOOT;				// ʐѕ
  mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
  mData.mScale		= 1.f;								// 
  WK7RenderObj::SetVfxFlag( false );					// {X͂ɂ傤ɂ؂
  hit_count = 0;
  WK7PLAYERCONTROL->SetPostPlayMotionCallBack(PlayerPostPlayMotionCallBack,(u32)this);
}
K7EnmHN9::~K7EnmHN9()
{
  WK7PLAYERCONTROL->SetPostPlayMotionCallBack(NULL,0);
}
bool K7EnmHN9::PlayerPostPlayMotionCallBack(WK7PlayerControlPlayMotionInfo *pInfo)
{
	if( pInfo->mParam==NULL ){
		return true;
	}
	K7EnmHN9	*pEnemy = (K7EnmHN9 *)pInfo->mParam;
	return pEnemy->_PlayerPostPlayMotionCallBack(pInfo);
}
bool K7EnmHN9::_PlayerPostPlayMotionCallBack(WK7PlayerControlPlayMotionInfo *pInfo)
{
	WK7Model	*pModel;
	if( mpNpcChara==NULL || (pModel = mpNpcChara->GetModel())==NULL ){
		return true;
	}
	switch( common_state ){
	case	0:
	case	1:
		break;
	default:
		return true;
	}
	WK7Npc::SetMotionIpFrame(pInfo->mIpFrame);
	PlayCommonMotion(pInfo->mCommonID,pInfo->mLoop,pInfo->mHokan,pInfo->mStartFrame,pInfo->mSpeed);
	WK7Npc::SetMotionIpFrame();
	return true;
}
bool K7EnmHN9::ControlProcess(void)
{
  switch( mState ){
  case NPC_STATE_INIT:
  NPC_CTRL_INIT_JUMP:
  StateInit();
  break;
  case NPC_STATE_WAIT:
  case NPC_STATE_WALK:
  case NPC_STATE_RUN:
  case NPC_STATE_TURN:
  case NPC_STATE_ATK:
  case NPC_STATE_DMG:
  case NPC_STATE_DMG_FALL:
  case NPC_STATE_LOSS:
  case NPC_STATE_DIE:
  default:
	break;
  }
	
	switch( common_state ){
	case	0:
		break;
	case	1:
		if( DamageTest() ){
			if( mDamage.mDamPos.y < 10.f ){
				//̂قɓ瑫Ƃ݂ȂB
				WK7Npc::SetMotionIpFrame(WK7PLAYER_INTERPOLATE_FRAME);
				PlayCommonMotion( (u32)WK7MOTION_PCCMN_DIE_F, false, true );
				WK7Npc::SetMotionIpFrame();
				common_state = 2;
				// 
				gpSound->mPlaySE(SFX_BOSS_HSM_RED_DIE);
			}else{
				// ĂȂGtFNg
				KK7HitNoDamageEffect(mDamage.mDamPos, mDamage.mDamPos, DAMTYPE_NORMAL, K7CYO, mWeakObj[NPCWEAKOBJID_WAIST].mpBone, 0 );
				
				WK7PLAYERCONTROL->PlayDamageEffect();
				f32		vital = WK7PLAYERCONTROL->GetManualVital();
static			f32		dvital = 0.1f;
				if( vital > 0.1f + dvital ){
					vital -= dvital;
					// _[WOŉoivC[
					WK7PLAYERCONTROL->SetPcDamage(mDamage.mDamPos, 0, 1, -1, 0);
					
				}else{
					vital = 0.1f;
				}
				WK7PLAYERCONTROL->SetManualVital(vital);
				
				// UVoice
				if ( rand()&1 ){
					gpSound->mPlaySE( SFX_BOSS_HSM_GOLD_ATTACK );	// rdĐ
				}
			}
		}
		break;
	default:
		break;
	}
	return false;
}
bool K7EnmHN9::FrameProcess(void)
{
  MotionProcess();
  if( mpNpcChara!=NULL ){
		
	if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
	  // [VXs[hRg[
	  MotionSpeedControl();
			
	  // ŏ̈ʒuZbg̎
	  if( !mFirstPosSet ){

		//̓͓ȂƓȂȂĂB040108
		mpNpcChara->SetVisible(true);
		mHideAlphaNow       = 1.0f;
		mFirstPosSet = 1;
		mpNpcChara->SetPosition(mPosition);
		// ꂪȂƑȂB
		switch( mpNpcChara->GetRenderID() ){
		case	WK7RENDEROBJ_INVALID_RENDERID:
		  //			case	WK7RENDEROBJ_RENDERID_MAX:
		case	WK7RENDEROBJ_RENDERID_DEFAULT:
		  mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
		  mpNpcChara->EnableVfxEffect();
		  break;
		default:
		  break;
		}
	  }

	}
  }
	
  return true;
}




