////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmKIS.h
//
// Creator       : Kawa
// Creation Date : 10/06/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMKIS_H__
#define	__ENMKIS_H__

#include "..\Wat\WK7Enemy.h"
#include "EnmBoss.h"
#include "..\Yam\YK7EffectHeader.h"
#include "..\Wat\WK7Model.h"

class K7EnmKIS : public K7EnmBoss{
protected:
	EFFECT		*mpTimer;					// ԕ\
	u32			mTimerEffectID;
	EFFECT		*mpResultScore;				// ʕ\PC
	u32			mResultScoreEffectID;
	
	u32			mHitNum[2];
	u8			mNoHit;
	
	void		Dummy( void );
	u32			mInitProcess;				// ǂݍ݃Xe[^Xp
	WK7Model 	*mpGun[2];					// ef
	s16			mSecondShotTiming;			// Qڂ̃^C~O
	s16			mBulletNow;					// e
	s16			mShotNum;					// VbgJEgp
	u8			mPauseChk;					// |[Y`FbN
	
	u32			mBattleCount;				// og̎
	u32			mBattleProcess;				// og̊Ǘ
	bool		mBatteleExit;				// og̏I}
	
	void		PcDamageSet(int side=0);
	void		DieMotSet(void);
	void		DamageMotSet(void);
	void		WeakPointChange(void);
	void 		DetachGun(void);
	void 		Release(void);
	
	void 		TimerRelease(void);
	bool 		ScoreCreate(s32 playernum, s32 enemynum);
	void 		ScoreRelease(void);
	
	void 		KisReload(void);
	
public:
	static	int	mKisBattleStart;
	K7EnmKIS(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
	~K7EnmKIS();
	
	
	bool	FrameProcess(void);
	bool	ControlProcess(void);
	

	void	StageProc(void);
	bool	KISBossEnd(void);
};


#ifdef	__ENMKIS_CPP__

#define KIS_HP				(150)			// LXMgo
#define KIS_GUN_BULLET_MAX	(12*2)

#define GUN_R				GUN_KIMBRPS_R
#define GUN_L				GUN_KIMBRPS_L

enum KIS_MOT{
	KIS_MOT_WAIT = 0,		// R
	KIS_MOT_SHOTPOSE,		// ˌ\
	KIS_MOT_SHOTFREE,		// ˌR
	KIS_MOT_SHOTNOW,		// ˌ
	KIS_MOT_SHOTNOWLOOP,	// ˌ[v
	KIS_MOT_SHOTRETURN,		// ˌ\
	KIS_MOT_RELOAD,			// [h
	KIS_MOT_DAM,			// _[W
	KIS_MOT_DIE,			// S
	KIS_MOT_MAX
};

#define KIS_WEAKPOS_MAX		(3)
char *pKISWeakObjNameTable[KIS_WEAKPOS_MAX] = {
	K7CHRBONE_SKULL,		// 
	K7CHRBONE_HUMERUS_R1,	// Er
	K7CHRBONE_HUMERUS_L1,	// r
};

#else

#endif

#endif	//__ENMKIS_H__

