////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object AiU[
//
// EnmN.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMN_CPP__

#include "EnmN.h"

#define MDLCODE_ID				(2)			// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(2)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeNMotionIdTable[] = {
	0,							// R
	0,							// 
	0,							// 
	0,							// ^[E
	0,							// ^[
	0,							//	^[
	0,							// UĂѓiNu쓮j
	0,							// 85cmɍU
	0,							// 150cmɍU
	0,							// _[WO
	0,							// _[W
	0,							// _[WO
	0,							// _[W
	0,							// _[WEO
	0,							// _[WE
	0,							// _[WO
	0,							// _[W
	0,							// _[WEgO
	0,							// _[WEg
	0,							// _[WgO
	0,							// _[Wg
	0,							// _[WӂƂу_EOiSj
	0,							// _[Wу_EiSj
	0,							// _[WE _E
	0,							// _[W _E
	330,						// _ER
	340,						// _E_[W
	350,						// _EȂ
	950,						// _EȂ瑖
	400,						// _E玀S
	440,						// _E85cmɍU
	430,						// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	500,						// ݍUi_j
	650,						// ݍUiRj
	450,						// ݍUiJGfj
	460,						// ݍUiR[ej
	470,						// ݍUi}XNj
	490,						// ݍUiPrj
	570,						// iAiU[X}CpjV䒣tҋ@
	580,						// iAiU[X}CpjVA
	590,						// iAiU[X}CpjVA
	600,						// iAiU[X}CpjVA
	610,						// iAiU[X}CpjVA󒆗R
	620,						// iAiU[X}CpjVA󒆗`nA͂
	-1
};

// e[u
static int eneFootSeTbl[] = {
	SFX_BT_HS_FOOT_STEP00,
	SFX_BT_HS_FOOT_STEP01,
	SFX_BT_HS_FOOT_STEP02,
	SFX_BT_HS_FOOT_STEP03,
	SFX_BT_HS_FOOT_STEP04,
	SFX_BT_HS_FOOT_STEP05
};

K7EnmN::K7EnmN(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeNMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	switch (rand()%3){										// 㔼ĝ
	case 0:
		mData.mWeakID	= NPCWEAKOBJID_RARM;
		break;
	case 1:
		mData.mWeakID	= NPCWEAKOBJID_HEAD;
		break;
	case 2:
		mData.mWeakID	= NPCWEAKOBJID_LARM;
		break;
	}
	mData.mVLossID		= NPCWEAKOBJID_LFOOT;				// ʐѕ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;					// 
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mCounterKurai	= 1;
	mData.mCeiling		= 1;
}

void K7EnmN::FootSeRun(Vec myPos)
{
	// ̂͂葖SE
	if(	(pCurrentChara()!=NULL)
	&&	(mData.mFootSe != 0)
	){
		WK7Model *pModel = pCurrentChara()->GetModel();
		if ((16  == GetCurrentMotionFrame())
		||	(32 == GetCurrentMotionFrame())
		){
			gpSound->mPlaySE3D( (int )eneFootSeTbl[rand()%6], myPos, 0 );		// rdĐ
			
			if( 16 == GetCurrentMotionFrame() ){
				// AE
				FootPaintTestSet(NPCWEAKOBJID_LARM,		0);
				FootPaintTestSet(NPCWEAKOBJID_RFOOT,	1);
			}else{
				FootPaintTestSet(NPCWEAKOBJID_RARM,		1);
				FootPaintTestSet(NPCWEAKOBJID_LFOOT,	0);
			}
			
		}
	}
}


