////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object obNX}C
//
// EnmS.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMS_CPP__

#include "EnmS.h"

#define MDLCODE_ID				(8)			// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(8)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeSMotionIdTable[] = {
	20,							// R
	50,							// 
	0,							// 
	0,							// ^[E
	0,							// ^[
	140,						// ^[
	0,							// UĂѓiNu쓮j
	100,						// 85cmɍU
	100,						// 150cmɍU
	150,						// _[WO
	180,						// _[W
	0,							// _[WO
	180,						// _[W
	190,						// _[WEO
	0,							// _[WE
	200,						// _[WO
	300,						// _[W
	210,						// _[WEgO
	0,							// _[WEg
	230,						// _[WgO
	0,							// _[Wg
	260,						// _[WӂƂу_EOiSj
	250,						// _[Wу_EiSj
	0,							// _[WE _E
	0,							// _[W _E
	0,							// _ER
	0,							// _E_[W
	0,							// _EȂ
	0,							// _EȂ瑖
	0,							// _E玀S
	0,							// _E85cmɍU
	0,							// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	500,						// ݍUi_j
	650,						// ݍUiRj
	450,						// ݍUiJGfj
	460,						// ݍUiR[ej
	470,						// ݍUi}XNj
	490,						// ݍUiPrj
	0,							// iAiU[X}CpjV䒣tҋ@
	0,							// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA󒆗R
	0,							// iAiU[X}CpjVA󒆗`nA͂
	500,						// _[WE]
	510,						// _[W]
	-1
};

#define EXTRA_PARTS_NAME	"Weak"

K7EnmS::K7EnmS(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeSMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= -1;
	mData.mVLossID		= -1;								// ʐѕij
	mData.mFootSe		= SFX_BT_BAHS_FUYU;					// 
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;					// _
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mTypeBig		= 1;
	mData.mCounterKurai	= 0;								// JE^[֎~
}



/*
	
	
	p_[hc̊蓖
	
	
*/
void K7EnmS::PartsRenderIDSet(void)
{
	u32 renderidex;
	WK7Model *pModel = pCurrentChara()->GetModel();
	
	renderidex = WK7RenderObj::GetUniqueRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
	pCurrentChara()->SetRenderIDEx(renderidex);
	
	// ʂJOBJƂĂ
	if ( pModel != NULL ){
		WK7JObj *pJOBJ;
		pJOBJ   = pModel->GetObj(EXTRA_PARTS_NAME);					// IuWF񂷂̂ǂ
		if ( pJOBJ != NULL ){
			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂OKȏꍇ
//			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂ȏꍇ
		}
	}
}



#define R_FOOT_TIMING	2
#define L_FOOT_TIMING	28
void K7EnmS::FootSeRun(Vec myPos)
{
	if(	(pCurrentChara()!=NULL)
	&&	(mData.mFootSe != 0)
	){
		WK7Model *pModel = pCurrentChara()->GetModel();
		if ((R_FOOT_TIMING  == GetCurrentMotionFrame())
		||	(L_FOOT_TIMING == GetCurrentMotionFrame())
		){
			gpSound->mPlaySE3D( mData.mFootSe, myPos, 0 );		// rdĐ
		}
	}
}
void K7EnmS::FootSeWalk(Vec myPos)
{
	if(	(pCurrentChara()!=NULL)
	&&	(mData.mFootSe != 0)
	){
		WK7Model *pModel = pCurrentChara()->GetModel();
		if (R_FOOT_TIMING  == GetCurrentMotionFrame()){
//		||	(L_FOOT_TIMING == GetCurrentMotionFrame())
//		){
			gpSound->mPlaySE3D( mData.mFootSe, myPos, 0 );		// rdĐ
		}
	}
}

bool K7EnmS::DamageMotionSelect(s16 frontFlag, u32 *pInSetMotID)
{
#pragma unused(frontFlag)
	*pInSetMotID = GetBackHSDmgMot(frontFlag);
	return true;
}


/*
	
	
	obNHS̖Gȃ^C~O
	
	<return>
	true			G
	false			GȂ
	
*/
bool K7EnmS::GetNoDamage(void)
{
	// ]ꒆ͖G
	if ((mMotID == WK7MOTION_NPCCMN_DMG_R_ROLL)
	||	(mMotID == WK7MOTION_NPCCMN_DMG_L_ROLL)
	){
		return true;
	}
	
	// ʍETChꒆ݂̍^C~O͖G
	if ((mMotID == WK7MOTION_NPCCMN_DMG_LSIDE_F)
	&&	(72 >= GetCurrentMotionFrame())
	&&	(18 <= GetCurrentMotionFrame())
	){
		return true;
	}
	if ((mMotID == WK7MOTION_NPCCMN_DMG_RSIDE_F)
	&&	(72 >= GetCurrentMotionFrame())
	&&	(18 <= GetCurrentMotionFrame())
	){
		return true;
	}
	return false;
}




