////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Objec
//
// EnmSPD.cpp			J Xs[hX}Cp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMSPD_CPP__

#include "EnmSPD.h"

#define MDLCODE_ID				(2)			// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(2)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeSPDMotionIdTable[] = {
	520,						// R
	521,						// 
	521,						// 
	120,						// ^[E
	130,						// ^[
	140,						// ^[
	60,							// UĂѓiNu쓮j
	420,						// 85cmɍU
	410,						// 150cmɍU
	150,						// _[WO
	160,						// _[W
	170,						// _[WO
	180,						// _[W
	190,						// _[WEO
	290,						// _[WE
	200,						// _[WO
	300,						// _[W
	210,						// _[WEgO
	220,						// _[WEg
	230,						// _[WgO
	240,						// _[Wg
	260,						// _[WӂƂу_EOiSj
	250,						// _[Wу_EiSj
	310,						// _[WE _E
	320,						// _[W _E
	330,						// _ER
	340,						// _E_[W
	350,						// _EȂ
	360,						// _EȂ瑖
	400,						// _E玀S
	440,						// _E85cmɍU
	430,						// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
//	680,						// ꎩR̂̂QiXs[hpj
	520,						// ꎩR̂̂QiXs[hpj
	660,						// Xs[hX}CsJn
	670,						// Xs[hX}C
	500,						// ݍUij
	-1
};


K7EnmSPD::K7EnmSPD(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor,int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeSPDMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go(Ƀf[^̕ŏ)
	mData.mWeakID		= NPCWEAKOBJID_HEAD;				// _
	mData.mVLossID		= (s16 )(rand()%NPCWEAKOBJID_MAX);
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP03;
	mData.mScale		= 1.f;
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mAtkPower1	= 1000;
	mData.mAtkPower2	= 1000;
}

f32 K7EnmSPD::GetWalkSpeed(void)
{
	// [VړʂZo
	return 0.33f;
}
f32 K7EnmSPD::GetRunSpeed(void)
{
	// [VړʂZo
	return 0.33f;
}


/*
	
	R̃[V̍Đ
	
	hokan		true....ۊǂ
				false...ۊǂȂ
	
*/
bool K7EnmSPD::MotSet_Wait(bool hokan)
{
	u32 standMotID;
	u32 Frame = GetCurrentMotionFrame();

	DmgSpeedSet(1.f);
	
	standMotID = WK7MOTION_NPCCMN_STAND;
	
	// [VĐ
	if ( mMotID != standMotID ){
		
		MotPlayInit(NPC_POSMODE_PROG);
		mMovePosMode = NPC_POSMODE_PROG;
		if ( hokan ){
			if( false == PlayCommonMotion(standMotID, true, true, 0.f) ){
				return false;
			}
		}else{
			if( false == PlayCommonMotion(standMotID, true, false, 0.f) ){
				return false;
			}
		}
	}else{
		if ( Frame >= 36.f ) {
			StopCommonMotion();
		}
	}
	return true;
}


