////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object WCAgX}C
//
// EnmU.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMU_CPP__

#include "EnmU.h"
#include "..\Wat\EnmList.h"
#include "..\Kaw\KK7Effect.h"

#define MDLCODE_ID				(24)		// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(2)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeUMotionIdTable[] = {
	20,							// R
	50,							// 
	90,							// 
	120,						// ^[E
	130,						// ^[
	140,						// ^[
	0,							// UĂѓiNu쓮j
	530,						// 85cmɍU
	530,						// 150cmɍU
	150,						// _[WO
	160,						// _[W
	170,						// _[WO
	180,						// _[W
	190,						// _[WEO
	290,						// _[WE
	200,						// _[WO
	300,						// _[W
	210,						// _[WEgO
	220,						// _[WEg
	230,						// _[WgO
	240,						// _[Wg
	260,						// _[WӂƂу_EOiSj
	250,						// _[Wу_EiSj
	310,						// _[WE _E
	320,						// _[W _E
	330,						// _ER
	340,						// _E_[W
	350,						// _EȂ
	360,						// _EȂ瑖
	400,						// _E玀S
	440,						// _E85cmɍU
	430,						// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	0,							// ݍUi_j
	0,							// ݍUiRj
	0,							// ݍUiJGfj
	0,							// ݍUiR[ej
	0,							// ݍUi}XNj
	0,							// ݍUiPrj
	0,							// iAiU[X}CpjV䒣tҋ@
	0,							// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA󒆗R
	0,							// iAiU[X}CpjVA󒆗`nA͂
	0,							// _[WE]
	0,							// _[W]
	1100,						// p[cAj[Vp
	0,							// f
	0,							// f
	-1
};

#define JAIAN_ZOOM			(3.f)
#define JAIAN_ATK_DIST		(60.f)

// WCAgwuX}C̔j͈
#define JAIAN_ATKBOMB_DIST			(24.f)
#define JAIAN_ATKMOT_BOMBOKFRAME	(150.f)		// jOKȃt[

#define EXTRA_PARTS_NAME		"Medama"
#define K7ENM_JAIA_HEADNAME		"Eyelid"

K7EnmU::K7EnmU(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeUMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= -1;
	mData.mVLossID		= -1;								// ʐѕ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= JAIAN_ZOOM;						// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mCounterKurai	= 0;								// JE^[U炢s
	mData.mAtkDist		= JAIAN_ATK_DIST;
	mData.mAtkDistBk	= mData.mAtkDist;
	
	mData.mAtkDist		= JAIAN_ATK_DIST;
	mData.mAtkDistBk	= mData.mAtkDist;
	
	mMabuta = true;
	mDownEfc = false;
}


/*
	
	
	mobZbgi^Cvj
	
	
	
*/
void K7EnmU::EneTypeReset(void)
{
	// ږ߂
	MabutaDisp();
	mDownEfc = false;
}

/*
	
	
	p_[hc̊蓖
	
	
*/
void K7EnmU::PartsRenderIDSet(void)
{
	u32 renderidex;
	WK7Model *pModel = pCurrentChara()->GetModel();
	
	renderidex = WK7RenderObj::GetUniqueRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
	pCurrentChara()->SetRenderIDEx(renderidex);
	
	// ʂJOBJƂĂ
	if ( pModel != NULL ){
		WK7JObj *pJOBJ;
		pJOBJ   = pModel->GetObj(EXTRA_PARTS_NAME);					// IuWF񂷂̂ǂ
		if ( pJOBJ != NULL ){
			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂OKȏꍇ
//			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂ȏꍇ
		}
	}
}


/*
	
	
	ꃂ[V̍Đ
	
	
*/
bool K7EnmU::MotSet_Extra(void)
{
	WK7Chara		*pCharaTmp;
	WK7Model		*pModel;
	WK7CharaMotion	*pCharaMotion;
	WK7ModelMotion	*pModelMotion;
	
	u32 id = WK7MOTION_NPCCMN_EXT_PARTS;
	
	pCharaTmp = pCurrentChara();
	if( pCharaTmp==NULL )										return false;
	if( (pModel = pCharaTmp->GetModel()) == NULL )				return false;
	if ( mpNpcMotion[id] == NULL )								return false;
	if( (pCharaMotion=mpNpcMotion[id]->GetMotion())==NULL )		return false;
	if( (pModelMotion=pCharaMotion->GetModelMotion())==NULL )	return false;
	
	// VK[V̓o^
	mpObjExtra = pModel->AttachMotion(	pModelMotion,
										K7ENM_JAIA_HEADNAME,
										NULL,
										false,
										true
	);
	if ( mpObjExtra == NULL )									return false;
	if ( true == mpObjExtra->PlayMotion(0.f,false,0.0f,false,true) ){					//  startframe
		mpObjExtra->SetMotionLoop(true, false, true);									//  loop
		mpObjExtra->SetMotionOperation(false, false, true);								// falseɂƁÃIuWFNg̓[V삪ȂȂ܂Bi͂łj
	}
	
	return true;
}



/*
	
	
	U[V
	
	
	<return>
	true	VK[VZbgꂽ
	false	[V̂܂
	
*/
bool K7EnmU::MotStatus_Atk(void)
{
	int seNo;

	// ݍU\m点
	KerenmiSignalCall();
	
	// ڂ̂܂Ԃ
	MabutaHide();
	
	if ( JAIAN_ATKMOT_BOMBOKFRAME <= GetCurrentMotionFrame() ){
		// lɑ΂čUǂ̃eXg
		Vec waistPos = {0.f, 0.f, 0.f};
		Vec enePos, opePos;
		f32 dist;
		bool bombOnly = false;
		
		if ( mWeakObj[NPCWEAKOBJID_WAIST].mpBone != NULL ){
			mWeakObj[NPCWEAKOBJID_WAIST].mpBone->GetWorldPosition(&waistPos);
		}else{
			return false;
		}
		if ( pCurrentChara() != NULL ){
			pCurrentChara()->GetPosition(enePos);
		}else{
			return false;
		}
		
		opePos = mOperationPos;
		opePos.y = enePos.y;
		dist = GHM_VEC_GET_DIST(&waistPos, &opePos);
		
		if ( (false == mDownEfc) && (166 < GetCurrentMotionFrame()) ){
			mDownEfc = true;
			Vec efcPos;
			
			efcPos.x = waistPos.x;
			efcPos.y = enePos.y;
			efcPos.z = waistPos.z;
			// 
			KK7JaiaHSSmokeEffect(efcPos);
			
			// HS hTbƓ|
			seNo = gpSound->mPlaySE3D(SFX_BT_GHS_DOWN, efcPos, 1, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
			gpSound->mSetPitchSENo( seNo, (s16 )-400 );			// 100 ́@{l
		}
		
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
			bombOnly = true;
			goto JAIA_BOMB_OK;
		}
		if (dist < JAIAN_ATKBOMB_DIST ){											// Δj
JAIA_BOMB_OK:
			// wuX}C
			SetVisible(false);
			// jnj
			KK7BattleEffectHSExplode(waistPos, 0, 2.f);
			if ( bombOnly == false ){
				// lɂqbgtO𗧂Ă
				WK7PLAYERCONTROL->SetPcDamage(waistPos, (s16 )mData.mAtkPower1);
			}
			MotSet_Loss();
			SetEnemyDieInfo(NPC_DIE_JIBAKU);
			mWaitCount = 8;
//			NpcRePopTest();
			
			return true;
		}
	}
	
	return false;
}


void K7EnmU::MabutaHide(void)
{
	WK7Model *pModel = pCurrentChara()->GetModel();
	WK7JObj *pJOBJ;
	if ( NULL != pModel ){
		pJOBJ = pModel->GetObj(K7ENM_JAIA_HEADNAME);
		if ( pJOBJ != NULL ){
			pJOBJ->Hide(false, false);
		}
	}
	mMabuta = false;
}

void K7EnmU::MabutaDisp(void)
{
	WK7Model *pModel = pCurrentChara()->GetModel();
	WK7JObj *pJOBJ;
	if ( NULL != pModel ){
		pJOBJ = pModel->GetObj(K7ENM_JAIA_HEADNAME);
		if ( pJOBJ != NULL ){
			pJOBJ->Disp(false, false);
		}
	}
	mMabuta = true;
}

void K7EnmU::VisibleTestDisp(void)
{
	WK7Model *pModel;
	if( (pModel = pCurrentChara()->GetModel())!=NULL ){
		pModel->Disp();
		if ( true == mMabuta ){
			MabutaDisp();
		}else{
			MabutaHide();
		}
	}
}

void K7EnmU::VisibleTestHide(void)
{
	WK7Model *pModel;
	if( (pModel = pCurrentChara()->GetModel())!=NULL ){
		pModel->Hide();
	}
}

// [VړʂZo
f32 K7EnmU::GetWalkSpeed(void)
{
	// [VړʂZo
	f32 Speed = WALK_SPEED_MOT / (GetFTotalMotionFrame() / WK7_FRAME_COUNT);
	Speed *= JAIAN_ZOOM;
	return Speed;
}
f32 K7EnmU::GetRunSpeed(void)
{
	// [VړʂZo
	f32 Speed = RUN_SPEED_MOT / (GetFTotalMotionFrame() / WK7_FRAME_COUNT);
	Speed *= JAIAN_ZOOM;
	return Speed;
}
