/*

 	KK7Effect.cpp

 	Creator       : Kawakami Satoshi (GHM)
 	Creation Date : 02/16/2003

*/

#define	__KK7EFFECT_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "..\Wat\K7App.h"
#include "..\Fujita\C_Font.h"
//#include "..\Yam\YK7EffectHeader.h"
#include "..\Yam\YK7EffectDamageBlood.h"
#include "..\Yam\YK7EffectHitMark.h"
#include "..\Yam\YK7EffectVLoss.h"
#include "..\Yam\YK7EffectHSExplode.h"
#include "..\Yam\YK7EffectHSDead.h"
#include "..\Yam\YK7EffectConveBlood.h"
#include "..\Yam\YK7EffectFlyBullet.h"
#include "..\Yam\YK7EffectKLine.h"
#include "..\Yam\YK7EffectLineRoll.h"
#include "..\Yam\YK7EffectExplode.h"
#include "..\Yam\YK7EffectFlower.h"
#include "..\Yam\YK7EffectSpSkillGage.h"
#include "..\Yam\YK7EffectSmoke.h"
#include "..\Yam\YK7EffectEasyAnim.h"
#include "..\Yam\YK7EffectMessage2.h"
#include "..\Yam\YK7EffectDamage.h"
#include "..\Yam\YK7EffectSkill.h"
#include "..\Yam\YK7EffectGravity.h"
#include "..\Yam\YK7EffectBullet.h"
#include "..\Yam\YK7EffectFlash.h"

#include "..\Wat\WK7Sight.h"
#include "..\Wat\WK7Player.h"
#include "KK7Effect.h"
#include "..\Matsu\mK7Flush.h"
#include "..\Wat\EnmList.h"
#include "..\Kaw\KK7BattleCtrl.h"


#define WEAKPOS_DIV_NUM	(6)

#if 0
//	
//	/*
//		
//		
//		ʉFɃtbV
//		
//		
//	*/
//	GHMGCTASK_HANDLER(kk7ScreenFlush)
//	{
//		KK7PrimController	*pKK7PrimController = (KK7PrimController *)GHMGCTASK_GETPARAM(0);
//		KK7Texture			mTex;				// eNX`
//		KK7Prim				mSprite;			// XvCg
//		KK7Util				util;
//		s16					frame;
//	
//		task_exit();
//	
//		mTex.mpHeadTex =NULL;
//		mSprite.Init(pKK7PrimController, &mTex);
//		mSprite.w	= (s16)640;
//		mSprite.h	= (s16)480;
//		mSprite.x0	= 50;
//		mSprite.y0	= 100;
//		mSprite.rgba= 0xffff0080;
//		
//		frame = 8;
//		do{
//			u32		texSize;
//			u16		w, h;
//			
//			if( mTex.mpHeadTex != NULL ){
//				util.FreeTexture( &mTex );
//			}
//			
//			//eNX`̕ƍ߂
//			w = 640;
//			h = 480;
//			
//			//eNX`ɕKvȃm
//			texSize			= GXGetTexBufferSize( w, h, GX_TF_IA8, GX_FALSE, 0 );
//			texSize		   += sizeof(GhmGcTexHeader);
//			mTex.mpHeadTex	= (GhmGcTexHeader*)ghmGcMemAlloc( (int)texSize );
//			
//			//eNX`ݒ
//			mTex.mpHeadTex->mImagePtr	= sizeof(GhmGcTexHeader);
//			mTex.mpHeadTex->mWidth		= w;
//			mTex.mpHeadTex->mHeight		= h;
//			
//			//EFBeNX`؂o
//			GXSetTexCopySrc( 0, 0, w, h );
//			GXSetTexCopyDst( w, h, GX_TF_IA8, GX_FALSE );
//			GXCopyTex( (void*)((u32)mTex.mpHeadTex + mTex.mpHeadTex->mImagePtr), GX_FALSE );
//			GXPixModeSync();
//			GXInvalidateTexAll();
//			
//			//eNX`
//			GXInitTexObj( &mTex.obj,
//						  (void*)((u32)mTex.mpHeadTex + mTex.mpHeadTex->mImagePtr),
//						  w,
//						  h,
//						  GX_TF_IA8,
//						  GX_CLAMP,
//						  GX_CLAMP,
//						  GX_FALSE );
//			
//			//XvCg\
//			mSprite.flag	|= 0x1;
//			
//			retsys();
//			frame--;
//		}while(frame);
//		
//		retsys();
//		
//		// Exit
//		mSprite.Term(pKK7PrimController);
//		util.FreeTexture( &mTex );
//		
//		task_exit();
//		
//		
//}

#endif


/*
	
	
	퓬 ̃GtFNgiftHgj
	
	
	<in>
	pPos GtFNgo|WV
	
*/
bool KK7BattleDefaultBloodStart(Vec shotPos, f32 yukaY, Vec shotDir, WK7JObj *pObj)
{
	Vec vecp;
	f32 distzx;

	// Jf[^Ƃĕϊ
	distzx = cosf(shotDir.x);
	vecp.y = sinf(shotDir.x);
#if 1
	vecp.x = distzx * sinf(shotDir.y );
	vecp.z = distzx * cosf(shotDir.y);
#else
//	{
//		f32 rotY;
//		rotY = shotDir.y + PI;
//		GHM_LIMIT_RANGE(rotY, PI, -PI);
//		vecp.x = distzx * sinf(rotY);
//		vecp.z = distzx * cosf(rotY);
//	}
#endif

	CreateHitMarkEffect(0,				// DamagePower ߁F0 :1 傾:2
						shotPos,		// _[Wʒu
						vecp,			// _[W
						pObj,
						yukaY + 0.1F	// ̍
	);
	return true;
}


/*
	
	
	퓬 ̃GtFNgiLʁj
	
	
	<in>
	pPos	GtFNgo|WV
	mainID	LN^[^Cv
	YukaY	̍iPr̂݁j
	pObj	WK7JObj|C^iPr̂݁j
	
*/
EFFECT *KK7BattleEffectCharaTypeBloodStart(Vec shotPos, u32 mainID, f32 YukaY, WK7JObj *pObj)
{
	GXColor Color ;
	EFFECT *pYamEfc = NULL;

	switch (mainID){
	case K7DAN:
		Color.r = (u8)150;
		Color.g = (u8)17;
		Color.b = (u8)20;
		Color.a = (u8)255;
		
		if ( BattleCtrl.GetDanPowerUp() ){
			pYamEfc = CreateDamageBloodEffect(	80,				//	s32 LineNum,
										shotPos,		//	Vec Point,
										50  * 0.01f,	//	f32 MaxSpeed,
										20  * 0.01f,	//	f32 MinSpeed,
										70  * 0.1f,		//	f32 MaxLength,
										30  * 0.1f,		//	f32 MinLength,
										200 * 0.001f,	//	f32 MaxLengthSpeed,
										150 * 0.001f,	//	f32 MinLengthSpeed,
										16,				//	u8 LineWidth,
										Color			//	GXColor Color,
										//	s32 Priority = 2000
			);							// _[W򖗃GtFNg쐬
		}else{
			pYamEfc = CreateDamageBloodEffect(	40,				//	s32 LineNum,
										shotPos,		//	Vec Point,
										50  * 0.01f,	//	f32 MaxSpeed,
										20  * 0.01f,	//	f32 MinSpeed,
										70  * 0.1f,		//	f32 MaxLength,
										30  * 0.1f,		//	f32 MinLength,
										250 * 0.001f,	//	f32 MaxLengthSpeed,
										180 * 0.001f,	//	f32 MinLengthSpeed,
										15,				//	u8 LineWidth,
										Color			//	GXColor Color,
										//	s32 Priority = 2000
			);							// _[W򖗃GtFNg쐬
		}
		
		break;
	case K7CAT:
		Color.r = (u8)150;
		Color.g = (u8)30;
		Color.b = (u8)40;
		Color.a = (u8)255;
		
		pYamEfc = CreateDamageBloodEffect(	60,				//	s32 LineNum,
									shotPos,		//	Vec Point,
									80  * 0.01f,	//	f32 MaxSpeed,
									50  * 0.01f,	//	f32 MinSpeed,
									25  * 0.1f,		//	f32 MaxLength,
									20   * 0.1f,		//	f32 MinLength,
									270 * 0.001f,	//	f32 MaxLengthSpeed,
									255 * 0.001f,	//	f32 MinLengthSpeed,
									15,				//	u8 LineWidth,
									Color			//	GXColor Color,
									//	s32 Priority = 2000
		);							// _[W򖗃GtFNg쐬
		
		break;
	case K7CYO:
		Color.r = (u8)150;
		Color.g = (u8)0;
		Color.b = (u8)0;
		Color.a = (u8)255;
		
		pYamEfc = CreateDamageBloodEffect(	60,				//	s32 LineNum,
									shotPos,		//	Vec Point,
									150  * 0.01f,	//	f32 MaxSpeed,
									70   * 0.01f,	//	f32 MinSpeed,
									100  * 0.1f,	//	f32 MaxLength,
									80   * 0.1f,	//	f32 MinLength,
									200 * 0.001f,	//	f32 MaxLengthSpeed,
									150  * 0.001f,	//	f32 MinLengthSpeed,
									10,				//	u8 LineWidth,
									Color			//	GXColor Color,
									//	s32 Priority = 2000
		);							// _[W򖗃GtFNg쐬
		
		break;
	case K7GAL:
		Color.r = (u8)170;
		Color.g = (u8)11;
		Color.b = (u8)30;
		Color.a = (u8)255;
		
		if ( BattleCtrl.GetDanPowerUp() ){
			pYamEfc = CreateDamageBloodEffect(	80,				//	s32 LineNum,
										shotPos,		//	Vec Point,
										100  * 0.01f,	//	f32 MaxSpeed,
										60  * 0.01f,	//	f32 MinSpeed,
										50  * 0.1f,		//	f32 MaxLength,
										30  * 0.1f,		//	f32 MinLength,
										140 * 0.001f,	//	f32 MaxLengthSpeed,
										80 * 0.001f,	//	f32 MinLengthSpeed,
										10,				//	u8 LineWidth,
										Color			//	GXColor Color,
										//	s32 Priority = 2000
			);							// _[W򖗃GtFNg쐬
		}else{
			pYamEfc = CreateDamageBloodEffect(	40,				//	s32 LineNum,
										shotPos,		//	Vec Point,
										70  * 0.01f,	//	f32 MaxSpeed,
										40  * 0.01f,	//	f32 MinSpeed,
										70  * 0.1f,		//	f32 MaxLength,
										30  * 0.1f,		//	f32 MinLength,
										140 * 0.001f,	//	f32 MaxLengthSpeed,
										80 * 0.001f,	//	f32 MinLengthSpeed,
										10,				//	u8 LineWidth,
										Color			//	GXColor Color,
										//	s32 Priority = 2000
			);							// _[W򖗃GtFNg쐬
		}
		
		break;
	case K7KED:
		Color.r = (u8)255;
		Color.g = (u8)70;
		Color.b = (u8)0;
		Color.a = (u8)255;
		
		pYamEfc = CreateDamageBloodEffect(	20,				//	s32 LineNum,
									shotPos,		//	Vec Point,
									195  * 0.01f,	//	f32 MaxSpeed,
									80  * 0.01f,	//	f32 MinSpeed,
									80  * 0.1f,		//	f32 MaxLength,
									55   * 0.1f,		//	f32 MinLength,
									400 * 0.001f,	//	f32 MaxLengthSpeed,
									180 * 0.001f,	//	f32 MinLengthSpeed,
									15,				//	u8 LineWidth,
									Color			//	GXColor Color,
									//	s32 Priority = 2000
		);							// _[W򖗃GtFNg쐬
		
		break;
	case K7KVN:
		if ( pObj != NULL ){
			Color.r = (u8)255;
			Color.g = (u8)70;
			Color.b = (u8)0;
			Color.a = (u8)255;
			
			pYamEfc = CreateDamageBlood(pObj,
										shotPos,		// Vec Point,
										3,				// Num
										YukaY
			);
			
			gpSound->mPlaySE3D( (int )SFX_PC_KVN_KNIFEHIT_HS, shotPos, 0 );		// rdĐ
			
			
		}
		break;
	}
	
	return pYamEfc;
}


/*
	
	
	퓬 ʌ̃GtFNg
	
	
	<in>
	myPos L̗ʒuinʂ̍̂ݕKvj
	
*/
//static BLOODEFFECTTASKPARAM BFP;					// Allocɂ邩H
EFFECT *KK7BattleEffectVLoss(f32 yukaY, Vec shotDir, WK7JObj *pObj)
{
	Vec vecp;
	f32 distzx;
	EFFECT *pEfc = NULL;

	// Jf[^Ƃĕϊ
	distzx = cosf(shotDir.x);
	vecp.y = sinf(shotDir.x);
	vecp.x = distzx * sinf(shotDir.y);
	vecp.z = distzx * cosf(shotDir.y);

	pEfc = CreateVLossEffect(	pObj,						// uGtFNg쐬
								vecp,
								VParam[ED_VLS][0] * 0.01F,	// Power ԑ
								yukaY + 0.1F,
								VParam[ED_VLS][1],			// BloodNum ̐
//								10,							// BloodNum ̐
								(u8)VParam[ED_VLS][2]
	);
	
	return pEfc;
}

/*
	
	
	wuX}C
	
	
	<in>
	waistPos ʒu
	
*/
bool KK7BattleEffectHSExplode(Vec waistPos, u32 suffix, f32 size)
{
	CreateHSExplodeEffect(	(u16 )suffix,
							waistPos,
							size
	);
	
	return true;
}


/*
	
	
	wuX}CS
	
	
	<in>
	myPos				L̗ʒuinʂ̍̂ݕKvj
	mode				0 _łɂꔭS
						1 ʂɂgoĎS
	bloodmode			k[hǂH
	bloodTexNumber		eNX`p^[
	
*/
EFFECT *KK7BattleEffectDead(f32 yukaY, Vec shotDir, WK7JObj *pObj, s16 mode, bool bloodmode, Vec Point, u8 bloodTexNumber, s16 bloodNum)
{
	EFFECT *pRetEffect;
	Vec vecp = {0.f, 0.f, 0.f};
	f32 distzx;
	u16 setBloodNum;

	WK7RenderObjEffectInfo	info;
	info.Create();
	
	if ( bloodNum < 0 ){
		if ( 0 == mode ){
			setBloodNum = VParam[ED_HSD1][1];
		}else{
			setBloodNum = VParam[ED_HSD2][1];
		}
	}else{
			setBloodNum = (u16 )bloodNum;
	}

	if ( 0 == mode ){
		// Jf[^Ƃĕϊ
		distzx = cosf(shotDir.x);
		vecp.y = sinf(shotDir.x);
		vecp.x = distzx * sinf(shotDir.y);
		vecp.z = distzx * cosf(shotDir.y);
		if ( false == bloodmode ){
			pRetEffect = CreateHSDeadEffect(	pObj,
								vecp,
								VParam[ED_HSD1][0] / 5.0F,	// Power ԑ
								yukaY,
								setBloodNum,				// BloodNum ̐
								(u8)VParam[ED_HSD1][2],
								0,
								NULL,
								3000,
								NULL,
								false,
								false,
								60,
								0.01F,
								(u8 )bloodTexNumber
			);
		}else{
			pRetEffect = CreateHSDeadEffect(	pObj,
								vecp,
								VParam[ED_HSD1][0] / 5.0F,	// Power ԑ
								yukaY,
								setBloodNum,				// BloodNum ̐
								(u8)VParam[ED_HSD1][2],
								0,
								NULL,
								3000,
								NULL,
								FALSE,
								true,					// k[hɂꍇ
								60,
								0.001f,
								(u8 )bloodTexNumber
			);
		}
		
		SetConveBloodFlag( bloodmode );
		if ( true == bloodmode ){
			SetConveBloodTargetPoint( Point );
		}
		
	}else{
		if ( false == bloodmode ){
			pRetEffect = CreateHSDeadEffect(	pObj,
								vecp,
								VParam[ED_HSD2][0] / 5.0F,	// Power ԑ
								yukaY,
								setBloodNum,				// BloodNum ̐
								(u8)VParam[ED_HSD2][2],
								3,
								NULL,
								3000,
								NULL,
								false,
								false,
								60,
								0.01F,
								(u8 )bloodTexNumber
			);
		}else{
			pRetEffect = CreateHSDeadEffect(	pObj,
								vecp,
								VParam[ED_HSD2][0] / 5.0F,	// Power ԑ
								yukaY,
								setBloodNum,				// BloodNum ̐
								(u8)VParam[ED_HSD2][2],
								3,
								NULL,
								3000,
								NULL,
								FALSE,
								true,						// k[hɂꍇ
								45,
								0.001f,
								(u8 )bloodTexNumber
			);
		}
		
		SetConveBloodFlag( bloodmode );
		if ( true == bloodmode ){
			SetConveBloodTargetPoint( Point );
		}
	}
	
	if( pRetEffect!=NULL ){ info.Parent(pRetEffect); }
	
	return pRetEffect;
}




/*
	
	
	eo
	
	
	<in>
	myPos	lʒu
	hitPos	qbgʒu
	mode	0:ʂ̏e
			1:Ol[h
			2:Ol[hd
			3:Ol[hd
	
	kyousei	true:IɃGtFNgoi`FbNsȂj
	
*/
//static f32 dankonSize[K7PCMAX] = {
//	0.25f,		// K7DAN,
//	0.2f,		// K7GAL,
//	0.2f,		// K7CAT,
//	0.5f,		// K7HAC,
//	0.0f,		// K7HAS,
//	0.35f,		// K7HAY,
//	0.3f,		// K7CYO,
//	0.25f,		// K7KED,
//	0.0f,		// K7KVN,
//	0.0f,		// K7MSK,
//};
static	f32		kk7HitWallDist = -1.0f;
bool KK7HitWallSetDist(f32 dist)
{
	kk7HitWallDist = dist;
	return true;
}
f32 KK7HitWallGetDist(bool org)
{
	if( kk7HitWallDist < 0.0f ){
		if( org==true ){
			return kk7HitWallDist;
		}
		return TYOUDAN_OK_DIST;
	}
	return kk7HitWallDist;
}
bool KK7HitWallEffect(Vec myPos, Vec hitPos, s16 mode, u32 mainID, bool kyousei)
{
static GXColor Color;
	int seNo;
	EFFECT *pYamEfc;
	EFFECT *pYamEfc2;
	f32 dist;

	if ( false == kyousei ){
		dist = GHM_VEC_GET_DIST(&myPos, &hitPos);
		if ( kk7HitWallDist < 0.0f ){
			if ( dist > TYOUDAN_OK_DIST ) return false;
		}else{
			if ( dist > kk7HitWallDist ) return false;
		}
	}
	
	switch (mode){
	case 0:
		if ( K7KVN == mainID ){
			CreateDamageBloodEffect( DMGBLD_KVN_INVALID, hitPos ) ;
		}else{
			Color.r = (u8 )VParam[ED_FLYBULLET][4];
			Color.g = (u8 )VParam[ED_FLYBULLET][5];
			Color.b = (u8 )VParam[ED_FLYBULLET][6];
			Color.a = 255;
			CreateFlyBulletEffect(	hitPos,
									Color,
									VParam[ED_FLYBULLET][7] * 0.1f,
									VParam[ED_FLYBULLET][8] * 0.01f,
									0.f
			);
			
		}
		if ( K7KVN == mainID ){
			seNo = SFX_PC_KVN_KNIFEHIT_WALL;
		}else{
			seNo = SFX_BT_TYOUDAN;
		}
		gpSound->mPlaySE3D( (int )seNo, hitPos, 0 );									// erdĐ
		break;
	case 1:
		// Ol[h
		CreateSmokeExplodeEffect(	hitPos,
									3.f,
									0,
									0,
									&pYamEfc,
									&pYamEfc2
		) ;
		
#if 0 
//		if ( NULL != pYamEfc )  WK7PLAYERCONTROL->CreateWallHitEfc(pYamEfc,		0);
//		if ( NULL != pYamEfc2 ) WK7PLAYERCONTROL->CreateWallHitEfc(pYamEfc2,	1);
#endif
		
		break;
	case 2:
		// d
		pYamEfc = CreateMskSparkBom( hitPos );
		WK7PLAYERCONTROL->CreateWallHitEfc(pYamEfc, 0);
		seNo = SFX_PC_MSK_TYOUDAN_DENGEKI;
		gpSound->mPlaySE3D( (int )seNo, hitPos, 1 );									// erdĐ
		break;
	case 3:
		// k
		pYamEfc = CreateGravityEffect( hitPos );
		WK7PLAYERCONTROL->CreateWallHitEfc(pYamEfc, 0);
		seNo = SFX_PC_MSK_TYOUDAN_SHUSOKU;
		gpSound->mPlaySE3D( (int )seNo, hitPos, 1 );									// erdĐ
		break;
	}
	
//	if ( dankonSize[mainID] != 0.f ){
//		// ~Xqbgpie
//		CreateBulletEffect(	BL_MARK,
//							hitPos,
//							NULL,
//							0.f,
//							dankonSize[mainID]
//		);
//	}
	
	return true;
}

/*
	
	
	_[WAGtFNgo
	
	hitPos	qbgꏊ
	myPos	Gl~[̃|WV
	mode	0:F 1:ԐF
	
*/
bool KK7HitNoDamageEffect(Vec hitPos, Vec enePos, WK7NpcDamType DamType, u32 mainID, WK7JObj *pJOBjIN, int mode)
{
	//  _[W
	BL_TYPE type;
	int seNo;
	int seID;
	bool picthChange = false;
	
	switch (DamType){
	case DAMTYPE_GRENADE_FIRE:
		seNo = SFX_BT_HIT_GRANADE_NO_DAMAGE;
		type = BL_INV_MSK_NRM;
		break;
	case DAMTYPE_GRENADE_THUND:
		seNo = SFX_BT_HIT_DENGEKI_NO_DAMAGE;
		type = BL_INV_MSK_ELC;
		break;
	case DAMTYPE_GRENADE_GRAVI:
		seNo = SFX_BT_HIT_SHUSOKU_NO_DAMAGE;
		type = BL_INV_MSK_CNV;
		break;
	case DAMTYPE_KVNTAMEUCHI:
		seNo = SFX_BT_HIT_KNIFE_NO_DAMAGE;
		if ( mode ){
			type = BL_INV_KVN_RED;
			picthChange = true;
		}else{
			type = BL_INV_KVN;
		}
		break;
	default:							    // ʏe
		if ( K7KVN == mainID ){
			seNo = SFX_BT_HIT_KNIFE_NO_DAMAGE;
			if ( mode ){
				type = BL_INV_KVN_RED;
				picthChange = true;
			}else{
				type = BL_INV_KVN;
			}
		}else{
			seNo = SFX_BT_HIT_BULLET_NO_DAMAGE;
			if ( mode ){
				type = BL_INV_NRM_RED;
				picthChange = true;
			}else{
				type = BL_INV_NRM;
			}
		}
		break;
	}
	
	seID = gpSound->mPlaySE3D(seNo, enePos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
	if ( picthChange ){
		gpSound->mSetPitchSENo( seID, (s16 )300 );			// 100 ́@{l
	}
	
	// ~Xqbgp
	CreateBulletEffect(	type,
						hitPos,
						pJOBjIN
	);																											// _[W eGtFNg쐬
	
	return true;
}


/*
	
	
	̕\
	
	
*/
#define PLAYDMGCOLOR		(GXColor){ 255,0,0,128 }	// vC[_[W󂯂Ƃ̃tbV̐F
bool KK7PcSmallHitEffect(void)
{
	// ʂԂ
//	gpFlush->mRequest(0x8f0000, 2000, 2000);
	
	// ʂtbV
	CreateFlashEffect( 
						TRUE,						// QcWn
						(Vec){0.0F,0.0F,0.0F},		// W
						1.0F,						// TCY
						PLAYDMGCOLOR,				// F
						0,							// 肫܂ł̎
						0,							// Ă܂ł̎
						FALSE 						// Z
						) ;
	
	return true;
}



/*
	
	
	WGtFNgo
	
	
*/
EFFECT *KK7KLineEffect(s16 time)
{
	GXColor Color ;
	EFFECT *pRet;

	Color.r = (u8)VParam[ED_KLINE][7+11] ;
	Color.g = (u8)VParam[ED_KLINE][8+11] ;
	Color.b = (u8)VParam[ED_KLINE][9+11] ;
	Color.a = (u8)VParam[ED_KLINE][10+11] ;
	pRet = CreateKLineEffect( (u8)0, (u8)0, VParam[ED_KLINE][0+11] * 10.0F,
						(Vec){320.0F, 240.0F, 0.0F}, (u16)VParam[ED_KLINE][1+11], VParam[ED_KLINE][2+11],
						VParam[ED_KLINE][3+11], (u8)VParam[ED_KLINE][4+11],
						VParam[ED_KLINE][5+11],
						time,									// Ԏw
						Color, (u8)VParam[ED_KLINE][23] ) ;
						
	return pRet;
}


/*
	
	
	WGtFNĝQo
	
	
*/
EFFECT *KK7KLineRollEffect(void)
{
	EFFECT *pRet;
	GXColor Color1, Color2 ;
	
	Color1.r = (u8)VParam[ED_LINEROLL][10] ;
	Color1.g = (u8)VParam[ED_LINEROLL][11] ;
	Color1.b = (u8)VParam[ED_LINEROLL][12] ;

	Color2.r = (u8)VParam[ED_LINEROLL][13] ;
	Color2.g = (u8)VParam[ED_LINEROLL][14] ;
	Color2.b = (u8)VParam[ED_LINEROLL][15] ;

	pRet = CreateLineRollEffect( (s32)VParam[ED_LINEROLL][7] * 10, (f32)VParam[ED_LINEROLL][8] * PI_2 / 36000.0F,
							(f32)VParam[ED_LINEROLL][2] * 0.001F, (s32)VParam[ED_LINEROLL][3], (s32)VParam[ED_LINEROLL][4],
							(f32)VParam[ED_LINEROLL][5] * 10, (f32)VParam[ED_LINEROLL][6] * 10.0F,
							(u8)VParam[ED_LINEROLL][9],
							Color1, Color2,
							(u8)VParam[ED_LINEROLL][16], (f32)VParam[ED_LINEROLL][17] / 100.0F ) ;
	return pRet;
}



/*
	
	
	XLGtFNg̃Q[Wo
	
	
*/
//	EFFECT *KK7ScanGaugeEffectCreate(void)
//	{
//		EFFECT *pEffect = NULL;
//		Vec Point ;
//		
//		Point.x = VParam[ED_SAR][9] ;
//		Point.y = VParam[ED_SAR][10] ;
//		Point.z = 0.0F ;
//	
//	//	pEffect = CreateSpSkillGageEffect( Point, 0 ) ;
//		return pEffect;
//	}
//	
//	/*
//		
//		
//		XyVA^bNGtFNg̃Q[Wo
//		
//		
//	*/
//	EFFECT *KK7SpAtkGaugeEffectCreate(void)
//	{
//		EFFECT *pEffect = NULL;
//		
//		if( CheckSetupFlower( WK7PLAYERCONTROL->GetBloodTexNum() ) == true ) {
//			pEffect = CreateFlowerEffect(WK7PLAYERCONTROL->GetBloodTexNum() ); // (02/01/04 Rc)				// Ԃ쐬
//		}
//		return pEffect;
//	}


//	/*
//		
//		
//		GtFNgQ[W̕\iԁj
//		
//		
//	*/
//	bool KK7EffectSpAtkGaugeVisible(EFFECT *pEffect, bool flag)
//	{
//		if ( NULL != pEffect ){
//			SetFlowerRenderFlag( (u8 )flag, pEffect ) ;
//			return true;
//		}
//		return false;
//	}
//	
//	
//	
//	/*
//		
//		
//		GtFNgQ[W̒lݒiԁj
//		
//		
//	*/
//	bool KK7EffectSpAtkGaugePointSet(EFFECT *pEffect, f32 nowPoint, f32 maxPoint)
//	{
//		f32 rate;
//	
//		if ( NULL != pEffect ){
//			
//			rate = nowPoint * 1.f / maxPoint;
//			
//			SetFlowerRate( rate, pEffect );
//			return true;
//		}
//		return false;
//	}
//	
//	/*
//		
//		
//		GtFNgQ[W̏Łiԁj
//		
//		
//	*/
//	bool KK7EffectSpAtkGaugeDelete(EFFECT *pEffect)
//	{
//		if ( NULL != pEffect ){
//			::DelReqEffect( pEffect );
//			pEffect = NULL;
//			return true;
//		}
//		return false;
//	}
//	
//	
//	
//	/*
//		
//		
//		GtFNgQ[W̕\
//		
//		
//	*/
//	bool KK7EffectGaugeVisible(EFFECT *pEffect, bool flag)
//	{
//		if ( NULL != pEffect ){
//			SetSpSkillGageRenderFlag( flag, pEffect ) ;
//			return true;
//		}
//		return false;
//	}
//	
//	
//	/*
//		
//		
//		GtFNgQ[W̒lݒ
//		
//		
//	*/
//	bool KK7EffectGaugePointSet(EFFECT *pEffect, f32 nowPoint, f32 maxPoint)
//	{
//		f32 rate;
//	
//		if ( NULL != pEffect ){
//			
//			rate = nowPoint * 1.f / maxPoint;
//			
//			SetSpSkillGageRate( rate, pEffect );
//			return true;
//		}
//		return false;
//	}
//	
//	
//	/*
//		
//		
//		GtFNgQ[W̏
//		
//		
//	*/
//	bool KK7EffectGaugeDelete(EFFECT *pEffect)
//	{
//		if ( NULL != pEffect ){
//			::DelReqEffect( pEffect );
//			pEffect = NULL;
//			return true;
//		}
//		return false;
//	}
//	


/*
		{
			Vec Point;
			f32 Size = 1.f;
			
			Point = hitPos;
			CreateSmokeEffect( 1, Point, 12.10000038146973F * Size,
								5.0F, 2.0F,
								0.1F, 100,
								(Vec){0.0F,0.0F,0.0F}, 0.0F,
								PI_2 / 720.0F, PI_2 / 720.0F,
								8.0F * Size, 4.0F * Size,
								8.0F * Size, 4.0F * Size,
								180, 140, 0.0F,
								(GXColor){255,0,0},(GXColor){0,0,0},(GXColor){0,0,255},
								PI / 2, -PI / 2, FALSE, 0.01F, 500 ) ; 
		}
		

*/

/*
	
	
	ׂo
	
	
	<in>
	Pos		ʒu
	
*/
bool KK7SenbeiSmokeEffect(Vec Pos, int mode)
{
	Vec Point ;
	GXColor Color ;
	
	Point = Pos;
	
	switch (mode){
	case 0:
		Color.r = (u8)158;
		Color.g = (u8)140;
		Color.b = (u8)109;
		break;
	case 1:
		Color.r = (u8)158;
		Color.g = (u8)150;
		Color.b = (u8)129;
		break;
	}
	CreateSmokeEffect( 1, Point,
						40.f * 0.1F,
						50.f * 0.01F,
						13.f * 0.01F,
						0.0F,
						128,
						(Vec){0.0F,0.0F,0.0F},
						0.0F,
						45.f * 0.1F / 180.0F,
						20.f * 0.1F / 180.0F, 
						80.f * 0.1F,
						40.f * 0.1F,
						80.f * 0.1F,
						40.f * 0.1F,
						80,
						70,
						20.f * 1.0F,
						Color, Color, Color,
						(u8)132,
						PI * VParam[ED_SMOKE_H][18] / 180.0F,
						0.0F,
						FALSE,
						(u8)VParam[ED_SMOKE_H][14], 
						VParam[ED_SMOKE_H][15] * 0.01F, FALSE, 0,
						Color, Color, Color,
						8.f * 0.01F
						) ;
	
	return true;
}


/*
	
	
	hAo
	
	
	<in>
	Pos		ʒu
	
*/
bool KK7DoorSmokeEffect(Vec Pos)
{
	Vec Point;
	GXColor Color;
	
	Point = Pos;
	
	Color.r = (u8)VParam[ED_SMOKE_DR][10] ;
	Color.g = (u8)VParam[ED_SMOKE_DR][11] ;
	Color.b = (u8)VParam[ED_SMOKE_DR][12] ;
	CreateSmokeEffect( 1, Point, VParam[ED_SMOKE_DR][0] * 0.1F,
						VParam[ED_SMOKE_DR][1] * 0.01F, VParam[ED_SMOKE_DR][2] * 0.01F,
						0.0F, VParam[ED_SMOKE_DR][3],
						(Vec){0.0F,0.0F,0.0F}, 0.0F,
						PI * VParam[ED_SMOKE_DR][4] * 0.1F / 180.0F, PI * VParam[ED_SMOKE_DR][5] * 0.1F / 180.0F, 
						VParam[ED_SMOKE_DR][6] * 0.1F, VParam[ED_SMOKE_DR][7] * 0.1F,
						VParam[ED_SMOKE_DR][6] * 0.1F, VParam[ED_SMOKE_DR][7] * 0.1F,
						VParam[ED_SMOKE_DR][8], VParam[ED_SMOKE_DR][9], VParam[ED_SMOKE_DR][17] * 1.0F,
						Color, Color, Color, (u8)VParam[ED_SMOKE_DR][13],
						PI * VParam[ED_SMOKE_DR][18] / 180.0F, 0.0F, FALSE, (u8)VParam[ED_SMOKE_DR][14], 
						VParam[ED_SMOKE_DR][15] * 0.01F, FALSE, 0,
						Color, Color, Color,
						VParam[ED_SMOKE_DR][16] * 0.01F ) ;
	return true;
}


/*
	
	
	WCAgHSp̉o
	
	
	<in>
	Pos		ʒu
	
*/
bool KK7JaiaHSSmokeEffect(Vec Pos)
{
	GXColor Color ;
	
	Color.r = (u8)VParam[ED_SMOKE_H][10] ;
	Color.g = (u8)VParam[ED_SMOKE_H][11] ;
	Color.b = (u8)VParam[ED_SMOKE_H][12] ;
	CreateSmokeEffect( 1, Pos, VParam[ED_SMOKE_H][0] * 0.1F,
						VParam[ED_SMOKE_H][1] * 0.01F, VParam[ED_SMOKE_H][2] * 0.01F,
						0.0F, VParam[ED_SMOKE_H][3],
						(Vec){0.0F,0.0F,0.0F}, 0.0F,
						PI * VParam[ED_SMOKE_H][4] * 0.1F / 180.0F, PI * VParam[ED_SMOKE_H][5] * 0.1F / 180.0F, 
						VParam[ED_SMOKE_H][6] * 0.1F, VParam[ED_SMOKE_H][7] * 0.1F,
						VParam[ED_SMOKE_H][6] * 0.1F, VParam[ED_SMOKE_H][7] * 0.1F,
						VParam[ED_SMOKE_H][8], VParam[ED_SMOKE_H][9], VParam[ED_SMOKE_H][17] * 1.0F,
						Color, Color, Color, (u8)VParam[ED_SMOKE_H][13],
						PI * VParam[ED_SMOKE_H][18] / 180.0F, 0.0F, FALSE, (u8)VParam[ED_SMOKE_H][14], 
						VParam[ED_SMOKE_H][15] * 0.01F, FALSE, 0,
						Color, Color, Color,
						VParam[ED_SMOKE_H][16] * 0.01F ) ;
	return true;
}


/*
	
	
	ԕrp
	
	
	<in>
	Pos		ʒu
	
*/
bool KK7FlowerPodBrokenSmokeEffect(Vec Pos)
{
	Vec Point ;
	GXColor Color ;
	
	Point = Pos;
	
	Color.r = (u8)182;
	Color.g = (u8)157;
	Color.b = (u8)105;
	CreateSmokeEffect(  1, Point,
						15.f * 0.1F,			// 0
						7.f * 0.01F,			// 1
						4.f * 0.01F,			// 2
						0.0F,
						35,						// 3
						(Vec){0.0F,0.0F,0.0F},
						0.0F,
						128.f * 0.1F / 180.0F,	// 4
						64.f * 0.1F / 180.0F, 	// 5
						120.f * 0.1F,			// 6
						50.f * 0.1F,			// 7
						120.f * 0.1F,			// 6
						50.f * 0.1F,			// 7
						30,						// 8
						20,						// 9
						VParam[ED_SMOKE_DR][17] * 1.0F,
						Color, Color, Color,
						(u8)VParam[ED_SMOKE_DR][13],
						PI * VParam[ED_SMOKE_H][18] / 180.0F,
						0.0F,
						FALSE,
						(u8)VParam[ED_SMOKE_H][14], 
						VParam[ED_SMOKE_H][15] * 0.01F, FALSE, 0,
						Color, Color, Color,
						VParam[ED_SMOKE_DR][16] * 0.01F
	) ;
	
	return true;
}



#if 0
/*
	
	
	IuWFNĝj󂷂
	
	JObj
	
*/
bool KK7BreakObjEffect(WK7JObj *pJObj)
{
	Vec Base, DPoint, SSpeed ;
	
	DPoint.x = pJObj->GetJObj()->mtx[0][3] ;
	DPoint.y = pJObj->GetJObj()->mtx[1][3] ;
	DPoint.z = pJObj->GetJObj()->mtx[2][3] ;
	
	Base.x = DPoint.x - VParam[ED_BREAK][7] * 0.1F ;
	Base.y = DPoint.y - VParam[ED_BREAK][8] * 0.1F ;
	Base.z = DPoint.z - VParam[ED_BREAK][9] * 0.1F ;
	
	SSpeed.x = 0.0F ;
	SSpeed.y = -VParam[ED_BREAK][2] * 0.01F ;
	SSpeed.z = 0.0F ;
	
	CreateBreakEffect( pJObj, Base,
						VParam[ED_BREAK][0] * 0.01F, VParam[ED_BREAK][1] * 0.01F, SSpeed,
						VParam[ED_BREAK][3] * 0.001F, VParam[ED_BREAK][4] * 0.001F,
						VParam[ED_BREAK][5] * 0.001F, VParam[ED_BREAK][6] * 0.001F ) ;
	return true;
}

#endif

/*
	
	
	ł̃GtFNgi|CYX}Cpj
	
	
	<in>
	Pos		ʒu
	
*/
static u16 PoizunSmokeVParam[] = {0, 56, 24, 121, 7, 33, 16, 76, 43, 98, 130, 0, 25, 75, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
#define POIZUON_COLOR_MAX	(5)
static u16 PoizunSmokeColor[POIZUON_COLOR_MAX][3] = {
	{76, 43, 98},
	{12, 44, 37},
	{60, 39, 54},
	{151, 40, 84},
	{89, 0, 70}
};
bool KK7PoizunSmokeEffect(Vec Pos)
{
	Vec Point ;
	GXColor Color ;
	
	Point = Pos;
	
	Color.r = (u8)PoizunSmokeColor[rand()%POIZUON_COLOR_MAX][0];
	Color.g = (u8)PoizunSmokeColor[rand()%POIZUON_COLOR_MAX][1];
	Color.b = (u8)PoizunSmokeColor[rand()%POIZUON_COLOR_MAX][2];
	Color.a = 255 ;
	
	CreateSmokeEffect( (u8)PoizunSmokeVParam[0], Point, PoizunSmokeVParam[1] * 0.1F,
						0.0F, 0.0F,
						0.0F, PoizunSmokeVParam[2],
						(Vec){0.0F,1.0F,1.0F},  PI_2 * PoizunSmokeVParam[3] / 360.0F,
						PI_2 / 720.0F, PI_2 / 720.0F,
						8.0F * PoizunSmokeVParam[4] * 0.01F, 7.0F * ( PoizunSmokeVParam[4] * 0.11F ),
						8.0F * PoizunSmokeVParam[4] * 0.01F, 7.0F * ( PoizunSmokeVParam[4] * 0.11F ),
						PoizunSmokeVParam[5], PoizunSmokeVParam[6], 0.0F,
						Color, Color, Color, (u8)PoizunSmokeVParam[10],
						0.0F, 0.0F, (u8)((int )rand()%2), (u8)PoizunSmokeVParam[12], 
						PoizunSmokeVParam[13] * 0.01F, FALSE, 0,
						Color, Color, Color,
//						(f32 )((u8 )PoizunSmokeVParam[14] * 0.01F), (s32 )500 ) ; 
						(f32 )((u8 )PoizunSmokeVParam[14] * 0.01F) ) ; 
	
	
	return true;
}




/*
	
	
	̉GtFNg
	
	
*/
static u16 FootSmokeVParam[] = 
{		0,		64,		17,		19,		5,
		18,		12,		158,		150,		129,

		106,		0,		8,		80,		1,
		0,		0,		0,		0,		0,

		0,		0,		0,		0,		0,
		0,		0,		0,		0,		0 };
bool KK7FootSmokeEffect(Vec Pos, Vec Dir)
{
	GXColor Color ;
	Vec Point;
	Vec vecp = {0.f, 0.f, 0.f};
	f32 distzx;

	Point.x = Pos.x;
	Point.y = Pos.y;
	Point.z = Pos.z;
	
	distzx = cosf(Dir.x);
	vecp.y = sinf(Dir.x);
	vecp.x = distzx * sinf(Dir.y);
	vecp.z = distzx * cosf(Dir.y);

	Color.r = (u8)FootSmokeVParam[7] ;
	Color.g = (u8)FootSmokeVParam[8] ;
	Color.b = (u8)FootSmokeVParam[9] ;
	Color.a = (u8)FootSmokeVParam[10] ;
	
	CreateSmokeEffect( (u8)FootSmokeVParam[0], Point, FootSmokeVParam[1] * 0.1F,
						0.0F, 0.0F,
						0.0F, FootSmokeVParam[2],
						(Vec)vecp,  PI_2 * FootSmokeVParam[3] / 360.0F,
						PI_2 / 720.0F, PI_2 / 720.0F,
						8.0F * FootSmokeVParam[4] * 0.01F, 7.0F * ( FootSmokeVParam[4] * 0.11F ),
						8.0F * FootSmokeVParam[4] * 0.01F, 7.0F * ( FootSmokeVParam[4] * 0.11F ),
						FootSmokeVParam[5], FootSmokeVParam[6], 0.0F,
						Color, Color, Color, (u8)FootSmokeVParam[10],
						0.0F, 0.0F, (u8)FootSmokeVParam[11], (u8)FootSmokeVParam[12], 
						FootSmokeVParam[13] * 0.01F, FALSE, 0,
						Color, Color, Color,
//						FootSmokeVParam[14] * 0.01F, 500 ) ; 
						FootSmokeVParam[14] * 0.01F ) ; 
	return true;
}


