/*

 	KK7Effect.h

 Creator       : Kawakami Satoshi (GHM)
 Creation Date : 02/16/2003

*/

#ifndef	__KK7EFFECT_H__
#define	__KK7EFFECT_H__


#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"
#include "..\Lib\ghmGcFile.h"
#include "..\Lib\ghmGcTask.h"
#include "..\Lib\ghmGcTex.h"

#include "..\Wat\WK7Chara.h"


#ifdef __KK7EFFECT_CPP__

//GHMGCTASK_HANDLER(kk7ScreenFlush);
bool KK7BattleDefaultBloodStart(Vec shotPos, f32 yukaY, Vec shotDir, WK7JObj *pObj);
EFFECT *KK7BattleEffectVLoss(f32 yukaY, Vec shotDir, WK7JObj *pObj);
bool KK7BattleEffectHSExplode(Vec waistPos, u32 suffix, f32 size);
//EFFECT *KK7BattleEffectDead(Vec myPos, Vec shotDir, WK7JObj *pObj, s16 mode, bool bloodmode, Vec Point, u8 bloodTexNumber, s16 bloodNum);
EFFECT *KK7BattleEffectDead(f32 yukaY, Vec shotDir, WK7JObj *pObj, s16 mode, bool bloodmode, Vec Point, u8 bloodTexNumber, s16 bloodNum);
bool KK7HitWallSetDist(f32 dist=1.0f);
f32 KK7HitWallGetDist(bool org);
bool KK7HitWallEffect(Vec myPos, Vec hitPos, s16 mode, u32 mainID, bool kyousei);
bool KK7HitNoDamageEffect(Vec hitPos, Vec enePos, WK7NpcDamType DamType, u32 mainID, WK7JObj *pJOBjIN, int mode);
EFFECT *KK7KLineEffect(s16 time);
EFFECT *KK7KLineRollEffect(void);

//	EFFECT *KK7ScanGaugeEffectCreate(void);
//	EFFECT *KK7SpAtkGaugeEffectCreate(void);
//	bool KK7EffectGaugeVisible(EFFECT *pEffect, bool flag);
//	bool KK7EffectGaugePointSet(EFFECT *pEffect, f32 nowPoint, f32 maxPoint);
//	bool KK7EffectGaugeDelete(EFFECT *pEffect);
bool KK7PcSmallHitEffect(void);
bool KK7SenbeiSmokeEffect(Vec Pos, int mode);
bool KK7DoorSmokeEffect(Vec Pos);
bool KK7JaiaHSSmokeEffect(Vec Pos);
EFFECT *KK7BattleEffectCharaTypeBloodStart(Vec shotPos, u32 mainID, f32 YukaY=0.f, WK7JObj *pObj=NULL);
bool KK7FlowerPodBrokenSmokeEffect(Vec Pos);
//	bool KK7EffectSpAtkGaugeVisible(EFFECT *pEffect, bool flag);
//	bool KK7EffectSpAtkGaugePointSet(EFFECT *pEffect, f32 nowPoint, f32 maxPoint);
//	bool KK7EffectSpAtkGaugeDelete(EFFECT *pEffect);
bool KK7PoizunSmokeEffect(Vec Pos);
bool KK7FootSmokeEffect(Vec Pos, Vec Dir);

#else

//extern GHMGCTASK_HANDLER(kk7ScreenFlush);
extern bool KK7BattleDefaultBloodStart(Vec shotPos, f32 yukaY, Vec shotDir, WK7JObj *pObj);
extern EFFECT *KK7BattleEffectVLoss(f32 yukaY, Vec shotDir, WK7JObj *pObj);
extern bool KK7BattleEffectHSExplode(Vec waistPos, u32 suffix, f32 size);
extern EFFECT *KK7BattleEffectDead(f32 yukaY, Vec shotDir, WK7JObj *pObj, s16 mode, bool bloodmode, Vec Point, u8 bloodTexNumber, s16 bloodNum);
extern	bool KK7HitWallSetDist(f32 dist=-1.0f);
extern	f32 KK7HitWallGetDist(bool org);
extern bool KK7HitWallEffect(Vec myPos, Vec hitPos, s16 mode, u32 mainID, bool kyousei);
extern bool KK7HitNoDamageEffect(Vec hitPos, Vec enePos, WK7NpcDamType DamType, u32 mainID, WK7JObj *pJOBjIN, int mode);
extern EFFECT *KK7KLineEffect(s16 time);
extern EFFECT *KK7KLineRollEffect(void);
//	extern EFFECT *KK7ScanGaugeEffectCreate(void);
//	extern EFFECT *KK7SpAtkGaugeEffectCreate(void);
//	extern bool KK7EffectGaugeVisible(EFFECT *pEffect, bool flag);
//	extern bool KK7EffectGaugePointSet(EFFECT *pEffect, f32 nowPoint, f32 maxPoint);
//	extern bool KK7EffectGaugeDelete(EFFECT *pEffect);
extern bool KK7PcSmallHitEffect(void);
extern bool KK7SenbeiSmokeEffect(Vec Pos, int mode);
extern bool KK7DoorSmokeEffect(Vec Pos);
extern bool KK7JaiaHSSmokeEffect(Vec Pos);
extern EFFECT *KK7BattleEffectCharaTypeBloodStart(Vec shotPos, u32 mainID, f32 YukaY=0.f, WK7JObj *pObj=NULL);
extern bool KK7FlowerPodBrokenSmokeEffect(Vec Pos);
extern bool KK7EffectSpAtkGaugeVisible(EFFECT *pEffect, bool flag);
extern bool KK7EffectSpAtkGaugePointSet(EFFECT *pEffect, f32 nowPoint, f32 maxPoint);
extern bool KK7EffectSpAtkGaugeDelete(EFFECT *pEffect);
extern bool KK7PoizunSmokeEffect(Vec Pos);
extern bool KK7FootSmokeEffect(Vec Pos, Vec Dir);

#endif


#endif



