/*

 	KK7Sound.cpp

 	Creator       : Kawakami Satoshi (GHM)
 	Creation Date : 02/16/2003

*/

#define	__KK7SOUND_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "..\Wat\Wk7MainTask.h"
#include "..\Wat\WK7EventScript.h"
#include "..\Wat\WK7EventItem.h"
#include "..\Wat\Wk7Event.h"
#include "..\Wat\Wk7Cam.h"
#include "..\Wat\Wk7GameInfo.h"
#include "..\Wat\Wk7Stage.h"
#include "..\Wat\Wk7Player.h"
#include "..\Wat\EnmList.h"
#include "..\Fujita\C_Font.h"
#include "KK7Sound.h"
#include "..\Matsu\mK7Sound.h"

// in --> int inId      Đʉԍ
//        u8  inVolume  Đ(default:SOUND_MASTER_VOLUME)
//        u8  inPan     ̖ʒu(default:SOUND_PAN_CENTER)  0 ~ 255
//        int inTrack   (default:0)
//        int inGroup   (default:0)


#define		HS_MIN_SEVOL	(40)						// gr̍Œ΂unk
#define		MIN_SEVOL		(10)

#define		PANLIMIT		(100.f)						// {[Eɂo`miU蕪j郊~bg̋ 10.f = 1m
#define		SE_MAX_VOL		(255)						// {[l`w

#define		MIN_VOLDIST		(8.f)						// RcTEhLɂȂȂi߂Ƃj

static f32	maxDist3D[] = {								// ̓͂ő勗
	200.f,												// n 20m
	400.f,												// jn̓͂ő勗 40
	30.f,												// wuX}C΂悤
	0.f,												// ΂piԁj
	2000.f,												// 100m
	ENEMY_SIGNALSE_DIST,								// ͂͂n
	50.f,												// Ə
};

/*
	
	
	rd{[lƃpvZ
	
	<in>
	tPos			^[Qbg̈ʒu
	volMax			ő{[l
	pGetVol			擾{[l
	pGetPan			擾pl
	type			0:n 1:ł 3:wuX}C΂悤
	
	
*/
u8	seVolCalc(Vec tPos, u8 volMax, u8 *pGetVol, u8 *pGetPan, int type)
{
	u8 minvol = MIN_SEVOL;
	WK7Cam *pCam;
	Vec camPos, camTPos;
	f32	dist, volMaxf, setVolf, camYaw, chaYaw, yaw, getPan;

	pCam = K7EVENT_MAINTASK->GetCamera();
	if ( pCam == NULL ){
		*pGetVol = volMax;
		*pGetPan = 127;
		return *pGetVol;
	}
	
#if 1
	pCam->GetWorldPositions(camPos,camTPos);
#else
	pCam->GetPosition(camPos);	// Jʒu擾
#endif
	dist = GHM_VEC_GET_DIST(&tPos, &camPos);							// JʒuƑΏۃ|WV̋擾
	
	if ( type == 3 ){													// wuX}C̍ŏ̏΂
		type = 0;
//		minvol = 5;
		minvol = HS_MIN_SEVOL;											// Œ{[
	}
	if ( type == 99 ){													// xrdp
		type = 5;
		minvol = 0;														// Œ{[
	}
	if ( type == 6 ){													// 
		minvol = 0;														// Œ{[
	}
	if ( (maxDist3D[type] - MIN_VOLDIST) < dist ){						// ꂷ
		*pGetVol = minvol;
		*pGetPan = 127;
		return *pGetVol;
	}
	if ( MIN_VOLDIST > dist ){											// ߂
		*pGetVol = volMax;
		*pGetPan = 127;
		return *pGetVol;
	}
	
	volMaxf = volMax - minvol;
	setVolf = ((maxDist3D[type] - MIN_VOLDIST) - dist) * volMaxf / (maxDist3D[type] - MIN_VOLDIST);
	setVolf += minvol;
	
	
#if 0
	pCam->GetTargetPosition(camTPos);									// J^[Qbgʒu擾
#endif
	camYaw	= atan2f(camTPos.x - camPos.x, camTPos.z - camPos.z);		// Jpx擾
	chaYaw	= atan2f(tPos.x - camPos.x, tPos.z - camPos.z);				// JƖړI̊px擾
	yaw		= chaYaw - camYaw;											// ݂̊px
	GHM_LIMIT_RANGE(yaw, PI, -PI);										// ۂ
	
	// p̒l߂
	getPan  = -1.f * 127.f * sin(yaw);
	getPan += 127.f;
	
	// {[l̃Zbg
	*pGetVol = (u8 )setVolf;
	
	// pl̃Zbg
	*pGetPan = (u8 )getPan;
	
#ifdef _DEBUG
//	C_Paper		paper(0,48);
//	PRINTF("\n YAW:%5.2f DIS:%5.2f %5.2f", yaw, dist, getPan);
#endif
	
	return (u8 )*pGetVol;
}

/*
	
	rd{[lƃpvZ
	
	<in>
	tPos			^[Qbg̈ʒu
	volMax			ő{[l
	volMin			ŏ{[l
	pGetVol			擾{[l
	pGetPan			擾pl
	
*/
u8	seVolCalc2(Vec tPos, u8 volMax, u8 volMin,u8 *pGetVol,u8 *pGetPan,f32 maxDist,f32 minDist)
{
	Vec		camPos, camTPos;
	f32		dist, setVolf, camYaw, chaYaw, yaw, getPan;

#if 1
	WK7CAM->GetWorldPositions(camPos,camTPos);
#else
//	WK7CAM->GetPosition      (camPos );									// Jʒu擾
//	WK7CAM->GetTargetPosition(camTPos);									// J^[Qbgʒu擾
#endif
	dist = GHM_VEC_GET_DIST(&tPos, &camPos);							// JʒuƑΏۃ|WV̋擾
	
	if( volMax < volMin ){
		// ő{[ŏ{[菬
		volMax = volMin;
	}
	
	if( maxDist < minDist ){
		// ő{[ŏ{[菬
		maxDist = minDist;
	}
	
	if( dist > maxDist - minDist ){									// ꂷ
		setVolf = volMin;
	}else if( dist < minDist ){										// ߂
		setVolf = volMax;
	}else{
		if( maxDist==minDist ){
			setVolf  = volMin;
		}else{
			setVolf = maxDist - minDist;
			setVolf = (setVolf - dist) * (volMax - volMin) / setVolf;
			setVolf += volMin;
		}
	}
	
	camYaw	= atan2f(camTPos.x - camPos.x, camTPos.z - camPos.z);		// Jpx擾
	chaYaw	= atan2f(tPos.x - camPos.x, tPos.z - camPos.z);				// JƖړI̊px擾
	yaw		= chaYaw - camYaw;											// ݂̊px
	GHM_LIMIT_RANGE(yaw, PI, -PI);										// ۂ
	
	// p̒l߂
	getPan  = -1.f * 127.f * sin(yaw);
	getPan += 127.f;
	
	// {[l̃Zbg
	*pGetVol = (u8 )setVolf;
	
	// pl̃Zbg
	*pGetPan = (u8 )getPan;
	
	return (u8 )*pGetVol;
}

/*
	
	
	[vrd̍ĐiJgXe[Wȍ~
	
	<in>
	taskEnd 		0:Xe[WςƏI
					1:}jAŁA-1ɂƏI
	
	evNo			0 ȊO ̃Cxgԍ true ɂȂ_Ń^XNIƂȂ
	charaID			-1 ȊO ̃Cxgԍ true ɂȂ_Ń^XNIƂȂ
	
	<return>
	LOOPSE   *p		
	NULL			̏ꍇ́AN܂Ń[v]܂
	
	
	
*/
LOOPSE *KK7SoundLoopSePlayVolumeChange(Vec Pos, u32 stageid, int inSEno, u8 volMax, u8 inMode, int taskEnd, u32 evNo, s32 charaID)
{
	LOOPSE *pData = NULL;

	if ( evNo != 0 ){
		if( GameInfo.GetScenarioFlag((int )evNo) == TRUE ){
			return pData;
		}
	}

	pData = (LOOPSE *)K7AppSmallMemAlloc( (int)(sizeof(LOOPSE)) );
	if ( pData != NULL ){
		pData->inSEno	= inSEno;
		pData->volMax	= volMax;
		pData->inMode	= inMode;
		pData->pos.x	= Pos.x;
		pData->pos.y	= Pos.y;
		pData->pos.z	= Pos.z;
		pData->stageid	= stageid;
		pData->taskEnd	= taskEnd;
		pData->evNo		= evNo;
		pData->charaID	= charaID;
		
		// NO`FbN
		if ( !pData->taskEnd ){
			if( WK7Stage::GetCurrentStageID () != 0xffffffff && WK7Stage::GetCurrentStageID () != pData->stageid ){
				GHMGCMEM_SAFE_FREE(pData);
				return (LOOPSE *)NULL;
			}
			if( WK7Stage::GetReleasedStageID() != 0xffffffff && WK7Stage::GetReleasedStageID() != pData->stageid ){
				GHMGCMEM_SAFE_FREE(pData);
				return (LOOPSE *)NULL;
			}
			if( WK7Stage::GetCurrentStageID ()==0xffffffff && WK7Stage::GetReleasedStageID()==0xffffffff ){
				GHMGCMEM_SAFE_FREE(pData);
				return (LOOPSE *)NULL;
			}
		}
		
		if ( -1 == GET_WK7MAINTASK_FRAMEPROCESSTASKPTR()->Start(	KK7SoundLoopSePlayVolumeChangeTask,
																	KK7SoundLoopSePlayVolumeChangeTermTask,
																	(u32)pData) ){
			GHMGCMEM_SAFE_FREE(pData);
			return (LOOPSE *)NULL;
		}
	}
	
	return pData;
}
GHMGCTASK_HANDLER(KK7SoundLoopSePlayVolumeChangeTask)
{
	LOOPSE *pData	= (LOOPSE *)task_get_param(0);
	u8		getVolume, getPan;
	int	count = 1;
	
	pData->retSEno = gpSound->mPlaySE( pData->inSEno, SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackBattleOverlap );
	
	while( 1 ) {
		
		if ( !pData->taskEnd ){
			if( WK7Stage::GetCurrentStageID () != 0xffffffff && WK7Stage::GetCurrentStageID () != pData->stageid ){
				break;
			}
			if( WK7Stage::GetReleasedStageID() != 0xffffffff && WK7Stage::GetReleasedStageID() != pData->stageid ){
				break;
			}
			if( WK7Stage::GetCurrentStageID ()==0xffffffff && WK7Stage::GetReleasedStageID()==0xffffffff ){
				break;
			}
		}else{
			if ( pData->taskEnd < 0 ){
				break;
			}
		}
		
		if( count ){
			count--;
		}else{
			if( gpSound->mCheckSENo(pData->retSEno)==false ){
				// ~ł
				return;
			}
		}
		
		// Cxgԍݒ肳Ăꍇ
		if ( 0 != pData->evNo ){
			if( GameInfo.GetScenarioFlag((int )pData->evNo) == TRUE ){			// ς݁H
				break;
			}
		}
		
		// Lݒ肳Ăꍇ
		if ( -1 != pData->charaID ){
			if ( pData->charaID != WK7PLAYERCONTROL->GetMainID() ){				// CLς
				break;
			}
		}
		
		// {[쐬
		seVolCalc(pData->pos, (u8 )pData->volMax, &getVolume, &getPan, (u8 )pData->inMode);
		
		// {[ύXit[wj
		gpSound->mSetVolumeSENo(pData->retSEno, getVolume, 1 );
		
		// pύXit[wj
		gpSound->mSetPanSENo(pData->retSEno, getPan );
		
		retsys();
	}
	
#define	AMBSE_FADESEC			(2)
#define	AMBSE_FADESOUNDTIME		(s16)(200 * AMBSE_FADESEC)
#define	AMBSE_FADETICK			WK7_SEC_TO_TICK(AMBSE_FADESEC)
	gpSound->mSetVolumeSENo(pData->retSEno, 0, AMBSE_FADESOUNDTIME );
	K7SCR_TIMEWAIT(AMBSE_FADETICK);
	
//	gpSound->mStopSE(pData->inSEno);
	
//	GHMGCMEM_SAFE_FREE( pData );
	
}
GHMGCTASK_HANDLER(KK7SoundLoopSePlayVolumeChangeTermTask)
{
	LOOPSE *pData	= (LOOPSE *)task_get_param(0);
	gpSound->mStopSENo(pData->retSEno);
	
	GHMGCMEM_SAFE_FREE( pData );
}


LOOPSE2 *KK7SoundLoopSePlayVolumeChange2(Vec Pos,u32 stageid,int inSEno,u8 volMax,u8 volMin,f32 maxDist,f32 minDist,int taskEnd,u32 evNo,u32 fadeTime)
{
	LOOPSE2	*pData = NULL;

	if ( evNo != 0 ){
		if( GameInfo.GetScenarioFlag((int )evNo) == TRUE ){
			return pData;
		}
	}

	pData = (LOOPSE2 *)K7AppSmallMemAlloc( (int)(sizeof(LOOPSE2)) );
	if ( pData != NULL ){
		
		pData->inSEno	= inSEno;
		pData->volMax	= volMax;
		pData->volMin	= volMin;
		pData->maxDist	= maxDist;
		pData->minDist	= minDist;
		pData->pos.x	= Pos.x;
		pData->pos.y	= Pos.y;
		pData->pos.z	= Pos.z;
		pData->stageid	= stageid;
		pData->taskEnd	= taskEnd;
		pData->evNo		= evNo;
		pData->fadeTime = fadeTime;
		
		// NO`FbN
		if ( !pData->taskEnd ){
			if( WK7Stage::GetCurrentStageID () != 0xffffffff && WK7Stage::GetCurrentStageID () != pData->stageid ){
				GHMGCMEM_SAFE_FREE(pData);
				return NULL;
			}
			if( WK7Stage::GetReleasedStageID() != 0xffffffff && WK7Stage::GetReleasedStageID() != pData->stageid ){
				GHMGCMEM_SAFE_FREE(pData);
				return NULL;
			}
			if( WK7Stage::GetCurrentStageID ()==0xffffffff && WK7Stage::GetReleasedStageID()==0xffffffff ){
				GHMGCMEM_SAFE_FREE(pData);
				return NULL;
			}
		}
		
		if ( -1 == GET_WK7MAINTASK_FRAMEPROCESSTASKPTR()->Start(	KK7SoundLoopSePlayVolumeChangeTask2,
																	KK7SoundLoopSePlayVolumeChangeTermTask2,
																	(u32)pData) ){
			GHMGCMEM_SAFE_FREE(pData);
			return NULL;
		}
	}
	
	return pData;
}
GHMGCTASK_HANDLER(KK7SoundLoopSePlayVolumeChangeTask2)
{
	LOOPSE2	*pData	= (LOOPSE2 *)task_get_param(0);
	u8		getVolume, getPan;
	int		count   = 1;
	u32		time    = 0;
	
	pData->retSEno = gpSound->mPlaySE(pData->inSEno, 0, SOUND_PAN_CENTER, eSETrackBattleOverlap );
	
	while( 1 ) {
		
		if ( !pData->taskEnd ){
			if( WK7Stage::GetCurrentStageID () != 0xffffffff && WK7Stage::GetCurrentStageID () != pData->stageid ){
				break;
			}
			if( WK7Stage::GetReleasedStageID() != 0xffffffff && WK7Stage::GetReleasedStageID() != pData->stageid ){
				break;
			}
			if( WK7Stage::GetCurrentStageID ()==0xffffffff && WK7Stage::GetReleasedStageID()==0xffffffff ){
				break;
			}
		}else{
			if ( pData->taskEnd < 0 ){
				break;
			}
		}
		
		if( count ){
			count--;
		}else{
			if( gpSound->mCheckSENo(pData->retSEno)==false ){
				// ~ł
				return;
			}
		}
		
		// Cxgԍݒ肳Ăꍇ
		if ( 0 != pData->evNo ){
			if( GameInfo.GetScenarioFlag((int )pData->evNo) == TRUE ){			// ς݁H
				break;
			}
		}
		
		f32		volrate;
		u8		volMin,volMax;
		
		if( time + WK7_TICK_PER_FRAME >= pData->fadeTime ){
			volrate = 1.0f;
		}else{
			time += WK7_TICK_PER_FRAME;
			volrate = (f32)time / pData->fadeTime;
		}
		
		volMin = (u8)(pData->volMin * volrate);
		volMax = (u8)(pData->volMax * volrate);
		
		// {[쐬
		seVolCalc2(pData->pos,
		           volMax,
		           volMin,
		           &getVolume,
		           &getPan,
		           pData->maxDist,
		           pData->minDist);
		
		// {[ύXit[wj
		gpSound->mSetVolumeSENo(pData->retSEno,getVolume,1);
		
		// pύXit[wj
		gpSound->mSetPanSENo(pData->retSEno,getPan);
		
		retsys();
	}
	
#define	AMBSE_FADESEC			(2)
#define	AMBSE_FADESOUNDTIME		(s16)(200 * AMBSE_FADESEC)
#define	AMBSE_FADETICK			WK7_SEC_TO_TICK(AMBSE_FADESEC)
	gpSound->mSetVolumeSENo(pData->retSEno,0,AMBSE_FADESOUNDTIME);
	K7SCR_TIMEWAIT(AMBSE_FADETICK);
}

GHMGCTASK_HANDLER(KK7SoundLoopSePlayVolumeChangeTermTask2)
{
	LOOPSE2	*pData	= (LOOPSE2 *)task_get_param(0);
	gpSound->mStopSENo(pData->retSEno);
	GHMGCMEM_SAFE_FREE( pData );
}

