////////////////////////////////////////////////////////////////////////////////
//
// GrassHopperManufacture GameCube Typedef
//
// ghmGcTypes.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/30/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__GHMGCTYPES_H__
#define	__GHMGCTYPES_H__

#include <dolphin.h>
#include <sysdolphin/baselib.h>
#include <sysdolphin/scene.h>

#ifndef	PI
#define	PI						(3.14159265358979f)
#endif

typedef	unsigned char			u_char;
typedef	unsigned short			u_short;
typedef	unsigned int			u_int;
typedef	unsigned long			u_long;

typedef	signed char				s_char;
typedef	signed short			s_short;
typedef	signed int				s_int;
typedef	signed long				s_long;

struct Vec4{
	f32		x,y,z,w;
};

typedef	f32 sysdolVec[3];

#include "ghmGcMem.h"

#endif	//__GHMGCTYPES_H__

