/**********************************************************************


1. Ѓnh\񋟂{}̂Ɋ܂܂AZpA}ʁAKiAR
   s[^E\tgEFAAASYyт̑̏iȉA
   u{閧vƂ܂j̒쌠AmIL̑̌́A
   Ѓnh\܂͊Ѓnh\Ɏgp҂ɋA܂B
2. {閧́AЃnh\ړIȊO̖ړIŎgpA
   邱Ƃł܂B
3. {閧AO҂֊J邱Ƃ͂ł܂B
4. {閧AςĎgp邱Ƃ͂ł܂B
5. Ѓnh\́A{閧̎gpɂ萶Ȃ鑹QɊւ
   AؐӔC𕉂Ȃ̂Ƃ܂B

Notices

1. Copyrights, any other intellectual property right and other rights 
   to and in the technical material, charts, specifications computer 
   software, algorithm and any other information (hereinafter called 
   "the Confidential Information") included in the media which is 
   provided by Hudson Soft Co., Ltd. shall belong to Hudson Soft Co., 
   Ltd. or its licensors.
2. No part of the Confidential Information may be reproducedor used 
   for any purpose other than that licensed by Hudson Soft Co., Ltd.
3. No part of the Confidential Information may be disclosed to any 
   third party.
4. No part of the Confidential Information may be revised in  order to 
   use it.
5. In no case shall Hudson Soft Co., Ltd. be held responsible for any 
   loss or damage arising from the use of the Confidential Information.
**********************************************************************/

//#pragma cplusplus			off
//#pragma cpp_extensions		off

#include "ghmgcmem.h"


#include <dolphin.h>
#include <string.h>

extern "C"{
#include <seqfile.h>
#include <HVQM4File.h>
#include <HVQM4Dec.h>
#include <HVQM4DecSnd.h>
#include <HVQM4Bufv.h>
#include <HVQM4Bufa.h>
#include <HVQM4Alloc.h>
}

typedef struct _tagImageBuf {
  int   buff_status;  /* Buffer status: 0 = Empty, 1 = It has data */
  int   disp_status;  /* Dispaly status: 0 = Disabled, 1 = Enabled */
  u32    frame;
  u8*  top;          /* Head pointer to the strage area of image data */
  HVQM4BufvData *bufv;
} ImageBuf;

typedef struct _hvqm4playerex_ {
    SEQFILEHANDLE  fp;
    HVQM4Header    header;
    HVQM4SeqObj    seqobj;
    u32 width;
    u32 height;
    u32 bnum;
    void *workbuff;
    HVQM4BufvHandle *hBufv;
    HVQM4BufaHandle *hBufa;
    hHVQM4DecSound   hSnd;
    u32 audio_track;
    OSThread playerThread;
    u8 *playerThreadStack;
    u32 read_buff_size;
    u8  *read_buff;
    BOOL disp;
    BOOL exec;
    BOOL wait;
	/*-- Play mode --*/
	BOOL play_repeat;
    /*-- Control --*/
    u32  play_control;
    BOOL play_1step;
    BOOL play_gop_skip;
    int  play_suspend;
    BOOL play_buffclear;
    BOOL exit_request;
    /*-- Synchronous mode --*/
    u32 sync_mode;
    int sync_field;
    /*-- Display timing --*/
    volatile u64 cur_time;
    volatile u64 nxt_time;
	u32 time_mode;
    u32 dat_time;
    void (*start_func)(struct _hvqm4playerex_ *,void *);
    void *start_parm;
    /*-- Video Decode --*/
    u32 yuvbuf;         /* Size of required area for a YUV image */
    ImageBuf* past;     /* Previous YUV image */
    ImageBuf* present;  /* Current YUV image */
    ImageBuf* future;   /* Prospective YUV image */
    ImageBuf  buff[3];
    /*-- For debugging --*/
    u32 end_bufv_nums;
    u32 end_bufa_nums;
    u32 disp_empty_count;
} *hHVQM4PlayerEx, HVQM4PlayerEx;

#define __MAKING_HVQM4PLAYEREX_LIB__
#include <HVQM4PlayerEx.h>

#define SYNC_MODE_VARIABLE  0
#define SYNC_MODE_FIELDSYNC 1

#define PLAY_CONTROL_NORMAL 0
#define PLAY_CONTROL_STEP   1
#define PLAY_CONTROL_PAUSE  2
#define PLAY_CONTROL_FWD    3
#define PLAY_CONTROL_RWD    4
#define PLAY_CONTROL_FWD1   5
#define PLAY_CONTROL_RWD2   6
#define PLAY_CONTROL_EXIT   7

#ifdef __USE_HVQM4InitFunction__
BOOL HVQM4InitFunction(u8 *version);
#endif

static BOOL shutdown_request=FALSE;
static volatile int  lib_link_counter=0;

static void inc_lib_link_counter()
{
    BOOL irq;
    irq=OSDisableInterrupts();
    lib_link_counter++;
    OSRestoreInterrupts(irq);
//    OSReport("lib_link_counter=%d\n",lib_link_counter);
}

static void dec_lib_link_counter()
{
    BOOL irq;
    irq=OSDisableInterrupts();
    if ( lib_link_counter > 0 ) {
        lib_link_counter--;
    } else {
#ifdef _DEBUG
        OSReport("lib_link_counter, under flow\n");
#endif
    }
    OSRestoreInterrupts(irq);
//    OSReport("lib_link_counter=%d\n",lib_link_counter);
}

/*---------------------------------------------------------------------------
    Shutdown setting
---------------------------------------------------------------------------*/

void HVQM4PlayerExSetShutdown(void)
{
    shutdown_request=TRUE;
    SeqFileSetShutdown();
}

/*---------------------------------------------------------------------------
    Shutdown confirmation
---------------------------------------------------------------------------*/

BOOL HVQM4PlayerExCheckShutdown(void)
{
    if ( lib_link_counter > 0 ) {
        return(TRUE);
    }
    return(FALSE);
}

/*---------------------------------------------------------------------------
    Cancel
---------------------------------------------------------------------------*/

static BOOL cancel_request=FALSE;

void HVQM4PlayerExSetCancel(void)
{
    BOOL irq;
    irq=OSDisableInterrupts();
    cancel_request=TRUE;
    SeqFileSetCancel();
    OSRestoreInterrupts(irq);
}

static void HVQM4PlayerExClrCancel(void)
{
    BOOL irq;
    irq=OSDisableInterrupts();
    cancel_request=FALSE;
    SeqFileClrCancel();
    OSRestoreInterrupts(irq);
}

/*===========================================================================
    Video decoding
===========================================================================*/

static u32 field_time = 16683;    /* 16683.3 */

BOOL HVQM4PlayerExViRetrace(hHVQM4PlayerEx hp)
{
    BOOL res;

    if ( !(hp->disp) ) {
        return(FALSE);
    }
    if ( (hp->wait) ) {
        return(FALSE);
    }

    if ( hp->sync_mode == SYNC_MODE_FIELDSYNC ) {
        if ( VIGetNextField() == hp->sync_field ) {
            hp->cur_time += hp->dat_time;
        }
    } else {
        hp->cur_time += field_time;
    }

    if ( hp->cur_time >= hp->nxt_time ) {
		if ( hp->sync_mode == SYNC_MODE_VARIABLE && hp->play_control == PLAY_CONTROL_NORMAL && hp->hBufa != NULL ) {
			int v,a,data;
			v=(int)HVQM4BufvGetDispNums(hp->hBufv);
			a=(int)HVQM4BufaGetSendNums(hp->hBufa);
			data = v - a;

			if ( a <= 1 || v <= 1 ) {
				hp->time_mode=0;
			} else if ( data > 2 ) {
				hp->time_mode=1;
			} else if ( data < -2 ) {
				hp->time_mode=2;
			} else {
				if ( hp->time_mode == 1 && data <= 0 ) {
					hp->time_mode=0;
				} else if ( hp->time_mode == 2 && data >= 0 ) {
					hp->time_mode=0;
				}
			}

			if ( hp->time_mode == 0 ) {
				hp->nxt_time += hp->dat_time;
			} else if ( hp->time_mode == 1 ) {
				hp->nxt_time += (((hp->dat_time)*9)/10);
			} else {
				hp->nxt_time += (((hp->dat_time)*10)/9);
			}
#if 1
{
 static u32 time_mode = 0xffffffff;
 if ( time_mode != hp->time_mode ) {
  if ( time_mode != 0xffffffff ) {
   switch( hp->time_mode ) {
   case 0: OSReport("* %d,%d %d\n",v,a,data); break;
   case 1: OSReport("+ %d,%d %d\n",v,a,data); break;
   case 2: OSReport("- %d,%d %d\n",v,a,data); break;
   }
  }
  time_mode = hp->time_mode ;
 }
}
#endif
		} else {
			hp->nxt_time += hp->dat_time;
		}
        res=TRUE;
    } else {
        res=FALSE;
    }

    return(res);
}

static BOOL decv_init(hHVQM4PlayerEx hp, u32 *errcode)
{
    int width;          /* Pixels of image horizontal */
    int height;         /* Pixels of image vertical */
    int h_samp;         /* Subsampling interval of color difference for horizontal */
    int v_samp;         /* Subsampling interval of color difference for vertical */
    HVQM4SeqObj *seqobj;

    /* For this function, errcode is never called as NULL */

    seqobj=&(hp->seqobj);

    /* Read image size */
    width  = HVQM4GetWidth(seqobj);
    height = HVQM4GetHeight(seqobj);
    h_samp = HVQM4GetSamplingRateH(seqobj);
    v_samp = HVQM4GetSamplingRateV(seqobj);

#ifdef __HVQM4PLAYEREX2_C__
    hp->yuvbuf = (u32)(width * height * 2);
#else
    hp->yuvbuf = (u32)(width * height * (h_samp * v_samp + 2)) / (h_samp * v_samp);
#endif

    hp->hBufv=HVQM4BufvCreate(hp->yuvbuf,hp->bnum);
    if ( hp->hBufv == NULL ) {
#ifdef _DEBUG
        OSReport("HVQM4BufvCreate(%d,%d) error !\n",hp->yuvbuf,hp->bnum);
#endif
        *errcode=HVQM4PLAYEREX_ERROR_INITVBUF;
        return(FALSE);
    }

    /* Initialize buffer */

    if ( (hp->buff[0].bufv=HVQM4BufvGetFree(hp->hBufv))==NULL ){
        OSHalt("decv_open(), buff[0].bufv set error !\n");
        *errcode=HVQM4PLAYEREX_ERROR_INITVBUF;
        return(FALSE);
    }
    if ( (hp->buff[1].bufv=HVQM4BufvGetFree(hp->hBufv))==NULL ){
        OSHalt("decv_open(), buff[1].bufv set error !\n");
        *errcode=HVQM4PLAYEREX_ERROR_INITVBUF;
        return(FALSE);
    }
    if ( (hp->buff[2].bufv=HVQM4BufvGetFree(hp->hBufv))==NULL ){
        OSHalt("decv_open(), buff[2].bufv set error !\n");
        *errcode=HVQM4PLAYEREX_ERROR_INITVBUF;
        return(FALSE);
    }
    hp->buff[0].buff_status = 0; hp->buff[0].disp_status = -1;
    hp->buff[1].buff_status = 0; hp->buff[1].disp_status = -1;
    hp->buff[2].buff_status = 0; hp->buff[2].disp_status = -1;
    hp->buff[0].top = hp->buff[0].bufv->buff;
    hp->buff[1].top = hp->buff[1].bufv->buff;
    hp->buff[2].top = hp->buff[2].bufv->buff;

    hp->past    = &(hp->buff[0]);
    hp->present = &(hp->buff[1]);
    hp->future  = &(hp->buff[2]);

    return(TRUE);
}

static void decv_wait(hHVQM4PlayerEx hp)
{
    HVQM4BufvData *dp;

//OSReport("decv_wait()\n");
    while( (dp = HVQM4BufvGetFree(hp->hBufv)) == NULL ) {
        hp->wait=FALSE;
        if ( hp->exec && hp->cur_time == 0 && !SeqFileCheckBusy(hp->fp) ) {
            hp->cur_time = 1;
            hp->disp=TRUE;
            if ( hp->start_func != NULL ) {
                hp->start_func(hp,hp->start_parm);
            }
        }
    }
    HVQM4BufvSetFree(hp->hBufv,hp->present->bufv);
    hp->present->bufv = dp;
    hp->present->top  = dp->buff;
}

static BOOL decv_decode(hHVQM4PlayerEx hp,u16 format,u8* code)
{
    u32 frame;

    frame=*((u32 *)code);
    code +=4 ;

    /* If it is not B picture, swap prospective picture and previous picture. */
    if (format != HVQM4_VIDEO_B_PIC) {
        ImageBuf* tmp; tmp = hp->past; hp->past = hp->future; hp->future = tmp;
        hp->future->buff_status = 0;              /* Prospective buffer is not available for reference. */
    }

    /* If it is B picture, terminate since decoding is not availabe without previous and prospect picture. 
     * If it is P picture, terminate since decoding is not availabe without previous picture.
    */
    if (((format == HVQM4_VIDEO_P_PIC) && (hp->past->buff_status == 0)) ||
        ((format == HVQM4_VIDEO_B_PIC) && (hp->past->buff_status == 0 &&
                                        hp->future->buff_status == 0))) {
        return(FALSE);
    }

    /* HVQM4 decoding */
    switch (format) {
    case HVQM4_VIDEO_I_PIC:   /* I picture */
        HVQM4DecodeIpic(&(hp->seqobj), code, hp->present->top);
        hp->present->disp_status = hp->present->buff_status = 1;
        hp->present->frame = frame;
        break;

    case HVQM4_VIDEO_P_PIC:   /* P picture */      
        HVQM4DecodePpic(&(hp->seqobj), code, hp->present->top, hp->past->top);
        hp->present->disp_status = hp->present->buff_status = 1;
        hp->present->frame = frame;
        break;

    case HVQM4_VIDEO_B_PIC:   /* B picture */
        HVQM4DecodeBpic(&(hp->seqobj), code, hp->present->top, hp->past->top, hp->future->top);
        hp->present->disp_status = hp->present->buff_status = 1;
        hp->present->frame = frame;
        break;
    default:
        return(FALSE);
    }
    /* If it is not B picture, swap current picture and prospective picture. */
    if (format != HVQM4_VIDEO_B_PIC) {
        ImageBuf* tmp;
        tmp = hp->present; hp->present = hp->future; hp->future = tmp;
    }

    return(TRUE);
}

static BOOL decv_update(hHVQM4PlayerEx hp)
{
    if (hp->present->disp_status == 1) {
        hp->present->disp_status = 0;
        hp->present->bufv->busy=TRUE;
#ifdef __HVQM4PLAYEREX2_C__
# ifdef __USE_DC_Store__
        DCStoreRangeNoSync(hp->present->bufv->buff,hp->present->bufv->size);
# endif
# ifdef __USE_DC_Flush__
        DCFlushRangeNoSync(hp->present->bufv->buff,hp->present->bufv->size);
# endif
#endif
        HVQM4BufvSetDisp(hp->hBufv,hp->present->bufv);
        return(TRUE);
    }

    if (hp->past->disp_status == 1) {
        hp->past->disp_status = 0;
        hp->past->bufv->busy=TRUE;
#ifdef __HVQM4PLAYEREX2_C__
# ifdef __USE_DC_Store__
        DCStoreRangeNoSync(hp->past->bufv->buff,hp->past->bufv->size);
# endif
# ifdef __USE_DC_Flush__
        DCFlushRangeNoSync(hp->past->bufv->buff,hp->past->bufv->size);
# endif
#endif
        HVQM4BufvSetDisp(hp->hBufv,hp->past->bufv);
        return(TRUE);
    }

    if (hp->past->disp_status == 0 && hp->present->disp_status == 0 && hp->future->disp_status == 1) {
        hp->future->disp_status = 0;
        hp->future->bufv->busy=TRUE;
#ifdef __HVQM4PLAYEREX2_C__
# ifdef __USE_DC_Store__
        DCStoreRangeNoSync(hp->future->bufv->buff,hp->future->bufv->size);
# endif
# ifdef __USE_DC_Flush__
        DCFlushRangeNoSync(hp->future->bufv->buff,hp->future->bufv->size);
# endif
#endif
        HVQM4BufvSetDisp(hp->hBufv,hp->future->bufv);
        return(TRUE);
    }

    return(FALSE);
}

/*===========================================================================
    Audio Decoding
===========================================================================*/

static BOOL deca_init(hHVQM4PlayerEx hp,u32 *errcode)
{
    u32 size;

    /* For this function, errcode is never called as NULL */

    if( hp->header.audioinfo.samples_per_sec == 0 && hp->header.audioinfo.channels == 0 ){
        /* If it is soundless data, do not initialize. */
#ifdef _DEBUG
        OSReport("no sound data\n");
#endif
        return(TRUE);
    }

#if 0
    size  = hp->header.audioinfo.samples_per_sec;
    size *= hp->header.usec_per_frame;
    size /= 1000000;
    size = OSRoundUp32B(size+32+1);
    size *= 4;

    hp->hBufa=HVQM4BufaCreate(size,((hp->bnum) * 2));
    if ( hp->hBufa == NULL ) {
#ifdef _DEBUG
        OSReport("HVQM4BufaCreate(%d,%d) error !\n",size,hp->bnum);
#endif
        *errcode=HVQM4PLAYEREX_ERROR_INITABUF;
        return(FALSE);
    }
#endif

    /* Initialize sound decoder */
    if ( (hp->hSnd=HVQM4DecSoundCreate(&(hp->header.audioinfo))) == NULL )  {
#ifdef _DEBUG
        OSReport("HVQM4DecSoundCreate() error !\n");
#endif
        *errcode=HVQM4PLAYEREX_ERROR_INITADEC;
        return(FALSE);
    }

	size = HVQM4DecSoundMaxDecodeSize(hp->hSnd,hp->header.max_audio_record_size,HVQM4PlayerExGetMaxAudioTrack(hp)+1);
	if ( size == 0 ) {
		size  = hp->header.audioinfo.samples_per_sec;
		size *= hp->header.usec_per_frame;
		size /= 1000000;
		size = OSRoundUp32B(size+32+1);
		size *= 4;
	} else {
		size = OSRoundUp32B(size+32+1);
	}
	hp->hBufa=HVQM4BufaCreate(size,((hp->bnum) * 2));
	if ( hp->hBufa == NULL ) {
#ifdef _DEBUG
		OSReport("HVQM4BufaCreate(%d,%d) error !\n",size,hp->bnum);
#endif
		*errcode=HVQM4PLAYEREX_ERROR_INITABUF;
		return(FALSE);
	}

    return(TRUE);    
}

static void deca_decode(hHVQM4PlayerEx hp,HVQM4RecHeader *rech,u8 *code)
{
    HVQM4BufaData *dp;
    u32 sample;
    u8 *out;

    while(1){
        if ( (dp=HVQM4BufaGetFree( hp->hBufa )) != NULL ) {
            break;
        }
#ifdef _DEBUG
        OSReport("Ai buff over run ?\n");
#endif
        if ( shutdown_request ) {
            return;
        }
        VIWaitForRetrace();
    }
    out=dp->buff;
    sample = *((u32 *)code);
    dp->size = sample*4;
    HVQM4DecSoundDecode( hp->hSnd,rech,sample,code+4,(int)(hp->audio_track),out );
    HVQM4BufaSetSend(hp->hBufa,dp);
}

/*===========================================================================
    Player Thread
===========================================================================*/

static void play_suspend(hHVQM4PlayerEx hp)
{
    BOOL irq;

    irq=OSDisableInterrupts();
    hp->play_suspend++;
    OSRestoreInterrupts(irq);
    while(1){
        if ( hp->play_suspend <= 0 ) {
            break;
        }
        if ( shutdown_request || cancel_request || hp->exit_request ) {
            hp->play_suspend=0;
            break;
        }
        VIWaitForRetrace();
    }
}

static void play_resume(hHVQM4PlayerEx hp)
{
	BOOL irq;

	irq=OSDisableInterrupts();
	if ( hp->play_suspend > 0 ) {
		hp->play_suspend--;
	}
	OSRestoreInterrupts(irq);
}

#define ReadBuffAlign 32768
#define OSRoundUpReadBuffAlign(x)    (((u32)(x)+ReadBuffAlign-1) & ~(ReadBuffAlign-1))

static BOOL alloc_read_buff(hHVQM4PlayerEx hp,u32 size)
{
    if ( size <= hp->read_buff_size ) {
        return(TRUE);
    }
//    OSReport("alloc_read_buff() %d:%08x",size,size);
    size = OSRoundUpReadBuffAlign(size);
//    OSReport(" -> %d:%08x\n",size,size);
    if ( hp->read_buff != NULL )  {
        HVQM4Free(hp->read_buff);
        hp->read_buff = NULL;
        hp->read_buff_size = 0 ;
    }
    hp->read_buff = (u8 *)HVQM4Alloc(size);
    if ( hp->read_buff == NULL ) {
#ifdef _DEBUG
        OSReport("read buffer alloc error !\n");
#endif
        return(FALSE);
    }
    hp->read_buff_size = size ;
    return(TRUE);
}

/* Decode a unit of GOP */
static BOOL gop_decode(hHVQM4PlayerEx hp, HVQM4GOPHeader *gophdr)
{
    u32 codesize;                            // Code size
    u8 *code;
    HVQM4RecHeader rechdr;
    u32 reccnt,recnum;
    u16 type;                                // Record type
    u16 fomt;                                // Format
    BOOL res;

    if ( hp->exit_request || cancel_request ) {
        hp->play_gop_skip=TRUE;
    }
    if ( hp->play_control == PLAY_CONTROL_RWD ) {
        hp->play_gop_skip=TRUE;
    } else if ( hp->play_control == PLAY_CONTROL_FWD ) {
        hp->play_gop_skip=TRUE;
    } else if ( hp->play_control == PLAY_CONTROL_PAUSE ) {
        hp->play_gop_skip=TRUE;
    } else {
        hp->play_gop_skip=FALSE;
    }

    reccnt = gophdr->vidrec_number + gophdr->audrec_number;
    recnum=0;
    while( recnum < reccnt ) {
        recnum++;
        if ( shutdown_request ) {
#ifdef _DEBUG
            OSReport("shutdown\n");
#endif
            return(FALSE);
        } 
        if ( cancel_request ) {
#ifdef _DEBUG
            OSReport("cancel\n");
#endif
            return(FALSE);
        } 
        if ( SeqFileRead( &rechdr, sizeof(HVQM4RecHeader), hp->fp) <= 0 ) {
#ifdef _DEBUG
            OSReport("HVQM4RecHeader read error \n");
#endif
            return(FALSE);
        }
        // Read code
        codesize = rechdr.size;  // Code size
        if ( !alloc_read_buff(hp,codesize) ) {
            return(FALSE);
        }
        code = hp->read_buff;
        if ( SeqFileRead( code, (int)codesize, hp->fp ) <= 0 ) {
#ifdef _DEBUG
            OSReport("hvqm code read error ! codesize=%d\n",codesize);
#endif
            return(FALSE);
        }

        // Start decoding
        type = rechdr.type;        // Record type
        fomt = rechdr.format;    // Format
        if (type == HVQM4_VIDEO) {
//            OSReport("V:%08x(%d)\n",codesize,codesize);
            decv_wait(hp);
            res=decv_decode(hp,fomt, code);
            if ( !res ) {
#ifdef _DEBUG
                OSReport("decode error !\n");
#endif
                return(FALSE);
            }
            if ( decv_update(hp) ) {
            }
        } else if (type == HVQM4_AUDIO) {
//            OSReport("A:%08x %08x %08x\n",codesize, *((u32 *)code),fomt );
            deca_decode(hp,&rechdr,code);
        } else {
#ifdef _DEBUG
            OSReport("unknown recode type. type=%d\n",type);
#endif
        }
        if ( recnum >= 4 && (recnum & 0x01)==0 ) {
            if ( hp->play_gop_skip ) {
                break;
            }
        }
        if ( (recnum & 0x01) == 0 ) {
            if ( !(hp->play_1step) ) {
                if ( hp->play_control == PLAY_CONTROL_STEP ) {
                    play_suspend(hp);
                }
            }
            hp->play_1step=FALSE;
        }
    }
    return (TRUE);
}

/* Decode a file */
static void *_HVQM4PlayerExThread(void *param)
{
    HVQM4GOPHeader gophdr;
    hHVQM4PlayerEx hp;
    u32 gop_total;
    u32 gop_num;
	u32 top;
    hp=(hHVQM4PlayerEx)param;
    
    gop_total = hp->header.gop_total;
    hp->dat_time = hp->header.usec_per_frame;
    hp->cur_time = 0;
    hp->nxt_time = 0;
    hp->exit_request=FALSE;
top=(u32)SeqFileGetPos(hp->fp);
do{
	SeqFileSeek(hp->fp,top);
    for ( gop_num=0 ; gop_num < gop_total && !(hp->exit_request) && !shutdown_request && !cancel_request ; ) {
        u32 cur,fwd,rwd;
        u32 control;
        cur=(u32)SeqFileGetPos(hp->fp);
        if ( SeqFileRead( &gophdr, sizeof(HVQM4GOPHeader), hp->fp ) <= 0 ) {
#ifdef _DEBUG
            OSReport("no gophdr, file end\n");
#endif
            break;
        }
        rwd= cur - gophdr.gop_offset;
        fwd= cur + gophdr.size + sizeof(HVQM4GOPHeader);
        control=hp->play_control;
        if ( !gop_decode(hp, &gophdr) ) {
            break;
        }
        switch(control){
        case PLAY_CONTROL_RWD:
            if ( gop_num == 0 ) {
                hp->play_control = PLAY_CONTROL_PAUSE;
                SeqFileSeek(hp->fp,cur);
            } else {
                SeqFileSeek(hp->fp,rwd);
                gop_num--;
            }
            break;
        case PLAY_CONTROL_FWD:
            if ( gop_num+1 == gop_total ) {
                hp->play_control = PLAY_CONTROL_PAUSE;
                SeqFileSeek(hp->fp,cur);
            } else {
                SeqFileSeek(hp->fp,fwd);
                gop_num++;
            }
            break;
        case PLAY_CONTROL_PAUSE:
            SeqFileSeek(hp->fp,cur);
            play_suspend(hp);
            break;
        default:
            SeqFileSeek(hp->fp,fwd);
            gop_num++;
            break;
        }
    }
} while( hp->play_repeat && !(hp->exit_request) && !shutdown_request && !cancel_request );

    decv_update(hp);
    hp->end_bufv_nums=HVQM4BufvGetDispNums(hp->hBufv);
    if ( hp->hBufa == NULL ) {
        hp->end_bufa_nums=0;
    } else {
        hp->end_bufa_nums=HVQM4BufaGetSendNums(hp->hBufa);
    }

    hp->wait=FALSE;    /* Since it is the case termination is executed before sufficient data is in buffer. */

    /* Wait for the rest of buffer to be played */
    if ( hp->disp ) {
        while( HVQM4BufvChkDisp(hp->hBufv) != NULL )
            ;
        if ( hp->hBufa != NULL ) {
            while( HVQM4BufaChkSend(hp->hBufa) != NULL )
                ;
        }
    }


    hp->disp=FALSE;
    while( SeqFileCheckBusy(hp->fp) && !shutdown_request && !cancel_request )
        ;
    hp->exec=FALSE;

    return(NULL);
}

/*===========================================================================
    extern function
===========================================================================*/

/* Close/free if each handle/pointer is not null. */
static BOOL _HVQM4PlayerExClose(hHVQM4PlayerEx hp,u32 *errcode)
{
    BOOL res;

    res=TRUE;
    if ( hp->read_buff != NULL ) {
        HVQM4Free(hp->read_buff);
        hp->read_buff=NULL;
        hp->read_buff_size=0;
    }
    if ( hp->fp != NULL ) {
        s32 stat;
        stat=SeqFileGetDvdStatus(hp->fp);
        if ( stat == DVD_STATE_FATAL_ERROR ) {
            if ( errcode != NULL ) {
                *errcode=HVQM4PLAYEREX_ERROR_READERROR;
            }
            res=FALSE;
        }
        SeqFileClose(hp->fp);
        hp->fp=NULL;
    }
    if ( hp->workbuff != NULL ) {
        HVQM4Free(hp->workbuff);
        hp->workbuff=NULL;
    }
    if ( hp->hBufv != NULL ) {
        HVQM4BufvClose(hp->hBufv);
        hp->hBufv=NULL;
    }
    if ( hp->hBufa != NULL ) {
        HVQM4BufaClose(hp->hBufa);
        hp->hBufa=NULL;
    }
    if ( hp->hSnd != NULL ) {
        HVQM4DecSoundClose(hp->hSnd);
        hp->hSnd=NULL;
    }
    if ( hp->playerThreadStack != NULL ) {
        HVQM4Free(hp->playerThreadStack);
        hp->playerThreadStack=NULL;
    }
    HVQM4Free(hp);
    dec_lib_link_counter();
    return(res);
}

/*---------------------------------------------------------------------------
    Create player
---------------------------------------------------------------------------*/

hHVQM4PlayerEx HVQM4PlayerExCreate(char *FileName,u32 bnum,OSPriority prio,u32 ssiz,int sync,void (*func)(hHVQM4PlayerEx,void *,s32 status),void *parm,u32 *errcode)
{
    hHVQM4PlayerEx hp;
    u32 worksize;
    BOOL res;
    u32 _errcode_;

	HVQM4PlayerExClrCancel();
    /* For making null check of errcode unnecessary */
    if ( errcode == NULL ) {
        errcode = &_errcode_;
    }

    if ( shutdown_request ){
        *errcode=HVQM4PLAYEREX_ERROR_SHUTDOWN;
        return(NULL);
    }
    inc_lib_link_counter();

    switch( VIGetTvFormat() ) {
    case VI_NTSC:    field_time = 16683;    /* 16683.3 */    break;
    case VI_MPAL:    field_time = 16683;    /* 16683.3 */    break;
    case VI_PAL:    field_time = 20000;    /* 20000   */    break;
    }

    /* Reserve memory for handle */
    if ( (hp=(hHVQM4PlayerEx)HVQM4Alloc(OSRoundUp32B(sizeof(HVQM4PlayerEx)))) == NULL ) {
#ifdef _DEBUG
        OSReport("Alloc hHVQM4PlayerEx error !\n");
#endif
        *errcode=HVQM4PLAYEREX_ERROR_ALLOCHANDLE;
        dec_lib_link_counter();
        return(NULL);
    }
    hp->fp=NULL;
    hp->workbuff=NULL;
    hp->hBufa=NULL;
    hp->hBufv=NULL;
    hp->hSnd =NULL;
    hp->audio_track=0;
    hp->playerThreadStack=NULL;
    hp->read_buff=NULL;
    hp->read_buff_size=0;
    hp->bnum=bnum;
    hp->start_func = NULL;
    hp->start_parm = NULL;
	hp->time_mode = 0 ;

    hp->play_control=PLAY_CONTROL_NORMAL;
    hp->play_1step=FALSE;
    hp->play_gop_skip=FALSE;
    hp->play_suspend=0;
    hp->play_buffclear=FALSE;
    hp->disp_empty_count=0;

OSReport( "1 mem free size %d\n", ghmGcMemGetFreeSize() );
	
    /* Open a file. */
    if ( (hp->fp=SeqFileOpen(FileName,(void (*)(void *,void *,s32))func,hp,parm)) == NULL ) {
#ifdef _DEBUG
        OSReport("can't open '%s'\n",FileName);
#endif
        _HVQM4PlayerExClose(hp,NULL);
        if ( cancel_request ) {
            *errcode=HVQM4PLAYEREX_ERROR_CANCEL;
        } else {
            *errcode=HVQM4PLAYEREX_ERROR_OPENFILE;
        }
        return(NULL);
    }
OSReport( "2 mem free size %d\n", ghmGcMemGetFreeSize() );
	
    /* Read header from file. */
    if ( SeqFileRead( &(hp->header), sizeof(HVQM4Header), hp->fp ) <= 0 ) {
#ifdef _DEBUG
        OSReport("HVQM4Header read error !\n");
#endif
        _HVQM4PlayerExClose(hp,NULL);
        if ( cancel_request ) {
            *errcode=HVQM4PLAYEREX_ERROR_CANCEL;
        } else {
            *errcode=HVQM4PLAYEREX_ERROR_READHEADER;
        }
        return(NULL);
    }
    /* Terminate if the version of file is different. */
#ifdef __USE_HVQM4InitFunction__
    if ( !HVQM4InitFunction( (hp->header.file_version) ) ) {
#ifdef _DEBUG
        OSReport("HVQM4Header version error !\n");
#endif
        _HVQM4PlayerExClose(hp,NULL);
        *errcode=HVQM4PLAYEREX_ERROR_VERSION;
        return(NULL);
    }
OSReport( "3 mem free size %d\n", ghmGcMemGetFreeSize() );
	
#else
    if ( strncmp(HVQM4_FILEVERSION, (char *)(hp->header.file_version), strlen(HVQM4_FILEVERSION)) != 0) {
#ifdef _DEBUG
        OSReport("HVQM4Header version error !\n");
#endif
        _HVQM4PlayerExClose(hp,NULL);
        *errcode=HVQM4PLAYEREX_ERROR_VERSION;
        return(NULL);
    }
#endif
OSReport( "4 mem free size %d\n", ghmGcMemGetFreeSize() );
	
#ifdef __USE_HVQM4PostReadHeader__
    if ( !HVQM4PlayerExPostReadHeader( &(hp->header) ) ) {
#ifdef _DEBUG
        OSReport("HVQM4 PostReadHeader error !\n");
#endif
        _HVQM4PlayerExClose(hp,NULL);
        *errcode=HVQM4PLAYEREX_ERROR_VERSION;
        return(NULL);
    }
#endif

OSReport( "5 mem free size %d\n", ghmGcMemGetFreeSize() );
	
    hp->sync_mode  = SYNC_MODE_VARIABLE;
    hp->sync_field = VI_FIELD_ABOVE;
    if ( ((hp->header.videoinfo.video_mode) & 0x03) != 0 ) {
        if ( ( VIGetTvFormat()==VI_NTSC || VIGetTvFormat()==VI_MPAL) && (hp->header.usec_per_frame == 33366 || hp->header.usec_per_frame == 33367) ){
            hp->sync_mode  = SYNC_MODE_FIELDSYNC;
        }
        if ( VIGetTvFormat()==VI_PAL &&  hp->header.usec_per_frame == 40000 ){
            hp->sync_mode  = SYNC_MODE_FIELDSYNC;
        }
    }

    if ( hp->sync_mode == SYNC_MODE_FIELDSYNC ) {
        if ( sync == -1 ) {
            hp->sync_field = ((hp->header.videoinfo.video_mode) & 0x01);
        } else {
            hp->sync_field = sync;
        }
    }

    /* Initialize decoder */
    HVQM4InitDecoder();
    HVQM4InitSeqObj(&(hp->seqobj),&(hp->header.videoinfo));
    hp->width=HVQM4GetWidth(&(hp->seqobj));
    hp->height=HVQM4GetHeight(&(hp->seqobj));
    /* Reserve work area for decoder. */
    worksize=HVQM4BuffSize(&(hp->seqobj));
    if ( (hp->workbuff=(void *)HVQM4Alloc(OSRoundUp32B(worksize))) == NULL ) {
#ifdef _DEBUG
        OSReport("work buffer alloc error !, worksize=%d,%d\n",worksize,OSRoundUp32B(worksize));
#endif
        _HVQM4PlayerExClose(hp,NULL);
        *errcode=HVQM4PLAYEREX_ERROR_ALLOCWORK;
        return(NULL);
    }
    HVQM4SetBuffer(&(hp->seqobj),hp->workbuff);

    if ( !decv_init(hp,errcode) ) {
        _HVQM4PlayerExClose(hp,NULL);
        return(NULL);
    }
    if ( !deca_init(hp,errcode) ) {
        _HVQM4PlayerExClose(hp,NULL);
        return(NULL);
    }
	
OSReport( "6 mem free size %d\n", ghmGcMemGetFreeSize() );
	
    /* Create player thread. */
    ssiz=OSRoundUp32B(ssiz);
    if ( (hp->playerThreadStack=(u8*)HVQM4Alloc(ssiz)) == NULL ) {
#ifdef _DEBUG
        OSReport("Alloc hHVQM4PlayerEx Stack !\n");
#endif
        _HVQM4PlayerExClose(hp,NULL);
        *errcode=HVQM4PLAYEREX_ERROR_ALLOCSTACK;
        return(NULL);
    }

    if ( !alloc_read_buff(hp,(hp->header.max_frame_size)) ) {
        _HVQM4PlayerExClose(hp,NULL);
        *errcode=HVQM4PLAYEREX_ERROR_ALLOCRDBUF;
        return(NULL);
    }

    res=OSCreateThread(
            &(hp->playerThread),
            _HVQM4PlayerExThread,
            hp,
            hp->playerThreadStack+ssiz,
            ssiz,
            prio,
            0
            );
    if ( !res ) {
#ifdef _DEBUG
        OSReport("HVQM4PlayerEx Thread Create error !\n");
#endif
        _HVQM4PlayerExClose(hp,NULL);
        *errcode=HVQM4PLAYEREX_ERROR_CREATETHREAD;
        return(NULL);
    }

    hp->disp=FALSE;
    hp->exec=TRUE;
    hp->wait=TRUE;
    return(hp);
}

HVQM4Header   *HVQM4PlayerExFileHeader(hHVQM4PlayerEx handle)
{
	return(&(handle->header));
}

void HVQM4PlayerExSetRepeatMode(hHVQM4PlayerEx handle,BOOL repeat)
{
	handle->play_repeat=repeat;
}

BOOL HVQM4PlayerExGetRepeatMode(hHVQM4PlayerEx handle)
{
	return(handle->play_repeat);
}

/*---------------------------------------------------------------------------
    Closing player
---------------------------------------------------------------------------*/

BOOL HVQM4PlayerExClose(hHVQM4PlayerEx handle,u32 *errcode)
{
    void *r;
    BOOL res;

    res=TRUE;
    OSJoinThread(&(handle->playerThread),&r);
    if ( !_HVQM4PlayerExClose(handle,errcode) ) {
        res=FALSE;
    }
    if ( shutdown_request ){
        if ( errcode != NULL ) {
            *errcode=HVQM4PLAYEREX_ERROR_SHUTDOWN;
        }
        res=FALSE;
    }
    return(res);
}

/*---------------------------------------------------------------------------
    Setting CallBack function for start playback
---------------------------------------------------------------------------*/

void HVQM4PlayerEx1stFrameFunc(hHVQM4PlayerEx handle,void (*func)(hHVQM4PlayerEx,void *),void *parm)
{
    handle->start_func = func;
    handle->start_parm = parm;
}

/*---------------------------------------------------------------------------
    Starting player thread
---------------------------------------------------------------------------*/

BOOL HVQM4PlayerExStart(hHVQM4PlayerEx handle)
{
//    OSReport("HVQM4PlayerExStart()\n");
    OSResumeThread(&(handle->playerThread));
    return(TRUE);
}

BOOL HVQM4PlayerExCheckExecute(hHVQM4PlayerEx handle)
{
    return(handle->exec);
}

u32 HVQM4PlayerExGetMicroSecPerFrame(hHVQM4PlayerEx handle)
{
    return(handle->header.usec_per_frame);
}

u32 HVQM4PlayerExGetWidth(hHVQM4PlayerEx handle)
{
    return(handle->width);
}

u32 HVQM4PlayerExGetHeight(hHVQM4PlayerEx handle)
{
    return(handle->height);
}

u32 HVQM4PlayerExGetAudioSamples(hHVQM4PlayerEx handle)
{
    return(handle->header.audioinfo.samples_per_sec);
}

u32 HVQM4PlayerExGetAudioChannels(hHVQM4PlayerEx handle)
{
    return(handle->header.audioinfo.channels);
}

/*===========================================================================
    Bufv/Bufa control function
===========================================================================*/

/*-- Bufv --*/

void *HVQM4PlayerExBufvGetBuff(hHVQM4BufvData handle)
{
    return(handle->buff);
}

u32   HVQM4PlayerExBufvGetSize(hHVQM4BufvData handle)
{
    return(handle->size);
}

void HVQM4PlayerExBufvSetBusyFlag(hHVQM4BufvData handle,BOOL flag)
{
    handle->busy = flag;
}

hHVQM4BufvData HVQM4PlayerExBufvGetDisp(hHVQM4PlayerEx handle)
{
    hHVQM4BufvData res;

    if ( handle->wait ) {
        return(NULL);
    }

    if ( shutdown_request || handle->exit_request || cancel_request ) {
        while( (res=HVQM4BufvGetDisp(handle->hBufv)) != NULL ) {
            HVQM4PlayerExBufvSetBusyFlag(res,FALSE);
        }
    } else {
        res=HVQM4BufvGetDisp(handle->hBufv);
        if ( res != NULL && handle->play_buffclear ) {
            /* Vacate the buffer if it is FWD/RWD. */
            hHVQM4BufvData t;
            while( (t=HVQM4BufvGetDisp(handle->hBufv)) != NULL ) {
                HVQM4PlayerExBufvSetBusyFlag(res,FALSE);
                res = t ;
            }
        }
        if ( res == NULL ) {
            handle->disp_empty_count ++;
        }
    }

    return(res);
}

/*-- Bufa --*/

void *HVQM4PlayerExBufaGetBuff(hHVQM4BufaData handle)
{
    return(handle->buff);
}

u32   HVQM4PlayerExBufaGetSize(hHVQM4BufaData handle)
{
    return(handle->size);
}

void HVQM4PlayerExBufaSetFree(hHVQM4PlayerEx handle,hHVQM4BufaData free)
{
    HVQM4BufaSetFree(handle->hBufa,free);
}

hHVQM4BufaData HVQM4PlayerExBufaGetSend(hHVQM4PlayerEx handle)
{
    hHVQM4BufaData res;

    if ( handle->wait || !(handle->disp) ) {
        return(NULL);
    }
    if ( handle->hBufa == NULL ) {
        return(NULL);
    }

    if ( shutdown_request ) {
        while( (res=HVQM4BufaGetSend(handle->hBufa)) != NULL ) {
            HVQM4PlayerExBufaSetFree(handle,res);
        }
    } else {
        res=HVQM4BufaGetSend(handle->hBufa);
        if ( res != NULL && handle->play_buffclear ) {
            /* Vacate the buffer if it is FWD/RWD. */
            hHVQM4BufaData t;
            while( (t=HVQM4BufaGetSend(handle->hBufa)) != NULL ) {
                HVQM4PlayerExBufaSetFree(handle,res);
                res = t ;
            }
        }
    }

    return(res);
}

/*===========================================================================
    Low Pass Filter
===========================================================================*/

u32 HVQM4PlayerExGetAudioFilter(hHVQM4PlayerEx handle)
{
    if ( handle->hSnd ) {
        return(HVQM4DecSoundGetFilter(handle->hSnd));
    } else {
        return(0);
    }
}

BOOL HVQM4PlayerExSetAudioFilter(hHVQM4PlayerEx handle,u32 filter)
{
    if ( handle->hSnd ) {
        return(HVQM4DecSoundSetFilter(handle->hSnd,filter));
    } else {
        return(FALSE);
    }
}

/*===========================================================================
    Audio Track
===========================================================================*/

u32 HVQM4PlayerExGetMaxAudioTrack(hHVQM4PlayerEx handle)
{
    return( (u32)((handle->header.audioinfo.multi_track) & 0x0f) );
}

u32 HVQM4PlayerExGetAudioTrack(hHVQM4PlayerEx handle)
{
    return(handle->audio_track);
}

BOOL HVQM4PlayerExSetAudioTrack(hHVQM4PlayerEx handle,u32 track)
{
    BOOL res;

    if ( track <= ((handle->header.audioinfo.multi_track) & 0x0f)  ){
        handle->audio_track=track;
        res=TRUE;
    } else {
        res=FALSE;
    }
    return(res);
}

/*===========================================================================
    extern control function
===========================================================================*/

/*---------------------------------------------------------------------------
    Playback control/Normal playback confirmation
---------------------------------------------------------------------------*/

BOOL HVQM4PlayerExControlCheckNormal(hHVQM4PlayerEx handle)
{
    if ( handle->play_control == PLAY_CONTROL_NORMAL ) {
        return(TRUE);
    } else {
        return(FALSE);
    }
}

/*---------------------------------------------------------------------------
    Playback control/Normal playback
---------------------------------------------------------------------------*/

BOOL HVQM4PlayerExControlNormal(hHVQM4PlayerEx handle)
{
    BOOL irq;
    hHVQM4BufvData v;
    hHVQM4BufaData a;

    irq=OSDisableInterrupts();
    if ( handle->play_control != PLAY_CONTROL_NORMAL ) {
        /* Vacate buffer and restart. */
        if ( handle->hBufa != NULL ) {
            while( (a=HVQM4BufaGetSend(handle->hBufa)) != NULL ) {
                HVQM4BufaSetFree(handle->hBufa,a);
            }
        }
        while( (v=HVQM4BufvGetDisp(handle->hBufv)) != NULL ) {
            v->busy=FALSE;
        }
        handle->wait=TRUE;
    }
    handle->play_control=PLAY_CONTROL_NORMAL;
    OSRestoreInterrupts(irq);
    handle->play_buffclear=FALSE;
    play_resume(handle);
    return(TRUE);
}

/*---------------------------------------------------------------------------
    Playback control/Skip
---------------------------------------------------------------------------*/

BOOL HVQM4PlayerExControlStep(hHVQM4PlayerEx handle)
{
    handle->play_control=PLAY_CONTROL_STEP;
    handle->play_1step=TRUE;
    handle->play_buffclear=FALSE;
    play_resume(handle);
    return(TRUE);
}

/*---------------------------------------------------------------------------
    Playback control/Foward
---------------------------------------------------------------------------*/

BOOL HVQM4PlayerExControlFwd(hHVQM4PlayerEx handle)
{
    handle->play_control=PLAY_CONTROL_FWD;
    handle->play_gop_skip=TRUE;
    handle->play_buffclear=TRUE;
    play_resume(handle);
    return(TRUE);
}

/*---------------------------------------------------------------------------
    Playback control/Rewind
---------------------------------------------------------------------------*/
BOOL HVQM4PlayerExControlRwd(hHVQM4PlayerEx handle)
{
    handle->play_control=PLAY_CONTROL_RWD;
    handle->play_gop_skip=TRUE;
    handle->play_buffclear=TRUE;
    play_resume(handle);
    return(TRUE);
}

/*---------------------------------------------------------------------------
    Playback control/Stop playback
---------------------------------------------------------------------------*/

BOOL HVQM4PlayerExControlExit(hHVQM4PlayerEx handle)
{
    handle->exit_request=TRUE;
    handle->play_gop_skip=TRUE;
    return(TRUE);
}

/*===========================================================================
    Debug Function
===========================================================================*/

/*---------------------------------------------------------------------------
    Debugging function/Obtain the number of decoded video data at termination
---------------------------------------------------------------------------*/

u32 HVQM4PlayerExDebug_EndBufvDispNums(hHVQM4PlayerEx handle)
{
    return(handle->end_bufv_nums);
}

/*---------------------------------------------------------------------------
    Debugging function/Obtain the number of decoded audio data at termination
---------------------------------------------------------------------------*/

u32 HVQM4PlayerExDebug_EndBufaSendNums(hHVQM4PlayerEx handle)
{
    return(handle->end_bufa_nums);
}

/*---------------------------------------------------------------------------
    Debugging function/Obtain the nuber of times for frame drop
---------------------------------------------------------------------------*/


u32 HVQM4PlayerExDebug_DispEmptyCount(hHVQM4PlayerEx handle)
{
    return(handle->disp_empty_count);
}

/*=========================================================================*/
