////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Sound
//
// mK7Sound.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/14/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7SOUND_H__
#define	__MK7SOUND_H__

//---- include ----
#include <sysdolphin\audiolib_ax.h>
#include "mK7Common.h"
#include ".\se\seAll.h"

//---- define ----
#define	SOUND_FILENAME_LENGTH		(256)	//TEh֌W̃t@C̍ő啶
#define	SOUND_ARAM_NUM				(10)	//
#define	SOUND_MASTER_VOLUME			(255)	//}X^[
#define	SOUND_SYSTEM_SE_VOLUME		(255)	//VXeSE
#define	SOUND_EVENT_SE_VOLUME		(255)	//LSE
#define	SOUND_BATTLE_SE_VOLUME		(255)	//퓬SE
#define	SOUND_PAN_CENTER			(127)	//p̐^ 0:[ 254:E[
#define	SOUND_SSM_NUM				(16)	//ɓǂݍ߂g`t@C̐
#define	SOUND_FILE_LENGTH			(32)	//TEht@C̕ő吔
#define	SOUND_DEFAULT_GROUP			(AXDRIVER_MAX_GROUP)
#define	VOLUME_MUSIC				(144)
#define	VOLUME_MUSIC_MUTE			(72)
#define	VOLUME_VOICE				(255)
#define	VOLUME_SE					(255)
#define	MUSIC_JIMAKU_FADEOUT_TIME	(200)	//1/200bP
#define	MUSIC_FADEOUT_TIME			(300)	//1/200bP
#define	MUSIC_FADEIN_TIME			(100)	//1/200bP

#define	SOUND_DEFAULT_DSP_INIT_RATE	(0)		//Wmixl(0-255)
#define	SOUND_DEFAULT_DSP_RATE		(160)	//Wmixl(0-255)

#define	DSP_SAME_RATE				(-1)	//ݐݒ肳ĂDSP̊g
#define	HPS_STOP_STREAM				(-1)	//Xg[~
#define	HPS_FADEOUT_STREAM			(-2)	//Xg[tF[hAEg
#define	HPS_SAME_STREAM				(-3)	//ݍĐĂXg[

#define	STREAM_PAUSE				(-1)	//ĐNGXgɍ܂ŖĂXg[|[Y

//---- enum ----
enum{
	eTrackMusic0 = 1,
	eTrackMusic1,
	eTrackMax,
};

enum{
	eBank0,		//VXe
	eBank1,		//퓬GtFNg
	eBank2,		//ViI풓(SViII)
	eBank3,		//vC[
	eBank4,		//{X(^Cg)
	eBankMax,
	eBankSystem   = eBank0,
	eBankBattle   = eBank1,
	eBankScenario = eBank2,
	eBankPlayer   = eBank3,
	eBankBoss     = eBank4,
};

typedef	enum{
	eSndReadingSsm,		//g`t@Cǂݍݒ
	eSndStandby,		//ҋ@
	eSndProcMax,
}enSoundProcess;

typedef	enum{
	eSndEventSsmAreaDeflag,	//Cxgpg`t@CGA|
	eSndReadReqEventSsm,	//g`t@Cǂݍ݃NGXg
	eSndReadingEventSsm,	//g`t@Cǂݍݒ
	eSndReadReqWaiting,		//g`t@Cǂݍ݃NGXg҂
	eSndReadErrEventSsm,	//g`t@Cǂݍ݃G[
}enReadEventSsm;

enum{
	eSETrackSystemOverlap = 1,
	eSETrackSystem00,
	eSETrackSystem01,
	eSETrackSystem02,
	eSETrackSystem03,
	eSETrackSystem04,
	eSETrackSystem05,
	eSETrackSystem06,
	eSETrackSystem07,
	eSETrackEventOverlap,
	eSETrackEvent00,
	eSETrackEvent01,
	eSETrackEvent02,
	eSETrackEvent03,
	eSETrackEvent04,
	eSETrackEvent05,
	eSETrackEvent06,
	eSETrackEvent07,
	eSETrackBattleOverlap,
	eSETrackBattle00,
	eSETrackBattle01,
	eSETrackBattle02,
	eSETrackBattle03,
	eSETrackBattle04,
	eSETrackBattle05,
	eSETrackBattle06,
	eSETrackBattle07,
	eSETrackScene01,		// Rc[vŎgp
	eSETrackScene02,		// Rc[vŎgp
	eSETrackScene03,		// Rc[vŎgp
	eSETrackScene04,		// Rc[vŎgp
	eSETrackScene05,		// Rc[vŎgp
	eSETrackScene06,		// Rc[vŎgp
	eSETrackMax,
};

enum{
	eSEGroupSystem00,
//	eSEGroupSystem01,
//	eSEGroupSystem02,
//	eSEGroupSystem03,
	eSEGroupSystem00Env,
//	eSEGroupSystem01Env,
//	eSEGroupSystem02Env,
//	eSEGroupSystem03Env,
//	eSEGroupEvent00,
//	eSEGroupEvent01,
//	eSEGroupEvent02,
//	eSEGroupEvent03,
//	eSEGroupEvent00Env,
//	eSEGroupEvent01Env,
//	eSEGroupEvent02Env,
//	eSEGroupEvent03Env,
	eSEGroupBattle00,		//XLEmCYŎg܂ 03.7.17 matsuzaki
//	eSEGroupBattle01,
//	eSEGroupBattle02,
//	eSEGroupBattle03,
	eSEGroupBattle00Env,
//	eSEGroupBattle01Env,
//	eSEGroupBattle02Env,
//	eSEGroupBattle03Env,
	eSEGroupMax,
};

typedef	enum{
	eDspNoEffect,
	eDspReverbHi,
	eDspReverbStd,
	eDspChorus,
	eDspDelay,
	eDspKindMax,
}enDspKind;

typedef	enum{
	eAch,
	eBch,
	eChMax,
}enDspCh;

typedef	enum{
	eCtrlSTXT,		//stxtLqɏ]
	eCtrlAPI,		//vOŐ䂷
	eCtrlMax,
}enDspCtrl;




//---- struct ----
typedef	struct{
	int		entryNum;
	int		bankNo;
	char	fileName[SOUND_FILE_LENGTH];
}stSsmDat;

typedef	struct{
	float	time;
	s16		volume;
}stFadeManeger;

//---- class ----
//TEhNX
class MK7Sound{
protected:
public:
	//---- ֐ ----
	//RXgN^
	MK7Sound();
	//fXgN^
	~MK7Sound();
	
	//****************************
	//******** ֌W ********
	//****************************
	//semt@Cǂݍ
	static	bool	ReadSem( void );
	//
	static	bool	Init( ghmGcMem& inHeap, u8 inVolume=SOUND_MASTER_VOLUME );
	//㏈
	static	bool	Term( void );
	//m
	static	void*	mAlloc( int inSize );
	//
	static	void	mFree( void* inPtr );
	
	//
	bool	mInit( ghmGcMem& inHeap, u8* inPlayList, u8 inVolume );
	//㏈
	bool	mTerm( void );
	//SẴTEh~
	bool	mStopAllSound( void );
	
	//**************************
	//******** DSP֌W  ********
	//**************************
	//DSPݒ
	bool		mSetDspCtrl( enDspCtrl inCtrl, enDspCh inCh=eBch );
	//DPSݒ
	bool		mSetDspKind( enDspKind inKind, enDspCh inCh=eBch );
	//ĂDSP̎ނ擾
	enDspKind	mGetDspKind( enDspCh inCh=eBch ){return(mDspKind[inCh]);}
	//O[vԍw肵ďo̓`l̃GtFNg~bNXlݒ
	bool		mSetDspRate( int inGroup, u8 inMix, enDspCh inCh=eBch );
	//SĂ̌eO[vɏo̓`l̃GtFNg~bNXlݒ
	bool		mSetDspRateAll( u8 inMix, enDspCh inCh=eBch );
	//DSP̂Ă銄擾
	u8		 	mGetDspRate( int inGroup, enDspCh inCh=eBch ){return(mDspRate[inCh][inGroup]);}
	//DSPĂ邩擾
	bool		mCheckDsp( int inGroup, enDspCh inCh=eBch ){return(mDspRate[inCh][inGroup]?true:false);}
	//DSP̎ނݒ肵ďo̓`l̃GtFNg~bNXlݒ
	bool		mSetDspKindRate( enDspKind inKind, int inGroup, u8 inMix, enDspCh inCh=eBch );
	//DSP̎ނݒ肵đSĂ̊eO[v̏o̓`lɃGtFNg~bNXlݒ
	bool		mSetDspKindRateAll( enDspKind inKind, u8 inMix, enDspCh inCh=eBch );
	
	//******************************
	//******** t[ ********
	//******************************
	//t[
	void	mFrameProcess( void );
	//݂̏󋵂擾
	enSoundProcess	mGetProcess( void ){return(mProcess);}
	
	//**************************************************
	//******** ʁEXeIEmݒ֌W ********
	//**************************************************
	//}X^[ʐݒ
	bool	mSetMasterVol( u8 inVolume );
	//}X^[ʎ擾
	u8		mGetMasterVol( void );
	//TEh[h̐ݒ
	bool	mSetSoundMode( int inSoundMode );
	//TEh[h̎擾
	int		mGetSoundMode( void );
	
	//**************************************
	//******** SEpg`t@CǗ ********
	//**************************************
	//g`t@C̓ǂݍ
	bool	mReadSsm( char* inFileName, int inBankNo );
	//g`t@C̉
	bool	mReleaseSsm( char* inFileName );
	
	//************************
	//******** SE֌W ********
	//************************
	//se̍Đ
	int		mPlaySE( int inId,
	                 u8  inVolume = SOUND_SYSTEM_SE_VOLUME,
	                 u8  inPan    = SOUND_PAN_CENTER,
	                 int inTrack  = 0,
	                 int inGroup  = 0 );
	//se̍Đsb`wt
	int		mPlaySEP( int inId,
					  s16 inPitch  = 0,
					  u8  inVolume = SOUND_SYSTEM_SE_VOLUME,
					  u8  inPan    = SOUND_PAN_CENTER,
					  int inTrack  = 0,
					  int inGroup  = 0 );
	//se̍Đ 3D
	int		mPlaySE3D( int inId,
	                   Vec tPos,
	                   int inMode   = 0,
	                   int inVolume = SOUND_SYSTEM_SE_VOLUME,
	                   int inTrack  = eSETrackBattleOverlap,
	                   int inGroup  = eSEGroupBattle00Env );
	//se̍Đ 3DŃsb`wt
	int		mPlaySE3DP( int inId,
						Vec tPos,
						s16 inPitch  = 0,
						int inMode   = 0,
						int inVolume = SOUND_SYSTEM_SE_VOLUME,
						int inTrack  = eSETrackBattleOverlap,
						int inGroup  = eSEGroupBattle00Env );
	
	//se̍Đ~
	bool	mStopSE( int inId );
	//zԍse̍Đ~
	bool	mStopSENo( int inId );
	//SĂSE~
	bool	mStopSEAll( void );
	
	//se̍Đ`FbN
	bool	mCheckSE( int inId );
	//zԍse̍Đ`FbN
	bool	mCheckSENo( int inId );
	
	//seŜ̉ʐݒtF[ht
	bool	mSetMasterVolumeSE( u8 inVolume, u16 inFadeTime );
	//SEŜ̉ʎ擾
	u8		mGetMasterVolumeSE( void ){return(mMasterVolSE);}
	
	//ʉԍw肵ă{[ƃ{[tF[hݒ
	bool	mSetVolumeSE( int inSEno, u8 inVolume, u16 inFadeTime );
	//zԍw肵ă{[ƃ{[tF[hݒ
	bool	mSetVolumeSENo( int inSEno, u8 inVolume, u16 inFadeTime );
	//O[vw肵ă{[ƃ{[tF[hݒ
	bool	mSetVolumeSEGroup( int inGroup, u8 inVolume, u16 inFadeTime );
	
	//ʉԍw肵dbdbtF[hݒ
	bool	mSetDBSE( int inSEno, int inVolume, u16 inFadeTime );
	//zԍw肵dbdbtF[hݒ
	bool	mSetDBSENo( int inSEno, int inVolume, u16 inFadeTime );
	//O[vw肵dbdbtF[hݒ
	//bool	mSetDBSEGroup( int inGroup, int inVolume, u16 inFadeTime );
	
	//ʉԍw肵ăpݒ
	bool	mSetPanSE( int inSEno, u8 inPan );
	//zԍw肵ăpݒ
	bool	mSetPanSENo( int inSEno, u8 inPan );
	//O[vw肵ăpݒ
	bool	mSetPanGroup( int inGroup, u8 inPan );
	
	//ʉԍŃsb`ݒ
	bool	mSetPitchSE( int inId, s16 inPitch );
	//zԍŃsb`ݒ
	bool	mSetPitchSENo( int inId, s16 inPitch );
	
	
	
	
	
	//********************************
	//******** Xg[֌W ********
	//********************************
	//stream̍Đ(t@Cw)
	bool	mPlayStream( char* inFileName,
	                     u8    inVolume  = VOLUME_MUSIC,
	                     int   inGroup   = AXDRIVER_MAX_GROUP,
	                     bool  inFadeOut = true );
	//stream̍Đ(ԍw)
	bool	mPlayStreamNo( int  inStreamNo,
	                       u8   inVolume  = VOLUME_MUSIC,
	                       int  inGroup   = AXDRIVER_MAX_GROUP,
	                       bool inFadeOut = true );
	//stream̍Đ~
	bool	mStopStream( void );
	//stream̍Đ`FbN
	bool	mCheckStream( void );
	//stream̉ʐݒ
	bool	mSetVolumeStream( u8 inVolume, int inCH=-1 );
	//stream̃tF[hݒ
	bool	mFadeVolumeStream( u8 inVolume, u16 inFadeTime );
	//stream̃{[擾
	u8		mGetVolumeStream( void );
	
	//Xg[Đ`FbN
	bool	mStreamCheckPlay( void );
	//Xg[~`FbN
	bool	mStreamCheckStop( void );
	
	//Xg[̓Đ
	bool	mPrepareStream( char* inFileName,
							u8    inVolume = VOLUME_MUSIC,
							int   inGroup  = AXDRIVER_MAX_GROUP );
	//Xg[̓Điԍwj
	bool	mPrepareStreamNo( int inStreamNo,
							  u8    inVolume = VOLUME_MUSIC,
							  int   inGroup  = AXDRIVER_MAX_GROUP );
	//Xg[̓Đ
	bool	mJustPlayStream( s16 inFadeVol = 0 );
	
	//Xg[̓ĐƂɑŐȂ~Ȃꍇ̕A֐
	bool	mResumeStream( void );
	
	//Xg[̃sb`ݒ
	bool	mSetPitchStream( s16 inPitch ){ HSD_AudioPStreamSetPitchCh(inPitch,mNowPlayMusicCh); return true; }
	
	//Đ̃Xg[ԍ擾(-1͖ĂȂort@CwōĐXg[)
	s16		mGetPlayStreamNo( void ){ return(mStreamNo); }
	
	//Xg[̈ꎞ~
	bool	mSetPauseStream( void );
	//Xg[̈ꎞ~
	bool	mReleasePauseStream( void );
	//Xg[|[Y擾
	bool	mGetPauseFlagStream( void ){return(mPauseFlag);}
	//Xg[̃|[YtO
	void	_mResetPauseFlagStream( void ){mPauseFlag=false;}
	
	//Xg[̍Đ(ɃXe[Wp)
	bool	mPlayStreamEx(	int  inStreamNo,
							u8   inVolume  = VOLUME_MUSIC,
							bool inFadeOut = true );
	//bool	mPlayStreamEx(	int       inStreamNo,
	//						s16       inMix     = DSP_SAME_RATE,
	//						u8        inVolume  = VOLUME_MUSIC,
	//						enDspKind inKind    = eDspKindMax,
	//						bool      inFadeOut = true );
	
	//Xg[̃~[g
	bool	mRequestMuteStream( void );
	//Xg[̃~[g
	bool	mReleaseMuteStream( void );
	//~[gݒ
	bool	mSetDontMuteStream( bool inDontMute=true ){ bool old=mDontMuteStream; mDontMuteStream=inDontMute; return(old); }
	//~[gԎ擾
	bool	mGetDontMuteStream( void ){ return(mDontMuteStream); }
	
	//****************************
	//******** PCpSE֌W ********
	//****************************
	//PCpg`t@Cǂݍ
	bool	mReadPcSsmReq( u32 inCharId );
	//PCpg`t@C
	bool	mReleasePcSsm( void );
	//ǂ܂Ăt@C̃LID擾
	u32		mGetPcSsmNo( void ){return(mCharNo);}
	
#ifdef	_DEBUG
	//************************************
	//******** fobOp֐ **********
	//************************************
	bool	mSetSoundDebug( bool inFlag );
	bool	mGetSoundDebug(void){ return mDebugSound; }
#endif

private:
	//---- ֐ ----
	////Cxgpg`t@C̓ǂݍ
	//void	mReadEventSsmProc( void );
	
	//tF[h̊Ď
	void	mFadeVolumeWatch( void );
	
	//---- ϐ ----
	u8					mMasterVol;							//}X^[{[
	u8					mStreamVol[eTrackMax];				//Xg[{[
	u8					mMasterVolSE;						//SE}X^[{[
	int					mSoundMode;							//TEh[h
	int					mBank[eBankMax];					//TEhg`oNԍ
	int					mReadingFiles;						//ǂݍݒ̃t@C̐
	stSsmDat			mSsmDat[SOUND_SSM_NUM];				//ǂݍ񂾔g`t@CƊYoNԍۑ\
	enSoundProcess		mProcess;							//TEht[vZX
	static	u32			mAramBlock[SOUND_ARAM_NUM];			//A-RAM
	static	u8* 		mPlayList;							//semt@C̓ǂݍ܂ꂽ|C^
	static	ghmGcMem*	mHeap;								//TEhpq[v̈
	
	int					mNowPlayMusicCh;					//ݍĐĂ鉹y`l
	stFadeManeger		mFadeMng[eTrackMax];				//tF[hǗ\
	s16					mStreamNo;							//ݍĐĂȔԍ(PlaySreamNôƂۑ)
	
	int					mOrder;								//ݓǂݍ܂ĂSẼt@CԂ̒l
	char				mFileName[SOUND_FILENAME_LENGTH];	//ǂݍ݃NGXĝt@C
	enReadEventSsm		mReadEventSeProc;					//CxgSẼt[
	
	enDspKind			mDspKind[eChMax];					//DSPޕۑp
	u8					mDspRate[eChMax][eSEGroupMax];		//DSP̂銄
	void*				mDspBuff[eChMax];					//DSPobt@
	AXFX_REVERBHI		mDspReverbHI[eChMax];				//o[ui
	AXFX_REVERBSTD		mDspReverbStd[eChMax];				//o[uX^_[h
	AXFX_CHORUS			mDspChorus[eChMax];					//R[X
	AXFX_DELAY			mDspDelay[eChMax];					//fBC
	
	u32					mCharNo;							//ݓǂݍłLN^SẼLN^ԍ
	
	int					mOldStreamNo;						//Xg[̓ĐƂ̑ŐȔԍ
	u8					mOldStreamVol;						//Xg[̓ĐƂ̑ŐȂ̉
	
	s16					mMuteStreamVol;						//ÕXg[̉
	
	bool				mPauseFlag;							//Xg[̃|[YԃtO
	bool				mDontMuteStream;					//Xg[mute֎~tO
	
#ifdef	_DEBUG
	bool				mDebugSound;						//TEhfobOtO
#endif
};

//---- extern ----
extern	MK7Sound*	gpSound;




#endif	//__MK7SOUND_H__




