////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Secom
//
// SK7PanelColor.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELCOLOR_H__
#define	__SK7PANELCOLOR_H__

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	߂l
#define	COLOR_CANCEL				(-1)//
#define	COLOR_MISS					(0)
#define	COLOR_CLEAR					(1)	//	XCb`I

enum{
	TEX_040405_BACKGROUND=0,
	TEX_040405_BAR,
	TEX_040405_BOTTAN_KASAN,
	TEX_040405_BOTTAN_KASAN2,
	TEX_040405_COLOR_SHADOW,
	TEX_040405_OK_KASAN,
	TEX_040405_MAX,
};


#define	COLOR_BAR_NUM				(3)
#define	SELECT_HANDSOME_NUM			(9)

typedef struct{
	s16			Color[COLOR_BAR_NUM];
}PANEL_COLOR_ANS;

//---- class ----
class SK7PanelColor : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_MOVE,
		PROC_CANCEL,
		PROC_COLOR_SET,
		PROC_MESSAGE,
		PROC_END,
		PROC_TIME,
		PROC_TIME2,
		PROC_CHECK,
	}eFrameProc;
	

protected:
	eFrameProc				m_Proc;
	
	TEX_DATA*				m_pTexData[TEX_040405_MAX];
	SK7Sprite				m_spBG;						//	wi
	SK7Sprite				m_spOk;						//	v
	SK7Sprite				m_spBar[COLOR_BAR_NUM];		//	o[
	SK7Sprite				m_spKasan;					//	XCb`
	SK7Sprite				m_spKasan2[SELECT_HANDSOME_NUM];					//	XCb`
	SK7Sprite				m_spShadow;
	SK7Sprite				m_spAnswer;
	s8						m_chSelect;
	s8						m_chSaveSelect;
	s8						m_chBarSelect;
	bool					m_bSEFlag;
	PANEL_COLOR_ANS	 		m_AnsColor[SELECT_HANDSOME_NUM];
	
	int						m_iTime;
	int						m_iKeyTime;
	int						m_iStopNum;
	
	void				SetBarPosition(void);
	void				CheckColor();
public:
	SK7PanelColor( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelColor();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELCOLOR_H__
