////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Curtain
//
// SK7PanelCurtain.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELCURTAIN_H__
#define	__SK7PANELCURTAIN_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l
#define	CURTAIN_OFF					(-1)	//	ouIt
#define	CURTAIN_CANCEL				(0)		//	rI
#define	CURTAIN_ON					(1)		//	ouI


//	eNX`[pX
#define	PNL055002TEX_BG				"Texture/055002/BG.BIN"


//---- class ----
class SK7PanelCurtain : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_MESSAGE,
		PROC_CHECK,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	s8						m_chSelect;
	
public:
	SK7PanelCurtain( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelCurtain();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELCURTAIN_H__
