////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel SK7PanelEleChange
//
// SK7PanelEleChange.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELELECHANGE_H__
#define	__SK7PANELELECHANGE_H__


#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	
#define	SETCHANGE_TOP					(0)	
#define SETCHANGE_4F					(1)

//	߂l
#define	ELECHANGE_CANCEL				(-1)//
#define	ELECHANGE_TOP					(0)	//	
#define	ELECHANGE_4F					(1)	//	Se


//	eNX`[ԍ
enum{
	TEX_011202_BASE=0,
	TEX_011202_BUTTON,
	TEX_011202_LIGHT,
	TEX_011202_MAX,
};

#define		ELECHANGE_LAMP_NUM			(4)

//---- class ----
class SK7PanelEleChange : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_MESSAGE,
		PROC_END,
		PROC_TIME,
		PROC_CHECK,
	}eFrameProc;
	
protected:
	eFrameProc				m_Proc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spLamp[ELECHANGE_LAMP_NUM];
	SK7Sprite				m_spSwitch[2];
	s8						m_chSelect;
	int						m_iTime;
	
public:
	SK7PanelEleChange( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelEleChange();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELELECHANGE_H__
