////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Secom
//
// SK7PanelKeyBoard.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELKEYBOARD_H__
#define	__SK7PANELKEYBOARD_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"
#include "../Yam/YK7String.h"


enum{
	TEX_055500_BASE=0,
	TEX_055500_ENTER,
	TEX_055500_KEYDOWN,
	TEX_055500_QNUMBER,
	TEX_055500_A_WAKU,
	TEX_055500_MAX,
};

//	߂l
#define	KEYBOARD_CANCEL				(-1)//
#define KEYBOARD_CLEAR				(0)	//	XCb`I

#define	KEYBOARD_ANSWER_NUM			(10)

//---- class ----
class SK7PanelKeyBoard : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_FIRST,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_MESSAGE,
		PROC_END,
		PROC_TIME,
		PROC_CHECK,
		PROC_FADE,
	}eFrameProc;
	

protected:
	eFrameProc				m_Proc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spQNo;
	SK7Sprite				m_spSelect;
	SK7Sprite				m_spQBox;
	SK7Sprite				m_spASelect;
	SK7Sprite				m_spEnter;
	SK7Sprite				m_spFade;
	s8						m_chSelect;
	int						m_iTime;
	int						m_iKeyTime;
	s8						m_chQNo;
	s8						m_chAnswerNo;
	s8						m_chAnswerData[KEYBOARD_ANSWER_NUM];
	s8						m_chSaveNoL;
	s8						m_chSaveNoR;
	bool					m_bAnswer;
	u8						m_Alpha;
	s8						m_chPlusAlpha;

	
	void	SetCursolPos();
	u8		GetUpDownNo(bool);
	void	SetKeyAnswer(void);
	void	RenderQ(void);
	
public:
	SK7PanelKeyBoard( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelKeyBoard();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELKEYBOARD_H__
