////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel RE
//
// SK7PanelKouro.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/11/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELKOURO_H__
#define	__SK7PANELKOURO_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l ----------------------------------
#define		KOURO_CANCEL		(-1)	
#define		KOURO_FALSE			(0)
#define		KOURO_TRUE			(1)


#define		COLOR_NUM			(3)
#define		SMOKE_SIZE			(128)


//---- class ----
class SK7PanelKouro : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_SMOKE,
		PROC_SMOKE2,
		PROC_MESSAGE,
		PROC_CHECK,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_OKOU,
		LOAD_SMOKE,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spOkou[COLOR_NUM];
	SK7Sprite				m_spSmoke[SMOKE_SIZE];
	
	s8						m_chSelect;
	s8						m_chColor;
	int						m_iMoveX;
	int						m_iTime;
	bool					m_bKemuri;
	
public:
	SK7PanelKouro( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelKouro();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	bool	MoveSmoke( bool State );
	
};

#endif	//__SK7PANELKOURO_H__
