////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel 
//
// SK7PanelLaundry.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/23/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELLAUNDRY_H__
#define	__SK7PANELLAUNDRY_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//---- class ----
class SK7PanelLaundry : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CHECK_MESSAGE,
		PROC_STOP_MESSAGE,
		PROC_CANCEL,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG=0,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	
	char*					m_pFileName;
	int						m_iMessageNo;
	u32						m_ulEffectID;
	
public:
	SK7PanelLaundry( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelLaundry();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
	bool	CheckMessage( u16 MesNo );
	
};

#endif	//__SK7PANELLAUNDRY_H__
