////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Secom
//
// SK7PanelLock.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELLOCK_H__
#define	__SK7PANELLOCK_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l & 
#define	LOCK_OFF					(0)	//	XCb`It
#define	LOCK_ON						(1)	//	XCb`I
#define	LOCK_POSTER_OFF				(2)	//	XCb`ItL[͂Ȃ
#define	LOCK_POSTER_ON				(3) //	XCb`IL[͂Ȃ


//---- class ----
class SK7PanelLock : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_MESSAGE,
		PROC_END,
		PROC_CHECK,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_SWITCH,
		LOAD_LAMP,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spSwitch;
	SK7Sprite				m_spLamp;
	s8						m_chSelect;
	
public:
	SK7PanelLock( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelLock();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PanelLock_H__
