//
// Killer7 Panel Mailbox
//
// SK7PanelMailbox.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/24/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELMAILBOX_H__
#define	__SK7PANELMAILBOX_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	߂
#define	MAILBOX_ANSWER_NOHIT		(-1)
#define	MAILBOX_ANSWER_HIT			(0)


//	eNX`[pX
static char* tblMailboxTexture[]=
{
	"Texture/020118/POST2_scott020118.BIN",
	"Texture/020118/POST2_rick020119.BIN",
	"Texture/020118/POST2_david020120.BIN",
	"Texture/020118/POST2_dolly020121.BIN",
	"Texture/020118/POST2_terry020122.BIN",
	"Texture/020118/POST2_skip020123.BIN",
	"Texture/020118/POST2_sweet20124.BIN",
	"Texture/020118/POST2_stan020125.BIN",
};


//---- class ----
class SK7PanelMailbox : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_TIME,
		PROC_MESSAGE,
		PROC_MESSAGE2,
		PROC_CANCEL,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG=0,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	
	bool					m_bAns;
	int						m_iPostNo;
	int						m_iTime;

//	EFFECT*					m_ESight;

public:
	SK7PanelMailbox( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelMailbox();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELMAILBOX_H__
