////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Niou
//
// SK7PanelNiou.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELNIOU_H__
#define	__SK7PANELNIOU_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l	--------------------------------------
#define		LIGHT_COLOR_NONE	(-1)
#define		LIGHT_COLOR_WHITE	(0)//	Cg
#define		LIGHT_COLOR_YELLOW	(1)//	CgF
//#define		LIGHT_COLOR_BLACK	(2)//	CgȂ
#define		LIGHT_COLOR_RED		(2)//	Cg
#define		LIGHT_COLOR_BLUE	(3)//	Cg
#define		LIGHT_COLOR_CANCEL	(-1)



#define		SWITCH_NUM			(4)
#define		SWITCH_FIRST_Y		(106)
#define		SWITCH_SIGHT_Y		(180)
#define		SWITCH_SIGHT_X		(42)
#define		SWITCH_UP_Y			(52)
#define		SWITCH_TIME			(20)

#define		SIGHT_FIRST_X		(80)
#define		SIGHT_FIRST_Y		(350)

#define		SPEED_FRAME			(4)


//	eNX`[pX
#define	PNL000106TEX_BG			"Texture/010600/LS03_BG.BIN"
#define	PNL000106TEX_SWITCH		"Texture/010600/LS03_ON.BIN"


//---- class ----
class SK7PanelNiou : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SIGHT_MOVE,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_MOVE_SWITCH,
		PROC_MESSAGE,
		PROC_SWITCH_TIME,
	}eInputCodeProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_SWITCH0,
//		LOAD_SWITCH1,
//		LOAD_SWITCH2,
//		LOAD_SWITCH3,
//		LOAD_SWITCH4,
	}eLoadTexProc;
	


protected:
	eInputCodeProc			m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spSwitch[SWITCH_NUM];	//	XCb`
	
	u8						m_ucSelectNo;			//	ZNg
	u32						m_lMoveTime;		
	Vec						m_vSightPos;	
	u32						m_lSwitchTime;
	bool					m_bMoveFlag;
	s8						m_cSaveNo;
	

public:
	SK7PanelNiou( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelNiou();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
	//	ړ	
//	bool	MoveSwitchPos();
//	bool	MoveSightPos();
};

#endif	//__SK7PANELNIOU_H__
