////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel sec
//
// SK7PanelSecurity.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELSECURITY_H__
#define	__SK7PANELSECURITY_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	߂l
#define	SECURITY_MISS					(0)
#define	SECURITY_CLEAR					(1)
#define	SECURITY_CANCEL					(-1)


#define	SCE_NO_MAX						(5)

enum{
	TEX_055700_BG=0,
	TEX_055700_NO,
	TEX_055700_NO2,
	TEX_055700_MAX,
};

//---- class ----
class SK7PanelSecurity : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_MESSAGE,
		PROC_SELECT_MAIN,
		PROC_CHECK,
		PROC_MOVE_NO,
		PROC_TIME,
		PROC_CANCEL,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_NO,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spNo[SCE_NO_MAX];		
	SK7Sprite				m_spNoPlus1;
	SK7Sprite				m_spNoPlus2;
	
	
	int						m_iMoveTime;
	s8						m_cSelect;
	bool					m_bKeyState;
	s8						m_chType;
	bool					m_bAnswerFlag1;
	bool					m_bAnswerFlag2;
	bool					m_bFirstCheck;

public:
	SK7PanelSecurity( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelSecurity();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
	//	ړvZ
	bool	MoveNo(bool state, s8 select);
	
};

#endif	//__SK7PANELSECURITY_H__
