////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel SK7PANELVENDING
//
// SK7PanelVending.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELVENDING_H__
#define	__SK7PANELVENDING_H__


#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l
#define	VENDING_CANCEL				(-1)//
#define	VENDING_MISS				(0)	//	s
#define	VENDING_OK					(1)	//	


//	eNX`[ԍ
enum{
	TEX_011302_BASE,
	TEX_011302_LAMP,
	TEX_011302_PIC,	
	TEX_011302_MAX,
};

#define		VENDING_NUM				(6)

//---- class ----
class SK7PanelVending : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_MESSAGE,
		PROC_END,
		PROC_TIME,
		PROC_CHECK,
	}eFrameProc;
	
protected:
	eFrameProc				m_Proc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spLamp[VENDING_NUM];
	SK7Sprite				m_spSwitch[VENDING_NUM];
	s8						m_chSelect;
	s8						m_chAnsNum;
	int						m_iTime;
	
public:
	SK7PanelVending( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelVending();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELVENDING_H__
