////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Switch 02
//
// mK7PanelSwitch02.h
// ZeBbN2FʘH̏ƖXCb`
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 09/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7PANELSWITCH02_H__
#define	__MK7PANELSWITCH02_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"

//---- enum ----
typedef	enum{
	ePanelSwitch02ReadTexOff,
	ePanelSwitch02ReadTexOn,
	ePanelSwitch02DispOff,
	ePanelSwitch02DispOn,
	ePanelSwitch02Decide,
	ePanelSwitch02Cancel,
	ePanelSwitch02Message,
	ePanelSwitch02MessageEnd,
	ePanelSwitch02StatsuMax,
}ePanelSwitch02Proc;



//---- class ----
class mK7PanelSwitch02 : public SK7PanelBase
{
protected:
	ePanelSwitch02Proc	mProc;
	
	SK7Sprite			mSpOff;			//XCb`It
	SK7Sprite			mSpOn;			//XCb`I
	
	bool				mSelectFlag;	//IʃtO
	bool				mLastCheck;		//Ō̊mFtO
	bool				mInitSelectFlag;//ItO
	
//	EFFECT*				mEfSight;		//TCgGtFNg
	u32					mKeyTime;		//key
	
public:
	mK7PanelSwitch02( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~mK7PanelSwitch02();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );
	
	// 싖ݒ֐
	virtual void mSetCtrlFlag( bool inBool );

	// _Oݒ֐
	virtual void mSetRender( bool inBool );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
};

#endif	//__MK7PANELSWITCH02_H__
