////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Switch 03
//
// mK7PanelSwitch03.h
// N[[̃XCb`
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 09/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7PANELSWITCH03_H__
#define	__MK7PANELSWITCH03_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"

//---- enum ----
typedef	enum{
	ePanelSwitch03ReadTexOff,
	ePanelSwitch03ReadTexOn,
	ePanelSwitch03DispOff,
	ePanelSwitch03DispOn,
	ePanelSwitch03Decide,
	ePanelSwitch03Cancel,
	ePanelSwitch03Time,
	ePanelSwitch03Message,
	ePanelSwitch03MessageEnd,
	ePanelSwitch03StatsuMax,
}ePanelSwitch03Proc;



//---- class ----
class mK7PanelSwitch03 : public SK7PanelBase
{
protected:
	ePanelSwitch03Proc	mProc;
	
	SK7Sprite			mSpOff;			//XCb`It
	SK7Sprite			mSpOn;			//XCb`I
	
	bool				mSelectFlag;	//IʃtO
	bool				mLastCheck;		//Ō̊mFtO
	bool				mInitSelectFlag;//ItO
	
//	EFFECT*				mEfSight;		//TCgGtFNg
	u32					mKeyTime;		//key
	int					m_iTime;
	
public:
	mK7PanelSwitch03( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~mK7PanelSwitch03();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );
	
	// 싖ݒ֐
	virtual void mSetCtrlFlag( bool inBool );

	// _Oݒ֐
	virtual void mSetRender( bool inBool );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
};

#endif	//__MK7PANELSWITCH03_H__
