////////////////////////////////////////////////////////////////////////////////
//
// Killer7 PlayEfMonotone : LGtFNgigrXLĎ̉j
//
// K7PlayEfMonotone.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 06/18/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7PLAYEFMonotone_CPP__

#include ".\K7PlayEfMonotone.h"
#include "..\Wat\WK7MainTask.h"
#include "..\Wat\WK7GameInfo.h"
#include "..\Yam\YK7Effect.h"
#include "..\Matsu\MK7Noise.h"

K7PlayEfMonotoneInstance::K7PlayEfMonotoneInstance(WK7PlayEffect *pContainerBase,ghmGcListObj *pAnchor,WK7JObj *pJObj,u32 color) : WK7PlayEffectInstance(pContainerBase,pAnchor,pJObj)
{
#pragma	unused(color)
//	mRender  = screenImageMonoColor.GetRender ();
//	mZUpDate = screenImageMonoColor.GetZUpdate();
//	screenImageMonoColor.SetRender (true );
//	screenImageMonoColor.SetZUpdate(false);
//	mColor = (screenImageMonoColor.GetR() << 24 | screenImageMonoColor.GetG() << 16 | screenImageMonoColor.GetB() << 8);
//	screenImageMonoColor.SetR((color >> 24) & 0xff);
//	screenImageMonoColor.SetG((color >> 16) & 0xff);
//	screenImageMonoColor.SetB((color >>  8) & 0xff);
}

K7PlayEfMonotoneInstance::~K7PlayEfMonotoneInstance()
{
//	screenImageMonoColor.SetRender (mRender );
//	screenImageMonoColor.SetZUpdate(mZUpDate);
//	screenImageMonoColor.SetR((mColor >> 24) & 0xff);
//	screenImageMonoColor.SetG((mColor >> 16) & 0xff);
//	screenImageMonoColor.SetB((mColor >>  8) & 0xff);
}

bool K7PlayEfMonotoneInstance::FrameProcess(bool stopReq)
{
	if( stopReq==true ){
		return false;
	}
	ChangePrioEffect(EFF_CONVEBLOOD2,400);
	ChangePrioEffect(EFF_BLOOD      ,400);
	ChangePrioEffect(EFF_BLOOD2     ,400);
	ChangePrioEffect(EFF_MESH       ,400);
	return true;
}

K7PlayEfMonotone::K7PlayEfMonotone(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj,u32 color) : WK7PlayEffect(pPlay,pAnchor,pJObj)
{
	mColor = color;
	mRender     = screenImageMonoColor.GetRender    ();
	mZUpDate    = screenImageMonoColor.GetZUpdate   ();
	mFullScreen = screenImageMonoColor.GetFullScreen();
	screenImageMonoColor.SetRender (true );
	screenImageMonoColor.SetZUpdate(false);
	mColor = (screenImageMonoColor.GetR() << 24 | screenImageMonoColor.GetG() << 16 | screenImageMonoColor.GetB() << 8);
	screenImageMonoColor.SetR((color >> 24) & 0xff);
	screenImageMonoColor.SetG((color >> 16) & 0xff);
	screenImageMonoColor.SetB((color >>  8) & 0xff);
	screenImageMonoColor.SetFullScreen(true);
	gpNoise->SetScreenCopyFlag(true);
}

K7PlayEfMonotone::~K7PlayEfMonotone()
{
	screenImageMonoColor.SetRender (mRender );
	screenImageMonoColor.SetZUpdate(mZUpDate);
	screenImageMonoColor.SetR((mColor >> 24) & 0xff);
	screenImageMonoColor.SetG((mColor >> 16) & 0xff);
	screenImageMonoColor.SetB((mColor >>  8) & 0xff);
	screenImageMonoColor.SetFullScreen(mFullScreen);
	gpNoise->SetScreenCopyFlag(false);
}

WK7PlayEffectInstance* K7PlayEfMonotone::CreateInstance(WK7JObj *pJObj)
{
	return new K7PlayEfMonotoneInstance(this,&mInstanceAnchor,pJObj,mColor);
}

