////////////////////////////////////////////////////////////////////////////////
//
// Killer7 PlayEffect
//
// K7PlayEffect.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7PLAYEFFECT_H__
#define	__K7PLAYEFFECT_H__

#include "..\Wat\WK7Play.h"

#define	K7PLAYEFFECT_DECL_START()				WK7PlayEffect* WK7Play::CreatePlayEffect(WK7JObj *pJObj) \
												{ \
													u32				id = WK7PlayEffect::GetEffectID(pJObj); \
													WK7PlayEffect	*pEffect; \
													ghmGcMemSetAllocName("PlEf"); \
													switch( id ){
#define	K7PLAYEFFECT_DECL(id,type)					case	(id): pEffect = new type           (this,&mPlayEffectAnchor,pJObj); break;
#define	K7PLAYEFFECT_DECL_PARAM(id,type,...)		case	(id): pEffect = new type           (this,&mPlayEffectAnchor,pJObj,__VA_ARGS__ ); break;
#define	K7PLAYEFFECT_DECL_END()						case	0xffffffff: return NULL; \
													default:      pEffect = new K7PlayEffectDef(this,&mPlayEffectAnchor,pJObj); break; \
													} \
													return pEffect; \
												}

#define	K7PLAYEFFECT_DECL_INVALID(id)	case	(id): pEffect = NULL; break;

class K7PlayEffectInstanceDef : public WK7PlayEffectInstance{
protected:
	EFFECT				*mpEffect;
	u32					mEffectID;
	bool FreeEffect(void);
public:
	K7PlayEffectInstanceDef(WK7PlayEffect *pContainer,ghmGcListObj *pAnchor,WK7JObj *pJObj,int prio);
	virtual ~K7PlayEffectInstanceDef();
	
	virtual bool FrameProcess(bool stopReq);
};

class K7PlayEffectDef : public WK7PlayEffect{
protected:
public:
	K7PlayEffectDef(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj);
	virtual ~K7PlayEffectDef();
	
	virtual bool CheckSetup(void);
	virtual WK7PlayEffectInstance* CreateInstance(WK7JObj *pJObj);
};

#endif	//__K7PLAYEFFECT_H__

