////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Logo Task
//
// SK7EndSaveTask.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/05/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7ENDSAVETASK_H__
#define	__SK7ENDSAVETASK_H__

#include "SK7Common.h"
#include "SK7Sprite.h"
#include "../Yam/YK7String.h"
#include "SK7SaveBase.h"


//	ŏIZ[uNX
class SK7EndSaveTask : public ghmGcAppTask
{
	typedef enum{
		eSaveLoad=0,
		eEffect,
	}eLoadProc;
	
	typedef enum{
		eLoad=0,
		eFade,
		eMain,
		eEnd,
	}eProc;
	
protected:
	SK7Sprite			m_spTV;
	SK7Sprite			m_spBack;
	SK7File*			m_pFile;
	eLoadProc			m_eLoad;
	eProc				m_eProc;
	bool				m_bRender;
	int					m_iDiskID;
	SK7SaveBase*		m_pSaveLoad;

	ghmGcTaskController *m_pTaskControl;	//	^XNRg[[

public:
	SK7EndSaveTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~SK7EndSaveTask();

	// R[obN
	virtual bool InitializeCallBack(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);

	bool Load();	
};

#endif	//__SK7ENDSAVETASK_H__



