////////////////////////////////////////////////////////////////////////////////
//
// Killer7 FirstCheck
//
// SK7FirstCheck.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 02/12/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7FIRSTCHECK_H__
#define	__SK7FIRSTCHECK_H__

#include "SK7Sprite.h"
#include "DVDBanner.h"
#include "SK7SaveData.h"
#include "SK7SaveBase.h"

enum{
	CHECK_STATE_FIRST=0,
	CHECK_STATE_KILLER8,
};

//	ZNgԍ	
enum{
	CHECK_SELECT_NORMAL=0,			//	Z[uȂAւ
	CHECK_SELECT_INIT,				//	NORMAL+
	CHECK_SELECT_IPL,				//	NORMAL+IPLʂ
	CHECK_SELECT_CHECK_INIT,		//	`FbN
	CHECK_SELECT_BREAK,				//	jp	
};

extern bool g_bFirstGameCheck;

class SK7FirstCheck : public SK7SaveBase 
{
	enum{
		DATA_IS_NONE=0,
		DATA_IS_BUSY,
		DATA_IS_TRUE,
	};
protected:
	bool				m_bCheckBFlag;
	bool				m_bSlotAOkFlag;
	bool				m_bSlotInFlag;
	int					m_iTime;
	int					m_iMessageTime;
	s8					m_chState;

	s8	 		CheckCardInsert(void);
	bool 		FrameMessageKey(void);
	void		CheckMount(void);
	void		CheckFileCheck(void);
	void		CheckFileErea(void);
	void		CheckFileErea2();
	s8			GetSelectNum(void);
	s8			CheckHopper7(void);
	s8			CheckKiller8(void);
	void 		CheckInitCard(void);
	void 		InitCheck(void);
	void		CheckHopperFlag(void);
	bool		CheckKillerData();
public:
	SK7FirstCheck(s8 State);
	~SK7FirstCheck();
	bool Load(void);							// [h		
	virtual bool FrameProcess(void);						// t[	
	virtual bool RenderProcess(void);						// _O	
	virtual bool GetMenuEnd(void);							// II擾֐
	virtual void SetCtrlFlag(bool flag){ m_bCtrl=flag; }	// 싖ݒ֐
	virtual void SetRender(bool flag){ m_bRender=flag; }	// _O
};

#endif	//__SK7FIRSTCHECK_H__
