////////////////////////////////////////////////////////////////////////////////
//
// Killer7 IMenuBase
//
// SK7IMenuBase.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7IMENUBASE_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7IMenuBase.h"
//#include "SK7IMenuChara.h"
#include "SK7IMenuPola.h"
#include "SK7IMenuVoice.h"
#include "SK7IMenuHato.h"
#include "SK7IMenuMap.h"
#include "SK7IMenuUlmeyda.h"
#include "SK7IMenuColor.h"


//========================================================================
//					RXgN^
//========================================================================
SK7IMenuBase::SK7IMenuBase()
{
	m_bRender = false;				// `tO
	m_bCtrl = false;				// 싖tO
//	PanelScreenEffectStop();
}


//========================================================================
//					fXgN^
//========================================================================
SK7IMenuBase:: ~SK7IMenuBase()
{
//	PanelScreenEffectStopRelease();
}

//========================================================================
//					pl
//========================================================================
SK7IMenuBase* SK7IMenuBase::Create(u8 id, u8 no)
{
	switch( id ){
	case	eMenuPolaroid: 
			ghmGcMemSetAllocName("SK7POLA");
			return new SK7IMenuPola();
	case	eMenuVoiceMemo:
			ghmGcMemSetAllocName("SK7MEMO");
			return new SK7IMenuVoice(no);
	case	eMenuHatoMemo:
			ghmGcMemSetAllocName("SK7HATOM");
			return new SK7IMenuHato();
	case	eMenuMap:
			ghmGcMemSetAllocName("SK7MAP");
			return new SK7IMenuMap();
	case	eMenuUlmeyda:	
			ghmGcMemSetAllocName("SK7UL");
			return new SK7IMenuUlmeyda();
	case 	eMenuColor:	
			ghmGcMemSetAllocName("SK7COLOR");
			return new SK7IMenuColor();
	default:
		break;
	}
	return NULL;
}

void SK7IMenuBase::SetRender(bool flag)
{
	if( flag==true ){
		PanelScreenEffectStop();
	}else{
		PanelScreenEffectStopRelease();
	}
	m_bRender=flag;
}	

