////////////////////////////////////////////////////////////////////////////////
//
// Killer7 IMenuUlmeyda
//
// SK7IMenuUlmeyda.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7IMENUULMEYDA_H__
#define	__SK7IMENUULMEYDA_H__

#include "SK7IMenuBase.h"
#include "SK7Sprite.h"
#include "../Yam/YK7Effect.h"
#include "../wat/WK7Archive.h"


enum{
	TEX_SMALL_01,
	TEX_SMALL_02,
	TEX_SMALL_03,
	TEX_SMALL_04,
	TEX_SMALL_05,
	TEX_SMALL_06,
	TEX_SMALL_07,
	TEX_SMALL_08,
	TEX_SMALL_09,
	TEX_SMALL_10,
	TEX_SMALL_11,
	TEX_SMALL_12,
#if 0
	TEX_UP_01,
	TEX_UP_02,
	TEX_UP_03,
	TEX_UP_04,
	TEX_UP_05,
	TEX_UP_06,
	TEX_UP_07,
	TEX_UP_08,
	TEX_UP_09,
	TEX_UP_10,
	TEX_UP_11,
	TEX_UP_12,
#endif
	TEX_UL_KASAN,
	TEX_BACK_GROUND,
	TEX_UL_MAX,
};


#define			ULMEYDA_NUM			(12)
#define			ULMEYDA_DATA_NUM	(TEX_UL_MAX+ULMEYDA_NUM)
#define			ULMEYDA_LIGHT_NUM	(10)

typedef struct{
	WK7Archive*		pArchive;			//	A[JCuNX
	WK7Model*		pModel;			//	fNX
	WK7Light*		pLight[ULMEYDA_LIGHT_NUM];
}ULMEYDA_MODEL;

//	EC_RNV
class SK7IMenuUlmeyda : public SK7IMenuBase
{ 
protected:
	
	typedef enum{
		LOAD_MODEL=0,
		LOAD_MOTION,
	}eLoadProc;
	
	typedef enum{
		PROC_LOAD=0,
		PROC_MAIN,
		PROC_BIG,
		PROC_END,
	}eMainProc;
			
	eLoadProc			m_eLoadProc;
	eMainProc			m_Proc;

	SK7File*		m_pFile;
	ghmGcResLink*	m_pResLink;			//	N\[X
	void*			m_pPackData;		//	f[^
	TEX_DATA*		m_ptData[TEX_UL_MAX];

	ULMEYDA_MODEL	m_UlModel[ULMEYDA_NUM];

	
	int				m_iTime;
	s8				m_chSelect;
	SK7Sprite		m_spBG;
	SK7Sprite		m_spUlmeyda[ULMEYDA_NUM];
	SK7Sprite		m_spKasan;
	
public:
	SK7IMenuUlmeyda();
	virtual ~SK7IMenuUlmeyda();
	
	// t[
	virtual bool  FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
	
	// t@CǂݍݏI擾֐
	virtual bool GetFileReadEnd(void);
	
	// II擾֐
	virtual bool GetMenuEnd(void);
	
	bool	LoadData();
	void	Initialize();
};

#endif	//__SK7IMENUULMEYDA_H__

