////////////////////////////////////////////////////////////////////////////////
//
// Killer7 MapData
//
// SK7MapData.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7MAPDATA_H__
#define	__SK7MAPDATA_H__

//	Xe[WZp		
struct MAP_KASAN{
	u16			StageID;			//	Xe[Whc
	u8			StageNo;
	u8			StageFix;			//	Xe[W`
	s16			x,y;				//	W
	u8			TexNo;				//	eNX`[ԍ
};

//	}bṽCp		
typedef struct{
	SK7Sprite	spCenter;
	SK7Sprite	spSide[2];		//	E ㉺
}MAP_LINE;


//	̃Cp		
typedef struct{
	SK7Sprite	spLine[2];
}ICONLINE;

//		}bvACRp			
struct MAPICON{
	u32 		StageID;			//	Xe[WID
	s8			IconNo;				//	ACRԍ
	s8			SubNo;				//	ACR̕Ήԍ
	VEC2		vPos;				//	ACRW
	VEC2		vLine1;				//	C
	VEC2		vLine2;				//	C̏I
	u32			IconFlag;			//	tO
};

//	ACRԍ
enum{
	MAP_ICON_EVENT=0,				//	Cxg
	MAP_ICON_FUSIGI=1,				//	ACegpCxg
	MAP_ICON_GET_ITEM=2,			//	ACe擾
	MAP_ICON_PIC=3,					//	ʐ^Cxg
	MAP_ICON_BULLET=4,				//	܂
	MAP_ICON_RING_FIRE=5,			//	w։
	MAP_ICON_RING_WATER=6,			//	w֐
	MAP_ICON_RING_PAST=7,			//	w։ߋ
	MAP_ICON_RING_WIND=8,			//	w֕
	MAP_ICON_RING_HPUP=9,			//	wփX^~i
	MAP_ICON_RING_ATTACK=10,		//	w֍U
	MAP_ICON_RING_BLUE=11,			//	w֐痢
	MAP_ICON_HATO=12,				//	͂
	MAP_ICON_MONBAN=13,				//	o
	MAP_ICON_ULMAYDA=14,			//	EC_
	MAP_ICON_TIP=15,				//	J[`bv
	MAP_ICON_GAL=16,				//	KVA
	MAP_ICON_DAN=17,				//	_
	MAP_ICON_KAE=18,				//	JGf
	MAP_ICON_CYO=19,				//	R[e
	MAP_ICON_KVN=20,				//	PB
	MAP_ICON_CAT=21,				//	R
	MAP_ICON_MSK=22,				//	}XN1
	MAP_ICON_MSK_TXS=23,			//	}XN2
	MAP_ICON_MSK_FIN=24,			//	}XN3
	MAP_ICON_TV=25,					//	su
	MAP_ICON_SAVE=26,				//	Z[uP
	MAP_ICON_BULLET_KASAN=27,		//	܂܉Z
	MAP_ICON_MAX=28,
};

#define		MAP_BLOCK_MAX			(15)
#define		MAP_OBJ_MAX				(4)
#define		MAP_KASAN_MAX			(15)
#define		MAP_ICON_MAX			(20)
#define		KASAN_COLOR				(0xfc6D0dff)
#define		KASAN_COLOR2			(0x00e077eb)
#define		TEX_MAP_MAX				(50)
#define		OVER_WORD_SIZE			(95)
#define		ICON_RING_GAP			(6)
#define		NOT_EVENT_FLAG			(0xffffffff)
#define		ICON_LINE_SIZE			(16)
#define		ICON_LINE_COLOR			(0xff00ffff)
#define		TAMAKASAN_MAX_NUM		(3)



//	
//			}bvf[^		
//	
static char* tblStageMapData[]={
	"/Texture/map/MapCel.pak",			//	ZeBbN
	"/Texture/map/MapFuk.pak",           //	tNV}
	"/Texture/map/MapKak.pak",           //	JNr
	"/Texture/map/MapTxs.pak",           //	eLTX
	"/Texture/map/MapIsz.pak",           //	Vn
	"/Texture/map/MapKur.pak",           //	J[eBX
	"/Texture/map/MapDmi.pak",           //	h~jJ1
	"/Texture/map/MapDmi.pak",           //	h~jJ2
	"/Texture/map/MapHtl.pak",           //	ze1
	"/Texture/map/MapScl.pak",           //	wZ
	"/Texture/map/MapHtl.pak",           //	ze2
	"/Texture/map/MapSen.pak",           //	
};

#define		TEX_MAP_DAY_NO		(0)			//	ɂ̃eNX`̈ʒu
#define		TEX_MAP_TITLE_NO	(1)			//	^Cg̃eNX`̈ʒu
#define		TEX_MAP_FIRST_NO	(2)			//	}bvf[^̐擪ԍ


//	
//			}bvIuWFNgf[^		
//	
#define	MAP_OBJ_DATA		"/item/map/map.pak"

enum{
	TEX_MOBJ_BACK_GROUND=0,
	TEX_MOBJ_PLUS,
	TEX_MOBJ_MAINAS,
	TEX_MOBJ_JYOSAN,
	TEX_MOBJ_MAX,
};

#define		MAP_OBJ_TEX_NUM			(32)//(TEX_MOBJ_MAX+MAP_ICON_MAX-ICON_RING_GAP)

//::::::::::::::::::::::::::	IuWFNgʒu	::::::::::::::::::::::::::::		

const VEC2	tblMapObjPos[]={
	28,28,		//	Xe[W^CgW
	429,429,    //	Xe[WtW
	558, 337,   //	Xe[Wꏊ啶
	33,71,		//	[g{bNX
	38,83,		//	[gCcUP
	56,125,		//	q{bNXroot
	39,130,		//	qCStart
};

enum{
	MAP_POS_TITLE=0,
	MAP_POS_DAY,
	MAP_POS_BIG_NAME,
	MAP_POS_ROOTBOX,
	MAP_POS_ROOTLINE,
	MAP_POS_CHILDBOX,
	MAP_POS_CHILDLINE,
};

#define		ROOT_LINE_SIZEY			(333)
#define		CHILD_LINE_SIZEX		(20)

//
//			J[			
//
const u32		tblMapColor[]={
	0xf06000cd,						//	Z̃J[
	0xff0000cd,                     //	}bvIuWFNgJ[
	0xffffffff,						//	}bv
	0xffffffe5,						//	^Cg
	0xffffffe5,						//	啶
	0xffffffD8,						//		
	0xffffffe5,						//	{bNXON
	0xffffff66,						//	{bNXoff
};

enum{
	MAP_COLOR_KASAN,
	MAP_COLOR_OBJ,
	MAP_COLOR_BODY,
	MAP_COLOR_TITLE,
	MAP_COLOR_BIG_NAME,
	MAP_COLOR_SMALL_NAME,
	MAP_COLOR_BOX_ON,
	MAP_COLOR_BOX_OFF,
};

#endif	//__SK7MAPDATA_H__

