////////////////////////////////////////////////////////////////////////////////
//
// Killer7 FirstCheck
//
// SK7SaveProcess.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 02/12/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7SAVEPROCESS_H__
#define	__SK7SAVEPROCESS_H__

#include "SK7Sprite.h"
#include "SK7SaveData.h"
#include "SK7SaveBase.h"


//	Z[u
enum{
	SAVE_STATE_TV=0,
	SAVE_STATE_END,
};

class SK7SaveProcess : public SK7SaveBase 
{

protected:
	s8					m_chSaveState;
	bool				m_bCreateFlag;
	u8					m_ucMoveNameFlag;
	f32					m_fSaveNameX;
	char*				m_pSavedName;				//	Z[uIO
	EFFECT*				m_pEffect;
	int					m_iSaveNameTime;
	
	void 		RenderMoveComment(void);
//	void		CheckSlotSelect();
//	void		CheckFileCheck();
//	void		CheckFileErea();
//	void		CheckSavePoint();
//	void		CheckSavePlay();
	void 		CreateSaveData();
	void 		WriteSaveData();
	void		CheckWriteEnd();
	void 		InitCheck(void);
//	bool 		FrameMessageKey(void);
	void 		CheckInitCard(void);
	void 		CheckDammyDelete(void);
	void	 	CheckFileRename(void);
	void		FrameEndSaveCheck(void);
	bool		FrameMove();
	public:
	SK7SaveProcess( s8 State );
	~SK7SaveProcess();
	virtual bool FrameProcess(void);						// t[	
	virtual bool RenderProcess(void);						// _O	
	virtual bool GetMenuEnd(void);							// II擾֐
	virtual void SetCtrlFlag(bool flag){ m_bCtrl=flag; }	// 싖ݒ֐
	virtual void SetRender(bool flag){ m_bRender=flag; }	// _O
};

#endif	//__SK7SAVEPROCESS_H__
