////////////////////////////////////////////////////////////////////////////////
//
// Killer7 ScenarioData
//
// SK7ScenarioData.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/27/2003
//
////////////////////////////////////////////////////////////////////////////////


#ifndef	__SK7SCENARIODATA_H__
#define	__SK7SCENARIODATA_H__

//#define	__ONEDAY__
#define		BG_Z					(27.3f)

//	ł\	-------------------------------------
typedef struct{
	char*	Normal;
	char*	Red;
	char*	Black;
}LOADMODEL_DATA;


//	ff[^
static LOADMODEL_DATA tblModelData[]={
	"/3DData/Model/Chara/KUN/KUN_M00.dat",	 	"/3DData/Model/Chara/KUN/KUN_R_M00.dat",	"/3DData/Model/Chara/KUN/KUN_B_M00.dat",
	"/3DData/Model/Chara/KRH/KRM_M00.dat",		"/3DData/Model/Chara/KRH/KRH_R_M00.dat",	"/3DData/Model/Chara/KRH/KRH_B_M00.dat",
	"/3DData/Model/Chara/UR2/UR2_M00.dat",		"/3DData/Model/Chara/UR2/UR2_R_M00.dat",	"/3DData/Model/Chara/UR2/UR2_B_M00.dat",
	"/3DData/Model/Chara/Cur/Cur_M00.dat",		"/3DData/Model/Chara/Cur/CUR_R_M00.dat",	"/3DData/Model/Chara/Cur/CUR_B_M00.dat",
	"/3DData/Model/Chara/HM1/HM1_M01.dat",		"/3DData/Model/Chara/HM1/HM1_R_M00.dat",	"/3DData/Model/Chara/HM1/HM1_B_M00.dat",
	"/3DData/Model/Chara/E02/E02_M00.dat",		"/3DData/Model/Chara/E02/E02_R_M00.dat",	"/3DData/Model/Chara/E02/E02_B_M00.dat",//	"/3DData/Model/Chara/Gal/Gal_R_M00.dat",		
	"/scenario/FLG_M01.dat",	 				"/scenario/FLG_M00.dat",					"/scenario/FLG_M00.dat",
	"/3DData/Model/Chara/AKI/AKI_M00.dat",		"/3DData/Model/Chara/AKI/AKI_R_M00.dat",	"/3DData/Model/Chara/AKI/AKI_B_M00.dat",
};


//	[Vf[^
static char *tblMotionData[]={
	"/3DData/Motion/Chara/KUN/KUN_0020.dat",
	"/3DData/Motion/Chara/KRH/KRH_0020.dat",
	"/3DData/Motion/Chara/UR2/UR2_0020.dat",
	"/3DData/Motion/Chara/Cur/CUR_0020.dat",
	"/3DData/Motion/Chara/HN1/HN1_0021.dat",
	"/3DData/Motion/Chara/E02/E02_0020.dat",
	"/scenario/FLG_0020.dat",
	"/3DData/Motion/Chara/AKI/AKI_0020.dat",
};

#define		SCENARIO_PACK_DATA			"/scenario/scenario.pak"

enum{
	SCE_PACK_TENSHI=0,
	SCE_PACK_RAKUJITU,
	SCE_PACK_KUMOOTOKO,
	SCE_PACK_KAIKOU,
	SCE_PACK_BUNSIN,
	SCE_PACK_EGAO,
	SCE_PACK_SISI,
	SCE_PACK_SIGHT,
	SCE_PACK_BLOODS,
	SCE_PACK_WASHI,
};

enum{
	SCE_TEX_SIGHT=0,
	SCE_TEX_BLOODS,
	SCE_TEX_WASHI,	
	SCE_TEX_T00,
	SCE_TEX_T01,
	SCE_TEX_T02,
	SCE_TEX_T03,
	SCE_TEX_T04,
	SCE_TEX_T05,
	SCE_TEX_T06,
	SCE_TEX_TARGET,
	SCE_TEX_TIME00,
	SCE_TEX_TIME01,
	SCE_TEX_TIME02,
	SCE_TEX_TIME03,
	SCE_TEX_TIME04,
	SCE_TEX_TIME05,
	SCE_TEX_TIME06,
	SCE_TEX_TITTLE_BAR,
	SCE_TEX_BOX,
	SCE_TEX_BIG_S,
	SCE_TEX_BIG_A,
	SCE_TEX_BIG_C,
	SCE_TEX_BIG_E,
	SCE_TEX_BIG_L,
	SCE_TEX_SMALL_A,
	SCE_TEX_SMALL_C,
	SCE_TEX_SMALL_E,
	SCE_TEX_SMALL_M,
	SCE_TEX_SMALL_N,
	SCE_TEX_SMALL_O,
	SCE_TEX_SMALL_R,
	SCE_TEX_SMALL_S,
	SCE_TEX_SMALL_U,
	SCE_TEX_SMALL2_D,
	SCE_TEX_SMALL2_G,
	SCE_TEX_SMALL2_I,
	SCE_TEX_SMALL2_L,
	SCE_TEX_SMALL2_T,
	SCE_TEX_RETURN_TITLE,
	SCE_TEX_Y,
	SCE_TEX_E,
	SCE_TEX_S,
	SCE_TEX_N,
	SCE_TEX_O,
	SCE_TEX_SAVE01,
	SCE_TEX_SAVE02,
	SCENARIO_TEX_NUM,
};

#define		SCENARIO_MAX_NUM		(7)

//		LN^[|WV		
const Vec tblModelPos[]=
{
	-1.0625f,		-14.175f,		37.22506f,	
	-0.4250003f,	-13.8125f,		34.69998f,
	-1.812479f,		-13.32500f,		41.07504f,
	-0.11248f,		-14.92501f,		41.58754f, 
	-1.0625f,		-14.175f,		37.22506f, 
	-1.0625f,		-14.175f,		37.22506f, 
	-3.487482f,		-45.43747f,		1.012494f,	
	-3.59999f,		-13.07499f,		37.4f, 
};

const Vec tblModelRot[]=
{
	0.0f, 0.2999995f, 0.0f,
	0.0f, 0.2999995f, 0.0f,
	0.0f, 0.5918136f,  0.0f,
	0.0f, 0.2999995f, 0.0f,
	0.0f, 0.2999995f, 0.0f,
	0.0f, 0.2999995f, 0.0f,
	0.0f, -1.216291f, 0.0f,
	0.0f, 0.2999995f, 0.0f,
};

const Vec tblModelLoadPos[]=
{
	2.187501f,-12.16251f,33.02512f,
	2.087498f,-11.16251f,30.89998f,
	0.4625210f,-11.87501f,35.57501f,
	1.437521f,-14.22501f,39.33754f,
	1.037508f,-12.62501f,31.98757f,	
	2.175002f,-11.98750f,28.41256f,
	2.187501f,-12.16251f,33.02512f,
	-2.362489f,-10.27499f,31.40000f,
};

const Vec tblModelLoadRot[]=
{
	0.0f,-0.4043142f,0.0f,
	0.0f,0.0f,0.0f,
	0.0f,0.5874983f,0.0f,
	0.0f,0.0f,0.0f,
	0.0f,0.2706872f,0.0f,
	0.0f,0.4499999f,0.0f,
	0.0f,-0.4043142f,0.0f,
	0.0f,0.0f,0.0f,
};

const Vec tblModelPosFirst[]=
{
	-2.549980f,		-15.35000f,			40.96253f,
	-3.600004f,		-14.05000f,			40.53750f,
	-3.137485f,		-13.13754f,			41.93760f,
	-3.249980f,		-14.40000f,			40.00000f,//-2.062478f,		-13.91250f,			40.42503f,
	-2.374983f,		-14.73752f,			42.86254f,//-3.024982f,		-14.10001f,			39.85005f,
	-3.262482f,		-14.18750f,			42.17508f,//-5.024981f,		-12.96250f,			31.67504f,
	-14.33748f,		-47.98751f,			11.21258f,
	-2.387494f,		-14.57498f,			42.32502f,
};


const Vec tblModelRotFirst[]=
{
	0.0f,	0.3500000f,		0.0f,
	0.0f,	0.0f,			0.0f,
	0.0f,	0.7711309f,		0.0f,
	0.0f,	0.0f,			0.0f,
	0.0f,	0.05000114f,	0.0f,//0.02068593f,	0.0f,
	0.0f,	0.6831865f,		0.0f,//0.6456865f,		0.0f,
	0.0f,	11.21258f,		0.0f,
	0.0f,	0.0f,			0.0f,
};

const Vec tblModelMovePos[]=
{
	-2.0f, 	-2.0f,		0.0f,
	2.0f,	2.0f,		0.0f,
	-2.0f, 	-2.0f,		0.0f,
	2.0f,	2.0f,		0.0f,
	-2.0f, 	-2.0f,		0.0f,
	2.0f,	2.0f,		0.0f,
	-2.0f, 	-2.0f,		0.0f,
	-2.0f, 	-2.0f,		0.0f,
};



//	wW
const Vec tblFrontSight[]=
{
	8.7311821f, 	6.38749577f,	BG_Z,
	8.7687745f, 	3.87500008f, 		BG_Z,
	8.8248399f,		1.2875643f,	BG_Z,
	8.7998399f,		-1.3624257f,		BG_Z,
	8.693586f,		-3.974927f,	BG_Z,
	8.8373381f, 	-6.38117544f,	BG_Z,
	8.612497f, 		6.4625f,	BG_Z,
};


//	TCg̏ꏊ
const Vec tblBackSight[]=
{
	-7.1624875f,		-5.3934533f,			60.0f,
	-7.2118704f,		-3.9380126f,		60.0f,
	-7.3494893f,	-2.3994793f,		60.0f,	
	-7.5119237f,	-0.7007508f,		60.0f,
	-7.0494045f,	0.9492586f,		60.0f,
	-8.2306984f,	2.40565651f,		60.0f,
	-7.725f,		-6.2f,			60.0f,
};



//	qop
const VEC2 tblShishiBack[]=
{
	1.1062353f,0.0749971f,
	1.200056f,0.0365961f,
	0.6560239f,-0.3200235f,
	1.5009911f,0.0446281f,
	1.146514f,0.04328283f,
	1.463189f,0.21410508f,
	0.0f,0.0f,
};

const VEC2 tblShishiFront[]=
{
	-1.9126069f,-0.11252865f,
	-1.9685681f,-0.07518720993f,
	-2.0434461f,-0.03774695f,
	-2.0433265f,0.01841688f,
	-2.1933534f,-0.03780153f,
	-2.174601f,-0.13158518f,
	0.0f,0.0f,
};


const u32 tblZBuffData[]=
{
	0x00FDFFFF,      //	ȉ̎͐Ԃ
	0x00FDFFFF,
	0x00FDFFFF,
	0x00FDFFFF,
	0x00FDFFFF,
	0x00FDFFFF,
	0x00FDFFFF,
	0x00FDFFFF,
};

//	ɂ̍W
const u16 tblDayX[]={ 467, 463, 487, 465, 459, 461, 603 };
//	
const u8 tblSceNameNum[]={ 5, 10, 9, 9, 8, 5, 4 };

//	J[e[u
typedef struct{
	GXColor 	Up;
	GXColor		Down;
}WASHI_COLOR;

const WASHI_COLOR tblWashiColor[]={
	0xef,0xf9,0xfd,0xff,	0x46, 0xa4, 0xe7, 0xff,
	253,239,239,255,		231,70,71,255,
	253,239,252,255,		135,70,231,255,
	253,239,239,255,		231,190,70,255,
	253,239,252,255,		231,71,103,255,
	246,246,246,255,		100,100,100,255,
	0xff,0xff,0xff,0xff,	0xff,0xff,0xff,0xff,
};

typedef struct{
	VEC2	Big;
	VEC2 	Mini;
	u8		TexNo;
}SCE_FONT_STATE;

//	eVp
const SCE_FONT_STATE tblTenshiFontPos[]={
	256,51,	462,51,	SCE_TEX_BIG_A,
	281,60,	435,60,	SCE_TEX_SMALL_N,
	302,59,	484,59,	SCE_TEX_SMALL2_G,
	317,60,	455,60,	SCE_TEX_SMALL_E,
	330,50,	447,50,	SCE_TEX_SMALL2_L,
};

//	NWcp
const SCE_FONT_STATE tblRakujituFontPos[]={
	253,51,	447,51,	SCE_TEX_BIG_S,
	276,60,	441,60,	SCE_TEX_SMALL_E,
	291,50,	525,50,	SCE_TEX_SMALL2_T,
	302,50,	433,50,	SCE_TEX_SMALL2_T,
	312,49,	487,49,	SCE_TEX_SMALL2_I,
	325,60,	465,60,	SCE_TEX_SMALL_N,
	347,59,	481,59,	SCE_TEX_SMALL2_G,
	366,60,	515,60,	SCE_TEX_SMALL_S,
	384,60,	505,60,	SCE_TEX_SMALL_U,
	405,60,	486,60,	SCE_TEX_SMALL_N,
};

//	NIgRp
const SCE_FONT_STATE tblKumootokoFontPos[]={
	256,51,	521,51,SCE_TEX_BIG_C,
	279,49,	442,49,SCE_TEX_SMALL2_L,
	290,60,	462,60,SCE_TEX_SMALL_O,
	310,60,	450,60,SCE_TEX_SMALL_U,
	331,50,	540,50,SCE_TEX_SMALL2_D,
	346,60,	432,60,SCE_TEX_SMALL_S,
	364,61,	489,61,SCE_TEX_SMALL_M,
	395,60,	509,60,SCE_TEX_SMALL_A,
	415,60,	476,60,SCE_TEX_SMALL_N,
};

//	JCREp
const SCE_FONT_STATE tblKaikoFontPos[]={
	254,51,	467,51,SCE_TEX_BIG_E,
	279,60,	456,60,SCE_TEX_SMALL_N,
	298,60,	513,60,SCE_TEX_SMALL_C,
	316,60,	499,60,SCE_TEX_SMALL_O,
	335,60,	526,60,SCE_TEX_SMALL_U,
	355,60,	442,60,SCE_TEX_SMALL_N,
	373,50,	433,50,SCE_TEX_SMALL2_T,
	383,60,	542,60,SCE_TEX_SMALL_E,
	396,60,	485,60,SCE_TEX_SMALL_R,
};

//	uVp
const SCE_FONT_STATE tblBunshinFontPos[]={
	256,51,	474,51,SCE_TEX_BIG_A,
	277,49,	455,49,SCE_TEX_SMALL2_L,
	287,50,	524,50,SCE_TEX_SMALL2_T,
	297,60,	465,60,SCE_TEX_SMALL_E,
	311,60,	431,60,SCE_TEX_SMALL_R,
	325,51,	503,51,SCE_TEX_BIG_E,
	353,59,	500,59,SCE_TEX_SMALL2_G,
	369,60,	442,60,SCE_TEX_SMALL_O,
};

//	GKIp
const SCE_FONT_STATE tblEgaoFontPos[]={
	253,51,	474,51,SCE_TEX_BIG_S,
	277,61,	436,61,SCE_TEX_SMALL_M,
	306,49,	491,49,SCE_TEX_SMALL2_I,
	314,49,	471,49,SCE_TEX_SMALL2_L,
	326,60,	462,60,SCE_TEX_SMALL_E,
};

//	qp
const SCE_FONT_STATE tblShishiFontPos[]={
	596.0f,291.0f,34,34,SCE_TEX_BIG_L,
	595.0f,276.0f,20,36,SCE_TEX_SMALL2_I,
	601.0f,264.0f,24,26,SCE_TEX_SMALL_O,
	601.0f,245.0f,24,26,SCE_TEX_SMALL_N, 
};

static const SCE_FONT_STATE* tblScenarioFontPos[]={
	tblTenshiFontPos,
	tblRakujituFontPos,
	tblKumootokoFontPos,
	tblKaikoFontPos,
	tblBunshinFontPos,
	tblEgaoFontPos,
	tblShishiFontPos,
};


#endif	//__SK7SCENARIODATA_H__