////////////////////////////////////////////////////////////////////////////////
//
// Killer7 ScenarioData
//
// SK7SpecialData.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/27/2003
//
////////////////////////////////////////////////////////////////////////////////


#ifndef	__SK7SPECIALDATA_H__
#define	__SK7SPECIALDATA_H__

#include "..\wat\K7GlobalFlag.h"
#include "SK7Pack.h"

#define		SELECT_FONT_MAX		(4)			//	ZNg̃tHg
#define		RING_CHANGE_NUM		(6)			//	O̐(痢ȊO)
#define		SELECT_WAKU_NUM		(8)			//	Ig̐
#define		SP_BULLET_NUM		(7)			//	eې
#define		ITEM_SELECT_MAX		(3)			//	ACeZNgu


//		O̎		
enum{
	RING_FIRE=0,
	RING_WATER,
	RING_PAST,
	RING_WIND,
	RING_HPUP,
	RING_ATTACK,
	RING_BLUE,
};

//		eNX`[wit[ԍ		
enum{
	BF_TEX_UP0=0,			//̕
	BF_TEX_UP1,			//
	BF_TEX_UP2,            //
	BF_TEX_UP3,            //
	BF_TEX_LEFT0,			//nWォ
	BF_TEX_LEFT1,			//nWォ
	BF_TEX_LEFT2,			//
	BF_TEX_LEFT3,          //
	BF_TEX_LEFT4,          //
	BF_TEX_DOWN0,          //
	BF_TEX_DOWN1,			//
	BF_TEX_DOWN2,          //
	BF_TEX_HATOUP0,			//͂
	BF_TEX_HATOUP1,			//͂
	BF_TEX_UP_KAZARI0,		//̏
	BF_TEX_UP_KAZARI1,		//̏
	BF_TEX_UP_KAZARI2,		//̏
	BF_TEX_DOWN_KAZARI0,	//̏
	BF_TEX_DOWN_KAZARI1,	//
	BF_TEX_DOWN_KAZARI2,	//
	BF_TEX_DOWN_KAZARI3,	//
	BF_TEX_TOGE0,			//̂ƂƂ
	BF_TEX_TOGE1,	

	BF_TEX_MAX,
};

//		wit[eNX`[ԍ		
enum{
	BF_NOTEX_UP=0,			//
	BF_NOTEX_DOWN,			//
	BF_NOTEX_LEFT,			//
	BF_NOTEX_CENTER_0,		//^񒆍
	BF_NOTEX_CENTER_1,		//
	BF_NOTEX_CENTER_2,		//
	BF_NOTEX_LEFTUP,		//
	BF_NOTEX_LCENTER,		//^
	BF_NOTEX_CENTER_3,		//^񒆂
	BF_NOTEX_UCENTER,		//^񒆉
	BF_NOTEX_LEFTUNDER,		//
	BF_NOTEX_DCENTER_0,		//^񒆂
	BF_NOTEX_DCENTER_1,		//
	BF_NOTEX_UNDER_R,
	
	BF_NOTEX_MAX,
};

//		ZNgtHgZbg		
enum{
	SET_ALPHA_DOWN=0,
	SET_ALPHA_ADD,
	SET_ALPHA_ZERO,
	SET_ALPHA_FULL,
};

//		}XN		
enum{
	MASK_CHARA_A=0,
	MASK_CHARA_B,
	MASK_MEMO,
	MASK_ITEM,
	MASK_BLOOD_A,
	MASK_BLOOD_B,
	MASK_MAX,
};

//		L[		
enum{
	RING_KEY_NONE=0,
	RING_KEY_RIGHT,
	RING_KEY_LEFT,
};

//		Ȍꏊ		
enum{
	RING_STATE_NOW=0,			//	IĂ
	RING_STATE_NOW_F,		//	IĂ̂ЂƂOy
	RING_STATE_NOW_B,		//	EEIN
};

//		eNX`[Ȃ悤̍\		
typedef struct{
	VEC2	XY;
	VEC2	SIZE;
}NOTEX_PARAM;


//		4\		
typedef struct{
	VEC2	v0,v1,v2,v3;
}VEC2_FOUR;

//		tu		
typedef struct{
	s8 No;
	f32 u0,u1,v0,v1;
}UV_STATE;

typedef struct{
	VEC2	XY;
	f32 u0,v0,u1,v1;
}LIGHT_STATE;

//		eۗp		
typedef struct{
	VEC2		XY;
	VEC2		Size;
	u16			Angle;
}BULLET_STATE;


//		Ov[g		
typedef struct{
	SK7Sprite	Back;
	SK7Sprite	LineH;
	SK7Sprite	LineW;
	SK7Sprite	Triangle;
	SK7Sprite	Mini;
	int			MoveTime;
	int			EndTime;
	u32			NameColor;
	bool		NameVisible;
}NamePlate;

//		SIuWFNg		
typedef struct{
	SK7Sprite			sprite;						//	SIuWFNg
	int 				PanelStartTime;
	int					PanelTime;
	f32					PanelSize;
	bool				MoveFlag;
	VEC2				vS0, vS1, vS2, vS3;
	int					MoveTime;
	f32					Angle;
	f32					Ex;
}PANEL_STATE;


//				

typedef struct{
	SK7Sprite		Chara[3];
	SK7Sprite		Item[SELECT_FONT_MAX];
	SK7Sprite		Memo[2];
	SK7Sprite		Blood[2];
	VEC2			vSpeed[SELECT_FONT_MAX];
	int				EndTime[SELECT_FONT_MAX];
	int				AddTime[SELECT_FONT_MAX];
	bool			MoveFlag;
}BLOCKSELECT;

//		tHg		
typedef struct{
	SK7Sprite		Font[SELECT_FONT_MAX];
	VEC2			vSpeed[SELECT_FONT_MAX];
	int				EndTime[SELECT_FONT_MAX];
	int				AddTime[SELECT_FONT_MAX];
}SHADOWFONT;

//		r[J[		
typedef struct{
	SK7Sprite	Body;
	SK7Sprite	Bottom;
	SK7Sprite	Memori;
	SK7Sprite	Top;
	SK7Sprite	Blood;
	SK7Sprite	Under;
	SK7Sprite	Pipe[2];
}BEAKER;

//		ZNg̘g		
typedef struct{
	u8			RenderNo;
	f32			Ex[SELECT_WAKU_NUM];
}SELECTA_ANIM;


//		OACR		
typedef struct{
	Vec				v, pv;						// W
	int				w, h;						// E
	u8				TexNo;
	u32				Color;
}_RING_ICON;


//		OACR		
typedef struct{
	_RING_ICON		View[RING_CHANGE_NUM];	//	screenp
	_RING_ICON		Obj[RING_CHANGE_NUM];	//	ACR
	_RING_ICON		SaveIcon;				//	Z[up
	int				iIconNum;				//	ACR
	int				KasanTime;				//	OZ^C
	int				LightTime;				//	qJ̃^C
	f32				fAngle;					//	px
	f32				fOneAngle;				//	̉]px
	f32				KasanAngle;				//	Z̃AO
	bool			bRender;				//	`tO
	bool			bKasanFlag;				//	ZtO
	bool			bLightFlag;				//	qJtO
	bool			bNotFlag;				//	wւĂ邩ǂ
	s8				SelectNo;				//	񂽂m
	u8				HasNo[RING_CHANGE_NUM];	//	Ԕԍ
	s8				SaveNo;					//	ZNgĂm
	SK7Sprite		Stone[RING_CHANGE_NUM]; //	Ղ炢
	SK7Sprite		Kasan;					//	Zp
	SK7Sprite		Kasan2;					//	ZQ
	SK7Sprite		Sample;					//	Tv
	SK7Sprite		Mini[RING_CHANGE_NUM];	//	O~j
}RING_ICON;

//		t\		
typedef struct{
	SK7Sprite		Blood;
	VEC2			Speed;
	int				Time;
	f32				Size;
	f32				SaveSize;
}LIFE_BLOOD;

//		ʐ^\		
typedef struct{
	SK7Sprite		Small;
	SK7Sprite		Big;
	f32				Angle;
	VEC2			vCenter;
	int				Time;
	bool			bMoveFlag;
}PHOTO_DATA;

//		Key		
typedef struct{
	int		PushTime;					//	L[vbV^C
	int		Power;
}KEYSTATE;

//		ǂł͂Ȃ		
typedef struct{
	SK7Sprite		spFont;
	SK7Sprite		spPlate;
	int 			Time;
	bool			SelectFlag;
}SORE;

//	L[	:::::::::::::::::::::::::::::::::::::::::::::::
const u8 tblPushKeyTime[]={ 3,3,3, };

//	wit[eNX`[W
const NOTEX_PARAM tblBFNoTexData[]=
{
	0.0f,0.0f, 		640.0f,12.0f,//
	0.0f,444.0f,	540.0f,36.0f,//
	0.0f,0.0f,		10.0f,480.0f,//
	10.0f,235.0f,	382.0f,10.0f,//^񒆍
	392.0f,262.0f,	76.0f,7.0f,  //
	468.0f,268.0f,	69.0f,3.0f,  //
	10.0f,12.0f,	274.0f,22.0f,//
	10.0f,98.0f,	5.0f,24.0f,  //^
	383.0f,132.0f,	8.0f,120.0f, //^񒆂
	226.0f,428.0f,	120.0f,8.0f,  //^񒆉
	10.0f,436.0f,	347.0f,9.0f, //̂
	320.0f,216.0f,	4.0f,60.0f,
	321.0f,280.0f,	4.0f,160.0f,
	328.0f,280.0f,	4.0f,160.0f,
};



const TEX_PARAM tblBgFrameData[]={
	283.0f,12.0f,	TEX_UP_001,		//̕
	346.0f,12.0f,   TEX_UP_002,		//
	422.0f,12.0f,   TEX_UP_002,		//
	503.0f,12.0f,   TEX_UP_002,		//
	10.0f,34.0f,    TEX_SIDE_001,	//nWォ
	0.0f,122.0f,   	TEX_SIDE_002,	//
	0.0f,176.0f,   	TEX_SIDE_003,	//
	10.0f,260.0f,   TEX_SIDE_004,	//
	10.0f,308.0f,   TEX_SIDE_005,	//
	138.0f,428.0f,  TEX_BOTTOM_001,	//
	310.0f,300.0f,  TEX_BOTTOM_002,	//
	295.0f,429.0f,  TEX_UP_002,		//
	383.0f,128.0f,	TEX_UP_003,		//͂
	416.0f,129.0f,  TEX_UP_003,		//
	20.0f,31.0f,	TEX_KAZARI_003,	//̏
	107.0f,31.0f,   TEX_KAZARI_001,	//̏
	235.0f,31.0f,   TEX_KAZARI_002,	//̏
	129.0f,230.0f,	TEX_KAZARI_001,	//̏
	257.0f,230.0f,	TEX_KAZARI_002,	//
	129.0f,244.0f,	TEX_KAZARI_003,	//
	257.0f,244.0f,	TEX_KAZARI_004,	//
	41.0f,274.0f,	TEX_SIDE_006,	//ƂƂ
	152.0f,392.0f,	TEX_SIDE_006,	//
};


static UV_STATE tblUVState[]={
	BF_TEX_DOWN2,		0.0f, 1.0f, 1.0f, 0.0f,
	BF_TEX_UP_KAZARI1, 	0.0f, 1.0f, 1.0f, 0.0f,		//	̏P
	BF_TEX_UP_KAZARI2, 	0.0f, 1.0f, 1.0f, 0.0f, 		//	̏Q
	-1,NULL,NULL,NULL,NULL,
};

const BULLET_STATE tblBulletState[]={
	//XY		SIZE,	ANGLE
	25,277, 	32,64, 	0,
	57,315, 	26,52,	14,
	15,325,		32,64, 	322,
	78,296,		26,52,	0,
	20,380,		26,52,	16,
	60,356,		32,64,	4,
	70,260,		22,44,	45,
};

//	}XN̍W
const NOTEX_PARAM tblMaskParam[]={
	0,0,		384,239,		//LN^[P
	384,0,		157,130,		//LN^[Q
	384,130,	157,140,		//͂
	0,239,		332,226,		//ACe
	332,268,	208,226,		//tP
	540,0,		100,480,		//tQ
};

//	Cg̃f[^
const LIGHT_STATE tblLightData[]={
	202,58,		0.0f,0.0f,1.0f,1.0f,
	153,241,	0.0f,1.0f,1.0f,0.0f,
	386,89,		1.0f,0.0f,0.0f,1.0f,
	333,267,	1.0f,1.0f,0.0f,0.0f,
};

//	plf[^
const VEC2_FOUR	tblPanelData[]={
	287.4496f,	212.0001f,	436.8123f,	212.0001f,	282.7372f,	296.4375f,	431.4876f,	295.1625f,//ACe
	317.6000f,	181.9875f,	403.1002f,	181.7751f,	314.5372f,	332.0375f,	410.9628f,	330.0250f,//li
	320.2496f,	192.4249f,	401.3253f,	192.4249f,	313.0373f,	319.8499f,	403.6500f,	320.0500f,//
	285.2377f,	209.8749f,	435.6122f,	207.2501f,	287.6747f,	295.3377f,	434.8627f,	295.3377f,//
	
	261.5f,234.5f,	350.0f,160.0f,	335.0f,322.5f,	423.5f,248.6f,	//
	261.5f,234.5f,	350.0f,160.0f,	335.0f,322.5f,	423.5f,248.6f,	//LZ
};

//	X~
enum{
	FONT_SMITHS=0,		//Smiths
	FONT_M_JIN,			//l
	FONT_M_KAKU,		//i
	FONT_E_JIN,			//l
	FONT_E_KAKU,        //i
	FONT_KOUTAI,        //
	
	FONT_ITEM,			//Item
	FONT_M_A,			//A
	FONT_M_I,           //C
	FONT_M_TE,          //e
	FONT_M_MU,          //
	FONT_E_A,           //A
	FONT_E_I,           //C
	FONT_E_TE,          //e
	FONT_E_MU,          //
	
	FONT_MEMO,			//memo
	FONT_ME,            //
	FONT_MO,            //
	FONT_HATO,          //͂
	
	FONT_BLOOD,			//Blood
	FONT_KETU,			//
	FONT_SEI,			//
	FONT_KAIFUKU,       //
};


//			tHgf[^		
const VEC2 tblSelectFont[]=
{
	315.0f,195.0f,//Smiths
	319.0f,185.0f,//l
	362.0f,185.0f,//i
	308.0f,195.0f,//l
	346.0f,195.0f,//i
	386.0f,195.0f,//
	
	230.0f,245.0f,//Item
	189.0f,250.0f,//A
	223.0f,250.0f,//C
	257.0f,250.0f,//e
	291.0f,250.0f,//
	201.0f,237.0f,//A
	232.0f,237.0f,//C
	265.0f,237.0f,//e
	297.0f,237.0f,//
	
	402.0f,243.0f,//memo
	399.0f,227.0f,//
	437.0f,227.0f,//
	388.0f,227.0f,//͂

	315.0f,290.0f,//Blood
	315.0f,261.0f,//
	358.0f,261.0f,//
	284.0f,245.0f,//
};

//			tpCv		
const VEC2 tblPipePos[]={
	414,459, 
	414,475,
};

//			ACeԍ		
enum{
	ITEM_SELECT_RING=0,
	ITEM_SELECT_PHOTO,
	ITEM_SELECT_ULCL,
	ITEM_SELECT_CHART,
	ITEM_SELECT_VOICE,
};

typedef struct{
	s8 No[ITEM_SELECT_MAX];
}ITEM_SELECTNO;

const ITEM_SELECTNO tblItemSelectNo[]={
	ITEM_SELECT_RING, ITEM_SELECT_PHOTO, -1,//	ZeBbN
	ITEM_SELECT_RING, ITEM_SELECT_PHOTO, -1,//	tNV}
	ITEM_SELECT_RING, ITEM_SELECT_PHOTO, -1,//	JNr
	ITEM_SELECT_RING, ITEM_SELECT_PHOTO, ITEM_SELECT_ULCL,        //	eLTX
	ITEM_SELECT_RING, ITEM_SELECT_PHOTO, -1,//	Vn
	ITEM_SELECT_RING, ITEM_SELECT_PHOTO, -1,//	J[eBX
	ITEM_SELECT_RING, ITEM_SELECT_PHOTO, ITEM_SELECT_CHART,//	h~jJ1
	ITEM_SELECT_RING, ITEM_SELECT_PHOTO, ITEM_SELECT_CHART,//	h~jJ2
	ITEM_SELECT_RING, -1, -1,	        //	ze1
	ITEM_SELECT_RING, ITEM_SELECT_VOICE, ITEM_SELECT_PHOTO,	        //	wZ
	ITEM_SELECT_RING, -1, -1,	        //	ze2
	ITEM_SELECT_RING, -1, -1,	        //	
};


//			Ig̃|WV		
typedef struct{
	VEC2	vL;
	VEC2	vR;
	u16 	TexNo;
}SELECT_STATE;

const SELECT_STATE tblSelectWaku[]={
	104.0f,25.0f,	86.0f,25.0f,	TEX_SELECT_1,
	99.0f,79.0f,	87.0f,79.0f,	TEX_SELECT_2,
	118.0f,146.0f,	18.0f,146.0f,	TEX_SELECT_2b,
	124.0f,146.0f,	16.0f,146.0f,	TEX_SELECT_3,
	187.0f,87.0f,	0,87.0f,		TEX_SELECT_2b,
	158.0f,62.0f,	0,62.0f,		TEX_SELECT_4,
	67.0f,64.0f,	11.0f,64.0f,	TEX_SELECT_5,
	0,66.0f,		98.0f,66.0f,	TEX_SELECT_6,
};

//			ACeI̍W		
const VEC2	tblSelectItemPos[]={
	102.5502f,		223.6250f,			//	O
	107.275267f,	268.3135f,			//	ʐ^
	35.0f,			220.1260f,			//	ER
	35.0f,			220.1260f,			//	J[`[g
	100.0f,			185.0f,				//	{CXR[_
};


//			Ig̃Aj[V		
const SELECTA_ANIM tblSelectAnim[]={
	//RenderNo  	1	 	2		3		4		5	  	6		7		8
	1,				1.0f, 	0.0f,	0.0f,	0.0f,	0.0f,	0.0f,	0.0f,	0.0f,
	3,				1.2f, 	1.0f,	1.0f,	0.0f,	0.0f,	0.0f,	0.0f,	0.0f,
	5,				0.95f,	1.2f,	1.2f,	1.0f,	1.0f,	0.0f,	0.0f,	0.0f,
	6,				1.2f, 	0.95f,	0.95f,	1.2f,	1.2f,	1.0f,	0.0f,	0.0f,
	7,				0.9f,	1.2f,	1.2f,	0.95f,	0.95f,	1.2f,	0.95f,	0.0f,
	SELECT_WAKU_NUM,1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,
};

//			ACel[ZNg		
const 	VEC2 tblItemNamePos[]={
	140.4375f, 269.0f, 
	214.75f,  314.3125f, 
	138.375f, 266.375f,
	138.375f, 266.375f,
	210.0f,  260.0f, 
};

//			ACeIg		
const	f32		tblWakuUpSize[]={
	108.0f,	//	O
	150.0f,	//	ʐ^
	108.0f,	//	ER
	108.0f,	//	J[`[g
	20.0f,	//	
};

//			wփf[^		
static char* tblRingName[]={ "Heat Ring", "Water Ring", "Past Ring", "Wind Ring", "Stamina Ring", "Attack Ring", "Look Ring", " ", };//equipment", };
const int tblRingData[]={ K7GLFL_RING_FIRE, K7GLFL_RING_WATER, K7GLFL_RING_PAST, K7GLFL_RING_WIND, K7GLFL_RING_HPUP, K7GLFL_RING_ATTACK, -1 };


//			`		
#define		ITEM_NUM_MAX		(2)

typedef struct{
	u32 No[ITEM_NUM_MAX];
}STAGE_KEY_OBJNO;
	
const STAGE_KEY_OBJNO tblStageObj[]={
	0x007307, 	0x007308,	//	ZeBbN
	0x010000, 	NULL,		//	tNV}
	0x011601, 	NULL,		//	JNr
	0x020101, 	NULL,		//	eLTX
	0x030315, 	NULL,		//	Vn
	0x035107,	0x035013,	//	J[eBX
	0x040401,	NULL,		//	h~jJ1
	NULL,		NULL,		//	h~jJ2
	NULL,		NULL,		//	ze1
	0x055700, 	NULL,		//	wZ
	NULL,		NULL,		//	ze2
	NULL,		NULL,		//	
};

//			ʐ^`		
const bool tblPhotoMini[]={
	true,	//	ZeBbN
	true,	//	tNV}
	true,	//	JNr
	true,	//	eLTX
	true,	//	Vn
	true,	//	J[eBX
	true,	//	h~jJ1
	true,	//	h~jJ2
	false,	//	ze1
	true,	//	wZ
	false,	//	ze2
	false,	//	
};

//			e		
typedef struct{
	u32 No[SP_BULLET_NUM];
}BULLET_NO;

const BULLET_NO tblBulletNo[]={
	0x007101,	0x007401,	NULL,		NULL,		NULL,		NULL,		NULL,		//	ZeBbN
	0x010000,	NULL,		NULL,		NULL,		NULL,		NULL,		NULL,       //	tNV}
	0x011301,	0x011401,	0x011501,	0x011601,	NULL,		NULL,		NULL,       //	JNr
	NULL,		NULL,		NULL,		NULL,		NULL,		NULL,		NULL,       //	eLTX
	0x030401,	0x030709,	0x030501,	NULL,		NULL,		NULL,     	NULL,		//	Vn
	0x035001,	0x035002,	0x035003,	NULL,		NULL,		NULL,		NULL,       //	J[eBX
	NULL,		NULL,		NULL,		NULL,		NULL,		NULL,		NULL,       //	h~jJ1
	NULL,		NULL,		NULL,		NULL,		NULL,		NULL,		NULL,       //	h~jJ2
	0x051101,	0x051201,	0x051301,	0x051401,	0x051501,	0x051601,	0x051701,   //	ze1
	0x055100,	NULL,		NULL,		NULL,		NULL,		NULL,		NULL,       //	wZ
	NULL,		NULL,		NULL,		NULL,		NULL,		NULL,		NULL,       //	ze2
	NULL,		NULL,		NULL,		NULL,		NULL,		NULL,		NULL,       //	
};

#endif	//__SK7SPECIALDATA_H__