////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Scn00
//
// K7Scn00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/08/2003
//
////////////////////////////////////////////////////////////////////////////////

#include "..\Wat\WK7Player.h"
#include "..\Wat\WK7Npc.h"
#include "..\Wat\WK7Play.h"
#include "..\Wat\WK7GameInfo.h"
#include "..\Wat\WK7MainTask.h"
#include "..\Wat\K7GlobalFlag.h"
#include "..\Matsu\MK7Noise.h"
#include "..\Wat\WK7Event.h"

K7EV_SCN_VAR_START(K7SCN00)
K7EV_SCN_VAR_END(K7SCN00)

K7EV_SCN_FLAG_START(K7SCN00)
K7EV_SCN_FLAG_END(K7SCN00)

K7EV_SCN_IDTABLE_START(K7SCN00)
K7EV_SCN_IDTABLE_END(K7SCN00)

K7EV_SCN_ITEMTABLE_START(K7SCN00)
K7EV_SCN_ITEMTABLE_END(K7SCN00)

//K7EV_SCN_HITOBJTABLE_START(K7SCN00)
//K7EV_SCN_HITOBJTABLE_END(K7SCN00)

// Cxgnh錾iCxghc`nhƂ̊֘Atj
K7EV_SCN_HANDLER_DECL_START(K7SCN00)
	
	K7EV_HANDLER_DECL(K7SCN00_EV_INIT               ,K7SCN00_Init                   ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_TERM               ,K7SCN00_Term                   ,NULL)
	
#if 0
	K7EV_HANDLER_DECL(K7SCN00_EV_OPENING            ,K7SCN00_Opening                ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL             ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL2            ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL3            ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL4            ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL5            ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL6            ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL7            ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL8            ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL9            ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL10           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL11           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL12           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL13           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL14           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL15           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL16           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL17           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL18           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL19           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL20           ,K7SCN00_CancelS                ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL21           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL22           ,K7SCN00_CancelS                ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL23           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL24           ,K7SCN00_CancelS                ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL25           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL26           ,K7SCN00_CancelS                ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL27           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL28           ,K7SCN00_CancelS                ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL29           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL30           ,K7SCN00_CancelS                ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL31           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL32           ,K7SCN00_CancelS                ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL33           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL34           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL35           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL36           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL37           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL38           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL39           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL40           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL41           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL42           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL43           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL44           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL45           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL46           ,K7SCN00_Cancel                 ,NULL)
//	K7EV_HANDLER_DECL(K7SCN00_EV_CANCEL47           ,K7SCN00_Cancel                 ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M01_DOOR53  ,K7SCN00_CancelS                ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M01_DOOR51  ,K7SCN00_CancelS                ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M01_DOOR54  ,K7SCN00_CancelS                ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M01_DOOR55  ,K7SCN00_CancelS                ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M01_DOOR56  ,K7SCN00_CancelS                ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M01_DOOR58  ,K7SCN00_CancelS                ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M01_DOOR    ,K7SCN00_CancelS                ,NULL)
	
	K7EV_HANDLER_DECL(K7SCN00_EV_STG000_M00_INIT    ,K7SCN00_Stg000M00Init          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG000_M00_TERM    ,K7SCN00_Stg000M00Term          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG000_M00_CURRENT ,K7SCN00_Stg000M00Current       ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG000_M00_ELEVATOR,K7SCN00_SelectStg000M00Elevetor,NULL)
	K7EV_HANDLER_DECL_COND(K7SCN00_EV_HSAPPEAR           ,K7SCN00_HSAppear               ,NULL,K7EV_COND_NOTRUN)
	K7EV_HANDLER_DECL_COND(K7SCN00_EV_MSEXPLODE          ,K7SCN00_MSExplode              ,NULL,K7EV_COND_NOTRUN)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG000_M00_TV      ,K7SCN00_SelectStg000M00TV      ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG000_M00_TV1     ,K7SCN00_SelectStg000M00TV1     ,NULL)
	
	K7EV_HANDLER_DECL(K7SCN00_EV_STG002_M00_INIT    ,K7SCN00_Stg002M00Init          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG002_M00_TERM    ,K7SCN00_Stg002M00Term          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG002_M00_CURRENT ,K7SCN00_Stg002M00Current       ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG002_M00_ELEVATOR,K7SCN00_SelectStg002M00Elevetor,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG002_M00_TO003B  ,K7SCN00_SelectStg002M00_TO003B ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG002_M00_TO003C  ,K7SCN00_SelectStg002M00_TO003C ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_EXTNO_000200       ,K7SCN00_EXTNO_000200           ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_EXTNO_000201       ,K7SCN00_EXTNO_000201           ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_EXTNO_000203       ,K7SCN00_EXTNO_000203           ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG002_M00_TV1     ,K7SCN00_SelectStg002M00TV1     ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG002_M00_TV2     ,K7SCN00_SelectStg002M00TV2     ,NULL)
	
	K7EV_HANDLER_DECL(K7SCN00_EV_STG003_M00_INIT    ,K7SCN00_Stg003M00Init          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG003_M00_TERM    ,K7SCN00_Stg003M00Term          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG003_M00_CURRENT ,K7SCN00_Stg003M00Current       ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG003_M00_TV      ,K7SCN00_SelectStg003M00TV      ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG003_M00_TV2     ,K7SCN00_SelectStg003M00TV2     ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG003_M00_TO002A  ,K7SCN00_SelectStg003M00_TO002A ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG003_M00_TO002B  ,K7SCN00_SelectStg003M00_TO002B ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG003_M00_TO004A  ,K7SCN00_SelectStg003M00_TO004A ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG003_M00_TO004B  ,K7SCN00_SelectStg003M00_TO004B ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG003_M00_TO006A  ,K7SCN00_SelectStg003M00_TO006A ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG003_M00_TO006B  ,K7SCN00_SelectStg003M00_TO006B ,NULL)
	
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M00_INIT    ,K7SCN00_Stg004M00Init          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M00_TERM    ,K7SCN00_Stg004M00Term          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M00_CURRENT ,K7SCN00_Stg004M00Current       ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M00_00030101,K7SCN00_Stg004M00_00030101     ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M00_00030103,K7SCN00_Stg004M00_00030103     ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M00_00030104,K7SCN00_Stg004M00_00030104     ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M00_00030105,K7SCN00_Stg004M00_00030105     ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M00_00030106,K7SCN00_Stg004M00_00030106     ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M00_00030107,K7SCN00_Stg004M00_00030107     ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M00_00030108,K7SCN00_Stg004M00_00030108     ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M00_TO003A  ,K7SCN00_Stg004M00_TO003A       ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M00_TO003B  ,K7SCN00_Stg004M00_TO003B       ,NULL)
	
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M01_INIT    ,K7SCN00_Stg004M01Init          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M01_TERM    ,K7SCN00_Stg004M01Term          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M01_CURRENT ,K7SCN00_Stg004M01Current       ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M01_TO003A  ,K7SCN00_Stg004M01_TO003A       ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG004_M01_TO003B  ,K7SCN00_Stg004M01_TO003B       ,NULL)
	
	K7EV_HANDLER_DECL(K7SCN00_EV_STG006_M00_INIT    ,K7SCN00_Stg006M00Init          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG006_M00_TERM    ,K7SCN00_Stg006M00Term          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG006_M00_CURRENT ,K7SCN00_Stg006M00Current       ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG006_M00_TO003A  ,K7SCN00_SelectStg006M00_TO003A ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG006_M00_TO003B  ,K7SCN00_SelectStg006M00_TO003B ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG006_M00_TO007A  ,K7SCN00_SelectStg006M00_TO007A ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG006_M00_TO007B  ,K7SCN00_SelectStg006M00_TO007B ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG006_M00_TV1     ,K7SCN00_SelectStg006M00TV1     ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG006_M00_TV2     ,K7SCN00_SelectStg006M00TV2     ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG006_M00_KEY     ,K7SCN00_SelectStg006M00KEY     ,NULL)
	
	K7EV_HANDLER_DECL(K7SCN00_EV_STG007_M00_INIT    ,K7SCN00_Stg007M00Init          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG007_M00_TERM    ,K7SCN00_Stg007M00Term          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG007_M00_CURRENT ,K7SCN00_Stg007M00Current       ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG007_M00_TO006A  ,K7SCN00_SelectStg007M00_TO006A ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG007_M00_TO006B  ,K7SCN00_SelectStg007M00_TO006B ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG007_M00_TO008   ,K7SCN00_SelectStg007M00_TO008  ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG007_M00_TO009   ,K7SCN00_SelectStg007M00_TO009  ,NULL)
	
	K7EV_HANDLER_DECL(K7SCN00_EV_STG008_M00_INIT    ,K7SCN00_Stg008M00Init          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG008_M00_TERM    ,K7SCN00_Stg008M00Term          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG008_M00_CURRENT ,K7SCN00_Stg008M00Current       ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG008_M00_TO007   ,K7SCN00_SelectStg008M00_TO007  ,NULL)
	
	K7EV_HANDLER_DECL(K7SCN00_EV_STG009_M00_INIT    ,K7SCN00_Stg009M00Init          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG009_M00_TERM    ,K7SCN00_Stg009M00Term          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG009_M00_CURRENT ,K7SCN00_Stg009M00Current       ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG009_M00_PLAY    ,K7SCN00_Stg009M00Play          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG009_M00_TO007   ,K7SCN00_Stg009M00_TO007        ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG009_M00_TV1     ,K7SCN00_SelectStg009M00TV1     ,NULL)
	
	K7EV_HANDLER_DECL(K7SCN00_EV_STG010_M00_INIT    ,K7SCN00_Stg010M00Init          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG010_M00_TERM    ,K7SCN00_Stg010M00Term          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG010_M00_CURRENT ,K7SCN00_Stg010M00Current       ,NULL)
	K7EV_HANDLER_DECL_COND(K7SCN00_EV_STG010_M00_PLAY,K7SCN00_Stg010M00Play          ,NULL,K7EV_COND_NOTRUN)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG010_M00_TO009   ,K7SCN00_SelectStg010M00_TO009  ,NULL)
	
	K7EV_HANDLER_DECL(K7SCN00_EV_STG011_M00_INIT    ,K7SCN00_Stg011M00Init          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG011_M00_TERM    ,K7SCN00_Stg011M00Term          ,NULL)
	K7EV_HANDLER_DECL(K7SCN00_EV_STG011_M00_CURRENT ,K7SCN00_Stg011M00Current       ,NULL)
	K7EV_HANDLER_DECL_COND(K7SCN00_EV_STG011_M00_PLAY,K7SCN00_Stg011M00Play          ,NULL,K7EV_COND_NOTRUN)
#endif
	
K7EV_SCN_HANDLER_DECL_END(K7SCN00)

// CxgfXNv^iCxg`j
K7EV_SCN_DESC_START(K7SCN00)
	
	K7EV_DESC_SCNINIT              (K7SCN00_EV_INIT)
	K7EV_DESC_SCNTERM              (K7SCN00_EV_TERM)
	
#if 0
	K7EV_DESC_STGINIT              (K7SCN00_EV_STG000_M00_INIT    ,K7STGID(0,0))
	K7EV_DESC_STGTERM              (K7SCN00_EV_STG000_M00_TERM    ,K7STGID(0,0))
	K7EV_DESC_STGSETCURRENT        (K7SCN00_EV_STG000_M00_CURRENT ,K7STGID(0,0))
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG000_M00_ELEVATOR,K7STGID(0,0),"jumpA_002_M00","Elevator","Elevator","to Large Hall")
	K7EV_DESC_STGBPARRIVE          (K7SCN00_EV_HSAPPEAR           ,K7STGID(0,0),"play_00020102")
	K7EV_DESC_STGBPARRIVE          (K7SCN00_EV_MSEXPLODE          ,K7STGID(0,0),"play_00020102a")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG000_M00_TV      ,K7STGID(0,0),"set7" ,"TV" ,"TV","Rest Room")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG000_M00_TV1     ,K7STGID(0,0),"set12","TV1","TV","Rest Room")
	
	K7EV_DESC_STGINIT              (K7SCN00_EV_STG002_M00_INIT    ,K7STGID(2,0))
	K7EV_DESC_STGTERM              (K7SCN00_EV_STG002_M00_TERM    ,K7STGID(2,0))
	K7EV_DESC_STGSETCURRENT        (K7SCN00_EV_STG002_M00_CURRENT ,K7STGID(2,0))
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG002_M00_ELEVATOR,K7STGID(2,0),"jumpA_000_M00","Elevator1","Elevator","to Parking")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG002_M00_TO003B  ,K7STGID(2,0),"jumpB_003_M00","jump1","Card Reader","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG002_M00_TO003C  ,K7STGID(2,0),"jumpC_003_M00","jump2","Card Reader","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG002_M00_TV1     ,K7STGID(2,0),"set_TV1","TV1","TV","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG002_M00_TV2     ,K7STGID(2,0),"set_NPC1","TV2","TV","Large Hall")
	K7EV_DESC_STGBPEXTRACONTACT    (K7SCN00_EV_EXTNO_000200       ,"set_NPC1"  ,EXTNO_0_002_00,"Extra A","male")
	K7EV_DESC_STGBPEXTRACONTACT    (K7SCN00_EV_EXTNO_000201       ,"set1_NPC_2",EXTNO_0_002_01,"Extra B","male")
	K7EV_DESC_STGBPEXTRACONTACT    (K7SCN00_EV_EXTNO_000203       ,"set_NPC3"  ,EXTNO_0_002_03,"Extra D","male")
	
	K7EV_DESC_STGINIT              (K7SCN00_EV_STG003_M00_INIT    ,K7STGID(3,0))
	K7EV_DESC_STGTERM              (K7SCN00_EV_STG003_M00_TERM    ,K7STGID(3,0))
	K7EV_DESC_STGSETCURRENT        (K7SCN00_EV_STG003_M00_CURRENT ,K7STGID(3,0))
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG003_M00_TV      ,K7STGID(3,0),"set_TV1","TV","TV","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG003_M00_TV2     ,K7STGID(3,0),"set_TV2","TV2","TV","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG003_M00_TO002A  ,K7STGID(3,0),"jumpB_002_M00","jump4","Downstairs","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG003_M00_TO002B  ,K7STGID(3,0),"jumpC_002_M00","jump3","Downstairs","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG003_M00_TO004A  ,K7STGID(3,0),"jumpF_004_M00","door1","Counselor Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG003_M00_TO004B  ,K7STGID(3,0),"jumpG_004_M00","door","Counselor Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG003_M00_TO006A  ,K7STGID(3,0),"jumpD_006_M00","jump1","Upstairs","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG003_M00_TO006B  ,K7STGID(3,0),"jumpE_006_M00","jump2","Upstairs","Large Hall")
	
	K7EV_DESC_STGINIT              (K7SCN00_EV_STG004_M00_INIT    ,K7STGID(4,0))
	K7EV_DESC_STGTERM              (K7SCN00_EV_STG004_M00_TERM    ,K7STGID(4,0))
	K7EV_DESC_STGSETCURRENT        (K7SCN00_EV_STG004_M00_CURRENT ,K7STGID(4,0))
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M00_00030101,K7STGID(4,0),"play_00030101","Door53","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M00_00030103,K7STGID(4,0),"play_00030103","Door51","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M00_00030104,K7STGID(4,0),"play_00030104","Door54","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M00_00030105,K7STGID(4,0),"play_00030105","Door55","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M00_00030106,K7STGID(4,0),"play_00030106","Door56","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M00_00030107,K7STGID(4,0),"play_00030107","Door58","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M00_00030108,K7STGID(4,0),"play_00030108","Door","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M00_TO003A  ,K7STGID(4,0),"jumpF_003_M00","Door57","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M00_TO003B  ,K7STGID(4,0),"jumpG_003_M00","Door52","Counseling Room","Large Hall")
	
	K7EV_DESC_STGINIT              (K7SCN00_EV_STG004_M01_INIT    ,K7STGID(4,1))
	K7EV_DESC_STGTERM              (K7SCN00_EV_STG004_M01_TERM    ,K7STGID(4,1))
	K7EV_DESC_STGSETCURRENT        (K7SCN00_EV_STG004_M01_CURRENT ,K7STGID(4,1))
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M01_DOOR53  ,K7STGID(4,1),"play_00030101","Door53","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M01_DOOR51  ,K7STGID(4,1),"play_00030103","Door51","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M01_DOOR54  ,K7STGID(4,1),"play_00030104","Door54","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M01_DOOR55  ,K7STGID(4,1),"play_00030105","Door55","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M01_DOOR56  ,K7STGID(4,1),"play_00030106","Door56","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M01_DOOR58  ,K7STGID(4,1),"play_00030107","Door58","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M01_DOOR    ,K7STGID(4,1),"play_00030108","Door"  ,"Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M01_TO003A  ,K7STGID(4,1),"jumpF_003_M00","Door57","Counseling Room","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG004_M01_TO003B  ,K7STGID(4,1),"jumpG_003_M00","Door52","Counseling Room","Large Hall")
	
	K7EV_DESC_STGINIT              (K7SCN00_EV_STG006_M00_INIT    ,K7STGID(6,0))
	K7EV_DESC_STGTERM              (K7SCN00_EV_STG006_M00_TERM    ,K7STGID(6,0))
	K7EV_DESC_STGSETCURRENT        (K7SCN00_EV_STG006_M00_CURRENT ,K7STGID(6,0))
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG006_M00_TO003A  ,K7STGID(6,0),"jumpE_003_M00","jump1","Downstairs","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG006_M00_TO003B  ,K7STGID(6,0),"jumpD_003_M00","jump2","Downstairs","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG006_M00_TO007A  ,K7STGID(6,0),"jumpA_007_M00","jump3","Upstairs","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG006_M00_TO007B  ,K7STGID(6,0),"jumpB_007_M00","jump4","Upstairs","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG006_M00_TV1     ,K7STGID(6,0),"set_TV1","TV1","TV","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG006_M00_TV2     ,K7STGID(6,0),"set_TV2","TV2","TV","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG006_M00_KEY     ,K7STGID(6,0),"set_Key","CardReader1","Card Reader","Large Hall")
	
	K7EV_DESC_STGINIT              (K7SCN00_EV_STG007_M00_INIT    ,K7STGID(7,0))
	K7EV_DESC_STGTERM              (K7SCN00_EV_STG007_M00_TERM    ,K7STGID(7,0))
	K7EV_DESC_STGSETCURRENT        (K7SCN00_EV_STG007_M00_CURRENT ,K7STGID(7,0))
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG007_M00_TO006A  ,K7STGID(7,0),"jumpA_006_M00","jump3","Downstairs","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG007_M00_TO006B  ,K7STGID(7,0),"jumpB_006_M00","jump4","Downstairs","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG007_M00_TO008   ,K7STGID(7,0),"jumpD_008_M00","jump5","Roof","Large Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG007_M00_TO009   ,K7STGID(7,0),"jumpC_009_M00","jump1","Elevator","Large Hall")
	
	K7EV_DESC_STGINIT              (K7SCN00_EV_STG008_M00_INIT    ,K7STGID(8,0))
	K7EV_DESC_STGTERM              (K7SCN00_EV_STG008_M00_TERM    ,K7STGID(8,0))
	K7EV_DESC_STGSETCURRENT        (K7SCN00_EV_STG008_M00_CURRENT ,K7STGID(8,0))
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG008_M00_TO007   ,K7STGID(8,0),"jumpD_007_M00","Door1","Door","Roof")
	
	K7EV_DESC_STGINIT              (K7SCN00_EV_STG009_M00_INIT    ,K7STGID(9,0))
	K7EV_DESC_STGTERM              (K7SCN00_EV_STG009_M00_TERM    ,K7STGID(9,0))
	K7EV_DESC_STGSETCURRENT        (K7SCN00_EV_STG009_M00_CURRENT ,K7STGID(9,0))
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG009_M00_PLAY    ,K7STGID(9,0),"jumpA_010_M00","Door","Door","Small Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG009_M00_TO007   ,K7STGID(9,0),"jumpC_007_M00_011_M00","Elevator1","Elevator","Small Hall")
	K7EV_DESC_STGBPSELECTOBJCONTACT(K7SCN00_EV_STG009_M00_TV1     ,K7STGID(9,0),"set_TV1","TV1","TV","Small Hall")
	
	K7EV_DESC_STGINIT              (K7SCN00_EV_STG010_M00_INIT    ,K7STGID(10,0))
	K7EV_DESC_STGTERM              (K7SCN00_EV_STG010_M00_TERM    ,K7STGID(10,0))
	K7EV_DESC_STGSETCURRENT        (K7SCN00_EV_STG010_M00_CURRENT ,K7STGID(10,0))
	K7EV_DESC_STGBPARRIVE          (K7SCN00_EV_STG010_M00_PLAY    ,K7STGID(10,0),"set2")
	K7EV_DESC_STGBPARRIVE          (K7SCN00_EV_STG010_M00_TO009   ,K7STGID(10,0),"jumpA_009_M00")
	
	K7EV_DESC_STGINIT              (K7SCN00_EV_STG011_M00_INIT    ,K7STGID(11,0))
	K7EV_DESC_STGTERM              (K7SCN00_EV_STG011_M00_TERM    ,K7STGID(11,0))
	K7EV_DESC_STGSETCURRENT        (K7SCN00_EV_STG011_M00_CURRENT ,K7STGID(11,0))
	K7EV_DESC_STGBPARRIVE          (K7SCN00_EV_STG011_M00_PLAY    ,K7STGID(11,0),"play_00030601")
#endif
	
K7EV_SCN_DESC_END(K7SCN00)

