////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Scn03
//
// K7Scn03.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 08/24/2003
//
////////////////////////////////////////////////////////////////////////////////

#include "..\Wat\WK7Player.h"
#include "..\Wat\WK7Npc.h"
#include "..\Wat\WK7Play.h"
#include "..\Wat\WK7GameInfo.h"
#include "..\Wat\WK7MainTask.h"
#include "..\Wat\K7GlobalFlag.h"
#include "..\Matsu\MK7Noise.h"
#include "..\Wat\WK7Event.h"

#define	K7SCN03_REVERB_DEF		(35)
#define	K7SCN03_REVERB_BIG		(50)
#define	K7SCN03_REVERB_SML		(20)
#define	K7SCN03_REVERB_NON		(0)

K7EV_SCN_VAR_START(K7SCN03)
	K7EV_VAR(K7SCN03,EVVA_SETGUM ,u8, 0)	// |bvR[plɂ͂߂
	
#ifdef	DEBUG_MATSUZAKI
	K7EV_VAR(K7SCN03,PZCARVA_UL ,u8, 0)		//K[WpYE㍶ E
	K7EV_VAR(K7SCN03,PZCARVA_UC ,u8, 1)		//K[WpYE㒆 E
	K7EV_VAR(K7SCN03,PZCARVA_UR ,u8, 2)		//K[WpYEE ED
	K7EV_VAR(K7SCN03,PZCARVA_ML ,u8, 3)		//K[WpYE E
	K7EV_VAR(K7SCN03,PZCARVA_MC ,u8, 8)		//K[WpYE EȂ
	K7EV_VAR(K7SCN03,PZCARVA_MR ,u8, 4)		//K[WpYEE E
	K7EV_VAR(K7SCN03,PZCARVA_DL ,u8, 5)		//K[WpYE E
	K7EV_VAR(K7SCN03,PZCARVA_DC ,u8, 6)		//K[WpYE E
	K7EV_VAR(K7SCN03,PZCARVA_DR ,u8, 7)		//K[WpYEE E
#else
	K7EV_VAR(K7SCN03,PZCARVA_UL ,u8, 0)		//K[WpYE㍶ E
	K7EV_VAR(K7SCN03,PZCARVA_UC ,u8, 1)		//K[WpYE㒆 E
	K7EV_VAR(K7SCN03,PZCARVA_UR ,u8, 2)		//K[WpYEE ED
	K7EV_VAR(K7SCN03,PZCARVA_ML ,u8, 3)		//K[WpYE E
	K7EV_VAR(K7SCN03,PZCARVA_MC ,u8, 4)		//K[WpYE E
	K7EV_VAR(K7SCN03,PZCARVA_MR ,u8, 5)		//K[WpYEE E
	K7EV_VAR(K7SCN03,PZCARVA_DL ,u8, 8)		//K[WpYE EȂ
	K7EV_VAR(K7SCN03,PZCARVA_DC ,u8, 6)		//K[WpYE E
	K7EV_VAR(K7SCN03,PZCARVA_DR ,u8, 7)		//K[WpYEE E
#endif
K7EV_SCN_VAR_END(K7SCN03)

K7EV_SCN_FLAG_START(K7SCN03)
	// CxgtO
	K7EV_FLAG(K7SCN03_EVFL_030001)		// ŏ̋L`FW
	K7EV_FLAG(K7SCN03_EVFL_JIHANKI_BINGO)	// K̔@
	K7EV_FLAG(K7SCN03_SP_321M00_KED)	// A[P[hAE
	
	// 
	K7EV_FLAG(K7SCN03_EVFL_030302)	// ʂ݃u^
	K7EV_FLAG(K7SCN03_EVFL_030302_1)	// ʂ݃N}
	K7EV_FLAG(K7SCN03_EVFL_030302_2)	// ʂ݃ETM
	K7EV_FLAG(K7SCN03_EVFL_030302_3)	// ʂ݃lR
	K7EV_FLAG(K7SCN03_EVFL_030302_4)	// ʂ݃lRQ
	K7EV_FLAG(K7SCN03_EVFL_030302_5)	// ʂ݃R}h
	K7EV_FLAG(K7SCN03_EVFL_030302_6)	// ʂ݃qcW
	K7EV_FLAG(K7SCN03_EVFL_030302_7)	// ʂ݃EV
	K7EV_FLAG(K7SCN03_EVFL_030302_8)	// ʂ݃T
	K7EV_FLAG(K7SCN03_EVFL_030302_9)	// ʂ݃T
	K7EV_FLAG(K7SCN03_EVFL_030302_10)	// ʂ݃lRP
	K7EV_FLAG(K7SCN03_EVFL_030302_11)	// ʂ݃ETM
	// ܂ŏԕՂł邱
	
	K7EV_FLAG(K7SCN03_EVFL_030302_YUBIWA)	// ߋ̎w֓
	K7EV_FLAG(K7SCN03_EVFL_030304)	// _{[j
	K7EV_FLAG(K7SCN03_EVFL_030314)	// ߑAX[W[bJ[
	K7EV_FLAG(K7SCN03_EVFL_030315)	// svcȑ`
	K7EV_FLAG(K7SCN03_EVFL_030315_USE_PASTRING)	// ߋ̎wւg
//		K7EV_FLAG(K7SCN03_EVFL_030401_0)	// i01ju[J[
//		K7EV_FLAG(K7SCN03_EVFL_030401_1)	// i01ju[J[
//		K7EV_FLAG(K7SCN03_EVFL_030402_0)	// i02ju[J[
//		K7EV_FLAG(K7SCN03_EVFL_030402_1)	// i02ju[J[
//		K7EV_FLAG(K7SCN03_EVFL_030403_0)	// i03ju[J[
//		K7EV_FLAG(K7SCN03_EVFL_030403_1)	// i03ju[J[
//		K7EV_FLAG(K7SCN03_EVFL_030404_0)	// i04ju[J[
//		K7EV_FLAG(K7SCN03_EVFL_030404_1)	// i04ju[J[
	K7EV_FLAG(K7SCN03_EVFL_BOARD_BINGO)	// {[h
//		K7EV_FLAG(K7SCN03_EVFL_BOARD_MISS)	// {[hs
	K7EV_FLAG(K7SCN03_EVFL_030401_KAZEUSE)	// ̎w֎gp
	K7EV_FLAG(K7SCN03_EVFL_030405)	// i01j
	K7EV_FLAG(K7SCN03_EVFL_030406)	// i02j
//	K7EV_FLAG(K7SCN03_EVFL_030407)	// i03j
	K7EV_FLAG(K7SCN03_EVFL_030408)	// i04j
	K7EV_FLAG(K7SCN03_EVFL_030408_HS_DISP)	// i04j HSo
	K7EV_FLAG(K7SCN03_EVFL_030412_SU)	// i03jj
	K7EV_FLAG(K7SCN03_EVFL_030409)	// ꃁCu[J[
	K7EV_FLAG(K7SCN03_EVFL_030410)	// XN[j
	K7EV_FLAG(K7SCN03_EVFL_030528)	// LbĝHi~Xe[nEX
	K7EV_FLAG(K7SCN03_EVFL_030501)	// [vL ǔj
	K7EV_FLAG(K7SCN03_EVFL_030502)	// [bg
	K7EV_FLAG(K7SCN03_EVFL_030503)	// ΂̋̉΂
	K7EV_FLAG(K7SCN03_EVFL_030504)	// S̓I
	K7EV_FLAG(K7SCN03_EVFL_030505)	// rEXEFC
	K7EV_FLAG(K7SCN03_EVFL_NUIGURUMI_START)	// ˂݃Q[Jn
	K7EV_FLAG(K7SCN03_EVFL_030507)	// ˂ݎ
	K7EV_FLAG(K7SCN03_EVFL_030508)	// ˂ݎ
	K7EV_FLAG(K7SCN03_EVFL_030509)	// ˂ݎ
	K7EV_FLAG(K7SCN03_EVFL_030510)	// ˂ݎ
	K7EV_FLAG(K7SCN03_EVFL_030511)	// ˂ݎ
	K7EV_FLAG(K7SCN03_EVFL_030512)	// ˂ݎ
	K7EV_FLAG(K7SCN03_EVFL_030513)	// ˂ݎ
	K7EV_FLAG(K7SCN03_EVFL_030514)	// ˂ݎ
	K7EV_FLAG(K7SCN03_EVFL_030515)	// Ԃꂽ
//	K7EV_FLAG(K7SCN03_EVFL_NUIGURUMI_CLEAR)	// ˂݃Q[NA
	K7EV_FLAG(K7SCN03_EVFL_030521)	// S̓I E
	K7EV_FLAG(K7SCN03_EVFL_030522)	// S̓I ^
	K7EV_FLAG(K7SCN03_EVFL_030523)	// S̓I 
	K7EV_FLAG(K7SCN03_EVFL_030524)	// S̓I O
	K7EV_FLAG(K7SCN03_EVFL_030525)	// S̓I O^
	K7EV_FLAG(K7SCN03_EVFL_030526)	// S̓I OE
	K7EV_FLAG(K7SCN03_EVFL_0305XX_ALL)	// S̓I SNA
	K7EV_FLAG(K7SCN03_EVFL_030652)		// ʘH̕̕
	K7EV_FLAG(K7SCN03_EVFL_030652_INIT)	// ʘH̕̕ǁiŏ̉oj
	K7EV_FLAG(K7SCN03_EVFL_030709_SPCYO)	// AR[e\
	K7EV_FLAG(K7SCN03_EVFL_030901)	// \t@[hI_̖߂
	K7EV_FLAG(K7SCN03_EVFL_031101)	// AJlOoL
	K7EV_FLAG(K7SCN03_BAN_ISZ)		//CVUJhyԁzԃXe[Wʉ߂ł邩
	K7EV_FLAG(K7SCN03_EVFL_APPEAR_ANGEL)	// Vgo
	K7EV_FLAG(K7SCN03_EVFL_GETDANGUN)		// _̏e擾
	K7EV_FLAG(K7SCN03_EVFL_AFTER_ANGEL)		// Vg
	
	
	// hAtO
	K7EV_FLAG(K7SCN03_DRFL_030401)	// ߑEO̔
	K7EV_FLAG(K7SCN03_DRFL_030501)	// [vLւ̔
	K7EV_FLAG(K7SCN03_DRFL_030502)	// ΂̋ւ̔
	K7EV_FLAG(K7SCN03_DRFL_030503)	// rEXEFCւ̔
	K7EV_FLAG(K7SCN03_DRFL_030504)	// ~Xe[nEXo
	K7EV_FLAG(K7SCN03_DRFL_030601)	// ~Xe[nEX
	K7EV_FLAG(K7SCN03_DRFL_030701)	// 2eֈړ̐
	K7EV_FLAG(K7SCN03_DRFL_030702)	// 3eֈړ̐
	K7EV_FLAG(K7SCN03_DRFL_030703)	// ŏKֈړ̐
	K7EV_FLAG(K7SCN03_DRFL_030901)	// ԏւ̔
	K7EV_FLAG(K7SCN03_DRFL_030607_HS_DISP)		// LɃL[ebh̏I_(DOOR_030607)ĂƂBȊÕXe[WĂƂ̓NAB
	K7EV_FLAG(K7SCN03_DRFL_030606_HS_DISP)		// LɃL[ebh̏I_(DOOR_030606)ĂƂBȊÕXe[WĂƂ̓NAB
	K7EV_FLAG(K7SCN03_DRFL_STG327M00_HS_DISP)	// Lɓ
	
	
	//J[eBX@EtOꗗ
	K7EV_FLAG(EV035000CHRINIT)		//J[eBX̉ƁySzLN^ݒ
	K7EV_FLAG(EV035001)				//J[eBX̉ƁyzŃKVA_ɑ
	K7EV_FLAG(EV035003)				//J[eBX̉Ɓyz嗇
	K7EV_FLAG(DR035004)				//J[eBX̉ƁyzK[WJĂ
	K7EV_FLAG(EV035013)				//J[eBX̉Ɓyzra̐
	K7EV_FLAG(EV035013STRANGE)		//J[eBX̉Ɓyzraɂsvcȑ`擾
	K7EV_FLAG(EV035005)				//J[eBX̉ƁyK[WzK[W̃ZT[󂵂
	K7EV_FLAG(EV035006)				//J[eBX̉ƁyK[WzBԂo
	K7EV_FLAG(EV035007GET_ATKRING)	//J[eBX̉ƁyK[WzU̓Abv̎wւ擾
	K7EV_FLAG(EV035008)				//J[eBX̉ƁyzgF̉΂
	K7EV_FLAG(EV035008FIRE)			//J[eBX̉ƁyzgF̉΂_
	K7EV_FLAG(EV035010)				//J[eBX̉ƁyzR[eWv
	K7EV_FLAG(EV035012)				//J[eBX̉ƁyzʘH(355M00)̃ZT[ɐGČx@쓮
	K7EV_FLAG(EV035017)				//J[eBX̉Ɓyz}XNŕǂj󂵂
	K7EV_FLAG(DR035003)				//J[eBX̉Ɓyzv[ւ̔JĂ
	K7EV_FLAG(EV0354TALK_TRAVIS)	//J[eBX̉Ɓyz˓̃gBXƘb
	K7EV_FLAG(DR035102)				//J[eBX̉ƁyʑԁzLԂ̔JĂ
	K7EV_FLAG(DR035103)				//J[eBX̉Ɓyʑԁzv[̔JĂ
	K7EV_FLAG(EV035101)				//J[eBX̉ƁyʑԁzZR1
	K7EV_FLAG(EV035102)				//J[eBX̉ƁyʑԁzZR2
	K7EV_FLAG(EV035104)				//J[eBX̉Ɓyʑ2zZR4
	K7EV_FLAG(EV035106)				//J[eBX̉Ɓyʑ2zLbĝCxg
	K7EV_FLAG(EV035107STRANGE)		//J[eBX̉Ɓyʑ2zLbgł̕svcȑ`擾
	K7EV_FLAG(EV0357CAT_SLIDING)	//J[eBX̉Ɓyʑ2zLbĝCxg
	K7EV_FLAG(EV035103)				//J[eBX̉Ɓyʑ3zZR3
	K7EV_FLAG(EV0358CAT_DIVING)		//J[eBX̉Ɓyʑ3zLbgŃ_XgV[gɔэ
	K7EV_FLAG(EV0358USE_PASTRING)	//J[eBX̉Ɓyʑ3zߋ̎wւg
	K7EV_FLAG(EV036000)				//J[eBX̉ƁyLԁzAJl|
	K7EV_FLAG(EV0361POOL_LIGHT_ON)	//J[eBX̉ƁyLԁzv[̃CgONɂ
	K7EV_FLAG(EV035108_0)			//J[eBX̉Ɓyv[zoupl̊Jo
	K7EV_FLAG(EV035108_1)			//J[eBX̉Ɓyv[zsvcȑ`1͂߂
	K7EV_FLAG(EV035108_2)			//J[eBX̉Ɓyv[zsvcȑ`2͂߂
	K7EV_FLAG(EV035108)				//J[eBX̉Ɓyv[zv[̐𔲂
	K7EV_FLAG(EV035110)				//J[eBX̉Ɓyv[zǂ󂵂
	K7EV_FLAG(DR036200)				//J[eBX̉Ɓyv[zւ̔J
	K7EV_FLAG(EV036201)				//J[eBX̉Ɓyv[z납痈ۂ́u肪v\
	K7EV_FLAG(EV0362CAT_SLIDING)	//J[eBX̉Ɓyv[zLbgʂ
	K7EV_FLAG(EVvsHSCUR)			//J[eBX̉ƁyLnzHSɏ
	K7EV_FLAG(EV0364DAN_EYESCAN)	//J[eBX̉ƁynʘHz_ŖԖF؂ʉ߂
	K7EV_FLAG(K7SCN03_BAN_CUR)		//J[eBX̉ƁyԁzԃXe[Wʉ߂ł邩
	
	K7EV_FLAG(EV03DISP_TITLE_ISZ)	//yViIRzO҃ViI^Cg
	K7EV_FLAG(EV03DISP_TITLE_CUR)	//yViIRz҃ViI^Cg
	
	K7EV_FLAG(K7SCN03_KIHAN_ISZ)	//LnAŏ̉oς
	K7EV_FLAG(K7SCN03_KIHAN_CUR)	//LnAŏ̉oς
	K7EV_FLAG(K7SCN03_CURUCURU_CERA)	//Z~bNX}C
	K7EV_FLAG(EV0361_OPEN_DOOR)		//J[eBX̉ƁyLԁzv[ւ̔JCxg?
	
	K7EV_FLAG(PR_HS_PROT)			//veNgX}CЉ
	K7EV_FLAG(PR_HS_PROT_Z)			//veNgyX}CЉ
	K7EV_FLAG(PR_HS_PROT_ZZ)		//veNgyyX}CЉ
	K7EV_FLAG(PR_HS_BROK)			//u[NЉ
	K7EV_FLAG(FIRST_AKN_DEMO)		//ŏ̃AJliVnjfI
	
	K7EV_FLAG(K7SCN03_EVFL_SPCYO_END)		// WՏI
	
K7EV_SCN_FLAG_END(K7SCN03)

K7EV_SCN_IDTABLE_START(K7SCN03)
K7EV_SCN_IDTABLE_END(K7SCN03)

K7EV_SCN_ITEMTABLE_START(K7SCN03)
	// JM
//	K7EV_ITEMTABLE(K7EVITEM_KEY (030201))					// ֌WҗpʘȞ
	
	// }bv
	K7EV_ITEMTABLE(K7EVITEM_MAP (030101))					// CVUJh̒n} Vn
	K7EV_ITEMTABLE(K7EVITEM_MAP (035001))					// J[eBX̉
	
	// 
	K7EV_ITEMTABLE(K7EVITEM_MEMO(030101))					// Vn
	K7EV_ITEMTABLE(K7EVITEM_MEMO(030201))					// ng A[P[h
	K7EV_ITEMTABLE(K7EVITEM_MEMO(030301))					// ng ֌WҗpʘH
	K7EV_ITEMTABLE(K7EVITEM_MEMO(030401))					// ng OʘH
	K7EV_ITEMTABLE(K7EVITEM_MEMO(030601))					// ng `
	K7EV_ITEMTABLE(K7EVITEM_MEMO(035001))					// ng K[W
	K7EV_ITEMTABLE(K7EVITEM_MEMO(035002))					// ng Qij
	K7EV_ITEMTABLE(K7EVITEM_MEMO(035003))					// ng K\EƂ
	
	//cvOEVn
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030001))					// LJUP	A[P[h			A[P[hE|bvR[
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030002))					// LJUQ	O			O
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030003))					// LJUR	L[ebhSe			L[ebh
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030010))					// gBXP				`PbgƂĂ
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030011))					// gBXQ	O			x`̏ő̈
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030012))					// gBXR	ꒆ			}CNŉ̂Ă
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030013))					// gBXS	\t@[hI_			VƎŎĂ
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030014))					// gBXT	L[ebh			Vg̃|[Yx̎
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030015))					// gBXU	~Xe[nEXOL			XɓoĂBx|[Y
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030020))					// CUP	
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030021))					// CUQ	A[P[h
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030022))					// CUR	ϑO
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030023))					// CUS	L[ebhPe			ĂE
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030024))					// CUT	L[ebhSe			\t@[hO
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030025))					// CUU	eLTX}XNŔj󂷂hA
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030026))					// CUV	
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030040))					// R͓			JiLnj
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030041))					// PXQ	{X풼Oԏ			{X
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030042))					// PXR	̋Ō			SSNAɏo
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030050))					// jIP	A[P[h
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030051))					// jIQ	ЈH
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030052))					// jIR	O
	K7EV_ITEMTABLE(K7EVITEM_ZAN (030060))					// NELo
	
	//cvOEJ[eBX̉
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035001))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035002))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035003))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035004))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035005))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035006))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035008))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035009))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035010))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035012))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035013))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035014))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035015))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035016))					// PX
	K7EV_ITEMTABLE(K7EVITEM_ZAN (035020))					// EC_
	K7EV_ITEMTABLE(K7EVITEM_ZAN (012150))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (012151))					// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (012152))					// 
	//EJ[eBX̉
	K7EV_ITEMTABLE(K7EVITEM_MEMO(035001))					//J[eBX̉ƁygCz
	//svcȑ`
	K7EV_ITEMTABLE(K7EVITEM_KEY (030315))					//Vn ]ƈpn œ
	K7EV_ITEMTABLE(K7EVITEM_KEY (035013))					//J[eBX̉Ɓyzra
	K7EV_ITEMTABLE(K7EVITEM_KEY (035107))					//J[eBX̉ƁyʑԁzLbg
	//e
	K7EV_ITEMTABLE(K7EVITEM_TAMA(030201))					//A[P[h |bvR[}V[
	K7EV_ITEMTABLE(K7EVITEM_TAMA(030401))					//OʘH D
	K7EV_ITEMTABLE(K7EVITEM_TAMA(030501))					//~Xe[nEX Vg
	K7EV_ITEMTABLE(K7EVITEM_TAMA(030709))					//L[ebh}V grX
	K7EV_ITEMTABLE(K7EVITEM_TAMA(035001))					//J[eBX̉Ɓyz呜
	K7EV_ITEMTABLE(K7EVITEM_TAMA(035002))					//J[eBX̉ƁyzgF
	K7EV_ITEMTABLE(K7EVITEM_TAMA(035003))					//J[eBX̉Ɓyʑԁzv
	
K7EV_SCN_ITEMTABLE_END(K7SCN03)

//K7EV_SCN_HITOBJTABLE_START(K7SCN03)
//K7EV_SCN_HITOBJTABLE_END(K7SCN03)

// Cxgnh錾iCxghc`nhƂ̊֘Atj
K7EV_SCN_HANDLER_DECL_START(K7SCN03)
	
	K7EV_HANDLER_DECL     (K7SCN03_EVENT_INIT               ,K7SCN03_Init               ,NULL)
	K7EV_HANDLER_DECL     (K7SCN03_EVENT_TERM               ,K7SCN03_Term               ,NULL)
	
K7EV_SCN_HANDLER_DECL_END(K7SCN03)

// CxgfXNv^iCxg`j
K7EV_SCN_DESC_START(K7SCN03)
	
	// ViI
	K7EV_DESC_SCNINIT      (K7SCN03_EVENT_INIT)
	// ViII
	K7EV_DESC_SCNTERM      (K7SCN03_EVENT_TERM)
	
K7EV_SCN_DESC_END(K7SCN03)

