////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Scn98
//
// K7Scn98.cpp
//
// Creator       : Kawakami Satoshi (GHM)
// Creation Date : 02/24/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7SCN97_CPP__
#pragma	warn_unusedarg			off

#include "..\Wat\WK7EventScript.h"
#include "..\Wat\WK7EventItem.h"
#include "..\Wat\WK7HitObj.h"

////////////////////////////////////////////////////////////////////////////////
// CxgfXNv^`
////////////////////////////////////////////////////////////////////////////////

#define	K7EV_BODY_PART
#include ".\K7Scn97.h"
#include "..\Wat\WK7Npc.h"
#include "..\Wat\WK7Enemy.h"
#include "..\Wat\WK7Obj.h"
#include "..\Wat\WK7Stage.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Enm\EnmANG.h"
#include "..\Enm\EnmKUN.h"
#include "..\Enm\EnmKRR.h"
#include "..\Enm\EnmUR2.h"
#include "..\Fujita\c_impulse.h"

////////////////////////////////////////////////////////////////////////////////
// nh`
////////////////////////////////////////////////////////////////////////////////

#include "..\Fujita\C_Font.h"

#define DEBUG_READ 1

K7EV_HANDLER(K7SCN97_Init)
{
	GameInfo.SetMode(WK7GameInfo::PLAY);
	
	K7SCR_PC_CREATE(K7CHRID(K7DAN,00));			// fǂݍ
	K7SCR_PC_MOTIONCREATE(K7CHRID(K7DAN,00));	// [Vǂݍ
	K7SCR_PC_CREATEWAIT();						// ǂݍݑ҂
	
	k7app.FadeStart(0,0);
	k7app.SetFadeColor(0);
	

	while( WK7Stage::ChangeStage()==false ){
		K7SCR_RETSYS();
	}
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	
	K7SCR_PC_VISIBLE(true);
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
	return;
}

K7EV_HANDLER(K7SCN97_Term)
{
	K7SCR_RETSYS();
}


#if 0
K7EV_HANDLER(K7SCN97_Stg707M01Init)
{
	WK7Npc		*pNpc[3];

  WK7PLAYERCONTROL->SetGameOver(); // lQ[I[o[[hɂ

	//eLg[B
	gpSound->mReadSsm( "seBossAngKun.ssm", eBankBoss );

#if SCN_00
#if DEBUG_READ
	K7SCR_PC_CREATE(K7CHRID(K7HAC,00));			// fǂݍ
	K7SCR_PC_MOTIONCREATE(K7CHRID(K7HAC,00));	// [Vǂݍ
	K7SCR_PC_CREATEWAIT();						// ǂݍݑ҂
#endif
#endif
	K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("Stage707_M01_scene_bps","Stage707_M01_scene_paths",0.5f,K7SCR_CAM_PATHDIR);
#if 0
	Vec p={52.f,1.f,-338.f};
	WK7PLAYERCONTROL->SetPosition(&p);	
#endif
	
	while( (pNpc[1] = WK7Npc::Create(ENENO_KUN))==NULL ){
		K7SCR_RETSYS();
	}
	while( (pNpc[2] = WK7Npc::Create(ENENO_ANG))==NULL ){
		K7SCR_RETSYS();
	}
	
	while( pNpc[1]->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	while( pNpc[2]->IsLoading()==true ){
		K7SCR_RETSYS();
	}

	WK7Stage::GetCurrentStage()->ChangePriority( WK7Stage::GetCurrentStage()->GetPriority()-2 );

	HSD_CameraDesc	*pDesc = WK7Stage::GetCurrentStage()->GetCameraDesc(0);
	if( pDesc!=NULL ){  K7EV_CAM->SetDesc(pDesc);}

	//JB
	WK7Cam *cam = K7EV_MAINTASK->GetCamera();
	cam->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);

	gpSound->mPlayStreamNo(HPS_BOSS_ANG);

	while( 1 ){
	  //ANGSB
	  if( !K7EnmANG::IsAlive() ) break;
	  K7SCR_RETSYS();
	}

	gpSound->mFadeVolumeStream(0,30);
	gpSound->mStopStream();

	//ogIB
	KK7BattleMainTask::BattleMainTaskExit(2);

	//HJ
	cam->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	cam->StopMotion();
	cam->DetachMotion();
	Vec tpos={50.f,12.f,-517.f};
	Vec cpos={46.f,17.f,-491.f};
	cam->SetPosition(cpos);
	cam->SetTargetPosition(tpos);
	cam->SetFov(59.f);

	bool flg = false;
	s32 ac = 0;
	while( 1 ){
	  //KUNSB
	  if( !K7EnmKUN::IsAlive() ) break;
	  if( !K7EnmKUN::IsAppeard() ){		//ogႾ߁B
		KK7BattleMainTask::BattleMainTaskExit(2);
		if( ac++ == (EXPLOSION_WAIT+140) ) gpSound->mPlayStreamNo(HPS_BOSS_KUN);
		WK7PLAYERCONTROL->SetPause();
	  }else{
		if( !flg ){  //P񂾂B
		  cam->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		  WK7PLAYERCONTROL->ResetPause();
		  flg = true;
		}
		//cam->SetMode(WK7Cam::WK7CAM_PATH_ANIM);
	  }

	  K7SCR_RETSYS();
	}

	gpSound->mFadeVolumeStream(0,30);
	gpSound->mStopStream();

	//ogIB
	KK7BattleMainTask::BattleMainTaskExit(2);
	cam->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	cam->StopMotion();
	cam->DetachMotion();
	cam->SetCinemaScopeMode(true);
	//eJB
	Vec pos={54.f,8.f,-351.f},hand_pos={49.f,16.f,-515.f};
	
	WK7Play				*pPlay;
	
	while( (pPlay = WK7Play::Create("00020711"))==NULL ){
		K7SCR_RETSYS();
	}
	
#if 0
	HSD_JObj *jobj = WK7PLAYERCONTROL->GetHandBone()->GetJObj();
	HSD_JObjSetupMatrix( jobj );
	HSD_MtxGetTranslate( jobj->mtx, &pos );
	pos.y += 7.f;
	pos.z -= 15.f;
#endif
	WK7PLAYERCONTROL->GetCharaPtr()->GetModel()->SetMotionRate( 0.5f );
	{
	  //C_ShockWaveSet *bullet = IMPULSE.Request( &pos, K7EnmKUN::GetHitPos(), 0.3f );
	  C_ShockWaveSet *bullet = IMPULSE.Request( &pos, &hand_pos, 0.3f );

	  f32 counter = 0.f;
	  bool flg = false;;
	  while( 1 ){
		//eJIB
		Vec *tpos=IMPULSE.GetPos( bullet );
		if( !tpos ) break;
		//ā[B
		//if( !flg && VECDistance( tpos, K7EnmKUN::GetHitPos() ) < 1.0f ){
		if( !flg && VECDistance( tpos, &hand_pos ) < 1.0f ){
		  gpSound->mPlaySE( SFX_BOSS_ANGKUN_KUNDIE );
		  flg = true;
		  IMPULSE.TerminateAll();
		  K7EnmANG::StopFeather();
		  //k7app.FadeStart(0xff,4800);
		  //k7app.SetFadeColor(0xffffffff);
		  break;
		}
		KK7BattleMainTask::BattleMainTaskExit(2);
		f32 rad = (f32)M_PI * counter / 180.f;
		f32 val = sinf( rad );
		Vec cpos={0.f, val - 0.5f, -(5.f+val*5.f)};
		Mtx m;
		MTXRotRad( m, 'y', 2.f*rad );
		MTXMultVec( m, &cpos, &cpos );
		VECAdd( tpos, &cpos, &cpos );
		cam->SetPosition(cpos);
		cam->SetTargetPosition(*tpos);
		cam->SetFov(59.f);
		//pLb
		if( val > 0.05f && val < 0.95f ) counter += 15.f;
		else counter += 0.1f;
		//counter += (0.3f + 1.0f * val * val * val);
		if( counter > 180.f ) counter = 0.f;
		K7SCR_RETSYS();
		//OSReport( "%f : %f\n", counter, val );
	  }
	}

	cam->SetFar(32768.f);

	while( pPlay->GetState()!=WK7Play::LOADED ){
		K7SCR_RETSYS();
	}
	
//	pPlay->Prepare();
//	
//	while( pPlay->GetState()!=WK7Play::STANDBY ){
//		K7SCR_RETSYS();
//	}
	
	pPlay->Start();
	WK7Stage::SetRenderStage(false);
	WK7Chara::SetRenderChara(false);
	WK7Item::SetRenderItem  (false);
	
	while( pPlay->GetState()==WK7Play::PLAY ){
		K7SCR_RETSYS();
	}
	
	GameInfo.SetMode     (WK7GameInfo::TERM           );
	GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
	
	delete pPlay;
	
//	k7app.FadeStart(0x00,4800);
//	k7app.SetFadeColor(0);
	
	//IB
//	while( k7app.IsFade()==true ){
//	  K7SCR_RETSYS();
//	}
	
	// I
	gpSound->mStopStream();
	
	cam->SetCinemaScopeMode(false);
	GameInfo.SetMode     (WK7GameInfo::TERM           );
	GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
}

//#if !DEBUG_READ
extern	void Stg707M01Init(ghmGcTask *pTask);
extern	void Stg707M01Init(ghmGcTask *pTask)
{
	// Oďop
	K7SCN97_Stg707M01Init(pTask);
}
//#endif
#endif

#if 0
K7EV_HANDLER(K7SCN97_Stg160M00Init)
{
	WK7Npc		*pNpc[3];

  WK7PLAYERCONTROL->SetGameOver(); // lQ[I[o[[hɂ

	//eLg[B
	gpSound->mReadSsm( "seBossKibKrr.ssm", eBankBoss );
#if SCN_01
#if DEBUG_READ
	//K7SCR_PC_CREATE(K7CHRID(K7KED,00));			// fǂݍ
	//K7SCR_PC_MOTIONCREATE(K7CHRID(K7KED,00));	// [Vǂݍ
	//K7SCR_PC_CREATEWAIT();						// ǂݍݑ҂
#endif
#endif
	

	K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("set_start","C0_camera3",0.5f,K7SCR_CAM_PATHDIR_REV);
	
#if 0
	while( (pNpc[1] = WK7Npc::Create(ENENO_KRR))==NULL ){
		K7SCR_RETSYS();
	}
	while( (pNpc[2] = WK7Npc::Create(ENENO_KIB))==NULL ){
		K7SCR_RETSYS();
	}
	
	while( pNpc[1]->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	while( pNpc[2]->IsLoading()==true ){
		K7SCR_RETSYS();
	}
#endif
	
	//eLg[B
	gpSound->mPlayStreamNo(HPS_BOSS_KIBKRR);


	while( 1 ){
	//ěςB
	WK7PLAYERCONTROL->SetKamaeDir(PI);
	
	  //݁AsgȂ̂łł悵B
	  if( K7EnmKRR::IsGameOver() ) break;
	  K7SCR_RETSYS();
	}

	//IB
	{
	  k7app.FadeStart(0xff,4800);
	  k7app.SetFadeColor(0x00000000);

	  while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	  }
	  gpSound->mStopStream();
	}
	GameInfo.SetMode     (WK7GameInfo::TERM           );
	GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
}

//#if !DEBUG_READ
extern	void Stg160M00Init(ghmGcTask *pTask);
extern	void Stg160M00Init(ghmGcTask *pTask)
{
	// Oďop
	K7SCN97_Stg160M00Init(pTask);
}
//#endif
#endif
#if 0
K7EV_HANDLER(K7SCN97_Stg206M00Init)
{

#if SCN_02
#endif
	
	K7SCR_PC_CREATEWAIT();						// ǂݍݑ҂
	//K7SCR_STG_SET_CURRENT_PATH_POINT("curve1");
	//K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("curve4",0,0.5f,K7SCR_CAM_PATHDIR_REV);
	
#if 0
	WK7Npc		*pNpc[3];
	while( (pNpc[1] = WK7Npc::Create(ENENO_UR2))==NULL ){
		K7SCR_RETSYS();
	}

	while( pNpc[1]->IsLoading()==true ){
		K7SCR_RETSYS();
	}
#endif
	
	//eLg[B
	gpSound->mPlayStreamNo(HPS_FREEMOVE_A);
	gpSound->mReadSsm( "seBossUr2.ssm", eBankBoss );

	WK7Cam *cam = K7EV_MAINTASK->GetCamera();
	cam->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);

	s32 counter = 0;
	while( 1 ){
	  if( K7EnmUR2::IsGameOver() ){
		break;
	  }else{
		C_Vec pos, tgt;
		f32 fov;
		if( K7EnmUR2::IsCamReq( pos, tgt, fov ) ){
		  //JCxgB
		  if( counter == 0 ){
			KK7BattleMainTask::BattleMainTaskExit(2);
			cam->StoreFov();
			cam->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
			cam->StopMotion();
			cam->DetachMotion();
			cam->StopInterpolate();
			WK7PLAYERCONTROL->SetPause();
		  }
		  cam->SetPosition(pos);
		  cam->SetTargetPosition(tgt);
		  cam->SetFov(fov);
		  counter++;
		}else{
		  if( counter ){
			cam->RestoreFov();
			cam->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
			WK7PLAYERCONTROL->ResetPause();
			counter = 0;
		  }
		}
	  }
	  K7SCR_RETSYS();
	}

	//IB
	{
	  k7app.FadeStart(0xff,4800);
	  k7app.SetFadeColor(0x00000000);

	  while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	  }
	  gpSound->mStopStream();
	}
}

extern	void Stg206M00Init(ghmGcTask *pTask);
extern	void Stg206M00Init(ghmGcTask *pTask)
{
	// Oďop
	K7SCN97_Stg206M00Init(pTask);
}
#endif
K7EV_HANDLER(K7SCN97_Stg000M00Term)
{
}


////////////////////////////////////////////////////////////////////////////////
// nhe[u
////////////////////////////////////////////////////////////////////////////////

#define	K7EV_TBL_PART
#include ".\K7Scn97.h"














