////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SCNALL
//
// K7SCNALL.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/08/2003
//
////////////////////////////////////////////////////////////////////////////////

#include "..\Wat\WK7Player.h"
#include "..\Wat\WK7Npc.h"
#include "..\Wat\WK7Play.h"
#include "..\Wat\WK7GameInfo.h"
#include "..\Wat\WK7Event.h"

// Cxgnh錾iCxghc`nhƂ̊֘Atj
K7EV_HANDLER_DECL_START
	K7EV_HANDLER_DECL     (K7SCNALL_EVENT_INIT          ,K7SCNALL_Init               ,NULL)
	K7EV_HANDLER_DECL     (K7SCNALL_EVENT_TERM          ,K7SCNALL_Init               ,NULL)
	K7EV_HANDLER_DECL_COND(K7SCNALL_STGBPARRIVE_DEFMOVE ,K7SCNALL_StgBpArriveDefMove ,NULL,K7EV_COND_NOTRUN)
	K7EV_HANDLER_DECL_COND(K7SCNALL_STGBPARRIVE_DEFMOVE2,K7SCNALL_StgBpArriveDefMove2,NULL,K7EV_COND_NOTRUN)
	K7EV_HANDLER_DECL_COND(K7SCNALL_STGBPARRIVE_DEFPLAY ,K7SCNALL_StgBpArriveDefPlay ,NULL,K7EV_COND_NOTRUN)
	K7EV_HANDLER_DECL_COND(K7SCNALL_STGBPARRIVE_DOOR    ,WK7Stage::DoorEventTask     ,NULL,K7EV_COND_NOTRUN)
//	K7EV_HANDLER_DECL_COND(K7SCNALL_STGBPTV             ,WK7Stage::TVEventTask       ,NULL,K7EV_COND_NOTRUN)
//	K7EV_HANDLER_DECL_COND(K7SCNALL_STGBPLTV            ,WK7Stage::LTVEventTask      ,NULL,K7EV_COND_NOTRUN)
//	K7EV_HANDLER_DECL_COND(K7SCNALL_STGHITOBJ           ,K7SCNALL_StgHitObj          ,NULL,K7EV_COND_NOTRUN)
	K7EV_HANDLER_DECL_COND(K7SCNALL_STGBPMAP            ,WK7Stage::MapEventTask      ,NULL,K7EV_COND_NOTRUN)
	K7EV_HANDLER_DECL_COND(K7SCNALL_STGBPKEY            ,WK7Stage::KeyEventTask      ,NULL,K7EV_COND_NOTRUN)
	K7EV_HANDLER_DECL_COND(K7SCNALL_STGBPMEMO           ,WK7Stage::MemoEventTask     ,NULL,K7EV_COND_NOTRUN)
//	K7EV_HANDLER_DECL_COND(K7SCNALL_STGPATHDOOR         ,WK7Path::DoorEventTask      ,NULL,K7EV_COND_NOTRUN)
//	K7EV_HANDLER_DECL_COND(K7SCNALL_STGPATHBRANCH       ,WK7Path::BranchEventTask    ,NULL,K7EV_COND_NOTRUN)
K7EV_HANDLER_DECL_END

// CxgfXNv^iCxg`j
K7EV_DESC_START
	K7EV_DESC_SCNINIT             (K7SCNALL_EVENT_INIT          )
	K7EV_DESC_SCNTERM             (K7SCNALL_EVENT_TERM          )
	K7EV_DESC_STGBPARRIVE_DEFMOVE (K7SCNALL_STGBPARRIVE_DEFMOVE )
	K7EV_DESC_STGBPARRIVE_DEFMOVE2(K7SCNALL_STGBPARRIVE_DEFMOVE2)
	K7EV_DESC_STGBPARRIVE_DEFPLAY (K7SCNALL_STGBPARRIVE_DEFPLAY )
	K7EV_DESC_STGBPARRIVE_DOOR    (K7SCNALL_STGBPARRIVE_DOOR    )
//	K7EV_DESC_STGBPTV             (K7SCNALL_STGBPTV             )
//	K7EV_DESC_STGBPLTV            (K7SCNALL_STGBPLTV            )
//	K7EV_DESC_STGHITOBJ           (K7SCNALL_STGHITOBJ           ,0xffffffff)
	K7EV_DESC_STGBPMAP            (K7SCNALL_STGBPMAP            ,0xffffffff)
	K7EV_DESC_STGBPKEY            (K7SCNALL_STGBPKEY            ,0xffffffff)
	K7EV_DESC_STGBPMEMO           (K7SCNALL_STGBPMEMO           ,0xffffffff)
//	K7EV_DESC_STGPATHDOOR         (K7SCNALL_STGPATHDOOR         ,0xffffffff,NULL)
//	K7EV_DESC_STGPATHBRANCH       (K7SCNALL_STGPATHBRANCH       ,0xffffffff,NULL)
K7EV_DESC_END

