////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage771M02
//
// K7Stage771M02.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/26/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE771M02_H__
#define	__K7STAGE771M02_H__

#include "..\..\..\Wat\WK7Stage.h"
#include "..\..\K7Stage.h"
#include ".\K7Stage771M00.h"
#include "..\..\..\Wat\WK7Player.h"
#include "..\..\..\Enm\EnmK.h"

class K7Stage771M02 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage771M02();
	K7Stage771M02(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	K7EnmK	*pNpcSu;
public:
	virtual ~K7Stage771M02();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool CondChangeCallBack(void);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
	virtual bool ZanEventCallBack  (WK7ZanEventInfo  &);
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);
	virtual bool SetCurrentCallBack(void);

};

#ifdef __K7STAGE771M02_CPP__


enum K7STAGE771M02_ONESHOTCAM{
	EVENT_TRUNK,
	EVENT_HSNEST,
	CAM771M02_HS_PRESEN_START,
	CAM771M02_HS_PRESEN_END,
};


K7StageEventOneShotCamera K7Stage771M02_Camera[] = {
//	{{-203.060f, -1.346f, -448.512f},{-163.517f, 14.279f, -488.706f}},
	{{-177.356f, 7.341f, -473.477f},{-169.112f, 18.289f, -484.664f}},
	{{-139.938f, 23.086f, -534.236f},{-119.113f, 21.983f, -527.006f}},
	{{152.629f, 13.000f, -515.404f},{175.837f, 14.644f, -516.112f}},		// HSЉp
	{{-20.063f, 13.000f, -515.157f},{3.146f, 14.644f, -515.865f}},		// HSЉpY[
};

#define	K7STAGE771M02_MES_GET_TAMA					(0)		// eۂɓꂽ
#define	K7STAGE771M02_MES_OPEN_TRUNK				(1)		// gNJ

#endif

#endif	//__K7STAGE771M02_H__

