////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage772M01
//
// K7Stage772M01.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE772M01_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage772M01.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Sound.h"


//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage772M01::K7Stage772M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage772M01_Camera );
	mAmbPlaySE = false;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage772M01::~K7Stage772M01()
{
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage772M01::SetCurrentCallBack( void )
{
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){-132.544f, 6.804f, -70.624f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){-177.438f, 5.723f, -289.888f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){-177.766f, 5.227f, -369.330f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		mAmbPlaySE = true;
	}
	
	//PCJ҂
	while( WK7Stage::IsChanging() != false )
	{
		K7SCR_RETSYS();
	}
	
	//HELP!Cxg
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007290) == false )
	{
		//CxgtOON
		K7SCR_SET_SCENARIO_FLAG(K7SCN07_EVFL_007290);
		////ȈՃLĐ
		//PlayOneShotCharaGeki( CAM772M01HELP, 4800*3, true, SFX_SCE0_2F_HELPME );
		gpSound->mPlaySE( SFX_SCE0_2F_HELPME );
	}
	
	return( true );
}
