////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage772M03
//
// K7Stage772M03.cpp
//
// Creator       : 
// Creation Date : 03/27/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE772M03_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage772M03.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\K7GlobalFlag.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Yam\YK7EffectDraft.h"
#include "..\..\..\Yam\YK7EffectModelFire.h"
#include "..\..\..\sato\SK7SpecialData.h"

//bZ[W
#define	MES772M03_00			(0)		//{IRpľ
#define	MES772M03_USE_FIRE_RING	(1)		//̎wւg
//[V
#define	MOT772M03_00	(0)		//LrlbgJ



//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage772M03::K7Stage772M03(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	int	i;
	
	SetOneShotCamLocTbl( K7Stage772M03_Camera );
	
	for( i = 0; i < STG772M03FIRE_EFFECT_NUM; i++ )
	{
		mCandle[i].mpEffect = NULL;
		mCandle[i].mpJObj   = NULL;
	}
	
	//N[[SEĐ
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007202) == TRUE )
	{
		gpSound->mPlaySE( SFX_SCE0_COOLER_RUN_LOOP );
	}
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage772M03::~K7Stage772M03()
{
	gpSound->mStopSE( SFX_SCE0_COOLER_RUN_LOOP );
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage772M03::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT772M03_00 );
	
	//GtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage772M03::TerminateCallBack( void )
{
	//̃GtFNgI
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007201_1) == TRUE )
	{
		mStopFireEffect();
	}
	
	while( WK7RenderObj::ReleaseEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage772M03::CondChangeCallBack( void )
{
	//LrlbgCxg
	if( K7SCR_GET_SCENARIO_FLAG(EV007308STRANGE) == true )	//{ĨRpľ2Ă
	{
		SimpleSetLastMotion( "cabinet", MOT772M03_00 );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007203), false );
	}else
	{
		//E\NCxg𐳉ĂLrlbgJĂ
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007201) == TRUE )
		{
			SimpleSetLastMotion( "cabinet", MOT772M03_00 );
		}else
		{
			SimpleSetStartMotion( "cabinet", MOT772M03_00 );
		}
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007203), true );
	}
	
	//E\NCxg
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007201) == TRUE )	//E\NĂ
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007201), false );
		if( K7SCR_GET_SCENARIO_FLAG(EV007308STRANGE) == false )
		{
			K7SCR_EVNO_SETENABLE( K7EVENTNO(007203), true );
		}else
		{
			K7SCR_EVNO_SETENABLE( K7EVENTNO(007203), false );
		}
	}else
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007201), true );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007203), false );
	}
	
	//΂_ĂGtFNgJn
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007201_1) == TRUE )
	{
		mStartFireEffect();
	}else
	{
		mStopFireEffect();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage772M03::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//E\NCxg
		case	K7EVENTNO( 007201 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//΂ACeĂ違΂_ĂȂΊJn
			if( (K7SCR_EVEQUIPRING(RING_FIRE) == true)
			 && (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007201_1) == FALSE) )
			{
				//w֎gpbZ[W
				FixCam( EV_CAM2_CANDLE );
				K7SCR_STGC_MESSAGE_B( MES772M03_USE_FIRE_RING );
				//E\NpỸplĂяo
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(007201), 1 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				K7SCR_PANEL_EXIT();
				//LZȂ牊_鑤̏
				if( K7SCR_PANEL_GETRESULT() != -1 )
				{
					//E\Nɉ̃GtFNgt
					mStartFireEffect();
					//GAR_Ă΂
					if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007202) == TRUE )
					{
						FixCam( EV_CAM2_CANDLE );
						K7SCR_PANEL_EXITWAIT();
						mGoOutFireEffect();
					}else
					{
						//E\N_ĂtOON
						K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007201_1 );
						//E\NpYɐ
						if( K7SCR_PANEL_GETRESULT() == 1 )
						{
							//WNV
							K7SCR_EVNO_SETENABLE( K7EVENTNO(007201), false );
							K7SCR_EVNO_SETENABLE( K7EVENTNO(007203), true );
							//tOON
							K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007201 );
							//Jݒ
							FixCam( EV_CAM2_CABINET_OPEN );
							//plI҂
							K7SCR_PANEL_EXITWAIT();
							//LrlbgJAjĐ
							gpSound->mPlaySE( SFX_SCE0_CANDLESHELF_OPEN );
							SimplePlayMotionB( "cabinet", MOT772M03_00 );
							//IfgEt@t@[
							gpSound->mPlaySE( SFX_SYS_TRUE );
							K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
						}else
						{
							WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
							K7SCR_PANEL_EXITWAIT();
						}
					}
				}else
				{
					WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
					K7SCR_PANEL_EXITWAIT();
				}
			}else
			if( (K7SCR_EVEQUIPRING(RING_FIRE) == true)
			 && (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007201_1) == true) )
			{
				FixCamWithRiddle( EV_CAM2_CANDLE );
			}else
			if( (K7SCR_EVEQUIPRING(RING_FIRE) == false)
			 && (K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007201_1) == true) )
			{
				FixCamWithRiddle( EV_CAM2_CANDLE );
			}else
			{
				//E\NpỸplĂяo
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(007201), 0 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				K7SCR_PANEL_EXIT();
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				K7SCR_PANEL_EXITWAIT();
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//GARCxg
		case	K7EVENTNO( 007202 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//GARpỸplĂяo
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007202) == TRUE )
			{
			//	mStopFireEffect();
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(000501), 1 );
			}else
			{
			//	mStopFireEffect();
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(000501), 0 );
			}
			//E\NSEĂ~߂
			if( gpSound->mCheckSE(SFX_SCE0_ROUSOKU) == true )
			{
				gpSound->mStopSE( SFX_SCE0_ROUSOKU );
			}
			K7SCR_PANEL_START();
			K7SCR_PANEL_TERMWAIT();
			K7SCR_RETSYS();
			K7SCR_PANEL_EXIT();
			//XCb`ONɂꍇ
			if( K7SCR_PANEL_GETRESULT() == 1 )
			{
			//	gpSound->mStopSE( SFX_SCE0_COOLER_RUN_LOOP );
			//	K7SCR_RETSYS();
			//	gpSound->mPlaySE( SFX_SCE0_COOLER_RUN_LOOP );
				K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007202 );
				//΂_Ă
				if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007201_1) == TRUE )
				{
					FixCam( EV_CAM2_CANDLE );
					gpSound->mPlaySE( SFX_SCE0_ROUSOKU );
					K7SCR_PANEL_EXITWAIT();
					mGoOutFireEffect();
					K7SCR_RESET_SCENARIO_FLAG(K7SCN07_EVFL_007201_1);
				}else
				{
					WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
					K7SCR_PANEL_EXITWAIT();
				}
			}else
			//XCb`OFFɂꍇ
			if( K7SCR_PANEL_GETRESULT() == 0 )
			{
			//	gpSound->mSetVolumeSE( SFX_SCE0_COOLER_RUN_LOOP, 0, 200 );
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				K7SCR_PANEL_EXITWAIT();
				K7SCR_RESET_SCENARIO_FLAG( K7SCN07_EVFL_007202 );
			}else
			{
				//JPCtH[ɖ߂
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				K7SCR_PANEL_EXITWAIT();
			}
			//΂_ĂSEĐ
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007201_1) == TRUE )
			{
				gpSound->mPlaySE( SFX_SCE0_ROUSOKU );
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//Lrlbg
		case	K7EVENTNO( 007203 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//E\NɐĂACe擾ł
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007201) == TRUE )
			{
				//擾SEĐ
				gpSound->mPlaySE( SFX_SYS_KEY_GET );
				//bZ[WtJݒ
				FixCam( EV_CAM2_ITEM );
				K7SCR_TIMEWAIT( 4800 * 2 );
				//ACe擾ʂ\
				SimpleItemGetMes( MES772M03_00, "ShieldPendant", true );
				//擾
				K7SCR_EVSETITEM( K7EVITEM_KEY(007308), true );
				K7SCR_SET_SCENARIO_FLAG( EV007308STRANGE );
				//WNV
				K7SCR_EVNO_SETENABLE( K7EVENTNO(007203), false );
			}else
			{
				FixCamWithRiddle( EV_CAM2_CABINET );
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//E\Nɉ΂_
//------------------------------------------------------------------------------
void
K7Stage772M03::mStartFireEffect( void )
{
	int      			i;
	char     			objname[64];
	Vec      			loc;
	WK7JObj* 			pJObj;
	Stg772M03Candle*	pCandle;
	
	for( i = 0, pCandle = mCandle; i < STG772M03FIRE_EFFECT_NUM; i++, pCandle++ )
	{
		sprintf( objname, "fire%d", i + 1 );
		pJObj = GetJObj( objname );
		pCandle->mpJObj = pJObj;
		if( pJObj != NULL )
		{
			pJObj->GetWorldPosition( loc );
		}else
		{
			loc.x = loc.y = loc.z = 0.0f;
		}
		//̃GtFNgNGCg
		if( (pCandle->mpEffect == NULL)
		 && ((pCandle->mpEffect=CreateEffectModelFire((const char*)NULL,MFIRE_CANDLE,&loc,0.25f)) != NULL)
		 && (pCandle->mpEffect->GetEffect() != NULL) )
		{
			SetWindModelFireEffect( pCandle->mpEffect->GetEffect(), (Vec){-0.2f,0.0f,-1.0f}, 0.0f );
		}
	}
	if( gpSound->mCheckSE(SFX_SCE0_ROUSOKU) == false )
	{
		gpSound->mPlaySE( SFX_SCE0_ROUSOKU );
	}
}

//------------------------------------------------------------------------------
//E\N̉΂̕\~߂
//------------------------------------------------------------------------------
void
K7Stage772M03::mStopFireEffect( void )
{
	int	i;
	
	for( i = 0; i < STG772M03FIRE_EFFECT_NUM; i++ )
	{
		if( mCandle[i].mpEffect != NULL )
		{
			DelReqEffect( mCandle[i].mpEffect );
			mCandle[i].mpEffect = NULL;
		}
	}
	if( gpSound->mCheckSE(SFX_SCE0_ROUSOKU) == true )
	{
		gpSound->mStopSE( SFX_SCE0_ROUSOKU );
	}
}

//------------------------------------------------------------------------------
//E\N̉΂
//------------------------------------------------------------------------------
void
K7Stage772M03::mGoOutFireEffect( void )
{
	int      			i;
	Stg772M03Candle*	pCandle;
	
	for( i = 0, pCandle = mCandle; i < STG772M03FIRE_EFFECT_NUM; i++, pCandle++ )
	{
		SetWindModelFireEffect( pCandle->mpEffect->GetEffect(), (Vec){-0.2f,0.0f,-1.0f}, 0.05f );
	}
	gpSound->mPlaySE( SFX_SCE0_CANDLE_DIE );
	K7SCR_TIMEWAIT( 4800 );
	
	mStopFireEffect();
	K7SCR_TIMEWAIT( 2400 );
}
