////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage773M04
//
// K7Stage773M04.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE773M04_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage773M04.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Wat\K7GlobalFlag.h"

//static	const char	*pHitObjName  = "event_000108";
//static	const char	*pKeyObjName  = "key_group";
static	const char	*pLucyName  = "event_000108";

//bZ[W
#define	MES773M04_00	(0)		//q[gO肵
#define	MES773M04_01	(1)		//{IRpľ
#define	MES773M04_02	(2)		//2Fւ̔̌J
#define	MES773M04_03	(3)		//2Fւ̔̌Ă
//[V
#define	MOT773M04_03	(3)		//@
#define	MOT773M04_04	(4)		//Ă
#define	MOT773M04_05	(5)		//@~J
#define	MOT773M04_06	(6)		//違@쓮
//f
#define	MDL773M04_RING				"ring"				//X[W[̃O
#define	MDL773M04_CYO_PICKING_POS	"cyo_picking"		//R[eJW
#define	MDL773M04_LOCK_ON			"cyo_padlock_on"	//̂O
#define	MDL773M04_LOCK_OFF			"cyo_padlock_off"	//̊JO




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage773M04::K7Stage773M04(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage773M04_Camera );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage773M04::~K7Stage773M04()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage773M04::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT773M04_03 );
	CreateOwnStageMotion( MOT773M04_04 );
	CreateOwnStageMotion( MOT773M04_05 );
	CreateOwnStageMotion( MOT773M04_06 );
	
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage773M04::CondChangeCallBack(void)
{
	WK7JObj	*pJObj;
	
	//Â͏Ă
	SimpleModelHide( "copy" );
	
	//΂_ACeĂ犣@WNV͏
	if( K7SCR_EVHASITEM(K7EVITEM_KEY(007309)) == TRUE )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007302), false );
		SimpleSetLastMotion( "e007309",MOT773M04_06 );
	}else
	{
		//X[W[Ɖb
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007203_0) == false )
		{
			//@
			if( (pJObj = PlayMotion("drum",MOT773M04_03)) != NULL )
			{
				pJObj->SetMotionLoop( true );
			}
			gpSound->mPlaySE( SFX_SCE0_DRY_ON_LOOP );
		}else
		{
			SimpleSetLastMotion( "e007309", MOT773M04_05 );
		}
	}
	
	//΂̎wւĂ烂f
	//if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_RING_FIRE) == true )
	if( K7SCR_GET_SCENARIO_FLAG(K7SCR07_GET_FIRERING) == true )
	{
		SimpleModelHide( MDL773M04_RING );
	}else
	{
		SimpleModelDisp( MDL773M04_RING );
	}
	
	//擾ĂCxg
	if( K7SCR_GET_SCENARIO_FLAG(EV007307STRANGE) == true )
	{	//WNV
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007308), false );
		SimpleModelHide( "key" );
	}else
	//gC̐𗬂Ă献\
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007310) == TRUE )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007308), true );
		SimpleModelDisp( "key" );
		SimpleSetLastMotion( "key", MOT773M04_04 );
	}else
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(007308), true );
		SimpleModelHide( "key" );
	}
	
	//2Kւ̔̌
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007203) == false )
	{
		SimpleModelDisp( MDL773M04_LOCK_ON );
		SimpleModelHide( MDL773M04_LOCK_OFF );
	}else
	{
		SimpleModelHide( MDL773M04_LOCK_ON );
		SimpleModelDisp( MDL773M04_LOCK_OFF );
	}
	
	return true;
}

//------------------------------------------------------------------------------
// Iȉj
//------------------------------------------------------------------------------
bool
K7Stage773M04::TerminateCallBack( void )
{
	WK7JObj *pJObj = NULL;
	
	//@̉Ă~߂
	if( gpSound->mCheckSE(SFX_SCE0_DRY_ON_LOOP) == true )
	{
		gpSound->mStopSE( SFX_SCE0_DRY_ON_LOOP );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage773M04::EventCallBack( WK7EventInfo &info )
{
	WK7JObj*        pJObj;
	WK7ZanEventInfo zanEventInfo;
	
	switch( info.mEventNo )
	{
		//svcȑ`
		case	K7EVENTNO(007308):
			//ĂȂΔ
			if( K7SCR_GET_SCENARIO_FLAG(EV007307STRANGE) == false )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//gC̐𗬂Ă献擾
				if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007310) == TRUE )
				{
					//擾SEĐ
					gpSound->mPlaySE( SFX_SYS_KEY_GET );
					//bZ[WtJݒ
					FixCam( EV_GET_KEY );
					K7SCR_TIMEWAIT( 4800 * 2 );
					//ACe擾ʂ\
					SimpleItemGetMes( MES773M04_01, "key", true );
					//擾
					K7SCR_EVSETITEM( K7EVITEM_KEY(007307), true );
					K7SCR_SET_SCENARIO_FLAG( EV007307STRANGE );
					//WNV
					K7SCR_EVNO_SETENABLE( K7EVENTNO(007308), false );
				}else
				{
					FixCamWithRiddle( EV_RIDDLE_KEY );
				}
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}
			break;
		
		//cvOEX[W[
		case	K7EVENTNO(007302):
			//΂_ACeĂȂΔ
			if( K7SCR_EVHASITEM(K7EVITEM_KEY(007309)) == FALSE )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//@plĂяo
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(000102), 1 );
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				K7SCR_PANEL_EXIT();
				//@~ĂCxg
				if( K7SCR_PANEL_GETRESULT() == 0 )
				{
					//inGame~
				//	K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					//Jݒ
					FixCam( EV_ZAN_KANSOUKI2 );
					WK7CAM->SetCinemaScopeColor( WK7CAM_DEFAULT_CINEMASCOPE_COLOR );
					WK7CAM->SetCinemaScopeMode( true );
					//@̉][V~
					if( (pJObj=GetJObj("e007309")) != NULL )
					{
						pJObj->StopMotion();
						K7SCR_RETSYS();
					}
					gpSound->mStopSE( SFX_SCE0_DRY_ON_LOOP );
					//@̔J[VĐ
					gpSound->mPlaySE( SFX_SCE0_DRY_OPEN );
					if( (pJObj = PlayMotion("e007309",MOT773M04_05)) != NULL )
					{
						pJObj->SetMotionLoop( false );
						while( pJObj->GetMotionState(false,true) != WK7MODEL_NOANIM )
						{
							K7SCR_RETSYS();
						}
					}
					//@plI҂
					K7SCR_PANEL_EXITWAIT();
					//inGame~
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007203_0 );
					//cvOƉb
					zanEventInfo.Initialize();
					zanEventInfo.mEventNo = K7EVENTZAN( 007301 );
					zanEventInfo.mpStage  = this;
					GameInfo.SetZanMesID( 0 );
					GameInfo.SetZanTermWait( true );
				//	GameInfo.SetZanNoiseCancel( false );
					GameInfo.SetZanNoiseCancel( true );
					GameInfo.SetZanCharaLoadCancel( true );
					CallZanEventCallBackTask( zanEventInfo );
					while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT )
					{
						K7SCR_RETSYS();
					}
					GameInfo.SetZanTermWait( false );
					GameInfo.SetZanManual( true );
					GameInfo.SetZanNoiseCancel( true );
					GameInfo.SetZanCinemaScopeCancel( true );
					while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY )
					{
						K7SCR_RETSYS();
					}
					gpSound->mStopStream();
					//inGame~icvO𔲂Ɖ邽߁j
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					K7SCR_PC_SETVISIBLE( false );
					//ACe擾ʂ\
					SimpleItemGetMes( MES773M04_00, MDL773M04_RING );
					//΂ACe擾
					K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_FIRE );
					K7SCR_SET_SCENARIO_FLAG( K7SCR07_GET_FIRERING );
					//tO𗎂Ƃ
					K7SCR_EVSETITEM( K7EVENTZAN(007301), false );
					//cvOƉb
					zanEventInfo.Initialize();
					zanEventInfo.mEventNo = K7EVENTZAN( 007301 );
					zanEventInfo.mpStage  = this;
					GameInfo.SetZanMesID( 1 );
					GameInfo.SetZanTermWait( true );
					GameInfo.SetZanNoiseCancel( true );
					GameInfo.SetZanCharaLoadCancel( true );
					CallZanEventCallBackTask( zanEventInfo );
					while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT )
					{
						K7SCR_RETSYS();
					}
					GameInfo.SetZanTermWait( false );
					GameInfo.SetZanManual( false );
				//	GameInfo.SetZanNoiseCancel( false );
					GameInfo.SetZanNoiseCancel( true );
					GameInfo.SetZanCinemaScopeCancel( false );
					FixCam( EV_ZAN_KANSOUKI2 );
					while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY )
					{
						K7SCR_RETSYS();
					}
					WK7CAM->SetCinemaScopeMode( true );
					//inGame~icvO𔲂Ɖ邽߁j
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					K7SCR_PC_SETVISIBLE( false );
					//@̔郂[VĐ
					K7SCR_PC_SETVISIBLE( true );
					gpSound->mPlaySE( SFX_SCE0_DRY_CLOSE );
					if( (pJObj = PlayMotion("e007309",MOT773M04_06)) != NULL )
					{
						pJObj->SetMotionLoop( false );
						while( pJObj->GetMotionState(false,true) != WK7MODEL_NOANIM )
						{
							K7SCR_RETSYS();
						}
						pJObj->StopMotion();
					}
					GameInfo.SetZanNoiseCancel( false );
					WK7CAM->SetCinemaScopeMode( false );

					WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
					WK7CAM->FrameProcess();
					WK7CAM->SetCurrent();
					gpSound->mPlayStreamNo( HPS_KRAKUJITU_C );

					//΂ACe擾
					K7SCR_EVSETITEM( K7EVITEM_KEY(007309), true );
					K7SCR_RESET_SCENARIO_FLAG( K7SCN07_EVFL_007203_0 );
					K7SCR_SET_SCENARIO_FLAG( K7SCR07_GET_FIRERING );
					K7SCR_EVCONDCHANGE();
				}else
				{
					K7SCR_PC_SETVISIBLE( true );
					//@plI҂
					K7SCR_PANEL_EXITWAIT();
				}
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
				return false;
			}
		
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage773M04::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//2Fւ̔
		case	K7EVENTDOOR( 007302 ):
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007203) == false )
			{
				if( WK7PLAYERCONTROL->GetMainID() == K7CYO )
				{
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					SimpleCyoPicking( MDL773M04_CYO_PICKING_POS, EV_CYO_PICKING );
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007203 );
					K7SCR_EVCONDCHANGE();
					K7SCR_PC_SETVISIBLE( false );
					FixCam( EV_OPEN2FDOOR );
					K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
					info.mCinemaScopeClear = true;
					//K7SCR_STGC_MESSAGE_B( MES773M04_02 );
					K7SCR_PC_SETVISIBLE( true );
					K7SCR_EXIT_PLAYMODE();
					K7SCR_EXIT_DEMOPAUSE();
				}else
				{
					FixCamMesWithRiddle( EV_OPEN2FDOOR, MES773M04_03 );
					return( false );
				}
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//qbgIuWF
//------------------------------------------------------------------------------
//bool
//K7Stage773M04::HitObjCallBack(WK7HitObjInfo &info)
//{
//	switch( info.mEventNo ){
//	case	K7EVENTNO(000108):
//		KK7BattleMainTask::BattleMainTaskExit(2);
//		K7SCR_RETSYS();
//		K7SCR_RETSYS();
//		while( GameInfo.SetMode(WK7GameInfo::PLAY)==false ){
//			K7SCR_RETSYS();
//		}
//		
//		WK7ZanEventInfo		zanEventInfo;
//		zanEventInfo.Initialize();
//		zanEventInfo.mEventNo = K7EVENTZAN(007301);
//		zanEventInfo.mpStage  = this;
//		ZanEventTask(zanEventInfo);
//		return false;
//	default:
//		break;
//	}
//	return true;
//}

