////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage775M02 Ln@Xs[hX}C
//
// K7Stage775M02.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE775M02_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage775M02.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7CharaPresent.h"
#include "..\..\..\Wat\K7GlobalFlag.h"
#include "..\..\..\Yam\YK7EffectVapor.h"

#define	K7STAGE775M02_KIHAN_HS_POSZ		(610.0f)
#define	MDL775M02_STEAM_00	"steam1"
#define	MDL775M02_STEAM_01	"steam2"
#define	MDL775M02_STEAM_02	"steam3"
#define	MDL775M02_STEAM_03	"steam4"

K7Stage775M02::K7Stage775M02(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage775M02_Camera);
	mpEffectVapor00 = NULL;
	mpEffectVapor01 = NULL;
	mpEffectVapor02 = NULL;
	mpEffectVapor03 = NULL;
	GameInfo.SetMenuMapEnable(false);
}

K7Stage775M02::~K7Stage775M02()
{
	GameInfo.SetMenuMapEnable(true);
	GameInfo.SetBossFlag(false);
	WK7PLAYERCONTROL->BattlePadRegulationClear();
}

K7STAGE_KIHANKUITABLE_START(K7Stage775M02Kui)
	K7STAGE_KIHANKUITABLE_CAM(1,K7EVENTTAMA(007101),26.091f, 15.277f, 598.265f, 27.931f, 14.619f, 616.654f)
	K7STAGE_KIHANKUITABLE_CAM(2,K7EVENTTAMA(007401),26.091f, 15.277f, 598.265f, 27.931f, 14.619f, 616.654f)
//	K7STAGE_KIHANKUITABLE_CAM(1,K7EVENTTAMA(007401),26.091f, 15.277f, 598.265f, 27.931f, 14.619f, 616.654f)
//	K7STAGE_KIHANKUITABLE_CAM(2,K7EVENTTAMA(007402),26.091f, 15.277f, 598.265f, 27.931f, 14.619f, 616.654f)
//	K7STAGE_KIHANKUITABLE_CAM(3,K7EVENTTAMA(007403),26.091f, 15.277f, 598.265f, 27.931f, 14.619f, 616.654f)
//	K7STAGE_KIHANKUITABLE_CAM(4,K7EVENTTAMA(007404),26.091f, 15.277f, 598.265f, 27.931f, 14.619f, 616.654f)
K7STAGE_KIHANKUITABLE_END()
bool K7Stage775M02::InitializeCallBack(void)
{
	WK7Npc *pEnemy = WK7Npc::Find( K7STAGE775M02_KIHAN_HS );
	
	if( WK7Npc::GetEnemyDieTest(K7STAGE775M02_KIHAN_HS)==false ){
		// LnX}C͐Ă	}jAu`ݒ
		SetManualBranch( true );
	}
	return true;
}

bool K7Stage775M02::CondChangeCallBack(void)
{
	if( mpEffectVapor00 == NULL )
	{
		mpEffectVapor00 = CreateVaporEffect( VP_775M02, GetJObj(MDL775M02_STEAM_00) );
	}
	if( mpEffectVapor01 == NULL )
	{
		mpEffectVapor01 = CreateVaporEffect( VP_775M02, GetJObj(MDL775M02_STEAM_01) );
	}
	if( mpEffectVapor02 == NULL )
	{
		mpEffectVapor02 = CreateVaporEffect( VP_775M02, GetJObj(MDL775M02_STEAM_02) );
	}
	if( mpEffectVapor03 == NULL )
	{
		mpEffectVapor03 = CreateVaporEffect( VP_775M02, GetJObj(MDL775M02_STEAM_03) );
	}
	return( true );
}

bool K7Stage775M02::TerminateCallBack(void)
{
	if( mpEffectVapor00 != NULL )
	{
		DeleteEffect( mpEffectVapor00 );
	}
	if( mpEffectVapor01 != NULL )
	{
		DeleteEffect( mpEffectVapor01 );
	}
	if( mpEffectVapor02 != NULL )
	{
		DeleteEffect( mpEffectVapor02 );
	}
	if( mpEffectVapor03 != NULL )
	{
		DeleteEffect( mpEffectVapor03 );
	}
	return( true );
}

bool K7Stage775M02::SetCurrentCallBack(void)
{
	WK7Npc *pEnemy = WK7Npc::Find( K7STAGE775M02_KIHAN_HS );
	
	if( WK7Npc::GetEnemyDieTest(K7STAGE775M02_KIHAN_HS)==true ){
		// Xs[hX}C͎ł
		//ȍĐ
		gpSound->mPlayStreamNo( HPS_SPEED_HS );
		return true;
	}else{
		/// LA
		WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_BOSSBATTLE);
	}
	
	GameInfo.SetBossFlag(true);
	
	//G`FbN
	if( pEnemy != NULL ){
		while( pEnemy->GetNpcState() == NPC_STATE_INIT ){
			K7SCR_RETSYS();
		}
		
		// ȍĐ
		gpSound->mPlayStreamNo( HPS_SPEED_HS );
		
		while( WK7Stage::IsChanging() != false ){
			K7SCR_RETSYS();
		}
		
		//inGame~
		K7SCR_ENTER_PLAYMODE_B();
		pEnemy->SetNoPause();						// Xs[hX}C̓|[YȂ
		K7SCR_ENTER_DEMOPAUSE();
		WK7PLAYERCONTROL->SetOperateEnable(false);
		
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_KIHAN) == false ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN07_KIHAN);
			
			// Ln叉߂
			
			KihanDemoFirst(pEnemy, DOOR_ENTER, HS_POS, 0,  81,  255, -48,  51, 849, 194, 1);
			
		}else{
			
			// LnQڈȍ~
			
			KihanDemo(K7STAGE775M02_KIHAN_HS, HS_POS);
			
		}
		
		// {XsJn
		while( pEnemy->KihanBoss_AiRun() == false ){
			K7SCR_RETSYS();
		}
		
		K7SCR_PC_SETVISIBLE(true);
		SetCameraStartPosition(WK7Stage::GetCurrentStageBpName());
		//JPCtH[ɖ߂
		WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
		
		K7SCR_RETSYS();
		K7SCR_CHARAPRESENT_DEBUGEND();
		K7SCR_TIMEWAIT(K7SCR_CP_RELEASETIME);
		
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
	}
	
	// }jAu`NA
	SetManualBranch( false );
	pEnemy->ResetNoPause();						// 
	
	return true;
};

bool K7Stage775M02::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(007501):
		if( KihanGateIsOpened()==false || WK7Npc::GetEnemyDieTest(K7STAGE775M02_KIHAN_HS)==false ){
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_EVCONDCHANGE();
			return false;
		}
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage775M02::HitObjCallBack(WK7HitObjInfo &info)
{
#pragma	unused(info)
#if 0
	K7StageKihanKui		*pKui = GetKui(info.mEventNo);
	if( pKui==NULL ){
		return true;
	}
	if( KihanKuiEvent(info)==true ){
		return true;
	}
	if( KihanGateIsOpened()==false ){
		return true;
	}
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	WK7Npc	*pEnemy = WK7Npc::Find(K7STAGE775M02_KIHAN_HS);
	if( pEnemy!=NULL ){
		
		gpSound->mPlaySE(SFX_SYS_FREE_KIHANMON);
		
		WK7Npc::SetNpcPauseAll(false);
		pEnemy->ResetPause();
		pEnemy->SetNpcState(NPC_STATE_SPD_MOVESTART);
		while( 1 ){
			switch( pEnemy->GetNpcState() ){
			case	NPC_STATE_SPD_WAIT:
			case	NPC_STATE_SPD_MOVESTART:
			case	NPC_STATE_SPD_EGG:
				K7SCR_RETSYS();
				continue;
			}
			break;
		}
		
		Vec		pos;
		pEnemy->GetPosition(pos);
		pos.z = K7STAGE775M02_KIHAN_HS_POSZ;
		pEnemy->SetPosition(pos);
		
	}
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
#endif
	return true;
}

bool K7Stage775M02::DieNpcCallBack(WK7DieNpcInfo &info)
{
	if( info.mpNpc==NULL ){
		return true;
	}
	switch( info.mpNpc->GetEneNo() ){
	case	K7STAGE775M02_KIHAN_HS:
		if ( info.mpNpc->GetDieMode() != NPC_DIE_JIBAKU ){
		//	gpSound->mPlayStreamNo( HPS_SAFE_PLACE );
		}
		GameInfo.SetBossFlag(false);
		K7SCR_EVCONDCHANGE();
		break;
	default:
		break;
	}
	return true;
}

