////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage101M01
//
// K7Stage101M01.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/04/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE101M01_H__
#define	__K7STAGE101M01_H__

#include "K7Stage101M00.h"

class K7Stage101M01 : public K7Stage101M00{
	friend class WK7Stage;
protected:
	
	K7Stage101M01();
	K7Stage101M01(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage101M01();
	
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool PathChangeCallBack(WK7PathChangeInfo &);
	virtual bool DoorEventCallBack (WK7DoorEventInfo  &);
	virtual bool EventCallBack     (WK7EventInfo      &);
};

#ifdef	__K7STAGE101M01_CPP__

enum K7STAGE101M01_ONESHOTCAM{
	DOOR_015001,
};

K7StageEventOneShotCamera	K7Stage101M01_Camera[] = {
	{{-288.075f, 62.488f, 145.143f},{-295.010f, 62.839f, 137.947f}},
};

enum{
	K7STAGE101M01_MES_INVISIBLE = 0		,		// ÂĉȂ
	K7STAGE101M01_MES_RING_WATER		,		// ̎wւɓꂽ
};

#endif

#endif	//__K7STAGE101M01_H__

