////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage103M00
//
// K7Stage103M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE103M00_CPP__

#include ".\K7Stage103M00.h"
//#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn01.h"

K7Stage103M00::K7Stage103M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage103M00_Camera);
}

K7Stage103M00::~K7Stage103M00()
{
}

bool K7Stage103M00::InitializeCallBack(void)
{
	HereComeANewHSInit( PR_HS_HEAD, ENENO_1_103_01 );
	return true;
}

bool K7Stage103M00::CondChangeCallBack(void)
{
	K7SCR_STG_SET_PATHENABLE("curve24",false);
	K7SCR_STG_SET_PATHENABLE("curve33",false);
	return true;
}

bool K7Stage103M00::SetCurrentCallBack(void)
{
	//V^HSЉ
	if( false == HereComeANewHS(	PR_HS_HEAD,
									ENENO_1_103_01,								// GID
									NULL,
									CAM103M00_HS_PRESEN_START,
									CAM103M00_HS_PRESEN_END,
									0,
									178,  289,  -7, 130, 774, 100 )				// OЉp
	){
		SetManualBranch(false);
		return( true );
	}
	return true;
}

bool K7Stage103M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
#if 0
	case	K7EVENTDOOR(010002):
		if( K7SCR_EVHASITEM(K7EVITEM_KEY(010001))==false ){
			// hAJȂ
	    	K7SCR_DEBUGPRINT("DOOR_010002 Closed : need KEY_010001");
	    	
			FixCamMes(DOOR_010002,K7STAGE103M00_MES_LOCKED_KEY);
			K7SCR_EVCONDCHANGE();
			
			return false;
		}else{
			// Jf
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_010002)==false ){
				
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_DRFL_010002);
				
				DoorClear(DOOR_010002,K7STAGE103M00_MES_USE_KYAKUSHITSU_KEY);
														// ǔvg
				
//				K7SCR_ENTER_PLAYMODE();
//				K7SCR_ENTER_DEMOPAUSE();
//				
//				// Jς
//				WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//				WK7CAM->SetPosition      (K7Stage103M00_Camera[DOOR_010002].pos);
//				WK7CAM->SetTargetPosition(K7Stage103M00_Camera[DOOR_010002].tgt);
//				K7SCR_PC_SETVISIBLE(false);
//				
//				gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
//				
//				K7SCR_STGC_MESSAGE_B(K7STAGE103M00_MES_USE_KYAKUSHITSU_KEY);
//														// ǔvg
//				
//				K7SCR_PC_RETURNVISIBLE();
//				K7SCR_EXIT_PLAYMODE();
//				K7SCR_EXIT_DEMOPAUSE();
			}
		}
		break;
#endif
//	case	K7EVENTDOOR(010009):
//	    if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_010014)!=TRUE ){
//			// RĂȂ̂܂ܒʉ
//			break;
//		}
//		// RĂ
//		if( WK7PLAYERCONTROL->SpAtkMskTest()==false ){
//			// }XN\͂gĂȂ
//			
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			
//			// Jς
//			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//			WK7CAM->SetPosition      (K7Stage103M00_Camera[DOOR_010009].pos);
//			WK7CAM->SetTargetPosition(K7Stage103M00_Camera[DOOR_010009].tgt);
//			K7SCR_PC_SETVISIBLE(false);
//			
//			K7SCR_STGC_MESSAGE_B(K7STAGE103M00_MES_CANT_ADVANCE_BY_FLAME);	// Ői߂Ȃ
//			
//			K7SCR_PC_RETURNVISIBLE();
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			
//		   	K7SCR_DEBUGPRINT("DOOR_010009 Closed : need Mask's SP");
//			K7SCR_EVCONDCHANGE();
//			return false;
//		}
//		break;
	default:
		break;
	}
	return true;
}

