////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage113M02
//
// K7Stage113M02.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE113M02_H__
#define	__K7STAGE113M02_H__

#include ".\K7Stage113M00.h"

class K7Stage113M02 : public K7Stage113{
	friend class WK7Stage;
protected:
	K7Stage113M02();
	K7Stage113M02(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage113M02();
	
	virtual bool CreateCallBack    (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
};

#ifdef	__K7STAGE113M02_CPP__

enum K7STAGE113M02_ONESHOTCAM{
	DOOR_010002,
	EVENT_010111,
	EVENT_010112,
	EVENT_010113,
};

K7StageEventOneShotCamera	K7Stage113M02_Camera[] = {
	{{ -201.578f, 11.170f, -280.252f},{-188.038f, 9.804f, -272.835f}},		// uq̌vgƂ̉o
	{{-35.041f, 9.969f, -1.331f},{-9.120f, 8.830f, -1.483f}},
	{{34.464f, 9.969f, -1.255f},{8.521f, 9.620f, -1.513f}},
	{{-0.115f, 9.969f, 33.688f},{-0.478f, 9.863f, 7.744f}},
};

enum{
	K7STAGE113M02_MES_CLOSE_FUSUMA_EVENT_010111 = 0		,		// Ղ̂ӂ܂߂EVENT_010111
	K7STAGE113M02_MES_OPEN_FUSUMA_EVENT_010111			,		// Ղ̂ӂ܂JEVENT_010111
	K7STAGE113M02_MES_CLOSE_FUSUMA_EVENT_010112			,		// ̂ӂ܂߂EVENT_010112
	K7STAGE113M02_MES_OPEN_FUSUMA_EVENT_010112			,		// ̂ӂ܂JEVENT_010112
	K7STAGE113M02_MES_CLOSE_FUSUMA_EVENT_010113			,		// 鐝̂ӂ܂߂EVENT_010113
	K7STAGE113M02_MES_OPEN_FUSUMA_EVENT_010113			,		// 鐝̂ӂ܂JEVENT_010113
};

#endif

#endif	//__K7STAGE113M02_H__

