////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage113M03
//
// K7Stage113M03.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE113M03_CPP__

#include ".\K7Stage113M03.h"
//#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn01.h"

K7Stage113M03::K7Stage113M03(ghmGcListObj *pAnchor,int prio) : K7Stage113(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage113M03_Camera);
}

K7Stage113M03::~K7Stage113M03()
{
}

bool K7Stage113M03::CreateCallBack(void)
{
	CreateOwnStageMotion(   0);
	CreateOwnStageMotion(   1);
	return true;
}

bool K7Stage113M03::SetCurrentCallBack(void)
{
	return true;
}

bool K7Stage113M03::CondChangeCallBack(void)
{
	int			i;
	for(i=1 ; i<=3 ; i++){
		MotionPlay(K7SCN01_EVFL_010103_1,0xffffffff,i);
	}
	return true;
}

bool K7Stage113M03::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(010116):
		MotionPlay(K7SCN01_EVFL_010103_1,K7STAGE113M03_MES_CLOSE_FUSUMA_EVENT_010116,1,EVENT_011116);
		break;
	case	K7EVENTNO(010115):
		MotionPlay(K7SCN01_EVFL_010103_1,K7STAGE113M03_MES_CLOSE_FUSUMA_EVENT_010115,2,EVENT_011115);
		break;
	case	K7EVENTNO(010114):
		MotionPlay(K7SCN01_EVFL_010103_1,K7STAGE113M03_MES_CLOSE_FUSUMA_EVENT_010114,3,EVENT_011114);
		break;
	default:
		break;
	}
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010103_1)==FALSE &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010103_2)==TRUE  &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010103_3)==TRUE  ){
	    K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010103);
	}else{
	    K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010103);
	}
	return true;
}

