////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage115M00
//
// K7Stage115M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE115M00_H__
#define	__K7STAGE115M00_H__

#include "..\K7Stage.h"
#include "..\..\..\Enm\EnmKIS.h"

typedef struct _KAKUZAI{
	WK7JObj		*pJObjBurn;
	WK7JObj		*pJObj;
	int			frame;
	f32			speed;
	f32			gravi;
}KAKUZAI;


class K7Stage115M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7EnmKIS		*pNpcKis;
	bool			mEnd;
	
	K7Stage115M00();
	K7Stage115M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	void KakuzaiInit(KAKUZAI *pInfoTop);
	void KakuzaiProc(KAKUZAI *pInfoTop);
public:
	virtual ~K7Stage115M00();
	virtual bool CreateCallBack    (void);
	virtual bool TerminateCallBack (void);
	virtual bool InitializeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	void KIS_OpeningDemo(void);
	virtual bool CondChangeCallBack(void);

//	virtual bool CreateCallBack(void);
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
//	virtual bool EventCallBack     (WK7EventInfo     &){ return true; }		// Cxg
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg retrun true  pXɊ܂܂郊NɃWvB
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	
};

#ifdef __K7STAGE115M00_CPP__


enum K7STAGE115M00_ONESHOTCAM{
	EN115M00,
};


K7StageEventOneShotCamera K7Stage115M00_Camera[] = {
	{{000.f,	000.f,	000.f},	{000.f,	000.f,	000.f}},
};

#define KAKUZAI_MAX	(3)
static char *pKakuzaiFireName[KAKUZAI_MAX] = {
	"BurnBeam01",
	"BurnBeam02",
	"BurnBeam03",
};
static char *pKakuzaiName[KAKUZAI_MAX] = {
	"Beam01",
	"Beam02",
	"Beam03",
};

#define KAKUZAI_RAND_POS	(8)
static Vec KakuzaiPos[KAKUZAI_RAND_POS]={
	{-37.137f, 130.841f, -102.902f},
	{58.612f, 130.841f, -103.468f},
	{58.055f, 130.841f, -57.103f},
	{-67.084f, 130.841f, -74.879f},
	{-32.339f, 130.841f, -51.569f},
	{85.088f, 130.841f, -89.847f},
	{-31.478f, 130.841f, 0.607f},
	{56.245f, 130.841f, 13.030f}
};

#endif

#endif	//__K7STAGE115M00_H__

