////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage118M00
//
// K7Stage118M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/14/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE118M00_H__
#define	__K7STAGE118M00_H__

#include "..\K7Stage.h"

#define	K7STAGE118M00_KIHAN_HS		ENENO_1_118M00_1

class K7Stage118M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage118M00();
	K7Stage118M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage118M00();
	
	virtual bool CondChangeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool InitializeCallBack(void);
	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);
};

#ifdef	__K7STAGE118M00_CPP__

enum K7STAGE118M00_ONESHOTCAM{
	HS_POS0,
	HS_POS1,
	HS_RETURN,					// ēop
};

K7StageEventOneShotCamera K7Stage118M00_Camera[] = {
	{{879.294f, 15.764f, -1973.086f},{881.628f, 13.209f, -1940.771f}},
	{{855.277f, 15.218f, -2181.836f},{856.903f, 12.841f, -2149.464f}},
	{{855.982f, 20.619f, -2185.254f},{856.367f, 19.634f, -2163.893f}},
};

//enum{
//	K7STAGE118M00_MES_JUMP = 0			,		// ɏ
//};

#endif

#endif	//__K7STAGE118M00_H__

