////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage190M01
//
// K7Stage190M01.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/05/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE190M01_H__
#define	__K7STAGE190M01_H__

#include "..\K7Stage.h"

class K7Stage190M01 : public WK7Stage{
	friend class WK7Stage;
protected:
	WK7RenderObjEffect		*mpRainEffect;
	WK7ModelMotion			*mpMskMotion;
	
	EFFECT *Billboard ;
	u32 BillboardID ;
	EFFECT *Impact ;
	u32 ImpactID ;
	EFFECT *Screen ;
	u32 ScreenID ;
	EFFECT *Smoke ;
	u32 SmokeID ;
	
	K7Stage190M01();
	K7Stage190M01(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage190M01();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo &);
};

#ifdef __K7STAGE190M01_CPP__


enum K7STAGE190M01_ONESHOTCAM{
	EV_CHARACHG_2CAM,
	EV_CHARACHG_2PC,
	EV_ROCK_CLOSE,
	EV_ROCK_BREAK,
};


K7StageEventOneShotCamera K7Stage190M01_Camera[] = {
	{{59.225f, 29.482f, 147.261f},{52.935f, 28.007f, 153.680f}},		//ĎJւ̃J
	{{29.086f, 19.982f, 210.942f},{32.229f, 25.367f, 204.303f}},		//ĎJŃL`FWLւ̃J
	{{1.195f, 2.368f, 29.090f},{1.617f, 1.009f, 38.988f}},				// ǂł
	{{-9.487f, 2.368f, 29.912f},{-17.870f, 1.607f, 35.310f}},			// ₪
};

enum{
	K7STAGE190M01_MES_ROCK_CLOSE = 0				,		// ₪ւǂł
	K7STAGE190M01_MES_ROCK_BREAK					,		// j󂵂
};

#endif

#endif	//__K7STAGE190M01_H__

