////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage206M00 LoENXe[W
//
// K7Stage206M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/23/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE160M00_CPP__

#include ".\K7Stage160M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Yam\YK7EffectBlood.h"
#include "..\..\..\Yam\YK7EffectHSDead.h"
#include "..\..\..\Yam\YK7MapSelect.h"
#include "..\..\..\sato\SK7ScenarioEnd.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Kaw\KK7BattleCtrl.h"

#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Enm\EnmKRR.h"
#include "..\..\..\Enm\EnmKIB.h"
K7Stage160M00::K7Stage160M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mEnd = false;
	GameInfo.SetMenuMapEnable(false);
	GameInfo.SetBossFlag     (true );
}
K7Stage160M00::~K7Stage160M00()
{
	GameInfo.SetMenuMapEnable(true );
	GameInfo.SetBossFlag     (false);
}

/*
	
	
	
*/
bool K7Stage160M00::InitializeCallBack(void)
{
	// 蓮Xe[Wnm
	SetManualBranch(true);
	return true;
}

/*
	
	I
	
*/
bool K7Stage160M00::TerminateCallBack(void)
{
	gpSound->mReleaseSsm( "seBossKibKrr.ssm");
	return true;
}

/*
	
	Jg
	
*/
bool K7Stage160M00::SetCurrentCallBack( void )
{
	u32		playno;
	
	while( IsChanging()==true ){
		K7SCR_RETSYS();
	}
	
	if( mEnd==true ){
		return true;
	}
	
	// ̃L
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();

	if ( K7SCR_GET_SCENARIO_FLAG(FIRST_KRR_DEMO) == FALSE ){
		
		// L
		WK7Play::StorePlayTB();
		playno = K7EVENTPLAY(01500201);
		WK7Play::PlayInit   (false,false);
		WK7Play::Prepare    (playno);
		WK7Play::PrepareWait(playno,false);
		WK7Play::StartB     (playno,false);
//		while( gpNoise->mSandRelease() == false )				K7SCR_RETSYS();
//		while( gpNoise->mGetSandFrameProc() != eSandStandby )	K7SCR_RETSYS();
//		WK7Play::PlayTB( K7EVENTPLAY(01500201) );
//		WK7Play::RestorePlayTB();
	//	WK7Play::SetPlayed(K7EVENTPLAY(01070210),false);		// LĂȂƂɂ
	
																		// LA
		while( gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL )==false ){
			K7SCR_RETSYS();
		}
		WK7Play::PlayReleaseAll();
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		WK7Play::RestorePlayTB();
		while( gpNoise->mGetSandFrameProc() != eSandExec )		K7SCR_RETSYS();
		
		K7SCR_SET_SCENARIO_FLAG(FIRST_KRR_DEMO);
	}
	
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(010501), false);					// ̃Cxg֎~i߂Ȃ
	
	gpSound->mReadSsm( "seBossKibKrr.ssm", eBankBoss );

	K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("set_start","C0_camera3",0.5f,K7SCR_CAM_PATHDIR_REV);
	
	// LoNBGMJn
	gpSound->mPlayStreamNo(HPS_BOSS_KIBKRR);
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	
	// ŒJ̐ݒ
	WK7StagePlaceInfo		*pPlaceInfo;
	pPlaceInfo = GetPlaceInfo(mID,"branchA");
	SetCameraStartPosition(pPlaceInfo);
	
	// mCY炷
	while( gpNoise->mSandRelease() == false )				K7SCR_RETSYS();
	while( gpNoise->mGetSandFrameProc() != eSandStandby )	K7SCR_RETSYS();
	
	/// LA
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_BOSSBATTLE);
	
	SetManualBranch(false);
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	// {XJnIIII
	
	while( 1 ){
		//ěςB
		WK7PLAYERCONTROL->SetKamaeDir(PI);
		
		//݁AsgȂ̂łł悵B
		if( K7EnmKRR::IsGameOver() ) break;
	  	
// fobOp
//		if( HSD_PadGetTrigger(0) & HSD_PAD_Y ) break;
		
		K7SCR_RETSYS();
		
		if ( false == WK7RenderObj::IsValid(this) ){				// Ă܂ǂHiob
			WK7PLAYERCONTROL->BattlePadRegulationSet();
			WK7PLAYERCONTROL->BattlePadRegulationSet();
			return true;
		}
		
	}

	mEnd = true;
	
	//ogIB
	KK7BattleMainTask::BattleMainTaskExit(2);
	
	/// LANA
	WK7PLAYERCONTROL->BattlePadRegulationSet();

	SK7ScenarioEnd	scnEnd;
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	K7SCR_NOISE_REQUEST();
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	K7SCR_STG_RELEASE(mID);
	WK7PLAYERCONTROL->Reset();
	WK7PLAYERCONTROL->ReleaseAll();
	WK7PLAYERCONTROL->SetOperateEnable(false);
	K7SCR_RETSYS();
	gpSound->mStopStream();
	
	playno = K7EVENTPLAY(01500202);
	WK7Play::PlayInit   (false,false);
	WK7Play::Prepare    (playno);
	WK7Play::PrepareWait(playno,false);
	WK7Play::StartB     (playno,false);
	
	K7SCR_NOISE_REQUEST();
	
	WK7Play::RestorePlayTB();
	WK7Play::PlayReleaseAll();
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	
	K7SCR_NOISE_RELEASE_TO_MAP();
	
	GameInfo.MapSelectInit(MAP_SQUARE_BUIL,MAP_VIADU);
	while( GameInfo.CheckMapSelectEnd()==false ){
		K7SCR_RETSYS();
	}
	GameInfo.MapSelectEnd();
	
	playno = K7EVENTPLAY(01100101);
	WK7Play::PlayInit   (false,false);
	WK7Play::Prepare    (playno);
	WK7Play::PrepareWait(playno,false);
	scnEnd.LoadData();
	WK7Play::StartB     (playno,false);
	
	WK7Play::PlayReleaseAll();
	K7SCR_RETSYS();
	WK7Play::RestorePlayTB();
	K7SCR_RETSYS();
	
	WK7Chara::SetRenderChara(true );
	WK7Stage::SetRenderStage(true );
	WK7Item::SetRenderItem  (true );
	
	//2.5b̊
	K7SCR_TIMEWAIT( 12000 );
	scnEnd.FrameProcess();
	scnEnd.Release();
	
	k7app.FadeStart(0,0);
	
//	//IB
//	{
//	  k7app.FadeStart(0xff,4800);
//	  k7app.SetFadeColor(0x00000000);
//
//	  while( k7app.IsFade()==true ){
//		K7SCR_RETSYS();
//	  }
//	  gpSound->mStopStream();
//	}
	
//	WK7Play::RestorePlayTB();
//	WK7Play::PlayReleaseAll();
//	K7SCR_RETSYS();
//	K7SCR_RETSYS();
	
	// NELõGl~[nEg̒ǉ
	BattleCtrl.IncTotalEnemyHunt(2);
	
	GameInfo.SetMode     (WK7GameInfo::TERM           );
	GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
  return true;
}

bool K7Stage160M00::HitObjCallBack(WK7HitObjInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(011705):
	case	K7EVENTNO(011706):
		if( info.mpJObj!=NULL ){
			Vec		vecp = {0.f, 0.f, 0.f};
			// ԂɂȂGtFNg
			CreateHSDeadEffect(info.mpJObj,
								vecp,
								VParam[ED_HSD1][0] / 10.0F,
								0.f,
								(u16)( VParam[ED_HSD2][21] * VParam[ED_FLOWER][10+((u8 )WK7PLAYERCONTROL->GetBloodTexNum()-1)] * 0.01F ),		// BloodNum ̐  (1/21/2004 Yamada)
								0,
								1,
								NULL,
								3000,
								NULL,
								false,
								false,
								80,
								0.01F,
								BLOODTEX_NORMALFLOWER,
								FALSE
			);
			// GtFNg Ԏg
			info.mpJObj->Hide(false,true);
		}
		break;
	default:
		break;
	}
	return true;
}

