////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage201M00
//
// K7Stage201M01.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2013
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE201M01_CPP__

#include ".\K7Stage201M01.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn02.h"
#include "..\..\..\Sato\SK7PanelBase.h"
#include "..\..\..\Yam\YK7EffectLensFlare.h"

#define K7STG201MOTNAME_PANEL   	"futa_panel"


//`````````````````````````````````````````````````
//			RXgN^
//`````````````````````````````````````````````````
K7Stage201M01::K7Stage201M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	K7SCR_RESET_SCENARIO_FLAG	( K7SCN02_ENFL_POP20 );
	K7SCR_RESET_SCENARIO_FLAG	( K7SCN02_ENFL_POP21 );
	K7SCR_RESET_SCENARIO_FLAG	( K7SCN02_DRFL_020101_SHORT );
	if( GetPrevStageID() == K7STGID(208,0) ){
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_DRFL_020800_SHORT)==true ){
			K7SCR_SET_SCENARIO_FLAG		( K7SCN02_ENFL_POP20 );
		}else{
			K7SCR_SET_SCENARIO_FLAG		( K7SCN02_ENFL_POP21 );
		}
		K7SCR_RESET_SCENARIO_FLAG	( K7SCN02_DRFL_020800_SHORT );
	}
	SetOneShotCamLocTbl( K7Stage201M01_Camera );
}

//`````````````````````````````````````````````````
//			fXgN^
//`````````````````````````````````````````````````
K7Stage201M01::~K7Stage201M01()
{
	// n
	::DeleteEffect( LensFlare ) ;
	::ReleaseLensFlareTexture() ;
}


//`````````````````````````````````````````````````
//			NGCg
//`````````````````````````````````````````````````
bool K7Stage201M01::CreateCallBack(void)
{
	CreateOwnStageMotion( EV_MOT_GATE );			
	return true;
}

//`````````````````````````````````````````````````
//		iǂݍݏÎɑ΂鏉j
//`````````````````````````````````````````````````
bool	K7Stage201M01::InitializeCallBack( void )
{
	HereComeANewHSInit( PR_HS_JAIA, ENENO_2_201M01_3 );
	
	// YtA
	if( GetJObj("sun") != NULL )
	{
		::SetupLensFlareTexture() ;
		while( ::CheckLensFlareTexture() == FALSE ){
			K7SCR_RETSYS() ;
		}
		LensFlare = ::CreateLensFlareEffect( GetJObj("sun") ) ;
	}
	
	//	Q[gCxg`FbN	--------------------------------------------------------
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_SETKEY ) ){	//	`͂߂Ă邩ǂ
		SimpleSetLastMotion( K7STG201MOTNAME_PANEL, EV_MOT_GATE, NULL );
		K7SCR_JOBJ_DISP( GetJObj("item08") );
	}else{
		K7SCR_JOBJ_HIDE( GetJObj("item08") );
	}	
	return true;
}

//`````````````````````````````````````````````````
//		Jg
//`````````````````````````````````````````````````
bool	K7Stage201M01::SetCurrentCallBack( void )
{
	//V^HSЉ
	if( false == HereComeANewHS(	PR_HS_JAIA,
									ENENO_2_201M01_3,								// GID
									NULL,
									CAM201M01_HS_PRESEN_START,
									CAM201M01_HS_PRESEN_END,
									0,
									211,  187,  -7,  67,1258, 112 )					// OЉp
	){
		SetManualBranch(false);
		return( true );
	}
	return true;
}


//`````````````````````````````````````````````````
//			Cxg
//`````````````````````````````````````````````````
bool K7Stage201M01::EventCallBack(WK7EventInfo &info)
{
#pragma unused(info)
#if 0
	WK7JObj*        pJObj=NULL;
	u32	oldColor;
	switch( info.mEventNo ){
		
	default:
		return true;
	}
#endif
	return false;
}


//`````````````````````````````````````````````````
//			hACxg
//`````````````````````````````````````````````````
bool K7Stage201M01::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	WK7JObj* pJObj;
//		Q[gCxg		
	case	K7EVENTDOOR(020101):		
		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_020101 )==false ){			//	CxgĂȂ
			if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_GETKEY ) ){				//	`Ă邩ǂ
				//inGame~
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				GameInfo.SetPanelCtrlOffWait(true);

				if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_SETKEY )==false ){	//	`͂߂ĂȂ
					//Jݒ
					FixCam( EV_CAM_GATE );
					K7SCR_SET_SCENARIO_FLAG( K7SCN02_DRFL_SETKEY );			
					K7SCR_RETSYS();
					K7SCR_TIMEWAIT( 4800*2 );
					//	`Zbg
					K7SCR_EVSETITEM( K7EVITEM_KEY(020101), false );
					
					K7SCR_JOBJ_DISP( GetJObj("item08") );
					gpSound->mPlaySE( SFX_SYS_AKASICITEM_SET );		//䉹	
					K7SCR_TIMEWAIT( 4800*1 );
					//[VX^[g
					gpSound->mPlaySE(SFX_SCE2_POSTOFFICE_PANEL_OPEN);
					if( (pJObj = PlayMotion( K7STG201MOTNAME_PANEL, EV_MOT_GATE)) != NULL ){
						pJObj->SetMotionLoop( false );
						while( pJObj->GetMotionState(false,true) != WK7MODEL_NOANIM ){
							K7SCR_RETSYS();
						}
					}
				}
				
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(020109), 0 );		//	Q[gpX[hpl
				K7SCR_PANEL_START();
				while( GameInfo.GetPanelModeState()!=WK7GameInfo::PMSTATE_TERM_CTRLOFFWAIT ){
					K7SCR_RETSYS();
				}
				GameInfo.SetPanelCtrlOffWait(false);	
				K7SCR_PC_SETVISIBLE( true );
				
				if( K7SCR_PANEL_GETRESULT() == 1 ){					//	
					gpSound->mPlaySE(SFX_SCE2_6MOJI_UNLOCK);		//	rd
					K7SCR_SET_SCENARIO_FLAG(K7SCN02_DRFL_020101);		//	pX[h

					GameInfo.SetPanelNoiseCancel(true);
					WK7StageDoorInfo	*pDoorInfo;
					pDoorInfo = WK7Stage::GetDoorInfo(info.mCurrStageID,
			                                  "door_020101",
			                                  info.mNextStageID,
			                                  info.mNextBpName);
					gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,pDoorInfo!=NULL? (int)pDoorInfo->mOpenSeID : NOISE_SE_MAP_DEFAULT);
					K7SCR_PANEL_TERMWAIT();
					K7SCR_RETSYS();
					K7SCR_PANEL_EXIT();
					K7SCR_PANEL_EXITWAIT();
					GameInfo.SetPanelNoiseCancel(false);
					return true;
				}else{
					//inGameĊJ
					K7SCR_PANEL_TERMWAIT();
					K7SCR_RETSYS();
					K7SCR_PANEL_EXIT();
					K7SCR_PANEL_EXITWAIT();
					K7SCR_EXIT_PLAYMODE();
					K7SCR_EXIT_DEMOPAUSE();
					K7SCR_EVCONDCHANGE();
				}					
			}else{	//	`ĂȂƂ	-------------------------------------------------
				//inGame~
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				FixCam( EV_CAM_GATE );							//Jݒ
				gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );		//䉹
				K7SCR_TIMEWAIT( 4800*2 );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );				
			}
		}else{
			return true;	
		}
		break;
		
	case 	K7EVENTDOOR(020102):
		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_020801 ) ){
			return true;
		}else{
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );

			FixCam( EV_CAM_DOOR );							//Jݒ
//			gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );		//䉹
			K7SCR_STGC_MESSAGE_B( 0 );
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );				
			return false;
		}
		break;
		
	case 	K7EVENTDOOR(020103):
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_DRFL_020101_SHORT );
		return true;

	default:
		return true;
	}
	return false;
}


//`````````````````````````````````````````````````
//			G񂾂Ƃ̃EC_RC擾Cxg
//`````````````````````````````````````````````````
bool K7Stage201M01::DieNpcCallBack(WK7DieNpcInfo &info)
{
	WK7Npc *pNpc = info.mpNpc;
	
	//	EC_r
	switch( pNpc->GetEneNo() ){
	case ENENO_2_201M01_1:		// `Q[g@㔼@iEC_j
	case ENENO_2_201M01_4:	//iEC_j
	case ENENO_2_201M01_5:	//iEC_j
	case ENENO_2_201M01_6:	//iEC_j
	case ENENO_2_201M01_7:	//iEC_j
	case ENENO_2_201M01_10:	//iEC_j
	case ENENO_2_201M01_11:	//iEC_j
	case ENENO_2_201M01_12:	//iEC_j
	case ENENO_2_201M01_13:	//iEC_j
	case ENENO_2_201M01_16:	//iEC_j
	case ENENO_2_201M01_17:	//iEC_j
	case ENENO_2_201M01_18:	//iEC_j
	case ENENO_2_201M01_19:	//iEC_j
	case ENENO_2_201M01_22:	//iEC_j
	case ENENO_2_201M01_23:	//iEC_j
	case ENENO_2_201M01_24:	//iEC_j
		K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL)++;		//_Qbg
//		gpSound->mPlaySE( SFX_SCE2_ULMAYDA_MEDAL_GET );
		if( K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) > K7SCN02_ULMEDAL_MAX ){
			K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) = K7SCN02_ULMEDAL_MAX;
		}
		break;
	}
	return true;
}




