////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage209M00
//
// K7Stage209M00.h
//
// Creator       : sato shinya (GHM)
// Creation Date : 04/16/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE209M00_H__
#define	__K7STAGE209M00_H__

#include "..\K7Stage.h"
#include "..\..\..\Yam\YK7Effect.h"

#define	TRAIN_FIRST		"t_first"
#define	TRAIN_NAME		"t01"
#define	TRAIN_LAST		"t_last"
#define TRAIN_FIRST_X	(456.0f)
#define	TRAIN_END_X		(-660.0f)
#define	TRAIN_Y			(-2)
#define	TRAIN_SIZE_X	(124.0f)
#define	TRAIN_SPEED		(2.0f)
#define	TRAIN_ALL_NUM	(12)
#define	TRAIN_MINI_NUM	(5)
#define	TRAIN_STOP_Z0	(-3271.0f)
#define	TRAIN_STOP_Z1	(-3480.0f)
#define	TRAIN_MAX_VOLUME		(255)


class K7Stage209M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	int			m_iTrainNum;
	EFFECT 		*LensFlare ;

	int			m_iSeNo;
	bool		m_bTrainSE;
	bool		m_bMoveFlag;
	
	K7Stage209M00();
	K7Stage209M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage209M00();

	virtual bool CreateCallBack    (void);              		// iǂݍݗ\sꍇȂǂɗpj
	virtual bool InitializeCallBack(void);              		// iǂݍݏÎɑ΂鏉j retrun true  ftHg̓Gǂݍ݂ɍsB
//	virtual bool CondChangeCallBack(void);
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);

	void	InitTrain();
	void	MoveTrain();
	void	MoveTrainSound( Vec* vPos, s16 inPitch );
};

#ifdef	__K7STAGE209M00_CPP__

#endif

#endif	//__K7STAGE209M00_H__

