////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage20M00
//
// K7Stage209M01.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/16/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE209M01_CPP__

#include ".\K7Stage209M01.h"
#include ".\K7Stage209M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn02.h"
#include "..\..\..\Sato\SK7PanelBase.h"
#include "..\..\..\Wat\WK7GameInfo.h"
#include "..\..\..\Sato\SK7SpecialData.h"
#include "..\..\..\Matsu\mK7Movie.h"
#include "..\..\..\Yam\YK7EffectSeenSound.h"
#include "..\..\..\Yam\YK7EffectLensFlare.h"
#include "..\..\..\kaw\KK7Sound.h"
#include "..\..\..\Wat\WK7Item.h"


#define		SONIC_WAVE_NAME		"sonic_wave"
#define		DRAG_DOOR			"door_warehouse"
#define		TRAIN_STOP1_Z0		(-3782.0f)
#define		TRAIN_STOP1_Z1		(-3932.0f)

//`````````````````````````````````````````````````
//			RXgN^
//`````````````````````````````````````````````````
K7Stage209M01::K7Stage209M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	LensFlare		= NULL;
	m_iSeNo			= 0;
	m_bTrainSE		= false;
	m_bMoveFlag		= false;
	m_bBoxSEFlag 	= false;
//	m_pEffect 		= NULL;
	m_iTrainNum 	= rand()%(TRAIN_ALL_NUM-TRAIN_MINI_NUM)+TRAIN_MINI_NUM;
	SetOneShotCamLocTbl( K7Stage209M01_Camera );
}

//`````````````````````````````````````````````````
//			fXgN^
//`````````````````````````````````````````````````
K7Stage209M01::~K7Stage209M01()
{
	K7SCR_RESET_SCENARIO_FLAG( K7SCN02_ENFL_POP19 );
	gpSound->mStopSE( SFX_SCE2_CARDBOARDBOX_YURE );
	gpSound->mStopSE( SFX_SCE2_TRAIN_LOOP );
	// n
	::DeleteEffect( LensFlare ) ;
	::ReleaseLensFlareTexture() ;
//	DeleteEffect( m_pEffect );
}

//`````````````````````````````````````````````````
//			NGCg
//`````````````````````````````````````````````````
bool K7Stage209M01::CreateCallBack(void)
{
	CreateOwnStageMotion( 0 );			//	K[W

	return true;
}

//`````````````````````````````````````````````````
//			Jg
//`````````````````````````````````````````````````
bool	K7Stage209M01::SetCurrentCallBack(void)
{	
//	if( !m_bBoxSEFlag ){
//	if( (!m_bBoxSEFlag) && (K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_020206)==true) ){
//		KK7SoundLoopSePlayVolumeChange((Vec){ 206.671f, 10.349f, -4263.335f }, K7SCR_STG_GET_CURRENTID(), SFX_SCE2_CARDBOARDBOX_YURE, 200 );
//		KK7SoundLoopSePlayVolumeChange((Vec){ 206.671f, 10.349f, -4263.335f }, K7SCR_STG_GET_CURRENTID(), SFX_SCE2_CARDBOARDBOX_YURE, 200 );
//		m_bBoxSEFlag = true;
//	}
	K7SCR_RETSYS();
	SetCurrentCallBackDefaultProc();
	while( WK7RenderObj::IsValid(this)==true && GetState()==LOADED ){
		MoveTrain();
		K7SCR_RETSYS();
	}
	return true;
}



//`````````````````````````````````````````````````
//		iǂݍݏÎɑ΂鏉j
//`````````````````````````````````````````````````
bool	K7Stage209M01::InitializeCallBack( void )
{
	// YtA
	if( GetJObj("sun") != NULL )
	{
		::SetupLensFlareTexture() ;
		while( ::CheckLensFlareTexture() == FALSE ){
			K7SCR_RETSYS() ;
		}
		LensFlare = ::CreateLensFlareEffect( GetJObj("sun") ) ;
	}
	
	InitTrain();
	
	WK7JObj *pJObj=NULL;
	//	hbOXgAqɂ̃pX̒ǉ	----------------------------------------
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020206 ) == TRUE ){
		K7SCR_STG_SET_PATHENABLE( "pass_drug", true );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(020204), false );	
		SimpleSetLastMotion( DRAG_DOOR, 0, NULL );
	}
	//	EC_RNV7	--------------------------------------------
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_ULCL07) ){
		K7SCR_EVNO_SETENABLE( K7EVENTNO(020206), false );	
	}
#if 0
	else{
			GXColor c1, c2 ;
			
			c1.r = (u8)VParam[ED_SEENSOUND][1] ;
			c1.g = (u8)VParam[ED_SEENSOUND][2] ;
			c1.b = (u8)VParam[ED_SEENSOUND][3] ;
			c1.a = (u8)VParam[ED_SEENSOUND][4] ;

			c2.r = (u8)VParam[ED_SEENSOUND][5] ;
			c2.g = (u8)VParam[ED_SEENSOUND][6] ;
			c2.b = (u8)VParam[ED_SEENSOUND][7] ;
			c2.a = (u8)VParam[ED_SEENSOUND][8] ;
			
			m_pEffect = CreateSeenSoundEffect( (Vec){ 206.671f, 10.349f, -4263.335f },		// W
									VParam[ED_SEENSOUND][13],		// 쐬҂
									VParam[ED_SEENSOUND][11],		// \
									(f32)VParam[ED_SEENSOUND][12] * 0.01F,	// 鑬x
									(f32)VParam[ED_SEENSOUND][9] * 0.01F,	// 
									c1, c2,	// F
									(f32)VParam[ED_SEENSOUND][10] * 0.01F ) ;	// L鑬x
		
		if( WK7PLAYERCONTROL->GetMainID() == K7CON ){
			K7SCR_EVNO_SETENABLE( K7EVENTNO(020206), true );	
			SetEffectDrawFlag( m_pEffect, TRUE ) ;
		}else{
			K7SCR_EVNO_SETENABLE( K7EVENTNO(020206), false );	
			SetEffectDrawFlag( m_pEffect, FALSE ) ;
		}
	}
#endif

	//	ł̐ݒ
	return true;
}

#if 0
//`````````````````````````````````````````````````
//			L`FWR[obN
//`````````````````````````````````````````````````
bool K7Stage209M01::CharaChangeCallBack   (WK7CharaChangeInfo    &info)
{
//	switch( K7CHR_MAINID(info.mCurrCharaID) ){
//	case K7CON:
//		if( !K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_ULCL07) ){
//			K7SCR_EVNO_SETENABLE( K7EVENTNO(020206), true );	
/			SetEffectDrawFlag( m_pEffect, TRUE ) ;
		}
		break;
	default:
		if( !K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_ULCL07) ){
			K7SCR_EVNO_SETENABLE( K7EVENTNO(020206), false );	
			SetEffectDrawFlag( m_pEffect, FALSE ) ;
		}
		break;
	}
	return true;
}
#endif

//`````````````````````````````````````````````````
//			Cxg
//`````````````````````````````````````````````````
bool K7Stage209M01::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){		
//		ʐ^CxgbZ[Ŵ		
	case 	K7EVENTNO(020204):
		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020206 ) == TRUE )	return false;	//CxgI`FbN
		//inGame~
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( true );
		FixCam( EV_CAM_DRAG );
		K7SCR_STGC_MESSAGE_B( MES_K7STG209_1 );
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( true );
		return true;

//		ʐ^Cxg		
	case K7EVENTNO(020209):
		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020206 ) == TRUE )	return true;	//CxgI`FbN
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_EVFL_020206 );
	
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		while( gpNoise->mSandRequest(eSandLongNoise)==false ){
			GHMGCTASK_RETSYS();
		}
		while( WK7Stage::ReleaseStageArchive()==false ){
			K7SCR_RETSYS();
		}
		while( WK7Stage::IsReleasedStageArchive()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->ReleaseTempData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
			K7SCR_RETSYS();
		}
		while( gpMovie->mGetStatus()!=eMvProcStandby ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		PlayMovie3(K7MOV_DRAGSTORE);
/*
#ifdef	_DEBUG
		ghmGcFile		file;
		if( file.Open( pFileName )==true ){
			file.Close();
#endif
			while( gpMovie->mRequest(pFileName)==false ){
				K7SCR_RETSYS();
			}
			
#ifdef	_DEBUG
		}
#endif
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		while( gpMovie->mGetStatus()!=eMvProcStandby ){
			if( gpMovie->mGetFrame() >= 1 && (HSD_PadGetTrigger(0) & HSD_PAD_START) ){
				gpMovie->mStop();
				while( gpMovie->mGetStatus()!=eMvProcStandby ){
					K7SCR_RETSYS();
				}
				break;
			}
			K7SCR_RETSYS();
		}
#ifdef	K7STAGE_MOVIE_DEBUG
		K7AppDumpMemoryType(1);
		while( !(HSD_PadGetTrigger(1) & HSD_PAD_A) ){
			K7SCR_RETSYS();
		}
#endif
*/
		while( gpNoise->mSandRequest(eSandLongNoise)==false ){
			GHMGCTASK_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->LoadData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7Stage::RestoreStageArchive()==false ){
			K7SCR_RETSYS();
		}
		while( WK7Stage::IsRestoredStageArchive()==false ){
			K7SCR_RETSYS();
		}
		SimpleSetStartMotion( DRAG_DOOR, 0, NULL );
		FixCam( EV_CAM_GARAGE );
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}

//		K7SCR_MOVIE_PLAY( K7MOV_DRAGSTORE );					//	[r[
		//	K[W[V	-------------------------------------
		//inGame~
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
//		K7SCR_PC_SETVISIBLE( false );

//		K7SCR_STGC_MESSAGE( MES_K7STG209_3 );
//		K7SCR_STG_MESSAGE_B( MES_K7STG209_3 );
		gpSound->mPlaySE( SFX_SCE2_DRUGSTORE_UNLOCK );
		//J߂
		SimplePlayMotionB( DRAG_DOOR, 0, NULL );		
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_ENFL_POP19 );
		K7SCR_STG_SET_PATHENABLE( "pass_drug", true );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(020204), false );
		K7SCR_STG_MESSAGE_B( MES_K7STG209_3 );
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
//		KK7SoundLoopSePlayVolumeChange((Vec){ 206.671f, 10.349f, -4263.335f }, K7SCR_STG_GET_CURRENTID(), SFX_SCE2_CARDBOARDBOX_YURE, 200 );
		m_bBoxSEFlag = true;

		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( true );
		return true;
				
//		EC_OVCxg		

	case	K7EVENTNO(020206):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_ULCL07) ) 	return true;
//		if( WK7PLAYERCONTROL->GetMainID() != K7CON )		return true;
		//inGame~
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
//		K7SCR_PC_SETVISIBLE( false );

		//GtFNg
//		DeleteEffect( m_pEffect );
		//ACe擾ʂ\
		K7SCR_STG_ITEMGET_B( MES_K7STG209_0 );
		//EC_07擾
		K7SCR_SET_SCENARIO_FLAG(K7SCN02_EVFL_ULCL07);
		//WNV
		K7SCR_EVNO_SETENABLE( K7EVENTNO(020206), false );
		
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
//		K7SCR_PC_SETVISIBLE( true );
		return true;
		
	default:	
		break;
	}	
	return false;
}

//`````````````````````````````````````````````````
//			ԕύXitOɂԕύX邽߂ɗpj
//`````````````````````````````````````````````````
bool K7Stage209M01::CondChangeCallBack(void)
{	
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020206 ) == TRUE ){
		K7SCR_STG_SET_DISABLEPATHCAMERA("event_020210",true);
		K7SCR_STG_SET_DISABLEPATHCAMERA("event_020209",true);
	}
	return true;
}
	

//`````````````````````````````````````````````````
//			hACxg
//`````````````````````````````````````````````````
bool K7Stage209M01::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){

//		X֋ǃCxg		
	case	K7EVENTDOOR(020203):
		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_020203 ) ) return true;
		for( int i = 0; i < K7SCN02_ULCOLE_NUM; i++ ){
			if( !K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_ULCL01+i ) ){	//	Rv[gĂȂ
				//inGame~
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//JZbg	
				FixCam( EV_CAM_POST );
				K7SCR_STGC_MESSAGE_B( MES_K7STG209_1 );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
				return false;
			}
		}
		//inGame~
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( false );
		//JZbg	
		FixCam( EV_CAM_POST );
		K7SCR_STGC_MESSAGE_B( MES_K7STG209_2 );
		gpSound->mPlaySE( SFX_SCE2_POSTOFFICE_UNLOCK );
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( true );
		
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_DRFL_020203 );
		char*	filename = "/Movie/postman.h4m";
		
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		while( gpNoise->mSandRequest(eSandLongNoise)==false ){
			GHMGCTASK_RETSYS();
		}
/*		while( WK7Stage::ReleaseStageArchive()==false ){
			K7SCR_RETSYS();
		}
		while( WK7Stage::IsReleasedStageArchive()==false ){
			K7SCR_RETSYS();
		}
*/		
		K7SCR_PC_VISIBLE( false );
		WK7Chara::SetRenderChara(false);
		WK7Stage::SetRenderStage(false);
		WK7Item::SetRenderItem  (false);

		K7SCR_RETSYS();
		K7SCR_RETSYS();

		WK7PLAYERCONTROL->SetOperateEnable(false);
		WK7PLAYERCONTROL->ReleaseArchive();
		while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
			K7SCR_RETSYS();
		}
		WK7Stage::DeleteStage(this);
		K7SCR_RETSYS();
	
		while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->ReleaseTempData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
			K7SCR_RETSYS();
		}
		while( gpMovie->mGetStatus()!=eMvProcStandby ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		PlayMovie3(K7MOV_POSTMAN);
/*
	#ifdef	_DEBUG
		ghmGcFile		file;
		if( file.Open(filename)==true ){
			file.Close();
	#endif
		while( gpMovie->mRequest(filename)==false ){
			K7SCR_RETSYS();
		}
	#ifdef	_DEBUG
		}
	#endif
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		while( gpMovie->mGetStatus()!=eMvProcStandby ){
			if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
				gpMovie->mStop();
				while( gpMovie->mGetStatus()!=eMvProcStandby ){
					K7SCR_RETSYS();
				}
				break;
			}
			K7SCR_RETSYS();
		}
*/
		while( gpNoise->mSandRequest(eSandLongNoise)==false ){
			GHMGCTASK_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->LoadData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
			K7SCR_RETSYS();
		}
		WK7Chara::SetRenderChara(true );
		WK7Stage::SetRenderStage(true );
		WK7Item::SetRenderItem  (true );
/*		while( WK7Stage::RestoreStageArchive()==false ){
			K7SCR_RETSYS();
		}
		while( WK7Stage::IsRestoredStageArchive()==false ){
			K7SCR_RETSYS();
		}
*/		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		K7SCR_PC_SETVISIBLE( true );
		return true;
	}
	return false;
}

//`````````````````````````````````````````````````
//			_o
//`````````````````````````````````````````````````
bool	K7Stage209M01::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	evno   = GetBpEventNo( info );
	int	pathNo = GetBpPathNo( info );
	if( evno==0xffffffff )		return true;
		
	switch( evno ){
#if 0
	case	K7EVENTNO( 020211 ):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_ULCL07) )	return true;
//		if( WK7PLAYERPATHCONTROL->GetCurrentPathInfo()->GetDir() == 1 ){			
//			gpSound->mStopSE( SFX_SCE2_CARDBOARDBOX_YURE );
//		}else{
			//inGame~
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			K7SCR_PC_SETVISIBLE( false );
			//Jݒ
//			FixCam( EV_CAM_ULCL7 );
//			gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );		//䉹
//			K7SCR_RETSYS();
//			while( gpSound->mCheckSE( SFX_SYS_APPEAR_RIDDLE ) ){
//				K7SCR_RETSYS();
//			}
			//h鉹
//			gpSound->mPlaySE3D(SFX_SCE2_CARDBOARDBOX_YURE, myPos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
//			gpSound->mPlaySE3D( SFX_SCE2_CARDBOARDBOX_YURE, 220 );
//			K7SCR_RETSYS();
//			K7SCR_TIMEWAIT( 4800 * 1 );

			//inGameĊJ
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			K7SCR_PC_SETVISIBLE( true );
		}
		break;
#endif	
	case K7EVENTNO( 020212 ):
		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020206 ) == TRUE )	return true;	//CxgI`FbN
		if( WK7PLAYERPATHCONTROL->GetCurrentPathInfo()->GetDir() == 1 ) return true;
		gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );		//䉹
		break;
		
	case K7EVENTNO( 020213 ):
		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020206 ) == TRUE )	return true;	//CxgI`FbN
		if( WK7PLAYERPATHCONTROL->GetCurrentPathInfo()->GetDir() == 0 ) return true;
		gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );		//䉹
		break;
	}
	return true;
}


//`````````````````````````````````````````````````
//			G񂾂Ƃ̃EC_RC擾Cxg
//`````````````````````````````````````````````````
bool K7Stage209M01::DieNpcCallBack(WK7DieNpcInfo &info)
{
	WK7Npc *pNpc = info.mpNpc;
	
	//	EC_r
	switch( pNpc->GetEneNo() ){
	case ENENO_2_209M01_4:		//iEC_j
	case ENENO_2_209M01_5:		//iEC_j
	case ENENO_2_209M01_6:		//iEC_j
	case ENENO_2_209M01_9:		//iEC_j
	case ENENO_2_209M01_10:		//iEC_j
	case ENENO_2_209M01_11:		//iEC_j
	case ENENO_2_209M01_14:		//iEC_j
	case ENENO_2_209M01_15:		//iEC_j
	case ENENO_2_209M01_16:		//iEC_j
	case ENENO_2_209M01_19:		//iEC_j
	case ENENO_2_209M01_20:		//iEC_j
	case ENENO_2_209M01_21:		//iEC_j	
		K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL)++;		//_Qbg
		if( K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) > K7SCN02_ULMEDAL_MAX ){
			K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) = K7SCN02_ULMEDAL_MAX;
		}
		break;
	}
	return true;
}



//`````````````````````````````````````````````````
//			Ԉړ
//`````````````````````````````````````````````````
void		K7Stage209M01::InitTrain()
{
	int i;
	Vec vPos;
	char name[255];
	for( i = 0; i < TRAIN_ALL_NUM; i++ ){
		if( i < m_iTrainNum ){
			if( i == 0 )	sprintf( name, TRAIN_FIRST );
			else if( i == m_iTrainNum-1 ) 	sprintf( name, TRAIN_LAST );
			else	sprintf( name, "t%02d", i );
			mpModel->GetObj( name )->GetWorldPosition( &vPos ); 
			vPos.x = TRAIN_FIRST_X+(TRAIN_SIZE_X*i);
			vPos.y = TRAIN_Y;
			mpModel->GetObj( name )->SetWorldPosition( &vPos ); 
			mpModel->GetObj( name )->Disp();
		}else{
			if( i == 11 ) break;
			if( i == m_iTrainNum ){
				sprintf( name, "t%02d", m_iTrainNum-1 );
				mpModel->GetObj( name )->Hide( false, true );
			}
			sprintf( name, "t%02d", i );
			mpModel->GetObj( name )->Hide( false, true );
		}
	}
}

//`````````````````````````````````````````````````
//			ԈړCxg
//`````````````````````````````````````````````````
void		K7Stage209M01::MoveTrain()
{
	Vec vPos, vChara;
	char name[255];
	f32 TrainSpeed=0.0f;
	WK7PLAYERCONTROL->GetPosition( &vChara );
	for( int i = 0; i < m_iTrainNum; i++ ){
		if( i == 0 )	sprintf( name, TRAIN_FIRST );
		else if( i == m_iTrainNum-1 ) 	sprintf( name, TRAIN_LAST );
		else	sprintf( name, "t%02d", i );
		mpModel->GetObj( name )->GetWorldPosition( &vPos ); 
		if( vChara.z >= TRAIN_STOP1_Z1 ){
			if( vChara.z >= TRAIN_STOP1_Z0 ){
				TrainSpeed = 0.0f;
			}else{
				TrainSpeed = (TRAIN_STOP1_Z0-vChara.z)/(TRAIN_STOP1_Z0-TRAIN_STOP1_Z1)*TRAIN_SPEED;
			}
		}else{
			TrainSpeed = TRAIN_SPEED;
		}		
		vPos.x -= TrainSpeed;
		mpModel->GetObj( name )->SetWorldPosition( &vPos ); 
		//	Ԍ̗
		if( m_iTrainNum-1 != i )	continue;
		if( vPos.x <= TRAIN_END_X ){
			m_iTrainNum = rand()%(TRAIN_ALL_NUM-TRAIN_MINI_NUM)+TRAIN_MINI_NUM;			
			InitTrain();
		}
	}
	//	TEhvZ
	Vec vFirst, vLast, vAns;
	mpModel->GetObj( TRAIN_FIRST )->GetWorldPosition( &vFirst ); 
	mpModel->GetObj( TRAIN_LAST )->GetWorldPosition( &vLast ); 
	
	if( vFirst.x > 0 ){
		vAns = vFirst;
	}else if( vLast.x < 0 ){
		vAns = vLast;
	}else{
		vAns.x = vAns.y = 0;
		vAns.z = vLast.z;
	}
	//	sb`vZ
	s16 Pitch=0;
	
	if( vChara.z >= TRAIN_STOP1_Z0 ){
		if( m_bTrainSE && m_bMoveFlag ){
			gpSound->mStopSE( SFX_SCE2_TRAIN_LOOP );
			gpSound->mPlaySE3D( SFX_SCE2_TEXAS_TRAIN_STOP, vAns, 1, 255 );			
			m_bTrainSE  = false;
			m_bMoveFlag = false;
		}
	}else{
		if( !m_bMoveFlag ){
			gpSound->mPlaySE3D( SFX_SCE2_TEXAS_TRAIN_START, vAns, 1, 255 );			
		}
		m_bMoveFlag = true;
		if( vChara.z >= TRAIN_STOP1_Z1 ){
			Pitch = (s16)(-(vChara.z-TRAIN_STOP1_Z1)*15);			
		}else{
			Pitch = 0;
		}
		MoveTrainSound( &vAns, Pitch );	
	}
}

//`````````````````````````````````````````````````
//			ԈړCxg
//`````````````````````````````````````````````````
void		K7Stage209M01::MoveTrainSound( Vec* vPos, s16 inPitch )
{
	u8		getVolume, getPan;
	if( m_bTrainSE == false ){
		m_iSeNo = gpSound->mPlaySE( SFX_SCE2_TRAIN_LOOP );
		m_bTrainSE = true;
	}
	// {[쐬
	seVolCalc( *vPos, TRAIN_MAX_VOLUME, &getVolume, &getPan, 1);
	// {[ύXit[wj
	gpSound->mSetVolumeSENo( m_iSeNo, getVolume, 1 );
	// pύXit[wj
	gpSound->mSetPanSENo( m_iSeNo, getPan );
	//zԍŃsb`ݒ
	gpSound->mSetPitchSENo( m_iSeNo, inPitch );

}


