////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage20M00
//
// K7Stage212M00.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/16/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE212M00_CPP__

#include ".\K7Stage212M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn02.h"
#include "..\..\..\Sato\SK7PanelBase.h"
#include "..\..\..\Wat\K7GlobalFlag.h"
#include "..\..\..\panel\SK7PanelGacha.h"


//`````````````````````````````````````````````````
//			RXgN^
//`````````````````````````````````````````````````
K7Stage212M00::K7Stage212M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage212M00_Camera );
}

//`````````````````````````````````````````````````
//			fXgN^
//`````````````````````````````````````````````````
K7Stage212M00::~K7Stage212M00()
{
}

//`````````````````````````````````````````````````
//		iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//`````````````````````````````````````````````````
bool	K7Stage212M00::InitializeCallBack( void )
{
	WK7JObj	*pJObj;
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_021203) ){
		//WNV
		K7SCR_EVNO_SETENABLE( K7EVENTNO(021201), false );
		//EC_̕\
		if( (pJObj = GetJObj("ulmeyda")) != NULL ){
			pJObj->Hide( false, true );
		}
	}
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_021202 ) ){
		if( (pJObj = GetJObj("blood1")) != NULL ){
			pJObj->Hide( false, true );
		}
	}else{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(021201), false );	//	ERւ̃WNV
	}

	return true;
}


//`````````````````````````````````````````````````
//			Cxg
//`````````````````````````````````````````````````
bool K7Stage212M00::EventCallBack(WK7EventInfo &info)
{
	const int tblULCL[]={ 
		K7SCN02_EVFL_ULCL01, 
		K7SCN02_EVFL_ULCL02,
		K7SCN02_EVFL_ULCL03,
		K7SCN02_EVFL_ULCL04,
		K7SCN02_EVFL_ULCL05,
		K7SCN02_EVFL_ULCL06,
		K7SCN02_EVFL_ULCL08,
		K7SCN02_EVFL_ULCL09,
		K7SCN02_EVFL_ULCL10,
		K7SCN02_EVFL_ULCL11,
	};
	switch( info.mEventNo ){
		
//		ERV[NbgCxg		

	case	K7EVENTNO(021201):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_021202) ){
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
//			K7SCR_PC_SETVISIBLE( false );

			FixCam(EV_CAM_ULCL);
			K7SCR_TIMEWAIT( 4800 * 2 );
			//EC_̕\
		//	WK7JObj	*pJObj;
		//	if( (pJObj = GetJObj("ulmeyda")) != NULL ){
		//		pJObj->Hide( false, true );
		//	}
			//ACe擾ʂ\
		//	K7SCR_STG_ITEMGET_B( MES_K7STG212_0 );
//			K7SCR_TIMEWAIT( 4800 * 1 );
//			K7SCR_PC_SETVISIBLE( true );
		//	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
			SimpleItemGetMes( MES_K7STG212_0, "ulmeyda", true );
			//EC_V[Nbg擾
			int num=0;
			K7SCR_SET_SCENARIO_FLAG(K7SCN02_EVFL_ULCLSECRET);
			K7SCR_SET_SCENARIO_FLAG(K7SCN02_EVFL_021203);
			for( int i = 0; i < ULCL_GET_MAX-1; i++ ){
				if( K7SCR_GET_SCENARIO_FLAG( tblULCL[i] )==true ){
					num++;
				}
			}
			if( num == ULCL_GET_MAX-1 ){
				K7SCR_SET_SCENARIO_FLAG( K7SCN02_EVFL_ULCLGACHA );
			}
			//WNV
			K7SCR_EVNO_SETENABLE( K7EVENTNO(021201), false );
			K7SCR_RETSYS();			

			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}else{
			FixCam(EV_CAM_ULCL);
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );		//擾SEĐ
			//bZ[WtJݒ
			FixCam( EV_CAM_BLOOD );
			K7SCR_STG_MESSAGE_B( 1 );
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			return true;
		}
		break;
	default:
		return true;
	}
	return false;
}


//`````````````````````````````````````````````````
//			\̓Cxg
//`````````````````````````````````````````````````
bool K7Stage212M00::SpAbilityCallBack(WK7SpAbilityInfo &info)
{
//	t	
	switch( info.mAbilityID ){
	case	PC_SPA_BLOODY_SHOWER:
		WK7PlayerSpInfoKed	*pKedInfo = WK7PLAYERCONTROL->GetSpInfoKed();
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_021202)==TRUE ){
			WK7PLAYERCONTROL->SetSpAbilityCancel(true);
			return false;
		}
		K7SCR_SET_SCENARIO_FLAG(K7SCN02_EVFL_021202);
		K7SCR_EVNO_SETENABLE( K7EVENTNO(021201), true );
		WK7PLAYERCONTROL->SetSpInfoType(1);
		pKedInfo->mpTargetJObj = GetJObj("blood1");
		pKedInfo->mKedPos .x = -32.0f;
		pKedInfo->mKedPos .y = 0.0f;
		pKedInfo->mKedPos .z = -211.0f;
		pKedInfo->mKedRotY   = -2.159f;
		pKedInfo->mZanPos .x = -40.205f;
		pKedInfo->mZanPos .y = 0.0f;
		pKedInfo->mZanPos .z = -213.977f;
		pKedInfo->mZanRotY   = HALF_PI;
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED2_MOTSTART     ){
			K7SCR_RETSYS();
		}
		FixCam(EV_CAM_KAEDE);
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED2_ZANAPPEAR    ){
			K7SCR_RETSYS();
		}
		Vec vPos={-17.667f,1.089f,-204.680f};
		Vec vTar={-25.840f,4.956f,-208.951f};
		WK7CAM->StartLinearInterpolateOnLinearPath(vPos, vTar, 50.0f );//mpOneShotCamera[1].pos, mpOneShotCamera[1].tgt, 50.0f);

		gpSound->mPlaySE(	SFX_PC_KED_MIZARU_FINGER  );
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED2_KUIKUI ){
			K7SCR_RETSYS();
		}
		FixCam(EV_CAM_MIZARU);
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED2_BLOODSTART ){
			K7SCR_RETSYS();
		}
		FixCam(EV_CAM_BLOOD);
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED2_MESSTART ){
			K7SCR_RETSYS();
		}
		while( WK7PLAYERCONTROL->SpAtkEffectEndTest(mID,K7KED)==false ){
			K7SCR_RETSYS();
		}
		return false;
	}
	return true;
}

//`````````````````````````````````````````````````
//			_o
//`````````````````````````````````````````````````
bool	K7Stage212M00::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	evno   = GetBpEventNo( info );
	int	pathNo = GetBpPathNo( info );
	if( evno==0xffffffff )		return true;

	switch( evno ){
	case K7EVENTNO( 021202 ):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_021202)==TRUE )	return true;
		if( WK7PLAYERPATHCONTROL->GetCurrentPathInfo()->GetDir() == 1 ) return true;
		gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );		//擾SEĐ		
		break;
	}
	return true;
}