////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage309M00 ΂̋
//
// K7Stage309M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE309M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage309M00.h"
#include "..\..\..\sato\SK7Special.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Effect.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Yam\YK7EffectModelFire.h"
#include "..\..\..\Yam\YK7EffectBillboard.h"
#include "..\..\..\Kaw\KK7Sound.h"

//f
#define	MDL309M00_DOOR			"animation"	//Ō̃hA[
#define	MDL309M00_FIRE			"burn"		//̔R镔

#define	PATH309M00_FIREROAD		"curve3_campath"		//̔R镔
#define	PATH309M00_GORIRA		"gorira"				//SQ[̑ÕpX

//bZ[W
#define	MES309M00_00		(0)							// ̓bNĊJȂ
#define	MES309M00_01		(1)							// 邭9ւ̔J

#define	MES309M00_02		(2)							//
#define	MES309M00_03		(3)							//

#define	MES309M00_WATERRING	(4)
#define	MES309M00_WINDRING	(5)
#define	MES309M00_NORING	(6)

#define	MES309M00_HIT		(7)							// I
#define	MES309M00_ALLCLEAR	(8)							// SĂ̋SS|


#define CAM309M00_GOLI_PATHNAME2			"gorira"

K7Stage309M00::K7Stage309M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpFireEffect = NULL;
	mpWater      = NULL;
	mSoundChange = 0;
	SetOneShotCamLocTbl( K7Stage309M00_Camera );
}

K7Stage309M00::~K7Stage309M00()
{
}


/*
	
	NGCg
	
*/
bool K7Stage309M00::CreateCallBack(void)
{
	CreateOwnStageMotion(0000);
	
	//GtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
//	//GtFNg
//	while( WK7RenderObj::CreateEffectBillResource(BILLEFF_SPRINKLER) == NULL )
//	{
//		K7SCR_RETSYS();
//	}
	
	return true;
}




/*
	
	
	
*/
bool K7Stage309M00::InitializeCallBack(void)
{
	WK7JObj *pJObj;
	int i;
	int evNo[ONI_MATO]={
		K7SCN03_EVFL_030521,
		K7SCN03_EVFL_030522,
		K7SCN03_EVFL_030523,
		K7SCN03_EVFL_030524,
		K7SCN03_EVFL_030525,
		K7SCN03_EVFL_030526,
	};

	// S̓I
	{
		for(i=0; i<ONI_MATO; i++){
			while( (pJObj = GetJObj(pHitName[i]))==NULL ){
				retsys();
			}
			if( K7SCR_GET_SCENARIO_FLAG(evNo[i])==TRUE ){						// jς
				pJObj->Hide(false,true);										// qbgIuWF
			}
		}
	}
	
	if ( K7SCR_GET_SCENARIO_FLAG(K7SCN03_DRFL_030503)==false ){
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(030503), false);
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(030503), true);
		
		// [VĐ
		if( (pJObj=PlayMotion("animation", 0))!=NULL ){
			K7SCR_RETSYS();
		}
		pJObj->SetMotionLoop(false);
	}
	
	
	BridgeFireStart();
	
	K7SCR_EVCONDCHANGE();
	
	return true;
}

bool K7Stage309M00::TerminateCallBack( void )
{
	//̃GtFNgIi΂̋Hj
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030503) == FALSE )
	{
		BridgeFireEnd();
	}
	while( WK7RenderObj::ReleaseEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
//	while( WK7RenderObj::ReleaseEffectAnimResource(BILLEFF_SPRINKLER) == NULL )
//	{
//		K7SCR_RETSYS();
//	}
	
	return true;
}

bool K7Stage309M00::CondChangeCallBack(void)
{
	WK7JObj		*pJObj = GetJObj("event_015300_cmn");
	
	// Ȃ̔ʂ̑Iʂ˂
	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030503)==TRUE){							// ΏH
		
		if ( 0 == mSoundChange ){
			gpSound->mPlayStreamNo(HPS_ISZK_L);
		}
		
		K7SCR_STG_SET_PATHENABLE(PATH309M00_FIREROAD, true);
		K7SCR_EVNO_SETENABLE(K7EVENTNO(030503),false);									// wւgCxg
//		K7SCR_JOBJ_HIDE(pJObj);
		
		if ( mpFireEffect != NULL ){
			ReleaseEffect(mpFireEffect);
			mpFireEffect = NULL;
		}
		
	}else{
		
		gpSound->mPlayStreamNo(HPS_ISZK_N);
		
		K7SCR_STG_SET_PATHENABLE(PATH309M00_FIREROAD, false);
		K7SCR_EVNO_SETENABLE(K7EVENTNO(030503),true );									// wւgCxg
//		K7SCR_JOBJ_DISP(pJObj);
	}
	
	// SJǂ
	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_0305XX_ALL)==TRUE){
		K7SCR_STG_SET_DISABLEPATHCAMERA(CAM309M00_GOLI_PATHNAME2,	true);
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(030508), true);								// ǂ̃V[gJbg
	}else{
		K7SCR_STG_SET_DISABLEPATHCAMERA(CAM309M00_GOLI_PATHNAME2,	false);
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(030508), false);								// ǂ̃V[gJbg֎~
	}
	
	return true;
}


/*
	
	Jg
	
	
*/
bool K7Stage309M00::SetCurrentCallBack(void)
{
	// Ȃ̔
	K7SCR_EVCONDCHANGE();
	
	while( K7SCR_STG_GET_CURRENTID() == K7STGID(309,0) ){
		if( strcmp(WK7PLAYERPATHCONTROL->GetCurrentPathName(), PATH309M00_GORIRA) == 0 )
		{
			// SÕpXɂA\S
			WK7PLAYERCONTROL->SetKamaeDir(1.57f);
			
			// Ȃ
			if ( 0 == mSoundChange ){
				gpSound->mPlayStreamNo(HPS_POP);
				mSoundChange++;
			}
		}
		
		K7SCR_RETSYS();
	}
	return true;
}


/*
	
	
	qbgIuWF
	
	
*/
bool K7Stage309M00::HitObjCallBack(WK7HitObjInfo &info)
{
	int	evFlag, camNo;
	
	switch( info.mEventNo ){
	case	K7EVENTNO(030521):
		evFlag	= K7SCN03_EVFL_030521;
		camNo = EV_030521;
		goto HIT_OK;
	case	K7EVENTNO(030522):
		evFlag	= K7SCN03_EVFL_030522;
		camNo = EV_030522;
		goto HIT_OK;
	case	K7EVENTNO(030523):
		evFlag	= K7SCN03_EVFL_030523;
		camNo = EV_030523;
		goto HIT_OK;
	case	K7EVENTNO(030524):
		evFlag	= K7SCN03_EVFL_030524;
		camNo = EV_030524;
		goto HIT_OK;
	case	K7EVENTNO(030525):
		evFlag	= K7SCN03_EVFL_030525;
		camNo = EV_030525;
		goto HIT_OK;
	case	K7EVENTNO(030526):
		evFlag	= K7SCN03_EVFL_030526;
		camNo = EV_030526;
HIT_OK:
		
		K7SCR_SET_SCENARIO_FLAG(evFlag);				// ItOĂ
		
		info.mpJObj->Hide(false,true);					// g
//		BrokenObj("door_000214_AccessA");
		
		// 
//		pos.x = -2145.f;
//		pos.y = 0.f;
//		pos.z = -2033.f;
//		KK7DoorSmokeEffect(pos);
		
		gpSound->mPlaySE(SFX_SCE3_AHOHIT);
		
		//ogIB
		KK7BattleMainTask::BattleMainTaskExit(2);
		
		K7SCR_PC_SETVISIBLE(false);
		
		// L|[Y
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		// Wait
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
		
		// Jς
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->SetPosition      (K7Stage309M00_Camera[camNo].pos);
		WK7CAM->SetTargetPosition(K7Stage309M00_Camera[camNo].tgt);
		
		if ( GoriraLastOneTest() < 6 ){
			K7SCR_STGC_MESSAGE_B(MES309M00_HIT);						// I
		}else{
			gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
			
			K7SCR_STGC_MESSAGE_B(MES309M00_ALLCLEAR);					// SĂ̋SS|
			
			K7SCR_EVCONDCHANGE();
		}
		
		if ((K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030521)==TRUE)
		&&	(K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030522)==TRUE)
		&&	(K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030523)==TRUE)
		&&	(K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030524)==TRUE)
		&&	(K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030525)==TRUE)
		&&	(K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030526)==TRUE)
		){
			K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_0305XX_ALL);			// ACR悤ɗĂ
			
			DoorOpen();
			
			K7SCR_STG_SET_DISABLEPATHCAMERA(CAM309M00_GOLI_PATHNAME2,	true);
			WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
			WK7CAMPATHFOLLOWINFO->SetPathCamera(NULL);
			WK7CAMPATHFOLLOWINFO->SetMode(WK7CamPathFollowInfo::FOLLOW_MODE);
		
		}
		
		// L|[Y
		K7SCR_PC_SETVISIBLE(true);
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EVCONDCHANGE();
																		// J߂
		return true;
		break;
	}
	return true;
}

int K7Stage309M00::GoriraLastOneTest(void)
{
	int num = 0;

	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030521)==TRUE) num++;
	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030522)==TRUE) num++;
	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030523)==TRUE) num++;
	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030524)==TRUE) num++;
	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030525)==TRUE) num++;
	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030526)==TRUE) num++;
	
	return num;
}

/*
	
	
	hACxg
	
	
*/
bool K7Stage309M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(030503):			// rEXEFCւ̔
		if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_DRFL_030503)==TRUE){
			return true;
		}else{
			// L|[Y
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			// JύX
			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
			WK7CAM->SetPosition      (K7Stage309M00_Camera[DR_030503].pos);
			WK7CAM->SetTargetPosition(K7Stage309M00_Camera[DR_030503].tgt);
			K7SCR_PC_SETVISIBLE(false);							// l
			
			// bZ[W
			K7SCR_STGC_MESSAGE_B(MES309M00_00);							// ̓bNĊJȂ
			
			// L|[Y
			K7SCR_PC_RETURNVISIBLE();							// l߂Ao
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			return false;
		}
		break;
	}
	return true;
}


/*
	
	
	Cxg
	
	
*/
bool K7Stage309M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(030503):			// RĂ鋴
		//inGame~
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		//̎wւ̎wւ𑕔Ă邩H
		if(	(K7SCR_EVEQUIPRING(RING_WIND) == true)
		||	(K7SCR_EVEQUIPRING(RING_WATER) == true)
		){
			FixCam( ONESHOTCAM_30503 );
			K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_030503);			// Ώ
			if ( K7SCR_EVEQUIPRING(RING_WIND) == true ){
				K7SCR_STGC_MESSAGE_B( MES309M00_WINDRING );
			}else{
				K7SCR_STGC_MESSAGE_B( MES309M00_WATERRING );
			}
			
			//SEĐ@΂鉹
			gpSound->mPlaySE(SFX_SCE3_FIRE_KIERU);
			
			//
			GoOutFireplaceEffectByWater();
			
			K7SCR_EVCONDCHANGE();
		}else{
			K7SCR_PC_SETVISIBLE( false );
			
			// J{bZ[Wt
			FixCamMesWithRiddle( ONESHOTCAM_30503, MES309M00_NORING );
			
			//inGameĊJ
			K7SCR_PC_SETVISIBLE( true );
		}
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	//{[h
	case	K7EVENTNO( 030518 ):
		// L|[Y
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		FixCamMes2( EV_030518, MES309M00_02 );
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	//{[h
	case	K7EVENTNO( 030519 ):
		// L|[Y
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		FixCamMes2( EV_030519, MES309M00_03 );
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	default:
		return false;
	}
	
	return true;
}



// Ō̃hAJ
void K7Stage309M00::DoorOpen(void)
{
	WK7JObj		*pJObj;

	// nj
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(030503), true);
	K7SCR_SET_SCENARIO_FLAG(K7SCN03_DRFL_030503);
	
	// Jς
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetPosition      (K7Stage309M00_Camera[DR_030503].pos);
	WK7CAM->SetTargetPosition(K7Stage309M00_Camera[DR_030503].tgt);
	
	// [VĐ
	if( (pJObj=PlayMotion(MDL309M00_DOOR, 0))!=NULL ){
		gpSound->mPlaySE(SFX_SCE3_ONI_GATE_OPEN);
		pJObj->SetMotionLoop(false);
	}
	
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
	
	gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
	
	K7SCR_STGC_MESSAGE_B(MES309M00_01);										// 邭9ւ̔J
}

// R
void K7Stage309M00::BridgeFireStart(void)
{
	WK7JObj		*pJObj = GetJObj("burn");
	
	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030503)==FALSE){
		mpFireEffect = CreateEffectModelFire(pJObj, MFIRE_ISZK_309);
//		if( strcmp(pJObj->GetName(), MDL309M00_FIRE)==0 ){
//			mpFireEffect = pFireEffect;
//		}
	}
}

// Xɏ
void K7Stage309M00::BridgeFireEnd(void)
{
	if (mpFireEffect != NULL){
		DelReqEffect(mpFireEffect);
	}
}

//------------------------------------------------------------------------------
//
// ΂
//
//------------------------------------------------------------------------------
void K7Stage309M00::GoOutFireplaceEffectByWater(void)
{
	//΂
	BridgeFireEnd();
	
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
}


