////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage312M01 װïݼݓ@2F
//
// K7Stage312M01.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE312M01_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage312M01.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectLight.h"
#include "..\..\..\Yam\YK7EffectTeleport.h"

K7Stage312M01::K7Stage312M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage312M01_Camera );
}

K7Stage312M01::~K7Stage312M01()
{
}


/*
	
	NGCg
	
*/
bool K7Stage312M01::CreateCallBack(void)
{
	return true;
}




/*
	
	I
	
	
*/
bool K7Stage312M01::TerminateCallBack(void)
{
	return true;
}


/*
	
	
	
*/
bool K7Stage312M01::InitializeCallBack(void)
{
	if ( K7SCR_GET_SCENARIO_FLAG(K7SCN03_DRFL_030701) == true ){
		// 蓮Xe[Wnm
		SetManualBranch(true);
	}
	return true;
}

/*
	
	
	Jg
	
	
*/
bool K7Stage312M01::SetCurrentCallBack(void)
{
	// ]ĂƂ
	if ( K7SCR_GET_SCENARIO_FLAG(K7SCN03_DRFL_030701) == true ){
		K7SCR_RESET_SCENARIO_FLAG(K7SCN03_DRFL_030701);
		
		// 蓮Xe[Wnm
		// L|[Y
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		// mCY炷
		SandRelease(SFX_SCE3_MAP_CHANGE_DOOR_WOOD_CLOSE);																// mCYJiXe[Wj
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
		
		// L|[Y
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		SetManualBranch(false);
	}
	return true;
}

/*
	
	hA
	
*/
bool K7Stage312M01::DoorEventCallBack (WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(030702):								// 3F ւ̈ړ̐
		K7SCR_SET_SCENARIO_FLAG(K7SCN03_DRFL_030702);
		
		// ]GtFNgf
		
#if 0
		// L|[Y
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		// Jς
		FixCam( DR_030702 );
		
		// ]GtFNgf
//		WarpEffectStart();
		
		// [v
		gpSound->mPlaySE(SFX_SCE3_TELEPO);
		
		// Wait
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3));
		
		
		// Wait
		K7SCR_TIMEWAIT(600);
#endif
		
		return true;
	}
	return true;
}


