
////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage321M00
//
// K7Stage321M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE321M00_H__
#define	__K7STAGE321M00_H__

#include "..\K7Stage.h"

class K7Stage321M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage321M00();
	K7Stage321M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	u32				NeonPlayNo;
	WK7JObj 		*pJObj;
	WK7JObj 		*pJObjHokan;				// ۊǗp̃Aj
	WK7RenderObjEffect* pStageEfc;
	f32				NowFrame, NowFrameHokan;
	s32				loadLgtTex;
	EFFECT *pPopCornEffect;
	EFFECT *pLgtEffect;
	u32				zuruPanel;
	
	void Demo030206(void);
//	void GumOKDemo(u32 evNo);
	int PopCornMachinePopTest(void);
	u32 SeachNeonNo(void);
	bool PopCornDemoPlay(void);
	int	PopCornDemoFlag;
	
public:
	virtual ~K7Stage321M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg retrun true  pXɊ܂܂郊NɃWvB
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &);
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
};


#ifdef __K7STAGE321M00_CPP__


enum K7STAGE321M00_ONESHOTCAM{
	ONESHOTCAM_POPCORN_DEMO,
	SECTRET_0,
	SECTRET_1,
	SECTRET_2,
	SECTRET_3,
	SECTRET_4,
	ONESHOTCAM_GINDAN,
	CAM321M00_HS_PRESEN_START,
	CAM321M00_HS_PRESEN_END,
};


K7StageEventOneShotCamera K7Stage321M00_Camera[] = {
	{{25.940f, 12.614f, -594.279f},{35.745f, 4.524f, -576.898f}},					// |b|R[f
	// JGfE
	{{-37.070f, 14.663f, -440.696f},{-47.912f, 11.326f, -420.688f}},
	{{-35.666f, 9.194f, -433.707f},{-15.075f, 12.341f, -423.953f}},
	{{-13.284f, 30.340f, -421.606f},{5.053f, 41.738f, -413.679f}},
	{{-53.340f, 12.376f, -428.350f},{-45.526f, 14.609f, -435.764f}},
	{{-53.892f, 14.277f, -441.853f},{-33.045f, 23.934f, -440.789f}},
	{{21.014f, 9.622f, -612.722f},{24.925f, 12.150f, -611.231f}},					// |vR[̋e\
	{{1.164f, 7.754f, -318.899f},{1.224f, 8.071f, -306.013f}},						// Љ
	{{-0.016f, 14.663f, -703.773f},{0.044f, 14.980f, -690.887f}},					// Љ
};

enum NEON{
	neon_rocket = 0,
	neon_phenix,
	neon_gun,
	neon_cowgirl,
	neon_bike,
	NEON_MAX
};

static char *pNeonNameTable[NEON_MAX] = {
	"neon_rocket",
	"neon_phenix",
	"neon_gun",
	"neon_cowgirl",
	"neon_bike"
};

static u32 NeonPCMTable[NEON_MAX] = {
	HPS_ISZK_H2,
	HPS_ISZK_H5,
	HPS_ISZK_H3,
	HPS_ISZK_H1,
	HPS_ISZK_H4
};

#endif

#endif	//__K7STAGE321M00_H__

