////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage325M00 i01j}XNp[Abv
//
// K7Stage325M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE325M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage325M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectLight.h"
#include "..\..\..\Kaw\KK7Effect.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7BattleCtrl.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Wat\WK7GameInfo.h"
#include "..\..\..\Sato\SK7SpOption.h"
#include "..\..\..\Yam\YK7EffectMuzzle.h"
#include "..\..\..\Yam\YK7EffectHSDead.h"
#include "..\..\..\Yam\YK7EffectDraft.h"
#include "..\..\..\Matsu\MK7Movie.h"
#include "..\..\..\Fujita\C_Font.h"

//f
#define	MDL325M00_SCREEN			"event_030410"	//CXN[

//bZ[W
#define	MES325M00_MSK_BOX_OPEN		(0)				//Cɕ
#define	MES325M00_MANTKAYO			(1)				//}gI

#define	K7STAGE325M00_CLOSE_PATHNAME		"curve7"				// pXO
#define	K7STAGE325M00_RIDDLE_PATHNAME		"event_030413_0"		// JpXO

//#define	K7STAGE325M00_BROKENWALL_WINDNAME	"wind"
#define	K7STAGE325M00_BROKENWALL_WINDNAME	"pPlane21"
#define	POS325M00_CRACK				((Vec){-384.433f, 5.796f, -1248.817f})	//ǂЂъW

K7Stage325M00::K7Stage325M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mBackupBloodGauge = 0;
	mpWindEffect = NULL;
	SetOneShotCamLocTbl( K7Stage325M00_Camera );
}

K7Stage325M00::~K7Stage325M00()
{
}


/*
	
	NGCg
	
*/
bool K7Stage325M00::CreateCallBack(void)
{
	pLgtEffect = NULL;
	
	// J[V
	CreateOwnStageMotion(0);
	
	// Cgfp̃eNX`ǂݍ
	loadLgtTex = rand()%7;
	SetupLightTex(loadLgtTex);
	return true;
}


/*
	
	
	
*/
bool K7Stage325M00::InitializeCallBack(void)
{
	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030405)==TRUE){
		K7SCR_EVNO_SETENABLE(K7EVENTNO(30405), false);				// ̃Cxg֎~
	}
	
	K7SCR_EVCONDCHANGE();
	
	return true;
}

bool K7Stage325M00::CondChangeCallBack(void)
{
	WK7JObj		*pWindJObj;
	EFFECT		*pWindEffect;
	bool		wind;
	
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030410)==true ){
		wind = false;
	}else{
		if( WK7PLAYERCONTROL->GetMainID()==K7CAT ){
			wind = true;
		}else{
			wind = false;
		}
	}
	pWindJObj = GetJObj(K7STAGE325M00_BROKENWALL_WINDNAME);
	if( pWindJObj!=NULL ){
		if( wind==true && GetCurrentStageID()==mID ){
			// \
			if( IsValidEffect(mpWindEffect)==false ){
				WK7RenderObjEffectInfo	info;
				info.Create();
				if( (pWindEffect = ::CreateDraft2Effect(pWindJObj,(s32)VParam[ED_DRAFT][2]))!=NULL ){
					mpWindEffect = CreateEffect(pWindEffect,&info);
					
					// ЂъꂽǂoĂĂ錄ԕ
					CatWindSePlay( POS325M00_CRACK, K7SCN03_EVFL_030410, SFX_SCE3_SUKIMAKAZE );
				}
			}
		}else{
			if( mpWindEffect!=NULL ){
				DelReqEffect(mpWindEffect);
				mpWindEffect = NULL;
			}
		}
	}
	
	BrokenScreen(0);
	
	// XN[̃pX
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030410)==TRUE ){
		K7SCR_STG_SET_PATHENABLE       (K7STAGE325M00_CLOSE_PATHNAME ,true);
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE325M00_RIDDLE_PATHNAME,true);
	}else{
		K7SCR_STG_SET_PATHENABLE       (K7STAGE325M00_CLOSE_PATHNAME ,false);
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE325M00_RIDDLE_PATHNAME,false);
	}
	return true;
}



/*
	
	Jg
	
	
*/
bool K7Stage325M00::SetCurrentCallBack(void)
{
	// GtFNg֘A
	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030405)==TRUE){
		TreasureBoxMotionPlay();
	}
	
	K7SCR_EVCONDCHANGE();
	
	return true;
}




/*
	
	I
	
	
*/
bool K7Stage325M00::TerminateCallBack(void)
{
	if ( NULL != pLgtEffect ){
		::DelReqEffect(pLgtEffect);
	}
	
	ReleaseLightTex(loadLgtTex);
	
	return true;
}



/*
	
	Cxg
	
*/
bool K7Stage325M00::EventCallBack(WK7EventInfo &info)
{
	s32 result;

	switch( info.mEventNo ){
	case	K7EVENTNO(030405):			// 
		if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030405)==FALSE){
			
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			// Jς
			if( K7MSK == WK7PLAYERCONTROL->GetMainID() ){
				// Jς
				FixCam(ONESHOTCAM_TREASURE_OK);
				result = 1;
			}else{
				// Jς
				FixCam(ONESHOTCAM_TREASURE_NO);
				result = 0;
			}
			
			if ( result ){
				// I
				
				TreasureBoxMotionPlay();
				gpSound->mPlaySE(SFX_SCE3_TREASURE_BOX);
				gpSound->mPlaySE(SFX_SCE3_TREASURE_BOX_OPEN);
				
				K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_030405);
				K7SCR_EVNO_SETENABLE(K7EVENTNO(30405), false);				// ̃Cxg֎~
				
				K7SCR_STGC_MESSAGE_B(MES325M00_MSK_BOX_OPEN);
				
//				gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
				
				// Jς
				FixCam(ONESHOTCAM_MSKLVUP);
				
				if ( NULL != pLgtEffect ){
					::DelReqEffect(pLgtEffect);
				}
				
				// Wait
				K7SCR_TIMEWAIT(2400);
				
				// }XNxAbv
#if 0
				BattleCtrl.MskPowerUp(KK7BATTLECTRL_MSKLV_TEXAS);
				GameInfo.BloodCharaChange(K7CHRID(K7MSK,4), 1, SFX_SCE3_MSK_LVUPVOICE_TEXAS);
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
				
				// Jς
				FixCam(ONESHOTCAM_MSKLVUPCOMP);
				// t@t@[
				gpSound->mPlaySE(SFX_SCE3_MSK_LVUP);
				
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(8));
#else
				ChangeMskToTexas();
#endif
				// ȍĊJ
				gpSound->mPlayStreamNo( HPS_ISZK_D1 );
			
			}else{
				K7SCR_STGC_MESSAGE_B(MES325M00_MANTKAYO);
			}
			
			// L|[Y
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
			return false;
		}
		
		break;
	}
	return true;
}


void K7Stage325M00::TreasureBoxMotionPlay(void)
{
	WK7JObj 		*pJObj;
	
	if( (pJObj=PlayMotion("Treasure_box", 000 /*, "Treasure_box"*/))!=NULL ){
		if( pJObj != NULL ){
			pJObj->SetMotionLoop(false);
		}
	}
	
	pJObj = GetJObj("Flash");
	if ( pJObj != NULL ){
		pLgtEffect = CreateLightEffect( pJObj,
										(s32)loadLgtTex,
										(f32)VParam[ED_LIGHT][1] * 0.1F, (f32)VParam[ED_LIGHT][2] * 0.1F,
										(f32)VParam[ED_LIGHT][3] * PI_2 / 360, (f32)VParam[ED_LIGHT][4] * PI_2 / 360, 
										(f32)VParam[ED_LIGHT][5] * 0.01F ) ;
	}
}


/*
	
	
	pX͂Ȃꂽ
	
	
*/
bool K7Stage325M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(030413):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030410)==TRUE ){			// XN[j
			return true;
		}else{
			gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
		}
		break;
	default:
		return true;
	}
	return true;
}





/*
	
	
	qbgIuWF
	
	
*/
bool K7Stage325M00::HitObjCallBack(WK7HitObjInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(030410):								// XN[
		
		if ( K7MSK == WK7PLAYERCONTROL->GetMainID() ){
			
			K7SCR_TIMEWAIT(1200);
			
			//ogIB
			KK7BattleMainTask::BattleMainTaskExit(2);
			// L|[Y
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			
			K7SCR_PC_SETVISIBLE(false);
			//
			KK7DoorSmokeEffect( (Vec){-404.f, -14.2f, -1246.f} );
			
			// Ȏ~߂
			gpSound->mStopStream();
			
			BrokenScreen(1);
			SetMskWallCam( ONESHOTCAM_SCREENBROKEN );
			
			K7SCR_PC_SETVISIBLE(true);
			
			K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_030410);	// ItOĂ
			// L|[Y
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_EVCONDCHANGE();
		}
		
		return true;
		
		break;
	}
	return true;
}

// mode GtFNgA
bool K7Stage325M00::BrokenScreen(int mode)
{
	WK7JObj *pJObj;
	WK7JObj *pWindJObj;
	
	if ( mode ){
		BrokenObj(MDL325M00_SCREEN);
	}
	pWindJObj = GetJObj(K7STAGE325M00_BROKENWALL_WINDNAME);
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030410)==true || mode ){
		K7SCR_JOBJ_HIDE(pWindJObj);
	}else{
		K7SCR_JOBJ_DISP(pWindJObj);
	}
	if( (pJObj = GetJObj(MDL325M00_SCREEN))!=NULL ){
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030410) == true ){				// ǔjς݁H
			pJObj->Hide(false,true);					// g
		}else{
			pJObj->Disp(false,true);					// g
		
		}
		
		return true;
	}
	
	return false;
}

void K7Stage325M00::ChangeMskToTexas(void)
{
	EFFECT			*pPcBombEfc = NULL;
	int				tick;
	bool			zupdate;
	bool			render;
	Vec				pos;
	f32				roty;
	s8				gunDataID[2] = { -1,-1 };
	WK7Chara		*pTmpChara = NULL;
	WK7Chara		*pChara = WK7PLAYERCONTROL->GetCharaPtr();
	WK7JObj			*pJObj  = NULL;
	WK7ModelMotion	*pModelMotion = WK7PLAYERCONTROL->GetCmnModelMotion((int)WK7PLAYERCONTROL->GetMotID());
	int				i;
	WK7StageMotion	*pStageMotion =  CreateOwnStageMotion(10);
	WK7CameraMotion	*pCameraMotion = NULL;
	PCDATA			pcData;
	
	WK7PLAYERCONTROL->InitDataSet(WK7PLAYERCONTROL->GetMainID(),pcData);
	
	if( pStageMotion!=NULL ){
		while( pStageMotion->GetState() != WK7MotionObj::LOADED ){
			K7SCR_RETSYS();
		}
		pCameraMotion = pStageMotion->GetCameraMotion();
	}
	
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_WAIT);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7PLAYERCONTROL->GetPosition(&pos);
	WK7PLAYERCONTROL->GetRotY(&roty);
	
	if( pChara!=NULL ){
		if( 0 <= pcData.mGunTypeR ){
			while( (gunDataID[0]=LoadGunArchive2((s8)pcData.mGunTypeR)) < 0 ){
				K7SCR_RETSYS();
			}
		}
		if( 0 <= pcData.mGunTypeL ){
			while( (gunDataID[1]=LoadGunArchive2((s8)pcData.mGunTypeL)) < 0 ){
				K7SCR_RETSYS();
			}
		}
		if( (pTmpChara = WK7RenderObj::CreateChara(pChara->GetID()))!=NULL ){
			while( pTmpChara->GetState()!=WK7RenderObj::LOADED ){
				K7SCR_RETSYS();
			}
			pTmpChara->CreatePrivateLight();
			pTmpChara->SetStageLight(false);
//			pTmpChara->SetRenderFlag(true);
			pTmpChara->SetPosition(pos);
			pTmpChara->SetRotY(roty);
//			pTmpChara->SetClothEnable(false);
			WK7Model	*pModel;
			if( (pModel = pTmpChara->GetModel())!=NULL ){
				pModel->AttachMotion(pModelMotion);
				pModel->PlayMotion  (-1.0f);
				pModel->SetMotionLoop(false);
				pJObj = pModel->GetObj(K7CHRBONE_WAIST);
//				pJObj->CopyUserDefinedMatrix(WK7PLAYERCONTROL->GetWaistObjPtr());
				pJObj->CopyTRS(WK7PLAYERCONTROL->GetWaistObjPtr());
			}
			if( gunDataID[0] >= 0 ){
				while( CheckGunArchiveLoad(gunDataID[0])==TRUE ){
					K7SCR_RETSYS();
				}
				AttachGunModel2(gunDataID[0],
				                NULL,
				                pTmpChara->GetModel(),
				                GUN_HAND_R
				);
			}
			if( gunDataID[1] >= 0 ){
				while( CheckGunArchiveLoad(gunDataID[1])==TRUE ){
					K7SCR_RETSYS();
				}
				AttachGunModel2(gunDataID[1],
				                NULL,
				                pTmpChara->GetModel(),
				                GUN_HAND_L
				);
			}
		}
	}
	
	K7SCR_RETSYS();
	pTmpChara->SetRenderFlag(true);
	
	WK7PLAYERCONTROL->SetEnableOnly(true );
	WK7PLAYERCONTROL->SetVisible(false);
	WK7PLAYERCONTROL->ReleaseArchive();
	while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
		K7SCR_RETSYS();
	}
	// eLTX
	BattleCtrl.MskPowerUp(KK7BATTLECTRL_MSKLV_TEXAS);
	WK7PLAYERCONTROL->RestoreArchive();
	while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::LOADED ){
		K7SCR_RETSYS();
	}
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_WAIT);
	WK7PLAYERCONTROL->SetVisible(false);
	WK7PLAYERCONTROL->RestorePathPosition();
	WK7PLAYERCONTROL->_MotSet_Wait(false);
	WK7PLAYERCONTROL->SetPosition(&pos);
	WK7PLAYERPATHCONTROL->CameraRenew();
	WK7PLAYERCONTROL->ChangeCallback();
	
	// [VĐ
	WK7PLAYERCONTROL->SetEnableOnly(false);
//	WK7PLAYERCONTROL->WK7PlayerMskSpAtkPosePlay();
//	WK7PLAYERCONTROL->PlayMotion(WK7MOTION_PCCMN_SPATK2,false,true,0.0f);
	if( (pModelMotion = WK7PLAYERCONTROL->GetCmnModelMotion(WK7MOTION_PCCMN_SPATK2))!=NULL ){
		WK7Model	*pModel;
		if( (pModel = pTmpChara->GetModel())!=NULL ){
			pModel->AttachMotion(pModelMotion);
			pModel->PlayMotion  (0.0f);
			pModel->SetMotionLoop(false);
		}
	}
	
	gpSound->mPlaySE(SFX_SCE3_MSK_LVUPVOICE_TEXAS);
	
	if( pCameraMotion != NULL ){
		// J[VĐ
		WK7CAM->SetMode      (WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->AttachMotion (pCameraMotion);
		WK7CAM->PlayMotion   ();
		WK7CAM->SetMotionLoop(false);
		WK7CAM->FrameProcess ();
		
		WK7CAM->SetRelativePosition(pos);
		WK7CAM->SetRelativeRotX(0.0f);
		WK7CAM->SetRelativeRotY(roty);
		WK7CAM->SetRelativeRotZ(0.0f);
		
		K7SCR_TIMEWAIT(146 * 160);
		
	}
	
	render  = screenImageMonoColor.GetRender ();
	zupdate = screenImageMonoColor.GetZUpdate();
	screenImageMonoColor.SetRender (true );
	screenImageMonoColor.SetZUpdate(false);
	
//	mFrameCountTrigger = true;
	
	screenImageMonoColor.SetA(0x00);
	screenImageMonoColor.SetA(0xff,WK7_SEC_TO_TICK(0.5f));
	while( screenImageMonoColor.IsAnimatingA()==true ){
		K7SCR_RETSYS();
	}
	
	while( (pPcBombEfc = GameInfo.PcBomb(pJObj,pos,roty,0,1))==NULL ){
		K7SCR_RETSYS();
	}
	
//	K7SCR_TIMEWAIT(100);
	
	while( false==GetHSDeadConveState(pPcBombEfc) ){
		GHMGCTASK_RETSYS();
	}
	
	pTmpChara->SetRenderFlag(false);
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	for(i=0 ; i<2 ; i++){
		if( gunDataID[i] >= 0 ){
			DetachGunModel2   (gunDataID[i]);
			ReleaseGunArchive2(gunDataID[i]);
		}
		gunDataID[i] = -1;
	}
	GHM_SAFE_DELETE(pTmpChara);
	
	for(tick=WK7_SEC_TO_TICK(2) ; tick > 0 ; tick -= WK7_TICK_PER_FRAME){
		K7SCR_RETSYS();
	}
//	if( true==GetEffectValidState(pPcBombEfc) ){
//		DeleteEffect(pPcBombEfc);
//	}
	
	while( (pPcBombEfc = GameInfo.PcBomb(1,1))==NULL ){
		K7SCR_RETSYS();
	}
	
	if( (pChara=WK7PLAYERCONTROL->GetCharaPtr())!=NULL ){
		pChara->StopMotion();
	}
	WK7PLAYERCONTROL->SetEnableOnly(true);
	while( false==GetHSDeadConveState(pPcBombEfc) ){
		K7SCR_RETSYS();
	}
	WK7PLAYERCONTROL->SetVisible(true);							// \
	if( pChara!=NULL ){
		pChara->ReplayMotion();
	}
	while( true == GetEffectValidState(pPcBombEfc) ){			// obj߂̃GtFNgI҂
		K7SCR_RETSYS();
	}
	
	screenImageMonoColor.SetA(0x00,WK7_SEC_TO_TICK(1.0f));
	while( screenImageMonoColor.IsAnimatingA()==true ){
		GHMGCTASK_RETSYS();
	}
	
//	mFrameCountTrigger = false;
	
	gpSound->mPlaySE(SFX_SCE3_MSK_LVUP);
	screenImageMonoColor.SetRender (render );
	screenImageMonoColor.SetZUpdate(zupdate);
	screenImageMonoColor.SetA(0xff,0);
	
	// \͍\`I
	WK7PLAYERCONTROL->SetEnableOnly(false);
	WK7PLAYERCONTROL->PlayMotion(WK7MOTION_PCCMN_SPATK,false,true,0.0f);
	
//	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(284.0f / 60.0f));
//	gpSound->mPlaySE(SFX_SCE3_MSK_LVUPVOICE_TEXAS);
	
	while( WK7PLAYERCONTROL->PcGetMotionState()!=WK7MODEL_NOANIM ){
		K7SCR_RETSYS();
	}
	
	while( WK7CAM->GetMotionState()!=WK7MODEL_NOANIM ){
		K7SCR_RETSYS();
	}
	
	while( gpSound->mCheckSE(SFX_SCE3_MSK_LVUP)==true ){
		K7SCR_RETSYS();
	}
	
	WK7CAM->StopMotion();
	WK7CAM->DetachMotion();
	
	WK7PLAYERCONTROL->SetEnableOnly(true);
	K7SCR_PC_VISIBLE( true );
	
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EXIT_PLAYMODE();
	WK7PLAYERCONTROL->BattlePadRegulationReSet(BPADREG_NO_WAIT);
	WK7PLAYERCONTROL->SetOperateEnable(true);
	WK7CAM->ClearRelativePosition();
	WK7CAM->ClearRelativeRotation();
	WK7CAM->FrameProcess();
}
