////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage325M00
//
// K7Stage325M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE325M00_H__
#define	__K7STAGE325M00_H__

#include "..\K7Stage.h"

class K7Stage325M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage325M00();
	K7Stage325M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	WK7RenderObjEffect			*mpWindEffect;
	
	void TreasureBoxMotionPlay(void);
	s32 loadLgtTex;
	EFFECT *pLgtEffect;
	bool BrokenScreen(int mode=0);
	void ChangeMskToTexas(void);
	u16 mBackupBloodGauge;
public:
	virtual ~K7Stage325M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool HitObjCallBack(WK7HitObjInfo &info);
	virtual bool BpLeaveCallBack(WK7BpInfo &info);
	
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg retrun true  pXɊ܂܂郊NɃWvB
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	
};

#ifdef __K7STAGE325M00_CPP__


enum K7STAGE325M00_ONESHOTCAM{
	ONESHOTCAM_SCREEN,
	ONESHOTCAM_TREASURE_NO,
	ONESHOTCAM_TREASURE_OK,
	ONESHOTCAM_SCREENBROKEN,
	ONESHOTCAM_MSKLVUP,
	ONESHOTCAM_MSKLVUPCOMP,
};


K7StageEventOneShotCamera K7Stage325M00_Camera[] = {
	{{-395.164f, 2.967f, -1248.708f},{-369.969f, 35.736f, -1280.481f}},				// XN[̂Ђ J
	{{-403.636f, -23.106f, -1171.406f},{-403.686f, 3.061f, -1221.583f}},			// 󔠃}XNȊOJ
	{{-403.510f, -31.869f, -1164.910f},{-404.414f, -1.343f, -1212.552f}},			// 󔠃}XNJ
	{{-401.512f, 5.017f, -1256.113f},{-402.878f, -9.142f, -1306.271f}},				// XN[Ԃ
	{{-403.959f, -7.719f, -1215.669f},{-414.851f, -7.593f, -1196.606f}},			// }XN`FW
	{{-403.993f, -3.024f, -1226.111f},{-403.747f, -6.536f, -1204.440f}},			// }XN`FW
};

#endif

#endif	//__K7STAGE325M00_H__

