////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage325M02 i03j
//
// K7Stage325M02.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE325M02_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage325M02.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectLight.h"

#define	K7STAGE325M02_CLOSE_PATHNAME_CAM	"event_030412_0"				// pXJ
#define	K7STAGE325M02_CLOSE_PATHNAME		"curve8"						// pXOi|Ȃƃ_j

K7Stage325M02::K7Stage325M02(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage325M02_Camera );		//	J
	pNpcSu = NULL;
}

K7Stage325M02::~K7Stage325M02()
{
}


/*
	
	NGCg
	
*/
bool K7Stage325M02::CreateCallBack(void)
{
	return true;
}


/*
	
	
	
*/
bool K7Stage325M02::InitializeCallBack(void)
{
	K7SCR_EVCONDCHANGE();
	
	return true;
}



/*
	
	
	󋵕ω
	
	
*/
bool K7Stage325M02::CondChangeCallBack(void)
{
	// XN[̃pXijj
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030412_SU)==TRUE ){
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE325M02_CLOSE_PATHNAME_CAM,true);
		K7SCR_STG_SET_PATHENABLE       (K7STAGE325M02_CLOSE_PATHNAME ,true);
	}else{
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE325M02_CLOSE_PATHNAME_CAM,false);
		K7SCR_STG_SET_PATHENABLE       (K7STAGE325M02_CLOSE_PATHNAME ,false);
	}
	return true;
}


bool K7Stage325M02::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(030412):
		// XN[̃pXijOj
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030412_SU)==false ){
			gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
		}
		break;
	default:
		return true;
	}
	return true;
}



/*
	
	I
	
	
*/
bool K7Stage325M02::TerminateCallBack(void)
{
	return true;
}

/*
	
	GS
	
*/
bool K7Stage325M02::DieNpcCallBack(WK7DieNpcInfo &info)
{
	if( info.mpNpc==NULL )
	{
		return true;
	}
	
	switch( info.mpNpc->GetEneNo() )
	{
		//ꑃgr
		case	ENENO_3_325M02_1:
//			gpSound->mPlayStreamNo( HPS_SAFE_PLACE );
			K7SCR_SET_SCENARIO_FLAG( K7SCN03_EVFL_030412_SU );
			K7SCR_EVCONDCHANGE();
			break;
		default:
			break;
	}
	
	return( true );
}

// ̐ݒ
#define CORE_NUM	(3)
bool K7Stage325M02::SetCurrentCallBack(void)
{
	pNpcSu = (K7EnmK *)WK7Npc::Find(ENENO_3_325M02_1);
	
	if ( pNpcSu != NULL ) {
		while( pNpcSu->SetUpTest()==false ){
			K7SCR_RETSYS();
		}
		pNpcSu->HitObjMake(WK7Stage::GetCurrentStage(), CORE_NUM);
	}
	return true;
}
bool K7Stage325M02::HitObjCallBack(WK7HitObjInfo &info)
{
	if ( pNpcSu != NULL ) {
		if( (info.mEventNo >= pNpcSu->GetHitObjID()) && (info.mEventNo < (pNpcSu->GetHitObjID()+CORE_NUM) ) ){
			if ( false == pNpcSu->CoreHit((int )info.mEventNo, info.mTypeID, info.mHitPos) ) {
				// RAj󂵂ĂȂ
				// qbgIuWF𕜊
//				info.mpHitObj->SetEnable(true);
				info.SetHitObjEnable(true);
			}
			return false;
		}
	}
	return true;
}



