////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage326M00 ʘH
//
// K7Stage326M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE326M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage326M00.h"
#include "..\..\..\Wat\WK7Archive.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7Effect.h"
#include "..\..\..\Kaw\KK7BattleCtrl.h"
#include "..\..\..\Yam\YK7EffectDraft.h"

//[V
#define	MOT326_KANBAN				(0)							// Ŕp̃[V
#define	MOT326_WALL_DISP			(1)							// ǂo
//#define	MOT326_WALL_BROKEN_DISP		(2)							// ꂽ̕ǂo

//f
#define	MDL326_KANBAN		"animation"							// Ŕf
#define	MDL326_HAHEN		"hahen"								// j
#define	MDL326_WALL			"event_030650"						// 

//f
#define	MDL326_PATH			"pass_texasmask"					// ӂpX
#define MDL326M00WIND		"polySurface2116"

#define	K7STAGE326M00_CLOSE_PATHNAME		"pass_texasmask"			// pXO
#define	K7STAGE326M00_RIDDLE_PATHNAME		"event_030651_0"			// JpXO

//bZ[W
#define	MES326M00_NO_MISS			(0)							// }XNŕǔj󎸔s
#define	MES326M00_NO_OK				(1)							// }XNŕǔjnj

static Vec windPos = {12.884f, -78.109f, -1153.475f};


K7Stage326M00::K7Stage326M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage326M00_Camera );
	mpWindEffect = NULL;
	mWallMove = false;
	mManualPathChange = false;
}

K7Stage326M00::~K7Stage326M00()
{
}

/*
	
	
	
*/
bool K7Stage326M00::InitializeCallBack(void)
{
	K7SCR_EVCONDCHANGE();
	return true;
}


/*
	
	Jg
	
	
*/
bool K7Stage326M00::SetCurrentCallBack(void)
{
	//[Vt@C
	CreateOwnStageMotion(MOT326_KANBAN);
	CreateOwnStageMotion(MOT326_WALL_DISP);
	
	while ( false == IsOwnMotionObjLoaded() ){
		K7SCR_RETSYS();
	}
	if ( false == WK7RenderObj::IsValid(this) ){				// (Xe[W)Ă܂ǂHK7SCR_RETSYS();̃`FbN
		return true;
	}
	
	WallMoveB();
	
	if ( true == K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_BOARD_BINGO) ){
		WK7JObj *pJObj;
		
		if( (pJObj = PlayMotion(MDL326_KANBAN, MOT326_KANBAN)) != NULL )
		{
			pJObj->SetMotionLoop(true, false, true);
		}
	}
	
	K7SCR_EVCONDCHANGE();
	
	return true;
}

bool K7Stage326M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	switch( eventNo ){
//	case	K7EVENTNO(030652):
//	case	K7EVENTNO(030653):
	case	K7EVENTNO(030654):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030652_INIT)==TRUE ){	// Vb^[oς
			return true;
		}
		
		// L|[Y
		mManualPathChange = true;
		
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_030652_INIT);
		
		FixCam(EV_WALL_START);
		
		WallMoveB(0.f);
		
		mManualPathChange = false;
		RenewPath();
		
		// L|[Y
		K7SCR_EVCONDCHANGE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		return true;
		break;
	case	K7EVENTNO(030651):					// J
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030652)==TRUE || pathNo!=0 ){
			break;
		}
		gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
		K7SCR_EVCONDCHANGE();
		return true;
		break;
	default:
		return true;
	}
	return true;
}


bool K7Stage326M00::CondChangeCallBack(void)
{
	EFFECT		*pWindEffect;
	WK7JObj		*pWindJObj;
	bool wind = false;
	WK7JObj *pJObj;

	// }XN̕ǔj
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030652)==TRUE ){
		K7SCR_STG_SET_PATHENABLE       (K7STAGE326M00_CLOSE_PATHNAME ,true);
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE326M00_RIDDLE_PATHNAME,true);
		pJObj = GetJObj(MDL326_WALL);
		if ( pJObj != NULL ){
			pJObj->Hide(false, true);
		}
		pJObj = GetJObj(MDL326_HAHEN);
		if ( pJObj != NULL ){
			pJObj->Disp(false, true);
		}
	}else{
		K7SCR_STG_SET_PATHENABLE       (K7STAGE326M00_CLOSE_PATHNAME ,false);
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE326M00_RIDDLE_PATHNAME,false);
		pJObj = GetJObj(MDL326_WALL);
		if ( pJObj != NULL ){
			pJObj->Disp(false, true);
		}
		pJObj = GetJObj(MDL326_HAHEN);
		if ( pJObj != NULL ){
			pJObj->Hide(false, true);
		}
	}
	
	// GtFNg
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030652)==TRUE ){			// jς
		wind = false;
	}else{
		if((WK7PLAYERCONTROL->GetMainID()==K7CAT)
		&& (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030652_INIT)==TRUE)
		){
			wind = true;
		}else{
			wind = false;
		}
	}
	pWindJObj = GetJObj(MDL326M00WIND);
	if( pWindJObj!=NULL ){
		if( wind==true && GetCurrentStageID()==mID ){
			if( IsValidEffect(mpWindEffect)==false ){
				WK7RenderObjEffectInfo	info;
				info.Create();
				if( (pWindEffect = ::CreateDraft2Effect(pWindJObj,(s32)VParam[ED_DRAFT][2]))!=NULL ){
					mpWindEffect = CreateEffect(pWindEffect,&info);
					// ԕȂ炷
					CatWindSePlay(windPos, K7SCN03_EVFL_030652, SFX_SCE3_SUKIMAKAZE);
				}
			}
		}else{
			if( mpWindEffect!=NULL ){
				DelReqEffect(mpWindEffect);
				mpWindEffect = NULL;
			}
		}
	}

	return true;
}


/*	
	
	
	ǈړ
	
	
*/
bool K7Stage326M00::WallMoveB(f32 sframe)
{
	WK7JObj* pJObj;
	
	if ( false == mWallMove ){
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030652_INIT)==TRUE ){
			if( (pJObj=PlayMotion(MDL326_WALL, MOT326_WALL_DISP, NULL, sframe)) != NULL ){
				
				// Vb^[Jn
				if ( sframe != -1.f ){
					seNo = gpSound->mPlaySE(SFX_SCE3_ISZK_SHUTTERLOOP);
				}else{
					seNo = -1;
				}
				
				if ( pJObj != NULL ){
					pJObj->Disp(false, true);
				}
				pJObj->SetMotionLoop(false, false, true);
			}
			if( sframe != -1.f ){
				while( pJObj->GetMotionState(false, true) != WK7MODEL_NOANIM ){
					K7SCR_RETSYS();
				}
				if ( seNo != -1 ){
					gpSound->mStopSENo(seNo);
					gpSound->mPlaySE(SFX_SCE3_ISZK_SHUTTERCLOSE);
				}
				K7SCR_TIMEWAIT(1);
			}
			
			mWallMove = true;
			
			return true;
		}
	}
	
	return false;
}




/*
	
	
	qbgIuWF
	
	
*/
bool K7Stage326M00::HitObjCallBack(WK7HitObjInfo &info)
{
	Vec pos;
	WK7JObj* pJObj;
	
	switch( info.mEventNo ){
	case	K7EVENTNO(030650):								// 
		
		if ( K7MSK == WK7PLAYERCONTROL->GetMainID() ){
			//ogIB
			KK7BattleMainTask::BattleMainTaskExit(2);
			
			// L|[Y
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			
			// Wait
			K7SCR_TIMEWAIT(5);
			
			// Jς
			FixCam(EV_WALL_BROKEN);
//			K7SCR_PC_SETVISIBLE(false);
			
			if ( KK7BATTLECTRL_MSKLV_TEXAS <= BattleCtrl.GetMskPowerUp() ){
				// jЏo
				pJObj = GetJObj(MDL326_HAHEN);
				if ( pJObj != NULL ){
					pJObj->Disp(false, true);
				}
				
				// 
				pos.x = 2.4f;
				pos.y = -73.3f;
				pos.z = -1150.9f;
				KK7DoorSmokeEffect(pos);
				
				// Wait
				K7SCR_TIMEWAIT(10);
				
				K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_030652);	// ItOĂ
				BrokenObj(MDL326_WALL);
				
				// Wait
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
				
				gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
				
				// Wait
//				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
				K7SCR_STGC_MESSAGE_B(MES326M00_NO_OK);
			
			}else{
				
				// Wait
				K7SCR_TIMEWAIT(5);
				
				K7SCR_STGC_MESSAGE_B(MES326M00_NO_MISS);
				
			}
			
			K7SCR_PC_SETVISIBLE(true);
			
			// L|[Y
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_EVCONDCHANGE();
		}
		
		return true;
		
		break;
	}
	return true;
}

bool K7Stage326M00::PathChangeCallBack(WK7PathChangeInfo &info)
{
	if( mManualPathChange==true ){
		return false;
	}
static	const char	*ppPathList[] = {
	K7STAGE326M00_RIDDLE_PATHNAME,
//	"curve31",
	NULL,
};
	WK7PathNurbs		*pPath = info.GetPath();
	if( pPath==NULL ){
		return true;
	}
	if( info.CompareList(ppPathList) >= 0 && mpPath!=NULL ){
		WK7Archive	*pArchive = mpPath->GetArchive();
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030652)==TRUE && pArchive!=NULL ){
			HSD_CameraDesc	*pCameraDesc = pArchive->GetCameraDesc("camera7");
			if( pCameraDesc!=NULL ){
				WK7CAMPATHFOLLOWINFO->SetMode(WK7CamPathFollowInfo::POSFIXED_MODE);
				WK7CAMPATHFOLLOWINFO->SetPathCamera(pCameraDesc);
				return false;
			}
		}
	}
	return true;
}

