////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage327M00 L
//
// K7Stage327M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE327M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage327M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectConfetti.h"
#include "..\..\..\Yam\YK7EffectRotLight.h"

//bZ[W
#define	MES327M00_NO_ENTER				(0)				//~Xe[nEXɓȂ
//#define	MES327M00_NO_ENTER2				(1)
#define	MES327M00_NO_ENTER3				(2)

//[V
#define	MOT327_KANBAN		(0)							// Ŕp̃[V

//f
#define	MDL327_KANBAN		"animation"					// Ŕf

K7Stage327M00::K7Stage327M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage327M00_Camera);
}

K7Stage327M00::~K7Stage327M00()
{
}

bool K7Stage327M00::CreateCallBack(void)
{
	//[Vt@C
	CreateOwnStageMotion(MOT327_KANBAN);
	// GLZbgp̃tO𗧂Ă
	K7SCR_SET_SCENARIO_FLAG(K7SCN03_DRFL_STG327M00_HS_DISP);
	return true;
}

bool K7Stage327M00::InitializeCallBack(void)
{
	int i;
	
	if ( true == K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030901) ){
		// Xe[WWv̂߃mCYȂ
		SetManualBranch( true );
	}
	HereComeANewHSInit( PR_HS_PROT_Z, ENENO_3_327M00_7 );

	for(i=0; i<K7STAGE327M00_LOT_LGT_MAX; i++){
		pRotLgt[i] = NULL;
	}
	return true;
}

/*
	
	Jg
	
	
*/
bool K7Stage327M00::SetCurrentCallBack(void)
{
	int i;
	bool	manual = false;

	//L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	SetCurrentCallBackDefaultProc();
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	if ( false == WK7RenderObj::IsValid(this) ){				// (Xe[W)Ă܂ǂHK7SCR_RETSYS();̃`FbN
		return true;
	}
	
	if ( true == K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_BOARD_BINGO) ){
		WK7JObj *pJObj;
		
		if( (pJObj = PlayMotion(MDL327_KANBAN, MOT327_KANBAN)) != NULL )
		{
			pJObj->SetMotionLoop(true, false, true);
		}
		
		for(i=0; i<K7STAGE327M00_LOT_LGT_MAX; i++){
			pRotLgt[i] = CreateRotLightEffect(  rotStg327LgtPos[i],								// W
												(Vec){ 0.0F, 0.0F, -1.0F },					// 
												PI_2 / 360.0F * 80,							// X( 80x )
												(f32)VParam[ED_ROTLIGHT][6] * PI_2 / 360,	// ]x
												VParam[ED_ROTLIGHT][7],						// [U[̑
												VParam[ED_ROTLIGHT][8] * 150				// 
												 ) ;
		}
	}
	
	//V^HSЉ
	if( false == HereComeANewHS(	PR_HS_PROT_Z,
									ENENO_3_327M00_7,								// GID
									NULL,
									CAM327M00_HS_PRESEN_START,
									CAM327M00_HS_PRESEN_END,
									0,
									184,  219,-101,  70,1057, 137 )				// OЉp
	){
		SetManualBranch(false);
		manual = true;
//		return false;
	}
	
	if ( true == K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030901) ){		// \t@[[h痈ꍇ
		
		SetManualBranch( false );
		manual = true;
		
		WK7Stage::SetCurrentPath(	WK7Stage::GetPathNurbsAll("curve17"),
									0.f,
									0,									// Forward
	//								WK7PATHINFO_INITDIR_TGTDIR			// 
									WK7PATHINFO_INITDIR_TGTDIR_REV		// wォ
		);
		
		// ŒJ̐ݒ
		WK7StagePlaceInfo		*pPlaceInfo;
		pPlaceInfo = GetPlaceInfo(mID,"curve17");
		SetCameraStartPosition(pPlaceInfo);
		
		K7SCR_RESET_SCENARIO_FLAG(K7SCN03_EVFL_030901);
		
		//JPCtH[ɖ߂
		WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
		
		// mCY
		SandRelease(pPlaceInfo);
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
	}
	
	GHMGCTASK_RETSYS();
	
	//L|[Y
	if( manual==true ){
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
	}
	
	return false;
}


/*
	
	
	I
	
	
*/
bool K7Stage327M00::TerminateCallBack(void)
{
	int i;

	for(i=0; i<K7STAGE327M00_LOT_LGT_MAX; i++){
		if ( NULL != pRotLgt[i] ){
			::DelReqEffect( pRotLgt[i] );
		}
	}
	
	// GzutONA
	K7SCR_RESET_SCENARIO_FLAG(K7SCN03_DRFL_030607_HS_DISP);
	K7SCR_RESET_SCENARIO_FLAG(K7SCN03_DRFL_030606_HS_DISP);
	K7SCR_RESET_SCENARIO_FLAG(K7SCN03_DRFL_STG327M00_HS_DISP);
	
	return true;
}



/*
	
	hA
	
*/
bool K7Stage327M00::DoorEventCallBack (WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(030601):								// ~Xe[nEX
		if( WK7PLAYERCONTROL->GetID() == K7CHRID(K7MSK,4) ){	// }XNLVJVERH
			
			K7SCR_SET_SCENARIO_FLAG(K7SCN03_DRFL_030601);		// ACR߂ɗĂ
			
			return true;
		}else{
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			
			K7SCR_STGC_MESSAGE_B(MES327M00_NO_ENTER);
			
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			return false;
		}
	case	K7EVENTDOOR(030606):								// GZbgtO
		K7SCR_SET_SCENARIO_FLAG(K7SCN03_DRFL_030606_HS_DISP);
		return true;
	case	K7EVENTDOOR(030607):								// GZbgtO
		K7SCR_SET_SCENARIO_FLAG(K7SCN03_DRFL_030607_HS_DISP);
		return true;
	}
	return true;
}

bool K7Stage327M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(030601):
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		K7SCR_STG_MESSAGE_B(MES327M00_NO_ENTER3);
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		return false;
	case	K7EVENTNO(030602):
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		K7SCR_STG_MESSAGE_B(MES327M00_NO_ENTER3);
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		return false;
	default:
		break;
	}
	return true;
}

