////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage351M00 J[eBX̉Ɓ@
//
// K7Stage351M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE351M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage351M00.h"
#include "..\..\..\Kaw\KK7Sound.h"

//f
#define	MDL351M00_GATE	"animation"	//̃f
//[V
#define	MOT351M00_00	(0)		//hA

//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage351M00::K7Stage351M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage351M00_Camera );
	mAmbPlaySE = false;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage351M00::~K7Stage351M00()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage351M00::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT351M00_00 );
	
	return( true );
}

//------------------------------------------------------------------------------
// JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage351M00::SetCurrentCallBack( void )
{
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){180.352f, 14.808f, -466.414f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE3_AMB_MUSHI1 );
		KK7SoundLoopSePlayVolumeChange((Vec){-301.902f, 33.471f, -338.828f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE3_AMB_MUSHI1 );
		mAmbPlaySE = true;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
// ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage351M00::CondChangeCallBack( void )
{
	//ĎJCxgʉ߂H
	if( K7SCR_GET_SCENARIO_FLAG(EV035001) == false )
	{
		SimpleSetStartMotion( MDL351M00_GATE, MOT351M00_00 );
		K7SCR_STG_SET_PATHENABLE( "curve6", true );
	}else
	{
		SimpleSetLastMotion( MDL351M00_GATE, MOT351M00_00 );
		K7SCR_STG_SET_PATHENABLE( "curve6", false );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage351M00::BpLeaveCallBack( WK7BpInfo &info )
{
	WK7JObj*	pJObj;
	u32	evno = GetBpEventNo( info );
	if( evno==0xffffffff )
		return( true );
	
	switch( evno )
	{
		//ĎJ
		case	K7EVENTNO( 035001 ):
			//KVA_ɑĂȂΕς
			if( (K7SCR_GET_SCENARIO_FLAG(EV035001) == FALSE) && (WK7PLAYERCONTROL->GetMainID() != K7DAN) )
			{
				//_ɑtOON
				K7SCR_SET_SCENARIO_FLAG( EV035001 );
				//L|[Y
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				//ĎJŃL
				K7SCR_NOISE_REQUEST();
				FixCam( CAM035001toCAM );
				K7SCR_NOISE_RELEASE();
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
				WatchCameraB( K7Stage351M00_Camera[CAM035001fromCAM].tgt,
							  K7Stage351M00_Camera[CAM035001fromCAM].pos,
							  K7CHRID(K7DAN,0), 1, false );
				//L|[Y
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				//傪
				FixCam( CAM035001toGATE );
				K7SCR_TIMEWAIT( 4800 );
				gpSound->mPlaySE( SFX_SCE3_CUR_GATE );
				if( (pJObj=PlayMotion(MDL351M00_GATE,MOT351M00_00)) != NULL )
				{
					pJObj->SetMotionLoop( false );
					while( pJObj->GetMotionState() != WK7MODEL_NOANIM )
					{
						K7SCR_RETSYS();
					}
				}
				K7SCR_TIMEWAIT( 4800 );
				//RfBVύX
				K7SCR_EVCONDCHANGE();
				//L|[Y
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}
