////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage353M00 J[eBX̉Ɓ@K[W
//
// K7Stage353M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE353M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage353M00.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

#define	NINE_EMPTY_NUM	(8)		//9pY̋plԍ

//bZ[W
#define	MES353M00_00		(0)		//EChO肵
#define	MES353M00_CAR_HINT	(1)		//ԃpỸqg
//f
#define	MDL353M00_SHUTTER	"Car_panel09"	//Vb^[
#define	MDL353M00_RING		"Ring"			//O
//[V
#define	MOT353M00_CARAPPEAR	(0)		//ԌɂJĎԂoĂ
#define	MOT353M00_CARUP		(4)		//ԂɈړ
#define	MOT353M00_CARDOWN	(2)		//ԂɈړ
#define	MOT353M00_CARLEFT	(3)		//ԂɈړ
#define	MOT353M00_CARRIGHT	(1)		//ԂEɈړ
//pX
#define	PAT353M00_SENSOR	"curve2"	//K[WÕ[U[ZT[jxpX

//O[oϐ
static char* name353tbl[] = {
	{ "panel01" },	//
	{ "panel02" },	//
	{ "panel03" },	//
	{ "panel04" },	//
	{ "panel05" },	//
	{ "panel06" },	//
	{ "panel07" },	//
	{ "panel08" },	//
	{ "" },			//ԂȂ
};




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage353M00::K7Stage353M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	int	i;
	u8*	original = &(K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UL));
	
	SetOneShotCamLocTbl( K7Stage353M00_Camera );
	//zuW𔽉f
	for( i = 0; i < NINE_PZL; i++ )mSetPos[i]=original[i];
	mpSpark = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage353M00::~K7Stage353M00()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//-----------------------------------------------------------------------------
bool
K7Stage353M00::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT353M00_CARUP );
	CreateOwnStageMotion( MOT353M00_CARDOWN );
	CreateOwnStageMotion( MOT353M00_CARLEFT );
	CreateOwnStageMotion( MOT353M00_CARRIGHT );
	CreateOwnStageMotion( MOT353M00_CARAPPEAR );
	
	//LLGtFNg
	LoadEasyAnimPack( ANIMID_SMALLLIGHT );
	while( CheckEasyAnimPackLoadState(ANIMID_SMALLLIGHT) == false )
	{
		K7SCR_RETSYS();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage353M00::TerminateCallBack( void )
{
	//LLGtFNg
	if( mpSpark != NULL )
	{
		DeleteEffect( mpSpark );
		mpSpark = NULL;
	}
	ReleaseEasyAnimPack( ANIMID_SMALLLIGHT );
	
	return( true );
}

//------------------------------------------------------------------------------
//Ԃ̍Wݒ
//------------------------------------------------------------------------------
void
K7Stage353M00::setCarObj( u8 inPosNo, char* inCarName )
{
	WK7JObj*	pJObj;
	Vec			pos[9] = {
		{ -233.885f, 30.564f, -641.939f },	//㍶
		{ -180.701f, 30.564f, -641.939f },	//㒆
		{ -127.897f, 30.564f, -641.939f },	//E
		{ -233.885f, 30.564f, -593.495f },	//
		{ -180.701f, 30.564f, -593.495f },	//
		{ -127.897f, 30.564f, -593.495f },	//E
		{ -233.885f, 30.564f, -544.965f },	//
		{ -180.701f, 30.564f, -544.965f },	//
		{ -127.897f, 30.564f, -544.965f },	//E
	};
	
	if( (inCarName != "")
	 && (pJObj = GetJObj(inCarName)) != NULL )
	{
		pJObj->SetPosition( pos[inPosNo] );
	}
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage353M00::CondChangeCallBack( void )
{
	//---- ԕ\W ----
	setCarObj( 0, name353tbl[mSetPos[0]] );	//㍶̏ꏊname[?]̎Ԃzu
	setCarObj( 1, name353tbl[mSetPos[1]] );	//㒆̏ꏊname[?]̎Ԃzu
	setCarObj( 2, name353tbl[mSetPos[2]] );	//Ȅꏊname[?]̎Ԃzu
	setCarObj( 3, name353tbl[mSetPos[3]] );	//̏ꏊname[?]̎Ԃzu
	setCarObj( 4, name353tbl[mSetPos[4]] );	//̏ꏊname[?]̎Ԃzu
	setCarObj( 5, name353tbl[mSetPos[5]] );	//Ȅꏊname[?]̎Ԃzu
	setCarObj( 6, name353tbl[mSetPos[6]] );	//̏ꏊname[?]̎Ԃzu
	setCarObj( 7, name353tbl[mSetPos[7]] );	//̏ꏊname[?]̎Ԃzu
	setCarObj( 8, name353tbl[mSetPos[8]] );	//Ȅꏊname[?]̎Ԃzu
	
	//ԃpYNA
	if( K7SCR_GET_SCENARIO_FLAG(EV035006) == true )
	{
		//{̃WNV
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035016), false );
		//pl̃WNV
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035006), false );
		//Vb^[J&ԏo
		SimpleSetLastMotion( MDL353M00_SHUTTER, MOT353M00_CARAPPEAR );
		//U̓Abv̎wւĂȂ΃Cxg\
		//if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_RING_ATTACK) == FALSE ) 
		if( K7SCR_GET_SCENARIO_FLAG(EV035007GET_ATKRING) == false ) 
		{
			K7SCR_EVNO_SETENABLE( K7EVENTNO(035007), true );
			SimpleModelDisp( MDL353M00_RING );
		}else
		{
			K7SCR_EVNO_SETENABLE( K7EVENTNO(035007), false );
			SimpleModelHide( MDL353M00_RING );
		}
	}else
	{
		//{̃WNVON
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035016), true );
		//plWNVON
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035006), true );
		//Vb^[JOɐݒ
		SimpleSetStartMotion( MDL353M00_SHUTTER, MOT353M00_CARAPPEAR );
		//w֕\
		SimpleModelDisp( MDL353M00_RING );
		//X[W[WNV
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035007), false );
	}
	
	//---- K[WZT[u ----
	if( K7SCR_GET_SCENARIO_FLAG(EV035005) == TRUE )
	{
		SimpleModelHide( "event_035005" );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035015), false );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PAT353M00_SENSOR, true );
		if( mpSpark != NULL )
		{
			DeleteEffect( mpSpark );
			mpSpark = NULL;
		}
	}else
	{
		SimpleModelDisp( "event_035005" );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(035015), true );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PAT353M00_SENSOR, false );
		if( mpSpark == NULL )
		{
			mpSpark = CreateEasyAnimEffect2( ANIMID_SMALLLIGHT,
											 (Vec){ -64.850f, 38.914f, -696.401f },
											 (Vec){ 2.0f, 2.0f, 2.0f },
											 true, -1 );
		}
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage353M00::EventCallBack( WK7EventInfo &info )
{
	WK7ZanEventInfo zanEventInfo;
	WK7JObj *pJObj;
	int	i, motID;
	u8	emptyPos;
	u8*	original = &(K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UL));
	
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	switch( info.mEventNo )
	{
		//pl
		case	K7EVENTNO( 035006 ):
			//̏Ԃۑ
			for( i = 0; i < NINE_PZL; i++ )
			{
				mSetPos[i] = original[i];
				if( mSetPos[i] == NINE_EMPTY_NUM )
				{
					emptyPos = (u8)i;
				}
			}
			//plĂяo
			K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(035003), -1 );
			K7SCR_PANEL_START();
			K7SCR_PANEL_TERMWAIT();
			K7SCR_RETSYS();
			K7SCR_PANEL_EXIT();
			//Ԃ𓮂`FbN
			if( K7SCR_PANEL_GETRESULT() != -1 )
			{
				//Ԃړۂ̃J
				FixCam( CAM353M00CARMOVE );
				K7SCR_PANEL_EXITWAIT();
				//󔒈ʒuɂԂ͂ǂ̈ʒuɂ擾 = i
				for( i = 0; i < NINE_PZL; i++ )
				{
						//󔒈ʒuɗV 
					if( original[emptyPos] == mSetPos[i] )
						break;				//ړԂ̌̏ꏊiŌ
				}
				//݂̏ꏊ(emptyPos)ƌ̏ꏊ(i)̈ʒu֌W𒲂ׂ
				switch( (s8)emptyPos - (s8)i )
				{
					//EɈړ
					case	-1:
						motID = MOT353M00_CARRIGHT;
						break;
					//Ɉړ
					case	1:
						motID = MOT353M00_CARLEFT;
						break;
					//Ɉړ
					case	-3:
						motID = MOT353M00_CARDOWN;
						break;
					//Ɉړ
					case	3:
						motID = MOT353M00_CARUP;
						break;
					default:
						ASSERT(0);	//킯Ȃ̂Ń`FbNpɒ~
						break;
				}
				//Ԃ𓮂
				gpSound->mPlaySE( SFX_SCE3_CUR_PARKING_SLIDE );
				SimplePlayMotionB( name353tbl[original[emptyPos]],motID,"Car_panel" );
				//[Vŏɖ߂čWXV
				if( (pJObj=PlayMotion(name353tbl[original[emptyPos]],motID,"Car_panel")) != NULL )
				{
					pJObj->StopMotion();
				}
				K7SCR_RETSYS();
				//zuW𔽉f
				for( i = 0; i < NINE_PZL; i++ )mSetPos[i]=original[i];
				K7SCR_EVCONDCHANGE();
				//󔒂^񒆂̒ỉE[Ȃ琳
				if( K7EVENT_SCN_VAR(K7SCN03,PZCARVA_MR) == NINE_EMPTY_NUM )
				{
					//{̃WNV
					K7SCR_EVNO_SETENABLE( K7EVENTNO(035016), false );
					//WNV
					K7SCR_EVNO_SETENABLE( K7EVENTNO(035006), false );
					//pYŎԂo
					K7SCR_SET_SCENARIO_FLAG( EV035006 );
					//X[W[ւ̃CxgWNV\
					K7SCR_EVNO_SETENABLE( K7EVENTNO(035007), true );
					//Vb^[J
					openShutter();
				}
			}else
			{
				K7SCR_PANEL_EXITWAIT();
			}
			break;
		
		//X[W[
		case	K7EVENTNO( 035007 ):
			//cvOƉb
			zanEventInfo.Initialize();
			zanEventInfo.mEventNo = K7EVENTZAN( 035014 );
			zanEventInfo.mpStage  = this;
			GameInfo.SetZanMesID( 0 );
			GameInfo.SetZanTermWait( true );
			GameInfo.SetZanNoiseCancel( false );
			GameInfo.SetZanCharaLoadCancel( true );
			CallZanEventCallBackTask( zanEventInfo );
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT )
			{
				K7SCR_RETSYS();
			}
			GameInfo.SetZanTermWait( false );
			GameInfo.SetZanManual( true );
			GameInfo.SetZanNoiseCancel( true );
			GameInfo.SetZanCinemaScopeCancel( true );
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY )
			{
				K7SCR_RETSYS();
			}
			gpSound->mStopStream();
			//U̓Abv̎w֎擾
			K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_ATTACK );
			//inGame~icvO𔲂Ɖ邽߁j
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//ACe擾ʂ\
			SimpleItemGetMes( MES353M00_00, MDL353M00_RING );
			K7SCR_SET_SCENARIO_FLAG( EV035007GET_ATKRING );
			//tO𗎂Ƃ
			K7SCR_EVSETITEM( K7EVENTZAN(035014), false );
			//cvOƉb
			zanEventInfo.Initialize();
			zanEventInfo.mEventNo = K7EVENTZAN( 035014 );
			zanEventInfo.mpStage  = this;
			GameInfo.SetZanMesID( 1 );
			GameInfo.SetZanTermWait( true );
			GameInfo.SetZanNoiseCancel( true );
			GameInfo.SetZanCharaLoadCancel( true );
			CallZanEventCallBackTask( zanEventInfo );
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT )
			{
				K7SCR_RETSYS();
			}
			GameInfo.SetZanTermWait( false );
			GameInfo.SetZanManual( false );
			GameInfo.SetZanNoiseCancel( false );
			GameInfo.SetZanCinemaScopeCancel( false );
			//JPCtH[ɖ߂
			WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY )
			{
				K7SCR_RETSYS();
			}
			gpSound->mPlayStreamNo( HPS_KRAKUJITU_C );
			K7SCR_EVNO_SETENABLE( K7EVENTNO(035007), false );
			break;
		
		//̃ZT[
		case	K7EVENTNO( 035015 ):
			//J
			FixCamWithRiddle( CAM353M00SENSORDEVICE );
			break;
		
		//ԃpỸqg
		case	K7EVENTNO( 035016 ):
			FixCamMesWithRiddle( CAM353M00CARHINT, MES353M00_CAR_HINT );
//			FixCamWithRiddle( CAM353M00CARHINT );
			break;
		
		//ftHg
		default:
			break;
	}
	
	//inGameĊJ
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return( true );
}

//------------------------------------------------------------------------------
//qbgIuWF
//------------------------------------------------------------------------------
bool
K7Stage353M00::HitObjCallBack( WK7HitObjInfo &info )
{
	switch( info.mEventNo )
	{
		//K[W̃ZT[
		case	K7EVENTNO( 035005 ):
			//ogIB
			KK7BattleMainTask::BattleMainTaskExit( 2 );
			//L|[Y
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			//IuWF
			info.mpJObj->Hide( false, true );
			gpSound->mPlaySE( SFX_SYS_TRUE );
			gpSound->mPlaySE( SFX_SCE3_CUR_CABLE_CUT );
			//WNV\
			K7SCR_EVNO_SETENABLE( K7EVENTNO(035015), false );
			//΂EGCg
		//	K7SCR_TIMEWAIT( 400 );
			//ZT[
			eraseSensor();
			//L|[Y
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//ZT[
//------------------------------------------------------------------------------
void
K7Stage353M00::eraseSensor( void )
{
	WK7AnimLinearF	alpha;
	C_SetAlpha*		pSetAlpha;
	WK7JObj*		pJObj;
	
	//mCY
	gpNoise->mSandRequest(eSandLongNoise);
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){K7SCR_RETSYS()};
	//K[WZT[j󂵂tOON
	K7SCR_SET_SCENARIO_FLAG( EV035005 );
	K7SCR_EVCONDCHANGE();
	// Jς
	FixCam( CAM353M00SENSOR );
	//mCY
	gpNoise->mSandRelease();
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){K7SCR_RETSYS()};
	//Ԃ̃ZT[
	gpSound->mPlaySE( SFX_SCE3_CUR_ALARMLASER_STOP );
	if( (pJObj=GetJObj("laser")) != NULL )
	{
		//Aj[Vݒ
		pJObj = GetJObj("laser");
		alpha.SetValue( 1.0f );
		alpha.Play( 0.0f, 1200 );
		pSetAlpha = new C_SetAlpha( pJObj->GetJObj(), alpha.GetValue(), false );
		if( pSetAlpha != NULL )
		{
			do{
				pSetAlpha->SetVal( alpha.GetValue(),false );
				K7SCR_RETSYS();
				alpha.FrameProcess();
			}while( alpha.IsAnimating() == true );
			pJObj->Hide( false, true );
		}
	}
	K7SCR_TIMEWAIT( 3600 );
	//mCY
	gpNoise->mSandRequest(eSandLongNoise);
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){K7SCR_RETSYS()};
	//JPCtH[ɖ߂
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	GHM_SAFE_DELETE( pSetAlpha );
	//mCY
	gpNoise->mSandRelease();
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){K7SCR_RETSYS()};
}

//------------------------------------------------------------------------------
//Vb^[J
//------------------------------------------------------------------------------
void
K7Stage353M00::openShutter( void )
{
	WK7JObj*	pJObj;
	
	//Vb^[ւ̃J
	FixCam( CAM353M00SHUTTER );
	//Vb^[J&ԏo
	if( (pJObj=PlayMotion(MDL353M00_SHUTTER,MOT353M00_CARAPPEAR)) != NULL )
	{
		pJObj->SetMotionLoop( false ,false, true );
		gpSound->mPlaySE( SFX_SCE3_CUR_PARKING_LONG );
		K7SCR_TIMEWAIT( 7200 );
		//Ԉړ̃J
		FixCam( CAM353M00SECRETCARMOVE );
		while( pJObj->GetMotionState(false,true) != WK7MODEL_NOANIM )
		{
			K7SCR_RETSYS();
		}
	}
	gpSound->mPlaySE( SFX_SYS_TRUE );
	//X[W[̃J
	FixCam( CAM353M00SUSIE );
	K7SCR_TIMEWAIT( 4800 );
	WK7CAM->StartLinearInterpolateOnLinearPath( K7Stage353M00_Camera[CAM353M00SUSIEUP].pos, K7Stage353M00_Camera[CAM353M00SUSIEUP].tgt, 60.0f );
	K7SCR_TIMEWAIT( 9600 );
}
