////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage362M00 J[eBX̉Ɓ@v[
//
// K7Stage362M00.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE362M00_H__
#define	__K7STAGE362M00_H__

#include "..\K7Stage.h"
#include "..\..\..\Kaw\KK7Sound.h"

class K7Stage362M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage362M00();
	K7Stage362M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	EFFECT*				mpPool;
	WK7RenderObjEffect*	mpWindEffect;
	WK7ModelMotion*		mpCatMotionSlow;	//Lbg[V
	WK7ModelMotion*		mpCatMotion;		//Lbg[V
	bool				mAmbPlaySE;
	LOOPSE*				mpLoopSE;
	
	void	PoolDisp( void );		//v[\
	void	PoolUndisp( void );		//v[
	void	PoolWaterLost( void );	//v[
//	void	CatSliding( bool inCamMotion, u32 inCamID=0xffffffff );	//Lbg
	
public:
	virtual ~K7Stage362M00();
	
	virtual bool CreateCallBack    (void);									// iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
	virtual bool InitializeCallBack(void);									// iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
	virtual bool CondChangeCallBack(void);									// ԕύXitOɂԕύX邽߂ɗpj
	virtual bool CharaChangeCallBack(WK7CharaChangeInfo &);					//L`FW
	virtual bool TerminateCallBack (void);									// Iȉj
	virtual bool SetCurrentCallBack(void);									// JgXe[Wɐݒ莞
	virtual bool EventCallBack     (WK7EventInfo     &);					// Cxg
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);					// hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);					// _o
//	virtual bool BpArriveCallBack  (WK7BpInfo        &);					// _
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);					// qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj

};

#ifdef __K7STAGE362M00_CPP__


enum K7STAGE362M00_ONESHOTCAM{
	CAM362M00BULBCAP,			//oůW
	CAM362M00POOL,				//v[
	CAM362M00_LOCKDOOR,			//ւ̔
	CAM362M00_CYO_PICKING,		//R[esbLO
	CAM362M00_LOCKDOOR_352,		//ւ̔
	CAM362M00_CYO_PICKING_352,	//R[esbLO
	CAM362M00_CAT_SLIDING_POOL,				//Lbg荞݁Ev[
	CAM362M00_CAT_SLIDING_GARDEN,			//Lbg荞݁E
	CAM362M00_RIDDLE_CAT_SLIDING_POOL,		//Lbg荞݂̓Ev[
	CAM362M00_RIDDLE_CAT_SLIDING_GARDEN,	//Lbg荞݂̓E
	CAM362M00_MSK_WALL,			//}XNǔj
};

K7StageEventOneShotCamera K7Stage362M00_Camera[] = {
	{{-478.428f, 31.821f, -907.056f},{-486.743f, 38.640f, -914.057f}},		//oůW
	{{-516.202f, 61.369f, -1034.413f},{-532.544f, 72.669f, -1020.728f}},	//v[
	{{-400.199f, 36.278f, -951.583f},{-405.122f, 40.221f, -959.343f}},		//ւ̔
	{{-405.658f, 37.460f, -951.592f},{-390.575f, 26.770f, -973.855f}},		//R[esbLOEւ̔
	{{-563.422f, 36.171f, -683.683f},{-582.854f, 36.787f, -671.085f}},		//ւ̔
	{{-574.299f, 35.596f, -676.193f},{-595.000f, 30.799f, -685.421f}},		//R[esbLOEւ̔
	{{-603.986f, 36.572f, -767.438f},{-607.795f, 46.546f, -744.425f}},		//Lbg荞݁Ev[
	{{-604.227f, 40.922f, -812.575f},{-613.612f, 53.870f, -832.269f}},		//Lbg荞݁E
	{{-600.835f, 31.486f, -792.683f},{-609.338f, 32.658f, -768.811f}},		//Lbg荞݂̓Ev[
	{{-602.924f, 33.595f, -799.378f},{-608.986f, 26.424f, -822.945f}},		//Lbg荞݂̓E
	{{-277.423f, -6.414f, -1162.594f},{-270.589f, -11.493f, -1147.027f}},	//}XNǔj
};

#endif

#endif	//__K7STAGE362M00_H__

