////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage363M00 J[eBX̉Ɓ@v[
//
// K7Stage363M00.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE363M00_H__
#define	__K7STAGE363M00_H__

#include "..\K7Stage.h"
#include "..\fujita\c_state.h"
#include "..\Matsu\mK7Sprite.h"
class K7Stage363M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage363M00();
	K7Stage363M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	WK7Archive		*mpArchive;
	WK7Chara		*mpHato;
	ghmGcFile							mpFile[7];
	u8									*mpTextureData[7];
	C_State state;
	bool SetMotion( s32 id_, bool loop_ = false, bool intrp_ = true  );
	bool IsMotionEnd( void );
	bool IsMotion( s32 id_ );
	void Penalty( void );
	void PigeonSet( void );
	bool PigeonSetVisible(bool flag);
	void CamSetChr2Enm( void );
	void CamSetEnm2Chr( void );
	void CamSetEnm( void );
	void AutoPlayIn( void );
	void AutoPlayOut( void );

	mK7Sprite		sprite[2][7];	
	stTexture		tex_obj[2][7];	
	s32 pc_hit,npc_hit;
	s32 cheat_count;
	bool penalty_hit;
	bool terminate_called;
	s32 mot_id;
public:
	virtual ~K7Stage363M00();
	bool SetCurrentCallBack( void );
	
	bool LoadAfterInit(void);
	bool IsLoadingAfterInit(void);
	virtual bool CreateCallBack    (void);
//	virtual bool InitializeCallBack(void)              { return true; }		// iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//	virtual bool CondChangeCallBack(void)              { return true; }		// ԕύXitOɂԕύX邽߂ɗpj
	virtual bool TerminateCallBack (void);
//	virtual bool SetCurrentCallBack(void)              { return true; }		// JgXe[Wɐݒ莞
//	virtual bool EventCallBack     (WK7EventInfo     &){ return true; }		// Cxg
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool BpLeaveCallBack   (WK7BpInfo        &){ return true; }		// _o
//	virtual bool BpArriveCallBack  (WK7BpInfo        &){ return true; }		// _
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &){ return true; }		// qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj

};

#ifdef __K7STAGE363M00_CPP__


enum K7STAGE363M00_ONESHOTCAM{
	EN000M00,
};


K7StageEventOneShotCamera K7Stage363M00_Camera[] = {
	{{000.f,	000.f,	000.f},	{000.f,	000.f,	000.f}},
};

#endif

#endif	//__K7STAGE363M00_H__

