////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage413M00 yh~jJzʂ
//
// K7Stage413M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE413M00_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage413M00.h"
#include "..\..\..\sato\SK7SpecialData.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Kaw\KK7Sound.h"

//bZ[W
#define	MES413M00_LIGHT				(0)		//肪_Ă
//pX
#define	PAT413M00_BARRIER_INNER		"event_040104_ked"	//E˔jɒʂpX
#define	PAT413M00_BARRIER_RIDDLE	"event_040107_0"	//EJ
#define	PAT413M00_SHORTCUT444		"event_040410_0"	//444ւ̃V[gJbgpX
//f
#define	MDL413M00_BARRIER			"secret_wall"		//E
#define	MDL413M00_SHORTCUT444_LIGHT	"ON"				//V[gJbg413̓
#define	MDL413M00_SHORTCUT444_DARK	"OFF"				//V[gJbg413̈
#define	MDL413M00_WARP_CANDLE_444	"warp_candle"		//V[gJbg413̃E\N




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage413M00::K7Stage413M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage413M00_Camera );
	mpEffectFire = NULL;
	mAmbPlaySE   = false;
	mpEffectLensFlare = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage413M00::~K7Stage413M00()
{
	ReleaseEffectLensFlare();
}

bool
K7Stage413M00::InitializeCallBack( void )
{
	HereComeANewHSInit( PR_HS_ROLLING, ENENO_4_413M00_7 );
	while( CheckSetupEffectLensFlare()==false ){
		K7SCR_RETSYS() ;
	}
	mpEffectLensFlare = CreateEffectLensFlare("sun_alpha");
	return true;
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage413M00::CreateCallBack( void )
{
	if( GetPrevStageID()==K7STGID(412,0) ){
		K7SCR_SET_SCENARIO_FLAG(K7SCN04_EVFL_ILLUSION_TOWN_CLEAR);
	}
	// YtA
	SetupEffectLensFlare();
	//GtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage413M00::CondChangeCallBack( void )
{
	//E˔j
	if( K7SCR_GET_SCENARIO_FLAG(EV040104) == false )
	{
		K7SCR_STG_SET_PATHENABLE( PAT413M00_BARRIER_INNER, false );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PAT413M00_BARRIER_RIDDLE, false );
		SimpleModelDisp( MDL413M00_BARRIER );
	}else
	{
		K7SCR_STG_SET_PATHENABLE( PAT413M00_BARRIER_INNER, true );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PAT413M00_BARRIER_RIDDLE, true );
		SimpleModelHide( MDL413M00_BARRIER );
	}
	
	//V[gJbg444
	K7SCR_SET_SCENARIO_FLAG( EV413444 );
	if( K7SCR_GET_SCENARIO_FLAG(EV413444) == true )
	{
		if( K7SCR_GET_SCENARIO_FLAG(EV444413) == true )
		{
			K7SCR_STG_SET_PATHENABLE( PAT413M00_SHORTCUT444, true );
			K7SCR_EVNO_SETENABLE( K7EVENTNO(040410), false );
		}else
		{
			K7SCR_STG_SET_PATHENABLE( PAT413M00_SHORTCUT444, false );
			K7SCR_EVNO_SETENABLE( K7EVENTNO(040410), true );
		}
		SimpleModelDisp( MDL413M00_SHORTCUT444_LIGHT );
		SimpleModelHide( MDL413M00_SHORTCUT444_DARK );
		EffectFireDisp( GetJObj(MDL413M00_WARP_CANDLE_444), mpEffectFire );
	}else
	{
		K7SCR_STG_SET_PATHENABLE( PAT413M00_SHORTCUT444, false );
		SimpleModelHide( MDL413M00_SHORTCUT444_LIGHT );
		SimpleModelDisp( MDL413M00_SHORTCUT444_DARK );
		EffectFireStop( mpEffectFire );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040410), true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage413M00::TerminateCallBack( void )
{
	//̃GtFNgI
	EffectFireStop( mpEffectFire );
	while( WK7RenderObj::ReleaseEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage413M00::SetCurrentCallBack( void )
{
	SetCurrentCallBackDefaultProc();
	
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){901.761f, 25.038f, -2097.250f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_AMB_SPARROW);
		mAmbPlaySE = true;
	}
	
	//GpoptOݒ
	if( GetPrevStageID() == K7STGID(412,0) )
	{
		K7SCR_SET_SCENARIO_FLAG( EN413M00_FROM412M00 );
		K7SCR_RESET_SCENARIO_FLAG( EN413M00_FROM415M00 );
	}else
	if( GetPrevStageID() == K7STGID(415,0) )
	{
		K7SCR_RESET_SCENARIO_FLAG( EN413M00_FROM412M00 );
		K7SCR_SET_SCENARIO_FLAG( EN413M00_FROM415M00 );
	}else
	{
		K7SCR_RESET_SCENARIO_FLAG( EN413M00_FROM412M00 );
		K7SCR_RESET_SCENARIO_FLAG( EN413M00_FROM415M00 );
	}
	
	//V^HSЉ
	if( false == HereComeANewHS( PR_HS_ROLLING, ENENO_4_413M00_7, "branchD1", CAM413M00_HS_PRESEN_START, CAM413M00_HS_PRESEN_END,
								0,
								201,  193,-140,  61, 879, 122 ) )
	{
		SetManualBranch(false);
		return( false );
	}
	
	return( false );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage413M00::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//E\N444
		case	K7EVENTNO( 040410 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			FixCamMes( CAM413M00_CANDLE_444, MES413M00_LIGHT );
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			#if	0
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//̎wւ𑕔ĂȂ
			if( K7SCR_EVEQUIPRING(RING_FIRE) == false )
			{
				FixCamWithRiddle( CAM413M00_CANDLE_444 );
			}else
			{
				FixCam( CAM413M00_CANDLE_444 );
				K7SCR_TIMEWAIT( 1200 );
				EffectFireStart( GetJObj(MDL413M00_WARP_CANDLE_444), mpEffectFire, CAM413M00_CANDLE_444, GetJObj(MDL413M00_SHORTCUT444_LIGHT), GetJObj(MDL413M00_SHORTCUT444_DARK) );
				K7SCR_SET_SCENARIO_FLAG( EV413444 );
				K7SCR_EVCONDCHANGE();
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			#endif
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );

}

//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage413M00::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	eventNo  = GetBpEventNo( info );
	int	pathNo   = GetBpPathNo( info );
	
	switch( eventNo )
	{
		//E
		case	K7EVENTNO( 040107 ):
			if( (K7SCR_GET_SCENARIO_FLAG(EV040104) == false) && (pathNo == 0) )
			{
				gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
			}
			break;
		
		//ftHg
		default:
			return( true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//XyVAreBgp
//------------------------------------------------------------------------------
bool
K7Stage413M00::SpAbilityCallBack( WK7SpAbilityInfo &info )
{
	WK7PlayerSpInfoKed* pKedInfo;
	
	switch( info.mAbilityID )
	{
		//JGf̃V[
		case	PC_SPA_BLOODY_SHOWER:
			if( K7SCR_GET_SCENARIO_FLAG(EV040104) == false )
			{
				pKedInfo = WK7PLAYERCONTROL->GetSpInfoKed();
				K7SCR_SET_SCENARIO_FLAG( EV040104 );
				WK7PLAYERCONTROL->SetSpInfoType( 0 );
				pKedInfo->mpTargetJObj = GetJObj( MDL413M00_BARRIER );
				pKedInfo->mKedPos .x   =   931.973f;
				pKedInfo->mKedPos .y   =       0.0f;
				pKedInfo->mKedPos .z   = -1923.471f;
				pKedInfo->mKedRotY     =    HALF_PI;
				pKedInfo->mZanPos .x   =   938.292f;
				pKedInfo->mZanPos .y   =       0.0f;
				pKedInfo->mZanPos .z   = -1930.161f;
				pKedInfo->mZanRotY     =       0.0f;
				//[VJn
				while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_MOTSTART ){K7SCR_RETSYS();}
				FixCam( CAM413M00_KED_BLOOD );
				//cvOo
				while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_ZANAPPEAR ){K7SCR_RETSYS();}
				FixCam( CAM413M00_ZAN_POS );
				//wJn
				while( WK7PLAYERCONTROL->GetSpProc()!=SPKED2_KUIKUI   ){K7SCR_RETSYS();}
				FixCam( CAM413M00_ZAN_FINGER );
				//Ej
			//	WK7CAM->StartLinearInterpolateOnLinearPath( mpOneShotCamera[CAM413M00_BARRIER].pos,
			//												mpOneShotCamera[CAM413M00_BARRIER].tgt,
			//												90.0f );
				while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_BREAKOBJ ){K7SCR_RETSYS();}
				FixCam( CAM413M00_BARRIER );
				//while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_ZANDISAPPEAR ){K7SCR_RETSYS();}
				while( WK7PLAYERCONTROL->SpAtkEffectEndTest(mID,K7KED)==false ){K7SCR_RETSYS();}
			}else
			{
				WK7PLAYERCONTROL->SetSpAbilityCancel( true );
				return( false );
			}
			return( false );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

