////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage415M00 yh~jJzZX
//
// K7Stage415M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE415M00_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage415M00.h"

//bZ[W
#define	MES415M00_UNLOCK			(0)	//J
#define	MES415M00_CYO_JUMP			(1)	//Wv
#define	MES415M00_LOCK				(2)	//Ă
//f
#define	MDL415M00_CYO_PICKING_POS	"cyo_pos"			//R[eJW
#define	MDL415M00_LOCK_ON			"cyo_padlock_on"	//̂Ă
#define	MDL415M00_LOCK_OFF			"cyo_padlock_off"	//̊JĂ




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage415M00::K7Stage415M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage415M00_Camera );
	mpEffectLensFlare = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage415M00::~K7Stage415M00()
{
	ReleaseEffectLensFlare();
}

bool
K7Stage415M00::CreateCallBack( void )
{
	// YtA
	SetupEffectLensFlare();
	return true;
}

bool
K7Stage415M00::InitializeCallBack( void )
{
	while( CheckSetupEffectLensFlare()==false ){
		K7SCR_RETSYS() ;
	}
	mpEffectLensFlare = CreateEffectLensFlare("sun_alpha");
	return true;
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage415M00::CondChangeCallBack( void )
{
	//R[êJ
	if( K7SCR_GET_SCENARIO_FLAG(DR040102) == false )
	{
		SimpleModelDisp( MDL415M00_LOCK_ON );
		SimpleModelHide( MDL415M00_LOCK_OFF );
	}else
	{
		SimpleModelHide( MDL415M00_LOCK_ON );
		SimpleModelDisp( MDL415M00_LOCK_OFF );
	}
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage415M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//V[gJbg
		case	K7EVENTDOOR( 040103 ):
			if( K7SCR_GET_SCENARIO_FLAG(DR040102) == false )
			{
				if( WK7PLAYERCONTROL->GetMainID() == K7CYO )
				{
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					SimpleCyoPicking( MDL415M00_CYO_PICKING_POS, CAM415M00_CYO_PICKING );
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
					K7SCR_SET_SCENARIO_FLAG( DR040102 );
					K7SCR_EVCONDCHANGE();
					K7SCR_PC_SETVISIBLE( false );
					FixCam( CAM415M00_SHORTCUT_DOOR );
					K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
					info.mCinemaScopeClear = true;
					//K7SCR_STGC_MESSAGE_B( MES415M00_UNLOCK );
					K7SCR_PC_SETVISIBLE( true );
					K7SCR_EXIT_PLAYMODE();
					K7SCR_EXIT_DEMOPAUSE();
				}else
				{
					FixCamMesWithRiddle( CAM415M00_SHORTCUT_DOOR, MES415M00_LOCK );
					return( false );
				}
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage415M00::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	eventNo  = GetBpEventNo( info );
	int	pathNo   = GetBpPathNo( info );
	
	switch( eventNo )
	{
		//Wvn_
		case	K7EVENTNO( 040105 ):
		case	K7EVENTNO( 040108 ):
			if( (K7SCR_GET_SCENARIO_FLAG(EV040105) == false) && (pathNo == 0) )
			{
				gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
			}
			break;
		
		//ftHg
		default:
			return( true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//XyVAreBgp
//------------------------------------------------------------------------------
bool
K7Stage415M00::SpAbilityCallBack( WK7SpAbilityInfo &info )
{
	WK7PlayerSpInfoCyo* pCyoInfo;
	
	switch( info.mAbilityID )
	{
		case	PC_SPA_BOOST_JUMP:
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			//Wv
			pCyoInfo = WK7PLAYERCONTROL->GetSpInfoCyo();
			pCyoInfo->mpToBpName      = "branchI_d4_415M00branchH";
			pCyoInfo->mFromPos.x      =   985.000f;
			pCyoInfo->mFromPos.y      =     0.000f;
			pCyoInfo->mFromPos.z      = -1341.373f;
			pCyoInfo->mFromRotY       =     1.571f;
			pCyoInfo->mToPos.x        =  1021.000f;
			pCyoInfo->mToPos.y        =    30.000f;
			pCyoInfo->mToPos.z        = -1343.000f;
			pCyoInfo->mToRotY         =     1.571f;
			pCyoInfo->mStageMessage   = true;
			pCyoInfo->mStageMessageID = MES415M00_CYO_JUMP;
			pCyoInfo->mLandingSE      = true;
			pCyoInfo->mLandingSEID    = SFX_PC_CYO_CHAKUCHI_CONC;
			//Jݒ
			FixCam( CAM415M00_JUMP_BOTTOM );
			//Wv[VĐ
			while( WK7PLAYERCONTROL->GetSpProc() < SPCYO_JUMPWAIT ){K7SCR_RETSYS();}
			//Jݒ
			FixCam( CAM415M00_JUMP_UPPER );
			//n[VĐ
			while( WK7PLAYERCONTROL->GetSpProc()!=SPCYO_IDLE ){K7SCR_RETSYS();}
			//WvtOON
			K7SCR_SET_SCENARIO_FLAG( EV040105 );
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			return( false );
			break;
		
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//cvOCxg
//------------------------------------------------------------------------------
bool
K7Stage415M00::ZanEventCallBack( WK7ZanEventInfo &info )
{
	switch( info.mEventNo )
	{
		//gFgBX
		case	K7EVENTZAN(040152):
			K7SCR_SET_SCENARIO_FLAG( EV415TALK_TRAVIS );
			break;
		
		default:
			break;
	}
	return( true );
}

bool
K7Stage415M00::SetCurrentCallBack( void )
{
	SetCurrentCallBackDefaultProc();
	
	while( K7SCR_STG_GET_CURRENTID() == K7STGID(415,0) ){
		Vec pcPos;
		
		WK7PLAYERCONTROL->GetPosition(pcPos);
		if ( pcPos.y > 20.f ){						// Gȍ
			WK7PLAYERCONTROL->SetMuteki();
		}else{
			WK7PLAYERCONTROL->ClearMuteki();
		}
		K7SCR_RETSYS();
	}
	
	return( true );
}

bool
K7Stage415M00::TerminateCallBack( void )
{
	// GԂ̂肠
	WK7PLAYERCONTROL->ClearMuteki();
	return( true );
}

