////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage420M01 yh~jJz2K
//
// K7Stage420M01.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE420M01_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage420M01.h"
#include "..\..\..\sato\SK7SpecialData.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

//bZ[W
#define	MES420M00_LIGHT		(0)		//Cg_Ă
//pX
#define	PAT420M01_SHORTCUT444		"event_040411_0"	//444ւ̃V[gJbgpX
//f
#define	MDL420M01_SHORTCUT444_LIGHT	"ON"				//V[gJbg420̓
#define	MDL420M01_SHORTCUT444_DARK	"OFF"				//V[gJbg420̈
#define	MDL420M01_WARP_CANDLE_444	"warp_candle"		//V[gJbg420̃E\N




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage420M01::K7Stage420M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage420M01_Camera );
	mpEffectFire = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage420M01::~K7Stage420M01()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage420M01::CreateCallBack( void )
{
	//GtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage420M01::CondChangeCallBack( void )
{
	//V[gJbg444
	K7SCR_SET_SCENARIO_FLAG( EV420444 );
	if( K7SCR_GET_SCENARIO_FLAG(EV420444) == true )
	{
		if( K7SCR_GET_SCENARIO_FLAG(EV444420) == true )
		{
			K7SCR_STG_SET_PATHENABLE( PAT420M01_SHORTCUT444, true );
			K7SCR_EVNO_SETENABLE( K7EVENTNO(040411), false );
		}else
		{
			K7SCR_STG_SET_PATHENABLE( PAT420M01_SHORTCUT444, false );
			K7SCR_EVNO_SETENABLE( K7EVENTNO(040411), true );
		}
		SimpleModelDisp( MDL420M01_SHORTCUT444_LIGHT );
		SimpleModelHide( MDL420M01_SHORTCUT444_DARK );
		EffectFireDisp( GetJObj(MDL420M01_WARP_CANDLE_444), mpEffectFire );
	}else
	{
		K7SCR_STG_SET_PATHENABLE( PAT420M01_SHORTCUT444, false );
		SimpleModelHide( MDL420M01_SHORTCUT444_LIGHT );
		SimpleModelDisp( MDL420M01_SHORTCUT444_DARK );
		EffectFireStop( mpEffectFire );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040411), true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage420M01::TerminateCallBack( void )
{
	//̃GtFNgI
	EffectFireStop( mpEffectFire );
	while( WK7RenderObj::ReleaseEffectAnimResource(ANIMID_FIRE) == false )
	{
		K7SCR_RETSYS();
	}
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage420M01::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//E\N444
		case	K7EVENTNO( 040411 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			FixCamMes( CAM420M01_CANDLE_444, MES420M00_LIGHT );
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
		#if	0
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//̎wւ𑕔ĂȂ
			if( K7SCR_EVEQUIPRING(RING_FIRE) == false )
			{
				FixCamWithRiddle( CAM420M01_CANDLE_444 );
			}else
			{
				FixCam( CAM420M01_CANDLE_444 );
				K7SCR_TIMEWAIT( 1200 );
				EffectFireStart( GetJObj(MDL420M01_WARP_CANDLE_444), mpEffectFire, CAM420M01_CANDLE_444, GetJObj(MDL420M01_SHORTCUT444_LIGHT), GetJObj(MDL420M01_SHORTCUT444_DARK) );
				K7SCR_SET_SCENARIO_FLAG( EV420444 );
				K7SCR_EVCONDCHANGE();
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
		#endif
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}
