////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage421M00 yh~jJzʘH
//
// K7Stage421M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE421M00_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage421M00.h"
#include "..\..\..\sato\SK7Special.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Yam\YK7EffectModelFire.h"

//---- define ----
#define	STG421M00_SHADOW_ELASE_TICK	(4800)		//êɂ鎞
#define	STG421M00_LAMP_ON_TICK		(1200)		//ʘH̃E\N_Ԋu
//P[^[
#define	LOC421M00_CANDLE		"candle_light%d"//E\N
#define	LOC421M00_CANDLE1		"candle_light1"	//E\N1
//pX
#define	PAT421M00_TO_INNER		"event_040201"	//v_̃pX
//f
#define	MDL421M00_SHADOW		"shadow_plane"	//ʘHBĂA
#define	MDL421M00_LIGHT			"ON_candle"		//ʘHƂ炷
#define	MDL421M00_CANDLE_01		"ON_01"			//E\N1
#define	MDL421M00_CANDLE_02		"ON_02"			//E\N2
#define	MDL421M00_CANDLE_03		"ON_03"			//E\N3
#define	MDL421M00_CANDLE_04		"ON_04"			//E\N4
#define	MDL421M00_CANDLE_05		"ON_05"			//E\N5
#define	MDL421M00_CANDLE_06		"ON_06"			//E\N6
#define	MDL421M00_SHADOW_INNER	"OFF_00"		//ʘH̉e
#define	MDL421M00_FOOTLIGHT		"lamp_under_shadow"	//ɗE\Ň
#define	MDL421M00_FLOOR_LIGHTS	"light_floor"	//vʘH̏̌
//bZ[W
#define	MES421M00_USE_FIRE_RING	(0)				//̎wւg




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage421M00::K7Stage421M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	int	i;
	
	SetOneShotCamLocTbl( K7Stage421M00_Camera );
	
	for( i = 0; i < STG421M00_EF_FIRE_NUM; i++ )
	{
		mpEffectFire[i] = NULL;
	}
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage421M00::~K7Stage421M00()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage421M00::CreateCallBack( void )
{
	//GtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage421M00::CondChangeCallBack( void )
{
	//v_Ă邩
	if( K7SCR_GET_SCENARIO_FLAG(EV040201) == false )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040201), true );
		K7SCR_STG_SET_PATHENABLE( PAT421M00_TO_INNER, false );
		SimpleModelDisp( MDL421M00_SHADOW );
		SimpleModelHide( MDL421M00_LIGHT );
		SimpleModelHide( MDL421M00_FOOTLIGHT );
		EffectFireStop421();
		gpSound->mPlayStreamEx( HPS_SAFE_PLACE );
	}else
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040201), false );
		K7SCR_STG_SET_PATHENABLE( PAT421M00_TO_INNER, true );
		SimpleModelHide( MDL421M00_SHADOW );
		SimpleModelDisp( MDL421M00_LIGHT );
		SimpleModelDisp( MDL421M00_FOOTLIGHT );
		EffectFireDisp421();
		gpSound->mPlayStreamEx( HPS_SAFE_PLACE_D );
	}
	
	//a҂̃[r[
	if( K7SCR_GET_SCENARIO_FLAG(MV040003) == false )
	{
		SimpleModelHide( MDL421M00_CANDLE_01 );
		SimpleModelHide( MDL421M00_CANDLE_02 );
		SimpleModelHide( MDL421M00_CANDLE_03 );
		SimpleModelHide( MDL421M00_CANDLE_04 );
		SimpleModelHide( MDL421M00_CANDLE_05 );
		SimpleModelHide( MDL421M00_CANDLE_06 );
		SimpleModelHide( MDL421M00_FLOOR_LIGHTS );
		SimpleModelDisp( MDL421M00_SHADOW_INNER );
	}else
	{
		SimpleModelDisp( MDL421M00_CANDLE_01 );
		SimpleModelDisp( MDL421M00_CANDLE_02 );
		SimpleModelDisp( MDL421M00_CANDLE_03 );
		SimpleModelDisp( MDL421M00_CANDLE_04 );
		SimpleModelDisp( MDL421M00_CANDLE_05 );
		SimpleModelDisp( MDL421M00_CANDLE_06 );
		SimpleModelDisp( MDL421M00_FLOOR_LIGHTS );
		SimpleModelHide( MDL421M00_SHADOW_INNER );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage421M00::TerminateCallBack( void )
{
	//̃GtFNgI
	EffectFireStop421();
	while( WK7RenderObj::ReleaseEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage421M00::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//v
		case	K7EVENTNO( 040201 ):
			if( K7SCR_GET_SCENARIO_FLAG(EV040201) == false )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//̎wւ𑕔ĂȂ
				if( K7SCR_EVEQUIPRING(RING_FIRE) == false )
				{
					FixCamWithRiddle( CAM421M00_LAMP );
				}else
				{
					FixCam( CAM421M00_LAMP );
					K7SCR_STGC_MESSAGE_B( MES421M00_USE_FIRE_RING );
					EffectFireStart421();
					K7SCR_SET_SCENARIO_FLAG( EV040201 );
					K7SCR_EVCONDCHANGE();
				}
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage421M00::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	eventNo  = GetBpEventNo( info );
	int	pathNo   = GetBpPathNo( info );
	
	switch( eventNo )
	{
		//a҂̃[r[
		case	K7EVENTNO( 040204 ):
			if( (pathNo == 0) && (K7SCR_GET_SCENARIO_FLAG(MV040003) == false) )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				mLightUp();
				K7SCR_SET_SCENARIO_FLAG( MV040003 );
				K7SCR_EVCONDCHANGE();
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
			}
			break;
		
		//ftHg
		default:
			return( true );
	}
	
	return( true );
}
//------------------------------------------------------------------------------
//E\Nɉ΂_
//------------------------------------------------------------------------------
void
K7Stage421M00::EffectFireStart421( void )
{
//	Vec					posRing;
//	Vec					posFire;
//	WK7JObj*			pJObj;
//	WK7RenderObjEffect*	fire;
//	
//	posRing.x = K7Stage421M00_Camera[CAM421M00_LAMP].pos.x;
//	posRing.y = K7Stage421M00_Camera[CAM421M00_LAMP].pos.y - 3.0f;
//	posRing.z = K7Stage421M00_Camera[CAM421M00_LAMP].pos.z;
//	
//	//̔ѐW擾
//	pJObj = GetJObj( LOC421M00_CANDLE1 );
//	if( pJObj != NULL )
//	{
//		pJObj->GetWorldPosition( posFire );
//	}
//	
//	//wւ̉GtFNg\
//	if( ((fire=CreateEffectModelFire((const char*)NULL,MFIRE_CANDLE,&posRing,0.5f)) != NULL) && (fire->GetEffect() != NULL) )
//	{
//		SetWindModelFireEffect( fire->GetEffect(),
//								(Vec){posFire.x-posRing.x,posFire.y-posRing.y,posFire.z-posRing.z},
//								0.05f );
//	}
//	K7SCR_TIMEWAIT( 4800 * 3 );
//	if( fire != NULL )
//	{
//		DelReqEffect( fire );
//	}
	
	//\
	gpSound->mPlaySE( SFX_SYS_TRUE );
	gpSound->mPlaySE( SFX_SCE4_LAMP );
	EffectFireDisp421();
	
	//e
	AlphaObjChange( GetJObj(MDL421M00_LIGHT), GetJObj(MDL421M00_SHADOW), STG421M00_SHADOW_ELASE_TICK );
	K7SCR_TIMEWAIT( STG421M00_SHADOW_ELASE_TICK );
}
//------------------------------------------------------------------------------
//E\N̉΂\
//------------------------------------------------------------------------------
void
K7Stage421M00::EffectFireDisp421( void )
{
	int      i;
	char     objname[64];
	Vec      loc;
	WK7JObj* pJObj;
	
	for( i = 0; i < STG421M00_EF_FIRE_NUM; i++ )
	{
		sprintf( objname, LOC421M00_CANDLE, i + 1 );
		pJObj = GetJObj( objname );
		if( pJObj != NULL )
		{
			pJObj->GetWorldPosition( loc );
		}else
		{
			loc.x = loc.y = loc.z = 0.0f;
		}
		//̃GtFNgNGCg
		if( (mpEffectFire[i] == NULL)
		 && ((mpEffectFire[i]=CreateEffectModelFire((const char*)NULL,MFIRE_CANDLE,&loc,0.25f)) != NULL)
		 && (mpEffectFire[i]->GetEffect() != NULL) )
		{
			SetWindModelFireEffect( mpEffectFire[i]->GetEffect(), (Vec){-0.2f,0.0f,-1.0f}, 0.0f );
		}
	}
}
//------------------------------------------------------------------------------
//E\N̉΂\
//------------------------------------------------------------------------------
void
K7Stage421M00::EffectFireStop421( void )
{
	int	i;
	
	for( i = 0; i < STG421M00_EF_FIRE_NUM; i++ )
	{
		if( mpEffectFire[i] != NULL )
		{
			DelReqEffect( mpEffectFire[i] );
			mpEffectFire[i] = NULL;
		}
	}
}
//------------------------------------------------------------------------------
//ʘH̃CgAbv
//------------------------------------------------------------------------------
void
K7Stage421M00::mLightUp( void )
{
	WK7JObj* pJObj;
	WK7JObj* pJObj2;
	
	//mCY
	K7SCR_NOISE_REQUEST();
	K7SCR_STAGE_RELEASE();
	K7SCR_NOISE_RELEASE();
	//[r[ĐEa
	K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_04050202 );
	//mCY
	K7SCR_NOISE_REQUEST();
	K7SCR_STAGE_RESTORE();
	K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR( "chara_position", "curve26", 0.0f, 1 );
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	K7SCR_NOISE_RELEASE();
	
	//E\NAœ_
	pJObj = GetJObj( MDL421M00_CANDLE_01 );
	gpSound->mPlaySE( SFX_SCE4_LAMP );
	AlphaObjChange( pJObj, NULL, STG421M00_LAMP_ON_TICK );
	
	pJObj = GetJObj( MDL421M00_CANDLE_02 );
	gpSound->mPlaySE( SFX_SCE4_LAMP );
	AlphaObjChange( pJObj, NULL, STG421M00_LAMP_ON_TICK );
	
	pJObj = GetJObj( MDL421M00_CANDLE_03 );
	gpSound->mPlaySE( SFX_SCE4_LAMP );
	AlphaObjChange( pJObj, NULL, STG421M00_LAMP_ON_TICK );
	
	pJObj = GetJObj( MDL421M00_CANDLE_04 );
	gpSound->mPlaySE( SFX_SCE4_LAMP );
	AlphaObjChange( pJObj, NULL, STG421M00_LAMP_ON_TICK );
	
	pJObj = GetJObj( MDL421M00_CANDLE_05 );
	gpSound->mPlaySE( SFX_SCE4_LAMP );
	AlphaObjChange( pJObj, NULL, STG421M00_LAMP_ON_TICK );
	
	pJObj  = GetJObj( MDL421M00_CANDLE_06 );
	pJObj2 = GetJObj( MDL421M00_SHADOW_INNER );
	gpSound->mPlaySE( SFX_SCE4_LAMP );
	AlphaObjChange( pJObj, pJObj2, STG421M00_LAMP_ON_TICK );
	
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
//	//mCY
//	K7SCR_NOISE_REQUEST();
//	K7SCR_PC_SETVISIBLE( true );
//	K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR( "chara_position", "curve26", 0.0f, 1 );
//	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
//	K7SCR_NOISE_RELEASE();
}
