////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage441M00 yh~jJzZʘH
//
// K7Stage441M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE441M00_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage441M00.h"
#include "..\..\..\sato\SK7SpecialData.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

//bZ[W
#define	MES441M00_LIGHT		(0)		//΂_Ă
//pX
#define	PAT441M00_SHORTCUT444		"event_040412_0"	//444ւ̃V[gJbgpX
//f
#define	MDL441M00_SHORTCUT444_LIGHT	"ON"				//V[gJbg420̓
#define	MDL441M00_SHORTCUT444_DARK	"OFF"				//V[gJbg420̈
#define	MDL441M00_WARP_CANDLE_444	"warp_candle"		//V[gJbg420̃E\N




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage441M00::K7Stage441M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage441M00_Camera );
	mpEffectFire = NULL;
	mpEffectLensFlare = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage441M00::~K7Stage441M00()
{
	ReleaseEffectLensFlare();
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage441M00::CreateCallBack( void )
{
	//GtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_FIRE) == NULL )
	{
		K7SCR_RETSYS();
	}
	// YtA
	SetupEffectLensFlare();
	return( true );
}

bool
K7Stage441M00::InitializeCallBack( void )
{
	while( CheckSetupEffectLensFlare()==false ){
		K7SCR_RETSYS() ;
	}
	mpEffectLensFlare = CreateEffectLensFlare("sun_alpha");
	return true;
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage441M00::CondChangeCallBack( void )
{
	//V[gJbg444
	K7SCR_SET_SCENARIO_FLAG( EV441444 );
	if( K7SCR_GET_SCENARIO_FLAG(EV441444) == true )
	{
		if( K7SCR_GET_SCENARIO_FLAG(EV444441) == true )
		{
			K7SCR_STG_SET_PATHENABLE( PAT441M00_SHORTCUT444, true );
			K7SCR_EVNO_SETENABLE( K7EVENTNO(040412), false );
		}else
		{
			K7SCR_STG_SET_PATHENABLE( PAT441M00_SHORTCUT444, false );
			K7SCR_EVNO_SETENABLE( K7EVENTNO(040412), true );
		}
		SimpleModelDisp( MDL441M00_SHORTCUT444_LIGHT );
		SimpleModelHide( MDL441M00_SHORTCUT444_DARK );
		EffectFireDisp( GetJObj(MDL441M00_WARP_CANDLE_444), mpEffectFire );
	}else
	{
		K7SCR_STG_SET_PATHENABLE( PAT441M00_SHORTCUT444, false );
		SimpleModelHide( MDL441M00_SHORTCUT444_LIGHT );
		SimpleModelDisp( MDL441M00_SHORTCUT444_DARK );
		EffectFireStop( mpEffectFire );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040412), true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage441M00::TerminateCallBack( void )
{
	//̃GtFNgI
	EffectFireStop( mpEffectFire );
	while( WK7RenderObj::ReleaseEffectAnimResource(ANIMID_FIRE) == false )
	{
		K7SCR_RETSYS();
	}
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage441M00::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//E\N444
		case	K7EVENTNO( 040412 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			FixCamMes( CAM441M00_CANDLE_444, MES441M00_LIGHT );
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
		#if	0
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			//̎wւ𑕔ĂȂ
			if( K7SCR_EVEQUIPRING(RING_FIRE) == false )
			{
				FixCamWithRiddle( CAM441M00_CANDLE_444 );
			}else
			{
				FixCam( CAM441M00_CANDLE_444 );
				K7SCR_TIMEWAIT( 1200 );
				EffectFireStart( GetJObj(MDL441M00_WARP_CANDLE_444), mpEffectFire, CAM441M00_CANDLE_444, GetJObj(MDL441M00_SHORTCUT444_LIGHT), GetJObj(MDL441M00_SHORTCUT444_DARK) );
				K7SCR_SET_SCENARIO_FLAG( EV441444 );
				K7SCR_EVCONDCHANGE();
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
		#endif
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}
