////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage442M00 yh~jJzKiʘH
//
// K7Stage442M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE442M00_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage442M00.h"
#include "..\..\..\sato\SK7SpecialData.h"
#include "..\..\Yam\YK7EffectItemGet.h"

//f
#define	MDL442M00_NOW			"now"			//
#define	MDL442M00_PAST			"past"			//ߋ
#define	MDL442M00_STRANGE_NOW	"obj12_now"		//svcȑ`E
#define	MDL442M00_STRANGE_PAST	"obj12_past"	//svcȑ`Eߋ
#define	MDL442M00_WATCH			"event_040401"	//v
//[V
#define	MOT442M00_WATCH			(0)				//v
//bZ[W
#define	MES442M00_GET_STRANGE	(0)				//svcȑ`肵
#define	MES442M00_PAST_RIDDLE	(1)				//Ă
#define	MSE442M00_USE_PAST_RING	(2)				//ߋ̎wւg

#define	COL442M00_PAST			(0xDBC464ff)	//ߋCxg̐F
#define	STG442M00_PAST_TIME		(12000)			//ߋCxgɂ鎞

#define	PRI442M00_BLACK_WALL	(WK7JOBJ_ZSORTPRIO_DEFAULT+(WK7JOBJ_ZSORTPRIO_SCALE*1))	//D揇ʁF
#define	PRI442M00_WALL_RIGHT	(WK7JOBJ_ZSORTPRIO_DEFAULT+(WK7JOBJ_ZSORTPRIO_SCALE*2))	//D揇ʁFE
#define	PRI442M00_WALL_UNDER	(WK7JOBJ_ZSORTPRIO_DEFAULT+(WK7JOBJ_ZSORTPRIO_SCALE*3))	//D揇ʁF̑
#define	PRI442M00_ROCK			(WK7JOBJ_ZSORTPRIO_DEFAULT+(WK7JOBJ_ZSORTPRIO_SCALE*4))	//D揇ʁF
#define	PRI442M00_WALL			(WK7JOBJ_ZSORTPRIO_DEFAULT+(WK7JOBJ_ZSORTPRIO_SCALE*5))	//D揇ʁF
#define	PRI442M00_STAND			(WK7JOBJ_ZSORTPRIO_DEFAULT+(WK7JOBJ_ZSORTPRIO_SCALE*6))	//D揇ʁF
#define	PRI442M00_STRANGE		(WK7JOBJ_ZSORTPRIO_DEFAULT+(WK7JOBJ_ZSORTPRIO_SCALE*7))	//D揇ʁF`
#define	PRI442M00_FENCE			(WK7JOBJ_ZSORTPRIO_DEFAULT+(WK7JOBJ_ZSORTPRIO_SCALE*8))	//D揇ʁF





//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage442M00::K7Stage442M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpEffectLensFlare = NULL;
	SetOneShotCamLocTbl( K7Stage442M00_Camera );
	PastInit( COL442M00_PAST );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage442M00::~K7Stage442M00()
{
	ReleaseEffectLensFlare();
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage442M00::CreateCallBack( void )
{
	CreateOwnStageMotion( MOT442M00_WATCH );
	// YtA
	SetupEffectLensFlare();
	return( true );
}

bool
K7Stage442M00::InitializeCallBack( void )
{
	while( CheckSetupEffectLensFlare()==false ){
		K7SCR_RETSYS() ;
	}
	mpEffectLensFlare = CreateEffectLensFlare("sun_alpha");
	return true;
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage442M00::CondChangeCallBack( void )
{
	//݂\
	SimpleModelDisp( MDL442M00_NOW );
	//ߋ\
	SimpleModelHide( MDL442M00_PAST );
	
	//ߋ̎wւg
	if( K7SCR_GET_SCENARIO_FLAG(EV442USE_PASTRING) == false )
	{
		//ߋ̎wւgĂȂ
		SimpleSetStartMotion( MDL442M00_WATCH, MOT442M00_WATCH );
		SimpleModelDisp( MDL442M00_NOW );			//ĂE
		SimpleModelDisp( MDL442M00_STRANGE_NOW );	//ĂEsvcȑ`
		SimpleModelHide( MDL442M00_PAST );			//ĂȂE
		SimpleModelHide( MDL442M00_STRANGE_PAST );	//ĂȂEsvcȑ`
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040401), true );
	}else
	{
		//ߋ̎wւg
		SimpleSetLastMotion( MDL442M00_WATCH, MOT442M00_WATCH );
		SimpleModelHide( MDL442M00_NOW );			//ĂE
		SimpleModelHide( MDL442M00_STRANGE_NOW );	//ĂEsvcȑ`
		SimpleModelDisp( MDL442M00_PAST );			//ĂȂE
		//svcȑ`
		if( K7SCR_GET_SCENARIO_FLAG(EV040401) == false )
		{
			//svcȑ`ĂȂ
			SimpleModelDisp( MDL442M00_STRANGE_PAST );	//ĂȂEsvcȑ`
			K7SCR_EVNO_SETENABLE( K7EVENTNO(040401), true );
		}else
		{
			//svcȑ`
			SimpleModelHide( MDL442M00_STRANGE_PAST );	//ĂȂEsvcȑ`
			K7SCR_EVNO_SETENABLE( K7EVENTNO(040401), false );
		}
	}
	
#if	0
	//svcȑ`擾
	if( K7SCR_GET_SCENARIO_FLAG(EV040401) == false )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040401), true );
		SimpleModelDisp( MDL442M00_STRANGE_NOW );
	}else
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040401), false );
		SimpleModelHide( MDL442M00_STRANGE_NOW );
	}
#endif
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage442M00::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//svcȑ`
		case	K7EVENTNO( 040401 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			//ߋ̎wւg
			if( K7SCR_GET_SCENARIO_FLAG(EV442USE_PASTRING) == false )
			{
				//ߋ̎wւ𑕔ĂȂ
				if( K7SCR_EVEQUIPRING(RING_PAST) == false )
				{
					FixCamMesWithRiddle( CAM442M00_STRANGE, MES442M00_PAST_RIDDLE );
				}else
				{
					GoThePast442M00();
				}
			}else
			//svcȑ`
			if( K7SCR_GET_SCENARIO_FLAG(EV040401) == false )
			{
				K7SCR_SET_SCENARIO_FLAG( EV040401 );
				K7SCR_EVSETITEM( K7EVITEM_KEY(040401), true );
				FixCam( CAM442M00_STRANGE );
				K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
				SimpleItemGetMes( MES442M00_GET_STRANGE, MDL442M00_STRANGE_PAST, true );
				K7SCR_EVCONDCHANGE();
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
#if	0
			if( K7SCR_GET_SCENARIO_FLAG(EV040401) == false )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//ߋ̎wւ𑕔ĂȂ
				if( K7SCR_EVEQUIPRING(RING_PAST) == false )
				{
					FixCamMesWithRiddle( CAM442M00_STRANGE, MES442M00_PAST_RIDDLE );
				}else
				{
					GoThePast442M00();
				}
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}
#endif
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//ߋɍs
//------------------------------------------------------------------------------
void
K7Stage442M00::GoThePast442M00( void )
{
	WK7JObj *pJObj, *pJObjDisp, *pJObjHide;
	
	//Jݒ
	FixCam( CAM442M00_STRANGE );
	K7SCR_STGC_MESSAGE_B( MSE442M00_USE_PAST_RING );
	//ߋ
	GoThePast( COL442M00_PAST, NULL, NULL, true );
	SimpleModelDisp( MDL442M00_NOW );
	SimpleModelHide( MDL442M00_PAST );
	//vCIeB̐ݒ
	//
	if( (pJObj=GetJObj("past_wall01_black")) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_BLACK_WALL, false, true );
	}
	if( (pJObj=GetJObj("broken_wall01_black")) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_BLACK_WALL, false, true );
	}
	//
	if( (pJObj=GetJObj("past_wall04_wall")) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_WALL, false, true );
	}
	if( (pJObj=GetJObj("broken_wall04_wall")) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_WALL, false, true );
	}
	//E̕
	if( (pJObj=GetJObj("broken_wall05_wall_right")) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_WALL_RIGHT, false, true );
	}
	//̑
	if( (pJObj=GetJObj("past_wall03_win")) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_WALL_UNDER, false, true );
	}
	if( (pJObj=GetJObj("broken_wall03_win")) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_WALL_UNDER, false, true );
	}
	//
	if( (pJObj=GetJObj("broken_wall03_win_iwa")) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_ROCK, false, true );
	}
	//
	if( (pJObj=GetJObj("past_wall03_win1")) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_STAND, false, true );
	}
	if( (pJObj=GetJObj("broken_wall03_win1")) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_STAND, false, true );
	}
	//`
	if( (pJObj=GetJObj(MDL442M00_STRANGE_PAST)) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_STRANGE, false, true );
	}
	if( (pJObj=GetJObj(MDL442M00_STRANGE_NOW)) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_STRANGE, false, true );
	}
	//
	if( (pJObj=GetJObj("past_wall02_lattice")) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_FENCE, false, true );
	}
	if( (pJObj=GetJObj("broken_wal02_lattice")) != NULL )
	{
		pJObj->SetZSortPrio( PRI442M00_FENCE, false, true );
	}
	//ݒ
	WK7AnimLinearF	Alpha;
	C_SetAlpha		*pSetAlpha[2];
	pSetAlpha[0] = NULL;
	pSetAlpha[1] = NULL;
	Alpha.SetValue( 0.0f );
	Alpha.Play( 1.0f, STG442M00_PAST_TIME );
	pJObjDisp = GetJObj( MDL442M00_PAST );
	pJObjHide = GetJObj( MDL442M00_NOW );
	if( pJObjDisp != NULL ){pSetAlpha[0] = new C_SetAlpha( pJObjDisp->GetJObj(),       Alpha.GetValue(), false );}
	if( pJObjHide != NULL ){pSetAlpha[1] = new C_SetAlpha( pJObjHide->GetJObj(),1.0f - Alpha.GetValue(), false );}
	if( pSetAlpha[0] != NULL ){pSetAlpha[0]->SetVal(         Alpha.GetValue(), false );}
	if( pSetAlpha[1] != NULL ){	pSetAlpha[1]->SetVal( 1.0f - Alpha.GetValue(), false );}
	if( pJObjDisp != NULL ){K7SCR_JOBJ_DISP( pJObjDisp );}
	if( pJObjHide != NULL ){K7SCR_JOBJ_DISP( pJObjHide );}
	//mCY𐰂炷
	K7SCR_NOISE_RELEASE();
	//v[VĐ
	gpSound->mPlaySE( SFX_SCE4_CLOCK_REVERSE );
	if( (pJObj=PlayMotion(MDL442M00_WATCH,MOT442M00_WATCH)) != NULL )
	{
		pJObj->SetMotionLoop( false ,false, true );
	}
	//݂Ɖߋœւ
	if( (pSetAlpha[0] != NULL) || (pSetAlpha[1] != NULL) )
	{
		while( Alpha.IsAnimating() == true )
		{
			K7SCR_RETSYS();
			Alpha.FrameProcess();
			if( pSetAlpha[0] != NULL ){pSetAlpha[0]->SetVal(        Alpha.GetValue(), false );}
			if( pSetAlpha[1] != NULL ){pSetAlpha[1]->SetVal( 1.0f - Alpha.GetValue(), false );}
		}
	}
	GHM_SAFE_DELETE( pSetAlpha[0] );
	GHM_SAFE_DELETE( pSetAlpha[1] );
	if( pJObjDisp != NULL ){K7SCR_JOBJ_DISP( pJObjDisp );}
	if( pJObjHide != NULL ){K7SCR_JOBJ_HIDE( pJObjHide );}
//	AlphaObjChange( GetJObj(MDL442M00_PAST), GetJObj(MDL442M00_NOW), STG442M00_PAST_TIME, -1, false, false );
	//v[VĐI҂
	while( pJObj->GetMotionState(false,true) != WK7MODEL_NOANIM )
	{
		K7SCR_RETSYS();
	}
	gpSound->mStopSE( SFX_SCE4_CLOCK_REVERSE );
	gpSound->mPlaySE( SFX_SYS_TRUE );
	K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
	//ߋ̎wւg
	K7SCR_SET_SCENARIO_FLAG( EV442USE_PASTRING );
	K7SCR_EVCONDCHANGE();
	//߂Ă
	BackTheCurrent();
#if	0
	//Vb^[\D揇ʐݒ
	SetItemGetShutterPriority( 5000 );
	//ACe擾ʂ\
	SimpleItemGetMes( MES442M00_GET_STRANGE, MDL442M00_STRANGE_PAST );
	//߂Ă
	BackTheCurrent( NULL, 0, true );
	SimpleModelDisp( MDL442M00_NOW );
	SimpleModelHide( MDL442M00_PAST );
	//svcȑ`擾
	K7SCR_SET_SCENARIO_FLAG( EV040401 );
	K7SCR_EVSETITEM( K7EVITEM_KEY(040401), true );
	K7SCR_EVCONDCHANGE();
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	K7SCR_PC_SETVISIBLE( true );
	//mCY𐰂炷
	K7SCR_NOISE_RELEASE();
#endif
}

