////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage517M00
//
// K7Stage517M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE517M00_H__
#define	__K7STAGE517M00_H__

#include ".\K7StageHotelElev.h"

class K7Stage517M00 : public K7StageHotelElev{
	friend class WK7Stage;
protected:
	WK7RenderObjEffect	*mpPetalEffect;
	
	bool ReleasePetal(void);
	bool CreatePetal(void);
	
	K7Stage517M00();
	K7Stage517M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage517M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
//	virtual bool BpArriveCallBack  (WK7BpInfo        &){ return true; }		// _
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &){ return true; }		// qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj
//	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);

};

#ifdef __K7STAGE517M00_CPP__

enum K7STAGE517M00_ONESHOTCAM{
	ELEVCAM,
	ELEVPLAYER,
	FLOWER,
	BLOW_FLOWER,
};

K7StageEventOneShotCamera K7Stage517M00_Camera[] = {
	{{-185.472f, 12.539f, -274.599f},{-207.774f, 11.206f, -277.424f}},
	{{-143.179f, 0.0f, -276.492f},{-192.803f, 0.0f, -275.263f}},
	{{-36.552f, -7.155f, -258.946f},{-84.940f, 19.309f, -252.875f}},
	{{-81.139f, 3.573f, -252.920f},{-130.955f, 18.155f, -272.529f}},
};

enum{
	K7STAGE517M00_MES_BLOW_FLOWER = 0,		// Ԃт炪
	K7STAGE517M00_MES_USE_WIND_RING,		// ̎wւK
};

#endif

#endif	//__K7STAGE517M00_H__

