////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage520M00
//
// K7Stage520M00.cpp		Ln ^C}[X}C
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE520M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage520M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7CharaPresent.h"
#include "..\..\..\Wat\K7GlobalFlag.h"
#include "..\..\..\Yam\YK7EffectVapor.h"

K7Stage520M00::K7Stage520M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelBase(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage520M00_Camera);
	pNpcTim = NULL;
	GameInfo.SetMenuMapEnable(false);
}

K7Stage520M00::~K7Stage520M00()
{
	GameInfo.SetMenuMapEnable(true);
	GameInfo.SetBossFlag(false);
	WK7PLAYERCONTROL->BattlePadRegulationClear();
}

bool K7Stage520M00::CondChangeCallBack(void)
{
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(051706),WK7Npc::GetEnemyDieTest(K7STAGE520M00_KIHAN_HS)==true);
	return true;
}


bool K7Stage520M00::InitializeCallBack(void)
{
	if( WK7Npc::GetEnemyDieTest(K7STAGE520M00_KIHAN_HS)==false ){
		// LnX}C͐Ă	}jAu`ݒ
		SetManualBranch( true );
	}
	return true;
}

bool K7Stage520M00::CreateCallBack(void)
{
	// ̃Xe[W͎蓮œǂݍ܂
	return false;
}

bool K7Stage520M00::SetCurrentCallBack(void)
{
	int exit = 1;
	
	if( WK7Npc::GetEnemyDieTest(K7STAGE520M00_KIHAN_HS)==true ){
		// ^C}[X}C͎ł
		//ȍĐ
		gpSound->mPlayStreamNo( HPS_SPEED_HS );
		return true;
	}else{
		/// LA
		WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_BOSSBATTLE);
	}
	
	GameInfo.SetBossFlag(true);
	
	WK7Stage::SetCurrentPath(	WK7Stage::GetPathNurbsAll("curve1"),
								0.8f,
								1,									// Forward
//								WK7PATHINFO_INITDIR_TGTDIR			// 
								WK7PATHINFO_INITDIR_TGTDIR_REV		// wォ
	);
	
	// {X ǂݍ
	while( (pNpcTim = (K7EnmTIM *)WK7Npc::Create(K7STAGE520M00_KIHAN_HS))==NULL ){
		K7SCR_RETSYS();
	}
	while( pNpcTim->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	
	K7SCR_EXIT_DEMOPAUSE();
	while( pNpcTim->GetNpcState() == NPC_STATE_INIT ){
		K7SCR_RETSYS();
	}
	K7SCR_ENTER_DEMOPAUSE();
	
	// _[IDU
	pNpcTim->HitObjMake(WK7Stage::GetCurrentStage());
	
	//ȍĐ
	gpSound->mPlayStreamNo( HPS_SPEED_HS );
	
	//PCJ҂
	while( WK7Stage::IsChanging() != false ){
		K7SCR_RETSYS();
	}
	
	WK7StagePlaceInfo		*pPlaceInfo = GetPlaceInfo("branchH");
	SetCameraStartPosition(pPlaceInfo);
	SetManualBranch(false);
	
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_KIHAN) == false ){
		K7SCR_SET_SCENARIO_FLAG(K7SCN05_KIHAN);
		
		// Ln叉߂
		
		KihanDemoFirst(pNpcTim, CAM520M00HSINIT,CAM520M00HSTERM, 0,  215,  274, -40, 144, 765, 119,
		1	);
		
	}else{
		
		// LnQڈȍ~
		
		KihanDemo(K7STAGE520M00_KIHAN_HS,CAM520M00HSRETURN);
		
	}
	
	// {XsJn
	while( pNpcTim->KihanBoss_AiRun() == false ){
		K7SCR_RETSYS();
	}
	
	K7SCR_PC_SETVISIBLE(true);
	SetCameraStartPosition(WK7Stage::GetCurrentStageBpName());
	//JPCtH[ɖ߂
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	
	K7SCR_RETSYS();
	K7SCR_CHARAPRESENT_DEBUGEND();
	K7SCR_TIMEWAIT(K7SCR_CP_RELEASETIME);
	
	//inGameĊJ
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	// }jAu`NA
	SetManualBranch( false );
	
	return false;
}


/*
	
	
	{X퐧pɎgp
	
	
*/
bool K7Stage520M00::HitObjCallBack(WK7HitObjInfo &info)
{
//	K7SCR_HITOBJ_SETENABLE(&info,true);
	if( pNpcTim != NULL ){
		if( (info.mEventNo >= 0) && (info.mEventNo < 9) ){
			if ( false == pNpcTim->TimVLoss((int )info.mEventNo, info.mTypeID, info.mHitPos) ){
				// qbgIuWF𕜊
//				info.mpHitObj->SetEnable(true);
				info.SetHitObjEnable(true);
			}
			return false;
		}
	}
	return true;
}


bool K7Stage520M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
	if( info.mpNpc==NULL ){
		return true;
	}
	switch( info.mpNpc->GetEneNo() ){
	case	K7STAGE520M00_KIHAN_HS:
		//ȍĐ
		if ( info.mpNpc->GetDieMode() != NPC_DIE_JIBAKU ){
			//gpSound->mPlayStreamNo( HPS_SCHOOL_E );
		}
		GameInfo.SetBossFlag(false);
//		K7SCR_SET_SCENARIO_FLAG(K7SCN05_KIHAN);
		K7SCR_EVCONDCHANGE();
//		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(051706),true);
		return false;
	default:
		break;
	}
	return true;
}

