////////////////////////////////////////////////////////////////////////////////
//
// Killer7 StageHotelElev
//
// StageHotelElev.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/22/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGEHOTELELEV_H__
#define	__K7STAGEHOTELELEV_H__

#include ".\K7StageHotelBase.h"

#define	K7STAGEHOTELELEV_MOTION_DOOROPEN		K7MOTID(511,   0)
#define	K7STAGEHOTELELEV_MOTION_DOORCLOSE		K7MOTID(511,   1)

class K7StageHotelElev : public K7StageHotelBase{
	friend class WK7Stage;
protected:
	u32					mElevDoorEventNo;
	u32					mElevCamID;
	u32					mElevPlayerPosID;
	bool				mStageInit;
	
	K7StageHotelElev();
	K7StageHotelElev(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	bool CreateMotion(void);
	bool OpenElevDoor(bool im=false);
	bool CloseElevDoor(bool im=false);
	int ElevEvent(WK7DoorEventInfo &info,int floor);
	bool InitElevEvent(void);
	bool StartElevEvent(void);
public:
	virtual ~K7StageHotelElev();
	
};

#endif	//__K7STAGEHOTELELEV_H__

