////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage551M01 ywZz1FLÊQ
//
// K7Stage551M01.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/17/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE551M01_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage551M01.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7BattleCtrl.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Yam\YK7EffectBillboard.h"

//bZ[W
#define	MES551M01_CLOSE_2F_DOOR	(0)		//2Fւ̔JȂ
#define	MES551M01_GET_BULLET	(1)		//e肵
#define	MES551M01_MASK_GET		(2)		//Sʃ}XN肵
#define	MES551M01_MASK_EQUIP	(3)		//Sʃ}XN𑕔
#define	MES551M01_MASK_FIND		(4)		//Sʃ}XN𔭌
#define	MES551M01_OPEN_2F_DOOR	(5)		//2Fւ̔J
#define	MES551M01_FIND_MEMO_1	(6)		//1
#define	MES551M01_FIND_MEMO_2	(7)		//2
#define	MES551M01_NUMBER		(8)		//ɏĂԍ
#define	MES551M01_GET_TAPE		(9)		//e[v肵
//[V
#define	MOT551M01_LOCKER_OP_GUN	(0)		//bJ[eŊJ
#define	MOT551M01_LOCKER_CL_GUN	(1)		//bJ[eŕ
#define	MOT551M01_LOCKER_OP		(2)		//bJ[J
#define	MOT551M01_LOCKER_CL		(3)		//bJ[
#define	MOT551M01_DOOR_OPEN		(4)		//2Fւ̔J
//[Ṽf
#define	MOT551M01_LOCKER_NAME	"Locker"
//f
#define	MDL551M01_DOOR			"Door_A"		//2Fւ̔
#define	MDL551M01_BULLET		"tama_055111"	//e
#define	MDL551M01_MASK			"item_400"		//}XN
#define	MDL551M01_LOCKER01		"Locker01"
#define	MDL551M01_LOCKER02		"Locker02"
#define	MDL551M01_LOCKER03		"Locker03"
#define	MDL551M01_LOCKER04		"Locker04"
#define	MDL551M01_LOCKER05		"Locker05"
#define	MDL551M01_LOCKER06		"Locker06"
#define	MDL551M01_LOCKER07		"Locker07"
#define	MDL551M01_LOCKER08		"Locker08"
#define	MDL551M01_LOCKER09		"Locker09"
#define	MDL551M01_LOCKER10		"Locker10"
#define	MDL551M01_LOCKER11		"Locker11"
#define	MDL551M01_LOCKER12		"Locker12"
#define	MDL551M01_TAPE			"Tape"
#define	MDL551M01_LOCKER656		"Locker656"

//define
#define	LOCKER_SHOT_NUM			(11)					//Ă郍bJ[̐
#define	LOCKER_INI_NAME			"ini"
#define	LOCKER_SHOT_1ST			MDL551M01_LOCKER01		//ŏɌbJ[
#define	LOCKER_SHOT_MASK		MDL551M01_LOCKER02		//Sʃ}XN郍bJ[
#define	LOCKER_SHOT_TRUE		MDL551M01_LOCKER03		//2Fւ̔JbJ[

//bJ[̊J菇̋Lqe[u
char gLockerTbl[LOCKER_SHOT_NUM][LOCKER_OPEN_MAX+1][LOCKER_NAME_LENGTH] =
{
	  //JbJ[P    JbJ[Q      郍bJ[
	{ MDL551M01_LOCKER04, MDL551M01_LOCKER07, MDL551M01_LOCKER01 },
	{ MDL551M01_LOCKER06, LOCKER_INI_NAME,    MDL551M01_LOCKER02 },
	{ LOCKER_INI_NAME,    LOCKER_INI_NAME,    MDL551M01_LOCKER03 },
	{ MDL551M01_LOCKER05, MDL551M01_LOCKER08, MDL551M01_LOCKER04 },
	{ MDL551M01_LOCKER06, MDL551M01_LOCKER11, MDL551M01_LOCKER05 },
	{ MDL551M01_LOCKER03, LOCKER_INI_NAME,    MDL551M01_LOCKER06 },
	{ MDL551M01_LOCKER08, MDL551M01_LOCKER10, MDL551M01_LOCKER07 },
	{ MDL551M01_LOCKER09, LOCKER_INI_NAME,    MDL551M01_LOCKER08 },
	{ MDL551M01_LOCKER02, MDL551M01_LOCKER03, MDL551M01_LOCKER09 },
	{ MDL551M01_LOCKER08, MDL551M01_LOCKER09, MDL551M01_LOCKER10 },
	{ MDL551M01_LOCKER02, MDL551M01_LOCKER09, MDL551M01_LOCKER11 },
};




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage551M01::K7Stage551M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	int	i;
	
	SetOneShotCamLocTbl( K7Stage551M01_Camera );
	
	//bJ[֌W
	for( i = 0; i < LOCKER_OPEN_MAX; i++ )
	{
		strcpy( mOpenLocker[i], LOCKER_INI_NAME );
		mpSpark[i] = NULL;
	}
	//}XNbJ[͕Ԃɂ
	K7SCR_RESET_SCENARIO_FLAG( EV055122MASK );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage551M01::~K7Stage551M01()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage551M01::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT551M01_LOCKER_OP );
	CreateOwnStageMotion( MOT551M01_LOCKER_CL );
	CreateOwnStageMotion( MOT551M01_LOCKER_OP_GUN );
	CreateOwnStageMotion( MOT551M01_LOCKER_CL_GUN );
	CreateOwnStageMotion( MOT551M01_DOOR_OPEN );
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage551M01::TerminateCallBack( void )
{
	int	i;
	
	//LLGtFNg
	for( i = 0; i < LOCKER_OPEN_MAX; i++ )
	{
		if( mpSpark[i] != NULL )
		{
			DeleteEffect( mpSpark[i] );
			mpSpark[i] = NULL;
		}
	}
	
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage551M01::CondChangeCallBack( void )
{
	//---- e ----
	if( K7SCR_EVHASITEM(K7EVITEM_TAMA(055100)) == false )
	{
		SimpleModelDisp( MDL551M01_BULLET );
	}else
	{
		SimpleModelHide( MDL551M01_BULLET );
	}
	RenewTamaEffect(K7EVENTTAMA(055100));
	
	//---- }XN ----
	if( K7SCR_GET_SCENARIO_FLAG(EV055100MASK) == false )
	{
		SimpleModelDisp( MDL551M01_MASK );
	}else
	{
		SimpleModelHide( MDL551M01_MASK );
	}
	
	//---- 2Fւ̔ ----
	if( K7SCR_GET_SCENARIO_FLAG(EV055100) == false )
	{
		SimpleSetStartMotion( MDL551M01_DOOR, MOT551M01_DOOR_OPEN );
	}else
	{
		SimpleSetLastMotion( MDL551M01_DOOR, MOT551M01_DOOR_OPEN );
	}
	
	//bJ[̒̃}XN
	if( K7SCR_GET_SCENARIO_FLAG(EV055122MASK) == false )
	{	//}XNbJ[Ă
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055122), false );
	}else
	{	//}XNbJ[JĂ
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055122), true );
	}
	//}XN肵ĂWNV͏
	if( K7SCR_GET_SCENARIO_FLAG(EV055100MASK) == true )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(055122), false );
	}
	
	//e[v
	if( K7SCR_GET_SCENARIO_FLAG(VRTAPE08) == false )
	{
		SimpleModelDisp( MDL551M01_TAPE );
	}else
	{
		SimpleModelHide( MDL551M01_TAPE );
	}
	
	//gBXEbJ[
	if( K7SCR_GET_SCENARIO_FLAG(EV55101_LOCKER_TRAVIS) == false )
	{
		SetZanEnable( K7EVENTZAN(055504), false );
		K7SCR_EVNO_SETENABLE( K7EVENTZAN(055504), false );
		SimpleSetStartMotion( MDL551M01_LOCKER656, MOT551M01_LOCKER_OP_GUN, MOT551M01_LOCKER_NAME );
	}else
	{
		SetZanEnable( K7EVENTZAN(055504), true );
		K7SCR_EVNO_SETENABLE( K7EVENTZAN(055504), true );
		SimpleSetStartMotion( MDL551M01_LOCKER656, MOT551M01_LOCKER_CL_GUN, MOT551M01_LOCKER_NAME );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage551M01::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//bJ[̒̃}XN
		case	K7EVENTNO( 055122 ):
			//L|[Y
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			FixCam( CAM551M01_LOCKER_MASK );
			//}XNłȂ΃bZ[Ŵ
			if( WK7PLAYERCONTROL->GetMainID() != K7MSK )
			{
				K7SCR_STGC_MESSAGE_B( MES551M01_MASK_FIND );
			}else
			{
				//EGCg
				K7SCR_TIMEWAIT( 4800 );
				//bZ[W\
				K7SCR_STG_ITEMGET( MES551M01_MASK_GET );
				K7SCR_STG_ITEMGET_NOTDISPLAYED_B( MES551M01_MASK_GET );
				SimpleModelHide( MDL551M01_MASK );
				K7SCR_PC_SETVISIBLE( true );
				SetCurrentPath(	GetPathNurbsAll("curve30"),
								0.000f,
								0,									// 0:forward 1:back
								WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
				FixCam( CAM551M01_MSK_CHANGE );
				K7SCR_RETSYS();
				//bZ[W\EGCg
				K7SCR_STG_ITEMGET_VALID_B( MES551M01_MASK_GET );
				//}XNϐg
				BattleCtrl.MskPowerUp( KK7BATTLECTRL_MSKLV_TEKKAMEN );
				GameInfo.BloodCharaChange( K7CHRID(K7MSK,6), 1, SFX_SCE5_SCL_MSK_LVUPVOICE_IRON );
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_TIMEWAIT( 4800 );
				FixCam( CAM551M01_MSK_CHANGE_AFTER );
				gpSound->mPlaySE( SFX_SCE5_SCL_MSK_LVUP );
				K7SCR_TIMEWAIT( 4800*5 );
				//}XN擾tOON
				K7SCR_SET_SCENARIO_FLAG( EV055100MASK );
				K7SCR_EVCONDCHANGE();
#if	0
				K7SCR_TIMEWAIT( 4800 );
				SimpleItemGetMes( MES551M01_MASK_GET, MDL551M01_MASK, true );
				//L\
				K7SCR_PC_SETVISIBLE( true );
				//}XNϐg
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				K7SCR_RETSYS();
				BattleCtrl.MskPowerUp( KK7BATTLECTRL_MSKLV_TEKKAMEN );
				GameInfo.BloodCharaChange( K7CHRID(K7MSK,6), 1, SFX_SCE5_SCL_MSK_LVUPVOICE_IRON );
				gpSound->mPlaySE( SFX_SCE5_SCL_MSK_LVUP );
				K7SCR_TIMEWAIT( 1200 );
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				K7SCR_TIMEWAIT( 3600 );
				//K7SCR_STGC_MESSAGE_B( MES551M01_MASK_EQUIP );
				//}XN擾tOON
				K7SCR_SET_SCENARIO_FLAG( EV055100MASK );
				K7SCR_EVCONDCHANGE();
#endif
			}
			//L|[Y
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage551M01::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//2Fւ̕܂Ă
		case	K7EVENTDOOR( 055101 ):
			if( K7SCR_GET_SCENARIO_FLAG(EV055100) == false )
			{
				FixCamMes( CAM551M01_TO2F, MES551M01_CLOSE_2F_DOOR );
				return( false );
			}
	    	break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//qbgIuWF
//------------------------------------------------------------------------------
bool
K7Stage551M01::HitObjCallBack( WK7HitObjInfo &info )
{
	WK7JObj*	pJObj = NULL;
	char*		pLockerName;
	int			i, j;
	Vec			locPos, locOffset = { 3.679f, 16.4f, 7.375f };
	
	switch( info.mEventNo )
	{
		//gBXbJ[
		case	K7EVENTNO( 055103 ):
			gpSound->mPlaySE( SFX_SCE5_SCL_LOCKER_BULLET_HIT );
			if( K7SCR_GET_SCENARIO_FLAG(EV55101_LOCKER_TRAVIS) == false )
			{
				//Ă̂ŊJ
				K7SCR_SET_SCENARIO_FLAG( EV55101_LOCKER_TRAVIS );
				gpSound->mPlaySE( SFX_SCE5_SCL_LOCKER_BULLET_OPEN );
				SimplePlayMotion( MDL551M01_LOCKER656, MOT551M01_LOCKER_OP_GUN, MOT551M01_LOCKER_NAME );
			}else
			{
				//JĂ̂ŕ
				K7SCR_RESET_SCENARIO_FLAG( EV55101_LOCKER_TRAVIS );
				gpSound->mPlaySE( SFX_SCE5_SCL_LOCKER_BULLET_CLOSE );
				SimplePlayMotion( MDL551M01_LOCKER656, MOT551M01_LOCKER_CL_GUN, MOT551M01_LOCKER_NAME );
			}
//			info.mpHitObj->SetEnable( true );
			info.SetHitObjEnable(true);
			K7SCR_EVCONDCHANGE();
			break;
		
		//AbJ[
		case	K7EVENTNO( 055101 ):
		case	K7EVENTNO( 055102 ):
			gpSound->mPlaySE( SFX_SCE5_SCL_LOCKER_BULLET_HIT );
			//ꂽbJ[擾
			pLockerName = GetHitLockerName( info );
			//ɃbJ[͌H
			if( strcmp(mOpenLocker[0],LOCKER_INI_NAME) == 0 )
			{
				//ꂽbJ[͍ŏɌׂbJ[H
				if( strcmp(pLockerName,LOCKER_SHOT_1ST) == 0 )
				{
					//JbJ[ۑ
					for( i = 0; i < LOCKER_OPEN_MAX; i++ )
					{
						strcpy( mOpenLocker[i], pLockerName );
					}
					//eĂH
					if( K7SCR_EVHASITEM(K7EVITEM_TAMA(055100)) == false )
					{
						//ogIB
						KK7BattleMainTask::BattleMainTaskExit( 2 );
						//L|[Y
						K7SCR_ENTER_PLAYMODE_B();
						K7SCR_ENTER_DEMOPAUSE();
						K7SCR_PC_SETVISIBLE( false );
						FixCam( CAM551M01_LOCKER_BULLET );
						//bJ[J
						gpSound->mPlaySE( SFX_SYS_TRUE );
						gpSound->mPlaySE( SFX_SCE5_SCL_LOCKER_BULLET_OPEN );
						SimplePlayMotionB( pLockerName, MOT551M01_LOCKER_OP_GUN, MOT551M01_LOCKER_NAME );
						gpSound->mPlaySE( SFX_SYS_CAMERA_ZOOM );
						K7SCR_TIMEWAIT( 4800 );
						//e
						SimpleItemGetMes( MES551M01_GET_BULLET, MDL551M01_BULLET );
						//etOON
						K7SCR_EVSETITEM( K7EVITEM_TAMA(055100), true );
						//qgbZ[W\
						if( K7SCR_GET_SCENARIO_FLAG(VRTAPE08) == false )
						{
						//	K7SCR_STGC_MESSAGE_B( MES551M01_FIND_MEMO_1 );
						//	K7SCR_STGC_MESSAGE_B( MES551M01_FIND_MEMO_2 );
						//	K7SCR_STGC_MESSAGE_B( MES551M01_NUMBER );
							SimpleItemGetMes( MES551M01_GET_TAPE, MDL551M01_TAPE, true );
							K7SCR_SET_SCENARIO_FLAG( VRTAPE08 );
						}
						K7SCR_EVCONDCHANGE();
						//L|[Y
						K7SCR_EXIT_PLAYMODE();
						K7SCR_EXIT_DEMOPAUSE();
						K7SCR_PC_SETVISIBLE( true );
					}else
					{
						gpSound->mPlaySE( SFX_SCE5_SCL_LOCKER_BULLET_OPEN );
						SimplePlayMotion( pLockerName, MOT551M01_LOCKER_OP_GUN, MOT551M01_LOCKER_NAME );
#if	0
						//ogIB
						KK7BattleMainTask::BattleMainTaskExit( 2 );
						//L|[Y
						K7SCR_ENTER_PLAYMODE_B();
						K7SCR_ENTER_DEMOPAUSE();
						K7SCR_PC_SETVISIBLE( false );
						FixCam( CAM551M01_LOCKER_BULLET );
						//bJ[J
						gpSound->mPlaySE( SFX_SCE5_SCL_LOCKER_BULLET_OPEN );
						SimplePlayMotionB( pLockerName, MOT551M01_LOCKER_OP_GUN, MOT551M01_LOCKER_NAME );
						K7SCR_TIMEWAIT( 4800 );
						//qgbZ[W\
						K7SCR_STGC_MESSAGE_B( MES551M01_FIND_MEMO_2 );
						K7SCR_STGC_MESSAGE_B( MES551M01_NUMBER );
						//L|[Y
						K7SCR_EXIT_PLAYMODE();
						K7SCR_EXIT_DEMOPAUSE();
						K7SCR_PC_SETVISIBLE( true );
#endif
					}
				}
			}else
			{
				//ꂽbJ[JĂ郍bJ[ׂ
				for( i = 0; i < LOCKER_OPEN_MAX; i++ )
				{
					if( strcmp(mOpenLocker[i],pLockerName) == 0 )
					{
						//ꂽbJ[
						gpSound->mPlaySE( SFX_SCE5_SCL_LOCKER_BULLET_CLOSE );
						SimplePlayMotion( pLockerName, MOT551M01_LOCKER_CL_GUN, MOT551M01_LOCKER_NAME );
						//JĂ郍bJ[
						for( j = 0; j < LOCKER_OPEN_MAX; j++ )
						{
							if( strcmp(mOpenLocker[j],pLockerName) != 0 )
							{
								gpSound->mPlaySE( SFX_SCE5_SCL_LOCKER_CLOSE );
								SimplePlayMotion( mOpenLocker[j], MOT551M01_LOCKER_CL, MOT551M01_LOCKER_NAME );
							}
						}
						//2Fւ̔JbJ[H
						if( (strcmp(mOpenLocker[i],LOCKER_SHOT_TRUE) == 0)
						 && (K7SCR_GET_SCENARIO_FLAG(EV055100) == false) )
						{
							//ogIB
							KK7BattleMainTask::BattleMainTaskExit( 2 );
							//L|[Y
							K7SCR_ENTER_PLAYMODE_B();
							K7SCR_ENTER_DEMOPAUSE();
							K7SCR_PC_SETVISIBLE( false );
							FixCam( CAM551M01_TO2F );
							//2Fւ̔J
							gpSound->mPlaySE( SFX_SYS_TRUE );
							gpSound->mPlaySE( SFX_SCE5_SCL_TO2NDFLOOR_OPEN );
							SimplePlayMotionB( MDL551M01_DOOR, MOT551M01_DOOR_OPEN );
							//K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
							//K7SCR_TIMEWAIT( 4800 );
							//bZ[W\
							K7SCR_STGC_MESSAGE_B( MES551M01_OPEN_2F_DOOR );
							//bJ[NAtOON
							K7SCR_SET_SCENARIO_FLAG( EV055100 );
							//bJ[
							for( j = 0; j < LOCKER_OPEN_MAX; j++ )
							{
								strcpy( mOpenLocker[j], LOCKER_INI_NAME );
							}
							//}XNbJ[Ăŏ
							K7SCR_RESET_SCENARIO_FLAG( EV055122MASK );
							K7SCR_EVCONDCHANGE();
							//L|[Y
							K7SCR_EXIT_PLAYMODE();
							K7SCR_EXIT_DEMOPAUSE();
							K7SCR_PC_SETVISIBLE( true );
						}else
						{
							//}XNbJ[Ăŏ
							K7SCR_RESET_SCENARIO_FLAG( EV055122MASK );
							K7SCR_EVCONDCHANGE();
							//Ȃ郍bJ[J
							for( j = 0; j < LOCKER_OPEN_MAX; j++ )
							{
								//JׂbJ[擾
								strcpy( mOpenLocker[j], GetOpenLockerName(pLockerName,j) );
								//JׂbJ[擾łJ
								if( strcmp(mOpenLocker[j],LOCKER_INI_NAME) != 0 )
								{
									gpSound->mPlaySE( SFX_SCE5_SCL_LOCKER_OPEN );
									SimplePlayMotion( mOpenLocker[j], MOT551M01_LOCKER_OP, MOT551M01_LOCKER_NAME );
								}
								//Sʃ}XN郍bJ[
								if( (strcmp(mOpenLocker[j],LOCKER_SHOT_MASK) == 0)
								 && (K7SCR_GET_SCENARIO_FLAG(EV055100MASK) == false) )
								{
									//ogIB
									KK7BattleMainTask::BattleMainTaskExit( 2 );
									//L|[Y
									K7SCR_ENTER_PLAYMODE_B();
									K7SCR_ENTER_DEMOPAUSE();
									K7SCR_PC_SETVISIBLE( false );
									FixCam( CAM551M01_LOCKER_MASK );
									K7SCR_STGC_MESSAGE_B( MES551M01_MASK_FIND );
									//}XNbJ[JĂ
									K7SCR_SET_SCENARIO_FLAG( EV055122MASK );
									K7SCR_EVCONDCHANGE();
									//L|[Y
									K7SCR_EXIT_PLAYMODE();
									K7SCR_EXIT_DEMOPAUSE();
									K7SCR_PC_SETVISIBLE( true );
								}
							}
							
						}
						break;
					}
				}
				#if	0	//JĂ郍bJ[ȊO͔Ȃ
				//ꂽbJ[͕Ă郍bJ[
				if( i == LOCKER_OPEN_MAX )
				{
					//SĂ̊JĂ郍bJ[
					for( i = 0; i < LOCKER_OPEN_MAX; i++ )
					{
						gpSound->mPlaySE( SFX_SYS_FREE_KIHANMON );
						SimplePlayMotion( mOpenLocker[i], MOT551M01_LOCKER_CL, MOT551M01_LOCKER_NAME );
						strcpy( mOpenLocker[i], LOCKER_INI_NAME );
					}
				}
				#endif
			}
//			info.mpHitObj->SetEnable( true );
			info.SetHitObjEnable(true);
			//JbJ[ɌIuWFNgt
			for( i = 0; i < LOCKER_OPEN_MAX; i++ )
			{
				//bJ[JĂ邩`FbN
				if( strcmp(mOpenLocker[i],LOCKER_INI_NAME) != 0 )
				{
					if( (pJObj=GetJObj(mOpenLocker[i])) != NULL )
					{
						pJObj->GetWorldPosition( &locPos );
						locPos.x += locOffset.x;
						locPos.y += locOffset.y;
						locPos.z += locOffset.z;
					}
					//GtFNgĂȂΐVɐ
					if( mpSpark[i] == NULL )
					{
						mpSpark[i] = CreateEasyAnimEffect2( ANIMID_SMALLLIGHT,
															locPos,
															(Vec){ 2.0f, 2.0f, 2.0f },
															true, -1 );
					}else
					//GtFNgĂ̂ňx폜Ă琶
					{
						DeleteEffect( mpSpark[i] );
						mpSpark[i] = NULL;
						mpSpark[i] = CreateEasyAnimEffect2( ANIMID_SMALLLIGHT,
															locPos,
															(Vec){ 2.0f, 2.0f, 2.0f },
															true, -1 );
					}
				}else
				//bJ[͊JĂȂ̂ō폜
				{
					if( mpSpark[i] != NULL )
					{
						DeleteEffect( mpSpark[i] );
						mpSpark[i] = NULL;
					}
//					CheckEffectValidState(  pSpark ,GetEffectID(pSpark) );
				}
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//J炭ׂbJ[擾
//------------------------------------------------------------------------------
char*
K7Stage551M01::GetOpenLockerName( char* inLockerName, int inNum )
{
	int	i;
	
	//JׂbJ[
	for( i = 0; i < LOCKER_SHOT_NUM; i++ )
	{
		if( strcmp(inLockerName,gLockerTbl[i][LOCKER_OPEN_MAX]) == 0 )
		{
			return( gLockerTbl[i][inNum] );
		}
	}
	
	//zg͂ɗ_
	return( MDL551M01_LOCKER01 );
}

//------------------------------------------------------------------------------
//bJ[̖O擾
// in --> WK7HitObjInfo &info  qbgIuWF
// out -> char*  bJ[̖O
//------------------------------------------------------------------------------
char*
K7Stage551M01::GetHitLockerName( WK7HitObjInfo &info )
{
	switch( info.mEventNo )
	{
		//bJ[
		case	K7EVENTNO( 055101 ):
		case	K7EVENTNO( 055102 ):
			{
				f32 MinLen, Len ;
				WK7JObj *MinJObj ;
				s32 i ;
				WK7JObj *JObj ;
				Vec Pos ;

				MinLen = 0.0F ;
				MinJObj = NULL ;
				JObj = info.mpJObj->GetChild() ;

				// 		
				for( i = 0 ; JObj != NULL ; i ++, JObj = JObj->GetNext() )
				{
/*
					HSD_JObjSetupMatrix( JObj->GetChild()->GetJObj() ) ;
					
					Pos.x = JObj->GetChild()->GetJObj()->mtx[0][3] ;
					Pos.y = JObj->GetChild()->GetJObj()->mtx[1][3] ;
					Pos.z = JObj->GetChild()->GetJObj()->mtx[2][3] ;
*/
					JObj->GetChild()->GetWorldPosition( &Pos ) ;
					Len = VECDistance( &Pos, &info.mHitPos ) ;
					if( MinLen > Len || MinJObj == NULL ){ MinJObj = JObj ; MinLen = Len ; }
				}
				
				return (char *)MinJObj->GetName() ;
			}
			break ;
		
		default:
			break;
	}
	
	return( MDL551M01_LOCKER01 );
}

