////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage551M02 ywZz1FLÊQ
//
// K7Stage551M01.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/17/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE551M01_H__
#define	__K7STAGE551M01_H__

#include "..\K7Stage.h"

#define	LOCKER_OPEN_MAX		(2)		//JbJ[̍ő吔
#define	LOCKER_NAME_LENGTH	(16)	//bJ[̒

class K7Stage551M01 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage551M01();
	K7Stage551M01(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	EFFECT*	mpSpark[LOCKER_OPEN_MAX];
	Vec		mHitPos;
	char	mOpenLocker[LOCKER_OPEN_MAX][LOCKER_NAME_LENGTH];	//JĂ郍bJ[ԍ
	
	char*	GetOpenLockerName( char* inLockerName, int inNum );	//J炭ׂbJ[擾
	char*	GetHitLockerName( WK7HitObjInfo &info );			//bJ[擾
	
public:
	virtual ~K7Stage551M01();
	
	virtual bool CreateCallBack    (void);					// iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//	virtual bool InitializeCallBack(void);					// iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
	virtual bool CondChangeCallBack(void);					// ԕύXitOɂԕύX邽߂ɗpj
	virtual bool TerminateCallBack (void);					// Iȉj
//	virtual bool SetCurrentCallBack(void);					// JgXe[Wɐݒ莞
	virtual bool EventCallBack     (WK7EventInfo     &);	// Cxg
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);	// hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &);	// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &);	// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &);	// Cxg
//	virtual bool BpLeaveCallBack   (WK7BpInfo        &);	// _o
//	virtual bool BpArriveCallBack  (WK7BpInfo        &);	// _
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);	// mobS
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);	// qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &);	// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &);	// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &);	// erCxgiZ[u|Cgj
//	virtual bool AttackCallBack    (WK7AttackInfo    &);	// v[[̍U
};

#ifdef __K7STAGE551M01_CPP__


enum K7STAGE551M01_ONESHOTCAM{
	CAM551M01_TO2F,				//2Fւ̔
	CAM551M01_LOCKER_BULLET,	//ẽbJ[
	CAM551M01_LOCKER_MASK,		//}XÑbJ[
	CAM551M01_MSK_CHANGE,		//}XNϐg
	CAM551M01_MSK_CHANGE_AFTER,	//}XNϐg
};

K7StageEventOneShotCamera K7Stage551M01_Camera[] = {
	{{166.649f, 10.094f, 84.263f},{155.308f, 8.857f, 100.656f}},	//2Fւ̔
	{{308.001f, 8.995f, 72.103f},{301.855f, 18.319f, 89.075f}},		//ẽbJ[
	{{392.865f, 0.291f, 70.122f},{379.138f, 5.913f, 87.845f}},		//}XÑbJ[
	{{387.117f, 9.496f, 95.021f},{367.648f, 2.566f, 106.819f}},		//}XNϐg
	{{395.394f, 14.864f, 96.276f},{372.023f, 10.405f, 95.880f}},	//}XNϐg
};

#endif

#endif	//__K7STAGE551M01_H__

