////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage551M02 ywZz2FL
//
// K7Stage551M02.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/17/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE551M02_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage551M02.h"

//pX
#define	PAT551M02_FROMLIBRARY	"BKR01"			//}ʘH
#define	PAT551M02_SHORTCUT		"BRpass"		//LnNAɒʉ߉\




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage551M02::K7Stage551M02(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage551M02_Camera );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage551M02::~K7Stage551M02()
{
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage551M02::CondChangeCallBack( void )
{
	//LnHS|
	if( K7SCR_GET_SCENARIO_FLAG(EV055710) == false )
	{	//ʉ߂ĂȂ
		K7SCR_STG_SET_PATHENABLE( PAT551M02_FROMLIBRARY, false );	//pX
		K7SCR_STG_SET_PATHENABLE( PAT551M02_SHORTCUT,    false );	//pX
	}else
	{	//ʉ߂
		K7SCR_STG_SET_PATHENABLE( PAT551M02_FROMLIBRARY, true );	//pX
		K7SCR_STG_SET_PATHENABLE( PAT551M02_SHORTCUT,    true );	//pX
	}
	
	return( true );
}




//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage551M02::DoorEventCallBack( WK7DoorEventInfo &info )
{
	u32			playno;
	
	switch( info.mEventNo )
	{
		//Zւ̔
		case	K7EVENTDOOR( 055102 ):
			playno = K7EVENTPLAY(05080102);
			if( WK7Play::HasPlayed(playno) == false )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				//KVA_ɑĂȂΕς
				if( WK7PLAYERCONTROL->GetMainID() != K7GAL )
				{
					//vC[ړ
					SetCurrentPath(	GetPathNurbsAll("curve53"),
									2.000f,
									0,									// 0:forward 1:back
									WK7PATHINFO_INITDIR_TGTDIR );		// :WK7PATHINFO_INITDIR_TGTDIR wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
					//ĎJŃL
					FixCam( CAM551M02_WATCHCAMERA );
					K7SCR_TIMEWAIT( 9600 );
					WatchCameraB( K7Stage551M02_Camera[CAM551M02_PLAYER].tgt,
								  K7Stage551M02_Camera[CAM551M02_PLAYER].pos,
								  K7CHRID(K7GAL,0), 1 );
				}
				//L|[Y
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
#if	0
					//L|[Y
					K7SCR_ENTER_PLAYMODE_B();
					K7SCR_ENTER_DEMOPAUSE();
				}
				//mCY
				K7SCR_NOISE_REQUEST();
				//Xe[WFL傫
				K7SCR_STAGE_RELEASE();
				//풓FL傫
				WK7EVENTCONTROLLER->ReleaseTempData2();
				while( WK7EVENTCONTROLLER->IsReleasedTempData2()==false ){
					K7SCR_RETSYS();
				}
				//L
				K7SCR_CHARAGEKI_PREPARE( playno );
				//mCY
				K7SCR_NOISE_RELEASE();
				//LI҂
				K7SCR_CHARAGEKI_END_WAIT( playno );
				//mCY
				K7SCR_NOISE_REQUEST();
				//LI
				K7SCR_CHARAGEKI_TERM( playno );
				//풓A
				while( WK7EVENTCONTROLLER->LoadData()==false ){
					K7SCR_RETSYS();
				}
				while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
					K7SCR_RETSYS();
				}
				//Xe[WA
				K7SCR_STAGE_RESTORE();
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
#endif
			}
	    	break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//GS
//------------------------------------------------------------------------------
bool
K7Stage551M02::DieNpcCallBack( WK7DieNpcInfo &info )
{
	if( info.mpNpc==NULL )
	{
		return true;
	}
	
	switch( info.mpNpc->GetEneNo() )
	{
		case	ENENO_5_551M02_1:
			K7SCR_SET_SCENARIO_FLAG( EV055102HS1 );
			break;
		case	ENENO_5_551M02_2:
			K7SCR_SET_SCENARIO_FLAG( EV055102HS2 );
			break;
		default:
			break;
	}
	
	return( true );
}
