////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage558M00 ywZzZ
//
// K7Stage558M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/17/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE558M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage558M00.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Wat\WK7Item.h"

//f
#define	MDL558M00_DOORCAMPUS		"Book_StandB"	//Zւ̔
#define	MDL558M00_DOORGYM			"Book_StandB"	//̈قւ̔	"Book_StandA"
#define	MDL558M00_TROPHY_LEFT		"event_55800"	//gtB[E
#define	MDL558M00_TROPHY_RIGHT		"event_55801"	//gtB[EE
//[V
#define	MOT558M00_DOORCAMPUS_OP		(0)				//Zւ̔J
#define	MOT558M00_DOORCAMPUS_CL		(1)				//Zւ̔
#define	MOT558M00_DOORGYM_OP		(0)				//̈قւ̔J (2)
#define	MOT558M00_DOORGYM_CL		(1)				//̈قւ̔ (3)
#define	MOT558M00_MOVE_TROPHY_00	(4)				//gtB[ event_055800 
#define	MOT558M00_MOVE_TROPHY_01	(5)				//gtB[ event_055803 
#define	MOT558M00_MOVE_TROPHY_02	(6)				//gtB[ event_055804 
#define	MOT558M00_MOVE_TROPHY_03	(7)				//gtB[ event_055802 E
#define	MOT558M00_MOVE_TROPHY_04	(8)				//gtB[ event_055801 E
//pX
#define	PAT558M00_TOGYM				"toGym"				//̈قւ̃pX
#define	PAT558M00_TOCAMPUS			"toCampus"			//Zւ̃pX
#define	PAT558M00_RIDDLE			"event_055810_0"	//gtB[J




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage558M00::K7Stage558M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage558M00_Camera );
	mpSparkLeft  = NULL;
	mpSparkRight = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage558M00::~K7Stage558M00()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage558M00::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT558M00_DOORCAMPUS_OP );
	CreateOwnStageMotion( MOT558M00_DOORCAMPUS_CL );
	CreateOwnStageMotion( MOT558M00_DOORGYM_OP );
	CreateOwnStageMotion( MOT558M00_DOORGYM_CL );
	CreateOwnStageMotion( MOT558M00_MOVE_TROPHY_00 );
	CreateOwnStageMotion( MOT558M00_MOVE_TROPHY_01 );
	CreateOwnStageMotion( MOT558M00_MOVE_TROPHY_02 );
	CreateOwnStageMotion( MOT558M00_MOVE_TROPHY_03 );
	CreateOwnStageMotion( MOT558M00_MOVE_TROPHY_04 );
	
	//LLGtFNg
	if( K7SCR_GET_SCENARIO_FLAG(EV55800_LOOK_05080102) == true )
	{
		while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL )
		{
			K7SCR_RETSYS();
		}
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage558M00::TerminateCallBack( void )
{
	//LLGtFNg
	if( mpSparkLeft != NULL )
	{
		DeleteEffect( mpSparkLeft );
		mpSparkLeft = NULL;
	}
	if( mpSparkRight != NULL )
	{
		DeleteEffect( mpSparkRight );
		mpSparkRight = NULL;
	}
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage558M00::CondChangeCallBack( void )
{
	//---- ̈قւ̔ ----
	if( K7SCR_GET_SCENARIO_FLAG(EV055800) == false )
	{	//Ă
		K7SCR_STG_SET_PATHENABLE( PAT558M00_TOGYM, false );
		SimpleSetLastMotion( MDL558M00_DOORGYM, MOT558M00_DOORGYM_CL );
		if( (mpSparkLeft == NULL) && (K7SCR_GET_SCENARIO_FLAG(EV55800_LOOK_05080102) == true) )
		{
			mpSparkLeft  = CreateEasyAnimEffect2( ANIMID_SMALLLIGHT,
												  (Vec){ 1037.392f, 117.618f, -198.723f },
												  (Vec){ 2.0f, 2.0f, 2.0f },
												  true, -1 );
		}
	}else
	{	//JĂ
		K7SCR_STG_SET_PATHENABLE( PAT558M00_TOGYM, true );
		SimpleSetLastMotion( MDL558M00_DOORGYM, MOT558M00_DOORGYM_OP );
		if( mpSparkLeft != NULL )
		{
			DeleteEffect( mpSparkLeft );
			mpSparkLeft = NULL;
		}
	}
	
	//---- ̔JĂꍇ͓JɂȂȂ
	if( K7SCR_GET_SCENARIO_FLAG(EV055800) == true )
	{
		K7SCR_STG_SET_DISABLEPATHCAMERA( PAT558M00_RIDDLE, true );
	}else
	{
		K7SCR_STG_SET_DISABLEPATHCAMERA( PAT558M00_RIDDLE, false );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage558M00::SetCurrentCallBack( void )
{
	//߂Ă̕ɗꍇ̓KVA̗ʒuC
	if( (K7SCR_GET_SCENARIO_FLAG(EV55800_LOOK_05080102) == false) && (GetPrevStageID() == K7STGID(551,2)) )
	{
		SetManualBranch( true );
		while( WK7Stage::IsChanging() == true )
		{
			K7SCR_RETSYS();
		}
		gpSound->mFadeVolumeStream( 0, 50 );
		K7SCR_TIMEWAIT( 1200 );
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		//---- LĐ ----
		//Xe[WFL傫
		K7SCR_STAGE_RELEASE();
		//풓FL傫
		WK7EVENTCONTROLLER->ReleaseTempData2();
		while( WK7EVENTCONTROLLER->IsReleasedTempData2()==false ){
			K7SCR_RETSYS();
		}
		//L
		u32	playno = K7EVENTPLAY(05080102);
		K7SCR_CHARAGEKI_PREPARE( playno );
		//mCY
		while( gpNoise->mGetSandFrameProc() != eSandExec ){K7SCR_RETSYS();}
		while( gpNoise->mSandRelease(NULL,NULL,NULL,NULL,SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_CLOSE) == false ){K7SCR_RETSYS();}
		while( gpNoise->mGetSandFrameProc() != eSandStandby ){K7SCR_RETSYS();}		
		//LI҂
		K7SCR_CHARAGEKI_END_WAIT( playno );
		//mCY
		K7SCR_NOISE_REQUEST();
		//LI
		K7SCR_CHARAGEKI_TERM( playno );
		//풓A
		while( WK7EVENTCONTROLLER->LoadData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
			K7SCR_RETSYS();
		}
		//Xe[WA
		K7SCR_STAGE_RESTORE();
		//---- vC[ʒu ----
		K7SCR_STG_VISIBLE( K7STGID(558,0), true );
		K7SCR_PC_VISIBLE( true );
		WK7PLAYERPATHCONTROL->SetEnable( true );
		WK7PLAYERCONTROL->SetEnable( true );
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		//ړJnpXɏ悹
		SetCurrentPath(	GetPathNurbsAll("curve1"),
						1.757f,
						0,									// 0:forward 1:back
						WK7PATHINFO_INITDIR_TGTDIR );		// :WK7PATHINFO_INITDIR_TGTDIR wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
		Vec	initpos;
		WK7PLAYERPATHCONTROL->GetCurrentPosition(&initpos);
		WK7CAMPATHFOLLOWINFO->SetStageStartMode              (true);
		WK7CAMPATHFOLLOWINFO->SetStageStartCamPosition       ((Vec){984.641f, 118.330f, -216.063f});
		WK7CAMPATHFOLLOWINFO->SetStageStartCamTargetPosition ((Vec){1014.594f, 110.719f, -228.746f});
		WK7CAMPATHFOLLOWINFO->SetStageStartTargetInitPosition(initpos);
		WK7CAMPATHFOLLOWINFO->SetStageStartDist( 3.0f );
		//LLGtFNg
		while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL )
		{
			K7SCR_RETSYS();
		}
		//mCYJiXe[Wj
		SandRelease();
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){GHMGCTASK_RETSYS();}
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		SetManualBranch( false );
		SetCurrentCallBackDefaultProc();
		K7SCR_SET_SCENARIO_FLAG( EV55800_LOOK_05080102 );
		CondChangeCallBack();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage558M00::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	eventNo  = GetBpEventNo( info );
	int	pathNo   = GetBpPathNo( info );
	
	switch( eventNo )
	{
		//gtB[
		case	K7EVENTNO( 055810 ):
			if( pathNo == 0 )
			{
				if( K7SCR_GET_SCENARIO_FLAG(EV055800) == false )
				{
					gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
				}
			}
			break;
		
		//ftHg
		default:
			return( true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//qbgIuWF
//------------------------------------------------------------------------------
bool
K7Stage558M00::HitObjCallBack( WK7HitObjInfo &info )
{
	WK7JObj*	pJObjGYM = NULL;	//̈ٔ
	WK7JObj*	pJObjCPS = NULL;	//Z
	
	//xłĂ܂
//	info.mpHitObj->SetEnable( true );
	info.SetHitObjEnable(true);
	
	//IuWFNgɂĕ򂳂
	switch( info.mEventNo )
	{
		//̈قւ̔gtB[
		case	K7EVENTNO( 055800 ):
			if( K7SCR_GET_SCENARIO_FLAG(EV055800) == false )
			{
				//ogIB
				KK7BattleMainTask::BattleMainTaskExit( 2 );
				//L|[Y
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_VISIBLE( false );
				SetDefaultCameraDesc();
			//	FixCam( CAM558M00_DOOR_LEFT );
				FixCam( CAM558M00_DOOR_RIGHT );
				gpSound->mPlaySE( SFX_SCE5_SCL_TROPHY_HIT );
				SimplePlayMotionB( MDL558M00_TROPHY_LEFT, MOT558M00_MOVE_TROPHY_00 );
				gpSound->mPlaySE( SFX_SYS_TRUE );
				K7SCR_TIMEWAIT( 2400 );
				gpSound->mPlaySE( SFX_SCE5_SCL_SHELF_OPEN );
				SimplePlayMotionB( MDL558M00_DOORGYM, MOT558M00_DOORGYM_OP );
				K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
				//JtOݒ
				K7SCR_SET_SCENARIO_FLAG( EV055800 );
				K7SCR_EVCONDCHANGE();
				//L|[Y
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_VISIBLE( true );
			}else
			{
				gpSound->mPlaySE( SFX_SCE5_SCL_TROPHY_HIT );
				SimplePlayMotion( MDL558M00_TROPHY_LEFT, MOT558M00_MOVE_TROPHY_00 );
			}
			break;
		
		//ftHg
		default:
			gpSound->mPlaySE( SFX_SCE5_SCL_TROPHY_HIT );
			switch( info.mEventNo )
			{
				case K7EVENTNO( 055803 ):SimplePlayMotion( "event_55803", MOT558M00_MOVE_TROPHY_01 );break;
				case K7EVENTNO( 055804 ):SimplePlayMotion( "event_55804", MOT558M00_MOVE_TROPHY_02 );break;
				case K7EVENTNO( 055802 ):SimplePlayMotion( "event_55802", MOT558M00_MOVE_TROPHY_03 );break;
				case K7EVENTNO( 055801 ):SimplePlayMotion( "event_55801", MOT558M00_MOVE_TROPHY_04 );break;
				default:break;
			}
			if( K7SCR_GET_SCENARIO_FLAG(EV055800) == true )
			{
				//ogIB
				KK7BattleMainTask::BattleMainTaskExit( 2 );
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_VISIBLE( false );
				SetDefaultCameraDesc();
			//	FixCam( CAM558M00_DOORCLOSE );
				FixCam( CAM558M00_DOOR_RIGHT );
				//̈ٔEnYgtB[߂
				if( K7SCR_GET_SCENARIO_FLAG(EV055800) == true )
				{
					gpSound->mPlaySE( SFX_SCE5_SCL_SHELF_CLOSE );
					if( (pJObjGYM=PlayMotion(MDL558M00_DOORGYM,MOT558M00_DOORGYM_CL)) != NULL )
					{
						pJObjGYM->SetMotionLoop( false );
					}
				}
				//[VI҂
				if( pJObjGYM != NULL )
				{
					while( pJObjGYM->GetMotionState() != WK7MODEL_NOANIM )
					{
						K7SCR_RETSYS();
					}
				}
				K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
				K7SCR_RESET_SCENARIO_FLAG( EV055800 );
				K7SCR_EVCONDCHANGE();
				if( strcmp(WK7PLAYERPATHCONTROL->GetCurrentPathName(),PAT558M00_TOGYM) == 0 )
				{
					SetCurrentPath(	GetPathNurbsAll("event_055810_0"),
									1.000f,
									0,									// 0:forward 1:back
									WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
					WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				}
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_VISIBLE( true );
			}
			break;
	}
	
	return( true );
}

