////////////////////////////////////////////////////////////////////////////////
//
// Killer7 GlobalFlag
//
// K7GlobalFlag.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/30/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7GLOBALVAR_DECL__
#define	__K7GLOBALVAR_DECL__

#undef	K7EV_GL_VAR_START
#undef	K7EV_GL_VAR
#undef	K7EV_GL_VAR_ARRAY
#undef	K7EV_GL_VAR_END
#undef	K7EV_GL_FLAG_START
#undef	K7EV_GL_FLAG
#undef	K7EV_GL_FLAG_END

#if	defined(__K7GLOBALVAR_INIT__)

#define	K7EV_GL_VAR_START()								void WK7GameVarGlobal::Initialize(void){
#define	K7EV_GL_VAR(id,type,initvar)						id = initvar; SETVARPOINTER(&id);
#define	K7EV_GL_VAR_ARRAY(id,num,type,initvar)				memset(id,initvar,sizeof(type) * num); SETVARPOINTER(id);
#define	K7EV_GL_VAR_END()								}

#define	K7EV_GL_FLAG_START()							
#define	K7EV_GL_FLAG(id)								
#define	K7EV_GL_FLAG_END()								

#elif	defined(__K7GLOBALVAR_DEBUG__)

#define	K7EV_GL_VAR_START()								K7EVVarType GlobalVarType[] = {
#define	K7EV_GL_VAR(id,type,initvar)						{ #type , #id , NULL , 0   },
#define	K7EV_GL_VAR_ARRAY(id,num,type,initvar)				{ #type , #id , NULL , num },
#define	K7EV_GL_VAR_END()									{ NULL  , NULL, NULL , -1  }, \
														};

#define	K7EV_GL_FLAG_START()							const char *GlobalFlagName[] = {
#define	K7EV_GL_FLAG(id)									#id ,
#define	K7EV_GL_FLAG_END()									NULL, \
														};

#else

#define	K7EV_GL_VAR_START()								struct WK7GameVarGlobal{
#define	K7EV_GL_VAR(id,type,initvar)						type		id;
#define	K7EV_GL_VAR_ARRAY(id,num,type,initvar)				type		id[num];
#define	K7EV_GL_VAR_END()									void Initialize(void); \
														};

#define	K7EV_GL_FLAG_START()							enum{ K7EV_GL_FLAG_START_VALUE = -1,
#define	K7EV_GL_FLAG(id)									id,
#define	K7EV_GL_FLAG_END()									K7GLFL_NUM , \
															K7GLFL_FORCED_DWORD = 0x7fffffff, \
														};

#endif

// O[oϐ
// K7EVENT_GL_VAR(member) ŃANZX
// K7EVENT_GL_VAR(ValueName)    = 1;
// K7EVENT_GL_VAR(ArrayName)[0] = 0;
//  etc.
K7EV_GL_VAR_START()
//	K7EV_GL_VAR      (ValueName  ,  int, 0)	// 
//	K7EV_GL_VAR_ARRAY(ArrayName  ,6,int, 0)	// 
//	K7EV_GL_VAR_ARRAY(EquipRing,6,s8 ,-1)	//	wւ̏p 
	K7EV_GL_VAR(PutRing,s8,-1)
	K7EV_GL_VAR(SpBloodThick,u16,0)		//roIvVptLOADp
	K7EV_GL_VAR(SpBloodThin,u16,0)		//roIvVptLOADp
	K7EV_GL_VAR(SpBloodSerum,u16,0)		//roIvVptLOADp
	K7EV_GL_VAR(SpBullet,s8,0)			//roIvVptLOADp
K7EV_GL_VAR_END()

// O[otO 
// K7SCR_SET_GLOBAL_FLAG
// K7SCR_GET_GLOBAL_FLAG
// K7SCR_RESET_GLOBAL_FLAG
K7EV_GL_FLAG_START()
	K7EV_GL_FLAG(K7GLFL_OPT_RECONTROL)		// IvVFRg[tǂ Ă遁t
	K7EV_GL_FLAG(K7GLFL_OPT_VIB)			// IvVFoCu[V Ă=ON
	K7EV_GL_FLAG(K7GLFL_OPT_ENGTELOP)		// IvVFpꎚ̕\or\
	K7EV_GL_FLAG(K7GLFL_GAME_CLEAR)			// Killer7NA
	K7EV_GL_FLAG(K7GLFL_GAME_CLEAR_K8)		// Killer8NA
	K7EV_GL_FLAG(K7GLFL_KILLER1)			// Killer8I
	K7EV_GL_FLAG(K7GLFL_HOPPER7)			// Hopper7I
	K7EV_GL_FLAG(K7GLFL_SCENARIO_CLEAR)		// ViINA
	K7EV_GL_FLAG(K7GLFL_EASY_MODE)			// ՂՓxI
	K7EV_GL_FLAG(K7GLFL_SECRET)				// Z͐
	
	K7EV_GL_FLAG(K7GLFL_RING_FIRE)			// ΂̎w
	K7EV_GL_FLAG(K7GLFL_RING_WATER)			// ̎w
	K7EV_GL_FLAG(K7GLFL_RING_PAST)			// ߋ̎w
	K7EV_GL_FLAG(K7GLFL_RING_WIND)			// ̎w
	K7EV_GL_FLAG(K7GLFL_RING_HPUP)			// HPAbvO
	K7EV_GL_FLAG(K7GLFL_RING_ATTACK)		// U̓AbvO
	K7EV_GL_FLAG(K7GLFL_RING_EYE)			// 痢჊O


	K7EV_GL_FLAG(K7GLFL_CP_MIZARU)			// LN^ЉF~U
	K7EV_GL_FLAG(K7GLFL_CP_HSNEST)			// LN^ЉFwuX}C̑
	K7EV_GL_FLAG(K7GLFL_CP_IWAZARU)			// LN^ЉFCU
	K7EV_GL_FLAG(K7GLFL_CP_KIKAZARU)		// LN^ЉFLJU
	K7EV_GL_FLAG(K7GLFL_CP_TRAVIS)			// LN^ЉFgBX
	K7EV_GL_FLAG(K7GLFL_CP_KES)				// LN^ЉFPX
	
//	K7EV_GL_FLAG(K7GLFL_LETTER)				// ~Xe[nEXɓ邽߂̏ҏiprœj
	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_00) 		//	`[gAtO(Ă邩ĂȂ)
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_01) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_02) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_03) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_04) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_05) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_06) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_07) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_08) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_09) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_10) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_11) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_12) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_13) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_14) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_15) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_16) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_17) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_18) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_19) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_20) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_21) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_22) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_23) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_24) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_25) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_26) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_27) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_28) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_29) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_30) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_31) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_32) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_33) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_34) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_35) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_36) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_37) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_38) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_39) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_40) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_41) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_42) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_43) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_44) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_45) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_46) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_47) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_48) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_49) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_50) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_51) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_52) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_53) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_54) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_55) 		//	
	K7EV_GL_FLAG(K7GLFL_TUTORIAL_56) 		//	

	K7EV_GL_FLAG(K7GLFL_HATO_CEL_0) 		//	ng
	K7EV_GL_FLAG(K7GLFL_HATO_CEL_1) 		//	
	K7EV_GL_FLAG(K7GLFL_HATO_FUK_0) 		//	
	K7EV_GL_FLAG(K7GLFL_HATO_FUK_1) 		//	
	K7EV_GL_FLAG(K7GLFL_HATO_FUK_2) 		//	
	K7EV_GL_FLAG(K7GLFL_HATO_TXS_0) 		//	
	K7EV_GL_FLAG(K7GLFL_HATO_CUR_0) 		//	
	K7EV_GL_FLAG(K7GLFL_HATO_SCL_0) 		//	
	
	K7EV_GL_FLAG(K7GLFL_PLAYERDEAD) 		//	LS
K7EV_GL_FLAG_END()

#endif

#ifndef	__K7GLOBALFLAG_H__
#define	__K7GLOBALFLAG_H__

//#include ".\WK7Event.h"

#define	K7SCR_CP_STARTTICK		(2400)
#define	K7SCR_CP_WAITTIME		(WK7_SEC_TO_TICK(2.5f))
#define	K7SCR_CP_RELEASETIME	(WK7_FRAME_TO_TICK(2))

#ifdef	_DEBUG
struct K7EVVarType;
extern	K7EVVarType GlobalVarType[];
extern	const char *GlobalFlagName[];
#endif

#endif	//__K7GLOBALFLAG_H__

