////////////////////////////////////////////////////////////////////////////////
//
// Killer7 ID
//
// K7ID.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/07/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7ID_H__
#define	__K7ID_H__

// ViIhc
enum{
//	K7SCN00 = 0,								// 00 (ԗ\)
	K7SCN07 = 0,								// 00 Vg
	K7SCN01,									// 01 
	K7SCN02,									// 02 _j
	K7SCN03,									// 03 
	K7SCN04,									// 04 g
	K7SCN05,									// 05 Ί
	K7SCN06,
//	K7SCN07,									// 00 Vg
	K7SCN00,									// 00 (ԗ\)
	K7SCN08,
	K7SCN09,
#if FUJITA
	K7SCN97 = 97,								//{Xp
#endif	  
	K7SCN98 = 98,								// ogpViI
	K7SCN99 = 99,								// pViI
	K7SCNNUM,
	K7SCN_UNKNOWN = -1,
//	K7SCN_FORCED_DWORD = 0x7fffffff,
};

// ViIt[
enum K7ScenarioFlow{
	K7SCNF_CEL = 0,								// ZeBbN
	K7SCNF_FUK,									// tNV}
	K7SCNF_KAK,									// pr
	K7SCNF_TXS,									// eLTX
	K7SCNF_ISZ,									// VniCVUJhj
	K7SCNF_CUR,									// J[eBX@
	K7SCNF_DM1,									// h~jJO
	K7SCNF_DM2,									// h~jJij[[Nj
	K7SCNF_HT1,									// zeP
	K7SCNF_SCL,									// wZ
	K7SCNF_HT2,									// zeQ
	K7SCNF_GNK,									// R͓
	K7SCNF_UNKNOWN = -1,
//	K7SCNF_FORCED_DWORD = 0x7fffffff,
};

// GAhc
enum K7Area{
	K7AREA_CEL = 0,								// ZeBbN
	K7AREA_FUK,									// tNV}
	K7AREA_KAK,									// pr
	K7AREA_TXS,									// eLTX
	K7AREA_ISZ,									// VniCVUJhj
	K7AREA_CUR,									// J[eBX@
	K7AREA_DOM,									// h~jJ
	K7AREA_NYK,									// j[[N
	K7AREA_HTL,									// ze
	K7AREA_SCL,									// wZ
	K7AREA_GNK,									// R͓
	K7AREA_GAL,									// KVA@
	K7AREA_HAR,									// n[}
	K7AREA_UNKNOWN = -1,
	K7AREA_FORCED_DWORD = 0x7fffffff,
};

// O[otO
#define	K7SCRIPT_GLOBAL_FLAG_NUM	(16)
// [JtO
#define	K7SCRIPT_LOCAL_FLAG_NUM		(16)

// [V
#define	K7MOT_ATTR				(0x80000000)

// IuWFNg^Cv
#define	K7OBJTYPE_CHR			(0)				// LN^
#define	K7OBJTYPE_STG			(1)				// Xe[W
#define	K7OBJTYPE_ITEM			(2)				// ACe
#define	K7OBJTYPE_OTHER			(3)
#define	K7OBJTYPE_PLAYER		(4)				// v[[
#define	K7OBJTYPE_PATH			(5)				// pX

#define	K7OBJTYPE_PLAY			(0xffff0000)	// L

// IuWFNgft@C ------------------------------------------------------

// LN^hc
#define	K7CHRMAINID_SHIFT		(8)
#define	K7CHRSUFFIX_MASK		((1<<K7CHRMAINID_SHIFT)-1)
#define	K7CHRID(main,suffix)	(((main)<<K7CHRMAINID_SHIFT)|suffix)
#define	K7CHR_MAINID(id)		((id)>>K7CHRMAINID_SHIFT)
#define	K7CHR_SUFFIX(id)		((id) & K7CHRSUFFIX_MASK)
//      main
//          suffix
#define	K7DAN_INITIAL			"DAN"			// _
#define	K7DAN					(0)
	#define	K7DAN_BASE					(0)
		#define	K7DAN_M00						K7CHRID(K7DAN,K7DAN_BASE)
		#define	K7DAN_M01						K7CHRID(K7DAN,1)
#define	K7GAL_INITIAL			"GAL"			// KVA
#define	K7GAL					(1)
	#define	K7GAL_BASE					(0)
		#define	K7GAL_M00						K7CHRID(K7GAL,K7GAL_BASE)
#define	K7CON_INITIAL			"CAT"			// Lbg(R)
#define	K7CAT_INITIAL			K7CON_INITIAL	// Lbg(R)
//#define	K7CON_INITIAL			"CON"
#define	K7CON					(2)
#define	K7CAT					K7CON
	#define	K7CON_BASE					(0)
	#define	K7CAT_BASE					K7CON_BASE
		#define	K7CON_M00						K7CHRID(K7CON,K7CON_BASE)
		#define	K7CAT_M00						K7CON_M00
#define	K7HAC_INITIAL			"HAC"			// Ԉ֎qiI[hjn-}
#define	K7HAC					(3)
	#define	K7HAC_BASE					(0)
		#define	K7HAC_M00						K7CHRID(K7HAC,K7HAC_BASE)
#define	K7HAS_INITIAL			"HAS"			// iI[hjn[}
#define	K7HAS					(4)
	#define	K7HAS_BASE					(0)
		#define	K7HAS_M00						K7CHRID(K7HAS,K7HAS_BASE)
#define	K7HAY_INITIAL			"HAY"			// On[}
#define	K7HAY					(5)
	#define	K7HAY_BASE					(0)
		#define	K7HAY_M00						K7CHRID(K7HAY,K7HAY_BASE)
#define	K7CYO_INITIAL			"CYO"			// R[e
#define	K7CYO					(6)
	#define	K7CYO_BASE					(0)
		#define	K7COY_M00						K7CHRID(K7COY,K7COY_BASE)
#define	K7KED_INITIAL			"KED"			// JGf
#define	K7KED					(7)
	#define	K7KED_BASE					(0)
		#define	K7KED_M00						K7CHRID(K7KED,K7KED_BASE)
#define	K7KVN_INITIAL			"KVN"			// PB
#define	K7KVN					(8)
	#define	K7KVN_BASE					(0)
		#define	K7KVN_M00						K7CHRID(K7KVN,K7KVN_BASE)
#define	K7MSK_INITIAL			"MSK"			// }XN
#define	K7MSK					(9)
	#define	K7MSK_BASE					(0)
		#define	K7MSK_M00						K7CHRID(K7MSK,K7MSK_BASE)

#define	K7PCMAX					(10)			// PCL}bNX

#if !FUJITA
#define	K7KNL_INITIAL			"KNL"			// NE
#define	K7KNL					(10)
	#define	K7KNL_BASE					(0)
		#define	K7KNL_M00						K7CHRID(K7KNL,K7KNL_BASE)
#else
#define	K7KUN_INITIAL			"KUN"			// NE
#define	K7KUN					(10)
	#define	K7KUN_BASE					(0)
		#define	K7KUN_M00						K7CHRID(K7KUN,K7KUN_BASE)
#endif

#if FUJITA
#define	K7ANG_INITIAL			"ANG"			// Vg
#define	K7ANG					(11)
	#define	K7ANG_BASE					(0)
		#define	K7ANG_M00						K7CHRID(K7ANG,K7ANG_BASE)
#define	K7KIB_INITIAL			"KIB"			// Lo
#define	K7KIB					(12)
	#define	K7KIB_BASE					(0)
		#define	K7KIB_M00						K7CHRID(K7KIB,K7KIB_BASE)
#define	K7KRR_INITIAL			"KRR"			// N
#define	K7KRR					(13)
	#define	K7KRR_BASE					(0)
		#define	K7KRR_M00						K7CHRID(K7KRR,K7KRR_BASE)
#endif

#define	K7KIS_INITIAL			"KIS"			// LXM
#define	K7KIS					(14)
	#define	K7KIS_BASE					(0)
		#define	K7KIS_M00						K7CHRID(K7KIS,K7KIS_BASE)

#define	K7HAT_INITIAL			"HAT"			// ng
#define	K7HAT					(15)
	#define	K7HAT_BASE					(0)
		#define	K7HAT_M00						K7CHRID(K7HAT,K7HAT_BASE)

#define	K7ENM_INITIAL			"ENM"
#define	K7ENM					(16)
	#define	K7ENM_BASE					(0)
		#define	K7ENM_M00						K7CHRID(K7ENM,K7ENM_BASE)

#define	K7DE2_INITIAL			"DE2"			// f|[
#define	K7DE2					(17)
	#define	K7DE2_BASE					(0)
		#define	K7DE2_M00						K7CHRID(K7DE2,K7DE2_BASE)
#if FUJITA
#define	K7UR2_INITIAL			"UR2"			//EC_iԂĂǂł́Hj
#define	K7UR2					(18)
	#define	K7UR2_BASE					(0)
		#define	K7UR2_M00						K7CHRID(K7UR2,K7UR2_BASE)
#endif

#define	K7SMA_INITIAL			"SMA"			// T}T
#define	K7SMA					(19)
	#define	K7SMA_BASE					(0)
		#define	K7SMA_M00						K7CHRID(K7SMA,K7SMA_BASE)

#define	K7AKN_INITIAL			"AKN"			// AJl
#define	K7AKN					(20)
	#define	K7AKN_BASE					(0)
		#define	K7AKN_M00						K7CHRID(K7AKN,K7AKN_BASE)

#define	K7CUR_INITIAL			"CUR"			// AJl
#define	K7CUR					(21)
	#define	K7CUR_BASE					(0)
		#define	K7CUR_M00						K7CHRID(K7CUR,K7CUR_BASE)

#define	K7BAN_INITIAL			"BAN"			// Ԑl
#define	K7BAN					(22)
	#define	K7BAN_BASE					(0)
		#define	K7BAN_M00						K7CHRID(K7BAN,K7SMA_BASE)

#define	K7TEN_INITIAL			"TEN"			// Q[ Vg
#define	K7TEN					(23)
	#define	K7TEN_BASE					(0)
		#define	K7TEN_M00						K7CHRID(K7TEN,K7TEN_BASE)

#define	K7FAN_INITIAL			"FAN"			// Vg
#define	K7FAN					(24)
	#define	K7FAN_BASE					(0)
		#define	K7FAN_M00						K7CHRID(K7FAN,K7FAN_BASE)

#define	K7GLY_INITIAL			"GLY"			// OKVA
#define	K7GLY					(25)
	#define	K7GLY_BASE					(0)
		#define	K7GLY_M00						K7CHRID(K7GLY,K7GLY_BASE)

#define	K7MAT_INITIAL			"MAT"			// }cP
#define	K7MAT					(26)
	#define	K7MAT_BASE					(0)
		#define	K7MAT_M00						K7CHRID(K7MAT,K7MAT_BASE)


#define	K7GRY_INITIAL			"GRY"			// M[E_[Y
#define	K7GRY					(27)
	#define	K7GRY_BASE					(0)
		#define	K7GRY_M00						K7CHRID(K7GRY,K7GRY_BASE)

#define	K7SNG_INITIAL			"SNG"			// VK[
#define	K7SNG					(28)
	#define	K7SNG_BASE					(0)
		#define	K7SNG_M00						K7CHRID(K7SNG,K7SNG_BASE)

#define	K7HNG_INITIAL			"HNG"			// ݂蒷
#define	K7HNG					(29)
	#define	K7HNG_BASE					(0)
		#define	K7HNG_M00						K7CHRID(K7JHNG,K7HNG_BASE)

#define	K7FER_INITIAL			"FER"			// Vg
#define	K7FER					(30)
	#define	K7FER_BASE					(0)
		#define	K7FER_M00						K7CHRID(K7JFER,K7FER_BASE)

#define	K7HM1_INITIAL			"HM1"			// nT
#define	K7HM1					(31)
	#define	K7HM1_BASE					(0)
		#define	K7HM1_M00						K7CHRID(K7HM1,K7HM1_BASE)

#define	K7HN2_INITIAL			"HN2"			// nT
#define	K7HN2					(32)
	#define	K7HN2_BASE					(0)
		#define	K7HN2_M00						K7CHRID(K7HN2,K7HN2_BASE)

#define	K7HN3_INITIAL			"HN3"			// nT
#define	K7HN3					(33)
	#define	K7HN3_BASE					(0)
		#define	K7HN3_M00						K7CHRID(K7HN3,K7HN3_BASE)

#define	K7HN4_INITIAL			"HN4"			// nT
#define	K7HN4					(34)
	#define	K7HN4_BASE					(0)
		#define	K7HN4_M00						K7CHRID(K7HN4,K7HN4_BASE)

#define	K7HN5_INITIAL			"HN5"			// nT
#define	K7HN5					(35)
	#define	K7HN5_BASE					(0)
		#define	K7HN5_M00						K7CHRID(K7HN5,K7HN5_BASE)

#define	K7HN6_INITIAL			"HN6"			// nT
#define	K7HN6					(36)
	#define	K7HN6_BASE					(0)
		#define	K7HN6_M00						K7CHRID(K7HN6,K7HN6_BASE)

#define	K7HN8_INITIAL			"HN8"			// nT
#define	K7HN8					(37)
	#define	K7HN8_BASE					(0)
		#define	K7HN8_M00						K7CHRID(K7HN8,K7HN8_BASE)

#define	K7HN9_INITIAL			"HN9"			// nT
#define	K7HN9					(38)
	#define	K7HN9_BASE					(0)
		#define	K7HN9_M00						K7CHRID(K7HN9,K7HN9_BASE)

#define	K7AK2_INITIAL			"AKN"			// AJlQ
#define	K7AK2					(39)
	#define	K7AK2_BASE					(0)
		#define	K7AK2_M00						K7CHRID(K7AK2,K7AK2_BASE)

#define	K7ZA1_INITIAL			"ZA1"			// cvO1
#define	K7ZA1					(51)
	#define	K7ZA1_BASE					(0)
		#define	K7ZA1_M00						K7CHRID(K7ZA1,K7ZA1_BASE)

#define	K7ZA2_INITIAL			"ZA2"			// cvO2
#define	K7ZA2					(52)
	#define	K7ZA2_BASE					(0)
		#define	K7ZA2_M00						K7CHRID(K7ZA2,K7ZA2_BASE)

#define	K7ZA3_INITIAL			"ZA3"			// cvO3
#define	K7ZA3					(53)
	#define	K7ZA3_BASE					(0)
		#define	K7ZA3_M00						K7CHRID(K7ZA3,K7ZA3_BASE)

#define	K7ZA4_INITIAL			"ZA4"			// cvO4igBXj
#define	K7ZA4					(54)
	#define	K7ZA4_BASE					(0)
		#define	K7ZA4_M00						K7CHRID(K7ZA4,K7ZA4_BASE)

#define	K7ZA5_INITIAL			"ZA5"			// cvO5iPXj
#define	K7ZA5					(55)
	#define	K7ZA5_BASE					(0)
		#define	K7ZA5_M00						K7CHRID(K7ZA5,K7ZA5_BASE)

#define	K7ZA6_INITIAL			"ZA6"			// cvO6iX[W[j
#define	K7ZA6					(56)
	#define	K7ZA6_BASE					(0)
		#define	K7ZA6_M00						K7CHRID(K7ZA6,K7ZA6_BASE)

#define	K7ZA7_INITIAL			"ZA7"			// cvO7ijIj
#define	K7ZA7					(57)
	#define	K7ZA7_BASE					(0)
		#define	K7ZA7_M00						K7CHRID(K7ZA7,K7ZA7_BASE)

#define	K7ZA8_INITIAL			"ZA8"			// cvO8i~Yj
#define	K7ZA8					(58)
	#define	K7ZA8_BASE					(0)
		#define	K7ZA8_M00						K7CHRID(K7ZA8,K7ZA8_BASE)

#define	K7ZA9_INITIAL			"ZA9"			// cvO9iLXMj
#define	K7ZA9					(59)
	#define	K7ZA9_BASE					(0)
		#define	K7ZA9_M00						K7CHRID(K7ZA9,K7ZA9_BASE)

#define	K7ZAA_INITIAL			"ZAA"			// cvO10iMҁj
#define	K7ZAA					(60)
	#define	K7ZAA_BASE					(0)
		#define	K7ZAA_M00						K7CHRID(K7ZAA,K7ZAA_BASE)

#define	K7ZAB_INITIAL			"ZAB"			// cvO11iL[Zj
#define	K7ZAB					(61)
	#define	K7ZAB_BASE					(0)
		#define	K7ZAB_M00						K7CHRID(K7ZAB,K7ZAB_BASE)

#define	K7ZAC_INITIAL			"ZAC"			// cvO12ino[gj
#define	K7ZAC					(62)
	#define	K7ZAC_BASE					(0)
		#define	K7ZAC_M00						K7CHRID(K7ZAC,K7ZAC_BASE)

#define	K7ZAD_INITIAL			"ZAD"			// cvO13iNj
#define	K7ZAD					(63)
	#define	K7ZAD_BASE					(0)
		#define	K7ZAD_M00						K7CHRID(K7ZAD,K7ZAD_BASE)

#define	K7ZAE_INITIAL			"ZAE"			// cvO14iLoj
#define	K7ZAE					(64)
	#define	K7ZAE_BASE					(0)
		#define	K7ZAE_M00						K7CHRID(K7ZAE,K7ZAE_BASE)

#define	K7ZAF_INITIAL			"ZAF"			// cvO15iEC_j
#define	K7ZAF					(65)
	#define	K7ZAF_BASE					(0)
		#define	K7ZAF_M00						K7CHRID(K7ZAF,K7ZAF_BASE)

#define	K7ZAG_INITIAL			"ZAG"			// cvO16iJ[eBXj
#define	K7ZAG					(66)
	#define	K7ZAG_BASE					(0)
		#define	K7ZAG_M00						K7CHRID(K7ZAG,K7ZAG_BASE)

#define	K7ZAH_INITIAL			"ZAH"			// cvO17iAJlj
#define	K7ZAH					(67)
	#define	K7ZAH_BASE					(0)
		#define	K7ZAH_M00						K7CHRID(K7ZAH,K7ZAH_BASE)

#define	K7ZAI_INITIAL			"ZAI"			// cvO18i}cPj
#define	K7ZAI					(68)
	#define	K7ZAI_BASE					(0)
		#define	K7ZAI_M00						K7CHRID(K7ZAI,K7ZAI_BASE)

#define	K7ZAJ_INITIAL			"ZAJ"			// cvO19if|[j
#define	K7ZAJ					(69)
	#define	K7ZAJ_BASE					(0)
		#define	K7ZAJ_M00						K7CHRID(K7ZAJ,K7ZAJ_BASE)

#define	K7ZAK_INITIAL			"ZAK"			// cvO20inT}ubNj
#define	K7ZAK					(70)
	#define	K7ZAK_BASE					(0)
		#define	K7ZAK_M00						K7CHRID(K7ZAK,K7ZAK_BASE)

#define	K7ZAL_INITIAL			"ZAL"			// cvO21
#define	K7ZAL					(71)
	#define	K7ZAL_BASE					(0)
		#define	K7ZAL_M00						K7CHRID(K7ZAL,K7ZAL_BASE)

#define	K7ZAM_INITIAL			"ZAM"			// cvO22
#define	K7ZAM					(72)
	#define	K7ZAM_BASE					(0)
		#define	K7ZAM_M00						K7CHRID(K7ZAM,K7ZAM_BASE)

#define	K7ZAN_INITIAL			"ZAN"			// cvO23
#define	K7ZAN					(73)
	#define	K7ZAN_BASE					(0)
		#define	K7ZAN_M00						K7CHRID(K7ZAN,K7ZAN_BASE)

#define	K7ZAO_INITIAL			"ZAO"			// cvO24
#define	K7ZAO					(74)
	#define	K7ZAO_BASE					(0)
		#define	K7ZAO_M00						K7CHRID(K7ZAO,K7ZAO_BASE)

#define	K7ZAP_INITIAL			"ZAP"			// cvO25
#define	K7ZAP					(75)
	#define	K7ZAP_BASE					(0)
		#define	K7ZAP_M00						K7CHRID(K7ZAP,K7ZAP_BASE)

#define	K7ZAQ_INITIAL			"ZAQ"			// cvO26
#define	K7ZAQ					(76)
	#define	K7ZAQ_BASE					(0)
		#define	K7ZAQ_M00						K7CHRID(K7ZAQ,K7ZAQ_BASE)

#define	K7ZAR_INITIAL			"ZAR"			// cvO27
#define	K7ZAR					(77)
	#define	K7ZAR_BASE					(0)
		#define	K7ZAR_M00						K7CHRID(K7ZAR,K7ZAR_BASE)

#define	K7ZAS_INITIAL			"ZAS"			// cvO28
#define	K7ZAS					(78)
	#define	K7ZAS_BASE					(0)
		#define	K7ZAS_M00						K7CHRID(K7ZAS,K7ZAS_BASE)

#define	K7ZAT_INITIAL			"ZAT"			// cvO29
#define	K7ZAT					(79)
	#define	K7ZAT_BASE					(0)
		#define	K7ZAT_M00						K7CHRID(K7ZAT,K7ZAT_BASE)

#define	K7ZAU_INITIAL			"ZAU"			// cvO30
#define	K7ZAU					(80)
	#define	K7ZAU_BASE					(0)
		#define	K7ZAU_M00						K7CHRID(K7ZAU,K7ZAU_BASE)

#define	K7ZAV_INITIAL			"ZAV"			// cvO31
#define	K7ZAV					(81)
	#define	K7ZAV_BASE					(0)
		#define	K7ZAV_M00						K7CHRID(K7ZAV,K7ZAV_BASE)

#define	K7ZAW_INITIAL			"ZAW"			// cvO32
#define	K7ZAW					(82)
	#define	K7ZAW_BASE					(0)
		#define	K7ZAW_M00						K7CHRID(K7ZAW,K7ZAW_BASE)

#define	K7ZAX_INITIAL			"ZAX"			// cvO33
#define	K7ZAX					(83)
	#define	K7ZAX_BASE					(0)
		#define	K7ZAX_M00						K7CHRID(K7ZAX,K7ZAX_BASE)

#define	K7ZAY_INITIAL			"ZAY"			// cvO34
#define	K7ZAY					(84)
	#define	K7ZAY_BASE					(0)
		#define	K7ZAY_M00						K7CHRID(K7ZAY,K7ZAY_BASE)

#define	K7ZAZ_INITIAL			"ZAZ"			// cvO35
#define	K7ZAZ					(85)
	#define	K7ZAZ_BASE					(0)
		#define	K7ZAZ_M00						K7CHRID(K7ZAZ,K7ZAZ_BASE)

#define	K7E00_INITIAL			"E00"
#define	K7E00					(100)
	#define	K7E00_BASE					(0)
		#define	K7E00_M00						K7CHRID(K7E00,K7E00_BASE)
#define	K7E_NUM					(100)
#define	K7ENMID(id)				(K7E00+id)

#define	K7S00_INITIAL			"S00"
#define	K7S00					(200)
	#define	K7S00_BASE					(0)
		#define	K7S00_M00						K7CHRID(K7S00,K7S00_BASE)
#define	K7S_NUM					(100)
#define	K7SILID(id)				(K7S00+id)

#define	K7CHRID_MAX				(1000-1)

// Xe[Whc
#define	K7STGMAINID_SHIFT		(8)
#define	K7STGSUFFIX_MASK		((1<<K7STGMAINID_SHIFT)-1)
#define	K7STGID(main,suffix)	(((main)<<K7STGMAINID_SHIFT)|suffix)
#define	K7STG_MAINID(id)		((id)>>K7STGMAINID_SHIFT)
#define	K7STG_SUFFIX(id)		((id) & K7STGSUFFIX_MASK)
//      main
//          suffix
#define	K7STG000				(0)
#define	K7STG_SHANGHAI_TOWER	(0)
	#define	K7STG_SHANGHAI_TOWER_BASE	(0)
		#define	K7STG000_M00					K7STGID(K7STG000,0)
		#define	K7STG_SHANGHAI_TOWER_M00		K7STGID(K7STG_SHANGHAI_TOWER,K7STG_SHANGHAI_TOWER_BASE)
		#define	K7STG000_M01					K7STGID(K7STG000,1)
		#define	K7STG000_M02					K7STGID(K7STG000,2)
		#define	K7STG000_M03					K7STGID(K7STG000,3)
		#define	K7STG000_M04					K7STGID(K7STG000,4)
		#define	K7STG000_M05					K7STGID(K7STG000,5)
		#define	K7STG000_M06					K7STGID(K7STG000,6)
		#define	K7STG000_M07					K7STGID(K7STG000,7)
		#define	K7STG000_M08					K7STGID(K7STG000,8)
		#define	K7STG000_M09					K7STGID(K7STG000,9)
#define	K7STG001				(1)
#define	K7STG002				(2)
#define	K7STG003				(3)
#define	K7STG004				(4)
#define	K7STG005				(5)
#define	K7STG006				(6)
#define	K7STG007				(7)

#define	K7STGID_MAX				(1000-1)

// ACehc
#define	K7ITEMMAINID_SHIFT		(8)
#define	K7ITEMSUFFIX_MASK		((1<<K7ITEMMAINID_SHIFT)-1)
#define	K7ITEMID(main,suffix)	(((main)<<K7ITEMMAINID_SHIFT)|(suffix))
#define	K7ITEM_MAINID(id)		((id)>>K7ITEMMAINID_SHIFT)
#define	K7ITEM_SUFFIX(id)		((id) & K7ITEMSUFFIX_MASK)
//      main
//          suffix
#define	K7ITEM000				(0)
#define	K7ITEM_DUMMY_MAIN		(0)
	#define	K7ITEM_DUMMY_BASE			(0)
		#define	K7ITEM000_00				K7ITEMID(K7ITEM000,K7ITEM_DUMMY_BASE)
#define	K7ITEM001				(1)
	#define	K7ITEM_001_BASE				(0)
		#define	K7ITEM001_00				K7ITEMID(K7ITEM000,K7ITEM_001_BASE)
#define	K7ITEM002				(2)
#define	K7ITEM003				(3)
#define	K7ITEM004				(4)
#define	K7ITEM005				(5)
#define	K7ITEM006				(6)
#define	K7ITEM007				(7)

#define	K7ITEMID_MAX			(1000-1)

// mobhc
#define K7NPC_A_ENE				(0)
#define K7NPC_B_ENE				(1)
#define K7NPC_C_NPC				(2)
#define K7NPC_D_NPC				(3)
#define K7NPC_E_NPC				(4)


// [Vft@C --------------------------------------------------------

// 
// [Vhc
// 

#define	K7MOTMAINID_SHIFT			(16)
#define	K7MOTSUFFIX_MASK			((1<<K7MOTMAINID_SHIFT)-1)
#define	K7MOTID(main,suffix)		(((main)<<K7MOTMAINID_SHIFT)|(suffix))

#define	K7MOT_MAINID(id)			((id)>>K7MOTMAINID_SHIFT)
#define	K7MOT_SUFFIX(id)			((id) & K7MOTSUFFIX_MASK)

// LN^[V
#define	K7MOT_DAN_0000				K7MOTID(K7DAN,0)
#define	K7MOT_GAL_0000				K7MOTID(K7GAL,0)
#define	K7MOT_CON_0000				K7MOTID(K7CON,0)
#define	K7MOT_CAT_0000				K7MOT_CON_0000
#define	K7MOT_HAC_0000				K7MOTID(K7HAC,0)
#define	K7MOT_HAS_0000				K7MOTID(K7HAS,0)
#define	K7MOT_HAY_0000				K7MOTID(K7HAY,0)
#define	K7MOT_CYO_0000				K7MOTID(K7CYO,0)
#define	K7MOT_KED_0000				K7MOTID(K7KED,0)
#define	K7MOT_KVN_0000				K7MOTID(K7KVN,0)
#define	K7MOT_MSK_0000				K7MOTID(K7MSK,0)
#define	K7MOT_KNL_0000				K7MOTID(K7KNL,0)
#define	K7MOT_ENM_0000				K7MOTID(K7ENM,0)

// Xe[W[V
#define	K7MOT_STG000_000			K7MOTID(K7STG000,0)
#define	K7MOT_STG001_000			K7MOTID(K7STG001,0)
#define	K7MOT_STG002_000			K7MOTID(K7STG002,0)
#define	K7MOT_STG003_000			K7MOTID(K7STG003,0)

// ACe[V
#define	K7MOT_ITEM000_000			K7MOTID(K7ITEM000,0)
#define	K7MOT_ITEM001_000			K7MOTID(K7ITEM001,0)
#define	K7MOT_ITEM002_000			K7MOTID(K7ITEM002,0)
#define	K7MOT_ITEM003_000			K7MOTID(K7ITEM003,0)


// 

//
// LN^{[ꗗ
//
#define K7CHRBONE_ROOT					"Root"						// [gʒu
 #define K7CHRBONE_WAIST				"Root_joint"				// 
  #define K7CHRBONE_SPINE1				"Spine_joint1"				// wP
   #define K7CHRBONE_SPINE2				"Spine_joint2"				// wQ
    #define K7CHRBONE_NECK				"Neck_joint"				// 
     #define K7CHRBONE_SKULL			"Skull_joint"				// 
      #define K7CHRBONE_SKULL_TIP		"Skull_tip"					// ̐[
    #define K7CHRBONE_SCAPULA_L			"ScapulaL_joint"			// b
     #define K7CHRBONE_HUMERUS_L1		"HumerusL_joint1"			// rP
      #define K7CHRBONE_HUMERUS_L2		"HumerusL_joint2"			// rQ
       #define K7CHRBONE_ULNA_L			"UlnaL_joint"				// Oriڍj
        #define K7CHRBONE_RADIUS_L		"RadiusL_joint"				// 
         #define K7CHRBONE_WRIST_L		"WristL_joint"				// 
    #define K7CHRBONE_SCAPULA_R			"ScapulaR_joint"			// Eb
     #define K7CHRBONE_HUMERUS_R1		"HumerusR_joint1"			// ErP
      #define K7CHRBONE_HUMERUS_R2		"HumerusR_joint2"			// ErQ
       #define K7CHRBONE_ULNA_R			"UlnaR_joint"				// EOriڍj
        #define K7CHRBONE_RADIUS_R		"RadiusR_joint"				// E
         #define K7CHRBONE_WRIST_R		"WristR_joint"				// E
  #define K7CHRBONE_HIP_L				"HipL_joint"				// \
   #define K7CHRBONE_THIGH_L			"ThighL_joint"				// ڕij
    #define K7CHRBONE_SHIN_L			"ShinL_joint"				// iˁj
     #define K7CHRBONE_ANKLE_L			"AnkleL_joint"				// 
      #define K7CHRBONE_TOE_L			"ToeL_joint"				// ܐ
       #define K7CHRBONE_TOE_L_TIP		"ToeL_tip"					// ܐ̐[
  #define K7CHRBONE_HIP_R				"HipR_joint"				// E\
   #define K7CHRBONE_THIGH_R			"ThighR_joint"				// Eڕij
    #define K7CHRBONE_SHIN_R			"ShinR_joint"				// Eiˁj
     #define K7CHRBONE_ANKLE_R			"AnkleR_joint"				// E
      #define K7CHRBONE_TOE_R			"ToeR_joint"				// Eܐ
       #define K7CHRBONE_TOE_R_TIP		"ToeR_tip"					// Eܐ̐[


//
// LN^XLꗗ
//
#define K7CHRSKIN_WAIST					"Body"						// 
#define K7CHRSKIN_HEAD					K7CHRBONE_SKULL				// 
#define K7CHRSKIN_ARM_L					"Arm_L"					// r
#define K7CHRSKIN_ARM_R					"Arm_R"						// Er
#define K7CHRSKIN_LEG_L					"Foot_L"					// riˁj
#define K7CHRSKIN_LEG_R					"Foot_R"					// Eriˁj

// ֘AdvȂ
#define K7CHRBONE_HANDS_HIGH			"Hands_High"
#define K7CHRSKIN_HANDR_LOW				"HandL_Low"
#define K7CHRSKIN_HANDL_LOW				"HandR_Low"

//
// LN^{[iej
//
//#define K7CHRBONE_GUNHAND				"GunPos"
#define K7CHRBONE_GUNHANDR				"GunPos_R"
#define K7CHRBONE_GUNHANDL				"GunPos_L"


//// 
//// êhc YK7Effect.h QƂ
//enum {
//	K7GUN_BARRETT = 0,
//	K7GUN_BRWNGHP_L = 1,
//	K7GUN_BRWNGHP_R = 2,
//	K7GUN_COLTGOV = 3,
//	K7GUN_COLTPYT = 4,
//	K7GUN_GLOCK26_L = 5,
//	K7GUN_GLOCK26_R = 6,
//	K7GUN_WTHRPPK = 7,
//	K7GUN_NUM = 8,
//} ;
//

// mob̎_IuWFNgphc
enum WK7NpcWeakObjectId{
	NPCWEAKOBJID_WAIST = 0,			// 
	NPCWEAKOBJID_HEAD,				// 
	NPCWEAKOBJID_RARM,				// Er
	NPCWEAKOBJID_LARM,				// r
	NPCWEAKOBJID_RFOOT,				// E
	NPCWEAKOBJID_LFOOT,				// 
	NPCWEAKOBJID_MAX,
};

//
// G̃io[ꗗ
enum {
	ENENO_7_771M01_1 = 0,
	ENENO_7_771M01_2,
	ENENO_7_771M01_3,
	ENENO_7_771M01_4,
	ENENO_7_771M01_5,
	ENENO_7_771M01_6,

	ENENO_7_771M02_1,
	ENENO_7_771M02_2,
	ENENO_7_771M02_3,
	ENENO_7_771M02_4,
	ENENO_7_771M02_5,
	ENENO_7_771M02_6,

	ENENO_7_772M01_1,
	ENENO_7_772M01_2,
	ENENO_7_772M01_3,
	ENENO_7_772M01_4,
	ENENO_7_772M01_5,
	ENENO_7_772M01_6,

	ENENO_7_772M02_1,
	ENENO_7_772M02_2,
	ENENO_7_772M02_3,
	ENENO_7_772M02_4,
	ENENO_7_772M02_5,
	ENENO_7_772M02_6,
	ENENO_7_772M02_7,
	ENENO_7_772M02_8,
	ENENO_7_772M02_9,
	ENENO_7_772M02_10,
	ENENO_7_772M02_11,

	ENENO_7_773M01_1,
	ENENO_7_773M01_2,
	ENENO_7_773M01_3,
	ENENO_7_773M01_4,
	ENENO_7_773M01_5,
	ENENO_7_773M01_6,
	ENENO_7_773M01_7,
	ENENO_7_773M01_8,
	ENENO_7_773M01_9,
	ENENO_7_773M01_10,
	ENENO_7_773M01_11,
	ENENO_7_773M01_12,
	ENENO_7_773M01_13,
	ENENO_7_773M01_14,
	ENENO_7_773M01_15,

	ENENO_7_773M02_1,
	ENENO_7_773M02_2,
	ENENO_7_773M02_3,
	ENENO_7_773M02_4,
	ENENO_7_773M02_5,
	ENENO_7_773M02_6,

	ENENO_7_773M02_7,
	ENENO_7_773M02_8,
	ENENO_7_773M02_9,

	ENENO_7_773M02_10,
	ENENO_7_773M02_11,
	ENENO_7_773M02_12,

	ENENO_7_773M03_1,	//~tFI
	ENENO_7_773M03_2,
	ENENO_7_773M03_3,
	ENENO_7_773M03_4,
	ENENO_7_773M03_5,
	ENENO_7_773M03_6,

	ENENO_7_773M04_1,	//~tFI
	ENENO_7_773M04_2,

	ENENO_7_773M05_1,
	ENENO_7_773M05_2,

	ENENO_7_774M01_1,
	ENENO_7_774M01_2,
	ENENO_7_774M01_3,
	ENENO_7_774M01_4,
	ENENO_7_774M01_5,
	ENENO_7_774M01_6,

	ENENO_7_774M02_1,
	ENENO_7_774M02_2,
	ENENO_7_774M02_3,
	ENENO_7_774M02_4,
	ENENO_7_774M02_5,
	ENENO_7_774M02_6,
	ENENO_7_774M02_7,
	ENENO_7_774M02_8,
	ENENO_7_774M02_9,

	ENENO_7_774M03_1,
	ENENO_7_774M03_2,

	ENENO_7_774M04_1,
	ENENO_7_774M04_2,

	ENENO_7_775M01_1,
	ENENO_7_775M01_2,
	ENENO_7_775M01_3,
	ENENO_7_775M01_4,
	ENENO_7_775M01_5,
	ENENO_7_775M01_6,

	ENENO_7_775M02_1,
	ENENO_7_775M02_2,
	ENENO_7_775M02_3,
	ENENO_7_775M02_4,
	ENENO_7_775M02_5,
	ENENO_7_775M02_6,
	ENENO_7_775M02_7,

	ENENO_1_100_01,
	ENENO_1_100_02,
	ENENO_1_100_03,
	ENENO_1_100_04,
	ENENO_1_100_05,

	ENENO_1_101_01,
	ENENO_1_101_02,
	ENENO_1_101_03,
	ENENO_1_101_04,
	ENENO_1_101_05,
	ENENO_1_101_06,

	ENENO_1_101_01_1,
	ENENO_1_101_02_1,
	ENENO_1_101_03_1,
	ENENO_1_101_04_1,

	ENENO_1_101M01_1,
	ENENO_1_101M01_2,
	ENENO_1_101M01_3,

	ENENO_1_102_01,
	ENENO_1_102_02,
	ENENO_1_102_03,
	ENENO_1_102_04,
	ENENO_1_102_05,
	ENENO_1_102_06,
	ENENO_1_102_07,		// mkp
	ENENO_1_102_08,		// 
	ENENO_1_102_09,		// 
	ENENO_1_102_10,		// mp
	ENENO_1_102_11,		// 
	ENENO_1_102_12,		// 

	ENENO_1_103_01,
	ENENO_1_103_02,
	ENENO_1_103_03,
	ENENO_1_103_04,

	ENENO_1_103_05,
	ENENO_1_103_06,

	ENENO_1_103_07,
	ENENO_1_103_08,
	ENENO_1_103_09,

	ENENO_1_104_01,
	ENENO_1_104_02,
	ENENO_1_104_03,
	ENENO_1_104_04,
	ENENO_1_104_05,

	ENENO_1_105M00_1,
	ENENO_1_105M00_2,
	ENENO_1_105M00_3,
	ENENO_1_105M00_4,
	ENENO_1_105M00_5,
	ENENO_1_105M00_6,
	ENENO_1_105M00_7,
	ENENO_1_105M00_8,

	ENENO_1_106_01,
	ENENO_1_106_02,
	ENENO_1_106_03,
	ENENO_1_106_04,
	ENENO_1_106_05,

	ENENO_1_108_01,
	ENENO_1_108_02,
	ENENO_1_108_03,
	ENENO_1_108_04,
	ENENO_1_108_05,		// op
	ENENO_1_108_06,		// 
	ENENO_1_108_07,		// 

	ENENO_1_112M00_1,
	ENENO_1_112M00_2,
	ENENO_1_112M00_3,
	ENENO_1_112M00_4,
	ENENO_1_112M00_5,
	ENENO_1_112M00_6,
	ENENO_1_112M00_7,
	ENENO_1_112M00_8,
	ENENO_1_112M00_9,

	ENENO_1_113M00_1,
	ENENO_1_113M00_2,
	ENENO_1_113M00_3,
	ENENO_1_113M00_4,
	ENENO_1_113M00_5,

	ENENO_1_113M01_1,
	ENENO_1_113M01_2,
	ENENO_1_113M01_3,
	ENENO_1_113M01_4,
	ENENO_1_113M01_5,

	ENENO_1_113M02_1,
	ENENO_1_113M02_2,
	ENENO_1_113M02_3,
	ENENO_1_113M02_4,
	ENENO_1_113M02_5,

	ENENO_1_113M03_1,
	ENENO_1_113M03_2,
	ENENO_1_113M03_3,
	ENENO_1_113M03_4,
	ENENO_1_113M03_5,

	ENENO_1_117M00_1,			// gȓ
	ENENO_1_117M00_2,
	ENENO_1_117M00_3,
	ENENO_1_117M00_4,
	ENENO_1_117M00_5,
	ENENO_1_117M00_6,
	ENENO_1_117M00_7,

	ENENO_1_118M00_1,			// Ln@t@gX}C

	ENENO_1_180M00_1,
	ENENO_1_180M00_2,
	ENENO_1_180M00_3,
	ENENO_1_180M00_4,
	ENENO_1_180M00_5,

	ENENO_1_190M01_1,
	ENENO_1_190M01_2,
	ENENO_1_190M01_3,
	ENENO_1_190M01_4,
	ENENO_1_190M01_5,

// pr----------------------------------------------------------------

	ENENO_1_137M00_1,	// O
	ENENO_1_137M00_2,
	ENENO_1_137M00_3,

	ENENO_1_131M00_1,	// 1F
	ENENO_1_131M00_2,
	ENENO_1_131M00_3,
	ENENO_1_131M00_4,
	ENENO_1_131M00_5,
	ENENO_1_131M00_6,
	ENENO_1_131M00_7,
	ENENO_1_131M00_8,
	ENENO_1_131M00_9,
	ENENO_1_131M00_10,
	ENENO_1_131M00_11,
	ENENO_1_131M00_12,

	ENENO_1_132M00_1,	// 2F
	ENENO_1_132M00_2,
	ENENO_1_132M00_3,
	ENENO_1_132M00_4,
	ENENO_1_132M00_5,
	ENENO_1_132M00_6,
	ENENO_1_132M00_7,
	ENENO_1_132M00_8,
	ENENO_1_132M00_9,

	ENENO_1_133M00_1,	// 3F	// 
	ENENO_1_133M00_2,
	ENENO_1_133M00_3,
	ENENO_1_133M00_4,	// |CY
	ENENO_1_133M00_5,	// QHS
	ENENO_1_133M00_6,	// 
	ENENO_1_133M00_7,	// 
	ENENO_1_133M00_8,	// |CY
	ENENO_1_133M00_9,

	ENENO_1_134M00_1,	// 4F
	ENENO_1_134M00_2,
	ENENO_1_134M00_3_KEY,
	ENENO_1_134M00_4,
	ENENO_1_134M00_5,
	ENENO_1_134M00_6,
	ENENO_1_134M00_7,
	ENENO_1_134M00_8,
	ENENO_1_134M00_9,
	ENENO_1_134M00_10,
	ENENO_1_134M00_11,
	ENENO_1_134M00_12,
	ENENO_1_134M00_13,
	ENENO_1_134M00_14,

	ENENO_1_135M00_1_KEY,	// 5F
	ENENO_1_135M00_2_KEY,
	ENENO_1_135M00_3_KEY,
	ENENO_1_135M00_4_KEY,
	ENENO_1_135M00_5,
	ENENO_1_135M00_6,
	ENENO_1_135M00_7,
	ENENO_1_135M00_8,

	ENENO_1_136M00_1,	// B1
	ENENO_1_136M00_2,	// B1
	ENENO_1_136M00_3,	// B1
	ENENO_1_136M00_4,	// B1
	ENENO_1_136M00_5,	// B1

	ENENO_1_138M00_1,	// Ln

// ViI02u_jv
// eLTX----------------------------------------------------------------
	ENENO_2_201M00_1,		// `Q[g@O
	ENENO_2_201M00_2,
	ENENO_2_201M00_3,
	ENENO_2_201M00_4,	//iEC_j
	ENENO_2_201M00_5,
	ENENO_2_201M00_6,
	ENENO_2_201M00_7,
	ENENO_2_201M00_8,
	ENENO_2_201M00_9,
	ENENO_2_201M00_10,

	ENENO_2_201M01_1,		// `Q[g@㔼@iEC_j
	ENENO_2_201M01_2,
	ENENO_2_201M01_3,
	ENENO_2_201M01_4,	//iEC_j
	ENENO_2_201M01_5,	//iEC_j
	ENENO_2_201M01_6,	//iEC_j
	ENENO_2_201M01_7,	//iEC_j
	ENENO_2_201M01_8,
	ENENO_2_201M01_9,
	ENENO_2_201M01_10,	//iEC_j
	ENENO_2_201M01_11,	//iEC_j
	ENENO_2_201M01_12,	//iEC_j
	ENENO_2_201M01_13,	//iEC_j
	ENENO_2_201M01_14,
	ENENO_2_201M01_15,
	ENENO_2_201M01_16,	//iEC_j
	ENENO_2_201M01_17,	//iEC_j
	ENENO_2_201M01_18,	//iEC_j
	ENENO_2_201M01_19,	//iEC_j
	ENENO_2_201M01_20,
	ENENO_2_201M01_21,
	ENENO_2_201M01_22,	//iEC_j
	ENENO_2_201M01_23,	//iEC_j
	ENENO_2_201M01_24,	//iEC_j

	ENENO_2_208M00_1_KEY,	// ZX@iEC_j
	ENENO_2_208M00_2,		//iEC_j
	ENENO_2_208M00_3,		//iEC_j
	ENENO_2_208M00_4,
	ENENO_2_208M00_5,
	ENENO_2_208M00_6,
	ENENO_2_208M00_7_KEY,	// HS
	ENENO_2_208M00_8,
	ENENO_2_208M00_9,
	ENENO_2_208M00_10,
	ENENO_2_208M00_11,	//iEC_j
	ENENO_2_208M00_12,	//iEC_j
	ENENO_2_208M00_13,	//iEC_j
	ENENO_2_208M00_14,	//iEC_j
	ENENO_2_208M00_15,	//iEC_j
	ENENO_2_208M00_16,	//iEC_j
	ENENO_2_208M00_17,	//iEC_j

	ENENO_2_209M00_1,		// Q[g`X֋ǁ@O
	ENENO_2_209M00_2,
	ENENO_2_209M00_3,
	ENENO_2_209M00_4,
	ENENO_2_209M00_5,
	ENENO_2_209M00_6,
	ENENO_2_209M00_7,
	ENENO_2_209M00_8,
	ENENO_2_209M00_9,
	ENENO_2_209M00_10,
	ENENO_2_209M00_11,
	ENENO_2_209M00_12,
	ENENO_2_209M00_13,
	ENENO_2_209M00_14,
	ENENO_2_209M00_15,
	ENENO_2_209M00_16,

	ENENO_2_209M01_1,		// Q[g`X֋ǁ@㔼
	ENENO_2_209M01_2,
	ENENO_2_209M01_3,
	ENENO_2_209M01_4,		//iEC_j
	ENENO_2_209M01_5,		//iEC_j
	ENENO_2_209M01_6,		//iEC_j
	ENENO_2_209M01_7,
	ENENO_2_209M01_8,
	ENENO_2_209M01_9,		//iEC_j
	ENENO_2_209M01_10,		//iEC_j
	ENENO_2_209M01_11,		//iEC_j
	ENENO_2_209M01_12,
	ENENO_2_209M01_13,
	ENENO_2_209M01_14,		//iEC_j
	ENENO_2_209M01_15,		//iEC_j
	ENENO_2_209M01_16,		//iEC_j
	ENENO_2_209M01_17,
	ENENO_2_209M01_18,
	ENENO_2_209M01_19,		//iEC_j
	ENENO_2_209M01_20,		//iEC_j
	ENENO_2_209M01_21,		//iEC_j

	ENENO_2_203M00_1,		// X֋ǁ`NCY

	ENENO_2_203M00_2,
	ENENO_2_203M00_3,
	ENENO_2_203M00_4,
	ENENO_2_203M00_5,
	ENENO_2_203M00_6,
	ENENO_2_203M00_7,
	ENENO_2_203M00_8,

	ENENO_2_203M00_9,
	ENENO_2_203M00_10,
	ENENO_2_203M00_11,
	ENENO_2_203M00_12,
	ENENO_2_203M00_13,
	ENENO_2_203M00_14,
	ENENO_2_203M00_15,

	ENENO_2_203M00_16,
	ENENO_2_203M00_17,
	ENENO_2_203M00_18,
	ENENO_2_203M00_19,
	ENENO_2_203M00_20,
	ENENO_2_203M00_21,

	ENENO_2_204M00_1,		// NCY`̧ײ
	ENENO_2_204M00_2,		//
	ENENO_2_204M00_3,		//
	ENENO_2_204M00_4,		//
	ENENO_2_204M00_5,		//
	ENENO_2_204M00_6,
	ENENO_2_204M00_7,

	ENENO_2_210M00_208_1,	// 208inYjiEC_j
	ENENO_2_210M00_208_2,	// 208inYjiEC_j
	ENENO_2_210M00_209_1,	// 209inYj
	ENENO_2_210M00_209_2,	// 209inYj
	ENENO_2_210M00_209_3,	// 209inYj
	ENENO_2_210M00_217_1,	// 217inYjiEC_j
	ENENO_2_210M00_219_1,	// 219inYjiEC_j
	ENENO_2_210M00_219_2,	// 219inYjiEC_j
	ENENO_2_210M00_219_3,	// 219inYjiEC_j
	ENENO_2_210M00_219_4,	// 219inYjiEC_j
	ENENO_2_210M00_219_5,	// 219inYjiEC_j
	ENENO_2_210M00_219_6,	// 219inYjiEC_j
	ENENO_2_210M00_219_7,	// 219inYjiEC_j
	ENENO_2_210M00_219_8,	// 219inYjiEC_j

	ENENO_2_211M00_1,		// 210iԕr̕jiEC_j
	ENENO_2_211M00_2,		// 210iԕr̕jiEC_j
	ENENO_2_211M00_3,		// 210iԕr̕jiEC_j
	ENENO_2_211M00_4,		// 210iԕr̕jiEC_j

	ENENO_2_212M00_1,		// 206iER̕j

// ViI03u琁v
// Vn----------------------------------------------------------------
	ENENO_3_321M00_1,	// A[P[h
	ENENO_3_321M00_2,
	ENENO_3_321M00_3,

	ENENO_3_321M00_4,
	ENENO_3_321M00_5,

	ENENO_3_321M00_6,
	ENENO_3_321M00_7,

	ENENO_3_321M00_8,
	ENENO_3_321M00_9,

	ENENO_3_323M00_1,	// ]ƈpn
	ENENO_3_323M00_2,
	ENENO_3_323M00_3,
	ENENO_3_323M00_4,
	ENENO_3_323M00_5,
	ENENO_3_323M00_6,
	ENENO_3_323M00_7,
	ENENO_3_323M00_8,
	ENENO_3_323M00_9,
	ENENO_3_323M00_10,
	ENENO_3_323M00_11,
	ENENO_3_323M00_12,
	ENENO_3_323M00_13,
	ENENO_3_323M00_14,
	ENENO_3_323M00_15,
	ENENO_3_323M00_16,
	ENENO_3_323M00_17,
	ENENO_3_323M00_18,
	ENENO_3_323M00_19,
	ENENO_3_323M00_20,
	ENENO_3_323M00_21,
	ENENO_3_323M00_22,
	ENENO_3_323M00_23,
	ENENO_3_323M00_24,
	ENENO_3_323M00_25,
	ENENO_3_323M00_26,
	ENENO_3_323M00_27,
	ENENO_3_323M00_28,
	ENENO_3_323M00_29,
	ENENO_3_323M00_30,
	ENENO_3_323M00_31,

	ENENO_3_323M01_1,	// H
	ENENO_3_323M01_2,
	ENENO_3_323M01_3,

	ENENO_3_324M00_1,	// OʘH
	ENENO_3_324M00_2,
	ENENO_3_324M00_3,
	ENENO_3_324M00_4,
	ENENO_3_324M00_5,

	ENENO_3_324M00_6,
	ENENO_3_324M00_7,
	ENENO_3_324M00_8,
	ENENO_3_324M00_9,

	ENENO_3_324M00_10,
	ENENO_3_324M00_11,
	ENENO_3_324M00_12,
	ENENO_3_324M00_13,
	ENENO_3_324M00_14,

	ENENO_3_324M00_15,
	ENENO_3_324M00_16,
	ENENO_3_324M00_17,
	ENENO_3_324M00_18,

	ENENO_3_324M00_19,
	ENENO_3_324M00_20,
	ENENO_3_324M00_21,
	ENENO_3_324M00_22,

	ENENO_3_324M00_23,
	ENENO_3_324M00_24,
	ENENO_3_324M00_25,
	ENENO_3_324M00_26,

	ENENO_3_324M00_27,
	ENENO_3_324M00_28,
	ENENO_3_324M00_29,
	ENENO_3_324M00_30,

	ENENO_3_324M00_31,
	ENENO_3_324M00_32,
	ENENO_3_324M00_33,
	ENENO_3_324M00_34,
	ENENO_3_324M00_35,

	ENENO_3_325M00_1,	// (01)
	ENENO_3_325M00_2,
	ENENO_3_325M00_3,
	ENENO_3_325M00_4,

	ENENO_3_325M01_1,	// (02)
	ENENO_3_325M01_2,
	ENENO_3_325M01_3,

	ENENO_3_325M02_1,	// (03)@// 
	ENENO_3_325M02_2,
	ENENO_3_325M02_3,
	ENENO_3_325M02_4,
	ENENO_3_325M02_5,

	ENENO_3_325M03_1,	// (04)
	ENENO_3_325M03_2,
	ENENO_3_325M03_3,
	ENENO_3_325M03_4,
	ENENO_3_325M03_5,
	ENENO_3_325M03_6,

	ENENO_3_327M00_1,	// L
	ENENO_3_327M00_2,
	ENENO_3_327M00_3,
	ENENO_3_327M00_4,
	ENENO_3_327M00_5,
	ENENO_3_327M00_6,
	ENENO_3_327M00_7,

	ENENO_3_327M00_8,
	ENENO_3_327M00_9,
	ENENO_3_327M00_10,
	ENENO_3_327M00_11,
	ENENO_3_327M00_12,
	ENENO_3_327M00_13,
	ENENO_3_327M00_14,

	ENENO_3_327M00_15,
	ENENO_3_327M00_16,
	ENENO_3_327M00_17,
	ENENO_3_327M00_18,
	ENENO_3_327M00_19,
	ENENO_3_327M00_20,
	ENENO_3_327M00_21,

	ENENO_3_327M00_22,
	ENENO_3_327M00_23,
	ENENO_3_327M00_24,
	ENENO_3_327M00_25,
	ENENO_3_327M00_26,
	ENENO_3_327M00_27,

	ENENO_3_327M00_28,
	ENENO_3_327M00_29,
	ENENO_3_327M00_30,
	ENENO_3_327M00_31,
	ENENO_3_327M00_32,
	ENENO_3_327M00_33,

	ENENO_3_327M00_34,
	ENENO_3_327M00_35,
	ENENO_3_327M00_36,
	ENENO_3_327M00_37,

	ENENO_3_327M00_38,
	ENENO_3_327M00_39,
	ENENO_3_327M00_40,
	ENENO_3_327M00_41,
	ENENO_3_327M00_42,

	ENENO_3_306M00_1,	// ~Xe[nEX 
	ENENO_3_306M00_2,
	ENENO_3_306M00_3,
	ENENO_3_306M00_4,
	ENENO_3_306M00_5,

	ENENO_3_307M00_1,	// ~Xe[nEX [vL
	ENENO_3_307M00_2,
	ENENO_3_307M00_3,

	ENENO_3_308M00_1,	// ~Xe[nEX [bg
	ENENO_3_308M00_2,

	ENENO_3_309M00_1,	// ~Xe[nEX ΂̋
	ENENO_3_309M00_2,
	ENENO_3_309M00_3,
	ENENO_3_309M00_4,

	ENENO_3_310M00_1,	// ~Xe[nEX 邭X Z~bNX}C
	
	ENENO_3_312M00_1,	// װïݼݓ@1e
	ENENO_3_312M00_2,
	ENENO_3_312M00_3,

	ENENO_3_312M01_1,	// װïݼݓ@2e
	ENENO_3_312M01_2,
	ENENO_3_312M01_3,

	ENENO_3_312M02_1,	// װïݼݓ@3e
	ENENO_3_312M02_2,
	ENENO_3_312M02_3,

	ENENO_3_313M00_1,	// װïݼݓ@


	ENENO_3_328M00_1,			// Ln@wbh{


// J[eBX@----------------------------------------------------------------
	ENENO_3_351M00_1,
	ENENO_3_351M00_2,
	ENENO_3_351M00_3,
	ENENO_3_351M00_4,
	ENENO_3_351M00_5,
	ENENO_3_351M00_6,

	ENENO_3_352M00_1,
	ENENO_3_352M00_2,
	ENENO_3_352M00_3,
	ENENO_3_352M00_4,
	ENENO_3_352M00_5,
	ENENO_3_352M00_6,

	ENENO_3_354M00_1,
	ENENO_3_354M00_2,
	ENENO_3_354M00_3,
	ENENO_3_354M00_4,
	ENENO_3_354M00_5,
	ENENO_3_354M00_6,
	ENENO_3_354M00_7,
	ENENO_3_354M00_8,
	ENENO_3_354M00_9,
	ENENO_3_354M00_10,
	ENENO_3_354M00_11,
	ENENO_3_354M00_12,
	ENENO_3_354M00_13,
	ENENO_3_354M00_14,
	ENENO_3_354M00_15,
	ENENO_3_354M00_16,
	ENENO_3_354M00_17,
	ENENO_3_354M00_18,

	ENENO_3_355M00_1,
	ENENO_3_355M00_2,
	ENENO_3_355M00_3,
	ENENO_3_355M00_4,
	ENENO_3_355M00_5,

	ENENO_3_356M00_1,
	ENENO_3_356M00_2,
	ENENO_3_356M00_3,
	ENENO_3_356M00_4,
	ENENO_3_356M00_5,
	ENENO_3_356M00_6,
	ENENO_3_356M00_7,
	ENENO_3_356M00_8,
	ENENO_3_356M00_9,
	ENENO_3_356M00_10,
	ENENO_3_356M00_11,
	ENENO_3_356M00_12,
	ENENO_3_356M00_13,
	ENENO_3_356M00_14,
	ENENO_3_356M00_15,
	ENENO_3_356M00_16,
	ENENO_3_356M00_17,
	ENENO_3_356M00_18,
	ENENO_3_356M00_19,
	ENENO_3_356M00_20,
	ENENO_3_356M00_21,
	ENENO_3_356M00_22,
	ENENO_3_356M00_23,
	ENENO_3_356M00_24,
	ENENO_3_356M00_25,
	ENENO_3_356M00_26,
	ENENO_3_356M00_27,
	ENENO_3_356M00_28,
	ENENO_3_356M00_29,
	ENENO_3_356M00_30,
	ENENO_3_356M00_31,
	ENENO_3_356M00_32,
	ENENO_3_356M00_33,
	ENENO_3_356M00_34,
	ENENO_3_356M00_35,

	ENENO_3_357M00_1,
	ENENO_3_357M00_2,
	ENENO_3_357M00_3,
	ENENO_3_357M00_4,
	ENENO_3_357M00_5,
	ENENO_3_357M00_6,

	ENENO_3_358M00_1,
	ENENO_3_358M00_2,
	ENENO_3_358M00_3,
	ENENO_3_358M00_4,
	ENENO_3_358M00_5,
	ENENO_3_358M00_6,

	ENENO_3_361M00_1,
	ENENO_3_361M00_2,
	ENENO_3_361M00_3,
	ENENO_3_361M00_4,
	ENENO_3_361M00_5,
	ENENO_3_361M00_6,

	ENENO_3_362M00_1,
	ENENO_3_362M00_2,
	ENENO_3_362M00_3,
	ENENO_3_362M00_4,
	ENENO_3_362M00_5,
	ENENO_3_362M00_6,

	ENENO_3_363M00_1,
	ENENO_3_363M00_2,
	ENENO_3_363M00_3,
	ENENO_3_363M00_4,
	ENENO_3_363M00_5,
	ENENO_3_363M00_6,

	ENENO_3_365M00_1,		//Ln@[U[X}C

// ViI04ugv
// h~jJ----------------------------------------------------------------
	ENENO_4_411M00_1,		//
	ENENO_4_411M00_2,		//
	ENENO_4_411M00_3,		//
	ENENO_4_411M00_4,		//
	ENENO_4_411M00_5,		//

	ENENO_4_412M00_1,		//
	ENENO_4_412M00_2,		//
	ENENO_4_412M00_3,		//
	ENENO_4_412M00_4,		//

	ENENO_4_413M00_1,		//
	ENENO_4_413M00_2,		//
	ENENO_4_413M00_3,		//
	ENENO_4_413M00_4,		//
	ENENO_4_413M00_5,		//
	ENENO_4_413M00_6,		//
	ENENO_4_413M00_7,		//
	ENENO_4_413M00_8,		//
	ENENO_4_413M00_9,		//
	ENENO_4_413M00_10,		//

	ENENO_4_415M00_1,		//
	ENENO_4_415M00_2,		//
	ENENO_4_415M00_3,		//
	ENENO_4_415M00_4,		//
	ENENO_4_415M00_5,		//
	ENENO_4_415M00_6,		//
	ENENO_4_415M00_7,		//
	ENENO_4_415M00_8,		//
	ENENO_4_415M00_9,		//
	ENENO_4_415M00_10,		//
	ENENO_4_415M00_11,		//
	ENENO_4_415M00_12,		//
	ENENO_4_415M00_13,		//
	ENENO_4_415M00_14,		//
	ENENO_4_415M00_15,		//

	ENENO_4_420M00_1,		//
	ENENO_4_420M00_2,		//
	ENENO_4_420M00_3,		//
	ENENO_4_420M00_4,		//
	ENENO_4_420M00_5,		//

	ENENO_4_420M01_1,		//
	ENENO_4_420M01_2,		//
	ENENO_4_420M01_3,		//
	ENENO_4_420M01_4,		//

	ENENO_4_422M00_1,		//
	ENENO_4_422M00_2,		//
	ENENO_4_422M00_3,		//
	ENENO_4_422M00_4,		//coL

	ENENO_4_425M00_1,		//Ki
	ENENO_4_425M00_2,
	ENENO_4_425M00_3,
	ENENO_4_425M00_4,
	ENENO_4_425M00_5,
	ENENO_4_425M00_6,

	ENENO_4_441M00_1,		//
	ENENO_4_441M00_2,		//
	ENENO_4_441M00_3,		//
	ENENO_4_441M00_4,		//
	ENENO_4_441M00_5,		//

	ENENO_4_443M00_1,		//
	ENENO_4_443M00_2,		//
	ENENO_4_443M00_3,		//
	ENENO_4_443M00_4,		//
	ENENO_4_443M00_5,		//
	ENENO_4_443M00_6,		//
	ENENO_4_443M00_7,		//
	ENENO_4_443M00_8,		//
	ENENO_4_443M00_9,		//
	ENENO_4_443M00_10,		//

	ENENO_4_444M01_1,		//
	ENENO_4_444M01_2,		//
	ENENO_4_444M01_3,		//
	ENENO_4_444M01_4,		//
	ENENO_4_444M01_5,		//
	ENENO_4_444M01_6,		//
	ENENO_4_444M01_7,		//

	ENENO_4_445M00_1,		//
	ENENO_4_445M00_2,		//
	ENENO_4_445M00_3,		//
	ENENO_4_445M00_4,		//
	ENENO_4_445M00_5,		//
	ENENO_4_445M00_6,		//

// ViI05uΊv
// ze----------------------------------------------------------------
	ENENO_5_511M00_1,		// coL	// 1K
	ENENO_5_511M00_2,		// m[}
	ENENO_5_511M00_3,		// m[}
	ENENO_5_511M00_4,		// QnL
	ENENO_5_511M00_5,		// 
	ENENO_5_511M00_6,		// 
	ENENO_5_511M00_7,		// ~N

	ENENO_5_512M00_1,		//		// 2K
	ENENO_5_512M00_2,		//
	ENENO_5_512M00_3,		//
	ENENO_5_512M00_4,		//coL
	ENENO_5_512M00_5,		//t[
	ENENO_5_512M00_6,
	ENENO_5_512M00_7,
	ENENO_5_512M00_8,
	ENENO_5_512M00_9,
	ENENO_5_512M00_10,
	ENENO_5_512M00_11,
	ENENO_5_512M00_12,
	ENENO_5_512M00_13,
	ENENO_5_512M00_14,
	ENENO_5_512M00_15,
	ENENO_5_512M00_16,
	ENENO_5_512M00_17,
	ENENO_5_512M00_18,
	ENENO_5_512M00_19,
	ENENO_5_512M00_20,
	ENENO_5_512M00_21,
	ENENO_5_512M00_22,
	ENENO_5_512M00_23,
	ENENO_5_512M00_24,
	ENENO_5_512M00_25,

	ENENO_5_513M00_1,		//t[	// 3K
	ENENO_5_513M00_2,		//t[
	ENENO_5_513M00_3,		//AiU[
	ENENO_5_513M00_4,		//AiU[
	ENENO_5_513M00_5,		//t@g
	ENENO_5_513M00_6,
	ENENO_5_513M00_7,
	ENENO_5_513M00_8,
	ENENO_5_513M00_9,
	ENENO_5_513M00_10,
	ENENO_5_513M00_11,
	ENENO_5_513M00_12,
	ENENO_5_513M00_13,
	ENENO_5_513M00_14,
	ENENO_5_513M00_15,
	ENENO_5_513M00_16,
	ENENO_5_513M00_17,
	ENENO_5_513M00_18,
	ENENO_5_513M00_19,
	ENENO_5_513M00_20,
	ENENO_5_513M00_21,
	ENENO_5_513M00_22,
	ENENO_5_513M00_23,
	ENENO_5_513M00_24,
	ENENO_5_513M00_25,
	ENENO_5_513M00_26,
	ENENO_5_513M00_27,
	ENENO_5_513M00_28,
	ENENO_5_513M00_29,
	ENENO_5_513M00_30,
	ENENO_5_513M00_31,
	ENENO_5_513M00_32,
	ENENO_5_513M00_33,

	ENENO_5_514M00_1,		//t[	// 4K
	ENENO_5_514M00_2,		//~N
	ENENO_5_514M00_3,		//|CY
	ENENO_5_514M00_4,		//AiU[
	ENENO_5_514M00_5,		//
	ENENO_5_514M00_6,		//
	ENENO_5_514M00_7,
	ENENO_5_514M00_8,
	ENENO_5_514M00_9,
	ENENO_5_514M00_10,
	ENENO_5_514M00_11,
	ENENO_5_514M00_12,
	ENENO_5_514M00_13,
	ENENO_5_514M00_14,
	ENENO_5_514M00_15,
	ENENO_5_514M00_16,
	ENENO_5_514M00_17,
	ENENO_5_514M00_18,
	ENENO_5_514M00_19,
	ENENO_5_514M00_20,
	ENENO_5_514M00_21,
	ENENO_5_514M00_22,
	ENENO_5_514M00_23,
	ENENO_5_514M00_24,
	ENENO_5_514M00_25,
	ENENO_5_514M00_26,
	ENENO_5_514M00_27,
	ENENO_5_514M00_28,
	ENENO_5_514M00_29,
	ENENO_5_514M00_30,
	ENENO_5_514M00_31,
	ENENO_5_514M00_32,
	ENENO_5_514M00_33,
	ENENO_5_514M00_34,
	ENENO_5_514M00_35,
	ENENO_5_514M00_36,
	ENENO_5_514M00_37,
	ENENO_5_514M00_38,
	ENENO_5_514M00_39,
	ENENO_5_514M00_40,
	ENENO_5_514M00_41,

	ENENO_5_515M00_1,		//	// 5K
	ENENO_5_515M00_2,		//
	ENENO_5_515M00_3,		//
	ENENO_5_515M00_4,		//
	ENENO_5_515M00_5,		//
	ENENO_5_515M00_6,		//
	ENENO_5_515M00_7,		//
	ENENO_5_515M00_8,		//
	ENENO_5_515M00_9,		//
	ENENO_5_515M00_10,		//
	ENENO_5_515M00_11,		//
	ENENO_5_515M00_12,		//
	ENENO_5_515M00_13,		//
	ENENO_5_515M00_14,		//
	ENENO_5_515M00_15,		//
	ENENO_5_515M00_16,		//
	ENENO_5_515M00_17,		//
	ENENO_5_515M00_18,		//
	ENENO_5_515M00_19,		//
	ENENO_5_515M00_20,		//
	ENENO_5_515M00_21,		//
	ENENO_5_515M00_22,		//
	ENENO_5_515M00_23,		//
	ENENO_5_515M00_24,		//
	ENENO_5_515M00_25,		//
	ENENO_5_515M00_26,		//
	ENENO_5_515M00_27,		//
	ENENO_5_515M00_28,		//
	ENENO_5_515M00_29,		//
	ENENO_5_515M00_30,		//
	ENENO_5_515M00_31,		//
	ENENO_5_515M00_32,		//
	ENENO_5_515M00_33,		//
	ENENO_5_515M00_34,		//
	ENENO_5_515M00_35,		//
	ENENO_5_515M00_36,		//
	ENENO_5_515M00_37,		//
	ENENO_5_515M00_38,		//
	ENENO_5_515M00_39,		//
	ENENO_5_515M00_40,		//
	ENENO_5_515M00_41,		//
	ENENO_5_515M00_42,		//
	ENENO_5_515M00_43,		//
	ENENO_5_515M00_44,		//
	ENENO_5_515M00_45,		//
	ENENO_5_515M00_46,		//
	ENENO_5_515M00_47,		//
	ENENO_5_515M00_48,		//

	ENENO_5_516M00_1,		//t[	// 6K
	ENENO_5_516M00_2,		//t[
	ENENO_5_516M00_3,		//[U[
	ENENO_5_516M00_4,		//
	ENENO_5_516M00_5,		//
	ENENO_5_516M00_6,		//
	ENENO_5_516M00_7,		//
	ENENO_5_516M00_8,		//
	ENENO_5_516M00_9,		//
	ENENO_5_516M00_10,		//
	ENENO_5_516M00_11,		//
	ENENO_5_516M00_12,		//
	ENENO_5_516M00_13,		//
	ENENO_5_516M00_14,		//
	ENENO_5_516M00_15,		//
	ENENO_5_516M00_16,		//
	ENENO_5_516M00_17,		//
	ENENO_5_516M00_18,		//
	ENENO_5_516M00_19,		//
	ENENO_5_516M00_20,		//
	ENENO_5_516M00_21,		//
	ENENO_5_516M00_22,		//
	ENENO_5_516M00_23,		//
	ENENO_5_516M00_24,		//
	ENENO_5_516M00_25,		//
	ENENO_5_516M00_26,		//
	ENENO_5_516M00_27,		//
	ENENO_5_516M00_28,		//
	ENENO_5_516M00_29,		//
	ENENO_5_516M00_30,		//
	ENENO_5_516M00_31,		//
	ENENO_5_516M00_32,		//
	ENENO_5_516M00_33,		//
	ENENO_5_516M00_34,		//
	ENENO_5_516M00_35,		//
	ENENO_5_516M00_36,		//
	ENENO_5_516M00_37,		//
	ENENO_5_516M00_38,		//
	ENENO_5_516M00_39,		//
	ENENO_5_516M00_40,		//
	ENENO_5_516M00_41,		//
	ENENO_5_516M00_42,		//
	ENENO_5_516M00_43,		//
	ENENO_5_516M00_44,		//
	ENENO_5_516M00_45,		//
	ENENO_5_516M00_46,		//
	ENENO_5_516M00_47,		//
	ENENO_5_516M00_48,		//

	ENENO_5_517M00_1,		//~N	// 7K

	ENENO_5_520M00_KIHAN_TIME,		// Ln

	ENENO_5_522M00_1,		// 2K@
	ENENO_5_522M00_2,		// 

	ENENO_5_523M00_1,		// 3K@
	ENENO_5_523M00_2,		// 

	ENENO_5_524M00_1,		// 4K@
	ENENO_5_524M00_2,		// 

	ENENO_5_525M00_1,		// 5K@
	ENENO_5_525M00_2,		// 

	ENENO_5_526M00_1,		// 6K@
	ENENO_5_526M00_2,		// 

// wZ----------------------------------------------------------------
	ENENO_5_551M00_1,		// 		// 1KL@1
	ENENO_5_551M00_2,		// 
	ENENO_5_551M00_3,		// 

	ENENO_5_551M01_1,		// 		// 1KL@2
	ENENO_5_551M01_2,		// 
	ENENO_5_551M01_3,		// 
	ENENO_5_551M01_4,		// 
	ENENO_5_551M01_5,		// 
	ENENO_5_551M01_6,		// 
	ENENO_5_551M01_7,		// 
	ENENO_5_551M01_8,		// 
	ENENO_5_551M01_9,		// 

	ENENO_5_551M02_1,		// |CY			// 2KL
	ENENO_5_551M02_2,		// |CY
	ENENO_5_551M02_3,		// m[}
	ENENO_5_551M02_4,		// m[}

	ENENO_5_551M03_1,		// 2KL@2
	ENENO_5_551M03_2,
	ENENO_5_551M03_3,

	ENENO_5_551M04_1,		// 1KL@3
	ENENO_5_551M04_2,
	ENENO_5_551M04_3,
	ENENO_5_551M04_4,
	ENENO_5_551M04_5,
	ENENO_5_551M04_6,

	ENENO_5_552M00_1,		// ~N			// wZ̈ٓnL

	ENENO_5_554M00_1,		// 					// 0

	ENENO_5_554M01_1,		// 					// 1

	ENENO_5_554M02_1,		// 					// 2

	ENENO_5_554M03_1,		// 					// 3

	ENENO_5_554M04_1,		// 					// 4

	ENENO_5_554M05_1,		// 					// 5

	ENENO_5_554M06_1,		// 					// 6

	ENENO_5_554M07_1,		// 					// 7
	ENENO_5_554M07_2,		// 					// 

	ENENO_5_554M08_1,		// 					// 8

	ENENO_5_554M09_1,		// 					// 9

	ENENO_5_554M10_1,		// 					// 10

	ENENO_5_554M11_1,		// 					// 11

	ENENO_5_554M12_1,		// 					// 12

	ENENO_5_557M00_1,		//Ln@MNeBJ

	ENENO_5_560M00_1,		//				// H
	ENENO_5_560M00_2,		//
	ENENO_5_560M00_3,		//
	ENENO_5_560M00_4,		//coL
	ENENO_5_560M00_5,		//
	ENENO_5_560M00_6,		//
	ENENO_5_560M00_7,		//
	ENENO_5_560M00_8,		//

	ENENO_5_553M00_BLHS_0,	//BLHS
	ENENO_5_553M00_BLHS_1,	//BLHS
	ENENO_5_553M00_BLHS_2,	//BLHS
	ENENO_5_553M00_BLHS_3,	//BLHS
	ENENO_5_553M00_BLHS_4,	//BLHS
	ENENO_5_553M00_BLHS_5,	//BLHS
	ENENO_5_553M00_BLHS_6,	//BLHS

// wZ----------------------------------------------------------------
	ENENO_5_570M00_1,		//
	ENENO_5_570M00_2,
	ENENO_5_570M00_3,
	ENENO_5_570M00_4,
	ENENO_5_570M00_5,

	ENENO_5_572M00_1,		//RVA܂
	ENENO_5_572M00_2,
	ENENO_5_572M00_3,
	ENENO_5_572M00_4,
	ENENO_5_572M00_5,

	ENENO_5_573M00_1,		//z[
	ENENO_5_573M00_2,
	ENENO_5_573M00_3,
	ENENO_5_573M00_4,
	ENENO_5_573M00_5,

// `[gA----------------------------------------------------------------
	ENENO_TUTORIAL_771M04_0,
	ENENO_TUTORIAL_771M04_1,
	
// {X----------------------------------------------------------------
	ENENO_ANG,
	ENENO_ANG2,
	ENENO_KUN,
	ENENO_KUN2,
	ENENO_KIB,
	ENENO_KRR,
	ENENO_KIS,
	ENENO_DE2,
	ENENO_UR2,
	ENENO_AKN,
	ENENO_AK2,
	ENENO_CUR,
	ENENO_FAN,
	ENENO_HNG,
	ENENO_HM1,
	ENENO_HN2,
	ENENO_HN3,
	ENENO_HN4,
	ENENO_HN5,
	ENENO_HN6,
	ENENO_HN8,
	ENENO_HN9,
	ENENO_MAX_TEST,
	ENENO_MAX,
};

//
//	GLXg̃^Cvꗗ
//	enum{
//		K7EXTRA_A = 0,
//		K7EXTRA_B,
//		K7EXTRA_D,
//		K7EXTRA_NUM,
//	};

//
// Gl~[̃^Cvꗗ
enum{
//	K7ENM_A = K7EXTRA_NUM,
	K7ENM_A = 0,
	K7ENM_B,
	K7ENM_C,
	K7ENM_D,
	K7ENM_E,
	K7ENM_F,
	K7ENM_G,
	K7ENM_H,				// H	coL
	K7ENM_DIVE,				// I	_CrO
	K7ENM_SU,				// J
	K7ENM_SU_EGG,			// K
	K7ENM_L_OYA,			// L
	K7ENM_L_EGG,			// M
	K7ENM_ANOT,				// N	AiU[X}C
	K7ENM_POIZ,				// O	|CY
	K7ENM_PROT,				// P	veNg
	K7ENM_FANT,				// Q	t@g
	K7ENM_LASE,				// R	[U[
	K7ENM_BACK,				// S	obN
	K7ENM_HEAD,				// T	wbh{
	K7ENM_JAIA,				// U	WCAg
	K7ENM_ROLL,				// V	[O
	K7ENM_URUM,				// W	EC_
	K7ENM_CERA,				// X	Z~bN
	K7ENM_BROK,				// Y	u[N
	K7ENM_BLHS,				// Z	ubNwuX}C
	K7ENM_TIME,				// TIM	^C}[
	K7ENM_GYAR,				// GYA	MNeBJ
	K7ENM_SPIR,				// SPI	XpC
	K7ENM_MYSL,				// MYS	~X
	K7ENM_TEN,				// ~NiFVgj
	K7ENM_FDAN,
	K7ENM_FCAT,
	K7ENM_FKED,
	K7ENM_FCYO,
	K7ENM_FMSK,
	K7ENM_FKVN,
	K7ENM_FHAC,
	K7ENM_FGAL,
	K7ENM_SPD,
	K7ENM_HSLASER,
#if FUJITA
	K7ENM_ANG,
	K7ENM_KUN,
	K7ENM_KRR,
	K7ENM_KIB,
#endif
	K7ENM_KIS,
	K7ENM_DE2,
#if FUJITA
	K7ENM_UR2,
	K7ENM_FAN,
	K7ENM_HM1,
	K7ENM_HN2,
	K7ENM_HN3,
	K7ENM_HN4,
	K7ENM_HN5,
	K7ENM_HN6,
	K7ENM_HN8,
	K7ENM_HN9,
#endif
	K7ENM_AKN,
	K7ENM_CUR,
	K7ENM_HNG,
	K7ENM_AK2,
	
	K7ENM_NUM,
};

//
// [r[hc
//
enum{
	K7MOV_CLEMENCE = 0,
	K7MOV_CLOUDMAN,
	K7MOV_DRAGSTORE,
	K7MOV_GURAD,
	K7MOV_POSTMAN,
	K7MOV_TRACTOR,
	K7MOV_05100201,
	K7MOV_05100202,
	K7MOV_051002018,
	K7MOV_051002028,
	K7MOV_01010101,		//`
	K7MOV_04010101,		//KVAH
	K7MOV_04010201,		//n[}s
	K7MOV_04010203,		//T_[XEQp
	K7MOV_04040101,		//RXe
	K7MOV_04050101,		//_ƃVK[
	K7MOV_04050202,		//a
	K7MOV_04050301,		//g@[
	K7MOV_04060101,		//nT}o
	K7MOV_04060902,		//uo
	K7MOV_04070101,		//NQ[
};
// _[W^Cv
enum WK7NpcDamType{
	DAMTYPE_NORMAL=0		,				// _[Wm[}
	DAMTYPE_BOMBER			,				// {o[in`ɔzuĂnj
	DAMTYPE_DOWNATK			,				// iU
	DAMTYPE_DANSPATK		,				// _\͂
	DAMTYPE_COUNTER			,				// JE^[Ułiʏuԁj
	DAMTYPE_CATSPATK		,				// R\͂ir܂Łj
	DAMTYPE_KVNTAMEUCHI		,				// Pr̂߂
	DAMTYPE_CYOMUGNUM		,				// R[e}Oi
	DAMTYPE_GALPOWER		,				// KVAp[Abv̒e
	DAMTYPE_DANPOWER		,				// _ep[Abv̒e
	DAMTYPE_TIMERHSONLY		,				// ^C}[HSp
	DAMTYPE_GYARMISSILE		,				// MNeBJ̃~TCɃqbgp
	DAMTYPE_GRENADE_FIRE	,				// Ol[hij
	DAMTYPE_GRENADE_THUND	,				// Ol[hidj
	DAMTYPE_GRENADE_GRAVI	,				// Ol[hid́j
	DAMTYPE_GRENADE_FINAL	,				// Ol[hit@Cij
	DAMTYPE_KVNFRONTSHOT	,				// PrOVbg
};
// Vbg[h̃tOiǉWK7HitObj.hWK7HitObjInfoTypeǉ
enum WK7PcShotMode{
	SHOTMODE_CLEAR=0,			// 
	SHOTMODE_NORMALSHOT,		// ʏ̂
	SHOTMODE_DANSPATK,			// _\
	SHOTMODE_KVNTAMEUCHI,		// Pr^E`
	SHOTMODE_CYOMAGNUM,			// R[e}Oi
	SHOTMODE_GALPOWER,			// KVAp[Abv̒e
	SHOTMODE_DANPOWER,			// _ep[Abv̒e
	SHOTMODE_GRENADE_FIRE	,	// }XNOl[h
	SHOTMODE_GRENADE_THUND	,	// }XNd
	SHOTMODE_GRENADE_GRAVI	,	// }XNk
	SHOTMODE_KVNCHARGEALL	,	// PrOʃVbg
	SHOTMODE_MSKCHARGEALL	,	// }XNSʃVbg
};
// qbgIuWF̃_[W^Cv
enum WK7HitObjInfoType{
	WK7HITOBJINFO_TYPE_NORMALSHOT = 0,		// ʂ̎ˌ
	WK7HITOBJINFO_TYPE_DANCHARGE,			// _̃^E`
	WK7HITOBJINFO_TYPE_KVNCHARGE,			// Pr̃^E`
	WK7HITOBJINFO_TYPE_CYOMAGNUM,			// R[e}Oi
	WK7HITOBJINFO_TYPE_GALPOWER,			// KVAp[Abv̒e
	WK7HITOBJINFO_TYPE_DANPOWER,			// _ep[Abv̒e
	WK7HITOBJINFO_TYPE_GRENADE_FIRE	,		// }XNOl[h
	WK7HITOBJINFO_TYPE_GRENADE_THUND,		// }XNd
	WK7HITOBJINFO_TYPE_GRENADE_GRAVI,		// }XNk
	WK7HITOBJINFO_TYPE_KVNCHARGEALL	,		// PrOʃVbg
	WK7HITOBJINFO_TYPE_MSKCHARGEALL	,		// }XNSʃVbg
};


// PGAł̓G̍ő吔
#define ONE_AREA_MAXENEMY		(10)

#endif	//__K7ID_H__

