////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Bullet Object
//
// WK7Bullet.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/18/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7BULLET_H__
#define	__WK7BULLET_H__

#if 0

//#include <sysdolphin\baselib.h>
#include "..\Lib\ghmGcDefine.h"
#include ".\WK7Obj.h"
#include "..\Fujita\C_SceneDesc.h"
#include "..\Fujita\C_JObj.h"
#include "..\Fujita\C_Particle.h"

//
// Bullet Task
//
class WK7Bullet : public WK7RenderObj{
protected:
	// fp
static	void					*mpArchive;
	C_SceneDesc					*mpScene;
	C_JObj						*mpJObj;
	
	Vec							mPosition;
	Vec							mVelocity;
	int							mState;
	int							mCount;
	float						mScale;
	
	// p[eBNp
	C_Generator					*mpGenerator;
	C_JObj						*mpParticleObj;
	
	WK7Bullet();
public:
	WK7Bullet(WK7Obj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	virtual ~WK7Bullet();
	
	// 
//	virtual bool Initialize(void);
	
	// I
//	virtual bool Terminate(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
	
	// ʒuݒ
	inline void SetPosition(const Vec &pos){ mPosition = pos; }
	inline void GetPosition(Vec &pos){ pos = mPosition; }
	
	// xݒ
	inline void SetVelocity(const Vec &vel){ mVelocity = vel; }
	inline void GetVelocity(Vec &vel){ vel = mVelocity; }
	
};

#endif

#endif	//__WK7BULLET_H__

