////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Effect
//
// WK7Effect.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/10/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7EFFECT_H__
#define	__WK7EFFECT_H__

//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"
#include ".\WK7Anim.h"

class WK7Fade{
public:
	enum State{
		IDLE = 0,
		FADE
	};
	enum Type{
		BLEND_TYPE,
		ADD_TYPE,
	};
protected:
	static Mtx				mView;
	static Mtx44			mProj;
	GXColor					mMatColor;
	WK7AnimLinear			mAlpha;
	Type					mType;
public:
	WK7Fade();
	~WK7Fade(){}
	
	static bool Initialize(void);
	
	bool FrameProcess(void);
	bool RenderProcess(void);			// JQcpɃZbgĂKv
	
	void SetColor(u32 color);
	void Start(u32 alpha,u32 time);
	void Start(u32 alpha,u32 color,u32 time);
	State GetState(void);
	u32 GetColor(void);
	
	bool SetType(Type type);
	inline Type GetType(void){ return mType; }
	
};

extern	WK7Fade			gMask;

#endif	//__WK7EFFECT_H__

