////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// WK7Enemy.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/15/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7ENEMY_H__
#define	__WK7ENEMY_H__

//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"
#include ".\WK7Chara.h"
#include ".\WK7Obj.h"
#include ".\WK7Npc.h"
#include ".\WK7GameInfo.h"
#include ".\K7ID.h"
#include "..\Matsu\mK7Sound.h"

//
// Enemy Object
//
class WK7Enemy : public WK7Npc{
protected:
	s16						mHP;					// ̗
	
	WK7Enemy();				// ftHgRXgN^֎~
	WK7Enemy(u32 enemyid,ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~WK7Enemy();
	
	inline WK7Enemy* GetPrev(void){ return (WK7Enemy *)ghmGcListObj::GetPrev(); }
	inline WK7Enemy* GetNext(void){ return (WK7Enemy *)ghmGcListObj::GetNext(); }
	
	inline void SetHP(s16 hp){ mHP = hp; }
	inline s16 GetHP(void){ return mHP; }
	
//	static WK7Enemy* Create(u32 enemyid,u32 stgid,u32 param=0);
	static WK7Enemy* Find(u32 enemyid,u32 stgid=0xffffffff,u32 param=0);
	static bool ReleaseStageEnemy(u32 stgid);
	
};

#ifdef __WK7ENEMY_CPP__


#else



#endif

#endif	//__WK7ENEMY_H__

