////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Motion
//
// WK7Motion.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/08/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7MOTION_H__
#define	__WK7MOTION_H__

//#include "..\Lib\ghmGcDefine.h"
#include ".\WK7Obj.h"
#include ".\WK7SceneDesc.h"
//#include ".\WK7Define.h"

// lp[VʃCfbNX
enum{
	WK7MOTION_PCCMN_STAND = 0,				// R
	WK7MOTION_PCCMN_WAIT1,					// ҋ@[VP
	WK7MOTION_PCCMN_WAIT2,					// ҋ@[VP
	WK7MOTION_PCCMN_WALK,					// 
	WK7MOTION_PCCMN_RUNSTART,				// n
	WK7MOTION_PCCMN_RUN,					// 
	WK7MOTION_PCCMN_TURN,					// ^[
	WK7MOTION_PCCMN_QUICKTURN,				// NCbN^[
	WK7MOTION_PCCMN_SHOTPOSE,				// ˌ\
	WK7MOTION_PCCMN_SHOTFREE,				// ˌR
	WK7MOTION_PCCMN_SHOTNOW,				// ˌ
	WK7MOTION_PCCMN_SHOTNOW_LONG,			// ˌiY[pAȂ́j
	WK7MOTION_PCCMN_SHOTWAIT,				// ˌEGCg
	WK7MOTION_PCCMN_RELOAD,					// [h
	WK7MOTION_PCCMN_RELOAD_FROMSTAND,		// [hiʏ펩R̂j
	WK7MOTION_PCCMN_DOWNATK,				// _EU
	WK7MOTION_PCCMN_SPATK,					// \͍U(SP Attack)
	WK7MOTION_PCCMN_SPATK2,					// \͍UQ(SP Attack)
	WK7MOTION_PCCMN_DMG_F,					// _[WO
	WK7MOTION_PCCMN_DMG_L,					// _[W
	WK7MOTION_PCCMN_DMG_R,					// _[WE
	WK7MOTION_PCCMN_DMG_B,					// _[W
	WK7MOTION_PCCMN_DIE_F,					// œ|O
	WK7MOTION_PCCMN_DIE_B,					// œ|
	WK7MOTION_PCCMN_WALK_STAIRS_UP,			// KiA
	WK7MOTION_PCCMN_WALK_STAIRS_DOWN,		// KiA
	WK7MOTION_PCCMN_RUN_STAIRS_UP,			// KiA
	WK7MOTION_PCCMN_RUN_STAIRS_DOWN,		// KiA
	WK7MOTION_PCCMN_KERENMI,				// ݍUiUj
	WK7MOTION_PCCMN_TAME,					// ^E`
	WK7MOTION_PCCMN_TAMEGO,					// ^E`
	WK7MOTION_PCCMN_ESCAPE,					// ݔ
	WK7MOTION_PCCMN_MAX,				// obʃ[V
};

enum{
	WK7MOTION_PCCMN_CAM_KERENMI = WK7MOTION_PCCMN_MAX,	// ݗpJ[V
	WK7MOTION_PCCMN_CAM_DOWNATK,						// _EUpJ[V
	WK7MOTION_PCCMN_CAM_RELOAD,							// [hpJ[V
	WK7MOTION_PCCMN_CAM_CHARGEALL,						// `[WVbgOʌnJ[V
	WK7MOTION_PCCMN_TOTAL_MAX
};

#define WK7MOTION_PC_CAMNUM			(WK7MOTION_PCCMN_TOTAL_MAX-WK7MOTION_PCCMN_MAX)

// mobp[VʃCfbNX
enum{
	WK7MOTION_NPCCMN_STAND = 0,				// R
	WK7MOTION_NPCCMN_WALK,					// 
	WK7MOTION_NPCCMN_RUN,					// 
	WK7MOTION_NPCCMN_TURN_R,				// ^[E
	WK7MOTION_NPCCMN_TURN_L,				// ^[
	WK7MOTION_NPCCMN_TURN_B,				// ^[
	WK7MOTION_NPCCMN_ATKREQ,				// UĂѓiNu쓮j
	WK7MOTION_NPCCMN_ATK85,					// 85cmɍU
	WK7MOTION_NPCCMN_ATK150,				// 150cmɍU
	WK7MOTION_NPCCMN_DMG_HEAD_F,			// _[WO
	WK7MOTION_NPCCMN_DMG_HEAD_B,			// _[W
	WK7MOTION_NPCCMN_DMG_BODY_F,			// _[WO
	WK7MOTION_NPCCMN_DMG_BODY_B,			// _[W
	WK7MOTION_NPCCMN_DMG_RFOOT_F,			// _[WEO
	WK7MOTION_NPCCMN_DMG_RFOOT_B,			// _[WE
	WK7MOTION_NPCCMN_DMG_LFOOT_F,			// _[WO
	WK7MOTION_NPCCMN_DMG_LFOOT_B,			// _[W
	WK7MOTION_NPCCMN_DMG_RSIDE_F,			// _[WEgO
	WK7MOTION_NPCCMN_DMG_RSIDE_B,			// _[WEg
	WK7MOTION_NPCCMN_DMG_LSIDE_F,			// _[WgO
	WK7MOTION_NPCCMN_DMG_LSIDE_B,			// _[Wg
	WK7MOTION_NPCCMN_DMG_BLOW_F,			// _[WӂƂу_EOiSj
	WK7MOTION_NPCCMN_DMG_BLOW_B,			// _[Wу_EiSj
	WK7MOTION_NPCCMN_DMG_RFOOTLOST,			// _[WE _E
	WK7MOTION_NPCCMN_DMG_LFOOTLOST,			// _[W _E
	WK7MOTION_NPCCMN_DOWN_FREE,				// _ER
	WK7MOTION_NPCCMN_DOWN_DMG,				// _E_[W
	WK7MOTION_NPCCMN_DOWN_WALK,				// _EȂ
	WK7MOTION_NPCCMN_DOWN_RUN,				// _EȂ瑖
	WK7MOTION_NPCCMN_DOWN_DIE,				// _E玀S
	WK7MOTION_NPCCMN_DOWN_ATK85,			// _E85cmɍU
	WK7MOTION_NPCCMN_DOWN_ATK150,			// _E150cmɍU
	WK7MOTION_NPCCMN_ATK_LASER,				// [U[ōU
	WK7MOTION_NPCCMN_HS_EXTPOP,				// gro[V݂ꍇ
	WK7MOTION_NPCCMN_HSLASER_SINK,			// [U[grB
	WK7MOTION_NPCCMN_SPD_WAIT,				// ꎩR̂̂QiXs[hpj
	WK7MOTION_NPCCMN_SPD_MOVESTART,			// Xs[hX}CsJn
	WK7MOTION_NPCCMN_SPD_EGG,				// Xs[hX}C
	WK7MOTION_NPCCMN_KERENMI_DAN,			// ݍUi_j
	WK7MOTION_NPCCMN_KERENMI_CAT,			// ݍUiRj
	WK7MOTION_NPCCMN_KERENMI_KED,			// ݍUiJGfj
	WK7MOTION_NPCCMN_KERENMI_CYO,			// ݍUiR[ej
	WK7MOTION_NPCCMN_KERENMI_MSK,			// ݍUi}XNj
	WK7MOTION_NPCCMN_KERENMI_KVN,			// ݍUiPrj
	WK7MOTION_NPCCMN_CEIL_WAIT,				// iAiU[X}CpjV䒣tҋ@
	WK7MOTION_NPCCMN_CEIL_WALK,				// iAiU[X}CpjVA
	WK7MOTION_NPCCMN_CEIL_RUN,				// iAiU[X}CpjVA
	WK7MOTION_NPCCMN_CEIL_DMG,				// iAiU[X}CpjVA
	WK7MOTION_NPCCMN_CEIL_FALLWAIT,			// iAiU[X}CpjVA󒆗R
	WK7MOTION_NPCCMN_CEIL_FALLEND,			// iAiU[X}CpjVA󒆗`nA͂
	WK7MOTION_NPCCMN_DMG_R_ROLL,			// _[WE]
	WK7MOTION_NPCCMN_DMG_L_ROLL,			// _[W]
	WK7MOTION_NPCCMN_EXT_PARTS,				// p[cAj[Vp
	WK7MOTION_NPCCMN_OKIAGARI_F,			// ]rpNオO
	WK7MOTION_NPCCMN_OKIAGARI_B,			// ]rpNオ
	WK7MOTION_NPCCMN_STD_NUM,				// 
};
enum{
	WK7MOTION_NPCCMN_EXT_EGG_HAKI = WK7MOTION_NPCCMN_STD_NUM,				// f
	WK7MOTION_NPCCMN_EXT_EGG_HAKARE,			// f
	WK7MOTION_NPCCMN_EXT_EGG_WAIT,				// R
	WK7MOTION_NPCCMN_EXT_EGG_WALK,				// ]
	WK7MOTION_NPCCMN_NUM,					// mobʃ[V
};


// Aj[VĐ[giAj[Vf[^UOt̃f[^ƂčĂ邽߁j
#define	WK7MOTION_DEFAULT_RATE			(60.0f / (f32)WK7_FRAME_RATE)

inline const char* GetDescName(const HSD_MatAnim* matanim)
{
	return _GetDescName( (char**)matanim );
}

inline const char* GetDescName(const HSD_MatAnimJoint* desc)
{
	return _GetDescName( (char**)desc );
}

inline const char* GetDescName(const HSD_ShapeAnimJoint* desc)
{
	return _GetDescName( (char**)desc );
}

// 
struct WK7MotionAttr{
	u32						mMotionID;				// [Vhc
//	union{
//		struct{
//			u32				mLoop    : 1;			// [v[V
//			u32				mMove    : 1;			// ړ[V
//			u32				mAttrPad :30;
//		};
		u32					mAttr;					// 
//	};
};
#define	WK7MOTIONATTR_DECL(motid,flag)			{ (motid) , (flag) }

#define	WK7MOTIONATTR_NOATTR					(0x00000000)
#define	WK7MOTIONATTR_LOOP						(0x80000000)
#define	WK7MOTIONATTR_MOVE						(0x40000000)

#ifndef	__WK7MOTION_CPP__
extern	WK7MotionAttr	WK7MotionAttrTable[];
#endif


class WK7Archive;
struct WK7SdExpInfo;

//
// Motion
//
class WK7Motion : public WK7SmallMemObj{
	friend class WK7RenderObj;
protected:
	WK7Archive		*mpArchive;
	static f32		mWholeMotionRate;
	
	WK7Motion();		// ftHgRXgN^֎~
	WK7Motion(WK7Archive *pArchive);
	virtual ~WK7Motion();
	
public:
	bool ReleaseReference(void);
	WK7SdExpInfo* GetSdExpInfo(void);
	
	static bool SetMotionRate(HSD_AObj *pAObj,f32 rate,bool wholeRateEnable=true);
	static f32 ConvMotionRate(f32 rate);
	
	static bool SetWholeMotionRate(f32 rate=1.0f);
	inline static f32 GetWholeMotionRate(void){ return mWholeMotionRate; }
};

#define	WK7MODELMOTIONTYPE_NORM			(0x00000001)
#define	WK7MODELMOTIONTYPE_MAT			(0x00000002)
#define	WK7MODELMOTIONTYPE_SHAPE		(0x00000004)
#define	WK7MODELMOTIONTYPE_ALL			(WK7MODELMOTIONTYPE_SHAPE|WK7MODELMOTIONTYPE_MAT|WK7MODELMOTIONTYPE_NORM)

class WK7ModelMotion : public WK7Motion{
	friend class WK7Archive;
protected:
	u32							mType;
	union{
		struct{
			u32					mLoop    : 1;			// [v[V
			u32					mMove    : 1;			// ړ[V
			u32					mAttrPad :30;
		};
		u32						mAttr;					// 
	};
	
	WK7ModelMotion();		// ftHgRXgN^֎~
	WK7ModelMotion(WK7Archive *pArchive);
public:
	virtual ~WK7ModelMotion();
	
	inline static const char* GetAnimJointName(HSD_AnimJoint *pAnimJoint){ return GetDescName(pAnimJoint); }
	inline static const char* GetMatAnimJointName(HSD_MatAnimJoint *pMatAnimJoint){ return GetDescName(pMatAnimJoint); }
	inline static const char* GetShapeAnimJointName(HSD_ShapeAnimJoint *pShapeAnimJoint){ return GetDescName(pShapeAnimJoint); }
	C_ModelSet* GetAnimModelSet(const char *pName);
	
	static HSD_AnimJoint* GetAnimJoint(const char *pName,HSD_AnimJoint *pAnimJoint,bool next=true,bool child=true);
	static HSD_MatAnimJoint* GetMatAnimJoint(const char *pName,HSD_MatAnimJoint *pMatAnimJoint,bool next=true,bool child=true);
	static HSD_ShapeAnimJoint* GetShapeAnimJoint(const char *pName,HSD_ShapeAnimJoint *pShapeAnimJoint,bool next=true,bool child=true);
	bool GetAnimJoint(const char *pName,HSD_AnimJoint      **ppAnimJoint     =NULL,
	                                    HSD_MatAnimJoint   **ppMatAnimJoint  =NULL,
	                                    HSD_ShapeAnimJoint **ppShapeAnimJoint=NULL);
	bool GetAnimJoint(int index        ,HSD_AnimJoint      **ppAnimJoint     =NULL,
	                                    HSD_MatAnimJoint   **ppMatAnimJoint  =NULL,
	                                    HSD_ShapeAnimJoint **ppShapeAnimJoint=NULL);
	static bool GetAnimJoint(C_ModelSet *pModelSet,HSD_AnimJoint      **ppAnimJoint     =NULL,
	                                               HSD_MatAnimJoint   **ppMatAnimJoint  =NULL,
	                                               HSD_ShapeAnimJoint **ppShapeAnimJoint=NULL);
	static bool GetAnimExist(C_ModelSet *pModelSet);
	
	static f32 GetTotalMotionFrame(HSD_AnimJoint *pAnimJoint,bool next=true,bool child=true);
	static f32 GetTotalMotionFrame(HSD_MatAnimJoint *pMatAnimJoint,bool next=true,bool child=true);
	static f32 GetTotalMotionFrame(HSD_ShapeAnimJoint *pShapeAnimJoint,bool next=true,bool child=true);
	
	f32 GetTotalAllMotionFrame(int index=-1,bool next=true,bool child=true);
	f32 GetTotalMotionFrame(int index=-1,bool next=true,bool child=true);
	f32 GetTotalMatMotionFrame(int index=-1,bool next=true,bool child=true);
	f32 GetTotalShapeMotionFrame(int index=-1,bool next=true,bool child=true);
	
	int GetModelSetNum(void);
	int GetAnimJointNum(void);
	int GetMatAnimJointNum(void);
	int GetShapeAnimJointNum(void);
	
	inline u32 GetType(void){ return mType; }
	
	inline bool GetLoop(void){ return mLoop? true : false; }
	inline bool GetMove(void){ return mMove? true : false; }
	inline u32 GetAttr(void){ return mAttr; }
	
	static WK7MotionAttr* GetAttr(u32 motid);
};

class WK7CameraMotion : public WK7Motion{
	friend class WK7Archive;
protected:
	
	WK7CameraMotion();		// ftHgRXgN^֎~
	WK7CameraMotion(WK7Archive *pArchive);
public:
	virtual ~WK7CameraMotion();
	
	f32 GetTotalMotionFrame(int index=-1);
	
	static int GetAnimNum(WK7Archive *pArchive);
	static HSD_CameraAnim* GetAnim(WK7Archive *pArchive,int index);
	static HSD_CameraAnim* GetAnim(WK7Archive *pArchive,const char *pName);
	static const char* GetAnimName(WK7Archive *pArchive,int index);
	
	inline int GetAnimNum(void){ return GetAnimNum(mpArchive); }
	inline HSD_CameraAnim* GetAnim(int index){ return GetAnim(mpArchive,index); }
	inline HSD_CameraAnim* GetAnim(const char *pName){ return GetAnim(mpArchive,pName); }
	inline const char* GetAnimName(int index){ return GetAnimName(mpArchive,index); }
};

class WK7LightMotion : public WK7Motion{
	friend class WK7Archive;
protected:
	
	WK7LightMotion();		// ftHgRXgN^֎~
	WK7LightMotion(WK7Archive *pArchive);
public:
	virtual ~WK7LightMotion();
	
	f32 GetTotalMotionFrame(int index=-1);
	
	int GetAnimNum(void);
	HSD_LightAnim* GetAnim(int index);
	HSD_LightAnim* GetAnim(const char *pName);
	static HSD_LightAnim* GetAnim(C_LightSet *pLightSet);
	const char* GetAnimName(int index);
};


#endif	//__WK7MOTION_H__

