////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Sprite
//
// WK7Sprite.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 05/28/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7SPRITE_H__
#define	__WK7SPRITE_H__

#include "..\Matsu\MK7Sprite.h"

//
// Sprite Class
//
class WK7Sprite : public mK7Sprite{
protected:
public:
	WK7Sprite(int prio=SPRT_PRI_NORMAL);
	virtual ~WK7Sprite();
};

class WK7SpriteT2 : public WK7Sprite{
protected:
	stTexture		*mppTex[2];
public:
	WK7SpriteT2(int prio=SPRT_PRI_NORMAL);
	virtual ~WK7SpriteT2();
	
	static void SetVtxTC0TA1(void);
	static void SetTevTC0TA1(void);
	virtual void mCallRenderProc(void);
	
	inline bool RelateTex(int index,stTexture *pTex){ if( index < 0 || index >= 2 ){ return false; } mppTex[index]=pTex; return true; }
	inline stTexture* GetTex(int index){ if( index < 0 || index >= 2 ){ return NULL; } return mppTex[index]; }
};

#endif	//__WK7SPRITE_H__

