///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7Break
//
// YK7Break.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/30/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7BREAK
#define __YK7BREAK

// include --------------------------------------
//#include <dolphin.h>
//#include <sysdolphin\baselib.h>
#include "../Wat/WK7Model.h"

// define ---------------------------------------

#define MAX_LENGTHOBJNUM		(40)
#define MAX_MESHINFONUM			(100)

// datatype -------------------------------------

// _vpŎgpf[^\
typedef struct tagLENGTHLISTCHIP LENGTHLISTCHIP ;
struct tagLENGTHLISTCHIP
{
	f32 Length ;						// 
	WK7JObj *JObj ;						// _܂ JObj
	s32 Number ;						// JObj ̒_io[
	
	LENGTHLISTCHIP *Next, *Back ;	// ̃oւ̃|C^
} ;

// _vpŎgpf[^\
typedef struct tagLENGTHLIST
{
	s32 Num ;				// 
	s32 MaxNum ;			// ő吔
	Vec Point ;				// rW
	
	WK7JObj *JObj ;			//  JObj
	s32 PointCounter ;		//  JObj ̒_JE^[

	LENGTHLISTCHIP Chip[MAX_LENGTHOBJNUM] ;	// pɎgp`bv
	LENGTHLISTCHIP *LastChip ;				// Ō̃`bv
} LENGTHLIST ;

// UVWf[^^
typedef struct tagUV
{
	f32 u, v ;
} UV ;

// bVf[^\
typedef struct tagMESH
{
	u8 BigMemFlag ;				// 傫̈gpĂ邩ǂ̃tO

	struct tagMESH *Next ;		// ̃bVf[^ւ̃AhX

	HSD_JObj *JObj ;			// ̃bVf[^̐eł HSD_JObj ւ̃|C^
	HSD_PObj *PObj ;			// ̃bVf[^ւ̃|C^
	u8 *PNMtxIndex ;			// _@ɑ΂čss̃CfbNXzւ̃|C^

	u16 PointNum ;				// _Wf[^̐
	Vec *Point ;				// _Wւ̃|C^
	u16 *PointIndex ;			// _WCfbNXf[^ւ̃|C^

	u16 ColorNum ;				// Ff[^̐
	u32 *Color ;				// Fւ̃|C^
	u16 *ColorIndex ;			// FCfbNXf[^ւ̃|C^

	u16 UvNum ;					// UVf[^̐
	UV *Uv ;					// UVWւ̃|C^
	u16 *UvIndex ;				// UVCfbNXf[^ւ̃|C^

	u16 NormalNum ;				// @f[^̐	
	Vec *Normal ;				// @ւ̃|C^
	u16 *NormalIndex ;			// @CfbNXf[^ւ̃|C^

	u16 IndexStride ;			// P_̂Ƃ̃XgChTCY
	u16 IndexDataNum ;			// _CfbNXf[^̐
	GXPrimitive PrimitiveType ;	// v~eBũ^Cv(Op`XgAXgbvA)
} MESH ;

// ȈՃbVf[^p_f[^
typedef struct tagBASVERT
{
	Vec Point ;				// Wf[^
	Vec Normal ;			// @
	UV Uv ;					// eNX`W
	u32 Color ;				// F
} BASVERT ;

// ȈՃbVf[^\
typedef struct tagBASICMESH
{
	u8 BigMemFlag ;				// 傫̈gpĂ邩ǂ̃tO

	HSD_JObj *JObj ;			// bV]Ă HSD_JObj ւ̃|C^(̃{[ΉĂԃEGCg̍{[ɏ])
	GXPrimitive PrimitiveType ;	// v~eBũ^Cv(Op`XgAXgbvA)
	struct tagBASICMESH *Next ;	// ̒_f[^ւ̃|C^
	u16 VertexNum ;				// _f[^̐
//	BASVERT *Vert ;				// _f[^zւ̃|C^
	void *VertexData ;			// _f[^zւ̃|C^
	Vec *Point ;				// Wf[^ւ̃|C^
	Vec *Normal ;				// @f[^ւ̃|C^
	UV *Uv ;					// eNX`Wւ̃|C^
	u32 *Color ;				// Ff[^ւ̃|C^
	u16 Stride ;				// f[^Ƃ̊Ԋu
	u16 IndexNum ;				// _CfbNX̐
	u16 *Index ;				// _CfbNXz
} BASICMESH ;

// ff[^\
typedef struct tagMODEL MODEL ;
struct tagMODEL
{
	u8 BigMemFlag ;				// 傫̈gpĂ邩ǂ̃tO

	HSD_JObj *JObj ;			// ƂȂ JObj

	MESH *Mesh ;				// ̃{[ł̃bVf[^
	MODEL *next, *child ;		// ̃fƎq̃f
} ;

// ȈՃff[^\
typedef struct tagBASICMODEL BASICMODEL ;
struct tagBASICMODEL
{
	u8 BigMemFlag ;				// 傫̈gpĂ邩ǂ̃tO

	HSD_JObj *JObj ;			// ƂȂ JObj

	BASICMESH *BasMesh ;		// ̃{[ł̊ȈՃbVf[^
	BASICMODEL *next, *child ;	// ̊ȈՃfƎq̊ȈՃf	
} ;

// _|C^Xg\
typedef struct tagPOSINDEXPOINTLIST
{
	s32 PolyPointNum ;
	Vec **PolyPoint ;
	u8 UseBigMem ;
} POSINDEXPOINTLIST ;

// ͂bVf[^̏
typedef struct tagMESHINFO
{
	s32 UseCounter ;				// ̃f[^gpĂGtFNg̐
	HSD_DObj *dobj ;				// ǂꂩ JObj ɑĂꍇ̏]Ă JObj
	HSD_PObj *pobj ;				// ǂꂩ JObj ɑĂꍇ̏]Ă PObj
	MESH *Mesh ;					// ǂꂩ JObj ɑĂꍇ JObj ̃bV̓f[^
} MESHINFO ;

// bVǗ
typedef struct tagMESHMANAGE
{
	MESHINFO MeshInfo[MAX_MESHINFONUM] ;
} MESHMANAGE ;

// _ǔpf[^\
typedef struct tagVERTEXHOMING
{
	MESH *Mesh ;			// ǔ钸_܂ރbṼ|C^
	s32 MeshID ;			// ǔ钸_܂ރbV̂hc
	u32 VertexNumber ;		// ǔ钸_܂ރbV̒ǔ钸_̃CfbNX
} VERTEXHOMING ;

// prototype ------------------------------------

extern s8 CreatePrimitiveMeshData( HSD_JObj *JObj, HSD_DObj *DObj, HSD_PObj *PObj, MESH **MeshBuf,
									u8 UseNormalFlag, u8 UsePosFlag,
									s8 UseColorFlag, s8 UseUvFlag, u8 UseBigMem, u8 DObjNextFlag = TRUE, u8 PObjNextFlag = TRUE ) ;	// sysdolphin ̃v~eBuf[^璸_f[^擾( 0:  }CiXl:G[ )
extern s8 DeletePrimitiveMeshData( MESH *Mesh, u8 NextFlag = TRUE ) ;				// bVf[^̌ns
extern s8 DismemberPrimitiveMeshData( MESH *Src, BASICMESH **Dest ) ;							// bVf[^ɕf[^쐬


extern s8 CreateBasicPrimitiveMeshData( MESH *Src, BASICMESH **Dest,
										 u8 TransformFlag, u8 UseNormalFlag,
										 u8 PosOnlyFlag, u8 UseBigMem, u8 NextFlag = TRUE ) ;		// bVf[^ɊȈՃbVf[^쐬( ( 0:  }CiXl:G[ ) UseNormalFlag  PosOnlyFlag D悳 UseNormalFlag == FALSE  @ȊOׂ͂ď )
extern s8 DeleteBasicMeshData( BASICMESH *BasMesh, u8 NextFlag = TRUE ) ;				// ȈՃbVf[^̌ns


extern s8 CreateModelData( HSD_JObj *JObj, MODEL **Model, u8 HideCheck,
							u8 NextFlag, u8 ChildFlag, u8 UseBigMem ) ;				// WK7JObj 烂ff[^쐬( Next  TRUE ̏ꍇ Child ͎I TRUE ɂȂ )( 0:  -1:s )
extern s8 DeleteModelData( MODEL *Model ) ;											// ff[^̌ns
extern s8 CreateBasicModelData( MODEL *Src, BASICMODEL **Dest, u8 HideCheck, u8 UseBigMem,
							u8 NextFlag = TRUE, u8 ChildFlag = TRUE ) ;				// MODEL ȈՃff[^쐬( Next  TRUE ̏ꍇ Child ͎I TRUE ɂȂ )
extern s8 DeleteBasicModelData( BASICMODEL *BasModel ) ;							// ȈՃff[^̌ns


extern s32 ScanBasicModelMesh( BASICMODEL *BasModel, s8 (*CallBack)( BASICMESH *BasMesh, void *Data ), void *Data ) ;	// ȈՃf̊ȈՃbVSđ
extern s32 ScanBasicModelPrimitive( BASICMODEL *BasModel, s8 (*CallBack)( Vec **Point, void *Data ), void *Data ) ;		// ȈՃf̃|SSđ
extern s32 ScanModelPrimitive( MODEL *Model, s8 (*CallBack)( Vec **Point, void *Data ),
								void *Data ) ;								// f̃|Sׂđ
extern s32 ScanMeshPrimitive( BASICMESH *BasicMesh,	s8 (*CallBack)( Vec **Point, void *Data ),
								void *Data, POSINDEXPOINTLIST *DestPIPList = NULL, POSINDEXPOINTLIST *ScanPIPList = NULL, u8 NextFlag = TRUE ) ;	// bV\Ă|SЂƂÂoē̊֐Ă
extern s32 ScanMeshVertex( BASICMESH *BasicMesh, s8 (*CallBack)( Vec *Point, void *Data ),	void *Data, s8 NextFlag = TRUE ) ;		// bV\Ă钸_ÂoăR[obN֐Ă
extern s8 ScanPrimitiveJObj( WK7JObj *JObj,	void (*CallBack)( WK7JObj *JObj, void *Data ),
								void *Data, s8 NextFlag = TRUE ) ;			//  JObj Ɋ֘Âv~eBuf[^ׂĂ JObj XL


extern s32 GetBasicMeshPolygonNum( BASICMESH *BasicMesh ) ;			// ȈՃbVf[^ɑ݂Ă|S̐𐔂
extern f32 GetBasicMeshPolygonArea( BASICMESH *BasicMesh ) ;		// f̑ʐς𓾂
extern f32 GetModelPolygonArea( MODEL *Model ) ;					// f̑ʐς𓾂
extern s32 GetJObjMeshPolygonNum( HSD_JObj *JObj ) ;				// v~eBut JObj ɑ݂Ă|S̐𐔂
extern s8 GetHaveHopeNumberVertexPObj( HSD_JObj *JObj, u32 Number, u32 *HopeNumber, HSD_PObj **PObj, HSD_DObj **DObj ) ;	// w̔ԍ̒_f[^ PObj  DObj ̃AhX𓾂
extern s8 GetHopeNumberVertexPositionAndNormal( MESH *Mesh, u32 Number, Vec *PosBuf, Vec *NrmBuf, MtxPtr PosMtxBuf = NULL, MtxPtr NrmMtxBuf = NULL ) ;	// bVf[^̊]̒_ԍ̖@ƍW𓾂
extern inline f32 GetPolygonArea( Vec **Point ) ;					// |S̖ʐς𓾂
inline extern HSD_DObj *GetHaveMeshDObj( HSD_JObj *JObj ) ;				// bVĂŏ dobj 擾

// PObj ɑ݂Ă|S̐𐔂
//extern s32 GetPObjMeshPolygonNum( HSD_PObj *PObj, u8 NextFlag = TRUE ) ;


extern s8 CreateMatrixTable( HSD_JObj *JObj, HSD_PObj *PObj,
								Mtx *PosMtxTable, Mtx *NrmMtxTable ) ;						// bVf[^{Gx[vt JObj AWϊse[uƖ@ϊse[u쐬
extern s8 CreateLengthList( WK7JObj *JObj, Vec Point, LENGTHLIST *ListBuf, u8 Num ) ; 		// w̍Wɋ߂_bVƒ_ԍ֐
extern s8 CreatePosIndexPointList( BASICMESH *BasM, POSINDEXPOINTLIST *PIPList, u8 UseBigMem ) ;	// ȈՒ_f[^\̂璸_|C^Xgf[^쐬
extern s8 DeletePosIndexPointList( POSINDEXPOINTLIST *PIPList ) ;							// _|C^Xgf[^̌n

extern s32 MeshManageInit( void ) ;								// bVǗ
extern s32 MeshManageTerm( void ) ;								// bVǗ̌n
extern s32 CreateMeshData( WK7JObj *JObj, HSD_DObj *dobj, HSD_PObj *pobj ) ;	// dobj 烁bVf[^쐬
extern s32 ReleaseMeshData( s32 MeshID ) ;						// dobj 쐬bVf[^
extern MESHINFO *GetMeshData( s32 MeshID ) ;			// dobj ̃bVf[^擾

extern s8 CreateVertexHomingData( VERTEXHOMING *HomingBuf, WK7JObj *JObj, Vec Pos ) ;	// w̍WɈԋ߂_̏쐬
extern s8 ReleaseVertexHomingData( VERTEXHOMING *HomingBuf ) ;							// w̍WɈԋ߂_̏
extern s8 GetVertexHomingInfo( VERTEXHOMING *HomingBuf, Vec *PosBuf, Vec *NrmBuf ) ;	// _ǔ񂩂w̒_̐΍WƂ̓_̖@𓾂

#endif


