///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBlood
//
// YK7EffectBlood.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/19/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTBLOOD_H
#define __YK7EFFECTBLOOD_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7Break.h"

// define ---------------------------------------

#define BLOODPAT_ONELINENUM		2
#define BLOODPAT_NUM			(BLOODPAT_ONELINENUM*BLOODPAT_ONELINENUM)
#define BLOODONE_SIZE			( UVSCALE / BLOODPAT_ONELINENUM )

// Ԃ̎
enum
{
	BLOODTEX_BLOOD = 0,		// 
	BLOODTEX_ROSE = 1,		// o			ij		F		_
	BLOODTEX_NARCISSUS = 2,	// 			iȈj	FF		R
	BLOODTEX_GLADIOLUS = 3,	// OWIX	ij	FsN	JGf
	BLOODTEX_AYAME = 4,		// A		ij	Fi)	R[e
	BLOODTEX_STRELITZIA = 5,// Ɋy		iej	FIW	}XN
	BLOODTEX_BLACKLILY = 6,	// N		i􂢁j	F		PB

	BLOODTEX_LOTUS = 7,		// @			i_j	FF		n[}
	BLOODTEX_CAMELLIA = 8,	// 			íj	F		KVA
	BLOODTEX_NORMALFLOWER = 9,	// ʂ̉
	BLOODTEX_FEATHER = 10,	// H
	BLOODTEX_NUMBER = 11,	// 
	BLOODTEX_NUM = 12,
} ;

// datatype -------------------------------------

// GtFNgʃf[^
typedef struct tagBLOODUNION
{
	TEXDATA BloodTex[BLOODTEX_NUM] ;		// ̃eNX`
	TEXDATA BloodSmokeTex ;					// eNX`f[^
	
	u32 color1, color2 ;
	bool colorvalid ;

/*	TEXTURE BloodTex ;				// ̃eNX`f[^
	TEXTURE BloodSmokeTex ;			// eNX`f[^
	ghmGcFile *TexFileBlood ;		// ̃eNX`t@C ghmGcFile
	ghmGcFile *TexFileBloodSmoke ;	// ̃eNX`t@C ghmGcFile
*/
} BLOODUNION ;

// IuWFNgf[^
typedef struct tagBLOODOBJECT
{
	u8 UseFlag ;
	union					// W( ԏ:z=g嗦 )
	{
		struct
		{
			f32 x, y, z ;
		} ;
		Vec v ;
	} ;	
	f32 sx, sy, sz ;		// x( ԏ:sz= )
	f32 ssx, ssy, ssz ;		// x( ԏ:ssx,ssy=W ssz=g嗦 )
	s8 Type ;				// 0:ł錌Ad͕׎󂯂 1:ł錌Ad͕׎󂯂Ȃ 2: 3: 
	u16 /*Count,*/ FadeCount ;	// JE^[( ԏ:I_CfbNXl )
//	u8 Color ;				// ̋Px
	u8 Pattarn ;			// ̃p^[io[
	u16 Pu, Pv ;			// ̃p^[̃eNX`W
	union
	{
		u16 Cycle ;			// ̕ςꍇ̃^C~O
		struct
		{
			u8 TargetPos ;		// ڕWW̃CfbNX
			u8 EndFlag ;		// ̃t[ŏłtO
		} ;
	} ;
	u16 FadeOutTime ;		// tF[hAEg܂ł̎
	u8 FadeFlag ;			// tF[hAEgĂ邩ǂtO
	union
	{
		struct
		{
			f32 SinWidth ;			// Uꕝ̍ől( ԏ:ڕWWx )
			f32 SinSpeed ;			// U鑬x( ԏ:ڕWWy )
			s16 SRot, SSpeed ;
		} ;
		
		Vec mpos ;					// ڕWW̑΍W
	} ;
	u8 RotType ;					// ]px(0:0 1:90 2:180 3:270)
	f32 FadeY ;						// tF[hAEgx
	GXColor Color, Color1, Color2 ;	// F
} BLOODOBJECT ;

// GtFNgf[^
typedef struct tagBLOODEFFECT
{
	EFFECT *ConveEffect ;			// GtFNgւ̃|C^
	u32 ConveEffectID ;				// GtFNĝhc
	BLOODOBJECT *ObjP ;				// IuWFNgf[^zւ̃|C^
	u32 Counter ;					// JE^[
	
	s8 SoundFlag ;					// 炵tO

	Vec Point ;						// GtFNg̍W
	f32 Yuka ;						// ̍
	f32 MaxPower, MinPower ;		// GtFNg̔юU鐨(傫قǉ܂Ŕт܂)
	u32 BloodNum ;					// ̑
	u32 MoveDrawBloodNum ;
	u32 UnMoveDrawBloodNum ;
	u32 MoveBloodNum ;				// ł錌̐
	u32 FadeTime ;					// tF[hAEgn܂Ă̎
	u8 FadeFlag ;					// tF[hAEgn܂Ă邩tO
	u8 PerspectiveFlag ;			// ϊsǂtO
	f32 NoGBlood ;					// d͂̉e󂯂Ȃ̗(1.0F:ׂĂ̌d͂̉e󂯂Ȃ 0.0F:ׂĂ̌d͂̉e󂯂)
	f32 DirIgnore ;					// w̕𖳎ČԊm(1.0F:ׂĂ̌w̕𖳎 0.0F:ׂĂ̌w֔̕)
	f32 Range ;						// w̕肸xA傫قǎw̕֍L͈͂ɔт܂B
	f32 BloodSize ;					// ̑傫
	u8 Mode ;						// [h(0:rxNgς郂[h 
									//			1:X[ɂȂ邪AxNgς炸Ad͂ʂɂ 
									//			2:X[ɂȂ炸Ad͂ʂɂ )
	u8 WaitTime ;					// ҂
	u16 FadeOutTime ;				// tF[hAEg܂ł̎
	u16 FadeRandTime ;				// tF[hAEg܂ł̎Ԃ̃_
	f32 SinWidth ;					// Uꕝ̍ől
	f32 SinSpeed ;					// U鑬x
	f32 FadeY ;						// tF[hAEgx
	u16 FadeSpeedTime ;				// tF[hAEg܂ł̎

	u16 SmokeNum ;					// ̐

	GXColor Color1_1, Color1_2, Color2 ;	// F
	u16 ColorMoveTime ;			// FڂςĂ
	s32 SoundID ;				// Ƃ̉
	f32 WindPower ;				// ̋
	u32 WindTime ;				// ̉eo܂ł̎
	
	EFFECT *MeshEffect ;		// bVGtFNg̃|C^

	u8 ConveFlag ;				// stO
	u8 ConveWaitTime ;			// zނ܂ő҂
	f32 ConvePower ;			// ͂̋
	
	u16 RotCounter ;			// ]JE^[
	u8 BloodTexNumber ;			// gpeNX`̃io[
} BLOODEFFECT ;

// GtFNgp\
typedef struct tagBLOODEFFECTINIT
{
	BLOODEFFECT *BloodEffect ;		// BLOODEFFECT \̂ւ̃|C^
	u32 Counter ;					// ̃JE^[
	u32 BloodNum ;					// P|ŠGtFNg
	
	Vec Point ;						// GtFNg̔[hW
	Vec Direction ;					// GtFNg̑S̓IȕxNg(PʃxNg)
	f32 MaxPower, MinPower ;		// GtFNg̔юU鐨(傫قǉ܂Ŕт܂)

	f32 NoGBlood ;					// d͂̉e󂯂Ȃ̗(1.0F:ׂĂ̌d͂̉e󂯂Ȃ 0.0F:ׂĂ̌d͂̉e󂯂)
	f32 DirIgnore ;					// w̕𖳎ČԊm(1.0F:ׂĂ̌w̕𖳎 0.0F:ׂĂ̌w֔̕)
	f32 Range ;						// w̕肸xA傫قǎw̕֍L͈͂ɔт܂B

	u8 Mode ;
	f32 dxz, doir ;					// 
	u16 FadeOutTime ;				// tF[hAEg܂ł̎
	u16 FadeRandTime ;				// tF[hAEg܂ł̎Ԃ̃_
	f32 SinWidth ;					// Uꕝ̍ől
	f32 SinSpeed ;					// U鑬x
	f32 FadeY ;

	GXColor Color1_1, Color1_2, Color2 ;	// F
	u16 ColorMoveTime ;			// FڂςĂ
	u8 ColorRand ;				// F̂Ԃ̍ől
	f32 SmokeRate ;				// ɂȂm
	u16 SmokeNum ;				// ̐
	f32 WindPower ;				// ̋
	u32 WindTime ;				// ̉eo܂ł̎
	u8 BloodTexNumber ;			// gp錌eNX`̔ԍ
} BLOODEFFECTINIT ;

// GtFNg^XNɓnf[^
typedef struct tagBLOODEFFECTTACKPARAM
{
	Vec Point ;					// GtFNg̔[hW
	Vec Direction ;				// GtFNg̑S̓IȕxNg(PʃxNg)
	f32 MaxPower, MinPower ;	// GtFNg̔юU鐨(傫قǉ܂Ŕт܂)
	u32 BloodNum ;				// ̌̐(800`1000łʂ̗ʂł)
	f32 Size ;					// юUn_W Point 痣ő咼
								// (lAԂł̗̌̍WӏɌł܂邱ƂɂȂ܂)
	f32 YukaY ;					// ̗AƔ肷鏰̍(̂Ƃ돰ɗǂ͂̒lĂ܂)
	u8 PerspectiveFlag ;		// ϊsǂtO
	f32 NoGBlood ;				// d͂̉e󂯂Ȃ̗(1.0F:ׂĂ̌d͂̉e󂯂Ȃ 0.0F:ׂĂ̌d͂̉e󂯂)
	f32 DirIgnore ;				// w̕𖳎ČԊm(1.0F:ׂĂ̌w̕𖳎 0.0F:ׂĂ̌w֔̕)
	f32 Range ;					// w̕肸xA傫قǎw̕֍L͈͂ɔт܂B
	f32 BloodSize ;				// ̑傫
	u8 Mode ;					// [h(0:rxNgς郂[h
								//			1:X[ɂȂ邪AxNgς炸Ad͂ʂɂ 
								//			2:X[ɂȂ炸Ad͂ʂɂ
								//			3:ӂӂ炵ȂYɔł )
	u8 WaitTime ;				// ҂
	u16 FadeOutTime ;			// tF[hAEg܂ł̎
	u16 FadeRandTime ;			// tF[hAEg܂ł̎Ԃ̃_
	f32 SinWidth ;				// Uꕝ̍ől
	f32 SinSpeed ;				// U鑬x
	f32 FadeY ;					// tF[hAEgx
	u16 FadeSpeedTime ;			// tF[hAEg܂ł̎
	
	GXColor Color1, Color2 ;	// F
	u16 ColorMoveTime ;			// FڂςĂ
	u8 ColorRand ;				// F̂Ԃ̍ől
	f32 SmokeRate ;				// ɂȂm
	s32 SoundID ;				// Ƃ̉
	f32 WindPower ;				// ̋
	u32 WindTime ;				// ̉eo܂ł̎
	
	u8 ConveFlag ;				// stO
	u8 ConveWaitTime ;			// zނ܂ő҂
	f32 ConvePower ;			// ͂̋
	u8 BloodTexNumber ;			// gp錌eNX`̔ԍ
} BLOODEFFECTTASKPARAM ;

typedef struct tagBLOODDEF
{
	f32 Length, Power, BloodNum, BloodSize ;
} BLOODDEF ;

// prototype ------------------------------------

extern s8 InitBloodData( void ) ;				// GtFNg̋ʃf[^
extern s8 CheckBloodData( void ) ;				// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndBloodData( void ) ;				// GtFNg̋ʃf[^n

//extern void BloodEffectTask( ghmGcTask *pTask ) ;							// GtFNg^XN

extern EFFECT *CreateVLossBloodEffect( HSD_JObj *JObj, Vec Direction,
									f32 MaxPower, f32 MinPower,
									u32 BloodNum, f32 YukaY, u8 PerspectiveFlag = TRUE,
									f32 NoGBlood = 0.1F, f32 DirIgnore = 1.0F / 20.0F,
									f32 Range = PI / 4.0F, f32 BloodSize = 0.44F,
									 u8 Mode = 0, u8 WaitTime = 0,
									u16 FadeOutTime = 600, u16 FadeRandTime = 40,
									f32 SinWidth = 1.0F, f32 SinSpeed = 0.1F,
									f32 FadeY = 10.0F, u16 FadeSpeedTime = FEED_TIME,
									GXColor Color1 = (GXColor){ 255,0,0 }, GXColor Color2 = (GXColor){0,0,0},
									u16 ColorMoveTime = FEED_TIME, u8 ColorRand = 0,
									f32 SmokeRate = 0.0F, s32 SoundID = -1,
									f32 WindPower = 9.0F, u32 WindTime = 30,
									u8 ConveFlag = FALSE, u8 ConveWaitTime = 10, f32 ConvePower = 1.0F,
									u8 BloodTexNumber = 0, u8 MeshFlag = TRUE, s32 Priority = -130 ) ;								// v~eBuf[^lGtFNg쐬
extern EFFECT *CreateBloodEffect( Vec Point, Vec Direction,
									f32 MaxPower, f32 MinPower,
									u32 BloodNum, f32 Size,
									f32 YukaY, u8 PerspectiveFlag = TRUE,
									f32 NoGBlood = 0.1F, f32 DirIgnore = 1.0F / 20.0F,
									f32 Range = PI / 4.0F, f32 BloodSize = 0.44F,
									 u8 Mode = 0, u8 WaitTime = 0, 
									u16 FadeOutTime = 600, u16 FadeRandTime = 40,
									f32 SinWidth = 1.0F, f32 SinSpeed = 0.1F,
									f32 FadeY = 10.0F, u16 FadeSpeedTime = FEED_TIME,
									GXColor Color1 = (GXColor){ 255,0,0 }, GXColor Color2 = (GXColor){0,0,0},
									u16 ColorMoveTime = FEED_TIME, u8 ColorRand = 0,
									f32 SmokeRate = 0.0F, s32 SoundID = -1,
									f32 WindPower = 9.0F, u32 WindTime = 30,
									u8 ConveFlag = FALSE, u8 ConveWaitTime = 10, f32 ConvePower = 1.0F,
									u8 BloodTexNumber = 0, s32 Priority = -130 ) ;					// ̃GtFNg쐬
extern s8 ReleaseBloodEffect( EFFECT *Effect ) ;					// ̃GtFNǧns
extern s8 MoveBloodEffect( EFFECT *Effect ) ;						// ̃GtFNgPt[
extern s8 DrawBloodEffect( EFFECT *Effect ) ;						// ̃GtFNg`悷

extern TEXTURE *GetBloodTex( u8 BloodTexNumber ) ;					// ̃eNX`擾
extern s8 GetBloodDefParam( Vec *Point, BLOODDEF *DefBuf ) ;		// ␳lZo 
extern s8 SetBloodColor( u32 color1, u32 color2 ) ;					// ̐Fݒ肷


#endif