///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBloodPack
//
// YK7EffectBloodPack.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 02/25/2004
//
//////////////////////////////////////////////////////////////////////////////

// include --------------------------------------
#include "./YK7EffectBloodPack.h"
#include "./YK7EffectString.h"
#include "../Wat/WK7Player.h"
#include "../Wat/Blood.h"

// define ---------------------------------------

#define BLOODPACKFONT		"/Yam/effect/BloodPack/BloodFont_GC.BIN"				// `ptHgt@C̃pX
#define BLOODPACKMAXNUM		(BLOOD_THIN_GAUGE_MAX / BLOOD_SPABILITY)				// pbN̍ő吔
#define GAGENUM				(3)														// Q[W̍s
#define GAGEBLOODNUM		(BLOOD_D_WEAK*3)										// Psӂ̌̕\
#define ONEGAGEPACKLENGTH	((f32)(SCW * GAGENUM) / BLOODPACKMAXNUM)				// PpbÑ[^[̒
#define PACKLENGTH(x)		((f32)( (x) * ONEGAGEPACKLENGTH ) / BLOOD_SPABILITY)	// ̗ʂsNZ߂

#define MESSAGENUM	8
char *MessageList[] =
{
//	"Blood Line", "Blood Full", "You've got BLOOD!", "Where's the Blood?",
//	"Got blood?", "no blood. . .", "Bloody hell!", "all you need Blood."
"Blood Line",
"Get that Blood!",
"You`ve got BLOOD!",
"Where`s the Blood?",
"Got Blood?",
"yummy yummy Blood!",
"Bloody hell!",
"all you need is Blood",
//"...all work and no play makes james a dull boy all work and no..."
} ;


// data type ------------------------------------

// data -----------------------------------------

static BLOODPACKUNION bpu ;			// pbNʃf[^

// functino proto type --------------------------

static void BPdrawsetup( void ) ;												// `揀
static void BPdrawpack( f32 x, f32 y, f32 rate ) ;								// pbN`悷
static f32 BPdrawbox( f32 x, f32 y, BLOODPACKEFFECT *bp, BLOODPACKMETER *mt ) ;	// [^[`悷
static void BPAddList( BLOODPACKEFFECT *bp, s32 index ) ;						// [^[Xgɒǉ
static void BPSubList( BLOODPACKEFFECT *bp, s32 index ) ;						// [^[Xg폜
static s8 BPGetPos( BLOODPACKEFFECT *bp, BLOODPACKMETER *mt, Vec *pos ) ;		// [^[̍W𓾂(E@E獶)
static f32 BPGetWidth( BLOODPACKMETER *mt ) ;									// [^[̕𓾂
static s32 BPGetBloodAllNum( BLOODPACKEFFECT *bp ) ;							// GtFNgŕێĂ錌̑ʂ𓾂
static s32 BPGetBloodAllNum2( BLOODPACKEFFECT *bp ) ;							// GtFNgŕێĂ錌̑ʂ𓾂(ڏŃpbNĂ)

// fucntion code --------------------------------

// GtFNgŕێĂ錌̑ʂ𓾂(ڏŃpbNĂ)
static s32 BPGetBloodAllNum2( BLOODPACKEFFECT *bp )
{
	BLOODPACKMETER *mt ;
	s32 num, i ;
	
	num = 0 ;
	mt = bp->meter ;
	for( i = 0 ; i < bp->meternum ; mt ++ )
	{
		if( mt->useflag == false ) continue ;
		i ++ ;
		
//		if( mt->mode == 0 ) continue ;
		
//		num += (s32)( mt->volume * ( 1.0F - mt->charge.x ) ) ;
		num += (s32)( mt->volume * mt->charge.x ) ;
	}
	
	// I
	return num ;
}

// GtFNgŕێĂ錌̑ʂ𓾂
static s32 BPGetBloodAllNum( BLOODPACKEFFECT *bp )
{
	BLOODPACKMETER *mt ;
	s32 num, i ;
	
	num = 0 ;
	mt = bp->meter ;
	for( i = 0 ; i < bp->meternum ; mt ++ )
	{
		if( mt->useflag == false ) continue ;
		i ++ ;
		
		num += mt->volume ;
	}
	
	// I
	return num ;
}

// pbN`悷
static void BPdrawpack( f32 x, f32 y, f32 rate )
{
	f32 w, h ;
	u8 r, g, b, a ;
	
	if( rate == 1.0F )
	{
		r = 200 ;
		g = 0 ;
		b = 0 ;
		a = 255 ; 
	}
	else
	{
		r = 255 ;
		g = 0 ;
		b = 0 ;
		a = 255 ; 
	}
	
	w = h = VParam[ED_BLOODPACK][7] ;

	GXBegin( GX_QUADS, GX_VTXFMT0, 4 ) ;
	{
		GP2( x, 		 y + h - h * rate  ) ;	GC4( r, g, b, a ) ;
		GP2( x + w, 	 y + h - h * rate  ) ;	GC4( r, g, b, a ) ;
		GP2( x + w, 	 y + h ) ;	GC4( r, g, b, a ) ;
		GP2( x, 		 y + h ) ;	GC4( r, g, b, a ) ;
	}
	GXEnd() ;

	GXBegin( GX_LINES, GX_VTXFMT0, 8 ) ;
	{
		GP2( x, 		 y + 1  ) ;	GC4( 0, 0, 0, 255 ) ;
		GP2( x + w, 	 y + 1  ) ;	GC4( 0, 0, 0, 255 ) ;

		GP2( x + w - 1, 	 y  ) ;	GC4( 0, 0, 0, 255 ) ;
		GP2( x + w - 1, 	 y + h  ) ;	GC4( 0, 0, 0, 255 ) ;

		GP2( x, 		 y + h - 1  ) ;	GC4( 0, 0, 0, 255 ) ;
		GP2( x + w, 	 y + h - 1  ) ;	GC4( 0, 0, 0, 255 ) ;

		GP2( x + 1, 	 y  ) ;	GC4( 0, 0, 0, 255 ) ;
		GP2( x + 1, 	 y + h  ) ;	GC4( 0, 0, 0, 255 ) ;
	}
	GXEnd() ;
/*
	GXBegin( GX_LINESTRIP, GX_VTXFMT0, 5 ) ;
	{
		GP2( x, 		 y  ) ;	GC4( 0, 0, 0, 255 ) ;
		GP2( x + w, 	 y  ) ;	GC4( 0, 0, 0, 255 ) ;
		GP2( x + w, 	 y + h  ) ;	GC4( 0, 0, 0, 255 ) ;
		GP2( x, 		 y + h  ) ;	GC4( 0, 0, 0, 255 ) ;
		GP2( x, 		 y  ) ;	GC4( 0, 0, 0, 255 ) ;
	}
	GXEnd() ;
*/
}

// [^[̕𓾂
static f32 BPGetWidth( BLOODPACKMETER *mt )
{
	return (f32)PACKLENGTH(mt->volume) * mt->size.x ;
}

// [^[̍W𓾂(E@E獶)
static s8 BPGetPos( BLOODPACKEFFECT *bp, BLOODPACKMETER *mt, Vec *pos )
{
	s32 i ;
	f32 x, y ;
	
	x = 0 ;
	y = VParam[ED_BLOODPACK][0] ;
	if( mt->mode == 0 )
	{
		for( i = 0 ; i < bp->rnum && &bp->meter[bp->rlist[i]] != mt ; i ++ )
			x += BPGetWidth( &bp->meter[bp->rlist[i]] ) ;
		if( i == bp->rnum ) return -1 ;
	}
	else
	{
		for( i = 0 ; i < bp->lnum && &bp->meter[bp->llist[i]] != mt ; i ++ )
		{
			x -= BPGetWidth( &bp->meter[bp->llist[i]] ) ;
			if( x < -SCW )
			{
				y += VParam[ED_BLOODPACK][2] ;
				x = 0.0F ;
			}
		}
		if( i == bp->lnum ) return -1 ;
	}
	pos->x = x + bp->drawx + SCW ;
	pos->y = y ;
	pos->z = 0.0F ;
	
	return 0 ;
}

// [^[Xgɒǉ
static void BPAddList( BLOODPACKEFFECT *bp, s32 index )
{
	BLOODPACKMETER *mt = &bp->meter[index] ;

	if( mt->mode == 0 )
	{
		bp->rlist[bp->rnum] = (s8)index ;
		bp->rnum ++ ;
	}
	else
	{
		bp->llist[bp->lnum] = (s8)index ;
		bp->lnum ++ ;
	}
}

// [^[Xg폜
static void BPSubList( BLOODPACKEFFECT *bp, s32 index )
{
	BLOODPACKMETER *mt = &bp->meter[index] ;

	s32 i ;
	if( mt->mode == 0 )
	{
		for( i = 0 ; i < bp->rnum && bp->rlist[i] != index ; i ++ ){}
		if( bp->rnum == i )
			bp->rnum = (s8)i ;
		if( bp->rnum - i - 1 > 0 )
			memmove( &bp->rlist[i], &bp->rlist[i+1], (u32)( bp->rnum - i - 1 ) ) ;
		bp->rnum -- ;
		
		if( bp == bpu.actpack && bp->rnum == 0 )
		{
			bpu.actflag = false ;
		}
	}
	else
	{
		for( i = 0 ; i < bp->lnum && bp->llist[i] != index ; i ++ ){}
		if( bp->lnum == i )
			bp->lnum = (s8)i ;
		if( bp->lnum - i - 1 != 0 )
			memmove( &bp->llist[i], &bp->llist[i+1], (u32)( bp->lnum - i - 1 ) ) ;
		bp->lnum -- ;
	}
}


// `揀
static void BPdrawsetup( void )
{
	// `̏
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;
	GXSetLineWidth( (u8)VParam[ED_BLOODPACK][3], GX_TO_ONE ) ;
}

// [^[`悷
static f32 BPdrawbox( f32 x, f32 y, BLOODPACKEFFECT *bp, BLOODPACKMETER *mt )
{
	f32 w, h, blw ;
//	u32 color ;
	f32 t, dw, wid ;
	f32 x2, max, min, fl, dx ;
	s32 dan ;
	
	h = VParam[ED_BLOODPACK][2] ;
//	w = BPGetWidth( mt ) ;
	w = (f32)mt->volume / GAGEBLOODNUM * ( bp->arear - bp->areal ) * mt->size.x ;
	blw = w * mt->charge.x ;
	dw = bp->arear - bp->areal ;
	wid = mt->mode == 0 ? SCW : dw ;
	dx = mt->mode == 0 ? 0 : bp->drawx ;

	// iڂׂ
	dan = (s32)( (s32)x / wid ) ;
	x -= (f32)( (s32)( (s32)x / wid ) * wid ) ;
	y += dan * h ;
	
	if( dan >= 3 ) return 0.0F ;

	if( dan & 1 )
	{
		x2 = wid - x ;
		max = 0 ;
		min = wid ;
		fl = -1.0F ;
	}
	else
	{
		x2 = x ;
		max = wid ;
		min = 0 ;
		fl = 1.0F ;
	}

	if( wid < x + blw )
	{
		t = wid - x ;
		DrawBox( x2 + dx,	y,		max + dx,						y + h,		CMK( 255, 0, 0, 255 ) ) ;
		if( dan < 2 )
			DrawBox( max + dx,	y + h,	max - fl * ( blw - t ) + dx, 	y + h + h,	CMK( 255, 0, 0, 255 ) ) ;
	}
	else
	{
		DrawBox( x2 + dx,	y,		x2 + fl * blw + dx,				y + h,		CMK( 255, 0, 0, 255 ) ) ;
	}

	// E
	if( wid < x + w )
	{
		t = wid - x ;
		DrawLineBox( x2 + dx,	y,		max + dx, 						y + h, 		CMK2( 0, 255 ), 2 ) ;
		if( dan < 2 )
			DrawLineBox( max + dx,	y + h, 	max - fl * ( w - t ) + dx, 	y + h + h, 	CMK2( 0, 255 ), 2 ) ;
	}
	else
	{
		DrawLineBox( x2 + dx,	y,		x2 + w * fl + dx, 				y + h, 		CMK2( 0, 255 ), 2 ) ;
	}
	
	// `敝Ԃ
	return w ;
}


// pbN̋ʃf[^
extern s8 InitBloodPackData( void )
{
	MEMINIT(bpu) ;

/*
	// tHg[h
	if( bpu.simage.Load( BLOODPACKFONT ) == false )
	{
		OSReport( "BloodFont_GC load error\n" ) ;
		return -1 ;
	}
*/

	// I
	return 0 ;
}

// pbNɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckBloodPackData( void )
{
	// tHg̃[h̊`FbN
//	if( bpu.simage.LoadCheck() == false ) return FALSE ;

	// I
	return TRUE ;
}

// pbN̋ʃf[^n
extern s8 EndBloodPackData( void )
{
	// tHg̏J
//	bpu.simage.Release() ;

	MEMINIT(bpu) ;
	
	// I
	return 0 ;
}


// pbN쐬
extern EFFECT *CreateBloodPackEffect( s32 Priority )
{
	EFFECT *ef ;
	BLOODPACKEFFECT *bp ; 

	// GtFNg̒ǉ
	ef = AddEffectData( EFF_BLOODPACK, (void **)&bp, Priority ) ;
	if( ef == NULL ) return NULL ;
	memset( bp, 0, sizeof( BLOODPACKEFFECT ) ) ;

	// p[^̏
	bp->drawx = -SCW ;
	bp->drawy = VParam[ED_BLOODPACK][5] ;
//	bp->drawx = 0 ;
	bp->mesmode = 0 ;
	bp->mescount = 0 ;
	bp->meterdrawflag = TRUE ;
	
	bp->areal = bp->drawx ;		bp->arear = bp->drawx + ( 354-32 ) ;
	bp->areat = bp->drawy ;		bp->areab = bp->drawy + ( VParam[ED_BLOODPACK][2] * 3 ) ;

	// Ƃ肠Zbg
	SetActBloodPack( ef ) ;

	// I
	return ef ;
}

// pbŇns
extern s8 ReleaseBloodPackEffect( EFFECT *effect )
{
	BLOODPACKEFFECT *bp = ( BLOODPACKEFFECT * )effect->Data ;
	
	// ANeBuȂ̂ꍇ̓Zbg
	if( bp == bpu.actpack )
	{
		bpu.actpack = NULL ;
		bpu.actflag = false ;
	}

	// I
	return 0 ;
}

// pbNPt[
extern s8 MoveBloodPackEffect( EFFECT *effect )
{
	BLOODPACKEFFECT *bp = ( BLOODPACKEFFECT * )effect->Data ;
	BLOODPACKMETER *mt ;
	s32 j, i, rcount ;
	
	if( effect->DelReqFlag == TRUE )
	{
		DeleteEffect( effect ) ;
		return 0 ;
	}

	// SẴ[^[
	mt = bp->meter ;
	rcount = 0 ;
	for( j = 0, i = 0 ; i < bp->meternum ; j ++, mt ++ )
	{
		if( mt->useflag == FALSE ) continue ;
		i ++ ;

		if( bp->leftstopflag == false || mt->mode != 1 )
		{
			mt->charge.proc() ;
			mt->size.proc() ;
		}

		switch( mt->mode )
		{
		case 0 :	// ʉEɋ
			switch( mt->state )
			{
			case 0 :	// ܂̂҂Ă
				if( mt->count2 < 0xff ) mt->count2 ++ ;
				if( mt->charge.x > 0.0F || mt->count2 > 120 ) mt->count ++ ;
				if( mt->count == VParam[ED_BLOODPACK][8] ) mt->charge.mov( (u8)VParam[ED_BLOODPACK][11], VParam[ED_BLOODPACK][9], 1.0F ) ;

				if( mt->charge.x == 1.0F )
				{
					mt->state ++ ;
				}
				rcount ++ ;
				break ; 

			case 1 :	// ̃[^[܂ԂɂȂ̂҂Ă
				if( bp->rnum2 == 0 )
				{
					mt->size.mov( (u8)VParam[ED_BLOODPACK][11], VParam[ED_BLOODPACK][9], 0.0F ) ;
					mt->state ++ ;
				}
				break ;

			case 2 :	// ʊOɈނ̂҂Ă
				if( mt->size.eop() == true )
				{
					// EXg폜
					BPSubList( bp, j ) ;

					mt->state = 0 ;
					mt->mode ++ ;
					mt->size.mov( (u8)VParam[ED_BLOODPACK][11], VParam[ED_BLOODPACK][9], 1.0F ) ;

					// Xgɒǉ
					BPAddList( bp, j ) ;
				}
				break ;
			}
			break ;
			
		case 1 :	// ʂɋ
			switch( mt->state )
			{
			case 0 :	// o҂Ă
				if( mt->size.x == 1.0F )
				{
					mt->charge.mov( 2, 0.005F/*(u8)VParam[ED_BLOODPACK][11], VParam[ED_BLOODPACK][10]*/, 0.0F ) ;
					mt->state ++ ;
				}
				break ;
			
			default :;
			}
			break ;

		default :;
		}
	}
	bp->rnum2 = (s8)rcount ;

	// bZ[W̏
	bp->mesp.proc() ;
	switch( bp->mesmode )
	{
	case 0 : break ;
	
	case 1 : 
		if( bp->rnum == 0 )
		{
			f32 exX ;
		
			exX = bp->mesnum == MESSAGENUM ? 0.7F : 1.0F ;
			
			CreateStringEffect( MessageList[bp->mesnum], 0xffffffff, exX ) ;
			bp->mesmode = 0 ;
			break ;
			
			
			bp->mesp.mov( 8, VParam[ED_BLOODPACK][9], 1.0F ) ;
			bp->mesmode ++ ;
			bp->mescount = 0 ;
		}
		break ;
		
	case 2 :
		if( bp->mesp.eop() == true )
		{
			bp->mescount ++ ;
			if( bp->mescount == 1 )
			{
				bp->mesp.mov( (u8)VParam[ED_BLOODPACK][11], VParam[ED_BLOODPACK][9], 0.0F ) ;
				bp->mesmode ++ ;
			}
		}
		break ;

	case 3 :
		if( bp->mesp.eop() ) bp->mesmode = 0 ;
		break ;
	}
	
	// ̗ʂϓ̏
/*	if( BPGetBloodAllNum( bp ) > WK7PLAYERCONTROL->GetNowBloodPoint() )
//	if( BPGetBloodAllNum2( bp ) > WK7PLAYERCONTROL->GetNowBloodPoint() )
	{
		s32 subnum, num ;
		
		// ʂZo
		subnum = BPGetBloodAllNum( bp ) - WK7PLAYERCONTROL->GetNowBloodPoint() ;
//		subnum = BPGetBloodAllNum2( bp ) - WK7PLAYERCONTROL->GetNowBloodPoint() ;

		// ʕ炷
		num = subnum ;
		while( num != 0 && bp->lnum != 0 )
		{
			mt = &bp->meter[bp->llist[0]] ;
			if( num > mt->volume )
			{
				num -= mt->volume ;
				mt->useflag = false ;
				BPSubList( bp, bp->llist[0] ) ;
				bp->meternum -- ;
			}
			else
			{
				mt->volume -= num ;
				num = 0 ;
			}
		}
		while( num != 0 && bp->rnum != 0 )
		{
			mt = &bp->meter[bp->rlist[0]] ;
			if( num > mt->volume )
			{
				num -= mt->volume ;
				mt->useflag = false ;
				BPSubList( bp, bp->rlist[0] ) ;
				bp->meternum -- ;
			}
			else
			{
				mt->volume -= num ;
				num = 0 ;
			}
		}
	}
*/
	// I
	return 0 ;
}

// pbN`悷
extern s8 DrawBloodPackEffect( EFFECT *effect )
{
	BLOODPACKEFFECT *bp = ( BLOODPACKEFFECT * )effect->Data ;
	BLOODPACKMETER *mt ;
	s32 i ;
	
	return 0 ;

	// `揀
	BPdrawsetup() ;

	if( bp->meterdrawflag == TRUE ) 
	{
		// Ẽ[^[`悷
		if( bp->drawx == -SCW )
		{
			f32 r, ry ;

			r = 0.0F ;
			ry = VParam[ED_BLOODPACK][0] ;
			for( i = 0 ; i < bp->rnum ; i ++ )
			{
				mt = &bp->meter[bp->rlist[i]] ;
				r += BPdrawbox( r, ry, bp, mt ) ;
/*
				r += BPdrawbox(	r, ry, bp, mt ) ;
				if( r > bp->arear - bp->areal )
				{
					ry -= VParam[ED_BLOODPACK][2] ;
					r -= bp->arear - bp->areal ;
				}
*/			}
		}
#if 0		
		// ̃[^[`悷
		{
			f32 l, /*lx,*/ ly ;

			l = 0.0F ; 
			ly = bp->drawy /*VParam[ED_BLOODPACK][0]*/ ;
//			lx = bp->drawx + SCW ;
			for( i = 0 ; i < bp->lnum ; i ++ )
			{
				mt = &bp->meter[bp->llist[i]] ;
				
				l += BPdrawbox( l, ly, bp, mt ) ;
/*				l -= BPdrawbox( lx + l, ly, bp, mt ) ;
				if( l < -( bp->arear - bp->areal ) )
				{
					ly -= VParam[ED_BLOODPACK][2] ;
					l += bp->arear - bp->areal ;
				}
*/			}
		}
#endif
	}

/*	// pbN̎I`
	{
		s32 i, num, addnum ;
		f32 x, y, addx ;
		s16 blood ;

//		blood = WK7PLAYERCONTROL->GetNowBloodPoint() ;
		blood = (short)( WK7PLAYERCONTROL->GetNowBloodPoint() - (short)BPGetBloodAllNum2( bp ) ) ;
		num = blood / BLOOD_SPABILITY ;
		addnum = blood % BLOOD_SPABILITY != 0 ? 1 : 0 ;
		x = VParam[ED_BLOODPACK][6] + bp->drawx ;
		y = bp->drawy ;
		addx = ( SCW - VParam[ED_BLOODPACK][6] - VParam[ED_BLOODPACK][14] - VParam[ED_BLOODPACK][7] ) / ( BLOODPACKMAXNUM - 1 ) ;

		for( i = 0 ; i < num ; i ++, x += addx ) BPdrawpack( x, y, 1.0F ) ;
		if( addnum != 0 )
		{
			BPdrawpack( x, y, (f32)( blood % BLOOD_SPABILITY ) / BLOOD_SPABILITY ) ;
		}
	}
*/
	// bZ[W̕`
	if( bp->drawx == -SCW )
	{
		f32 width ;
		GXColor c = { 255, 255, 255, 255 } ;

		bpu.simage.DrawSetup() ;
		bpu.simage.SetColor( &c ) ;

//		bpu.simage.SetExRate2( 0.8F, 1.0F ) ;
//		if( bp->mesnum == MESSAGENUM ) bpu.simage.SetExRate2( 0.8F, 1.0F ) ;
//		else bpu.simage.SetExRate( 1.0F ) ;
	
		width = bpu.simage.DrawSStr( 0, 0, MessageList[bp->mesnum], false, false )  ;
		bpu.simage.DrawSStr( ( SCW - width ) + ( ( width + VParam[ED_BLOODPACK][12] ) *  bp->mesp.x ) + bp->drawx, VParam[ED_BLOODPACK][13], MessageList[bp->mesnum] ) ;
	}

	// I
	return 0 ;
}

// pbN̍폜]o
extern s8 DelReqBloodPackEffect( EFFECT *effect ) 
{
	effect->DelReqFlag = TRUE ;
	
	// I
	return 0 ;
}

	



// pbN\̂wWύX
extern s8 SetBloodPackDrawX( EFFECT *effect, int x )
{
	BLOODPACKEFFECT *bp = ( BLOODPACKEFFECT * )effect->Data ;
	
	bp->drawx = x ;
	
	bp->areal = bp->drawx ;		bp->arear = bp->drawx + ( 354-32 ) ;
	bp->areat = bp->drawy ;		bp->areab = bp->drawy + ( VParam[ED_BLOODPACK][2] * 3 ) ;
	
	// I
	return 0 ;
}

// pbN\̂xWύX
extern s8 SetBloodPackDrawY( EFFECT *effect, int y )
{
	BLOODPACKEFFECT *bp = ( BLOODPACKEFFECT * )effect->Data ;
	
	bp->drawy = y ;
	
	bp->areal = bp->drawx ;		bp->arear = bp->drawx + ( 354-32 ) ;
	bp->areat = bp->drawy ;		bp->areab = bp->drawy + ( VParam[ED_BLOODPACK][2] * 3 ) ;
	
	// I
	return 0 ;
}



// pbN[^[ǉ
extern s8 AddBloodMeter( EFFECT *effect, s16 bloodVolume, u16 bloodmaxnum )
{
	BLOODPACKEFFECT *bp = ( BLOODPACKEFFECT * )effect->Data ;
	BLOODPACKMETER *mt ;
	s32 i, j ;
	
	// 󂢂Ă郁[^[T
	if( bp->meternum == MAXBLOODPACKMETERNUM )
	{
		// 󂢂Ă鍶[^[Ȃׂ
		for( j = 0, i = 0, mt = bp->meter ; i < bp->lnum ; j ++, mt ++ )
		{
			if( mt->useflag == false || mt->mode == 0 ) continue ;
			if( mt->state >= 1 && mt->charge.eop() == true ) break ;
			i ++ ;
		}
		if( i == bp->lnum ) return -1 ;
		
		// Xg폜
		BPSubList( bp, j ) ;
		i = j ;
		
		// U炷
		bp->meternum -- ;
	}
	else
	{
		for( i = 0, mt = bp->meter ; mt->useflag == true ; i ++, mt ++ ){}
	}
	
	// Xe[^X
	mt->useflag = TRUE ;
	mt->mode = 0 ;
	mt->state = 0 ;
	mt->volume = bloodVolume ;
	mt->bloodmaxnum = bloodmaxnum ;
	mt->bloodnum = 0 ;
	mt->charge.spos( 0.0F ) ;
	mt->size.spos( 0.0F ) ;
	mt->size.mov( (u8)VParam[ED_BLOODPACK][11], VParam[ED_BLOODPACK][9], 1.0F ) ;
	mt->count = 0 ;
	mt->count2 = 0 ;
	
	if( bp->mesmode == 0 )
	{
//		bp->mesnum = MESSAGENUM ;
//		if( GetRandINum( 100 ) == 0 ) bp->mesnum = MESSAGENUM ;
//		else bp->mesnum = (s8)GetRandINum( MESSAGENUM ) ;
		bp->mesnum = (s8)GetRandINum( MESSAGENUM ) ;
		bp->mesp.spos( 0.0F ) ;
		bp->mesmode = 1 ;
		bp->mescount = 0 ;
	}

	bp->meternum ++ ;
	
	// Xgɒǉ
	BPAddList( bp, i ) ;
	
	bpu.actflag = true ;

	// I
	return 0 ;
}

// AddBloodMeter ŊJݒ
extern s8 CloseBloodMeter( void )
{
	bpu.actflag = false ;

	// I
	return 0 ;
}


// ɋz\̌pbN[^[̃|C^𓾂
extern BLOODPACKMETER *GetActBloodMeter( void )
{
	if( bpu.actpack == NULL ) return NULL ;
	if( bpu.actflag == false ) return NULL ;

	if( bpu.actpack->rnum == 0 ) return NULL ;
	
	return &bpu.actpack->meter[bpu.actpack->rlist[bpu.actpack->rnum-1]] ;
}

// w̃[^[ׂ̌̎W𓾂
extern s8 GetBloodMeterPos( BLOODPACKMETER *meter, Vec *pos )
{
	if( BPGetPos( bpu.actpack, meter, pos ) == -1 ) return -1 ;
	pos->y += VParam[ED_BLOODPACK][2] >> 1 ;

	return 0 ;
}

// pbN̍W擾
extern s8 GetBloodPackPos( EFFECT *effect, s8 index, Vec *Pos )
{
	BLOODPACKEFFECT *blpack = ( BLOODPACKEFFECT * )effect->Data ;
	f32 x, y, addx ;

	x = VParam[ED_BLOODPACK][6] + blpack->drawx ;
	y = blpack->drawy ;
	addx = ( SCW - VParam[ED_BLOODPACK][6] - VParam[ED_BLOODPACK][14] - VParam[ED_BLOODPACK][7] ) / ( BLOODPACKMAXNUM - 1 ) ;

	Pos->y = y ;
	Pos->x = x + index * addx ;
	Pos->z = 0.0F ;
	
	// I
	return 0 ;
}

// ɋz\̌pbN[^[̃|C^𓾂
extern void SetActBloodPack( EFFECT *effect )
{
	BLOODPACKEFFECT *blpack = ( BLOODPACKEFFECT * )effect->Data ;

	// |C^Zbg邾
	bpu.actpack = blpack ;
	bpu.actflag = false ;
}

// [^[`悷邩ǂ̃tOZbg
extern void SetMeterDrawFlagBloodPack( EFFECT *effect, s8 flag )
{
	BLOODPACKEFFECT *blpack = ( BLOODPACKEFFECT * )effect->Data ;

	// tOZbg邾
	blpack->meterdrawflag = flag ;
}

// ʂ̃[^[̓~߂邩ǂ̃tOZbg( true:~܂  false: )
extern void SetMeterStopFlagBloodPack( EFFECT *effect, s8 flag )
{
	BLOODPACKEFFECT *blpack = ( BLOODPACKEFFECT * )effect->Data ;

	// tOZbg邾
	blpack->leftstopflag = flag ;
}
	


// pbN[^[Ɍ̗ǉ
extern s8 IncBloodMeterBlood( BLOODPACKMETER *meter )
{
	if( meter->bloodmaxnum > meter->bloodnum ) meter->bloodnum ++ ;
	if( meter->count < VParam[ED_BLOODPACK][8] )
	{
		meter->charge.mov( (u8)VParam[ED_BLOODPACK][11], VParam[ED_BLOODPACK][9], (f32)meter->bloodnum / meter->bloodmaxnum ) ;
	}
	
	return 0 ;
}

// pbN[^[Ɍ̗ǉ鏈I
extern s8 EndBloodMeterBlood( BLOODPACKMETER *meter )
{
	meter->count = (u8)VParam[ED_BLOODPACK][8] ;
	meter->charge.mov( (u8)VParam[ED_BLOODPACK][11], VParam[ED_BLOODPACK][9], 1.0F ) ;
	
	return 0 ;
}

// [^[̋zݏIǂ擾( true:I  false:܂ )
extern bool GetBloodMeterEndState( EFFECT *effect )
{
	BLOODPACKEFFECT *bp = ( BLOODPACKEFFECT * )effect->Data ;
//	BLOODPACKMETER *mt ;
	int i ;
	
	if( bp->rnum != 0 ) return false ;
	for( i = 0 ; i < bp->lnum ; i ++ )
		if( bp->meter[bp->llist[i]].charge.x != 0.0F ) return false ;

	return true ;
}







