///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBullet
//
// YK7EffectBullet.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/10/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTBULLET_H
#define __YK7EFFECTBULLET_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7Break.h"
#include "../Wat/WK7Light.h"

// define ---------------------------------------

// 
enum BL_TYPE
{
	BL_INV_MSK_NRM = 0,	// }XNʏee
	BL_INV_MSK_ELC,		// }XNdee
	BL_INV_MSK_CNV,		// }XNWee
	BL_INV_NRM,			// ʏe̖e
	BL_INV_KVN,			// PB̖e
	BL_INV_NRM_RED,		// ʏe̖e
	BL_INV_KVN_RED,		// PB̖e
	BL_MARK,			// e}[N
} ;

// datatype -------------------------------------

// eGtFNgʃf[^
typedef struct tagBULLETUNION
{
	WK7Light *light ;
	TEXDATA MarkTex ;				// e}[NeNX`
} BULLETUNION ;

// eGtFNgf[^
typedef struct tagBULLETEFFECT
{
	BL_TYPE type ;

	s32 mod, con ;
	EFFECT *eff1, *eff2 ;
	u32 eff1id, eff2id ;
	
	f32 alpha ;
	f32 drawrot ;
	f32 Size ;			// 傫

	f32 yukay ;			// ̍
	Vec speed ;			// Xs[h
	Vec rot ;			// ]
	Vec rotspeed ;		// ]x
	WK7Model *model ;	// f

	Vec pos ;
	WK7JObj *JObj ;										// ǂꂩ JObj ɏ]Ăꍇ̏]Ă JObj
	s32 MeshInfoID ;									// bVf[^̂hc
	MESH *Mesh ;										// ǂꂩ JObj ɏ]Ăꍇ JObj ̃bV̓f[^
	u32 VertexNumber ;									// ΏۂƂ钸_̃io[
} BULLETEFFECT ;

// prototype ------------------------------------

extern s8 InitBulletData( void ) ;			// eGtFNg̋ʃf[^
extern s8 CheckBulletData( void ) ;			// eGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndBulletData( void ) ;			// eGtFNg̋ʃf[^n

extern EFFECT *CreateBulletEffect(
								BL_TYPE type,					// ehc
								Vec pos, 						// qbgW
								WK7JObj *JObj = NULL,			// Ώۂ WK7JObj
								f32 YukaY = 0.0F,				// ̍
								f32 Size = 0.3F,				// TCY
								s32 Priority = -1 ) ;			// eGtFNg쐬

extern s8 ReleaseBulletEffect( EFFECT *Effect ) ;				// eGtFNǧns
extern s8 MoveBulletEffect( EFFECT *Effect ) ;				// eGtFNgPt[
extern s8 DrawBulletEffect( EFFECT *Effect ) ;				// eGtFNg`悷

extern WK7Light *GetBulletLight( void ) ;					// Cg̎擾

#endif

