///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCentLight2
//
// YK7EffectCentLight2.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/28/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTCENTLIGHT2_H
#define __YK7EFFECTCENTLIGHT2_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define MAXLIGHTOBJ_NUM			1000				// IuWFNg̍ő吔

// datatype -------------------------------------

// WGtFNgʃf[^
typedef struct tagCENTLIGHT2UNION
{
	u8 Dummy ;
} CENTLIGHT2UNION ;

// CIuWFNgf[^
typedef struct tagCENTLIGHT2OBJECT
{
	u8 vflag ;					// LtO
	Vec dir ;					// 
	f32 initlen, len ;			// 
	f32 size ;					// 傫
} CENTLIGHT2OBJECT ;

// WGtFNgf[^
typedef struct tagCENTLIGHT2EFFECT
{
	CENTLIGHT2OBJECT *Obj ;			// ̃f[^ւ̃|C^
	s32 ObjNum ;					// ̐
	s32 MaxObjNum ;					// IuWFNg̍ő吔

	Vec Pos ;						// W
	f32 MaxLen, MinLen ;			// ő勗ƍŒZ
	f32 MaxSize, MinSize ;			// őTCYƍŏTCY
	f32 Speed ;						// x
	f32 CreateCost ;				// 쐬RXg
	f32 CreateCounter ;				// 쐬JE^[
	u32 Color ;						// F
	f32 Alpha ;
	
	f32 CLSize ;				// Š̃TCY
	f32 CLRandSize ;			// Š̃TCỸ_l
} CENTLIGHT2EFFECT ;

// WGtFNg^XNɓnf[^
typedef struct tagCENTLIGHT2EFFECTTACKPARAM
{
	s32 MaxObjNum ;					// IuWFNg̍ő吔

	Vec Pos ;						// W	
	f32 MaxLen, MinLen ;			// ő勗ƍŒZ
	f32 MaxSize, MinSize ;			// őTCYƍŏTCY
	f32 Speed ;						// x
	f32 CreateCost ;				// 쐬RXg
	u32 Color ;						// F
} CENTLIGHT2EFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitCentLight2Data( void ) ;				// WGtFNg̋ʃf[^
extern s8 CheckCentLight2Data( void ) ;				// WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndCentLight2Data( void ) ;				// WGtFNg̋ʃf[^n

extern EFFECT *CreateCentLight2Effect( 				// WGtFNg쐬
						s32 MaxObjNum,					// IuWFNg̍ő吔

						Vec Pos,						// W	
						f32 MaxLen, f32 MinLen,			// ő勗ƍŒZ
						f32 MaxSize, f32 MinSize,		// őTCYƍŏTCY
						f32 Speed,						// x
						f32 CreateCost,					// 쐬RXg
						GXColor Color,					// F
						s32 Priority = 2000 ) ;	
extern s8 ReleaseCentLight2Effect( EFFECT *Effect ) ;						// WGtFNǧns
extern s8 MoveCentLight2Effect( EFFECT *Effect ) ;							// WGtFNgPt[
extern s8 DrawCentLight2Effect( EFFECT *Effect ) ;							// WGtFNg`悷

extern s8 SetCentLight2Pos( Vec Pos, EFFECT *Effect ) ;						// GtFNg̍WύX
extern s8 SetCentLight2CentSize( f32 Size, f32 RandSize, EFFECT *Effect ) ;	// Š̑傫ݒ肷
extern s8 SetCentLight2Speed( f32 Speed, EFFECT *Effect ) ;					// xύX

#endif
