///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCharge
//
// YK7EffectCharge.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/21/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectCharge.h"
#include "./YK7File.h"
#include "../Wat/WK7Player.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_CHARGE2]

#define OBIINSPEED		(3.0F)							// тo鑬
#define OBIWIDTH		(100)							// т̕
#define OBIALPHA		((50)*255/100)					// т̃At@l
#define OBILEFTALPHA	(s32)(PRM[2] * 255 / 100)		// т̃Of[V̍őAt@l

#define KIRI			((f32)PRM[7]*0.01F)				// IƔf闦
#define TUBEINSPEED		((f32)PRM[3] * 0.1F)			// ǂɌ܂鑬x
#define TUBEMOVTIME		((f32)PRM[4] * 0.1F)			// ǂړ̂Ɋ|鎞

#define PLATEALPHA		((f32)PRM[5]*0.01F)
#define PLATEALPHA2		((f32)PRM[6]*0.01F)

#define LIGHTEX			(2.0F)			// g`悳鍂

#define BLOODX			(5.0F)			// ǂ̌̍W
#define BLOODY			(6.0F+BLOODH)
#define BLOODW			(8.0F)			// ǂ̌̕
#define BLOODH			(64.0F)			// ǂ̌̍
#define BLOODTEXH		(8.0F)			// eNX`̑傫

#ifdef YAMADADEBUG
	#if 0
		#define CHARGELEVEL		(PRM[0]) 		// fobOp̃x
	#else
		#define CHARGELEVEL		(WK7PLAYERCONTROL->GetChargeSetUpLv()) 			// x
	#endif
#else
#define CHARGELEVEL		(WK7PLAYERCONTROL->GetChargeSetUpLv()) 			// x
#endif

#define TBIND(x)		tubepos[cg->num-1][(x)]				// `[üʒuCfbNX𓾂

#define PACKPATH		"/Yam/Effect/Charge/Charge.rsl"		// pbNt@C̃pX

// f[^ԍ
enum
{
	DAT_0 = 0,
	DAT_1,
	DAT_2,
	DAT_3,
	DAT_4,
	DAT_5,
	DAT_kasan01,
	DAT_kasan02,
	DAT_kasan03,
	DAT_kasan04,
	DAT_kasan05,
	DAT_kasan_b_01,
	DAT_kasan_b_02,
	DAT_kasan_b_03,
	DAT_kasan_b_04,
	DAT_kasan_b_05,
	DAT_moji,
	DAT_moji_shadow,
	DAT_blood_8,
	DAT_plate,
	DAT_plate_line,
	DAT_sikenkan,
	DAT_waku,
} ;

// ǂ̏
typedef struct tagTUBEINFO
{
	s16 x, y ;
	u8 scale, alpha ;
	
	s16 kx, ky ;
	s16 kbx, kby ;
	u8 alphab ;
} TUBEINFO ;
TUBEINFO tubeinfo[] = 
{
	41,224,100,70,24,281,27,249,80,		// ԎO
	14,216,90,60,0,267,0,236,65,		// ԍ
	70,216,90,60,54,267,56,236,65,		// ԉE
	30,207,80,55,15,254,15,234,45,		// 
	56,207,80,55,47,254,49,234,45,		// E
} ;

// ǂ̐ɂQƃe[u
const s8 tubepos[MAX_TUBENUM][MAX_TUBENUM] =
{
	{0},			// {
	{0,2},			// {
	{0,1,2},		// O{
	{0,1,4,2},		// l{
	{0,1,3,4,2},	// ܖ{
} ;

// Ze[u̐F
const GXColor paletecolor[7] =
{
	255,128,64,255,			// 0@IW
	255,64,80,255,			// 1@
	236,60,177,255,			// 2@
	20,150,250/*54,54,217*/,255,		// 3@
	107,217,54,255,			// 4@
	238,193,60,255,			// 5@F()
	0,0,0,0					// 6@_~[
} ;


// data -----------------------------------------

CHARGEUNION chgu ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// `[WGtFNg̋ʃf[^
extern s8 InitChargeData( void )
{
	MEMINIT( chgu ) ;

	return 0 ;
}

// `[WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckChargeData( void )
{
	return TRUE ;
}

// `[WGtFNg̋ʃf[^n
extern s8 EndChargeData( void )
{
	MEMINIT( chgu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// `[WGtFNg쐬
extern EFFECT *CreateChargeEffect(
									s32 TubeNum,				// ǂ̐
									s32 Priority )				// `[WGtFNg쐬
{
	EFFECT *Effect ;
	CHARGEEFFECT *cg ;
	s32 i ;
	
	// f[^̃ZbgAbvsĂȂ牽ɃG[
	if( chgu.SetupState != 2 ) return NULL ;
	
	// V`[Wf[^쐬
	Effect = AddEffectData( EFF_CHARGE, (void**)&cg, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// f[^̏
	cg->num = TubeNum ;
	cg->inrate.init(true) ;
	for( i = 0 ; i < MAX_TUBENUM ; i ++ )
		cg->tuberate[i].init(true) ;

	cg->mod = 0 ;
	cg->con = 0 ;
	cg->tubemov.init(true) ;
	cg->fronttube = 0 ;
	cg->chargenum = 0 ;
	cg->frontchagerate = 0.0F ;
	cg->brinkflag = false ;
	cg->brinkcon = 0 ;
	cg->AutoFlag = true ;

	cg->InFlag = false ;

	// I
	return Effect ;
}

// `[WGtFNǧns
extern s8 ReleaseChargeEffect( EFFECT *Effect )
{
	CHARGEEFFECT *cg = ( CHARGEEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// `[WGtFNgPt[
extern s8 MoveChargeEffect( EFFECT *Effect )
{
	CHARGEEFFECT *cg = ( CHARGEEFFECT * )Effect->Data ;
	s32 i ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// Ԃɂď𕪊
	switch( cg->mod )
	{
	case 0 :		// AChO
		// ܂Ă鎎ǂ̐Ǝۂ̃xɍقNꍇ͏s
		if( cg->chargenum == CHARGELEVEL ) break ;
		
		// ꍇ͎ǂ̏Ԃ邾
		if( cg->chargenum > CHARGELEVEL )
		{
			SetChargeEffectTubeNum( Effect, cg->num ) ;
			break ;
		}
		
		// {ł܂Ăꍇ͎ǈړs
		if( cg->chargenum != 0 )
		{
			cg->mod = 1 ;	// ړ
			cg->con = 0 ;
		}
		else
		{
			cg->mod = 2 ;	// ܂鏈
			cg->con = 0 ;
		}
		break ;
		
	case 1 :		// ǈړ
		if( cg->con == 0 )
		{
			cg->tubemov.mov( 1, TUBEMOVTIME, 1.0F ) ;	// ړJn
			cg->tuberate[TBIND(cg->fronttube+1)].mov( 1, TUBEINSPEED, 1.0F ) ;	// ܂̊Jn
			cg->con = 1 ;
		}

		// ړIm
		if( cg->tubemov.x > KIRI ) 
		{
			cg->tubemov.movend() ;
			cg->tubemov.spos( 0.0F ) ;
			
			// ԎOɗ鎎ǂ̃CfbNXCNg
			cg->fronttube ++ ;
//			if( cg->fronttube < 0 ) cg->fronttube += cg->num ;
			
			// ė܂̂҂ɓ
			cg->con = 1 ;
			cg->mod = 2 ;
		}
		break ;
		
	case 2 :		// ܂鏈
		if( cg->con == 0 )
		{
			cg->tuberate[TBIND(cg->fronttube)].mov( 1, TUBEINSPEED, 1.0F ) ;	// ܂̊Jn
			cg->con = 1 ;
		}
		cg->frontchagerate = cg->tuberate[TBIND(cg->fronttube)].x ;

		// ړIm
		if( cg->tuberate[TBIND(cg->fronttube)].x > KIRI ) 
		{
			cg->frontchagerate = 0.0F ;
			cg->tuberate[TBIND(cg->fronttube)].movend() ;
			
			// ܂Ă鎎ǂ̐CNg
			cg->chargenum ++ ;
			
			// AChOԂɖ߂
			cg->mod = 0 ;
			cg->con = 0 ;
		}
		break ;
	}

	// ڏ
	for( i = 0 ; i < MAX_TUBENUM ; i ++ )
		cg->tuberate[i].proc() ;
	cg->tubemov.proc() ;

	// шړ
	if( cg->AutoFlag == true )
	{
		cg->inrate.proc() ;
	}

	// I
	return 0 ;
}

// `[WGtFNg`悷
extern s8 DrawChargeEffect( EFFECT *Effect )
{
	CHARGEEFFECT *cg = ( CHARGEEFFECT * )Effect->Data ;
	s32 i ;
	f32 ax ;
	
	ax = cg->inrate.x * OBIWIDTH - OBIWIDTH ;
	
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX, TRUE ) ;
	
	// 悸`
//	DrawBox( ax, 0, OBIWIDTH + ax, SCH, CMK( 0, 0, 0, OBIALPHA ) ) ;
	
	// x`
	EffectTexColorIgnoreSetup( TRUE ) ;
	if( VParam[ED_CHARGE2][0] > 5 ) VParam[ED_CHARGE2][0] = 5 ;
	DrawTex( 0 + ax, 114, &chgu.texwaku, CMK( 0, 0, 0,255 ) ) ;
	DrawTex( 14 + ax,130, &chgu.texmoji_shadow, CMK( 0,0,0, 255 ) ) ;
	DrawTex( 23 + ax,139, &chgu.texmoji, CMK( 255,255,255,255 ) ) ;
	DrawTex( 57 + ax,156, &chgu.texnum[cg->chargenum], CMK( 255,255,255,255 ) ) ;
	
	// v[g`
	DrawTex( 2 + ax,257, &chgu.texplate, CMK( 255,255,255,30*255/100 ) ) ;
	DrawTex( 2 + ax,265, &chgu.texplate_line, CMK( 0,0,0,50*255/100 ) ) ;
	
	// ǂ`
	{
		TUBEINFO *now, *next ;
		f32 nowrate, nextrate, backrate, x, y, alpha, scale ;
		s32 nowind, nextind ;
		f32 movrate ;
		u32 cr ;
		
		movrate = cg->tubemov.x ;
		
		// Zv[g̕ɕ`
		backrate = 0.0F ;
		for( i = 0 ; i < cg->num ; i ++ )
		{
			// pӂ
			nowind 	= cg->fronttube	- i ;
			nextind	= cg->fronttube	- i + 1 ;
			if( nowind	> cg->num ) nowind	-= cg->num ;
			if( nextind	> cg->num ) nextind	-= cg->num ;
			if( nowind	< 0 ) nowind		+= cg->num ;
			if( nextind	< 0 ) nextind		+= cg->num ;

			now = &tubeinfo[TBIND(i)] ;
			next = &tubeinfo[TBIND(( i + 1 == cg->num ) ? 0 : i+1)] ;

			nowrate = cg->tuberate[TBIND(nowind)].x ;
			nextrate = cg->tuberate[TBIND(nextind)].x ;

			// v[g̕`
			EffectBlendModeSetup( EF_BLEND_ADD ) ;
			EffectTexColorIgnoreSetup( TRUE ) ;
			cr = CMK( paletecolor[cg->chargenum+1].r * cg->frontchagerate + paletecolor[cg->chargenum].r * ( 1.0F - cg->frontchagerate ),
						paletecolor[cg->chargenum+1].g * cg->frontchagerate + paletecolor[cg->chargenum].g * ( 1.0F - cg->frontchagerate ),
						paletecolor[cg->chargenum+1].b * cg->frontchagerate + paletecolor[cg->chargenum].b * ( 1.0F - cg->frontchagerate ),
						paletecolor[cg->chargenum+1].a * cg->frontchagerate + paletecolor[cg->chargenum].a * ( 1.0F - cg->frontchagerate ) ) ;
			DrawTex( now->kx + ax, now->ky, &chgu.texkasan[TBIND(i)], CMKC2( cr,
					(f32)255 * PLATEALPHA * ( nowrate * ( 1.0F - movrate ) + backrate * ( movrate ) ) ) ) ;

			backrate = nowrate ;
		}

		// ǂ̐JԂ
		backrate = 0.0F ;
		for( i = 0 ; i < cg->num ; i ++ )
		{
			// pӂ
//			nowind 	= cg->fronttube	+ i ;
//			nextind	= cg->fronttube	+ i + 1 ;
			nowind 	= cg->fronttube	- i ;
			nextind	= cg->fronttube	- i + 1 ;
			if( nowind	> cg->num ) nowind	-= cg->num ;
			if( nextind	> cg->num ) nextind	-= cg->num ;
			if( nowind	< 0 ) nowind		+= cg->num ;
			if( nextind	< 0 ) nextind		+= cg->num ;

//			now = &tubeinfo[TBIND(nowind)] ;
//			next = &tubeinfo[TBIND(nextind)] ;
			now = &tubeinfo[TBIND(i)] ;
			next = &tubeinfo[TBIND(( i + 1 == cg->num ) ? 0 : i+1)] ;

			nowrate = cg->tuberate[TBIND(nowind)].x ;
			nextrate = cg->tuberate[TBIND(nextind)].x ;
			
			x = (f32)( next->x - now->x ) * movrate + now->x ;
			y = (f32)( next->y - now->y ) * movrate + now->y ;
			alpha = ( (f32)( (f32)next->alpha - (f32)now->alpha ) * movrate + now->alpha ) * 0.01F ;
			scale = ( (f32)( (f32)next->scale - (f32)now->scale ) * movrate + now->scale ) * 0.01F ;
			
			// ̕`( (x+5,y+6)ɂPzuāAɌĂWƖ܂܂B8*8̑fނłB)
			//  = x + 5 + 8 * 8 + 8 = x + 77
			EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
			EffectTexColorIgnoreSetup( FALSE ) ;
			DrawTex4( x + BLOODX * scale + ax,					y + ( BLOODY - BLOODH * nowrate ) * scale,
						x + ( BLOODX + BLOODW ) * scale + ax,	y + BLOODY * scale,
						0.0F, 0.0F,
						1.0F, BLOODH * nowrate / BLOODTEXH, &chgu.texblood_8 ) ;

			// ǂ̕`
			EffectBlendModeSetup( EF_BLEND_ADD ) ;
			EffectTexColorIgnoreSetup( TRUE ) ;
			DrawExTex( x + ax, y, scale, false, &chgu.texsikenkan, CMK2( 255, alpha * 255 ) ) ;
/*
			DrawTex4( x + ax,										y,
						x + TEXW( chgu.texsikenkan ) * scale + ax,	y + TEXH( chgu.texsikenkan ) * scale,
						0.0F, 0.0F,
						1.0F, 1.0F, &chgu.texsikenkan ) ;
*/

			// Ẑ`悷
			EffectBlendModeSetup( EF_BLEND_ADD ) ;
			EffectTexColorIgnoreSetup( TRUE ) ;
			cr = CMK( paletecolor[cg->chargenum+1].r * cg->frontchagerate + paletecolor[cg->chargenum].r * ( 1.0F - cg->frontchagerate ),
						paletecolor[cg->chargenum+1].g * cg->frontchagerate + paletecolor[cg->chargenum].g * ( 1.0F - cg->frontchagerate ),
						paletecolor[cg->chargenum+1].b * cg->frontchagerate + paletecolor[cg->chargenum].b * ( 1.0F - cg->frontchagerate ),
						paletecolor[cg->chargenum+1].a * cg->frontchagerate + paletecolor[cg->chargenum].a * ( 1.0F - cg->frontchagerate ) ) ;
			DrawTex( now->kbx + ax, now->kby, &chgu.texkasanb[TBIND(i)], 
				CMKC2( cr, (f32)255 * PLATEALPHA2 * ( (f32)now->alphab * 0.01F ) * ( nowrate * ( 1.0F - movrate ) + backrate * ( movrate ) ) ) ) ;
				
			if( cg->brinkflag == true )
			{
				if( cg->brinkcon == TRUE )
				{
					f32 h, w ;
				
					// LIGHTEX
					h = TEXH(chgu.texkasanb[TBIND(i)]) ;
					w = TEXW(chgu.texkasanb[TBIND(i)]) ;
					DrawTex3( 	now->kbx + ax, 		now->kby - h,
								now->kbx + ax + w,	now->kby + h,
								&chgu.texkasanb[TBIND(i)], 
								CMKC2( cr, (f32)255 * PLATEALPHA2 * ( (f32)now->alphab * 0.01F ) * ( nowrate * ( 1.0F - movrate ) + backrate * ( movrate ) ) ) ) ;
				}
				else
				{
					DrawTex( now->kbx + ax, now->kby, &chgu.texkasanb[TBIND(i)], 
						CMKC2( cr, (f32)255 * PLATEALPHA2 * ( (f32)now->alphab * 0.01F ) * ( nowrate * ( 1.0F - movrate ) + backrate * ( movrate ) ) ) ) ;
				}
			}

			backrate = nowrate ;
		}
		cg->brinkcon = cg->brinkcon == TRUE ? FALSE : TRUE ;
	}
	
/*	// Of[V`
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;
	GBGN( GX_QUADS, 4 ) ;
	{
		GP2(  + ax, 			0 ) ;	GCX( (u32)OBILEFTALPHA ) ;
		GP2( OBIWIDTH + ax, 	0 ) ;	GCX( 0 ) ;
		GP2( OBIWIDTH + ax, 	SCH ) ;	GCX( 0 ) ;
		GP2(  + ax, 			SCH ) ;	GCX( (u32)OBILEFTALPHA ) ;
	}
	GEND() ;
*/
	
	EffectTexColorIgnoreSetup( FALSE ) ;

	// I
	return 0 ;
}


// `[WGtFNg̏s
extern bool SetupChargeEffect( void )
{
	if( chgu.SetupState != 0 ) return true ;

	// pbNt@CNX쐬
	ghmGcMemSetAllocName("YResLink");
	chgu.Pack = new YK7ResLink ;
	if( chgu.Pack == NULL ) return false ;
	
	// pbNt@Cǂݍ
	chgu.Pack->Read( PACKPATH ) ;
	
	// ZbgAbvԂ𐄈ڂ
	chgu.SetupState = 1 ;
	
	// I
	return true ;

ERR :
	if( chgu.Pack != NULL ) delete chgu.Pack ;
	
	return false ;
}

// `[WGtFNg̏̊Ԃ𒲂ׂ( false:܂  true: )
extern bool CheckSetupChargeEffect( void )
{
	if( chgu.SetupState == 2 ) return true ;
	if( chgu.SetupState == 0 ) return false ;
	
	// ǂݍݏIm
	if( chgu.Pack->GetState() != YK7ResLink::ST_IDLE ) return false ;
	
	// IĂeNX`\z
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_0), &chgu.texnum[0] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_1), &chgu.texnum[1] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_2), &chgu.texnum[2] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_3), &chgu.texnum[3] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_4), &chgu.texnum[4] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_5), &chgu.texnum[5] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_kasan01), &chgu.texkasan[0] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_kasan02), &chgu.texkasan[1] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_kasan03), &chgu.texkasan[2] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_kasan04), &chgu.texkasan[3] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_kasan05), &chgu.texkasan[4] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_kasan_b_01), &chgu.texkasanb[0] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_kasan_b_02), &chgu.texkasanb[1] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_kasan_b_03), &chgu.texkasanb[2] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_kasan_b_04), &chgu.texkasanb[3] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_kasan_b_05), &chgu.texkasanb[4] ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_moji), &chgu.texmoji ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_moji_shadow), &chgu.texmoji_shadow ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_blood_8), &chgu.texblood_8, TEX_TYPE_REPEAT ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_plate), &chgu.texplate ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_plate_line), &chgu.texplate_line ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_sikenkan), &chgu.texsikenkan ) ;
	TexLoadSetMem( chgu.Pack->GetGroup()->GetResource(DAT_waku), &chgu.texwaku ) ;
	
	// ZbgAbvԂ𐄈
	chgu.SetupState = 2 ;
	
	// I
	return true ;
}

// `[WGtFNg̏̌n
extern bool ReleaseChargeEffect( void )
{
	if( chgu.SetupState == 0 ) return true ;
	
	// eNX`̌n
	if( chgu.SetupState == 2 )
	{
		TexRelease( &chgu.texnum[0] ) ;
		TexRelease( &chgu.texnum[1] ) ;
		TexRelease( &chgu.texnum[2] ) ;
		TexRelease( &chgu.texnum[3] ) ;
		TexRelease( &chgu.texnum[4] ) ;
		TexRelease( &chgu.texnum[5] ) ;
		TexRelease( &chgu.texkasan[0] ) ;
		TexRelease( &chgu.texkasan[1] ) ;
		TexRelease( &chgu.texkasan[2] ) ;
		TexRelease( &chgu.texkasan[3] ) ;
		TexRelease( &chgu.texkasan[4] ) ;
		TexRelease( &chgu.texkasanb[0] ) ;
		TexRelease( &chgu.texkasanb[1] ) ;
		TexRelease( &chgu.texkasanb[2] ) ;
		TexRelease( &chgu.texkasanb[3] ) ;
		TexRelease( &chgu.texkasanb[4] ) ;
		TexRelease( &chgu.texmoji ) ;
		TexRelease( &chgu.texmoji_shadow ) ;
		TexRelease( &chgu.texblood_8 ) ;
		TexRelease( &chgu.texplate ) ;
		TexRelease( &chgu.texplate_line ) ;
		TexRelease( &chgu.texsikenkan ) ;
		TexRelease( &chgu.texwaku ) ;
	}
	
	// pbNt@Čn
	if( chgu.Pack != NULL ) delete chgu.Pack ;
	chgu.Pack = NULL ;
	
	// ZbgAbvԂ̏
	chgu.SetupState = 0 ;
	
	// I
	return 0 ;
}

// `[WGtFNg̎ǂ̐ύX
extern bool SetChargeEffectTubeNum( EFFECT *Effect, s32 TubeNum )
{
	CHARGEEFFECT *cg = ( CHARGEEFFECT * )Effect->Data ;
	s32 i ;

	cg->num = TubeNum ;
	for( i = 0 ; i < MAX_TUBENUM ; i ++ )
		cg->tuberate[i].init(true) ;
	cg->fronttube = 0 ;
	cg->chargenum = 0 ;
		
	// I
	return true ;
}

// `[WGtFNg̕\tOZbg( true:\  false:\Ȃ )
extern bool SetChargeEffectInFlag( EFFECT *Effect, bool InFlag )
{
	CHARGEEFFECT *cg = ( CHARGEEFFECT * )Effect->Data ;
	
	cg->InFlag = InFlag ;
	cg->inrate.mov( 1, OBIINSPEED, cg->InFlag == true ? 1.0F : 0.0F ) ;

	// I
	return 0 ;
}

// `[WGtFNgŗ܂Ă鎎ǂ̐
extern s32 GetChargeEffectChargeNum( EFFECT *Effect )
{
	CHARGEEFFECT *cg = ( CHARGEEFFECT * )Effect->Data ;
	
	return cg->chargenum ; 
}

// `[WGtFNg̓_ł̃IEItݒ肷
extern bool SetChargeEffectBrinkFlag( EFFECT *Effect, bool brinkflag )
{
	CHARGEEFFECT *cg = ( CHARGEEFFECT * )Effect->Data ;
	
	cg->brinkflag = brinkflag ;
	
	return true ; 
}

// `[WGtFNg̑эW̎ݒ@\̃IԂύX
extern bool SetChargeEffectAutoFlag( EFFECT *Effect, bool AutoFlag )
{
	CHARGEEFFECT *cg = ( CHARGEEFFECT * )Effect->Data ;
	
	cg->AutoFlag = AutoFlag ;
	
	return true ;
}


// `[WGtFNg̏oύX
extern bool SetChargeEffectInRate( EFFECT *Effect, f32 rate )
{
	CHARGEEFFECT *cg = ( CHARGEEFFECT * )Effect->Data ;
	
	if( cg->AutoFlag == true ) return true ;
	
	cg->inrate.spos( rate ) ;
	
	return true ;
}

// `[WGtFNg̏o擾
extern f32 GetChargeEffectInRate( EFFECT *Effect )
{
	CHARGEEFFECT *cg = ( CHARGEEFFECT * )Effect->Data ;
	
	return cg->inrate.x ;
}

// `[WGtFNg̍т̕𓾂
extern f32 GetChargeEffectObiWidth( void )
{
	return OBIWIDTH ;
}



