///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectConfetti
//
// YK7EffectConfetti.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/02/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTCONFETTI_H
#define __YK7EFFECTCONFETTI_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7Break.h"

// define ---------------------------------------

// datatype -------------------------------------

// GtFNgʃf[^
typedef struct tagCONFETTIUNION
{
	TEXDATA ConfettiTex ;							// ̃eNX`f[^
	s8 NotAllDrawFlag ;								// ׂĂ`悵Ȃǂ̃tO
} CONFETTIUNION ;

// IuWFNgf[^
typedef struct tagCONFETTIOBJECT
{
	Vec Point ;					// W
	Vec Speed ;					// Xs[h
	u16 Counter1, Counter2 ;	// JE^[
	GXColor Color ;				// F
	u8 ColorIndex ;				// F
	u16 WaitT, FadeT ;			// tF[hAEgp
	u8 a ;						// At@
} CONFETTIOBJECT ;

// GtFNgf[^
typedef struct tagCONFETTIEFFECT
{
	CONFETTIOBJECT *ObjP ;			// IuWFNgf[^zւ̃|C^
	s32 MaxNum ;					// IuWFNg̍ő吔
	s32 Counter ;					// pJE^[

	Vec Point ;						// W
	f32 MaxDownSpeed, MinDownSpeed ;// Ⴊ鑬x
	f32 Radius ;					// Ⴊ~锼a
	f32 YukaY ;						// ̍
	f32 CreateY ;					// 쐬鍂
	f32 Size ;						// ̑傫

	GXColor Color ;					// F
} CONFETTIEFFECT ;

// GtFNg^XNɓnf[^
typedef struct tagCONFETTIEFFECTTACKPARAM
{
	s32 MaxNum ;					// IuWFNg̍ő吔
	Vec Point ;						// GtFNg郏[hW
	f32 MaxDownSpeed, MinDownSpeed ;// Ⴊ鑬x
	f32 Radius ;					// Ⴊ~锼a
	f32 Size ;						// ̑傫
	f32 YukaY ;						// ̍
	f32 CreateY ;					// 쐬鍂
	GXColor *Color ;				// F
} CONFETTIEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitConfettiData( void ) ;				// GtFNg̋ʃf[^
extern s8 CheckConfettiData( void ) ;				// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndConfettiData( void ) ;					// GtFNg̋ʃf[^n

extern EFFECT *CreateConfettiEffect( s32 MaxNum, Vec Point,
									 f32 MaxDownSpeed, f32 MinDownSpeed, 
									f32 Radius, f32 Size,
									 f32 YukaY, f32 CreateY,
									GXColor *Color = NULL,  s32 Priority = -1 ) ;	// ̃GtFNg쐬
extern s8 ReleaseConfettiEffect( EFFECT *Effect ) ;							// ̃GtFNǧns
extern s8 MoveConfettiEffect( EFFECT *Effect ) ;							// ̃GtFNgPt[
extern s8 DrawConfettiEffect( EFFECT *Effect ) ;							// ̃GtFNg`悷

extern s8 SetConfettiEffectPoint( EFFECT *Effect, Vec Point ) ;				// Ⴊ钆S_ύX
extern s8 SetConfettiAllDrawFlag( s8 Flag ) ;								// ׂ̂Ă`悷邩ǂ̃tOZbg


#endif

