///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCountDown
//
// YK7EffectCountDown.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/13/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTCOUNTDOWN_H
#define __YK7EFFECTCOUNTDOWN_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// JEg_EGtFNgʃf[^
typedef struct tagCOUNTDOWNUNION
{
	TEXDATA loser ;
	TEXDATA loser_blur ;
	TEXDATA winner ;
	TEXDATA winner_blur ;
	TEXDATA go ;
} COUNTDOWNUNION ;

// JEg_EIuWFNgf[^
typedef struct tagCOUNTDOWNOBJECT
{
	f32 size ;
	f32 alpha ;
} COUNTDOWNOBJECT ;

// JEg_EGtFNgf[^
typedef struct tagCOUNTDOWNEFFECT
{
	COUNTDOWNOBJECT num[3] ;

	f32 gorot ;
	f32 gosize ;
	f32 goalpha ;
	
	s32 mode1, mode2, counter ;
} COUNTDOWNEFFECT ;

// JEg_EGtFNg^XNɓnf[^
typedef struct tagCOUNTDOWNEFFECTTACKPARAM
{
} COUNTDOWNEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitCountDownData( void ) ;			// JEg_EGtFNg̋ʃf[^
extern s8 CheckCountDownData( void ) ;		// JEg_EGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndCountDownData( void ) ;			// JEg_EGtFNg̋ʃf[^n

extern EFFECT *CreateCountDownEffect( s32 Priority = -1 ) ;		// JEg_EGtFNg쐬
extern s8 ReleaseCountDownEffect( EFFECT *Effect ) ;				// JEg_EGtFNǧns
extern s8 MoveCountDownEffect( EFFECT *Effect ) ;					// JEg_EGtFNgPt[
extern s8 DrawCountDownEffect( EFFECT *Effect ) ;					// JEg_EGtFNg`悷

extern s8 GetCountDownState( EFFECT *Effect ) ;			// JEg_ȄԂ𓾂( 0:3  1:2  2:1  3:go )

#endif

