///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectEasyAnim
//
// YK7EffectEasyAnim.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/01/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTEASYANIM_H
#define __YK7EFFECTEASYANIM_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7EasyAnim.h"

// define ---------------------------------------

#define ANIMPACK_MAXNUM			10				// Aj[Vf[^ǂݍ߂ő吔
#define ANIMPACK_ANIMNUM		6				// ̃Aj[Vf[^̍őR}

// ȈՃAj[VhcXg
enum
{
	ANIMID_SMALLLIGHT = 0,						// ̋P
	ANIMID_SPARK = 3,							// d̃Xp[N
	ANIMID_FIRE = 4,							// vɓĂ鉊
	ANIMID_DROPWATER = 1,						// Ă䂭
	ANIMID_DROPWATER2 = 2,						// Ē˂
	ANIMID_NEWTYPE = 5,							// j[^CvM
	ANIMID_NUM = 6,								// hc̐
} ;


// datatype -------------------------------------

// ȈՃAj[Vf[^\
typedef struct tagEASYANIMPACK
{
//	s32 UseCounter ;				// gpJE^[
	u8 UseFlag ;					// gptO
	u8 FileFlag ;					// t@Cǂݍ񂾂tO
	EASYANIMHEAD *Head ;			// ǂݍ񂾃wb_
	ghmGcFile *File ;				// t@CǂݍݎɎgNX
	GXTexObj TexObj ;				// Aj[VeNX`̃eNX`IuWFNg

//	TEXDATA *Anim ;					// Aj[Vpf[^
	TEXDATA Anim[ANIMPACK_ANIMNUM] ;
	u8 AnimNum ;					// Aԃt@Cœǂݍ񂾐
} EASYANIMPACK ;

// ȈՃAjGtFNgʃf[^
typedef struct tagEASYANIMUNION
{
	EASYANIMPACK AnimPack[ANIMPACK_MAXNUM] ;		// Aj[VpbNf[^
	u8 AnimPackNum ;								// Aj[VpbN̐

	s32 AnimPackID[ANIMID_NUM], AnimPackCounter[ANIMID_NUM] ;		// Aj[VpbNf[^̃pbNf[^hc
	s8 NotDrawFlag ;												// `tO
} EASYANIMUNION ;

// ȈՃAjGtFNgf[^
typedef struct tagEASYANIMEFFECT
{
	s8 AnimPackID ;				// gpĂAj[VpbN̂hc
	Vec Point ;					// \W
	Vec Size ;					// \ۂ̃TCY
	u8 AddBlendFlag ;			// ZuhtO

	u32 AnimPatNum ;			// p^[ڂ̃Aj[VĂ邩A̒l
	u32	AnimCounter ;			// Aj[VJE^[(`bN^C)
	u32 WaitFrameTime ;			// ҂t[^C
	s8 DrawFlag ;				// `tO
	s8 NonLoopFlag ;			// Aj[V𖳎ĂP[vŃAj[VI点邩tO
	s8 Pos2DFlag ;				// nꂽW͂QcWǂ̃tO
} EASYANIMEFFECT ;

// ȈՃAjGtFNgf[^p\
typedef struct tagEASYANIMEFFECTTASKPARAM
{
	s8 AnimPackID ;				// gpĂAj[VpbN̂hc
	Vec Point ;					// \W
	Vec Size ;					// \ۂ̃TCY
	u8 AddBlendFlag ;			// ZuhtO
	s32 Sound ;					// ( -1:炳Ȃ )
	s8 NonLoopFlag ;			// Aj[V𖳎ĂP[vŃAj[VI点邩tO
	s8 Pos2DFlag ;				// nꂽW͂QcWǂ̃tO
} EASYANIMEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitEasyAnimData( void ) ;			// ȈՃAjGtFNg̋ʃf[^
extern s8 CheckEasyAnimData( void ) ;			// ȈՃAjGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndEasyAnimData( void ) ;				// ȈՃAjGtFNg̋ʃf[^n

extern EFFECT *CreateEasyAnimEffect( s8 AnimPackID, Vec Point, Vec Size,
										u8 AddBlendFlag, s32 Sound, s8 NonLoopFlag = FALSE, s8 Pos2DFlag = FALSE,
										 s32 Priority = -130 ) ;	// ȈՃAjGtFNg쐬
extern EFFECT *CreateEasyAnimEffect2( s8 AnimID, Vec Point, Vec Size,
										u8 AddBlendFlag, s32 Sound, s8 NonLoopFlag = FALSE, s8 Pos2DFlag = FALSE,
										 s32 Priority = -130 ) ;	// ȈՃAjGtFNg쐬2
extern s8 ReleaseEasyAnimEffect( EFFECT *Effect ) ;							// ȈՃAjGtFNǧns
extern s8 MoveEasyAnimEffect( EFFECT *Effect ) ;							// ȈՃAjGtFNgPt[
extern s8 DrawEasyAnimEffect( EFFECT *Effect ) ;							// ȈՃAjGtFNg`悷

extern s8 SetEasyAnimPoint( EFFECT *Effect, Vec Point ) ;					// ȈՃAj`悷WύX
extern s8 SetEasyAnimDrawFlag( EFFECT *Effect, u8 DrawFlag ) ;				// `tOZbg( TRUE:`  FALSE:` )

extern s8 LoadEasyAnimData( char *FileName ) ;								// ȈՃAj[Vf[^ǂݍ
extern s8 SetupEasyAnimData( void *AnimData ) ;								// ȈՃAj[Vf[^(bin)Zbg(Rs[͂܂̂ ReleaseEasyAnimData ܂œnf[^͉Ȃł)
extern s8 ReleaseEasyAnimData( s8 AnimPackID ) ;							// ȈՃAj[Vf[^
extern s8 CheckEasyAnimDataLoadState( s8 AnimPackID ) ;						// ȈՃAj[Vf[^ǂݍ܂Ă邩ǂ`FbN( TRUE:ǂݍ܂Ă  FALSE:ǂݍ܂ĂȂ )

extern s8 LoadEasyAnimPack( s8 AnimID ) ;									// Aj[Vf[^[h
extern s8 ReleaseEasyAnimPack( s8 AnimID ) ;								// Aj[Vf[^
extern s8 CheckEasyAnimPackLoadState( s8 AnimID ) ;							// Aj[Vf[^ǂݍ܂Ă邩ǂ`FbN( TRUE:ǂݍ܂Ă   FALSE:ǂݍ܂ĂȂ )

extern s8 SetEasyAnimAllDrawFlag( s8 Flag ) ;								// ȈՃAjGtFNg`悷邩ǂ̃tOZbg

#endif
