///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectExplode
//
// YK7EffectExplode.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/04/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTEXPLODE_H
#define __YK7EFFECTEXPLODE_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Archive.h"

// define ---------------------------------------

enum
{
	EXP_MSK_NORMAL = 1,
	EXP_MSK_SPARK = 4,
} ;

#define MAX_ANIMENUM		24
#define MAX_EXPLODE			10			// ő唚

// datatype -------------------------------------

// p[^␳pf[^\
typedef struct tagSMEXPDEF
{
	f32 Length, Num, Size, ASize ;
} SMEXPDEF ;

// GtFNgAj[Vpf[^
typedef struct tagEXPLODEANIME
{
	u8 UseFlag ;				// gptO
	WK7Archive *Archive ;		// ̔ȈʒuAj[VA[JCuf[^
	WK7Model *Model ;			// ff[^
	WK7ModelMotion *Anim ;		// Aj[Vf[^
	WK7JObj *TopObj ;			// gbvIuWFNg
	EFFECT *UseEffect ;			// gpĂGtFNgf[^̃|C^
} EXPLODEANIME ;

// GtFNgʃf[^
typedef struct tagEXPLODEUNION
{
	TEXDATA TestRgbTex[MAX_ANIMENUM] ;		// eXgqfaeNX`
//	TEXDATA TestAlphaTex[MAX_ANIMENUM] ;	// eXgAt@eNX`
//	TEXTURE TestRgbTex[MAX_ANIMENUM] ;		// eXgqfaeNX`
//	TEXTURE TestAlphaTex[MAX_ANIMENUM] ;	// eXgAt@eNX`
//	ghmGcFile *TexFileTestRgb[MAX_ANIMENUM] ;// eXgqfaeNX` ghmGcFile
//	ghmGcFile *TexFileTestAlpha[MAX_ANIMENUM] ;// eXgAt@eNX` ghmGcFile
	
	EXPLODEANIME Anime[MAX_EXPLODE] ;		// ̔ȈʒuAj[VA[JCuf[^
	u8 NextUseID ;							// Ɏghcʒu
	WK7Archive *ModelArc ;					// ff[^ƃ[Vf[^A[JCut@C
} EXPLODEUNION ;

// GtFNgf[^
typedef struct tagEXPLODEEFFECT
{
	WK7Model *Model ;			// ff[^
	WK7ModelMotion *Anim ;		// Aj[Vf[^
	WK7JObj *TopObj ;			// gbvIuWFNg
	u8 AnimID ;					// Aj[Vhc
//	EXPLODEANIME *AnimeData ;	// Aj[Vf[^
	Vec Point ;					// W
	u32 Counter ;				// JE^[
	f32 Size ;					// TCY
	u8 BomAnimFlag ;		// ̈ړAj[VstO
} EXPLODEEFFECT ;

// GtFNg^XNɓnf[^
typedef struct tagEXPLODEEFFECTTACKPARAM
{
	Vec Point ;				// W
	f32 Size ;				// TCY
	u8 BomAnimFlag ;		// ̈ړAj[VstO
} EXPLODEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitExplodeData( void ) ;				// GtFNg̋ʃf[^
extern s8 CheckExplodeData( void ) ;			// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndExplodeData( void ) ;				// GtFNg̋ʃf[^n

//extern void ExplodeEffectTask( ghmGcTask *pTask ) ;								// GtFNg^XN

extern EFFECT *CreateExplodeEffect( Vec Point, f32 Size, u8 BomAnimFlag, s32 Priority = -2 ) ;		// GtFNg쐬
extern EFFECT *CreateSmokeExplodeEffect( Vec Point, f32 Size, u8 ExplodeTypeNumber, u32 Color = 0, EFFECT **Effect1 = NULL, EFFECT **Effect2 = NULL ) ;				// GtFNg쐬
extern s8 ReleaseExplodeEffect( EFFECT *Effect ) ;									// GtFNǧns
extern s8 MoveExplodeEffect( EFFECT *Effect ) ;										// GtFNgPt[
extern s8 DrawExplodeEffect( EFFECT *Effect ) ;										// GtFNg`悷

extern s8 GetSmokeExDef( Vec Pos, SMEXPDEF *buf ) ;

#endif
