///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFeather
//
// YK7EffectFeather.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 09/22/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTFEATHER_H
#define __YK7EFFECTFEATHER_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7Break.h"

// define ---------------------------------------

#define FEATHER_MODELNUM		3			// Hf̐

// datatype -------------------------------------

// HGtFNgʃf[^
typedef struct tagFEATHERUNION
{
	TEXDATA FeatherTex ;							// H̃eNX`f[^
	WK7Archive *FeatherArc ;						// Hf̃A[JCu
	WK7Model *FeatherK7Model ;						// Hf̃ff[^
	BASICMESH *FeatherMesh[FEATHER_MODELNUM] ;		// H̃ff[^	
	u8 LoadCompFlag ;								// [htO
} FEATHERUNION ;

// HIuWFNgf[^
typedef struct tagFEATHEROBJECT
{
	u8 ValidFlag ;				// LtO
	Vec Point ;					// W
	Vec Speed ;					// Xs[h
	Vec Rotate ;				// ]ix, y, z ̏)
	Vec RotSpeed ;				// ]x
	u8 UseModel ;				// gpHf̃CfbNX
	u16 Counter ;				// JE^[
	u8 Alpha ;					// `掞̃At@l
	GXColor Color ;				// J[
} FEATHEROBJECT ;

// HGtFNgf[^
typedef struct tagFEATHEREFFECT
{
	u8 MoveMode ;					// 샂[h(0:[h  1:郂[h)
	FEATHEROBJECT *ObjP ;			// HIuWFNgf[^zւ̃|C^
	Vec Point ;						// W
	u8 Mode ;						// `惂[h(0:Add  1:Alpha)
	s32 ObjNum ;					// HIuWFNg̐
	s32 FadeOutNum ;				// tF[hAEgH̐
	u16 Counter ;					// pJE^[
	f32 Power ;						// HröЗ
	f32 RotSpeed ;					// ]Xs[h
	u8 QuickTime ;					// HɔԎ
	f32 QuickRate ;					// ̑x̔{
	f32 DownSpeed ;					// H鑬x
	u8 CrtTime ;					// n߂܂ł̎
	u8 FadeSpeed ;					// n߂Ă̏܂ł̑x
	f32 Air ;						// CRx
	f32 FeatherR ;					// H~锼a
	f32 FeatherCounter ;			// H~点JE^
	f32 OneFeatherPoint ;			// HꖇôɕKvȃJEgl
	
	s8 WaitTime ;					// ҂
	f32 Size ;						// TCY
} FEATHEREFFECT ;

// HGtFNg^XNɓnf[^
typedef struct tagFEATHEREFFECTTACKPARAM
{
	s32 FetherNum ;					// HIuWFNg̐
	Vec Point ;						// HGtFNg郏[hW
	f32 Power ;						// HröЗ
	f32 RotSpeed ;					// ]Xs[h
	u8 QuickTime ;					// HɔԎ
	f32 QuickRate ;					// ̑x̔{
	f32 DownSpeed ;					// H鑬x
	u8 CrtTime ;					// n߂܂ł̎
	u8 FadeSpeed ;					// n߂Ă̏܂ł̑x
	f32 Air ;						// CRx
	f32 FeatherR ;					// H~锼a
	u8 MoveMode ;					// 샂[h(0:H[h  1:H~胂[h)
	f32 Size ;						// TCY
} FEATHEREFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitFeatherData( void ) ;				// HGtFNg̋ʃf[^
extern s8 CheckFeatherData( void ) ;			// HGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndFeatherData( void ) ;				// HGtFNg̋ʃf[^n

extern EFFECT *CreateFeatherEffect( s32 FetherNum, Vec Point, f32 Power, f32 RotSpeed, 
									u8 QuickTime, f32 QuickRate, f32 DownSpeed,
									u8 CrtTime, u8 FadeSpeed, f32 Air, f32 FeatherR = 0.0F,
									u8 MoveMode = 0, WK7JObj *JObj = NULL, s8 WaitTime = 0,
									f32 Size = 1.0F,  s32 Priority = -1 ) ;	// H̃GtFNg쐬
extern s8 ReleaseFeatherEffect( EFFECT *Effect ) ;							// H̃GtFNǧns
extern s8 MoveFeatherEffect( EFFECT *Effect ) ;								// H̃GtFNgPt[
extern s8 DrawFeatherEffect( EFFECT *Effect ) ;								// H̃GtFNg`悷

extern s8 SetFeatherEffectPoint( EFFECT *Effect, Vec Point ) ;				// H钆S_ύX

#endif

