///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFlashLine
//
// YK7EffectFlashLine.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/20/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTFLASHLINE_H
#define __YK7EFFECTFLASHLINE_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// tbVCGtFNgʃf[^
typedef struct tagFLASHLINEUNION
{
	u8 dummy ;
} FLASHLINEUNION ;

// tbVCGtFNgIuWFNgf[^
typedef struct tagFLASHLINEOBJECT
{
	f32 Rotate ;				// px
	f32 RotSpeed ;				// ]Xs[h
	f32 MaxWidth ;				// ő啝
} FLASHLINEOBJECT ;

// tbVCGtFNgf[^
typedef struct tagFLASHLINEEFFECT
{
	u8 FlashMode ;				// [h(0:яoĖ߂ 1:Jĕ邾)
	Vec Point ;					// RcW

	FLASHLINEOBJECT	*LineObj ;	// IuWFNg
	u16 LineNum ;				// ̐

	u16 WidthWait ;				// ωn߂܂ł̎
	f32 WidthTime ;				// ő啝ɂȂ܂ł̎
	f32 MaxWidth ;				// C̍ő啝
	f32 RSpeed ;				// C̔a鑬
	f32 MaxR ;					// C̍ő唼a
	u16 CenterAlphaWait ;		// St߂ɂȂn߂܂ł̎
	f32 CenterAlphaSpeed ;		// St߂ɂȂ鑬x
	f32 MaxCenterAlphaR ;		// St߂̓̍̕ő唼a

	u16 FadeOutWait ;			// n܂܂ł̎
	f32 CenterAlphaFadeSpeed ;	// St߂̎x
	f32 RFadeSpeed ;			// a̎x	
	u16 FadeOutTime ;			// 鎞

	f32 AlphaGradLength ;		// St߂̉~̃Of[V̊̕(1.0:SgăOf[V)
	f32 RGradLength ;			// ÕOf[V̒
	u8 R, G, B ;				// F
	
	f32 NoAlphaR, AlphaR ;				// aƓa
	u16 Counter ;				// ėpJE^
	f32 Width ;					// C̕
	u8 Mode ;					// 샂[h(0:g 1:)
} FLASHLINEEFFECT ;

// tbVCGtFNg^XNɓnf[^
typedef struct tagFLASHLINEEFFECTTACKPARAM
{
	u8 FlashMode ;					// [h(0:яoĖ߂ 1:Jĕ邾)
	Vec Point ;					// RcW

	u16 LineNum ;				// ̐

	u16 WidthWait ;				// ωn߂܂ł̎
	f32 WidthTime ;				// ő啝ɂȂ܂ł̎
	f32 MaxWidth ;				// C̍ő啝
	f32 RSpeed ;				// C̔a鑬
	f32 MaxR ;					// C̍ő唼a
	u16 CenterAlphaWait ;		// St߂ɂȂn߂܂ł̎
	f32 CenterAlphaSpeed ;		// St߂ɂȂ鑬x
	f32 MaxCenterAlphaR ;		// St߂̓̍̕ő唼a

	u16 FadeOutWait ;			// n܂܂ł̎
	f32 CenterAlphaFadeSpeed ;	// St߂̎x
	f32 RFadeSpeed ;			// a̎x	
	u16 FadeOutTime ;			// 鎞

	f32 AlphaGradLength ;		// St߂̉~̃Of[V̊̕(1.0:SgăOf[V)
	f32 RGradLength ;			// ÕOf[V̒
	u8 R, G, B ;				// F
} FLASHLINEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitFlashLineData( void ) ;				// tbVCGtFNg̋ʃf[^
extern s8 CheckFlashLineData( void ) ;				// tbVCGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndFlashLineData( void ) ;				// tbVCGtFNg̋ʃf[^n

//extern void FlashLineEffectTask( ghmGcTask *pTask ) ;								// tbVCGtFNg^XN

extern EFFECT *CreateFlashLineEffect( u8 Mode, Vec Point, u16 LineNum,
									u16 WidthWait, f32 WidthTime, f32 MaxWidth,
									f32 RSpeed, f32 MaxR,
									u16 CenterAlphaWait, f32 CenterAlphaSpeed,
									u16 FadeOutWait,
									f32 CenterAlphaFadeSpeed, f32 RFadeSpeed, u16 FadeOutTime,
									f32 AlphaGradLength, f32 RGradLength,
									u8 R, u8 G, u8 B,
									s32 Priority = -1 ) ;							// tbVCGtFNg쐬
extern s8 ReleaseFlashLineEffect( EFFECT *Effect ) ;								// tbVCGtFNǧns
extern s8 MoveFlashLineEffect( EFFECT *Effect ) ;									// tbVCGtFNgPt[
extern s8 DrawFlashLineEffect( EFFECT *Effect ) ;									// tbVCGtFNg`悷

#endif
