///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectGauge
//
// YK7EffectGauge.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 08/07/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTGAUGE_H
#define __YK7EFFECTGAUGE_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7Move.h"

// define ---------------------------------------

#define GAUGE_MAXNUM	400				// Q[WC̍ő吔

// datatype -------------------------------------

// Q[WGtFNgʃf[^
typedef struct tagGAUGEUNION
{
	u8 Dummy ;
} GAUGEUNION ;

// Q[WIuWFNgf[^
typedef struct tagGAUGEOBJECT
{
	u8 UseFlag ;					// gptO

	f32 Persent ;					// ̒( 1.0F:LтĂ  0.0F:LтĂȂ )
	f32 Speed ;						// LтXs[h
	f32 Length ;					// Ŝ̒
	f32 Time ;						// ^C
	f32 AllTime ;					// Ŝ̃^C
} GAUGEOBJECT ;

// Q[WGtFNgf[^
typedef struct tagGAUGEEFFECT
{
	GAUGEOBJECT Line[GAUGE_MAXNUM] ;		// Q[Wf[^
	u16 LineNum ;							// Q[W̐
	
	GXColor Color ;							// F
	f32 MaxSpeed ;							// őXs[h
	f32 MinSpeed ;							// ŏXs[h
	
	Vec	Point ;								// `W

	u8 MaxLineNum ;							// ő僉C( MAX:GAUGE_MAXNUM )
	u16 Length ;							// 
	f32 Rate ;								// ő̒肷郌[g
	u8 Alpha ;								// At@l
	
	u8 Mode ;								// \[h( 0:[h 1:[^[[h )
	u8 Mode2 ;								// ڏ
	s32 Counter ;							// JE^
	CMov len ;								// ɐLт̒
} GAUGEEFFECT ;

// Q[WGtFNg^XNɓnf[^
typedef struct tagGAUGEEFFECTTACKPARAM
{
	u8 MaxLineNum ;				// ő僉C( MAX:GAUGE_MAXNUM )
	u16 Length ;				// 
	f32 Rate ;					// ő̒肷郌[g

	GXColor Color ;				// F
	f32 MaxSpeed ;				// őXs[h
	f32 MinSpeed ;				// ŏXs[h

	Vec	Point ;					// `W
} GAUGEEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitGaugeData( void ) ;					// Q[WGtFNg̋ʃf[^
extern s8 CheckGaugeData( void ) ;					// Q[WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndGaugeData( void ) ;					// Q[WGtFNg̋ʃf[^n

extern EFFECT *CreateGaugeEffect( u8 MaxLineNum, u16 Length, Vec Point, f32 Rate, 
								 GXColor Color, f32 MaxSpeed, f32 MinSpeed, u8 InitMode = 0, s32 Priority = 6000 ) ;		// Q[W̃GtFNg쐬
extern s8 ReleaseGaugeEffect( EFFECT *Effect ) ;											// Q[W̃GtFNǧns
extern s8 MoveGaugeEffect( EFFECT *Effect ) ;												// Q[W̃GtFNgPt[
extern s8 DrawGaugeEffect( EFFECT *Effect ) ;												// Q[W̃GtFNg`悷

extern s8 SetUseGaugeEffect( EFFECT *Effect, u8 LineNum )  ;								// gpQ[WC̐ύX
extern s8 SetGaugeAlpha( u8 Alpha, EFFECT *Effect ) ;										// Q[WC̃At@lZbg
extern s8 SetGaugeMode( u8 Mode, EFFECT *Effect ) ;											// Q[W̕\[hύX
extern s8 SetGaugeRate( f32 Rate, EFFECT *Effect ) ;										// ̒ݒ肷

#endif