///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectGore
//
// YK7EffectGore.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 07/24/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTGORE_H
#define __YK7EFFECTGORE_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// ЃGtFNgʃf[^
typedef struct tagGOREUNION
{
	TEXDATA GoreTex ;			// ЃeNX`̃f[^
} GOREUNION ;

// ЃGtFNgf[^
typedef struct tagGOREEFFECT
{
	u32 Mode ;					// [h
	u32 Counter1, Counter2 ;	// ėpJE^[
	
	Vec Point ;					// Ђ`悷鍶W(QcW)
	f32 Width, Height ;			// ƍ
	u16 UpTime ;				// Ђ͂肷܂ł̎
	u16 alpha ;					// At@
} GOREEFFECT ;

// ЃGtFNgf[^p\
typedef struct tagGOREEFFECTTASKPARAM
{
	Vec Point ;					// Ђ`悷鍶W(QcW)
	f32 Width, Height ;			// ƍ
	u16 UpTime ;				// Ђ͂肷܂ł̎
} GOREEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitGoreData( void ) ;			// ЃGtFNg̋ʃf[^
extern s8 CheckGoreData( void ) ;			// ЃGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndGoreData( void ) ;				// ЃGtFNg̋ʃf[^n

extern EFFECT *CreateGoreEffect( Vec Point, f32 Width, f32 Height, u16 UpTime, s32 Priority = 6000 ) ;	// ЃGtFNg쐬
extern s8 ReleaseGoreEffect( EFFECT *Effect ) ;							// ЃGtFNǧns
extern s8 MoveGoreEffect( EFFECT *Effect ) ;							// ЃGtFNgPt[
extern s8 DrawGoreEffect( EFFECT *Effect ) ;							// ЃGtFNg`悷

#endif
