///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectHSDead
//
// YK7EffectHSDead.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/27/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTHSDEAD_H
#define __YK7EFFECTHSDEAD_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"
#include "./YK7EffectBlood.h"

// define ---------------------------------------

#define MAXBLOODEFFECTNUM		100

// datatype -------------------------------------

// wuX}CSGtFNgʃf[^
typedef struct tagHSDEADUNION
{
	f32 TimeRate ;							// GtFNg̓ɑ΂␳l

	GXColor color1, color2 ;				// F
	bool colorflag ;						// FwtO

	f32 size ;								// ̃TCY
	bool sizeflag ;							// ̃TCYwtO

	f32 noGRate ;							// d͂̉e󂯂Ȃ
	bool noGRateFlag ;						// d͂̉e󂯂Ȃϐ̗LtO

	f32 Range ;								// łɑ΂镝
	bool RangeFlag ;						// łɑ΂镝̗LtO

	f32 DirIgnore ;							// ł𖳎闦
	bool DirIgnoreFlag ;					// ł𖳎闦̗LtO

	f32 MinPower ;							// łŏx
	bool MinPowerFlag ;						// łŏx̗LtO

	f32 FadeY ;								// n߂x̍
	bool FadeYFlag ;						// n߂x̗̍LtO
} HSDEADUNION ;

// ̏
typedef struct tagBLOODINFO
{
	Vec Point, Speed, Acceleration ;		// WƑxƉx
} BLOODINFO ;

// wuX}CSGtFNg^XNɓnf[^
typedef struct tagHSDEADEFFECTTACKPARAM
{
	WK7JObj *JObj ;		// 镔ʂ HSD_JObj 
	Vec Direction ;			// 
	f32 Power ;				// ̐
	f32 YukaY ;				// ̍(yWl)
	u16 BloodNum ;			// юUl̗ʁB(P`Rʂ育낾Ǝv܂)
	u8 Wait ;				// ҂
	u8 Mode ;				// [h(0:ŏČオxArxNgς郂[h
							//			1:X[ɂȂ邪AxNgς炸Ad͂ʂɂ 
							//			2:X[ɂȂ炸Ad͂ʂɂ
							//			3:ӂӂ炵ȂYɔł )
							//			4:mode0 ɕ̊𒲐
	s32 Priority ;			// Dx

	BLOODINFO *BInfo ;		// ̏̔zւ̃|C^
	u32 BInfoNum ;			// ̏̐
	u32 BInfoMaxNum ;		// ̏̍ő吔
	u8 BloodEffectDeleteFlag ;	// GtFNg͍쐬폜Ă܂tO

	u8 ConveFlag ;				// stO
	u8 ConveWaitTime ;			// zނ܂ő҂
	f32 ConvePower ;			// ͂̋
	u8 BloodTexNumber ;			// gp錌eNX`io[
	s8 ImpactFlag ;				// ʂh炷tO
	s8 ReverseFlag ;			// юÛł͂Ȃ邩ǂ̃tO
	f32 FadeOutWait ;			// tF[hAEg܂ł̎( 1.0F  )

	f32 TimeRate ;	
} HSDEADEFFECTTASKPARAM ;

// wuX}CSGtFNgf[^
typedef struct tagHSDEADEFFECT
{
	u8 Counter ;
	EFFECT *MeshEffect ;
	EFFECT *Eff ;
	u32 EffID ;

	f32 noGRate ;							// d͂̉e󂯂Ȃ
	bool noGRateFlag ;						// d͂̉e󂯂Ȃϐ̗LtO

	f32 Range ;								// d͂̉e󂯂Ȃ
	bool RangeFlag ;						// d͂̉e󂯂Ȃϐ̗LtO

	f32 DirIgnore ;							// ł𖳎闦
	bool DirIgnoreFlag ;					// ł𖳎闦̗LtO
	
	f32 MinPower ;							// łŏx
	bool MinPowerFlag ;						// łŏx̗LtO

	f32 FadeY ;								// n߂x̍
	bool FadeYFlag ;						// n߂x̗̍LtO
	
//	EFFECT *Eff[MAXBLOODEFFECTNUM] ;
//	u32 EffID[MAXBLOODEFFECTNUM] ;
//	s32 EffNum ;
	
	HSDEADEFFECTTASKPARAM Param ;
} HSDEADEFFECT ;


// prototype ------------------------------------

extern s8 InitHSDeadData( void ) ;				// wuX}CSGtFNg̋ʃf[^
extern s8 CheckHSDeadData( void ) ;				// wuX}CSGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndHSDeadData( void ) ;				// wuX}CSGtFNg̋ʃf[^n

extern EFFECT *CreateHSDeadEffect( WK7JObj *JObj,						// GtFNg JObj
									Vec Direction,						// ɔł
									f32 Power,							// ł
									f32 YukaY,							// t̍
									u16 BloodNum,						// ̗̗ʂɊւl
									u8 Wait = 0,						// ܂ł̑҂
									u8 Mode = 0,						// [h(0:ŏČオxArxNgς郂[h
																		//			1:X[ɂȂ邪AxNgς炸Ad͂ʂɂ 
																		//			2:X[ɂȂ炸Ad͂ʂɂ
																		//			3:ӂӂ炵ȂYɔł )
																		//			4:mode0 ɕ̊𒲐
									BLOODINFO *BInfo = NULL,			// ̔ˏ񂪗~ꍇ NULL ȊO
									u32 BInfoMaxNum = 3000,				// BInfo œn̐
									s32 *BInfoNumBuffer = NULL,			// BInfo ֌W
									u8 BloodEffectDeleteFlag = FALSE,	
									u8 ConveFlag = FALSE,
									u8 ConveWaitTime = 10,
									f32 ConvePower = 1.0F,
									u8 BloodTexNumber = BLOODTEX_BLOOD,
									s8 ImpactFlag = TRUE,
									s8 ReverseFlag = FALSE,
									f32 FadeOutWait = 1.0F,
									s32 Priority = -130 ) ;		// wuX}CSGtFNg쐬
extern s8 ReleaseHSDeadEffect( EFFECT *Effect ) ;			// wuX}CSGtFNǧns
extern s8 MoveHSDeadEffect( EFFECT *Effect ) ;				// wuX}CSGtFNgPt[
extern s8 DrawHSDeadEffect( EFFECT *Effect ) ;				// wuX}CSGtFNg`悷

extern s8 GetHSDeadConveState( EFFECT *Effect ) ;			// Iǂ𓾂( TRUE:  FALSE:܂ )

extern s32 ConvModelBlood( BLOODINFO **Info, WK7Model *Model, u16 Num, f32 Power ) ;	// ̍WƔł䂭擾
extern s8 SetHSDeadEffectNoGBloodRate( f32 Rate ) ;						// wuX}CSGtFNg̏d͂̉e̊ݒ肷
extern s8 SetHSDeadEffectTimeRate( f32 Rate ) ;							// wuX}CSGtFNg̓쎞Ԃɑ΂␳lݒ肷
extern s8 SetHSDeadEffectColor( GXColor color1, GXColor color2 ) ;		// ɍ쐬wuX}CSGtFNg̐Fݒ肷
extern s8 SetHSDeadEffectColor( u32 color1, u32 color2 ) ;				// ɍ쐬wuX}CSGtFNg̐Fݒ肷
extern s8 SetHSDeadEffectBloodSize( f32 Size ) ;						// ɍ쐬wuX}CSGtFNǧ̃TCYݒ肷
extern s8 SetHSDeadEffectRange( f32 Range ) ;							// ɍ쐬wuX}CSGtFNǧłɑ΂镝
extern s8 SetHSDeadEffectDirIgnore( f32 DirIgnore ) ;					// ɍ쐬wuX}CSGtFNǧł𖳎闦
extern s8 SetHSDeadEffectMinPower( f32 MinPower ) ;						// ɍ쐬wuX}CSGtFNǧłŏx̗
extern s8 SetHSDeadEffectFadeY( f32 FadeY ) ;							// ɍ쐬wuX}CSGtFNǧn߂鍂ݒ肷

#endif