///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectHSLaser
//
// YK7EffectHSLaser.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/14/2004
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectHSLaser.h"

// define ---------------------------------------

// data -----------------------------------------

HSLASERUNION HSLUnion ;

// datatype -------------------------------------

// function code --------------------------------

// gr[U[GtFNg̋ʃf[^
extern s8 InitHSLaserData( void )
{
	MEMINIT( HSLUnion ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}

// gr[U[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckHSLaserData( void )
{
	return TRUE ;
}

// gr[U[GtFNg̋ʃf[^n
extern s8 EndHSLaserData( void )
{
	MEMINIT( HSLUnion ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// gr[U[GtFNg쐬
extern EFFECT *CreateHSLaserEffect( Vec Pos, Vec Dir, f32 Length, f32 Width,
									GXColor Color, u16 DivNum, f32 YukaY,
									f32 RingSpace, f32 RingSpeed,
									f32 RingCounter, f32 RingWidth, s32 Priority )
{
	EFFECT *Effect ;
	HSLASEREFFECT *HLP ;
	
	RingSpace = RingSpace ;
	RingSpeed = RingSpeed ;
	RingCounter = RingCounter ;
	RingWidth = RingWidth ;
	
	// Vgr[U[f[^쐬
	Effect = AddEffectData( EFF_HSLASER, (void**)&HLP, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// gr[U[f[^
	HLP->Pos = Pos ;
	HLP->Dir = Dir ;
	HLP->Length = Length ;
	HLP->Width = Width ;
	HLP->Color = Color ;
	HLP->DivNum = DivNum ;
	HLP->LightRate = 0.0F ;
	HLP->YukaY = YukaY ;
	HLP->RingShot = NULL ;
	HLP->Laser = NULL ;
	HLP->DrawFlag = TRUE ;
	HLP->CrtFlag = FALSE ;
	HLP->FastDeleteFlag = FALSE ;

	// I
	return Effect ;
}

// gr[U[GtFNǧns
extern s8 ReleaseHSLaserEffect( EFFECT *Effect )
{
	HSLASEREFFECT *HLs = ( HSLASEREFFECT * )Effect->Data ;

	// ɂ邱ƂȂ

	// I
	return 0 ;
}

// gr[U[GtFNgPt[
extern s8 MoveHSLaserEffect( EFFECT *Effect )
{
	HSLASEREFFECT *HLs = ( HSLASEREFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// U폜tOĂ邩A
	// 폜tOĂāAgr[U[̃oCAXO폜
	if( ( Effect->DelReqFlag == TRUE && HLs->LightRate == 0.0F ) ||
		HLs->FastDeleteFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// `tOĂ邩ǂŃoCAX̒lω
	if( HLs->CrtFlag == TRUE )
	{
		HLs->LightRate += VParam[ED_HSLASER][7] * 0.01F ;
		if( HLs->LightRate >= 1.0F ) HLs->LightRate = 1.0F ;
	}
	else
	{
		HLs->LightRate -= VParam[ED_HSLASER][7] * 0.01F ;
		if( HLs->LightRate < 0.0F ) HLs->LightRate = 0.0F ;
	}

	// I
	return 0 ;
}

// gr[U[GtFNg`悷
extern s8 DrawHSLaserEffect( EFFECT *Effect )
{
	HSLASEREFFECT *HLs = ( HSLASEREFFECT * )Effect->Data ;
//	f32 CrtLength ;

	// `tO|Ă`悵Ȃ
	if( HLs->DrawFlag == FALSE ) return 0 ;

	// I
	return 0 ;
}

// gr[U[GtFNg̔˓_ƌݒ肷
extern s8 SetHSLaserEffectPos( EFFECT *Effect, Vec *Pos, Vec *Dir )
{
	HSLASEREFFECT *HLs = ( HSLASEREFFECT * )Effect->Data ;

	if( Pos != NULL ) HLs->Pos = *Pos ;
	if( Dir != NULL ) HLs->Dir = *Dir ;
	
	// I
	return 0 ;
}

// gr[U[GtFNg`悷邩ǂZbg(nIȂ)
extern s8 SetHSLaserEffectDrawFlag( EFFECT *Effect, s8 DrawFlag )
{
	HSLASEREFFECT *HLs = ( HSLASEREFFECT * )Effect->Data ;
	
	HLs->DrawFlag = DrawFlag ;
	
	// I
	return 0 ;
}

// gr[U[GtFNg`悷邩ǂZbg(tF[ho[W)
extern s8 SetHSLaserEffectRenderFlag( EFFECT *Effect, s8 RenderFlag )
{
	HSLASEREFFECT *HLs = ( HSLASEREFFECT * )Effect->Data ;
	
	HLs->CrtFlag = RenderFlag ;

	// I
	return 0 ;
}




