///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectKiraKira
//
// YK7EffectKiraKira.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/30/2003
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectKiraKira.h"
#include "./YK7EffectBillboard.h"

// define ---------------------------------------

// data type ------------------------------------

// data -----------------------------------------

static KIRAKIRAUNION KRU ;

// function proto type --------------------------

// function code --------------------------------

// LLGtFNg̋ʃf[^
extern s8 InitKiraKiraData( void )
{
	MEMINIT(KRU) ;

	LoadBillboardImage( BILLID_KIRAKIRA ) ;

	// I
	return 0 ;
}

// LLGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckKiraKiraData( void )
{
	if( CheckBillboardImageLoadState( BILLID_KIRAKIRA ) == FALSE ) return FALSE ;

	return TRUE ;
}


// LLGtFNg̋ʃf[^n
extern s8 EndKiraKiraData( void )
{
	ReleaseBillboardImage( BILLID_KIRAKIRA ) ;
	
	MEMINIT(KRU) ;

	// I
	return 0 ;
}




// LLGtFNg쐬
extern EFFECT *CreateKiraKiraEffect(
						Vec Pos,						// W
						u32 Color,						// F
						f32 Size,						// TCY
						f32 CreateCost,					// 쐬RXg
						s32 Priority )
{
	EFFECT *Effect ;
	KIRAKIRAEFFECT *kr ;
	KIRAKIRAOBJECT *ob ;
	u32 i ;

	// VCf[^쐬
	Effect = AddEffectData( EFF_KIRAKIRA, (void**)&kr, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// p[^ۑE
	kr->Pos				= Pos ;
	kr->Color			= Color ;
	kr->Size			= Size ;
	kr->CreateCost		= CreateCost ;
	kr->CreateCounter	= 0.0F ;
	kr->ObjNum			= 0 ;

	// IuWFNg̏	
	ob = kr->Obj ;
	for( i = 0 ; i < KIRAKIRA_MAXNUM ; i ++, ob ++ ) ob->vflag = 0 ;

	// I
	return Effect ;
}

// LLGtFNǧns
extern s8 ReleaseKiraKiraEffect( EFFECT *Effect )
{
	KIRAKIRAEFFECT *kr = ( KIRAKIRAEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// LLGtFNgPt[
extern s8 MoveKiraKiraEffect( EFFECT *Effect )
{
	KIRAKIRAEFFECT *kr = ( KIRAKIRAEFFECT * )Effect->Data ;
	KIRAKIRAOBJECT *ob ;
	u32 i, num ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE && kr->ObjNum == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// ׂẴCIuWFNg
	ob = kr->Obj ;
	num = (u32)kr->ObjNum ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->vflag == 0 ) continue ;

		i ++ ;

		if( ob->boundnum != VParam[ED_KIRAKIRA][4] )
		{
			ob->alpha += ob->alphaspeed ;
			ob->alphaspeed -= VParam[ED_KIRAKIRA][0] * 0.001F ; 
		}
		else
		{
			ob->alpha += VParam[ED_KIRAKIRA][0] * 0.001F ; 
			if( ob->alpha > 1.0F )
			{
				ob->vflag = 0 ;
				kr->ObjNum -- ;
			}
		}
		ob->pos.y -= VParam[ED_KIRAKIRA][5] * 0.001F ;
		ob->rot += PI / 180.0F * VParam[ED_KIRAKIRA][3] ;
		
//		ob->alpha = 1.0F ;

		if( ob->alpha < 0.0F )
		{
			ob->boundnum ++ ;
/*			if( ob->boundnum >= VParam[ED_KIRAKIRA][4] )
			{
				ob->vflag = false ;
				kr->ObjNum -- ;
			}
			else
*/			{
				ob->alpha = 0.0F ;
				ob->alphaspeed = ob->alphaspeed * -1.0F * VParam[ED_KIRAKIRA][2] * 0.001F ;  
			}
		}
	}
	
	// IuWFNg쐬
	if( kr->ObjNum != KIRAKIRA_MAXNUM && Effect->DelReqFlag != TRUE )
	{
		f32 rsize = kr->Size * VParam[ED_KIRAKIRA][14] * 0.01F ;
	
		kr->CreateCounter += 1.0F ;
		while( kr->CreateCounter > kr->CreateCost && kr->ObjNum != KIRAKIRA_MAXNUM )
		{
			kr->CreateCounter -= kr->CreateCost ;
		
			for( ob = kr->Obj ; ob->vflag ; ob ++ ){}
			
			ob->vflag = TRUE ;
			ob->alpha = 1.0F ;
			ob->alphaspeed = -VParam[ED_KIRAKIRA][1] * 0.001F ;
			ob->rot = GetRandFNum( PI_2 ) ;
			ob->pos = kr->Pos ;
			ob->boundnum = 0 ;
			
			ob->pos.x += GetRandFNum( rsize ) - rsize / 2 ;
			ob->pos.y += GetRandFNum( rsize ) - rsize / 2 ;
			ob->pos.z += GetRandFNum( rsize ) - rsize / 2 ;

			kr->ObjNum ++ ;
		}
	}
	
	// I
	return 0 ;
}

// LLGtFNg`悷
extern s8 DrawKiraKiraEffect( EFFECT *Effect )
{
	KIRAKIRAEFFECT *kr = ( KIRAKIRAEFFECT * )Effect->Data ;
	KIRAKIRAOBJECT *ob ;
	Mtx tmtx ;
	u32 i, num, cr, j ;
	f32 sz ;
	Vec tv[4] ;

//	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_USETEX ) ;							// `̏
//	GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_4, GX_FALSE, GX_TEVPREV ) ;

	// eNX`̃[h
//	GTLOAD2( KRU.KiraKiraTex ) ;
	GTLOAD( &GetBillboardImage( BILLID_SPFIRE2 )->TexObj ) ;						// eNX`̃[h
	
	// ts̎擾
	EffectGetInvViewMatrix( tmtx ) ;

	// _
	sz = 0.5F * kr->Size ;
	tv[0].x = -sz ;	tv[0].z = 0.0F ;	tv[0].y = sz ;
	tv[1].x = sz ;	tv[1].z = 0.0F ;	tv[1].y = sz ;
	tv[2].x = sz ;	tv[2].z = 0.0F ;	tv[2].y = -sz ;
	tv[3].x = -sz ;	tv[3].z = 0.0F ;	tv[3].y = -sz ;
	{
		f32 Sin, Cos, f ;
		
		Sin = SINF( kr->Rot ) ;		Cos = COSF( kr->Rot ) ;
		kr->Rot = GetRandFNum( PI_2 ) ;
	
		for( i = 0 ; i < 4 ; i ++ )
		{
			f = Cos * tv[i].x - Sin * tv[i].y ;
			tv[i].y = Sin * tv[i].x + Cos * tv[i].y ;
			tv[i].x = f ;
			MTXMultVec( tmtx, &tv[i], &tv[i] ) ;
		}
	}

	// `揈	
	GBGN( GX_QUADS, kr->ObjNum * 4 * VParam[ED_KIRAKIRA][15] ) ;
	
	// IuWFNg̐JԂ
	ob = kr->Obj ;
	num = (u32)kr->ObjNum ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->vflag == 0 ) continue ;
		
		i ++ ;

		cr = CMKC2( kr->Color, ( 1.0F - ( ob->alpha > 1.0F ? 1.0F : ob->alpha ) ) * 255 * ( (f32)( VParam[ED_KIRAKIRA][4] - ob->boundnum ) / VParam[ED_KIRAKIRA][4] ) ) ;
//		cr = CMKC2( kr->Color, ( ob->alpha > 1.0F ? 1.0F : ob->alpha ) * 255  ) ;
		for( j = 0 ; j < VParam[ED_KIRAKIRA][15] ; j ++ )
		{
			GPV3( tv[0], ob->pos ) ; GCX( cr ) ; GT( 0.0F, 0.0F ) ;
			GPV3( tv[1], ob->pos ) ; GCX( cr ) ; GT( 1.0F, 0.0F ) ;
			GPV3( tv[2], ob->pos ) ; GCX( cr ) ; GT( 1.0F, 1.0F ) ;
			GPV3( tv[3], ob->pos ) ; GCX( cr ) ; GT( 0.0F, 1.0F ) ;
		}
	}
	GEND() ;

	// I
	return 0 ;
}


// LLGtFNg̍WύX
extern s8 SetKiraKiraEffectPos( Vec Pos, EFFECT *Effect )
{
	KIRAKIRAEFFECT *kr = ( KIRAKIRAEFFECT * )Effect->Data ;
	
	kr->Pos = Pos ;

	// I
	return 0 ;
}




