///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLight
//
// YK7EffectLight.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/28/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTLIGHT_H
#define __YK7EFFECTLIGHT_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/Wk7Model.h"

// define ---------------------------------------

#define LIGHTTEXNUM			10			// eNX`̎ނ̐

// datatype -------------------------------------

// eNX`Ǘf[^
typedef struct tagLIGHTTEX
{
	s32 Count ;				// QƐ
	TEXDATA Tex ;			// eNX`
} LIGHTTEX ;

// GtFNgʃf[^
typedef struct tagLIGHTUNION
{
	LIGHTTEX Tex[LIGHTTEXNUM] ;			// eNX`f[^
} LIGHTUNION ;

// GtFNgf[^
typedef struct tagLIGHTEFFECT
{
	s32 TexNumber ;						// gpeNX`io[
	
	f32 MinY, MaxY ;					// ̍
	f32 MaxSinSpeed, MinSinSpeed ;		// TCXs[h̍ŏlƍől
	f32 ExRate ;						// 㕔ł̊g嗦

	f32 Y, SinSpeed ;					// ݂̌̍ƃTCXs[h
	f32 SinCounter ;					// TCJE^

	WK7JObj *Pos[4] ;					// lp`̂S_ WK7JObj ւ̃|C^
} LIGHTEFFECT ;

// GtFNgf[^p\
typedef struct tagLIGHTEFFECTTASKPARAM
{
	WK7JObj *JObj ;					// "P00" ` "P03" ܂ł JObj  WK7JObj ւ̃|C^
	s32 TexNumber ;					// eNX`ԍ
	f32 MaxY, MinY ;				// ̍ő̍ƍŏ̍
	f32 MaxSinSpeed, MinSinSpeed ;	// TCXs[h̍ő呬xƍŏx
	f32 ExRate ;					// 㕔ł̊g嗦
} LIGHTEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitLightData( void ) ;			// GtFNg̋ʃf[^
extern s8 CheckLightData( void ) ;			// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndLightData( void ) ;			// GtFNg̋ʃf[^n

extern EFFECT *CreateLightEffect(
					WK7JObj *JObj,									// "P1" ` "P4" ܂ł JObj  WK7JObj ւ̃|C^
					s32 TexNumber = 0,								// eNX`ԍ
					f32 MaxY = -1.0F, f32 MinY = -1.0F,				// ̍ő̍ƍŏ̍
					f32 MaxSinSpeed = -1.0F, f32 MinSinSpeed = -1.0F,	// TCXs[h̍ő呬xƍŏx
					f32 ExRate = -1.0F,								// 㕔ł̊g嗦
					s32 Priority = -130 ) ;							// GtFNg쐬
extern s8 ReleaseLightEffect( EFFECT *Effect ) ;					// GtFNǧns
extern s8 MoveLightEffect( EFFECT *Effect ) ;						// GtFNgPt[
extern s8 DrawLightEffect( EFFECT *Effect ) ;						// GtFNg`悷

extern s8 SetupLightTex( s32 TexNumber ) ;					// eNX`̏s
extern s8 CheckLightTex( s32 TexNumber ) ;					// eNX`̏ǂ擾( TRUE: FALSE:܂ )
extern s8 ReleaseLightTex( s32 TexNumber ) ;				// eNX`
extern GXTexObj *GetLightTex( s32 TexNumber ) ;				// eNX`擾

#endif