///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLine
//
// YK7EffectLine.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/04/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTLINE_H
#define __YK7EFFECTLINE_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

enum
{
	LINE_TYPE_NORMAL = 0,			// ʏ퓮Aw̕ɐ΂
	LINE_TYPE_OUTCIRCLE = 1,		// ΂w̕A͈͂̉~̊Ôݔ΂
	LINE_TYPE_NOUTCIRCLE = 2,		// w̕ɐȕɂ̂ݔ΂
} ;


// datatype -------------------------------------

// CGtFNgʃf[^
typedef struct tagLINEUNION
{
	TEXDATA TestTex ;				// eXgeNX`
} LINEUNION ;

// CIuWFNgf[^
typedef struct tagLINEOBJECT
{
	Vec NowPoint, BackPoint ;		// Pt[O̍Wƌ̍W
	Vec Speed ;						// ĂƃXs[h̃xNg
	u8 TexX, TexY ;
	GXColor Color ;					// F
} LINEOBJECT ;

// CGtFNgf[^
typedef struct tagLINEEFFECT
{
	u8 Mode2DFlag ;					// WvZȂǂQcvZǂ̃tO(TRUE:Qc FALSE:Rc)

	LINEOBJECT *Object ;			// CIuWFNgzւ̃|C^
	u16 LineObjectNum ;				// CIuWFNg̐
	Vec Point ;						// SW
	f32 Gravity ;					// d
	u32 Counter ;					// JE^[
	u8 TexNumber ;					// gpeNX`io[
	GXColor Color ;					// eNX`J[ɏZJ[
	f32 Width ;						// 
	f32 Length ;					// 
	u16 Time ;						// \Ă
	u16 FadeTime ;					// tF[hAEgn߂Ă܂ł̎
	u8 AbsWidthFlag ;				// ̕Ɋ֌WȂw̕ɂ邩tO
	u8 Type ;						// ^Cv
	u8 Mode ;						// [h
	f32 YukaY ;						// ̍
	TEXTURE *Tex ;					// eNX`
} LINEEFFECT ;

// CGtFNg^XNɓnf[^
typedef struct tagLINEEFFECTTACKPARAM
{
	u8 Mode2DFlag ;			// WvZȂǂQcvZǂ̃tO(TRUE:Qc FALSE:Rc)

	u8 TexNumber ;			// gpeNX`io[
	GXColor Color ;			// eNX`J[ɏZJ[
	Vec Point ;				// W
	f32 Size ;				// юU_ƂȂԂ̑傫
	f32 MaxPower ;			// őp[
	f32 MinPower ;			// Œp[
	Vec Direction ;			// 
	f32 RotRange ;			// ͈̔
	f32 Scatter ;			// ֌WȕɎU΂闦
	f32 Gravity ;			// d
	u16 LineNum ;			// ̐
	u16 Time ;				// \Ă
	u16 FadeTime ;			// tF[hAEgn߂Ă܂ł̎
	u8 AbsWidthFlag ;		// ̕Ɋ֌WȂw̕ɂ邩tO
	u8 Type ;				// ^Cv
	u8 Mode ;				// [h
	f32 YukaY ;				// ̍
	TEXTURE *Tex ;			// eNX`
	u8 ColorRand ;			// F̃_l
} LINEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitLineData( void ) ;			// CGtFNg̋ʃf[^
extern s8 CheckLineData( void ) ;			// CGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndLineData( void ) ;				// CGtFNg̋ʃf[^n

//extern void LineEffectTask( ghmGcTask *pTask ) ;					// CGtFNg^XN

extern EFFECT *CreateLineEffect( u8 Mode2DFlag, u8 TexNumber, GXColor Color, Vec Point,
								 f32 Size, f32 Width, f32 Length,
								f32 MaxPower, f32 MinPower, Vec Direction,
								 f32 RotRange, f32 Scatter,	f32 Gravity,
								 u16 LineNum, u16 Time, u16 FadeTime,
								 u8 AbsWidthFlag, u8 Type, u8 Mode,
								 f32 YukaY, TEXTURE *Tex,
								 u8 ColorRand, s32 Priority = -1 ) ;		// CGtFNg쐬
extern s8 ReleaseLineEffect( EFFECT *Effect ) ;						// CGtFNǧns
extern s8 MoveLineEffect( EFFECT *Effect ) ;						// CGtFNgPt[
extern s8 DrawLineEffect( EFFECT *Effect ) ;						// CGtFNg`悷

#endif
