///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMessage
//
// YK7EffectMessage.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 07/23/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTMESSAGE_H
#define __YK7EFFECTMESSAGE_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../matsu/mk7Jimaku.h"

// define ---------------------------------------

#define MES_NOICON			0						// ACRȂ
#define MES_MACRO			(0x53)					// }Nw
#define MES_MACRO_ITEM		(0x01)					// ACew
#define MES_MACRO_CONTINUE	(0x4c)					// Aw

#define MES_CHARID_MASK		(0xff00)
#define MES_SIZE_MASK		(0x00ff)

// hc
enum
{
	CHARID_ITEM = 0xf100
} ; 

// bZ[Ŵhc
enum
{
	MES_KEYGET = 0,					// ɓꂽbZ[W
	MES_HSIDGET = 1,				// wuX}ChcQbg
	MES_NUM = 2,					// bZ[W̐
} ;

// xɏo郁bZ[W̍ő吔
#define MAX_MESSAGENUM				6/*7*/

// ɓǂݍ߂pbN̍ő吔
#define MAX_LOADPACKNUM				20

// ACR̐
#define ICON_NUM					60

// ̍ő吔
#define MAX_STRLENGTH				100

// 񋓂eNX`̖AhX
#define FONT_NULLPOINT				((stFontParam *)0xffffff)

// datatype -------------------------------------

// sӂ̏
typedef struct tagMESSAGELINE
{
	stFontParam *TexPos[MAX_STRLENGTH] ;		// eNX`AhX
	s32 Width, Height ;							// ƍ
	s32 StrLen, DrawStrLen ;					// 񒷂ƁA`悷镶
} MESSAGELINE ;

// bZ[WpbNf[^
typedef struct tagMESSAGEPACK
{
	u8 UseFlag ;					// gĂ邩tO
	void *JmbData ;					// Jmt f[^i[Ăobt@ւ̃|C^
	ghmGcFile *JmbFile ;			// [hp ghmGcFile IuWFNg
	GXTexObj TexObj ;				// ZbgeNX`̃eNX`IuWFNg
	u8 FileFlag ;					// t@Cǂݍ񂾂tO
	s8 SetupFlag ;					// ZbgAbvIĂ邩tO( 2:IĂ  ȊO:IĂȂ(1:ACRǂݍݒ  0:IĂȂ) )
} MESSAGEPACK ;

// UV 
typedef struct tagMESSAGEUV
{
	f32 u, v ;
} MESSAGEUV ;

// r
typedef struct tagMESSAGERUBI
{
	s8 fromNum;							//ڂ
	s8 toNum;							//
	u8 rNum ;							//r̐
	MESSAGEUV CharUv[JIMAKU_RUBI_MAX];	//r̃eNX`W
} MESSAGERUBI ;

// bZ[WGtFNgʃf[^
typedef struct tagMESSAGEUNION
{
//	TEXTURE MessageTex[MES_NUM] ;			// bZ[W}bveNX`̃f[^
//	ghmGcFile *MessageTexFile[MES_NUM] ;	// bZ[W}bveNX`t@CIuWFNg

	MESSAGEPACK MesPack[MAX_LOADPACKNUM] ;	// bZ[WpbNf[^
	u8 MesPackNum ;							// ǂݍł郁bZ[WpbNf[^̐
	
	TEXDATA IconTexList[ICON_NUM] ;			// ACReNX`Xg
	s8 IconTexCount[ICON_NUM] ;				// ACReNX`̎QƐۑϐ
	
	TEXDATA TestIconTex ;
	TEXDATA RubiTex ;

	TEXTURE ArrowTex ;				// eNX`̃f[^
	ghmGcFile *ArrowTexFile ;		// eNX`t@CIuWFNg

	TEXTURE IconTex ;				// ACR}bveNX`̃f[^
	ghmGcFile *IconTexFile ;		// ACR}bveNX`t@CIuWFNg

	u8 Object[MAX_MESSAGENUM] ;		// \Ă郁bZ[WIuWFNg̃tO
	u8 ObjectNum ;					// IuWFNg̐
	
	s16 WaitTime ;					// ҂JE^[
	
	Vec PlXVec, PlYVec ;			// bZ[W̕\ʂ̂wƂx
	Vec PlStPoint ;					// ʂ̌_WAJWƃJ̌狁߂
									// wxygJ̑΍W
									
	Vec PlXVec2, PlYVec2 ;			// bZ[W̕\ʂ̂wƂx
	Vec PlStPoint2 ;				// ʂ̌_WAJWƃJ̌狁߂
									// wxygJ̑΍W

	Vec PlXVec3, PlYVec3 ;			// bZ[W̕\ʂ̂wƂx
	Vec PlStPoint3 ;				// ʂ̌_WAJWƃJ̌狁߂
									// wxygJ̑΍W
} MESSAGEUNION ;

// bZ[WGtFNgf[^
typedef struct tagMESSAGEEFFECT
{
	s8 PackID ;					// bZ[WpbNhc
	s32 IconID ;				// \ACR̂hc
	s32 SoundID ;				// ĐTEĥhc
	u16 MessageID ;				// bZ[Whc
	s8 PostID ;					// IuWFNĝhc

	u16 Mode ;					// [h
	u32 Counter1, Counter2 ;	// ėpJE^[
	
	f32 ArrowX ;					// `̊_W(vO`敔܂)
	f32 BotLineX, BotLineLength ;	// C̊_wWђ
	f32 MesX ;						// bZ[W̊_wW
	s16 PointLineX, PointLineNum ;	// _̊_wWƐ
	s8 PointLineGradFlag ;			// Of[VtO
	
	f32 ItemX ;
	s8 ItenDrawFlag ;
	
	s16 WaitTime ;					// ҂
	s8 LeftFlag ;					// ʍ\tO
	s16 y ;							// bZ[W`悷xW
	s8 StopFlag ;					// Xgbv悤ɂ
	s8 StopFlag2 ;					// XgbvtO

	f32 Size ; 						// ʒ[ł̑傫( 1.0F:{ )
	f32 ExRate ;					// ʒ[痣ɏ]ďȂ闦( 0.0F:ȂȂ  0.1F:10hbgӂ1hbgȂ )
	s8 MesType ;					// bZ[W^Cv
	s32 Length, Length2, MaxLength ;// bZ[W̒
	s16 SoundFlag ;					// 炵tO
	
	GXColor Color ;					// F
//	GXColor ColorTable[MAX_STRLENGTH] ;	// ̐Fe[u
	s8 ColorTableIndex ;			// J[e[ugꍇ̃CfbNX
	s8 MesType2 ;					// bZ[W^CvQ( 0:ʍ킹͏  1:ʍ킹͉  2:ACRtbZ[W )
	
	s8 IconMode ;
	s32 IconCounter1 ;
	s32 IconCounter2 ;
	
	s32 IconX ;
	s8 IconDrawFlag ;
	
	f32 RandMap[MAX_STRLENGTH] ;	// ̃TCY̗
	s32 MaxHeight ;					// őc
	s8 BottanCancelFlag ;			// {^LZLǂ̃tO
	
	f32 MesXRate ;					// L( 1.0F:L肫Ă  0.0F:Ă )
	f32 MesXRateSpeed ;				// L̑x
} MESSAGEEFFECT ;

// bZ[WGtFNgf[^p\
typedef struct tagMESSAGEEFFECTTASKPARAM
{
	s8 PackID ;				// bZ[WpbNhc
	u16 MessageID ;			// bZ[Whc
	s32 IconID ;			// ACRhc
	s32 SoundID ;			// TEhhc
	s8 LeftFlag ;			// ʍ\tO
	s16 y ;					// bZ[W`悷xW
	s8 StopFlag ;			// Xgbv悤ɂ
	f32 Size ;				// ̑傫( 1.0F:{ )@bZ[W^CvQ̂ݗL
	f32 ExRate ;			// ̑傫̕ω( 1.0F:PhbgӂP傫ω ) bZ[W^CvQ̂ݗL
	s8 MesType ;			// bZ[W^Cv( 0:V  1:Rc  2:Qc )
	GXColor *Color ;		// ̐Fւ̃|C^
	s8 ColorTableIndex ;	// J[e[ugꍇ̃CfbNX
	s8 MesType2 ;			// bZ[W^CvQ( 0:njbZ[W  1:LZbZ[W  2:ʂ̃bZ[W )
} MESSAGEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitMessageData( void ) ;				// bZ[WGtFNg̋ʃf[^
extern s8 CheckMessageData( void ) ;			// bZ[WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndMessageData( void ) ;				// bZ[WGtFNg̋ʃf[^n

extern EFFECT *CreateMessageEffect( s8 PackID, u16 MessageID,
									s32 IconID = -1, s32 SoundID = -1,
									s8 LeftFlag = FALSE, s16 y = -1,
									s8 StopFlag = FALSE, 
									f32 Size = 1.0F, f32 ExRate = 0.0F,
									s8 MesType = 2, GXColor *Color = NULL,
									s8 ColorTableIndex = 2, s8 MesType2 = 2,
									s8 BottanCancelFlag = TRUE, s32 Priority = 6000 ) ;		// bZ[WGtFNg쐬
extern s8 ReleaseMessageEffect( EFFECT *Effect ) ;						// bZ[WGtFNǧns
extern s8 MoveMessageEffect( EFFECT *Effect ) ;							// bZ[WGtFNgPt[
extern s8 DrawMessageEffect( EFFECT *Effect ) ;							// bZ[WGtFNg`悷

extern u8 ResetMessageWaitCount( void ) ;								// ҂ԂZbg
extern u8 FrameProcessMessageWaitCount( void ) ;						// ҂ԏ

extern u8 StopReleaseMessageEffect( EFFECT *Effect ) ;					// ~Ԃ
extern s8 GetStopStateMessageEffect( EFFECT *Effect ) ;					// ~Ԃł邩ǂ擾( TRUE:~ FALSE: )

extern s8 LoadMessagePack( char *FilePath ) ;							// bZ[WpbNf[^(jmb)ǂݍ
extern s8 SetupMessagePack( void *JmbData ) ;							// bZ[WpbNf[^(jmb)Zbg(Rs[͂܂̂ ReleaseMessagePack ܂œnf[^͉Ȃł)
extern s8 ReleaseMessagePack( s8 PackID ) ;								// bZ[WpbNf[^
extern s8 CheckMessagePackLoadComp( s8 PackID ) ;						// bZ[WpbNf[^t@CǂݍݏIǂ擾( TREU:ǂݍ݊  FALSE:ǂݍݒ )
extern MESSAGEPACK *GetMessagePack( s8 PackID ) ;						// bZ[WpbNf[^̃AhX擾
extern GhmGcTexHeader *GetMessageTexHeader( s8 PackID ) ;				// bZ[WpbNf[^̃eNX`wb_̃AhX擾
extern s32 GetMessageStringUvInfo( s8 PackID, s8 MessageID, s8 LineNo, stFontParam **FontParamBuffer, u16 *CharIDBuf = NULL, MESSAGELINE *MesLine = NULL, MESSAGERUBI *RubiBuf = NULL ) ;	// bZ[W̃eNX`̗擾
extern s32 GetMessageStringLength( s8 PackID, s8 MessageID, s8 LineNo ) ;	// bZ[W̕`掞̕擾
extern s32 GetMessageStringHeight( s8 PackID, s8 MessageID, s8 LineNo ) ;	// bZ[W̕`掞̍擾
extern GXTexObj *GetMessageTexObj( s8 PackID ) ;						// bZ[W̃eNX`IuWFNg擾
extern TEXDATA *GetMessageRubiTexData( void ) ;							// bZ[W̃reNX`IuWFNg擾
extern GXTexObj *GetMessageIconTexObj( s8 PackID, s8 MessageID ) ;		// bZ[WɑΉACR̃eNX`Ԃ
extern GXTexObj *GetMessageIconTexObj( s8 IconID ) ;					// w̃ACRԍ̃ACReNX`擾
extern TEXDATA  *GetMessageIconTex( s8 PackID, s8 MessageID ) ;			// w̃bZ[WɑΉACR̃eNX`f[^擾
extern s8 GetMessageIconNumber( s8 PackID, s8 MessageID ) ;				// w̃bZ[WɑΉACR̔ԍ擾
extern TEXDATA	*GetMessageIconTex( s8 IconID ) ;						// w̃ACRԍ̃ACReNX`f[^擾
extern s8 GetNoneIconCheck( s8 PackID, s8 MessageID ) ;					// w̃bZ[WACRȂǂ𒲂ׂ( TRUE:Ȃ  FALSE: )
extern s32 GetMessageSoundID( s8 PackID, s8 MessageID ) ;				// w̃bZ[WɑΉʉhc擾
extern s8 GetMessageContinueState( s8 PackID, s8 MessageID, s8 LineNo ) ;// w̃bZ[Wɑw肪邩ǂ擾( TRUE: FALSE:Ȃ )

#endif
