///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMissile
//
// YK7EffectMissile.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/09/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTMISSILE_H
#define __YK7EFFECTMISSILE_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// ~TCGtFNgʃf[^
typedef struct tagMISSILEUNION
{
	u8 dummy ;
} MISSILEUNION ;

// ~TCGtFNgf[^
typedef struct tagMISSILEEFFECT
{
	Vec back ;
	Vec pos, dpos ;				// ۂ̍Wƕ`W
	Vec targetpos ;				// ڕWW

	f32 length ;				// ڕW܂ł̋
	f32 initlength ;			// ̖ڕW܂ł̋
	DIR3 dir ;					// O

	EFFECT *cloud ;				// GtFNg
	u32 cloudid ;				// GtFNghc

	f32 xrot, yrot ;			// Əc̐Upx
	f32 width ;					// Uꕝ

	f32 speed ;					// x
	f32 xrotspeed, yrotspeed ;	// UpxωXs[h
} MISSILEEFFECT ;

// prototype ------------------------------------

extern s8 InitMissileData( void ) ;			// ~TCGtFNg̋ʃf[^
extern s8 CheckMissileData( void ) ;			// ~TCGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndMissileData( void ) ;			// ~TCGtFNg̋ʃf[^n

extern EFFECT *CreateMissileEffect(
								Vec pos,					// JnW
								Vec targetpos,				// ڕWW

								f32 width,					// Uꕝ

								f32 speed,						// x
								f32 xrotspeed, f32 yrotspeed,	// UpxωXs[h
								s32 Priority = -1 ) ;			// ~TCGtFNg쐬

extern s8 ReleaseMissileEffect( EFFECT *Effect ) ;				// ~TCGtFNǧns
extern s8 MoveMissileEffect( EFFECT *Effect ) ;				// ~TCGtFNgPt[
extern s8 DrawMissileEffect( EFFECT *Effect ) ;				// ~TCGtFNg`悷

#endif

