///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectName
//
// YK7EffectName.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 02/12/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectName.h"
#include "./YK7EffectMessage.h"

// define ---------------------------------------

#define NAMEJMBFILEPATH		"Yam/Effect/Name/Name.jmb"

// datatype -------------------------------------

// data -----------------------------------------

NAMEUNION NmUnion ;

// function proto type --------------------------

// function code --------------------------------

// OGtFNg̋ʃf[^
extern s8 InitNameData( void )
{
	MEMINIT( NmUnion ) ;
	
	// OpbN jmb f[^̓ǂݍ
//	NmUnion.NameJmbID = LoadMessagePack( NAMEJMBFILEPATH ) ; 

	// I
	return 0 ;
}

// OtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckNameData( void )
{
	// jmb f[^ǂݍ܂ĂȂ FALSE Ԃ
//	if( CheckMessagePackLoadComp( NmUnion.NameJmbID ) == FALSE ) return FALSE ;

	return TRUE ;
}


// OGtFNg̋ʃf[^n
extern s8 EndNameData( void )
{
	// OpbNf[^
//	ReleaseMessagePack( NmUnion.NameJmbID ) ;

	// I
	return 0 ;
}


// ÕGtFNg쐬
extern EFFECT *CreateNameEffect( Vec Pos,					// wW
								 s8 NameNumber,				// Oԍ
									s32 Priority )
{
	EFFECT *Effect ;
	NAMEEFFECT *Nm ;

	// t@C̓ǂݍ݂IĂȂ牽ɏI
	if( CheckNameData() == FALSE ) return 0 ;

	// VOf[^쐬
	Effect = AddEffectData( EFF_NAME, (void**)&Nm, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// p[^ۑ
	Nm->Pos = Pos ;
	Nm->NameNumber = NameNumber ;
	
	// I
	return Effect ;
}

// ÕGtFNǧns
extern s8 ReleaseNameEffect( EFFECT *Effect )
{
	NAMEEFFECT *Nm = ( NAMEEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// ÕGtFNgPt[
extern s8 MoveNameEffect( EFFECT *Effect )
{
	NAMEEFFECT *Nm = ( NAMEEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE ) 
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// I
	return 0 ;
}

// ÕGtFNg`悷
extern s8 DrawNameEffect( EFFECT *Effect )
{
	NAMEEFFECT *Nm = ( NAMEEFFECT * )Effect->Data ;
	
	// I
	return 0 ;
}					

// OGtFNgwWύX
extern s8 SetNamePos( Vec Pos, EFFECT *Effect )
{
	NAMEEFFECT *Nm = ( NAMEEFFECT * )Effect->Data ;
	
	Nm->Pos = Pos ;
	
	// I
	return 0 ;
}


