///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectNoiseOut
//
// YK7EffectNoiseOut.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTNOISEOUT_H
#define __YK7EFFECTNOISEOUT_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

// datatype -------------------------------------

// mCYAEgGtFNgʃf[^
typedef struct tagNOISEOUTUNION
{
	bool NotAutoDelete ;			// ɃmCYAEgGtFNg폜ȂtO
} NOISEOUTUNION ;

// mCYAEgGtFNgf[^
typedef struct tagNOISEOUTEFFECT
{
	WK7ScreenImage *Image ;			// ʃC[W
	WK7JObj *JObj ;					// `悷郂f
	EFFECT *Noise ;					// mCYGtFNg
	s32 Counter ;					// JE^[
	s8 Type ;						// ^Cv( 0:o  1:ޏo )
	s8 NoiseType ;					// mCY^Cv( 0:T}Tޏo  1:suL`FW )

	bool NotAutoDelete ;			// ɃmCYAEgGtFNg폜ȂtO
} NOISEOUTEFFECT ;

// mCYAEgGtFNgf[^p\
typedef struct tagNOISEOUTEFFECTTASKPARAM
{
	s8 Type ;						// ^Cv( 0:o  1:ޏo )
} NOISEOUTEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitNoiseOutData( void ) ;			// mCYAEgGtFNg̋ʃf[^
extern s8 CheckNoiseOutData( void ) ;			// mCYAEgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndNoiseOutData( void ) ;				// mCYAEgGtFNg̋ʃf[^n

extern EFFECT *CreateNoiseOutEffect( WK7JObj *JObj, s8 Type = 1, s8 NoiseType = 0, s32 Priority = 2000 ) ;	// mCYAEgGtFNg쐬
extern s8 ReleaseNoiseOutEffect( EFFECT *Effect ) ;										// mCYAEgGtFNǧns
extern s8 MoveNoiseOutEffect( EFFECT *Effect ) ;										// mCYAEgGtFNgPt[
extern s8 DrawNoiseOutEffect( EFFECT *Effect ) ;										// mCYAEgGtFNg`悷

extern s8 SetNoiseOutNotAutoDelete( void ) ;			// mCYAEgGtFNgɏȂ悤ɂ
extern bool CheckNoiseOutEndState( EFFECT *Effect ) ;	// mCYAEgGtFNgIǂ擾( false:܂  true:I )

#endif
