///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectPetal
//
// YK7EffectPetal.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/22/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTPETAL_H
#define __YK7EFFECTPETAL_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

// datatype -------------------------------------

// ԕكGtFNgʃf[^
typedef struct tagPETALUNION
{
	TEXDATA petal ;
} PETALUNION ;

// ԕكIuWFNgf[^
typedef struct tagPETALOBJECT
{
	u8 valid ;		// L
	u8 upflag ;		// ㏸tO
	f32 len ;		// S̋
	s32 rot ;		// ]l

	f32 y ;			// 
	f32 ysp ;		// ㏸x

	f32 u, v ;		// tu\
} PETALOBJECT ;

// ԕكGtFNgf[^
typedef struct tagPETALEFFECT
{
	bool startflag ;		// ㏸sX^[gtO
	Vec Pos ;				// SW
	u32 counter ;

	WK7JObj *areaJObj ;		// zuꏊ̃bV JObj
	f32 objarea ;			// IuWFNgzu͈
	f32 objrate ;			// Pʖʐς̃IuWFNg̐

	PETALOBJECT *obj ;		// ԕكIuWFNg
	s32 objnum ;			// IuWFNg̐
	f32 objnumcounter ;		// IuWFNg쐬鎞ɎgpJE^
	
	s32 updrawnum ;
	s32 downdrawnum ;

	f32 deady ;				// ԕق

	f32 rotcount ;			// ]JE^
	f32 rotspeed ;			// ]x
	f32 size ; 				// ԕق̑傫

	s32 rotsp ;				// ]x
	s32 rotssp ;			// ]x
	s32 rotmaxsp ;			// ]ōx

	f32 upssp ;				// ㏸x
	f32 upmaxsp ;			// ㏸ő呬x

	f32 uplen ;				// ㏸n߂鋗
	u16 uprotS, uprotE ;	// ㏸n߂͈

	f32 lensp ;				// k܂鑬x
	f32 lenssp ;			// k܂x
	f32 lenmaxsp ;			// k܂ōx
} PETALEFFECT ;

// prototype ------------------------------------

extern s8 InitPetalData( void ) ;			// ԕكGtFNg̋ʃf[^
extern s8 CheckPetalData( void ) ;			// ԕكGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndPetalData( void ) ;			// ԕكGtFNg̋ʃf[^n

extern EFFECT *CreatePetalEffect(
								Vec Pos,				// SW

								WK7JObj *areaJObj,		// zuꏊ̃bV JObj
								f32 objarea,			// IuWFNgzu͈( JObj ȏꍇɎg( ݂͔Ή ) )
								f32 objrate,			// Pʖʐς̃IuWFNg̐

								f32 deady,				// ԕق
								
								f32 rotspeed,			// ԕى摜̉]x
								f32 size, 				// ԕق̑傫

								s32 rotsspeed,			// ]x
								s32 rotmaxspeed,		// ]ōx

								f32 upsspeed,			// ㏸x
								f32 upmaxspeed,			// ㏸ő呬x
	
								f32 uplen,				// ㏸n߂鋗
								u16 uprotS, u16 uprotE,	// ㏸n߂͈

								f32 lensspeed,			// k܂x
								f32 lenmaxspeed,		// k܂ōx
								s32 Priority = -131 ) ;	// ԕكGtFNg쐬
extern s8 ReleasePetalEffect( EFFECT *Effect ) ;		// ԕكGtFNǧns
extern s8 MovePetalEffect( EFFECT *Effect ) ;			// ԕكGtFNgPt[
extern s8 DrawPetalEffect( EFFECT *Effect ) ;			// ԕكGtFNg`悷

extern s8 SetPetalEffectStart( EFFECT *Effect ) ;		// ԕكGtFNgJn

#endif

