///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectPopCorn
//
// YK7EffectPopCorn.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/28/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTPOPCORN_H
#define __YK7EFFECTPOPCORN_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/Wk7Model.h"

// define ---------------------------------------

// datatype -------------------------------------

// |bvR[GtFNgʃf[^
typedef struct tagPOPCORNUNION
{
	u8 Dummy ;
} POPCORNUNION ;

// |bvR[GtFNgf[^
typedef struct tagPOPCORNEFFECT
{
	EFFECT *BillEff ;			// r{[hGtFNg
	u32 BillEffID ;				// r{[hGtFNĝhc
	
	Vec PopPoly[5][2][3] ;		// |bvR[ђ˂anw̓蔻p|S̍W
	WK7JObj *PopBox[8] ;		// |bvR[ђ˂钷̂̒_f[^ WK7JObj ւ̃|C^
								// 0`3   4`7 
	f32 Speed ;					// ђ˂|bvR[̑x
	
	
	f32 CreateCounter ;			// |bvR[쐬JE^
} POPCORNEFFECT ;

// |bvR[GtFNgf[^p\
typedef struct tagPOPCORNEFFECTTASKPARAM
{
	WK7JObj *JObj ;				// |bvR[ђ˂钷̂̒_f[^pP[^ WK7JObj ւ̃|C^
	f32 Speed ;					// ђ˂|bvR[̑x
	f32 YukaY ;					// ̍
} POPCORNEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitPopCornData( void ) ;				// |bvR[GtFNg̋ʃf[^
extern s8 CheckPopCornData( void ) ;			// |bvR[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndPopCornData( void ) ;				// |bvR[GtFNg̋ʃf[^n

extern EFFECT *CreatePopCornEffect( WK7JObj *JObj,				// |bvR[ђ˂钷̂̒_f[^pP[^ WK7JObj ւ̃|C^
									f32 Speed,					// ђ˂|bvR[̑x
									f32 YukaY,					// ̍
									s32 Priority = -130 ) ;		// |bvR[GtFNg쐬
extern s8 ReleasePopCornEffect( EFFECT *Effect ) ;				// |bvR[GtFNǧns
extern s8 MovePopCornEffect( EFFECT *Effect ) ;					// |bvR[GtFNgPt[
extern s8 DrawPopCornEffect( EFFECT *Effect ) ;					// |bvR[GtFNg`悷

extern s8 SetPopCornEffectSpeed( EFFECT *Effect, f32 Speed ) ;		// |bvR[̃Xs[h

#endif