///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectRotLight
//
// YK7EffectRotLight.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/26/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTROTLIGHT_H
#define __YK7EFFECTROTLIGHT_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// 邭郉CgGtFNgʃf[^
typedef struct tagROTLIGHTUNION
{
	u8 NotAllDrawFlag ;
} ROTLIGHTUNION ;

// 邭郉CgGtFNgf[^
typedef struct tagROTLIGHTEFFECT
{
	EFFECT *LaserEffect ;				// [U[GtFNg̃|C^

	Vec Pos ;							// W
	Vec Dir ;							// 
	
	DIR3 Dv ;							// R
	
	f32 Slope ;							// X
	f32 Width ;							// ]
	f32 Length ;						// 
	f32 RotCounter ;					// ]JE^
	f32 RotSpeed ;						// ]x
	f32 ColorCounter ;					// FJE^
	
	GXColor Color ;						// F
} ROTLIGHTEFFECT ;

// 邭郉CgGtFNgf[^p\
typedef struct tagROTLIGHTEFFECTTASKPARAM
{
	Vec Pos ;			// W
	Vec Dir ;			// 
	f32 Slope ;			// X
	f32 Speed ;			// ]x
	f32 Width ;			// ]
	f32 Length ;		// 
} ROTLIGHTEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitRotLightData( void ) ;				// 邭郉CgGtFNg̋ʃf[^
extern s8 CheckRotLightData( void ) ;				// 邭郉CgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndRotLightData( void ) ;					// 邭郉CgGtFNg̋ʃf[^n

extern EFFECT *CreateRotLightEffect(
									 Vec Pos,				// W
									 Vec Dir,				// 
									 f32 Slope = -1.0F,		// X
									 f32 Speed = -1.0F,		// ]x
									 f32 Width = -1.0F,		// ]
									 f32 Length = -1.0F,	// 
									 s32 Priority = -3 ) ;	// 邭郉CgGtFNg쐬
extern s8 ReleaseRotLightEffect( EFFECT *Effect ) ;					// 邭郉CgGtFNǧns
extern s8 MoveRotLightEffect( EFFECT *Effect ) ;					// 邭郉CgGtFNgPt[
extern s8 DrawRotLightEffect( EFFECT *Effect ) ;					// 邭郉CgGtFNg`悷

extern s8 SetRotLightAllDrawFlag( s8 Flag ) ;						// 邭郉Cg\`悷邩ǂ̃tOZbg
extern GXColor HSVToRGB( f32 H, f32 S, f32 V ) ;					// gruJ[qfaJ[ɕϊ

#endif