///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectScanLine
//
// YK7EffectScanLine.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 11/17/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSCANLINE_H
#define __YK7EFFECTSCANLINE_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// GtFNgʃf[^
typedef struct tagSCANLINEUNION
{
	u8 Dummy ;
} SCANLINEUNION ;

// GtFNgf[^
typedef struct tagSCANLINEEFFECT
{
	s8 LineWidth ;			// ̑
	u8 Alpha ;				// ̔Z
} SCANLINEEFFECT ;

// GtFNg^XNɓnf[^
typedef struct tagSCANLINEEFFECTTACKPARAM
{
	s8 LineWidth ;			// ̑
	u8 Alpha ;				// ̔Z
} SCANLINEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitScanLineData( void ) ;							// GtFNg̋ʃf[^
extern s8 CheckScanLineData( void ) ;							// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndScanLineData( void ) ;								// GtFNg̋ʃf[^n

extern EFFECT *CreateScanLineEffect( s8 LineWidth, u8 Alpha, s32 Priority = 6000 ) ;		// ̃GtFNg쐬
extern s8 ReleaseScanLineEffect( EFFECT *Effect ) ;								// ̃GtFNǧns
extern s8 MoveScanLineEffect( EFFECT *Effect ) ;								// ̃GtFNgPt[
extern s8 DrawScanLineEffect( EFFECT *Effect ) ;								// ̃GtFNg`悷

#endif