///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSearch
//
// YK7EffectSearch.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/26/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSEARCH_H
#define __YK7EFFECTSEARCH_H

// include --------------------------------------
#include "../Wat/WK7Model.h"
#include "./YK7Effect.h"

// define ---------------------------------------

#define BACK_PNUM		10

// datatype -------------------------------------

// T[``GtFNgʃf[^
typedef struct tagSEARCHUNION
{
	u8 Dummy ;
} SEARCHUNION ;

// T[``GtFNgf[^
typedef struct tagSEARCHEFFECT
{
	u8 DrawFlag ;						// \邩ǂAtO
	f32 BaseSize ;						// {ƂȂTCY
	WK7JObj *HeadJObj ;					// ̕ WK7JObj
	WK7JObj *WaistJObj ;				// ̕ WK7JObj
	
	u8 Mode ;							// [h(0:N 1:蓮 2:I)
	
	f32 Skill ;							// T[`̃XLAlقǃJ[\肷
	f32 Speed ;							// GɒǂƂ鑬
	Vec Point ;
	f32 sx, sy ;
	u16 Counter ;
	
	Vec BackPoint[BACK_PNUM] ;
	u32 RenderID ;						// `掞̂hc
	u8 EnemyAlphaL, EnemyAlphaH ;		// G̃At@l
} SEARCHEFFECT ;

// T[``GtFNgf[^p\
typedef struct tagSEARCHEFFECTTASKPARAM
{
	f32 BaseSize ;						// {ƂȂTCY(l:3.0F)
	f32 Skill ;							// T[`̃XLAlقǃJ[\肷(l:1.3F)
	f32 Speed ;							// GɒǂƂ鑬(l:1.0F)
	WK7JObj *HeadJObj ;					// ̕ WK7JObj
	WK7JObj *WaistJObj ;				// ̕ WK7JObj
	u32 RenderID ;						// `掞̂hc
} SEARCHEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitSearchData( void ) ;				// T[``GtFNg̋ʃf[^
extern s8 CheckSearchData( void ) ;				// T[``GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSearchData( void ) ;				// T[``GtFNg̋ʃf[^n

//extern void SearchEffectTask( ghmGcTask *pTask ) ;						// T[``GtFNg^XN

extern EFFECT *CreateSearchEffect( f32 BaseSize, f32 Skill, f32 Speed, WK7JObj *HeadJObj, WK7JObj *WaistJObj, u32 RenderID, s32 Priority = 7000 ) ;		// T[``GtFNg쐬
extern s8 ReleaseSearchEffect( EFFECT *Effect ) ;						// T[``GtFNǧns
extern s8 MoveSearchEffect( EFFECT *Effect ) ;							// T[``GtFNgPt[
extern s8 DrawSearchEffect( EFFECT *Effect ) ;							// T[``GtFNg`悷

extern s8 SetSearchEffectRenderFlag( EFFECT *Effect, s8 Flag ) ;		// T[``GtFNg`悷邩ǂZbg
extern s8 DelReqSearchEffect( EFFECT *Effect ) ;						// 폜NGXgs

#endif