///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSight
//
// YK7EffectSight.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/23/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSIGHT_H
#define __YK7EFFECTSIGHT_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define SIG_WAKUW	(48)
#define SIG_WAKUH	(48)
#define SIG_X		((SCW-(SIG_WAKUW * 2))/2)	// Əg̍w
#define SIG_Y		((SCH-(SIG_WAKUH * 2))/2)	// Əg̍x
#define SIG_W		(SIG_WAKUW * 2)				// Əg̕
#define SIG_H		(SIG_WAKUH * 2)				// Əg̍


#define SHOT_MAXNUM		100		// ce̍ő吔
#define FUJITA 1
#define BACK_POINTMAXNUM	18
#define DECNUM	3

// Ə̃^Cv
enum
{
	SIGHT_TYPE_DAN = 0,			// _
	SIGHT_TYPE_CON = 1,			// R
	SIGHT_TYPE_KED = 2,			// JGf
	SIGHT_TYPE_MSK = 3,			// }XN
	SIGHT_TYPE_CYO = 4,			// R[e
	SIGHT_TYPE_GAL = 5,			// KVA
	SIGHT_TYPE_HAC = 6,			// Ԉ֎qn[}
	SIGHT_TYPE_KVN = 7,			// PB
	SIGHT_TYPE_HAY = 8,			// On[}
	SIGHT_TYPE_CURSOR = 9,		// IJ[\
} ;


// datatype -------------------------------------

// ƏGtFNgʃf[^
typedef struct tagSIGHTUNION
{
	u8 Dummy ;
	TEXDATA SightTex ;					// TCgeNX`

	TEXDATA gradTex ;	
	TEXDATA arcTex ;
	TEXDATA circleTex ;
	TEXDATA sightTex ;
	TEXDATA centerTex ;
	TEXDATA crossTex ;
} SIGHTUNION ;

// GtFNgp\
typedef struct tagSIGHTDEC
{
	f32 x ;								// ړl( 0.0F ` 1.0F )
	f32 sx ;							// ړx
	f32 w ;								// 
} SIGHTDEC ;

// ƏGtFNgIuWFNgf[^
typedef struct tagSIGHTOBJECT
{
	SIGHTDEC LDec[DECNUM] ;				// 葕
	SIGHTDEC DDec[DECNUM] ;				// E葕
	SIGHTDEC UDec[DECNUM] ;				// 葕
	SIGHTDEC RDec[DECNUM] ;				// 葕

	Vec Point ;							// J[\̑Έʒu
	Vec AbsPoint ;						// J[\̐Έʒu
	Vec BackPoint[BACK_POINTMAXNUM] ;
	Vec TargetPoint ;					// J[\ړڕWW
	f32 Speed ;							// ړXs[h

	f32 VibRate, VibRate2 ;
	f32 HPan, VPan ;					// EƏ㉺̊
	f32 XAdd, YAdd ;					// Ă闦
	f32 Width, Height ;					// Ə̕ƍ(1.0F`0.0F)
} SIGHTOBJECT ;

// ce\p\
typedef struct tagSIGHTSHOTNUM
{
	u8 Mode ;							// [h( 0:gp 1:ړ 2: 3:SɌ )
	f32 x ;								// W( 0.0F ` 1.0F )
	f32 sx ;							// ړJnƂ̖ڕWւ̋
	f32 sl ;							// ړJnƂ̂wW
	f32 nx ;							// zuׂW( 0.0F ` 1.0F )
	u16 Counter ;						// oߎ
} SIGHTSHOTNUM ;


// ƏGtFNgf[^
typedef struct tagSIGHTEFFECT
{
	bool onflag ;
	s32 counter ;

	bool centcolorf ;		// S̐FύXtO
	u32 centcolor ;			// S̐F

	bool circlecolorf ;		// S~̐FύXtO
	u32 circlecolor ;		// S~̐F

	u8 VibMode ;						// u[h(0:W  1:ɍsقǂԂAɍsقǈ肷郂[h )

//	EFFECT *cenlight ;					// SɌW߂GtFNg
//	EFFECT *cenlight2 ;					// SɌW߂GtFNgQ
	s8 SentType ;						// ߌ̃^Cv

	SIGHTOBJECT Obj[2] ;				// TCgIuWFNgf[^
	u8 ObjectNum ;						// IuWFNg̐
	GXColor Color ;						// F

	u8 DrawFlag ;						// `tO
	u8 Mode ;							// [h(0:o 1:W 2:폜 3:[h 4:[h)
	u32 Counter ;						// JE^
	u8 SightType ;						// TCg^Cv

	u8 SquareDrawFlag ;					// S̏㉺̎lp`\邩ǂ̃tO	
	u8 LineDrawFlag ;					// ㉺EɐLт郉C`悷邩ǂ̃tO
	f32 LineSize ;						// C̃TCY( 0.0F`1.0F )
	f32 LineInSpeed, LineOutSpeed ;		// C̏oXs[hƑޏoXs[h

	f32 VibRate2, VibRate3 ;
	f32 VibRate, VibPower ;				// Ԃꗦ(1.0F ` 0.0F)AԂp[(hbgP)
	u8 VibCounter ;						// ԂꏈpJE^
	f32 VibX, VibY ;					// Ԃ̑傫
	f32 XAdd, YAdd ;					// Ă闦
	Vec Point ;							// J[\݈̌ʒu
	f32 MaxMove, MinSize ;				// Ə̃TCYŏɂȂ܂ł̈ړ(sNZP)ƁAƏ̍ŏTCY(1.0F`0.0F)
	f32 BackSpeed ;						// ԂTCYɖ߂Xs[h(Pt[̖߂ 1.0F łPt[ŕKɖ߂)
	f32 alpha[2] ;						// At@l

	f32 XSquareLength, YSquareLength ;	// Əc̕W͂lp`̃TCY
	f32 SightWidth, SightHeight ;		// Ə̕ƍ(sNZP)
	
	f32 Width, Height ;					// Ə̕ƍ(1.0F`0.0F)
	f32 HPan, VPan ;					// EƏ㉺̊
	Vec MovePoint ;						// ړ̈ʒu
	u8 DecVibSyncFlag ;					// xƓ邩tO

	SIGHTSHOTNUM Shot[SHOT_MAXNUM] ;	// ce\pf[^
	u8 ShotNum ;						// ce\pf[^̐
	u8 MaxShotNum ;						// ce̍ő吔
	f32 MoveLength ;					// ce\̐\ł镝( 1.0F ` 0.0F )
	u8 MoveSpeed1 ;						// ړx(PʁFt[)(1:zȗx  2:VbgɒSɌƂ̑x)
	u8 MoveSpeed2 ;
	f32 InitSpeed1 ;					// ړXs[h(PʁFPʉx)(1:zȗx  2:VbgɒSɌƂ̑x)
	f32 InitSpeed2 ;

	f32 ShotLineSize ;					// ce\C̒̔{(1.0 = 100%)
	u8 ShotLineWidth ;					// ̕
	u8 CurPointLockFlag ;				// eIuWFNg̍WbN邩tO

	u8 ObjectMoveMode ;					// eIuWFNg̍W[h(0:u[h  1:ڎw胂[h)
	f32 Rotate ;						// X

	f32 LineRot ;						// ̉](0.0F`1.0F)

	u8 DrawFlagNum[2] ;
	u8 LeftFlag[2], UpFlag[2], DownFlag[2], RightFlag[2] ;		// ꂼce\stO
#if FUJITA
  f32 w,h;
#endif

	u8 AddBlendFlag ;					// ZtO
	
	s32 brinkcon ;				// _ŃJE^
	s32 chargelevel ;			// `[Wx
} SIGHTEFFECT ;

// ƏGtFNgf[^p\
typedef struct tagSIGHTEFFECTTASKPARAM
{
	u8 ObjectNum ;						// TCgIuWFNg̐
	Vec *ObjectVec ;					// eIuWFNg̑΍W(ꍇ͂Q̔zւ̃|C^)
	GXColor Color ;						// F
	Vec Point ;							// W
	f32 VibPower ;						// Ԃꗦ(1.0F ` 0.0F)AԂp[(hbgP)
	f32 MaxMove, MinSize ;				// Ə̃TCYŏɂȂ܂ł̈ړ(sNZP)ƁAƏ̍ŏTCY(1.0F`0.0F)
	f32 BackSpeed ;						// TCYɖ߂Xs[h(Pt[̖߂ 1.0F łPt[ŕKɖ߂)

	f32 XSquareLength, YSquareLength ;	// Əc̕W͂lp`̃TCY
	f32 SightWidth, SightHeight ;		// Ə̕ƍ(sNZP)
	u8 DecVibSyncFlag ;					// xƓ邩tO
	
	u8 MaxShotNum ;						// \ce̍ő吔
	u8 ShotNum ;						// ݂̎ce
	f32 MoveLength ;					// ce\̐\ł镝( 1.0F ` 0.0F )
	u8 MoveSpeed1 ;						// ړx(PʁFt[)(1:zȗx  2:VbgɒSɌƂ̑x)
	u8 MoveSpeed2 ;
	f32 InitSpeed1 ;					// ړXs[h(PʁFPʉx)(1:zȗx  2:VbgɒSɌƂ̑x)
	f32 InitSpeed2 ;
	f32 LineInSpeed, LineOutSpeed ;		// C̏oXs[hƑޏoXs[h
	f32 ShotLineSize ;					// ce\C̒̔{(1.0 = 100%)
	u8 ShotLineWidth ;					// ̕
	u8 CurPointLockFlag ;				// eIuWFNg̍WbN邩tO
	
	u8 Left1Flag, Up1Flag, Down1Flag, Right1Flag ;		// ꂼce\stO
	u8 Left2Flag, Up2Flag, Down2Flag, Right2Flag ;		// ꂼce\stO
	f32 Rotate ;						// X
	u8 AddBlendFlag ;					// ZtO
} SIGHTEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitSightData( void ) ;				// ƏGtFNg̋ʃf[^
extern s8 CheckSightData( void ) ;				// ƏGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSightData( void ) ;				// ƏGtFNg̋ʃf[^n

//extern void SightEffectTask( ghmGcTask *pTask ) ;						// ƏGtFNg^XN

extern EFFECT *CreateSightEffect2( u8 VibMode, u8 ObjectNum, Vec *ObjectVec,
									GXColor Color, Vec Point, f32 VibPower,
									f32 MaxMove, f32 MinSize, f32 BackSpeed,
									f32 SightWidth, f32 SightHeight,
									f32 XSquareLength, f32 YSquareLength, u8 DecVibSyncFlag,
									u8 MaxShotNum, u8 ShotNum, f32 MoveLength, u8 MoveSpeed1, u8 MoveSpeed2,
									f32 InitSpeed1, f32 InitSpeed2,
									f32 LineInSpeed, f32 LineOutSpeed, f32 ShotLineSize,
									u8 ShotLineWidth, u8 CurPointLockFlag,
									u8 Left1Flag, u8 Up1Flag, u8 Down1Flag, u8 Right1Flag,
									u8 Left2Flag, u8 Up2Flag, u8 Down2Flag, u8 Right2Flag,
									f32 Rotate,
									u8 AddBlendFlag, u8 SightType, s32 Priority = 120 ) ;		// ƏGtFNg쐬
extern EFFECT *CreateSightEffect( Vec Point, u8 MaxShotNum, u8 ShotNum, u8 SightType, s32 Priority = 120 ) ;			// ƏGtFNg쐬
extern s8 ReleaseSightEffect( EFFECT *Effect ) ;						// ƏGtFNǧns
extern s8 MoveSightEffect( EFFECT *Effect ) ;							// ƏGtFNgPt[
extern s8 DrawSightEffect( EFFECT *Effect ) ;							// ƏGtFNg`悷

extern s8 SetSightEffectPoint( EFFECT *Effect, Vec *Point, u8 AfterImageFlag = FALSE ) ;	// ƏGtFNg̍WZbg 
extern s8 SetSightEffectRenderFlag( EFFECT *Effect, s8 Flag ) ;								// ƏGtFNg̕`悷邩ǂ̃tOZbg
extern s8 DelReqSightEffect( EFFECT *Effect ) ;												// ƏGtFNgɍ폜w߂o
#if FUJITA
extern s8 SetSightEffectWH( EFFECT *Effect, f32, f32 );
#endif
extern s8 SetSightEffectAlphaSet( EFFECT *Effect, u32 col );
extern s8 GetSightShotPoint( EFFECT *Effect, s16 *y, s16 *x, u8 Hand ) ;		// ʒu擾( Hand  0:E  1: )
extern s8 SightVib( EFFECT *Effect ) ;											// ƏԂꂳ

extern s8 SetSightShotNum( EFFECT *Effect, u8 ShotNum ) ;						// ceZbg
extern s8 SetSightLineDrawFlag( EFFECT *Effect, u8 Flag ) ;						// Ə̏㉺EɐLт`悷邩ǂ̃tOZbg
extern s8 SetSightSquareDrawFlag( EFFECT *Effect, u8 Flag ) ;					// Ə̒ŜS̎lp`悷邩ǂ̃tOZbg
extern s8 SetSightSize( EFFECT *Effect, f32 Width, f32 Height ) ;				// Ə̒S̃TCYZbg

extern s8 SetSightDirectPointFlag( EFFECT *Effect, u8 DirectPointFlag ) ;		// TCg̍W΍Ww肷邩ǂݒ肷
extern u8 GetSightDirectPointFlag( EFFECT *Effect );
extern s8 SetSightTargetPoint( EFFECT *Effect, Vec Point, u8 Hand ) ;			// TCg̐΍Ww肷( Hand  0:E  1: )

extern void AddSearchID( u32 ID ) ;
extern void SubSearchID( u32 ID ) ;

extern s8 ChangeSightState( EFFECT *Effect, s8 Type ) ;			// TCg̃^CvύX( 0:ʏ  1:ߌ )
extern void SetSightModeFlag( EFFECT *Effect, bool Flag ) ;		// \^Cv̕ύXs
extern void SetSightCenterColor( EFFECT *Effect, bool valid, GXColor color ) ;	// S̃p[c̐FύX
extern void SetSightCenterColor( EFFECT *Effect, bool valid, u32 color ) ;		// S̃p[c̐FύX
extern void SetSightCircleColor( EFFECT *Effect, bool valid, GXColor color ) ;	// S̃p[c̐FύX
extern void SetSightCircleColor( EFFECT *Effect, bool valid, u32 color ) ;		// S̃p[c̐FύX

extern void SetSightChargeLevel( EFFECT *Effect, s32 chargelevel ) ;		// `[WxZbg

#endif
