///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSkillExe2
//
// YK7EffectSkillExe2.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/17/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSKILLEXE2_H
#define __YK7EFFECTSKILLEXE2_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// \͔QGtFNgʃf[^
typedef struct tagSKILLEXE2UNION
{
	u8 Dummy ;
} SKILLEXE2UNION ;

// \͔QGtFNgf[^
typedef struct tagSKILLEXE2EFFECT
{
	s8 Mode ;				// ( 0:	 : )

	EFFECT *ScreenEffect ;	// XN[GtFNgւ̃|C^
	u32 ScreenEffectID ;
	
	f32 ExRate ;			// g嗦
	f32 Alpha ;				// At@
} SKILLEXE2EFFECT ;

// \͔QGtFNgf[^p\
typedef struct tagSKILLEXE2EFFECTTASKPARAM
{
	u8 Dummy ;
} SKILLEXE2EFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitSkillExe2Data( void ) ;				// \͔QGtFNg̋ʃf[^
extern s8 CheckSkillExe2Data( void ) ;				// \͔QGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSkillExe2Data( void ) ;				// \͔QGtFNg̋ʃf[^n

extern EFFECT *CreateSkillExe2Effect( s32 Priority = 1000 ) ;		// \͔QGtFNg쐬
extern s8 ReleaseSkillExe2Effect( EFFECT *Effect ) ;				// \͔QGtFNǧns
extern s8 MoveSkillExe2Effect( EFFECT *Effect ) ;					// \͔QGtFNgPt[
extern s8 DrawSkillExe2Effect( EFFECT *Effect ) ;					// \͔QGtFNg`悷

extern s8 DelReqSkillExe2Effect( EFFECT *Effect ) ;					// 폜NGXgs
extern s8 SetSkillExe2EffectMode( EFFECT *Effect, s8 Mode = 1 ) ;	// 샂[hύX( 0:ヂ[h  1:[h )

#endif
