///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSlip
//
// YK7EffectSlip.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/13/2003
//
//////////////////////////////////////////////////////////////////////////////

#if 0

#ifndef __YK7EFFECTSLIP_H
#define __YK7EFFECTSLIP_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define MAX_SLIPBILLNUM		10		// r{[h̍ő吔
#define MAX_SLIPHNUM		10		// r{[h̍ő吔
#define MAX_SLIPNUM			8		// ЂƂ̃}YGtFNgoXbv̐

enum
{
	MUZ_TYPE_H = 0,		// ^Cv
	MUZ_TYPE_V = 1,		// r{[h^Cv
	MUZ_TYPE_X = 2,		// XeNX`^Cv
} ;

// datatype -------------------------------------

// XbvGtFNgʃf[^
typedef struct tagSLIPUNION
{
	TEXTURE X1 ;				// Slipsh_X1.BIN
	TEXTURE V1 ;				// Slipsh_V1.BIN
	TEXTURE H1 ;				// Slipsh_H1.BIN
//	TEXTURE FrontTex[2] ;		// Xbv̐[̃eNX`f[^
//	TEXTURE BillTex[4] ;		// Xbṽr{[h`悷eNX`f[^
} SLIPUNION ;

// Xbvp_f[^
typedef struct tagSLIPVERTEX
{
	Vec Point ;				// _
	Vec Scale ;				// TCY
} SLIPVERTEX ;

// Xbvp[cf[^
typedef struct tagSLIPPARTS
{
	HSD_JObj *JObj ;			// JObject
	char Type ;					// ^Cv
} SLIPPARTS ;

// XbvIuWFNgf[^
typedef struct tagSLIPOBJECT
{
	SLIPPARTS *VParts ;									// r{[h^Cvp[c̃f[^zւ̃|C^
	u8 VNum ;											// r{[h^Cvp[c̐
	SLIPPARTS *HParts ;									// y^Cvp[c̃f[^zւ̃|C^
	u8 HNum ;											// y^Cvp[c̐
	SLIPPARTS *XParts ;									// XeNX`ŕ`悷f[^zւ̃|C^
	u8 XNum ;											// XeNX`ŕ`悷p[c̐

	f32 r1, r2 ;						// _l
} SLIPOBJECT ;

// XbvGtFNgf[^
typedef struct tagSLIPEFFECT
{
	WK7JObj *GunModel ;					// ẽff[^IuWFNg̃|C^
	HSD_AnimJoint *SlipAnim ;			// }ỸAj[Vf[^ւ̃|C^
	SLIPOBJECT Obj ;					// Xbvf[^
	u16 Counter ;						// JE^[
} SLIPEFFECT ;

// Xbv̈f[^
typedef struct tagSLIPEFFECTTASKPARAM
{
	WK7JObj *GunModel ;					// ẽff[^IuWFNg̃|C^
} SLIPEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitSlipData( void ) ;				// XbvGtFNg̋ʃf[^
extern s8 EndSlipData( void ) ;					// XbvGtFNg̋ʃf[^n

//extern void SlipEffectTask( ghmGcTask *pTask ) ;					// }YGtFNg^XN


extern EFFECT *CreateSlipEffect( WK7JObj *GunModel, u32 Priority = 100 ) ;	// XbṽGtFNg쐬
extern s8 ReleaseSlipEffect( EFFECT *Effect ) ;								// XbṽGtFNǧns
extern s8 MoveSlipEffect( EFFECT *Effect ) ;								// XbṽGtFNgPt[
extern s8 DrawSlipEffect( EFFECT *Effect ) ;								// XbṽGtFNg`悷

#endif

#endif