///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSmoke
//
// YK7EffectSmoke.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/16/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectSmoke.h"
#include "./YK7Break.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

//#define SMOKETEX "/Yam/Effect/Smoke/PoisonGas_P1"			// GtFNgp̃eNX`t@C
#define SMOKETEX "/Yam/Effect/Smoke/PoisonGas_P1_A.bin"		// GtFNgp̃eNX`t@C

// datatype -------------------------------------

// data -----------------------------------------

SMOKEUNION SmoUnion ;

// function proto type --------------------------

// function code --------------------------------

// GtFNg̋ʃf[^
extern s8 InitSmokeData( void )
{
	MEMINIT( SmoUnion ) ;

	// peNX`[ǂݍ
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_PoisonGas_P1_A ), &SmoUnion.SmokeTexAlpha ) ;
//	TexLoadSet( SMOKETEX, &SmoUnion.SmokeTexAlpha ) ;

	// I
	return 0 ;
}

// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSmokeData( void )
{
//	if( TexLoadChk( &SmoUnion.SmokeTexAlpha ) == FALSE ) return FALSE ;
	
	return TRUE ;
}


// GtFNg̋ʃf[^n
extern s8 EndSmokeData( void )
{
	TexRelease( &SmoUnion.SmokeTexAlpha ) ;
	
	// I
	return 0 ;
}


// ̃GtFNg쐬
extern EFFECT *CreateSmokeEffect( u8 Mode, Vec Point, f32 Power,
									f32 HPower, f32 VPower,
									f32 ResistPower, u16 SmokeNum,
									 Vec Direction, f32 DirectionRange,
									 f32 MaxRotSpeed, f32 MinRotSpeed,
									 f32 MaxXSize, f32 MinXSize, 
									 f32 MaxYSize, f32 MinYSize,
									 u16 MaxLifeTime, u16 MinLifeTime, f32 AreaSize,
									 GXColor Color1, GXColor Color2, GXColor Color3, u8 SmokeAlpha,
									 f32 MaxOir, f32 MinOir, u8 AddBlendFlag, u8 StopTime,
									 f32 MoveArea, u8 AddBlendPhase2Flag, u8 PhaseMoveAlpha,
									 GXColor Color21, GXColor Color22, GXColor Color23,
									 f32 LowSpeed, s32 Priority )
{
	EFFECT *Effect ;
	SMOKEEFFECT *Smoke ;
	u32 i, Num ;
	SMOKEOBJECT *Ob ;
	f32 oir, xzr, r, Length, MaxLength, HLength, VLength, MaxUpLength ;
	f32 BaseOir, BaseXzr ;
	bool AlphaX4Flag ;
	
	AlphaX4Flag = SmoUnion.AlphaX4Flag ;
	SmoUnion.AlphaX4Flag = false ;
	
	// t@C̓ǂݍ݂IĂȂ牽ɏI
	if( CheckSmokeData() == FALSE ) return 0 ;

//	return 0 ;

	// t@C
//	CLOSECHK( SmoUnion.TexFileAlpha ) ;
	
	// Vf[^쐬
	Effect = AddEffectData( EFF_SMOKE, (void**)&Smoke, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// WZbg
	SetEffectPos( Effect, &Point ) ;
	
	// ̃p[^ۑ
	Smoke->Mode = Mode ;
	Smoke->Point = Point ;
	Smoke->Power = Power ;
	Smoke->HPower = HPower ;
	Smoke->VPower = VPower ;
	Smoke->ResistPower = ResistPower ;
	Smoke->SmokeNum = SmokeNum ;
	Smoke->Direction = Direction ;
	Smoke->DirectionRange = DirectionRange ;
	Smoke->MaxRotSpeed = MaxRotSpeed ;
	Smoke->MinRotSpeed = MinRotSpeed ;
	Smoke->MaxXSize = MaxXSize ;
	Smoke->MinXSize = MinXSize ;
	Smoke->MaxYSize = MaxYSize ;
	Smoke->MinYSize = MinYSize ;
	Smoke->MaxLifeTime = MaxLifeTime ;
	Smoke->MinLifeTime = MinLifeTime ;
	Smoke->AreaSize = AreaSize ;
	Smoke->Color1 = Color1 ;
	Smoke->Color2 = Color2 ;
	Smoke->Color3 = Color3 ;
	Smoke->Counter = 0 ;
	Smoke->MaxOir = MaxOir ;
	Smoke->MinOir = MinOir ;
	Smoke->AddBlendFlag = AddBlendFlag ;
	Smoke->MoveArea = MoveArea ;
	Smoke->AddBlendPhase2Flag = AddBlendPhase2Flag ;
	Smoke->PhaseMoveAlpha = PhaseMoveAlpha ;
	Smoke->Color21 = Color21 ;
	Smoke->Color22 = Color22 ;
	Smoke->Color23 = Color23 ;
	Smoke->SmokeAlpha = SmokeAlpha ;
	Smoke->PhaseSmoke2Num = 0 ;
	Smoke->LowSpeed = LowSpeed ;
	Smoke->AlphaX4Flag = AlphaX4Flag ;

	// ő򋗗Zo
//	MaxLength = ( ( Power / ResistPower ) * Power ) / 2.0F     * 2.0F ;
	MaxLength = Power ;
	if( Smoke->AreaSize == 0.0F ) Smoke->AreaSize = MaxLength * 2 ;
	MaxUpLength = MaxLength * ( VPower / HPower ) ;

	// IuWFNg̃f[^i[郁̈mۂ
	Smoke->ObjP = ( SMOKEOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( SMOKEOBJECT ) * SmokeNum ), "Y_SmkObj" ) ;
	if( Smoke->ObjP == NULL ){ DeleteEffect( Effect ) ; return NULL ; }
	
	// 
	if( Mode == 0 )
	{
		BaseXzr = atan2( Direction.z, Direction.x ) ;
		BaseOir = atan2( Direction.y, Direction.x * cos( -BaseXzr ) - Direction.z * sin( -BaseXzr ) ) ;
	}
	
	// IuWFNg̏
	Ob = Smoke->ObjP ;
	Num = Smoke->SmokeNum ;
	for( i = 0 ; i < Num ; i ++, Ob ++ )
	{
		// WZbg
		Ob->Point = Point ;

		// xZo
		switch( Smoke->Mode )
		{
		case 1 :
			{
				xzr = rand() * PI_2 / RAND_MAX ;
				oir = rand() * ( MaxOir - MinOir ) / RAND_MAX + MinOir ;
				
				// 򋗗Zbg
				Length = rand() * ( MaxLength * Smoke->MoveArea ) / RAND_MAX + ( MaxLength - MaxLength * Smoke->MoveArea ) ;
				HLength = cos( oir ) * Length ;
				VLength = sin( oir ) * Length ;
				
				VLength *= ( VPower / HPower ) ;
				Length = sqrt( HLength * HLength + VLength * VLength ) ;

				// xZo
				Ob->Power = ( Length * 2 ) / StopTime ;

				Ob->SubPower = Ob->Power / StopTime ;
				
		//		Ob->Power = ( Power - Power / 3.0F ) * rand() / RAND_MAX + Power / 3.0F ;
				Ob->Direction.x = cos( oir ) * Ob->Power ;
				Ob->Direction.y = sin( oir ) * Ob->Power ;
				Ob->Direction.z = sin( xzr ) * Ob->Direction.x ;
				Ob->Direction.x = cos( xzr ) * Ob->Direction.x ;

				// XP[O
				Ob->Direction.x *= HPower ;
				Ob->Direction.z *= HPower ;
				Ob->Direction.y *= VPower ;

				// K
				r = sqrt( Ob->Direction.x * Ob->Direction.x +
							Ob->Direction.z * Ob->Direction.z + 
							Ob->Direction.y * Ob->Direction.y ) ; 
				Ob->Direction.x /= r ;
				Ob->Direction.y /= r ;
				Ob->Direction.z /= r ;
			}
			break ;
			
		case 0 :
			{
				f32 rr, rp ;

				// łpxZo
				rr = rand() * PI_2 / RAND_MAX ;
				rp = rand() * DirectionRange / RAND_MAX ;
				xzr = cosf( rr ) * rp + BaseXzr ;
				oir = sinf( rr ) * rp + BaseOir ;
				
				// 򋗗Zbg
				Length = rand() * ( MaxLength * Smoke->MoveArea ) / RAND_MAX + ( MaxLength - MaxLength * Smoke->MoveArea ) ;

				// xZo
				Ob->Power = ( Length * 2 ) / StopTime ;

				Ob->SubPower = Ob->Power / StopTime ;

		//		Ob->Power = ( Power - Power / 3.0F ) * rand() / RAND_MAX + Power / 3.0F ;
				Ob->Direction.x = cos( oir ) * Ob->Power ;
				Ob->Direction.y = sin( oir ) * Ob->Power ;
				Ob->Direction.z = sin( xzr ) * Ob->Direction.x ;
				Ob->Direction.x = cos( xzr ) * Ob->Direction.x ;

				// K
				r = sqrt( Ob->Direction.x * Ob->Direction.x +
							Ob->Direction.z * Ob->Direction.z + 
							Ob->Direction.y * Ob->Direction.y ) ; 
				Ob->Direction.x /= r ;
				Ob->Direction.y /= r ;
				Ob->Direction.z /= r ;
			}
			break ;
		}
		
		// Ă鎞ԂZbg
		Ob->LifeTime = (s16)( ( MaxLifeTime - MinLifeTime ) * rand() / RAND_MAX + MinLifeTime ) ;
		
		// ]pxƉ]xZbg
		Ob->Rotate = rand() * PI_2 / RAND_MAX ;
		Ob->RotSpeed = ( MaxRotSpeed - MinRotSpeed ) * rand() / RAND_MAX + MinRotSpeed ;
		
		// r{[h̃TCYZbg
		Ob->XSize = ( MaxXSize - MinXSize ) * rand() / RAND_MAX + MinXSize ;
		Ob->YSize = ( MaxYSize - MinYSize ) * rand() / RAND_MAX + MinYSize ;
		
		// JE^
		Ob->Counter = 0 ;
		Ob->Counter2 = 0 ;
		
		// ]肷
		Ob->RotDirection = ( rand() - 1 ) * 2 / RAND_MAX == 1 ; 
		
		// F̕ϓxZbg
//		Ob->ColorRatio = 1.0F + ( rand() * 0.4F / RAND_MAX - 0.2F ) ;
#if 1
		Ob->ColorRatio[0] = ( rand() * ( VParam[ED_HSEXP1][11] * 0.1F ) / RAND_MAX - ( VParam[ED_HSEXP1][11] * 0.1F ) / 2.0F ) ;
		Ob->ColorRatio[1] = ( rand() * ( VParam[ED_HSEXP1][11] * 0.1F ) / RAND_MAX - ( VParam[ED_HSEXP1][11] * 0.1F ) / 2.0F ) ;
		Ob->ColorRatio[2] = ( rand() * ( VParam[ED_HSEXP1][11] * 0.1F ) / RAND_MAX - ( VParam[ED_HSEXP1][11] * 0.1F ) / 2.0F ) ;
#else
		Ob->ColorRatio[0] = ( rand() * 0.4F / RAND_MAX - 0.2F ) ;
		Ob->ColorRatio[1] = ( rand() * 0.4F / RAND_MAX - 0.2F ) ;
		Ob->ColorRatio[2] = ( rand() * 0.4F / RAND_MAX - 0.2F ) ;
#endif

		// At@֌W̏
		Ob->Mode = 0 ;
		Ob->Alpha = 0 ;
	}

	// I
	return Effect ;
}

// ̃GtFNǧns
extern s8 ReleaseSmokeEffect( EFFECT *Effect )
{
	SMOKEEFFECT *SmokeEffect = ( SMOKEEFFECT * )Effect->Data ;

	// GtFNgIuWFNgp̃J
	CHKMEMFREE2( SmokeEffect->ObjP ) ;

	// I
	return 0 ;
}

// ̃GtFNgPt[
extern s8 MoveSmokeEffect( EFFECT *Effect )
{
	SMOKEEFFECT *SmokeEffect = ( SMOKEEFFECT * )Effect->Data ;
	u32 i, Num ;
	SMOKEOBJECT *Ob ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// JE^lɒB폜
	if( SmokeEffect->Counter == SmokeEffect->MaxLifeTime + 1 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	else
	{
		SmokeEffect->Counter ++ ;
	}

	// IuWFNg̐JԂ
	Num = SmokeEffect->SmokeNum ;
	Ob = SmokeEffect->ObjP ;
	for( i = 0 ; i < Num ; i ++, Ob ++ )
	{
		// ړ
		Ob->Point.x += Ob->Direction.x * Ob->Power ;
		Ob->Point.y += Ob->Direction.y * Ob->Power ;
		Ob->Point.z += Ob->Direction.z * Ob->Power ;
		
		// 
		Ob->Power -= Ob->SubPower ;
		if( Ob->Power < SmokeEffect->LowSpeed )
		{
			Ob->Power = SmokeEffect->LowSpeed ;
			Ob->Counter2 ++ ;
		}
		
		// ]
		Ob->Rotate += Ob->RotDirection ? Ob->RotSpeed : -Ob->RotSpeed ;
		
		// JEg
		Ob->Counter ++ ;
		if( Ob->LifeTime < Ob->Counter ) Ob->Counter = Ob->LifeTime ;
		
		// At@l̎Zo
		{
			f32 f ;
			
//			f = ( Ob->LifeTime - Ob->Counter ) * 0.75F / Ob->LifeTime ;
//			f *= 1.5F ;
			f = ( Ob->LifeTime * 0.25F - Ob->Counter ) / Ob->LifeTime ;
			if( f > 1.0F ) f = 1.0F ;
			if( f < 0.0F ) f = 0.0F ;
			Ob->Alpha = (u8)( f * SmokeEffect->SmokeAlpha ) ;


//			f = ( Ob->LifeTime - Ob->Counter ) * 0.75F / ( Ob->LifeTime * 1.5F ) ;
//			f *= 1.5F ;
			f = ( (f32)Ob->LifeTime - Ob->Counter ) / Ob->LifeTime ;
			if( f > 1.0F ) f = 1.0F ;
			if( f < 0.0F ) f = 0.0F ;
			Ob->Alpha2 = (u8)( f * SmokeEffect->SmokeAlpha / 2 ) ;
			
//			if( Ob->Alpha == 0 )
//				Ob->Alpha2 = 0 ;
		}
		
		// KlAt@lĂAt@uh[hɈڍs
		if( SmokeEffect->AddBlendPhase2Flag == TRUE &&
			Ob->Mode == 0 && Ob->Alpha < SmokeEffect->PhaseMoveAlpha )
		{
			Ob->Mode = 1 ;
			
			// tF[YQɈڍs𑝂₷
			SmokeEffect->PhaseSmoke2Num ++ ;
		}
	}

	// I
	return 0 ;
}

// ̃GtFNg`悷
extern s8 DrawSmokeEffect( EFFECT *Effect )
{
	SMOKEEFFECT *sm = ( SMOKEEFFECT * )Effect->Data ;
	Mtx TMtx ;
	u32 j, Num ;
	SMOKEOBJECT *Ob ;
	u8 r, g, b, a ;
	s16 Color ;
	f32 f, Sin, Cos, x, y, z, Size ;
	SMOKEUNION *SmokeUnion = &SmoUnion ;
	Vec p[4], Center, V ;
	
	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, sm->AddBlendFlag == FALSE ? EF_BLEND_ALPHA : EF_BLEND_ADD, EF_TEV_USETEX ) ;
	
	// ]us擾
	EffectGetInvViewMatrix( TMtx ) ;
	
	// XP[ƒSW𓾂
	GetScreenPosition( &sm->Point, &Center ) ;
	Size = GetScreenSize( &sm->Point, sm->AreaSize ) ;

	// TEVݒ
    GXSetNumTevStages(1);
	GXSetTevSwapModeTable( GX_TEV_SWAP2, GX_CH_RED, GX_CH_RED, GX_CH_RED, GX_CH_RED ) ;
	GXSetTevSwapMode( GX_TEVSTAGE0, GX_TEV_SWAP0, GX_TEV_SWAP2 ) ;
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC ) ; 
    GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
	GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_RASA, GX_CA_TEXA, GX_CA_ZERO ) ; 
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, sm->AlphaX4Flag ? GX_CS_SCALE_4 : GX_CS_SCALE_2, GX_TRUE, GX_TEVPREV ) ;

	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;

	// eNX`̃[h
	GTLOAD2( SmokeUnion->SmokeTexAlpha ) ;
	
	// `揈
	{
		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( sm->SmokeNum * 4 ) ) ;
		{
			Ob = sm->ObjP ;
			Num = sm->SmokeNum ;
			for( j = 0 ; j < Num ; j ++, Ob ++ )
			{
				GetScreenPosition( &Ob->Point, &V ) ;

				// _J[̎Zo
				f = ( Ob->LifeTime - Ob->Counter ) * 0.75F / Ob->LifeTime ;
				f *= 1.5F ;
				if( f > 1.0F ) f = 1.0F ;
				a = (u8)( f * sm->SmokeAlpha ) ;

				f = ( ( V.x - Center.x ) + Size / 2 ) / Size ;
				if( f < 0.5F )
				{
					f *= 2.0F ;
					Color = (s16)( sm->Color2.r * f + ( 1.0F - f ) * sm->Color1.r + Ob->ColorRatio[0] * 255 ) ;
					r = (u8)( Color > 255 ? 255 : ( Color < 0 ? 0 : Color ) ) ;
					Color = (s16)( sm->Color2.g * f + ( 1.0F - f ) * sm->Color1.g + Ob->ColorRatio[1] * 255 ) ;
					g = (u8)( Color > 255 ? 255 : ( Color < 0 ? 0 : Color ) ) ;
					Color = (s16)( sm->Color2.b * f + ( 1.0F - f ) * sm->Color1.b + Ob->ColorRatio[2] * 255 ) ;
					b = (u8)( Color > 255 ? 255 : ( Color < 0 ? 0 : Color ) ) ;
				}
				else
				{
					f = ( f - 0.5F ) * 2.0F ;
					Color = (s16)( sm->Color3.r * f + ( 1.0F - f ) * sm->Color2.r + Ob->ColorRatio[0] * 255 ) ;
					r = (u8)( Color > 255 ? 255 : ( Color < 0 ? 0 : Color ) ) ;
					Color = (s16)( sm->Color3.g * f + ( 1.0F - f ) * sm->Color2.g + Ob->ColorRatio[1] * 255 ) ;
					g = (u8)( Color > 255 ? 255 : ( Color < 0 ? 0 : Color ) ) ;
					Color = (s16)( sm->Color3.b * f + ( 1.0F - f ) * sm->Color2.b + Ob->ColorRatio[2] * 255 ) ;
					b = (u8)( Color > 255 ? 255 : ( Color < 0 ? 0 : Color ) ) ;
				}
					
				// W̎Zo
				Sin = sin( Ob->Rotate ) ;
				Cos = cos( Ob->Rotate ) ;
				y = Ob->Point.y + sin( Ob->Point.x * 0.005F * Ob->Counter2 ) / 10.0F ;
				x = Ob->Point.x ;
				z = Ob->Point.z ;

				p[0].x = -( Ob->XSize / 2 ) ;	p[0].y = Ob->YSize / 2 ;	p[0].z = 0.0F ;
				f = Cos * p[0].x - Sin * p[0].y ; p[0].y = Sin * p[0].x + Cos * p[0].y ; p[0].x = f ;
				MTXMultVec( TMtx, &p[0], &p[0] ) ;
				GP3( p[0].x + x, p[0].y + y, p[0].z + z ) ; GC4( r, g, b, a ) ; GT2( 0, 0 ) ;

				p[1].x = ( Ob->XSize / 2 ) ;	p[1].y = Ob->YSize / 2 ;	p[1].z = 0.0F ;
				f = Cos * p[1].x - Sin * p[1].y ; p[1].y = Sin * p[1].x + Cos * p[1].y ; p[1].x = f ;
				MTXMultVec( TMtx, &p[1], &p[1] ) ;
				GP3( p[1].x + x, p[1].y + y, p[1].z + z ) ; GC4( r, g, b, a ) ; GT2( UVSCALE, 0 ) ;

				p[2].x = ( Ob->XSize / 2 ) ;	p[2].y = -Ob->YSize / 2 ;	p[2].z = 0.0F ;
				f = Cos * p[2].x - Sin * p[2].y ; p[2].y = Sin * p[2].x + Cos * p[2].y ; p[2].x = f ;
				MTXMultVec( TMtx, &p[2], &p[2] ) ;
				GP3( p[2].x + x, p[2].y + y, p[2].z + z ) ; GC4( r, g, b, a ) ; GT2( UVSCALE, UVSCALE ) ;

				p[3].x = -( Ob->XSize / 2 ) ;	p[3].y = -Ob->YSize / 2 ;	p[3].z = 0.0F ;
				f = Cos * p[3].x - Sin * p[3].y ; p[3].y = Sin * p[3].x + Cos * p[3].y ; p[3].x = f ;
				MTXMultVec( TMtx, &p[3], &p[3] ) ;
				GP3( p[3].x + x, p[3].y + y, p[3].z + z ) ; GC4( r, g, b, a ) ; GT2( 0, UVSCALE ) ;
			}
		}
		GXEnd() ;
	}

	// ߂
	GXSetTevSwapModeTable( GX_TEV_SWAP2, GX_CH_GREEN, GX_CH_GREEN, GX_CH_GREEN, GX_CH_ALPHA ) ;
	GXSetTevSwapMode( GX_TEVSTAGE0, GX_TEV_SWAP0, GX_TEV_SWAP0 ) ;
	
	// I
	return 0 ;
}					

// ̃eNX`擾
extern GXTexObj *GetSmokeTex( void )
{
	return &SmoUnion.SmokeTexAlpha.Data.Obj ;
}

// ̃eNX``悷ۂɃ X4 ŕ`ǂ̃tOZbg
extern s8 SetSmokeAlphaX4Flag( void )
{
	SmoUnion.AlphaX4Flag = true ;
	
	return 0 ;
}
