///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSmokeObj
//
// YK7EffectSmokeObj.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/31/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSMOKEOBJ_H
#define __YK7EFFECTSMOKEOBJ_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// ݒς݃p[^hc
enum
{
	SMO_HNG_BIG = 2,		// pF
	SMO_HNG_SMALL,			// pF
} ;

// datatype -------------------------------------

// IuWFNgGtFNgʃf[^
typedef struct tagSMOKEOBJUNION
{
	u8 dummy ;
} SMOKEOBJUNION ;

// IuWFNgGtFNgIuWFNgf[^
typedef struct tagSMOKEOBJOBJECT
{
	u8 vflag ;			// LtO
	Vec	pos ;			// W
	Vec speed ;			// x
	f32 alpha ;			// At@l
//	f32 size ;			// TCY
	u8 maxalphaflag ;	// őAt@lɂȂǂtO
	
	f32 upalphasp ;		// ㏸̃̑x
	f32 downalphasp ;	// ~̃̑x
} SMOKEOBJOBJECT ;

// IuWFNgGtFNgf[^
typedef struct tagSMOKEOBJEFFECT
{
	SMOKEOBJOBJECT *obj ;	// IuWFNg
	s32 num ;				// 
	s32 maxnum ;			// ő吔
	
	Vec pos ;				// ʒu
	f32 area ;				// TCY
	u32 color ;				// F
	
//	f32 maxsize, minsize ;	// őTCYƍŏTCY
	f32 size ;				// TCY
	f32 maxspeed, minspeed ;	// ő呬xŏx
	f32 maxupalphaspeed, minupalphaspeed ; 		// ㏸ő僿xƍŏx
	f32 maxdownalphaspeed, mindownalphaspeed ;	// ~ő僿xƍŏx
	f32 maxalpha ;			// őAt@l

	f32 crerate ;			// 쐬[g
	f32 crecounter ;		// 쐬JE^
	
	bool postype ;			// W^Cv(true:΍W  false:΍W)
	
	s32 dietime ;			// S
	s32 diecounter ;		// SJE^
} SMOKEOBJEFFECT ;

// prototype ------------------------------------

extern s8 InitSmokeObjData( void ) ;			// IuWFNgGtFNg̋ʃf[^
extern s8 CheckSmokeObjData( void ) ;			// IuWFNgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSmokeObjData( void ) ;			// IuWFNgGtFNg̋ʃf[^n

extern EFFECT *CreateSmokeObjEffect(
								u8 type, Vec pos,
								s32 dietime = -1,				// S
								s32 Priority = -1 ) ;			// IuWFNgGtFNg쐬

extern EFFECT *CreateSmokeObjEffect(
								s32 maxnum,				// ő吔
								
								Vec pos,				// ʒu
								f32 area,				// TCY
								u32 color,				// F
								
							//	f32 maxsize, minsize ;	// őTCYƍŏTCY
								f32 size,				// TCY
								f32 maxspeed, f32 minspeed,	// ő呬xŏx
								f32 maxupalphaspeed, f32 minupalphaspeed, 		// ㏸ő僿xƍŏx
								f32 maxdownalphaspeed, f32 mindownalphaspeed,	// ~ő僿xƍŏx
								f32 maxalpha,			// őAt@l
								f32 createrate,			// 쐬[g
								bool postype, 			// W^Cv(true:΍W  false:΍W)
								s32 dietime,				// S
								s32 Priority = -1 ) ;			// IuWFNgGtFNg쐬

extern s8 ReleaseSmokeObjEffect( EFFECT *Effect ) ;				// IuWFNgGtFNǧns
extern s8 MoveSmokeObjEffect( EFFECT *Effect ) ;				// IuWFNgGtFNgPt[
extern s8 DrawSmokeObjEffect( EFFECT *Effect ) ;				// IuWFNgGtFNg`悷

extern s8 SetSmokeObjEffectPos( EFFECT *Effect, Vec pos ) ;		// IuWFNgGtFNg̔WύX

#endif

