///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSound
//
// YK7EffectSound.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 07/03/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSOUND_H
#define __YK7EFFECTSOUND_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// TEhGtFNgʃf[^
typedef struct tagSOUNDUNION
{
	s8 Dummy ;
} SOUNDUNION ;

// TEhGtFNgf[^
typedef struct tagSOUNDEFFECT
{
	u32 SoundID ;
	u32 SoundWait ;
	Vec Point ;
	bool SE2DFlag ;
	bool SoundOffMusiFlag ;
} SOUNDEFFECT ;

// TEhGtFNg^XNɓnf[^
typedef struct tagSOUNDEFFECTTACKPARAM
{
	u32 SoundID ;
	u32 SoundWait ;
	Vec Point ;
} SOUNDEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitSoundData( void ) ;				// TEhGtFNg̋ʃf[^
extern s8 CheckSoundData( void ) ;				// TEhGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSoundData( void ) ;				// TEhGtFNg̋ʃf[^n

extern EFFECT *CreateSoundEffect( u32 SoundID, u32 SoundWait, Vec Point, bool SE2DFlag = false, bool SoundOffMusiFlag = false, s32 Priority = 400 ) ;		// TEh̃GtFNg쐬
extern s8 ReleaseSoundEffect( EFFECT *Effect ) ;							// TEh̃GtFNǧns
extern s8 MoveSoundEffect( EFFECT *Effect ) ;								// TEh̃GtFNgPt[
extern s8 DrawSoundEffect( EFFECT *Effect ) ;								// TEh̃GtFNg`悷

#endif