///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSpotLight
//
// YK7EffectSpotLight.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 02/02/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectSpotLight.h"
#include "./YK7EffectNoise.h"
#include "../Wat/WK7MainTask.h"
#include "../Wat/WK7Cam.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

SPOTLIGHTUNION SpLUnion ;

// function proto type --------------------------

s8 SpotLightTexLoadCheck( void ) ;				// [hǂ𒲂ׂ

// function code --------------------------------

// [hǂ𒲂ׂ
s8 SpotLightTexLoadCheck( void )
{
	// I
	return TRUE ;
}



// X|bgCgGtFNg̋ʃf[^
extern s8 InitSpotLightData( void )
{
	MEMINIT( SpLUnion ) ;
	
	// I
	return 0 ;
}

// X|bgCgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSpotLightData( void )
{
	return TRUE ;
}



// X|bgCgGtFNg̋ʃf[^n
extern s8 EndSpotLightData( void )
{
	MEMINIT( SpLUnion ) ;
	
	// I
	return 0 ;
}


// X|bgCg̃GtFNg쐬
extern EFFECT *CreateSpotLightEffect( WK7JObj *JObj, s32 Priority )
{
	SPOTLIGHTEFFECT *Ns ;
	EFFECT *Effect = NULL, *Noise = NULL ;
	WK7ScreenImage *Image = NULL ;
	
	Image = new WK7ScreenImage ;
	if( Image == NULL ) return NULL ;
	if( Image->AllocBuffer() == false ) goto ER ;
	
	Noise = CreateNoiseEffect( TRUE ) ;
	if( Noise == NULL ) goto ER ;
	SetEffectIndeManageFlag( Noise, TRUE ) ;

	// VX|bgCgf[^쐬
	Effect = AddEffectData( EFF_SPOTLIGHT, (void**)&Ns, Priority ) ;
	if( Effect == NULL ) goto ER ;
	memset( Ns, 0, sizeof( SPOTLIGHTEFFECT ) ) ;

	// X|bgCgf[^
	Ns->JObj = JObj ;
	Ns->Image = Image ;
	Ns->Noise = Noise ;
	Ns->Counter = 0 ;
	
	//  JObj ͔\
	JObj->Hide( false, true ) ;

	// mCY𔭐	
	AddNoiseLine( Ns->Noise, (u8)VParam[ED_CHARCHANGE][3], VParam[ED_CHARCHANGE][4], VParam[ED_CHARCHANGE][5], VParam[ED_CHARCHANGE][6] ) ; 

	// I
	return Effect ;
	
ER :
	if( Image ) delete Image ;
	if( Noise ) DeleteEffect( Noise ) ;
	if( Effect ) DeleteEffect( Effect ) ;
	
	return NULL ;
}

// X|bgCg̃GtFNǧns
extern s8 ReleaseSpotLightEffect( EFFECT *Effect )
{
	SPOTLIGHTEFFECT *Ns = ( SPOTLIGHTEFFECT * )Effect->Data ;
	
	// 폜
	if( Ns->Image ) delete Ns->Image ;
	if( Ns->Noise ) DeleteEffect( Ns->Noise ) ;

	// ɂ邱ƂȂ
	return 0 ;
}

// X|bgCg̃GtFNgPt[
extern s8 MoveSpotLightEffect( EFFECT *Effect )
{
	SPOTLIGHTEFFECT *Ns = ( SPOTLIGHTEFFECT * )Effect->Data ;

	if( (SPOTLIGHTEFFECT *)NULL == Ns ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( SpotLightTexLoadCheck() == FALSE ) return 0 ;
	
	// JE^CNg
	Ns->Counter += VParam[ED_SPOTLIGHT][0] ;
	if( Ns->Counter >= SCH || Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// mCYGtFNg̃t[vZXs
	MoveEffect( Ns->Noise ) ;
	
	// I
	return 0 ;
}
	
// X|bgCg̃GtFNg`悷
extern s8 DrawSpotLightEffect( EFFECT *Effect )
{
	SPOTLIGHTEFFECT *Ns = ( SPOTLIGHTEFFECT * )Effect->Data ;

	if( (SPOTLIGHTEFFECT *)NULL == Ns ) return 0 ;
	if( SpotLightTexLoadCheck() == FALSE ) return 0 ;

	//VUO͈̔͐ݒ(!?)
	GXSetScissor( 0, 0, SCW, SCH );
	//r[|[g̐ݒ
	GXSetViewport( 0.0f, 0.0f, (f32)K7APP_SCREEN_WIDTH, (f32)K7APP_SCREEN_HEIGHT, 0.0f, 1.0f );
	
	// ܂ʂ荞
	Ns->Image->ScreenCopy() ;
	
	// ʂ
	{
		EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_NONE, EF_TEV_NOTEX ) ;
		GXSetAlphaUpdate( TRUE ) ;
		GXSetColorUpdate( TRUE ) ;
		GXSetDstAlpha( TRUE, 0 ) ;
		
		GXBegin( GX_QUADS, GX_VTXFMT0, 4 ) ;
		{
			GP2( 0, 0 ) ;		GCX( 0xff )  ;
			GP2( SCW, 0  ) ;	GCX( 0xff )  ;
			GP2( SCW, SCH ) ;	GCX( 0xff )  ;
			GP2( 0, SCH  ) ;	GCX( 0xff )  ;
		}
		GXEnd() ;
	}

	// f`悷
	{
		Ns->JObj->Disp( false, true ) ;
		Ns->JObj->SetDstAlpha( 255, false, true ) ;
		WK7CAM->SetCurrent() ;
		Ns->JObj->RenderProcess() ;
		WK7CAM->EndCurrent() ;
		Ns->JObj->Hide( false, true ) ;
	}

	//VUO͈̔͐ݒ(!?)
	GXSetScissor( 0, 0, SCW, SCH );
	//r[|[g̐ݒ
	GXSetViewport( 0.0f, 0.0f, (f32)K7APP_SCREEN_WIDTH, (f32)K7APP_SCREEN_HEIGHT, 0.0f, 1.0f );
	
	// ̈
	{
		EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_NONE, EF_TEV_NOTEX ) ;
		GXSetAlphaUpdate( TRUE ) ;
		GXSetColorUpdate( TRUE ) ;
		GXSetDstAlpha( TRUE, 0 ) ;
		
		GXBegin( GX_QUADS, GX_VTXFMT0, 4 ) ;
		{
			GP2( 0, 0 ) ;				GCX( 0xff )  ;
			GP2( SCW, 0  ) ;			GCX( 0xff )  ;
			GP2( SCW, Ns->Counter ) ;	GCX( 0xff )  ;
			GP2( 0, Ns->Counter ) ;		GCX( 0xff )  ;
		}
		GXEnd() ;
	}
	
	// ʂ荞
	screenImageFullColor.ScreenCopy() ;
	
	// X摜`悷
	{
		GTLOAD( Ns->Image->GetTexObj() ) ;
	
		EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_NONE, EF_TEV_USETEX ) ;
		DrawTex3( 0, 0, SCW, SCH ) ;
	}

	// mCYGtFNg`悷
	{
		DrawEffect( Ns->Noise ) ;
	}

	// I
	return 0 ;
}





