///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectStick
//
// YK7EffectStick.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/07/2004
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectStick.h"

// define ---------------------------------------

// data -----------------------------------------

STICKUNION stu ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// hGtFNg̋ʃf[^
extern s8 InitStickData( void )
{
	MEMINIT( stu ) ;

	stu.Length = (f32)VParam[ED_STICK][0] * 0.1F ;
	stu.Size = (f32)VParam[ED_STICK][1]	* 0.1F ;

	stu.AlphaSpeed = VParam[ED_STICK][8] * 0.01F ;
	stu.Alpha = stu.AlphaSpeed * VParam[ED_STICK][7] + 1.0F ;

	return 0 ;
}

// hGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckStickData( void )
{
	return TRUE ;
}

// hGtFNg̋ʃf[^n
extern s8 EndStickData( void )
{
	MEMINIT( stu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// hGtFNg쐬
extern EFFECT *CreateStickEffect(
									WK7JObj *JObj,				// hIuWFNg JObj
									Vec Pos,					// GtFNgoW
									GXColor color,				// F
									s32 Priority )				// hGtFNg쐬
{
	EFFECT *Effect ;
	STICKEFFECT *st ;
	
	// Vhf[^쐬
	Effect = AddEffectData( EFF_STICK, (void**)&st, Priority ) ;
	if( Effect == NULL ) return NULL ;
	memset( st, 0, sizeof( STICKEFFECT ) ) ;

	// hf[^
	st->color = *((u32 *)&color) ;
	if( CreateVertexHomingData( &st->PosInfo, JObj, Pos ) < 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	st->Length = stu.Length ;
	stu.Length = (f32)VParam[ED_STICK][0] * 0.1F ;
	
	st->Size = stu.Size ;
	stu.Size = (f32)VParam[ED_STICK][1]	* 0.1F ;

	st->AlphaSpeed = stu.AlphaSpeed ;
	stu.AlphaSpeed = VParam[ED_STICK][8] * 0.01F ;
	
	st->Alpha = stu.Alpha ;
	stu.Alpha = stu.AlphaSpeed * VParam[ED_STICK][7] + 1.0F ;

	// I
	return Effect ;
}

// hGtFNǧns
extern s8 ReleaseStickEffect( EFFECT *Effect )
{
	STICKEFFECT *st = ( STICKEFFECT * )Effect->Data ;

	// hf[^̌n
	ReleaseVertexHomingData( &st->PosInfo ) ;

	// I
	return 0 ;
}

// hGtFNgPt[
extern s8 MoveStickEffect( EFFECT *Effect )
{
	STICKEFFECT *st = ( STICKEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	st->Alpha -= st->AlphaSpeed ;
	if( st->Alpha < 0.0F )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// I
	return 0 ;
}

// hGtFNg`悷
extern s8 DrawStickEffect( EFFECT *Effect )
{
	STICKEFFECT *st = ( STICKEFFECT * )Effect->Data ;
	Vec pos, nrm ;
	u8 DivNum ;
	f32 size, len ;
	u32 color ;

	if( VParam[ED_STICK][2] <= 2 ) VParam[ED_STICK][2] = 2 ;
	
	// ǔ钸_݂̌̍Wƌ擾
	GetVertexHomingInfo( &st->PosInfo, &pos, &nrm ) ;
	VECNormalize( &nrm, &nrm ) ;
	
	// ~̕`揀
	DrawCylinSetup( nrm ) ;
	
	color = CMKC2( st->color, ( st->color & 0xff ) * ( st->Alpha >= 1.0F ? 1.0F : st->Alpha ) ) ;

	// `
	len = st->Length ;
	size = st->Size ;
	DivNum = (u8)VParam[ED_STICK][6] ;
	DrawCylin( pos, nrm, 0.0F, len, size, 0.0F, color, DivNum ) ;
	DrawCylin( pos, nrm, 0.0F, -len, size, 0.0F, color, DivNum ) ;

	// I
	return 0 ;
}

// hIuWFNg̒ύX
extern void SetStickLength( f32 len )
{
	stu.Length = len ;
}

// hIuWFNg̕ύX
extern void SetStickWidth( f32 width )
{
	stu.Size = width ;
}

// hIuWFNg\鎞Ԋ֌Wݒ肷
extern void SetStickDrawTime( u8 Time, f32 AlphaSpeed )
{
	stu.AlphaSpeed = AlphaSpeed < 0.0F ? VParam[ED_STICK][8] * 0.01F : AlphaSpeed ;
	stu.Alpha = stu.AlphaSpeed * Time + 1.0F ;
}


