///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectVital
//
// YK7EffectVital.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/06/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectVital.h"

#if FUJITA
#include "../Wat/WK7MainTask.h"
#endif

// define ---------------------------------------

#define CIR_DIVNUM			30				// ~̕		

// datatype -------------------------------------

// data -----------------------------------------

VITALUNION VitUnion ;

// function code --------------------------------

// ̗̓GtFNg̋ʃf[^
extern s8 InitVitalData( void )
{
	MEMINIT( VitUnion ) ;

	// I
	return 0 ;
}

// ̗̓GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckVitalData( void )
{
	return TRUE ;
}

// ̗̓GtFNg̋ʃf[^n
extern s8 EndVitalData( void )
{
	MEMINIT( VitUnion ) ;

	// I
	return 0 ;
}


// ̗͂̃GtFNg쐬
extern EFFECT *CreateVitalEffect( s32 Priority )
{
	VITALEFFECT *Vital ;
	EFFECT *Effect ;
	
	// V̗̓f[^쐬
	Effect = AddEffectData( EFF_VITAL, (void**)&Vital, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// ̗̓f[^
	Vital->TempVitalRate = 1.0F ;
	Vital->VitalRate = 1.0F ;
	Vital->DrawFlag = FALSE ;

	// I
	return Effect ;
}

// ̗͂̃GtFNǧns
extern s8 ReleaseVitalEffect( EFFECT *Effect )
{
	VITALEFFECT *Vital = ( VITALEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ
	return 0 ;
}

// ̗͂̃GtFNgPt[
extern s8 MoveVitalEffect( EFFECT *Effect )
{
	VITALEFFECT *Vital = ( VITALEFFECT * )Effect->Data ;

	if( (VITALEFFECT *)NULL == Vital ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
	}
	else
	{
		// ̗͂߂Â
		if( Vital->TempVitalRate < Vital->VitalRate )
		{
			Vital->TempVitalRate += 0.05F + ( Vital->VitalRate - Vital->TempVitalRate ) / 4.0F ;
	//		Vital->TempVitalRate += 0.1F ;
			if( Vital->TempVitalRate > Vital->VitalRate ) Vital->TempVitalRate = Vital->VitalRate ;
		}
		else
		if( Vital->TempVitalRate > Vital->VitalRate )
		{
			Vital->TempVitalRate -= 0.05F + ( Vital->TempVitalRate - Vital->VitalRate ) / 4.0F ;
	//		Vital->TempVitalRate -= 0.1F ;
			if( Vital->TempVitalRate < Vital->VitalRate ) Vital->TempVitalRate = Vital->VitalRate ;
		}
	}
	
	// I
	return 0 ;
}
	
// ̗͂̃GtFNg`悷
extern s8 DrawVitalEffect( EFFECT *Effect )
{
	VITALEFFECT *Vital = ( VITALEFFECT * )Effect->Data ;
//	int DrawNum ;
//	static Vec TempV[2][CIR_DIVNUM] ;
	Vec (*TempV)[CIR_DIVNUM] = ( Vec (*)[CIR_DIVNUM] )WorkBuffer ;
	VITALUNION *VitalUnion = &VitUnion ;

	if( (VITALEFFECT *)NULL == Vital ) return 0 ;
	if( Vital->DrawFlag == FALSE ) return 0 ;
	
	if( VitUnion.NotDrawFlag == TRUE ) return 0 ;

#if FUJITA
#if 0
#if 0
	static f32 r = 0.f;
	r += 0.005f;
	if( r > 1.f ) r = 0.f;
	C_BrokenGlass g( screenImageFullColor.GetTexObj(), r );
#e	se
	C_BrokenGlass g( screenImageFullColor.GetTexObj(), Vital->TempVitalRate );
	g.Disp();
#endif
#endif
	return 0;
#endif
	// `揀
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;
	
	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA4, 0 ) ;

	// iq̒_f[^p
	{
		u32 i ;
		f32 Size ;
		
		Size = Vital->TempVitalRate * 400 ;
		for( i = 0 ; i < CIR_DIVNUM ; i ++ )
		{
			TempV[0][i].x = ( COS( ( PI2DIV * i ) / ( CIR_DIVNUM - 1 ) ) * 400.0F + WK7_SCREEN_WIDTH / 2 ) ;
			TempV[0][i].y = ( SIN( ( PI2DIV * i ) / ( CIR_DIVNUM - 1 ) ) * 400.0F + WK7_SCREEN_HEIGHT / 2 ) ;
			
			TempV[1][i].x = ( COS( ( PI2DIV * i ) / ( CIR_DIVNUM - 1 ) ) * Size + WK7_SCREEN_WIDTH / 2 ) ;
			TempV[1][i].y = ( SIN( ( PI2DIV * i ) / ( CIR_DIVNUM - 1 ) ) * Size + WK7_SCREEN_HEIGHT / 2 ) ;
		}
	}

	// `揈
	{
		u16 i, Color1, Color2 ;

		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( ( CIR_DIVNUM - 1 ) * 4 ) ) ;
		{
			Color1 = GXPackedRGBA4( (u8)VParam[ED_VITAL][1], (u8)VParam[ED_VITAL][2], (u8)VParam[ED_VITAL][3], 255 ) ;
			Color2 = GXPackedRGBA4( 0, 0, 0, 0 ) ;

			for( i = 0 ; i < CIR_DIVNUM - 1 ; i ++ )
			{
				GP2( TempV[0][i].x, TempV[0][i].y ) ; GXColor1u16( Color1 ) ;
				GP2( TempV[0][i+1].x, TempV[0][i+1].y ) ; GXColor1u16( Color1 ) ;
				GP2( TempV[1][i+1].x, TempV[1][i+1].y ) ; GXColor1u16( Color2 ) ;
				GP2( TempV[1][i].x, TempV[1][i].y ) ; GXColor1u16( Color2 ) ;
			}
		}
		GXEnd() ;
	}

	// I
	return 0 ;
}

// ̗͂Zbg
extern s8 SetVitalRate( f32 VitalRate, EFFECT *Effect )
{
	VITALEFFECT *Vital = ( VITALEFFECT * )Effect->Data ;
	
	Vital->VitalRate = VitalRate ;
	
	// I
	return 0 ;
}

// ̗̓GtFNg`悷邩ǂ̃tOZbg
extern s8 SetVitalDrawFlag( u8 DrawFlag, EFFECT *Effect )
{
	VITALEFFECT *Vital = ( VITALEFFECT * )Effect->Data ;
	
	Vital->DrawFlag = DrawFlag ;
	
	// I
	return 0 ;
}
	
// ݒ肵̗̓[gɐڂ𓾂(TRUE:ڂ  FALSE:܂BĂȂ)
extern s8 CheckVitalRate( EFFECT *Effect )
{
	VITALEFFECT *Vital = ( VITALEFFECT * )Effect->Data ;
	
	// I
	return 	(s8)( Vital->TempVitalRate == Vital->VitalRate ? TRUE : FALSE ) ;
}

// ̗͕\`悷邩ǂ̃tOZbg
extern s8 SetVitalAllDrawFlag( s8 Flag )
{
	VitUnion.NotDrawFlag = !Flag ;
	
	// I
	return 0 ;
}	
