///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectWave
//
// YK7EffectWave.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/11/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectWave.h"
#include "../Wat/WK7MainTask.h"

// define ---------------------------------------

#define SCREEN_XDIVNUM			20									// ʂ̉̕
#define SCREEN_YDIVNUM			(u32)(SCREEN_XDIVNUM * 0.75F)		// ʂ̏c̕

// datatype -------------------------------------

// data -----------------------------------------

WAVEUNION WavUnion ;

// function code --------------------------------

// gGtFNg̋ʃf[^
extern s8 InitWaveData( void )
{
	MEMINIT( WavUnion ) ;
	
	// I
	return 0 ;
}

// gGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckWaveData( void )
{
	return TRUE ;
}

// gGtFNg̋ʃf[^n
extern s8 EndWaveData( void )
{
	MEMINIT( WavUnion ) ;
	
	// I
	return 0 ;
}


// g̃GtFNg쐬
extern EFFECT *CreateWaveEffect( Vec Point, f32 Height,	f32 SubAcceHeight,	f32 Length, f32 SubAcceLength,
									f32 Speed, f32 SubAcceSpeed, u8 SubBlendFlag, GXColor SubColor, s32 Priority )
{
	WAVEEFFECT *Wave ;
	EFFECT *Effect ;
	
	// Vgf[^쐬
	Effect = AddEffectData( EFF_WAVE, (void**)&Wave, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// gf[^
	Wave->Point = Point ;
	Wave->Height = Height ;
	Wave->SubAcceHeight = SubAcceHeight ;
	Wave->Length = Length ;
	Wave->SubAcceLength = SubAcceLength ;
	Wave->Speed = Speed ;
	Wave->SubAcceSpeed = SubAcceSpeed ;
	Wave->r = -Length / 2 ;	
//	Wave->Point.z = 0.0F ;
	Wave->SubBlendFlag = SubBlendFlag ;
	Wave->SubColor = SubColor ;

	// I
	return Effect ;
}

// g̃GtFNǧns
extern s8 ReleaseWaveEffect( EFFECT *Effect )
{
	WAVEEFFECT *WaveEffect = ( WAVEEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ
	return 0 ;
}

// g̃GtFNgPt[
extern s8 MoveWaveEffect( EFFECT *Effect )
{
	WAVEEFFECT *WaveEffect = ( WAVEEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	// I𖞂Ă폜
	if( /*( WaveEffect->r > WK7_SCREEN_WIDTH * 1.5F ) ||*/
		( WaveEffect->Speed < 0.0F ) ||
		( WaveEffect->Length < 0.0F ) ||
		( WaveEffect->Height < 0.0F ) )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	else
	{
		// ȊȌꍇ͐ڏ
		WaveEffect->r += WaveEffect->Speed ;
		WaveEffect->Length -= WaveEffect->SubAcceLength ;
		WaveEffect->Height -= WaveEffect->SubAcceHeight ;
		WaveEffect->Speed -= WaveEffect->SubAcceSpeed ;
	}
	
	// I
	return 0 ;
}
	
// g̃GtFNg`悷
extern s8 DrawWaveEffect( EFFECT *Effect )
{
	WAVEEFFECT *Wave = ( WAVEEFFECT * )Effect->Data ;
	WAVEUNION *WaveUnion = &WavUnion ;
//	static Vec Map[SCREEN_YDIVNUM][SCREEN_XDIVNUM] ;
//	static u16 UVMap[SCREEN_YDIVNUM][SCREEN_XDIVNUM][2] ;
	Vec (*Map)[SCREEN_XDIVNUM] = ( Vec (*)[SCREEN_XDIVNUM] )WorkBuffer ;
	u16 (*UVMap)[SCREEN_XDIVNUM][2] = ( u16 (*)[SCREEN_XDIVNUM][2] )&WorkBuffer[sizeof( Vec ) * SCREEN_XDIVNUM * SCREEN_YDIVNUM] ;
	f32 Height, Length, rr ;
	Vec Point ;
	GXColor Color ;
	
	// XP[Oꂽ_WEEa߂
	{
		f32 Scale ;
	
		GetScreenPosition( &Wave->Point, &Point ) ;
//		Point = (Vec){320.0F, 240.0F, 0.0F } ;
		Scale = GetScreenSize( &Wave->Point, 0.1F ) ;
//		Scale = 1.0F ;
//		Point.x = WK7_SCREEN_WIDTH - Point.x ;
//		Point.y = WK7_SCREEN_HEIGHT - Point.y ;

		Height = Wave->Height * Scale ;
		Length = Wave->Length * Scale ;
		rr = Wave->r * Scale ;
	}

	// ʂ̕`Ԃ擾鏈
	{
		screenImageFullColor.ScreenCopy() ;
		GTLOAD( screenImageFullColor.GetTexObj() ) ;
	}

	// `揀
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_NONE, EF_TEV_USETEX ) ;

	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;

	// F̃Zbg
	if( Wave->SubBlendFlag == TRUE  )
		Color = Wave->SubColor ;
	else
		Color = (GXColor){255, 255, 255, 255} ;
		
	// iq̒_f[^p
	{
		Vec V, tempV ;
		u32 i, j ;
		Vec *Z ;
		f32 r, z ;
		u16 u, v, *UV ;
		const f32 d = 1115.7475601F ;
		
		// ꒸_}bv쐬
		Z = &Map[0][0] ;
		UV = &UVMap[0][0][0] ;
		V.z = 0.0F ;
		tempV.z = 0.0F ;
		for( i = 0 ; i < SCREEN_YDIVNUM ; i ++ )
		{
			V.y = (f32)WK7_SCREEN_HEIGHT / ( SCREEN_YDIVNUM - 1 ) * i ;
			v = (u16)( UVSCALE * i / ( SCREEN_YDIVNUM - 1 ) ) ;
			for( j = 0 ; j < SCREEN_XDIVNUM ; j ++, Z ++, UV += 2 )
			{
				V.x = (f32)WK7_SCREEN_WIDTH / ( SCREEN_XDIVNUM - 1 ) * j ;
				u = (u16)( UVSCALE * j / ( SCREEN_XDIVNUM - 1 ) ) ;

				tempV.x = V.x - Point.x ;
				tempV.y = V.y - Point.y ;
				r = ( sqrt( tempV.x * tempV.x + tempV.y * tempV.y ) - rr ) / ( Length / 2 ) ;

				UV[0] = u ;
				UV[1] = v ;
				if( r < 1.0F && r > -1.0F )
				{
					Z->z = cos( r * PI / 2 ) * Height ;
					z = ( d - Z->z ) / d ;
					if( z < 0.1F ) z = 0.1F ; 
				}
				else
				if( r > 1.0F && r < 3.0F )
				{
					r -= 1.0F ;
					Z->z = cos( r * PI / 2 + PI / 2 ) * Height / 2 ;
					z = ( d - Z->z ) / d ;
					if( z < 0.1F ) z = 0.1F ; 
				}
				else
				{
					z = 1.0F ; 
					Z->z = 0.0F ;
				}

				Z->x = ( ( V.x - Point.x ) / z + Point.x ) ;
				Z->y = ( ( V.y - Point.y ) / z + Point.y ) ;
			}
		}
	}

	// `揈
	{
		u16 i, j ;

		GXBegin( GX_TRIANGLES, GX_VTXFMT0, (u16)( ( SCREEN_XDIVNUM - 1 ) * ( SCREEN_YDIVNUM - 1 ) * 6 ) ) ;
		{
			// Ő[̉~ȊỎ~`
			{
				// ̐JԂ
				for( i = 0 ; i < SCREEN_YDIVNUM - 1 ; i ++ )
				{
					for( j = 0 ; j < SCREEN_XDIVNUM - 1 ; j ++ )
					{
						// W̏o
						GPV2( Map[i][j] ) ;		GC( Color ) ;  GT2( UVMap[i][j][0], UVMap[i][j][1] ) ; 
						GPV2( Map[i][j+1] ) ;	GC( Color ) ; GT2( UVMap[i][j+1][0], UVMap[i][j+1][1] ) ; 
						GPV2( Map[i+1][j] ) ;	GC( Color ) ; GT2( UVMap[i+1][j][0], UVMap[i+1][j][1] ) ; 

						GPV2( Map[i+1][j] ) ;	GC( Color ) ; GT2( UVMap[i+1][j][0], UVMap[i+1][j][1] ) ; 
						GPV2( Map[i][j+1] ) ;	GC( Color ) ; GT2( UVMap[i][j+1][0], UVMap[i][j+1][1] ) ; 
						GPV2( Map[i+1][j+1] ) ;	GC( Color ) ; GT2( UVMap[i+1][j+1][0], UVMap[i+1][j+1][1] ) ; 
					}
				}
			}
		}
		GXEnd() ;
	}
	
	// I
	return 0 ;
}
