///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectWhirl
//
// YK7EffectWhirl.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/06/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTWHIRL_H
#define __YK7EFFECTWHIRL_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// ʂ˂GtFNgʃf[^
typedef struct tagWHIRLUNION
{
	u8 Dummy ;
} WHIRLUNION ;

// ʂ˂GtFNgf[^
typedef struct tagWHIRLEFFECT
{
//	WK7ScreenImage *ScreenImage ;		// ʃC[W荞ݗp
	Vec Point ;							// ˂ꂳW
	f32 Radius ;						// ˂ꂳ锼a
	f32 RadiusSpeed ;					// ˂ꂳ锼ãXs[h
	f32 Rotate ;						// ˂ꂳpx
	f32 WhirlSpeed ;					// ˂ꂳ鑬x(100.0˂ꂫ)
	f32 WhirlAddSpeed ;					// ˂ꂳx
	u16 WhirlTime ;						// ˂ꂳ鎞
	u16 WhirlWait ;						// ˂ꂫĂ̒~
	f32 WhirlFinishSpeed ;				// ˂ꂪɖ߂鑬x
	f32 WhirlFinishAddSpeed ;			// ˂ꂪɖ߂x
	u16 WhirlFinishTime ;				// ˂ꂩ߂܂ł̎
	u16 Counter ;						// JE^[
	f32 RotCounter ;					// ]JE^[
	u16 Mode ;							// tF[Y
} WHIRLEFFECT ;

// ʂ˂GtFNgf[^p\
typedef struct tagWHIRLEFFECTTASKPARAM
{
	Vec Point ;					// ʂւ܂RcW
	f32 Radius ;				// ˂ꂳ锼a
	f32 RadiusSpeed ;			// ˂ꂳ锼ãXs[h
	f32 Rotate ;				// ˂ꂳpx
	f32 WhirlSpeed ;			// ˂ꂳ鑬x(100.0˂ꂫ WhirlTimeÔƂ̂ݗL)
	f32 WhirlAddSpeed ;			// ˂ꂳx(WhirlTimeÔƂ̂ݗL)
	u16 WhirlTime ;				// ˂ꂳ鎞 
	u16 WhirlWait ;				// ˂ꂫĂ̒~
	f32 WhirlFinishSpeed ;		// ˂ꂪɖ߂鑬x(WhirlFinishTimeÔƂ̂ݗL)
	f32 WhirlFinishAddSpeed ;	// ˂ꂪɖ߂x(WhirlFinishTimeÔƂ̂ݗL)
	u16 WhirlFinishTime ;		// ˂ꂩ߂܂ł̎
} WHIRLEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitWhirlData( void ) ;				// ʂ˂GtFNg̋ʃf[^
extern s8 CheckWhirlData( void ) ;				// ʂ˂GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndWhirlData( void ) ;				// ʂ˂GtFNg̋ʃf[^n

//extern void WhirlEffectTask( ghmGcTask *pTask ) ;						// ʂ˂GtFNg^XN

extern EFFECT *CreateWhirlEffect( Vec Point,					// ʂւ܂RcW
									f32 Radius,					// ˂ꂳ锼a
									f32 RadiusSpeed,			// ˂ꂳ锼ãXs[h
									f32 Rotate,					// ˂ꂳpx
									f32 WhirlSpeed,				// ˂ꂳ鑬x(100.0˂ꂫ WhirlTimeÔƂ̂ݗL)
									f32 WhirlAddSpeed,			// ˂ꂳx(WhirlTimeÔƂ̂ݗL)
									u16 WhirlTime,				// ˂ꂳ鎞 
									u16 WhirlWait,				// ˂ꂫĂ̒~
									f32 WhirlFinishSpeed,		// ˂ꂪɖ߂鑬x(WhirlFinishTimeÔƂ̂ݗL)
									f32 WhirlFinishAddSpeed,	// ˂ꂪɖ߂x(WhirlFinishTimeÔƂ̂ݗL)
									u16 WhirlFinishTime,		// ˂ꂩ߂܂ł̎
									s32 Priority = 1500 ) ;					// ʂ˂GtFNg쐬
extern s8 ReleaseWhirlEffect( EFFECT *Effect ) ;							// ʂ˂GtFNǧns
extern s8 MoveWhirlEffect( EFFECT *Effect ) ;								// ʂ˂GtFNgPt[
extern s8 DrawWhirlEffect( EFFECT *Effect ) ;								// ʂ˂GtFNg`悷

extern s8 SetWhirlEffectRadius( EFFECT *Effect, f32 Radius ) ;		// ˂ꂳ锼aύX

#endif