///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectWind
//
// YK7EffectWind.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/26/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectWind.h"
#include "./YK7EffectLine.h"

// define ---------------------------------------
#define ONE_V		(1.0F / ( WIND_AIMAGENUM - 1 ))

// data -----------------------------------------

WINDUNION wdu ;
extern LINEUNION LUnion ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// GtFNg̋ʃf[^
extern s8 InitWindData( void )
{
	MEMINIT( wdu ) ;

	return 0 ;
}

// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckWindData( void )
{
	return TRUE ;
}

// GtFNg̋ʃf[^n
extern s8 EndWindData( void )
{
	MEMINIT( wdu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// GtFNg쐬
extern EFFECT *CreateWindEffect(
								s32 objmaxnum,			// IuWFNg̍ő吔

								Vec pos,				// SW
								f32 r,					// a

								f32 speed,				// x
								Vec dir,				// 
								Vec adddir, 			// Z

								s32 lifetime,			// \
								f32 alphaspeed,			// At@Xs[h

								f32 crerate,			// 쐬x

								u32 color,				// F
								s32 Priority )			// GtFNg쐬
{
	EFFECT *Effect ;
	WINDEFFECT *wd ;
	WINDOBJECT *obj ;
	
	// IuWFNg̃f[^j̍郁̊m
	obj = ( WINDOBJECT * )K7AppSmallMemAllocName( (s32)( objmaxnum * sizeof( WINDOBJECT ) ), "Y_WndObj" ) ;
	if( obj == NULL ) return NULL ;
	memset( obj, 0, objmaxnum * sizeof( WINDOBJECT ) ) ;
	
	// Vf[^쐬
	Effect = AddEffectData( EFF_WIND, (void**)&wd, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( obj ) ;
		return NULL ;
	}
	memset( wd, 0, sizeof( WINDEFFECT ) ) ;
	
	// ̃Zbg
	wd->obj = obj ;
	wd->objnum = 0 ;
	wd->objmaxnum = objmaxnum ;
	
	wd->pos = pos ;
	wd->r = r ;

	wd->speed = speed ;
	wd->dir = dir ;
	wd->adddir = adddir ;
	GetXYZVector( wd->dir, &wd->xv, &wd->yv, &wd->zv ) ;

	wd->alpha = 1.0F + lifetime * alphaspeed ;
	wd->alphaspeed = alphaspeed ;
	
	wd->crerate = crerate ;
	wd->crecounter = 0.0F ;
	
	wd->color = color ;
	wd->basealpha = 1.0F ;

	// I
	return Effect ;
}

// GtFNǧns
extern s8 ReleaseWindEffect( EFFECT *Effect )
{
	WINDEFFECT *wd = ( WINDEFFECT * )Effect->Data ;
	
	if( wd->obj != NULL ) K7AppSmallMemFree( wd->obj ) ;

	// I
	return 0 ;
}

// GtFNgPt[
extern s8 MoveWindEffect( EFFECT *Effect )
{
	WINDEFFECT *wd = ( WINDEFFECT * )Effect->Data ;
	WINDOBJECT *ob ;
	s32 num, i ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE )
	{
		wd->basealpha -= (f32)VParam[ED_WIND][1] * 0.01F ;
	}
	
	if( Effect->DelReqFlag == TRUE && ( wd->objnum == 0 || wd->basealpha <= 0.0F ) )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// 
	ob = wd->obj ;
	num = wd->objnum ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->valid == FALSE ) continue ;
		
		i ++ ;

		memmove( &ob->pos[1], &ob->pos[0], sizeof( Vec ) * ( WIND_AIMAGENUM - 1 ) ) ;
		ob->pos[0].x += ob->dir.x * wd->speed ;
		ob->pos[0].y += ob->dir.y * wd->speed ;
		ob->pos[0].z += ob->dir.z * wd->speed ;
		
		ob->dir.x += wd->adddir.x ;
		ob->dir.y += wd->adddir.y ;
		ob->dir.z += wd->adddir.z ;
		VECNormalize( &ob->dir, &ob->dir ) ;

		ob->alpha -= wd->alphaspeed ;
		if( ob->alpha <= 0.0F )
		{
			wd->objnum -- ;
			ob->valid = FALSE ;
		}
	}

	// 쐬
	if( Effect->DelReqFlag == FALSE && wd->objnum < wd->objmaxnum )
	{
		s32 rot ;
		f32 len, x, y ;
	
		wd->crecounter += 1.0F ;
		while( wd->crecounter >= wd->crerate && wd->objnum < wd->objmaxnum )
		{
			wd->crecounter -= wd->crerate ;
			
			// gĂȂIuWFNgT
			for( ob = wd->obj ; ob->valid ; ob ++ ){}
			
			// Zbg
			wd->objnum ++ ;
			
			ob->valid = TRUE ;
			ob->alpha = wd->alpha ;
			ob->dir = wd->dir ;

			rot = GetRandINum( PI2DIV ) ;
			len = GetRandFNum( wd->r ) ;
			x = COS( rot ) * len ;
			y = SIN( rot ) * len ;
//			x = COSF( (f32)rot * PI_2 / PI2DIV ) * len ;
//			y = SINF( (f32)rot * PI_2 / PI2DIV ) * len ;

			ob->pos[0].x = wd->xv.x * x + wd->yv.x * y + wd->pos.x ;
			ob->pos[0].y = wd->xv.y * x + wd->yv.y * y + wd->pos.y ;
			ob->pos[0].z = wd->xv.z * x + wd->yv.z * y + wd->pos.z ;
			for( i = 1 ; i < WIND_AIMAGENUM ; i ++ ) ob->pos[i] = ob->pos[0] ;
		}
	}
	
	// I
	return 0 ;
}

// GtFNg`悷
extern s8 DrawWindEffect( EFFECT *Effect )
{
	WINDEFFECT *wd = ( WINDEFFECT * )Effect->Data ;
	WINDOBJECT *ob ;
	f32 v ;
	s32 num, i, j ;
	u32 cr, balpah ;
	
	if( wd->objnum == 0 ) return 0 ;
	
	// `̏
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
	
	// eNX`̃[h
	GTLOAD2( LUnion.TestTex ) ;

	// ̑Zbg
	GXSetLineWidth( (u8)VParam[ED_WIND][0], GX_TO_ONE ) ;
	GXEnableTexOffsets( GX_TEXCOORD0, GX_ENABLE, GX_ENABLE ) ;
	
	// {At@lZbg
	balpah = (u32)( VParam[ED_WIND][12] * wd->basealpha ) ;
	
	// `
	GBGN( GX_LINES, wd->objnum * ( ( WIND_AIMAGENUM - 1 ) * 2 ) ) ;
	{
		ob = wd->obj ;
		num = wd->objnum ;
		for( i = 0 ; i < num ; ob ++ )
		{
			if( ob->valid == FALSE ) continue ;
			
			i ++ ;
			
			cr = CMKC2( wd->color, ob->alpha >= 1.0F ? balpah : ob->alpha * balpah ) ;

			GPV( ob->pos[0] ) ;		GCX( CMKC2( wd->color, 0 ) ) ;	GT( 0.0F, 0.0F ) ;
			GPV( ob->pos[1] ) ;		GCX( cr ) ;						GT( 0.0F, ONE_V ) ;

			v = ONE_V ;			
			for( j = 1 ; j < WIND_AIMAGENUM - 2 ; j ++, v += ONE_V )
			{
				GPV( ob->pos[j] ) ;		GCX( cr ) ;		GT( 0.0F, v ) ;
				GPV( ob->pos[j+1] ) ;	GCX( cr ) ;		GT( 0.0F, v + ONE_V ) ;
			}

			GPV( ob->pos[j] ) ;		GCX( cr ) ;						GT( 0.0F, v ) ;
			GPV( ob->pos[j+1] ) ;	GCX( CMKC2( wd->color, 0 ) ) ;	GT( 0.0F, v + ONE_V ) ;
		}
	}
	GEND() ;
	
	// I
	return 0 ;
}

