///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7MapSelect
//
// YK7MapSelect.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 09/10/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __MAPSELECT
#define __MAPSELECT

// include --------------------------------------
#include <dolphin.h>
#include "./YK7Effect.h"
#include "./YK7TestTask.h"
#include "../Wat/WK7MainTask.h"
#include "../Lib/ghmGcTex.h"

// define ---------------------------------------

// }bvIꏊhc
enum
{
	MAP_VIADU = 0,					// RXeubW
	MAP_GAL_HOME = 1,				// KVA
	MAP_HORAIZUN = 2,				// zCY^[
	MAP_SCHOOL = 3,					// Ro[wZ
	MAP_ISZKLAND = 4,				// ISZKh
	MAP_CATHISU_HOUSE = 5,			// J[eBX@
	MAP_OKUTAGON = 6,				// IN^S
	MAP_FUKUSHIMA = 7,				// tNV}
	MAP_FUKUSHIMA_AFTER = 8,		// tNV}Ւn
	MAP_TEARROOM = 9,				// i
	MAP_SQUARE_BUIL = 10,			// pr
	MAP_INTER_CITY = 11,			// C^[VeB
	MAP_CORRIDOR = 12,				// L
	MAP_BROARDWAY = 13,				// u[hEFC
	MAP_HOTEL = 14,					// ze
	MAP_WARSHIP_ISLAND = 15,		// ͓
	MAP_NONAMEBUILL = 30,			// O̖r
	MAP_SPORTCLUB = 31,				// X|[cNu
	MAP_SHANGHAI = 40,				// C
	
	MAP_WASHINGTON2 = 35,			// ()VgZOOM1
	MAP_WASHINGTON3 = 36,			// ()VgZOOM2
	MAP_WASHINGTON = 16,			// Vg
	MAP_WASHINGTON_DC = 17,			// VgcDb
	MAP_TEXAS2 = 37,				// eLTXZOOM1
	MAP_TEXAS = 18,					// eLTXZOOM2
	MAP_DOMINIKA2 = 34,				// h~jJZOOM1
	MAP_DOMINIKA = 19,				// h~jJZOOM2
	MAP_NY2 = 32,					// ()j[[NZOOM1
	MAP_NY3 = 33,					// j[[NZOOM2
	MAP_NY = 20,					// j[[NZOOM3
	MAP_NY_PHILADELPHIA = 38,		// j[[NEtBftBA
	MAP_PHILADELPHIA = 21,			// tBftBA
	MAP_WORLD = 22,					// En}
	
	MAP_SEATTLE = 39,				// VAg
	MAP_SEATTLE_SUBURB = 23,		// VAgxO
	MAP_SEATTLE_CITY = 24,			// VAgssGA
	MAP_SEATTLE_MOUNTAINS = 25,		// VAgRԕGA
	MAP_WASHINGTON_DC_DEFENSE = 26,	// VgcDbhGA
	MAP_WASHINGTON_DC_CENTER = 27,	// VgcDbSnGA
	MAP_PHILADELPHIA_CITY = 28,		// tBftBAAss
	
	MAP_USA = 29,					// AJSy
	
	MAP_NUM = 41,					// }bvI̍ő吔
} ;

// data type ------------------------------------

// data -----------------------------------------

// function proto type --------------------------

//extern s8 MapSelectInit( s32 FirstMap = MAP_USA, s32 SelectMap = -1 ) ;				// }bvZNg̏
extern s8 MapSelectInit( s32 FirstMap, s32 GoolMap, bool ButtonCancelFlag = true ) ;	// }bvZNg̏
extern s8 MapSelectEnd( void ) ;											// }bvZNǧn

extern s8 MapSelectFrameProcess( void ) ;									// }bvZNg̃t[vZX
extern s8 MapSelectRenderProcess( void ) ;									// }bvZNg̕`vZX

extern s8 CheckMapSelectEnd( void ) ;										// }bvZNgIǂ擾( TRUE:I  FALSE:܂s )
extern s32 GetMapSelectPoint( void ) ;										// }bvZNgőIꂽ(Ă)ꏊhc𓾂

extern void SetMapSelectValidFlag( u8 MapID, u8 Flag ) ;					// }bvZNg̗L̃tOZbg
extern u8 GetMapSelectValidFlag( u8 MapID ) ;								// }bvZNg̗L̃tO擾

extern s8 MapRootCreate( s32 StartID, s32 EndID ) ;							// }bvړ̌oHTi[


#endif

