// =============================================================================
//
//	tHgC[WNX
//
//	YK7String.h
//
//	Creator			: Takumi Yamada(GHM)
//	Creation Date	: 02/23/04
//
// =============================================================================

/*

	폜 delete 邾

	C[Wt@CtH[}bg
	
		悸 FONTIMAGEFILEHEAD 
		̎ StrPackNum ̐ SISTRPACK ݂
		̎ StrNum ̐ STRINFO ݂
		̎ ChrNum ̐ CHRINFO ݂
		̎ GCpeNX`t@C̃C[WۂƓĂ

	ȏ
*/

// dCN[hh~p`
#ifndef __YK7STRING
#define __YK7STRING

// include ---------------------------------------
#include "../Lib/ghmGcFile.h"
#include "../Lib/ghmGcTex.h"

// define ----------------------------------------

#define SIMAXSTRCHRNUM		(128)				// ̍̕ő啶
#define SIMAXSTRNUM			(30)				// ̕pbNɊi[ł镶̐
#define SIIDENTIFIER		("STRIMAGE")		// t@Cʗphc
#define SIIDENTIFIER_SIZE	(9)					// t@Cʗphc̕


// data type -------------------------------------

// ꕶ̏
typedef struct tagSICHR
{
	unsigned short Code ;		// R[h
	unsigned short x, y ;		// ݂`̍W
	unsigned short w, h ;		// ̃TCY( addw ̒lfĂ )
	short dx, dy ;				// w̍Wɕ`悷ۂɕKvȉ摜``悷ׂWւ̑Βl( addw ̒lfĂ )
	unsigned short addx ;		// ̕\ׂW̑Βl( addw ł̍W␳sł̒l )
	unsigned char addw ;		// tB^̂߂ɕ␳TCY̕Е̕
	unsigned short Code2 ;		// ڂɎgR[h(R[hƎۂɓo^R[hႤꍇɎg)
} SICHR ;

// ̏
typedef struct tagSISTR
{
	short ChrIndex[SIMAXSTRCHRNUM+1] ;		// Ɏg镶̃CfbNX̔z( null ̑ -1 )
} SISTR ;

// pbN̏
typedef struct tagSISTRPACK
{
	short StrIndex[SIMAXSTRNUM+1] ;			// pbNɎg镶̃CfbNX̔z( null ̑ -1 )
} SISTRPACK ;

// t@C̏
typedef struct tagSTRIMAGEFILEHEAD
{
	char Identifier[SIIDENTIFIER_SIZE] ;	// t@Chc( SIIDENTIFIER )
	int Height ;							// sӂ̍
	int StrPackNum ;						// pbN̐
	int StrNum ;							// ̐
	int ChrNum ;							// ̐
	int Tume ;								// Ԃ̋l߃hbg
} STRIMAGEFILEHEAD ;

// function proto type ---------------------------

// class -----------------------------------------

// C[WNX
class YK7StrImage
{
private :
	bool initflag ;							// tO
	STRIMAGEFILEHEAD *head ;				// wb_
	SISTRPACK *strpack ;					// pbNzւ̃|C^
	SISTR *str ;							// zւ̃|C^
	SICHR *chr ;							// zւ̃|C^
	ghmGcFile *File ;						// t@CNX
	GhmGcTexHeader *THeader ;				// eNX`f[^̃wb_
	GXTexObj TObj ;							// eNX`IuWFNg
	GXColor color ;							// `掞̐F
	float exX, exY ;						// g嗦
	int jikan ;								// ǉ
	int kanaY ;								// JitHg`悷ۂ̕␳xWl
	bool ReverseFlag ;						// ]tO
	YK7StrImage *KanaFont ;					// JitHgz_
	bool MemImageFlag ;						// C[W̓ǂݍ݂AtO

public :
	YK7StrImage() ;							// RXgN^
	virtual ~YK7StrImage() ;				// fXgN^

	bool 					Load( char *FilePath ) ;											// t@C̓ǂݍ
	bool 					LoadMem( void *MemImage ) ;											// ɓWJꂽt@CC[WZbgAbv(n͉̈Ă͂ȂB̓NXs)
	bool 					LoadCheck( void ) ;													// [hI`FbN( true:I   false:܂ )
	bool 					Release( void ) ;													// f[^̉

	void					SetColor( GXColor *Color ) ;										// `ɎgpFZbg
	void					SetColor2( u32 color ) ;											// `ɎgpFZbg
	inline void				SetKanaY( int Y ){ kanaY = Y ; }									// JitHg`悷ۂ̕␳xWlZbg
	inline void				SetJikan( int Jikan ){ jikan = Jikan ; }							// ԂZbg
	inline void 			SetKanaFont( YK7StrImage *kanaFont ){ KanaFont = kanaFont ; }		// ȕptHgZbg
	inline void 			SetExRate( float exrate ){ exY = exX = exrate ; }					// `掞̊g嗦Zbg
	inline void 			SetExRate2( float extX, float extY ){ exY = extY ; exX = extX ; }	// `掞̊g嗦Zbg
	inline GXTexObj 		*GetTexObj( void ){ return &TObj ; }								// eNX`IuWFNg擾
	inline int 				GetHeight( void ){ return head->Height ; }							// tHg̍𓾂
	inline GhmGcTexHeader 	*GetTexHeader( void ){ return THeader ; }							// eNX`̃wb_擾
	int 					GetCodeGraph( int Code, SICHR **chrbuf ) ;							// w̃R[hɑΉOtBbNꍇ͂̏̕Ԃ( Ȃ -1 Ԃ )
	inline SISTRPACK 		*GetStrPack( int index ){ return &strpack[index] ; }				// w̃CfbNX̕pbNԂ
	inline SISTR 			*GetStrInfo( int index ){ return &str[index] ; }					// w̃CfbNX̕Ԃ
	inline SICHR 			*GetChrInfo( int index ){ return &chr[index] ; }					// w̃CfbNX̕Ԃ
	int						GetStrPackLineNum( int index ) ;									// w̃CfbNX̕pbN̍s擾						
	float 					DrawStr( float x, float y, int index, bool center = false, bool drawflag = true ) ;		// w̃CfbNX̕`悷
	float 					DrawStrPack( float x, float y, int index, int wait = 3, bool center = false, bool drawflag = true ) ;	// w̃CfbNX̕pbN`悷
	float 					DrawSStr( float x, float y, char *string, bool center = false, bool drawflag = true, bool setup = true ) ;					// PoCg̕`悷(ɂQoCg܂܂Ă邩ǂ͍lȂ)
	float 					DrawFSStr( float x, float y, bool center, bool drawflag, char *string, ... ) ;							// t`悷
	inline void 			SetReverseFlag( bool Flag ){ ReverseFlag = Flag ; }					// ]tOZbg
	static bool 			MultiByteCharCheck( const char *Buf ) ;								// QoCgׂ( true:QoCg  false:PoCg )

	void 					DrawSetup( void ) ;													// `悷邽߂̏s
	int						GetDrawNum( char *string ) ;										// `悷镶̐擾
	void 					DrawChar( float x, float y, int index, bool setup = true ) ;		// ꕶ`悷( g GXBegin GXEnd g )
} ;


#endif	// __YK7STRING

