#include "common.h"
#include "c_particle.h"
#include "utility.h"

C_Particle* C_Particle::instance = 0;

C_Particle& C_Particle::GetInstance( void ){
  if( !instance ){
	//񂾂Ał悵ƂB
	ghmGcMemSetAllocName("C_Ptcl");
	instance = new C_Particle("/Wat/blood.ptl", "/Wat/blood.txg", "/Wat/blood.ref");
  }
  return *instance;
}

C_Particle::C_Particle( char* p, char* t, char* r ){
//C_Particle::C_Particle( char* p, char* t, char* r ) : 
//  ptl(p), txg(t), ref(r){
  mRender = true;
  /* p[eBN */
  psInitParticle(1024); /* ImۂȂ̂ŁAőp[eBN͂Ołǂ */
  /* WFl[^ */
  psInitGenerator(1024); /* ImۂȂ̂ŁAőWFl[^͂Ołǂ */
  /* AppSRT */
  psInitAppSRT(0, sizeof(PSAppSRT));

#if 0
  //JObjɖߍ񂾃p[eBNgꍇB
  /* p[eBÑR[obNݒ */
  HSD_JObjSetSPtclCallback((HSD_PtclCallback)psCreateGeneratorIDJObjS);
  HSD_JObjSetDPtclCallback((HSD_PtclCallback)psCreateGeneratorIDJObjD);
  HSD_JObjSetPtclTargetCallback((HSD_PtclTargetCallback)psSetPointJObjNodup);
#endif


//  struct Ptcl_header {
//    u16 version;
//    u16 bank;
//    int skip;
//    int nbCmd;
//  } *header;

	initProc = -1;
	pPtlFile = NULL;
	pTxgFile = NULL;
	pRefFile = NULL;
	pPtlData = NULL;
	pTxgData = NULL;
	pRefData = NULL;
	pPtlName = p;
	pTxgName = t;
	pRefName = r;

#if 0
  ghmGcMemSetAllocName("CPtclPtl");
  ptl.Read();
  ghmGcMemSetAllocName("CPtclTxg");
  txg.Read();
  ghmGcMemSetAllocName("CPtclRef");
  ref.Read();
  DCFlushRange(txg.GetAddr(), txg.GetFileSize());
  header = (struct Ptcl_header*)ptl.GetAddr();
  if (header->version != psGetRequiredPtclVersion()) {
    OSReport("unmatch versions between system(%d) and ptcl-file(%d)",
	     psGetRequiredPtclVersion(),
	     header->version);
	ASSERT(0);
  }

  psInitDataBank((int)header->bank, 
				 (int*)ptl.GetAddr(), 
				 (int*)txg.GetAddr(), 
				 (u32*)ref.GetAddr(), NULL);
#endif
}

bool C_Particle::Init(void)
{
	initProc = 0;
	return true;
}

bool C_Particle::InitProc(void)
{
	struct Ptcl_header {
		u16 version;
		u16 bank;
		int skip;
		int nbCmd;
	} *header;
	
	switch( initProc ){
	case	-1:
		break;
	case	0:
		if( pPtlName==NULL ){
			initProc = 16;
			break;
		}
		ghmGcMemSetAllocName("CPtclPtl");
		if( (pPtlFile = new ghmGcFile)==NULL ){
			break;
		}
		initProc++;
	case	1:
		if( pPtlFile->Open(pPtlName)==false ){
			break;
		}
		initProc++;
		break;
	case	2:
		ghmGcMemSetAllocName("CPtclPtl");
		if( (pPtlData=pPtlFile->Read())==NULL ){
			break;
		}
		initProc++;
		break;
	case	3:
		if( pPtlFile->GetState()!=ghmGcFile::READFINISH ){
			break;
		}
		pPtlFile->Close();
		GHM_SAFE_DELETE(pPtlFile);
		initProc = 16;
		break;
	case	16:
		if( pTxgName==NULL ){
			initProc = 32;
			break;
		}
		ghmGcMemSetAllocName("CPtclTxg");
		if( (pTxgFile = new ghmGcFile)==NULL ){
			break;
		}
		initProc++;
	case	17:
		if( pTxgFile->Open(pTxgName)==false ){
			break;
		}
		initProc++;
		break;
	case	18:
		ghmGcMemSetAllocName("CPtclTxg");
		if( (pTxgData=pTxgFile->Read())==NULL ){
			break;
		}
		initProc++;
		break;
	case	19:
		if( pTxgFile->GetState()!=ghmGcFile::READFINISH ){
			break;
		}
		pTxgFile->Close();
		GHM_SAFE_DELETE(pTxgFile);
		initProc = 32;
		break;
	case	32:
		if( pRefName==NULL ){
			initProc = 48;
			break;
		}
		ghmGcMemSetAllocName("CPtclRef");
		if( (pRefFile = new ghmGcFile)==NULL ){
			break;
		}
		initProc++;
	case	33:
		if( pRefFile->Open(pRefName)==false ){
			break;
		}
		initProc++;
		break;
	case	34:
		ghmGcMemSetAllocName("CPtclRef");
		if( (pRefData=pRefFile->Read())==NULL ){
			break;
		}
		initProc++;
		break;
	case	35:
		if( pRefFile->GetState()!=ghmGcFile::READFINISH ){
			break;
		}
		pRefFile->Close();
		GHM_SAFE_DELETE(pRefFile);
		initProc = 48;
		break;
	case	48:
		//DCFlushRange(txg.GetAddr(),txg.GetFileSize());
		header = (struct Ptcl_header*)pPtlData;
		if( header->version != psGetRequiredPtclVersion() ){
			OSReport("unmatch versions between system(%d) and ptcl-file(%d)",
			     psGetRequiredPtclVersion(),
			     header->version);
			ASSERT(0);
		}
		psInitDataBank((int)header->bank, 
		               (int*)pPtlData,
		               (int*)pTxgData,
		               (u32*)pRefData,NULL);
		initProc = -1;
		break;
	default:
		return true;
	}
	return false;
}

void C_Particle::Proc( C_CObj& cobj )
{
  /* Ηp̃Jݒ */
  psSetBillboardCamera(cobj.GetCObj());
  /* p[eBN̉ߎs */
  psInterpretParticles(0);
  /* WFl[^̏ */
  psExecGenerator(0);
}
void C_Particle::Proc( HSD_CObj* cobj )
{
  /* Ηp̃Jݒ */
  psSetBillboardCamera(cobj);
  /* p[eBN̉ߎs */
  psInterpretParticles(0);
  /* WFl[^̏ */
  psExecGenerator(0);
}

void C_Particle::SetRender(bool flag)
{
	mRender = flag;
}

bool C_Particle::GetRender(void)
{
	return mRender;
}

void C_Particle::Disp( void )
{
  if( mRender==false ){
	return;
  }
  /* p[eBN̕\ */
  for (u32 trsp = 0; trsp < 3; trsp++) {
	HSD_StateSetColorUpdate(GX_TRUE);
	psDispParticles(0xffff, trsp);
  }
}

void C_Particle::Reset( void )
{
  /* ݂p[eBN̑S */
  psKillAllGenerator();
  psKillAllParticle();
}      

C_Particle::~C_Particle(){
  /* VXȅI */
  psRemoveParticle();  /* p[eBN */
  psRemoveGenerator(); /* WFl[^ */
  psRemoveAppSRT();    /* AppSRT */
  GHMGCMEM_SAFE_FREE(pPtlData);
  GHMGCMEM_SAFE_FREE(pTxgData);
  GHMGCMEM_SAFE_FREE(pRefData);
  GHM_SAFE_DELETE(pPtlFile);
  GHM_SAFE_DELETE(pTxgFile);
  GHM_SAFE_DELETE(pRefFile);
//  if( ptl.GetAddr()!=NULL ){
//	ghmGcMemFree(ptl.GetAddr());
//  }
//  if( txg.GetAddr()!=NULL ){
//	ghmGcMemFree(txg.GetAddr());
//  }
//  if( ref.GetAddr()!=NULL ){
//	ghmGcMemFree(ref.GetAddr());
//  }
}



C_Generator::C_Generator( C_JObj& jobj_, int id_ ){
	jobj = jobj_.GetJObj();
	Initialize( id_ );
}
C_Generator::C_Generator( HSD_JObj* jobj_, int id_ ){
	jobj = jobj_;
	Initialize( id_ );
}
C_Generator::C_Generator( WK7Chara *_chara, int id_ ){
	jobj = _chara->GetModel()->GetTopObj()->GetJObj();
	Initialize( id_ );
}
C_Generator::C_Generator( Vec &pos, int id_ ){
	jobj = HSD_JObjAlloc();
	if( jobj ){
	  HSD_JObjSetTranslate( jobj, &pos );
	  Initialize( id_ );
	}
}

C_Generator::~C_Generator(){
  if( jobj ){
	HSD_JObjUnref(jobj);
	psKillJObjGenerator(jobj);
  }
  if( gp ) psKillGeneratorChild( gp );
}
void C_Generator::Fire( void ){
	gp = psCreateGeneratorIDJObjD(0, 0, id, jobj);
}
s32 C_Generator::IsAlive( void ){
	if( gp ) return (s32)gp->numChild;
	else	 return (s32)-1;	
}
void C_Generator::SetPos( Vec &_p ){
	HSD_JObjSetTranslate( jobj, (Vec*)&_p );
}
int C_Generator::GetID( void ){ return id; }
void C_Generator::SetRot( Vec &_r ){
	HSD_JObjSetRx( jobj, _r.x );
	HSD_JObjSetRy( jobj, _r.y );
	HSD_JObjSetRz( jobj, _r.z );
}
HSD_JObj *C_Generator::GetJObj( void ){ return jobj; }
void C_Generator::Initialize( int id_ ){
	HSD_JObjRef(jobj);
	id = id_;
	gp = 0;
	pos = 0;
}
