#ifndef ___C_PARTICLE_H___
#define ___C_PARTICLE_H___

//#include "common.h"
#include "c_cobj.h"
//#include "c_dvd.h"
#include "c_jobj.h"
#include <particle.h>
#include "..\Wat\WK7Chara.h"
#include "..\Wat\WK7Model.h"
#include "..\Lib\ghmGcFile.h"
//VOg
#define PARTICLE (C_Particle::GetInstance())
#define USE_PARTICLE (C_Particle::GetInstance())
class C_Particle{
 public:
  static C_Particle& GetInstance( void );
  int GetInitProc(void){ return initProc; }
  bool Init(void);
  bool InitProc(void);
  void Proc( C_CObj& cobj );
  void Proc( HSD_CObj* cobj );
  void Disp( void );
  void Reset( void );
  void SetRender(bool flag);
  bool GetRender(void);
  ~C_Particle();

 private:
//  C_DVD ptl;
//  C_DVD txg;
//  C_DVD ref;
  char				*pPtlName;
  char				*pTxgName;
  char				*pRefName;
  ghmGcFile			*pPtlFile;
  ghmGcFile			*pTxgFile;
  ghmGcFile			*pRefFile;
  void				*pPtlData;
  void				*pTxgData;
  void				*pRefData;
  int				initProc;
  bool				mRender;
  static C_Particle *instance;
  //֎~B
  C_Particle( char* p, char* t, char* r );
  C_Particle( void );
};

class C_Generator{
 public:
  C_Generator( C_JObj& jobj_, int id_ );
  C_Generator( HSD_JObj* jobj_, int id_ );
  C_Generator( WK7Chara *_chara, int id_ );
  C_Generator( Vec &pos, int id_ );
  ~C_Generator();
  void Fire( void );
  s32 IsAlive( void );
  void SetPos( Vec &_p );
  int GetID( void );
  void SetRot( Vec &_r );
  HSD_JObj *GetJObj( void );
//  C_Generator( C_JObj& jobj_, int id_ ){
//	jobj = jobj_.GetJObj();
//	Initialize( id_ );
//  }
//  C_Generator( HSD_JObj* jobj_, int id_ ){
//	jobj = jobj_;
//	Initialize( id_ );
//  }
//  C_Generator( WK7Chara *_chara, int id_ ){
//	jobj = _chara->GetModel()->GetTopObj()->GetJObj();
//	Initialize( id_ );
//  }
//  C_Generator( Vec &pos, int id_ ){
//	jobj = HSD_JObjAlloc();
//	HSD_JObjSetTranslate( jobj, &pos );
//	Initialize( id_ );
//	HSD_JObjUnref(jobj);//łRefĂ邩B
//  }
//
//  ~C_Generator(){
//	HSD_JObjUnref(jobj);
//	psKillJObjGenerator(jobj);
//	if( gp ) psKillGeneratorChild( gp );
//  }
//  void Fire( void ){
//	gp = psCreateGeneratorIDJObjD(0, 0, id, jobj);
//  }
//  s32 IsAlive( void ){
//	if( gp ) return (s32)gp->numChild;
//	else	 return (s32)-1;	
//  }
//  void SetPos( Vec &_p ){
//	HSD_JObjSetTranslate( jobj, (Vec*)&_p );
//  }
//  int GetID( void ){ return id; }
//  void SetRot( Vec &_r ){
//	HSD_JObjSetRx( jobj, _r.x );
//	HSD_JObjSetRy( jobj, _r.y );
//	HSD_JObjSetRz( jobj, _r.z );
//  }
//  HSD_JObj *GetJObj( void ){ return jobj; }
 private:
  HSD_JObj *jobj;
  Generator *gp;
  C_Vec *pos;
  int id;
  void Initialize( int id_ );
//  void Initialize( int id_ ){
//	HSD_JObjRef(jobj);
//	id = id_;
//	gp = 0;
//	pos = 0;
//  }
  PSUserFunc call_backs;
};
#endif

