#ifndef ___C_PERF_H___
#define ___C_PERF_H___

//#include "common.h"
#include <dolphin/perf.h>

//ptH[}X[^[
//Tv̂܂܁B
//ڂeɂẮA
//allman20020620\prog_man\prog\perf\1.htmlQƁB
class C_Perf {
 public:
  C_Perf(void);
  virtual ~C_Perf();
		
  void	Start(void);
  void	End  (void);
  void	StartProc(void); 
  void	EndProc  (void);
  void	StartRender(void);
  void	EndRender  (void); 
		
  void	Dump(void);
  void	Draw(void);
		
 private:
  enum VALS{
	// maximum number of samples to take per measurement frame
	NUM_SAMPLES	= 60,
	//number of measurement frames.There is currently no point in using more than 1
	NUM_FRAMES = 1,
	// total number of measurement events
	NUM_TYPES	 = 3,
	// IDs for each event
	RENDER = 0,
	UPDATE = 1,
	WAIT = 2
  };

  u8*			DL[2];
  u32			DLSize[2];
  s32			DLIdx;
		
  static void	DrawInit(void);
  static void* Alloc( u32 size );
  static void Free( void *ptr );
};
#endif
