#ifndef ___C_SCENE_H___
#define ___C_SCENE_H___

//#include "common.h"
#include <vector.h>
#include "c_scenedesc.h"
#include "c_jobj.h"
#include "c_cobj.h"
#include "c_lobj.h"
#include "c_fog.h"

//C_SceneC_SceneDescɑ΂CX^X̂悤Ȃ́B
//JAfACgAtHO܂Ƃ߂́B
//vO͂ɑ΂Ďs(Proc)A\(Disp)̖߂oB
//葁ARo[gV[\ƂɎgB
class C_Scene {
 public:
  C_Scene(const C_SceneDesc* sd);
  C_Scene();

  virtual ~C_Scene();

  void Proc();
  void Disp();
  C_LObj *GetLObj( u32 idx ){ return lobj[idx]; }
  C_CObj *GetCObj( void ){ return cobj; }
  C_JObj *GetJObj( void ){ return jobj[0]; }
  int StartCam( void ){
	if(cobj) return cobj->DispStart();
	else	 return 0;	
  }
  void DispLight( void );
  void DispModel( void );
  void EndCam( void ){
	cobj->DispEnd();
  }
 protected:
  C_CObj*			cobj;	// J
  vector<C_JObj*>	jobj;	// fz
  vector<C_LObj*>	lobj;	// Cgz
  C_Fog*			fog;	// tHO
};

#endif
