
// nTbh n[}Rs[

#include "EnmHM1.h"
#include "..\Yam\YK7EffectHSDead.h"

K7EnmHM1::K7EnmHM1(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
  K7EnmBoss( enemyid, suffix, pAnchor, prio, K7HM1, 0 )
{
  CopyPCPackMotion( K7HAC );
  // Gʂ̃f[^̃Zbg
  mData.mHp			= 100;								// go
  mData.mWeakID		= NPCWEAKOBJID_RARM;				// _
  mData.mVLossID		= NPCWEAKOBJID_LFOOT;				// ʐѕ
  mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
  mData.mScale		= 1.f;								// 
  WK7RenderObj::SetVfxFlag( false );					// {X͂ɂ傤ɂ؂
  mpEffect = NULL;
  WK7PLAYERCONTROL->SetPostPlayMotionCallBack(PlayerPostPlayMotionCallBack,(u32)this);
}
K7EnmHM1::~K7EnmHM1()
{
  if( mpEffect!=NULL && WK7RenderObj::IsValid(mpNpcChara)==true ){
	mpNpcChara->ReleaseEffect(mpEffect);
	mpEffect = NULL;
  }
  WK7PLAYERCONTROL->SetPostPlayMotionCallBack(NULL,0);
}
bool K7EnmHM1::PlayerPostPlayMotionCallBack(WK7PlayerControlPlayMotionInfo *pInfo)
{
	if( pInfo->mParam==NULL ){
		return true;
	}
	K7EnmHM1	*pEnemy = (K7EnmHM1 *)pInfo->mParam;
	return pEnemy->_PlayerPostPlayMotionCallBack(pInfo);
}
bool K7EnmHM1::_PlayerPostPlayMotionCallBack(WK7PlayerControlPlayMotionInfo *pInfo)
{
	WK7Model	*pModel;
	if( mpNpcChara==NULL || (pModel = mpNpcChara->GetModel())==NULL ){
		return true;
	}
	switch( common_state ){
	case	0:
		return true;
	case	1:
		break;
	default:
		return true;
	}
	WK7Npc::SetMotionIpFrame(pInfo->mIpFrame);
	PlayCommonMotion(pInfo->mCommonID,pInfo->mLoop,pInfo->mHokan,pInfo->mStartFrame,pInfo->mSpeed);
	WK7Npc::SetMotionIpFrame();
	return true;
}
bool K7EnmHM1::ControlProcess(void)
{
  switch( mState ){
  case NPC_STATE_INIT:
  NPC_CTRL_INIT_JUMP:
  StateInit();
  WK7Npc::SetMotionIpFrame(WK7PLAYER_INTERPOLATE_FRAME);
  PlayCommonMotion( 0, true, true );
  WK7Npc::SetMotionIpFrame();
  break;
  case NPC_STATE_WAIT:
  case NPC_STATE_WALK:
  case NPC_STATE_RUN:
  case NPC_STATE_TURN:
  case NPC_STATE_ATK:
  case NPC_STATE_DMG:
  case NPC_STATE_DMG_FALL:
  case NPC_STATE_LOSS:
  case NPC_STATE_DIE:
  default:
	break;
  }
	
	switch( common_state ){
	case 0:  //JnOB
		break;
	case 1: //B
		if( DamageTest() ){
			if( WK7RenderObj::IsValid(mpNpcChara)==true ){
				Vec					pos,dir;
				f32					roty;
//				GXColor				color = { 0x00,0xff,0x00,0xff };
				mpNpcChara->GetPosition(pos);
				mpNpcChara->GetRotY(&roty);
				roty += PI;
				GHM_LIMIT_RANGE(roty,PI,-PI);
				dir.y = 0.0f;
				dir.x = sinf(roty);
				dir.z = cosf(roty);
//				::SetHSDeadEffectColor(color,color);
				WK7RenderObjEffectInfo	info;
				info.Create();
				::SetHSDeadEffectBloodSize( 1.2F ) ;
				mpEffect = mpNpcChara->CreateEffect(CreateHSDeadEffect(mpNpcChara->GetJObj(),
													dir,
													VParam[ED_HSD1][0] / 2.5F,	// Power ԑ
													pos.y,
													(u16)( VParam[ED_HSD1][1] * 0.5F ),			// BloodNum ̐
													(u8)VParam[ED_HSD1][2],		// Wait
													0,							// Mode
													NULL,						// BInfo
													3000,						// BInfoMaxNum
													NULL,						// BInfoNumBuffer		
													false,						// BloodEffectDeleteFlag
													false,						// ConveFlag
													60 * WK7_FRAME_RATE / 30,	// ConveWaitTime
													0.01F,						// ConvePower
													BLOODTEX_NUMBER,//BLOODTEX_BLOOD,
													TRUE,
													FALSE,
													1.0F,
													2
													
				),&info);
				if( mpEffect != NULL ){
					mpEffect->SetForcedDrawFlag(1);
					mpEffect->SetDrawFlag(true);
				}
				mpNpcChara->SetRenderFlag(false);
				
				// 
				gpSound->mPlaySE(SFX_BOSS_HSM_GOLD_DIE);
			}
			common_state = 2;
		}
		break;
	default:
		break;
	}
	
	return false;
}
bool K7EnmHM1::FrameProcess(void)
{
  MotionProcess();
  if( mpNpcChara!=NULL ){
		
	if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
	  // [VXs[hRg[
	  MotionSpeedControl();
			
	  // ŏ̈ʒuZbg̎
	  if( !mFirstPosSet ){

		//̓͓ȂƓȂȂĂB040108
		mpNpcChara->SetVisible(true);
		mHideAlphaNow       = 1.0f;
		mFirstPosSet = 1;
		mpNpcChara->SetPosition(mPosition);
		// ꂪȂƑȂB
		switch( mpNpcChara->GetRenderID() ){
		case	WK7RENDEROBJ_INVALID_RENDERID:
		  //			case	WK7RENDEROBJ_RENDERID_MAX:
		case	WK7RENDEROBJ_RENDERID_DEFAULT:
		  mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
		  mpNpcChara->EnableVfxEffect();
		  break;
		default:
		  break;
		}
	  }

	}
  }
	
  return true;
}





