
// nTuE Rs[

#include "EnmHN3.h"
#include "..\Kaw\KK7Effect.h"

K7EnmHN3::K7EnmHN3(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
  K7EnmBoss( enemyid, suffix, pAnchor, prio, K7HN3, 0 )
{
  CopyPCPackMotion( K7KED );
  // Gʂ̃f[^̃Zbg
  mData.mHp			= 100;								// go
  mData.mWeakID		= NPCWEAKOBJID_RARM;				// _
  mData.mVLossID		= NPCWEAKOBJID_LFOOT;				// ʐѕ
  mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
  mData.mScale		= 1.f;								// 
  WK7RenderObj::SetVfxFlag( false );					// {X͂ɂ傤ɂ؂
  WK7PLAYERCONTROL->SetPostPlayMotionCallBack(PlayerPostPlayMotionCallBack,(u32)this);
}
K7EnmHN3::~K7EnmHN3()
{
  WK7PLAYERCONTROL->SetPostPlayMotionCallBack(NULL,0);
}
bool K7EnmHN3::PlayerPostPlayMotionCallBack(WK7PlayerControlPlayMotionInfo *pInfo)
{
	if( pInfo->mParam==NULL ){
		return true;
	}
	K7EnmHN3	*pEnemy = (K7EnmHN3 *)pInfo->mParam;
	return pEnemy->_PlayerPostPlayMotionCallBack(pInfo);
}
bool K7EnmHN3::_PlayerPostPlayMotionCallBack(WK7PlayerControlPlayMotionInfo *pInfo)
{
	WK7Model	*pModel;
	if( mpNpcChara==NULL || (pModel = mpNpcChara->GetModel())==NULL ){
		return true;
	}
	switch( common_state ){
	case	0:
		break;
	case	1:
		switch( pInfo->mCommonID ){
		case	WK7MOTION_PCCMN_RELOAD:
		case	WK7MOTION_PCCMN_RELOAD_FROMSTAND:
			// [h
			common_state = 2;
			WK7CharaMotion	*pCharaMotion = WK7MotionObj::GetCharaMotion(K7MOTID(K7HN3, 600));
			if( pCharaMotion==NULL ){
				break;
			}
			WK7ModelMotion	*pReloadMotion = pCharaMotion->GetModelMotion();
			if( pReloadMotion==NULL ){
				break;
			}
			pModel->StopMotion();
			pModel->DetachMotion();
			pModel->AttachMotion(pReloadMotion);
			pModel->PlayMotion(pInfo->mStartFrame,true,6.0f);
			pModel->SetMotionLoop(false);
			mDefMotSpeed = pInfo->mSpeed;
			return true;
		}
		break;
	default:
		return true;
	}
	WK7Npc::SetMotionIpFrame(pInfo->mIpFrame);
	PlayCommonMotion(pInfo->mCommonID,pInfo->mLoop,pInfo->mHokan,pInfo->mStartFrame,pInfo->mSpeed);
	WK7Npc::SetMotionIpFrame();
	return true;
}
bool K7EnmHN3::ControlProcess(void)
{
	bool yarareSe = false;

	switch( mState ){
	case NPC_STATE_INIT:
	NPC_CTRL_INIT_JUMP:
	StateInit();
	break;
	case NPC_STATE_WAIT:
	case NPC_STATE_WALK:
	case NPC_STATE_RUN:
	case NPC_STATE_TURN:
	case NPC_STATE_ATK:
	case NPC_STATE_DMG:
	case NPC_STATE_DMG_FALL:
	case NPC_STATE_LOSS:
	case NPC_STATE_DIE:
	default:
	break;
	}
	switch( common_state ){
	case	0:
	case	1:
		if( DamageTest()==true ){
#if 0
//			WK7PLAYERCONTROL->PlayDamageEffect();
#else
			Vec pcRot = {0.f, 0.f, 0.f};
			int dmgVoiceNo;
			
			if ( rand()&1 ){
				// _[WOŉo
				WK7PLAYERCONTROL->SetPcDamage(mDamage.mDamPos, 0, 1, -1, 0);
			}else{
				if ( rand()&1 )	dmgVoiceNo = SFX_BOSS_HSM_LTBROWN_DAMAGE1;
				else			dmgVoiceNo = SFX_BOSS_HSM_LTBROWN_DAMAGE2;
				
				WK7PLAYERCONTROL->GetRotY(&pcRot.y);
				
				// ̃GtFNg
				KK7BattleEffectCharaTypeBloodStart(	mDamage.mDamPos, K7KED );
				
				// Voice
				gpSound->mPlaySE3D( dmgVoiceNo, mDamage.mDamPos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
				yarareSe = true;
			}
#endif
			
			f32		vital = WK7PLAYERCONTROL->GetManualVital();
static		f32		dvital = 0.1f;
			if( vital > 0.1f + dvital ){
				vital -= dvital;
			}else{
				vital = 0.1f;
			}
			WK7PLAYERCONTROL->SetManualVital(vital);
			
			// UVoice
			if ( yarareSe == false ){
				gpSound->mPlaySE(SFX_BOSS_HSM_LTBROWN_ATTACK);			// USE
			}
		}
		break;
	case	2:
		// ߂Ƃ̃ANV
		if( GetCurrentMotionFrame() >= 84 ){
			common_state = 3;
			gpSound->mPlaySE(SFX_PC_KED_SYAGEKI);
			gpSound->mPlaySE(SFX_BOSS_HSM_LTBROWN_ATTACK);			// USE
//			gpSound->mPlaySE(SFX_BOSS_HSM_LTBROWN_KIME);			//  brown
			WK7PLAYERCONTROL->PlayDamageEffect();
			WK7PLAYERCONTROL->SetManualVital(0.0f);
		}
		break;
	case	3:
		if( mpNpcChara->GetMotionState()==WK7MODEL_NOANIM ){
			common_state = 4;
			WK7Npc::SetMotionIpFrame(WK7PLAYER_INTERPOLATE_FRAME);
			PlayCommonMotion(WK7MOTION_PCCMN_SHOTWAIT,false,true,0.0f,1.0f);
			WK7Npc::SetMotionIpFrame();
		}
		break;
	case	4:
		if( mpNpcChara->GetMotionState()==WK7MODEL_NOANIM ){
			common_state = 5;
			WK7Npc::SetMotionIpFrame(WK7PLAYER_INTERPOLATE_FRAME);
			PlayCommonMotion(WK7MOTION_NPCCMN_STAND,true,true,0.0f,1.0f);
			WK7Npc::SetMotionIpFrame();
		}
		break;
	default:
		break;
	}
  return false;
}
bool K7EnmHN3::FrameProcess(void)
{
  MotionProcess();
  if( mpNpcChara!=NULL ){
		
	if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
	  // [VXs[hRg[
	  MotionSpeedControl();
			
	  // ŏ̈ʒuZbg̎
	  if( !mFirstPosSet ){

		//̓͓ȂƓȂȂĂB040108
		mpNpcChara->SetVisible(true);
		mHideAlphaNow       = 1.0f;
		mFirstPosSet = 1;
		mpNpcChara->SetPosition(mPosition);
		// ꂪȂƑȂB
		switch( mpNpcChara->GetRenderID() ){
		case	WK7RENDEROBJ_INVALID_RENDERID:
		  //			case	WK7RENDEROBJ_RENDERID_MAX:
		case	WK7RENDEROBJ_RENDERID_DEFAULT:
		  mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
		  mpNpcChara->EnableVfxEffect();
		  break;
		default:
		  break;
		}
	  }

	}
  }
	
  return true;
}




