////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmK.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMK_H__
#define	__ENMK_H__

#include "..\Wat\WK7Enemy.h"
#include "..\Wat\WK7HitObj.h"


#define E18_CORE_MAX	(7)

class K7EnmK : public WK7Enemy{
protected:
	void PartsRenderIDSet(void);
//	void PartsRenderIDSet_Simple(char *pWeakName);
	void PartsRenderIDSet_Plural(void);
	int coreDead[E18_CORE_MAX];
//	WK7PcShotMode GetShotType(WK7HitObjInfoType hitType);
	bool SuDmgProc(int id, s16 damPoint, WK7JObj *pJObj, WK7HitObjInfoType hitType, Vec hitPos);
	bool DieTest(Vec *pCorePos);
	u8 mEasySu;
public:
	K7EnmK(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
	void HitObjMake(WK7Stage *pCurrentStage, int CoreNum);
	u32 GetHitObjID(void);
	bool CoreHit(int inID, WK7HitObjInfoType hitType, Vec hitPos);
	void VisibleTestDisp(void);
	bool MotStatus_Die(void);
	bool GetNoDamage(void);
};

#endif	//__ENMK_H__

