////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmL.cpp			il^j
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//

/*               K7ENM_L_OYA                  */


////////////////////////////////////////////////////////////////////////////////

#define	__ENML_CPP__

#include "EnmL.h"

#include "..\Wat\K7GlobalFlag.h"
#include "..\Wat\WK7EventScript.h"

#define MDLCODE_ID				(23)			// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(23)			// dmHQwww ́H̔ԍi[Vj


s16 npcTypeLMotionIdTable[] = {
	20,							// R
	50,							// 
	90,							// 
	0,							// ^[E
	0,							// ^[
	140,						// ^[
	0,							// UĂѓiNu쓮j
	410,						// 85cmɍU
	410,						// 150cmɍU
	0,							// _[WO
	0,							// _[W
	170,						// _[WO
	180,						// _[W
	0,							// _[WEO
	0,							// _[WE
	0,							// _[WO
	0,							// _[W
	0,							// _[WEgO
	0,							// _[WEg
	0,							// _[WgO
	0,							// _[Wg
	250,						// _[WӂƂу_EOiSj
	260,						// _[Wу_EiSj
	0,							// _[WE _E
	0,							// _[W _E
	0,							// _ER
	0,							// _E_[W
	0,							// _EȂ
	0,							// _EȂ瑖
	0,							// _E玀S
	0,							// _E85cmɍU
	0,							// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	0,							// ݍUi_j
	0,							// ݍUiRj
	0,							// ݍUiJGfj
	0,							// ݍUiR[ej
	0,							// ݍUi}XNj
	0,							// ݍUiPrj
	0,							// iAiU[X}CpjV䒣tҋ@
	0,							// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA󒆗R
	0,							// iAiU[X}CpjVA󒆗`nA͂
	-1
};

s16 npcTypeLHakiMotionIdTable[] = {
	700,						// f
	0,							// f
	0,							// R
	0,							// 
	-1
};

#define ENML_ATK_DIST (35.f)

K7EnmL::K7EnmL(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){	// C[W[[h͉̎F̃RAɂ
		suffix = 1;
	}
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeLMotionIdTable,		MOTCODE_ID);
	CreatePackMotion(npcTypeLHakiMotionIdTable,	MOTCODE_ID, WK7MOTION_NPCCMN_STD_NUM);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= -1;
	mData.mVLossID		= -1;								// ʌ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;					// 
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mCounterKurai	= 0;								// JE^[
	mData.mTypeEggOya	= 1;
	mData.mAtkDist		= ENML_ATK_DIST;
	mData.mAtkDistBk	= mData.mAtkDist;
}

/*
	
	
	p_[hc̊蓖
	
	
*/
#define EXTRA_PARTS_NAME	"E23_hit"
void K7EnmL::PartsRenderIDSet(void)
{
	u32 renderidex;
	WK7Model *pModel = pCurrentChara()->GetModel();
	
	renderidex = WK7RenderObj::GetUniqueRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
	pCurrentChara()->SetRenderIDEx(renderidex);
	
	// ʂJOBJƂĂ
	if ( pModel != NULL ){
		WK7JObj *pJOBJ;
		pJOBJ   = pModel->GetObj(EXTRA_PARTS_NAME);					// IuWF񂷂̂ǂ
		if ( pJOBJ != NULL ){
			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂OKȏꍇ
//			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂ȏꍇ
		}
	}
}

bool K7EnmL::DamageMotionSelect(s16 frontFlag, u32 *pInSetMotID)
{
	if ( frontFlag )	*pInSetMotID = WK7MOTION_NPCCMN_DMG_BODY_F;
	else				*pInSetMotID = WK7MOTION_NPCCMN_DMG_BODY_B;
	return true;
}






