////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmO.cpp |CYX}C
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMO_CPP__

#include "EnmO.h"

#define MDLCODE_ID				(26)		// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(2)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeOMotionIdTable[] = {
	20,							// R
	50,							// 
	90,							// 
	120,						// ^[E
	130,						// ^[
	140,						// ^[
	60,							// UĂѓiNu쓮j
	420,						// 85cmɍU
	410,						// 150cmɍU
	150,						// _[WO
	160,						// _[W
	170,						// _[WO
	180,						// _[W
	190,						// _[WEO
	290,						// _[WE
	200,						// _[WO
	300,						// _[W
	210,						// _[WEgO
	220,						// _[WEg
	230,						// _[WgO
	240,						// _[Wg
	260,						// _[WӂƂу_EOiSj
	250,						// _[Wу_EiSj
	310,						// _[WE _E
	320,						// _[W _E
	330,						// _ER
	340,						// _E_[W
	350,						// _EȂ
	360,						// _EȂ瑖
	400,						// _E玀S
	440,						// _E85cmɍU
	430,						// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	500,						// ݍUi_j
	650,						// ݍUiRj
	450,						// ݍUiJGfj
	460,						// ݍUiR[ej
	470,						// ݍUi}XNj
	490,						// ݍUiPrj
	0,							// iAiU[X}CpjV䒣tҋ@
	0,							// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA󒆗R
	0,							// iAiU[X}CpjVA󒆗`nA͂
	0,							// _[WE]
	0,							// _[W]
	0,							// p[cAj[Vp
	990,						// ]rpNオO
	980,						// ]rpNオ
	0,							// f
	0,							// f
	-1
};


K7EnmO::K7EnmO(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeOMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= GetRandWeakID();
	mData.mVLossID		= -1;								// ʐѕ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= NPCWEAKOBJID_MAX;					// ăZbg_ł邱Ƃ̎w
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mCounterKurai	= 1;
}
