////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmSPI.cpp		XpC
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMSPI_CPP__

#include "EnmSPI.h"

#define MDLCODE_ID				(29)			// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(29)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeSPIMotionIdTable[] = {
	20,							// R
	50,							// 
	0,							// 
	0,						// ^[E
	0,						// ^[
	0,						// ^[
	0,							// UĂѓiNu쓮j
	0,						// 85cmɍU
	0,						// 150cmɍU
	0,						// _[WO
	0,						// _[W
	0,						// _[WO
	0,						// _[W
	0,						// _[WEO
	0,						// _[WE
	0,						// _[WO
	0,						// _[W
	0,						// _[WEgO
	0,						// _[WEg
	0,						// _[WgO
	0,						// _[Wg
	0,						// _[WӂƂу_EOiSj
	0,						// _[Wу_EiSj
	0,						// _[WE _E
	0,						// _[W _E
	0,						// _ER
	0,						// _E_[W
	0,						// _EȂ
	0,						// _EȂ瑖
	0,						// _E玀S
	0,						// _E85cmɍU
	0,						// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	0,						// ݍUi_j
	0,						// ݍUiRj
	0,						// ݍUiJGfj
	0,						// ݍUiR[ej
	0,						// ݍUi}XNj
	0,						// ݍUiPrj
	0,							// f
	0,							// f
	-1
};

#define EXTRA_PARTS_NAME	"Face"

K7EnmSPI::K7EnmSPI(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeSPIMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= -1;								// ꌂ
	mData.mVLossID		= -1;								// ʐѕ
	mData.mFootSe		= 0;								// P
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mCounterKurai	= 0;
	
	mData.mAtkDist		= 0.f;								// UiUȂ̂
	mData.mAtkDistBk	= mData.mAtkDist;
}

/*
	
	
	p_[hc̊蓖
	
	
*/
void K7EnmSPI::PartsRenderIDSet(void)
{
	u32 renderidex;
	WK7Model *pModel = pCurrentChara()->GetModel();
	
	renderidex = WK7RenderObj::GetUniqueRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
	pCurrentChara()->SetRenderIDEx(renderidex);
	
	// ʂJOBJƂĂ
	if ( pModel != NULL ){
		WK7JObj *pJOBJ;
		pJOBJ   = pModel->GetObj(EXTRA_PARTS_NAME);					// IuWF񂷂̂ǂ
		if ( pJOBJ != NULL ){
			pCurrentChara()->SetRenderIDEx(pJOBJ,false,true);		// ݂ɂȂł̂OKȏꍇ
//			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂ȏꍇ
		}
	}
}

//	mLoopFootSEno = gpSound->mPlaySE( SFX_BT_BHS_FLY, SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackBattleOverlap );

