////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object	[O
//
// EnmV.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMV_CPP__

#include "EnmV.h"
#include "..\Wat\EnmList.h"

#define MDLCODE_ID				(2)			// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(2)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeVMotionIdTable[] = {
	20,							// R
	731,						// 
	731,						// 
	0,							// ^[E
	0,							// ^[
	140,						// ^[
	0,							// UĂѓiNu쓮j
	420,						// 85cmɍU
	410,						// 150cmɍU
	0,							// _[WO
	0,							// _[W
	0,							// _[WO
	0,							// _[W
	0,							// _[WEO
	0,							// _[WE
	0,							// _[WO
	0,							// _[W
	0,							// _[WEgO
	0,							// _[WEg
	0,							// _[WgO
	0,							// _[Wg
	732,						// _[WӂƂу_EOiSj
	732,						// _[Wу_EiSj
	0,							// _[WE _E
	0,							// _[W _E
	0,							// _ER
	0,							// _E_[W
	0,							// _EȂ
	0,							// _EȂ瑖
	732,						// _E玀S
	0,							// _E85cmɍU
	0,							// _E150cmɍU
	0,							// [U[ōU
	733,					// gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	500,						// ݍUi_j
	650,						// ݍUiRj
	450,						// ݍUiJGfj
	460,						// ݍUiR[ej
	470,						// ݍUi}XNj
	490,						// ݍUiPrj
	0,							// f
	0,							// f
	-1
};

#define ROLL_SPEED_MOT			(23.007f)

K7EnmV::K7EnmV(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeVMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= GetRandWeakID();
	mData.mVLossID		= -1;								// ʐѕ
	mData.mFootSe		= SFX_BT_RHS_ROLL;					// 
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= NPCWEAKOBJID_MAX;					// ăZbg_ł邱Ƃ̎w
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mNoWaitMot	= 1;
	
	mData.mCounterKurai	= 1;								// JE^[U炢
}


bool K7EnmV::MotStatus_ExtPop(void)
{
	if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
		// IiƂ肠
		if( false == MotSet_Walk(mOperationDist, true) ) return true;
		mState = NPC_STATE_WALK;
		return false;
	}
	return false;
}


#define R_FOOT_TIMING	10
//#define L_FOOT_TIMING	28
void K7EnmV::FootSeRun(Vec myPos)
{
	if(	(pCurrentChara()!=NULL)
	&&	(mData.mFootSe != 0)
	){
		WK7Model *pModel = pCurrentChara()->GetModel();
		if (R_FOOT_TIMING  == GetCurrentMotionFrame()){
			gpSound->mPlaySE3D( mData.mFootSe, myPos, 0 );		// rdĐ
		}
	}
}
void K7EnmV::FootSeWalk(Vec myPos)
{
	if(	(pCurrentChara()!=NULL)
	&&	(mData.mFootSe != 0)
	){
		WK7Model *pModel = pCurrentChara()->GetModel();
		if (R_FOOT_TIMING  == GetCurrentMotionFrame()){
			gpSound->mPlaySE3D( mData.mFootSe, myPos, 0 );		// rdĐ
		}
	}
}

f32 K7EnmV::GetWalkSpeed(void)
{
	// [VړʂZo
	f32 Speed = ROLL_SPEED_MOT / (GetFTotalMotionFrame() / WK7_FRAME_COUNT);
	return Speed;
}

f32 K7EnmV::GetRunSpeed(void)
{
	// [VړʂZo
	f32 Speed = (ROLL_SPEED_MOT * 2.f) / (GetFTotalMotionFrame() / WK7_FRAME_COUNT);
	return Speed;
}
