/*

 	KK7Prim.h

 Creator       : Kawakami Satoshi (GHM)
 Creation Date : 02/16/2003

*/

#ifndef	__KK7PRIM_H__
#define	__KK7PRIM_H__


#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"
#include "..\Lib\ghmGcFile.h"
#include "..\Lib\ghmGcTask.h"
#include "..\Kaw\KK7Util.h"


#define INIT_PRIORITY				(64)

class KK7PrimController;

// KK7 Prim NX
class KK7Prim{
	friend class KK7PrimController;
protected:
	KK7Prim			*pPrev;			//ÕXvCgւ̃|C^
	KK7Prim			*pNext;			//̃XvCgւ̃|C^
	
	void			SetCamera2D(void);
	void			Set2DTev(void);
public:
	KK7Prim();
	virtual ~KK7Prim();


	KK7Texture		*mpTex;
	
	GXPrimitive		mKind;			//v~eBu̎
	
	s16				w;				//
	s16				h;				//
	s16				x0, y0;
	s16				x1, y1;
	s16				x2, y2;
	s16				x3, y3;
	s16				u0, v0;
	s16				u1, v1;
	s16				u2, v2;
	s16				u3, v3;
	s16				scale;			// XP[
	s16				priority;		// Dx

	u32				rgba;			//RGBA
	u32				flag;			//ėptO


	void			Init(KK7PrimController *pKK7PrimController, KK7Texture* inTex=NULL);
	void			Term(KK7PrimController *pKK7PrimController);
	void			RenderPrim(KK7PrimController *pKK7PrimController);
};

// KK7 Prim Rg[NX
class KK7PrimController{
protected:
	KK7Prim			*pPrimTop;		//gbv
	
public:

	KK7PrimController();
	virtual ~KK7PrimController();
	KK7Prim 		*GetPrimTop(void){ return pPrimTop; };
	void			SetPrimTop(KK7Prim *pKK7Prim){ pPrimTop = pKK7Prim; };

	bool			RenderProcess(void);
};


#ifdef __KK7PRIM_CPP__


#else


#endif


#endif

