////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Kawakami Test Task
//
// KK7TestTask.h
//
// Creator       : Kawakami Satoshi (GHM)
// Creation Date : 11/28/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__KK7TESTTASK_H__
#define	__KK7TESTTASK_H__

#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"
#include "..\Lib\ghmGcFile.h"
#include "..\Lib\ghmGcTask.h"

#include "..\Wat\WK7Archive.h"
#include "..\Wat\WK7Cam.h"
#include "..\Kaw\KK7DebugMenuTask.h"
#include "..\Kaw\KK7BattleMainTask.h"

#include "..\Fujita\C_Lobj.h"

#define TEST_STAGE_CHARA_MAX	(5)

class KK7TestTask : public ghmGcAppTask{
protected:
	
//	WK7ArchiveController		mArchiveController;			// K7A[JCuǗRg[[
	
	WK7Archive					*mpStageArchive;			// _~[Xe[W쐬p
	WK7Model					*mpStageModel;

	WK7Archive					*mpCharaArchive[TEST_STAGE_CHARA_MAX];			// _~[L쐬p
	WK7Model					*mpCharaModel[TEST_STAGE_CHARA_MAX];

	C_LObj						*mpLObj;

	WK7Cam						mCamera;

	// ^XNp
	ghmGcTaskController			mTaskController;
	
	// fobOj[p
//	KK7DebugMenuTask			debugMenu;
	
	// og^XNNp
	KK7BattleMainTask			mBattelMain;


public:
	KK7TestTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~KK7TestTask();
	
	virtual bool InitializeCallBack(void);					// R[obN
	virtual bool FrameProcess(void);						// t[
	virtual bool TerminateCallBack(void);					// IR[obN
	virtual bool RenderProcess(void);						// _O
	
	bool	AllCharaCreate(void);							// eXgLpALN^[̍쐬
	bool	EnemyAI(void);

};

#endif	//__KK7TESTTASK_H__

