/*

 	KK7Util.h

 Creator       : Kawakami Satoshi (GHM)
 Creation Date : 02/16/2003

*/

#ifndef	__KK7UTIL_H__
#define	__KK7UTIL_H__


#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"
#include "..\Lib\ghmGcFile.h"
#include "..\Lib\ghmGcTask.h"
#include "..\Lib\ghmGcTex.h"
#include "..\Matsu\mK7Sound.h"

typedef struct{
	s16				x;
	s16				y;
}S16POSXY;

//eNX`Ǘ\
typedef	struct{
	GhmGcTexHeader	*mpHeadTex;		//t@Cǂݍ񂾃eNX`
	GXTexObj		obj;			//GCAvǗp
}KK7Texture;

class	KK7Util
{
private:
	ghmGcFile	mFile;
	
public:
	KK7Util();
	~KK7Util();

	void		InitTexture(KK7Texture* inTex);
	void		FreeTexture( KK7Texture* inTex );
	bool		FileReadB(char* inFileName, void** inBuff);
};

#define	NOW							(0)
#define	TARGET						(1)


#ifdef __KK7UTIL_CPP__

void KK7PadRumble(int padNo, int frame);
GHMGCTASK_HANDLER(KK7PadRumbleTask);
void KK7ShakeCamera(f32 *pTable=NULL, int cnt=0);
GHMGCTASK_HANDLER(KK7ShakeCam);
bool KK7VecMove(Vec *set, Vec *now, f32 div);

#else

extern void KK7PadRumble(int padNo, int frame);
GHMGCTASK_HANDLER(KK7PadRumbleTask);
extern void KK7ShakeCamera(f32 *pTable=NULL, int cnt=0);
GHMGCTASK_HANDLER(KK7ShakeCam);
extern bool KK7VecMove(Vec *set, Vec *now, f32 div);

#endif


#endif



