////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Jimaku
//
// mK7Jimaku.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 11/22/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7JIMAKU_CPP__

//---- include ----
#include "..\wat\WK7Define.h"
#include "..\wat\WK7MainMenu.h"
#include "..\fujita\c_font.h"
#include "mK7Jimaku.h"
#include "mK7Movie.h"
#include "mK7Noise.h"

//---- define ----
//{ݒ莖
#define	JIMAKU_BUFF_MAX			(512)			//\obt@(̕Aŕ\ł)

//ۂ̐Ff[^:RGBAl
#define	JIMAKU_COLOR			(0xFFFFFF00)	//F
//#define	JIMAKU_COLOR_RED		(0xED1C2400)	//FE
//#define	JIMAKU_COLOR_RED		(0x4A0E20ff)	//FE
#define	JIMAKU_COLOR_RED		(0xFF1C2400)	//FE
#define	JIMAKU_COLOR_SHADOW		(0x00000000)	//FEe
#define	JIMAKU_COLOR_BIG_SHADOW	(0x10101000)	//FE傫e

//Xy[Xݒ
#define	JIMAKU_SPACE_HW			(12)			//pXy[X
#define	JIMAKU_SPACE_ZW			(20)			//SpXy[X

//f[^i[fBNg
#define	SUBTITLE_DIR			""
#define	JIMAKU_RUBI_FILE		"Texture/rubi.bin"

//Wn
//#define	JIMAKU_DISP_Y			(K7APP_SCREEN_HEIGHT-73)	//\YW
//#define	JIMAKU_DISP_Y			(K7APP_SCREEN_HEIGHT-69)	//\YW
#define	JIMAKU_DISP_Y			(K7APP_SCREEN_HEIGHT-80)	//\YW
#define	JIMAKU_RUBI_Y			(JIMAKU_DISP_Y-12)			//r̕\YW

//tF[hCAEg֌W
#define	JIMAKU_MOJI_ALPHA		((u8)0xff)		//̃l
#define	JIMAKU_SHADOW_ALPHA		((u8)0xc0)		//̉ẽl
#define	JIMAKU_MOJI_FADE		(400)			//̃̕tF[hCx
#define	JIMAKU_FADEOUT_TIME 	(400)			//̃tF[hAEgɂ鎞(P:tick)
#define	JIMAKU_BACKFADEOUT_TIME (1200)			//̔wîɂ鎞(P:tick)

//wi֌W
#define	JIMAKU_BACK_FADE_A		(0xcc)			//tF[h̃l
#define	JIMAKU_BACK_FADE_IN		(200)			//tF[hCɂ鎞(P:tick)
#define	JIMAKU_BACK_COLOR		(0xED1C2400)	//F
#define	JIMAKU_BACK_Y			(JIMAKU_DISP_Y-32)

//J[\֌W
#define	JIMAKU_ADV_CUR_W		(32)			//摗J[\̉
#define	JIMAKU_ADV_CUR_H		(32)			//摗J[\̍
#define	JIMAKU_ADV_CUR_WAIT		(10)			//摗J[\̃AjEGCg

//̕\ꕝ
#define	JIMAKU_MOJI_ZURE_X		(4)
#define	JIMAKU_MOJI_ZURE_Y		(6)
#define	JIMAKU_MOJI_MOVE_ZURE_X	(32)
#define	JIMAKU_MOJI_MOVE_ZURE	(16)
#define	JIMAKU_CENTERING_ZURE	(64)
#define	JIMAKU_MOVE_TIME		(800)			//̕()Ŷɂ鎞:tick
#define	JIMAKU_SHADOW_MOVE_RATE	(400)			//̉e1hbgɑ΂ē 200

//wi̒[܂ł̋
#define	JIMAKU_TO_BACK_LENGTH	(16)

//̐LkɕKvȃXvCg̐
#define	JIMAKU_SPRT_SATSU		(11)			//uEvɕKvȐ
#define	JIMAKU_SPRT_SHI			(10)			//uvɕKvȐ

//Lт镶̐Lтm
#define	JIMAKU_ELASTIC_RATE		(32)			//̐l1̊mŕLт܂
#define	JIMAKU_ELASTIC_N_TICK	(300)//(180)		//Lт̂ɂ鎞
#define	JIMAKU_ELASTIC_T_TICK	(200)//(100)		//kނ̂ɂ鎞
#define	JIMAKU_ELASTIC_WAIT		(150)//(100)		//Lт܂ܑҋ@鎞





//---- O[oϐ ----
MK7Jimaku*	gpJimaku = NULL;

//uEv̐Lт镔̍We[u
s16	gTblSatsu[JIMAKU_SPRT_SATSU][3][2] = {
	{ {  9,  9 }, {  4,  4 }, { 11,  6 } },
	{ { 15, 15 }, {  0, 21 }, {  9, 10 } },
	{ { 11, 33 }, {  0, 43 }, {  7, 31 } },
	{ { 40, 17 }, { 44,  8 }, { 48, 17 } },
	{ { 43, 40 }, { 49, 43 }, { 43, 47 } },
	{ {  6, 28 }, {  0, 24 }, {  8, 21 } },
	{ { 17, 39 }, { 12, 49 }, { 10, 40 } },
	{ { 12,  4 }, { 21,  0 }, { 21, 10 } },
	{ { 32, 44 }, { 15, 47 }, { 25, 38 } },
	{ { 34,  3 }, { 41,  2 }, { 41,  8 } },
	{ { 23,  6 }, { 26,  0 }, { 29,  4 } },
};
//uv̐Lт镔̍We[u
s16	gTblShi[JIMAKU_SPRT_SHI][3][2] = {
	{ {  8, 10 }, {  0,  6 }, { 10,  4 } },
	{ { 14, 42 }, {  0, 48 }, {  9, 37 } },
	{ { 38,  5 }, { 42,  1 }, { 46,  5 } },
	{ { 42, 39 }, { 48, 42 }, { 42, 44 } },
	{ { 11, 30 }, {  1, 33 }, {  4, 22 } },
	{ { 33, 17 }, { 45, 13 }, { 40, 27 } },
	{ { 14,  7 }, { 16,  6 }, { 16,  7 } },
	{ { 28,  7 }, { 29,  6 }, { 30,  7 } },
	{ { 13, 17 }, { 11, 16 }, { 14, 16 } },
	{ { 10, 24 }, {  9, 21 }, { 11, 23 } },
};




//---- public ----
//-----------------------------------------------------------------------------
//RXgN^
//-----------------------------------------------------------------------------
MK7Jimaku::MK7Jimaku()
{
	mFrameProc = eJimakuStandby;
}




//-----------------------------------------------------------------------------
//fXgN^
//-----------------------------------------------------------------------------
MK7Jimaku::~MK7Jimaku()
{
}




//-----------------------------------------------------------------------------
//wi_O
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mRenderBack( void )
{
	//Lɐԃg~O߃Jbg
	return;
	
	stJimakuSprite*	sprt = &mBackSprt;
	
	//XvCg̕\tOĂȂΖ߂
	if( sprt->flag )
	{
		//tevݒ
		//J
		mK7Sprite::mSetCamera2D();
		
		//Zobt@r[hݒ
		GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );
		//EFBփ_Oۂ̃J[obt@XV[h
		GXSetColorUpdate( GX_TRUE );
		//EFBփ_Oۂ̃At@obt@XV[h
		GXSetAlphaUpdate( GX_TRUE );
		//EFBƂ̃uh@߂
		GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
		
		//TEVXe[Wŗp\ɂeNX`W̐ݒ
		GXSetNumTexGens( 0 );
		
		//TEVXe[Wւ̏o͂łJ[`l̐ݒ聨̊GXSetTevOrderŗp
		GXSetNumChans( 1 );
		//GX_COLOR0A0̃CgRg[̐ݒ
		GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE );
//		GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT0, GX_DF_NONE, GX_AF_NONE );

		//TEVXe[W̐ݒ
		GXSetNumTevStages( 1 );
		//TEVXe[WŔJ[
		GXSetTevOp( GX_TEVSTAGE0, GX_PASSCLR );
		
		//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
		GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0 );	//J[`lgꍇ͂Ăяo
		
		//̎_ł̒_Lqq̑SẴAgr[gGX_NONEɃZbg
		GXClearVtxDesc();
		//Jg_Lqq̂ꂼ̑̎ނݒ
		GXSetVtxDesc( GX_VA_POS,  GX_DIRECT );	//ʒuW̎ނݒ
		GXSetVtxDesc( GX_VA_CLR0, GX_DIRECT );	//J[0̎ނݒ
		
		//ꂼ̗̑vf(?)Ǝނݒ
		GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ,  GX_S16  , 0 );	//|WV̗vfƎނw
		GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 );	//J[0̗vfƎނw
		
		//\tOĂ΃XvCg`悷
		if( sprt->flag )
		{
			//gCAOXgbvGX_VTXFMT0g4_̕`
			GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, 4 );
				// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
				GXPosition3s16( 0, JIMAKU_BACK_Y, SPRT_PRI_DUMMY );
				GXColor1u32   ( 0 );
				
				GXPosition3s16( K7APP_SCREEN_WIDTH, JIMAKU_BACK_Y, SPRT_PRI_DUMMY );
				GXColor1u32   ( 0 );
				
				GXPosition3s16( 0, K7APP_SCREEN_HEIGHT, SPRT_PRI_DUMMY );
				GXColor1u32   ( sprt->rgba );
				
				GXPosition3s16( K7APP_SCREEN_WIDTH, K7APP_SCREEN_HEIGHT, SPRT_PRI_DUMMY );
				GXColor1u32   ( sprt->rgba );
			GXEnd();
#if	0
			//gCAOXgbvGX_VTXFMT0g4_̕`
			GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, 4 );
				// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
				GXPosition3s16( sprt->x0, sprt->y0, sprt->priority );
				GXColor1u32   ( 0 );
				
				GXPosition3s16( sprt->x1, sprt->y1, sprt->priority );
				GXColor1u32   ( 0 );
				
				GXPosition3s16( sprt->x2, sprt->y2, sprt->priority );
				GXColor1u32   ( sprt->rgba );
				
				GXPosition3s16( sprt->x3, sprt->y3, sprt->priority );
				GXColor1u32   ( sprt->rgba );
			GXEnd();

			//CXgbv
			GXSetLineWidth( (u8)24, GX_TO_ZERO );
			switch( mBackSprtDir )
			{
				case	eBottom:
					GXBegin( GX_LINESTRIP, GX_VTXFMT0, 4 );
						// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
						GXPosition3s16( sprt->x2, sprt->y2, sprt->priority );
						GXColor1u32   ( sprt->rgba | 0xa0a0a000 );	//JIMAKU_WHITE );
						
						GXPosition3s16( sprt->x0, sprt->y0, sprt->priority );
						GXColor1u32   ( sprt->rgba | 0xa0a0a000 );	//JIMAKU_WHITE );
						
						GXPosition3s16( sprt->x1, sprt->y1, sprt->priority );
						GXColor1u32   ( sprt->rgba | 0xa0a0a000 );	//JIMAKU_WHITE );
						
						GXPosition3s16( sprt->x3, sprt->y3, sprt->priority );
						GXColor1u32   ( sprt->rgba | 0xa0a0a000 );	//JIMAKU_WHITE );
					GXEnd();
					break;
				case	eLeft:
					GXBegin( GX_LINESTRIP, GX_VTXFMT0, 4 );
						// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
						GXPosition3s16( sprt->x0, sprt->y0, sprt->priority );
						GXColor1u32   ( sprt->rgba | 0xa0a0a000 );	//JIMAKU_WHITE );
						
						GXPosition3s16( sprt->x1, sprt->y1, sprt->priority );
						GXColor1u32   ( sprt->rgba | 0xa0a0a000 );	//JIMAKU_WHITE );
						
						GXPosition3s16( sprt->x3, sprt->y3, sprt->priority );
						GXColor1u32   ( sprt->rgba | 0xa0a0a000 );	//JIMAKU_WHITE );
						
						GXPosition3s16( sprt->x2, sprt->y2, sprt->priority );
						GXColor1u32   ( sprt->rgba | 0xa0a0a000 );	//JIMAKU_WHITE );
					GXEnd();
					break;
				case	eRight:
					GXBegin( GX_LINESTRIP, GX_VTXFMT0, 4 );
						// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
						GXPosition3s16( sprt->x1, sprt->y1, sprt->priority );
						GXColor1u32   ( sprt->rgba | 0xa0a0a000 );	//JIMAKU_WHITE );
						
						GXPosition3s16( sprt->x0, sprt->y0, sprt->priority );
						GXColor1u32   ( sprt->rgba | 0xa0a0a000 );	//JIMAKU_WHITE );
						
						GXPosition3s16( sprt->x2, sprt->y2, sprt->priority );
						GXColor1u32   ( sprt->rgba | 0xa0a0a000 );	//JIMAKU_WHITE );
						
						GXPosition3s16( sprt->x3, sprt->y3, sprt->priority );
						GXColor1u32   ( sprt->rgba | 0xa0a0a000 );	//JIMAKU_WHITE );
					GXEnd();
					break;
				default:
					break;
			}
#endif
		}
	}
}




//-----------------------------------------------------------------------------
//static̏
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::Init( void )
{
	if( gpJimaku == NULL ){
		ghmGcMemSetAllocName("MJimaku");
		gpJimaku = new MK7Jimaku;
	}
	gpJimaku->mInit();
}
//-----------------------------------------------------------------------------
//static̏I
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::Term( void )
{
	gpJimaku->mTerm();
	GHM_SAFE_DELETE( gpJimaku );
}
//-----------------------------------------------------------------------------
//̏
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mInit( void )
{
	int	i, j;
	
	//
	mFrameProc     = eJimakuSystemRead;		//t[󋵏
	mAdvCurAnmWait = 0;						//摗J[\̃AjEGCg
	mDat           = NULL;					//f[^|C^
	mTex.tex       = NULL;					//eNX`|C^
	strcpy( mFileName, "" );				//ǂݍ݃t@C
	mTotalTick     = 0.0f;					//\ԂĎtick
	mPauseFlag     = true;					//|[YԂɂ
	
	//tHgpXvCg̏ݒ
	for( i =0; i < JIMAKU_SPRT_MAX; i++ )
	{
		mSprt[i].mRelateTex( &mTex );
		mSprt[i].mSetPriority( SPRT_PRI_JMK );
	}
	//̉XvCg
	for( i = 0; i < JIMAKU_SPRT_MAX; i++ )
	{
		for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
		{
			mSprtSS[i][j].mRelateTex( &mTex );
			mSprtSS[i][j].mSetPriority( SPRT_PRI_JMK_SHADOW );
		}
	}
	//̑傫epXvCg
	for( i = 0; i < JIMAKU_SPRT_MAX; i++ )
	{
		mSprtS[i].mRelateTex( &mTex );
		mSprtS[i].mSetPriority( SPRT_PRI_JMK_BIGSHADOW );
		mSprtSMoveFlag[i] = 0;
		mSprtSOrgX[i]     = 0;
		mSprtSOrgY[i]     = 0;
	}
	
	//̔wi
	mBackSprt.priority = SPRT_PRI_DUMMY;
	mBackSprt.w        = K7APP_SCREEN_WIDTH;
	mBackSprt.x0       = 0;
	mBackSprt.y0       = JIMAKU_BACK_Y;
	mBackSprt.x1       = K7APP_SCREEN_WIDTH;
	mBackSprt.y1       = JIMAKU_BACK_Y;
	mBackSprt.x2       = 0;
	mBackSprt.y2       = K7APP_SCREEN_HEIGHT;
	mBackSprt.x3       = K7APP_SCREEN_WIDTH;
	mBackSprt.y3       = K7APP_SCREEN_HEIGHT;
	mBackSprt.rgba     = JIMAKU_BACK_COLOR;
	mBackSprt.flag     = 0;
	
	//witF[hC
	mBackFadeInFlag    = true;
	
	//uEvuv̓ʕXvCg֌W
	mESatsu.mNum         = 0;
	mESatsu.mSprt        = NULL;
	mESatsu.mElastic     = NULL;
	mESatsu.mElasticWait = NULL;
	mEShi.mNum           = 0;
	mEShi.mSprt          = NULL;
	mEShi.mElastic       = NULL;
	mEShi.mElasticWait   = NULL;
	
	//L[͑҂tO
	mKeyWaitFlag = false;
	
	//̕\x
	mSpeed = 1.0f;
}




//-----------------------------------------------------------------------------
//̏I
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mTerm( void )
{
	//
	mDispStop();
	
	//f[^
	GHMGCMEM_SAFE_FREE( mDat );
	
	//VXeeNX`
	GHMGCMEM_SAFE_FREE( mTexRubi.tex );
	
	////eNX`t@C
	//zkJimakuTexFileFree();	//mdatɂ邽mdatƂɈꏏɉ邽ߕsv
}




//-----------------------------------------------------------------------------
//̃f[^ǂݍ
// in --> char* inFileName  ǂݍރt@C
// out -> bool  false       f[^ǂݍ݂NGXgłȂ
//              true        f[^ǂݍ݂NGXgł
//-----------------------------------------------------------------------------
bool
MK7Jimaku::mReadReq( char* inFileName )
{
	//t[ҋ@łȂΖ߂
	if( mFrameProc != eJimakuStandby )
		return( false );
	
	//ǂݍݎwt@CȑOƈႤt@CłΓǂݍ݃NGXg
	if( strcmp(mFileName,inFileName) )
	{
		//t@Cۑ
		strcpy( mFileName, inFileName );
		//t@Cǂݍ݃NGXgtO𗧂Ă
		mFrameProc = eJimakuDataReadReq;
	}else
	{
		//ɓǂݍ݂IĂt@ĈŃt[ҋ@ɂ
		mFrameProc = eJimakuStandby;
	}
	
	return( true );
}




//-----------------------------------------------------------------------------
//ݓǂݍł鎚f[^͐̕𓾂
// in --> none
// out -> s16  ݓǂݍł鎚f[^͐̕
//-----------------------------------------------------------------------------
s16
MK7Jimaku::mGetSentenceNumMax( void )
{
	if( mDat != NULL )
		return( mDat->num );
	else
		return( 0 );
}




//---- private ----
//-----------------------------------------------------------------------------
//\I`FbN
// in --> none
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Jimaku::mDispEndCheck( void )
{
	int	i, j;
	
	//XvCg\tONA
	for( i =0; i < JIMAKU_SPRT_MAX; i++ )
	{
		mSprt[i].mSetDispFlag( false );
		mSprt[i].mSetRGBA( 0 );
	}
	//̉eXvCg\ɂ
	for( i =0; i < JIMAKU_SPRT_MAX; i++ )
	{
		mSprtS[i].mSetDispFlag( false );
		mSprtS[i].mSetRGBA( 0 );
	}
	//̉eXvCg\ɂ
	for( i =0; i < JIMAKU_SPRT_MAX; i++ )
	{
		for( j =0; j < JIMAKU_SHADOW_MAX; j++ )
		{
			mSprtSS[i][j].mSetDispFlag( false );
			mSprtSS[i][j].mSetRGBA( 0 );
		}
	}
	
	//I`FbN
	if( ((mLineIndex + 1) == JIMAKU_LINE_MAX)
	 || (mSentenceDat[mSentenceIndex].jimaku[mLineIndex+1].chardat[0] == (s16)JIMAKU_NO_FONT) )
	{
		if( (mSentenceIndex + 1) < mDat->num )
		{
			//\indexZ
			mSentenceIndex++;
			//\sNA
			mLineIndex = 0;
			//̔wi\
			if( mBackEndFlag == 0 )
			{
				mBackSprt.flag = 0;
				//witF[hC
				mBackFadeInFlag = true;
			}else
			{
				//wi̓tF[hCȂĂ悵
				mBackFadeInFlag = false;
			}
		}else
		{
			//̔wi\
			if( mBackEndFlag == 0 )
			{
			//	mBackSprt.w    = 0;
			//	mBackSprt.x0   = K7APP_SCREEN_WIDTH / 2;
			//	mBackSprt.y0   = K7APP_SCREEN_HEIGHT;
			//	mBackSprt.x1   = K7APP_SCREEN_WIDTH / 2;
			//	mBackSprt.y1   = K7APP_SCREEN_HEIGHT;
			//	mBackSprt.x2   = K7APP_SCREEN_WIDTH / 2;
			//	mBackSprt.y2   = K7APP_SCREEN_HEIGHT;
			//	mBackSprt.x3   = K7APP_SCREEN_WIDTH / 2;
			//	mBackSprt.y3   = K7APP_SCREEN_HEIGHT;
				mBackSprt.flag = 0;
				//witF[hC
				mBackFadeInFlag = true;
			}
			//f[^I
			return( true );
		}
	}else
	{
		//\sZ
		mLineIndex++;
		//wi̓tF[hCȂĂ悵
		mBackFadeInFlag = false;
	}
	
	//f[^͑܂
	return( false );
}




//-----------------------------------------------------------------------------
//̕Z^O
// in --> int inWidth  \̕
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mCentering( int inWidth )
{
	s32	i, j, k, fromNum, toNum, charID, rubiNum;
	s16 zureX, zureY, mojiW;
	s32	moveTime;
	f32	orgX, orgY;
	
	//ړԎ擾
	moveTime = mSentenceDat[mSentenceIndex].jimaku[mLineIndex].disptime + JIMAKU_FADEOUT_TIME;
	
	//̃Z^O
	for( i = 0; i < mLastDispSprtNum; i++ )
	{
		//ϐ
		zureX = 0;
		zureY = 0;
		//\tOZbg
		mSprt[i].mSetDispFlag( true );
		//
		mSprt[i].mSetX0( (s16)(mSprt[i].mGetX0() + (s16)((K7APP_SCREEN_WIDTH - inWidth) / 2)) );
		
		
		
		
		
#if	0
		//Yĕ\
		mSprt[i].mSetX0( (s16)(mSprt[i].mGetX0() + HSD_Randi(JIMAKU_MOJI_ZURE_X) - (JIMAKU_MOJI_ZURE_X/2)) );
		mSprt[i].mSetY0( (s16)(mSprt[i].mGetY0() + HSD_Randi(JIMAKU_MOJI_ZURE_Y) - (JIMAKU_MOJI_ZURE_Y/2)) );
#endif
#if	0
		//KW`YW ̕\
		zureX = (s16)(mSprt[i].mGetX0() + HSD_Randi(JIMAKU_MOJI_ZURE_X) - (JIMAKU_MOJI_ZURE_X/2));
		zureY = (s16)(mSprt[i].mGetY0() + HSD_Randi(JIMAKU_MOJI_ZURE_Y) - (JIMAKU_MOJI_ZURE_Y/2));
		//ړ
		mSprt[i].mSetMove( zureX, zureY, JIMAKU_MOVE_TIME );
#endif
#if	1
		//YW`KW`YW ̕\
		orgX = mSprt[i].mGetX0();
		orgY = mSprt[i].mGetY0();
		zureX = (s16)(HSD_Randi(JIMAKU_MOJI_ZURE_X) - (JIMAKU_MOJI_ZURE_X/2));
		zureY = (s16)(HSD_Randi(JIMAKU_MOJI_ZURE_Y) - (JIMAKU_MOJI_ZURE_Y/2));
		//炵ĕ\
		mSprt[i].mSetX0( (s16)(mSprt[i].mGetX0() + zureX) );
		mSprt[i].mSetY0( (s16)(mSprt[i].mGetY0() + zureY) );
		//ړ
		mSprt[i].mSetMove( (s16)(orgX - zureX), (s16)(orgY - zureY), moveTime );
#endif
		
		
		
		
		//ep̏ݒ肷
		if( mSprt[i].mGetDispFlag() )
		{
			//̉ݒ
			for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
			{
				mSprtSS[i][j].mSetDispFlag( true );
				mSprtSS[i][j].mSetRGBA( JIMAKU_COLOR_SHADOW );
				mSprtSS[i][j].mSetU0( mSprt[i].mGetU0() );
				mSprtSS[i][j].mSetV0( mSprt[i].mGetV0() );
				mSprtSS[i][j].mSetWH( mSprt[i].mGetW(), mSprt[i].mGetH() );
#if	0
				//KW`YW ̕\
				switch( j )
				{
					case	0:
						mSprtSS[i][j].mSetXY0( (s16)(mSprt[i].mGetX0() - 1), mSprt[i].mGetY0() );
						mSprtSS[i][j].mSetMove( (s16)(zureX - 1), zureY, JIMAKU_MOVE_TIME );
						break;
					case	1:
						mSprtSS[i][j].mSetXY0( (s16)(mSprt[i].mGetX0() + 1), mSprt[i].mGetY0() );
						mSprtSS[i][j].mSetMove( (s16)(zureX + 1), zureY, JIMAKU_MOVE_TIME );
						break;
					case	2:
						mSprtSS[i][j].mSetXY0( mSprt[i].mGetX0(), (s16)(mSprt[i].mGetY0() - 1) );
						mSprtSS[i][j].mSetMove( zureX, (s16)(zureY - 1), JIMAKU_MOVE_TIME );
						break;
					case	3:
						mSprtSS[i][j].mSetXY0( mSprt[i].mGetX0(), (s16)(mSprt[i].mGetY0() + 1) );
						mSprtSS[i][j].mSetMove( zureX, (s16)(zureY + 1), JIMAKU_MOVE_TIME );
						break;
				}
#endif
#if	1
				//YW`KW`YW ̕\
				switch( j )
				{
					case	0:
						mSprtSS[i][j].mSetXY0( (s16)(mSprt[i].mGetX0() - 1), mSprt[i].mGetY0() );
						mSprtSS[i][j].mSetMove( (s16)(orgX - zureX - 1), (s16)(orgY - zureY), moveTime );
						break;
					case	1:
						mSprtSS[i][j].mSetXY0( (s16)(mSprt[i].mGetX0() + 1), mSprt[i].mGetY0() );
						mSprtSS[i][j].mSetMove( (s16)(orgX - zureX + 1), (s16)(orgY - zureY), moveTime );
						break;
					case	2:
						mSprtSS[i][j].mSetXY0( mSprt[i].mGetX0(), (s16)(mSprt[i].mGetY0() - 1) );
						mSprtSS[i][j].mSetMove( (s16)(orgX - zureX), (s16)(orgY - zureY - 1), moveTime );
						break;
					case	3:
						mSprtSS[i][j].mSetXY0( mSprt[i].mGetX0(), (s16)(mSprt[i].mGetY0() + 1) );
						mSprtSS[i][j].mSetMove( (s16)(orgX - zureX), (s16)(orgY - zureY + 1), moveTime );
						break;
				}
#endif
			}
			
			
			
			
			
			
			
			//傫ȉeݒ
			mSprtS[i].mSetDispFlag( true );
			mSprtS[i].mSetRGBA( JIMAKU_COLOR_BIG_SHADOW );
			mSprtS[i].mSetU0( mSprt[i].mGetU0() );
			mSprtS[i].mSetV0( mSprt[i].mGetV0() );
			mSprtS[i].mSetWH( mSprt[i].mGetW(), mSprt[i].mGetH() );
			
			//̂P
		//	mSprtS[i].mSetXY0( orgX, orgY );
			
			//̂Q
		//	mSprtS[i].mSetScale( eScaleWH, 1.1f, 1 );
		//	mSprtS[i].mScaleProc();	//XP[𒼂ɔf邽߂ɂŌĂяo
		//	mSprtS[i].mSetXY0( (s16)(mSprt[i].mGetX0() - 1), (s16)(mSprt[i].mGetY0() - 1) );
			
			//̂R
			mSprtS[i].mSetScale( eScaleWH, 1.5f, 1 );
			mSprtS[i].mScaleProc();	//XP[𒼂ɔf邽߂ɂŌĂяo
//			mSprtS[i].mSetXY0( (s16)(mSprt[i].mGetX0() - (mSprtS[i].mGetW() / 2)), (s16)(mSprt[i].mGetY0() - (mSprtS[i].mGetH() / 2)) );
			mSprtS[i].mSetXY0( (s16)(mSprt[i].mGetX0() - (mSprtS[i].mGetW() / 4)), (s16)(mSprt[i].mGetY0() + 4) );
			//Wۑ
			mSprtSOrgX[i] = mSprtS[i].mGetX0();
			mSprtSOrgY[i] = mSprtS[i].mGetY0();
			zureX = (s16)(HSD_Randi(JIMAKU_MOJI_MOVE_ZURE_X) - (JIMAKU_MOJI_MOVE_ZURE_X/2));
			zureY = (s16)(HSD_Randi(JIMAKU_MOJI_MOVE_ZURE) - (JIMAKU_MOJI_MOVE_ZURE/2));
			//炵ĕ\
			mSprtS[i].mSetX0( (s16)(mSprtS[i].mGetX0() + zureX) );
			mSprtS[i].mSetY0( (s16)(mSprtS[i].mGetY0() + zureY) );
			//ړ
			mSprtS[i].mSetMove( (s16)(mSprtSOrgX[i] - zureX),
								(s16)(mSprtSOrgY[i] - zureY),
								(mK7GetAbsS16((s16)(zureX*2)) + mK7GetAbsS16((s16)(zureY*2))) * JIMAKU_SHADOW_MOVE_RATE );
			//mSprtS[i].mSetMove( (s16)(mSprtSOrgX[i] - zureX), (s16)(mSprtSOrgY[i] - zureY), moveTime );
		}
	}
	
	//rXvCgݒ
	for( i = 0; i < JIMAKU_RUBI_DAT_MAX; i++ )
	{
		mojiW   = 0;
		rubiNum = 0;
		fromNum = mSentenceDat[mSentenceIndex].jimaku[mLineIndex].rubidat[i].fromNum;
		toNum   = mSentenceDat[mSentenceIndex].jimaku[mLineIndex].rubidat[i].toNum;
		//rӂ銿̕𐔂
		for( k = fromNum; k < (fromNum + toNum); k++ )
		{
			mojiW += mSprt[k].mGetW();
		}
		//rUV
		for( j = 0; j < JIMAKU_RUBI_MAX; j++ )
		{
			charID = mSentenceDat[mSentenceIndex].jimaku[mLineIndex].rubidat[i].charID[j];
			if( charID != -1 )
			{
				rubiNum++;	//r̕𐔂
			//	if( mSprt[fromNum].mGetRGBA() == JIMAKU_COLOR_RED )
			//		mSprtRubi[i][j].mSetRGBA( JIMAKU_COLOR_RED );
			//	else
			//		mSprtRubi[i][j].mSetRGBA( JIMAKU_COLOR );
				mSprtRubi[i][j].mSetRGBA( JIMAKU_COLOR );
				mSprtRubi[i][j].mSetDispFlag( true );
				mSprtRubi[i][j].mSetUV0( (s16)((charID % JIMAKU_RUBI_W_NUM) * JIMAKU_RUBI_W), (s16)((charID / JIMAKU_RUBI_W_NUM) * JIMAKU_RUBI_H) );
			}
		}
		//rXY
		for( j = 0; j < JIMAKU_RUBI_MAX; j++ )
		{
			charID = mSentenceDat[mSentenceIndex].jimaku[mLineIndex].rubidat[i].charID[j];
			if( charID != -1 )
			{
				mSprtRubi[i][j].mSetXY0( (s16)(mSprt[fromNum].mGetX0() + ((mojiW - (JIMAKU_RUBI_W * rubiNum)) / 2) + (JIMAKU_RUBI_W * j)), JIMAKU_RUBI_Y );
			}
		}
	}
}
//-----------------------------------------------------------------------------
//ëړ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mJmkShadowMoveProc( void )
{
	int	i;
	s16 zureX, zureY;
	s32	moveTime;
	
	for( i = 0; i < JIMAKU_SPRT_MAX; i++ )
	{
		if( (mSprtS[i].mGetDispFlag() == true) && (mSprtS[i].mGetMoveEnd() == true) )
		{
			zureX = (s16)(HSD_Randi(JIMAKU_MOJI_MOVE_ZURE_X) - (JIMAKU_MOJI_MOVE_ZURE_X/2));
			zureY = (s16)(HSD_Randi(JIMAKU_MOJI_MOVE_ZURE) - (JIMAKU_MOJI_MOVE_ZURE/2));
			switch( mSprtSMoveFlag[i] )
			{
				case	0:
					moveTime = (mK7GetAbsS16((s16)(mSprtSOrgX[i]-mSprtS[i].mGetX0()))
							  + mK7GetAbsS16((s16)(mSprtSOrgY[i]-mSprtS[i].mGetY0()))
							  + mK7GetAbsS16(zureX)
							  + mK7GetAbsS16(zureY) ) * JIMAKU_SHADOW_MOVE_RATE;
					mSprtS[i].mSetMove( (s16)(mSprtSOrgX[i] - zureX), (s16)(mSprtSOrgY[i] - zureY), moveTime );
					break;
				
				case	1:
					moveTime = (mK7GetAbsS16(zureX) + mK7GetAbsS16(zureY)) * JIMAKU_SHADOW_MOVE_RATE;
					mSprtS[i].mSetMove( (s16)(mSprtS[i].mGetX0() + zureX), (s16)(mSprtS[i].mGetY0() + zureY), moveTime );
					break;
				
				default:
					break;
			}
			//̃tO𔽓]
			mSprtSMoveFlag[i] ^= 1;
		}
	}
}




//-----------------------------------------------------------------------------
//̃tF[hCI`FbN
// in --> none
// out -> true   tF[hCI
//        false  tF[hC
//-----------------------------------------------------------------------------
bool
MK7Jimaku::mCheckFadeInEnd( void )
{
	//\Ă镶Ȃ΃tF[hC͏IƂɂ
	if( mLastDispSprtNum == 0 )
		return( true );
	//tF[hCI`FbN
	if( (mSprt[mLastDispSprtNum-1].mGetFadeEnd() == true)
	 && (mBackSprt.fade.nowTick == 0) )
		return( true );
	else
		return( false );
}
//-----------------------------------------------------------------------------
//̃tF[hCݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mSetFadeIn( void )
{
	int	i, j;
	s32	fadeTime;
	
	//tF[hݒ
	for( i = 0; i < JIMAKU_SPRT_MAX; i++ )
	{
		if( mSprt[i].mGetDispFlag() )
		{
			//͕{
			mSprt[i].mSetFade( JIMAKU_MOJI_ALPHA, JIMAKU_MOJI_FADE );
			//͉e
			if( mSprtS[i].mGetDispFlag() )
			{
				mSprtS[i].mSetFade( JIMAKU_SHADOW_ALPHA, JIMAKU_MOJI_FADE );
			}
			for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
			{
				if( mSprtSS[i][j].mGetDispFlag() )
				{
					mSprtSS[i][j].mSetFade( JIMAKU_SHADOW_ALPHA, JIMAKU_MOJI_FADE );
				}
			}
		}
	}
	
	//uEv̐Lт镔̃tF[hݒ
	for( i = 0; i < mESatsu.mNum; i++ )
	{
		for( j = 0; j < JIMAKU_SPRT_SATSU; j++ )
		{
			mESatsu.mSprt[i*JIMAKU_SPRT_SATSU+j].mSetFade( JIMAKU_MOJI_ALPHA, JIMAKU_MOJI_FADE );
		}
	}
	//uv̐Lт镔̃tF[hݒ
	for( i = 0; i < mEShi.mNum; i++ )
	{
		for( j = 0; j < JIMAKU_SPRT_SHI; j++ )
		{
			mEShi.mSprt[i*JIMAKU_SPRT_SHI+j].mSetFade( JIMAKU_MOJI_ALPHA, JIMAKU_MOJI_FADE );
		}
	}
	
	//wi̕\ݒ
	mBackSprt.flag = true;
	
	//witF[hCf[^
	if( mBackFadeInFlag == true )
	{
		fadeTime               = 1;
		mBackSprt.fade.orgA    = 0;						//ŏ̃l
		mBackSprt.fade.toA     = JIMAKU_BACK_FADE_A;	//ڕWƂȂ郿l
		mBackSprt.fade.nowA    = 0;						//݂̃l
		mBackSprt.fade.tick    = fadeTime;				//tF[hɂ鎞
		mBackSprt.fade.nowTick = fadeTime;				//tF[hɂĂ鎞
		mBackSprt.rgba         = JIMAKU_BACK_COLOR;
	}else
	{
		fadeTime               = JIMAKU_BACK_FADE_IN;
	}
	
	//rXvCgݒ
	for( i = 0; i < JIMAKU_RUBI_DAT_MAX; i++ )
	{
		for( j = 0; j < JIMAKU_RUBI_MAX; j++ )
		{
			if( mSprtRubi[i][j].mGetDispFlag() == true )
			{
				mSprtRubi[i][j].mSetFade( JIMAKU_MOJI_ALPHA, JIMAKU_MOJI_FADE );
			}
		}
	}
	
#if	0
	//
	if( mBackSprtDir == eBottom )
	{
		mBackSprt.move[2].orgX    = mBackSprt.x2;			//ړOXW
		mBackSprt.move[2].orgY    = mBackSprt.y2;			//ړOYW
		mBackSprt.move[2].toX     = (s16)(mSprt[0].mGetX0() - JIMAKU_TO_BACK_LENGTH);	//ړXW
		mBackSprt.move[2].toY     = K7APP_SCREEN_HEIGHT;	//ړYW
		mBackSprt.move[2].nowX    = (f32)mBackSprt.x2;		//݂XW
		mBackSprt.move[2].nowY    = (f32)mBackSprt.y2;		//݂YW
		mBackSprt.move[2].tick    = fadeTime;				//ړɂ鎞
		mBackSprt.move[2].nowTick = fadeTime;				//ړɂĂ鎞
		
		mBackSprt.move[0].orgX    = mBackSprt.x0;			//ړOXW
		mBackSprt.move[0].orgY    = mBackSprt.y0;			//ړOYW
		mBackSprt.move[0].toX     = mBackSprt.move[2].toX;	//ړXW
		mBackSprt.move[0].toY     = (s16)(JIMAKU_DISP_Y - JIMAKU_TO_BACK_LENGTH);	//ړYW
		mBackSprt.move[0].nowX    = (f32)mBackSprt.x0;		//݂XW
		mBackSprt.move[0].nowY    = (f32)mBackSprt.y0;		//݂YW
		mBackSprt.move[0].tick    = fadeTime;				//ړɂ鎞
		mBackSprt.move[0].nowTick = fadeTime;				//ړɂĂ鎞
		
		mBackSprt.move[3].orgX    = mBackSprt.x3;			//ړOXW
		mBackSprt.move[3].orgY    = mBackSprt.y3;			//ړOYW
		mBackSprt.move[3].toX     = (s16)(mSprt[0].mGetX0() + mBackSprt.w + JIMAKU_TO_BACK_LENGTH);	//ړXW
		mBackSprt.move[3].toY     = K7APP_SCREEN_HEIGHT;	//ړYW
		mBackSprt.move[3].nowX    = (f32)mBackSprt.x3;		//݂XW
		mBackSprt.move[3].nowY    = (f32)mBackSprt.y3;		//݂YW
		mBackSprt.move[3].tick    = fadeTime;	//gkɂ鎞
		mBackSprt.move[3].nowTick = fadeTime;	//gkɂĂ鎞
		
		mBackSprt.move[1].orgX    = mBackSprt.x1;			//ړOXW
		mBackSprt.move[1].orgY    = mBackSprt.y1;			//ړOYW
		mBackSprt.move[1].toX     = mBackSprt.move[3].toX;	//ړXW
		mBackSprt.move[1].toY     = mBackSprt.move[0].toY;	//ړYW
		mBackSprt.move[1].nowX    = (f32)mBackSprt.x1;		//݂XW
		mBackSprt.move[1].nowY    = (f32)mBackSprt.y1;		//݂YW
		mBackSprt.move[1].tick    = fadeTime;				//ړɂ鎞
		mBackSprt.move[1].nowTick = fadeTime;				//ړɂĂ鎞
	}else
	//
	if( mBackSprtDir == eLeft )
	{
		mBackSprt.move[0].orgX    = mBackSprt.x0;			//ړOXW
		mBackSprt.move[0].orgY    = mBackSprt.y0;			//ړOYW
		mBackSprt.move[0].toX     = 0;						//ړXW
		mBackSprt.move[0].toY     = (s16)(JIMAKU_DISP_Y - JIMAKU_TO_BACK_LENGTH);	//ړYW
		mBackSprt.move[0].nowX    = (f32)mBackSprt.x0;		//݂XW
		mBackSprt.move[0].nowY    = (f32)mBackSprt.y0;		//݂YW
		mBackSprt.move[0].tick    = fadeTime;				//ړɂ鎞
		mBackSprt.move[0].nowTick = fadeTime;				//ړɂĂ鎞
		
		mBackSprt.move[1].orgX    = mBackSprt.x1;			//ړOXW
		mBackSprt.move[1].orgY    = mBackSprt.y1;			//ړOYW
		mBackSprt.move[1].toX     = (s16)(mSprt[0].mGetX0() + mBackSprt.w + JIMAKU_TO_BACK_LENGTH);	//ړXW
		mBackSprt.move[1].toY     = mBackSprt.move[0].toY;	//ړYW
		mBackSprt.move[1].nowX    = (f32)mBackSprt.x1;		//݂XW
		mBackSprt.move[1].nowY    = (f32)mBackSprt.y1;		//݂YW
		mBackSprt.move[1].tick    = fadeTime;				//ړɂ鎞
		mBackSprt.move[1].nowTick = fadeTime;				//ړɂĂ鎞
		
		mBackSprt.move[2].orgX    = mBackSprt.x2;			//ړOXW
		mBackSprt.move[2].orgY    = mBackSprt.y2;			//ړOYW
		mBackSprt.move[2].toX     = 0;						//ړXW
		mBackSprt.move[2].toY     = K7APP_SCREEN_HEIGHT;	//ړYW
		mBackSprt.move[2].nowX    = (f32)mBackSprt.x2;		//݂XW
		mBackSprt.move[2].nowY    = (f32)mBackSprt.y2;		//݂YW
		mBackSprt.move[2].tick    = fadeTime;				//ړɂ鎞
		mBackSprt.move[2].nowTick = fadeTime;				//ړɂĂ鎞
		
		mBackSprt.move[3].orgX    = mBackSprt.x3;			//ړOXW
		mBackSprt.move[3].orgY    = mBackSprt.y3;			//ړOYW
		mBackSprt.move[3].toX     = mBackSprt.move[1].toX;	//ړXW
		mBackSprt.move[3].toY     = K7APP_SCREEN_HEIGHT;	//ړYW
		mBackSprt.move[3].nowX    = (f32)mBackSprt.x3;		//݂XW
		mBackSprt.move[3].nowY    = (f32)mBackSprt.y3;		//݂YW
		mBackSprt.move[3].tick    = fadeTime;				//ړɂ鎞
		mBackSprt.move[3].nowTick = fadeTime;				//ړɂĂ鎞
	}else
	//E
	{
		mBackSprt.move[1].orgX    = mBackSprt.x1;			//ړOXW
		mBackSprt.move[1].orgY    = mBackSprt.y1;			//ړOYW
		mBackSprt.move[1].toX     = K7APP_SCREEN_WIDTH;		//ړXW
		mBackSprt.move[1].toY     = (s16)(JIMAKU_DISP_Y - JIMAKU_TO_BACK_LENGTH);	//ړYW
		mBackSprt.move[1].nowX    = (f32)mBackSprt.x1;		//݂XW
		mBackSprt.move[1].nowY    = (f32)mBackSprt.y1;		//݂YW
		mBackSprt.move[1].tick    = fadeTime;				//ړɂ鎞
		mBackSprt.move[1].nowTick = fadeTime;				//ړɂĂ鎞
		
		mBackSprt.move[0].orgX    = mBackSprt.x0;			//ړOXW
		mBackSprt.move[0].orgY    = mBackSprt.y0;			//ړOYW
		mBackSprt.move[0].toX     = (s16)(mSprt[0].mGetX0() - JIMAKU_TO_BACK_LENGTH);	//ړXW
		mBackSprt.move[0].toY     = mBackSprt.move[1].toY;	//ړYW
		mBackSprt.move[0].nowX    = (f32)mBackSprt.x0;		//݂XW
		mBackSprt.move[0].nowY    = (f32)mBackSprt.y0;		//݂YW
		mBackSprt.move[0].tick    = fadeTime;				//ړɂ鎞
		mBackSprt.move[0].nowTick = fadeTime;				//ړɂĂ鎞
		
		mBackSprt.move[3].orgX    = mBackSprt.x3;			//ړOXW
		mBackSprt.move[3].orgY    = mBackSprt.y3;			//ړOYW
		mBackSprt.move[3].toX     = K7APP_SCREEN_WIDTH;		//ړXW
		mBackSprt.move[3].toY     = K7APP_SCREEN_HEIGHT;	//ړYW
		mBackSprt.move[3].nowX    = (f32)mBackSprt.x3;		//݂XW
		mBackSprt.move[3].nowY    = (f32)mBackSprt.y3;		//݂YW
		mBackSprt.move[3].tick    = fadeTime;				//ړɂ鎞
		mBackSprt.move[3].nowTick = fadeTime;				//ړɂĂ鎞
		
		mBackSprt.move[2].orgX    = mBackSprt.x2;			//ړOXW
		mBackSprt.move[2].orgY    = mBackSprt.y2;			//ړOYW
		mBackSprt.move[2].toX     = mBackSprt.move[0].toX;	//ړXW
		mBackSprt.move[2].toY     = K7APP_SCREEN_HEIGHT;	//ړYW
		mBackSprt.move[2].nowX    = (f32)mBackSprt.x2;		//݂XW
		mBackSprt.move[2].nowY    = (f32)mBackSprt.y2;		//݂YW
		mBackSprt.move[2].tick    = fadeTime;				//ړɂ鎞
		mBackSprt.move[2].nowTick = fadeTime;				//ړɂĂ鎞
	}
#endif
}
//-----------------------------------------------------------------------------
//̃tF[hC
// in --> none
// out -> true   tF[hCI
//        false  tF[hC
//-----------------------------------------------------------------------------
bool
MK7Jimaku::mFadeIn( void )
{
	//witF[h
	mBackSprtFade();
	//wiړ
	mBackSprtMove();
	
	//I`FbN֐
	return( mCheckFadeInEnd() );
}
//-----------------------------------------------------------------------------
//̃tF[hAEgݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mSetFadeOut( void )
{
	int	i, j;
	
	//
	for( i = 0; i < mLastDispSprtNum; i++ )
	{
		mSprt[i].mSetFade( 0, JIMAKU_FADEOUT_TIME );
	//	if( mBackEndFlag == 1 )
	//	mSprt[i].mSetScale( eScaleW, 8.0f, JIMAKU_FADEOUT_TIME );
		mSprtS[i].mSetFade( 0, JIMAKU_FADEOUT_TIME );
	//	if( mBackEndFlag == 1 )
	//	mSprtS[i].mSetScale( eScaleW, 8.0f, JIMAKU_FADEOUT_TIME );
		for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
		{
			mSprtSS[i][j].mSetFade( 0, JIMAKU_FADEOUT_TIME );
		}
	}
	
	//uEv̐Lт镔̃tF[hݒ
	for( i = 0; i < mESatsu.mNum; i++ )
	{
		for( j = 0; j < JIMAKU_SPRT_SATSU; j++ )
		{
			mESatsu.mSprt[i*JIMAKU_SPRT_SATSU+j].mSetFade( 0, JIMAKU_FADEOUT_TIME );
		}
	}
	//uv̐Lт镔̃tF[hݒ
	for( i = 0; i < mEShi.mNum; i++ )
	{
		for( j = 0; j < JIMAKU_SPRT_SHI; j++ )
		{
			mEShi.mSprt[i*JIMAKU_SPRT_SHI+j].mSetFade( 0, JIMAKU_FADEOUT_TIME );
		}
	}
	
	//rXvCgݒ
	for( i = 0; i < JIMAKU_RUBI_DAT_MAX; i++ )
	{
		for( j = 0; j < JIMAKU_RUBI_MAX; j++ )
		{
			if( mSprtRubi[i][j].mGetDispFlag() == true )
			{
				mSprtRubi[i][j].mSetFade( 0, JIMAKU_FADEOUT_TIME );
			}
		}
	}
	
	//Ȉꍇ͉ɏkď
	//͂̕ŏ違Ō̍sɒBĂ
	if( (mBackEndFlag == 0) && (((mLineIndex + 1) == JIMAKU_LINE_MAX) || (mSentenceDat[mSentenceIndex].jimaku[mLineIndex+1].chardat[0] == (s16)JIMAKU_NO_FONT)) )
	{//ɏkނ̂
		//wĩtF[h
		mBackSprt.fade.orgA    = (u8)(mBackSprt.rgba & 0xff);	//ŏ̃l
		mBackSprt.fade.toA     = 0;								//ڕWƂȂ郿l
		mBackSprt.fade.nowA    = (u8)(mBackSprt.rgba & 0xff);	//݂̃l
		mBackSprt.fade.tick    = JIMAKU_BACKFADEOUT_TIME;		//tF[hɂ鎞
		mBackSprt.fade.nowTick = JIMAKU_BACKFADEOUT_TIME;		//tF[hɂĂ鎞
		
#if	0
		//wïړ
		mBackSprt.move[0].orgX    = mBackSprt.x0;				//ړOXW
		mBackSprt.move[0].orgY    = mBackSprt.y0;				//ړOYW
		mBackSprt.move[0].toX     = mBackSprt.x0;				//ړXW
		mBackSprt.move[0].toY     = K7APP_SCREEN_HEIGHT;		//ړYW
		mBackSprt.move[0].nowX    = (f32)mBackSprt.x0;			//݂XW
		mBackSprt.move[0].nowY    = (f32)mBackSprt.y0;			//݂YW
		mBackSprt.move[0].tick    = JIMAKU_BACKFADEOUT_TIME;	//gkɂ鎞
		mBackSprt.move[0].nowTick = JIMAKU_BACKFADEOUT_TIME;	//gkɂĂ鎞
		
		mBackSprt.move[1].orgX    = mBackSprt.x1;				//ړOXW
		mBackSprt.move[1].orgY    = mBackSprt.y1;				//ړOYW
		mBackSprt.move[1].toX     = mBackSprt.x1;				//ړXW
		mBackSprt.move[1].toY     = K7APP_SCREEN_HEIGHT;		//ړYW
		mBackSprt.move[1].nowX    = (f32)mBackSprt.x1;			//݂XW
		mBackSprt.move[1].nowY    = (f32)mBackSprt.y1;			//݂YW
		mBackSprt.move[1].tick    = JIMAKU_BACKFADEOUT_TIME;	//gkɂ鎞
		mBackSprt.move[1].nowTick = JIMAKU_BACKFADEOUT_TIME;	//gkɂĂ鎞
		
		mBackSprt.move[2].orgX    = mBackSprt.x2;				//ړOXW
		mBackSprt.move[2].orgY    = mBackSprt.y2;				//ړOYW
		mBackSprt.move[2].toX     = mBackSprt.x2;				//ړXW
		mBackSprt.move[2].toY     = K7APP_SCREEN_HEIGHT;		//ړYW
		mBackSprt.move[2].nowX    = (f32)mBackSprt.x2;			//݂XW
		mBackSprt.move[2].nowY    = (f32)mBackSprt.y2;			//݂YW
		mBackSprt.move[2].tick    = JIMAKU_BACKFADEOUT_TIME;	//gkɂ鎞
		mBackSprt.move[2].nowTick = JIMAKU_BACKFADEOUT_TIME;	//gkɂĂ鎞
		
		mBackSprt.move[3].orgX    = mBackSprt.x3;				//ړOXW
		mBackSprt.move[3].orgY    = mBackSprt.y3;				//ړOYW
		mBackSprt.move[3].toX     = mBackSprt.x3;				//ړXW
		mBackSprt.move[3].toY     = K7APP_SCREEN_HEIGHT;		//ړYW
		mBackSprt.move[3].nowX    = (f32)mBackSprt.x3;			//݂XW
		mBackSprt.move[3].nowY    = (f32)mBackSprt.y3;			//݂YW
		mBackSprt.move[3].tick    = JIMAKU_BACKFADEOUT_TIME;	//gkɂ鎞
		mBackSprt.move[3].nowTick = JIMAKU_BACKFADEOUT_TIME;	//gkɂĂ鎞
#endif
	}
}
//-----------------------------------------------------------------------------
//̃tF[hAEg
// in --> none
// out -> true   tF[hAEgI
//        false  tF[hAEg
//-----------------------------------------------------------------------------
bool
MK7Jimaku::mFadeOut( void )
{
	//wĩtF[hAEg
	mBackSprtFade();
	//wiړ
	mBackSprtMove();
	
	//ݕ\̎ŕ\I`FbN
	if( mBackEndFlag )
	{
		//f[^ꍇ͕̃tF[h`FbN
		if( mSprt[0].mGetFadeNowTick() == 0 )
			return( true );
	}else
	{
		//f[^Ȃꍇ͔wĩtF[h`FbN
		if( mBackSprt.fade.nowTick == 0 )
			return( true );
	}
	
	return( false );
}




//-----------------------------------------------------------------------------
//wĩtF[h
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mBackSprtFade( void )
{
	if( mBackSprt.fade.nowTick != 0 )
	{
		mBackSprt.fade.nowA    += ((f32)mBackSprt.fade.toA - (f32)mBackSprt.fade.orgA) / (f32)WK7_TICK_TO_FRAME(mBackSprt.fade.tick);
		mBackSprt.fade.nowTick -= WK7_TICK_PER_FRAME;
		if( mBackSprt.fade.nowTick <= 0 )
		{
			mBackSprt.fade.nowA     = (f32)mBackSprt.fade.toA;
			mBackSprt.fade.nowTick  = 0;
		}
		mBackSprt.rgba = (u32)((u32)(mBackSprt.rgba & 0xffffff00) | (u8)mBackSprt.fade.nowA);
	}
	
	//RGBAl0łΔ\ɂ
	if( (mBackSprt.rgba & 0x000000ff) == 0 )
		mBackSprt.flag = false;
}
//-----------------------------------------------------------------------------
//wïړ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mBackSprtMove( void )
{
	stMove*	pMove;
	int		i;
	
	for( i = 0, pMove = &mBackSprt.move[0]; i < 4; i++, pMove++ )
	{
		if( pMove->nowTick != 0 )
		{
			pMove->nowX    += ((f32)pMove->toX - (f32)pMove->orgX) / (f32)WK7_TICK_TO_FRAME(pMove->tick);
			pMove->nowY    += ((f32)pMove->toY - (f32)pMove->orgY) / (f32)WK7_TICK_TO_FRAME(pMove->tick);
			pMove->nowTick -= WK7_TICK_PER_FRAME;
			if( pMove->nowTick <= 0 )
			{
				pMove->nowX    = (f32)pMove->toX;
				pMove->nowY    = (f32)pMove->toY;
				pMove->nowTick = 0;
			}
			switch( i )
			{
				case	0:
					mBackSprt.x0 = (s16)pMove->nowX;
					mBackSprt.y0 = (s16)pMove->nowY;
					break;
				case	1:
					mBackSprt.x1 = (s16)pMove->nowX;
					mBackSprt.y1 = (s16)pMove->nowY;
					break;
				case	2:
					mBackSprt.x2 = (s16)pMove->nowX;
					mBackSprt.y2 = (s16)pMove->nowY;
					break;
				case	3:
					mBackSprt.x3 = (s16)pMove->nowX;
					mBackSprt.y3 = (s16)pMove->nowY;
					break;
				default:
					break;
			}
		}
	}
}




//-----------------------------------------------------------------------------
//\̂߂̃t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mJmkFrameProc( void )
{
	enFileRead	fileStatus;
	char		temp[256];
	s32			i, j, charH;
	s16			dat, charIndex;
	
	//̃VXeǂݍ݁f[^ǂݍ݁\
	switch( mFrameProc )
	{
		//---- VXet@Cǂݍ݌n ----
		//VXef[^ǂݍ݃NGXg
		case	eJimakuSystemRead:
			//pVXeeNX`ǂݍ
			fileStatus = mFile.mK7FileRead( JIMAKU_RUBI_FILE, &((void*)mTexRubi.tex) );
			if( fileStatus == eFileReadSucsess )
			{
				//eNX`̏
				mK7InitTexture( &mTexRubi );
				//rXvCg
				for( i = 0; i < JIMAKU_RUBI_DAT_MAX; i++ )
				{
					for( j = 0; j < JIMAKU_RUBI_MAX; j++ )
					{
						mSprtRubi[i][j].mRelateTex( &mTexRubi );
						mSprtRubi[i][j].mSetDispFlag( false );
						mSprtRubi[i][j].mSetPriority( SPRT_PRI_JMK_RUBI );
						mSprtRubi[i][j].mSetWH( JIMAKU_RUBI_W, JIMAKU_RUBI_H );
					}
				}
				mFrameProc = eJimakuStandby;
			}
			break;
		
		//---- f[^t@Cǂݍ݌n ----
		//f[^t@Cǂݍ݃NGXg
		case	eJimakuDataReadReq:
			//f[^
			GHMGCMEM_SAFE_FREE( mDat );
			mFrameProc = eJimakuDataRead;
			break;
		//f[^t@Cǂݍ
		case	eJimakuDataRead:
			//t@C
			strcpy( temp, SUBTITLE_DIR );
			strcat( temp, mFileName );
			//f[^ǂݍ
			fileStatus = mFile.mK7FileRead( temp, &((void*)mDat) );
			if( fileStatus == eFileReadSucsess )
			{
				mDataSet( mDat );
			}
			break;
		
		//---- \n ----
		//f[^ݒ
		case	eJimakuDataSet:
			//---- \ ----
			//ϐ
			mLastDispSprtNum = 0;
			mBackSprt.w      = 0;	//͕
			charH            = 0;	//̍
			mESatsu.mNum     = 0;
			mEShi.mNum       = 0;
			mJmkElasticTerm( &mESatsu );
			mJmkElasticTerm( &mEShi );
			for( i = 0; i < JIMAKU_SPRT_MAX; i++ )
			{
				mESatsu.mIndexTbl[i] = (s16)JIMAKU_NO_FONT;
				mEShi.mIndexTbl[i]   = (s16)JIMAKU_NO_FONT;
			}
			
			//XvCgXvCg̊eݒ
			for( charIndex = 0, i = 0; i < JIMAKU_SPRT_MAX; i++ )
			{
				dat = mSentenceDat[mSentenceIndex].jimaku[mLineIndex].chardat[charIndex];
				//sm
				if( dat == (s16)JIMAKU_RETURN )
				{
					break;
				}else
				//pXy[Xm
				if( dat == (s16)JIMAKU_SPACE_H )
				{
					mBackSprt.w += JIMAKU_SPACE_HW;
					i--;	//XvCgID͐i߂Ȃ
				}else
				//SpXy[Xm
				if( dat == (s16)JIMAKU_SPACE_Z )
				{
					mBackSprt.w += JIMAKU_SPACE_ZW;
					i--;	//XvCgID͐i߂Ȃ
				}else
				{
					//uEv̑傫`FbN
					if( dat & (s16)JIMAKU_FLAG_SATSU )
					{	
						//傫
						dat = (s16)(dat & ~(s16)JIMAKU_FLAG_SATSU);
						mSprt[i].mSetRGBA( JIMAKU_COLOR_RED );
						mESatsu.mNum++;
						mESatsu.mIndexTbl[i] = (s16)JIMAKU_FLAG_SATSU;
					}else
					//uv̑傫`FbN
					if( dat & (s16)JIMAKU_FLAG_SHI )
					{	
						//傫
						dat = (s16)(dat & ~(s16)JIMAKU_FLAG_SHI);
						mSprt[i].mSetRGBA( JIMAKU_COLOR_RED );
						mEShi.mNum++;
						mEShi.mIndexTbl[i] = (s16)JIMAKU_FLAG_SHI;
					}else
					{
						//ʏ̕
						mSprt[i].mSetRGBA( JIMAKU_COLOR );
					}
					//ԍeNX`uvl߂
					charH          = (s16)mFParam[dat].h;
					mSprt[i].mSetDispFlag( false );
					mSprt[i].mSetU0( (s16)mFParam[dat].u );
					mSprt[i].mSetV0( (s16)mFParam[dat].v );
					mSprt[i].mSetWH( (s16)mFParam[dat].w, (s16)mFParam[dat].h );
					mSprt[i].mSetX0( mBackSprt.w );
					mSprt[i].mSetY0( (s16)JIMAKU_DISP_Y );
					mLastDispSprtNum += 1;					//\XvCǧJEg
					mBackSprt.w      += mSprt[i].mGetW();	//vZ
				}
				//f[^ւindexi߂
				charIndex++;
			}
			
			//\Jn܂ł̃EGCg擾
			mStartWaitTime = mSentenceDat[mSentenceIndex].jimaku[mLineIndex].wait;
			
			//ItOĂĎ̎f[^Ȃ΃tF[hAEgԂ̓obN̏鎞Ԃ̗p@łȂΒʏtF[hAEg
			if( (mBackEndFlag == true)
			 && (((mLineIndex + 1) == JIMAKU_LINE_MAX) || (mSentenceDat[mSentenceIndex].jimaku[mLineIndex+1].chardat[0] == (s16)JIMAKU_NO_FONT)) )
				mDisptime = mSentenceDat[mSentenceIndex].jimaku[mLineIndex].disptime - JIMAKU_MOJI_FADE - JIMAKU_BACKFADEOUT_TIME;
			else
				mDisptime = mSentenceDat[mSentenceIndex].jimaku[mLineIndex].disptime - JIMAKU_MOJI_FADE - JIMAKU_FADEOUT_TIME;
			
			//\Ԃ0菬ꍇ1b\悤ɏC
			if( mDisptime <= 0 )
			{
				mDisptime = WK7_TICK_PER_SEC - JIMAKU_MOJI_FADE - JIMAKU_FADEOUT_TIME;
			}
			
			//\JnÕEGCg
			mFrameProc = eJimakuStartWait;
			break;
		
		//---- \܂ł̃EGCg ----
		case	eJimakuStartWait:
			if( (mTotalTick >= (f32)mStartWaitTime) && (mPauseFlag == false) )
			{
				mCentering( mBackSprt.w );	//̃Z^O:Z^OƓɕ\tOONɂ邽߂Őݒ
				mJmkElasticSetSprt( &mESatsu, eElSatsu );	//uEvLт镶̐ݒ:̍Wݒ肪Iɍs
				mJmkElasticSetSprt( &mEShi, eElShi );		//uvLт镶̐ݒ:̍Wݒ肪Iɍs
				mSetFadeIn();				//tF[hCf[^ݒ
				mFrameProc = eJimakuFadeIn;	//tF[hC
			}
			break;
		
		//---- tF[hC ----
		//tF[hC
		case	eJimakuFadeIn:
			if( mFadeIn() == true )
			{
				if( mWaitKind == eJimakuDataWait )
				{
					//\Ԃw肳ĂΎԑ҂
					mFrameProc = eJimakuWaitByTime;
				}else
				if( mWaitKind == eJimakuKeyWait)
				{
					//L[͑҂
					mFrameProc = eJimakuWaitByKey;
				}
			}
			break;
		
		//---- 摗菈 ----
		//EGCgI҂
		case	eJimakuWaitByTime:
			if( mTotalTick >= (f32)(mDisptime + mStartWaitTime - JIMAKU_FADEOUT_TIME) )
			{
				mSetFadeOut();
				mFrameProc = eJimakuFadeOut;
			}
			break;
		
		//L[҂^CEGCg
		case	eJimakuWaitByKey:
			//҂Ԃ炷
			mDisptime -= WK7_TICK_PER_FRAME;
			//L[ꂽԂ
			if( (HSD_PadGetTrigger(0) & PAD_BUTTON_A) || (mDisptime <= 0) )
			{
				mSetFadeOut();
				mFrameProc = eJimakuFadeOut;
			}
			break;
		
		//---- tF[hAEg ----
		//tF[hAEg
		case	eJimakuFadeOut:
			if( mFadeOut() == true )
			{
				//rXvCg
				for( i = 0; i < JIMAKU_RUBI_DAT_MAX; i++ )
					for( j = 0; j < JIMAKU_RUBI_MAX; j++ )
						mSprtRubi[i][j].mSetDispFlag( false );
				//̐Lт镔̏I
				mJmkElasticTerm( &mESatsu );
				mJmkElasticTerm( &mEShi );
				//̎ɑǂׂ
				if( mDispEndCheck() == true )
				{
					//f[^IX^oC
					mFrameProc = eJimakuStandby;
				}else
				{
					//f[^\
					mFrameProc = eJimakuDataSet;
				}
			}
			break;
		
		//---- ҋ@ ----
		case	eJimakuStandby:
			break;
		
		//---- ftHg ----
		default:
			break;
	}
	
	//\ԂĎticǩvZ
	if( (mFrameProc == eJimakuStartWait)	//\܂ł̃EGCg
	 || (mFrameProc == eJimakuFadeIn)		//tF[hC
	 || (mFrameProc == eJimakuWaitByTime)	//\Eԑ҂
	 || (mFrameProc == eJimakuWaitByKey)	//\EL[͑҂
	 || (mFrameProc == eJimakuFadeOut) )	//tF[hAEg
	{
		if( mPauseFlag == false )
		{
			if( (gpMovie->mGetStatus() == eMvProcStandby) && (gpNoise->mGetSandFrameProc() == eSandStandby) )
			{	//---- L -----
			//	mTotalTick += (u32)((f32)WK7_TICK_PER_FRAME * mSpeed);
				mTotalTick += (4800.0f / 29.97f) * mSpeed;
			}else
			{	//---- [r[ ----
				//movieĐmovie̕\t[tickvZ
				mTotalTick = (f32)(WK7_FRAME_TO_TICK(gpMovie->mGetFrame()));
			}
		}
	}
#ifndef	K7APP_MASTER
//	if( mDat != NULL && mainMenu.GetModeInfo()==true )
//	{
//		C_Paper	paper(280,24);
//		PRINTF( "%.3f(%.1f)\n", mTotalTick/4800.0f, mTotalTick );
//		C_Paper	paper2(280,36);
//		PRINTF( "%.3f\n", (gpMovie->mGetFrame() / 29.97f) );
//	}
#endif
}




//-----------------------------------------------------------------------------
//\̂߂̖t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mFrameProcess( void )
{
	//\̂߂̃t[
	mJmkFrameProc();
	//̉ëړ
	mJmkShadowMoveProc();
	//Lт镶̏
	mJmkElasticFrameProc();
}




//-----------------------------------------------------------------------------
//f[^̂AhXݒ肷
// in --> void* inDat  f[^̂AhX
// out -> false f[^ݒ莸si\Ă\j
//        true  f[^ݒ萬
//-----------------------------------------------------------------------------
bool
MK7Jimaku::mDataSet( void* inDat )
{
	int	i;
	
	//NULLw肳ꂽf[^͂Ȃ̂Ŗ߂
	if( inDat == NULL )
	{
		mDat = NULL;
		return( true );
	}
	
	//t[ҋ@łȂΖ߂
	if( (mFrameProc != eJimakuStandby) && (mFrameProc != eJimakuDataRead) )
	{
		return( false );
	}
	
	//f[^AhXݒ
	mDat = (stSentence*)inDat;
	//̓f[^ւ̃AhXݒ
	mSentenceDat = (stOneSentence*)((char*)mDat + mDat->offset);
	//uvwhf[^ւ̃AhXݒ
	mFParam = (stFontParam*)((char*)mDat + mDat->charOffset);
	//eNX`AhẌn
	mTex.tex = (GhmGcTexHeader*)((char*)mDat + mDat->texOffset);
	//eNX`̏
	mK7InitTexture( &mTex );
	
	//
	mTotalTick     = 0.0f;	//\ԂĎtick
	mSentenceIndex = 0;		//\͔ԍ
	mPauseFlag     = true;	//\̓|[YԂɂĂ
	
	//
	mLineIndex     = 0;					//\sNA
	mRGBA          = JIMAKU_COLOR;		//̏Fݒ
	mWaitKind      = eJimakuDataWait;	//摗胂[hݒ
	mBackSprtDir   = (enJimakuBackDir)mSentenceDat[mSentenceIndex].info.backLocate;
	mBackEndFlag   = (u8)mSentenceDat[mSentenceIndex].info.countinue;
	mKeyWaitFlag   = (u8)mSentenceDat[mSentenceIndex].info.key;
	if( mKeyWaitFlag )
		mWaitKind  = eJimakuKeyWait;
	mVoiceWaitTime = mSentenceDat[mSentenceIndex].info.wait;
	
	//wi̎lړ񏉊
	for( i = 0; i < 4; i++ )
	{
		mBackSprt.move[i].nowTick = 0;
	}
	
	//̃t[f[^ݒɕύX
	mFrameProc = eJimakuDataSet;
	
	//I
	return( true );
}
//-----------------------------------------------------------------------------
//̕\~ăX^oCԂɂ܂
// in --> none
// out -> bool true   ̃vO~߂ăX^oCԂɂȂ
//             false  ̃vO~߂邱ƂłȂ
//-----------------------------------------------------------------------------
bool
MK7Jimaku::mDispStop( void )
{
	int	i, j;
	
	//f[^ǂݍݒȂǂ͒~ɂłȂ
	if( (mFrameProc == eJimakuSystemRead)		//VXef[^̓ǂݍݒ
	 || (mFrameProc == eJimakuDataReadReq)		//f[^ǂݍ݃NGXg
	 || (mFrameProc == eJimakuDataRead)			//f[^ǂݍݒ
	)
	{
		return( false );
	}
	
	//XvCg\tONA
	for( i =0; i < JIMAKU_SPRT_MAX; i++ )
	{
		mSprt[i].mSetDispFlag( false );
		mSprt[i].mSetRGBA( 0 );
	}
	
	//̉eXvCg\ɂ
	for( i =0; i < JIMAKU_SPRT_MAX; i++ )
	{
		mSprtS[i].mSetDispFlag( false );
		mSprtS[i].mSetRGBA( 0 );
	}
	
	//̉eXvCg\ɂ
	for( i =0; i < JIMAKU_SPRT_MAX; i++ )
	{
		for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
		{
			mSprtSS[i][j].mSetDispFlag( false );
			mSprtSS[i][j].mSetRGBA( 0 );
		}
	}
	
	//rXvCg
	for( i = 0; i < JIMAKU_RUBI_DAT_MAX; i++ )
		for( j = 0; j < JIMAKU_RUBI_MAX; j++ )
			mSprtRubi[i][j].mSetDispFlag( false );
	
	//̔wi\
	mBackSprt.flag = 0;
	for( i = 0; i < 4; i++ )
		mBackSprt.move[i].nowTick = 0;
	
	//
	mLineIndex      = 0;			///sւindexNA
	mRGBA           = JIMAKU_COLOR;	//̏Fݒ
	
	//̃t[\ɕύX
	mFrameProc = eJimakuStandby;
	
	//̐Lт镔̏I
	mJmkElasticTerm( &mESatsu );
	mJmkElasticTerm( &mEShi );
	for( i = 0; i < JIMAKU_SPRT_MAX; i++ )
	{
		mESatsu.mIndexTbl[i] = (s16)JIMAKU_NO_FONT;
		mEShi.mIndexTbl[i]   = (s16)JIMAKU_NO_FONT;
	}
	
	return( true );
}




//-----------------------------------------------------------------------------
//\JE^[̈ꎞ~
// in --> u32  inTick  |[YƂɎw肵tick
// out -> bool false   NGXg󂯕tԂłȂ
//             true    NGXg
//-----------------------------------------------------------------------------
bool
MK7Jimaku::mSetPause( void )
{
	//f[^Ȃ΃|[YKvȂ
	if( mDat == NULL )
	{
		return( false );
	}

	mPauseFlag = true;
#if	0
	if( (mFrameProc == eJimakuStartWait)	//\܂ł̃EGCg
	 || (mFrameProc == eJimakuStandby) )	//ҋ@
	{
		mPauseFlag = true;
	}else
	{
		return( false );
	}
#endif
	
	return( true );
}
//-----------------------------------------------------------------------------
//\JE^[̈ꎞ~
// in --> u32  inTick  |[YƂɎw肵tick
// out -> bool false   ݃|[YĂ܂
//             true    |[Y܂
//-----------------------------------------------------------------------------
bool
MK7Jimaku::mReleasePause( u32 inTick )
{
	//f[^Ȃ΃|[YKvȂ
	if( mDat == NULL )
	{
		return( false );
	}
	
	if( mPauseFlag == true )
	{
		if( inTick != 0 )
		{
			mTotalTick = (f32)inTick;
		}
		mPauseFlag = false;
	}else
	{
		return( false );
	}
	
	return( true );
}




//-----------------------------------------------------------------------------
//̐Lт镔̃XvCgݒ
// in --> stElastic*    inEl
//        enElasticKind inKind
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mJmkElasticSetSprt( stElastic* inEl, enElasticKind inKind )
{
	s32		i, j;
	s16		index, mojiFlag, elNum;
	s16*	tbl;
	
	switch( inKind )
	{
		case	eElSatsu:
			mojiFlag = (s16)JIMAKU_FLAG_SATSU;
			elNum    = JIMAKU_SPRT_SATSU;
			tbl      = gTblSatsu[0][0];
			break;
		
		case	eElShi:
			mojiFlag = (s16)JIMAKU_FLAG_SHI;
			elNum    = JIMAKU_SPRT_SHI;
			tbl      = gTblShi[0][0];
			break;
		
		default:
			break;
	}
	
	//Lт镔̃XvCgΐݒ
	if( inEl->mNum )
	{
		//̊m
		ghmGcMemSetAllocName("MSprite");
		inEl->mSprt        = new mK7Sprite[elNum * inEl->mNum];
		inEl->mElastic     = (enJmkElastic*)K7AppSmallMemAlloc( (int)(sizeof(enJmkElastic)*elNum*inEl->mNum) );
		inEl->mElasticWait = (s16*)K7AppSmallMemAlloc( (int)(sizeof(s16)*elNum*inEl->mNum) );
		index              = 0;
		//f[^ŏ猟ĊY邽тUVXYݒ肵Ă
		for( i = 0; i < JIMAKU_SPRT_MAX; i++ )
		{
			if( inEl->mIndexTbl[i] == mojiFlag )
			{
				for( j = 0; j < elNum; j++ )
				{
					inEl->mElastic[index*elNum+j] = eJmkElasticStandby;
					
					inEl->mSprt[index*elNum+j].mSetTriangleTexPrim();
					inEl->mSprt[index*elNum+j].mSetPriority( SPRT_PRI_JMK_ELASTIC );
					inEl->mSprt[index*elNum+j].mRelateTex( &mTex );
					inEl->mSprt[index*elNum+j].mSetDispFlag( true );
					inEl->mSprt[index*elNum+j].mSetRGBA( JIMAKU_COLOR_RED );
					
					inEl->mSprt[index*elNum+j].mSetX0( (s16)(tbl[(3*2*j)+(2*0)+(0)] + mSprt[i].mGetX0()) );	//Op`1_X
					inEl->mSprt[index*elNum+j].mSetY0( (s16)(tbl[(3*2*j)+(2*0)+(1)] + mSprt[i].mGetY0()) );	//Op`1_X
					inEl->mSprt[index*elNum+j].mSetX1( (s16)(tbl[(3*2*j)+(2*1)+(0)] + mSprt[i].mGetX0()) );	//Op`1_X
					inEl->mSprt[index*elNum+j].mSetY1( (s16)(tbl[(3*2*j)+(2*1)+(1)] + mSprt[i].mGetY0()) );	//Op`1_X
					inEl->mSprt[index*elNum+j].mSetX2( (s16)(tbl[(3*2*j)+(2*2)+(0)] + mSprt[i].mGetX0()) );	//Op`1_X
					inEl->mSprt[index*elNum+j].mSetY2( (s16)(tbl[(3*2*j)+(2*2)+(1)] + mSprt[i].mGetY0()) );	//Op`1_X
					
					inEl->mSprt[index*elNum+j].mSetU0( (s16)(tbl[(3*2*j)+(2*0)+(0)] + mSprt[i].mGetU0()) );	//Op`1_X
					inEl->mSprt[index*elNum+j].mSetV0( (s16)(tbl[(3*2*j)+(2*0)+(1)] + mSprt[i].mGetV0()) );	//Op`1_X
					inEl->mSprt[index*elNum+j].mSetU1( (s16)(tbl[(3*2*j)+(2*1)+(0)] + mSprt[i].mGetU0()) );	//Op`1_X
					inEl->mSprt[index*elNum+j].mSetV1( (s16)(tbl[(3*2*j)+(2*1)+(1)] + mSprt[i].mGetV0()) );	//Op`1_X
					inEl->mSprt[index*elNum+j].mSetU2( (s16)(tbl[(3*2*j)+(2*2)+(0)] + mSprt[i].mGetU0()) );	//Op`1_X
					inEl->mSprt[index*elNum+j].mSetV2( (s16)(tbl[(3*2*j)+(2*2)+(1)] + mSprt[i].mGetV0()) );	//Op`1_X
				}
				index++;
			}
		}
	}
}
//-----------------------------------------------------------------------------
//̐Lт镔̃XvCg̃t[
// in --> stElastic*    inEl
//        enElasticKind inKind
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mJmkElasticFrameProcFunc( stElastic* inEl, enElasticKind inKind )
{
	f32		rate;
	s16		i, j, index, x1, y1, mojiFlag, elNum;
	s16*	tbl;
	s16*	gTbl;
	
	//uEv̐Lт镔̍We[u
	s16	tblSatsuN[JIMAKU_SPRT_SATSU][2] = {
		{ -128,  -72 },
		{  -56,   34 },
		{  -36,   30 },
		{    0,  -64 },
		{  128,    0 },
		{  -90,    0 },
		{    0,  128 },
		{  128, -128 },
		{ -128,   48 },
		{  128, -128 },
		{   -4, -128 },
	};
	//uv̐Lт镔̍We[u
	s16	tblShiN[JIMAKU_SPRT_SHI][2] = {
		{ -128,    0 },
		{  -64,   32 },
		{    0, -128 },
		{  128,    0 },
		{ -112,  128 },
		{  112, -128 },
		{   32, -128 },
		{    0, -128 },
		{ -128,    0 },
		{ -104, -128 },
	};
	
	//\t[łȂΉȂŖ߂
	if( (mFrameProc == eJimakuSystemRead)			//VXef[^̓ǂݍݒ
	 || (mFrameProc == eJimakuDataReadReq)			//f[^ǂݍ݃NGXg
	 || (mFrameProc == eJimakuDataRead)				//f[^ǂݍݒ
	 || (mFrameProc == eJimakuDataSet)				//f[^ݒ
	 || (mFrameProc == eJimakuStartWait)			//\܂ł̃EGCg
//	 || (mFrameProc == eJimakuFadeIn)				//tF[hC
//	 || (mFrameProc == eJimakuWaitByTime)			//\Eԑ҂
//	 || (mFrameProc == eJimakuWaitByVoice)			//\EĐI҂
//	 || (mFrameProc == eJimakuWaitByKey)			//\EL[͑҂
//	 || (mFrameProc == eJimakuWaitByProgIndicate)	//\EvOw҂
//	 || (mFrameProc == eJimakuFadeOut)				//tF[hAEg
	 || (mFrameProc == eJimakuStandby) )			//ҋ@
	{
		return;
	}
	
	//̎ނŐl
	switch( inKind )
	{
		case	eElSatsu:
			mojiFlag = (s16)JIMAKU_FLAG_SATSU;
			elNum    = JIMAKU_SPRT_SATSU;
			tbl      = tblSatsuN[0];
			gTbl     = gTblSatsu[0][0];
			break;
		
		case	eElShi:
			mojiFlag = (s16)JIMAKU_FLAG_SHI;
			elNum    = JIMAKU_SPRT_SHI;
			tbl      = tblShiN[0];
			gTbl     = gTblShi[0][0];
			break;
		
		default:
			break;
	}
	
	//Lт镔̏
	if( inEl->mNum != 0 )
	{
		index = 0;
		for( i = 0; i < JIMAKU_SPRT_MAX; i++ )
		{
			//XvCgŜY̓index
			if( inEl->mIndexTbl[i] == mojiFlag )
			{
				//̐Lт镔̌[v
				for( j = 0; j < elNum; j++ )
				{
					switch( inEl->mElastic[index*elNum+j] )
					{
						//X̕ʂLт邩kނ
						case	eJmkElasticStandby:
							if( HSD_Randi(JIMAKU_ELASTIC_RATE) == 0 )
							{
								rate = (f32)(HSD_Randi(100)) / 100.0f;
								x1 = (s16)(inEl->mSprt[index*elNum+j].mGetX1() + (s16)((f32)tbl[(2*j)+0] * rate) );
								y1 = (s16)(inEl->mSprt[index*elNum+j].mGetY1() + (s16)((f32)tbl[(2*j)+1] * rate) );
								inEl->mSprt[index*elNum+j].mSetElastic( x1, y1, JIMAKU_ELASTIC_N_TICK );
								inEl->mElastic[index*elNum+j] = eJmkElasticN;
							}
							break;
						
						case	eJmkElasticN:
							if( inEl->mSprt[index*elNum+j].mGetElasticEnd() == true )
							{
								inEl->mElasticWait[index*elNum+j] = (s16)(HSD_Randi(JIMAKU_ELASTIC_WAIT/2)+(JIMAKU_ELASTIC_WAIT/2));
								inEl->mElastic[index*elNum+j] = eJmkElasticWait;
							}
							break;
						
						case	eJmkElasticWait:
							if( inEl->mElasticWait[index*elNum+j] > 0 )
							{
								inEl->mElasticWait[index*elNum+j] -= WK7_TICK_PER_FRAME;
							}else
							{
								x1 = (s16)(gTbl[(3*2*j)+(2*1)+(0)] + mSprt[i].mGetX0());
								y1 = (s16)(gTbl[(3*2*j)+(2*1)+(1)] + mSprt[i].mGetY0());
								inEl->mSprt[index*elNum+j].mSetElastic( x1, y1, JIMAKU_ELASTIC_T_TICK );
								inEl->mElasticWait[index*elNum+j] = 0;
								inEl->mElastic[index*elNum+j] = eJmkElasticT;
							}
							break;
						
						case	eJmkElasticT:
							if( inEl->mSprt[index*elNum+j].mGetElasticEnd() == true )
							{
								inEl->mElastic[index*elNum+j] = eJmkElasticStandby;
							}
							break;
						
						default:
							break;
					}
					//x[XƂȂ镶ړĂLk镔Ȃ悤ɍWXV
					inEl->mSprt[index*elNum+j].mSetX0( (s16)(gTbl[(3*2*j)+(2*0)+(0)] + mSprt[i].mGetX0()) );	//Op`1_X
					inEl->mSprt[index*elNum+j].mSetY0( (s16)(gTbl[(3*2*j)+(2*0)+(1)] + mSprt[i].mGetY0()) );	//Op`1_Y
					inEl->mSprt[index*elNum+j].mSetX2( (s16)(gTbl[(3*2*j)+(2*2)+(0)] + mSprt[i].mGetX0()) );	//Op`3_X
					inEl->mSprt[index*elNum+j].mSetY2( (s16)(gTbl[(3*2*j)+(2*2)+(1)] + mSprt[i].mGetY0()) );	//Op`3_Y
				}
				//
				index++;
			}
		}
	}
	return;
}
//-----------------------------------------------------------------------------
//̐Lт镔̃XvCg̃t[Ăяo
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mJmkElasticFrameProc( void )
{
	mJmkElasticFrameProcFunc( &mESatsu, eElSatsu );
	mJmkElasticFrameProcFunc( &mEShi, eElShi );
}
//-----------------------------------------------------------------------------
//̐Lт镔ɎgpϐȂǂ̏I
// in --> stElastic* inEl  Lт镔̐ݒ\
// out -> none
//-----------------------------------------------------------------------------
void
MK7Jimaku::mJmkElasticTerm( stElastic* inEl )
{
	inEl->mNum = 0;
	GHM_SAFE_DELETE_ARRAY( inEl->mSprt );
	GHMGCMEM_SAFE_FREE( inEl->mElastic );
	GHMGCMEM_SAFE_FREE( inEl->mElasticWait );
}

//-----------------------------------------------------------------------------
//̕\xݒ
// in --> f32 ݒ肵x
// out -> f32 ݒ肳Ăx
//-----------------------------------------------------------------------------
f32
MK7Jimaku::mSetDispSpeed( f32 inSpeed )
{
	f32	old = mSpeed;
	mSpeed = inSpeed;	
	return( old );
}
