////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Sprite
//
// mK7Sprite.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/17/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7SPRITE_H__
#define	__MK7SPRITE_H__

//---- include ----
#include "mK7Common.h"




//---- define ----
//XgD揇  int^ 
#define	SPRT_PRI_NORMAL			(256)		//ʏ
//֌W
#define	SPRT_PRI_JMK_BIGSHADOW	(10)		//̑傫ȉe
#define	SPRT_PRI_JMK_SHADOW		(20)		//̉
#define	SPRT_PRI_JMK			(30)		//
#define	SPRT_PRI_JMK_ELASTIC	(40)		//E̐LkXvCg
#define	SPRT_PRI_JMK_RUBI		(50)		//r
#define	SPRT_PRI_JMK_SYSTEM		(60)		//VXen
//^C|֌W
#define	SPRT_PRI_TYPO_SHADOW	(10)		//^C|̉e
#define	SPRT_PRI_TYPO			(20)		//^C|
//mCY֌W
#define	SPRT_PRI_SANDBASE		(220)		//̃Lv`摜
#define	SPRT_PRI_DIM			(225)		//XL̂Ԃ
#define	SPRT_PRI_DIM_MONO		(226)		//XL̒PFpl(E)
#define	SPRT_PRI_DIM_HS			(227)		//XLHS
#define	SPRT_PRI_NOISE			(230)		//mCY
#define	SPRT_PRI_NOISE_FONT		(240)		//mCYɍڂ镶

#define	SPRT_PRI_DUMMY			(0)

//\D揇ʌn
//#define	PRIORITY_HIGH_SPRT			(0)
//#define	PRIORITY_FADE				(1)
//#define	PRIORITY_JIMAKU				(2)
//#define	PRIORITY_JIMAKU_SHADOW		(3)
//#define	PRIORITY_JIMAKU_BACK		(4)
//#define	PRIORITY_TYPO				(5)
//#define	PRIORITY_TYPO_SHADOW		(6)
//#define	PRIORITY_LOW_SPRT			(64)




//---- typedef ----
//tevݒ֐̌^
typedef	void tevFunc( void );
//vtxݒ֐̌^
typedef	void vtxFunc( void );
//mRenderProc֐̌^
class	mK7Sprite;
typedef	void (mK7Sprite::*renderFuncPtr)( void );




//---- enum ----
//XvCg̊gk̕
typedef	enum{
	eScaleW,
	eScaleH,
	eScaleWH,
	eScaleMax,
}enScaleDir;

//vtx̎
typedef	enum{
	eVtxNonTex,		//eNX`Ȃ
	eVtxTex,		//eNX`
	eVtxMax,
}enVtxKind;

//tev̎
typedef	enum{
	eTevFlat,				//tbg|Stev
	eTevSprite,				//spritetev
	eTevSpriteNoTexAlpha,	//spritetevŃeNX`̃gȂ
	eTevAddAlpha,			//Zptev
	eTevScanHS,				//HSXLp
	eTevKindMax,
}enTevKind;

//_O̎
typedef	enum{
	eRenderLine,			//2_w̃C
	eRenderTriangle,		//Op`
	eRenderBox,				//lp`
	eRenderTransformBox,	//ό`lp`
	eRenderSprite,			//eNX`̎lp`XvCg
	eRenderMax,
}enRenderKind;




//---- struct ----
//XP[\
typedef	struct{
	f32	start;		//ŏ̊gk
	f32	last;		//ŏIIȊgk
	f32	now;		//݂̊gk
	s32	tick;		//gkɂ鎞
	s32	nowTick;	//gkɂĂ鎞
	s32	waitTick;	//gk܂łɑ҂
}stScale;

//ړ\
typedef	struct{
	f32	orgX;		//ړOXW
	f32	orgY;		//ړOYW
	f32 toX;		//ړXW
	f32 toY;		//ړYW
	f32	nowX;		//݂XW
	f32	nowY;		//݂YW
	s32	tick;		//ړɂ鎞
	s32	nowTick;	//ړɂĂ鎞
	s32	waitTick;	//ړ܂łɑ҂
}stMove;

//ό``ړ\
typedef	struct{
	f32		orgX1;	//ړOX1W
	f32		orgY1;	//ړOY1W
	f32		orgX2;	//ړOX2W
	f32		orgY2;	//ړOY2W
	f32		orgX3;	//ړOX3W
	f32		orgY3;	//ړOY3W
	bool	flag;	//4_̓ƗړgtO
}stMove4Vtx;

//tF[h\
typedef	struct{
	u8	orgA;		//ŏ̃l
	u8	toA;		//ڕWƂȂ郿l
	f32	nowA;		//݂̃l
	s32	tick;		//tF[hɂ鎞
	s32	nowTick;	//tF[hɂĂ鎞
	s32	waitTick;	//tF[h܂łɑ҂
}stFade;

//U\
typedef	struct{
	s16	vibrateW;	//U
	f32	orgY;		//YW
	u8	index;		//ǓXindex
	s32	tick;		//Uɂ鎞
	s32	nowTick;	//UɂĂ鎞
	s32	waitTick;	//U܂łɑ҂
}stVibrate;




//---- NX ----
class	mK7Sprite : public ghmGcListObj
{
	public:
		//RXgN^
		mK7Sprite( int inPriority = SPRT_PRI_NORMAL );
		
		//fXgN^
		virtual ~mK7Sprite( void );
		
		//eNX`֘At
		void	mRelateTex( stTexture* inTex );
		//eNX`擾
		stTexture*	mGetTex( void ){return(mTex);}
		
		//Cv~eBuɐݒ肷
		void	mSetLinePrim( void );
		//Op`eNX`̃v~eBuɐݒ肷
		void	mSetTriangleTexPrim( void );
		//lp`v~eBuɐݒ肷
		void	mSetBoxPrim( void );
		//ό`lp`v~eBuɐݒ肷
		void	mSetTransformBoxPrim( void );
		//eNX`̎lp`v~eBuɐݒ肷
		void	mSetSpritePrim( void );
		//eNX`ŃeNX`̃gȂlp`v~eBuɐݒ肷
		void	mSetSpriteNoTexAlphaPrim( void );
		//eNX`̎lp`Zv~eBuɐݒ肷
		void	mSetSpriteAddAlphaPrim( void );
		//HSXLp̃v~eBuɐݒ肷
		void	mSetSpriteScanHSPrim( void );
		
		//ݒ
		void	mSetW( s16 inW );
		//ݒ
		void	mSetH( s16 inH );
		//擾
		s16		mGetW( void ){return(mW);}
		//擾
		s16		mGetH( void ){return(mH);}
		//{̕擾
		s16		mGetOrgW( void ){return(mOrgW);}
		//{̍擾
		s16		mGetOrgH( void ){return(mOrgH);}
		
		//ݒ
		void	mSetWH( s16 inW, s16 inH );
		
		//\XWݒ
		void	mSetX0( f32 inX ){mX0=inX;mOrgX0=inX;}
		//\XWݒ
		void	mSetX1( f32 inX ){mX1=mMove4Vtx.orgX1=inX;}
		//\XWݒ
		void	mSetX2( f32 inX ){mX2=mMove4Vtx.orgX2=inX;}
		//\XWݒ
		void	mSetX3( f32 inX ){mX3=mMove4Vtx.orgX3=inX;}
		
		//\YWݒ
		void	mSetY0( f32 inY ){mY0=inY;mOrgY0=inY;}
		//\YWݒ
		void	mSetY1( f32 inY ){mY1=mMove4Vtx.orgY1=inY;}
		//\YWݒ
		void	mSetY2( f32 inY ){mY2=mMove4Vtx.orgY2=inY;}
		//\YWݒ
		void	mSetY3( f32 inY ){mY3=mMove4Vtx.orgY3=inY;}
		
		//\X0W擾
		f32		mGetX0( void ){return(mX0);}
		//\X1W擾
		f32		mGetX1( void ){return(mX1);}
		//\X2W擾
		f32		mGetX2( void ){return(mX2);}
		//\X3W擾
		f32		mGetX3( void ){return(mX3);}
		
		//\Y0W擾
		f32		mGetY0( void ){return(mY0);}
		//\Y1W擾
		f32		mGetY1( void ){return(mY1);}
		//\Y2W擾
		f32		mGetY2( void ){return(mY2);}
		//\Y3W擾
		f32		mGetY3( void ){return(mY3);}
		
		//\XYWݒ
		void	mSetXY0( f32 inX, f32 inY );
		
		//\ݒ
		void	mSetDispFlag( bool inFlag ){mFlag=inFlag;}
		//\擾
		bool	mGetDispFlag( void ){return(mFlag);}
		
		//RGBAݒ
		void	mSetRGBA( u32 inRgba ){mRgba0=mRgba1=mRgba2=mRgba3=inRgba;}
		//RGBA擾
		u32		mGetRGBA( void ){return(mRgba0);}
		//Alݒ
		void	mSetA( u8 inA );
		//Al擾
		u8		mGetA( void ){return((u8)(mRgba0&0x000000ff));}
		
		//RGBAݒ
		void	mSetRGBA0( u32 inRgba ){mRgba0=inRgba;}
		//RGBA擾
		u32		mGetRGBA0( void ){return(mRgba0);}
		//Alݒ
		void	mSetA0( u8 inA ){mRgba0=(mRgba0&0xffffff00)|inA;}
		//Al擾
		u8		mGetA0( void ){return((u8)(mRgba0&0x000000ff));}
		//RGBAݒ
		void	mSetRGBA1( u32 inRgba ){mRgba1=inRgba;}
		//RGBA擾
		u32		mGetRGBA1( void ){return(mRgba1);}
		//Alݒ
		void	mSetA1( u8 inA ){mRgba1=(mRgba1&0xffffff00)|inA;}
		//Al擾
		u8		mGetA1( void ){return((u8)(mRgba1&0x000000ff));}
		//RGBAݒ
		void	mSetRGBA2( u32 inRgba ){mRgba2=inRgba;}
		//RGBA擾
		u32		mGetRGBA2( void ){return(mRgba2);}
		//Alݒ
		void	mSetA2( u8 inA ){mRgba2=(mRgba2&0xffffff00)|inA;}
		//Al擾
		u8		mGetA2( void ){return((u8)(mRgba2&0x000000ff));}
		//RGBAݒ
		void	mSetRGBA3( u32 inRgba ){mRgba3=inRgba;}
		//RGBA擾
		u32		mGetRGBA3( void ){return(mRgba3);}
		//Alݒ
		void	mSetA3( u8 inA ){mRgba3=(mRgba3&0xffffff00)|inA;}
		//Al擾
		u8		mGetA3( void ){return((u8)(mRgba3&0x000000ff));}
		
		//u0v0ݒ
		void	mSetUV0( s16 inU, s16 inV ){mU0=inU;mV0=inV;mU1=(s16)(inU+mW);mV1=inV;mU2=inU;mV2=(s16)(inV+mH);mU3=(s16)(inU+mW);mV3=(s16)(inV+mH);}
		//u0v0ݒ
		void	mSetUV1( s16 inU, s16 inV ){mU1=inU;mV1=inV;}
		//u0v0ݒ
		void	mSetUV2( s16 inU, s16 inV ){mU2=inU;mV2=inV;}
		//u0v0ݒ
		void	mSetUV3( s16 inU, s16 inV ){mU3=inU;mV3=inV;}
		
		//u0ݒ
		void	mSetU0( s16 inU ){mU0=inU;mU1=(s16)(inU+mW);mU2=inU;mU3=(s16)(inU+mW);}
		//u1ݒ
		void	mSetU1( s16 inU ){mU1=inU;}
		//u2ݒ
		void	mSetU2( s16 inU ){mU2=inU;}
		//u3ݒ
		void	mSetU3( s16 inU ){mU3=inU;}
		
		//v0ݒ
		void	mSetV0( s16 inV ){mV0=inV;mV1=inV;mV2=(s16)(inV+mH);mV3=(s16)(inV+mH);}
		//v1ݒ
		void	mSetV1( s16 inV ){mV1=inV;}
		//v2ݒ
		void	mSetV2( s16 inV ){mV2=inV;}
		//v3ݒ
		void	mSetV3( s16 inV ){mV3=inV;}
		
		//u0擾
		s16		mGetU0( void ){return(mU0);}
		//u1擾
		s16		mGetU1( void ){return(mU1);}
		//u2擾
		s16		mGetU2( void ){return(mU2);}
		//u3擾
		s16		mGetU3( void ){return(mU3);}
		
		//v0擾
		s16		mGetV0( void ){return(mV0);}
		//v1擾
		s16		mGetV1( void ){return(mV1);}
		//v2擾
		s16		mGetV2( void ){return(mV2);}
		//v3擾
		s16		mGetV3( void ){return(mV3);}
		
		//fadě݂tick擾
		s32		mGetFadeNowTick( void ){return(mFade.nowTick);}
		
		//tex擾
		u16		mGetTexW( void ){return(mTex->tex->mWidth);}
		//tex擾
		u16		mGetTexH( void ){return(mTex->tex->mHeight);}
		
		//texobj擾
		GXTexObj*	mGetTexObj( void ){return(&mTex->obj);}
		
		//v~eBu̎ނ擾
		GXPrimitive	mGetPrimKind( void ){return(mKind);}
		
		//gkݒ
		void	mSetScale( enScaleDir inScaleDir, f32 inScale, s32 inTick );
		//XvCggkwEGCgt
		void	mSetScaleWithWait( enScaleDir inScaleDir, f32 inScale, s32 inTick, s32 inWaitTick );
		//gkImF
		bool	mGetScaleEnd( void );
		//gk
		void	mScaleProc( void );

		//ړݒ
		void	mSetMove( f32 inX, f32 inY, s32 inTick );
		//ړImF
		bool	mGetMoveEnd( void );
		//ړ
		void	mMoveProc( void );

		//XY0̐Lkݒ
		void	mSetElastic( f32 inX, f32 inY, s32 inTick );
		//XY0̐LkImF
		bool	mGetElasticEnd( void );
		//XY0̐Lk
		void	mElasticProc( void );

		//tF[hݒ
		void	mSetFade( u8 inA, s32 inTick );
		//XvCgtF[hwEGCg
		void	mSetFadeWithWait( u8 inA, s32 inTick, s32 inWaitTick );
		//tF[hImF
		bool	mGetFadeEnd( void );
		//tF[h
		void	mFadeProc( void );

		//CUw
		void	mSetVibrate( s16 inVibrateW, s32 inTick );
		//CU
		void	mVibrateProc( void );

		//_OEC
		void	mRenderLine( void );
		//Op`_O
		void	mRenderTriangleTex( void );
		//lp`_O
		void	mRenderBox( void );
		//ό`lp`_O
		void	mRenderTransformBox( void );
		//_OEeNX`tXvCg
		void	mRenderSprite( void );
		//_OĂяo֐
		virtual void	mCallRenderProc( void );
		
		//`
		static
		void	mRender( void );
		
		//vtxOvtxƓǂׂ
		bool	mCheckSameVtx( void );
		//tevOtevƓǂׂ
		bool	mCheckSameTev( void );
		
		//2DpJ
		static
		void	mSetCamera2D( void );
		
		//eNX`ƃCgƒ_̊ݒ
		static
		void	mSetCommonEnv( void );
		
		//XgNX̃|C^擾
		mK7Sprite* mGetPrev( void ){ return(mK7Sprite*)ghmGcListObj::GetPrev(); }
		mK7Sprite* mGetNext( void ){ return(mK7Sprite*)ghmGcListObj::GetNext(); }
		//XgD揇ʂ̐ݒ
		void	mSetPriority( int inPriority ){ ghmGcListObj::ChangePriority(inPriority); }
		int		mGetPriority( void ){ return(ghmGcListObj::GetPriority()); }
		
//	private:
	protected:
		
		//prim̎ސݒ
		void	mSetPrimKind( GXPrimitive inKind ){mKind=inKind;};
		//vtxݒ
		void	mSetVtx( enVtxKind inVtxKind );
		//tevݒ
		void	mSetTev( enTevKind inTevKind );
		//_Oݒ
		void	mSetRenderFunc( enRenderKind inRenderKind );
		
		//---- vtx ----
		//xyz.rgba8pvtx
		static
		void	mSetNoTexVtx( void );
		//xyz.rgba8.texpvtx
		static
		void	mSetTexVtx( void );
		
		//---- tev ----
		//tbg|Sptevݒ
		static
		void	mSetFlatTev( void );
		//spriteptevݒ
		static
		void	mSetSpriteTev( void );
		//spriteptevݒEeNX`͎̃gȂ
		static
		void	mSetSpriteTevNoTexAlpha( void );
		//Zptevݒ
		static
		void	mSetSpriteTevAddAlpha( void );
		//spriteptevݒ:HSXLpT[OtBp
		static
		void	mSetScanHSTev( void );
		
		//oϐ
		stTexture*		mTex;		//XvCggpeNX`\̂ւ̃|C^
		GXPrimitive		mKind;		//XvCg̃v~eBu̎
		s16				mW;			//XvCg
		s16				mH;			//XvCg
		s16				mU0;		//eNX`̒̃ItZbg:0
		s16				mV0;		//eNX`̒̃ItZbg:c0
		s16				mU1;		//eNX`̒̃ItZbg:1
		s16				mV1;		//eNX`̒̃ItZbg:c1
		s16				mU2;		//eNX`̒̃ItZbg:2
		s16				mV2;		//eNX`̒̃ItZbg:c2
		s16				mU3;		//eNX`̒̃ItZbg:3
		s16				mV3;		//eNX`̒̃ItZbg:c3
		f32				mX0;		//XvCg\Wx0
		f32				mY0;		//XvCg\py0
		f32				mX1;		//XvCg\Wx1
		f32				mY1;		//XvCg\py1
		f32				mX2;		//XvCg\Wx2
		f32				mY2;		//XvCg\py2
		f32				mX3;		//XvCg\Wx2
		f32				mY3;		//XvCg\py2
		u32				mRgba0;		//RGBA0
		u32				mRgba1;		//RGBA1
		u32				mRgba2;		//RGBA2
		u32				mRgba3;		//RGBA3
		bool			mFlag;		//ėptO
		s16				mOrgW;		//IWi̕:gkp
		s16				mOrgH;		//IWi̍:gkp
		f32				mOrgX0;		//IWiXW:gkp
		f32				mOrgY0;		//IWiYW:gkp
		
		stScale			mScaleW;	//XP[
		stScale			mScaleH;	//XP[
		stMove			mMove;		//ړ
		stMove			mMoveXY0;	//ړXY0EuEvuv̐Lkp
		stMove4Vtx		mMove4Vtx;	//ό``ړ
		stFade			mFade;		//tF[h
		stVibrate		mVib;		//U
		
		vtxFunc*		mVtxFunc;	//vtxݒ֐ւ̃|C^
		tevFunc*		mTevFunc;	//tevݒ֐ւ̃|C^
		renderFuncPtr	mRenderFunc;//_O֐ւ̃|C^
		
		//mK7Sprite*	mPrev;		//ÕXvCgւ̃|C^
		//mK7Sprite*	mNext;		//̃XvCgւ̃|C^
		//static	mK7Sprite*		mSprtTop;		//XvCgXg̐擪
		
		//static錾ϐ͎̂̃\[XȂǂɏȂ΂ȂȂ
		static	ghmGcListObj	mAnchor;		//Xg\̃NX
		static	stTexture*		mOldTex;		//ÕeNX`
		static	vtxFunc*		mOldVtxFunc;	//Ovtx֐
		static	tevFunc*		mOldTevFunc;	//Otev֐
};

#endif	//__MK7SPRITE_H__
