////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Cook2
//
// SK7PanelCook2.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELCOOK2_H__
#define	__SK7PANELCOOK2_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


#define		ANSWER_OWAN		(4)

#define		EFFECT_X		(239)
#define		EFFECT_Y		(30)
#define		EFFECT_SIZE		(300)

#define		MOVE_SPEED		(2.4f)
#define		MOVE_TIME		(20)

//	eNX`[pX
#define	PNL010700TEX_BG		"Texture/010700/ryouri_BG.BIN"
#define	PNL010700TEX_OWAN	"Texture/010700/owan.BIN"
#define	PNL010700TEX_EFFECT "Texture/010700/grow.BIN"
#define	PNL010700TEX_EFFECT2 "Texture/010700/grow2.BIN"


 
//---- class ----
class SK7PanelCook2 : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_FIRST_TIME,
		PROC_FIRST_NAME,
		PROC_MISS_NAME,
		PROC_TIME,
		PROC_MESSAGE,
		PROC_MESSAGE2,
		PROC_CANCEL,
	}eInputCodeProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG=0,
		LOAD_EFFECT,
		LOAD_EFFECT2,
		LOAD_OWAN,
	}eLoadTexProc;

protected:
	eInputCodeProc			m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spOwan;
	SK7Sprite				m_spEffect;				//	
	SK7Sprite				m_spEffect2;

	bool					m_bAnswer;
	bool					m_bFirst;
	u32						m_lMoveTime;
	u32						m_lTime;

public:
	SK7PanelCook2( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelCook2();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
	//	GtFNgړ
	bool	MoveEffect();
};

#endif	//__SK7PANELCOOK2_H__
