////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Darts
//
// SK7PanelDarts.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELDARTS_H__
#define	__SK7PANELDARTS_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l
#define	DARTS_CLEAR					(1)
#define	DARTS_MISS					(0)
#define	DARTS_CANCEL				(-1)


//	eNX`[pX
#define	PNL000401TEX_BG				"Texture/000401/darts2_BG.BIN"
#define	PNL000401TEX_NO				"Texture/000401/darts2_nmbr.BIN"


#define	CLEAR_POINT		(400)
#define	NO_NUM			(3)

//---- class ----
class SK7PanelDarts : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_TIME,
		PROC_CANCEL,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		
		LOAD_BG,
		LOAD_NO,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spNo[NO_NUM];					//	io[	

public:
	SK7PanelDarts( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelDarts();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELDARTS_H__
