////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Elevator2
//
// SK7PanelElevator2.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELELEVATOR2_H__
#define	__SK7PANELELEVATOR2_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"
#include "SK7PanelElevator.h"



//---- class ----
class SK7PanelElevator2 : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CLOSE,
		PROC_CHECK,
		PROC_CANCEL,
		PROC_TIME,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		
		LOAD_BG,
		LOAD_BUTTON,
		LOAD_LGT,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spButton;
	SK7Sprite				m_spLgt;
	
	s8						m_sSelect;
	int						m_iTime;
	
//	EFFECT*					m_ESight;

public:
	SK7PanelElevator2( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelElevator2();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELELEVATOR2_H__
