////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel MainBreaker
//
// SK7PanelMainBreaker.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELMAINBREAKER_H__
#define	__SK7PANELMAINBREAKER_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	Ԃƈ
#define	MAINBREAKER_ON				(0)		//	u[J[Ăi߁j
#define	MAINBREAKER_OFF				(1)		//	u[J[Ăivj


//	eNX`[pX
#define	PNL030409TEX_BG			"Texture/030409/EVENT_030409.BIN"
#define	PNL030409TEX_ON			"Texture/030409/E_030409_00.BIN"
#define	PNL030409TEX_OFF		"Texture/030409/E_030409_01.BIN"


//---- class ----
class SK7PanelMainBreaker : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_MESSAGE,
		PROC_CHECK,
		PROC_CANCEL,
	}eInputCodeProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_ON,
		LOAD_OFF,
	}eLoadTexProc;

protected:
	eInputCodeProc			m_Proc;
	eLoadTexProc			m_TexProc;
	s8						m_cSelect;
	int						m_iTime;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spSwitchOn;
	SK7Sprite				m_spSwitchOff;
	
	
public:
	SK7PanelMainBreaker( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelMainBreaker();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELMAINBREAKER_H__
