////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel SK7PanelStaff2
//
// SK7PanelStaff2.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELSTAFF2_H__
#define	__SK7PANELSTAFF2_H__

#include "SK7PanelBase.h"
#include "SK7Sprite.h"
#include "SK7Font.h"
#include "SK7PackData.h"
#include "../yam/YK7Effect.h"


enum{
	TEX_STAFF_01=0,
	TEX_STAFF_02,
	TEX_STAFF_03,
	TEX_STAFF_04,
	TEX_STAFF_05,
	TEX_STAFF_06,
	TEX_STAFF_07,
	TEX_STAFF_08,
	TEX_STAFF_09,
	TEX_STAFF_11,
	TEX_STAFF_12,
	TEX_STAFF_13,
	TEX_STAFF_14,
	
	TEX_STAFF_MAX,
};



//---- class ----
class SK7PanelStaff2 : public SK7PanelBase
{
	typedef enum{
		eLoad=0,
		eTime,
		eMain,
		eFade,
		eTime2,
		eTime3,
		eShanhaiStart,
		eShanhai,
		eEnd,
	}eProc;
	
protected:
	SK7Sprite			m_spName;
	SK7Sprite			m_spBlack;
	SK7Sprite			m_spFade;
	SK7File				m_File;
	SK7PackData*		m_pPack;
	TEX_DATA			m_Texture[TEX_STAFF_MAX];
	TEX_DATA			m_ShanhaiTex;
	u32					m_lSpeed;
	int					m_iDrawTime;
	eProc				m_eProc;
	int					m_iBlock;
	int					m_iTime;
	int					m_iLoad;
	bool				m_bRenderNotFlag;

	bool				Move();

public:
	SK7PanelStaff2( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelStaff2();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	Load();	
};

#endif	//__SK7PANELSTAFF2_H__
