////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Toilet
//
// SK7PanelToilet.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/01/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELTOILET_H__
#define	__SK7PANELTOILET_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	Noẃ@l	---------------------------------------
#define		NOT_MOVE			(-1)		//	Ђ˂ĂȂB
#define		NOT_WATER			(0)			//	Ȃ
#define		IN_WATER			(1)			//	

//	Ԃl	-------------------------------------------
#define		NOBU_X				(64)
#define		NOBU_Y				(128)

//	eNX`[pX
#define	PNL000603TEX_BG			"Texture/000603/toilet.BIN"
#define	PNL000603TEX_NOBU		"Texture/000603/toilet_flow.BIN"


//---- class ----
class SK7PanelToilet : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_FIRST_MESSAGE,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_CHECK,
		PROC_MOVE_NOBU,
		PROC_SOUND_CHECK,
		PROC_MESSAGE_CHECK,
		PROC_MESSAGE,
		PROC_MESSAGE2,
		PROC_TIME,
	}eInputCodeProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		
		LOAD_BG,
		LOAD_NOBU,
	}eLoadTexProc;

protected:
	eInputCodeProc			m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spNobu;				//	mu
	
	f32						m_fAngle;
	bool					m_bNobuFlag;
	int						m_iTime;

public:
	SK7PanelToilet( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelToilet();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
	//	gCf[^	
//	bool	MoveNobu();
};

#endif	//__SK7PANELTOILET_H__
