////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Kouro
//
// mK7PanelKouro.h
// F
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 09/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7PANELKOURO_H__
#define	__MK7PANELKOURO_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"
#include "../matsu/mK7Sprite.h"

//---- enum ----
typedef	enum{
	ePanelKouroReadTexSmoke,
	ePanelKouroReadTexKouro,
	ePanelKouroReadTexOkou0,
	ePanelKouroReadTexOkou1,
	ePanelKouroReadTexOkou2,
	ePanelKouroSelectOkou0,
	ePanelKouroSelectOkou1,
	ePanelKouroSelectOkou2,
	ePanelKouroLastCheck,
	ePanelKouroSmokeFadeIn,
	ePanelKouroSmokeFadeOut,
	ePanelKouroSmokeMessage,
	ePanelKouroDecide,
	ePanelKouroCancel,
	ePanelKouroStatsuMax,
}ePanelKouroProc;



//---- class ----
class mK7PanelKouro : public SK7PanelBase
{
protected:
	ePanelKouroProc	mProc;
	
	SK7Sprite		mSpSmoke;		//
	SK7Sprite		mSpKouro;		//F
	SK7Sprite		mSpOkou0;		//0
	SK7Sprite		mSpOkou1;		//1
	SK7Sprite		mSpOkou2;		//2
	mK7Sprite*		mSmkSprt;		//XvCg
	
	s32				mSmokeHeight;	//XvCg̍
	s32				mKouroNo;		//Fԍ(eNX`ʗp/𔻕ʗp)
	s32				mSelectFlag;	//Iʒl
	s32				mXIndex;		//We[uւindex
	bool			mLastCheck;		//Ō̊mFtO
	s32				mInitSelectFlag;//ItO
	
//	EFFECT*			mEfSight;		//TCgGtFNg
	u32				mKeyTime;		//key
	
public:
	mK7PanelKouro( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~mK7PanelKouro();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );
	
	// 싖ݒ֐
	virtual void mSetCtrlFlag( bool inBool );

	// _Oݒ֐
	virtual void mSetRender( bool inBool );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// ̃tF[hݒ
	void	mSetSmokeFade( s32 inType, s32 inSelect );
	
	// XWݒ
	void	mSetSmokeX0( void );
};

#endif	//__MK7PANELKOURO_H__
