////////////////////////////////////////////////////////////////////////////////
//
// Killer7 PlayEf0008  : LGtFNg0008
//
// WK7PlayEf0008.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7PLAYEF0008_CPP__

#include ".\K7PlayEf0008.h"
#include ".\K7PlayEfHSScan.h"

K7PlayEf0008Instance::K7PlayEf0008Instance(WK7PlayEffect *pContainerBase,ghmGcListObj *pAnchor,WK7JObj *pJObj) : WK7PlayEffectInstance(pContainerBase,pAnchor,pJObj)
{
	K7PlayEf0008		*pContainer = (K7PlayEf0008 *)pContainerBase;
	int					i;
	f32					alpha[2][2];
	
	alpha[0][0] = 1.0f;
	alpha[0][1] = 0.0f;
	alpha[1][0] = 0.0f;
	alpha[1][1] = K7PLAYEFFECT_HSNONSCAN_ALPHA;
	
	for(i=0 ; i<2 ; i++){
		if( (mpJObj[i] = pContainer->mpJObj[i])!=NULL ){
			mpJObj[i]->Disp(false,true);
			mpJObj[i]->CreateAlphaControl(alpha[i][0],false);
			mpJObj[i]->SetAlpha(alpha[i][1],4800);
		}
	}
}

K7PlayEf0008Instance::~K7PlayEf0008Instance()
{
	if( mpJObj[0]!=NULL ){
		mpJObj[0]->Hide(false,true);
	}
}

bool K7PlayEf0008Instance::FrameProcess(bool stopReq)
{
	if( stopReq==true ){
		return false;
	}
	int		i;
	bool	result = false;
	for(i=0 ; i<2 ; i++){
		if( mpJObj[i]==NULL ){
			continue;
		}
		if( mpJObj[i]->IsAnimatingAlpha()==true ){
			result = true;
		}else{
			if( i==0 ){
				mpJObj[i]->Hide(false,true);
			}
		}
	}
	return result;
}

K7PlayEf0008::K7PlayEf0008(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj) : WK7PlayEffect(pPlay,pAnchor,pJObj)
{
	WK7PlayEffectInfo	*pEffectInfo = GetEffectInfo();
	WK7Model			*pModel;
	mpJObj[0] = 
	mpJObj[1] = NULL;
	if( pEffectInfo==NULL ){
		return;
	}
	if( (pModel = pEffectInfo->mpModel)!=NULL ){
		if( (mpJObj[0] = pModel->GetObj("KDA_N_Root"))!=NULL ){
			mpJObj[0]->Disp(false,true);
		}
		if( (mpJObj[1] = pModel->GetObj("E02_Root"))!=NULL ){
			WK7JObj		*pJObj;
			if( (pJObj=mpJObj[1]->GetObj("Head_Parts"))!=NULL ){
				pJObj->SetZSortPrio(pJObj->GetZSortPrio() - 16,false,true);
			}
			mpJObj[1]->Hide(false,true);
			mpJObj[1]->SetDstAlpha(WK7RenderObj::ConvRenderIDToAlpha(WK7RENDEROBJ_RENDERID_HALF+1),false,true);
		}
	}
}

WK7PlayEffectInstance* K7PlayEf0008::CreateInstance(WK7JObj *pJObj)
{
	return new K7PlayEf0008Instance(this,&mInstanceAnchor,pJObj);
}

