////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Blood class
//
// SK7Blood.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7BLOOD_H__
#define	__SK7BLODD_H__

#define __BLOOD_DEBUG__		(0)

//#include ""../wat/WK7Model.h""
#include "../yam/YK7EffectHSDead.h"
#include "SK7Sprite.h"
#include "SK7ScenarioData.h"

//	̃TCY
#define		SK7BLOOD_SIZE		(80)

//	ړt[
#define		MOJI_FRAME			(2)
#define		MOJI_STOP_TIME		(80)
#define		BLOOD_NUM			(2000)//(8001)

#ifdef	__SK7BLOOD_CPP__
//	f[^̍Ŵ	-----------------------------------
const Vec	tblKanjiGap[]=
{
	1.9f,		0.3f,		34.787f,
	1.3f,		-0.4f,		40.77f,
	0.1125f, 	-2.7f,		42.7f,
	-1.574998f, -2.4f,		42.4f,
	0.0f,		0.0f,		40.125f,
	0.0f,		0.0f,		40.125f,
};
#endif

//	xNg
#define	VECTOR_ADD(V1,V2)\
	{\
		V1.x += V2.x;\
		V1.y += V2.y;\
		V1.z += V2.z;\
	}
	
//	NX
class SK7Blood
{
protected:
	Vec*			m_pvBloodPos;			// ̍W
	Vec*			m_pvMojiPos[SCENARIO_MAX_NUM];			//	̃|WV
	int				m_iMojiNum[SCENARIO_MAX_NUM];			//	̃p[eBN
	
	SK7File			m_File;				//	t@C
	BLOODINFO*		m_pBloodInfo;		//	̃f[^
	BLOODINFO*		m_pBloodInfo2;	
	int				m_iBloodNum;		//	̐
	int				m_iBloodNum2;
	bool			m_bBloodParam;

	bool			m_b2DBloodDrawFlag;
	VEC2U16*		m_pFontVector[SCENARIO_MAX_NUM];
	s32				m_sFontPosNum[SCENARIO_MAX_NUM];
	
	u16				m_sTexProc;
	u8				m_uMojiNo;
	
	int				m_iBloodTime;
		
	TEX_DATA*		m_TexData;			//	eNX`f[^

public:
	SK7Blood();
	~SK7Blood();

	//	f[^쐬
	bool			ReadKanjiData2( int no, void* pData );
	//	̍쐬	-------------------------------
	void			CreateBloodObject( WK7Model* pModel,WK7Model* pModel2, u16 Num, f32 Power );
	//	f[^폜
	void			Delete();
	//	̕`
	void			DrawBlood();
	void			DrawBlood2D(int No);
	//	̈ړ
	bool			MoveBlood(int sNo);
	bool			MoveRedBlood(int sNo);
	//	ړWZbg
	void			SetMojiPoint(int sNo);
	//	eNX`[h
	void			LoadTexture2( TEX_DATA* pData ){ m_TexData = pData; }
	void			SetBloodParam(bool state){ m_bBloodParam = state; }
};

#endif	//__SK7BLOOD_H__

