////////////////////////////////////////////////////////////////////////////////
//
// Killer7 ItemData
//
// SK7ItemData.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/29/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7ITEMDATA_H__
#define	__SK7ITEMDATA_H__


//	ACe
typedef struct 
{
	f32	x,y,z,rot;
}ITEM_PARAM;

#ifdef	__SK7ITEM_CPP__

char* tblItemModel[]={
	"/3DData/Model/Chara/Dan/Dan_M00.dat",
	"/3DData/Model/Chara/Gal/Gal_M00.dat",
	"/3DData/Model/Chara/Cat/Cat_M00.dat",
	"/3DData/Model/Chara/Hac/HAC_M00.dat",
	"/3DData/Model/Chara/Gal/Gal_M00.dat",
	"/3DData/Model/Chara/Gal/Gal_M00.dat",
	"/3DData/Model/Chara/Cyo/CYO_M00.dat",
	"/3DData/Model/Chara/KED/KED_M00.dat",
	"/3DData/Model/Chara/Kvn/Kvn_M00.dat",
	"/3DData/Model/Chara/Msk/MSK_M00.dat",
};


//	[VXg
char* tblMotionName[]=
{
	"/3DData/Motion/Chara/Dan/DAN_0020.dat",//	_
	"/3DData/Motion/Chara/Gal/Gal_0020.dat",//	KV[
	"/3DData/Motion/Chara/Cat/Cat_0020.dat",//	R
	"/3DData/Motion/Chara/Hac/HAC_0020.dat",//	Ԉ֎qn[}
	"/3DData/Motion/Chara/Gal/Gal_0020.dat",//	KV[
	"/3DData/Motion/Chara/Hay/HAY_0020.dat",//	On[}
	"/3DData/Motion/Chara/Cyo/CYO_0020.dat",//	R[e
	"/3DData/Motion/Chara/KED/KED_0020.dat",//	
	"/3DData/Motion/Chara/KVN/Kvn_0020.dat",//	PB
	"/3DData/Motion/Chara/Msk/MSK_0020.dat",//	}XN
};

//	ẽfe[u
char*	tblGunModelFile[]=
{
	//	EA	A
	"/Yam/Effect/MuzzleFlash/GunModel/ColtPytR_M00.dat",	NULL,//	_
	"/Yam/Effect/MuzzleFlash/GunModel/WthrPP2R_M00.dat",	NULL,//	KVA
	"/Yam/Effect/MuzzleFlash/GunModel/Glock26R_M00.dat",	"/Yam/Effect/MuzzleFlash/GunModel/Glock26L_M00.dat",	//	R
	NULL,													NULL,//	Ԉ֎qn[}
	NULL,													NULL,//	_~[
	NULL,													NULL,//	_~[
	"/Yam/Effect/MuzzleFlash/GunModel/EnfieldR_M00.dat",	NULL,//	R[e
	"/Yam/Effect/MuzzleFlash/GunModel/ColtGStR_M00.dat",	NULL,//	
	"/Yam/Effect/MuzzleFlash/GunModel/ThKnifeR_M00.dat",	"/Yam/Effect/MuzzleFlash/GunModel/HkKnifeL_M00.dat",//	PB
	"/Yam/Effect/MuzzleFlash/GunModel/M79GLncR_M00.dat",	"/Yam/Effect/MuzzleFlash/GunModel/M79GLncL_M00.dat",//	}XN
};

//	e[u
const ITEM_PARAM	 tblItemModelPositon[]=
{
	//	wC	xC		yA		]
	16.30000f,-14.79900f,39.03749f,-0.3200000f,//	_
	16.30000f,-14.79900f,39.03749f,-0.2738715f,//	邵[
	16.30000f,-14.79900f,39.03749f,-1.602739f, //	R
	16.30000f,-14.79900f,39.03749f,-0.1281875f,//	Ԃn[}
	16.30000f,-14.79900f,39.03749f,-0.3200000f,//	_~[
	16.30000f,-14.79900f,39.03749f,-0.3200000f,//	R[e
	16.30000f,-14.79900f,39.03749f,-0.3200000f,//	
	16.30000f,-14.79900f,39.03749f,-0.5406842f,//	PB
	16.30000f,-14.79900f,39.03749f,-0.3200000f,//	}XN
	16.30000f,-14.79900f,39.03749f,-0.3200000f,//	}XN
};

#else

extern	char* tblItemModel[];
extern	char* tblMotionName[];
extern	char* tblGunModelFile[];
extern	const ITEM_PARAM	 tblItemModelPositon[];

#endif

#endif	//__SK7ITEMDATA_H__

