////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// SK7PanelBase.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/22/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELBASE_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelBase.h"
#include "..\Yam\YK7EffectEasyAnim.h"
#include "..\Yam\YK7EffectVital.h"
#include "..\Yam\YK7EffectMessage2.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/WK7Cam.h"
#include "../fujita/c_font.h"
#include "../matsu/mK7Sound.h"
#include "../Wat/WK7Event.h"
#include "../Yam/YK7EffectEasyAnim.h"
#include "../Yam/YK7EffectVital.h"
#include "../Yam/YK7EffectMessage2.h"

//#include "SK7PanelComming.h"

//#include "../panel/mK7PanelSwitch00.h"
#include "mK7PanelSwitch01.h"
//#include "mK7PanelSwitch02.h"
#include "mK7PanelSwitch03.h"
//#include "mK7PanelSwitch04.h"
//#include "mK7PanelSwitch05.h"
//#include "mK7PanelKouro.h"

//#include "SK7PanelLaundry.h"
#include "SK7PanelInputCode.h"
#include "SK7PanelNiou.h"
//#include "SK7PanelManageKey.h"
//#include "SK7PanelDarts.h"
//#include "SK7PanelCook.h"
//#include "SK7PanelCook2.h"
#include "SK7PanelToilet.h"

#include "SK7PanelKeiba.h"
//#include "SK7PanelLocker.h"
//#include "SK7PanelElevator.h"
//#include "SK7PanelElevator2.h"
//#include "SK7PanelManageKey2.h"
#include "SK7PanelChinChiro.h"
#include "SK7PanelCards.h"
//#include "SK7PanelRoulette.h"
#include "SK7PanelIno.h"

#include "SK7PanelPoster.h"
//#include "SK7PanelMailbox.h"
#include "SK7panelGacha.h"
#include "SK7PanelPsychoTest.h"
#include "SK7PanelGum.h"
//#include "SK7PanelPopcorn.h"
#include "SK7PanelBreaker.h"
#include "SK7PanelMainBreaker.h"
#include "SK7PanelSofa.h"
//#include "SK7PanelVisitor.h"

#include "SK7PanelNine.h"
#include "SK7PanelSecom.h"
#include "SK7PanelCock.h"
//#include "SK7PanelValve.h"
#include "SK7PanelBook.h"
#include "SK7PanelCandle.h"
#include "SK7PanelLock.h"
#include "SK7PanelKouro.h"
#include "SK7PanelKakejiku.h"
#include "SK7PanelInputCode6.h"
#include "SK7PanelDonCho.h"

SK7PanelCreateFunc*	SK7PanelBase::m_pPanelCreateFunc = NULL;

#ifdef	_DEBUG
static SK7PanelDebugMenuTable		debugMenuTable[] = {
	{ ePanel000101 , "000101" },
	{ ePanel000102 , "000102" },
	{ ePanel000104 , "000104" },
	{ ePanel000201 , "000201" },
	{ ePanel000304 , "000304" },
	{ ePanel000401 , "000401" },
	{ ePanel000501 , "000501" },
	{ ePanel000502 , "000502" },
	{ ePanel000603 , "000603" },
	{ ePanel000606 , "000606" },
	{ ePanel007201 , "007201" },
	{ ePanel007301 , "007301" },
	{ ePanel007307 , "007307" },
	{ ePanel010600 , "010600" },
	{ ePanel010700 , "010700" },
	{ ePanel010701 , "010701" },
	{ ePanel010401 , "010401" },
	{ ePanel010402 , "010402" },
	{ ePanel010403 , "010403" },
	{ ePanel011201 , "011201" },
	{ ePanel011301 , "011301" },
	{ ePanel011304 , "011304" },
	{ ePanel011305 , "011305" },
	{ ePanel011308 , "011308" },
	{ ePanel011309 , "011309" },
	{ ePanel011402 , "011402" },
	{ ePanel011403 , "011403" },
	{ ePanel011404 , "011404" },
	{ ePanel011406 , "011406" },
	{ ePanel011502 , "011502" },
	{ ePanel011503 , "011503" },
	{ ePanel011506 , "011506" },
	{ ePanel011602 , "011602" },
	{ ePanel011603 , "011603" },
	{ ePanel011604 , "011604" },
	{ ePanel011606 , "011606" },
	{ ePanel011607 , "011607" },
	{ ePanel011608 , "011608" },
	{ ePanel020101 , "020101" },
	{ ePanel020103 , "020103" },
	{ ePanel020105 , "020105" },
	{ ePanel020107 , "020107" },
	{ ePanel020108 , "020108" },
	{ ePanel020109 , "020109" },
	{ ePanel020110 , "020110" },
	{ ePanel020111 , "020111" },
	{ ePanel020112 , "020112" },
	{ ePanel020113 , "020113" },
	{ ePanel020114 , "020114" },
	{ ePanel020115 , "020115" },
	{ ePanel020116 , "020116" },
	{ ePanel020117 , "020117" },
	{ ePanel020118 , "020118" },
	{ ePanel020119 , "020119" },
	{ ePanel020120 , "020120" },
	{ ePanel020121 , "020121" },
	{ ePanel020122 , "020122" },
	{ ePanel020123 , "020123" },
	{ ePanel020124 , "020124" },
	{ ePanel020125 , "020125" },
	{ ePanel030101 , "030101" },
	{ ePanel030102 , "030102" },
	{ ePanel030103 , "030103" },
	{ ePanel030104 , "030104" },
	{ ePanel030105 , "030105" },
	{ ePanel030106 , "030106" },
	{ ePanel030201 , "030201" },
	{ ePanel030202 , "030202" },
	{ ePanel030203 , "030203" },
	{ ePanel030204 , "030204" },
	{ ePanel030205 , "030205" },
	{ ePanel030206 , "030206" },
	{ ePanel030301 , "030301" },
	{ ePanel030401 , "030401" },
	{ ePanel030402 , "030402" },
	{ ePanel030403 , "030403" },
	{ ePanel030404 , "030404" },
	{ ePanel030409 , "030409" },
	{ ePanel030414 , "030414" },
	{ ePanel030901 , "030901" },

	{ eRakum000101 , "0000101" },
	{ eRakum000102 , "0000102" },
	{ eRakum000103 , "0000103" },
	{ eRakum000501 , "0000501" },
	{ eRakum000502 , "0000502" },
	{ eRakum030301 , "0030301" },
	
	{ eRakum010001 , "0010001" },
	{ eRakum010002 , "0010002" },
	{ eRakum010003 , "0010003" },
	
	{ eRakum011201 , "0011201" },
	{ eRakum011301 , "0011301" },
	{ eRakum011501 , "0011501" },

	{ ePanelIDMax  , NULL     },
};

const SK7PanelDebugMenuTable* SK7PanelBase::GetDebugMenuTable(ePanelID id)
{
	SK7PanelDebugMenuTable		*pTable;
	for(pTable=debugMenuTable ; pTable->m_eID!=ePanelIDMax ; pTable++){
		if( pTable->m_eID==id ){
			return pTable;
		}
	}
	return NULL;
}
#endif


//	fobNptHg
bool	SK7PanelBase::PanelDebugFont( s32* Answer, s8 min, s8 max, bool move )
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_A )
	{
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_B )
	{
		return true;
	}
	if( move )
	{
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_UP ){
			if( --(*Answer) <= min ){
				(*Answer) = min;
			}
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_DOWN ){
			if( ++(*Answer) >= max ){
				(*Answer) = max;
			}
		}
	}
	C_Paper paper( 200, 150, 2, true, 300, 300 );
	PRINTF("%d", (int)(*Answer) );
	
	return false;
}

//	pl̃Cxgԍ
static u32 PanelEventNo=0;

//========================================================================
//					RXgN^
//========================================================================
SK7PanelBase::SK7PanelBase( s32 Now, s32 Now2, bool CursolFlag, bool SoundFlag )
{
	m_sNowAnswer		= Now;			//	݂̓
	m_sNow2Answer		= Now2;
	m_EffectID			= 0;
	m_CheckID			= 0;
	m_MessageID			= 0;
	m_sLastWait     	= PANEL_LAST_WAIT;
	m_bRender    		= false;
	m_bCtrl      		= false;
	m_bDirDrawFlag		= true;
	m_Proc				= ePanelBaseMove;
	m_MecProc			= eMesLoad;
	m_cCheckJmbHandle	= 0;
	for( int i = 0; i < 4; i++ )	m_bSaveDir[i] = false;

	//	bZ[Wf[^쐬	===========================================
	char str[255];
	u32 No = ((u32)PanelEventNo>>28);
	u32 ENo = (u32)PanelEventNo - (No<<28);
	
	//	plCxg
	if( No == 0 ){
		sprintf( str, "Message/panel/0%d/P%06x.jmb", GameInfo.GetScenarioID(), ENo );
	}else{	//	Cxg
		sprintf( str, "Message/panel/0%d/R%06x.jmb", GameInfo.GetScenarioID(), ENo );
	}
	
	m_cCheckJmbHandle	= LoadMessagePack( str );

	m_pEffectCheck		= NULL;
	m_pEffectCursol		= NULL;
	m_pEffectMessage	= NULL;
	
	if( CursolFlag ){
		m_pEffectCursol     = CreatePanelCursorEffect( -100, -100 );
		m_EffectID = GetEffectID( m_pEffectCursol );	
		RunPanelCursorOkCancelSelect( m_pEffectCursol );
		SetCursolDisp( false );
		SetCursolSize( 64, 64 );
	}
	
	//	pbN֘A	-----------------------------------------------------
	m_pTexture		= NULL;
	m_pResLink	 	= NULL;
	m_pPackData		= NULL;
	m_pYFont		= NULL;
	m_pSentence		= NULL;
	m_pSentence2	= NULL;
//	gpSound->mSetPauseStream();
	if( !SoundFlag ){
		gpSound->mRequestMuteStream();
	}
	PanelScreenEffectStop();
}

//========================================================================
//					fXgN^
//========================================================================
SK7PanelBase:: ~SK7PanelBase()
{
	GHM_SAFE_DELETE(m_pResLink);
	GHM_SAFE_DELETE(m_pYFont);
	GHM_SAFE_DELETE_ARRAY	( m_pTexture );
	if( m_pEffectCursol != NULL && CheckEffectValidState(m_pEffectCursol, m_EffectID) == TRUE )	::DelReqEffect( m_pEffectCursol );
	ReleaseMessagePack(m_cCheckJmbHandle);
	SetEasyAnimAllDrawFlag( true );
	SetVitalAllDrawFlag(true);
	
//	gpSound->mReleasePauseStream();
	gpSound->mReleaseMuteStream();
	
	PanelScreenEffectRestart();
//	PanelScreenEffectStopRelease();
}

//========================================================================
//					pbN[h
//========================================================================
bool		SK7PanelBase::LoadPackData( char* Data, u8 TexNum, u8 font, u8 fontnum )
{
	int i;
	if( m_File.OpenDataFile( Data, &m_pPackData ) ){
		ghmGcMemSetAllocName("PANELTEX");
		m_pTexture = new TEX_DATA[TexNum];		
		ghmGcMemSetAllocName("PANELPACK");
		if( (m_pResLink = new((ghmGcResLink *)m_pPackData) ghmGcResLink)==NULL ){
			return false;
		}
		ghmGcMemSetAllocName("SK7YAMFON");
		switch( font ){
		case PANEL_FONT_NONE:
			fontnum = 0;
			break;
		case PANEL_FONT_YAMADA:
			m_pYFont = new YK7StrImage;
			m_pYFont->LoadMem( (void*)m_pResLink->GetResource(0) );
			fontnum = 1;
			break;
		case PANEL_FONT_MATSU:						
			m_pSentence = (stSentence*)m_pResLink->GetResource(0);
			if( fontnum == 2 )	m_pSentence2 = (stSentence*)m_pResLink->GetResource(1);
			break;
		}
		int no = 0;
		if( font != PANEL_FONT_NONE )	no = fontnum;
		//	eNX`[pbN		---------------------------------------
		for( i = 0; i < TexNum; i++ ){
			if( (m_pTexture[i].Header = (GhmGcTexHeader*)m_pResLink->GetResource(i+no))==NULL ){
				return false;
			}
			InitTexture( &m_pTexture[i] );
		}
		return true;
	}
	return false;
}

//========================================================================
//					II`FbN֐
//========================================================================
s8			SK7PanelBase::CheckAnswer( s16 No, bool Cursol, bool cancel )
{
	if( m_pEffectCursol == NULL || CheckEffectValidState(m_pEffectCursol, m_EffectID) == FALSE )	return PANEL_CHECK_SET;
	
	int i=0;

	switch( m_Proc )
	{
	case	ePanelBaseMove:
		if( No != -1 ){
			m_pEffectCheck = CreateMessage2Effect(m_cCheckJmbHandle, (u8)No, TRUE );
			m_CheckID = GetEffectID( m_pEffectCheck );
		}
		for( i = 0; i < 4; i++ ){
			if( GetPanelCursorDirDrawFlag( m_pEffectCursol, i ) == TRUE ){
				m_bSaveDir[i] = true;
			}else{
				m_bSaveDir[i] = false;
			}
		}
		m_bDirDrawFlag = false;
		SetCursolDir(0,0);
		m_Proc = ePanelBaseCheck;
		break;
		
	case 	ePanelBaseCheck:
		if( m_pEffectCheck != NULL ){
			if( GetStopStateMessage2Effect( m_pEffectCheck ) == TRUE ){
				SetPanelCursorOkCancelSelectButton( m_pEffectCursol, CUR_COMP ); 
				m_Proc = ePanelBaseMoveEnd;			
			}
		}else{
			SetPanelCursorOkCancelSelectButton( m_pEffectCursol, CUR_COMP ); 
			m_Proc = ePanelBaseMoveEnd;
		}
		break;
		
	case	ePanelBaseMoveEnd: 
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
//			gpSound->mPlaySE( SFX_SYS_PNL_OK );
			if( m_pEffectCheck != NULL )	StopReleaseMessage2Effect( m_pEffectCheck );
			SetCursolDisp( true );
			SetPanelCursorOkCancelSelectButton( m_pEffectCursol, CUR_EXE ); 
			m_Proc = ePanelBaseSet;
			break;
		}
		
		if( cancel ){
			if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
				gpSound->mPlaySE( SFX_SYS_PNL_CANCEL );
				if( m_pEffectCheck != NULL )	StopReleaseMessage2Effect( m_pEffectCheck );
				SetPanelCursorOkCancelSelectButton( m_pEffectCursol, CUR_DECIP ); 
				SetCursolDisp( true );
				m_bDirDrawFlag = true;
				m_Proc = ePanelBaseReturn;
				break;
			}
		}
		break;
		
	case	ePanelBaseReturn:
		if( !CheckEffectValidState( m_pEffectCheck, m_CheckID )){
			for( i = 0; i < 4; i++ ){
				if( m_bSaveDir[i] ){
					SetPanelCursorDirDrawFlag( m_pEffectCursol, i, 	TRUE );
				}
			}
			m_Proc = ePanelBaseMove;
			return PANEL_CHECK_RETURN;
		}
		break;
		
	case	ePanelBaseSet:
		if( !CheckEffectValidState( m_pEffectCheck, m_CheckID )){
			m_Proc = ePanelBaseMove;
			if( !Cursol )	DeleteCursolMessage();
			else			SetPanelCursorOkCancelSelectButton( m_pEffectCursol, CUR_DECIP ); 
			return PANEL_CHECK_SET;
		}
		break;
	}		
	return PANEL_CHECK_WORKING;
}

//========================================================================
//					pl
//========================================================================
SK7PanelBase* SK7PanelBase::Create(ePanelID id,s32 now,s32 now2)
{
	u32		evno;
	switch( id ){
	case	ePanel000101: evno = K7EVENTNO(000101); break;
	case	ePanel000102: evno = K7EVENTNO(000102); break;
	case	ePanel000104: evno = K7EVENTNO(000104); break;
	case	ePanel000201: evno = K7EVENTNO(000201); break;
	case	ePanel000304: evno = K7EVENTNO(000304); break;
	case	ePanel000401: evno = K7EVENTNO(000401); break;
	case	ePanel000501: evno = K7EVENTNO(000501); break;
	case	ePanel000502: evno = K7EVENTNO(000502); break;
	case	ePanel000603: evno = K7EVENTNO(000603); break;
	case	ePanel000606: evno = K7EVENTNO(000606); break;
	case 	ePanel007301: evno = K7EVENTNO(007301);	break;
	case 	ePanel007307: evno = K7EVENTNO(007307);	break;
	case 	ePanel010600: evno = K7EVENTNO(010600); break;
	case	ePanel010700: evno = K7EVENTNO(010700); break;
	case	ePanel010701: evno = K7EVENTNO(010701); break;
	case	ePanel010401: evno = K7EVENTNO(010401); break;
	case	ePanel010402: evno = K7EVENTNO(010402); break;
	case	ePanel010403: evno = K7EVENTNO(010403); break;
	case	ePanel011201: evno = K7EVENTNO(011201); break;
	case	ePanel011301: evno = K7EVENTNO(011301); break;
	case	ePanel011304: evno = K7EVENTNO(011304); break;
	case 	ePanel011305: evno = K7EVENTNO(011305); break;
	case	ePanel011308: evno = K7EVENTNO(011308); break;
	case	ePanel011309: evno = K7EVENTNO(011309); break;
	case	ePanel011310: evno = K7EVENTNO(011310); break;
	case	ePanel011402: evno = K7EVENTNO(011402); break;
	case	ePanel011403: evno = K7EVENTNO(011403); break;
	case	ePanel011404: evno = K7EVENTNO(011404); break;
	case	ePanel011406: evno = K7EVENTNO(011406); break;
	case	ePanel011502: evno = K7EVENTNO(011502); break;
	case	ePanel011503: evno = K7EVENTNO(011503); break;
	case	ePanel011506: evno = K7EVENTNO(011506); break;
	case	ePanel011602: evno = K7EVENTNO(011602); break;
	case	ePanel011603: evno = K7EVENTNO(011603); break;
	case	ePanel011604: evno = K7EVENTNO(011604); break;
	case	ePanel011606: evno = K7EVENTNO(011606); break;
	case	ePanel011607: evno = K7EVENTNO(011607); break;
	case	ePanel011608: evno = K7EVENTNO(011608); break;
	case	ePanel020101: evno = K7EVENTNO(020101); break;
	case	ePanel020103: evno = K7EVENTNO(020103); break;
	case	ePanel020105: evno = K7EVENTNO(020105); break;
	case	ePanel020107: evno = K7EVENTNO(020107); break;
	case	ePanel020108: evno = K7EVENTNO(020108); break;
	case	ePanel020109: evno = K7EVENTNO(020109); break;
	case	ePanel020110: evno = K7EVENTNO(020110); break;
	case	ePanel020111: evno = K7EVENTNO(020111); break;
	case	ePanel020112: evno = K7EVENTNO(020112); break;
	case	ePanel020113: evno = K7EVENTNO(020113); break;
	case	ePanel020114: evno = K7EVENTNO(020114); break;
	case	ePanel020115: evno = K7EVENTNO(020115); break;
	case	ePanel020116: evno = K7EVENTNO(020116); break;
	case	ePanel020117: evno = K7EVENTNO(020117); break;
	case	ePanel020118: evno = K7EVENTNO(020118); break;
	case	ePanel020119: evno = K7EVENTNO(020119); break;
	case	ePanel020120: evno = K7EVENTNO(020120); break;
	case	ePanel020121: evno = K7EVENTNO(020121); break;
	case	ePanel020122: evno = K7EVENTNO(020122); break;
	case	ePanel020123: evno = K7EVENTNO(020123); break;
	case	ePanel020124: evno = K7EVENTNO(020124); break;
	case	ePanel020125: evno = K7EVENTNO(020125); break;
	case	ePanel030101: evno = K7EVENTNO(030101); break;
	case	ePanel030102: evno = K7EVENTNO(030102); break;
	case	ePanel030103: evno = K7EVENTNO(030103); break;
	case	ePanel030104: evno = K7EVENTNO(030104); break;
	case	ePanel030105: evno = K7EVENTNO(030105); break;
	case	ePanel030106: evno = K7EVENTNO(030106); break;
	case	ePanel030201: evno = K7EVENTNO(030201); break;
	case	ePanel030202: evno = K7EVENTNO(030202); break;
	case	ePanel030203: evno = K7EVENTNO(030203); break;
	case	ePanel030204: evno = K7EVENTNO(030204); break;
	case	ePanel030205: evno = K7EVENTNO(030205); break;
	case	ePanel030206: evno = K7EVENTNO(030206); break;
	case	ePanel030301: evno = K7EVENTNO(030301); break;
	case	ePanel030401: evno = K7EVENTNO(030401); break;
	case	ePanel030402: evno = K7EVENTNO(030402); break;
	case	ePanel030403: evno = K7EVENTNO(030403); break;
	case	ePanel030404: evno = K7EVENTNO(030404); break;
	case	ePanel030409: evno = K7EVENTNO(030409); break;
	case	ePanel030414: evno = K7EVENTNO(030414); break;
		
//	case	ePanel030515: evno = K7EVENTNO(030515); break;
//	case	ePanel030516: evno = K7EVENTNO(030516); break;
//	case	ePanel030517: evno = K7EVENTNO(030517); break;
//	case	ePanel030518: evno = K7EVENTNO(030518); break;
//	case	ePanel030519: evno = K7EVENTNO(030519); break;
//	case  	ePanel030520: evno = K7EVENTNO(030520); break;
	case	ePanel030901: evno = K7EVENTNO(030901); break;


	//		------------------------------------------------------
	case	eRakum000101: evno = K7EVENTRAKU(000101); break;
	case	eRakum000102: evno = K7EVENTRAKU(000102); break;
	case	eRakum000103: evno = K7EVENTRAKU(000103); break;
	case	eRakum000501: evno = K7EVENTRAKU(000501); break;
	case	eRakum000502: evno = K7EVENTRAKU(000502); break;

	case	eRakum010001: evno = K7EVENTRAKU(010001); break;
	case	eRakum010002: evno = K7EVENTRAKU(010002); break;
	case	eRakum010003: evno = K7EVENTRAKU(010003); break;
	
	case	eRakum011201: evno = K7EVENTRAKU(011201); break;
	case	eRakum011301: evno = K7EVENTRAKU(011301); break;
	case	eRakum011501: evno = K7EVENTRAKU(011501); break;
		
	case	eRakum030201: evno = K7EVENTRAKU(030201); break;
	case	eRakum030301: evno = K7EVENTRAKU(030301); break;
		
	//	debug
	case	ePanelDebug:
	default:              evno = K7EVENTNO  (999999); break;
	}
	return Create(evno,now,now2);
}

#if 0
SK7PanelBase* SK7PanelBase::Create(u32 evno,s32 now,s32 now2 )
{
#pragma	unused(now2)

	PanelEventNo = evno;			//	Cxgԍ

	switch( evno ){
//	case	K7EVENTNO(000101): return new mK7PanelSwitch00(now);
	case	K7EVENTNO(000102): return new mK7PanelSwitch01(now);//SK7PanelLaundry(now);
//	case	K7EVENTNO(000104): return new SK7PanelManageKey(now);
//	case	K7EVENTNO(000201): return new mK7PanelSwitch02(now);
	case	K7EVENTNO(000304): return new SK7PanelInputCode(now);
	case	K7EVENTNO(000401): return new SK7PanelDarts(now);
	case	K7EVENTNO(000501): return new mK7PanelSwitch03(now);
//	case	K7EVENTNO(000502): return new mK7PanelSwitch04(now);
	case	K7EVENTNO(000603): return new SK7PanelToilet(now);
	case	K7EVENTNO(000606): return new mK7PanelSwitch05(now);
	case 	K7EVENTNO(010600): return new SK7PanelNiou(now);
	case	K7EVENTNO(007201): return new SK7PanelCandle(now);
	case 	K7EVENTNO(007301): return new SK7PanelPoster((s32)evno, 0);
	case 	K7EVENTNO(007307): return new SK7PanelBook(now);
//	case	K7EVENTNO(010700): return new SK7PanelCook2(now);
//	case	K7EVENTNO(010701): return new SK7PanelCook(now);
//	case	K7EVENTNO(010401): return new SK7PanelKouro(0);//mK7PanelKouro(0);
//	case	K7EVENTNO(010402): return new SK7PanelKouro(1);//mK7PanelKouro(1);
//	case	K7EVENTNO(010403): return new SK7PanelKouro(2);//mK7PanelKouro(2);
	case	K7EVENTNO(011201): return new SK7PanelLocker(now);
	case	K7EVENTNO(011301): return new SK7PanelElevator(now);
	case	K7EVENTNO(011304): return new SK7PanelManageKey2(now);
	case 	K7EVENTNO(011305): return new SK7PanelChinChiro(now);
	case	K7EVENTNO(011308): return new SK7PanelElevator2(now);
	case	K7EVENTNO(011309): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(011402): return new SK7PanelCards(0);
	case	K7EVENTNO(011403): return new SK7PanelCards(1);
	case	K7EVENTNO(011404): return new SK7PanelCards(2);
	case	K7EVENTNO(011406): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(011502): return new SK7PanelKeiba(now);
	case	K7EVENTNO(011503): return new SK7PanelRoulette(now);
	case	K7EVENTNO(011506): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(011602): return new SK7PanelIno(GAME_INO);
	case	K7EVENTNO(011603): return new SK7PanelIno(GAME_SHIKA);
	case	K7EVENTNO(011604): return new SK7PanelIno(GAME_CHO);
	case	K7EVENTNO(011606): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(011607): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(011608): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(015201): return new SK7PanelKakejiku(now);
	case	K7EVENTNO(020101): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020103): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020105): return new SK7PanelGacha(now);
	case	K7EVENTNO(020107): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020108): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020109): return new SK7PanelInputCode6(now);
	case	K7EVENTNO(020110): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020111): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020112): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020113): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020114): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020115): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020116): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(020117): return new SK7PanelPsychoTest(now);
	case	K7EVENTNO(020201): return new SK7PanelPoster((s32)evno, 0);
//	case	K7EVENTNO(020118): return new SK7PanelMailbox(0);
//	case	K7EVENTNO(020119): return new SK7PanelMailbox(1);
//	case	K7EVENTNO(020120): return new SK7PanelMailbox(2);
//	case	K7EVENTNO(020121): return new SK7PanelMailbox(3);
//	case	K7EVENTNO(020122): return new SK7PanelMailbox(4);
//	case	K7EVENTNO(020123): return new SK7PanelMailbox(5);
//	case	K7EVENTNO(020124): return new SK7PanelMailbox(6);
//	case	K7EVENTNO(020125): return new SK7PanelMailbox(7);
	case	K7EVENTNO(030101): return new SK7PanelPoster((s32)evno, 0);
//	case	K7EVENTNO(030102): return new SK7PanelVisitor(now);
	case	K7EVENTNO(030103): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(030104): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(030105): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(030106): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(030201): return new SK7PanelGum(now,GUM_PHOENIX);
	case	K7EVENTNO(030202): return new SK7PanelGum(now,GUM_COWGIRL);
	case	K7EVENTNO(030203): return new SK7PanelGum(now,GUM_BIKE);
	case	K7EVENTNO(030204): return new SK7PanelGum(now,GUM_GUN);
	case	K7EVENTNO(030205): return new SK7PanelGum(now,GUM_MISSILE);
	case	K7EVENTNO(030206): return new SK7PanelPopcorn(now);
	case	K7EVENTNO(030301): return new SK7PanelPoster((s32)evno, 0);
	case	K7EVENTNO(030401): return new SK7PanelBreaker(now);
	case	K7EVENTNO(030402): return new SK7PanelBreaker(now);
	case	K7EVENTNO(030403): return new SK7PanelBreaker(now);
	case	K7EVENTNO(030404): return new SK7PanelBreaker(now);
	case	K7EVENTNO(030409): return new SK7PanelMainBreaker(now);
	case	K7EVENTNO(030414): return new SK7PanelPoster((s32)evno, 0);

//	case	K7EVENTNO(030515): return new SK7PanelPoster(K7EVENTNO(030515));
//	case	K7EVENTNO(030516): return new SK7PanelPoster(K7EVENTNO(030516));
//	case	K7EVENTNO(030517): return new SK7PanelPoster(K7EVENTNO(030517));
//	case	K7EVENTNO(030518): return new SK7PanelPoster(K7EVENTNO(030518));
//	case	K7EVENTNO(030519): return new SK7PanelPoster(K7EVENTNO(030519));
//	case	K7EVENTNO(030520): return new SK7PanelPoster(K7EVENTNO(030520));

	case	K7EVENTNO(030901): return new SK7PanelSofa(now);
	case	K7EVENTNO(035003): return new SK7PanelNine(now);
	case	K7EVENTNO(035005): return new SK7PanelSecom(now);
	case	K7EVENTNO(035006): return new SK7PanelSecom(now);
	case	K7EVENTNO(035007): return new SK7PanelSecom(now);
	case	K7EVENTNO(035008): return new SK7PanelSecom(now);
	case	K7EVENTNO(035009): return new SK7PanelSecom(now);
	case	K7EVENTNO(035010): return new SK7PanelSecom(now);
	case	K7EVENTNO(035012): return new SK7PanelLock(now);
	case	K7EVENTNO(035014): return new SK7PanelCock(now);
	case	K7EVENTNO(035015): return new SK7PanelValve(now);

	case	K7EVENTNO(050101): return new SK7PanelDebug(now);//SK7PanelHotelElevator(ELEVATOR_DIRECT7);
	case	K7EVENTNO(050103): return new SK7PanelDebug(now);//SK7PanelHotelElevator(ELEVATOR_HOTEL2F);
	case	K7EVENTNO(050202): return new SK7PanelDebug(now);//SK7PanelHotelElevator(ELEVATOR_HOTEL3F);
	case	K7EVENTNO(050302): return new SK7PanelDebug(now);//SK7PanelHotelElevator(ELEVATOR_HOTEL4F);
	case	K7EVENTNO(050402): return new SK7PanelDebug(now);//SK7PanelHotelElevator(ELEVATOR_HOTEL5F);
	case	K7EVENTNO(050502): return new SK7PanelDebug(now);//SK7PanelHotelElevator(ELEVATOR_HOTEL6F);
	case	K7EVENTNO(050602): return new SK7PanelDebug(now);//SK7PanelHotelElevator(ELEVATOR_HOTEL7F);
	case	K7EVENTNO(050701): return new SK7PanelDebug(now);//SK7PanelHotelElevator(ELEVATOR_HOTELROOF);
	case	K7EVENTNO(055002): return new SK7PanelDebug(now);//SK7PanelCurtain(now);
	case	K7EVENTNO(055300): return new SK7PanelDoncho(now);//SK7PanelCurtain(now);
	case	K7EVENTNO(055700): return new SK7PanelDoncho(now);//SK7PanelCurtain(now);

	case	K7EVENTNO  (999999):
	default:                     return new SK7PanelDebug(now);
	}
	return NULL;
}
#endif

#define	__SK7PANELCREATE_INCLUDE__
#include "..\sato\SK7PanelCreate.h"
//========================================================================
//					pl
//========================================================================
SK7PanelBase* SK7PanelBase::Create(u32 evno,s32 now,s32 now2 )
{
	SK7PanelBase	*pPanel;
	PanelEventNo = evno;			//	Cxgԍ
	
	if( m_pPanelCreateFunc!=NULL ){
		if( (pPanel = m_pPanelCreateFunc(evno,now,now2))!=NULL ){
			return pPanel;
		}
	}

	switch( evno ){
#include "SK7PanelCreate.h"
	case	K7EVENTNO  (999999):
	default:                     return new SK7PanelDebug(now);
	}
	return NULL;
}

//========================================================================
//					plVXebZ[W
//========================================================================
bool		SK7PanelBase::DrawMessage( u16 MesNo )
{
	//	bZ[W`FbN	----------------------------------
	if( m_cCheckJmbHandle == -1 )	return true;
	
	switch( m_MecProc ){
	case eMesLoad:
		m_pEffectMessage = CreateMessage2Effect(m_cCheckJmbHandle, MesNo, TRUE );
		m_MessageID	= GetEffectID(m_pEffectMessage);
		m_MecProc = eMesCheck; 
		break;
	case eMesCheck:
		if( !CheckEffectValidState( m_pEffectMessage, m_MessageID )){
			m_MecProc = eMesEnd; 		
		}
		break;
	case eMesEnd:	
		m_MecProc = eMesLoad;
		return true;
	}
	return false;
}

//========================================================================
//					J[\ړZbg
//========================================================================
void		SK7PanelBase::SetCursolDir( s8 dir, u8 state  )
{
	if( m_pEffectCursol == NULL || CheckEffectValidState(m_pEffectCursol, m_EffectID) == FALSE )	return;
	
	s8 flag = 0;
	flag |= dir;
	SetPanelCursorDirDrawFlag( m_pEffectCursol, CUR_UP, 	FALSE );
	SetPanelCursorDirDrawFlag( m_pEffectCursol, CUR_DOWN, 	FALSE );
	SetPanelCursorDirDrawFlag( m_pEffectCursol, CUR_RIGHT, 	FALSE );
	SetPanelCursorDirDrawFlag( m_pEffectCursol, CUR_LEFT, 	FALSE );
	
	if( !m_bDirDrawFlag )	return;
	
	if( flag & CURSOL_DIR_UP ){
		SetPanelCursorDirDrawFlag	( m_pEffectCursol, CUR_UP, 	TRUE );
		if( state == 1 ) SetPanelCursorDirWhiteBrink	( m_pEffectCursol,	CUR_UP );
	}else{
		if( state == 1 ) SetPanelCursorDirBlackBrink( m_pEffectCursol,	CUR_UP );
	}
	if( flag & CURSOL_DIR_DOWN ){
		SetPanelCursorDirDrawFlag( m_pEffectCursol, CUR_DOWN, 	TRUE );
		if( state == 1 ) SetPanelCursorDirWhiteBrink	( m_pEffectCursol,	CUR_DOWN );
	}else{
		if( state == 1 ) SetPanelCursorDirBlackBrink( m_pEffectCursol,	CUR_DOWN );
	}
	if( flag & CURSOL_DIR_RIGHT ){
		SetPanelCursorDirDrawFlag( m_pEffectCursol, CUR_RIGHT, 	TRUE );
		if( state == 1 ) SetPanelCursorDirWhiteBrink	( m_pEffectCursol,	CUR_RIGHT );
	}else{
		if( state == 1 ) SetPanelCursorDirBlackBrink( m_pEffectCursol,	CUR_RIGHT );
	}
	if( flag & CURSOL_DIR_LEFT ){
		SetPanelCursorDirDrawFlag( m_pEffectCursol, CUR_LEFT, 	TRUE );
		if( state == 1 ) SetPanelCursorDirWhiteBrink	( m_pEffectCursol,	CUR_LEFT );
	}else{
		if( state == 1 ) SetPanelCursorDirBlackBrink( m_pEffectCursol,	CUR_LEFT );
	}
}

//========================================================================
//					plJ[\`check
//========================================================================
bool		SK7PanelBase::GetPanelCursolEnd()
{
	if( m_pEffectCursol == NULL || CheckEffectValidState(m_pEffectCursol, m_EffectID) == FALSE ) return	true;
	
	DeleteEffect( m_pEffectCursol );	//	
	
	return true;
#if 0
	if( GetPanelCursorDrawAlpha( m_pEffectCursol ) == 0 ){
		return true;
	}else{
		return false;
	}
#endif
}

//========================================================================
//					RXgN^
//========================================================================
SK7PanelDebug::SK7PanelDebug( s32 Now ) : SK7PanelBase( Now )
{
	m_sNowAnswer = -1;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelDebug::~SK7PanelDebug()
{ 	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelDebug::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		m_Proc = PROC_SELECT_MAIN;
		break;


	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( PanelDebugFont( &m_sNowAnswer, -1, 127 ) ){
			m_Proc = PROC_CANCEL;
		}
		break;

			
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelDebug::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelDebug::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelDebug::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelDebug::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}


