////////////////////////////////////////////////////////////////////////////////
//
// Killer7 
//
// SK7Photo.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PHOTO_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7Photo.h"



//========================================================================
//					RXgN^
//========================================================================
SK7Photo::SK7Photo() : SK7IMenuBase()
{
	//	wi
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	m_eLoadProc = LOAD_BG;
	m_Proc = PROC_LOAD;
}


//========================================================================
//					fXgN^
//========================================================================
SK7Photo::~SK7Photo()
{
	m_spBG.Delete();
}

//========================================================================
//					t[
//========================================================================
bool  	SK7Photo::FrameProcess(void)
{
	switch( m_Proc )
	{
	case PROC_LOAD:
		if( LoadData() )
		{
			m_Proc = PROC_MAIN;
		}
		break;
		
	case PROC_MAIN:
		if( !m_bCtrl )	break;
		if( HSD_PadGetTrigger(0) & (PAD_BUTTON_A|PAD_BUTTON_B) )
		{
			m_Proc = PROC_END;
		}
		break;
		
	case PROC_END: 
		break;
	}
	return true;
}

//========================================================================
//					_O
//========================================================================
bool 	SK7Photo::RenderProcess(void)
{
	if( !m_bRender )	return true;
	
	m_spBG.Render();
	return true;
}

//========================================================================
//					t@CǂݍݏI擾֐
//========================================================================
bool 	SK7Photo::GetFileReadEnd(void)
{
	if( m_Proc >= PROC_MAIN )
	{
		return true;
	}
	return false;
}

//========================================================================
//					j[I֐
//========================================================================
bool 	SK7Photo::GetMenuEnd(void)
{
	if( m_Proc == PROC_END )
	{
		return true;
	}
	return false;
}

//========================================================================
//					f[^[h
//========================================================================
bool	SK7Photo::LoadData(void)
{
	switch( m_eLoadProc )
	{
	case LOAD_BG:
		if( m_spBG.LoadTexture( IMENU_CHARA_BG ) )
		{
			return true;
		}
		break;
	}
	return false;
}
