////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SK7Special
//
// SK7Special.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 02/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7SPECIAL_CPP__

//#define	__DEBUG_FONT_DATA__
//#define	__RING_DEBUG__
//#define	__DEBUG_LIFE__
//#define		__DEBUG_SELECT__
//#define	__DEBUG_CHO__
//#define	__DEBUG_ITEM3__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "SK7Common.h"
#include "../matsu/mk7Sound.h"
#include "../Yam/YK7Effect.h"
#include "../wat/WK7Player.h"
#include "../wat/WK7Sight.h"
#include "SK7SpOption.h"
#include "SK7Special.h"
#include "../kaw/KK7BattleCtrl.h"
#include "../wat/WK7Skill.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/K7GlobalFlag.h"
#include "../wat/WK7Event.h"
#include "../wat/WK7SceneBlur.h"
#include "../wat/WK7Cam.h"
#include "../wat/WK7SelectIF.h"
#include "../matsu/mK7Noise.h"
#include "../wat/WK7Stage.h"
#include "../wat/WK7Item.h"
#include "..\Yam\YK7EffectBloodPack.h"
#include "..\Yam\YK7EffectBlood.h"
#include "../scn/K7Scn02.h"
#include "../scn/K7Scn05.h"
#include "SK7SpecialData.h"
#include "../fujita/c_font.h"


//	S̃EBhE	::::::::::::::::::::::::::::::::::::::::::::::
#define		WINDOW_SIZE_X		(200)
#define		WINDOW_SIZE_Y		(480)
#define		WINDOW_ALPHA		(0xc0)
#define		WINDOW_MOVE_FRAME	(10)
#define		WINDOW_NFONT_X		(100)
#define		WINDOW_MOVE_SIZE	(560)

//	O	::::::::::::::::::::::::::::::::::::::::::::::::::::
#define		NAME_BACK_X			(84)
#define		NAME_BACK_Y			(45)//(55)
#define		NAME_BACK_Y2		(26)
#define		NAME_BACK_SIZEX		(153)
#define		NAME_BACK_SIZEY		(28)
#define		NAME_BACK_COLOR		(0x1a1a1abf)
#define		NAME_SELECT_PLUSX	(-20.0f)
#define		NAME_TRIANGLE_X		(237)
#define		NAME_TRIANGLE_Y		(m_fNameBackY+14)//(59)//(69)
#define		NAME_TRIANGLE_PLUSX	(13)
#define		NAME_TRIANGLE_PLUSY	(14)
#define		NAME_TRIANGLE_COLOR	(0x000000ff)
#define		NAME_GAP_X			(6.5f)
#define		NAME_GAP_Y			(NAME_BACK_SIZEY+2)
#define		NAME_BACK2_SIZE		(2)
#define		NAME_BACK2_COLOR	(0x000000ff)
#define		NAME_MINI_X			(NAME_TRIANGLE_X)
#define		NAME_MINI_Y			(NAME_BACK_Y)
#define		NAME_MINI_SIZEX		(NAME_TRIANGLE_PLUSX)
#define		NAME_MINI_SIZEY		(NAME_BACK_SIZEY-NAME_TRIANGLE_PLUSY)
#define		NAME_FONT_COLOR		(0xffffffff)
#define		NAME_FONT_BLOCK		(0)
#define		NAME_SMITH_LINE		(7)
#define		NAME_FONT_X			(NAME_BACK_X+10.0f)
#define		NAME_FONT_Y			(m_fNameBackY+3.5f)
#define		NAME_FONT_GAPX		(5)
#define		NAME_FONT_SPACE		(3.0f)
#define		NAME_FONT_BETWEEN	(2.0f)
#define		NAME_SMITH_X		(104.0f)//(99.0f)
#define		NAME_SMITH_BETWEEN	(1.0f)
#define		NAME_SMITH_GAPX		(5.0f)
#define		NAME_NOT_ALPHA		(0x40)
#define		NAME_MOVE_TIME		(5)
#define		KASAN_SIZE_X		(210.0f)//(205.0f)//(198.0f)
#define		KASAN_SIZE_Y		(54.0f)//(48.0f)
#define		KASAN_GAPX			(-3.0f)
#define		KASAN_GAPY			(-13.0f)
#define		KASAN_COLOR			(0xa0a0a0bf)
#define		NAME_KEY_FRAME		(5)
#define		NAME_FRONT_SPEED	(-5.0f)
#define		NAME_BACK_SPEED		(2.4f)

//	ACel[	:::::::::::::::::::::::::::::::::::::::::
#define		ITEM_NAME_X				(303)
#define		ITEM_NAME_Y				(313)
#define		ITEM_NAME_SELECTX		(-23.0f)
#define		ITEM_BACK_COLOR			(0x3a3a3aBf)
#define		ITEM_NAME_ALPHA_TIME	(15)
#define		NAME_PLATE_TRIX(X)		(X+153)
#define		NAME_PLATE_TRIY(Y)		(Y+14)
#define		NAME_PLATE_MINIX(X)		(X+153)
#define		NAME_PLATE_MINIY(Y)		(Y)
#define		NAME_PLATE_FONTX(X)		(X+22.0f)
#define		NAME_PLATE_FONTY(Y)		(Y+3.0f)


//	E[	:::::::::::::::::::::::::::::::::::::::::::::::::::
#define		RIGHT_WIN_X			(555)
#define		RIGHT_WIN_Y			(0)
#define		RIGHT_WIN_COLOR		(0x1a1a1a7f)
#define		RIGHT_WIN_SIZEX		(85)
#define		RIGHT_WIN_SIZEY		(480)
#define		LEFT_WIN_COLOR		(0x1a1a1a7f)//10)

//	LN^[	:::::::::::::::::::::::::::::::::::::::::::
#define		CHARA_X				(289)
#define		CHARA_Y				(45)//(55)
#define		CHARA_FRAME_X0		(283)
#define		CHARA_FRAME_X1		(285)
#define		CHARA_FRAME_X2		(295)
#define		CHARA_FRAME_X3		(293)
#define		CHARA_FRAME_Y0		(54)//(64)
#define		CHARA_FRAME_Y1		(127)//(137)
#define		CHARA_FRAME_Y2		(54)//(64)
#define		CHARA_FRAME_Y3		(175)//(185)
#define		CHARA_FRAME_COLOR	(0x000000ff)

//	O	:::::::::::::::::::::::::::::::::::::::::::::::::::
#define		RING_X0				(236)
#define		RING_Y0				(312)
#define		RING_STONE_X		(1)
#define		RING_STONE_Y		(1)
#define		RING_SENRI_X		(207)
#define		RING_SENRI_Y		(413)
#define		RING_ICON_X			(NAME_BACK_X+NAME_BACK_SIZEX+20)
#define		RING_ICON_Y			(m_fNameBackY+5)
#define		RING_SIZE			(32)
#define		RING_SELECT_COLOR	(0xFD2C24ff)
#define		RING_SELECT_SIZE	(15)
#define		RING_COLOR_NOTSELECT	( 0x4f4f4f7f )

#define		RING_ICON_SIZE		(32)
#define		RING_ICON_R			(104.0f)//(96.0f)//60.0f)
#define		RING_ICON_R2		(80.0f)
#define		RING_ICON_KATAMUKI	(308.0f)//(213.0f)//15.0f)
#define		RING_ICON_EYEZ		(978.6521f)//(1000.0f)
#define		RING_ICON_Z			(8.0f)
#define		RING_ICON_CENTER_X	(160.0f)//(155.0f)//(162.0f)//(148.0f)
#define		RING_ICON_CENTER_Y	(17.5f)//(27.5f)//(115.0f)
#define		RING_ICON_CENTER_X2	(180.0f)
#define		RING_ANGLE_SPEED	(5)
#define		RING_EQUIP_TIME		(9)
#define		RING_OBJ_X			(257.25f)
#define		RING_OBJ_Y			(309.5f)

#define		RING_NAME_X			(212.5f)
#define		RING_NAME_Y			(366.0f)
#define		RING_NAME_CENTERX	(265.0f)
#define		RING_KASAN_X		(259.6875f)//(119.1875f+32.0f)
#define		RING_KASAN_Y		(312.5f)//(301.25f+32.0f)
#define		RING_KASAN_NORMAL	(64)
#define		RING_KASAN_MINI		(22.4f)
#define		RING_KASAN_BIG		(73.6f)
#define		RING_KASAN_BIG_TIME		(8)
#define		RING_KASAN_SMALL_TIME	(7)
#define		RING_KASAN2_X		(-8)
#define 	RING_KASAN2_Y		(-30)
#define		RING_KASAN2_SIZEX	(48)
#define		RING_KASAN2_SIZEY	(4)

#define		RING_SAMPLE_X		(258.5f)
#define		RING_SAMPLE_Y		(337.3125f)

#define		RING_MINI_X			(204)
#define		RING_MINI_Y			(407)
#define		RING_MINI_SIZE		(20)

//	ʐ^	:::::::::::::::::::::::::::::::::::::::::::::::::::
#define		PHOTO_ANGLE			(350)
#define		PHOTO_X				(120)
#define		PHOTO_Y				(360)
#define		PHOTO_SIZE_X		(64)
#define		PHOTO_SIZE_Y		(64)
#define		PHOTOBIG_SIZE_X		(240)
#define		PHOTOBIG_SIZE_Y		(240)
#define		PHOTOBIG_X			(900)
#define		PHOTOBIG_Y			(-300)
#define		PHOTO_MOVE_TIME		(15)
#define		PHOTO_COLOR_NOTSELECT	( 0x4f4f4fff )
#define		PHOTO_WAIT_TIME		(30)


//		:::::::::::::::::::::::::::::::::::::::::::::::::::
#define		MEMO_X				(496)
#define		MEMO_Y				(154)
#define		MEMO_ALPHA			(0x99)
#define		MEMO_MOVE_FRAME		(1)
#define		MEMO_MOVE_SIZE		(3)

//	r[J[	------------------------------------
#define		BEAKER_BODY_X			(375)
#define		BEAKER_BODY_Y			(311)
#define		BEAKER_BODY_ALPHA		(140)
#define		BEAKER_BODY_SIZEY		(128)
#define		BEAKER_TOP_X			(375)
#define		BEAKER_TOP_Y			(295)
#define		BEAKER_UNDER_X			(375)
#define		BEAKER_UNDER_Y			(439)
#define		BEAKER_BOTTOM_X			(399)
#define		BEAKER_MEMORI_X			(380)
#define		BEAKER_MEMORI_Y			(325)
#define		BEAKER_SIZE_X			(76)
#define		BEAKER_BLOOD_X			(379)
#define		BEAKER_BLOOD_SIZEX		(73)
#define		BEAKER_BLOOD_COLOR		(0xf01925ff)
#define		THICK_BLOOD_GAPX		(40)
#define		THICK_BLOOD_GAPY		(50)
#define		DL_X					(29)
#define		DL_Y					(77)

//	pl	:::::::::::::::::::::::::::::::::::::::::::::::::::
#define		PANEL_X				(288)//(295)
#define		PANEL_Y				(182)//(170)//(194)//(184)
#define		PANEL_SIZE			(148)//(128)//(115)
#define		PANEL_ANGLE			(0)//315)
#define		PANEL_COLOR			(0x000000ff)
#define		PANEL_MOVE_TIME		(20)
#define		PANEL_START_TIME	(14)
#define		PANEL_TIME			(6)
#define		PANEL_SPEED			(13.0f/7.0f)
#define		PANEL_MOVE_SPEED	(5)
#define		PANEL_MOVE_ANGLE	(0)//3.0f)

#define		BLOCK_SELECT_EX		(8.2f)
#define		BLOCK_SELECT_MOVE	(3.4f)
#define		BLOCK_SELECT_FRAME	(2)
#define		BLOCK_KEY_POWER		(0.5f)
#define		UV_MAX				(2)	//UVϊ

//	񕜌t	::::::::::::::::::::::::::::::::::::::::::::::::
#define		LIFE_BLOOD_X		(490)
#define		LIFE_BLOOD_Y		(395)
#define		LIFE_BLOOD_TIME		(22)
#define		LIFE_BLOOD_TIME2	(4)
#define		BLOOD_MAX_SIZE		(24)

//	tʕ\	:::::::::::::::::::::::::::::::::::::::::::::::::
#define		BLOOD_NO_X			(495)
#define		BLOOD_NO_Y			(393)

#define		STATE_X				(370)
#define		STATE_Y				(40)
#define		STATE_GAP_Y			(20)
#define		STATE_LIST_NUM		(3)

//	Cg	::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#define		LIGHT_SIZE			(180)
#define		LIGHT_ALPHA_TIME	(25)

//	ẼC	::::::::::::::::::::::::::::::::::::::::::
#define		RIGHT_LINE_SIZE		(6)
#define		RIGHT_LINE_COLOR	(0x0000007f)

//	ƂƂ	::::::::::::::::::::::::::::::::::::::::::
#define		TOGE_ANGLE_A		(5)
#define		TOGE_ANGLE_B		(60)
#define		TOGE_SIZE_X			(8)
#define		TOGE_SIZE_Y			(128)

//	}XN	::::::::::::::::::::::::::::::::::::::::::::::::::
#define		MASK_TIME			(10)
#define		MASK_COLOR			(0x000000B2)
#define		MASK_ALPHA			(0xbf)

//	ZNgtHg	:::::::::::::::::::::::::::::::::::::
#define		SELECT_MAX_SIZE_X	(10)
#define		SELECT_MAX_SIZE_Y	(10)
#define		SELECT_FONT_ALPHA_A	(0x23)
#define		SELECT_FONT_ALPHA_B	(0x23)
#define		SELECT_FONT_DOWN_ALPHA	(0x4c)
#define		SELECT_ALPHA_SPEED	(5)
#define		SELECT_ALPHA_ANSWER_SPEED (5)

#define		SELECT_WAKU_TIME			(6)
#define		SELECT_WAKU_ROTNO			(4)
#define		ITEM_SELECT_TIME			(4)

//	ACe	::::::::::::::::::::::::::::::::::::::::::::::
#define		ITEM_POS_X		(242)
#define		ITEM_POS_Y		(422)
#define		ITEM_POS_GAPX	(34)

//	ER	::::::::::::::::::::::::::::::::::::::::::::::
#define		ULCL_X			(67)
#define		ULCL_Y			(300)

//	J[`[g	::::::::::::::::::::::::::::::::::::::::::
#define		CHART_X			(50)
#define		CHART_Y			(302)

//	{CXR[_[	::::::::::::::::::::::::::::::::::::
#define		VOICE_X			(121.5f)
#define		VOICE_Y			(264.0625f)

//	_ۂ	::::::::::::::::::::::::::::::::::::;:
#define		MEDAL_X			(24)//27)
#define		MEDAL_Y			(398)
#define		MEDAL_NO_X		(MEDAL_X+30)
#define		MEDAL_NO_Y		(MEDAL_Y+10)

//	ǃRł͂Ȃ	:::::::::::::::::::::::::::::::::::::::
#define		SORE_X			(143)
#define		SORE_Y			(200)

//	ubNZNg	::::::::::::::::::::::::::::::::::::::::::::::
enum{
	BLOCK_SELECT_CHARA=0,
	BLOCK_SELECT_ITEM,
	BLOCK_SELECT_MEMO,
	BLOCK_SELECT_BLOOD,
	BLOCK_SELECT_NOT,
	BLOCK_SELECT_CANCEL,
};

enum{
	LIFE_CHECK=0,
	LIFE_EYE,
};
	

//========================================================================
//					RXgN^
//========================================================================
SK7Special::SK7Special( SK7SpOption* pOption )
{
	//	RctHg[h	***********************************************
	ghmGcMemSetAllocName("SK7SPEYFONT");
	m_pYFont = new YK7StrImage;
	m_pYFont->LoadMem( g_pSpData->GetYFontData(0) );

	//	|C^擾	:::::::::::::::::::::::::::::::::::::::::::
	m_pOption		= pOption;

	//	teNX`[̎󂯓n	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	TEXTURE* tex = GetBloodTex(0);
	m_BloodTex.Header 	= tex->Header;
	m_BloodTex.Obj		= tex->Obj;	

	Initialize();
}


//========================================================================
//					fXgN^
//========================================================================
SK7Special::~SK7Special()
{	
	//	GtFNgX^[g	**********************************************************
//	PanelScreenEffectStopRelease();
	SubScreenEffectStopRelease();
	GHM_SAFE_DELETE( m_pspSubIcon );
	GHM_SAFE_DELETE( m_pYFont );
	GHM_SAFE_DELETE( m_pMenu );
	GHM_SAFE_DELETE( m_pspMedal );
	GHM_SAFE_DELETE_ARRAY( m_pLifeBlood );
	GHM_SAFE_DELETE_ARRAY( m_spBgFrame );
	GHM_SAFE_DELETE_ARRAY( m_spBgFrameTex );
}


//========================================================================
//					
//========================================================================
void	SK7Special::Initialize(void)
{
	//	GtFNgXgbv	**********************************************************
//	PanelScreenEffectStop();
	SubScreenEffectStop();

	int i=0;
	m_chNameSelect 			= 0;
	m_iMoveTime 			= 0;
	m_chBlockSelect 		= BLOCK_SELECT_NOT;
	m_chSaveSelect			= 0;
	m_chRingSelect			= 0;
	m_eItemProc				= 0;
	m_eBloodProc			= 0;
	m_eMemoProc				= 0;
	m_chItemSelect			= 0;
	m_eMenuProc				= 0;
	m_iKeyTime				= 0;
	m_sOldHpPer				= 0;
	m_sNowHpPer				= 0;
	m_iSelectTime			= 0;
	m_iItemNameTime			= 0;
	m_iMemoTime				= 0;
	m_chItemSelectNo		= 0;
	m_chItemNum				= 0;
	m_lEventNo				= 0xffffffff;
	m_chLRFlag				= RING_KEY_NONE;
	m_bMoveFlag 			= true;
	m_bBlockFlag			= false;
	m_bLightMoveFlag		= true;
	m_bRingNameFlag 		= true;
	m_bMenuRenderFlag		= false;
	m_bPlayerLightEnable 	= false;
	m_bMaskFlag				= false;
	m_pMenu					= NULL;
	m_pLifeBlood			= NULL;
	m_pspMedal				= NULL;
	m_pspSubIcon			= NULL;
	m_eProc 				= PROC_MOVE;
	m_fScrollX				= 640.0f - (m_pOption->GetBloodPointMoveX()+100.0f);
	m_fStateFontX			= STATE_X-m_fScrollX;
	m_fBloodNoX				= BLOOD_NO_X-m_fScrollX;
	m_fMedalX				= MEDAL_NO_X-m_fScrollX;
	
	//	LN^[̌
	if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==true ){
		m_chCharaNum 	= CHANGE_CHARA_NUM;
		m_fNameBackY	= NAME_BACK_Y2;
	}else{
		m_chCharaNum 	= CHANGE_CHARA_NUM-1;
		m_fNameBackY	= NAME_BACK_Y;
	}
	m_Key.PushTime 			= 0;
	m_Key.Power				= 0;
	
	m_Panel.PanelStartTime 	= 0;
	m_Panel.PanelTime		= 0;
	m_Panel.MoveTime		= 0;
	m_Panel.PanelSize		= PANEL_SIZE;
	m_Panel.MoveFlag		= true;		

	m_pOption->SetState(SPOPTION_STANBY);
	m_pOption->SetOptionX();
	m_pOption->SetMacineRender( true );
	m_pOption->SetBeakerRender( true );	
	m_pOption->SetRenderConpas( false );
	m_pOption->SetCodeFlag	  ( true );
	m_pOption->SetNoudoRender ( false );
	m_bEnemyConpasFlag = m_pOption->GetEnemyConpasRender();

	//	EBhE	**********************************************************
	for( i = 0; i < ITEM_SELECT_MAX; i++){
		if( tblItemSelectNo[GameInfo.GetScenarioFlow()].No[i] == -1 ) break;
		m_chItemNum++;
	}
	
	//	EBhE	**********************************************************
	m_spWindow.SetSprite( -m_fScrollX, 0.0f, 640.0f, 480.0f, WINDOW_COLOR );
	m_spWindow.SetFlag	( true, RENDER_FLAG );
		
	//	t[Im	-------------------------------------------------
	ghmGcMemSetAllocName("SK7SPEFRAME1");
	m_spBgFrame 	= new SK7Sprite[BF_NOTEX_MAX];
	ghmGcMemSetAllocName("SK7SPEFRAME2");
	m_spBgFrameTex 	= new SK7Sprite[BF_TEX_MAX];

	//	eNX`[t[		******************************************************
	for( i = 0; i < BF_NOTEX_MAX; i++ ){
		m_spBgFrame[i].SetSprite( tblBFNoTexData[i].XY.x-m_fScrollX, tblBFNoTexData[i].XY.y, tblBFNoTexData[i].SIZE.x, tblBFNoTexData[i].SIZE.y, 0x000000ff );
		m_spBgFrame[i].SetVisible( true );
	}
	int UvNo=0;
	//	eNX`[		******************************************************
	for( i = 0; i < BF_TEX_MAX; i++ ){
		m_spBgFrameTex[i].SetTexSprite( tblBgFrameData[i].XY.x-m_fScrollX, tblBgFrameData[i].XY.y, g_pSpData->GetTexture((u8)(tblBgFrameData[i].TexNo)) );
		m_spBgFrameTex[i].SetColor( 0x000000ff );
		m_spBgFrameTex[i].SetVisible( true );

		if( tblUVState[UvNo].No ==  i ){	//uv
			m_spBgFrameTex[i].SetSTTwo( tblUVState[UvNo].u0, tblUVState[UvNo].u1, tblUVState[UvNo].v0, tblUVState[UvNo].v1 );
			UvNo++;
		}
	}

	SET_SPRITE_ROT( &m_spBgFrameTex[BF_TEX_TOGE0], TOGE_ANGLE_A, tblBgFrameData[BF_TEX_TOGE0].XY.x+TOGE_SIZE_X*0.5f, tblBgFrameData[BF_TEX_TOGE0].XY.y+TOGE_SIZE_Y*0.5f, TOGE_SIZE_X, TOGE_SIZE_Y )\
	SET_SPRITE_ROT( &m_spBgFrameTex[BF_TEX_TOGE1], TOGE_ANGLE_B, tblBgFrameData[BF_TEX_TOGE1].XY.x+TOGE_SIZE_X*0.5f, tblBgFrameData[BF_TEX_TOGE1].XY.y+TOGE_SIZE_Y*0.5f, TOGE_SIZE_X, TOGE_SIZE_Y )\
	m_spBgFrameTex[BF_TEX_TOGE0].SetIncX( -m_fScrollX );
	m_spBgFrameTex[BF_TEX_TOGE1].SetIncX( -m_fScrollX );

	//	E[	************************************************
	m_spRightWin.SetSprite	( RIGHT_WIN_X-m_fScrollX,RIGHT_WIN_Y, RIGHT_WIN_SIZEX, RIGHT_WIN_SIZEY, RIGHT_WIN_COLOR );
	m_spRightWin.SetVisible	( true );
	m_spLWin.SetSprite		( m_spRightWin.GetX0()+OPTION_WINDOW_LX, 0.0f, -OPTION_WINDOW_LX, 480, RIGHT_WIN_COLOR );
	m_spLWin.SetColor4		( LEFT_WIN_COLOR, RIGHT_WIN_COLOR, LEFT_WIN_COLOR, RIGHT_WIN_COLOR );
	m_spLWin.SetFlag		( true, V4COLOR_FLAG|RENDER_FLAG );

	//	LN^[	******************************************************
	u8 texno = 0;
	switch( WK7PLAYERCONTROL->GetMainID() ){
	case K7DAN: texno = 1; break;
	case K7GAL:	texno = 0; break;
	case K7CON: texno = 5; break;
	case K7CYO: texno = 4; break;
	case K7KED: texno = 2; break;
	case K7KVN: texno = 3; break;
	case K7HAY:	texno = 7; break;
	case K7MSK:
		//	}XNLvUpΉ	---------------------------------------------
		switch( BattleCtrl.GetMskPowerUp() ){
		case KK7BATTLECTRL_MSKLV_TEXAS:		texno = 8; 		break;
		case KK7BATTLECTRL_MSKLV_FINAL:		
		case KK7BATTLECTRL_MSKLV_TEKKAMEN:	texno = 9;		break;
		default: 							texno = 6; 		break;
		}
		break;
	}
	//	}XNϐg
	s8 selectno=(s8)texno;
	if( texno > 7 )	selectno = 6;

	m_chSaveSelect = m_chNameSelect = (s8)(selectno-1);
	m_spChara.SetTexSprite	( CHARA_X-m_fScrollX, CHARA_Y, g_pSpData->GetTexture(TEX_ALL_CHARA), CHANGE_CHARA_NUM+3, 1, texno );
	m_spChara.SetVisible	( true );

	//	LN^[t[	******************************************************
	m_spCharaFrame.SetSpriteFlex( CHARA_FRAME_X0, CHARA_FRAME_Y0, CHARA_FRAME_X1, CHARA_FRAME_Y1, CHARA_FRAME_X2, CHARA_FRAME_Y2, CHARA_FRAME_X3, CHARA_FRAME_Y3, CHARA_FRAME_COLOR );
	m_spCharaFrame.SetIncX		( -m_fScrollX );
	m_spCharaFrame.SetVisible	( true );

	//	ԏ	*****************************************************
	for( i = 0; i < m_chCharaNum; i++ )	m_NamePlate[i].MoveTime = 0;
	
	//	Ov[g	******************************************************
	if( m_chSaveSelect != -1 ){
		SetAllNamePlate( (u8)m_chSaveSelect, -m_fScrollX );
		//	S`FbN	**************************************************
		CheckDeath();
	}else{
		//	邵̂Ƃ	**************************************************
		for( i = 1; i < CHANGE_CHARA_NUM; i++ )	SetNamePlateRender	( &m_NamePlate[i], false );
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==true ){
			SetNamePlatePos		( &m_NamePlate[0], 1, true, -m_fScrollX );
		}else{
			SetNamePlatePos		( &m_NamePlate[0], 0, true, -m_fScrollX );
		}
		SetNamePlateRender	( &m_NamePlate[0], true );
	}
	
	//	ʐ^f[^	**************************************************
	m_Photo.Small.SetTexture( g_pStageData->GetStageTex(STAGE_TEX_PHOTO) );
	SET_SPRITE_ROT( &m_Photo.Small, PHOTO_ANGLE, PHOTO_X+PHOTO_SIZE_X*0.5f, PHOTO_Y+PHOTO_SIZE_Y*0.5f, PHOTO_SIZE_X, PHOTO_SIZE_Y );
	m_Photo.Small.SetIncX( -m_fScrollX );

	m_Photo.Angle 	= 0;
	m_Photo.Time 	= 0;
	m_Photo.vCenter.x = PHOTOBIG_X; 	m_Photo.vCenter.y = PHOTOBIG_Y;
	m_Photo.Big.SetTexture( g_pStageData->GetStageTex(STAGE_TEX_PHOTO) );
	SET_SPRITE_ROT( &m_Photo.Big, m_Photo.Angle, m_Photo.vCenter.x, m_Photo.vCenter.y, PHOTOBIG_SIZE_X, PHOTOBIG_SIZE_Y );
	m_Photo.Big.SetVisible( false );
	
	//	f[^	**************************************************
	m_spMemo.SetTexSprite	( MEMO_X-m_fScrollX, MEMO_Y, g_pSpData->GetTexture(TEX_MEMO) );
	m_spMemo.SetAlpha		( MEMO_ALPHA );
	m_spMemo.SetVisible		( true );

	//	ZNgtHg	***************************************
	m_SelectFont.Chara[0].SetTexSprite( tblSelectFont[FONT_SMITHS].x-m_fScrollX, tblSelectFont[FONT_SMITHS].y,  g_pSpData->GetTexture(TEX_GROUP_A), 1, SP_SELECT_NUM, 0 );
	m_SelectFont.Chara[0].SetVisible	( true );
	for( i = 1; i < 3; i++ )	m_SelectFont.Chara[i].SetVisible( false );
	m_SelectFont.Memo[0].SetTexSprite( tblSelectFont[FONT_MEMO].x-m_fScrollX, tblSelectFont[FONT_MEMO].y,	g_pSpData->GetTexture(TEX_GROUP_A), 1, SP_SELECT_NUM, 1);
	m_SelectFont.Memo[0].SetVisible		( true );
	m_SelectFont.Memo[1].SetVisible		( false );
	m_SelectFont.Blood[0].SetTexSprite( tblSelectFont[FONT_BLOOD].x-m_fScrollX, tblSelectFont[FONT_BLOOD].y, g_pSpData->GetTexture(TEX_GROUP_A), 1, SP_SELECT_NUM, 2 );
	m_SelectFont.Blood[0].SetVisible( true );
	m_SelectFont.Blood[1].SetVisible( false );
	m_SelectFont.Item[0].SetTexSprite( tblSelectFont[FONT_ITEM].x-m_fScrollX, tblSelectFont[FONT_ITEM].y, g_pSpData->GetTexture(TEX_GROUP_A), 1, SP_SELECT_NUM, 3 );
	m_SelectFont.Item[0].SetVisible( true );
	for( i = 0; i < 4; i++ ){
		if( i != 0 )	m_SelectFont.Item[i].SetVisible( false );
		m_SelectFont.vSpeed[i].x = m_SelectFont.vSpeed[i].y	= 0;
		m_SelectFont.AddTime[i]	= m_SelectFont.EndTime[i]	= 0;
	}
	m_SelectFont.MoveFlag = false;
	
	//	pl	***************************************************
	m_Panel.sprite.SetTexSprite	( PANEL_X, PANEL_Y, g_pSpData->GetTexture(TEX_PANEL) );//TEX_MEMO) );
	m_Panel.sprite.SetColor		( PANEL_COLOR );
	m_Panel.sprite.SetVisible	( true );
	SET_SPRITE_ROT				( &m_Panel.sprite, PANEL_ANGLE, PANEL_X+PANEL_SIZE*0.5f, PANEL_Y+PANEL_SIZE*0.5f, PANEL_SIZE, PANEL_SIZE );
	m_Panel.sprite.SetIncX		( -m_fScrollX );
	m_Panel.Angle			= PANEL_ANGLE;
	m_Panel.Ex				= PANEL_SPEED;
		
	//	}XN	*************************************************
	for( i = 0; i < MASK_MAX; i++ ){
		m_spMask[i].SetSprite( tblMaskParam[i].XY.x-m_fScrollX, tblMaskParam[i].XY.y, tblMaskParam[i].SIZE.x,tblMaskParam[i].SIZE.y, MASK_COLOR );	
		m_spMask[i].SetColor ( 0x00000000 );
		m_spMask[i].SetVisible( true );
	}
	SetBlockSelectMask( BLOCK_SELECT_NOT );
	
	//	ICg	*********************************************
	m_spLight.SetTexSprite	( tblLightData[0].XY.x, tblLightData[0].XY.y, g_pSpData->GetTexture(TEX_LIGHT) );
	m_spLight.SetTwoSize	( LIGHT_SIZE, LIGHT_SIZE );
	m_spLight.SetSTTwo		( tblLightData[0].u0, tblLightData[0].v0, tblLightData[0].u1, tblLightData[0].v1);
	m_spLight.SetAlpha		( 0x00 );
	m_spLight.SetVisible	( false );
	m_spLight.SetBlendNo	( SPR_BLEND_ONE );

	//	Z	***************************************************
	m_spNameKasan.SetBlendNo(2);

	//	Xe[Wp̃IuWFNg	-------------------------------
	SetStageObject();
	
	//	r[J[	**************************************************
	m_Beaker.Body.SetTexSprite	( BEAKER_BODY_X-m_fScrollX , 	BEAKER_BODY_Y, g_pSpData->GetTexture(TEX_BEAKER_BODY) );
	m_Beaker.Body.SetAlpha		( BEAKER_BODY_ALPHA );
	m_Beaker.Body.SetVisible	( true );
	m_Beaker.Bottom.SetTexSprite( BEAKER_BOTTOM_X-m_fScrollX, 	BEAKER_BOTTOM_Y, g_pSpData->GetTexture(TEX_BEAKER_BOTTOM) );
	m_Beaker.Bottom.SetVisible	( true );
	m_Beaker.Memori.SetTexSprite( BEAKER_MEMORI_X-m_fScrollX, 	BEAKER_MEMORI_Y, g_pSpData->GetTexture(TEX_BEAKER_MEMORI) );
	m_Beaker.Memori.SetVisible	( true );
	m_Beaker.Memori.SetColor	( 0xffffffff );
	m_Beaker.Top.SetTexSprite	( BEAKER_TOP_X-m_fScrollX, 	BEAKER_TOP_Y, g_pSpData->GetTexture(TEX_BEAKER_TOP) );
	m_Beaker.Top.SetVisible		( true );
	m_Beaker.Blood.SetTexSprite	( BEAKER_BLOOD_X-m_fScrollX, 	BEAKER_UNDER_Y, g_pSpData->GetTexture(TEX_BLOOD) );
	m_Beaker.Blood.SetTwoSize	( BEAKER_BLOOD_SIZEX,	-((f32)m_pOption->GetBloodGauge(BP_THICK) * ((f32)BEAKER_BODY_SIZEY/(f32)BLOOD_THICK_GAUGE_MAX))  );
	m_Beaker.Blood.SetFlag		( true, SIZE_FLAG|RENDER_FLAG );
	m_Beaker.Blood.SetColor		( BEAKER_BLOOD_COLOR );
	m_Beaker.Under.SetTexSprite	( BEAKER_UNDER_X-m_fScrollX, BEAKER_UNDER_Y, g_pSpData->GetTexture(TEX_BEAKER_TOP) );
	m_Beaker.Under.SetSTTwo		( 0, 1.0f, 1.0f, 0.0f );
	m_Beaker.Under.SetVisible	( true );	
	for( i = 0; i < 2; i++ ){
		m_Beaker.Pipe[i].SetTexSprite	( tblPipePos[i].x-m_fScrollX, tblPipePos[i].y, g_pSpData->GetTexture(TEX_PIPE) );
		m_Beaker.Pipe[i].SetVisible		( true );
	}
	//	OACR	*************************************************
	//	Ă̂邩ǂ
	m_RingIcon.fAngle 		= 0;
	m_RingIcon.iIconNum		= 0;
	m_RingIcon.fOneAngle	= 0;
	m_RingIcon.KasanAngle	= 0;
	m_RingIcon.SelectNo		= 0;
	m_RingIcon.bRender		= true;
	m_RingIcon.bKasanFlag	= false;
	m_RingIcon.bLightFlag	= false;
	m_RingIcon.bNotFlag		= false;	
	m_RingIcon.KasanTime	= 0;
	m_RingIcon.LightTime	= 0;
	m_RingIcon.Kasan.SetTexSprite	( RING_KASAN_X-m_fScrollX, RING_KASAN_Y, g_pSpData->GetTexture(TEX_RING_KASAN) );
	m_RingIcon.Kasan.SetBlendNo		( SPR_BLEND_ONE );
	m_RingIcon.Kasan.SetFlag		( true, CENTER_FLAG|SIZE_FLAG ); 
	m_RingIcon.Kasan.SetTwoSize		( RING_KASAN_NORMAL, RING_KASAN_NORMAL );
	
	m_RingIcon.Kasan2.SetTexSprite	( RING_KASAN_X-m_fScrollX+RING_KASAN2_X, RING_KASAN_Y+RING_KASAN2_Y, g_pSpData->GetTexture(TEX_RING_KASAN2) );
	m_RingIcon.Kasan2.SetBlendNo	( SPR_BLEND_ONE );
	m_RingIcon.Kasan2.SetFlag		( true, CENTER_FLAG|SIZE_FLAG );
	m_RingIcon.Kasan2.SetTwoSize	( RING_KASAN2_SIZEX*0.5f, RING_KASAN2_SIZEY*0.5f );
	SET_SPRITE_ROT( &m_RingIcon.Kasan2, m_RingIcon.KasanAngle, RING_KASAN_X+RING_KASAN2_X+5.0f, RING_KASAN_Y+RING_KASAN2_Y+28.0f, m_RingIcon.Kasan2.GetSizeX(), m_RingIcon.Kasan2.GetSizeY() );
	m_RingIcon.Sample.SetTexSprite	( RING_SAMPLE_X-m_fScrollX, RING_SAMPLE_Y, g_pSpData->GetTexture(TEX_STONE), SP_RING_NUM, 1,  RING_NOT_NO );
	m_RingIcon.Sample.SetTwoSize	( 56.0f, 56.0f );
	m_RingIcon.Sample.SetVisible	( false );		//	̎wւ`悷

	//	O	**************************************************
	int NowRingNo=-1;		//	ݎĂ̃gbvob^[
	if( WK7PLAYERCONTROL->GetMainID() != K7GAL ){		
		int RingIconNo=0;
		for( i = 0; i < RING_CHANGE_NUM; i++ ){
			if( tblRingData[i] == -1 )	break;
			if( GameInfo.GetGlobalFlag( tblRingData[i] ) ){
				m_RingIcon.iIconNum++;
				m_RingIcon.Obj[RingIconNo].TexNo = (u8)i;
				m_RingIcon.HasNo[RingIconNo] = (u8)i;		//	f[^Z[u
				//	~jO쐬	---------------------------------------------
				m_RingIcon.Mini[RingIconNo].SetTexSprite	( RING_MINI_X + RingIconNo * (RING_SIZE-10)-m_fScrollX, RING_MINI_Y, g_pSpData->GetTexture(TEX_STONE), SP_RING_NUM, 1, (u16)i );
				m_RingIcon.Mini[RingIconNo].SetTwoSize		( RING_MINI_SIZE, RING_MINI_SIZE );
				m_RingIcon.Mini[RingIconNo].SetFlag			( true, RENDER_FLAG|SIZE_FLAG );
				RingIconNo++;
				if( NowRingNo == -1 )	NowRingNo = i;
			}
		}
		//	eNX`[ԍ쐬	--------------------------------------------
		if( K7EVENT_GL_VAR(PutRing) != -1 ){
			int StopNo;
			for( StopNo = 0; StopNo < m_RingIcon.iIconNum; StopNo++ ){
				if( m_RingIcon.HasNo[StopNo] == K7EVENT_GL_VAR(PutRing) ) break;
			}
			for( i = 0; i < m_RingIcon.iIconNum; i++ ){
				if( (StopNo+i) >= m_RingIcon.iIconNum ){
					if( i == 0 )	m_RingIcon.SaveNo = m_chRingSelect = (s8)(StopNo+i-m_RingIcon.iIconNum);
					m_RingIcon.Obj[i].TexNo = m_RingIcon.HasNo[StopNo+i-m_RingIcon.iIconNum];
				}else{
					if( i == 0 )	m_RingIcon.SaveNo = m_chRingSelect = (s8)(StopNo+i);
					m_RingIcon.Obj[i].TexNo = m_RingIcon.HasNo[StopNo+i];
				}
			}
		}
	}else{		//	KVA̎
		m_RingIcon.iIconNum = 1;
		m_RingIcon.Obj[0].TexNo = RING_CHANGE_NUM;
	}
	//	OĂȂ	------------------------------------------------------
	if( ((m_RingIcon.iIconNum == 0 || K7EVENT_GL_VAR(PutRing) == -1) && WK7PLAYERCONTROL->GetMainID() != K7GAL) ||
		( WK7PLAYERCONTROL->GetMainID() == K7GAL && !K7SCR_GET_GLOBAL_FLAG( K7GLFL_RING_EYE ) ))
	{
		if( GameInfo.GetScenarioID() == K7SCN06 ){
			m_RingIcon.Sample.SetVisible( false );	//	̎wւ`悷
		}else{
			m_RingIcon.Sample.SetVisible( true );	//	̎wւ`悷
			m_RingIcon.Sample.SetAlpha( 0x7f );
		}
	}
	//	OW쐬	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	f32 icon_r = RING_ICON_R;
	if( m_RingIcon.iIconNum < 4 )	icon_r = RING_ICON_R2;
	
	for( int i = 0; i < m_RingIcon.iIconNum; i++ ){
		m_RingIcon.Obj[i].pv.x = icon_r * ( cosf( (TWO_PI)/m_RingIcon.iIconNum*i+MTXDegToRad(250)));
		m_RingIcon.Obj[i].pv.y = icon_r * ( sinf( (TWO_PI)/m_RingIcon.iIconNum*i+MTXDegToRad(250)));
		m_RingIcon.Obj[i].pv.z 	= 0.0f;
		m_RingIcon.Obj[i].w 	= m_RingIcon.Obj[i].h = RING_ICON_SIZE;
				
		m_RingIcon.Obj[i].v.x = m_RingIcon.Obj[i].pv.x*sinf( m_RingIcon.fAngle ) - m_RingIcon.Obj[i].pv.y*cosf( m_RingIcon.fAngle );
		m_RingIcon.Obj[i].v.y = RING_ICON_KATAMUKI;
		m_RingIcon.Obj[i].v.z = m_RingIcon.Obj[i].pv.x * cosf( m_RingIcon.fAngle ) + m_RingIcon.Obj[i].pv.y * sinf( m_RingIcon.fAngle );
			
		m_RingIcon.Stone[i].SetTexture	( g_pSpData->GetTexture(TEX_STONE), SP_RING_NUM, 1 );
		m_RingIcon.Stone[i].SetFlag		( true, BLOCK_FLAG );
	}
	IconZSort();		//	y\[g
	ChangeView();		//	ϊ

	//	邵񂶂Ȃ悗
	if( WK7PLAYERCONTROL->GetMainID() != K7GAL ){
		if( K7EVENT_GL_VAR(PutRing) != -1 ){
			m_RingIcon.SelectNo = K7EVENT_GL_VAR(PutRing);
			SetRingImage(K7EVENT_GL_VAR(PutRing));	//	O`Zbg
			m_RingIcon.Kasan.SetVisible(true);
		}else{
			m_RingIcon.SelectNo = RING_NOT_NO;
			SetRingImage((s8)NowRingNo);	//	O`Zbg
			for( i = 0; i < m_RingIcon.iIconNum; i++ )	m_RingIcon.Stone[i].SetVisible( false );
		}
		m_bRingNameFlag = true;
	}else{
		SetRingImage(RING_CHANGE_NUM);	//	O`Zbg
		m_bRingNameFlag = true;
		m_RingIcon.SelectNo = RING_CHANGE_NUM;
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_RING_EYE ) ){
			m_RingIcon.Stone[0].SetVisible(true);
			m_RingIcon.Kasan.SetVisible(true);
		}else{
			m_RingIcon.SelectNo = RING_NOT_NO;
			m_RingIcon.Stone[0].SetVisible(false);
			m_RingIcon.Kasan.SetVisible(false);
		}
	}
	for( i = 0; i < m_RingIcon.iIconNum; i++ )	m_RingIcon.Stone[i].SetIncX( -m_fScrollX );

	//	Ol[	=========================================================
	m_fRingNameX = RING_NAME_CENTERX - (m_pYFont->DrawFSStr( m_fRingNameX, 	RING_NAME_Y, false, false, 	tblRingName[m_RingIcon.SelectNo] )*0.5f)-m_fScrollX;
	
	//	ZNgg	::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	for( i = 0; i < SELECT_WAKU_NUM; i++ ){
		m_spSelect[i].SetTexSprite	( tblSelectWaku[i].vL.x, tblSelectWaku[i].vL.y, g_pSpData->GetTexture((u8)tblSelectWaku[i].TexNo) );
		m_spSelect[i].SetColor		( 0x000000ff );
		m_spSelect[i].SetVisible	(false);
	}
	m_spSelect[0].SetFlag( true, SIZE_FLAG );
	SET_SPRITE_ROT( &m_spSelect[SELECT_WAKU_ROTNO], 270, tblSelectWaku[SELECT_WAKU_ROTNO].vL.x+tblSelectItemPos[0].x+11, 
					tblSelectWaku[SELECT_WAKU_ROTNO].vL.y+tblSelectItemPos[0].y+36, m_spSelect[SELECT_WAKU_ROTNO].GetTexSizeX(), m_spSelect[SELECT_WAKU_ROTNO].GetTexSizeY() ); 
	m_spSelect[0].SetXY0	( tblSelectWaku[i].vL.x+tblSelectItemPos[0].x, 250.0f );
	m_spSelect[0].SetTwoSize( m_spSelect[0].GetTexSizeX(), tblWakuUpSize[0] );
	for( i = 0; i < 2; i++ ){
		m_spItemName[i].SetTexSprite	( tblItemNamePos[0].x+i*2, tblItemNamePos[0].y+i*2, g_pSpData->GetTexture(TEX_SELECT_NAME), 1, 5, 0 );
		m_spItemName[i].SetVisible		( false );
		m_spItemName[i].SetAlpha		(0xff);
	}
	m_spItemName[1].SetColor( 0x000000ff );
	
	//	ǃRł͂Ȃ.
	m_Sore.Time 		= 0;
	m_Sore.SelectFlag 	= false;
	m_Sore.spFont.SetTexSprite	( SORE_X, SORE_Y, g_pSpData->GetTexture(TEX_MOJI_SORE) );
	m_Sore.spFont.SetVisible	( false );
	m_Sore.spPlate.SetTexSprite	( SORE_X, SORE_Y, g_pSpData->GetTexture(TEX_MOJI_PLATE) );
	m_Sore.spPlate.SetColor		( 0x000000ff );
	m_Sore.spPlate.SetVisible	( false );
	
	//	̃{bNX
	m_spLeftBox.SetSpriteFlex	( 0.0f, 244.0f, 129.0f,244.0f,  0.0f, 255.0f, 62.0f, 255.0f, 0x000000ff );
	m_spLeftBox.SetVisible		( true );
	
	//	fVbg
	m_spDL.SetTexSprite			( m_Beaker.Body.GetX0()+DL_X, m_Beaker.Body.GetY0()+DL_Y, g_pSpData->GetTexture(TEX_DL) );
	m_spDL.SetColor				( 0x000000ff );
	m_spDL.SetVisible			( true );

	if( true != WK7PLAYERCONTROL->PcDieTest() ) gpSound->mPlaySE(SFX_SYS_SUBSCREEN_OPEN);
}

//========================================================================
//					t[
//========================================================================
bool 	SK7Special::FrameProcess(void)
{
	if( !m_bControlFlag )	return true;
	int i;
	//	I	**********************************************************
	if( (m_eProc == PROC_BLOCK_SELECT && HSD_PadGetTrigger(0) & (HSD_PAD_START|HSD_PAD_B)) ||
		true == WK7PLAYERCONTROL->PcDieTest() ){
		m_bRingNameFlag = false;
		m_bMoveFlag = false;
		//	VhȄ	==========================================
		for( i = 0; i < SELECT_FONT_MAX; i++ ){
			m_ShadowSmall.Font[i].SetVisible( false );
			m_ShadowBig.Font[i].SetVisible( false );
		}
		if( WK7PLAYERCONTROL->GetBloodPackEffectPtr() != NULL ){
			SetBloodPackDrawX( WK7PLAYERCONTROL->GetBloodPackEffectPtr(), (int)(-m_fScrollX) );
		}
		m_RingIcon.Kasan2.SetVisible( false );
		m_Photo.Big.SetVisible(false);
		for( i = 0; i < SELECT_WAKU_NUM; i++ )	m_spSelect[i].SetVisible( false );
		for( i = 0; i < 2; i++ )				m_spItemName[i].SetVisible( false );
		if( true != WK7PLAYERCONTROL->PcDieTest() )  gpSound->mPlaySE(SFX_SYS_SUBSCREEN_CLOSE);
		m_eProc = PROC_MOVE;
	}
	//	ZNgtHg̃At@	***********************************
	if( m_bBlockFlag ){
		if( m_bLightMoveFlag ){
			if( m_spLight.AddAlpha( LIGHT_ALPHA_TIME, 0xff ) )		m_bLightMoveFlag = false;
		}else{
			if( m_spLight.DownAlpha( LIGHT_ALPHA_TIME, 0x7f ) )		m_bLightMoveFlag = true;
		}
		SetSelectAlpha( (u8)m_chBlockSelect, SET_ALPHA_DOWN );
	}else{
		m_bLightMoveFlag = false;
		m_spLight.SetAlpha( 0xff );
	}
	//	tz	*****************************************************
	m_Beaker.Blood.SetSizeY( -((f32)m_pOption->GetBloodGauge(BP_THICK) * ((f32)BEAKER_BODY_SIZEY/(f32)BLOOD_THICK_GAUGE_MAX)) );
	
	//	ZNgtHg	*************************************
	if( m_eProc == PROC_NAME_SELECT || m_eProc == PROC_ITEM || m_eProc == PROC_LIFE || m_eProc == PROC_MEMO ){
		SetAnswerAlpha( (u8)m_chBlockSelect );
	}

	switch( m_eProc )
	{
	//	ړ	**********************************************************
	case PROC_MOVE:
		if( MoveWindow(m_bMoveFlag) ){
			if( m_bMoveFlag ){
				m_eProc = PROC_BLOCK_SELECT;
			}else{
				m_pOption->InitOptionWindow();
				m_pOption->SetMacineRender( false );
				m_pOption->SetBeakerRender( false );
				m_pOption->SetRenderConpas( true );
				m_pOption->SetCodeFlag	  ( false );
				m_pOption->SetNoudoRender ( true );
				m_pOption->SetEnemyConpasRender( m_bEnemyConpasFlag );
				GHM_SAFE_DELETE_ARRAY( m_spBgFrame );
				GHM_SAFE_DELETE_ARRAY( m_spBgFrameTex );
				m_eProc = PROC_EXIT;
			}
		}
		break;

	//	BLOCK	**********************************************************
	case PROC_BLOCK_SELECT:	FrameBlockProcess();		break;
			
	//	l[	**********************************************************
	case PROC_NAME_SELECT:	FrameCharaProcess();		break;

	//	ACeI	**********************************************************
	case PROC_ITEM:		FrameItemProcess();		break;
		
	//	񕜑I	**********************************************************
	case PROC_LIFE:		FrameBloodProcess();	break;
		
	//		**********************************************************
	case PROC_MEMO:		FrameMemoProcess();		break;
				
	//	o	**********************************************************
	case PROC_EXIT:
		break;
	}
	
	return true;
}


//========================================================================
//					_O
//========================================================================
bool 	SK7Special::RenderWindowProcess(void)
{
	if( !m_bRenderFlag )	return true;
	
	m_spWindow.Render();
	m_spRightWin.Render();
	m_spLWin.Render();
	return true;
}

//========================================================================
//					_O
//========================================================================
bool 	SK7Special::RenderProcess(void)
{
	if( !m_bRenderFlag )	return true;

	if( !m_bMenuRenderFlag ){
		m_spLight.Render();

		//	uh߂
		GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );

		int i;

		for( i = 0; i < BF_NOTEX_MAX; i++ ){
			m_spBgFrame[i].Render();
		}
		for( i = 0; i < BF_TEX_MAX; i++ ){
			m_spBgFrameTex[i].Render();
		}
		m_spLeftBox.Render();
		for( i = 0; i < m_chCharaNum; i++ ){
			m_NamePlate[i].Back.Render();
			m_NamePlate[i].LineH.Render();
			m_NamePlate[i].LineW.Render();
			m_NamePlate[i].Triangle.Render(); 
			m_NamePlate[i].Mini.Render();
		}
		
		m_spNameKasan.Render();
		//	uh߂
		GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );

		//	Ll[tHg	---------------------------------
		char* strCharaName[]={ "Dan", "KAEDE" , "Kevin", "Coyote", "Con", "MASK De", "Harman" };
		for( i = 0; i < m_chCharaNum; i++ ){
			if( m_NamePlate[i].NameVisible ){
				m_pYFont->DrawSetup();
				m_pYFont->SetExRate( 1.0f );
				m_pYFont->SetColor2( m_NamePlate[i].NameColor );
				if( WK7PLAYERCONTROL->GetMainID() == K7GAL ){
					m_pYFont->DrawFSStr( m_NamePlate[i].Back.GetX0()+NAME_GAP_X, 	NAME_PLATE_FONTY( m_NamePlate[i].Back.GetY0() ), false, true, "Garcian" ); 
					m_pYFont->DrawFSStr( m_NamePlate[i].Back.GetX0()+NAME_SMITH_X,	NAME_PLATE_FONTY( m_NamePlate[i].Back.GetY0() ), false, true, "Smith" ); 
				}else{
					m_pYFont->DrawFSStr( m_NamePlate[i].Back.GetX0()+NAME_GAP_X, 	NAME_PLATE_FONTY( m_NamePlate[i].Back.GetY0() ), false, true, strCharaName[i] ); 
					m_pYFont->DrawFSStr( m_NamePlate[i].Back.GetX0()+NAME_SMITH_X, 	NAME_PLATE_FONTY( m_NamePlate[i].Back.GetY0() ), false, true, "Smith" ); 
				}
			}
		}

		for( i = 0; i < SP_BULLET_NUM; i++ ){
			m_Bullet[i].Render();
		}
		for( i = 0; i < ITEM_NUM_MAX; i++ ){
			m_spItem[i].Render();
		}
		if( m_pspSubIcon != NULL )	m_pspSubIcon->Render();
		m_Photo.Small.Render();
		m_spMemo.Render();
		m_spChara.Render();
		m_spCharaFrame.Render();
		m_Panel.sprite.Render();

		//	OACR	-------------------------------------
		for( i = 0; i < m_RingIcon.iIconNum; i++ ){
			m_RingIcon.Stone[i].Render();
			m_RingIcon.Mini[i].Render();
		}
		//	OTv	-------------------------------------
		m_RingIcon.Sample.Render();
		
		//	ZNgg	--------------------------------------------------------------
		for( i = 0; i < SELECT_WAKU_NUM; i++ ){
			m_spSelect[i].Render();
		}
		m_spItemName[1].Render();
		m_spItemName[0].Render();
		
		RenderRingName();	//	Ol[

		//	wւ̉Z	------------------------------------------
		m_RingIcon.Kasan.Render();
		m_RingIcon.Kasan2.Render();
		GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );

		//	r[J[	-----------------------------------------
		m_Beaker.Bottom.Render();
		m_Beaker.Blood.Render();
		m_Beaker.Body.Render();
		m_Beaker.Memori.Render();
		m_Beaker.Top.Render();
		m_Beaker.Under.Render();
		m_Beaker.Pipe[0].Render();	
		m_Beaker.Pipe[1].Render();	
		YK7StrImage* pString = m_pOption->GetYamadaFont();
		pString->DrawSetup();
		pString->SetColor2( 0x000000ff );
		pString->SetExRate( 1.1f );
		pString->SetJikan( -3 );
		pString->DrawFSStr( m_Beaker.Body.GetX0()+THICK_BLOOD_GAPX, 	m_Beaker.Body.GetY0()+THICK_BLOOD_GAPY,  true, true, "%d",m_pOption->GetBloodGauge(BP_THICK)  ); 
		pString->SetJikan( 0 );
		m_spDL.Render();
		
		//	RctHg	--------------------------------
		RenderCharaState();

		//	_	----------------------------------------
		if( m_pspMedal != NULL )	m_pspMedal->Render();
		
		//	}XN	-----------------------------------------------
		for( int i = 0; i < MASK_MAX; i++ ){
			m_spMask[i].Render();
		}

		//	t	-------------------------------------------------
		for( i = 0; i < LIFE_BLOOD_NUM; i++ ){
			if( m_pLifeBlood != NULL ){
				m_pLifeBlood[i].Blood.Render();
			}
		}		

		for( i = 0; i < SELECT_FONT_MAX; i++ )	m_ShadowSmall.Font[i].Render();
		for( i = 0; i < SELECT_FONT_MAX; i++ )	m_ShadowBig.Font[i].Render();
		
		for( i = 0; i < SELECT_FONT_MAX; i++ ){
			if( i < 3 ){
				m_SelectFont.Chara[i].Render();
			}
			if( i < 2 ){
				m_SelectFont.Memo[i].Render();
				m_SelectFont.Blood[i].Render();
			}
			m_SelectFont.Item[i].Render();
		}	
		//	łʐ^	::::::::::::::::::::::::::::::::::::::::::::::::::::
		m_Photo.Big.Render();
		
		//	ǂł͂Ȃ
		m_Sore.spPlate.Render();
		m_Sore.spFont.Render();
	}else{
		//	uh߂
		GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );

		if( m_pMenu != NULL ){
			m_pMenu->RenderProcess();
		}
	}
	screenImageFullColor.ScreenCopy();
	return true;
}


//========================================================================
//				EBhEړ
//========================================================================
bool		SK7Special::MoveWindow( bool State )
{
	int i;
	f32 MoveX;
	if( State ){
		MoveX = m_fScrollX/SP_MOVE_FRAME;
	}else{
		MoveX = -640/SP_MOVE_FRAME;
	}
	m_pOption->MoveOptionX( State );
	
	m_spWindow.SetIncX		( MoveX );
	m_spLWin.SetIncX		( MoveX );
	m_spRightWin.SetIncX	( MoveX );
	m_spChara.SetIncX		( MoveX );
	m_spCharaFrame.SetIncX	( MoveX );
	m_spNameKasan.SetIncX	( MoveX );
	m_Photo.Small.SetIncX	( MoveX );
	m_spMemo.SetIncX		( MoveX );
	m_Panel.sprite.SetIncX	( MoveX );
	if( m_pspSubIcon != NULL )	m_pspSubIcon->SetIncX		( MoveX );
	m_RingIcon.Kasan.SetIncX( MoveX );
	m_RingIcon.Kasan2.SetIncX( MoveX );
	m_RingIcon.Sample.SetIncX( MoveX );
	m_spLight.SetIncX		( MoveX );
	m_Beaker.Body.SetIncX	( MoveX );
	m_Beaker.Bottom.SetIncX	( MoveX );
	m_Beaker.Memori.SetIncX	( MoveX );
	m_Beaker.Top.SetIncX	( MoveX );
	m_Beaker.Blood.SetIncX	( MoveX );
	m_Beaker.Under.SetIncX	( MoveX );
	m_Beaker.Pipe[0].SetIncX( MoveX );
	m_Beaker.Pipe[1].SetIncX( MoveX );
	m_spDL.SetIncX			( MoveX );
	if( m_pspMedal != NULL )		m_pspMedal->SetIncX( MoveX );

	for( i = 0; i < 4; i++ ){
		if( i < 3 ){
			m_SelectFont.Chara[i].SetIncX	( MoveX );
		}
		if( i < 2 ){
			m_SelectFont.Memo[i].SetIncX	( MoveX );
			m_SelectFont.Blood[i].SetIncX	( MoveX );
		}
		m_SelectFont.Item[i].SetIncX	( MoveX );
	}

	m_fStateFontX	+= MoveX;
	m_fBloodNoX		+= MoveX;
	m_fRingNameX 	+= MoveX;
	m_fMedalX		+= MoveX;


	for( i = 0; i < ITEM_NUM_MAX; i++ ){
		m_spItem[i].SetIncX( MoveX );
	}
	for( i = 0; i < BF_NOTEX_MAX; i++ ){
		m_spBgFrame[i].SetIncX( MoveX );
	}
	for( i = 0; i < BF_TEX_MAX; i++ ){
		m_spBgFrameTex[i].SetIncX( MoveX );
	}
	for( int i = 0; i < m_chCharaNum; i++ ){
		m_NamePlate[i].Back.SetIncX		( MoveX );
		m_NamePlate[i].LineW.SetIncX	( MoveX );
		m_NamePlate[i].LineH.SetIncX	( MoveX );
		m_NamePlate[i].Triangle.SetIncX	( MoveX ); 
		m_NamePlate[i].Mini.SetIncX		( MoveX );
	}
	for( i = 0; i < m_RingIcon.iIconNum; i++ ){
		m_RingIcon.Stone[i].SetIncX	( MoveX );		
		m_RingIcon.Mini[i].SetIncX	( MoveX );		
	}
	for( int i = 0; i < SP_BULLET_NUM; i++ ){
		m_Bullet[i].SetIncX( MoveX );
	}
	for( i = 0; i < MASK_MAX; i++ ){
		m_spMask[i].SetIncX( MoveX );
	}

	if( ++m_iMoveTime >= SP_MOVE_FRAME ){
		m_iMoveTime = 0;
		return true;
	}
	return false;
}

//========================================================================
//				LIC
//========================================================================
void		SK7Special::CharaSelectState( s8 Select, bool flag )
{
	//	}XNLvUpΉ	---------------------------------------------
	u8 NameSelectNo = (u8)m_chNameSelect;
	if( NameSelectNo == 5 ){
		switch( BattleCtrl.GetMskPowerUp() ){
		case KK7BATTLECTRL_MSKLV_TEXAS:		NameSelectNo = 7; 		break;
		case KK7BATTLECTRL_MSKLV_FINAL:		
		case KK7BATTLECTRL_MSKLV_TEKKAMEN:	NameSelectNo = 8;		break;
		}
	}
	m_spChara.SetTexNo( (u8)(NameSelectNo+1) );
	
	if( flag ){
		if( m_chNameSelect != Select ){
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_CHOOSE );
		}	
	}
}

//========================================================================
//				LIC
//========================================================================
void		SK7Special::FrameCharaProcess()
{
	m_iKeyTime++;
		//	KV[`FbN	----------------------------------------------
	if( m_chSaveSelect != -1 ){
		
		//	ɓ	------------------------------------------
		for( int i = 0; i < m_chCharaNum; i++ ){
			if( m_chNameSelect != i ){
				SetNamePlateIncPos( &m_NamePlate[i], (u8)i, false, NAME_BACK_SPEED );
				if( m_NamePlate[i].Back.GetX0() >= NAME_BACK_X ){
					SetNamePlatePositon( &m_NamePlate[i], (u8)i, 0 );
				}
			}else{
				SetNamePlateIncPos( &m_NamePlate[i], (u8)i, false, NAME_FRONT_SPEED );
				if( m_NamePlate[i].Back.GetX0() <= (NAME_BACK_X + NAME_SELECT_PLUSX) ){
					SetNamePlatePositon( &m_NamePlate[i], (u8)i, NAME_SELECT_PLUSX );
				}
				m_spNameKasan.SetXY0( m_NamePlate[i].Back.GetX0()+NAME_SELECT_PLUSX+KASAN_GAPX, m_fNameBackY+i*NAME_GAP_Y+KASAN_GAPY );
			}
		}
		if( CheckKeyN( SK7_KEY_UP ) && m_iKeyTime > NAME_KEY_FRAME ){
			m_iKeyTime = 0;
			s8 SaveSelect = m_chNameSelect;
			m_chNameSelect--;
			if( m_chNameSelect < 0 )	m_chNameSelect = (s8)(m_chCharaNum-1);
			while( m_NamePlate[m_chNameSelect].Back.GetAlpha() == NAME_NOT_ALPHA ){
				if( --m_chNameSelect < 0 ){
					m_chNameSelect = (s8)(m_chCharaNum-1);
				}
			}
			CharaSelectState( SaveSelect );
			return;
		}
		if( CheckKeyN( SK7_KEY_DOWN ) && m_iKeyTime > NAME_KEY_FRAME ){
			m_iKeyTime = 0;
			s8 SaveSelect = m_chNameSelect;
			m_chNameSelect++;
			if( m_chNameSelect >= m_chCharaNum )	m_chNameSelect = 0;
			while( m_NamePlate[m_chNameSelect].Back.GetAlpha() == NAME_NOT_ALPHA ){
				if( ++m_chNameSelect >= m_chCharaNum ){
					m_chNameSelect = 0;
				}
			}
			CharaSelectState( SaveSelect );
			return;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			if( m_chSaveSelect == m_chNameSelect ){
				gpSound->mPlaySE( SFX_SYS_SUBSCREEN_BOO );
				return;
			}
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_DECISION );
			m_lRetCode = RESULT_SP_CHARA*(m_chNameSelect+1);
			m_pOption->InitOptionWindow();
			GHM_SAFE_DELETE_ARRAY( m_spBgFrame );
			GHM_SAFE_DELETE_ARRAY( m_spBgFrameTex );
			m_eProc = PROC_EXIT;
			return;
		}
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		m_bBlockFlag = false;
		SetSelectAlpha( (u8)m_chBlockSelect, SET_ALPHA_FULL );
		m_spLight.SetVisible( false );
		gpSound->mPlaySE( SFX_SYS_SUBSCREEN_CANSEL );
		if( m_chSaveSelect != -1 ){
			m_chNameSelect = m_chSaveSelect;
			SetAllNamePlate( (u8)m_chNameSelect );
			for( int i = 0; i < m_chCharaNum; i++ ){
				if( m_chNameSelect != i )	m_NamePlate[i].MoveTime = 0;
				else						m_NamePlate[i].MoveTime = NAME_MOVE_TIME;
			}
			CharaSelectState( false );
			CheckDeath();
		}
		m_chBlockSelect = BLOCK_SELECT_CANCEL;
		m_eProc = PROC_BLOCK_SELECT;
		return;
	}
}



//========================================================================
//				ACeIC
//========================================================================
void		SK7Special::FrameItemProcess()
{
	int i;
#ifdef __RING_DEBUG__
	static f32 YAN = 270, XAN = 270, RR = RING_ICON_R, KK = RING_ICON_KATAMUKI;
	XAN += HSD_PadGetNormalStickX(0);	
	YAN += HSD_PadGetNormalStickY(0);
	if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT )	RR++;
	if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT )	RR--;
	if( HSD_PadGetRepeat(0) & HSD_PAD_Y )		KK++;
	if( HSD_PadGetRepeat(0) & HSD_PAD_X )		KK--;
#endif
	
#ifdef __DEBUG_SELECT__
	static f32 XP=320, YP=240;
	XP += HSD_PadGetNormalStickX(0);
	YP += HSD_PadGetNormalStickY(0);
	for( int i = 0; i < SELECT_WAKU_NUM; i++ ){
		m_spSelect[i].SetVisible( true );
		m_spSelect[i].SetXY0( XP+tblSelectWaku[i].vL.x, YP+tblSelectWaku[i].vL.y );
	}
#endif
	
#ifdef __DEBUG_ITEM3__
	if( m_pspSubIcon != NULL )	DEBUG_GET_2D_POS( m_pspSubIcon );
#endif	
	//	ǂł͂Ȃ		
	if( m_pOption->GetBossFlag() && m_Sore.SelectFlag ){
		if( MoveSore() ){
			m_eItemProc = ITEM_PROC_SELECT;		//	ZNg		
			m_Sore.SelectFlag = false;
		}
		return;
	}
	
	//	OZ		
	if( m_RingIcon.bKasanFlag ){
		m_RingIcon.KasanTime++;
		m_RingIcon.KasanAngle += (360/(RING_KASAN_SMALL_TIME+RING_KASAN_BIG_TIME));
		if( m_RingIcon.KasanTime < RING_KASAN_BIG_TIME ){
			m_RingIcon.Kasan.SetIncSizeXY	( (RING_KASAN_BIG-RING_KASAN_MINI)/RING_KASAN_BIG_TIME, (RING_KASAN_BIG-RING_KASAN_MINI)/RING_KASAN_BIG_TIME );
		}else if( m_RingIcon.KasanTime < RING_KASAN_SMALL_TIME+RING_KASAN_BIG_TIME){
			m_RingIcon.Kasan.SetIncSizeXY	( (RING_KASAN_NORMAL-RING_KASAN_BIG)/RING_KASAN_SMALL_TIME, (RING_KASAN_NORMAL-RING_KASAN_BIG)/RING_KASAN_SMALL_TIME );
		}else{
			m_RingIcon.bKasanFlag = false;
			m_RingIcon.KasanTime = 0;
		}
	}
	//	OZ2 		
	if( m_RingIcon.bLightFlag ){
		m_RingIcon.LightTime++;
		if( m_RingIcon.LightTime < RING_KASAN_BIG_TIME ){
			m_RingIcon.Kasan2.SetIncSizeXY	( (RING_KASAN2_SIZEX*0.7f)/RING_KASAN_BIG_TIME, (RING_KASAN2_SIZEY*0.7f)/RING_KASAN_BIG_TIME );
		}else if( m_RingIcon.LightTime < RING_KASAN_SMALL_TIME+RING_KASAN_BIG_TIME){
			m_RingIcon.Kasan2.SetIncSizeXY	( (RING_KASAN2_SIZEX*0.2f)/RING_KASAN_SMALL_TIME, (RING_KASAN2_SIZEY*0.2f)/RING_KASAN_SMALL_TIME );
		}else{
			m_RingIcon.Kasan2.SetVisible(false);
			m_RingIcon.LightTime = 0;
			m_RingIcon.bLightFlag = false;
		}
		SET_SPRITE_ROT( &m_RingIcon.Kasan2, m_RingIcon.KasanAngle, RING_KASAN_X+RING_KASAN2_X+5.0f, RING_KASAN_Y+RING_KASAN2_Y+28.0f, m_RingIcon.Kasan2.GetSizeX(), m_RingIcon.Kasan2.GetSizeY() );
	}

	m_iKeyTime++;
	
	switch( m_eItemProc ){
	//	ACeI	
	case ITEM_PROC_SELECT:
		//	ZNgg	------------------------------------------------
		for( i = 0; i < SELECT_WAKU_NUM; i++ ){
			if( i < tblSelectAnim[m_iSelectTime].RenderNo )		m_spSelect[i].SetVisible( true );
			if( i != SELECT_WAKU_ROTNO ) 						m_spSelect[i].SetEX( tblSelectAnim[m_iSelectTime].Ex[i] );
		}
		//	IJ[Zbg	---------------------------------------
		switch( m_chItemSelect ){
		case ITEM_SELECT_RING:	SetRingSelectState( true, false, true );	break;
		case ITEM_SELECT_PHOTO:	SetRingSelectState( false, true, false );	break;
		default:				SetRingSelectState( false, false, false );	break;
		}
		if( ++m_iSelectTime > SELECT_WAKU_TIME-1 ){
			m_iSelectTime = SELECT_WAKU_TIME-1;
			//	ACe	---------------------------------------------
			for( i = 0; i < 2; i++ ){
				m_spItemName[i].SetXY0		( tblItemNamePos[m_chItemSelect].x+i*2, tblItemNamePos[m_chItemSelect].y+i*2 );
				m_spItemName[i].SetTexNo	( (u16)m_chItemSelect );
				m_spItemName[i].SetVisible	( true );
			}
		}
		
		//	ACeIĂƂ̃ACe̓_	:::::::::::::::::::::::::::::::::::::
		for( i = 0; i < 2; i++ ){
			if( m_iItemNameTime < ITEM_NAME_ALPHA_TIME ){
				m_spItemName[i].DownAlpha( ITEM_NAME_ALPHA_TIME, 0x00 );
			}
			else if( m_iItemNameTime < ITEM_NAME_ALPHA_TIME*2 ){
				m_spItemName[i].AddAlpha( ITEM_NAME_ALPHA_TIME, 0xff );				
			}
			else if( m_iItemNameTime > ITEM_NAME_ALPHA_TIME*2+5 ){
				m_iItemNameTime = 0;
			}
		}
		m_iItemNameTime++;
		
		//	I	:::::::::::::::::::::::::::::::::::::::::::::::
		if( CheckKeyT( SK7_KEY_RIGHT|SK7_KEY_UP ) ){
			m_iKeyTime = 0; 
			if( m_chItemSelectNo == 0 )	break;
			if( m_chItemSelectNo == 1 && WK7PLAYERCONTROL->GetMainID() == K7GAL )	break;
			//	wẐƂ	---------------------------------------
			if( GameInfo.GetScenarioFlow() == K7SCNF_SCL ){
				//	{CXR[_`FbN	---------------------------
				if( K7SCR_GET_SCENARIO_FLAG( VRHAVE ) ){
					if( WK7PLAYERCONTROL->GetMainID() == K7GAL ){
						if( m_chItemSelectNo==2 )	m_chItemSelectNo = 1;
					}else{
						m_chItemSelectNo--;
					}
				}else{
					if( WK7PLAYERCONTROL->GetMainID() == K7GAL )	break;
					m_chItemSelectNo = 0;	//	KVAȊO͎wւ
				}
			}else{
				m_chItemSelectNo--;
			}
			m_chItemSelect = tblItemSelectNo[GameInfo.GetScenarioFlow()].No[m_chItemSelectNo];
			//	g̈ړ	-----------------------------------------------------------
			SetSelectWaku();
			m_iSelectTime = 0;
			for( i = 0; i < 2; i++ )	m_spItemName[i].SetVisible	( false );

			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_CHOOSE );
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT|SK7_KEY_DOWN ) ){
			m_iKeyTime = 0;
			//	ʐ^ȂƂׂ͂Ȃ	----------------------------------------
			if( !m_Photo.Small.CheckFlag( RENDER_FLAG ) )	break;
			//	{CXR[_[ĂȂƑIłȂ	------------------------
			if( m_chItemSelect==ITEM_SELECT_RING && GameInfo.GetScenarioFlow() == K7SCNF_SCL && K7SCR_GET_SCENARIO_FLAG( VRHAVE ) == false ){
				m_chItemSelectNo = 2;
			}else{
				if( m_chItemSelectNo == m_chItemNum-1 )	break;
				m_chItemSelectNo++;
			}
			m_chItemSelect = tblItemSelectNo[GameInfo.GetScenarioFlow()].No[m_chItemSelectNo];
			
			//	g̈ړ	-----------------------------------------------------------
			SetSelectWaku();
			m_iSelectTime = 0;
			for( i = 0; i < 2; i++ )	m_spItemName[i].SetVisible	( false );
			
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_CHOOSE );
			break;
		}
		//		:::::::::::::::::::::::::::::::::::::::::::::::
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			//	g̈ړ	-----------------------------------------------------------
			for( i = 0; i < SELECT_WAKU_NUM; i++ ){
				m_spSelect[i].SetVisible( true );
				m_spSelect[i].SetEX( 1.0f );
			}
			SetSelectWaku(true);
			m_iSelectTime = SELECT_WAKU_TIME-1;
			
			//	{XŊĴACêƂ
			if( m_pOption->GetBossFlag() && (m_chItemSelect > ITEM_SELECT_PHOTO) ){
				m_Sore.spFont.SetVisible	( true );
				m_Sore.spPlate.SetVisible	( true );
				m_Sore.SelectFlag = true;
				return;
			}
			//	ACe	---------------------------------------------
			for( i = 0; i < 2; i++ ){
				m_spItemName[i].SetXY0		( tblItemNamePos[m_chItemSelect].x+i*2, tblItemNamePos[m_chItemSelect].y+i*2 );
				m_spItemName[i].SetTexNo	( (u16)m_chItemSelect );
				m_spItemName[i].SetVisible	( true );
				m_spItemName[i].SetAlpha	( 0xff );
			}
			//	낢ȃACeʂ	----------------------------------
			switch( m_chItemSelect ){
			//	w։ʂ	:::::::::::::::::::::::::::::::::::::::::::
			case ITEM_SELECT_RING:
				//	w֎ĂȂłB	-------------------------------------
				if( m_RingIcon.iIconNum <= 0 ){
					m_eItemProc = ITEM_PROC_SELECT;
					gpSound->mPlaySE( SFX_SYS_SUBSCREEN_BOO );
					return;
				}
				for( i = 0; i < m_RingIcon.iIconNum; i++ ){
					m_RingIcon.Stone[i].SetVisible	( true );
					m_RingIcon.Mini[i].SetVisible	( false );
				}
				for( i = 0; i < m_pOption->GetBalletNum(); i++ )		m_Bullet[i].SetVisible		( false );
				for( i = 0; i < SELECT_WAKU_NUM; i++ )					m_spSelect[i].SetVisible	( false );
				for( i = 0; i < 2; i++ )								m_spItemName[i].SetVisible	( false );
				//	eNX`[ϊ	--------------------------
				m_RingIcon.SelectNo = GetRingNo();
				m_RingIcon.Sample.SetVisible( false );
				m_RingIcon.Kasan.SetVisible	( true );
				m_RingIcon.Kasan.SetAlpha	( 0xff );
				m_Photo.Small.SetAlpha		( 0x00 );
				if( m_pspSubIcon != NULL )	m_pspSubIcon->SetVisible	( false );
				m_bRingNameFlag = true;
				m_eItemProc = ITEM_PROC_RING;
				break;
	
			//	ʐ^ʂ	:::::::::::::::::::::::::::::::::::::::::::
			case ITEM_SELECT_PHOTO:
				m_Photo.Angle 	= 0;
				m_Photo.Time 	= 0;
				m_Photo.vCenter.x = PHOTOBIG_X; 	m_Photo.vCenter.y = PHOTOBIG_Y;
				m_Photo.Big.SetVisible( true );
				m_Photo.bMoveFlag = true;
				m_eItemProc = ITEM_PROC_MOVE_PHOTO;
				break;
				
			//	EC_ʂ	:::::::::::::::::::::::::::::::::::::::::::
			case ITEM_SELECT_ULCL:		m_eItemProc = ITEM_PROC_ULCOL;	break;
			//	`[gʂ	:::::::::::::::::::::::::::::::::::::::::::
			case ITEM_SELECT_CHART:		m_eItemProc = ITEM_PROC_CHART;	break;
			//	HCXʂ	:::::::::::::::::::::::::::::::::::::::::::
			case ITEM_SELECT_VOICE:		m_eItemProc = ITEM_PROC_VOICE;	break;
			}
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_DECISION );
			break;
		}
		//	LZ	::::::::::::::::::::::::::::::::::::::::
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_CANSEL );
			CancelItemProcess( CANCEL_PROC_SELECT );
			break;
		}
		break;

	//	w֑I	
	case ITEM_PROC_RING:
#ifdef __RING_DEBUG__
		for( i = 0; i < m_RingIcon.iIconNum; i++ ){
			m_RingIcon.Obj[i].pv.x = RR * ( cosf( (TWO_PI)/m_RingIcon.iIconNum*i+MTXDegToRad(XAN)));
			m_RingIcon.Obj[i].pv.y = RR * ( sinf( (TWO_PI)/m_RingIcon.iIconNum*i+MTXDegToRad(YAN)));
			m_RingIcon.Obj[i].pv.z 	= 0.0f;
			m_RingIcon.Obj[i].w 	= m_RingIcon.Obj[i].h = RING_ICON_SIZE;
					
			m_RingIcon.Obj[i].v.x = m_RingIcon.Obj[i].pv.x*sinf( m_RingIcon.fAngle ) - m_RingIcon.Obj[i].pv.y*cosf( m_RingIcon.fAngle );
			m_RingIcon.Obj[i].v.y = KK;
			m_RingIcon.Obj[i].v.z = m_RingIcon.Obj[i].pv.x * cosf( m_RingIcon.fAngle ) + m_RingIcon.Obj[i].pv.y * sinf( m_RingIcon.fAngle );				
		}
		IconZSort();		//	y\[g
		ChangeView();		//	ϊ
		SetRingImage(m_chRingSelect);		//	O`Zbg
#else 
		//	L[tO	----------------------------------
		m_chLRFlag = RING_KEY_NONE;
		
		//	E	*************************************************
		if( CheckKeyN( SK7_KEY_LEFT ) ){
			m_chLRFlag = RING_KEY_LEFT;
			if( m_iKeyTime > NAME_KEY_FRAME-1 ){
				if( m_RingIcon.iIconNum <= 1 )	return;
				if( ++m_chRingSelect >= m_RingIcon.iIconNum )	m_chRingSelect = 0;
				_MoveRingKeyState();
			}
			break;
		}		
		//		*************************************************
		if( CheckKeyN( SK7_KEY_RIGHT ) ){
			m_chLRFlag = RING_KEY_RIGHT;
			if( m_iKeyTime > NAME_KEY_FRAME-1 ){
				if( m_RingIcon.iIconNum <= 1 )		return;
				if( --m_chRingSelect < 0 )	m_chRingSelect = (s8)(m_RingIcon.iIconNum-1);
				_MoveRingKeyState();
			}
			break;
		}
//		//	L[̓`FbN	:::::::::::::
		if( m_chLRFlag == RING_KEY_NONE ){
			m_Key.PushTime = 0;
			m_Key.Power = 0;
		}
		//		*************************************************
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_RING_SET );
			//	wւĂ邩`FbN	--------------------------------------
			if( m_RingIcon.iIconNum <= 0 ){
				CancelItemProcess( CANCEL_PROC_RINGNOSET );
				break;
			}
			//	w֑	-------------------------------------------------------
			K7EVENT_GL_VAR(PutRing) = (s8)m_RingIcon.HasNo[m_chRingSelect];
			m_RingIcon.SaveNo = m_chRingSelect;
			for( i = 0; i < m_pOption->GetBalletNum(); i++ )		m_Bullet[i].SetVisible( true );
			//	Cgݒ	-------------------------------------------------------
#if 0
			m_RingIcon.LightTime = 0;
			m_RingIcon.bLightFlag = true;
			m_RingIcon.Kasan2.SetTwoSize( RING_KASAN2_SIZEX*0.5f, RING_KASAN2_SIZEY*0.5f );
			m_RingIcon.Kasan2.SetVisible( true );
			//	qJݒ	---------------------------------------------------------
			m_RingIcon.KasanTime = 0;
			m_RingIcon.bKasanFlag = true;
			m_RingIcon.Kasan.SetTwoSize( RING_KASAN_MINI, RING_KASAN_MINI );
			m_RingIcon.Kasan.SetVisible( true );
#endif
			CancelItemProcess( CANCEL_PROC_RINGSET );
			return;
		}
		//	LZ	**************************************************
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			if( K7EVENT_GL_VAR(PutRing) != -1 ){
				m_RingIcon.fAngle -= (TWO_PI/m_RingIcon.iIconNum)*(m_chRingSelect-m_RingIcon.SaveNo);
				for( i = 0; i < m_RingIcon.iIconNum; i++ ){
					m_RingIcon.Obj[i].v.x =	m_RingIcon.Obj[i].pv.x * sinf( m_RingIcon.fAngle ) - m_RingIcon.Obj[i].pv.y * cosf( m_RingIcon.fAngle );
					m_RingIcon.Obj[i].v.z = m_RingIcon.Obj[i].pv.x * cosf( m_RingIcon.fAngle ) + m_RingIcon.Obj[i].pv.y * sinf( m_RingIcon.fAngle );
				}
				m_RingIcon.SelectNo = K7EVENT_GL_VAR(PutRing);
				IconZSort();
				ChangeView();
				SetRingImage( (s8)m_RingIcon.HasNo[m_RingIcon.SaveNo] );
				m_chRingSelect = m_RingIcon.SaveNo;
			}
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_CANSEL );
			CancelItemProcess( CANCEL_PROC_RINGNOSET );
			for( int i = 0; i < m_pOption->GetBalletNum(); i++ )		m_Bullet[i].SetVisible( true );
			break;
		}
#endif
		break;


	//	wֈړ	
	case ITEM_PROC_ICON_MOVE:
		bool retcode=false;
		//	E]	------------------------------------
		if( m_chLRFlag == RING_KEY_LEFT ){
			m_RingIcon.fAngle += (TWO_PI/m_RingIcon.iIconNum)/(RING_ANGLE_SPEED-m_Key.Power);
			if( m_RingIcon.fAngle <= m_RingIcon.fOneAngle+(TWO_PI/m_RingIcon.iIconNum) ){
				retcode = false;
			}else{
				m_RingIcon.fAngle = m_RingIcon.fOneAngle+(TWO_PI/m_RingIcon.iIconNum);
				retcode = true;
			}
		}else{
			//	]	---------------------------------
			m_RingIcon.fAngle -= (TWO_PI/m_RingIcon.iIconNum)/(RING_ANGLE_SPEED-m_Key.Power);
			if( m_RingIcon.fAngle >= m_RingIcon.fOneAngle-(TWO_PI/m_RingIcon.iIconNum)){
				retcode = false;
			}else{
				m_RingIcon.fAngle = m_RingIcon.fOneAngle-(TWO_PI/m_RingIcon.iIconNum);
				retcode = true;
			}
		}
		//	ړ----------------------------------------------
		for( i = 0; i < m_RingIcon.iIconNum; i++ ){
			m_RingIcon.Obj[i].v.x =	m_RingIcon.Obj[i].pv.x * sinf( m_RingIcon.fAngle ) - m_RingIcon.Obj[i].pv.y * cosf( m_RingIcon.fAngle );
			m_RingIcon.Obj[i].v.z = m_RingIcon.Obj[i].pv.x * cosf( m_RingIcon.fAngle ) + m_RingIcon.Obj[i].pv.y * sinf( m_RingIcon.fAngle );
		}
		IconZSort();
		ChangeView();
		SetRingImage( (s8)m_RingIcon.HasNo[m_chRingSelect] );
		if( retcode ){
			m_RingIcon.KasanTime = 0;
			m_RingIcon.bKasanFlag = true;
			m_RingIcon.Kasan.SetTwoSize( RING_KASAN_MINI, RING_KASAN_MINI );
			m_RingIcon.Kasan.SetVisible( true );
			m_RingIcon.SelectNo = (s8)m_RingIcon.HasNo[m_chRingSelect];//GetRingNo();
			m_eItemProc = ITEM_PROC_RING;
		}
		break;

	//	ʐ^ړ	
	case ITEM_PROC_MOVE_PHOTO:
		m_Photo.vCenter.x 	+= (320.0f-PHOTOBIG_X)/PHOTO_MOVE_TIME;
		m_Photo.vCenter.y 	+= (240.0f-PHOTOBIG_Y)/PHOTO_MOVE_TIME;
		m_Photo.Angle 	  	-= (360.0f/PHOTO_MOVE_TIME);
		SET_SPRITE_ROT( &m_Photo.Big, m_Photo.Angle, m_Photo.vCenter.x, m_Photo.vCenter.y, PHOTOBIG_SIZE_X, PHOTOBIG_SIZE_Y );
		if( ++m_Photo.Time >= PHOTO_MOVE_TIME ){
			m_Photo.Angle = 0;
			m_Photo.Time = 0;
			if( m_Photo.bMoveFlag ){
				//	Cxg_jp	-------------------------------------------
				if( GameInfo.GetScenarioID() == K7SCN02 && K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020206 ) != true ){
					const char* pPathName = WK7PLAYERPATHCONTROL->GetCurrentPathName();
					const char* tblPathName[]={ "event_020209","event_020210" };
					for( int i = 0; i < 2; i++ ){
						if( strcmp( pPathName, tblPathName[i] ) == 0 ){
							gpSound->mPlaySE( SFX_SYS_TRUE );
							m_eItemProc = ITEM_PROC_PHOTO_WAIT;
							return;
						}
					}
				}
				m_eItemProc = ITEM_PROC_PHOTO;
			}else{
				CancelItemProcess( CANCEL_PROC_PHOTO );
			}
		}
		break;

	//	ʐ^	
	case ITEM_PROC_PHOTO:
		if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){			
			m_lEventNo = 0xffffffff;
			m_Photo.bMoveFlag 	= false;
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_CANSEL );
			m_eItemProc = ITEM_PROC_MOVE_PHOTO;
		}
		break;
			
	//	ʐ^ҋ@	
	case ITEM_PROC_PHOTO_WAIT:
		if( ++m_iMemoTime > PHOTO_WAIT_TIME ){
			m_iMemoTime = PHOTO_WAIT_TIME;
			if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){			
				m_lEventNo 	= K7EVENTNO(020209);	
				m_iMemoTime	= 0;
				m_eProc 	= PROC_EXIT;
			}
		}
		break;

		
	//	EC_	
	case ITEM_PROC_ULCOL:
		TaskMenu(eMenuUlmeyda);
		if( m_pMenu != NULL )	m_pMenu->FrameProcess();
		break;
		
	//	J[`[g	
	case ITEM_PROC_CHART:
		TaskMenu(eMenuColor);
		if( m_pMenu != NULL )	m_pMenu->FrameProcess();
		break;
	//	{CXR[_	
	case ITEM_PROC_VOICE:
		TaskMenu(eMenuVoiceMemo);
		if( m_pMenu != NULL )	m_pMenu->FrameProcess();
		break;
	
	}
}


//========================================================================
//					Oʂł̃L[͂Ƃ̏
//========================================================================
void 			SK7Special::_MoveRingKeyState()
{
	//	L[^C`FbN	------------------------------------
	if( ++m_Key.PushTime > tblPushKeyTime[m_Key.Power] ){
		if( ++m_Key.Power >= RING_ANGLE_SPEED-1 )	m_Key.Power = RING_ANGLE_SPEED-2;
		m_Key.PushTime = 0;
	}
	m_RingIcon.Kasan.SetVisible( false );
	m_RingIcon.fOneAngle = m_RingIcon.fAngle;
	m_RingIcon.KasanAngle = 0;
	gpSound->mPlaySE( SFX_SYS_SUBSCREEN_CHOOSE );
	m_iKeyTime = 0;
	m_eItemProc = ITEM_PROC_ICON_MOVE;	
}


//========================================================================
//				ACeLZCxg
//========================================================================
void		SK7Special::CancelItemProcess( s8 Proc )
{
	int i;
	switch( Proc ){
	//	ĨLZ	:::::::::::::::::::::::::::::::::::::::::::::::::
	case CANCEL_PROC_SELECT:
		for( i = 0; i < SELECT_WAKU_NUM; i++ )	m_spSelect[i].SetVisible( false );
		for( i = 0; i < 2; i++ )				m_spItemName[i].SetVisible( false );
		m_bBlockFlag = false;
		for( i = 0; i < m_RingIcon.iIconNum; i++ ){
			m_RingIcon.Stone[i].SetColor( 0xffffffff );
			m_RingIcon.Mini[i].SetColor( 0xffffffff );
		}
		m_Photo.Small.SetColor	( 0xffffffff );
		if( m_pspSubIcon != NULL )	m_pspSubIcon->SetColor	( 0xffffffff );
		SetSelectAlpha( (u8)m_chBlockSelect, SET_ALPHA_FULL );
		m_chItemSelect = 0;
		m_spLight.SetVisible( false );
		m_chBlockSelect = BLOCK_SELECT_CANCEL;
		if( m_RingIcon.Sample.CheckFlag( RENDER_FLAG ) ){
			m_RingIcon.Kasan.SetVisible( false );
		}else{
			m_RingIcon.Kasan.SetVisible( true );
		}
		m_RingIcon.Kasan2.SetVisible( false );
		m_eProc = PROC_BLOCK_SELECT;
		break;
		
	//	OI	:::::::::::::::::::::::::::::::::::::::::::::
	case CANCEL_PROC_RINGSET:
		for( int i = 0; i < m_RingIcon.iIconNum; i++ ){
			m_RingIcon.Mini[i].SetVisible	( true );
			if( m_RingIcon.Stone[i].GetTexNo() != m_RingIcon.HasNo[m_chRingSelect] )		m_RingIcon.Stone[i].SetVisible( false );
		}
		m_RingIcon.Kasan.SetVisible( true );
		//	ZNgg`悵Ȃ	---------------------------------------------------
		for( i = 0; i < SELECT_WAKU_NUM; i++ )		m_spSelect[i].SetVisible( false );
		//	ACe		-------------------------------------------------------
		for( i = 0; i < 2; i++ )				m_spItemName[i].SetVisible( false );
		//	TũACR\	---------------------------------------------------
		if( m_pspSubIcon != NULL )	m_pspSubIcon->SetVisible	( true );
		//	ubNtO		----------------------------------------------------
		m_bBlockFlag = false;
		//	ACe̐F߂		----------------------------------------------------
		for( i = 0; i < m_RingIcon.iIconNum; i++ ){
			m_RingIcon.Stone[i].SetColor( 0xffffffff );
			m_RingIcon.Mini[i].SetColor( 0xffffffff );
		}
		m_Photo.Small.SetColor	( 0xffffffff );
		if( m_pspSubIcon != NULL )	m_pspSubIcon->SetColor	( 0xffffffff );
		//	ACẽ}XN	-----------------------------------------------------
		SetSelectAlpha( (u8)m_chBlockSelect, SET_ALPHA_FULL );
		//	ACeZNgԍ	-----------------------------------------------------
		m_chItemSelect = 0;
		//	Cg			-----------------------------------------------------
		m_spLight.SetVisible( false );
		//	ubNLZ
		m_chBlockSelect = BLOCK_SELECT_CANCEL;
		//	OACR̉Z`b
		if( m_RingIcon.Sample.CheckFlag( RENDER_FLAG ) ){
			m_RingIcon.Kasan.SetVisible( false );
		}else{
			m_RingIcon.Kasan.SetVisible( true );
			m_RingIcon.Kasan.SetTwoSize		( RING_KASAN_NORMAL, RING_KASAN_NORMAL );
		}
		//	]̉Z͏	------------------------------------------------------------
		m_RingIcon.bLightFlag = false;
		m_RingIcon.Kasan2.SetVisible( false );
		//	ACeZNg֖߂	--------------------------------------------------
		m_eItemProc = ITEM_PROC_SELECT;
		//	ubÑZNg֖߂	------------------------------------------------
		m_eProc = PROC_BLOCK_SELECT;
		break;
		
	//	OĨLZ	:::::::::::::::::::::::::::::::::::::::::::::
	case CANCEL_PROC_RINGNOSET:
		//	ĂȂƂ	-------------------------------------
		if( K7EVENT_GL_VAR(PutRing) == -1 ){
			for( int i = 0; i < m_RingIcon.iIconNum; i++ ){
				m_RingIcon.Stone[i].SetVisible	( false );
				m_RingIcon.Mini[i].SetVisible	( true );
			}
			m_RingIcon.Sample.SetVisible( true );
			m_RingIcon.Kasan.SetVisible	( false );
			m_RingIcon.SelectNo = RING_NOT_NO;
		}else{
			for( int i = 0; i < m_RingIcon.iIconNum; i++ ){
				m_RingIcon.Mini[i].SetVisible	( true );
				if( m_RingIcon.Stone[i].GetTexNo() != m_RingIcon.HasNo[m_chRingSelect] )		m_RingIcon.Stone[i].SetVisible( false );
			}
			m_RingIcon.Kasan.SetVisible( true );
		}
		for( i = 0; i < SELECT_WAKU_NUM; i++ )		m_spSelect[i].SetVisible( true );
		m_Photo.Small.SetAlpha	( 0x7f );
//		m_Photo.Small.SetVisible( true );
		if( m_pspSubIcon != NULL )	m_pspSubIcon->SetVisible	( true );
		m_eItemProc = ITEM_PROC_SELECT;		//	ZNg		
		break;
		
	//	ʐ^ĨLZ	--------------------------------------------------
	case CANCEL_PROC_PHOTO:
		m_Photo.Big.SetVisible(false);
		m_eItemProc = ITEM_PROC_SELECT;		//	ZNg		
		break;
		
	//	̃LZ	----------------------------------------------
	case CANCEL_PROC_MEMO:
		m_bBlockFlag = false;
		m_iMemoTime	 = 0;
		SetSelectAlpha( (u8)m_chBlockSelect, SET_ALPHA_FULL );
		m_spLight.SetVisible( false );
		m_chBlockSelect = BLOCK_SELECT_CANCEL;
		m_eMemoProc = MEMO_PROC_SELECT;
		m_eProc = PROC_BLOCK_SELECT;
		break;
	}
}


//========================================================================
//				͂ƑIC
//========================================================================
void		SK7Special::FrameMemoProcess()
{
	//	{X
	if( m_pOption->GetBossFlag() ){
		if( MoveSore() ){
			CancelItemProcess( CANCEL_PROC_MEMO );
		}
		return;
	}
	switch( m_eMemoProc ){
	case MEMO_PROC_SELECT:
		//	͂Ƃ̈ړ		---------------------------------------------
		if( ++m_iMemoTime >= MEMO_MOVE_FRAME  ){
			f32 Angle = MTXDegToRad(rand()%360);
			f32 Rad	  = rand()%MEMO_MOVE_SIZE;
			m_spMemo.SetXY0( MEMO_X+(Rad*cosf(Angle)),  MEMO_Y+(Rad*sinf(Angle)));
			m_iMemoTime = 0;
		}
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_DECISION );
			m_eMemoProc = MEMO_PROC_HATO;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			CancelItemProcess( CANCEL_PROC_MEMO );
			return;
		}
		break;
	case MEMO_PROC_HATO:
		TaskMenu(eMenuHatoMemo);
		if( m_pMenu != NULL ){
			m_pMenu->FrameProcess();
		}
		break;
	}
}

//========================================================================
//				tIC
//========================================================================
void		SK7Special::FrameBloodProcess()
{
	s16 NowHp, MaxHp;
	switch( m_eBloodProc ){
	case BLOOD_PROC_SELECT:
		//		----------------------------------
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			//	L̂gôl`wƌݒn擾	---------------------------------------
			WK7PLAYERCONTROL->GetDataHp( WK7PLAYERCONTROL->GetMainID(), &NowHp, &MaxHp );
			//	őlɒĂ񕜂Ȃ	-----------------------------------------------
			if( WK7PLAYERCONTROL->GetHp() >= MaxHp ){
				gpSound->mPlaySE( SFX_SYS_SUBSCREEN_BOO );
				return;
			}
			//	1pbN		---------------------------------------------------------
			if( m_pOption->GetBloodGauge(BP_THIN) >= BLOOD_PACK ){		//	1pbN
				m_pOption->IncBloodGauge(BP_THIN, -BLOOD_PACK);			//	炷
				//	tZbg	-------------------------------------------------
				SetLifeBlood(true);
				gpSound->mPlaySE( SFX_SYS_SUBSCREEN_KESSEIKAKUSAN );
				m_eBloodProc = BLOOD_PROC_MOVE;
				return;
			}
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_BOO );
		}
		//	LZ	----------------------------------------------------------------
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			m_bBlockFlag = false;
			SetSelectAlpha( (u8)m_chBlockSelect, SET_ALPHA_FULL );
			m_spLight.SetVisible( false );
			m_chBlockSelect = BLOCK_SELECT_CANCEL;
			m_eProc = PROC_BLOCK_SELECT;
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_CANSEL );
			return;
		}
		break;
	//	tړ	:::::::::::::::::::::::::::::::::::::::::::::::::::::::
	case BLOOD_PROC_MOVE:
		if( MoveLifeBlood(true) ){
			SetLifeBlood(false);
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_KESSEITOBU  );
			m_eBloodProc = BLOOD_PROC_MOVE2;
		}
		break;
		
	//	ڋʂ܂ňړ	:::::::::::::::::::::::::::::::::::::::::::::::::::::::
	case BLOOD_PROC_MOVE2:
		if( MoveLifeBlood(false) ){			
			//	L̂gôl`wƌݒn擾	---------------------------------------
			WK7PLAYERCONTROL->GetDataHp( WK7PLAYERCONTROL->GetMainID(), &NowHp, &MaxHp );
			//	qɃL̉	===============================================
			NowHp += BLOOD_LIFE_RECOVERY;
			if( NowHp >= MaxHp )	NowHp = MaxHp;
			WK7PLAYERCONTROL->SetDataHp( WK7PLAYERCONTROL->GetMainID(), NowHp);	//	qɃL̉
			
			//	JgL̉	==============================================
			m_sOldHpPer = (f32)WK7PLAYERCONTROL->GetHp()/(f32)MaxHp;			//	񕜑O̒l
			WK7PLAYERCONTROL->IncHp(BLOOD_LIFE_RECOVERY);						//	JgL̉
			m_sNowHpPer = (f32)WK7PLAYERCONTROL->GetHp()/(f32)MaxHp;			//	񕜌̒l
			
			if( m_sNowHpPer != 1 ){
				gpSound->mPlaySE( SFX_SYS_SUBSCREEN_CURE );
			}else{
				gpSound->mPlaySE( SFX_SYS_SUBSCREEN_CUREALL );
			}

			//	ڂ̃Aj[V
			m_pOption->SetEyeAniem( m_sOldHpPer, m_sNowHpPer );
			m_eBloodProc = BLOOD_PROC_SELECT;
		}
		break;
	}
}

//========================================================================
//				ubNIC
//========================================================================
void		SK7Special::FrameBlockProcess()
{
#ifdef 	__DEBUG_CHO__
	static Vec vPos;
	static int no;
	if( HSD_PadGetTrigger(0) & HSD_PAD_UP ){
		if( ++no > 3 ) no = 0;
		return;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_DOWN ){
		if( --no < 0 ) no = 3;
		return;
	}
	if( no == 0 )	vPos = *m_Panel.sprite.GetPos0();
	if( no == 1 )	vPos = *m_Panel.sprite.GetPos1();
	if( no == 2 )	vPos = *m_Panel.sprite.GetPos2();
	if( no == 3 )	vPos = *m_Panel.sprite.GetPos3();
	
	vPos.x += HSD_PadGetNormalStickX(0);
	vPos.y -= HSD_PadGetNormalStickY(0);	
	if( no == 0 )	m_Panel.sprite.SetPos0(vPos);
	if( no == 1 )	m_Panel.sprite.SetPos1(vPos);
	if( no == 2 )	m_Panel.sprite.SetPos2(vPos);
	if( no == 3 )	m_Panel.sprite.SetPos3(vPos);
	return;
#endif
	int i;
	bool SelectFlag=false;
	s8	SelectNo = BLOCK_SELECT_NOT;
	VEC2 Stick;
	Stick.x = Stick.y = 0.0f;
	Stick.x += HSD_PadGetNormalStickX(0);
	Stick.y += HSD_PadGetNormalStickY(0);

	//	pl̈ړ	---------------------------------------
	MovePanel();

	//	tHgړ	-------------------------------------
	FrameMoveFont( (u8)m_chBlockSelect );

	//	LZNg	---------------------------------
	if( !SelectFlag && Stick.x < BLOCK_KEY_POWER && Stick.y > BLOCK_KEY_POWER ){
		SelectNo = BLOCK_SELECT_CHARA;
		SelectFlag = true;
	}
	//	ACe	-------------------------------------
	if( !SelectFlag && Stick.x < -BLOCK_KEY_POWER && Stick.y < BLOCK_KEY_POWER ){
		SelectNo = BLOCK_SELECT_ITEM;
		SelectFlag = true;
	}
	//	ng	------------------------------------
	if( !SelectFlag && Stick.x > BLOCK_KEY_POWER && Stick.y > -BLOCK_KEY_POWER ){
		SelectNo = BLOCK_SELECT_MEMO;
		SelectFlag = true;
	}
	//	t	-----------------------------------------
	if( !SelectFlag && Stick.x > -BLOCK_KEY_POWER && Stick.y < -BLOCK_KEY_POWER ){
		SelectNo = BLOCK_SELECT_BLOOD;
		SelectFlag = true;
	}

	if( !SelectFlag ){
		//	^񒆂̊g	------------------------------
		if( ++m_Panel.PanelStartTime < PANEL_MOVE_TIME ){
			if( m_Panel.PanelStartTime < PANEL_START_TIME ){
				if( m_Panel.Ex > 0 ){
					m_Panel.Angle += (f32)PANEL_MOVE_ANGLE/PANEL_TIME;
				}else{
					m_Panel.Angle -= (f32)PANEL_MOVE_ANGLE/PANEL_TIME;
				}
				m_Panel.PanelSize += m_Panel.Ex;
			}
			SET_SPRITE_ROT		( &m_Panel.sprite, m_Panel.Angle, PANEL_X+PANEL_SIZE*0.5f, PANEL_Y+PANEL_SIZE*0.5f, m_Panel.PanelSize, m_Panel.PanelSize );		
			//	܂Ԃ^Cɂ
			if( m_Panel.PanelStartTime == PANEL_TIME ){
				gpSound->mPlaySE(SFX_SYS_SUBSCREEN_BEAT_A+rand()%4);
				m_Panel.Ex = -m_Panel.Ex;
			}
		}else{
			m_Panel.PanelSize = PANEL_SIZE;
			m_Panel.Ex = -m_Panel.Ex;
			m_Panel.Angle = PANEL_ANGLE;
			m_Panel.PanelStartTime = 0;
		}
	}

	//	}XN|	----------------------------------
	SetBlockSelectMask( (u8)SelectNo );

	//	I`FbN	::::::::::::::::::::::::::::::::::::::::::::::
	if( m_chBlockSelect != SelectNo ){
		m_chBlockSelect = SelectNo;
		SetMovePanel();							//	pl̓Zbg
		SetSelectFont((u8)SelectNo, false);		//	ZNgtHg̃Zbg
		gpSound->mPlaySE( SFX_SYS_SUBSCREEN_OPERATE );

		for( int i = 0; i < SELECT_FONT_MAX; i++ ){
			m_SelectFont.EndTime[i] = rand()%3+2;		
			SetMoveFont( &m_SelectFont.vSpeed[i], (rand()%3+1), m_SelectFont.EndTime[i] );
			m_SelectFont.AddTime[i] = 0;
			
			m_ShadowSmall.EndTime[i] = rand()%3+2;		
			SetMoveFont( &m_ShadowSmall.vSpeed[i], (rand()%23+3), m_ShadowSmall.EndTime[i] );
			m_ShadowSmall.AddTime[i] = 0;

			m_ShadowBig.EndTime[i] = rand()%3+1;		
			SetMoveFont( &m_ShadowBig.vSpeed[i], (rand()%23+3), m_ShadowBig.EndTime[i] );
			m_ShadowBig.AddTime[i] = 0;	
		}
		
		//	VhEtHgZbg	:::::::::::::::::::::::::::::::::::::::::::::::
		if( SelectNo < BLOCK_SELECT_NOT ){
			const u8 BlockTexNo[]={ TEX_MOJI_JIN, 	TEX_MOJI_A, TEX_MOJI_ME, 	TEX_MOJI_KETSU, };
			const int BlockPosNo[]={ FONT_M_JIN, 	FONT_M_A,	FONT_ME,		FONT_KETU,		};
			for( i = 0; i < SELECT_FONT_MAX; i++ ){
				m_ShadowSmall.Font[i].SetVisible( true );
				m_ShadowBig.Font[i].SetVisible( true );
				
				if( SelectNo == BLOCK_SELECT_ITEM ){
					m_ShadowSmall.Font[i].SetTexSprite( tblSelectFont[ BlockPosNo[SelectNo]+i ].x, tblSelectFont[ BlockPosNo[SelectNo]+i ].y, g_pSpData->GetTexture( (u8)(BlockTexNo[SelectNo]+i) ) );
					m_ShadowBig.Font[i].SetTexSprite( tblSelectFont[ BlockPosNo[SelectNo]+i ].x, tblSelectFont[ BlockPosNo[SelectNo]+i ].y, g_pSpData->GetTexture( (u8)(BlockTexNo[SelectNo]+i )) );
				}else{
					if( i < 2 ){
						m_ShadowSmall.Font[i].SetTexSprite( tblSelectFont[ BlockPosNo[SelectNo]+i ].x, tblSelectFont[ BlockPosNo[SelectNo]+i ].y, g_pSpData->GetTexture((u8)(BlockTexNo[SelectNo]+i)) );
						m_ShadowBig.Font[i].SetTexSprite( tblSelectFont[ BlockPosNo[SelectNo]+i ].x, tblSelectFont[ BlockPosNo[SelectNo]+i ].y, g_pSpData->GetTexture( (u8)(BlockTexNo[SelectNo]+i) ) );
					}else{
						m_ShadowSmall.Font[i].SetVisible( false );
						m_ShadowBig.Font[i].SetVisible( false );
					}
				}
				m_ShadowSmall.Font[i].SetAlpha( SELECT_FONT_ALPHA_A );
				m_ShadowBig.Font[i].SetAlpha( SELECT_FONT_ALPHA_B );
			}
		}else{
			for( i = 0; i < SELECT_FONT_MAX; i++ ){
				m_ShadowSmall.Font[i].SetVisible( false );
				m_ShadowBig.Font[i].SetVisible( false );
			}
		}
			
		if( SelectNo < BLOCK_SELECT_NOT ){
			m_SelectFont.MoveFlag = true;		//	ړnj
		}else{
			memset( m_SelectFont.vSpeed,  0, sizeof( VEC2 )*SELECT_FONT_MAX );
			memset( m_SelectFont.EndTime, 0, sizeof( int )*SELECT_FONT_MAX );
			memset( m_SelectFont.AddTime, 0, sizeof( int )*SELECT_FONT_MAX );
			m_SelectFont.MoveFlag = false;	//	ړnj
		}
	}
	//	ZNg	------------------------------
	if( SelectFlag ){
		//	^񒆂̂	-----------------------------
		m_Panel.PanelStartTime 	= 0;
		m_Panel.PanelTime		= 0;
		m_Panel.PanelSize		= PANEL_SIZE;//PANEL_SPEED;
		m_Panel.MoveFlag		= false;

		//		-----------------------------------------
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			//	KVAʐ^ȂƂ͖߂
			if( WK7PLAYERCONTROL->GetMainID() == K7GAL && !m_Photo.Small.CheckFlag( RENDER_FLAG ) &&
				SelectNo == BLOCK_SELECT_ITEM ){
				gpSound->mPlaySE(SFX_SYS_SUBSCREEN_BOO);
				return;
			}

			//	ZNgtHg̃Zbg	===============================
			SetSelectFont((u8)SelectNo, true);		
			//	plZbg	==========================================
			SetMoveEndPanel();
			//	}XNSZbg	=======================================
			SetBlockSelectMask( (u8)SelectNo, true );		
			//	Cg`	------------------------------------------
			SetSelectLight((u8)SelectNo);
			//	ubNAt@Zbg	
			m_bBlockFlag = true;
			gpSound->mPlaySE( SFX_SYS_SUBSCREEN_DECISION );
			m_eProc = (s8)(m_chBlockSelect+PROC_NAME_SELECT);
			//	CgZbg	=========================================
			m_spLight.SetAlpha(0x00);
			m_bLightMoveFlag = true;
			
			//	̎Ƀ{X
			if( m_eProc == PROC_MEMO && m_pOption->GetBossFlag() ){
				m_Sore.spFont.SetVisible	( true );
				m_Sore.spPlate.SetVisible	( true );
			}
	
			//	ACeIʂɍsƂ	*********************************************
			if( m_eProc != PROC_ITEM ) return;

			m_chItemSelectNo = ITEM_SELECT_RING;
			//	̃LKVAƂƏO̐	------------------------------------------
			if( WK7PLAYERCONTROL->GetMainID() == K7GAL || m_RingIcon.iIconNum <= 0  ){
				if( GameInfo.GetScenarioFlow() == K7SCNF_SCL ){
					if( K7SCR_GET_SCENARIO_FLAG( VRHAVE ) )	m_chItemSelectNo = 1;
					else									m_chItemSelectNo = 2;		//	wZ
				}else{
					m_chItemSelectNo = 1;
				}
			}
			m_chItemSelect = tblItemSelectNo[GameInfo.GetScenarioFlow()].No[m_chItemSelectNo];			
			for( int i = 0; i < 4; i++ ){
				m_SelectFont.Item[i].SetVisible( false );//( 0x00 );
			}
			if( K7EVENT_GL_VAR(PutRing) != -1 ){
				m_RingIcon.Kasan.SetVisible	( true );
				m_RingIcon.Kasan.SetAlpha	( 0xff );
			}
			//	OȊÕACẽACRÂ	----------------------------
			if( K7EVENT_GL_VAR(PutRing) != -1 ){
				m_Photo.Small.SetColor	( RING_COLOR_NOTSELECT );
				if( m_pspSubIcon != NULL )	m_pspSubIcon->SetColor	( RING_COLOR_NOTSELECT );
			}
			//	ACeIg̓o	*************************************************
			m_iSelectTime = 0;
			SetSelectWaku();
			return;
		}
	}else{
		if( SelectNo != BLOCK_SELECT_NOT ){
			m_chBlockSelect = BLOCK_SELECT_NOT;
		}
	}
}

//========================================================================
//				ړtHg
//========================================================================
void		SK7Special::FrameMoveFont( u8 No )
{
	int i;
	//	ړ`FbN	---------------------------------------
	if( m_SelectFont.MoveFlag ){
		switch( No ){
		case BLOCK_SELECT_CHARA:	
			for( i = 0; i < 2; i++ ){
				CheckMoveFont( &m_SelectFont.Chara[i], 	&m_SelectFont.vSpeed[i], 	(u8)i, No, MOVE_FONT_NORMAL );
				CheckMoveFont( &m_ShadowSmall.Font[i], 	&m_ShadowSmall.vSpeed[i], 	(u8)i, No, MOVE_FONT_SMALL );
				CheckMoveFont( &m_ShadowBig.Font[i],	&m_ShadowBig.vSpeed[i], 	(u8)i, No, MOVE_FONT_BIG );
			}
			break;
		case BLOCK_SELECT_ITEM:
			for( i = 0; i < SELECT_FONT_MAX; i++ ){
				CheckMoveFont( &m_SelectFont.Item[i], 	&m_SelectFont.vSpeed[i], 	(u8)i, No, MOVE_FONT_NORMAL );
				CheckMoveFont( &m_ShadowSmall.Font[i], 	&m_ShadowSmall.vSpeed[i], 	(u8)i, No, MOVE_FONT_SMALL );
				CheckMoveFont( &m_ShadowBig.Font[i],	&m_ShadowBig.vSpeed[i], 	(u8)i, No, MOVE_FONT_BIG );
			}
			break;
		case BLOCK_SELECT_MEMO:
			for( i = 0; i < 2; i++ ){
				CheckMoveFont( &m_SelectFont.Memo[i], 	&m_SelectFont.vSpeed[i], 	(u8)i, No, MOVE_FONT_NORMAL );
				CheckMoveFont( &m_ShadowSmall.Font[i], 	&m_ShadowSmall.vSpeed[i], 	(u8)i, No, MOVE_FONT_SMALL );
				CheckMoveFont( &m_ShadowBig.Font[i],	&m_ShadowBig.vSpeed[i], 	(u8)i, No, MOVE_FONT_BIG );
			}
			break;
		case BLOCK_SELECT_BLOOD:
			for( i = 0; i < 2; i++ ){
				CheckMoveFont( &m_SelectFont.Blood[i], 	&m_SelectFont.vSpeed[i], 	(u8)i, No, MOVE_FONT_NORMAL );
				CheckMoveFont( &m_ShadowSmall.Font[i], 	&m_ShadowSmall.vSpeed[i], 	(u8)i, No, MOVE_FONT_SMALL );
				CheckMoveFont( &m_ShadowBig.Font[i],	&m_ShadowBig.vSpeed[i], 	(u8)i, No, MOVE_FONT_BIG );
			}
			break;
		}
	}
}

//========================================================================
//				ړtHg
//========================================================================
void		SK7Special::SetMoveFont( VEC2 *pVector, int MovR, int Time )
{
	f32 SpeedAngle	= MTXDegToRad(rand()%360);		//	ړpx
	pVector->x = (MovR*cosf(SpeedAngle))/Time;		//	ړXs[h
	pVector->y = (MovR*sinf(SpeedAngle))/Time;
	if( pVector->x == 0.0f )		pVector->x = 0.3f;
	if( pVector->y == 0.0f )		pVector->y = 0.3f;
}


//========================================================================
//				WZbg
//========================================================================
void		SK7Special::CheckMoveFont( SK7Sprite* pSp, VEC2* pSpeed, u8 No, u8 Select, s8 State )
{
	bool MoveFlag=false;
	const int SelectFontNo[]={ FONT_M_JIN, FONT_M_A, FONT_ME, FONT_KETU, };

	Vec vPos = *pSp->GetPos0();
	vPos.x += pSpeed->x;
	vPos.y += pSpeed->y;

	if( vPos.x > tblSelectFont[SelectFontNo[Select]+No].x+SELECT_MAX_SIZE_X ){
		vPos.x = tblSelectFont[SelectFontNo[Select]+No].x+SELECT_MAX_SIZE_X;
		MoveFlag = true;
	}
	if( vPos.x < tblSelectFont[SelectFontNo[Select]+No].x-SELECT_MAX_SIZE_X ){
		vPos.x = tblSelectFont[SelectFontNo[Select]+No].x-SELECT_MAX_SIZE_X;
		MoveFlag = true;
	}
	if( vPos.y > tblSelectFont[SelectFontNo[Select]+No].y+SELECT_MAX_SIZE_Y ){
		vPos.y = tblSelectFont[SelectFontNo[Select]+No].y+SELECT_MAX_SIZE_Y;
		MoveFlag = true;
	}
	if( vPos.y < tblSelectFont[SelectFontNo[Select]+No].y-SELECT_MAX_SIZE_Y ){
		vPos.y = tblSelectFont[SelectFontNo[Select]+No].y-SELECT_MAX_SIZE_Y;
		MoveFlag = true;
	}
	if( MoveFlag ){
		switch( State ){
		case MOVE_FONT_NORMAL:
			m_SelectFont.EndTime[No] = rand()%3+2;		
			SetMoveFont( pSpeed, (rand()%3+1), m_SelectFont.EndTime[No] );
			m_SelectFont.AddTime[No] = 0;
			break;
		case MOVE_FONT_SMALL:
			m_ShadowSmall.EndTime[No] = rand()%3+2;		
			SetMoveFont( pSpeed, (rand()%23+3), m_ShadowSmall.EndTime[No] );
			m_ShadowSmall.AddTime[No] = 0;
			break;
		case MOVE_FONT_BIG:
			m_ShadowBig.EndTime[No] = rand()%3+1;		
			SetMoveFont( pSpeed, (rand()%23+3), m_ShadowBig.EndTime[No] );
			m_ShadowBig.AddTime[No] = 0;	
			break;
		}
	}
	pSp->SetXY0( vPos.x, vPos.y );
}


//========================================================================
//				CgZbg
//========================================================================
void		SK7Special::SetSelectLight( u8 No )
{
	m_spLight.SetXY0	( tblLightData[No].XY.x, tblLightData[No].XY.y );
	m_spLight.SetSTTwo	( tblLightData[No].u0, tblLightData[No].v0, tblLightData[No].u1, tblLightData[No].v1);
	m_spLight.SetVisible( true );
}


//========================================================================
//						񕜌t̍쐬
//========================================================================
void			SK7Special::SetLifeBlood( bool State )
{
	if( State ){
		u32 BloodColor[]={ 0xa00020ff, 0xc00000e0, 0xa04040ff, 0x992010e0 };
		
		//	m	^---------------------------------------------
		ghmGcMemSetAllocName("SK7SPELIFE");
		m_pLifeBlood = new LIFE_BLOOD[LIFE_BLOOD_NUM];
		
		for( int i = 0; i < LIFE_BLOOD_NUM; i++ ){
			m_pLifeBlood[i].Blood.SetTexSprite	( LIFE_BLOOD_X, LIFE_BLOOD_Y, &m_BloodTex, 2, 2, (u8)(i%4) );
			m_pLifeBlood[i].Blood.SetFlag		( true, SIZE_FLAG|RENDER_FLAG );
			m_pLifeBlood[i].Blood.SetColor		( BloodColor[i%4] );
			m_pLifeBlood[i].Time = 0;
			f32 Angle 			= MTXDegToRad(rand()%360);
			f32 radius 			= (rand()%10);
			if( (i%2) == 0 )	m_pLifeBlood[i].Size	= ((rand()%10)*0.22f);
			else				m_pLifeBlood[i].Size	= -((rand()%10)*0.18f);
			m_pLifeBlood[i].Blood.SetTwoSize		( BLOOD_MAX_SIZE, BLOOD_MAX_SIZE );
			m_pLifeBlood[i].Speed.x = cosf( Angle ) * radius; 
			m_pLifeBlood[i].Speed.y = sinf( Angle ) * radius;
		}
	}else{
		for( int i = 0; i < LIFE_BLOOD_NUM;  i++ ){
			m_pLifeBlood[i].Speed.x = (EYE_RIGHT_X - m_pLifeBlood[i].Blood.GetX0())/LIFE_BLOOD_TIME2;
			m_pLifeBlood[i].Speed.y = (EYE_Y - m_pLifeBlood[i].Blood.GetY0())/LIFE_BLOOD_TIME2;
		}
	}
}

//========================================================================
//						񕜌ẗړ
//========================================================================
bool			SK7Special::MoveLifeBlood( bool State )
{
	if( State ){
		for( int i = 0; i < LIFE_BLOOD_NUM; i++ ){
			m_pLifeBlood[i].Blood.SetIncSizeXY	( m_pLifeBlood[i].Size, m_pLifeBlood[i].Size );
			m_pLifeBlood[i].Blood.SetIncXY		( m_pLifeBlood[i].Speed.x, m_pLifeBlood[i].Speed.y );
		}
		if( ++m_pLifeBlood[0].Time >= LIFE_BLOOD_TIME ){
			for( int i = 0; i < LIFE_BLOOD_NUM; i++ ){
				m_pLifeBlood[i].SaveSize = m_pLifeBlood[i].Blood.GetSizeX();
			}
			m_pLifeBlood[0].Time = 0;
			return true;
		}
	}else{
		for( int i = 0; i < LIFE_BLOOD_NUM; i++ ){
			if( (i%2) == 0 )	m_pLifeBlood[i].Blood.SetIncSizeXY	( (BLOOD_MAX_SIZE-m_pLifeBlood[i].SaveSize)/LIFE_BLOOD_TIME2, (BLOOD_MAX_SIZE-m_pLifeBlood[i].SaveSize)/LIFE_BLOOD_TIME2 );
			else				m_pLifeBlood[i].Blood.SetIncSizeXY	( (m_pLifeBlood[i].SaveSize-BLOOD_MAX_SIZE)/LIFE_BLOOD_TIME2, (m_pLifeBlood[i].SaveSize-BLOOD_MAX_SIZE)/LIFE_BLOOD_TIME2 );
			m_pLifeBlood[i].Blood.SetIncXY( m_pLifeBlood[i].Speed.x, m_pLifeBlood[i].Speed.y );
		}
		if( ++m_pLifeBlood[0].Time > LIFE_BLOOD_TIME2 ){
			for( int i = 0; i < LIFE_BLOOD_NUM; i++ )	m_pLifeBlood[i].Blood.SetVisible( false );
			m_pLifeBlood[0].Time = 0;
			//	f[g	----------------------------------
			GHM_SAFE_DELETE_ARRAY( m_pLifeBlood );
			return true;
		}
	}
	return false;
}

//========================================================================
//				
//========================================================================
bool		SK7Special::_CheckDeath( u32 CharaNo )
{
	if( !BattleCtrl.PcDieTest(CharaNo) && BattleCtrl.PcCollectTest(CharaNo) ){
		if( BattleCtrl.PcReCallTest(CharaNo) && BattleCtrl.PcSelOKTest(CharaNo) ){
			return true;
		}
	}
	return false;
}

//========================================================================
//				
//========================================================================
bool		SK7Special::CheckDeath()
{	
	u32 CharaNo[]={ K7DAN, K7KED, K7KVN, K7CYO, K7CON, K7MSK, K7HAY, };
	for( int i = 0; i < m_chCharaNum; i++ ){
		if( _CheckDeath( CharaNo[i] ) )	continue;
	
		m_NamePlate[i].Back.SetAlpha		( NAME_NOT_ALPHA );
		m_NamePlate[i].LineW.SetAlpha		( NAME_NOT_ALPHA );
		m_NamePlate[i].LineH.SetAlpha		( NAME_NOT_ALPHA );
		m_NamePlate[i].Triangle.SetAlpha	( NAME_NOT_ALPHA );
		m_NamePlate[i].Mini.SetAlpha		( NAME_NOT_ALPHA );
		m_NamePlate[i].NameColor =  0xffffff40;

	}
	return true;
}

//========================================================================
//					l[v[gZbg
//========================================================================
void		SK7Special::SetAllNamePlate( u8 No, f32 IncX )
{
	for( int i = 0; i < m_chCharaNum; i++ ){
		if( i < m_chCharaNum-1 ){
			if( i == No ){
				SetNamePlatePos( &m_NamePlate[i], No, true, IncX ); 
			}else{
				SetNamePlatePos( &m_NamePlate[i], (u8)i, false, IncX ); 
			}
		}else{
			if( i == No ){
				SetNamePlatePos( &m_NamePlate[i], No, true, IncX ); 
			}else{
				SetNamePlatePos( &m_NamePlate[i], (u8)i, false, IncX ); 
			}
		}
		SetNamePlateRender( &m_NamePlate[i], true );
	}
}

//========================================================================
//					l[v[g̍WZbg
//========================================================================
void	SK7Special::SetNamePlatePos( NamePlate* pNp, u8 No, bool Select, f32 IncX )
{
	f32 SelectX=0.0f;
	int TexNo = No;
	if( Select )	SelectX = NAME_SELECT_PLUSX;

	pNp->Back.SetSprite			( NAME_BACK_X+SelectX+IncX, m_fNameBackY+No*NAME_GAP_Y, NAME_BACK_SIZEX, NAME_BACK_SIZEY, NAME_BACK_COLOR );
	pNp->LineH.SetSprite		( NAME_BACK_X+SelectX+IncX, m_fNameBackY+No*NAME_GAP_Y, NAME_BACK2_SIZE, NAME_BACK_SIZEY, NAME_BACK2_COLOR );
	pNp->LineW.SetSprite		( NAME_BACK_X+SelectX+IncX, m_fNameBackY+No*NAME_GAP_Y+NAME_BACK_SIZEY-NAME_BACK2_SIZE, NAME_BACK_SIZEX, NAME_BACK2_SIZE, NAME_BACK2_COLOR );		
	pNp->Mini.SetSprite			( NAME_MINI_X+SelectX+IncX, m_fNameBackY+No*NAME_GAP_Y, NAME_MINI_SIZEX, NAME_MINI_SIZEY, NAME_BACK_COLOR );
	pNp->Triangle.SetTriangle	( NAME_TRIANGLE_X+SelectX+IncX, NAME_TRIANGLE_Y+No*NAME_GAP_Y, NAME_TRIANGLE_X+NAME_TRIANGLE_PLUSX+SelectX+IncX, NAME_TRIANGLE_Y+No*NAME_GAP_Y, NAME_TRIANGLE_X+SelectX+IncX, NAME_TRIANGLE_Y+No*NAME_GAP_Y+NAME_TRIANGLE_PLUSY,NAME_TRIANGLE_COLOR );
	pNp->NameColor = NAME_FONT_COLOR;
	if( Select ){
		pNp->MoveTime = NAME_MOVE_TIME;
		m_spNameKasan.SetTexSprite	( NAME_BACK_X+NAME_SELECT_PLUSX*2+IncX+KASAN_GAPX, m_fNameBackY+No*NAME_GAP_Y+KASAN_GAPY, g_pSpData->GetTexture(TEX_NAME_KASAN) );		
		m_spNameKasan.SetTwoSize	( KASAN_SIZE_X, KASAN_SIZE_Y ); 
		m_spNameKasan.SetColor		( KASAN_COLOR );
		m_spNameKasan.SetFlag		( true, SIZE_FLAG );
	}
	SetNamePlateRender( pNp, true );
}

//========================================================================
//					l[v[g̍WZbg
//========================================================================
void	SK7Special::SetNamePlatePositon( NamePlate* pNp, u8 No, f32 IncX )
{
	int TexNo = No;

	pNp->Back.SetXY0		( NAME_BACK_X+IncX, m_fNameBackY+No*NAME_GAP_Y );	
	pNp->LineH.SetXY0		( NAME_BACK_X+IncX, m_fNameBackY+No*NAME_GAP_Y );
	pNp->LineW.SetXY0		( NAME_BACK_X+IncX, m_fNameBackY+No*NAME_GAP_Y+NAME_BACK_SIZEY-NAME_BACK2_SIZE );
	pNp->Mini.SetXY0		( NAME_MINI_X+IncX, m_fNameBackY+No*NAME_GAP_Y );
	pNp->Triangle.SetXY0	( NAME_TRIANGLE_X+IncX, NAME_TRIANGLE_Y+No*NAME_GAP_Y );
	pNp->Triangle.SetXY1	( NAME_TRIANGLE_X+NAME_TRIANGLE_PLUSX+IncX, NAME_TRIANGLE_Y+No*NAME_GAP_Y );
	pNp->Triangle.SetXY2	( NAME_TRIANGLE_X+IncX, NAME_TRIANGLE_Y+No*NAME_GAP_Y+NAME_TRIANGLE_PLUSY );
	SetNamePlateRender( pNp, true );
}


//========================================================================
//					l[v[g̍WZbg
//========================================================================
void	SK7Special::SetNamePlateIncPos( NamePlate* pNp, u8 No, bool Select, f32 IncX )
{
	int TexNo = No;

	pNp->Back.SetIncX		( IncX );	
	pNp->LineH.SetIncX		( IncX );
	pNp->LineW.SetIncX		( IncX );
	pNp->Mini.SetIncX		( IncX );
	pNp->Triangle.SetIncX	( IncX );
	if( Select ){
		pNp->MoveTime = NAME_MOVE_TIME;
		m_spNameKasan.SetTexSprite	( NAME_BACK_X+NAME_SELECT_PLUSX*2+IncX+KASAN_GAPX, m_fNameBackY+No*NAME_GAP_Y+KASAN_GAPY, g_pSpData->GetTexture(TEX_NAME_KASAN) );
	}
	SetNamePlateRender( pNp, true );
}

//========================================================================
//					l[v[g̍WZbg
//========================================================================
void	SK7Special::SetNamePlateRender( NamePlate* pNp, bool Render )
{
	pNp->Back.SetVisible		( Render );
	pNp->LineW.SetVisible		( Render );
	pNp->LineH.SetVisible		( Render );
	pNp->Triangle.SetVisible	( Render );
	pNp->Mini.SetVisible		( Render );
	pNp->NameVisible = Render;
	
	m_spNameKasan.SetVisible	( Render );
}


//========================================================================
//					g̍쐬
//========================================================================
void		SK7Special::SetSelectWaku( bool Render )
{
	if( m_chItemSelect == 0 ){
		for( int i = 0; i < SELECT_WAKU_NUM; i++ ){
			m_spSelect[i].SetXY0	( tblSelectWaku[i].vL.x+tblSelectItemPos[m_chItemSelect].x, tblSelectWaku[i].vL.y+tblSelectItemPos[m_chItemSelect].y );
			m_spSelect[i].SetSTTwo	( 0.0f, 0.0f, 1.0f, 1.0f );
			m_spSelect[i].SetVisible( Render );
		}
		SET_SPRITE_ROT( &m_spSelect[SELECT_WAKU_ROTNO], 270, tblSelectWaku[SELECT_WAKU_ROTNO].vL.x+tblSelectItemPos[m_chItemSelect].x+11, 
						tblSelectWaku[SELECT_WAKU_ROTNO].vL.y+tblSelectItemPos[m_chItemSelect].y+36, m_spSelect[SELECT_WAKU_ROTNO].GetTexSizeX(), m_spSelect[SELECT_WAKU_ROTNO].GetTexSizeY() ); 
		m_spSelect[0].SetXY0	( tblSelectWaku[0].vL.x+tblSelectItemPos[m_chItemSelect].x, 240.0f );
		m_spSelect[0].SetTwoSize( m_spSelect[0].GetTexSizeX(), tblWakuUpSize[m_chItemSelect] );
	}else{
		for( int i = 0; i < SELECT_WAKU_NUM; i++ ){
			m_spSelect[i].SetXY0	( tblSelectWaku[i].vR.x+tblSelectItemPos[m_chItemSelect].x, tblSelectWaku[i].vR.y+tblSelectItemPos[m_chItemSelect].y );
			m_spSelect[i].SetSTTwo	( 1.0f, 0.0f, 0.0f, 1.0f );
			m_spSelect[i].SetVisible( Render );
		}
		SET_SPRITE_ROT( &m_spSelect[SELECT_WAKU_ROTNO], 270, tblSelectWaku[SELECT_WAKU_ROTNO].vR.x+tblSelectItemPos[m_chItemSelect].x+6,
						tblSelectWaku[SELECT_WAKU_ROTNO].vR.y+tblSelectItemPos[m_chItemSelect].y+36.0f, m_spSelect[SELECT_WAKU_ROTNO].GetTexSizeX(), m_spSelect[SELECT_WAKU_ROTNO].GetTexSizeY() );
		m_spSelect[0].SetXY0	( tblSelectWaku[0].vR.x+tblSelectItemPos[m_chItemSelect].x, 240.0f );
		m_spSelect[0].SetTwoSize( m_spSelect[0].GetTexSizeX(), tblWakuUpSize[m_chItemSelect] );
	}
}



//========================================================================
//				ACeIC
//========================================================================
void		SK7Special::RenderCharaState()
{
	//	t	*************************************************
	YK7StrImage* pString = m_pOption->GetYamadaFont();
	pString->DrawSetup();
	pString->SetExRate(0.70f);
	pString->SetColor2( 0x000000ff );
	pString->DrawFSStr( m_fBloodNoX+2.0f, BLOOD_NO_Y+2.0f, false, true, "~%d", (m_pOption->GetBloodGauge( BP_THIN )/BLOOD_PACK)  ); 
	pString->DrawSetup();
	pString->SetExRate(0.70f);
	pString->SetColor2( 0xffffffff );
	pString->DrawFSStr( m_fBloodNoX, BLOOD_NO_Y, false, true, "~%d", (m_pOption->GetBloodGauge( BP_THIN )/BLOOD_PACK)  ); 
	
	//	EC__	-----------------------------------------------------
	if( GameInfo.GetScenarioID() == 2 ){			//	NIgR̂Ƃ
		pString->DrawSetup();
		pString->SetExRate(0.75f);
		pString->SetColor2( 0xffffffff );
		pString->DrawFSStr( m_fMedalX, MEDAL_NO_Y, false, true, "~%d", K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) ); 
		pString->DrawFSStr( m_fMedalX, MEDAL_NO_Y+2, false, true, "~%d", K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) ); 
	}
		
	if( WK7PLAYERCONTROL->GetMainID() != K7GAL ){
		//	
		for( int i = 0; i < STATE_LIST_NUM; i++ ){
			m_pYFont->DrawSetup();
			m_pYFont->SetExRate( 1.0f );
			m_pYFont->SetColor2( 0x000000ff );
			if( i == 0 ){
				m_pYFont->DrawFSStr( m_fStateFontX, STATE_Y+i*STATE_GAP_Y, false, true, "Power LV%d Speed", pWK7Skill->GetSkillLv( SKILL_GUNPOWER, GetPlayerID((u8)(m_chNameSelect)) ) );//WK7PLAYERCONTROL->GetMainID()  )  );	
				m_pYFont->DrawFSStr( m_fStateFontX+2, STATE_Y+i*STATE_GAP_Y, false, true, "Power"  );
				m_pYFont->DrawFSStr( m_fStateFontX+101, STATE_Y+i*STATE_GAP_Y, false, true, "Speed"  );
			}
			if( i == 1 ){
				if( GetPlayerID((u8)(m_chNameSelect)) == K7KVN ){//WK7PLAYERCONTROL->GetMainID() == K7KVN ){
					m_pYFont->DrawFSStr( m_fStateFontX, STATE_Y+i*STATE_GAP_Y, false, true, "LV%d Invisible LV%d", pWK7Skill->GetSkillLv( SKILL_SHOTCANCEL, GetPlayerID((u8)(m_chNameSelect))/*WK7PLAYERCONTROL->GetMainID()*/ ), pWK7Skill->GetSkillLv( SKILL_BURE, GetPlayerID((u8)(m_chNameSelect))));
					m_pYFont->DrawFSStr( m_fStateFontX+1, STATE_Y+i*STATE_GAP_Y, false, true, "       Invisible" );
				}else{
					m_pYFont->DrawFSStr( m_fStateFontX, STATE_Y+i*STATE_GAP_Y, false, true, "LV%d Waver LV%d", pWK7Skill->GetSkillLv( SKILL_SHOTCANCEL, GetPlayerID((u8)(m_chNameSelect))/*WK7PLAYERCONTROL->GetMainID()*/ ), pWK7Skill->GetSkillLv( SKILL_BURE, GetPlayerID((u8)(m_chNameSelect))));
					m_pYFont->DrawFSStr( m_fStateFontX+1, STATE_Y+i*STATE_GAP_Y, false, true, "       Waver" );
				}
			}
			if( i == 2 ){
				if( GetPlayerID((u8)(m_chNameSelect)) == K7MSK ){// WK7PLAYERCONTROL->GetMainID() == K7MSK ){
					m_pYFont->DrawFSStr( m_fStateFontX, STATE_Y+i*STATE_GAP_Y, false, true, "Range LV%d", pWK7Skill->GetSkillLv( SKILL_CRITICALSIZE, GetPlayerID((u8)(m_chNameSelect)))/*WK7PLAYERCONTROL->GetMainID() )*/  ); 
					m_pYFont->DrawFSStr( m_fStateFontX+2, STATE_Y+i*STATE_GAP_Y, false, true, "Range" );					
				}else{
					m_pYFont->DrawFSStr( m_fStateFontX, STATE_Y+i*STATE_GAP_Y, false, true, "Critical LV%d", pWK7Skill->GetSkillLv( SKILL_CRITICALSIZE, GetPlayerID((u8)(m_chNameSelect)))/*WK7PLAYERCONTROL->GetMainID() )*/  ); 
					m_pYFont->DrawFSStr( m_fStateFontX+2, STATE_Y+i*STATE_GAP_Y, false, true, "Critical" );
				}
			}
		}
	}
}

//========================================================================
//				ACeIC
//========================================================================
void		SK7Special::RenderRingName()
{
	if( !m_bRingNameFlag )			return;

#if 0
	static VEC2 v={ RING_NAME_X, RING_NAME_Y };
	v.x += HSD_PadGetNormalSubStickX(0);
	v.y += HSD_PadGetNormalSubStickY(0);
#endif

	//	OĂȂƂ͕\Ȃ	------------------------------------------------------------------
	m_pYFont->DrawSetup();
	m_pYFont->SetExRate( 1.0f );
	m_pYFont->SetColor2( 0x000000ff );
	
	//	TCY擾	---------------------------------------------------------------------------
	if( m_eProc != PROC_MOVE ){
		m_fRingNameX = RING_NAME_CENTERX - (m_pYFont->DrawFSStr( m_fRingNameX, 	RING_NAME_Y, false, false, 	tblRingName[m_RingIcon.SelectNo] )*0.5f);
	}
	
	if( m_RingIcon.SelectNo != RING_NOT_NO ){
		m_pYFont->DrawFSStr( m_fRingNameX+2, 	RING_NAME_Y+2, 	false, true,	tblRingName[m_RingIcon.SelectNo] );
	}
	GXColor ColorTable[]={ {255,139,46,255}, {47,168,197,255}, {149,33,192,255}, {137,199,49,255}, {237,51,53,255}, {245,177,43,255},{41,140,190,255},{0,0,0,255}, };
	m_pYFont->DrawSetup();
	m_pYFont->SetExRate( 1.0f );
	m_pYFont->SetColor( &ColorTable[m_RingIcon.SelectNo] );
	m_pYFont->DrawFSStr( m_fRingNameX, RING_NAME_Y, false, true, tblRingName[m_RingIcon.SelectNo] );
}

//========================================================================
//					݂̃O`FbN
//========================================================================
s8			SK7Special::GetRingNo()
{
	if( m_RingIcon.bNotFlag )	return -1;
	
	int IconNo=0;
	s8 IconTexNo = (s8)m_RingIcon.View[IconNo].TexNo;
	for( int i = 0; i < m_RingIcon.iIconNum; i++ ){
		if( m_RingIcon.View[IconNo].v.x < m_RingIcon.View[i].v.x ){
			IconNo = i;
			IconTexNo = (s8)m_RingIcon.View[i].TexNo;
		}
	}
	return IconTexNo;		
}

//========================================================================
//					plړZbg
//========================================================================
void		SK7Special::SetMovePanel()
{
	//	ݍWQbg	------------------------------------
	m_Panel.MoveTime = PANEL_MOVE_SPEED;
	SET_VEC2XY( m_Panel.vS0, m_Panel.sprite.GetX0(), m_Panel.sprite.GetY0() );
	SET_VEC2XY( m_Panel.vS1, m_Panel.sprite.GetX1(), m_Panel.sprite.GetY1() );
	SET_VEC2XY( m_Panel.vS2, m_Panel.sprite.GetX2(), m_Panel.sprite.GetY2() );
	SET_VEC2XY( m_Panel.vS3, m_Panel.sprite.GetX3(), m_Panel.sprite.GetY3() );
}


//========================================================================
//					[uplړ
//========================================================================
void		SK7Special::MovePanel()
{
	if( --m_Panel.MoveTime >= 0 ){
		m_Panel.sprite.SetXY0( m_Panel.sprite.GetX0()+(tblPanelData[m_chBlockSelect].v0.x-m_Panel.vS0.x)/PANEL_MOVE_SPEED, m_Panel.sprite.GetY0()+(tblPanelData[m_chBlockSelect].v0.y-m_Panel.vS0.y)/PANEL_MOVE_SPEED );
		m_Panel.sprite.SetXY1( m_Panel.sprite.GetX1()+(tblPanelData[m_chBlockSelect].v1.x-m_Panel.vS1.x)/PANEL_MOVE_SPEED, m_Panel.sprite.GetY1()+(tblPanelData[m_chBlockSelect].v1.y-m_Panel.vS1.y)/PANEL_MOVE_SPEED );
		m_Panel.sprite.SetXY2( m_Panel.sprite.GetX2()+(tblPanelData[m_chBlockSelect].v2.x-m_Panel.vS2.x)/PANEL_MOVE_SPEED, m_Panel.sprite.GetY2()+(tblPanelData[m_chBlockSelect].v2.y-m_Panel.vS2.y)/PANEL_MOVE_SPEED );
		m_Panel.sprite.SetXY3( m_Panel.sprite.GetX3()+(tblPanelData[m_chBlockSelect].v3.x-m_Panel.vS3.x)/PANEL_MOVE_SPEED, m_Panel.sprite.GetY3()+(tblPanelData[m_chBlockSelect].v3.y-m_Panel.vS3.y)/PANEL_MOVE_SPEED );
	}else{
		m_Panel.MoveTime = 0;
	}
}

//========================================================================
//					plړIZbg
//========================================================================
void		SK7Special::SetMoveEndPanel()
{
	m_Panel.sprite.SetXY0( tblPanelData[m_chBlockSelect].v0.x,	tblPanelData[m_chBlockSelect].v0.y );
	m_Panel.sprite.SetXY1( tblPanelData[m_chBlockSelect].v1.x,	tblPanelData[m_chBlockSelect].v1.y );
	m_Panel.sprite.SetXY2( tblPanelData[m_chBlockSelect].v2.x,	tblPanelData[m_chBlockSelect].v2.y );
	m_Panel.sprite.SetXY3( tblPanelData[m_chBlockSelect].v3.x,	tblPanelData[m_chBlockSelect].v3.y );
	m_Panel.MoveTime = 0;
}

//========================================================================
//				I}XN\
//========================================================================
void		SK7Special::SetBlockSelectMask( u8 BlockNo, bool Render )
{
	if( Render ){
		for( int i = 0; i < MASK_MAX; i++ ){
			m_spMask[i].SetAlpha( MASK_ALPHA );
		}
		m_RingIcon.Kasan.SetAlpha( 0x00 );
	}
	switch(BlockNo){
	case BLOCK_SELECT_CHARA:
		if( !Render ){
			for( int i = 0; i < MASK_MAX; i++ ){
				if( !(i == MASK_CHARA_A || i == MASK_CHARA_B) ){
					m_spMask[i].AddAlpha( MASK_TIME, MASK_ALPHA );
				}
			}
			m_RingIcon.Kasan.DownAlpha( MASK_TIME, 0x00 );
		}
		m_spMask[MASK_CHARA_A].SetAlpha( 0x00 );
		m_spMask[MASK_CHARA_B].SetAlpha( 0x00 );
		break;
	case BLOCK_SELECT_ITEM:
		if( !Render ){
			for( int i = 0; i < MASK_MAX; i++ ){
				if( !(i == MASK_ITEM) ){
					m_spMask[i].AddAlpha( MASK_TIME, MASK_ALPHA );
				}
			}
			m_RingIcon.Kasan.SetAlpha( 0xff );
		}
		m_spMask[MASK_ITEM].SetAlpha( 0x00 );
		break;
	case BLOCK_SELECT_MEMO:		
		if( !Render ){
			for( int i = 0; i < MASK_MAX; i++ ){
				if( !(i == MASK_MEMO) ){
					m_spMask[i].AddAlpha( MASK_TIME, MASK_ALPHA );
				}
			}
			m_RingIcon.Kasan.DownAlpha( MASK_TIME, 0x00 );
		}
		m_spMask[MASK_MEMO].SetAlpha( 0x00 );
		break;
	case BLOCK_SELECT_BLOOD:
		if( !Render ){
			for( int i = 0; i < MASK_MAX; i++ ){
				if( !(i == MASK_BLOOD_A || i == MASK_BLOOD_B) ){
					m_spMask[i].AddAlpha( MASK_TIME, MASK_ALPHA );
				}
			}
			m_RingIcon.Kasan.DownAlpha( MASK_TIME, 0x00 );
		}
		m_spMask[MASK_BLOOD_A].SetAlpha( 0x00 );
		m_spMask[MASK_BLOOD_B].SetAlpha( 0x00 );
		break;
	default:
		for( int i = 0; i < MASK_MAX; i++ ){
			if( !Render ){
				m_spMask[i].DownAlpha( MASK_TIME, 0x00 );
			}else{
				m_spMask[i].SetAlpha( 0x00 );
			}
		}
		if( !Render )	m_RingIcon.Kasan.AddAlpha	( MASK_TIME, 0xff );
		else			m_RingIcon.Kasan.SetAlpha	( 0xff );
		break;
	}
}

//========================================================================
//					ACR̃C[WZbg
//========================================================================
void		SK7Special::SetRingSelectState( bool ring, bool photo, bool lr )
{
	int i;
	
	u32 ringcolor = 0xffffffff;
	if( !ring ){
		m_RingIcon.Kasan.SetVisible( false );
		ringcolor = RING_COLOR_NOTSELECT;
	}else{
		if( !m_RingIcon.Sample.CheckFlag( RENDER_FLAG ) )	m_RingIcon.Kasan.SetVisible( true );
	}
	
	for( i = 0; i < m_RingIcon.iIconNum; i++ ){
		m_RingIcon.Stone[i].SetColor( ringcolor );
		m_RingIcon.Mini[i].SetColor( ringcolor );
	}
	
	u32 photocolor = 0xffffffff;
	if( !photo )	photocolor = PHOTO_COLOR_NOTSELECT;
	m_Photo.Small.SetColor	( photocolor );
	
	u32 iconcolor = 0xffffffff;
	if( ring || photo )		iconcolor = PHOTO_COLOR_NOTSELECT;
	if( m_pspSubIcon != NULL )	m_pspSubIcon->SetColor	( iconcolor ); 
		
	if( lr ){
		SET_SPRITE_ROT( &m_spSelect[SELECT_WAKU_ROTNO], 270, tblSelectWaku[SELECT_WAKU_ROTNO].vL.x+tblSelectItemPos[m_chItemSelect].x+11, tblSelectWaku[SELECT_WAKU_ROTNO].vL.y+tblSelectItemPos[m_chItemSelect].y+36,
							m_spSelect[SELECT_WAKU_ROTNO].GetTexSizeX()*tblSelectAnim[m_iSelectTime].Ex[SELECT_WAKU_ROTNO], m_spSelect[SELECT_WAKU_ROTNO].GetTexSizeY()*tblSelectAnim[m_iSelectTime].Ex[SELECT_WAKU_ROTNO] ); 
	}else{
		SET_SPRITE_ROT( &m_spSelect[SELECT_WAKU_ROTNO], 270, tblSelectWaku[SELECT_WAKU_ROTNO].vR.x+tblSelectItemPos[m_chItemSelect].x+6, tblSelectWaku[SELECT_WAKU_ROTNO].vR.y+tblSelectItemPos[m_chItemSelect].y+36,
						m_spSelect[SELECT_WAKU_ROTNO].GetTexSizeX()*tblSelectAnim[m_iSelectTime].Ex[SELECT_WAKU_ROTNO], m_spSelect[SELECT_WAKU_ROTNO].GetTexSizeY()*tblSelectAnim[m_iSelectTime].Ex[SELECT_WAKU_ROTNO] ); 
	}
}

//========================================================================
//				tHg̃ZNgAt@o
//========================================================================
void	SK7Special::SetAnswerAlpha( u8 Block )
{
	for( int i = 0; i < SELECT_FONT_MAX; i++ ){
		switch( Block ){
		case BLOCK_SELECT_CHARA:
			if( i < 3 )	m_SelectFont.Chara[i].AddAlpha( SELECT_ALPHA_ANSWER_SPEED );
			m_ShadowSmall.Font[i].DownAlpha( SELECT_ALPHA_ANSWER_SPEED );
			m_ShadowBig.Font[i].DownAlpha( SELECT_ALPHA_ANSWER_SPEED );
			break;
		case BLOCK_SELECT_ITEM:
			m_SelectFont.Item[i].AddAlpha( SELECT_ALPHA_ANSWER_SPEED );
			m_ShadowSmall.Font[i].DownAlpha( SELECT_ALPHA_ANSWER_SPEED );
			m_ShadowBig.Font[i].DownAlpha( SELECT_ALPHA_ANSWER_SPEED );
			break;
		case BLOCK_SELECT_MEMO:
			if( i < 2 )	m_SelectFont.Memo[i].AddAlpha( SELECT_ALPHA_ANSWER_SPEED );
			m_ShadowSmall.Font[i].DownAlpha( SELECT_ALPHA_ANSWER_SPEED );
			m_ShadowBig.Font[i].DownAlpha( SELECT_ALPHA_ANSWER_SPEED );
			break;
		case BLOCK_SELECT_BLOOD:
			if( i < 2 )	m_SelectFont.Blood[i].AddAlpha( SELECT_ALPHA_ANSWER_SPEED );
			m_ShadowSmall.Font[i].DownAlpha( SELECT_ALPHA_ANSWER_SPEED );
			m_ShadowBig.Font[i].DownAlpha( SELECT_ALPHA_ANSWER_SPEED );
			break;
		}
	}
}

//========================================================================
//				tHg̃ZNgAt@
//========================================================================
void	SK7Special::SetSelectAlpha( u8 Block, u8 Select )
{
	int i;
	for( i = 0; i < SELECT_FONT_MAX; i++ ){
		switch( Select ){
		case SET_ALPHA_DOWN:
			m_ShadowSmall.Font[i].DownAlpha( SELECT_ALPHA_SPEED, 0x00 );
			m_ShadowBig.Font[i].DownAlpha( SELECT_ALPHA_SPEED, 0x00 );
			if( i < 3 ){
				if( Block != BLOCK_SELECT_CHARA )	m_SelectFont.Chara[i].DownAlpha( SELECT_ALPHA_SPEED, 0x00 );
			}
			if( i < 2 ){
				if( Block != BLOCK_SELECT_MEMO )	m_SelectFont.Memo[i].DownAlpha( SELECT_ALPHA_SPEED, 0x00 );
				if( Block != BLOCK_SELECT_BLOOD )	m_SelectFont.Blood[i].DownAlpha( SELECT_ALPHA_SPEED, 0x00 );
			}
			if( Block != BLOCK_SELECT_ITEM )		m_SelectFont.Item[i].DownAlpha( SELECT_ALPHA_SPEED, 0x00 );
			break;
			
		case SET_ALPHA_ADD:
			m_ShadowSmall.Font[i].AddAlpha( SELECT_ALPHA_SPEED, 0xff );
			m_ShadowBig.Font[i].AddAlpha( SELECT_ALPHA_SPEED, 0xff );
			if( i < 3 ){
				if( Block != BLOCK_SELECT_CHARA )	m_SelectFont.Chara[i].AddAlpha( SELECT_ALPHA_SPEED, 0xff);
			}
			if( i < 2 ){
				if( Block != BLOCK_SELECT_MEMO )	m_SelectFont.Memo[i].AddAlpha( SELECT_ALPHA_SPEED, 0xff );
				if( Block != BLOCK_SELECT_BLOOD )	m_SelectFont.Blood[i].AddAlpha( SELECT_ALPHA_SPEED, 0xff );
			}
			if( Block != BLOCK_SELECT_ITEM )		m_SelectFont.Item[i].AddAlpha( SELECT_ALPHA_SPEED, 0xff );
			break;
			
		case SET_ALPHA_ZERO:
			m_ShadowSmall.Font[i].SetAlpha( 0 );
			m_ShadowBig.Font[i].SetAlpha( 0 );
			if( i < 3 ){
				m_SelectFont.Chara[i].SetAlpha( 0 );
			}
			if( i < 2 ){
				m_SelectFont.Memo[i].SetAlpha( 0 );
				m_SelectFont.Blood[i].SetAlpha( 0 );
			}
			m_SelectFont.Item[i].SetAlpha( 0 );
			break;
			
		case SET_ALPHA_FULL:
			m_ShadowSmall.Font[i].SetAlpha( 0x00 );
			m_ShadowBig.Font[i].SetAlpha( 0x00 );
			if( i < 3 ){
				m_SelectFont.Chara[i].SetAlpha( 0xff );
			}
			if( i < 2 ){
				m_SelectFont.Memo[i].SetAlpha( 0xff );
				m_SelectFont.Blood[i].SetAlpha( 0xff );
			}
			m_SelectFont.Item[i].SetAlpha( 0xff );
			break;
		}
	}
}


//========================================================================
//				tHg̃ZNgݒ
//========================================================================
void	SK7Special::SetSelectFont( u8 Select, bool Anwer )
{	
	int i;
	//		--------------------------------------------------------------------------------------
	if( !Anwer ){
		m_SelectFont.Chara[0].SetTexSprite( tblSelectFont[FONT_SMITHS].x, tblSelectFont[FONT_SMITHS].y,  g_pSpData->GetTexture(TEX_GROUP_A), 1, SP_SELECT_NUM, 0 );
		m_SelectFont.Chara[0].SetVisible( true );
		for( i = 1; i < 3; i++ )	m_SelectFont.Chara[i].SetVisible( false );
		m_SelectFont.Memo[0].SetTexSprite( tblSelectFont[FONT_MEMO].x, tblSelectFont[FONT_MEMO].y,	g_pSpData->GetTexture(TEX_GROUP_A), 1, SP_SELECT_NUM, 1);
		m_SelectFont.Memo[0].SetVisible( true );
		m_SelectFont.Memo[1].SetVisible( false );
		m_SelectFont.Blood[0].SetTexSprite( tblSelectFont[FONT_BLOOD].x, tblSelectFont[FONT_BLOOD].y, g_pSpData->GetTexture(TEX_GROUP_A), 1, SP_SELECT_NUM, 2 );
		m_SelectFont.Blood[0].SetVisible( true );
		m_SelectFont.Blood[1].SetVisible( false );
		m_SelectFont.Item[0].SetTexSprite( tblSelectFont[FONT_ITEM].x, tblSelectFont[FONT_ITEM].y, g_pSpData->GetTexture(TEX_GROUP_A), 1, SP_SELECT_NUM, 3 );
		m_SelectFont.Item[0].SetVisible( true );
		for( i = 0; i < 4; i++ ){
			if( i != 0 )	m_SelectFont.Item[i].SetVisible( false );
			m_SelectFont.vSpeed[i].x = m_SelectFont.vSpeed[i].y	= 0;
			m_SelectFont.AddTime[i]	= m_SelectFont.EndTime[i]	= 0;
		}
	}

	switch( Select ){
	case BLOCK_SELECT_CHARA:
		if( Anwer ){
			for( int i = 0; i < 4; i++ ){
				if( i < 2 ){
					m_SelectFont.Chara[i].SetTexture(g_pSpData->GetTexture((u8)(TEX_MOJI_KOU+i)) );
					m_SelectFont.Chara[i].SetVisible( true );
					m_SelectFont.Chara[i].SetAlpha( SELECT_FONT_DOWN_ALPHA );
				}
			}
		}else{
			for( int i = 0; i < 2; i++ ){
				m_SelectFont.Chara[i].SetTexSprite( tblSelectFont[FONT_M_JIN+i].x, 	tblSelectFont[FONT_M_JIN+i].y,  g_pSpData->GetTexture((u8)(TEX_MOJI_JIN+i)));
				m_SelectFont.Chara[i].SetVisible( true );
			}
			m_SelectFont.Chara[2].SetVisible( false );
		}
		break;
	case BLOCK_SELECT_ITEM:
		if( !Anwer ){
			for( int i = 0; i < 4; i++ ){
				m_SelectFont.Item[i].SetTexSprite( tblSelectFont[FONT_M_A+i].x, 	tblSelectFont[FONT_M_A+i].y,  g_pSpData->GetTexture((u8)(TEX_MOJI_A+i)));
				m_SelectFont.Item[i].SetVisible( true );
			}
		}else{
			for( int i = 0; i < 4; i++ ){
				m_SelectFont.Item[i].SetAlpha( SELECT_FONT_DOWN_ALPHA );
			}
		}
		break;
	case BLOCK_SELECT_MEMO:
		if( Anwer ){
			for( int i = 0; i < 4; i++ ){
				if( i < 2 ){
					m_SelectFont.Memo[i].SetTexture( g_pSpData->GetTexture((u8)(TEX_MOJI_HA+i)) );
					m_SelectFont.Memo[i].SetVisible( true );
					m_SelectFont.Memo[i].SetAlpha( SELECT_FONT_DOWN_ALPHA );
				}
			}
		}else{
			for( int i = 0; i < 2; i++ ){
				m_SelectFont.Memo[i].SetTexSprite( tblSelectFont[FONT_ME+i].x, 	tblSelectFont[FONT_ME+i].y,  g_pSpData->GetTexture((u8)(TEX_MOJI_ME+i)));
				m_SelectFont.Memo[i].SetVisible( true );
			}
		}
		break;		
	case BLOCK_SELECT_BLOOD:
		if( Anwer ){
			for( int i = 0; i < 4; i++ ){
				if( i < 2 ){
					m_SelectFont.Blood[i].SetTexture(g_pSpData->GetTexture((u8)(TEX_MOJI_KAI+i)));
					m_SelectFont.Blood[i].SetVisible( true );
					m_SelectFont.Blood[i].SetAlpha( SELECT_FONT_DOWN_ALPHA );
				}
			}
		}else{
			for( int i = 0; i < 2; i++ ){
				m_SelectFont.Blood[i].SetTexSprite( tblSelectFont[FONT_KETU+i].x, 	tblSelectFont[FONT_KETU+i].y,  g_pSpData->GetTexture((u8)(TEX_MOJI_KETSU+i)));
				m_SelectFont.Blood[i].SetVisible( true );
			}
		}
		break;
	}
}


//========================================================================
//					ACR̂\[g
//========================================================================
void		SK7Special::IconZSort()
{
	int i, j;
	for( i = 0; i < m_RingIcon.iIconNum; i ++ ){
		for( j = 0; j < m_RingIcon.iIconNum; j ++ ){
			if( m_RingIcon.Obj[i].v.z > m_RingIcon.Obj[j].v.z ){
				m_RingIcon.SaveIcon = m_RingIcon.Obj[i];
				m_RingIcon.Obj[i] = m_RingIcon.Obj[j];
				m_RingIcon.Obj[j] = m_RingIcon.SaveIcon;
			}
		}
	}
}

//========================================================================
//					ϊ
//========================================================================
void		SK7Special::ChangeView()
{
	f32 fScale;
#ifdef __RING_DEBUG__
	static f32 eye_z = RING_ICON_EYEZ;
	eye_z += HSD_PadGetNormalStickY(0);
#endif
	
	for( int i = 0; i < m_RingIcon.iIconNum; i++ ){
		fScale = RING_ICON_EYEZ / ( m_RingIcon.Obj[i].v.z + RING_ICON_EYEZ );						// XP[t@N^
		m_RingIcon.View[i].v.x 	= m_RingIcon.Obj[i].v.x * fScale;			// ʒu
		m_RingIcon.View[i].v.y 	= m_RingIcon.Obj[i].v.y * fScale;
		m_RingIcon.View[i].v.z 	= m_RingIcon.Obj[i].v.z * fScale;
		m_RingIcon.View[i].w 	= (int)(m_RingIcon.Obj[i].w * fScale);	// 傫
		m_RingIcon.View[i].h 	= (int)(m_RingIcon.Obj[i].h * fScale);
		m_RingIcon.View[i].TexNo= m_RingIcon.Obj[i].TexNo;
	}
}

//========================================================================
//					ACR̃C[WZbg
//========================================================================
void			SK7Special::SetRingImage( s8 SetNo )
{
#ifdef __RING_DEBUG__
	static f32 		set_x = 159.3248f;
	static f32		set_y = 131.9251f;				
	static f32 		ZZ = 25.0f;
	set_y += HSD_PadGetNormalSubStickY(0);
	set_x += HSD_PadGetNormalSubStickX(0);
	if( HSD_PadGetRepeat(0) & HSD_PAD_UP ){
		ZZ++;
	}
	if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN ){
		ZZ--;
	}
#endif
	f32		nDisp_x, nDisp_y, nZ;

	for( int i = 0; i < m_RingIcon.iIconNum; i++ ){

#ifdef __RING_DEBUG__
		nDisp_x = m_RingIcon.View[i].v.x + set_x;
		nDisp_y = m_RingIcon.View[i].v.y + set_y;
		nZ = 0;//(-m_RingIcon.View[i].v.x+m_RingIcon.View[i].v.z)/ZZ;//RING_ICON_Z;
//		nZ = m_RingIcon.View[i].v.z/RING_ICON_Z;
#else
		if( m_RingIcon.iIconNum < 4 ){
			nDisp_x = m_RingIcon.View[i].v.x + RING_ICON_CENTER_X2;
			nDisp_y = m_RingIcon.View[i].v.y + RING_ICON_CENTER_Y;
		}else{
			nDisp_x = m_RingIcon.View[i].v.x + RING_ICON_CENTER_X;
			nDisp_y = m_RingIcon.View[i].v.y + RING_ICON_CENTER_Y;
		}
		nZ = 0;//(-m_RingIcon.View[i].v.x+m_RingIcon.View[i].v.z)/RING_ICON_Z;
#endif

		m_RingIcon.Stone[i].SetFlag( true, VTX4_FLAG|BLOCK_FLAG );
		
		//	ĂȂƂ	---------------------------------------------
		if( m_RingIcon.View[i].TexNo == SetNo ){
			nZ = -m_RingIcon.View[i].v.x/RING_ICON_Z;
			m_RingIcon.Stone[i].SetVisible( true );
		}
		m_RingIcon.Stone[i].SetXYTwo(	nDisp_x - ( m_RingIcon.View[i].w >> 1 ) + nZ,
										nDisp_y - ( m_RingIcon.View[i].h >> 1 ) + nZ,
										nDisp_x + ( m_RingIcon.View[i].w >> 1 ) - nZ,
										nDisp_y + ( m_RingIcon.View[i].h >> 1 ) - nZ);
		m_RingIcon.Stone[i].SetTexNo( m_RingIcon.View[i].TexNo );
	}
}


//========================================================================
//					ʉʃ^XN
//========================================================================
void			SK7Special::TaskMenu( u8 MenuNo )
{
	WK7Chara		*pChara;
	WK7Model		*pModel;

	switch( m_eMenuProc ){
	case OTHER_INIT:
		m_bBlur = SceneBlur.GetVisible();
		static WK7Cam::Mode	cammode = WK7CAM->GetMode();
		m_bVfx  = WK7RenderObj::GetVfxFlag();		
		WK7CAM->GetPosition(m_vCamPos);
		WK7CAM->GetTargetPosition( m_vCamTgt );
		WK7CAM->StoreFov ();
		WK7CAM->StoreNear();
		WK7CAM->StoreFar ();
	
		if( (pChara = WK7PLAYERCONTROL->GetCharaPtr())==NULL ||
		    (pModel = pChara->GetModel())==NULL ){
			return;
		}
		WK7PLAYERCONTROL->SetOperateEnable(false);
		WK7SELECTIF->Disappear();
		m_eMenuProc = OTHER_NOISE_START;
		break;
		
	case OTHER_NOISE_START:
		if( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==true ){
			m_pOption->SetRender(false);
			WK7PLAYERCONTROL->ReleaseArchive();	//	vC[̂݊J
			m_eMenuProc = OTHER_RELEASE_PLAYER;
		}
		break;
		
	case OTHER_RELEASE_PLAYER:	
		if( WK7PLAYERCONTROL->GetReleaseState()==WK7PlayerControl::RELEASEDARCHIVE ){
			SetBlockSelectMask( BLOCK_SELECT_NOT );
			m_bMaskFlag = true;
			m_eMenuProc = OTHER_CREATE_MENU;
		}
		break;		
		
	case OTHER_CREATE_MENU:
		if( (m_pMenu = SK7IMenuBase::Create( (u8)MenuNo, 0 )) != NULL){
			if( MenuNo == eMenuHatoMemo ){	
				m_bBlockFlag = false;
				for( int i = 0; i < 4; i++ ){
					m_ShadowSmall.Font[i].SetVisible( false );
					m_ShadowBig.Font[i].SetVisible( false );
				}
				SetSelectAlpha( (u8)m_chBlockSelect, SET_ALPHA_FULL );
			}
			m_bMenuRenderFlag = true;
			m_eMenuProc = OTHER_NOISE_END;
	    }
		break;
		
	case OTHER_NOISE_END:
		if( gpNoise->mGetSandFrameProc()==eSandExec ){
			m_eMenuProc = OTHER_MENU_READ_END;
		}
		break;
		
	case OTHER_MENU_READ_END:
		if( m_pMenu->GetFileReadEnd()==true ){
			m_bPlayerLightEnable = WK7PLAYERCONTROL->GetLightEnable();
			WK7PLAYERCONTROL->SetLightEnable(false);
			WK7Light::SetEnableAll(false,K7OBJTYPE_STG);
			WK7SIGHT->SetVisible(false);
			WK7PLAYERCONTROL->SetVisible(false);
			WK7Chara::SetRenderChara(false);
			WK7Stage::SetRenderStage(false);
			WK7Item::SetRenderItem  (false);
			SceneBlur.SetVisible(false);
			m_pMenu->SetRender(true);
			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
			WK7RenderObj::SetVfxFlag(false);
			m_eMenuProc = OTHER_NOISE_RELEASE;
		}
		break;
				
	case OTHER_NOISE_RELEASE:
		if( gpNoise->mSandRelease()==true ){
			m_eMenuProc = OTHER_NOISE_STANBY;
		}
		break;
		
	case OTHER_NOISE_STANBY:
		if( gpNoise->mGetSandFrameProc()==eSandStandby ){
			m_eMenuProc = OTHER_MENU_PROCESS;
			m_pMenu->SetCtrlFlag(true);
		}
		break;
		
	case OTHER_MENU_PROCESS:
		if( m_pMenu->GetMenuEnd()==true ){
			m_pMenu->SetCtrlFlag(false);
			m_eMenuProc = OTHER_MENU_END_NOISE;
		}
		break;
		
	case OTHER_MENU_END_NOISE:
		if( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==true ){
			m_bMenuRenderFlag = false;
			WK7PLAYERCONTROL->RestoreArchive();
			m_eMenuProc = OTHER_RESTORE_CHECK;
		}
		break;
		
	case OTHER_RESTORE_CHECK:
		if( WK7PLAYERCONTROL->GetReleaseState()==WK7PlayerControl::LOADED ){
			m_eMenuProc = OTHER_END_NOISE_START;
		}
		break;
		
	case OTHER_END_NOISE_START:
		if( gpNoise->mGetSandFrameProc()==eSandExec ){
			m_pMenu->SetRender (false);
			GHM_SAFE_DELETE(m_pMenu);
			WK7PLAYERCONTROL->GetPathControl()->CameraRenew();
			WK7PLAYERCONTROL->SetOperateEnable(false);					// ł͂ob֎~ɂ
//			WK7PLAYERCONTROL->VitalVisible(true);
			WK7PLAYERPATHCONTROL->SetActive(true);
			WK7PLAYERCONTROL->SetVisible(true);
			WK7Chara::SetRenderChara(true);
			WK7Stage::SetRenderStage(true);
			WK7Item::SetRenderItem  (true);
			SceneBlur.SetVisible(m_bBlur);
			WK7CAM->SetMode(cammode);
			WK7CAM->RestoreFov ();
			WK7CAM->RestoreNear();
			WK7CAM->RestoreFar ();
			WK7Light::SetEnableAll(true,K7OBJTYPE_STG);
			WK7PLAYERCONTROL->SetLightEnable(m_bPlayerLightEnable);
			WK7RenderObj::SetVfxFlag(m_bVfx);
			m_pOption->SetRender(true);
			m_bBlockFlag = false;
			SetSelectFont( 255, false );
			if( MenuNo != eMenuHatoMemo ){
				for( int i = 0; i < 4; i++ )	m_SelectFont.Item[i].SetVisible( false );
			}
			m_spLight.SetVisible( false );
			m_chBlockSelect = BLOCK_SELECT_NOT;
			SET_SPRITE_ROT				( &m_Panel.sprite, PANEL_ANGLE, PANEL_X+PANEL_SIZE*0.5f, PANEL_Y+PANEL_SIZE*0.5f, PANEL_SIZE, PANEL_SIZE );
			m_eMenuProc = OTHER_END_NOISE_RELEASE;
		}
		break;
		
	case OTHER_END_NOISE_RELEASE:
		if( gpNoise->mSandRelease()==true ){
			for( int i = 0; i < MASK_MAX; i++ ){
				m_spMask[i].SetAlpha( 0 );
			}
			m_eMenuProc = OTHER_PROC_END;
			m_spLight.SetVisible( false );
		}
		break;
	
	case OTHER_PROC_END:
		if( gpNoise->mGetSandFrameProc()==eSandStandby ){
			WK7CAM->SetPosition(m_vCamPos);
			WK7CAM->SetTargetPosition( m_vCamTgt );
			m_eMenuProc = 0;
			m_bMaskFlag = false;
			m_iMemoTime = 0;
			if( MenuNo == eMenuHatoMemo ){	
				m_eMemoProc = 0;
				m_eProc = PROC_BLOCK_SELECT;
			}else{
				m_eItemProc = ITEM_PROC_SELECT;		//	ZNg
			}
		}
		break;
	}
}

//========================================================================
//					܂܃Zbg
//========================================================================
void			SK7Special::SetTamatama()
{
	int i,num=0;
	//	ʐ	:::::::::::::::::::::::::::::::::::::::::::::::::::::::
	for( i = 0; i < SP_BULLET_NUM; i++ ){
		if( tblBulletNo[GameInfo.GetScenarioFlow()].No[i] == NULL )		break;
		num++;
	}
	//		------------------------------------------------------
	num = m_pOption->GetBalletNum();

	//	ʍ쐬	:::::::::::::::::::::::::::::::::::::::::::::::::::::::
	for( i = 0; i < SP_BULLET_NUM; i++ ){
		if( i < num ){
			m_Bullet[i].SetTexture	( g_pSpData->GetTexture(TEX_BULLET) );
			SET_SPRITE_ROT			( &m_Bullet[i], tblBulletState[i].Angle, (tblBulletState[i].XY.x+tblBulletState[i].Size.x*0.5f) , (tblBulletState[i].XY.y+tblBulletState[i].Size.y*0.5f), tblBulletState[i].Size.x, tblBulletState[i].Size.y );
			m_Bullet[i].SetIncX		( -m_fScrollX );
			m_Bullet[i].SetVisible	( true );	
		}else{
			m_Bullet[i].SetVisible	( false );
		}
	}
}

//========================================================================
//					Xe[WIuWFNgZbg
//========================================================================
void			SK7Special::SetStageObject()
{
	//	܂܂̃Zbg	-------------------------------------------------
	SetTamatama();
	
	int i=0, num=0;
	//	IuWFNg	========================================================
	for( i = 0; i < ITEM_NUM_MAX; i++ ){
		if( tblStageObj[GameInfo.GetScenarioFlow()].No[i] == NULL ){
			break;
		}
		num++;
	}
	//	IuWFNg쐬	====================================================
	for( i = 0; i < ITEM_NUM_MAX; i++ ){
		if( i >= num ) break;
		m_spItem[i].SetTexSprite( ITEM_POS_X+i*ITEM_POS_GAPX-m_fScrollX, ITEM_POS_Y, g_pStageData->GetStageTex(STAGE_TEX_ITEM) , (u16)num, 1, (u8)i );
		if( WK7EventItem::HasItem(K7EVITEM_KEYID( tblStageObj[GameInfo.GetScenarioFlow()].No[i] ) )){
			if( WK7EventItem::IsUsedItem(K7EVITEM_KEYID( tblStageObj[GameInfo.GetScenarioFlow()].No[i] )) ){
				m_spItem[i].SetVisible( false );
			}else{
				m_spItem[i].SetVisible( true );
			}
		}else{
			m_spItem[i].SetVisible( false );
		}
//		m_spItem[i].SetVisible	( WK7EventItem::HasItem(K7EVITEM_KEYID( tblStageObj[GameInfo.GetScenarioFlow()].No[i] )) );
	}
	//	ʐ^쐬	====================================================
	m_Photo.Small.SetVisible( tblPhotoMini[GameInfo.GetScenarioFlow()] );
	//	̑쐬	====================================================
	GHM_SAFE_DELETE( m_pspSubIcon );
	switch( GameInfo.GetScenarioFlow() ){
	//	eLTX	
	case K7SCNF_TXS:
		m_pspSubIcon = new SK7Sprite;
		//	ER -----------------------------------------------
		m_pspSubIcon->SetTexSprite( ULCL_X-m_fScrollX, ULCL_Y, g_pStageData->GetStageTex(STAGE_TEX_ICON) );
		m_pspSubIcon->SetVisible	( true );
		//	_	-----------------------------------------------
		ghmGcMemSetAllocName("SK7SPEMEDAL");
		m_pspMedal = new SK7Sprite;
		m_pspMedal->SetTexSprite( MEDAL_X-m_fScrollX, MEDAL_Y, g_pStageData->GetStageTex(STAGE_TEX_MEDAL) );
		m_pspMedal->SetVisible	( true );
		break;
	//	h~jJ		
	case K7SCNF_DM1:		
	case K7SCNF_DM2:
		m_pspSubIcon = new SK7Sprite;
		m_pspSubIcon->SetTexSprite( CHART_X-m_fScrollX, CHART_Y, g_pStageData->GetStageTex(STAGE_TEX_ICON) );
		m_pspSubIcon->SetVisible	( true );
		break;
	//	wZ		
	case K7SCNF_SCL:
		//	{CXR[_[	------------------------------------------
		if( K7SCR_GET_SCENARIO_FLAG( VRHAVE ) ){
			m_pspSubIcon = new SK7Sprite;
			m_pspSubIcon->SetTexSprite( VOICE_X-m_fScrollX, VOICE_Y, g_pStageData->GetStageTex(STAGE_TEX_ICON) );
			m_pspSubIcon->SetVisible	( true );
		}
		break;
	}
}

//========================================================================
//				ǂł͂Ȃ
//========================================================================
bool		SK7Special::MoveSore()
{
	bool retcode = false;
	if( ++m_Sore.Time >= MEMO_MOVE_FRAME  ){
		f32 Angle = MTXDegToRad(rand()%360);
		f32 Rad	  = rand()%MEMO_MOVE_SIZE;
		m_Sore.spFont.SetXY0	( SORE_X+(Rad*cosf(Angle)),  SORE_Y+(Rad*sinf(Angle)));
		m_Sore.spPlate.SetXY0	( SORE_X+(Rad*cosf(Angle)),  SORE_Y+(Rad*sinf(Angle)));
		m_Sore.Time = 0;
	}
	if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
		retcode = true;
		m_Sore.spFont.SetVisible( false );
		m_Sore.spPlate.SetVisible( false );
	}
	return retcode;
}

	