////////////////////////////////////////////////////////////////////////////////
//
// Kwiller7 SK7Special
//
// SK7Special.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 02/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7SPECIAL_H__
#define	__SK7SPECIAL_H__

#include "SK7Font.h"
#include "SK7Pack.h"
#include "SK7SpOption.h"
#include "SK7IMenuBase.h"
#include "../Yam/YK7String.h"
#include "SK7SpecialData.h"


#define		BEAKER_BOTTOM_Y		(446)


#define		CHANGE_CHARA_NUM	(7)//(6)
#define		BLOCK_NAME_NUM		(6)
#define		BLOOD_PACK_NUM		(7)
#define		SP_LINE_NUM			(11)
#define		SP_MOVE_FRAME		(6)
#define		LINE_LEFT_X			(538.0f)
#define		RIGHT_LINE_NUM		(2)//11)

#define		SP_SELECT_NUM		(4)
#define		SP_RING_NUM			(8)
#define		RING_NOT_NO			(7)
#define		ITEM_PLATE_NUM		(3)
#define		LIFE_BLOOD_NUM		(250)
#define		WINDOW_COLOR		(0x646464B2)//(0x707070c0)
#define		BEAKER_BLOOD_COLOR2	(0x9e0c14ff)


//	Ԃl	=====================================
#define		RESULT_SP_NONE		(0x00000000)		//	ȂB
#define		RESULT_SP_START		(0x00000001)		//	X^[g{^ăACeʂ
#define		RESULT_SP_CHARA		(0x00010000)		//	L`FW
#define		RESULT_SP_SPECIAL	(0x00100000)		//	Zԍ
#define		RESULT_SP_ITEM		(0x01000000)		//	ACeԍ

//	:::::::::::::::		L`FW		::::::::::::::::::::::::::::::::::::::
#define		RESULT_CHANGE_DAN	(0x00010000)		//	_
#define		RESULT_CHANGE_KED	(0x00020000)		//	
#define		RESULT_CHANGE_KVN	(0x00030000)		//	PB
#define		RESULT_CHANGE_CYO	(0x00040000)		//	R[e
#define		RESULT_CHANGE_CON	(0x00050000)		//	R
#define		RESULT_CHANGE_MSK	(0x00060000)		//	}XN
#define		RESULT_CHANGE_HAY	(0x00070000)		//	On[}
#define		RESULT_CHANGE_GAL	(0x00080000)		//	KVA

//	:::::::::::::::		Z		::::::::::::::::::::::::::::::::::::::
#define		RESULT_SP_DAN_0		(0x00100000)		//	_SP0 	time slip
#define		RESULT_SP_DAN_1		(0x00100001)		//	_SP0 	time slip
#define		RESULT_SP_KED_0		(0x00200000)		//	SP0 	open spirit guide
#define		RESULT_SP_KVN_0		(0x00300000)		//	PBSP0 cloaking
#define		RESULT_SP_CYO_0		(0x00400000)		//	R[eSP0 boost jump
#define		RESULT_SP_CON_0		(0x00500000)		//	RSP0 	sonic sight
#define		RESULT_SP_CON_1		(0x00500001)		//	RSP1 	wind manipulation
#define		RESULT_SP_MSK_0		(0x00600000)		//	}XNSP0 	super strength

//	:::::::::::::::		ACe	::::::::::::::::::::::::::::::::::::::
#define		RESULT_ITEM_DAN_0	(0x01000000)		//	_ITEM0 		ignition fire
#define		RESULT_ITEM_KED_0	(0x02000000)		//	ITEM0 	suck blood
#define		RESULT_ITEM_KVN_0	(0x03000000)		//	PBITEM0 	system hack
#define		RESULT_ITEM_CYO_0	(0x04000000)		//	R[eITEM0 	picking tool
#define		RESULT_ITEM_CON_0	(0x05000000)		//	RITEM0 		magic mirror
#define		RESULT_ITEM_MSK_0	(0x06000000)		//	}XNITEM0 	magic wallet

//	\͉ʃNX
class SK7Special
{
	//	PROC
	typedef enum{
		PROC_MOVE=0,
		PROC_BLOCK_SELECT,
		PROC_NAME_SELECT,
		PROC_ITEM,
		PROC_MEMO,
		PROC_LIFE,
		PROC_EXIT,
	}eProc;	
	
	enum{
		ITEM_PROC_SELECT=0,
		ITEM_PROC_RING,		//	OR}h
		ITEM_PROC_ICON_MOVE,//	O]
		ITEM_PROC_MOVE_PHOTO,
		ITEM_PROC_PHOTO,	//	ʐ^
		ITEM_PROC_PHOTO_WAIT,
		ITEM_PROC_ULCOL,	//	ER
		ITEM_PROC_CHART,	//	`[g
		ITEM_PROC_VOICE,	//	{CXR[_
	};
	
	enum{
		BLOOD_PROC_SELECT=0,
		BLOOD_PROC_MOVE,
		BLOOD_PROC_MOVE2,
	};
	
	enum{
		MEMO_PROC_SELECT=0,
		MEMO_PROC_HATO,
	};
	
	//	ACe
	enum{
		ITEM_NAME_RING=0,
		ITEM_NAME_PHOTO,
		ITEM_NAME_ULCL,
		ITEM_NAME_CHART,
		ITEM_NAME_VOICE,
		ITEM_NAME_MAX,
	};
	
	//	j[ʂmn
	enum{
		MENU_ULMEYDA=0,
		MENU_COLOR,
		MENU_VOICE,
	};
	
	//	ACeLZCxg
	enum{
		CANCEL_PROC_SELECT = 0,
		CANCEL_PROC_RINGSET,
		CANCEL_PROC_RINGNOSET,
		CANCEL_PROC_PHOTO,
		CANCEL_PROC_MEMO,
	};
	
	enum{
		OTHER_INIT=0,
		OTHER_NOISE_START,
		OTHER_RELEASE_PLAYER,
		OTHER_CREATE_MENU,
		OTHER_NOISE_END,
		OTHER_MENU_READ_END,
		OTHER_NOISE_RELEASE,
		OTHER_NOISE_STANBY,
		OTHER_MENU_PROCESS,
		OTHER_MENU_END_NOISE,
		OTHER_RESTORE_CHECK,
		OTHER_END_NOISE_START,
		OTHER_END_NOISE_RELEASE,
		OTHER_PROC_END,
	};
	
	enum{
		MOVE_FONT_NORMAL=0,
		MOVE_FONT_SMALL,
		MOVE_FONT_BIG,
	};


protected:
	s8					m_eProc;						//	C
	s8					m_eItemProc;					//	Ct
	s8					m_eMenuProc;					//	ng
	s8					m_eBloodProc;					//	t
	s8					m_eMemoProc;

	bool				m_bRenderFlag;
	bool				m_bControlFlag;
	bool				m_bMoveFlag;					//	ړtO 
	bool				m_bBlockFlag;					//	ubNI
	bool				m_bLightMoveFlag;				//	Cg
	bool				m_bRingNameFlag;				//	O
	bool				m_bPlayerLightEnable;
	bool				m_bBlur;
	bool				m_bVfx;
	bool				m_bMenuRenderFlag;
	bool				m_bEnemyConpasFlag;
	bool				m_bMaskFlag;
	Vec					m_vCamPos;
	Vec					m_vCamTgt;
	
	YK7StrImage* 		m_pYFont;						//	RctHg
	SK7IMenuBase*		m_pMenu;
	
	SK7Sprite			m_spWindow;						//	EBhE
	SK7Sprite			m_spLWin;						//	EBhE
	SK7Sprite*			m_spBgFrame;					//	wit[
	SK7Sprite*			m_spBgFrameTex;					//	wit[eNX`[
	SK7Sprite			m_spRightWin;					//	E[
	SK7Sprite			m_spNameKasan;					//	ỎZ
	SK7Sprite			m_spChara;						//	L
	SK7Sprite			m_spCharaFrame;					//	Le
	SK7Sprite			m_Bullet[SP_BULLET_NUM];		//	obg
	SK7Sprite			m_spMemo;						//	
	SK7Sprite			m_spMask[MASK_MAX];				//	}XN
	SK7Sprite			m_spLight;						//	ICg
	SK7Sprite			m_spItem[ITEM_NUM_MAX];			//	ACeACR
	SK7Sprite			m_spSelect[SELECT_WAKU_NUM];	//	ZNg
	SK7Sprite			m_spItemName[2];				//	IO
	SK7Sprite			m_spRingSample;					//	Tv
	SK7Sprite*			m_pspSubIcon;					//	EC_Ƃ
	SK7Sprite*			m_pspMedal;						//	_ACR
	SK7Sprite			m_spLeftBox;					//	̃{bNX
	SK7Sprite			m_spDL;							//	fVbg

	RING_ICON			m_RingIcon;
	PANEL_STATE			m_Panel;						//	pl
	NamePlate			m_NamePlate[CHANGE_CHARA_NUM];	//	O
	BLOCKSELECT			m_SelectFont;					//	ZNgtHg
	SHADOWFONT			m_ShadowSmall;					//	e
	SHADOWFONT			m_ShadowBig;					//	e傫
	BEAKER				m_Beaker;						//	r[J[
	LIFE_BLOOD*			m_pLifeBlood;					//	񕜌t
	PHOTO_DATA			m_Photo;
	KEYSTATE			m_Key;							//	L[
	SORE				m_Sore;							//	ǂł͂Ȃ

	SK7SpOption*		m_pOption;						//	IvVNX
	TEX_DATA			m_BloodTex;						//	teNX`[

	int					m_iKeyTime;						//	L[^C
	int					m_iMoveTime;					//	EBhEړ
	int					m_iPackTime;					//	pbÑ^C
	int					m_iSelectTime;					//	ZNgAj̃^C
	int					m_iItemNameTime;				//	ACẽAt@^C
	int					m_iMemoTime;					//	͂Ƃ̈ړ^C
	s8					m_chBlockSelect;				//	ZNg
	s8					m_chNameSelect;					//	OI
	s8					m_chSaveSelect;					//	ZNgZ[u
	s8					m_chRingSelect;					//	OZNg
	s8					m_chItemSelect;					//	ACeZNg
	s8					m_chItemSelectNo;				//	m
	s8					m_chLRFlag;						//	L[tO
	s8					m_chItemNum;					//	ACe
	s8					m_chCharaNum;					//	LN^[
	f32					m_sOldHpPer;					//	go
	f32					m_sNowHpPer;					//	݂̂go
	f32					m_fStateFontX;					//	ԃtHg
	f32					m_fBloodNoX;					//	t
	f32					m_fRingNameX;					//	wւ̖O
	f32					m_fScrollX;						//	XN[W
	f32					m_fMedalX;						//	_
	f32					m_fNameBackY;					//	l[̂x
	s32					m_lRetCode;						//	AT[
	u32					m_lEventNo;						//	Cxgm
	
	//	֐	=====================================================
	bool	MoveWindow(bool);								//	ړ
	bool 	MoveSore(void);
	bool	_CheckDeath( u32 CharaNo );
	bool	CheckDeath();				//	S`FbN
	void	SetNamePlatePos( NamePlate* pNp, u8 No, bool Select, f32 IncX=0 );
	void	SetNamePlatePositon( NamePlate* pNp, u8 No, f32 IncX );
	void	SetNamePlateIncPos( NamePlate* pNp, u8 No, bool Select, f32 IncX );
	void	SetNamePlateRender( NamePlate* pNp,bool  );
	void	SetAllNamePlate( u8 No, f32 IncX=0 );

	void	FrameBloodProcess();
	void	FrameMemoProcess();
	void	FrameItemProcess();
	void	FrameCharaProcess();
	void	FrameBlockProcess();

	void	CancelItemProcess( s8 Proc );
	void	RenderCharaState();

	void	SetSelectLight( u8 No );	
	void	SetBlockSelectMask( u8 BlockNo, bool Render=false  );
	void	SetMovePanel();
	void	SetMoveEndPanel();
	void	MovePanel();
	void	SetSelectFont( u8 Select, bool Anwer );
	void	SetMoveFont( VEC2 *pVector, int MovR, int Time );
	void	CheckMoveFont( SK7Sprite* pSp, VEC2* pSpeed, u8 No, u8 Select, s8 State );
	void	FrameMoveFont( u8 No );
	void	SetSelectAlpha( u8 Block, u8 Select );
	void	SetAnswerAlpha( u8 Block );
	void	RenderRingName();
	s8		GetRingNo();
	s8		GetRingPolyNo( u8 State );
	void	TaskMenu( u8 MenuNo );
	void	SetSelectWaku( bool Render=false );
	void	SetRingSelectState( bool ring, bool photo, bool lr );
	void	CharaSelectState( s8 Select,  bool flag = true );

	void	IconZSort();
	void	ChangeView();
	void	SetRingImage( s8 SetNo );
	void	SetLifeBlood(bool);
	bool	MoveLifeBlood(bool);
	
	void	SetStageObject();				//	Xe[W̐p̃IuWFNgZbg
	void	SetTamatama();					//	܂

	void	_MoveRingKeyState();			//	L[̓Oړ
	
public:	
	SK7Special( SK7SpOption* );
	~SK7Special();
	
	void	Initialize			(void);		//	
	bool 	FrameProcess		(void);		// t[
	bool 	RenderProcess		(void);		// _O	
	bool	RenderWindowProcess	(void);		//	EBhẼ_O

//	etOn	===================================================================
	void	SetRender	( bool state )	{ 	m_bRenderFlag = state; }	//	`tO
	void	SetCtrlFlag	( bool state )	{ 	m_bControlFlag = state; }	//	Rg[tO
	bool	GetMenuEnd	(void)			{	return (m_eProc == PROC_EXIT) ? true : false; }		//	ItO	
	s32 	GetResult	(void)			{	return m_lRetCode; }		//	Iϐ擾	
	u32		GetEventNo	(void)			{ 	return m_lEventNo; }
};

#endif	//__SK7SPECIAL_H__



