////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Scn04
//
// K7Scn04.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 08/24/2003
//
////////////////////////////////////////////////////////////////////////////////

#include "..\Wat\WK7Player.h"
#include "..\Wat\WK7Npc.h"
#include "..\Wat\WK7Play.h"
#include "..\Wat\WK7GameInfo.h"
#include "..\Wat\WK7MainTask.h"
#include "..\Wat\K7GlobalFlag.h"
#include "..\Matsu\MK7Noise.h"
#include "..\Wat\WK7Event.h"

#define		K7SCN04_COLORCHIP_NUM		(9)
#define		K7SCN04_COLORCHIP_COLORNUM	(21)

K7EV_SCN_VAR_START(K7SCN04)
	K7EV_VAR_ARRAY(K7SCN04,EVVA_COLORCHIP_POS,K7SCN04_COLORCHIP_NUM,s8,-1)		// J[`bv
	K7EV_VAR_ARRAY(K7SCN04,EVVA_COLORCHIP_COLOR,K7SCN04_COLORCHIP_COLORNUM,u8,0)		// J[`bv|Cg
	K7EV_VAR      (K7SCN04,EVVA_ILLUSION_LOOP,s8,-1)							// ̊X[v
K7EV_SCN_VAR_END(K7SCN04)

K7EV_SCN_FLAG_START(K7SCN04)
	K7EV_FLAG(K7SCN04_EVFL_COLORCHIP_01)				//	J[`bvi쐬j
	K7EV_FLAG(K7SCN04_EVFL_COLORCHIP_02)					
	K7EV_FLAG(K7SCN04_EVFL_COLORCHIP_03)					
	K7EV_FLAG(K7SCN04_EVFL_COLORCHIP_04)					
	K7EV_FLAG(K7SCN04_EVFL_COLORCHIP_05)					
	K7EV_FLAG(K7SCN04_EVFL_COLORCHIP_06)					
	K7EV_FLAG(K7SCN04_EVFL_COLORCHIP_07)					
	K7EV_FLAG(K7SCN04_EVFL_COLORCHIP_08)					
	K7EV_FLAG(K7SCN04_EVFL_COLORCHIP_09)					
	
	K7EV_FLAG(K7SCN04_EVFL_ILLUSION_TOWN)				// ̊X
	K7EV_FLAG(K7SCN04_EVFL_ILLUSION_TOWN_CLEAR)			// ̊XNA
	
	K7EV_FLAG(MV040000)				//y[r[zKVẢƁEn[}s
	K7EV_FLAG(MV040001)				//y[r[zKVẢƁEn[}c
	K7EV_FLAG(MV040002)				//y[r[zOE_ƃVK[
	K7EV_FLAG(MV040003)				//y[r[zOEa
	
	K7EV_FLAG(EV04DISP_TITLE_DM1)	//yh~jJzO҃ViI^Cg
	K7EV_FLAG(EV04DISP_TITLE_DM2)	//yh~jJz҃ViI^Cg
	
	K7EV_FLAG(EV040102)				//yh~jJzOL̒Mj󂵂
	K7EV_FLAG(EV040104)				//yh~jJzʂ̌E˔j
	K7EV_FLAG(EV040105)				//yh~jJzZXŃR[eWv
	K7EV_FLAG(EV040201)				//yh~jJz̐ʘH̃v_
	K7EV_FLAG(EV040202)				//yh~jJz̉BHS̑|
	K7EV_FLAG(EV040401)				//yh~jJzsvcȑ`擾
	K7EV_FLAG(EV040403)				//yh~jJzAgG̕ǂj󂵂
	K7EV_FLAG(EV040404)				//yh~jJzԂ񂵂
	K7EV_FLAG(EV040405)				//yh~jJzJ[`bvplNA
	K7EV_FLAG(EV040405_0)			//yh~jJzsvcȑ`͂߂
	
	K7EV_FLAG(EV442USE_PASTRING)	//yh~jJzߋ̎wւgp
	K7EV_FLAG(EV415TALK_TRAVIS)		//yh~jJzR[eWv̐̃gBXƉb
	K7EV_FLAG(EV445BREAK_HS_NEST)	//yh~jJzg@[@HS̑j󂵂
	
	K7EV_FLAG(EN413M00_FROM412M00)	//yh~jJzGpopptO
	K7EV_FLAG(EN413M00_FROM415M00)	//yh~jJzGpopptO
	K7EV_FLAG(EN443M00_FROM442M00)	//yh~jJzGpopptO
	K7EV_FLAG(EN443M00_FROM444M00)	//yh~jJzGpopptO
	
	K7EV_FLAG(EV444413)				//yh~jJz444413ւ̃v_
	K7EV_FLAG(EV444420)				//yh~jJz444420ւ̃v_
	K7EV_FLAG(EV444441)				//yh~jJz444441ւ̃v_
	K7EV_FLAG(EV413444)				//yh~jJz413444ւ̃v_
	K7EV_FLAG(EV420444)				//yh~jJz420444ւ̃v_
	K7EV_FLAG(EV441444)				//yh~jJz441444ւ̃v_
	
	K7EV_FLAG(DR040102)				//yh~jJzOL̃V[gJbg̔Ă
	
	K7EV_FLAG(PR_HS_ROLLING)		//yh~jJz413M00[OЉ
	
	K7EV_FLAG(EV04END)
K7EV_SCN_FLAG_END(K7SCN04)

K7EV_SCN_IDTABLE_START(K7SCN04)
K7EV_SCN_IDTABLE_END(K7SCN04)

K7EV_SCN_ITEMTABLE_START(K7SCN04)
	// cvOECU
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040101))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040102))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040103))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040104))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040105))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040106))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040107))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040108))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040201))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040202))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040203))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040204))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040401))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040402))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040403))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040404))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040405))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (121600))		// n[}
	
	// cvOEgBX
	K7EV_ITEMTABLE(K7EVITEM_ZAN (041501))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (041502))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (041503))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (041504))		// 
	
	// cvOEjI
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040281))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040481))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040482))		// 
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040483))		// 
	
	// cvOEJ[eBX
	K7EV_ITEMTABLE(K7EVITEM_ZAN (040090))		// 
	
	//svcȑ`
	K7EV_ITEMTABLE(K7EVITEM_KEY (040401))		//h~jJ ߋɖ߂ē
	
K7EV_SCN_ITEMTABLE_END(K7SCN04)

//K7EV_SCN_HITOBJTABLE_START(K7SCN04)
//K7EV_SCN_HITOBJTABLE_END(K7SCN04)

// Cxgnh錾iCxghc`nhƂ̊֘Atj
K7EV_SCN_HANDLER_DECL_START(K7SCN04)
	
	K7EV_HANDLER_DECL     (K7SCN04_EVENT_INIT               ,K7SCN04_Init               ,NULL)
	K7EV_HANDLER_DECL     (K7SCN04_EVENT_TERM               ,K7SCN04_Term               ,NULL)
	
K7EV_SCN_HANDLER_DECL_END(K7SCN04)

// CxgfXNv^iCxg`j
K7EV_SCN_DESC_START(K7SCN04)
	
	// ViI
	K7EV_DESC_SCNINIT      (K7SCN04_EVENT_INIT)
	// ViII
	K7EV_DESC_SCNTERM      (K7SCN04_EVENT_TERM)
	
K7EV_SCN_DESC_END(K7SCN04)

