////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Scn06
//
// K7Scn06.cpp
//
// Creator       : Kawakami Satoshi (GHM)
// Creation Date : 08/24/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7SCN06_CPP__
#pragma	warn_unusedarg			off

////////////////////////////////////////////////////////////////////////////////
// CxgfXNv^`
////////////////////////////////////////////////////////////////////////////////

#define	K7EV_BODY_PART
#include ".\K7Scn06.h"
#include "..\Wat\WK7Npc.h"
#include "..\Wat\WK7Enemy.h"
#include "..\Yam\YK7MapSelect.h"

////////////////////////////////////////////////////////////////////////////////
// nh`
////////////////////////////////////////////////////////////////////////////////

#include "..\Fujita\C_Font.h"

#include "..\Matsu\mK7Common.h"
#include "..\Matsu\mK7Sprite.h"
#define	FILE_TEX_3NENGO		"Texture/3nengo.bin"

K7EV_HANDLER(K7SCN06_Init)
{
	u32			stgid;
	u32			chrid;
	mK7File		file;
	stTexture	tex;
	mK7Sprite	sprt;
	
	K7SCR_ENTER_PLAYMODE();
	
	K7SCR_MOON_START();
	K7SCR_MOON_WAIT();
	
	//inGame~
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	//}bvړ
	MapSelectInit( MAP_WARSHIP_ISLAND, MAP_WARSHIP_ISLAND );
	//}bvړʕ`
	while( CheckMapSelectEnd() == false )
	{
		MapSelectFrameProcess();
		MapSelectRenderProcess();
		K7SCR_RETSYS();
	}
	MapSelectEnd();
	
	//ViI^Cg\
	K7SCR_SCENARIO_TITLE_DISP( ST_BATTLE_SHIP );
	
	//---- 3N\ ----
	while( file.mK7FileRead(FILE_TEX_3NENGO,&((void*)tex.tex)) != eFileReadSucsess )
	{
		K7SCR_RETSYS();
	}
	mK7InitTexture( &tex );
	sprt.mRelateTex( &tex );
	sprt.mSetDispFlag( false );
	sprt.mSetPriority( SPRT_PRI_JMK_RUBI );
	sprt.mSetWH( 640, 480 );
	sprt.mSetXY0( 0, 0 );
	sprt.mSetRGBA( 0xffffff00 );
	sprt.mSetDispFlag( true );
	sprt.mSetFade( 0xff, 2400 );
	while( sprt.mGetFadeEnd() == false )
	{
		K7SCR_RETSYS();
	}
	K7SCR_TIMEWAIT( 2400 );
	//R͓
	WK7Play::StorePlayTB();
	sprt.mSetFadeWithWait( 0x00, 4800*3, 4800*3 );
	WK7Play::PlayTB( K7EVENTPLAY(05100101) );
	sprt.mSetDispFlag( false );
	WK7Play::RestorePlayTB();
	
	//KĂACeݒ
	K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_FIRE );
	K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_WATER );
	K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_PAST );
	K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_WIND );
	K7SCR_RESET_GLOBAL_FLAG( K7GLFL_RING_EYE );
	
	//R͓
	stgid = K7STGID( 570, 0 );
	chrid = K7CHRID( K7GAL, 0 );
	
	gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
	while(gpNoise->mGetSandFrameProc() != eSandExec){K7SCR_RETSYS();}
	
	K7SCR_STG_CREATE_B( stgid );
	K7SCR_PC_CREATE( chrid );		//fǂݍ
	K7SCR_PC_MOTIONCREATE( chrid );	//[Vǂݍ
	K7SCR_PC_CREATEWAIT();			//ǂݍݑ҂
	K7SCR_STG_SET_CURRENT( stgid );
	
	WK7Stage::SetCameraStartPosition( stgid, "branchA" );
	K7SCR_RETSYS();
	
	K7SCR_PC_VISIBLE( true );
	K7SCR_RETSYS();
	K7SCR_STG_VISIBLE( stgid, true );
	
	WK7Stage::SandRelease(stgid);
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
	
	//inGameĊJ
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	sprt.mSetDispFlag( false );
	GHMGCMEM_SAFE_FREE( tex.tex );
	
	return;
}

K7EV_HANDLER(K7SCN06_Term)
{
	K7SCR_RETSYS();
}

////////////////////////////////////////////////////////////////////////////////
// nhe[u
////////////////////////////////////////////////////////////////////////////////

#define	K7EV_TBL_PART
#include ".\K7Scn06.h"

#include "..\REL\REL_Setup.h" 

#define	K7EV_VAR_EDIT
#include "..\Scn\K7Scn06.h"
#undef	K7EV_VAR_EDIT

#include "..\sato\SK7IMenuMap.h"
#define	__SK7MAPCREATE06__
#include "..\sato\map\SK7StageMap06.h" 

#include "..\Stage\K7Stage.h"
#define	__K7STAGECREATE_INCLUDE__
#include	".\info\K7StageCreate.h"
WK7Stage* WK7Stage::CreateStageScn06(u32 id,int prio)
{
	K7STG_CREATE_DECL_START()
#include	".\info\K7StageCreate.h"
	K7STG_CREATE_DECL_END()
	return NULL;
}

#define	__ENMCREATE_INCLUDE__
#include	"..\Wat\EnmCreate.h"
WK7Npc* WK7Npc::CreateScn06(u32 type,u32 suffix)
{
	ENM_CREATE_DECL_START()
#include	"..\Wat\EnmCreate.h"
	ENM_CREATE_DECL_END()
	return NULL;
}

#include "..\sato\SK7PanelBase.h"
#define	__SK7PANELCREATE_INCLUDE__
#include "..\sato\SK7PanelCreate.h"
SK7PanelBase* SK7PanelBase::CreatePanel06(u32 evno,s32 now, s32 now2 )
{
	switch( evno ){
#include "..\sato\SK7PanelCreate.h"
	}
	return NULL;
}

static	WK7StageBpCamInfo	K7ScnBpCamInfo[] = {
#include	"..\Stage\Info\K7StageBpCamInfo.h"
WK7STGBPCAMINF_END()
static	WK7StageDoorInfo	K7ScnDoorInfo[] = {
#include	"..\Stage\Info\K7StageDoorInfo.h"
WK7STGDRINF_END()
static	WK7StagePlaceInfo	K7ScnPlaceInfo[] = {
#include	"..\Stage\Info\K7StagePlaceInfo.h"
WK7STGPLINF_END()
static	WK7StageTamaInfo	K7ScnTamaInfo[] = {
#include	"..\Stage\Info\K7StageTamaInfo.h"
WK7STGTAMAINF_END()
static	WK7StageSoundInfo	K7ScnSoundInfo[] = {
#include	"..\Stage\Info\K7StageSoundInfo.h"
WK7STGSOUNDINF_END()
static	WK7StageSpCond		K7ScnSpCond[] = {
#include	"..\Stage\Info\K7StageSpCond.h"
WK7STGSPCOND_END()

RELMODULE_EXPORT void _prolog(void)
{
	ModuleConstructors();
	
	SK7PanelBase::SetCreatePanelFunc(SK7PanelBase::CreatePanel06);
	SK7IMenuMap::SetScnIconTable( tblScenarioIcon06 );
	SK7IMenuMap::SetItmIconTable( tblItemIcon06 );
	WK7Stage::SetCreateStageFunc(WK7Stage::CreateStageScn06);
	WK7Stage::SetScenarioDoorInfo (K7ScnDoorInfo );
	WK7Stage::SetScenarioPlaceInfo(K7ScnPlaceInfo);
	WK7Stage::SetScenarioTamaInfo (K7ScnTamaInfo );
	WK7Stage::SetScenarioSoundInfo(K7ScnSoundInfo);
	WK7Stage::SetScenarioSpCond   (K7ScnSpCond   );
	WK7Stage::SetScenarioBpCamInfo(K7ScnBpCamInfo);
	WK7Npc::SetNpcCreateFunc(WK7Npc::CreateScn06);
	WK7EVENTCONTROLLER->SetScenarioEventHandler(K7EV_SCN_HANDLER_TABLE(K7SCN06));
	WK7EVENTCONTROLLER->SetScenarioEventDesc   (K7EV_SCN_DESC_TABLE   (K7SCN06));
	WK7Event::SetIDTable  (K7EV_SCN_IDTABLE  (K7SCN06));
	WK7EventItem::SetTable(K7EV_SCN_ITEMTABLE(K7SCN06));
	WK7GAMEINFO_SETFLAGNAME(K7EV_SCN_FLAGNAME(K7SCN06));
	WK7GAMEINFO_SETVARTYPE(K7EV_SCN_VARTYPENAMEBODY(K7SCN06));
	if( GameInfo.GetContinue()==false ){
#define	K7EV_VAR_INIT
#include "..\Scn\K7Scn06.h"
#undef	K7EV_VAR_INIT
	}
#define	K7EV_VAR_DEBUG
#include "..\Scn\K7Scn06.h"
#undef	K7EV_VAR_DEBUG
}

/*
 * _epilog is called before the the module is unlinked
 * This executes the static destructors for the module.
 */

RELMODULE_EXPORT void _epilog(void)
{
	ModuleDestructors();
	
	WK7Stage::SetCreateStageFunc(NULL);
	WK7Stage::SetScenarioDoorInfo (NULL);
	WK7Stage::SetScenarioPlaceInfo(NULL);
	WK7Stage::SetScenarioTamaInfo (NULL);
	WK7Stage::SetScenarioSoundInfo(NULL);
	WK7Stage::SetScenarioSpCond   (NULL);
	WK7Stage::SetScenarioBpCamInfo(NULL);
	WK7Npc::SetNpcCreateFunc(NULL);
	WK7EVENTCONTROLLER->SetScenarioEventHandler(NULL);
	WK7EVENTCONTROLLER->SetScenarioEventDesc   (NULL);
	WK7EventItem::SetTable(NULL);
	WK7Event::SetIDTable  (NULL);
	WK7GAMEINFO_SETFLAGNAME(NULL);
	WK7GAMEINFO_SETVARTYPE(NULL);
}

/*
 * _unresolved is called if a module attempts
 * to call a symbol that is not present in another module.
 * If _unresolved is not specified, the branch to the symbol
 * will instead branch back to itself.
 */

RELMODULE_EXPORT void _unresolved(void)
{
	u32		i;
	u32*	p;
	
	OSReport("\nError: Unlinked function called in module %s.\n", __FILE__);
	OSReport("Address:      Back Chain    LR Save\n");
	for (i = 0, p = (u32*) OSGetStackPointer(); // get current sp
	     p && (u32) p != 0xffffffff && i++ < 16;
	     p = (u32*) *p)                         // get caller sp
	{
		OSReport("0x%08x:   0x%08x    0x%08x\n", p, p[0], p[1]);
	}
	OSReport("\n");
}

