////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Scn99
//
// K7Scn99.cpp
//
// Creator       : Kawakami Satoshi (GHM)
// Creation Date : 02/24/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7SCN99_CPP__
#pragma	warn_unusedarg			off

////////////////////////////////////////////////////////////////////////////////
// CxgfXNv^`
////////////////////////////////////////////////////////////////////////////////

#define	K7EV_BODY_PART
#include ".\K7Scn99.h"

#include "..\Wat\WK7Stage.h"

////////////////////////////////////////////////////////////////////////////////
// nh`
////////////////////////////////////////////////////////////////////////////////

#include "..\Fujita\C_Font.h"

#ifndef	K7APP_INIT_CHARA
#define	K7APP_INIT_CHARA		K7CHRID(K7DAN,0)
#endif

K7EV_HANDLER(K7SCN99_Init)
{
	GameInfo.SetMode(WK7GameInfo::PLAY);
	
	k7app.FadeStart(0,4800);
	k7app.SetFadeColor(0);
	
	K7SCR_PC_CREATE      (K7APP_INIT_CHARA);	// fǂݍ
	K7SCR_PC_MOTIONCREATE(K7APP_INIT_CHARA);	// [Vǂݍ
	
	K7SCR_PC_CREATEWAIT();						// ǂݍݑ҂
	
	while( WK7Stage::ChangeStage()==false ){
		K7SCR_RETSYS();
	}
	k7app.FadeStart(0,0);
	k7app.SetFadeColor(0);
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	
	// \
	K7SCR_PC_VISIBLE(true);
//	K7SCR_PC_SET_CURRENT_PLAYER(K7CHRID(K7DAN,98));	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
#if 0
	while( 1 ){
		
		if( HSD_PadGetTrigger(1) & HSD_PAD_X ){
			break;
		}
		
		K7SCR_RETSYS();
	}
	
	WK7Play			*pPlay;
	
	while( (pPlay=WK7Play::Create("03010101"))==NULL ){
		K7SCR_RETSYS();
	}
	
	pPlay->Prepare();
	
	while( pPlay->GetState()!=WK7Play::STANDBY ){
		K7SCR_RETSYS();
	}
	
	pPlay->Start();
	
	while( pPlay->GetState()!=WK7Play::PLAY ){
		K7SCR_RETSYS();
	}
#endif
	
}

K7EV_HANDLER(K7SCN99_Term)
{
	K7SCR_RETSYS();
}

////////////////////////////////////////////////////////////////////////////////
// nhe[u
////////////////////////////////////////////////////////////////////////////////

#define	K7EV_TBL_PART
#include ".\K7Scn99.h"

#include "..\REL\REL_Setup.h"

RELMODULE_EXPORT void _prolog(void)
{
	ModuleConstructors();
	WK7EVENTCONTROLLER->SetScenarioEventHandler(K7EV_SCN_HANDLER_TABLE(K7SCN99));
	WK7EVENTCONTROLLER->SetScenarioEventDesc   (K7EV_SCN_DESC_TABLE   (K7SCN99));
}

/*
 * _epilog is called before the the module is unlinked
 * This executes the static destructors for the module.
 */

RELMODULE_EXPORT void _epilog(void)
{
	ModuleDestructors();
	WK7EVENTCONTROLLER->SetScenarioEventHandler(NULL);
	WK7EVENTCONTROLLER->SetScenarioEventDesc   (NULL);
}

/*
 * _unresolved is called if a module attempts
 * to call a symbol that is not present in another module.
 * If _unresolved is not specified, the branch to the symbol
 * will instead branch back to itself.
 */

RELMODULE_EXPORT void _unresolved(void)
{
	u32		i;
	u32*	p;
	
	OSReport("\nError: Unlinked function called in module %s.\n", __FILE__);
	OSReport("Address:      Back Chain    LR Save\n");
	for (i = 0, p = (u32*) OSGetStackPointer(); // get current sp
	     p && (u32) p != 0xffffffff && i++ < 16;
	     p = (u32*) *p)                         // get caller sp
	{
		OSReport("0x%08x:   0x%08x    0x%08x\n", p, p[0], p[1]);
	}
	OSReport("\n");
}

