////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage771M01
//
// K7Stage771M01.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE771M01_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage771M01.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7CharaPresent.h"
#include "..\..\..\Wat\K7GlobalFlag.h"
#include "..\..\..\Kaw\KK7Sound.h"

#define	K7STAGE771M01_DOORMOTION		(100)
#define	K7STAGE771M01_DOORNAME			"ele_door"
#define	K7STAGE771M01_DOOROPENPATH		"sp3"
//pX
#define	PAT771M01_1ST_WAY				"before1"	//e肷ÕpX
#define	PAT771M01_2ND_WAY1				"after1"	//e肵ʉ߂łpX1
#define	PAT771M01_2ND_WAY2				"after2"	//e肵ʉ߂łpX2


K7Stage771M01::K7Stage771M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage771M01_Camera);
	mAmbPlaySE = false;
}

K7Stage771M01::~K7Stage771M01()
{
}

bool K7Stage771M01::CreateCallBack(void)
{
//	CreateOwnStageMotion(K7STAGE771M01_DOORMOTION);
	return true;
}

bool K7Stage771M01::InitializeCallBack(void)
{
//	if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7) ){	// zbp[[h
//		HereComeANewHSInit( PR_HS_HOPPER, ENENO_7_771M01_2 );
//	}
	K7SCR_EVNO_SETENABLE(K7EVENTNO(007101),false);
	return true;
}

bool K7Stage771M01::CondChangeCallBack(void)
{
//	f32		startframe;
//	WK7JObj	*pJObj;
//	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_771M01_0)==TRUE ){
//		startframe = -1.0f;
//		K7SCR_STG_SET_PATHENABLE(K7STAGE771M01_DOOROPENPATH,true);
//	}else{
//		startframe = 0.0f;
//		K7SCR_STG_SET_PATHENABLE(K7STAGE771M01_DOOROPENPATH,false);
//	}
//	if( (pJObj=PlayMotion(K7STAGE771M01_DOORNAME,K7STAGE771M01_DOORMOTION,NULL,startframe))!=NULL ){
//		if( startframe < 0.0f ){
//			pJObj->SetMotionLoop(false,false,true);
//		}
//	}
	//e肵2Kւ̃pXJ
	if( K7SCR_EVHASITEM(K7EVITEM_TAMA(007101)) == false )
	{
		K7SCR_STG_SET_PATHENABLE( PAT771M01_1ST_WAY, true );
		K7SCR_STG_SET_PATHENABLE( PAT771M01_2ND_WAY1, false );
		K7SCR_STG_SET_PATHENABLE( PAT771M01_2ND_WAY2, false );
	}else
	{
		K7SCR_STG_SET_PATHENABLE( PAT771M01_1ST_WAY, false );
		K7SCR_STG_SET_PATHENABLE( PAT771M01_2ND_WAY1, true );
		K7SCR_STG_SET_PATHENABLE( PAT771M01_2ND_WAY2, true );
	}
	
	return true;
}

bool K7Stage771M01::SpAbilityCallBack(WK7SpAbilityInfo &info)
{
#pragma	unused(info)
	return true;
}

bool K7Stage771M01::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	switch( eventNo ){
	case	K7EVENTNO(007103):
#if 0
		if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_CP_TRAVIS  )==TRUE &&
		    K7SCR_GET_GLOBAL_FLAG(K7GLFL_CP_KIKAZARU)==TRUE ){
			return true;
		}
		
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);
		
		if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_CP_TRAVIS  )==FALSE ){
			K7SCR_SET_GLOBAL_FLAG(K7GLFL_CP_TRAVIS);
		
			FixCam(TRAVIS);
			
			K7SCR_CHARAPRESENT_DEBUGSTART();
			K7SCR_RESERVENAME(K7SCR_CP_STARTTICK,0,  318,   85, 205, 108, 158, 235);
			K7SCR_TIMEWAIT(K7SCR_CP_WAITTIME);
			K7SCR_CHARAPRESENT_DEBUGEND();
			
		}
		
		if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_CP_KIKAZARU)==FALSE ){
			K7SCR_SET_GLOBAL_FLAG(K7GLFL_CP_KIKAZARU);
		
			FixCam(KIKAZARU);
			
			K7SCR_CHARAPRESENT_DEBUGSTART();
			K7SCR_RESERVENAME(K7SCR_CP_STARTTICK,1,  138,  210, 232, 102, 123, 120);
			K7SCR_TIMEWAIT(K7SCR_CP_WAITTIME);
			K7SCR_CHARAPRESENT_DEBUGEND();
			
		}
		
		K7SCR_PC_SETVISIBLE(true);
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EXIT_PLAYMODE();
		
#endif
		break;
	default:
		return true;
	}
	return true;
}

//------------------------------------------------------------------------------
// JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage771M01::SetCurrentCallBack( void )
{
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){28.699f, 6.050f, -388.460f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		mAmbPlaySE = true;
	}
//	if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7) ){	// zbp[[h
//		// zbp[}Љ
//		//V^HSЉ
//		if( false == HereComeANewHS(	PR_HS_HOPPER,
//										ENENO_7_771M01_2,							// GID
//										NULL,
//										CAM771M01_HS_PRESEN_START,
//										CAM771M01_HS_PRESEN_END,
//										2,
//										174,  327,  -4,  49, 655, 252 )				// OЉp
//		){
//			SetManualBranch(false);
//			return( true );
//		}
//	}
	
	return( true );
}