////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage775M02
//
// K7Stage775M02.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/26/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE775M02_H__
#define	__K7STAGE775M02_H__

#include "..\..\..\Wat\WK7Stage.h"
#include "..\..\K7Stage.h"

#define	K7STAGE775M02_KIHAN_HS		ENENO_7_775M02_6

class K7Stage775M02 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage775M02();
	K7Stage775M02(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	EFFECT*	mpEffectVapor00;
	EFFECT*	mpEffectVapor01;
	EFFECT*	mpEffectVapor02;
	EFFECT*	mpEffectVapor03;
	
public:
	virtual ~K7Stage775M02();
	
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);
};

#ifdef __K7STAGE775M02_CPP__


enum K7STAGE775M02_ONESHOTCAM{
	HS_POS,
	DOOR_ENTER,
	HS_REVIVAL,
};


K7StageEventOneShotCamera K7Stage775M02_Camera[] = {
	{{32.398f, 7.050f, 629.176f},{32.045f, 4.812f, 608.012f}},			// HS
	{{31.107f, 9.377f, 344.663f},{30.439f, 8.703f, 323.234f}},			// 
	{{28.194f, 11.332f, 613.395f},{17.810f, 10.085f, 591.658f}},		// REVIVAL
};

#endif

#endif	//__K7STAGE775M02_H__

