////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage102M00
//
// K7Stage102M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE102M00_H__
#define	__K7STAGE102M00_H__

#include "..\K7Stage.h"

class K7Stage102M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage102M00();
	K7Stage102M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	bool ChangeFusuma(int index,bool flag,f32 startframe);
//	bool AppearHS(int index,int mesid,int camid,int *enmno);
	bool AppearHS(int *enmno0,int *enmno1);
public:
	virtual ~K7Stage102M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool TerminateCallBack (void);
	virtual bool CondChangeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
	virtual bool EventCallBack     (WK7EventInfo     &);
};

#ifdef	__K7STAGE102M00_CPP__

enum K7STAGE102M00_ONESHOTCAM{
	DOOR_010003,
	EVENT_010600_HS,
	EVENT_010601_HS,
	EVENT_010604,
	EVENT_010604_0,
	EVENT_010604_1,
	EVENT_010600,
	EVENT_010601,
	EVENT_NIOU_BULLET0,
	EVENT_NIOU_BULLET1,
	EVENT_NIOU_DOOR,
};

K7StageEventOneShotCamera	K7Stage102M00_Camera[] = {
//	{{ -104.941f, 16.328f, -263.606f},{-73.213f, 5.408f, -211.891f}},		// bNOꂽƂ̉o
//	{{-1073.587f, 10.384f, -307.393f},{-1031.232f, 9.412f, -322.673f}},		// bNOꂽƂ̉o
	{{-93.855f, 7.303f, -242.221f},{-103.632f, 12.101f, -198.521f}},		// bNOꂽƂ̉o
//	{{-950.824f, 13.068f, -305.187f},{-985.438f, 11.812f, -305.631f}},		// k̉
	{{-54.650f, 12.035f, -96.419f},{-33.631f, 10.260f, -101.892f}},			// k̉
//	{{-657.791f, 12.941f, -306.380f},{-623.209f, 10.954f, -306.239f}},		// 쑤̉
	{{-132.523f, 9.999f, 138.773f},{-153.608f, 8.818f, 144.154f}},			// 쑤̉
	
	{{-167.164f, 13.785f, 17.186f},{-147.085f, 10.803f, 24.273f}},			// `͂ߍ
	
	{{-55.742f, 8.651f, -176.788f},{-45.225f, 9.259f, -171.040f}},
	{{-58.504f, 4.306f, 218.487f},{-51.213f, 4.436f, 208.957f}},
	
	{{-74.458f, -1.973f, -181.331f},{-53.108f, 3.754f, -181.786f}},
	{{-74.856f, -1.973f, 223.719f},{-53.506f, 3.754f, 223.265f}},
	
	{{-89.956f, 7.843f, 88.197f},{-88.833f, 11.111f, 148.458f}},
	{{-86.623f, 2.152f, -3.982f},{-85.500f, 5.421f, 56.280f}},
	
	{{-75.685f, 12.968f, -237.708f},{-69.559f, 11.094f, -227.982f}},
};

enum{
	K7STAGE102M00_MES_LOCKED_KEY = 0		,		// ̓bNĂ
	K7STAGE102M00_MES_UNLOCKED_KEY			,		// ʎ̃bNOꂽ
	K7STAGE102M00_MES_DONT_OPEN				,		// 瑤͊JȂ悤
	K7STAGE102M00_MES_OPEN_KEY				,		// J
	K7STAGE102M00_MES_PUSH_SW_010600_WHITE	,		// F̃XCb`EVENT_010600
	K7STAGE102M00_MES_PUSH_SW_010600_YELLOW	,		// F̃XCb`EVENT_010600
	K7STAGE102M00_MES_PUSH_SW_010600_BLACK	,		// F̃XCb`EVENT_010600
	K7STAGE102M00_MES_PUSH_SW_010600_RED	,		// F̃XCb`EVENT_010600
	K7STAGE102M00_MES_PUSH_SW_010600_BLUE	,		// F̃XCb`EVENT_010600
	K7STAGE102M00_MES_PUSH_SW_010601_WHITE	,		// F̃XCb`EVENT_010601
	K7STAGE102M00_MES_PUSH_SW_010601_YELLOW	,		// F̃XCb`EVENT_010601
	K7STAGE102M00_MES_PUSH_SW_010601_BLACK	,		// F̃XCb`EVENT_010601
	K7STAGE102M00_MES_PUSH_SW_010601_RED	,		// F̃XCb`EVENT_010601
	K7STAGE102M00_MES_PUSH_SW_010601_BLUE	,		// F̃XCb`EVENT_010601
	K7STAGE102M00_MES_APPEAR_HS0			,		// wuX}Cꂽ
	K7STAGE102M00_MES_APPEAR_HS1			,		// wuX}Cꂽ
};

#endif

#endif	//__K7STAGE102M00_H__

