////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage105M00
//
// K7Stage105M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE105M00_H__
#define	__K7STAGE105M00_H__

#include "..\K7Stage.h"

class K7Stage105M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage105M00();
	K7Stage105M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage105M00();
	
	virtual bool InitializeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);
};

#ifdef	__K7STAGE105M00_CPP__

enum K7STAGE105M00_ONESHOTCAM{
	JUMP_0,
	JUMP_1,
};

K7StageEventOneShotCamera K7Stage105M00_Camera[] = {
	// R[eWv
	{{572.017f, 8.221f, 68.683f},{565.518f, 3.879f, 62.446f}},
	{{573.883f, 44.433f, 65.742f},{573.745f, 42.755f, 43.786f}},
};

enum{
	K7STAGE105M00_MES_JUMP = 0				,		// R[eW`vI
};

#endif

#endif	//__K7STAGE105M00_H__

