////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage108M00
//
// K7Stage108M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE108M00_CPP__

#include ".\K7Stage108M00.h"
//#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Yam\YK7EffectDraft.h"

#define	K7SCN01_TAIKO_VOLUME		(255)

#define	K7STAGE108M00_TAIKO_FUSUMA_PATH		"Pass_Travis"
#define	K7STAGE108M00_TAIKO_RIDDLE_PATH		"event_010320_0"
#define	K7STAGE108M00_BROKENWALL_WINDNAME	"wind01"

static Vec windPos = {-56.835f, 2.516f, -616.708f};

K7STAGE_BROKENWALLINFO_START(K7Stage108M00_BrokenWallInfo)
	K7STAGE_BROKENWALLINFO_CAM(K7EVENTNO(010320) , "event_010320_msk" , K7STAGE108M00_TAIKO_FUSUMA_PATH , K7SCN01_TAIKO_FUSUMA , BROKEN_FUSUMA)
K7STAGE_BROKENWALLINFO_END()

K7Stage108M00::K7Stage108M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
//	int			i;
//	for(i=0 ; i<4 ; i++){
//		mpFusuma[i] = NULL;
//	}
	SetOneShotCamLocTbl(K7Stage108M00_Camera);
	SetBrokenWallInfo  (K7Stage108M00_BrokenWallInfo);
	mpWindEffect = NULL;
}

K7Stage108M00::~K7Stage108M00()
{
}

//static const char	*pLampObjName[] = {
//	"event_010308",
//	"event_010309",
//	"event_010310",
//	"event_010311",
//};
//static const char	*pFireObjName[] = {
//	"burn010308",
//	"burn010309",
//	"burn010310",
//	"burn010311",
//};
//static const char	*pFusumaObjName[] = {
//	"BurnableDoorGroup_010308",
//	"BurnableDoorGroup_010309",
//	"BurnableDoorGroup_010310",
//	"BurnableDoorGroup_010311",
//};
//static const char	*pRouteName[] = {
//	"event_010305_0",
//	"event_010304_0",
//	"event_010303_0",
//	"event_010302_0",
//};
static const char	*pFusumaName = "Fusumagroup";
static const char	*pClearFusumaName[] = {
	"Fusumagroup_Clear01",
	"Fusumagroup_Clear02",
	NULL,
};
static	int	enm[] = {
	ENENO_1_108_05,
	ENENO_1_108_06,
	ENENO_1_108_07,
	-1,
};
//WK7JObj* K7Stage108M00::GetLamp(int i)
//{
//	if( i < 0 || i >= 4 ){
//		return NULL;
//	}
//	return GetJObj(pLampObjName[i]);
//}
//WK7JObj* K7Stage108M00::GetFire(int i)
//{
//	if( i < 0 || i >= 4 ){
//		return NULL;
//	}
//	return GetJObj(pFireObjName[i]);
//}
//WK7JObj* K7Stage108M00::GetFusuma(int i)
//{
//	if( i < 0 || i >= 4 ){
//		return NULL;
//	}
//	return GetJObj(pFusumaObjName[i]);
//}
//WK7PathNurbs* K7Stage108M00::GetRoute(int i)
//{
//	if( i < 0 || i >= 4 ){
//		return NULL;
//	}
//	return GetPathNurbs(pRouteName[i]);
//}

bool K7Stage108M00::CreateCallBack(void)
{
	CreateOwnStageMotion(   0);
//	CreateOwnStageMotion(   1);
//	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_FIRE)==NULL ){
//		K7SCR_RETSYS();
//	}
	return true;
}

bool K7Stage108M00::InitializeCallBack(void)
{
//	K7EVENT_SCN_VAR(K7SCN01,EVVA_0103) = -1;
//	K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010302);
//	K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010303);
//	K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010304);
//	K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010305);
	K7SCR_EVCONDCHANGE();
	return true;
}

bool K7Stage108M00::TerminateCallBack(void)
{
//	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_FIRE);
	return true;
}

bool K7Stage108M00::SetCurrentCallBack(void)
{
//	
//	int				i;
//	WK7JObj			*pLamp;
//	WK7JObj			*pFusuma;
//	WK7JObj			*pFire;
//	WK7PathNurbs	*pPath;
//	
//	for(i=0 ; i<4 ; i++){
//		while( (mpFusuma[i] = new K7Stage108M00Fusuma)==NULL ){
//			K7SCR_RETSYS();
//		}
//		pLamp   = GetLamp  (i);
//		pFire   = GetFire  (i);
//		pFusuma = GetFusuma(i);
//		pPath   = GetRoute (i);
//		mpFusuma[i]->Initialize(this,pPath,pFusuma,pLamp,pFire,K7SCN01_EVFL_010308 + i,(u32)(K7STAGE108M00_MES_BURN_FUSUMA_010308 + i));
//		mpFusuma[i]->Setup     ();
//	}
	SetCurrentCallBackDefaultProc();
	while( WK7Npc::GetNpcPauseAll()==true ){
		if( WK7RenderObj::IsValid(this)==false || GetState()!=LOADED ){
			return false;
		}
		K7SCR_RETSYS();
	}
	K7SCR_EVCONDCHANGE();
	return false;
}

bool K7Stage108M00::CharaChangeCallBack(WK7CharaChangeInfo &info)
{
#pragma	unused(info)
	K7SCR_EVCONDCHANGE();
	return true;
}

bool K7Stage108M00::CondChangeCallBack(void)
{
	WK7JObj	*pJObj;
	int		i;
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010312)==TRUE ){
		if( (pJObj=PlayMotion(pFusumaName, 0,NULL,-1.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
		for(i=0 ; enm[i] >= 0 ; i++){
			K7SCR_NPC_POPGO     ((u32)enm[i]);
			K7SCR_NPC_SAKUTEKIGO((u32)enm[i]);
		}
	}
	WK7JObj		*pWindJObj;
	EFFECT		*pWindEffect;
	bool		wind;
	pWindJObj = GetJObj(K7STAGE108M00_BROKENWALL_WINDNAME);
	K7SCR_JOBJ_HIDE(pWindJObj);
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_TAIKO_FUSUMA)==true ){
		wind = false;
	}else{
		if( WK7PLAYERCONTROL->GetMainID()==K7CAT ){
			CatWindSePlay(windPos, K7SCN01_TAIKO_FUSUMA, SFX_SCE1_AMB_KAKUSUKIMA);
			wind = true;
		}else{
			wind = false;
		}
	}
	if( pWindJObj!=NULL ){
		if( wind==true ){
			if( IsValidEffect(mpWindEffect)==false ){
				WK7RenderObjEffectInfo	info;
				info.Create();
				if( (pWindEffect = ::CreateDraft2Effect(pWindJObj,(s32)VParam[ED_DRAFT][2]))!=NULL ){
					mpWindEffect = CreateEffect(pWindEffect,&info);
				}
			}
		}else{
			if( mpWindEffect!=NULL ){
				DelReqEffect(mpWindEffect);
				mpWindEffect = NULL;
			}
		}
	}
	
//	bool	pathflag;
	
//	if( K7EVENT_SCN_VAR(K7SCN01,EVVA_0103)==3 ){
		for(i=0 ; pClearFusumaName[i]!=NULL ; i++){
			if( (pJObj=PlayMotion(pClearFusumaName[i], 0,pFusumaName,-1.0f))!=NULL ){
				pJObj->SetMotionLoop(false,false,true);
			}
		}
//		pathflag = true;
//	}else{
//		for(i=0 ; pClearFusumaName[i]!=NULL ; i++){
//			if( (pJObj=GetJObj(pClearFusumaName[i]))!=NULL ){
//				pJObj->DetachMotion(false,true);
//				pJObj->ResetMotion (false,true);
//			}
//		}
//		pathflag = false;
//	}
	
//	K7SCR_STG_SET_PATHENABLE("Pass_Thing" ,pathflag);
//	K7SCR_STG_SET_PATHENABLE(K7STAGE108M00_TAIKO_FUSUMA_PATH,pathflag);
	
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_TAIKO_FUSUMA)==TRUE ){
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE108M00_TAIKO_RIDDLE_PATH,true);
	}else{
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE108M00_TAIKO_RIDDLE_PATH,false);
	}
	
	return true;
}

//bool K7Stage108M00::DoorEventCallBack(WK7DoorEventInfo &info)
//{
//	switch( info.mEventNo ){
//	case	K7EVENTDOOR(010008):
//	    if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_010008)!=TRUE ){
//			// hAJȂ
//	    	K7SCR_DEBUGPRINT("DOOR_010008 Closed : need EVENT_010305");
//			
//			FixCamMes(DOOR_010008,K7STAGE108M00_MES_LOCKED_DOOR);
//			
////			K7SCR_ENTER_PLAYMODE();
////			K7SCR_ENTER_DEMOPAUSE();
////			
////			// Jς
////			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
////			WK7CAM->SetPosition      (K7Stage108M00_Camera[DOOR_010008].pos);
////			WK7CAM->SetTargetPosition(K7Stage108M00_Camera[DOOR_010008].tgt);
////			K7SCR_PC_SETVISIBLE(false);
////			
////			K7SCR_STGC_MESSAGE_B(K7STAGE108M00_MES_LOCKED_DOOR);
////			
////			K7SCR_PC_RETURNVISIBLE();
////			K7SCR_EXIT_PLAYMODE();
////			K7SCR_EXIT_DEMOPAUSE();
////			
////			K7SCR_EVCONDCHANGE();
//			return false;
//		}else{
//			
//#if 0
//			// Stage114_M00event_011108,event_011108_0̕Ɉړ
//			u32		stgid = K7STGID(114, 0);
//			
//			gpNoise->mSandRequest(eSandLongNoise);
//			
//			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
//				K7SCR_RETSYS();
//			}
//			
//			K7SCR_STG_RELEASE    (mID);
//			K7SCR_STG_CREATE_B   (stgid);
//			K7SCR_STG_SET_CURRENT(stgid);
//			K7SCR_STG_VISIBLE    (stgid,true);
//			
//			WK7Stage::SandRelease(stgid);
//			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
//				K7SCR_RETSYS();
//			}
//			
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			
//			return false;
//#else
//			info.mNextStageID = K7STGID(112,0);
////			strncpy(info.mNextBpName,"branchA",WK7DOOREVENT_BPNAME_MAX-1);
//			strncpy(info.mNextBpName,"door_015004",WK7DOOREVENT_BPNAME_MAX-1);
//#endif
//		}
//		break;
//	default:
//		break;
//	}
//	return true;
//}

//bool K7Stage108M00::HitLampEffect(int index)
//{
//	if( index < 0 || index >= 4 ){
//		return false;
//	}
//	
//	K7Stage108M00Fusuma		*pFusuma = mpFusuma[index];
//	
//	if( pFusuma->Start()==false ){
//		return false;
//	}
//	
//	while( pFusuma->IsEnd()==false ){
//		K7SCR_RETSYS();
//	}
//	
//	K7SCR_EVCONDCHANGE();
//	
//	return true;
//}

//bool K7Stage108M00::HitObjCallBack(WK7HitObjInfo &info)
//{
//	switch( info.mEventNo ){
//	case	K7EVENTNO(010308): return HitLampEffect(0);
//	case	K7EVENTNO(010309): return HitLampEffect(1);
//	case	K7EVENTNO(010310): return HitLampEffect(2);
//	case	K7EVENTNO(010311): return HitLampEffect(3);
//		break;
//	default:
//		return true;
//	}
//	return true;
//}

bool K7Stage108M00::BpArriveCallBack(WK7BpInfo &info)
{
	u32	evno = GetBpEventNo(info);
	if( evno==0xffffffff ){
		return true;
	}
	int		i;
	switch( evno ){
	case	K7EVENTNO(010312):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010312)==FALSE ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010312);
			
			// gro
			WK7JObj	*pJObj;
			if( (pJObj=PlayMotion(pFusumaName, 0))!=NULL ){
				pJObj->SetMotionLoop(false,false,true);
			}
			gpSound->mPlaySE(SFX_SCE1_FUSUMA_FAST);
			
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			WK7PLAYERCONTROL->SetOperateEnable(false);
			WK7Npc::SetNpcPauseAll(false);
			
			// wuX}C|bvAbv
			for(i=0 ; enm[i] >= 0 ; i++){
				K7SCR_NPC_POPGO((u32)enm[i]);
			}
			
			FixCam(EVENT_010312);
			K7SCR_PC_SETVISIBLE(false);
			
//			K7SCR_STG_MESSAGE_B2(K7STAGE108M00_MES_CAME_HS);
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3.0f))
			
			for(i=0 ; enm[i] >= 0 ; i++){
				K7SCR_NPC_SAKUTEKIGO((u32)enm[i]);
			}
			
			K7SCR_PC_RETURNVISIBLE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			WK7PLAYERCONTROL->SetOperateEnable(true);
			
		}
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage108M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(010320):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_TAIKO_FUSUMA)==TRUE ){
			return true;
		}
		break;
	default:
		return true;
	}
	gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
	return true;
//	u32	evno = GetBpEventNo(info);
//	if( evno==0xffffffff ){
//		return true;
//	}
//	int	pathno = GetBpPathNo(info);
//	if( pathno < 0 ){
//		return true;
//	}
//	switch( evno ){
//	// V
//	case	K7EVENTNO(010300):
//	case	K7EVENTNO(010314):
//		switch( pathno ){
//		case	0:
//			gpSound->mSetDspRateAll(0);
//			gpSound->mFadeVolumeStream(0,MUSIC_FADEOUT_TIME);
//			break;
//		case	1:
//			K7EVENT_SCN_VAR(K7SCN01,EVVA_0103) = -1;
//			gpSound->mSetDspRateAll(0);
//			gpSound->mFadeVolumeStream(0,MUSIC_FADEOUT_TIME);
//			K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010302);
//			K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010303);
//			K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010304);
//			K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010305);
//			gpSound->mPlaySE(SFX_SCE1_TAIKO_RESET);
//			
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			
//			K7SCR_STGC_MESSAGE_B(K7STAGE108M00_MES_RING_TONE_010300);
//			
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			break;
//		default:
//			return true;
//		}
//		break;
//	// {
//	case	K7EVENTNO(010301):
//	case	K7EVENTNO(010313):
//		switch( pathno ){
//		case	0:
//			gpSound->mSetDspRateAll(0);
//			gpSound->mFadeVolumeStream(0,MUSIC_FADEOUT_TIME);
//			break;
//		case	1:
//			gpSound->mSetDspRateAll(0);
//			gpSound->mPlayStreamNo(HPS_TAIKO_TEHON,K7SCN01_TAIKO_VOLUME);
//			
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			
//			K7SCR_STGC_MESSAGE_B(K7STAGE108M00_MES_RING_TONE_010301);
//			
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			break;
//		default:
//			return true;
//		}
//		break;
//	// ۃp^[P
//	case	K7EVENTNO(010302):
//		switch( pathno ){
//		case	0:
//			gpSound->mSetDspRateAll(0);
//			gpSound->mFadeVolumeStream(0,MUSIC_FADEOUT_TIME);
//			break;
//		case	1:
//			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010302)==TRUE ){
//				return false;
//			}
//			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010302);
//			if( K7EVENT_SCN_VAR(K7SCN01,EVVA_0103)==-1 ){
//				K7EVENT_SCN_VAR(K7SCN01,EVVA_0103) = 0;
//			}
//			gpSound->mSetDspRateAll(0);
//			gpSound->mPlayStreamNo(HPS_TAIKO_1,K7SCN01_TAIKO_VOLUME);
//			
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			
//			K7SCR_STGC_MESSAGE_B(K7STAGE108M00_MES_RING_TONE_010302);
//			
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			break;
//		default:
//			return true;
//		}
//		break;
//	// ۃp^[Q
//	case	K7EVENTNO(010303):
//		switch( pathno ){
//		case	0:
//			gpSound->mSetDspRateAll(0);
//			gpSound->mFadeVolumeStream(0,MUSIC_FADEOUT_TIME);
//			break;
//		case	1:
//		   	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010303)==TRUE ){
//				return false;
//			}
//			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010303);
//			if( K7EVENT_SCN_VAR(K7SCN01,EVVA_0103)==0 ){
//				K7EVENT_SCN_VAR(K7SCN01,EVVA_0103) = 1;
//			}
//			gpSound->mSetDspRateAll(0);
//			gpSound->mPlayStreamNo(HPS_TAIKO_2,K7SCN01_TAIKO_VOLUME);
//			
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			
//			K7SCR_STGC_MESSAGE_B(K7STAGE108M00_MES_RING_TONE_010303);
//			
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			break;
//		default:
//			return true;
//		}
//		break;
//	// ۃp^[R
//	case	K7EVENTNO(010304):
//		switch( pathno ){
//		case	0:
//			gpSound->mSetDspRateAll(0);
//			gpSound->mFadeVolumeStream(0,MUSIC_FADEOUT_TIME);
//			break;
//		case	1:
//			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010304)==TRUE ){
//				return false;
//			}
//		   	K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010304);
//			if( K7EVENT_SCN_VAR(K7SCN01,EVVA_0103)==1 ){
//				K7EVENT_SCN_VAR(K7SCN01,EVVA_0103) = 2;
//			}
//			gpSound->mSetDspRateAll(0);
//			gpSound->mPlayStreamNo(HPS_TAIKO_3,K7SCN01_TAIKO_VOLUME);
//			
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			
//			K7SCR_STGC_MESSAGE_B(K7STAGE108M00_MES_RING_TONE_010304);
//			
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			break;
//		default:
//			return true;
//		}
//		break;
//	// ۃp^[S
//	case	K7EVENTNO(010305):
//		switch( pathno ){
//		case	0:
//			gpSound->mSetDspRateAll(0);
//			gpSound->mFadeVolumeStream(0,MUSIC_FADEOUT_TIME);
//			break;
//		case	1:
//			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010305)==TRUE ){
//				return false;
//			}
//		   	K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010305);
//			gpSound->mSetDspRateAll(0);
//			gpSound->mPlayStreamNo(HPS_TAIKO_4,K7SCN01_TAIKO_VOLUME);
//			if( K7EVENT_SCN_VAR(K7SCN01,EVVA_0103)==2 ){
//				K7EVENT_SCN_VAR(K7SCN01,EVVA_0103) = 3;
//				
//				K7SCR_ENTER_PLAYMODE();
//				K7SCR_ENTER_DEMOPAUSE();
//				
//				K7SCR_STGC_MESSAGE_B(K7STAGE108M00_MES_RING_TONE_010305);
//				
//				K7SCR_ENTER_PLAYMODE();
//				K7SCR_ENTER_DEMOPAUSE();
//				
//				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
//				
//				// Jf
//				if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_010008)==false ){
//					
//					K7SCR_SET_SCENARIO_FLAG(K7SCN01_DRFL_010008);
//					
//					FixCamMes(DOOR_010008,K7STAGE108M00_MES_UNLOCKED_DOOR,SFX_SCE1_TAIKO_KEY_OPEN);
//					
////					// Jς
////					WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
////					WK7CAM->SetPosition      (K7Stage108M00_Camera[DOOR_010008].pos);
////					WK7CAM->SetTargetPosition(K7Stage108M00_Camera[DOOR_010008].tgt);
////					K7SCR_PC_SETVISIBLE(false);
////					
//////					gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
////					gpSound->mPlaySE(SFX_SCE1_TAIKO_KEY_OPEN);
////					
////					K7SCR_STGC_MESSAGE_B(K7STAGE108M00_MES_UNLOCKED_DOOR);
////															// ՘T̊Ԃ̃bNOꂽ
////					
////					K7SCR_PC_RETURNVISIBLE();
////					K7SCR_EXIT_PLAYMODE();
////					K7SCR_EXIT_DEMOPAUSE();
//					
//			    	K7SCR_DEBUGPRINT("Open DOOR_010008");
//				}
//			
//				K7SCR_EXIT_PLAYMODE();
//				K7SCR_EXIT_DEMOPAUSE();
//				
//			}else{
//				
//				K7SCR_ENTER_PLAYMODE();
//				K7SCR_ENTER_DEMOPAUSE();
//				
//				K7SCR_STGC_MESSAGE_B(K7STAGE108M00_MES_RING_TONE_010305);
//				
//				K7SCR_EXIT_PLAYMODE();
//				K7SCR_EXIT_DEMOPAUSE();
//			}
//			break;
//		default:
//			return true;
//		}
//		break;
//	default:
//		return true;
//	}
//	return false;
}

//bool K7Stage108M00::FrameProcess(void)
//{
//	int		i;
//	switch( GetState() ){
//	case	LOADED:
//		for(i=0 ; i<4 ; i++){
//			if( mpFusuma[i]==NULL ){
//				continue;
//			}
//			mpFusuma[i]->FrameProcess();
//		}
//		break;
//	case	RELEASEARCHIVE:
//	case	RELEASEDARCHIVE:
//		for(i=0 ; i<4 ; i++){
//			GHM_SAFE_DELETE(mpFusuma[i]);
//		}
//		break;
//	default:
//		break;
//	}
//	return WK7Stage::FrameProcess();
//}

#if 0
K7Stage108M00Fusuma::K7Stage108M00Fusuma()
{
	mpFusuma   = NULL;
	mpLamp     = NULL;
	mpEffect   = NULL;
	mState     = IDLE;
	mFlag      = 0xffffffff;
	mMessageID = 0xffffffff;
}

K7Stage108M00Fusuma::~K7Stage108M00Fusuma()
{
	mpStage->ReleaseEffect(mpEffect);
}

bool K7Stage108M00Fusuma::LampAlphaSetup(void)
{
	if( mpLamp==NULL ){
		return false;
	}
	WK7HitObj::InitFind();
	WK7HitObj	*pHitObj = WK7HitObj::Find(mpLamp);
	if( pHitObj==NULL ){
		return false;
	}
	static	HSD_PEDesc	pedesc = {
		//J[AAt@AŒAt@݁AZobt@SăGiuB
		ENABLE_COLOR_UPDATE|ENABLE_ALPHA_UPDATE|ENABLE_DST_ALPHA|ENABLE_COMPARE|ENABLE_ZUPDATE|ENABLE_DITHER|BEFORE_TEX,
		// GXSetAlphaCompare(),ref0,ref1
		0,0,
		// GXSetDstAlpha(),dst_alpha
		WK7RENDEROBJ_RENDERID_DEFAULT_ALPHA,
		// GXSetBlendMode(),type,src_factor,dst_factor,logic_op
		GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR,
		//GXSetZMode(),func
		GX_LEQUAL,
		//GXAlphaCompare,comp0,op,comp1
		GX_ALWAYS,GX_AOP_AND,GX_ALWAYS
	};
	pedesc.dst_alpha = WK7RenderObj::ConvRenderIDToAlpha(pHitObj->GetRenderID());
	mpLamp->SetPE(&pedesc,false,false);
	if( (mpLamp=mpLamp->GetChild())!=NULL ){
		static	HSD_PEDesc	pedesc_noalpha = {
			//J[AAt@AŒAt@݁AZobt@SăGiuB
			ENABLE_COLOR_UPDATE|ENABLE_COMPARE|ENABLE_ZUPDATE|ENABLE_DITHER|BEFORE_TEX,
			// GXSetAlphaCompare(),ref0,ref1
			0,0,
			// GXSetDstAlpha(),dst_alpha
			WK7RENDEROBJ_RENDERID_DEFAULT_ALPHA,
			// GXSetBlendMode(),type,src_factor,dst_factor,logic_op
			GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR,
			//GXSetZMode(),func
			GX_LEQUAL,
			//GXAlphaCompare,comp0,op,comp1
			GX_ALWAYS,GX_AOP_AND,GX_ALWAYS
		};
		mpLamp->SetPE(&pedesc,true,true);
	}
	return true;
}

bool K7Stage108M00Fusuma::FrameProcess(void)
{
	switch( mState ){
	case	IDLE:
		break;
	case	START:
		SetPathEnable(false);
		K7SCR_SET_SCENARIO_FLAG(mFlag);
		// C
		K7SCR_JOBJ_HIDE(mpLamp);
		// RĂ鉊GtFNg
		GHM_SAFE_DELETE(mpEffect);
		mLampFire.Start();
		mCounter = WK7_FRAME_RATE / 2;
		mState = LAMPBURN;
	case	LAMPBURN:
		if( mCounter ){
			mCounter--;
			break;
		}
		SetPathEnable(true);
		mState = BURNING;
		mFusumaFire[0].Start();
		mFusumaFire[1].Start();
		if( mMessageID != 0xffffffff ){
			K7SCR_STGC_MESSAGE(mMessageID);
		}
	case	BURNING:
		if( mFusumaFire[0].IsEnd()==false ||
		    mFusumaFire[1].IsEnd()==false ||
		    mLampFire     .IsEnd()==false ){
			break;
		}
		mState = END;
	case	END:
	default:
		break;
	}
	
	mLampFire     .FrameProcess();
	mFusumaFire[0].FrameProcess();
	mFusumaFire[1].FrameProcess();
	
	return true;
}

bool K7Stage108M00Fusuma::Initialize(WK7Stage *pStage,WK7PathNurbs *pPath,WK7JObj *pFusuma,WK7JObj *pLamp,WK7JObj *pFire,int flag,u32 mesid)
{
	int		i;
	mpStage    = pStage;
	mpPath     = pPath;
	mpFusuma   = pFusuma;
	mpLamp     = pLamp;
	mpFire     = pFire;
	mFlag      = flag;
	mMessageID = mesid;
	LampAlphaSetup();
	mLampFire.Initialize(pStage,pFire);
	for(i=0,pFusuma=pFusuma->GetChild() ; i<2 && pFusuma!=NULL ; i++,pFusuma=pFusuma->GetNext()){
		mFusumaFire[i].Initialize(pStage,pFusuma);
	}
	return true;
}

bool K7Stage108M00Fusuma::SetPathEnable(bool flag)
{
	if( mpPath==NULL ){
		return false;
	}
	mpPath->SetEnable  (flag);
	mpPath->SetEnableEx(flag);
	return true;
}

bool K7Stage108M00Fusuma::Setup(int onoff)
{
	if( onoff < 0 ){
		if( K7SCR_GET_SCENARIO_FLAG(mFlag)==TRUE ){
			onoff = 1;
		}else{
			onoff = 0;
		}
	}else{
		if( onoff==0 ){
			K7SCR_RESET_SCENARIO_FLAG(mFlag);
		}else{
			K7SCR_SET_SCENARIO_FLAG(mFlag);
		}
	}
static	Vec		size = { 0.6f , 1.2f , 0.0f };
	if( onoff==0 ){
		K7SCR_JOBJ_DISP(mpLamp);
		if( mpEffect==NULL && mpLamp!=NULL ){
			Vec		pos;
			mpLamp->GetWorldPosition(pos);
			pos.y = 11.0f;
			mpEffect = mpStage->CreateEffectEasyAnim(ANIMID_FIRE,pos,size,0);
		}
		mLampFire     .Setup(true);
		mFusumaFire[0].Setup(true);
		mFusumaFire[1].Setup(true);
		SetPathEnable(false);
		mState = IDLE;
	}else{
		K7SCR_JOBJ_HIDE(mpLamp);
		mpStage->ReleaseEffect(mpEffect);
		
		// Cヂ[VĐ
		
		mLampFire     .Setup(false);
		mFusumaFire[0].Setup(false);
		mFusumaFire[1].Setup(false);
		SetPathEnable(true);
		mState = END;
	}
	return true;
}

bool K7Stage108M00Fusuma::Start(void)
{
	switch( mState ){
	case	IDLE:
	case	END:
		break;
	default:
		return false;
	}
	mState = START;
	return true;
}

K7Stage108M00FusumaFire::K7Stage108M00FusumaFire()
{
	mpSetAlpha = NULL;
	mpStage  = NULL;
	mpFusuma = NULL;
	mState   = IDLE;
	mpEffect = NULL;
	mRot     = 0.0f;
	mRotSpd  = 0.0f;
	mCounter = 0;
}

K7Stage108M00FusumaFire::~K7Stage108M00FusumaFire()
{
	GHM_SAFE_DELETE(mpSetAlpha);
	mpStage->ReleaseEffect(mpEffect);
}

bool K7Stage108M00FusumaFire::Initialize(WK7Stage *pStage,WK7JObj *pFusuma)
{
	mpStage  = pStage;
	mpFusuma = pFusuma;
	return true;
}

bool K7Stage108M00FusumaFire::Start(void)
{
	switch( mState ){
	case	IDLE:
	case	END:
		break;
	default:
		return false;
	}
	mState = START;
	return true;
}

bool K7Stage108M00FusumaFire::Setup(bool onoff)
{
	mpStage->ReleaseEffect(mpEffect);
	if( onoff==true ){
		K7SCR_JOBJ_DISP(mpFusuma);
	}else{
		K7SCR_JOBJ_HIDE(mpFusuma);
	}
	return true;
}

#define	FUSUMA_ROTMAX		(PI * 0.5f)
bool K7Stage108M00FusumaFire::FrameProcess(void)
{
	switch( mState ){
	case	IDLE:
		mRot   = 0.0f;
		break;
	case	START:
		if( mpFusuma==NULL ){
			mState = END;
			break;
		}
		K7SCR_JOBJ_DISP(mpFusuma);
		mpStage->ReleaseEffect(mpEffect);
		if( (mpEffect = mpStage->CreateEffectModelFire(mpFusuma,MFIRE_WALL))==NULL ){
			break;
		}
		GHM_SAFE_DELETE(mpSetAlpha);
		mState   = BURNWAIT;
		mRot     = 0.0f;
		mRotSpd  = 0.0f;
		mCounter = HSD_Rand() % 4;
	case	BURNWAIT:
		if( mCounter ){
			mCounter--;
			break;
		}
		mState   = BURNING;
	case	BURNING:
		mRotSpd += 0.005f;
		mRot    += mRotSpd;
		if( mRot < FUSUMA_ROTMAX ){
			break;
		}
		mRot = FUSUMA_ROTMAX;
		mAlpha.SetValue(1.0f);
		if( (mpSetAlpha = new C_SetAlpha(mpFusuma->GetJObj(),mAlpha.GetValue(),false))==NULL ){
			break;
		}
		mAlpha.Play(0.0f,WK7_SEC_TO_TICK(2));
		mState = BURNEDWAIT;
		mCounter = (int)(HSD_Rand() % (WK7_FRAME_RATE * 2));
	case	BURNEDWAIT:
		if( mCounter ){
			mCounter--;
			break;
		}
		if( mpStage->IsValidEffect(mpEffect)==true ){
			mpEffect->DelReqEffect();
		}
		mState = VANISH;
	case	VANISH:
		if( mpStage->IsValidEffect(mpEffect)==true ){
			break;
		}
		if( mAlpha.IsAnimating()==true ){
			break;
		}
		K7SCR_JOBJ_HIDE(mpFusuma);
		GHM_SAFE_DELETE(mpSetAlpha);
		mState = END;
	case	END:
	default:
		mRot = FUSUMA_ROTMAX;
		break;
	}
	if( mpFusuma!=NULL ){
		mpFusuma->SetRotZ(mRot);
	}
	if( mpSetAlpha != NULL ){
		mpSetAlpha->SetVal(mAlpha.GetValue(),false);
	}
	if( mpEffect != NULL ){
		if( mpStage->IsValidEffect(mpEffect)==false ){
			mpEffect = NULL;
		}
	}
	mAlpha.FrameProcess();
	return true;
}

K7Stage108M00LampFire::K7Stage108M00LampFire()
{
	mpStage  = NULL;
	mpFire   = NULL;
	mState   = IDLE;
	mpEffect = NULL;
	mCounter = 0;
}

K7Stage108M00LampFire::~K7Stage108M00LampFire()
{
	mpStage->ReleaseEffect(mpEffect);
}
	
bool K7Stage108M00LampFire::Initialize(WK7Stage *pStage,WK7JObj *pFire)
{
	mpStage  = pStage;
	mpFire   = pFire;
	return true;
}

bool K7Stage108M00LampFire::Start(void)
{
	switch( mState ){
	case	IDLE:
	case	END:
		break;
	default:
		return false;
	}
	mState = START;
	return true;
}

bool K7Stage108M00LampFire::Setup(bool /*onoff*/)
{
	K7SCR_JOBJ_HIDE(mpFire  );
	mpStage->ReleaseEffect(mpEffect);
	return true;
}

bool K7Stage108M00LampFire::FrameProcess(void)
{
	switch( mState ){
	case	IDLE:
		break;
	case	START:
		if( mpFire==NULL ){
			mState = END;
			break;
		}
		if( (mpEffect = mpStage->CreateEffectModelFire(mpFire,MFIRE_WALL))==NULL ){
			break;
		}
		mCounter = (int)WK7_SEC_TO_TICK(0.5f);
		mState   = BURNING;
	case	BURNING:
		if( mCounter > 0 ){
			mCounter -= WK7_TICK_PER_FRAME;
			break;
		}
		mState = VANISH;
		if( mpStage->IsValidEffect(mpEffect)==true ){
			mpEffect->DelReqEffect();
		}
	case	VANISH:
		if( mpStage->IsValidEffect(mpEffect)==true ){
			break;
		}
		mState = END;
	case	END:
		break;
	default:
		break;
	}
	if( mpEffect != NULL ){
		if( mpStage->IsValidEffect(mpEffect)==false ){
			mpEffect = NULL;
		}
	}
	return true;
}

#endif

