////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage109M00
//
// K7Stage109M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE109M00_H__
#define	__K7STAGE109M00_H__

#include "..\K7Stage.h"

class K7Stage109M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage109M00();
	K7Stage109M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage109M00();
	
	virtual bool CondChangeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
};

#ifdef	__K7STAGE109M00_CPP__

enum K7STAGE109M00_ONESHOTCAM{
	EVENT_010400,
};

K7StageEventOneShotCamera	K7Stage109M00_Camera[] = {
	{{-53.947f, 4.376f, 9.917f},{-37.037f, 6.457f, 35.264f}},			// uq̌vgƂ̉o
};

enum{
	K7STAGE109M00_MES_GET_KEY = 0				,		// uq̌vɓꂽ
	K7STAGE109M00_MES_SET_KOU_010401_BLUE		,		// F̍ZbgEVENT_010401
	K7STAGE109M00_MES_SET_KOU_010401_RED		,		// F̍ZbgEVENT_010401
	K7STAGE109M00_MES_SET_KOU_010401_WHITE		,		// F̍ZbgEVENT_010401
	K7STAGE109M00_MES_SET_KOU_010402_YELLOW		,		// F̍ZbgEVENT_010402
	K7STAGE109M00_MES_SET_KOU_010402_GREEN		,		// ΐF̍ZbgEVENT_010402
	K7STAGE109M00_MES_SET_KOU_010402_RED		,		// F̍ZbgEVENT_010402
	K7STAGE109M00_MES_SET_KOU_010403_RED		,		// F̍ZbgEVENT_010403
	K7STAGE109M00_MES_SET_KOU_010403_WHITE		,		// F̍ZbgEVENT_010403
	K7STAGE109M00_MES_SET_KOU_010403_BLUE		,		// F̍ZbgEVENT_010403
};

#endif

#endif	//__K7STAGE109M00_H__

