////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage110M00
//
// K7Stage110M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE110M00_H__
#define	__K7STAGE110M00_H__

#include "..\K7Stage.h"

class K7Stage110M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage110M00();
	K7Stage110M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage110M00();
	
	virtual bool InitializeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool DoorEventCallBack(WK7DoorEventInfo &);
};

#ifdef	__K7STAGE110M00_CPP__

enum K7STAGE110M00_ONESHOTCAM{
//	DOOR_010004,
	DOOR_010005,
	DOOR_010006,
};

K7StageEventOneShotCamera	K7Stage110M00_Camera[] = {
//	{{120.726f, 8.124f, -68.723f},{159.297f, 13.097f, -25.759f}},		// H
//	{{261.249f, 10.451f, -72.022f},{260.271f, 10.994f, -14.081f}},		// Lb`
//	{{412.678f, 4.686f, -81.394f},{382.309f, 10.385f, -32.800f}},		// uꉮ̌vgƂ̉o
	{{-1389.979f, 7.418f, -263.495f},{-1361.359f, 13.442f, -313.473f}},	// Lb`
	{{-1528.883f, 7.418f, -344.174f},{-1489.219f, 10.511f, -302.097f}},	// uꉮ̌vgƂ̉o
};

enum{
	K7STAGE110M00_MES_LOCKED_KEY = 0			,		// |Ă
	K7STAGE110M00_MES_LOCKED_DOOR				,		// ̓bNĂ
	K7STAGE110M00_MES_UNLOCKED_HANARE			,		// ̃bNOꂽ
	K7STAGE110M00_MES_DONT_OPEN_THIS_SIDE		,		// 瑤͊JȂ悤
};

#endif

#endif	//__K7STAGE110M00_H__

