////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage111M00
//
// K7Stage111M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE111M00_H__
#define	__K7STAGE111M00_H__

#include "..\K7Stage.h"

class K7Stage111M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage111M00();
	K7Stage111M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage111M00();
	
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
};

#ifdef	__K7STAGE111M00_CPP__

enum K7STAGE111M00_ONESHOTCAM{
	DOOR_010002,
};

K7StageEventOneShotCamera	K7Stage111M00_Camera[] = {
	{{ -201.578f, 11.170f, -280.252f},{-188.038f, 9.804f, -272.835f}},		// uq̌vgƂ̉o
};

enum{
	K7STAGE111M00_MES_GET_DISH_BLACK = 0		,		// F̎Mɓꂽ
	K7STAGE111M00_MES_GET_DISH_BLUE				,		// F̎Mɓꂽ
	K7STAGE111M00_MES_GET_DISH_GREEN			,		// ΐF̎Mɓꂽ
	K7STAGE111M00_MES_GET_DISH_BROWN			,		// F̎Mɓꂽ
	K7STAGE111M00_MES_GET_DISH_PURPLE			,		// F̎Mɓꂽ
	K7STAGE111M00_MES_GET_DISH_WHITE			,		// F̎Mɓꂽ
};

#endif

#endif	//__K7STAGE111M00_H__

