////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage113M03
//
// K7Stage113M03.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE113M03_H__
#define	__K7STAGE113M03_H__

#include ".\K7Stage113M00.h"

class K7Stage113M03 : public K7Stage113{
	friend class WK7Stage;
protected:
	K7Stage113M03();
	K7Stage113M03(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage113M03();
	
	virtual bool CreateCallBack    (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
};

#ifdef	__K7STAGE113M03_CPP__

enum K7STAGE113M03_ONESHOTCAM{
	DOOR_010002,
	EVENT_011114,
	EVENT_011115,
	EVENT_011116,
};

K7StageEventOneShotCamera	K7Stage113M03_Camera[] = {
	{{ -201.578f, 11.170f, -280.252f},{-188.038f, 9.804f, -272.835f}},		// uq̌vgƂ̉o
	{{-0.194f, 10.014f, 33.598f},{0.032f, 9.020f, 9.636f}},
	{{-33.276f, 10.014f, -0.298f},{-9.295f, 9.788f, 0.010f}},
	{{-0.067f, 10.014f, -31.662f},{0.236f, 10.387f, -7.682f}},
};

enum{
	K7STAGE113M03_MES_CLOSE_FUSUMA_EVENT_010114 = 0		,		// 鐝̂ӂ܂߂EVENT_010114
	K7STAGE113M03_MES_OPEN_FUSUMA_EVENT_010114			,		// 鐝̂ӂ܂JEVENT_010114
	K7STAGE113M03_MES_CLOSE_FUSUMA_EVENT_010115			,		// Ղ̂ӂ܂߂EVENT_010115
	K7STAGE113M03_MES_OPEN_FUSUMA_EVENT_010115			,		// Ղ̂ӂ܂JEVENT_010115
	K7STAGE113M03_MES_CLOSE_FUSUMA_EVENT_010116			,		// ̂ӂ܂߂EVENT_010116
	K7STAGE113M03_MES_OPEN_FUSUMA_EVENT_010116			,		// ̂ӂ܂JEVENT_010116
};

#endif

#endif	//__K7STAGE113M03_H__

