////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage115M00 LXM핔
//
// K7Stage115M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/31/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE115M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include ".\K7Stage115M00.h"
//#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Enm\EnmKIS.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Yam\YK7MapSelect.h"
#include "..\..\..\sato\SK7ScenarioEnd.h"
#include "..\..\..\Yam\YK7EffectModelFire.h"

//#define	BATTLE_ESCAPE
#ifndef	_DEBUG
#undef	BATTLE_ESCAPE
#endif

// [V
#define MOT115M00_FALLBROKEN		(1)  //

K7Stage115M00::K7Stage115M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	// Init
	pNpcKis				= NULL;
	mEnd				= false;
	GameInfo.SetMenuMapEnable(false);
	GameInfo.SetBossFlag     (true );
	WK7PLAYERCONTROL->SetCamRevDisable(true);
}

K7Stage115M00::~K7Stage115M00()
{
	WK7PLAYERCONTROL->ClearGameOver();
	WK7PLAYERCONTROL->SetCamRevDisable(false);
	GameInfo.SetSpecialEnable(true );
	GameInfo.SetMenuMapEnable(true );
	GameInfo.SetBossFlag     (false);
}

bool K7Stage115M00::CreateCallBack(void)
{
	// [Vǂݍ
	CreateOwnStageMotion(MOT115M00_FALLBROKEN);
	return true;
}

bool K7Stage115M00::TerminateCallBack(void)
{
	
	
	
	return true;
}

/*
	
	
	
*/
bool K7Stage115M00::InitializeCallBack(void)
{
	if( mEnd==true ){
		return true;
	}

	// 蓮Xe[Wnm
	SetManualBranch(true);
	
//	// Xe[WR₷
//	WK7JObj		*pObj = GetJObj("burn");
//	if( pObj!=NULL ){
//		pObj->Hide(false,true);
//		CreateEffectModelFire(pObj,MFIRE_KIS);
//	}
	
	// LXMԍ擾
	pNpcKis = (K7EnmKIS *)WK7Npc::Find(ENENO_KIS);
	
	return false;
}

/*
	
	Jg
	
	
*/
bool K7Stage115M00::SetCurrentCallBack(void)
{
	if( mEnd==true ){
		return true;
	}
	
	while( pNpcKis==NULL ){
		K7SCR_RETSYS();
	}
	
	s32			task, exit = 1;
	KAKUZAI		kakuzai[KAKUZAI_MAX];
//	WK7JObj  	*pJObjBurn;
	
	task = 0;
	
	KakuzaiInit(kakuzai);
	
	// {XĎp
	while(exit){
		
		switch (task){
		case 0:					// fAzu
			// L|[Y
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			/// LA
			WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_KAMAE_ONLY);
			WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_WAIT);
			WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_BOSSBATTLE);
			
			K7SCR_RETSYS();
			/// lʒuEݒ
			// ʒuݒiViIprX^[gʒuj
			WK7Stage::SetCurrentPath(	WK7Stage::GetPathNurbsAll("curve1_camera1_fix"),
										0.372f,
										1,									// Back
//										WK7PATHINFO_INITDIR_TGTDIR			// 
										WK7PATHINFO_INITDIR_TGTDIR_REV		// wォ
			);

			
			// LXMI[vjOf
			KIS_OpeningDemo();
			if ( K7SCR_GET_SCENARIO_FLAG(FIRST_KISHIGI_DEMO) == FALSE ){
				K7SCR_SET_SCENARIO_FLAG(FIRST_KISHIGI_DEMO);
			}
			
			// 퓬JnI
			K7EnmKIS::mKisBattleStart = 1;
			
			task++;
			break;
		case 1:
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
//			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);	// JꎞŒŔ
			task++;
			break;
		case 2:
			pNpcKis->StageProc();
		}
		
		KakuzaiProc(kakuzai);
		K7SCR_RETSYS();
		
		if ( false == WK7RenderObj::IsValid(this) ){		// iXe[WjĂ܂ǂHiob
			WK7PLAYERCONTROL->BattlePadRegulationSet();
			gpSound->mStopStream();
			return true;
		}
		
		// {X픲
		if ((true == WK7PLAYERCONTROL->PcDieTest())			// l
		||	(false == pNpcKis->KISBossEnd())				//	{XI
		||	(WK7Stage::GetCurrentStageID()!=K7STGID(115,0))	//	Xe[WύX
		){
			exit = 0;
		}
		
#ifndef	K7APP_MASTER
#ifdef	BATTLE_ESCAPE
//		if( HSD_PadGetTrigger(1) & HSD_PAD_Y ){
//			mEnd = true;
//			exit = -1;
//			goto skip;
//		}
#endif
#endif
	}
	
	if ( true == WK7PLAYERCONTROL->PcDieTest() ){			// PCŏIꍇ
		WK7PLAYERCONTROL->BattlePadRegulationSet();
		gpSound->mStopStream();
		return true;
	}
	
	// ɂ gpNoise->mSandRequest(eSandLongNoise); ɂAmCY|Ă 040429
	
	mEnd = true;
	
#if 0
	k7app.SetFadeColor(0);
	k7app.FadeStart(0,WK7_DEFAULT_FADE_TICK);
	while( k7app.IsFade()==false ){
		K7SCR_RETSYS();
	}
#endif
	
skip:
	mEnd = true;
	
	// 蓮Xe[Wnm
	SetManualBranch(false);
	
	WK7PLAYERCONTROL->BattlePadRegulationSet();
	
	// ̃Xe[W쐬
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
//	WK7Stage	*pNextStg;
//	u32			nextStgID = K7STGID(137, 0);
//	u32			charaid = WK7PLAYERCONTROL->GetID();
	u32			playno;
	
//	gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7PLAYERCONTROL->Reset();
	WK7PLAYERCONTROL->ReleaseAll();
	K7SCR_STG_RELEASE(mID);
	
#ifndef	K7APP_MASTER
//		while( !(HSD_PadGetTrigger(1) & HSD_PAD_LEFT) ){
//			K7SCR_RETSYS();
//		}
#endif
	
	SK7ScenarioEnd	scnEnd;
	
	WK7Play::PlayInit   (false,false);
	playno = K7EVENTPLAY(01050204);
	WK7Play::Prepare    (playno);
	WK7Play::PrepareWait(playno,false);
	scnEnd.LoadData();
	WK7Play::StartB     (playno,false);
	WK7Play::PlayReleaseAll();
	K7SCR_RETSYS();
	WK7CAM->SetCinemaScopeMode(false);
	while( WK7Play::Find(playno)!=NULL ){
		K7SCR_RETSYS();
	}
	K7SCR_RETSYS();
	WK7Play::RestorePlayTB();
	
	scnEnd.FrameProcess();
	
//	K7SCR_NOISE_REQUEST();
	
	k7app.FadeStart(0,0);
	K7SCR_RETSYS();
	scnEnd.Release();
	
	WK7Chara::SetRenderChara(true );
	WK7Stage::SetRenderStage(true );
	WK7Item::SetRenderItem  (true );
	
//	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
//		K7SCR_RETSYS();
//	}
	
	gpSound->mStopStream();
	
//	K7SCR_NOISE_RELEASE_TO_MAP();
//	
//	GameInfo.MapSelectInit(MAP_FUKUSHIMA,MAP_GAL_HOME);
//	while( GameInfo.CheckMapSelectEnd()==false ){
//		K7SCR_RETSYS();
//	}
//	GameInfo.MapSelectEnd();
	
	K7SCR_MOON_START2();
	K7SCR_MOON_WAIT();
	
	gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
	
	GameInfo.SetScenarioFlow(K7SCNF_KAK);
	K7SCR_CHANGE_SCENARIO_DATA();
	// LN^X^[gn_Zbg
	WK7PLAYERCONTROL->ChangeStartChkPoint();
	
	u32		stgid = K7STGID(120,0);
	u32		chrid = K7CHRID(K7GAL,0);
	
	K7SCR_STG_CREATE_B   (stgid);
	K7SCR_PC_CREATE      (chrid);			// fǂݍ
	K7SCR_PC_MOTIONCREATE(chrid);			// [Vǂݍ
	K7SCR_PC_CREATEWAIT();					// ǂݍݑ҂
	K7SCR_STG_SET_CURRENT(stgid);
	
	K7SCR_PC_VISIBLE     (true);
	K7SCR_STG_VISIBLE    (stgid,true);
//	WK7PLAYERCONTROL->BattlePadRegulationSet();
	
//	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
//		K7SCR_RETSYS();
//	}
//	
//	while( gpNoise->mSandRelease()==false ){
//		GHMGCTASK_RETSYS();
//	}
//	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
//		GHMGCTASK_RETSYS();
//	}
//	
//	K7SCR_EXIT_PLAYMODE();
//	K7SCR_EXIT_DEMOPAUSE();
	
#if 0
	playno = K7EVENTPLAY(01060101);
	WK7Play::Prepare    (playno);
	WK7Play::PrepareWait(playno,false);
	WK7Play::StartB     (playno,false);
	WK7Play::PlayReleaseAll();
#if 1
	while( WK7Play::Find(playno)!=NULL ){
		K7SCR_RETSYS();
	}
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	playno = K7EVENTPLAY(01090101);
	WK7Play::Prepare    (playno);
	WK7Play::PrepareWait(playno,false);
	WK7Play::StartB     (playno,false);
	WK7Play::PlayReleaseAll();
#endif
	
//		K7SCR_PLAY_START_B(K7EVENTPLAY(01050204));
//		K7SCR_PLAY_RELEASE(K7EVENTPLAY(01050204));
//		K7SCR_RETSYS();
//		K7SCR_RETSYS();
//		K7SCR_PLAY_START_B(K7EVENTPLAY(01060101));
//		K7SCR_PLAY_RELEASE(K7EVENTPLAY(01060101));
//		K7SCR_RETSYS();
//		K7SCR_RETSYS();
//		K7SCR_PLAY_START_B(K7EVENTPLAY(01090101));
//		K7SCR_PLAY_RELEASE(K7EVENTPLAY(01090101));
//		K7SCR_PLAY_TERM()
	gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	WK7Play::RestorePlayTB();
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	
	// ̃Xe[Wǂݍ
	while( (pNextStg = WK7RenderObj::CreateStage(nextStgID))==NULL ){
		K7SCR_RETSYS();
	}
	while( pNextStg->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	WK7PLAYERCONTROL->CreateModel(charaid);
	WK7PLAYERCONTROL->CreatePackMotion(charaid);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7PLAYERCONTROL->SetVisible(true);
	WK7PLAYERPATHCONTROL->CameraRenew();
	while( WK7PLAYERCONTROL->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	WK7PLAYERCONTROL->ChangeCallback();
	
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT(nextStgID);
	K7SCR_STG_VISIBLE    (nextStgID,true);
	/// pX싖
	WK7PLAYERCONTROL->SetPathEnable(true);
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	WK7PLAYERCONTROL->BattlePadRegulationSet();
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
#endif
	
	return true;
}


/*
	
	LXMf
	
	
*/
void K7Stage115M00::KIS_OpeningDemo(void)
{
	if ( K7SCR_GET_SCENARIO_FLAG(FIRST_KISHIGI_DEMO) == FALSE ){
		
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		WK7Play		*pPlay;
		u32			playno;
		
		WK7Play::StorePlayTB();
		playno = K7EVENTPLAY(01500101);
		while( (pPlay=WK7Play::Create(playno))==NULL ){
			K7SCR_RETSYS();
		}
		pPlay->Prepare();
		
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			K7SCR_RETSYS();
		}
		
		while( pPlay->GetState()!=WK7Play::PREPARED ){
			K7SCR_RETSYS();
		}
		WK7Chara::SetRenderChara(false);
		WK7Stage::SetRenderStage(false);
		WK7Item::SetRenderItem  (false);
		pPlay->Start();
		K7SCR_RETSYS();
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		while( pPlay->GetState()!=WK7Play::PLAYED ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
			K7SCR_RETSYS();
		}
			
		pPlay->SetVisibleAll(false);
		WK7Play::PlayReleaseAll();
		K7SCR_RETSYS();
		K7SCR_RETSYS();
//		WK7Play::PlayTB(playno);
//		WK7Play::SetTermCaptureRenderOn(false);
		WK7Play::RestorePlayTB();
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			K7SCR_RETSYS();
		}
	}
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	// Xe[WR₷
	WK7JObj		*pObj = GetJObj("burn");
	if( pObj!=NULL ){
		pObj->Hide(false,true);
		CreateEffectModelFire(pObj,MFIRE_KIS);
	}
	WK7Chara::SetRenderChara(true );
	WK7Stage::SetRenderStage(true );
	WK7Item::SetRenderItem  (true );
	
	gpNoise->mSandRelease();								// mCYJ

	K7SCR_TIMEWAIT(300);

	WK7CAMPATHFOLLOWINFO->SetStageStartMode(false);
	WK7CAM->SetBranchPointMode(false);
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);

	K7SCR_TIMEWAIT(300);
	
	while ( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
}


/*
	
	Ăpޏ
	
	
*/
void K7Stage115M00::KakuzaiInit(KAKUZAI *pInfoTop)
{
	int i;
	
	for(i=0; i<KAKUZAI_MAX; i++, pInfoTop++){
		pInfoTop->frame     = 0;
		pInfoTop->speed     = 0.f;
		pInfoTop->gravi     = 0.f;
		pInfoTop->pJObjBurn = GetJObj(pKakuzaiFireName[i]);
		pInfoTop->pJObj     = GetJObj(pKakuzaiName[i]);
	}
}


/*
	
	Ăp
	
	
*/
static f32 randParam  = 0.01f;
static f32 graviParam = 0.00098f;

void K7Stage115M00::KakuzaiProc(KAKUZAI *pInfoTop)
{
	KAKUZAI *pKakuzai;
	int i;
	
	for(i=0, pKakuzai=pInfoTop; i<KAKUZAI_MAX; i++, pKakuzai++){
		
		if ( pKakuzai->frame == 0 ){
			// ҋ@
			pKakuzai->frame  = (int )rand()%30 + 10;
			pKakuzai->gravi  = 0.f;
			pKakuzai->speed  = (f32 )(HSD_Randf() * randParam);
			
			// ʒuݒ
			pKakuzai->pJObj->SetPosition(KakuzaiPos[rand()%KAKUZAI_RAND_POS]);
		}else{
			if ( pKakuzai->frame > 1 ){
				pKakuzai->frame--;
			}else{
				Vec pos;
				
				pKakuzai->pJObj->GetPosition(&pos);
				pKakuzai->gravi += graviParam;
				pKakuzai->speed += pKakuzai->gravi;
				pos.y -= pKakuzai->speed;
				
				pKakuzai->pJObj->SetPosition(pos);
				pKakuzai->pJObjBurn->SetPosition(pos);
				
				if ( pos.y < -50.f ){
					pKakuzai->frame=0;
				}
			}
		}
	}
}

bool K7Stage115M00::CondChangeCallBack(void)
{
	// L`FW̓xɃNAĂ܂̂ŁAxtO𗧂Ă
	WK7PLAYERCONTROL->SetCamRevDisable(true);
	return true;
}
