////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage131M00
//
// K7Stage131M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE131M00_H__
#define	__K7STAGE131M00_H__

#include "..\K7Stage.h"

class K7Stage131M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage131M00();
	K7Stage131M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	bool mDeskOpen;
	bool mIkasamaSadou;
	bool DeskOpen(int se=0);
	bool IkasamaSetUp(int se=0);
	bool PanelOpen(void);
	bool IkasamaDisp(bool flag);
public:
	virtual ~K7Stage131M00();

	virtual bool CreateCallBack    (void);
	virtual bool TerminateCallBack (void);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool InitializeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
};

#define ROOM131M00_ELEVATORDOOR_NAME	"ElevatorGroup01"


#ifdef __K7STAGE131M00_CPP__

enum K7STAGE131M00_ONESHOTCAM{
	ONESHOTCAM_011310,
	ONESHOTCAM_011309,
	ONESHOTCAM_011305,
	ONESHOTCAM_IKASAMA,
	ONESHOTCAM_011310_OPEN,
	CAM131M00_HS_PRESEN_START,
	CAM131M00_HS_PRESEN_END,
};


K7StageEventOneShotCamera K7Stage131M00_Camera[] = {
	{{244.927f, 13.200f, 28.511f},{300.013f, 15.103f, 42.289f}},					// sbLO|Cgpl
	{{413.111f, 15.647f, 40.489f},{357.154f, 18.454f, 42.297f}},					// o|X^[
	{{142.562f, 3.042f, 37.098f},{157.146f, 16.902f, 27.293f}},						// o
	{{158.043f, 6.264f, 50.528f},{154.729f, 9.693f, 39.516f}},						// ܑuJ
	{{276.075f, 12.958f, 37.763f},{292.747f, 12.580f, 37.242f}},					// sbLO|CgplƂ
	{{296.731f, 11.468f, -90.927f},{319.788f, 13.529f, -88.487f}},// HSЉp
	{{92.336f, 11.468f, -92.733f},{115.393f, 13.529f, -90.293f}},// HSЉpY[
};

#endif


#endif	//__K7STAGE131M00_H__

