////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage134M00
//
// K7Stage134M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE134M00_H__
#define	__K7STAGE134M00_H__

#include "..\K7Stage.h"

class K7Stage134M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage134M00();
	K7Stage134M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	bool mDeskOpen;
	int mDoorMode;
	bool DeskOpen(int se);
	bool PanelAllOKTest(void);
	bool BrockadePath(void);
	bool DoorLockB(int mode);
public:
	virtual ~K7Stage134M00();
	virtual bool CreateCallBack    (void);
	virtual bool TerminateCallBack (void);
	virtual bool InitializeCallBack(void);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
	virtual bool EventCallBack     (WK7EventInfo     &);		// Cxg
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool BpLeaveCallBack( WK7BpInfo &info );
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
//	virtual bool SpAbilityCallBack(WK7SpAbilityInfo &info);
	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);

//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
};


#ifdef __K7STAGE134M00_CPP__


enum K7STAGE134M00_ONESHOTCAM{
	ONESHOTCAM_DESK,
	EV_011606,
	EV_011607,
	EV_011608,
	DOOR_010402,
	SECTRET_0,
	ELEV_CAMERA_POS,
	ELEV_PLAYER_POS,
	SECTRET_1,
	SECTRET_2,
	SECTRET_3,
	SECTRET_4,
	ONESHOTCAM_TAMAUP,
	ONESHOTCAM_LASEROFF,
	ONESHOTCAM_SAKUCLOSE,
};


K7StageEventOneShotCamera K7Stage134M00_Camera[] = {
	{{186.277f, 13.544f, -253.327f},{184.199f, 19.320f, -249.310f}},		// ̃e[uJ
	{{170.451f, 11.962f, -88.676f},{170.117f, 11.832f, -100.006f}},
	{{284.341f, 11.362f, -43.121f},{295.664f, 11.480f, -43.661f}},
	{{316.704f, 11.362f, -74.677f},{305.368f, 11.365f, -74.618f}},
	{{22.538f, 8.873f, -152.710f},{17.396f, 8.834f, -94.990f}},				// 403
	{{210.552f, 11.054f, -101.062f},{203.702f, 9.968f, -108.266f}},			// E
	{{-10.381f, 11.568f, -107.046f},{-32.396f, 11.239f, -107.996f}},		//Gx[^ւ̃J
	{{-10.787f, -0.000f, -100.182f},{-17.787f, -0.000f, -100.182f}},		//Gx[^̃vC[̍W
	{{222.458f, 12.409f, -92.242f},{214.663f, 10.504f, -86.273f}},
	{{211.389f, 12.409f, -90.050f},{201.407f, 12.328f, -89.469f}},
	{{239.039f, 11.013f, -90.956f},{231.503f, 4.897f, -93.368f}},
	{{215.014f, 6.863f, -104.605f},{211.054f, 3.966f, -113.319f}},
	{{192.216f, -1.177f, -260.612f},{185.526f, 10.133f, -251.390f}},		// eeAbv
	{{117.602f, 11.818f, -101.835f},{164.877f, 2.811f, -102.755f}},			// [U[J
	{{156.973f, 12.366f, -101.008f},{166.890f, 13.616f, -100.706f}},		// Vb^[J
};

#endif

#endif	//__K7STAGE134M00_H__

