////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage134M01 prSKL
//
// K7Stage134M01.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE134M01_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Wat\WK7Event.h"
#include ".\K7Stage134M01.h"
#include "..\..\..\Matsu\MK7Sound.h"
#include "..\..\..\Panel\SK7PanelIno.h"
//#include "..\..\..\Panel\SK7PanelShika.h"
//#include "..\..\..\Panel\SK7PanelCho.h"

// [V
#define	MOT134M01_00		(0)		//Gx[^̔J
#define	MOT134M01_01		(1)		//Gx[^̔
#define MOT134M01_MONINIT	(6)				// 傪܂܁il

// f
#define MDL134M01_ELEVATORDOOR	"ElevatorGroup01"		// Gx[^[̃hA

#define PATH134M01_ELEVATORPATH		"ElevatorHallPath"

K7Stage134M01::K7Stage134M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage134M01_Camera);
}

K7Stage134M01::~K7Stage134M01()
{
}


/*
	
	NGCg
	
*/
bool K7Stage134M01::CreateCallBack(void)
{
	//[Vt@C
	CreateOwnStageMotion( MOT134M01_00 );
	CreateOwnStageMotion( MOT134M01_01 );
	CreateOwnStageMotion( MOT134M01_MONINIT );
	
	return true;
}


/*
	
	Jg
	
*/
bool K7Stage134M01::SetCurrentCallBack(void)
{
	//136M00痈ꍇ̓Gx[^Cxg
	
	if( GetPrevStageID() == K7STGID(136,0) )
	{
		SetCurrentCallBackDefaultProc();
		
		while( IsChanging()==true ){
			K7SCR_RETSYS();
		}
		
		{
			WK7JObj*	pJObj;
			if( (pJObj = PlayMotion(MDL134M01_ELEVATORDOOR, MOT134M01_MONINIT)) != NULL ){
				pJObj->SetMotionLoop( false );
			}
		}
		
		ElevGetOff( ELEV_CAMERA_POS, ELEV_PLAYER_POS, MDL134M01_ELEVATORDOOR, MOT134M01_00, 0, SFX_SCE1_ELV_OPEN );
		
		WK7Stage::SetCurrentPath(	WK7Stage::GetPathNurbsAll(PATH134M01_ELEVATORPATH),
									1.f,
									1,									// Forward
									WK7PATHINFO_INITDIR_TGTDIR			// 
//									WK7PATHINFO_INITDIR_TGTDIR_REV		// wォ
		);
		
		// ŒJ̐ݒ
		WK7StagePlaceInfo		*pPlaceInfo;
		pPlaceInfo = GetPlaceInfo(mID,PATH134M01_ELEVATORPATH);
		SetCameraStartPosition(pPlaceInfo);
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		SandRelease(pPlaceInfo);
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
		WK7PLAYERPATHCONTROL->SetBranchPointFix(false);
		WK7PLAYERPATHCONTROL->SetActive(true);
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
	}
	
	return true;
}

/*
	
	
	
*/
bool K7Stage134M01::InitializeCallBack(void)
{
	K7SCR_EVCONDCHANGE();
	return true;
}

/*
	
	Cxg
	
*/
bool K7Stage134M01::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	// EVENT_011605 Gx[^[pl 
	case	K7EVENTNO(011605):
		//Gx[^ɏ
		ElevGetOn( ELEV_CAMERA_POS, ELEV_PLAYER_POS, MDL134M01_ELEVATORDOOR, MOT134M01_01, 0, SFX_SCE1_ELV_CLOSE );
		
#if 1
		{	// 蓮Xe[Wǂݑւ
			u32		stgid = K7STGID(136, 0);
			u32		mIDBack;
			
			// L|[Y
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			gpNoise->mSandRequest(eSandLongNoise);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			SetChanging(true);
			mIDBack = mID;
			K7SCR_STG_RELEASE    (mID);
			WK7Stage::SetPrevStageID(mIDBack);
			K7SCR_STG_CREATE_B   (stgid);
			K7SCR_STG_SET_CURRENT(stgid);
			K7SCR_STG_VISIBLE    (stgid,true);
			SetChanging(false);
		}
		
		return false;
#endif
		
//		Scn1SK7PanelElevatorPanelB(K7STGID(134, 0));
		break;
	default:
		break;
	}
	
	return false;
}




