////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage135M00
//
// K7Stage135M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE135M00_H__
#define	__K7STAGE135M00_H__

#include "..\K7Stage.h"

class K7Stage135M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage135M00();
	K7Stage135M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
//	bool mSheetOpen;
	bool SheetOpen(int se=0);
public:
	virtual ~K7Stage135M00();
	virtual bool CreateCallBack    (void);
	virtual bool EventCallBack     (WK7EventInfo     &);		// Cxg
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);		// hACxg
	virtual bool SetCurrentCallBack(void);
	virtual bool DieNpcCallBack(WK7DieNpcInfo &info);
	virtual bool CondChangeCallBack(void);
	virtual bool HitObjCallBack(WK7HitObjInfo &);
	
//	virtual bool InitializeCallBack(void)              { return true; }		// iǂݍݏÎɑ΂鏉j
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
};

#ifdef __K7STAGE135M00_CPP__


enum K7STAGE135M00_ONESHOTCAM{
	ELEV_CAMERA_POS,
	ELEV_PLAYER_POS,
	ONESHOTCAM_NAZO,
};


K7StageEventOneShotCamera K7Stage135M00_Camera[] = {
	{{-10.381f, 11.568f, -107.046f},{-32.396f, 11.239f, -107.996f}},		//Gx[^ւ̃J
	{{-10.787f, -0.041f, -100.182f},{-17.787f, -0.041f, -100.182f}},		//Gx[^̃vC[̍W
	{{37.203f, 17.286f, -117.913f},{76.498f, 9.524f, -77.954f}},			//V[gJ
};

#endif
#endif	//__K7STAGE135M00_H__

