////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage136M00 prn if|[Xe[Wj
//
// K7Stage136M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE136M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include ".\K7Stage136M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7Npc.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Kaw\KK7Effect.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Panel\SK7PanelLocker.h"
#include "..\..\..\Matsu\MK7Sound.h"
#include "..\..\..\Enm\EnmDe2.h"
#include "..\..\..\Yam\YK7EffectDraft.h"

// bZ[W

// [V
#define	MOT136M00_00					(5)		//Gx[^̔J
#define	MOT136M00_01					(4)		//Gx[^̔

#define MOT136M00_L_BROKEN				(0) 	 //ǔjЗivC[獶j
#define MOT136M00_C_BROKEN				(1) 	 //ǔjЗij
#define MOT136M00_R_BROKEN				(2) 	 //ǔjЗivC[Ej
#define MOT136M00_MONINIT				(6)		// 傪܂܁il

// f
#define MDL136M00_ELEVATORDOOR			"ElevatorGroup01"		// Gx[^[̃hA
#define MDL136M00_WALL					"event_011209"			// 
#define MDL136M00WIND					"wind01"

// {Xp
#define MDL136M00_L_WALL				"event_011210"			// 
#define MDL136M00_C_WALL				"event_011211"			// 
#define MDL136M00_R_WALL				"event_011212"			// 

// pX
#define	K7STAGE136M00_CLOSE_PATHNAME		"curve12"			// pXO
#define	K7STAGE136M00_RIDDLE_PATHNAME		"event_011209_0"	// JpXO

static Vec windPos = {38.175f, 10.264f, -101.974f};

K7Stage136M00::K7Stage136M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	int i;

	for(i=0; i<FALLLOCKNUM; i++){
		mBrokenRockID[i] = -1;
		pBrokenRock[i] = NULL;
		mWallHitFlag[i] = 0;
	}
	
	mpWindEffect = NULL;
	SetOneShotCamLocTbl(K7Stage136M00_Camera);
	GameInfo.SetMenuMapEnable(false);
	GameInfo.SetBossFlag     (true );
	mHitWallNo = 0;
	mFallWallCount = 0;
}

K7Stage136M00::~K7Stage136M00()
{
	GameInfo.SetMenuMapEnable(true );
	GameInfo.SetBossFlag     (false);
}

/*
	
	
	
*/
bool K7Stage136M00::InitializeCallBack(void)
{
#if 0
	K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011209);			// ItOĂ
#endif
	K7SCR_STG_SET_JUNCTION_PASS_EVNO(K7EVENTNO(011207));
	
	K7SCR_EVNO_SETENABLE(K7EVENTNO(011201), false);			// ҏ֎~ɂĂ܂
	
	K7SCR_EVCONDCHANGE();
	return true;
}


/*
	
	NGCg
	
*/
bool K7Stage136M00::CreateCallBack(void)
{
	//[Vt@C
	CreateOwnStageMotion( MOT136M00_00 );
	CreateOwnStageMotion( MOT136M00_01 );
	CreateOwnStageMotion(MOT136M00_L_BROKEN);
	CreateOwnStageMotion(MOT136M00_C_BROKEN);
	CreateOwnStageMotion(MOT136M00_R_BROKEN);
	CreateOwnStageMotion( MOT136M00_MONINIT );
	// ̃Xe[W͎蓮œǂݍ܂
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_DE2_END) == false){			// f|[|ĂȂ
		return false;
	}else{
		return true;
	}
}




/*
	
	Jg
	
*/
bool K7Stage136M00::SetCurrentCallBack(void)
{
	K7EnmDE2	*pNpcDe2;
	int exit = 0;
	int i;
	
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_DE2_END) == false){			// f|[|ĂȂ
		
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		// {X ǂݍ
		while( (pNpcDe2 = (K7EnmDE2 *)WK7Npc::Create(ENENO_DE2))==NULL ){
			K7SCR_RETSYS();
		}
		while( pNpcDe2->IsLoading()==true ){
			K7SCR_RETSYS();
		}
		while( pNpcDe2->GetNpcState() == NPC_STATE_INIT ){
			K7SCR_RETSYS();
		}
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		exit = 1;
	}else{
		exit = 0;
	}
	
	//134M01,135M00痈ꍇ̓Gx[^Cxg
	if(	(GetPrevStageID() == K7STGID(134,1))
	||	(GetPrevStageID() == K7STGID(135,0))
	){
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		while( IsChanging()==true ){
			K7SCR_RETSYS();
		}
		
		K7SCR_EVCONDCHANGE();
		
		{
			WK7JObj*	pJObj;
			if( (pJObj = PlayMotion(MDL136M00_ELEVATORDOOR, MOT136M00_MONINIT)) != NULL ){
				pJObj->SetMotionLoop( false );
			}
		}
		
		ElevGetOff( ELEV_CAMERA_POS, ELEV_PLAYER_POS, MDL136M00_ELEVATORDOOR, MOT136M00_00, 1, SFX_SCE1_ELV_OPEN );
		
		// ŒJ̐ݒ
		WK7StagePlaceInfo		*pPlaceInfo;
		pPlaceInfo = GetPlaceInfo(mID,"event_011207");
		SetCameraStartPosition(pPlaceInfo);
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		SandRelease(pPlaceInfo);
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
		WK7PLAYERPATHCONTROL->SetBranchPointFix(false);
		WK7PLAYERPATHCONTROL->SetActive(true);
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
	}
	
	K7SCR_EVCONDCHANGE();
	
	// ʂ̋
	gpSound->mPlayStreamNo(HPS_KRAKUJITU_F);
	
	while(exit){
		
		if ( 1 == K7EnmDE2::mDE2BattleStart ){
			pNpcDe2->StageProc(WK7Stage::GetCurrentStage());
		}
		
		GHMGCTASK_RETSYS();
		
		if ( false == WK7RenderObj::IsValid(this) ){				// Ă܂ǂHiob
			K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_011209);			// ǍĂѕ
			WK7PLAYERCONTROL->BattlePadRegulationSet();
			return true;
		}
		
		// ₪f|[ɓ邩ǂH̔
		if ( 1 == K7EnmDE2::mDE2BattleStart ){
			for(i=0; i<FALLLOCKNUM; i++){
				if ( mBrokenRockID[i] != -1 ){
					if ( pBrokenRock[i]->GetCurrentMotionFrame() == 36.f ) {
						// SE
	//					gpSound->mPlaySE(SFX_SCE1_FUKU_ROCKDESTROY);
						// f|[Ƀqbgǂ̔s
						if ( true == pNpcDe2->DE2HitTest(&BrokenRockPos[mBrokenRockID[i]]) ) {
							mHitWallNo = 1;
						}
					}
					if ( pBrokenRock[i]->GetCurrentMotionFrame() == 42.f ) {
						// GtFNginʂɗu
						gpSound->mPlaySE(SFX_BOSS_DE2_WALLFALL_FLOOR);
						KK7DoorSmokeEffect(BrokenRockPos[mBrokenRockID[i]]);
						mBrokenRockID[i] = -1;
						if ( mFallWallCount >= 3 ){
							// f|[ŏIU`
							pNpcDe2->FinalAtkCall();
						}
					}
				}
			}
		}
		
		// {X픲
		if ((0 != pNpcDe2->DE2BossEnd())							//	{XI
		||	(WK7Stage::GetCurrentStage() == NULL)					//	Xe[W܂
		||	(WK7Stage::GetCurrentStage()->GetID()!=K7STGID(136,0))	//	Xe[WύX
		){
			if ( 1 == pNpcDe2->DE2BossEnd() ){
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_DE2_END);
				
				K7SCR_STG_SET_PATHENABLE       (K7STAGE136M00_CLOSE_PATHNAME ,true);
				K7SCR_EVNO_SETENABLE(K7EVENTNO(011207), true);			// ̃Cxg֎~iGx[^[j
			}
			exit = 0;
		}
	}
	
	// ɂ gpNoise->mSandRequest(eSandLongNoise); ɂAmCY|Ă 040429
	
	// 蓮Xe[Wnm
//	SetManualBranch(false);
	
	return true;
}


/*
	
	
	qbgIuWF
	
	
*/
bool K7Stage136M00::HitObjCallBack(WK7HitObjInfo &info)
{
	WK7JObj		*pJObj;
	
	if ( K7EnmDE2::mDE2BattleStart ){
		
		// {X풆͂
		if ( !mHitWallNo ){
			switch( info.mEventNo ){
			case	K7EVENTNO(011210):								// Ǎ
				if ( !mWallHitFlag[0] ) {
					mWallHitFlag[0] = 1;
					pJObj = GetJObj(MDL136M00_L_WALL);
					if( (pJObj=PlayMotion(MDL136M00_L_WALL, MOT136M00_L_BROKEN))!=NULL ){
						gpSound->mPlaySE(SFX_BOSS_DE2_WALLFALL);		//ǁ@V䂩番
						pJObj->SetMotionLoop(false);
						pBrokenRock[0] = pJObj;
						mBrokenRockID[0] = 0;
						mFallWallCount++;
					}
				}else{
					return false;
				}
				break;
			case	K7EVENTNO(011211):								// ǐ^
				if ( !mWallHitFlag[1] ) {
					mWallHitFlag[1] = 1;
					pJObj = GetJObj(MDL136M00_C_WALL);
					if( (pJObj=PlayMotion(MDL136M00_C_WALL, MOT136M00_C_BROKEN))!=NULL ){
						gpSound->mPlaySE(SFX_BOSS_DE2_WALLFALL);		//ǁ@V䂩番
						pJObj->SetMotionLoop(false);
						pBrokenRock[1] = pJObj;
						mBrokenRockID[1] = 1;
						mFallWallCount++;
					}
				}else{
					return false;
				}
				break;
			case	K7EVENTNO(011212):								// ǉE
				if ( !mWallHitFlag[2] ) {
					mWallHitFlag[2] = 1;
					pJObj = GetJObj(MDL136M00_R_WALL);
					if( (pJObj=PlayMotion(MDL136M00_R_WALL, MOT136M00_R_BROKEN))!=NULL ){
						gpSound->mPlaySE(SFX_BOSS_DE2_WALLFALL);		//ǁ@V䂩番
						pJObj->SetMotionLoop(false);
						pBrokenRock[2] = pJObj;
						mBrokenRockID[2] = 2;
						mFallWallCount++;
					}
				}else{
					return false;
				}
				break;
			}
			
		}
		
	}else{
		switch( info.mEventNo ){
		case	K7EVENTNO(011209):								// 
			
			if ( K7MSK == WK7PLAYERCONTROL->GetMainID() ){
				//ogIB
				KK7BattleMainTask::BattleMainTaskExit(2);
				// L|[Y
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE(false);
				
				//
				KK7DoorSmokeEffect( (Vec){-404.f, -14.f, -1246.f} );
				
				BrokenScreen(1);
				gpSound->mPlaySE(SFX_SCE1_FUKU_ROCKDESTROY);
				SetMskWallCam( ONESHOTCAM_SCREENBROKEN );
				
				K7SCR_PC_SETVISIBLE(true);
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011209);			// jς ItOĂ
				
				if ( K7SCR_GET_SCENARIO_FLAG(FIRST_DEP_DEMO) == FALSE ){
					K7SCR_NOISE_REQUEST();
					K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(01070210) );
					K7SCR_NOISE_RELEASE();
					K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(01070210) );
					K7SCR_NOISE_REQUEST();
					K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(01070210) );
					WK7Play::SetPlayed(K7EVENTPLAY(01070210),false);		// LĂȂƂɂ
					K7SCR_EVCONDCHANGE();
					WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
					WK7CAMPATHFOLLOWINFO->SetPathCamera(NULL);
					WK7CAMPATHFOLLOWINFO->SetMode(WK7CamPathFollowInfo::FOLLOW_MODE);
					K7SCR_NOISE_RELEASE();
					
					K7SCR_SET_SCENARIO_FLAG(FIRST_DEP_DEMO);
				}else{
					K7SCR_EVCONDCHANGE();
					WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
					WK7CAMPATHFOLLOWINFO->SetPathCamera(NULL);
					WK7CAMPATHFOLLOWINFO->SetMode(WK7CamPathFollowInfo::FOLLOW_MODE);
				}
				
				// L|[Y
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				
				// f|[JnI
				// {XJn
				K7EnmDE2::mDE2BattleStart = 1;
				
			}
			
			return true;
			
			break;
		}
	}
	return true;
}


bool K7Stage136M00::CondChangeCallBack(void)
{
	EFFECT		*pWindEffect;
	WK7JObj		*pWindJObj;
	bool		wind=false;

	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011202_GEKI) == true ){		// ̃LH
		if ( K7SCR_EVHASITEM(K7EVENTZAN(011051)) == false )	{				// cOCxg
			K7SCR_EVNO_SETENABLE(K7EVENTZAN(011051), true);					// cOCxg
			SetZanEventEnable(K7EVENTZAN(011051),true);
		}
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTZAN(011051), false);					// cOCxg֎~
		SetZanEventEnable(K7EVENTZAN(011051),false);
	}
	
	// ǂ̃pX
	BrokenScreen();
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_DE2_END) == true){				// f|[|
//	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011209)==TRUE ){
		K7SCR_STG_SET_PATHENABLE       (K7STAGE136M00_CLOSE_PATHNAME ,true);
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011207), true);						// ̃Cxg֎~iGx[^[j
	}else{
		K7SCR_STG_SET_PATHENABLE       (K7STAGE136M00_CLOSE_PATHNAME ,false);
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011209)==FALSE ){
			K7SCR_EVNO_SETENABLE(K7EVENTNO(011207), true);					// ̃Cxg֎~iGx[^[j
		}else{
			K7SCR_EVNO_SETENABLE(K7EVENTNO(011207), false);					// ̃Cxg֎~iGx[^[֎~j
		}
	}
	

	// GtFNg
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011209)==TRUE ){			// jς
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE136M00_RIDDLE_PATHNAME,true);
		wind = false;
	}else{
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE136M00_RIDDLE_PATHNAME,false);
		if( WK7PLAYERCONTROL->GetMainID()==K7CAT ){
			wind = true;
		}else{
			wind = false;
		}
	}
	pWindJObj = GetJObj(MDL136M00WIND);
	if( pWindJObj!=NULL ){
		if( wind==true && GetCurrentStageID()==mID ){
			if( IsValidEffect(mpWindEffect)==false ){
				WK7RenderObjEffectInfo	info;
				info.Create();
				if( (pWindEffect = ::CreateDraft2Effect(pWindJObj,(s32)VParam[ED_DRAFT][2]))!=NULL ){
					mpWindEffect = CreateEffect(pWindEffect,&info);
					CatWindSePlay(windPos, K7SCN01_EVFL_011209, SFX_SCE1_SUKIMAWIND16);
				}
			}
		}else{
			if( mpWindEffect!=NULL ){
				DelReqEffect(mpWindEffect);
				mpWindEffect = NULL;
			}
		}
	}
	return true;
}


/*
	
	Cxg
	
*/
bool K7Stage136M00::EventCallBack(WK7EventInfo &info)
{
//	s32  result;
//	int panelOK;

	switch( info.mEventNo ){
	// EVENT_011207 Gx[^[pl 
	case	K7EVENTNO(011207):
		//Gx[^ɏ
		ElevGetOn( ELEV_CAMERA_POS, ELEV_PLAYER_POS, MDL136M00_ELEVATORDOOR, MOT136M00_01, 1, SFX_SCE1_ELV_CLOSE );
		
#if 1
		{	// 蓮Xe[Wǂݑւ
			u32		stgid;
			u32		mIDBack;
			
			if ( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011202) == true ){
				stgid = K7STGID(135, 0);				// 4F֌
			}else{
				stgid = K7STGID(134, 1);				// 5F֌
			}
			
			// L|[Y
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			gpNoise->mSandRequest(eSandLongNoise);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			SetChanging(true);
			mIDBack = mID;
			K7SCR_STG_RELEASE    (mID);
			WK7Stage::SetPrevStageID(mIDBack);
			K7SCR_STG_CREATE_B   (stgid);
			K7SCR_STG_SET_CURRENT(stgid);
			K7SCR_STG_VISIBLE    (stgid,true);
			SetChanging(false);
		}
		
		return true;
#endif
		
	default:
		return false;
	}
	return false;
}

/*
	
	G񂾂R[
	
*/
bool K7Stage136M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
	WK7Npc *pNpc = info.mpNpc;
//	
//	if ( ENENO_1_136_01 == pNpc->GetEneNo() ){		// nbJ[p̖wuX}C
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(010101))==false ){
//			AllRockerEventEnable(true);				// RCbJ[Cxg
//		}
//		return false;
//	}
	return true;
}


/*
	
	
	hACxg
	
	original Matsuzaki
	
*/
bool K7Stage136M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo ){
	//L 01|07-02-02@
	case	K7EVENTDOOR( 011201 ):
		if( WK7Play::HasPlayed(K7EVENTPLAY(01070202)) == false )
		{
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			
			// LtO
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011202_GEKI);
			
			//mCY
			K7SCR_NOISE_REQUEST();
			//L
			WK7Chara::SetRenderChara(false);
			WK7Stage::SetRenderStage(false);
			WK7Item::SetRenderItem  (false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			WK7Stage::DeleteStage(this);
			WK7PLAYERCONTROL->ReleaseArchive();
			while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
				K7SCR_RETSYS();
			}
			K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(01070202) );
			//mCY
			K7SCR_NOISE_RELEASE();
			//LI҂
			K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(01070202) );
			//mCY
			K7SCR_NOISE_REQUEST();
			//LI
			K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(01070202) );
#if	0
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			// LtO
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011202_GEKI);
			
			gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
			
			WK7Chara::SetRenderChara(false);
			WK7Stage::SetRenderStage(false);
			WK7Item::SetRenderItem  (false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			WK7Stage::DeleteStage(this);
			WK7PLAYERCONTROL->ReleaseArchive();
			while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
				K7SCR_RETSYS();
			}
			
//			while( WK7Stage::ReleaseStageArchive()==false ){			// Xe[Wf[^̉
//				K7SCR_RETSYS();
//			}
//			while( WK7Stage::IsReleasedStageArchive()==false ){
//				K7SCR_RETSYS();
//			}
			while( gpNoise->mGetSandFrameProc() != eSandExec )		K7SCR_RETSYS();
			WK7Play::StorePlayTB();
			while( gpNoise->mSandRelease() == false )				K7SCR_RETSYS();
			while( gpNoise->mGetSandFrameProc() != eSandStandby )	K7SCR_RETSYS();
			WK7Play::PlayTB( K7EVENTPLAY(01070202) );
			WK7Play::RestorePlayTB();
			
			// ȉXe[WԈړȂ̂ŃJbg
//			while( WK7Stage::RestoreStageArchive()==false ){			// Xe[Wf[^̕
//				K7SCR_RETSYS();
//			}
//			while( WK7Stage::IsRestoredStageArchive()==false ){
//				K7SCR_RETSYS();
//			}
			//inGameĊJ
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
#endif
		}
    	break;
	//ftHg
	default:
		break;
	}
	
	return( true );
	
}



// mode GtFNgA
bool K7Stage136M00::BrokenScreen(int mode)
{
	WK7JObj *pJObj;
	
	if ( mode ){
		BrokenObj(MDL136M00_WALL);
	}
	if( (pJObj = GetJObj(MDL136M00_WALL))!=NULL ){
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011209) == true ){
			pJObj->Hide(false,true);								// g
		}else{
			pJObj->Disp(false,true);								// g
		}
		return true;
	}
	
	return false;
}

/*
	
	
	cvOCxg̐
	
	
*/
bool K7Stage136M00::ZanEventCallBack(WK7ZanEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTZAN(011031):
		if ( false == K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011202_GEKI) ){
			return false;
		}
	default:
		break;
	}
	return true;
}

/*
	
	
	pX͂Ȃꂽ
	
	
*/
bool K7Stage136M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(011209):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011209)==TRUE ){			// jς
			return true;
		}else{
			gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
		}
		break;
	default:
		return true;
	}
	return true;
}


