////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage136M00
//
// K7Stage136M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE136M00_H__
#define	__K7STAGE136M00_H__

#include "..\K7Stage.h"

#define FALLLOCKNUM	(3)

class K7Stage136M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage136M00();
	K7Stage136M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	bool BrokenScreen(int mode=0);
	s8   mBrokenRockID[FALLLOCKNUM];
	WK7JObj *pBrokenRock[FALLLOCKNUM];
	u8 mWallHitFlag[FALLLOCKNUM];
	WK7RenderObjEffect *mpWindEffect;
	u8 mHitWallNo;
	u8 mFallWallCount;
public:
	virtual ~K7Stage136M00();
	virtual bool InitializeCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);		// hACxg
	virtual bool HitObjCallBack(WK7HitObjInfo &info);
	virtual bool ZanEventCallBack(WK7ZanEventInfo &);
	
	virtual bool CreateCallBack    (void);
	virtual bool BpLeaveCallBack(WK7BpInfo &);
//	virtual bool InitializeCallBack(void)              { return true; }		// iǂݍݏÎɑ΂鏉j
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
};

#ifdef __K7STAGE136M00_CPP__


enum K7STAGE136M00_ONESHOTCAM{
	ONESHOTCAM_011201,
	ONESHOTCAM_011201_OPEN,
	ELEV_CAMERA_POS,
	ELEV_PLAYER_POS,
	ONESHOTCAM_SCREENBROKEN,
};

Vec BrokenRockPos[] = {
	{87.720f, 0.f, -112.111f},
	{89.248f, 0.f, -98.861f},
	{88.157f, 0.f, -87.567f},
};

K7StageEventOneShotCamera K7Stage136M00_Camera[] = {
	{{173.735f, -0.159f, -148.238f},{157.489f, 15.002f, -96.072f}},			// bJ[̒ɏҏisbLO鎞j
	{{178.667f, 6.918f, -123.584f},{165.259f, 15.392f, -105.420f}},
	{{-10.381f, 11.568f, -107.046f},{-32.396f, 11.239f, -107.996f}},		//Gx[^ւ̃J
	{{-10.787f, -0.041f, -100.182f},{-17.787f, -0.041f, -100.182f}},		//Gx[^̃vC[̍W
	{{31.364f, 11.968f, -94.195f},{14.825f, 7.434f, -78.160f}},				//ǔj
};

#endif

#endif	//__K7STAGE136M00_H__

