////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage137M00
//
// K7Stage137M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE137M00_H__
#define	__K7STAGE137M00_H__

#include "..\K7Stage.h"

class K7Stage137M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	bool					mStageInit;
	
	K7Stage137M00();
	K7Stage137M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage137M00();
	
	virtual bool InitializeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
	virtual bool CreateCallBack    (void);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool BpLeaveCallBack(WK7BpInfo &info);
	
	bool JihankiOpenEvent(void);
	
//	virtual bool InitializeCallBack(void)              { return true; }		// iǂݍݏÎɑ΂鏉j
//	virtual bool CondChangeCallBack(void)              { return true; }		// ԕύXitOɂԕύX邽߂ɗpj
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
};

#ifdef __K7STAGE137M00_CPP__


enum K7STAGE137M00_ONESHOTCAM{
	ONESHOTCAM_011301,					// ԃ{lbg
	ONESHOTCAM_011302,					// ̋@
	ONESHOTCAM_011311,					// ĎJ
	ONESHOTCAM_011312,					// ĎJ
	ONESHOTCAM_011311_0,				// ĎJ
};


K7StageEventOneShotCamera K7Stage137M00_Camera[] = {
	{{-289.595f, 13.714f, 310.751f},{-279.270f, 18.882f, 307.483f}},
	{{-3.604f, 11.236f, 5.054f},{15.471f, 17.102f, 20.967f}},
	{{-282.703f, 21.232f, 172.399f},{-289.503f, 25.601f, 148.630f}},
	{{-183.524f, 18.759f, 360.827f},{-173.548f, 24.263f, 383.199f}},
	{{-297.723f, 28.123f, 142.039f},{-275.783f, 22.138f, 152.673f}},
};

#endif

#endif	//__K7STAGE137M00_H__

