////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage201M00
//
// K7Stage201M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2013
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE201M00_CPP__

#include ".\K7Stage201M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn02.h"
#include "..\..\..\Sato\SK7PanelBase.h"
#include "..\..\..\Yam\YK7EffectLensFlare.h"

#define	K7STG201MOTID_MSK			K7MOTID(K7MSK,540)
#define	K7STG201MOTNAME_CAR			"event_020101_MSK"
#define	K7STG201MOTNAME_SUSIE		"futa"
#define K7STG201MOTNAME_PANEL   	"futa_panel"
#define	K7STG201MOTNAME_ROPE		"rope0"
#define	K7STG201MOTNAME_ROPEBASE	"ropebase"
#define	K6STG201RING				"ring"


//`````````````````````````````````````````````````
//			RXgN^
//`````````````````````````````````````````````````
K7Stage201M00::K7Stage201M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	K7SCR_SET_SCENARIO_FLAG( K7SCN02_ENFL_POP1 );		
	SetOneShotCamLocTbl( K7Stage201M00_Camera );
	mPlayBgm = HPS_CLOUDSMAN_B;
}

//`````````````````````````````````````````````````
//			fXgN^
//`````````````````````````````````````````````````
K7Stage201M00::~K7Stage201M00()
{
	// n
	::DeleteEffect( LensFlare ) ;
	::ReleaseLensFlareTexture() ;
}


//`````````````````````````````````````````````````
//			NGCg
//`````````````````````````````````````````````````
bool K7Stage201M00::CreateCallBack(void)
{
	CreateOwnStageMotion( EV_MOT_SUSIE );			
	CreateOwnStageMotion( EV_MOT_CAR );
	CreateOwnStageMotion( EV_MOT_SUSIE2 );
	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7STG201MOTID_MSK);
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_020101)==TRUE ){
		SetCollisionIndex(1);
	}else{
		SetCollisionIndex(0);
	}
	return true;
}

//`````````````````````````````````````````````````
//		iǂݍݏÎɑ΂鏉j
//`````````````````````````````````````````````````
bool	K7Stage201M00::InitializeCallBack( void )
{
	
	HereComeANewHSInit( PR_HS_URUM, ENENO_2_201M00_4 );
	
	// YtA
	if( GetJObj("sun") != NULL )
	{
		::SetupLensFlareTexture() ;
		while( ::CheckLensFlareTexture() == FALSE ){
			K7SCR_RETSYS() ;
		}
		LensFlare = ::CreateLensFlareEffect( GetJObj("sun") ) ;
	}

	//	}XNg[[Cxg`FbN	----------------------------------------
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_020101) ){		
		K7SCR_STG_SET_PATHENABLE( "sp_mskA0", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskA1", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskA2", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskA3", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskA4", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskA5", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskA6", false );
		//	\	----------------------------------------------------------------
		K7SCR_STG_SET_PATHENABLE( "sp_mskB0", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB1", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB2", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB3", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB4", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB5", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB6", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB7", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB8", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB9", true );

		K7SCR_EVNO_SETENABLE( K7EVENTNO(020101), false );
		PlayMotion( EV_MOT_CAR, -1.0f );
		SetMotionLoop( false );
	}else{
		mpMskMotion  = GetOwnModelMotion( K7MOT_ATTR|K7OBJTYPE_CHR, K7STG201MOTID_MSK );
		K7SCR_STG_SET_PATHENABLE( "sp_mskA0", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskA1", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskA2", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskA3", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskA4", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskA5", true );
		K7SCR_STG_SET_PATHENABLE( "sp_mskA6", true );
		//	\	----------------------------------------------------------------
		K7SCR_STG_SET_PATHENABLE( "sp_mskB0", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB1", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB2", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB3", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB4", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB5", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB6", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB7", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB8", false );
		K7SCR_STG_SET_PATHENABLE( "sp_mskB9", false );
	}
	//	g[-		----------------------------------------------
	K7SCR_JOBJ_DISP( GetJObj(K7STG201MOTNAME_ROPE) );
	K7SCR_JOBJ_HIDE( GetJObj(K7STG201MOTNAME_ROPEBASE) );

	//	[[	----------------------------------------------------
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020110 ) ){
		K7SCR_JOBJ_HIDE( GetJObj(K6STG201RING) );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(020110), false );
		SimpleSetLastMotion( K7STG201MOTNAME_SUSIE, EV_MOT_SUSIE2, NULL );
	}
	return true;
}

//`````````````````````````````````````````````````
// 			JgXe[Wɐݒ莞
//`````````````````````````````````````````````````
bool K7Stage201M00::SetCurrentCallBack(void)
{
	Vec pcPos;
	
	SetCurrentCallBackDefaultProc();
	
	//V^HSЉ
	if( false == HereComeANewHS(	PR_HS_URUM,
									ENENO_2_201M00_4,								// GID
									NULL,
									CAM201M00_HS_PRESEN_START,
									CAM201M00_HS_PRESEN_END,
									0,
									210,  320,  -9,  84, 672, 229 )					// OЉp
	){
		SetManualBranch(false);
//		return( false );
	}
	
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_020001 ) )	goto BGMCHANGE;
	
	if( WK7PLAYERCONTROL->GetMainID()==K7CYO ){
		goto BGMCHANGE;
	}
	
	if( GetPrevStageID() == K7STGID(200,0) ){
		SetManualBranch(true);
		while( WK7Stage::IsChanging() != false ){
			K7SCR_RETSYS();
		}
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();

		K7SCR_RETSYS();
		K7SCR_RETSYS();
		K7SCR_TIMEWAIT( WK7_SEC_TO_TICK(2) );

		FixCam( EV_CAM_CAMERA );
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		//ǂJɂȂ܂ő҂
//		while( WK7Stage::IsChanging() != false )
//		{
//			K7SCR_RETSYS();
//		}
		//inGame~
		K7SCR_TIMEWAIT( WK7_SEC_TO_TICK(2) );
		WatchCameraB( K7Stage201M00_Camera[EV_CAM_CAMERA_IN].tgt,
					  K7Stage201M00_Camera[EV_CAM_CAMERA_IN].pos,
					  K7CHRID(K7CYO,0), 1 );
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_DRFL_020001 );
		
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		SetManualBranch(false);
	}
	
BGMCHANGE:
	
	while( K7SCR_STG_GET_CURRENTID() == K7STGID(201,0) ){
#define BGM_CHANGE_DIST	(244.775f)
		Vec TrailerPos = {243.422f, 0.959f, -861.152f};
		f32 dist;
		
		WK7PLAYERCONTROL->GetPosition(pcPos);
		dist = GHM_VEC_GET_DIST(&pcPos, &TrailerPos);
		
		if ( GameInfo.GetMode() == WK7GameInfo::MOVE ){					// L`F̎ȂǋȂωȂ悤ɑΏ
			if ( dist > BGM_CHANGE_DIST ){
				if ( mPlayBgm != HPS_CLOUDSMAN_B ) {
					gpSound->mPlayStreamNo((int )HPS_CLOUDSMAN_B);		// Ȗ炵Ȃ
					mPlayBgm = HPS_CLOUDSMAN_B;
				}
			}else{
				if ( mPlayBgm != HPS_KRAKUJITU_C ) {
					gpSound->mPlayStreamNo((int )HPS_KRAKUJITU_C);		// Ȗ炵Ȃ
					mPlayBgm = HPS_KRAKUJITU_C;
				}
			}
		}
		K7SCR_RETSYS();
	}
	return true;
}


//`````````````````````````````````````````````````
//			ԕύXitOɂԕύX邽߂ɗpj
//`````````````````````````````````````````````````
bool K7Stage201M00::CondChangeCallBack(void)
{		
//	[[Cxg	
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020110 ) ){
		K7SCR_EVNO_SETENABLE( K7EVENTNO(020110), false );	
	}
	return true;
}

//`````````````````````````````````````````````````
//			Cxg
//`````````````````````````````````````````````````
bool K7Stage201M00::EventCallBack(WK7EventInfo &info)
{
	WK7JObj*        pJObj=NULL;
	WK7ZanEventInfo		zanEventInfo;
	WK7CameraMotion*	pCamMot  = GetOwnCameraMotion( EV_MOT_CAR );
//	u32	oldColor;
	switch( info.mEventNo ){
		
//		g[[Cxg		
	
	case	K7EVENTNO(020101):
		//	}XN
		if( WK7PLAYERCONTROL->GetMainID() == K7MSK ){
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			//	mCYZbg	------------------------------------------------------
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue);
			K7SCR_RETSYS();
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			//	G폜
			WK7Npc::NpcVisibleAll(false);

			//bZ[WtJݒ
			//[vϊ	
			K7SCR_JOBJ_DISP( GetJObj(K7STG201MOTNAME_ROPEBASE) );
			K7SCR_JOBJ_HIDE( GetJObj(K7STG201MOTNAME_ROPE) );
			K7SCR_TIMEWAIT( 4800*1 );

			//[VX^[g
			PlayMotion( EV_MOT_CAR, 0.0f );
			SetMotionLoop( false );
			
static	Vec		pos = { 230.0f , 1.0f , -961.0f };
static	f32		roty = PI;
static	s32		tick = 6000;
			//}XN[VZbg	----------------------------------
			WK7Model	*pPcModel = WK7PLAYERCONTROL->GetCharaModel();
			WK7PLAYERCONTROL->SetEnable(false);
			if( pPcModel != NULL ){
				pPcModel->SetPosition  (pos);
				pPcModel->SetRotY      (roty);
				pPcModel->AttachMotion (mpMskMotion);
				pPcModel->PlayMotion   ();
				pPcModel->SetMotionLoop(false);
			}
			//J[VĐ
			WK7CAM->SetMode( WK7Cam::WK7CAM_FREE_TARGET );
#if 0
			oldColor = WK7CAM->GetCinemaScopeColor();
			WK7CAM->SetCinemaScopeColor(WK7CAM_DEFAULT_CINEMASCOPE_COLOR);
			WK7CAM->SetCinemaScopeMode( true );
#endif
			WK7CAM->AttachMotion( pCamMot );
			WK7CAM->PlayMotion();
			WK7CAM->SetMotionLoop( false );
			gpSound->mPlaySE( SFX_SCE2_TRAILER_PULL );
			//	mCY߂	----------------------------------------------------------
			while( gpNoise->mSandRelease()==false ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			while( pPcModel->GetMotionState()!=WK7MODEL_NOANIM ){
				K7SCR_RETSYS();
			}
			//JI	-------------------------------------------------------
			WK7CAM->DetachMotion();
#if 0
			WK7CAM->SetCinemaScopeMode( false );
			WK7CAM->SetCinemaScopeColor( oldColor );
#endif
			K7SCR_RETSYS();
			//}XNʏԂ	------------------------------------------------------
			WK7PLAYERCONTROL->SetEnable(true);
			gpSound->mStopSE( SFX_SCE2_TRAILER_PULL );
			//	mCYZbg	------------------------------------------------------
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue);
			K7SCR_RETSYS();
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			// RW̓ւ
			SetCollisionIndex(1);
			CreateCollision();
			InitializeNpc();
			//	pX̐؂ւ	------------------------------------------------------
			K7SCR_STG_SET_PATHENABLE( "sp_mskA0", false );
			K7SCR_STG_SET_PATHENABLE( "sp_mskA1", false );
			K7SCR_STG_SET_PATHENABLE( "sp_mskA2", false );
			K7SCR_STG_SET_PATHENABLE( "sp_mskA3", false );
			K7SCR_STG_SET_PATHENABLE( "sp_mskA4", false );
			K7SCR_STG_SET_PATHENABLE( "sp_mskA5", false );
			K7SCR_STG_SET_PATHENABLE( "sp_mskA6", false );
			//	\	----------------------------------------------------------------
			K7SCR_STG_SET_PATHENABLE( "sp_mskB0", true );
			K7SCR_STG_SET_PATHENABLE( "sp_mskB1", true );
			K7SCR_STG_SET_PATHENABLE( "sp_mskB2", true );
			K7SCR_STG_SET_PATHENABLE( "sp_mskB3", true );
			K7SCR_STG_SET_PATHENABLE( "sp_mskB4", true );
			K7SCR_STG_SET_PATHENABLE( "sp_mskB5", true );
			K7SCR_STG_SET_PATHENABLE( "sp_mskB6", true );
			K7SCR_STG_SET_PATHENABLE( "sp_mskB7", true );
			K7SCR_STG_SET_PATHENABLE( "sp_mskB8", true );
			K7SCR_STG_SET_PATHENABLE( "sp_mskB9", true );
			//	}XNۂړ	----------------------------------------------
			WK7PLAYERCONTROL->SetEnable(true);
			K7SCR_STG_SET_CURRENT_PATH_TOBP("msk_position","sp_mskB3");
			WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
			K7SCR_RETSYS();
			//	ӂ炮Zbg	----------------------------------------------------
			K7SCR_SET_SCENARIO_FLAG(K7SCN02_EVFL_020101);
			//	[v߂	
			K7SCR_JOBJ_DISP( GetJObj(K7STG201MOTNAME_ROPE) );
			K7SCR_JOBJ_HIDE( GetJObj(K7STG201MOTNAME_ROPEBASE) );
			FixCam( EV_CAM_TRAILER_MOVE_1 );
			//	G߂
			WK7Npc::NpcVisibleAll(true);
			//	mCY߂	----------------------------------------------------------
			while( gpNoise->mSandRelease()==false ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			
			Vec		initpos;
			WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
			WK7PLAYERPATHCONTROL->GetCurrentPosition(&initpos);
			WK7CAMPATHFOLLOWINFO->SetStageStartMode              (true);
			WK7CAMPATHFOLLOWINFO->SetStageStartCamPosition       (K7Stage201M00_Camera[EV_CAM_TRAILER_MOVE_1].pos);
			WK7CAMPATHFOLLOWINFO->SetStageStartCamTargetPosition (K7Stage201M00_Camera[EV_CAM_TRAILER_MOVE_1].tgt);
			WK7CAMPATHFOLLOWINFO->SetStageStartTargetInitPosition(initpos);
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
		}else{
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );

			//bZ[WtJݒ
			FixCam( EV_CAM_TRAILER );

			gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );		//䉹
			//	bZ[W
			K7SCR_STGC_MESSAGE_B( 0 );

			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
		}
		break;
		
//		X[W[		
	case 	K7EVENTNO(020110):
		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020110 ) )	return true;
		//inGame~
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( false );

		//	ѕ\
		WK7CAM->SetCinemaScopeColor(WK7CAM_DEFAULT_CINEMASCOPE_COLOR);
		WK7CAM->SetCinemaScopeMode( true );

		//HPUPOACe擾
		K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_HPUP );
		FixCam( EV_CAM_SUSIE );
		//^Ñ[V
		gpSound->mPlaySE( SFX_SCE2_GASTANK_OPEN );
		if( (pJObj = PlayMotion( K7STG201MOTNAME_SUSIE, EV_MOT_SUSIE)) != NULL ){
			pJObj->SetMotionLoop( false );
			while( pJObj->GetMotionState(false,true) != WK7MODEL_NOANIM ){
				K7SCR_RETSYS();
			}
		}
		//cvOƉb
		zanEventInfo.Initialize();
		zanEventInfo.mEventNo = K7EVENTZAN( 020102 );
		zanEventInfo.mpStage  = this;
		GameInfo.SetZanMesID			( 0 );
		GameInfo.SetZanTermWait			( true );
		GameInfo.SetZanNoiseCancel		( true );
		GameInfo.SetZanCharaLoadCancel	( true );
		CallZanEventCallBackTask( zanEventInfo );
		while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT )
		{
			K7SCR_RETSYS();
		}
		GameInfo.SetZanTermWait( false );
		GameInfo.SetZanManual( true );
		GameInfo.SetZanCinemaScopeCancel( true );
		while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY )
		{
			K7SCR_RETSYS();
		}
		gpSound->mStopStream();
		//inGame~icvO𔲂Ɖ邽߁j
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( false );
		//O폜
		K7SCR_JOBJ_HIDE( GetJObj(K6STG201RING) );
		//ACe擾ʂ\
		K7SCR_STG_ITEMGET_B( K7STAGE201M00_GET_HPUP_RING );
		//tO𗎂Ƃ
		K7SCR_EVSETITEM( K7EVITEM_ZAN (020102), false );
		//WNV폜
		K7SCR_EVNO_SETENABLE( K7EVENTNO(020110), false );	
		//[[CxgtOZbg
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_EVFL_020110 );
		//cvOƉb
		zanEventInfo.Initialize();
		zanEventInfo.mEventNo = K7EVENTZAN( 020102 );
		zanEventInfo.mpStage  = this;
		GameInfo.SetZanMesID			( 1 );
		GameInfo.SetZanTermWait			( true );
		GameInfo.SetZanNoiseCancel		( true );
		GameInfo.SetZanCharaLoadCancel	( true );
		CallZanEventCallBackTask( zanEventInfo );
		while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT )
		{
			K7SCR_RETSYS();
		}
		GameInfo.SetZanTermWait			( false );
		GameInfo.SetZanManual			( false );
		GameInfo.SetZanCinemaScopeCancel( false );
		while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY ){
			K7SCR_RETSYS();
		}
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		//inGame~icvO𔲂Ɖ邽߁j
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( false );
//		K7SCR_PC_SETVISIBLE( true );
		
		//	ѕ\
		WK7CAM->SetCinemaScopeColor(WK7CAM_DEFAULT_CINEMASCOPE_COLOR);
		WK7CAM->SetCinemaScopeMode( true );

		gpSound->mPlaySE( SFX_SCE2_GASTANK_CLOSE );
		//	X[W[	---------------------------------------------------
		if( (pJObj = PlayMotion( K7STG201MOTNAME_SUSIE, EV_MOT_SUSIE2)) != NULL ){
			pJObj->SetMotionLoop( false );
			while( pJObj->GetMotionState(false,true) != WK7MODEL_NOANIM ){
				K7SCR_RETSYS();
			}
			pJObj->StopMotion();
		}
		//inGameĊJ
		K7SCR_PC_SETVISIBLE( true );
		WK7PLAYERCONTROL->FrameProcess();
		WK7CAM->SetCinemaScopeMode( false );
		WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
		WK7CAM->FrameProcess();
		WK7CAM->SetCurrent();
//		K7SCR_RETSYS();

#if 1
		mPlayBgm = -1;
#else
//		gpSound->mPlayStreamNo(HPS_CLOUDSMAN_B);
#endif
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		return false;
	default:
		return true;
	}
	return false;
}

//`````````````````````````````````````````````````
//			G񂾂Ƃ̃EC_RC擾Cxg
//`````````````````````````````````````````````````
bool K7Stage201M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
	int num=0;
	WK7Npc *pNpc = info.mpNpc;
	switch( pNpc->GetEneNo() ){
	case ENENO_2_201M00_1:
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_ENFL_POP1_0 );
		break;
	case ENENO_2_201M00_2:
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_ENFL_POP1_1 );
		break;
	case ENENO_2_201M00_4:
		K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL)++;		//_Qbg
		if( K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) > K7SCN02_ULMEDAL_MAX ){
			K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) = K7SCN02_ULMEDAL_MAX;
		}
		break;
	}
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_ENFL_POP1_0 )==true && 
		K7SCR_GET_SCENARIO_FLAG( K7SCN02_ENFL_POP1_1 )==true )
	{
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_ENFL_POP1 );
	}
	return true;
}




