////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage201M00
//
// K7Stage201M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2013
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE201M00_H__
#define	__K7STAGE201M00_H__

#include "..\K7Stage.h"
#include "..\..\..\Yam\YK7Effect.h"

class K7Stage201M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	int mPlayBgm;
	WK7ModelMotion			*mpMskMotion;
	EFFECT 					*LensFlare ;

	K7Stage201M00();
	K7Stage201M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage201M00();

	virtual bool CreateCallBack    (void);				// iǂݍݗ\sꍇȂǂɗpj
	virtual bool InitializeCallBack(void);             	// iǂݍݏÎɑ΂鏉j retrun true  ftHg̓Gǂݍ݂ɍsB
	virtual bool CondChangeCallBack(void);
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);
	
};

#ifdef	__K7STAGE201M00_CPP__

//	bZ[Wԍ	
enum{
	K7STAGE201M00_TRAILER=0,		//	g[
	K7STAGE201M00_GET_HPUP_RING,	//	goAbvO
	DUM0,
	DUM1,
	DUM2,
	DUM3,
	CAM201M00_HS_PRESEN_START,
	CAM201M00_HS_PRESEN_END,
};

//	JW	
K7StageEventOneShotCamera	K7Stage201M00_Camera[]={
	{{217.005f,11.305f,-941.153f},{206.831f,1.670f,-958.625f}},		//	g[[
	{{219.287f,11.695f,-1085.325f},{212.843f,2.444f,-1104.651f}},
	{{-96.432f,-11.409f,-2221.628f},{-51.833f,10.932f,-2187.865f}},	//	Q[gpl
	{{281.261f,22.768f,-891.641f},{235.915f,7.723f,-860.318f}},
	{{125.210f,83.564f,28.441f},{97.457f,61.610f,-16.321f}},		//	ĎJ
	{{-4.206f,-0.582f,-41.137f},{36.139f,36.871f,-26.124f}},		// ĎJQiĂق
	{{-0.176f, 1.495f, -171.403f},{0.132f, 4.297f, -122.985f}},		//	Љ
	{{-0.642f, 9.918f, -1184.247f},{-0.335f, 12.720f, -1135.829f}},		//	ЉAbv
};

//	Jԍ	
enum{
	EV_CAM_TRAILER=0,				//	g[[
	EV_CAM_TRAILER_MOVE_1,			//	ړ
	EV_CAM_GATE,					//	Q[g
	EV_CAM_SUSIE,					//	[[
	EV_CAM_CAMERA,					//	ĎJ
	EV_CAM_CAMERA_IN,				//
};

//	Xe[W[V	
enum{
	EV_MOT_SUSIE=0,					//	X[W[
	EV_MOT_GATE,					//	Q[g
	EV_MOT_CAR,						//	
	EV_MOT_SUSIE2,					//	X[W[
};

#endif

#endif	//__K7STAGE201M00_H__

