////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage205M00
//
// K7Stage205M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/23/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE205M00_CPP__

#include ".\K7Stage205M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Scn\K7Scn02.h"
#include "../../../Yam/YK7EffectSmoke.h"
#include "../../../Yam/YK7EffectImpact.h"
#include "../../../Matsu/mK7Movie.h"
#include "..\..\..\Yam\YK7EffectLensFlare.h"


K7Stage205M00::K7Stage205M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage205M00_Camera );
	K7SCR_RESET_SCENARIO_FLAG( K7SCN02_EVFL_020314 );
}

K7Stage205M00::~K7Stage205M00()
{
	// n
	::DeleteEffect( LensFlare ) ;
	::ReleaseLensFlareTexture() ;
}

//`````````````````````````````````````````````````
//			NGCg
//`````````````````````````````````````````````````
bool K7Stage205M00::CreateCallBack(void)
{
	CreateOwnStageMotion( EV_MOT_KAKIWARI );			
	return true;
}

//`````````````````````````````````````````````````
//		iǂݍݏÎɑ΂鏉j 
//`````````````````````````````````````````````````
bool	K7Stage205M00::InitializeCallBack( void )
{
	// YtA
	if( GetJObj("sun") != NULL )
	{
		::SetupLensFlareTexture() ;
		while( ::CheckLensFlareTexture() == FALSE ){
			K7SCR_RETSYS() ;
		}
		LensFlare = ::CreateLensFlareEffect( GetJObj("sun") ) ;
	}
	
	return true ;
}

//`````````````````````````````````````````````````
//		iǂݍݏÎɑ΂鏉j 
//`````````````````````````````````````````````````
bool	K7Stage205M00::CondChangeCallBack( void )
{
	//	`FbN	----------------------------------------
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020314 ) ){		
		PlayMotion(EV_MOT_KAKIWARI,-1.0f);		//	ŏI[V
		SetMotionLoop(false);
		K7SCR_EVNO_SETENABLE( K7EVENTDOOR(020501), false );	//	WNV
//		K7SCR_EVNO_SETENABLE( K7EVENTNO(020206), false );	//	WNV
	}
	//	S[r[	-----------------------------------------
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020502 )){
		K7SCR_STG_SET_PATHENABLE( "pass_wagon", true );		//	pX쐬
		K7SCR_JOBJ_DISP( GetJObj("stage206_ev") );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(020502), false );	//	WNV
	}else{
		K7SCR_STG_SET_PATHENABLE( "pass_wagon", false );		//	pX쐬
		K7SCR_JOBJ_HIDE( GetJObj("stage206_ev") );		
	}
	return true;
}

//`````````````````````````````````````````````````
//			Cxg
//`````````````````````````````````````````````````
bool K7Stage205M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	//		S[r[		
	case 	K7EVENTNO( 020502 ):
		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020502 ) )	return true;		
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_EVFL_020502 );		//	Zbg
		char* pFileName = "/Movie/cloudman.h4m";
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		while( gpNoise->mSandRequest(eSandLongNoise)==false ){
			GHMGCTASK_RETSYS();
		}
		while( WK7Stage::ReleaseStageArchive()==false ){
			K7SCR_RETSYS();
		}
		while( WK7Stage::IsReleasedStageArchive()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->ReleaseTempData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
			K7SCR_RETSYS();
		}
		while( gpMovie->mGetStatus()!=eMvProcStandby ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
	#ifdef	_DEBUG
		ghmGcFile		file;
		if( file.Open(pFileName)==true ){
			file.Close();
	#endif
		while( gpMovie->mRequest(pFileName)==false ){
			K7SCR_RETSYS();
		}
	#ifdef	_DEBUG
		}
	#endif
		while( gpMovie->mGetStatus()!=eMvProcStandby ){
			if( gpMovie->mGetFrame() >= 1 && (HSD_PadGetTrigger(0) & HSD_PAD_START) ){
				gpMovie->mStop();
				while( gpMovie->mGetStatus()!=eMvProcStandby ){
					K7SCR_RETSYS();
				}
				break;
			}
			K7SCR_RETSYS();
		}
		while( gpNoise->mSandRequest(eSandLongNoise)==false ){
			GHMGCTASK_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->LoadData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7Stage::RestoreStageArchive()==false ){
			K7SCR_RETSYS();
		}
		while( WK7Stage::IsRestoredStageArchive()==false ){
			K7SCR_RETSYS();
		}
		K7SCR_STG_SET_PATHENABLE( "pass_wagon", true );		//	pX쐬
		K7SCR_JOBJ_DISP( GetJObj("stage206_ev") );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(020502), false );	//	WNV
		K7SCR_STG_SET_CURRENT_PATH_TOBP( "chara_pos", "pass_wagon");
		SetCurrentPath(	GetPathNurbsAll("pass_wagon"), 0.000f,
						0,									//0:forward 1:back
						WK7PATHINFO_INITDIR_TGTDIR_REV );		//:WK7PATHINFO_INITDIR_TGTDIR wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		K7SCR_RETSYS();
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}

//		K7SCR_MOVIE_PLAY(K7MOV_CLOUDMAN);					//	[r[
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		WK7PLAYERCONTROL->SetEnable(true);
		K7SCR_PC_SETVISIBLE( true );
		break;
	}	
	return true;
}
	
//`````````````````````````````````````````````````
//			_o
//`````````````````````````````````````````````````
bool	K7Stage205M00::BpLeaveCallBack( WK7BpInfo &info )
{
	WK7CameraMotion*	pCamMot  = GetOwnCameraMotion( EV_MOT_KAKIWARI );

	u32	evno   = GetBpEventNo( info );
	int	pathNo = GetBpPathNo( info );
	if( evno==0xffffffff )		return true;
		
	switch( evno ){
		
//		Ԃꂗ		
	case	K7EVENTNO( 020501 ):
		//	pXOł܂ȂĂȂƂ	
		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_020314 ) )	return true;
		
		//inGame~
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
//		K7SCR_PC_SETVISIBLE( false );
		
		//Jݒ
//		FixCam( EV_CAM_KAKIWARI );
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_EVFL_020314 );			
		K7SCR_RETSYS();
		//[VX^[g
		gpSound->mPlaySE( SFX_SCE2_KAKIWARI );
		PlayMotion(EV_MOT_KAKIWARI,0.0f);
		
		//{̃[V
		WK7JObj *pJObj=NULL;
		if( (pJObj = PlayMotion( "firstlife_bldg", EV_MOT_KAKIWARI)) != NULL ){
			pJObj->SetMotionLoop( false );
		}		
		//J[VĐ
		WK7CAM->SetMode( WK7Cam::WK7CAM_FREE_TARGET );
		WK7CAM->AttachMotion( pCamMot );
		WK7CAM->PlayMotion();
		WK7CAM->SetMotionLoop( false );

		
//		while( GetMotionState()!=WK7MODEL_NOANIM )
		{
			K7SCR_RETSYS();
		}

		K7SCR_EVNO_SETENABLE( K7EVENTDOOR(020501), false );	//	WNV

		while( ( mpModel->GetObj( "FL_smoke" )->GetJObj()->flags & JOBJ_HIDDEN ) != 0 ){ K7SCR_RETSYS(); }
		
		{
			Vec Point ;
			GXColor Color ;
			
			mpModel->GetObj( "FL_smoke" )->GetWorldPosition( &Point ) ;

			Color.r = (u8)VParam[ED_SMOKE_DR2][10] ;
			Color.g = (u8)VParam[ED_SMOKE_DR2][11] ;
			Color.b = (u8)VParam[ED_SMOKE_DR2][12] ;
			CreateSmokeEffect( 1, Point, VParam[ED_SMOKE_DR2][0] * 10.0F,
								VParam[ED_SMOKE_DR2][1] * 0.01F, VParam[ED_SMOKE_DR2][2] * 0.01F,
								0.0F, VParam[ED_SMOKE_DR2][3],
								(Vec){0.0F,0.0F,0.0F}, 0.0F,
								PI * VParam[ED_SMOKE_DR2][4] * 0.1F / 180.0F, PI * VParam[ED_SMOKE_DR2][5] * 0.1F / 180.0F, 
								VParam[ED_SMOKE_DR2][6] * 10.0F, VParam[ED_SMOKE_DR2][7] * 10.0F,
								VParam[ED_SMOKE_DR2][6] * 10.0F, VParam[ED_SMOKE_DR2][7] * 10.0F,
								VParam[ED_SMOKE_DR2][8], VParam[ED_SMOKE_DR2][9], VParam[ED_SMOKE_DR2][17] * 1.0F,
								Color, Color, Color, (u8)VParam[ED_SMOKE_DR2][13],
								PI * VParam[ED_SMOKE_DR2][18] / 180.0F, 0.0F, FALSE, (u8)VParam[ED_SMOKE_DR2][14], 
								VParam[ED_SMOKE_DR2][15] * 0.01F, FALSE, 0,
								Color, Color, Color,
								VParam[ED_SMOKE_DR2][16] * 10.0F ) ;
		}

		// ʂh炷
		CreateImpactEffect( 80, 0, (Vec){0.0F, 1.0F, 0.0F}, 20, 0, TRUE ) ;
		
		while( GetMotionState()!=WK7MODEL_NOANIM ){ K7SCR_RETSYS(); }
		


		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
//		K7SCR_PC_SETVISIBLE( true );
		break;
	}	
	return true;
}
