////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage20M00
//
// K7Stage211M00.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/16/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE211M00_CPP__

#include ".\K7Stage211M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn02.h"
#include "..\..\..\Sato\SK7PanelBase.h"
#include "..\..\..\Sato\SK7SpecialData.h"


//`````````````````````````````````````````````````
//			RXgN^
//`````````````````````````````````````````````````
K7Stage211M00::K7Stage211M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage211M00_Camera );
}


//`````````````````````````````````````````````````
//			fXgN^
//`````````````````````````````````````````````````
K7Stage211M00::~K7Stage211M00()
{
}

//`````````````````````````````````````````````````
//			NGCg
//`````````````````````````````````````````````````
bool K7Stage211M00::CreateCallBack(void)
{
	CreateOwnStageMotion( 0 );

	return true;
}

//`````````````````````````````````````````````````
//		iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//`````````````````````````````````````````````````
bool	K7Stage211M00::InitializeCallBack( void )
{
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_021100 )==true ){
		K7SCR_EVNO_SETENABLE( K7EVENTNO(021101), false );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(021102), true );
		//	[VŏIt[	
		PlayMotion(0,-1.0f);
		SetMotionLoop(false);
	}else{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(021101), true );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(021102), false );
	}
	//	svcȑ`擾Ă	-------------------------------
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_GETKEY ) ){
		//WNV
		K7SCR_EVNO_SETENABLE( K7EVENTNO(021101), false );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(021102), false );

		//	擾ACe
		WK7JObj	*pJObj;
		if( (pJObj = GetJObj("item08")) != NULL ){
			pJObj->Hide( false, true );
		}
		//	[VŏIt[	
		PlayMotion(0,-1.0f);
		SetMotionLoop(false);
	}
	return true;
}


//`````````````````````````````````````````````````
//			Cxg
//`````````````````````````````````````````````````
bool K7Stage211M00::EventCallBack(WK7EventInfo &info)
{
	WK7JObj	*pJObj;
	switch( info.mEventNo ){

//		`擾Cxg		
	case	K7EVENTNO(021101):
		//	̎w֑	-------------------------------------
		if( K7SCR_EVEQUIPRING(RING_WATER) ){
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
//			K7SCR_PC_SETVISIBLE( false );
			//bZ[WtJݒ
			FixCam( EV_CAM_WATER );
			K7SCR_STGC_MESSAGE_B( MES_K7STG211_W_YUBIWA );
			gpSound->mPlaySE( SFX_SCE2_WATER_FULL );		
			//[VX^[g
			PlayMotion(0,0.0f);
			SetMotionLoop(false);
			while( GetMotionState()!=WK7MODEL_NOANIM ){
				K7SCR_RETSYS();
			}
			//J߂
			WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
			K7SCR_RETSYS();
			//mCY
//			K7SCR_NOISE_REQUEST();
			K7SCR_SET_SCENARIO_FLAG( K7SCN02_EVFL_021100 );
			//WNV
			K7SCR_EVNO_SETENABLE( K7EVENTNO(021101), false );
			K7SCR_EVNO_SETENABLE( K7EVENTNO(021102), true );
			//mCYEFCg
//			K7SCR_TIMEWAIT(4800);
//			K7SCR_PC_SETVISIBLE( true );
			//mCY
//			K7SCR_NOISE_RELEASE();
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}else{
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );

			//bZ[WtJݒ
			FixCam( EV_CAM_WATER );

			gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );		//䉹
			//	bZ[W
			K7SCR_STGC_MESSAGE_B( MES_K7STG211_SOKO );

			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
		}
		break;
		
	case 	K7EVENTNO(021102):
		//inGame~
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		//bZ[WtJݒ
//		FixCam( EV_CAM_WATER );
		//	擾ACe
		if( (pJObj = GetJObj("item08")) != NULL ){
			pJObj->Hide( false, true );
		}
		//J߂
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		//ACe擾ʂ\
		K7SCR_STG_ITEMGET_B( MES_K7STG211_0 );
		//mCY
//		K7SCR_NOISE_REQUEST();
		//擾
		K7SCR_EVSETITEM( K7EVITEM_KEY(020101), true );
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_DRFL_GETKEY );
		//WNV
		K7SCR_EVNO_SETENABLE( K7EVENTNO(021102), false );
		//mCYEFCg
//		K7SCR_TIMEWAIT(4800);
		//mCY
//		K7SCR_NOISE_RELEASE();
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	default:
		return true;
	}
	return false;
}

//`````````````````````````````````````````````````
//			G񂾂Ƃ̃EC_RC擾Cxg
//`````````````````````````````````````````````````
bool K7Stage211M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
	WK7Npc *pNpc = info.mpNpc;
	
	//	EC_r
	switch( pNpc->GetEneNo() ){
	case ENENO_2_211M00_1:		// 210iԕr̕jiEC_j
	case ENENO_2_211M00_2:		// 210iԕr̕jiEC_j
	case ENENO_2_211M00_3:		// 210iԕr̕jiEC_j
	case ENENO_2_211M00_4:		// 210iԕr̕jiEC_j

		K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL)++;		//_Qbg
//		gpSound->mPlaySE( SFX_SCE2_ULMAYDA_MEDAL_GET );
		if( K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) > K7SCN02_ULMEDAL_MAX ){
			K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) = K7SCN02_ULMEDAL_MAX;
		}
		break;
	}
	return true;
}