////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage300M00
//
// K7Stage300M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE300M00_H__
#define	__K7STAGE300M00_H__

#include "..\K7Stage.h"

#define K7STAGE300_BALLOON_MAX	(6)

class K7Stage300M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage300M00();
	K7Stage300M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
//	WK7RenderObjEffect* pStageEfc;
	WK7RenderObjEffect* pBalloon[K7STAGE300_BALLOON_MAX];
	void BalloonPlay(void);
	void BalloonStop(void);
public:
	virtual ~K7Stage300M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool BpLeaveCallBack(WK7BpInfo &info);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	
};

#ifdef __K7STAGE300M00_CPP__

#define BALLOON_MAX_Y		(240.f)

Vec BalloonPos[K7STAGE300_BALLOON_MAX] = {
	{-156.820f, 13.754f, -145.189f},
	{-50.189f, 9.826f, -201.971f},
	{48.031f, 28.954f, -206.953f},
	{155.902f, 9.535f, -156.903f},
	{219.181f, 32.190f, -59.603f},
	{-205.521f, 2.299f, -45.653f}
};

enum K7STAGE300M00_ONESHOTCAM{
	ONESHOTCAM_030001_0,
	ONESHOTCAM_030001,
};


K7StageEventOneShotCamera K7Stage300M00_Camera[] = {
	{{-33.425f, 31.400f, 252.523f},{-22.672f, 29.396f, 273.101f}},				// ĎJ
	{{-8.265f, 13.441f, 269.485f},{-23.619f, 30.395f, 265.023f}},				// ĎJ
};

#endif

#endif	//__K7STAGE300M00_H__

