////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage309M00
//
// K7Stage309M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE309M00_H__
#define	__K7STAGE309M00_H__

#include "..\K7Stage.h"

class K7Stage309M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage309M00();
	K7Stage309M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	WK7RenderObjEffect	*mpFireEffect;
	WK7RenderObjEffect  *mpWater;	//XvN[
	void DoorOpen(void);
	void BridgeFireStart(void);
	void BridgeFireEnd(void);
	void GoOutFireplaceEffectByWater(void);
	int GoriraLastOneTest(void);
	u8 mSoundChange;
public:
	virtual ~K7Stage309M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj

};

#ifdef __K7STAGE309M00_CPP__

#define ONI_MATO	6
static char *pHitName[ONI_MATO]={
	"event_030521",
	"event_030522",
	"event_030523",
	"event_030524",
	"event_030525",
	"event_030526",
};

enum K7STAGE309M00_ONESHOTCAM{
	EV_030521,
	EV_030522,
	EV_030523,
	EV_030524,
	EV_030525,
	EV_030526,
	DR_030503,
	ONESHOTCAM_30503,
	EV_030518,
	EV_030519
};


K7StageEventOneShotCamera K7Stage309M00_Camera[] = {
	{{-2181.008f, 13.298f, -1666.064f},{-2211.774f, 12.410f, -1666.504f}},		// S̓I E
	{{-2187.307f, 13.298f, -1715.042f},{-2218.075f, 12.434f, -1714.690f}},		// S̓I ^
	{{-2179.203f, 13.298f, -1760.513f},{-2209.971f, 12.433f, -1760.160f}},		// S̓I 
	{{-2806.442f, 13.298f, -1760.500f},{-2837.210f, 12.432f, -1760.147f}},		// S̓I O
	{{-2813.570f, 13.298f, -1714.940f},{-2844.338f, 12.432f, -1714.587f}},		// S̓I O^
	{{-2803.992f, 13.298f, -1666.647f},{-2834.760f, 12.432f, -1666.294f}},		// S̓I OE
	{{-2998.637f, 8.876f, -1687.038f},{-2986.100f, 4.826f, -1703.640f}},		// S̊炪J
	{{-2570.357f, 2.705f, -1869.677f},{-2520.251f, 28.900f, -1873.343f}},		// RĂ鋴AȂȂp
	{{-2387.465f, 15.777f, -1877.631f},{-2443.546f, 8.479f, -1881.673f}},		// ΋ ̃{[h
	{{-3009.725f, 34.655f, -1865.625f},{-3009.987f, 49.380f, -1852.191f}},		// SSQ[̃{[h
};

#endif

#endif	//__K7STAGE309M00_H__

