////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage310M00
//
// K7Stage310M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 05/27/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE310M00_H__
#define	__K7STAGE310M00_H__

#include "..\K7Stage.h"

class K7Stage310M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	WK7Chara			*mpLargeAngel;
	WK7Model			*mpLargeAngelModel;
	WK7ModelMotion		*mpLargeAngelMotion;
	C_SetAlpha			*mpSetAlpha;
	WK7AnimLinearF		mAlpha;
	
	K7Stage310M00();
	K7Stage310M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage310M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &){ return true; }		// qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj

};

#ifdef __K7STAGE310M00_CPP__


enum K7STAGE310M00_ONESHOTCAM{
	LARGE_ANGEL0,
	LARGE_ANGEL1,
	CAM310M00HSINIT,
	CAM310M00HSTERM,
};

K7StageEventOneShotCamera K7Stage310M00_Camera[] = {
	{{-2925.681f, 11.268f, -2015.409f},{-2925.838f, 9.766f, -1990.560f}},
//	{{-2923.187f, 18.059f, -2065.523f},{-2927.838f, 0.499f, -2012.712f}},
	{{-2918.844f, 11.375f, -2156.965f},{-2918.740f, 11.119f, -2153.471f}},
//	{{-2915.844f, 19.804f, -2181.411f},{-2920.494f, 2.245f, -2128.600f}},
	{{-2919.060f, 8.318f, -1929.981f},{-2918.390f, 3.801f, -1874.112f}},
	{{-2921.147f, 18.377f, -2028.787f},{-2920.477f, 13.860f, -1972.918f}}
};

enum{
	K7STAGE310M00_MES_GETGUN = 0		,		// _̏eɓꂽ
};

#endif

#endif	//__K7STAGE310M00_H__

