////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage325M03 i04j X[W[o
//
// K7Stage325M03.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE325M03_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage325M03.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectLight.h"

//bZ[W
#define	MES325M03_00	(0)							// J䉹
#define MES325M03_01	(1)							// ߋ̎wւ߂

//[V
#define	MOT325M03_OPEN	(0)							// 󔠊J
#define	MOT325M03_CLOSE	(1)							// 󔠂܂

// f
#define	MDL325M03_RING			"Ring"				//O
#define	MDL325M03_TOREASURE		"Treasure_box"		//
#define	MDL325M03_KEYOPEN		"cyo_padlock_off"	//AJ
#define	MDL325M03_KEYLOCK		"cyo_padlock_on"	//A܂Ă


#define	MDL325M03_CYO_PICKING_POS		"CYO_picking"		//R[eJW


K7Stage325M03::K7Stage325M03(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage325M03_Camera );
	mPlayBgm = HPS_ISZK_D4;
}

K7Stage325M03::~K7Stage325M03()
{
}


/*
	
	NGCg
	
*/
bool K7Stage325M03::CreateCallBack(void)
{
	// J[V
	CreateOwnStageMotion(MOT325M03_OPEN);
	CreateOwnStageMotion(MOT325M03_CLOSE);
	return true;
}


/*
	
	
	
*/
bool K7Stage325M03::InitializeCallBack(void)
{
	
	if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030408)==TRUE){
		K7SCR_EVNO_SETENABLE(K7EVENTNO(30408), false);				// ̃Cxg֎~
	}
	return true;
}



/*
	
	Jg
	
	
*/
bool K7Stage325M03::SetCurrentCallBack(void)
{
	Vec pcPos;
	
	SetCurrentCallBackDefaultProc();
	
	while( K7SCR_STG_GET_CURRENTID() == K7STGID(325,3) ){
		if ( GameInfo.GetMode() == WK7GameInfo::MOVE ){					// L`F̎ȂǋȂωȂ悤ɑΏ
			WK7PLAYERCONTROL->GetPosition(pcPos);
			if ( pcPos.z < -1290.f ){
				if ( mPlayBgm != HPS_ISZK_D4 ) {
					gpSound->mPlayStreamNo((int )HPS_ISZK_D4);			// Ȗ炵Ȃ
					mPlayBgm = HPS_ISZK_D4;
				}
			}else{
				if ( mPlayBgm != HPS_KRAKUJITU_C ) {
					gpSound->mPlayStreamNo((int )HPS_KRAKUJITU_C);		// Ȗ炵Ȃ
					mPlayBgm = HPS_KRAKUJITU_C;
				}
			}
		}
		K7SCR_RETSYS();
	}
	return true;
}



/*
	
	I
	
	
*/
bool K7Stage325M03::TerminateCallBack(void)
{
	return true;
}

bool K7Stage325M03::CondChangeCallBack(void)
{
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030408) == true ){			// 󔠉
		SimpleModelDisp( MDL325M03_KEYOPEN );
		SimpleModelHide( MDL325M03_KEYLOCK );
	}else{
		SimpleModelDisp( MDL325M03_KEYLOCK );
		SimpleModelHide( MDL325M03_KEYOPEN );
	}
	return true;
}


/*
	
	Cxg
	
*/
bool K7Stage325M03::EventCallBack(WK7EventInfo &info)
{
	WK7JObj		*pJObj=NULL;
	WK7ZanEventInfo zanEventInfo;

	switch( info.mEventNo ){
	case	K7EVENTNO(030408):			// 
		if (K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030408)==FALSE){
			
			if( WK7PLAYERCONTROL->GetMainID() == K7CYO )
			{
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				WK7Npc::NpcVisibleAll(false);
				SimpleCyoPicking( MDL325M03_CYO_PICKING_POS, ONESHOTCAM_PICK, PICKING_325M01 );
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_SET_SCENARIO_FLAG( K7SCN03_EVFL_030408 );
				K7SCR_EVCONDCHANGE();
				K7SCR_PC_SETVISIBLE( false );
				FixCam( ONESHOTCAM_KEYUP );
				K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
//				info.mCinemaScopeClear = true;
				K7SCR_PC_SETVISIBLE( true );
				
				// 󔠊J
				// Jς
				WK7CAM->SetCinemaScopeMode(true);								// VlXRON
				FixCam(ONESHOTCAM_SUSIE);
				K7SCR_PC_SETVISIBLE( true );
				
				gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
				
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
				
				gpSound->mPlaySE(SFX_SCE3_TREASURE_BOX_OPEN);
				TreasureBoxMotionPlay(MOT325M03_OPEN);
				
				K7SCR_EVNO_SETENABLE(K7EVENTNO(30408), false);				// ̃Cxg֎~
				
				// Wait
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
				
				// X[Wo
				//cvOƉb
				zanEventInfo.Initialize();
				zanEventInfo.mEventNo = K7EVENTZAN( 030030 );
				zanEventInfo.mpStage  = this;
				GameInfo.SetZanMesID( 0 );
				GameInfo.SetZanTermWait( true );
				GameInfo.SetZanNoiseCancel( true );
				GameInfo.SetZanCharaLoadCancel( true );
				CallZanEventCallBackTask( zanEventInfo );
				while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT )
				{
				K7SCR_RETSYS();				// X[W[b
				}
				GameInfo.SetZanTermWait( false );
				GameInfo.SetZanManual( true );
				GameInfo.SetZanNoiseCancel( true );
				GameInfo.SetZanCinemaScopeCancel( true );
				
				K7SCR_PC_SETVISIBLE( false );
				
				while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY )
				{
					K7SCR_RETSYS();
				}
				gpSound->mStopStream();
				
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
				
				// tF[hAEg
				// ߋ̎w֎擾
				K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_PAST );
				K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_030302_YUBIWA);
				
				//wւ̃f\
				if( (pJObj=GetJObj(MDL325M03_RING)) != NULL )
				{
					K7SCR_JOBJ_HIDE(pJObj);
				}
				{
					bool	SetOperateEnableSave;
					bool	NpcPauseAllSave;
					WK7RenderObjEffect	*pRenderObjEffect;
					
					// wփQbg
					while( (pRenderObjEffect = CreateItemGet(MES325M03_01, true, -1, SFX_SCE3_SUSIE_GEROGERO))==NULL ){
						retsys();
					}
					
					SetOperateEnableSave = WK7PLAYERCONTROL->GetOperateEnable();
					NpcPauseAllSave = WK7Npc::GetNpcPauseAll();
					
					WK7PLAYERCONTROL->SetOperateEnable(false);
					WK7Npc::NpcPauseAll();
					
					while( IsValidEffect(pRenderObjEffect)==true ){
						retsys();
					}
					
					WK7PLAYERCONTROL->SetOperateEnable(SetOperateEnableSave);
					if ( NpcPauseAllSave == false ){
						WK7Npc::NpcResetPauseAll();
					}
					
				}
				
				//tO𗎂Ƃ
				K7SCR_EVSETITEM( K7EVENTZAN(0300300), false );
				//cvOƉb
				zanEventInfo.Initialize();
				zanEventInfo.mEventNo = K7EVENTZAN( 030030 );
				zanEventInfo.mpStage  = this;
				GameInfo.SetZanMesID( 1 );
				GameInfo.SetZanTermWait( true );
				GameInfo.SetZanNoiseCancel( true );
				GameInfo.SetZanCharaLoadCancel( true );
				CallZanEventCallBackTask( zanEventInfo );
				while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT )
				{
				K7SCR_RETSYS();				// X[W[b
				}
				GameInfo.SetZanTermWait( false );
				GameInfo.SetZanManual( false );
				GameInfo.SetZanNoiseCancel( true );
				GameInfo.SetZanCinemaScopeCancel( true );
				
				// Jςi󔠕߂JɂĂ
				FixCam( ONESHOTCAM_SUSIE );
				while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY )
				{
					K7SCR_RETSYS();
				}
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				
				// 󔠕܂
				gpSound->mPlaySE(SFX_SCE3_TREASURE_BOX_CLOSE);
				TreasureBoxMotionPlay(MOT325M03_CLOSE);
				
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3));
				
				K7SCR_EVCONDCHANGE();
				
				K7SCR_PC_SETVISIBLE( true );
				
				K7SCR_RETSYS();
				
				WK7CAM->SetCinemaScopeMode( false );										// VlXROFF
				WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
				WK7CAM->FrameProcess();
				WK7CAM->SetCurrent();
				
				gpSound->mPlayStreamNo( HPS_KRAKUJITU_C );
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				
				WK7Npc::NpcVisibleAll(true);
				
				K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_030408_HS_DISP);			// G|bvp
				
				return false;
			}else{
				FixCamMesWithRiddle( ONESHOTCAM_PICK, MES325M03_00 );
				return( false );
			}
		}
		break;
	}
	return true;
}


void K7Stage325M03::TreasureBoxMotionPlay(int motno)
{
	WK7JObj 		*pJObj;
	
	if( (pJObj=PlayMotion(MDL325M03_TOREASURE, motno))!=NULL ){
		pJObj->SetMotionLoop(false);
		while( pJObj->GetMotionState(false, true) != WK7MODEL_NOANIM )
		{
			K7SCR_RETSYS();
		}
	}
	
}
