////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage354M00 J[eBX̉Ɓ@
//
// K7Stage354M00.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE354M00_H__
#define	__K7STAGE354M00_H__

#include "..\K7Stage.h"

class K7Stage354M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage354M00();
	K7Stage354M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	WK7RenderObjEffect*	mFire;			//GtFNg
//	WK7RenderObjEffect*	mWater;			//XvN[
	WK7RenderObjEffect*	mpWindEffect1;	//1
	WK7RenderObjEffect*	mpWindEffect2;	//2
	WK7ModelMotion*		mpCatMotion;	//Lbg[V
	
	void	PlayFireplaceSE( void );				//gF̌ʉ炷
	void	DispFireplaceEffect( void );			//gFGtFNg\
	void	StopFireplaceEffect( void );			//gFGtFNg~߂
	void	StartFireplaceEffect( void );			//gF̉΂_
	void	GoOutFireplaceEffect( void );			//gF̉΂
	void	GoOutFireplaceEffectByWater( void );	//gF̉΂(̎w)
	void	PoolLightOn( void );					//v[邭Ȃ
	void	PoolLightOff( void );					//v[ÂȂ
//	void	PoolLightAnm( bool inLight, u32 inCamID, WK7JObj* inPJObj );
//	void	SetPoolLight( bool inLight );			//v[̃Cgݒ
	void	CyoJumpLand( void );					//R[ẽWv`n
	
public:
	virtual ~K7Stage354M00();
	
	virtual bool CreateCallBack    (void);									// iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
	virtual bool InitializeCallBack(void);									// iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
	virtual bool CondChangeCallBack(void);									// ԕύXitOɂԕύX邽߂ɗpj
	virtual bool CharaChangeCallBack(WK7CharaChangeInfo &);					// L`FW
	virtual bool TerminateCallBack (void);									// Iȉj
	virtual bool SetCurrentCallBack(void);									// JgXe[Wɐݒ莞
	virtual bool EventCallBack     (WK7EventInfo     &);					// Cxg
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);					// hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);					// _o
//	virtual bool BpArriveCallBack  (WK7BpInfo        &);					// _
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);					// qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj
	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);					// XyV\͎gp
	virtual bool ZanEventCallBack  (WK7ZanEventInfo &info);					// cvOCxg
};

#ifdef __K7STAGE354M00_CPP__


enum K7STAGE354M00_ONESHOTCAM{
	CAM354M00FIREPLACE,			//gF
	CAM354M00POOL,				//v[
	CAM354M00JUMPBOTTOM,		//WvEgF
	CAM354M00JUMPUPPER,			//WvEgF
	CAM354M00_LOCKDOOR,			//v[ւ̔
	CAM354M00_DUSTCHUTE,		//_XgV[g
	CAM354M00_POOL_LIGHT4,		//v[̃Cg4
	CAM354M00_POOL_LIGHT5,		//v[̃Cg5
	CAM354M00_POOL_LIGHT6,		//v[̃Cg6
	CAM354M00_DUSTCHUTE_OUT,	//_XgV[g
	CAM354M00_POOL_INIT,		//v[J
	CAM354M00_POOL_TERM,		//v[IJ
	CAM354M00_MSK_WALL,			//}XNǔj
};

K7StageEventOneShotCamera K7Stage354M00_Camera[] = {
	{{-154.977f, 34.179f, -1135.203f},{-174.824f, 37.137f, -1144.265f}},	//gF
	{{-472.899f, 20.882f, -1216.082f},{-482.380f, 19.173f, -1223.236f}},	//v[
	{{-149.957f, 30.294f, -1127.727f},{-159.045f, 26.723f, -1125.568f}},	//WvEgF
	{{-126.326f, 100.976f, -1136.606f},{-123.646f, 110.555f, -1137.640f}},	//WvEgF
	{{-532.437f, 32.993f, -1408.157f},{-541.851f, 26.585f, -1391.292f}},	//v[ւ̔
	{{-118.063f, 34.804f, -1393.941f},{-140.492f, 30.542f, -1382.935f}},	//_XgV[g
	{{-266.978f, 32.301f, -1181.759f},{-274.124f, 25.061f, -1188.124f}},	//v[̃Cg4
	{{-265.368f, 35.655f, -1101.952f},{-272.404f, 28.461f, -1108.490f}},	//v[̃Cg5
	{{-259.515f, 40.201f, -1013.624f},{-266.473f, 33.006f, -1020.244f}},	//v[̃Cg6
	{{-163.276f, 33.034f, -1412.509f},{-163.130f, 32.131f, -1420.959f}},	//_XgV[go
	{{-472.899f, 20.882f, -1216.082f},{-482.380f, 19.173f, -1223.236f}},	//v[J
	{{-491.247f, 21.814f, -1200.796f},{-500.119f, 18.377f, -1208.108f}},	//v[IJ
	{{-171.740f, 34.399f, -1203.559f},{-165.599f, 31.046f, -1188.066f}},	//}XNǔj
};

#endif

#endif	//__K7STAGE354M00_H__

