////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage355M00 J[eBX̉Ɓ@ʘH
//
// K7Stage355M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE355M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage355M00.h"
#include "..\..\..\Kaw\KK7Sound.h"

//bZ[W
#define	MES355M00_00	(0)		//ZR̃bNĂ܂
#define	MES355M00_01	(1)		//v[ւ̔܂Ă
//f
#define	MDL355M00_DOOR_POOL			"pool_door"
//[V
#define	MOT355M00_DOOR_POOL_OPEN	(0)				//v[ւ̔J





//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage355M00::K7Stage355M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage355M00_Camera );
	//v[ւ̔͏ɊJĂ
	K7SCR_SET_SCENARIO_FLAG( DR035103 );
	mAmbPlaySE = false;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage355M00::~K7Stage355M00()
{
}

//------------------------------------------------------------------------------
// iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//------------------------------------------------------------------------------
bool
K7Stage355M00::InitializeCallBack( void )
{
	//361M00̑LԂJCxgĂяoĂꍇ͕Ԃ
	if( K7SCR_GET_SCENARIO_FLAG(EV0361_OPEN_DOOR) == true )
	{
		return( true );
	}
	
	HereComeANewHSInit( PR_HS_PROT_ZZ, ENENO_3_355M00_4 );
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage355M00::SetCurrentCallBack( void )
{
	//361M00̑LԂJCxgĂяoĂꍇ͕Ԃ
	if( K7SCR_GET_SCENARIO_FLAG(EV0361_OPEN_DOOR) == true )
	{
		return( true );
	}
	
	//V^HSЉ
	if( false == HereComeANewHS(	PR_HS_PROT_ZZ,
									ENENO_3_355M00_4,								// GID
									NULL,
									CAM355M00_HS_PRESEN_START,
									CAM355M00_HS_PRESEN_END,
									0,
									138,  271, -31,  96,1053, 158 )				// OЉp
	){
		SetManualBranch(false);
//		return false;
	}
	
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){-160.186f, 41.072f, -1513.748f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE3_AMB_MUSHI1 );
		KK7SoundLoopSePlayVolumeChange((Vec){-244.838f, 44.781f, -1808.162f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE3_AMB_MUSHI1 );
		KK7SoundLoopSePlayVolumeChange((Vec){5.084f, 147.059f, -2551.625f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE3_AMB_MUSHI1 );
		mAmbPlaySE = true;
	}
	
	return( true );
}


//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage355M00::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT355M00_DOOR_POOL_OPEN );
	
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage355M00::CondChangeCallBack( void )
{
	//gF̉΂Ă邩mF
	if( K7SCR_GET_SCENARIO_FLAG(EV035008) == FALSE )
	{
		//gF̉΂_Ă
		SimpleModelDisp( "on1" );
		SimpleModelHide( "off1" );
	}else
	{
		//gF̉΂Ă
		SimpleModelHide( "on1" );
		SimpleModelDisp( "off1" );
	}
	
	//LԂւ̔JĂZT[͕\Ȃ
	if( K7SCR_GET_SCENARIO_FLAG(DR035102) == true )
	{
		SimpleModelHide( "laser" );
	}else
	{
		SimpleModelDisp( "laser" );
	}
	
	//v[ւ̔
	if( K7SCR_GET_SCENARIO_FLAG(DR035103) == false )
	{
		SimpleSetStartMotion( MDL355M00_DOOR_POOL, MOT355M00_DOOR_POOL_OPEN );
	}else
	{
		SimpleSetLastMotion( MDL355M00_DOOR_POOL, MOT355M00_DOOR_POOL_OPEN );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage355M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//v[ւ̔
		case	K7EVENTDOOR( 035103 ):
			if( K7SCR_GET_SCENARIO_FLAG(DR035103) == false )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				//JŒ胁bZ[W
				FixCamMes( CAM355M00_DOORPOOL, MES355M00_01 );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				return( false );
			}else
			{
				//AJl̃plŃCg_H
				if( K7SCR_GET_SCENARIO_FLAG(EV0361POOL_LIGHT_ON) == false )
				{	//΂Ă
					info.mNextStageID = K7STGID( 362, 1 );
					strcpy( info.mNextBpName, "branchA" );
				}else
				{	//΂_Ă
					info.mNextStageID = K7STGID( 362, 0 );
				}
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage355M00::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	evno   = GetBpEventNo( info );
	int	pathNo = GetBpPathNo( info );
	if( evno==0xffffffff )
		return( true );
	
	//LԂ̔JĂȂ΃ZT[쓮
	if( K7SCR_GET_SCENARIO_FLAG(DR035102) == false )
	{
		switch( evno )
		{
			//ZT[
			case	K7EVENTNO( 035011 ):
				if( K7SCR_GET_SCENARIO_FLAG(EV035012) == FALSE )
				{
					//PrœłȂ΃ZȒ֎~ɂ
					if( WK7PLAYERCONTROL->SpAtkKvnTest() == false )
					{
						//L|[Y
						K7SCR_ENTER_PLAYMODE_B();
						K7SCR_ENTER_DEMOPAUSE();
						//ZȒsɂ
						K7SCR_SET_SCENARIO_FLAG( EV035012 );
						gpSound->mPlaySE( SFX_SCE3_CUR_ALARM );
						gpSound->mPlaySE( SFX_SCE3_SECURITY_ACTIVATED );
						K7SCR_STGC_MESSAGE_B( MES355M00_00 );
						//L|[Y
						K7SCR_EXIT_PLAYMODE();
						K7SCR_EXIT_DEMOPAUSE();
					}
				}
				break;
			
			//ftHg
			default:
				break;
		}
	}
	
	return( true );
}
