////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage411M00 yh~jJzOL
//
// K7Stage411M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE411M00_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage411M00.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectScreen.h"
#include "..\..\..\Yam\YK7EffectSmoke.h"
#include "..\..\..\Yam\YK7EffectImpact.h"

//VK[
#define	MDL411M00_SNG_CHRID		K7CHRID(K7SNG,0)
#define	MOT411M00_SNG_STANDBY	K7MOTID(K7SNG,20)

//bZ[W
#define	MES411M00_SHORTCUT_DOOR	(0)		//炩͒ʂȂ
#define	MES411M00_NEED_MSK		(1)		//vXZŒʂꂻ
//pX
#define	PAT411M00_BARREL_INNER	"event_040102_msk"	//M̉֐iރpX
#define	PAT411M00_BARREL_RIDDLE	"event_040106_0"	//M̓J̃pX
//f
#define	MDL411M00_BARREL		"event_040102"		//M
//[V
#define	MOT411M00_BARREL_BREAK	(0)					//M
#define	MOT411M00_MSK_PWRBM		K7MOTID(K7MSK,530)	//}XÑp[{


const u16 __SmokeParam[20] = 
{	101,		3,		2,		274,		50,
	20,		60,		50,		90,		70,

	191,	175,	150,		255,		5,
	30,		30,		10,		79,		0 } ;


//------------------------------------------------------------------------------
//VK[̃R[obN
//------------------------------------------------------------------------------
#define	SINGER_LOOP_TIMES	(1-1)
static	LOOPSE*	gpSingerSE         = NULL;
static	f32		gSingerOldMotFrame = 999.999f;
static	u8		gSingerLoop        = SINGER_LOOP_TIMES;
static	bool	gSingerTerm        = true;
static	bool	SingerCallBack( WK7JObj* pJObj, void* pData );
static	bool	SingerCallBack( WK7JObj* pJObj, void* pData )
{
#pragma unused(pData)
	f32 motFrame = pJObj->GetCurrentMotionFrame( false, true );
	if( gSingerOldMotFrame > motFrame )
	{
		//̓[v
		if( (gSingerTerm == false) && (gSingerLoop < SINGER_LOOP_TIMES) )
		{
			gSingerLoop++;
		}else
		{
			if( gpSingerSE == NULL )
			{
				gpSingerSE = KK7SoundLoopSePlayVolumeChange((Vec){-103.3353f,0.0f,-278.7338f}, K7STGID(411,0), SFX_SCE4_SINGER_STAGE );
				if( gpSingerSE != NULL )
				{
					gSingerTerm = false;
				}
			}else
			{
				//^XNI
				gpSingerSE->taskEnd = -1;
				gpSingerSE = NULL;
				//^XNItOON
				gSingerTerm = true;
			}
			gSingerLoop = 0;
		}
	}
	
	if( gSingerTerm == false )
	{
		gSingerOldMotFrame = motFrame;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage411M00::K7Stage411M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage411M00_Camera );
	mpSng              = NULL;
	mpSngModel         = NULL;
	mpSngMotionStandby = NULL;
	mpEffectLensFlare  = NULL;
	mPlayAmbSE         = false;
	Smoke = NULL ;
	Impact = NULL ;
	Screen = NULL ;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage411M00::~K7Stage411M00()
{
	gpSingerSE         = NULL;
	gSingerOldMotFrame = 999.999f;
	gSingerLoop        = SINGER_LOOP_TIMES;
	gSingerTerm        = true;
	ReleaseEffectLensFlare();
	if( CheckEffectValidState( Impact, ImpactID ) == TRUE ) DeleteEffect( Impact ) ;
	if( CheckEffectValidState( Screen, ScreenID ) == TRUE ) DeleteEffect( Screen ) ;
	if( CheckEffectValidState( Smoke, SmokeID ) == TRUE ) DeleteEffect( Smoke ) ;
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage411M00::CreateCallBack( void )
{
	CreateOwnStageMotion( MOT411M00_BARREL_BREAK );
	WK7RenderObj::CreateOwnMotionObj( K7MOT_ATTR|K7OBJTYPE_CHR, MOT411M00_MSK_PWRBM );
	
	mpSng = CreateOwnChara( MDL411M00_SNG_CHRID );
	WK7RenderObj::CreateOwnMotionObj( K7MOT_ATTR|K7OBJTYPE_CHR, MOT411M00_SNG_STANDBY );
	
	return( true );
}

//------------------------------------------------------------------------------
//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//------------------------------------------------------------------------------
bool
K7Stage411M00::InitializeCallBack( void )
{
	WK7JObj*	pJObj;
	Vec			loc;
	f32			rot;
	
	mpMskMotion = GetOwnModelMotion( K7MOT_ATTR|K7OBJTYPE_CHR, MOT411M00_MSK_PWRBM );
	
	mpSng              = GetOwnChara( MDL411M00_SNG_CHRID );
	mpSngModel         = GetOwnModel( K7OBJTYPE_CHR, MDL411M00_SNG_CHRID );
	mpSngMotionStandby = GetOwnModelMotion( K7MOT_ATTR|K7OBJTYPE_CHR, MOT411M00_SNG_STANDBY );
	
	//֎qW擾
	if( (pJObj=GetJObj("sng_pos")) != NULL )
	{
		pJObj->GetWorldPosition( loc );
		rot = pJObj->GetRotY();
	}else
	{
		loc.x = loc.y = loc.z = rot = 0.0f;
	}
	//[VĐ&fݒu
	if( (mpSngModel != NULL) && (mpSngMotionStandby != NULL) )
	{
		mpSngModel->AttachMotion( mpSngMotionStandby );
		mpSngModel->PlayMotion();
		mpSngModel->SetMotionLoop( true );
		mpSngModel->SetPosition( loc );
		mpSngModel->SetRotY( rot );
		mpSng->SetRenderFlag( true );
	}
	
//	pJObj = mpSngModel->GetTopObj();
//	pJObj->SetPostFrameProcessCallBack( SingerCallBack );
	
	// YtA
	SetupEffectLensFlare();
	
	while( CheckSetupEffectLensFlare()==false ){
		K7SCR_RETSYS() ;
	}
	mpEffectLensFlare = CreateEffectLensFlare("sun_alpha");
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage411M00::CondChangeCallBack( void )
{
	//Mj󂵂
	if( K7SCR_GET_SCENARIO_FLAG(EV040102) == false )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040102), true );
		K7SCR_STG_SET_PATHENABLE( PAT411M00_BARREL_INNER, false );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PAT411M00_BARREL_RIDDLE, false );
		SimpleModelDisp( MDL411M00_BARREL );
		SimpleSetStartMotion( MDL411M00_BARREL, MOT411M00_BARREL_BREAK );
	}else
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040102), false );
		K7SCR_STG_SET_PATHENABLE( PAT411M00_BARREL_INNER, true );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PAT411M00_BARREL_RIDDLE, true );
		SimpleModelHide( MDL411M00_BARREL );
		SimpleSetLastMotion( MDL411M00_BARREL, MOT411M00_BARREL_BREAK );
	}
	//M̃pXJoff
	K7SCR_STG_SET_DISABLEPATHCAMERA( PAT411M00_BARREL_RIDDLE, true );
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage411M00::SetCurrentCallBack( void )
{
	if( (GetPrevStageID() == K7STGID(410,0)) && (K7SCR_GET_SCENARIO_FLAG(MV040002) == false) )
	{
		//_Ƀ`FW
		if( WK7PLAYERCONTROL->GetMainID() != K7DAN )
		{
			WK7StagePlaceInfo		*pPlaceInfo;
			
			SetManualBranch(true);
			while( WK7Stage::IsChanging()==true ){
				K7SCR_RETSYS();
			}
			
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			
			pPlaceInfo = GetPlaceInfo("curve5");
			SetCameraStartPosition(pPlaceInfo);
			while( SandRelease(pPlaceInfo)==false ){
				K7SCR_RETSYS();
			}
			SetCurrentCallBackDefaultProc();
			
			FixCam( CAM411M00_CAMERA );
			K7SCR_TIMEWAIT( 4800 * 2 );
			WatchCameraB( K7Stage411M00_Camera[CAM411M00_PC].tgt,
						  K7Stage411M00_Camera[CAM411M00_PC].pos,
						  K7CHRID(K7DAN,0), 1 );
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			//[r[ĐE_ƃVK[
			K7SCR_SET_SCENARIO_FLAG( MV040002 );
			K7SCR_NOISE_REQUEST();
			K7SCR_STG_VISIBLE( mID, false );
			K7SCR_STAGE_RELEASE();
			K7SCR_NOISE_RELEASE();
			//[r[ĐE_ƃVK[
			K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_04050101 );
			K7SCR_NOISE_REQUEST();
			K7SCR_STAGE_RESTORE();
			K7SCR_STG_VISIBLE( mID, true );
			//K7SCR_STG_SET_CURRENT_PATH( "position_dan", "curve6" );
			K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR( "position_dan", "curve6", 0.0f, WK7PATHINFO_INITDIR_TGTDIR_REV );
			WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
			K7SCR_NOISE_RELEASE();
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			SetManualBranch(false);
			//VK[SEĐ
			if( mPlayAmbSE == false )
			{
				mpSngModel->GetTopObj()->SetPostFrameProcessCallBack( SingerCallBack );
				mPlayAmbSE = true;
				TRACE( "after movie\n" );
			}
			return( false );
		}
	}
	
	//VK[SEĐ
	if( mPlayAmbSE == false )
	{
		mpSngModel->GetTopObj()->SetPostFrameProcessCallBack( SingerCallBack );
		mPlayAmbSE = true;
		TRACE( "after not play movie\n" );
	}
	
#if	0
	//_ɃL`FW
	if( K7SCR_GET_SCENARIO_FLAG(MV040002) == false )
	{
		//MOVE[hɂȂȂ
		SetMoveModeCancel( true );
		//ǂJɂȂ܂ő҂
		while( WK7Stage::IsChanging() != false )
		{
			K7SCR_RETSYS();
		}
		//inGame~
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		//KVA_ɑĂȂΕς
		if( WK7PLAYERCONTROL->GetMainID() != K7DAN )
		{
			//ĎJŃL
			FixCam( CAM411M00_CAMERA );
			K7SCR_TIMEWAIT( WK7_SEC_TO_TICK(2) );
			WatchCameraB( K7Stage411M00_Camera[CAM411M00_PC].tgt,
						  K7Stage411M00_Camera[CAM411M00_PC].pos,
						  K7CHRID(K7DAN,0), 1 );
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
		}
		K7SCR_SET_SCENARIO_FLAG( MV040002 );
		//[r[ĐE_ƃVK[
		K7SCR_NOISE_REQUEST();
		K7SCR_STG_VISIBLE( mID, false );
		K7SCR_STAGE_RELEASE();
		K7SCR_NOISE_RELEASE();
		//[r[ĐE_ƃVK[
		K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_GURAD );
		K7SCR_NOISE_REQUEST();
		K7SCR_STAGE_RESTORE();
		K7SCR_STG_VISIBLE( mID, true );
		K7SCR_STG_SET_CURRENT_PATH( "position_dan", "curve6" );
		WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
		K7SCR_NOISE_RELEASE();
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
	}
#endif
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage411M00::EventCallBack( WK7EventInfo &info )
{
	WK7Model*	pPcModel;
	WK7JObj*	pJObj;
	Vec			pos;
	int			time;
	
	switch( info.mEventNo )
	{
		case	K7EVENTNO(040102):
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			if( WK7PLAYERCONTROL->GetMainID() == K7MSK )
			{
				//mCYđO
				K7SCR_NOISE_REQUEST();
				if( (pJObj=GetJObj("msk_pos")) != NULL )
				{
					pJObj->GetWorldPosition( pos );
				}else
				{
					pos.x =  -11.000f;
					pos.y =    0.000f;
					pos.z = -391.000f;
				}
				if( WK7PLAYERCONTROL->GetCharaPtr() != NULL )
				{
					WK7PLAYERCONTROL->GetCharaPtr()->SetClothEnable( false );
				}
				WK7PLAYERCONTROL->SetClothEnable(false);
				WK7PLAYERPATHCONTROL->SetEnable( false );
				WK7PLAYERCONTROL->SetEnable( false );
				WK7PLAYERCONTROL->SetPosition( &pos );
				WK7PLAYERCONTROL->SetRotY( PI );
				pPcModel = WK7PLAYERCONTROL->GetCharaModel();
				pPcModel->AttachMotion( mpMskMotion );
				//WK7CAM->SetCinemaScopeMode( true );
				FixCam( CAM411M00_MSK_ATTACK );
				//K7SCR_NOISE_RELEASE();
				//}XNvXZy
				pPcModel->PlayMotion();
				pPcModel->SetMotionLoop( false );
				gpSound->mPlaySE( SFX_SCE4_MSK_BARREL_BOMB );
				SimplePlayMotion( MDL411M00_BARREL, MOT411M00_BARREL_BREAK );
				K7SCR_NOISE_RELEASE();
				Screen = CreateScreenEffect() ;
				if( Screen != NULL )
				{
					SetScreenEffectExRate( Screen, 1.02F ) ;
					SetScreenEffectAddFlag( Screen, FALSE ) ;
					SetScreenEffectAlpha( Screen, 0.45F ) ;
					SetScreenEffectDrawFlag( Screen, TRUE ) ;
					ScreenID = GetEffectID( Screen ) ;
				}
#if 1
//				time = 25560;
				time = 22000;
#else
//				K7SCR_TIMEWAIT( 25560 );
#endif
				while( pPcModel->GetMotionState() != WK7MODEL_NOANIM )
				{
					if ( 222 == pPcModel->GetCurrentMotionFrame() ){				// }XNӂ΂萺Đ
						gpSound->mPlaySE( SFX_PC_MSK_POWVOICE_C,					// uӂ񂪂`v
										  SOUND_SYSTEM_SE_VOLUME,					// 
										  SOUND_PAN_CENTER,							// p
										  eSETrackBattleOverlap, 					// gbN
										  eSEGroupBattle00Env );					// O[v
					}
					if ( 368 == pPcModel->GetCurrentMotionFrame() ){
						gpSound->mPlaySE( SFX_PC_MSK_POWVOICE_A,					// u͂Iv
										  SOUND_SYSTEM_SE_VOLUME,					// 
										  SOUND_PAN_CENTER,							// p
										  eSETrackBattleOverlap, 					// gbN
										  eSEGroupBattle00Env );					// O[v
					}
					
					if ( 374 == pPcModel->GetCurrentMotionFrame() ){
						// o
						{
							GXColor Color ;
							Vec Point = { -11.459F, 0.250F, -402.053F } ;
							
							Color.r = (u8)__SmokeParam[10] ;
							Color.g = (u8)__SmokeParam[11] ;
							Color.b = (u8)__SmokeParam[12] ;
							Smoke = CreateSmokeEffect( 1, Point, __SmokeParam[0] * 0.1F,
												__SmokeParam[1] * 0.01F, __SmokeParam[2] * 0.01F,
												0.0F, __SmokeParam[3],
												(Vec){0.0F,0.0F,0.0F}, 0.0F,
												PI * __SmokeParam[4] * 0.1F / 180.0F, PI * __SmokeParam[5] * 0.1F / 180.0F, 
												__SmokeParam[6] * 0.1F, __SmokeParam[7] * 0.1F,
												__SmokeParam[6] * 0.1F, __SmokeParam[7] * 0.1F,
												__SmokeParam[8], __SmokeParam[9], __SmokeParam[17] * 1.0F,
												Color, Color, Color, (u8)__SmokeParam[13],
												PI * __SmokeParam[18] / 180.0F, 0.0F, FALSE, (u8)__SmokeParam[14], 
												__SmokeParam[15] * 0.01F, FALSE, 0,
												Color, Color, Color,
												__SmokeParam[16] * 0.01F ) ;
							if( Smoke != NULL ) SmokeID = GetEffectID( Smoke ) ;
						}
						// ʂh炷
						Impact = CreateImpactEffect( 60, 40, (Vec){0.0F, 0.0F, 0.0F}, 17, 0, TRUE ) ;
						if( Impact != NULL ) ImpactID = GetEffectID( Impact ) ;
					}
					
					if ( time > 0 ){
						time -= WK7_TICK_PER_FRAME;
					}else{
						FixCam( CAM411M00_BARREL );
					}
					K7SCR_RETSYS();
				}
//				while( pPcModel->GetMotionState() != WK7MODEL_NOANIM )
//				{
//					K7SCR_RETSYS();
//				}
				//mCY𔭐Č㏈
				K7SCR_NOISE_REQUEST();
				if( WK7PLAYERCONTROL->GetCharaPtr() != NULL )
				{
					WK7PLAYERCONTROL->GetCharaPtr()->SetClothEnable( true );
				}
				if( CheckEffectValidState( Screen, ScreenID ) == TRUE ) ::DelReqEffect( Screen ) ;
				Screen = NULL ;
				//WK7CAM->SetCinemaScopeMode( false );
				K7SCR_SET_SCENARIO_FLAG( EV040102 );
				K7SCR_EVCONDCHANGE();
				WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
				WK7PLAYERPATHCONTROL->SetEnable( true );
				WK7PLAYERCONTROL->SetEnable( true );
				WK7PLAYERCONTROL->SetClothEnable(true);
				WK7PLAYERCONTROL->NextMotionHokanEnableRequest();
				//ړJnpXɏ悹
				SetCurrentPath(	GetPathNurbsAll(PAT411M00_BARREL_INNER),
								0.000f,
								0,									// 0:forward 1:back
								WK7PATHINFO_INITDIR_TGTDIR_REV );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
//				//ړJnpXɏ悹
//				SetCurrentPath(	GetPathNurbsAll(PAT411M00_BARREL_RIDDLE),
//								1.000f,
//								0,									// 0:forward 1:back
//								WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
				K7SCR_NOISE_RELEASE();
			}else
			{
				K7SCR_PC_SETVISIBLE( false );
				FixCamMesWithRiddle( CAM411M00_BARREL_RIDDLE, MES411M00_NEED_MSK );
			}
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( true );
			break;
		
		//ftHg
		default:
			break;
			
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage411M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//V[gJbg
		case	K7EVENTDOOR( 040102 ):
			if( K7SCR_GET_SCENARIO_FLAG(DR040102) == false )
			{
				FixCamMes( CAM411M00_SHORTCUT_DOOR, MES411M00_SHORTCUT_DOOR );
				return( false );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage411M00::BpLeaveCallBack( WK7BpInfo &info )
{
	return( true );
	
	u32	eventNo  = GetBpEventNo( info );
	int	pathNo   = GetBpPathNo( info );
	
	switch( eventNo )
	{
		//M
		case	K7EVENTNO( 040106 ):
			if( (K7SCR_GET_SCENARIO_FLAG(EV040102) == false) && (pathNo == 0) )
			{
				gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
			}
			break;
		
		//ftHg
		default:
			return( true );
	}
	
	return( true );
}
