////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage441M01 yh~jJzAgG
//
// K7Stage441M01.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE441M01_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage441M01.h"
#include "..\..\..\Kaw\KK7Effect.h"
#include "..\..\..\Yam\YK7EffectDraft.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"

//pX
#define	PAT441M01_ATELIER_INNER		"event_040403_0"	//ǂ󂵂Ēʉ߂ł悤ɂȂpX
#define	PAT441M01_ATELIER_RIDDLE	"event_040406_0"	//ǔj̓JpX
//f
#define	MDL441M01_WALL				"event_040403"		//
#define	MDL441M01_FAN1				"ceiling_fan00"		//@1
#define	MDL441M01_FAN2				"ceiling_fan01"		//@2
#define	MDL441M01_FAN3				"ceiling_fan02"		//@3
#define	MDL441M01_WIND				"hibi"				//n_
//[V
#define	MOT441M01_FAN_ROLLING		(0)					//@]
//SE
#define	SE441M01_CAT_WIND			(SFX_SYS_SAND_NOISE)	//LbgŌ镗̉
//W
#define	POS441M01_CRACK				((Vec){-670.950f, 5.000f, -80.519f})	//ǂЂъW




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage441M01::K7Stage441M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage441M01_Camera );
	mpWindEffect = NULL;
	mFanWork     = false;
//	mAmbPlaySE   = false;
	mpLoopSE     = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage441M01::~K7Stage441M01()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage441M01::CreateCallBack( void )
{
	CreateOwnStageMotion( MOT441M01_FAN_ROLLING );
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage441M01::CondChangeCallBack( void )
{
	WK7JObj*		pJObj;
	WK7ModelMotion*	pMotion;
	EFFECT*			pWindEffect;
	f32				frame = 1.0f;
	
	gpSound->mSetDspRateAll(20);
	//@]
	if( mFanWork == false )
	{
		pMotion = GetOwnModelMotion( MOT441M01_FAN_ROLLING );
		if( pMotion != NULL )
		{
			frame = pMotion->GetTotalMotionFrame();
		}
		if( (pJObj=PlayMotion(MDL441M01_FAN1,MOT441M01_FAN_ROLLING,NULL,frame*0.0f)) != NULL )
		{
		//	frame = pJObj->GetTotalMotionFrame( false, true );
			pJObj->SetMotionLoop( true ,true, true );
		}
		if( (pJObj=PlayMotion(MDL441M01_FAN2,MOT441M01_FAN_ROLLING,MDL441M01_FAN1,frame*0.3f)) != NULL )
		{
			pJObj->SetMotionLoop( true ,true, true );
		}
		if( (pJObj=PlayMotion(MDL441M01_FAN3,MOT441M01_FAN_ROLLING,MDL441M01_FAN1,frame*0.6f)) != NULL )
		{
			pJObj->SetMotionLoop( true ,true, true );
		}
		mFanWork = true;
	}
	
	//ǂ
	if( K7SCR_GET_SCENARIO_FLAG(EV040403) == false )
	{
		K7SCR_STG_SET_PATHENABLE( PAT441M01_ATELIER_INNER, false );
		SimpleModelDisp( MDL441M01_WALL );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PAT441M01_ATELIER_RIDDLE, false );
		if( WK7PLAYERCONTROL->GetMainID() == K7CAT && GetCurrentStageID()==mID )
		{
			WK7RenderObjEffectInfo	info;
			info.Create();
			if( ((pJObj=GetJObj(MDL441M01_WIND)) != NULL)
			 && (IsValidEffect(mpWindEffect) == false)
			 && ((pWindEffect = ::CreateDraft2Effect(pJObj,(s32)VParam[ED_DRAFT][2])) != NULL) )
			{
				mpWindEffect = CreateEffect( pWindEffect ,&info);
				// }XNŔj󂷂ЂъꂽǂoĂĂ錄ԕ
				CatWindSePlay( POS441M01_CRACK, EV040403, SFX_SCE4_SUKIMAWIND16 );
			}
		}else
		{
			if( mpWindEffect != NULL )
			{
//				ReleaseEffect( mpWindEffect );
				DelReqEffect( mpWindEffect );
				mpWindEffect = NULL;
			}
		}
		gpSound->mPlayStreamEx( HPS_BUNSIN_D );
	}else
	{
		K7SCR_STG_SET_PATHENABLE( PAT441M01_ATELIER_INNER, true );
		SimpleModelHide( MDL441M01_WALL );
		K7SCR_STG_SET_DISABLEPATHCAMERA( PAT441M01_ATELIER_RIDDLE, true );
		if( mpWindEffect != NULL )
		{
			ReleaseEffect( mpWindEffect );
			mpWindEffect = NULL;
		}
		gpSound->mPlayStreamEx( HPS_BUNSIN_B );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage441M01::SetCurrentCallBack( void )
{
//	if( (mAmbPlaySE == false) && (K7SCR_GET_SCENARIO_FLAG(EV040403) == false) )
//	{
//		mpLoopSE = KK7SoundLoopSePlayVolumeChange((Vec){-670.465f, 15.018f, -80.990f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_SUKIMAWIND16 );
//		mAmbPlaySE = true;
//	}
	
	K7SCR_EVCONDCHANGE();
	return( true );
}

//------------------------------------------------------------------------------
//L`FW
//------------------------------------------------------------------------------
bool
K7Stage441M01::CharaChangeCallBack( WK7CharaChangeInfo &info )
{
#pragma	unused(info)
	K7SCR_EVCONDCHANGE();
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage441M01::EventCallBack( WK7EventInfo &info )
{
	switch( info.mEventNo )
	{
		//i
		case	K7EVENTNO( 040402 ):
			SimpleCallPanel( K7EVENTNO(040402) );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage441M01::BpLeaveCallBack( WK7BpInfo &info )
{
	u32	eventNo  = GetBpEventNo( info );
	int	pathNo   = GetBpPathNo( info );
	
	switch( eventNo )
	{
		//
		case	K7EVENTNO( 040406 ):
			if( (K7SCR_GET_SCENARIO_FLAG(EV040403) == false) && (pathNo == 0) )
			{
				gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
			}
			break;
		
		//ftHg
		default:
			return( true );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//qbgIuWF
//------------------------------------------------------------------------------
bool
K7Stage441M01::HitObjCallBack( WK7HitObjInfo &info )
{
	switch( info.mEventNo )
	{
		//
		case	K7EVENTNO( 040403 ):
			if( WK7PLAYERCONTROL->GetMainID() == K7MSK )
			{
				//퓬I
				KK7BattleMainTask::BattleMainTaskExit(2);
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//ǂtOON
				K7SCR_SET_SCENARIO_FLAG( EV040403 );
				K7SCR_STG_SET_PATHENABLE( PAT441M01_ATELIER_INNER, true );
				K7SCR_STG_SET_DISABLEPATHCAMERA( PAT441M01_ATELIER_RIDDLE, true );
				if( mpLoopSE != NULL )
				{
					mpLoopSE->taskEnd = -1;
				}
				//EGCg
				K7SCR_TIMEWAIT( 800 );
				//JύX
				FixCam( CAM441M01_MSK_WALL );
				//
				KK7DoorSmokeEffect( POS441M01_CRACK );
				K7SCR_TIMEWAIT( 1600 );
				//IuWF
				info.mpJObj->Hide( false, true );
				BrokenObj( MDL441M01_WALL );
				//EGCg
				K7SCR_TIMEWAIT( K7SCR_MSK_WALL_BEFORE_TICK );
				gpSound->mPlaySE( SFX_SYS_TRUE );
				K7SCR_TIMEWAIT( K7SCR_MSK_WALL_AFTER_TICK );
				gpSound->mPlayStreamEx( HPS_BUNSIN_B );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}
