////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage523M00
//
// K7Stage523M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE523M00_H__
#define	__K7STAGE523M00_H__

#include ".\K7StageHotelBase.h"

class K7Stage523M00 : public K7StageHotelBase{
	friend class WK7Stage;
protected:
	K7Stage523M00();
	K7Stage523M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	EFFECT*	mpSpark;
public:
	virtual ~K7Stage523M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
//	virtual bool BpArriveCallBack  (WK7BpInfo        &){ return true; }		// _
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj
//	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);
	virtual bool TamaEventCallBack (WK7TamaEventInfo &);
};

#ifdef __K7STAGE523M00_CPP__


enum K7STAGE523M00_ONESHOTCAM{
	EVENT_051301,
	TAMA_051301,
};


K7StageEventOneShotCamera K7Stage523M00_Camera[] = {
	{{-203.173f, 5.819f, -34.523f},{-196.631f, 10.549f, -28.622f}},
	{{-202.737f, 12.028f, -22.788f},{-195.674f, 19.101f, -23.095f}},
};

#define	K7STAGE523M00_MES_ELECTRIC_SHOCK			(0)		// dCŊdĂ܂
#define	K7STAGE523M00_MES_CUT_CODE					(1)		// R[hؒf

#endif

#endif	//__K7STAGE523M00_H__

