////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage524M00
//
// K7Stage524M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE524M00_H__
#define	__K7STAGE524M00_H__

#include ".\K7StageHotelBase.h"

class K7Stage524M00 : public K7StageHotelBase{
	friend class WK7Stage;
protected:
	WK7RenderObjEffect			*mpWindEffect;
	int							mSubNo;
	
	K7Stage524M00();
	K7Stage524M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage524M00();
	
	virtual bool CreateCallBack    (void);
//	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
//	virtual bool BpArriveCallBack  (WK7BpInfo        &){ return true; }		// _
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj
//	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);
	virtual bool CharaChangeCallBack(WK7CharaChangeInfo &);
};

#ifdef __K7STAGE524M00_CPP__


enum K7STAGE524M00_ONESHOTCAM{
	EVENT_051401,
};


K7StageEventOneShotCamera K7Stage524M00_Camera[] = {
	{{-30.438f, 9.028f, -139.200f},{-33.084f, 6.760f, -148.574f}},
};

#define	K7STAGE524M00_MES_BROKEN_CLOSET		(0)				// N[[bgj󂵂

#endif

#endif	//__K7STAGE524M00_H__

