////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage525M00
//
// K7Stage525M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE525M00_H__
#define	__K7STAGE525M00_H__

#include ".\K7StageHotelBase.h"

class K7Stage525M00 : public K7StageHotelBase{
	friend class WK7Stage;
protected:
	WK7RenderObjEffect			*mpCandleFireEffect[2];
	C_SetAlpha					*mpSetAlpha[2];
	WK7AnimLinearF				mAlpha;
	
	bool StartCandleFire(void);
	bool StopCandleFire(void);
	
	K7Stage525M00();
	K7Stage525M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage525M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
//	virtual bool BpArriveCallBack  (WK7BpInfo        &){ return true; }		// _
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj
//	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);
};

#ifdef __K7STAGE525M00_CPP__


enum K7STAGE525M00_ONESHOTCAM{
	EVENT_051501_0,
	EVENT_051501_1,
};


K7StageEventOneShotCamera K7Stage525M00_Camera[] = {
	{{-119.987f, 12.827f, -598.327f},{-111.360f, 14.061f, -602.123f}},
	{{-100.733f, 19.443f, -584.047f},{-93.973f, 24.801f, -578.989f}},
};

enum{
	K7STAGE525M00_MES_USE_FIRE_RING = 0		,		// ̎wւK
};

#endif

#endif	//__K7STAGE525M00_H__

