////////////////////////////////////////////////////////////////////////////////
//
// Killer7 StageHotelBase
//
// StageHotelBase.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 06/11/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGEHOTELBASE_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7StageHotelBase.h"

K7StageHotelBase::K7StageHotelBase(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
}

K7StageHotelBase::~K7StageHotelBase()
{
}

bool K7StageHotelBase::CreateCallBack(void)
{
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
		return false;
	}
	return true;
}

bool K7StageHotelBase::InitPath(void)
{
static	const char	*pPath1 = "FirstTime";
static	const char	*pPath2 = "SecondTime";
	const char	*pPath[2];
	const char	*pPathName;
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
		pPath[0] = pPath2;
		pPath[1] = pPath1;
	}else{
		pPath[0] = pPath1;
		pPath[1] = pPath2;
	}
	WK7PathNurbs		*pPathNurbs;
	int					i;
	for(pPathNurbs=mpPath->GetPathTop() ; pPathNurbs!=NULL ; pPathNurbs=pPathNurbs->GetNext()){
		if( (pPathName=pPathNurbs->GetName())==NULL ){
			continue;
		}
		for(i=1 ; i>=0 ; i--){
			if( strstr(pPathName,pPath[i])==pPathName ){
				break;
			}
		}
		switch( i ){
		case	0: pPathNurbs->SetEnable(true ); pPathNurbs->SetEnableEx(true ); break;
		case	1: pPathNurbs->SetEnable(false); pPathNurbs->SetEnableEx(false); break;
		default:                                                                 break;
		}
	}
//	WK7JObj		*pJObj = GetJObj("GLASS");
//	static	HSD_PEDesc	pedesc = {
//		//J[AAt@AŒAt@݁AZobt@SăGiuB
//		ENABLE_COLOR_UPDATE|ENABLE_ALPHA_UPDATE|ENABLE_DST_ALPHA|ENABLE_COMPARE|ENABLE_ZUPDATE|ENABLE_DITHER|BEFORE_TEX,
//		// GXSetAlphaCompare(),ref0,ref1
//		0,0,
//		// GXSetDstAlpha(),dst_alpha
//		WK7RENDEROBJ_RENDERID_DEFAULT_ALPHA,
//		// GXSetBlendMode(),type,src_factor,dst_factor,logic_op
//		GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR,
//		//GXSetZMode(),func
//		GX_LEQUAL,
//		//GXAlphaCompare,comp0,op,comp1
//		GX_ALWAYS,GX_AOP_AND,GX_ALWAYS
//	};
//	if( pJObj!=NULL ){
//		pJObj->SetPE(&pedesc,false,true);
//		pJObj->SetNoZUpdate(false,false,true);
//	}
	return true;
}

