////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage554M00 ywZz 554M00`554M12
//
// K7Stage554M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/17/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE554M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage554M00.h"

#define	CAM554Mxx_WAIT	(9600)		//̕\
//f
#define	MDL554M00_TAPE	"Tape"		//554M00̃e[v
#define	MDL554M02_TAPE	"Tape"		//554M02̃e[v
#define	MDL554M04_TAPE	"Tape"		//554M04̃e[v
#define	MDL554M07_TAPE	"Tape"		//554M07̃e[v
#define	MDL554M10_TAPE	"Tape"		//554M10̃e[v
#define	MDL554M11_TAPE	"Tape"		//554M11̃e[v
#define	MDL554M12_TAPE	"Tape"		//554M12̃e[v




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage554M00::K7Stage554M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage554M00_Camera );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage554M00::~K7Stage554M00()
{
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage554M00::SetCurrentCallBack( void )
{
	TapeEventControl();
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage554M00::EventCallBack( WK7EventInfo &info )
{
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE( false );
	
	switch( info.mEventNo )
	{
		//
		case K7EVENTNO(055400): FixCamMes(CAM554M00_BLACKBOARD,0); break;
		case K7EVENTNO(055401): FixCamMes(CAM554M01_BLACKBOARD,0); break;
		case K7EVENTNO(055402): FixCamMes(CAM554M02_BLACKBOARD,0); break;
		case K7EVENTNO(055403): FixCamMes(CAM554M03_BLACKBOARD,0); break;
		case K7EVENTNO(055404): FixCamMes(CAM554M04_BLACKBOARD,0); break;
		case K7EVENTNO(055405): FixCamMes(CAM554M05_BLACKBOARD,0); break;
		case K7EVENTNO(055406): FixCamMes(CAM554M06_BLACKBOARD,0); break;
		case K7EVENTNO(055407): FixCamMes(CAM554M07_BLACKBOARD,0); break;
		case K7EVENTNO(055408): FixCamMes(CAM554M08_BLACKBOARD,0); break;
		case K7EVENTNO(055409): FixCamMes(CAM554M09_BLACKBOARD,0); break;
		case K7EVENTNO(055410): FixCamMes(CAM554M10_BLACKBOARD,0); break;
		case K7EVENTNO(055411): FixCamMes(CAM554M11_BLACKBOARD,0); break;
		case K7EVENTNO(055412): FixCamMes(CAM554M12_BLACKBOARD,0); break;
		
		//e[v
		case K7EVENTNO(055150):
			FixCam( CAM554M00_TAPE );
			K7SCR_TIMEWAIT( 4800 );
			SimpleItemGetMes( 1, MDL554M00_TAPE, true );
			K7SCR_SET_SCENARIO_FLAG( VRTAPE05 );
			TapeEventControl();
			break;
		
		case K7EVENTNO(055151):
			FixCam( CAM554M02_TAPE );
			K7SCR_TIMEWAIT( 4800 );
			SimpleItemGetMes( 1, MDL554M02_TAPE, true );
			K7SCR_SET_SCENARIO_FLAG( VRTAPE01 );
			TapeEventControl();
			break;
		
		case K7EVENTNO(055152):
			FixCam( CAM554M04_TAPE );
			K7SCR_TIMEWAIT( 4800 );
			SimpleItemGetMes( 1, MDL554M04_TAPE, true );
			K7SCR_SET_SCENARIO_FLAG( VRTAPE06 );
			TapeEventControl();
			break;
		
		case K7EVENTNO(055153):
			FixCam( CAM554M07_TAPE );
			K7SCR_TIMEWAIT( 4800 );
			SimpleItemGetMes( 1, MDL554M07_TAPE, true );
			K7SCR_SET_SCENARIO_FLAG( VRTAPE07 );
			TapeEventControl();
			break;
		
		case K7EVENTNO(055154):
			FixCam( CAM554M10_TAPE );
			K7SCR_TIMEWAIT( 4800 );
			SimpleItemGetMes( 1, MDL554M10_TAPE, true );
			K7SCR_SET_SCENARIO_FLAG( VRTAPE03 );
			TapeEventControl();
			break;
		
		case K7EVENTNO(055155):
			FixCam( CAM554M11_TAPE );
			K7SCR_TIMEWAIT( 4800 );
			SimpleItemGetMes( 1, MDL554M11_TAPE, true );
			K7SCR_SET_SCENARIO_FLAG( VRTAPE04 );
			TapeEventControl();
			break;
		
		case K7EVENTNO(055156):
			FixCam( CAM554M12_TAPE );
			K7SCR_TIMEWAIT( 4800 );
			SimpleItemGetMes( 1, MDL554M12_TAPE, true );
			K7SCR_SET_SCENARIO_FLAG( VRTAPE02 );
			TapeEventControl();
			break;
		
		//ftHg
		default:
			break;
	}
	
	//inGameĊJ
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE( true );
	
	return( true );
}

//------------------------------------------------------------------------------
//e[vCxg
//------------------------------------------------------------------------------
bool
K7Stage554M00::TapeEventControl( void )
{
	//{Iɔ\
	SimpleModelHide( "Tape" );
	
	switch( WK7Stage::GetCurrentStage()->GetID() )
	{
		case	K7STGID(554,0):
			if( K7SCR_GET_SCENARIO_FLAG(VRTAPE05) == false )
			{
				SimpleModelDisp( MDL554M00_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055150), true );
			}else
			{
				SimpleModelHide( MDL554M00_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055150), false );
			}
			break;
		
		case	K7STGID(554,2):
			if( K7SCR_GET_SCENARIO_FLAG(VRTAPE01) == false )
			{
				SimpleModelDisp( MDL554M02_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055151), true );
			}else
			{
				SimpleModelHide( MDL554M02_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055151), false );
			}
			break;
		
		case	K7STGID(554,4):
			if( K7SCR_GET_SCENARIO_FLAG(VRTAPE06) == false )
			{
				SimpleModelDisp( MDL554M04_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055152), true );
			}else
			{
				SimpleModelHide( MDL554M04_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055152), false );
			}
			break;
		
		case	K7STGID(554,7):
			if( K7SCR_GET_SCENARIO_FLAG(VRTAPE07) == false )
			{
				SimpleModelDisp( MDL554M07_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055153), true );
			}else
			{
				SimpleModelHide( MDL554M07_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055153), false );
			}
			break;
		
		case	K7STGID(554,10):
			if( K7SCR_GET_SCENARIO_FLAG(VRTAPE03) == false )
			{
				SimpleModelDisp( MDL554M10_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055154), true );
			}else
			{
				SimpleModelHide( MDL554M10_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055154), false );
			}
			break;
		
		case	K7STGID(554,11):
			if( K7SCR_GET_SCENARIO_FLAG(VRTAPE04) == false )
			{
				SimpleModelDisp( MDL554M11_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055155), true );
			}else
			{
				SimpleModelHide( MDL554M11_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055155), false );
			}
			break;
		
		case	K7STGID(554,12):
			if( K7SCR_GET_SCENARIO_FLAG(VRTAPE02) == false )
			{
				SimpleModelDisp( MDL554M12_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055156), true );
			}else
			{
				SimpleModelHide( MDL554M12_TAPE );
				K7SCR_EVNO_SETENABLE( K7EVENTNO(055156), false );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

