////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage600M00 yKVA@zn
//
// K7Stage600M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 05/28/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE600M00_CPP__

#include "..\..\..\Scn\K7Scn06.h"
#include ".\K7Stage600M00.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7Effect.h"
#include "..\..\..\Enm\EnmKUN.h"

#define STG600M00_BULLET_CAM_FRAME	(30.0f)		//eԉoɂ鎞

K7Stage600M00::K7Stage600M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
//	SetOneShotCamLocTbl(K7Stage600M00_Camera);
	GameInfo.SetMenuMapEnable(false);
	GameInfo.SetBossFlag     (true );
	KK7HitWallSetDist(2500.0f);
}

K7Stage600M00::~K7Stage600M00()
{
	GameInfo.SetMenuMapEnable(true );
	GameInfo.SetBossFlag     (false);
	KK7HitWallSetDist();
}

bool K7Stage600M00::CreateCallBack(void)
{
	gpSound->mReadSsm("seBossAngKun.ssm",eBankBoss);
	return true;
}

bool K7Stage600M00::TerminateCallBack(void)
{
	gpSound->mReleaseSsm("seBossAngKun.ssm");
	return true;
}

bool K7Stage600M00::SetCurrentCallBack(void)
{
#if	1
	WK7Play		*pPlay;
	
	//NłL
	WK7Play::SetDontStopStream( true );			//LIɃXg[~Ȃ
	WK7Play::SetDontReleasePlayerSsm( true );	//vC[SE͉Ȃ
	WK7Play::SetSkipCancel          (true);
	while( (pPlay=WK7Play::Create(K7EVENTPLAY(05120101)))==NULL ){
		K7SCR_RETSYS();
	}
	pPlay->Prepare();
	while( pPlay->GetState()!=WK7Play::PREPARED ){
		K7SCR_RETSYS();
	}
	
	//plŃXg[mutes߁Ał͂֎~
	gpSound->mSetDontMuteStream();
	
	K7SCR_PANEL_SETPANELEVNO(K7EVENTNO(060000),0);
	GameInfo.SetPanelReleaseCancel(true);
	GameInfo.SetPanelNoiseCancel(true);
//	GameInfo.SetPanelCtrlOffWait(true);
	GameInfo.SetPanelInitHideWait(true);
	
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_KAMAE_ONLY);
	
	//ǂJɂȂ܂ő҂
	while( WK7Stage::IsChanging() != false ){
		K7SCR_RETSYS();
	}
	
	while( K7EnmKUN::GetInstance()==NULL ){
		K7SCR_RETSYS();
	}
	
	KUN.SetGameState(KUN_GAME_STATE1);
	KUN.SetAlive();
	
	WK7PLAYERCONTROL->SetOperateEnable(true);
	K7EnmKUN::Start();
	
	while( K7EnmKUN::IsAlive() ){
	  K7SCR_RETSYS();
	}
	KK7BattleMainTask::BattleMainTaskExit(2);
	
	//NɌĔłe
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_PANEL_START();
//	WK7CAM->SetCinemaScopeMode(true);
	FixCam( BULLET_START );
	K7SCR_TIMEWAIT( 100 );
	WK7CAM->StartLinearInterpolateOnLinearPath( K7Stage600M00_Camera[BULLET_TERM].pos, K7Stage600M00_Camera[BULLET_TERM].tgt, STG600M00_BULLET_CAM_FRAME );
//	k7app.FadeStart( 0x0, 0 );
//	k7app.SetFadeColor( 0xffffffff );
//	k7app.FadeStart( 0xff, WK7_FRAME_TO_TICK((u32)STG600M00_BULLET_CAM_FRAME) );
	K7SCR_TIMEWAIT( WK7_FRAME_TO_TICK((u32)(STG600M00_BULLET_CAM_FRAME-16)) );
//	k7app.FadeStart( 0x0, 0 );
//	WK7CAM->SetCinemaScopeMode(false);
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem(false);
	
    WK7Chara::SetRenderChara(false);
    WK7Stage::SetRenderStage(false);
    WK7Item::SetRenderItem(false);
    
	WK7CAM->SetFar(100000.0f);
//	WK7Play::SetTermCaptureRenderOn (true);
//	WK7Play::SetTermCapturePreRender(true);
	pPlay->Start();
	K7SCR_RETSYS();
	while( pPlay->GetState()!=WK7Play::PLAYED ){
		K7SCR_RETSYS();
	}
	WK7Play::PlayReleaseAll();
	K7SCR_RETSYS();
//	WK7Play::SetTermCaptureRenderOn (false);
	WK7Play::SetSkipCancel          (false);
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem(false);
	
	WK7CAM->SetCinemaScopeMode(false);
	
	K7SCR_PANEL_INITWAIT();
	GameInfo.SetPanelInitHideWait(false);
	K7SCR_PANEL_TERMWAIT();
	K7SCR_RETSYS();
	K7SCR_PANEL_EXIT();
	K7SCR_PANEL_EXITWAIT();
	
	WK7PLAYERCONTROL->BattlePadRegulationSet();
	
	//Ō̃LŃXg[~߂Ȃ̂łŎ~߂ăsb`߂
	gpSound->mStopStream();
	gpSound->mSetPitchStream(0);
	
	screenImageFullColor.SetPreRender (false);
	screenImageFullColor.SetRender    (false);
	screenImageFullColor.SetCopyEnable(true );
	screenImageMonoColor.SetPreRender (false);
	screenImageMonoColor.SetRender    (false);
	screenImageMonoColor.SetCopyEnable(true );
	
	//Q[NAtOݒ
	K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR );
	//Killer8[hKiller8NAtO𗧂Ă
	if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == true )
	{
		K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR_K8 );
	}
	
	GameInfo.SetMode     (WK7GameInfo::TERM           );
	GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
	
	return false;
#else
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_KAMAE_ONLY);
	
	//ǂJɂȂ܂ő҂
	while( WK7Stage::IsChanging() != false ){
		K7SCR_RETSYS();
	}
	
	while( K7EnmKUN::GetInstance()==NULL ){
		K7SCR_RETSYS();
	}
	
	KUN.SetGameState(KUN_GAME_STATE1);
	KUN.SetAlive();
	
	WK7PLAYERCONTROL->SetOperateEnable(true);
	K7EnmKUN::Start();
	gpSound->mPlayStreamNo(HPS_BOSS_KUN);
	
	while( K7EnmKUN::IsAlive() ){
	  K7SCR_RETSYS();
	}
	KK7BattleMainTask::BattleMainTaskExit(2);
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	gpSound->mFadeVolumeStream(0,30);
	gpSound->mStopStream();
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem(false);
	
	K7SCR_PANEL_SETPANELEVNO(K7EVENTNO(060000),0);
	GameInfo.SetPanelReleaseCancel(true);
	GameInfo.SetPanelNoiseCancel(true);
//	GameInfo.SetPanelCtrlOffWait(true);
	GameInfo.SetPanelInitHideWait(true);
	K7SCR_PANEL_START();
	
	WK7Play::StorePlayTB();
	WK7CAM->SetFar(100000.0f);
	WK7Play::SetTermCaptureRenderOn (true);
	WK7Play::SetTermCapturePreRender(true);
	WK7Play::SetSkipCancel          (true);
	WK7Play::PlayTB(K7EVENTPLAY(05120101));
	WK7Play::SetTermCaptureRenderOn (false);
	WK7Play::SetSkipCancel          (false);
	WK7Play::RestorePlayTB(false);
	
	gpSound->mStopStream();
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem(false);
	
	K7SCR_PANEL_INITWAIT();
	GameInfo.SetPanelInitHideWait(false);
	K7SCR_PANEL_TERMWAIT();
	K7SCR_RETSYS();
	K7SCR_PANEL_EXIT();
	K7SCR_PANEL_EXITWAIT();
	
//	K7SCR_PANEL_SETPANELEVNO(K7EVENTNO(060001),0);
//	GameInfo.SetPanelReleaseCancel(true);
//	GameInfo.SetPanelNoiseCancel(true);
////	GameInfo.SetPanelCtrlOffWait(true);
////	GameInfo.SetPanelInitHideWait(true);
//	K7SCR_PANEL_START();
//	K7SCR_PANEL_TERMWAIT();
//	K7SCR_RETSYS();
//	K7SCR_PANEL_EXIT();
//	K7SCR_PANEL_EXITWAIT();
//	
//	GameInfo.SetPanelNoiseCancel(false);
//	GameInfo.SetPanelReleaseCancel(false);
	
//	mScnEnd.FrameProcess();
	
	WK7PLAYERCONTROL->BattlePadRegulationSet();
	
	GameInfo.SetMode     (WK7GameInfo::TERM           );
	GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
	
	return false;
#endif
}

