////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Create
//
// EnmCreate.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/19/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifdef	__ENMCREATE_INCLUDE__

#include "..\Enm\EnmA.h"
#include "..\Enm\EnmB.h"
#include "..\Enm\EnmC.h"
#include "..\Enm\EnmD.h"
#include "..\Enm\EnmE.h"
#include "..\Enm\EnmF.h"
#include "..\Enm\EnmG.h"
#include "..\Enm\EnmH.h"
#include "..\Enm\EnmI.h"
#include "..\Enm\EnmJ.h"
#include "..\Enm\EnmK.h"
#include "..\Enm\EnmL.h"
#include "..\Enm\EnmM.h"
#include "..\Enm\EnmN.h"
#include "..\Enm\EnmO.h"
#include "..\Enm\EnmP.h"
#include "..\Enm\EnmQ.h"
#include "..\Enm\EnmR.h"
#include "..\Enm\EnmS.h"
#include "..\Enm\EnmT.h"
#include "..\Enm\EnmU.h"
#include "..\Enm\EnmV.h"
#include "..\Enm\EnmW.h"
#include "..\Enm\EnmX.h"
#include "..\Enm\EnmY.h"
#include "..\Enm\EnmZ.h"
#include "..\Enm\EnmMYS.h"
#include "..\Enm\EnmTIM.h"
#include "..\Enm\EnmGYA.h"
#include "..\Enm\EnmSPI.h"
#include "..\Enm\EnmSPD.h"
#include "..\Enm\EnmHSLaser.h"
#include "..\Enm\EnmFDAN.h"
#include "..\Enm\EnmFCAT.h"
#include "..\Enm\EnmFKED.h"
#include "..\Enm\EnmFCYO.h"
#include "..\Enm\EnmFMSK.h"
#include "..\Enm\EnmFKVN.h"
#include "..\Enm\EnmFHAC.h"
#include "..\Enm\EnmFGAL.h"
#include "..\Enm\EnmANG.h"
#include "..\Enm\EnmFAN.h"
#include "..\Enm\EnmKUN.h"
#include "..\Enm\EnmKRR.h"
#include "..\Enm\EnmKIB.h"
#include "..\Enm\EnmUR2.h"
#include "..\Enm\EnmCUR.h"
#include "..\Enm\EnmKIS.h"
#include "..\Enm\EnmDE2.h"
#include "..\Enm\EnmAKN.h"
#include "..\Enm\EnmTEN.h"
#include "..\Enm\EnmHM1.h"
#include "..\Enm\EnmHN2.h"
#include "..\Enm\EnmHN3.h"
#include "..\Enm\EnmHN4.h"
#include "..\Enm\EnmHN5.h"
#include "..\Enm\EnmHN6.h"
#include "..\Enm\EnmHN8.h"
#include "..\Enm\EnmHN9.h"
#include "..\Enm\EnmHNG.h"

#define	ENM_CREATE_DECL_START()				switch( type ){
#define	ENM_CREATE_DECL(type,cls)			case	(type): return new cls(type,suffix,&mAnchor);
#define	ENM_CREATE_DECL_END()				}

#undef	__ENMCREATE_INCLUDE__

#else

#ifndef	__ENMCREATE_H__
#define	__ENMCREATE_H__


#ifdef	__K7SCN01_CPP__
	ENM_CREATE_DECL(K7ENM_KRR    ,K7EnmKIB)
	ENM_CREATE_DECL(K7ENM_KIB    ,K7EnmKRR)
	ENM_CREATE_DECL(K7ENM_KIS    ,K7EnmKIS)
	ENM_CREATE_DECL(K7ENM_DE2    ,K7EnmDE2)
#endif

#ifdef	__K7SCN02_CPP__
	ENM_CREATE_DECL(K7ENM_URUM   ,K7EnmW)
#endif

#ifdef	__K7SCN03_CPP__
	ENM_CREATE_DECL(K7ENM_CERA   ,K7EnmX)
	ENM_CREATE_DECL(K7ENM_CUR    ,K7EnmCUR)
	ENM_CREATE_DECL(K7ENM_AKN    ,K7EnmAKN)
	ENM_CREATE_DECL(K7ENM_AK2    ,K7EnmAK2)
#endif

#ifdef	__K7SCN04_CPP__
	ENM_CREATE_DECL(K7ENM_HM1    ,K7EnmHM1)
	ENM_CREATE_DECL(K7ENM_HN2    ,K7EnmHN2)
	ENM_CREATE_DECL(K7ENM_HN3    ,K7EnmHN3)
	ENM_CREATE_DECL(K7ENM_HN4    ,K7EnmHN4)
	ENM_CREATE_DECL(K7ENM_HN5    ,K7EnmHN5)
	ENM_CREATE_DECL(K7ENM_HN6    ,K7EnmHN6)
	ENM_CREATE_DECL(K7ENM_HN8    ,K7EnmHN8)
	ENM_CREATE_DECL(K7ENM_HN9    ,K7EnmHN9)
#endif

#ifdef	__K7SCN05_CPP__
	ENM_CREATE_DECL(K7ENM_GYAR   ,K7EnmGYA)
	ENM_CREATE_DECL(K7ENM_TIME   ,K7EnmTIM)
	ENM_CREATE_DECL(K7ENM_BLHS   ,K7EnmZ)
	ENM_CREATE_DECL(K7ENM_HNG    ,K7EnmHNG)
#endif

#ifdef	__K7SCN06_CPP__
#endif

#ifdef	__K7SCN07_CPP__
	ENM_CREATE_DECL(K7ENM_SPD    ,K7EnmSPD)
	ENM_CREATE_DECL(K7ENM_ANG    ,K7EnmANG)
#endif

#ifdef	__WK7NPC_CPP__
	ENM_CREATE_DECL(K7ENM_A      ,K7EnmA)
	ENM_CREATE_DECL(K7ENM_B      ,K7EnmB)
	ENM_CREATE_DECL(K7ENM_C      ,K7EnmC)
	ENM_CREATE_DECL(K7ENM_D      ,K7EnmD)
	ENM_CREATE_DECL(K7ENM_E      ,K7EnmE)
	ENM_CREATE_DECL(K7ENM_F      ,K7EnmF)
	ENM_CREATE_DECL(K7ENM_G      ,K7EnmG)
	ENM_CREATE_DECL(K7ENM_H      ,K7EnmH)
	ENM_CREATE_DECL(K7ENM_DIVE   ,K7EnmI)
	ENM_CREATE_DECL(K7ENM_SU_EGG ,K7EnmJ)
	ENM_CREATE_DECL(K7ENM_SU     ,K7EnmK)
	ENM_CREATE_DECL(K7ENM_L_OYA  ,K7EnmL)
	ENM_CREATE_DECL(K7ENM_L_EGG  ,K7EnmM)
	ENM_CREATE_DECL(K7ENM_ANOT   ,K7EnmN)
	ENM_CREATE_DECL(K7ENM_POIZ   ,K7EnmO)
	ENM_CREATE_DECL(K7ENM_PROT   ,K7EnmP)
	ENM_CREATE_DECL(K7ENM_FANT   ,K7EnmQ)
	ENM_CREATE_DECL(K7ENM_LASE   ,K7EnmR)
	ENM_CREATE_DECL(K7ENM_BACK   ,K7EnmS)
	ENM_CREATE_DECL(K7ENM_HEAD   ,K7EnmT)
	ENM_CREATE_DECL(K7ENM_JAIA   ,K7EnmU)
	ENM_CREATE_DECL(K7ENM_ROLL   ,K7EnmV)
	ENM_CREATE_DECL(K7ENM_BROK   ,K7EnmY)
	ENM_CREATE_DECL(K7ENM_SPIR   ,K7EnmSPI)
	ENM_CREATE_DECL(K7ENM_MYSL   ,K7EnmMYS)
	ENM_CREATE_DECL(K7ENM_HSLASER,K7EnmHSLASER)
	ENM_CREATE_DECL(K7ENM_FDAN   ,K7EnmFDAN)
	ENM_CREATE_DECL(K7ENM_FCAT   ,K7EnmFCAT)
	ENM_CREATE_DECL(K7ENM_FKED   ,K7EnmFKED)
	ENM_CREATE_DECL(K7ENM_FCYO   ,K7EnmFCYO)
	ENM_CREATE_DECL(K7ENM_FMSK   ,K7EnmFMSK)
	ENM_CREATE_DECL(K7ENM_FKVN   ,K7EnmFKVN)
	ENM_CREATE_DECL(K7ENM_FHAC   ,K7EnmFHAC)
	ENM_CREATE_DECL(K7ENM_FGAL   ,K7EnmFGAL)
	// {X֌W
	ENM_CREATE_DECL(K7ENM_FAN    ,K7EnmFAN)
	ENM_CREATE_DECL(K7ENM_KUN    ,K7EnmKUN)
	ENM_CREATE_DECL(K7ENM_TEN    ,K7EnmTEN)
	ENM_CREATE_DECL(K7ENM_UR2    ,K7EnmUR2)

#endif

#endif

#endif

