///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EasyAnim
//
// YK7EasyAnim.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/02/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EASYANIM_H
#define __YK7EASYANIM_H

// include --------------------------------------
//#include <GhmTypes.h>

// define ---------------------------------------

#define EASYANIM_TEXMAXNUM		20	

// data type ------------------------------------

// Aj[V̂PZ̃f[^
typedef struct tagEASYANIMCELL
{
	signed char PatNumber ;				// p^[io[( -1ŉ\Ȃ )
	signed char RandomFlag ;			// t[_lɂ邩AtO
	unsigned char FrameInfo ;			// \t[(_̏ꍇ FrameInfo / 10 ` FramInfo ̊ԂɂȂ)
} EASYANIMCELL ;

// R}ӂ̏(AԃeNX`̎̂ݗL)
typedef struct tagEASYANIMCHIP
{
	unsigned short DrawX ;				// `悷鍶wW
	unsigned short DrawY ;				// `悷鍶xW
} EASYANIMCHIP ;

#if 1

// ȈՃAj[Vwb_
typedef struct tagEASYANIMHEAD
{
	unsigned char FrameInfoNum ;				// Aj[Vp^[̐
	unsigned char LoopFlag ;					// [v邩ǂ̃tO(TRUE: FALSE:Ȃ)
	unsigned short w, h ;						// Pp^[̕ƍ
	unsigned short TexOffset ;					// eNX`f[^i[ĂItZbg
	unsigned short OneFrameTime ;				// Pt[̃`bN^C
	unsigned char TexFormat ;					// eNX`tH[}bg( 0:RGB5A3  1:RGB565  2:RGBA8  1:S3TC  2:I4  3:IA4  4:I8  5:IA8 )
	EASYANIMCHIP ChipInfo[EASYANIM_TEXMAXNUM] ;	// eNX`eR}̏
	EASYANIMCELL FrameInfo[] ;					// Pp^[Ƃ̕\t[(p^[݂̐)
} EASYANIMHEAD ;

#else

// ȈՃAj[Vwb_
typedef struct tagEASYANIMHEAD
{
	unsigned char AnimNum ;				// Aj[Vp^[̐
	unsigned char Pitch ;				// 񂠂ɕłp^̐
	unsigned char LoopFlag ;			// [v邩ǂ̃tO(TRUE: FALSE:Ȃ)
	unsigned short w, h ;				// Pp^[̕ƍ
	unsigned short TexOffset ;			// eNX`f[^i[ĂItZbg
	unsigned short OneFrameTime ;		// Pt[̃`bN^C
	unsigned char FrameInfo[] ;			// Pp^[Ƃ̕\t[(p^[݂̐)
} EASYANIMHEAD ;

#endif

// data -----------------------------------------

// function proto type --------------------------

#endif


