///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBloodPack
//
// YK7EffectBloodPack.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 02/25/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTBLOODPACK_H
#define __YK7EFFECTBLOODPACK_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7String.h"
#include "./YK7Move.h"

// define ---------------------------------------

#define MAXBLOODPACKMETERNUM		20		// ̂܂Ԃ\[^[g̍ő吔

// data type ------------------------------------

// [^[
typedef struct tagBLOODPACKMETER
{
	u8 useflag ;		// gptO
	u8 mode ;			// ( 0:ʉEɏoĂ  1:ʍɊi[ꂽ )
	u8 state ;			// ԂQ
	u8 count ;			// JE^
	u8 count2 ;			// JE^Q
	s16 volume ;		// 󂯎̗ʂ̒l
	u16 bloodmaxnum ;	// 擾\̗̌̐
	u16 bloodnum ;		// 擾̗̐

	CMov charge ;		// [^[̗܂( x:0.0F~1.0F )
	CMov size ;			// TCY( x:0.0F~1.0F )
} BLOODPACKMETER ;

// pbNGtFNgf[^
typedef struct tagBLOODPACKEFFECT
{
	BLOODPACKMETER meter[MAXBLOODPACKMETERNUM] ;	// [^[
	int meternum ;									// [^[̐
	s8 rlist[MAXBLOODPACKMETERNUM] ;				// Ẽ[^[`̃Xg
	s8 llist[MAXBLOODPACKMETERNUM] ;				// ̃[^[`̃Xg
	s8 rnum, lnum ;									// Ẽ[^[̐
	s8 rnum2 ;

	s32 drawy ;			// `xW
	s32 drawx ;			// `wW
	s32 areal ;			// `\̈
	s32 arear ;
	s32 areat ;
	s32 areab ;

	CMov mesp ;			// bZ[W̍W( x:0.0F~1.0F )
	s8 mesnum ;			// bZ[W̔ԍ
	u16 mescount ;		// bZ[W̃JE^
	s8 mesmode ;		// bZ[W̏

	s8 leftstopflag ;	// ʂ̃[^[̓Ƃ߂邩ǂ	
	s8 meterdrawflag ;	// [^[`悷邩ǂ̃tO
} BLOODPACKEFFECT ;

// pbNGtFNgʃf[^
typedef struct tagBLOODPACKUNION
{
	YK7StrImage simage ;				// `ptHgC[WNX
//	BLOODPACKMETER *actmeter ;			// Ɍz|Ɏgp錌[^[̃AhX
	BLOODPACKEFFECT *actpack ;			// z|Ɏgp錌pbNGtFNg̃AhX
	bool actflag ;
} BLOODPACKUNION ;

// data -----------------------------------------

// function proto type --------------------------

extern s8 InitBloodPackData( void ) ;				// pbN̋ʃf[^
extern s8 CheckBloodPackData( void ) ;				// pbNɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndBloodPackData( void ) ;				// pbN̋ʃf[^n

extern EFFECT *CreateBloodPackEffect( s32 Priority = 129 ) ;				// pbN쐬
extern s8 ReleaseBloodPackEffect( EFFECT *effect ) ;						// pbŇns
extern s8 MoveBloodPackEffect( EFFECT *effect ) ;							// pbNPt[
extern s8 DrawBloodPackEffect( EFFECT *effect ) ;							// pbN`悷
extern s8 DelReqBloodPackEffect( EFFECT *effect ) ;							// pbN̍폜]o

extern s8 SetBloodPackDrawX( EFFECT *effect, int x ) ;						// pbN\̂wWύX
extern s8 SetBloodPackDrawY( EFFECT *effect, int y ) ;						// pbN\̂xWύX
extern s8 AddBloodMeter( EFFECT *effect, s16 bloodVolume, u16 bloodmaxnum = 200) ;	// pbN[^[ǉ
extern s8 CloseBloodMeter( void ) ;											// AddBloodMeter ŊJݒ

extern s8 GetBloodPackPos( EFFECT *effect, s8 index, Vec *Pos ) ;	// pbN̍W擾
extern void SetActBloodPack( EFFECT *effect ) ;						// ɋz\̌pbN[^[̃|C^𓾂
extern void SetMeterDrawFlagBloodPack( EFFECT *effect, s8 flag ) ;	// [^[`悷邩ǂ̃tOZbg
extern void SetMeterStopFlagBloodPack( EFFECT *effect, s8 flag ) ;	// ʂ̃[^[̓~߂邩ǂ̃tOZbg( true:~܂  false: )

extern BLOODPACKMETER *GetActBloodMeter( void ) ;					// ɋz\̌pbN[^[̃|C^𓾂
extern s8 GetBloodMeterPos( BLOODPACKMETER *meter, Vec *pos ) ;		// w̃[^[ׂ̌̎W𓾂
extern s8 IncBloodMeterBlood( BLOODPACKMETER *meter ) ;				// pbN[^[Ɍ̗ǉ
extern s8 EndBloodMeterBlood( BLOODPACKMETER *meter ) ;				// pbN[^[Ɍ̗ǉ鏈I

extern bool GetBloodMeterEndState( EFFECT *effect ) ;				// [^[̋zݏIǂ擾( true:I  false:܂ )

#endif	// __YK7EFFECTBLOODPACK_H
