///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBlur
//
// YK7EffectBlur.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTBLUR_H
#define __YK7EFFECTBLUR_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

// datatype -------------------------------------

// u[GtFNgʃf[^
typedef struct tagBLURUNION
{
	f32 AlphaSpeed ;		// Xs[h
	u8 Time ;				// \
	u16 MaxNum ;			// ő吔
} BLURUNION ;

// u[IuWFNgf[^
typedef struct tagBLUROBJECT
{
	u8 vflag ;				// LtO
	Vec p[2] ;				// `悷W
	f32 alpha ;				// At@l
	
	s32 next, back ;
} BLUROBJECT ;

// u[GtFNgf[^
typedef struct tagBLUREFFECT
{
	BLUROBJECT *Obj ;			// IuWFNg
	u16 ObjNum ;				// IuWFNg̐
	u16 MaxNum ;				// ő吔
	s32 first, last ;			// ŏ̃IuWFNg̃CfbNX
	
	f32 AlphaSpeed ;			// Xs[h
	u8 Time ;					// \^C

	WK7JObj *TopJObj, *BotJObj ;// OՕ`Ɏgp JObj
	Vec BTopPos, BBotPos ;		// O JObj1 JObj2 ̍W
	u32 topcolor, botcolor ;	// F
	
	bool createflag ;			// 쐬tO
} BLUREFFECT ;

// u[GtFNg^XNɓnf[^
typedef struct tagBLUREFFECTTACKPARAM
{
	WK7JObj *JObj1, *JObj2 ;	// OՕ`Ɏgp JObj
	u32 color ;					// F
} BLUREFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitBlurData( void ) ;			// u[GtFNg̋ʃf[^
extern s8 CheckBlurData( void ) ;			// u[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndBlurData( void ) ;				// u[GtFNg̋ʃf[^n

extern EFFECT *CreateBlurEffect(
									WK7JObj *JObj,						// FXBlur_Top  FXBlur_Bot Ƃ̃P[^݂ JObj ւ̃|C^
									GXColor topcolor, GXColor botcolor,	// F
									s32 Priority = -2 ) ;				// u[GtFNg쐬

extern EFFECT *CreateBlurEffect(
									WK7JObj *TopJObj, WK7JObj *BotJObj,		// OՕ`Ɏgp JObj
									GXColor topcolor, GXColor botcolor,		// F
									s32 Priority = -2 ) ;				// u[GtFNg쐬
extern s8 ReleaseBlurEffect( EFFECT *Effect ) ;							// u[GtFNǧns
extern s8 MoveBlurEffect( EFFECT *Effect ) ;							// u[GtFNgPt[
extern s8 DrawBlurEffect( EFFECT *Effect ) ;							// u[GtFNg`悷

extern s8 SetBlurCreateFlag( EFFECT *Effect, bool CreateFlag ) ;		// u[GtFNg쐬邩ǂ̃tO

#endif

