///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBreak
//
// YK7EffectBreak.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/08/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTBREAK_H
#define __YK7EFFECTBREAK_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"
#include "../fujita/C_SetAlpha.h"

// define ---------------------------------------

// datatype -------------------------------------

// GtFNgʃf[^
typedef struct tagBREAKUNION
{
	u8 Dummy ;
} BREAKUNION ;

// GtFNgIuWFNgf[^
typedef struct tagBREAKOBJECT
{
	u8 UseFlag ;					// LtO

	WK7JObj *JObj ;					// ꏈ JObj ւ̃|C^
	Vec Speed ;						// Xs[h
	Vec RotSpeed ;					// ]x
	Vec Point, Rotate ;				// WE]l
	f32 Alpha, AlphaSpeed ;			// At@lƃAt@Xs[h
} BREAKOBJECT ;

// GtFNgf[^
typedef struct tagBREAKEFFECT
{
	BREAKOBJECT *ObjP ;				// IuWFNgf[^ւ̃|C^
	s16 ObjNum ;					// IuWFNg̐
	s16 RunObjNum ;					// ĂIuWFNg̐

	GXTexObj TexObj ;				// eNX`IuWFNg
	Vec SSpeed ;					// x

	WK7JObj *JObj ;					// ẽIuWFNg	
	f32 Alpha, AlphaSpeed ;			// At@lƃAt@Xs[h
	C_SetAlpha *CAlpha ;			// At@lZbgpNX
} BREAKEFFECT ;

// GtFNgf[^p\
typedef struct tagBREAKEFFECTTASKPARAM
{
	WK7JObj *JObj ;						// ꏈ JObj ւ̃|C^

	Vec BasePoint ;						// GlM[̊_ƂȂW
	f32 MaxPower, MinPower ;			// ΂p[
	Vec SSpeed ;						// x
	f32 MaxRotSpeed, MinRotSpeed ;		// ]x
	f32 MaxAlphaSpeed, MinAlphaSpeed ;	// At@Xs[h
} BREAKEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitBreakData( void ) ;				// GtFNg̋ʃf[^
extern s8 CheckBreakData( void ) ;				// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndBreakData( void ) ;				// GtFNg̋ʃf[^n

extern EFFECT *CreateBreakEffect( WK7JObj *JObj, Vec BasePoint,
									f32 MaxPower, f32 MinPower, Vec SSpeed,
									f32 MaxRotSpeed, f32 MinRotSpeed,
									f32 MaxAlphaSpeed, f32 MinAlphaSpeed, s32 Priority = -1 ) ;			// GtFNg쐬
extern s8 ReleaseBreakEffect( EFFECT *Effect ) ;							// GtFNǧns
extern s8 MoveBreakEffect( EFFECT *Effect ) ;								// GtFNgPt[
extern s8 DrawBreakEffect( EFFECT *Effect ) ;								// GtFNg`悷


#endif