///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCamera
//
// YK7EffectCamera.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 11/17/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTCAMERA_H
#define __YK7EFFECTCAMERA_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// ĎJGtFNgʃf[^
typedef struct tagCAMERAUNION
{
	TEXDATA FrameTex ;
} CAMERAUNION ;

// ĎJGtFNgf[^
typedef struct tagCAMERAEFFECT
{
	EFFECT *Noise ;					// mCYGtFNg̃|C^
	EFFECT *ScanLine ;				// XLCGtFNg̃|C^
	
	s32 NoiseCounter ;				// mCY𔭐^C~Ov邽߂̃JE^
	s8 NoiseCreateFlag ;			// mCY쐬邩ǂ̃tO
	
	s8 SoundFlag ;					// 炵tO

} CAMERAEFFECT ;

// ĎJGtFNg^XNɓnf[^
typedef struct tagCAMERAEFFECTTACKPARAM
{
	u8 Dummy ;				// _~[
} CAMERAEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitCameraData( void ) ;					// ĎJGtFNg̋ʃf[^
extern s8 CheckCameraData( void ) ;					// ĎJGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndCameraData( void ) ;					// ĎJGtFNg̋ʃf[^n

extern EFFECT *CreateCameraEffect( s32 Priority = 6000 ) ;		// ĎJ̃GtFNg쐬
extern s8 ReleaseCameraEffect( EFFECT *Effect ) ;							// ĎJ̃GtFNǧns
extern s8 MoveCameraEffect( EFFECT *Effect ) ;								// ĎJ̃GtFNgPt[
extern s8 DrawCameraEffect( EFFECT *Effect ) ;								// ĎJ̃GtFNg`悷

extern s8 SetCameraNoiseFlag( EFFECT *Effect, s8 NoiseFlag ) ;		// mCY쐬邩ǂύX

#endif