///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCharGeki
//
// YK7EffectCharGeki.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 11/18/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTCHARGEKI_H
#define __YK7EFFECTCHARGEKI_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Obj.h"
#include "../fujita/c_radialblur.h"
#include "../fujita/c_setalpha.h"
#include "../Wat/WK7Play.h"
#include "../Wat/WK7Model.h"
#include "./YK7EffectMuzzle.h"

// define ---------------------------------------

#define MAX_CHARGEKI_EFFECT_NUM		30

// datatype -------------------------------------

// ̏
typedef struct tagAK_SPHERE
{
	u8 validf ;
	f32 x, y ;
	f32 speed ;
	f32 size ;
} AK_SPHERE ;

// LGtFNgʃf[^
typedef struct tagCHARGEKIUNION
{
	struct WK7PlayEffectInfo *PlayEffectInfo ;		// L֘Ȁ񂪋l܂\̂ւ̃|C^
	
	TEXDATA TV ;									// EC_fer̃eNX`
	TEXDATA ZAKA_TV ;								// wzaka_tv.BINx
	TEXDATA LIVE_PLATE ;							// wlivee_plate.BINx
	TEXDATA LIVE ;									// wlivex
	TEXDATA NOISE ;									// mCYpeNX`
	
	TEXDATA akt_Speed[2] ;							// AJlopeNX`e 
	TEXDATA akt_New[2] ;
	TEXDATA akt_Bg ;
	TEXDATA akt_sphere ;
//	TEXDATA AKN[2] ;								// AJleNX`
	
	WK7ScreenImage *ak_Image1 ;						// XN[C[W
	WK7ScreenImage *ak_Image2 ;						// XN[C[W
	EFFECT *ak_SpeedA, *ak_SpeedB ;					// AJlopGtFNge
	EFFECT *ak_Bg, *ak_BgEx ;
	EFFECT *ak_New ;
	AK_SPHERE *ak_sp ;								// f[^zւ̃|C^
	s32 ak_spnum ;									// ̐
	
	s32 NoiseCon ;
	bool NoiseOnFlag ;
	bool BigNoiseStartFlag ;						// łmCY\邩tO
	s32 BigNoiseCounter1 ;							// łmCY̏pJE^[
	s32 BigNoiseCounter2 ;
	
	EFFECT *eftable[MAX_CHARGEKI_EFFECT_NUM] ;		// LŎgĂGtFNg
	u32 efidtable[MAX_CHARGEKI_EFFECT_NUM] ;		// LŎgĂGtFNĝhc
	s32 efnum ;										// LŎgĂGtFNg̐
	
	u8 SMod ;
	
	bool YureStartFlag ;				// hJntO
	bool YureEndFlag ;					// hItO
	s32 YureCon, YureCon2 ;				// hJE^

	C_SetAlpha *C_Alpha ;				// NX
	bool AlphaEndFlag ;					// ItO
	f32 Alpha ;							// 
	
	C_RadialBlur *RadialBlur ;			// NE̎肪rJrJ鏈Ɏgp
	EFFECT *Muzzle, *Muzzle2 ;			// }YtbV
	u32 MuzzleID, MuzzleID2 ;			// }YtbV̂hc
	EFFECT *CarBlood ;					// ԓŌꂽ̌
	EFFECT *Imi1Blood ;					// ږǂŌPlڂ̌
	EFFECT *Imi2Blood ;					// ږǂŌQlڂ̌
	EFFECT *Imi3Blood ;					// ږǂŌRlڂ̌
	EFFECT *Imi4Blood ;					// ږǂŌSlڂ̌
	EFFECT *HSDead ;					// wuX}C
	EFFECT *Noise ;						// mCYGtFNg
	EFFECT *Effect ;					// ėp
	s32 Counter ;						// ėpJE^
	EFFECT *KunSmoke ;					// ÑX[N
	EFFECT *MFire ;						// ft@CAGtFNg
	EFFECT *Screen ;					// XN[GtFNg
	EFFECT *BillEff ;					// r{[hGtFNg
	
	WK7JObj *Head ;						// f
	Vec HeadPos ;						// W
	Vec HeadRot ;						// ]
	Vec HeadSpeed ;						// x
	Vec HeadRotSpeed ;					// ]x

	WK7JObj *MissileBill[4][21] ;		// ~TCWK7JObj
	Vec MisBackPos[4][21] ;				// ~TC̑Ot[̍W
	EFFECT *MuzCloud[2] ;				// }YtbV̉
	Vec MuzBackPos[2] ;					// }Y̑OW
	s8 MuzCloudFlag[2] ;				// }ỶotO
	EFFECT *MissileEffect ;				// ~TCGtFNgւ̃|C^
	EFFECT *JetEffect[13] ;				// WFbg̃GtFNg
	u32 JetEffectID[13] ;				// WFbgGtFNĝhc
	WK7JObj *JetJObj[13] ;				// WFbgWK7JObj
	Vec JetBackPos[13] ;				// WFbĝPt[O̍W
	s32 GunDataID[GUN_NUM] ;			// êhc
	f32 YukaY ;							// ̍
} CHARGEKIUNION ;

// LGtFNgf[^
typedef struct tagCHARGEKIEFFECT
{
	s16 mode ;
	s32 con, con2 ;
	s16 EffectNumber  ;		// GtFNgԍ
	
	EFFECT *Effect ;		// ėpGtFNg|C^
	u32 EffectID ;			// ėpGtFNghc
} CHARGEKIEFFECT ;

// LGtFNg^XNɓnf[^
typedef struct tagCHARGEKIEFFECTTACKPARAM
{
	WK7JObj *JObj ;			// GtFNgɕKv WK7JObj ւ̃|C^
	s16 EffectNumber  ;		// GtFNgԍ
} CHARGEKIEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitCharGekiData( void ) ;							// LGtFNg̋ʃf[^
extern s8 CheckCharGekiData( void ) ;							// LGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndCharGekiData( void ) ;								// LGtFNg̋ʃf[^n

extern s8 SetCharGekiPlayEffectInfo( struct WK7PlayEffectInfo *PlayEffectInfo ) ;	// WK7PlayEffectInfo \̂̃|C^Zbg
extern s8 SetupCharGekiEffect( s16 EffectNumber ) ;				// LŎgpGtFNg̏s
extern s8 CheckCharGekiEffectSetup( s16 EffectNumber ) ;		// LŎgpGtFNg̏I`FbN( TRUE:  FALSE: )
extern s8 EndCharGekiEffect( s16 EffectNumber ) ;				// LŎgpGtFNǧn

extern EFFECT *CreateCharGekiEffect( s16 EffectNumber, s32 Priority ) ;		// L̃GtFNg쐬
extern s8 ReleaseCharGekiEffect( EFFECT *Effect ) ;				// L̃GtFNǧns
extern s8 MoveCharGekiEffect( EFFECT *Effect ) ;				// L̃GtFNgPt[
extern s8 DrawCharGekiEffect( EFFECT *Effect ) ;				// L̃GtFNg`悷
extern s8 SetCharGekiKunSmokePoint( EFFECT *KunSmoke ) ;		// N̉o^


#endif