///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCloud
//
// YK7EffectCloud.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 02/05/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectCloud.h"
#include "./YK7EffectSmoke.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

CLOUDUNION ClUnion ;

// function proto type --------------------------

// function code --------------------------------

// _GtFNg̋ʃf[^
extern s8 InitCloudData( void )
{
	MEMINIT( ClUnion ) ;

	// I
	return 0 ;
}

// _tFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckCloudData( void )
{
	return TRUE ;
}


// _GtFNg̋ʃf[^n
extern s8 EndCloudData( void )
{
	// I
	return 0 ;
}


// _̃GtFNg쐬
extern EFFECT *CreateCloudEffect(	f32 Size,						// 傫
									u16 MaxObjNum,					// IuWFNg̍ő吔
									f32 AlphaDownSpeed,				// At@l鑬x
									f32 InitAlpha,					// At@l
									GXColor Color,					// F
									s32 Priority )
{
	EFFECT *Effect ;
	CLOUDEFFECT *Cl ;
	CLOUDOBJECT *Ob ;

	// t@C̓ǂݍ݂IĂȂ牽ɏI
	if( CheckCloudData() == FALSE ) return 0 ;

	// ̊m
	Ob = ( CLOUDOBJECT * )K7AppSmallMemAllocName( (s32)( ( sizeof( CLOUDOBJECT ) + sizeof( u16 ) ) * MaxObjNum ), "Y_CloudObj" ) ;
	if( Ob == NULL ) return NULL ;
	memset( Ob, 0, ( sizeof( CLOUDOBJECT ) + sizeof( u16 ) ) * MaxObjNum ) ;

	// V_f[^쐬
	Effect = AddEffectData( EFF_CLOUD, (void**)&Cl, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( Ob ) ;
		return NULL ;
	}

	// p[^ۑ
	Cl->Size = Size ;
	Cl->MaxObjNum = MaxObjNum ;
	Cl->AlphaDownSpeed = AlphaDownSpeed ;
	Cl->InitAlpha = InitAlpha ;
	Cl->Color = Color ;

	Cl->RenderList = (u16*)( (u8*)Ob + sizeof( CLOUDOBJECT ) * MaxObjNum ) ;
	Cl->RenderNum = 0 ;
	Cl->VertCounter = 0 ;
	Cl->ValidCounter= 0 ;
	Cl->ObjP = Ob ;
	Cl->ObjNum = 0 ;
	Cl->Mode = 0 ;
	
	// I
	return Effect ;
}

// _̃GtFNǧns
extern s8 ReleaseCloudEffect( EFFECT *Effect )
{
	CLOUDEFFECT *Cl = ( CLOUDEFFECT * )Effect->Data ;

	// _GtFNgIuWFNgp̃J
	CHKMEMFREE2( Cl->ObjP ) ;
	
	// I
	return 0 ;
}

// _̃GtFNgPt[
extern s8 MoveCloudEffect( EFFECT *Effect )
{
	CLOUDEFFECT *Cl = ( CLOUDEFFECT * )Effect->Data ;
	u32 i, j, Num ;
	CLOUDOBJECT *Ob ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂăIuWFNgO폜
	if( Effect->DelReqFlag == TRUE && Cl->ObjNum == 0 ) 
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// _̐JԂ
	Num = Cl->ObjNum ;
	Ob = Cl->ObjP ;
	Cl->VertCounter = 0 ;
	Cl->RenderNum = 0 ;
	for( i = 0, j = 0 ; i < Num ; Ob ++, j ++ )
	{
		// LtOĂȂ牽Ȃ
		if( Ob->ValidFlag == FALSE ) continue ;

		Ob->Alpha -= Cl->AlphaDownSpeed ;
		if( Ob->Alpha < 0.0F )
		{
			Cl->ObjNum -- ;
			Ob->ValidFlag = FALSE ;
		}
		else
		{
			Cl->RenderList[Cl->RenderNum] = (u16)j ;
			Cl->RenderNum ++ ;
		}

		i ++ ;
	}

	// I
	return 0 ;
}

// _̃GtFNg`悷
extern s8 DrawCloudEffect( EFFECT *Effect )
{
	CLOUDEFFECT *Cl = ( CLOUDEFFECT * )Effect->Data ;
	u32 j ;
	Mtx TMtx ;
	CLOUDOBJECT *Ob, *ObjP ;
	CLOUDUNION *CloudUnion = &ClUnion ;
	Vec CamP, p2[4] ;
	Vec p[4] ;

	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_USETEX, TRUE ) ;
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_2, GX_TRUE, GX_TEVPREV ) ;
	
	// eNX`̃[h
	GTLOAD( GetSmokeTex() ) ;
	
	// J̈ʒu擾
	HSD_CObjGetEyePosition( GetEffectCamera(), &CamP ) ;	

	// ]us擾
	EffectGetInvViewMatrix( TMtx ) ;

	// `揈
	if( Cl->RenderNum != 0 )
	{
		s32 DrawNum, NokoriNum, Count ;
		u16 MaxVertNum ;
	
		MaxVertNum = (u16)( 65535 * ( (f32)VParam[ED_CLOUD][19] * 0.01F ) ) ;
		DrawNum = NokoriNum = Cl->RenderNum ;
		if( DrawNum * 4 > MaxVertNum ) DrawNum = MaxVertNum / 4 ;
		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( DrawNum * 4 ) ) ;
		NokoriNum -= DrawNum ;
		Count = 0 ;

		{
			u32 Num ;
//			f32 a ;
//			u8 ba ;
			u16 *List ;
			f32 Size/*, AddX*/ ;
			u32 cr ;

			Size = Cl->Size ;
			p[0].x = -Size ; p[0].y = Size ; p[0].z = 0.0F ;
			p[1].x = Size ; p[1].y = Size ; p[1].z = 0.0F ;
			p[2].x = Size ; p[2].y = -Size ; p[2].z = 0.0F ;
			p[3].x = -Size ; p[3].y = -Size ; p[3].z = 0.0F ;

			PSMTXMultVec( TMtx, &p[0], &p2[0] ) ;
			PSMTXMultVec( TMtx, &p[1], &p2[1] ) ;
			PSMTXMultVec( TMtx, &p[2], &p2[2] ) ;
			PSMTXMultVec( TMtx, &p[3], &p2[3] ) ;
				
			Num = Cl->RenderNum ;
			List = Cl->RenderList ;
			ObjP = Cl->ObjP ;
			for( j = 0 ; j < Num ; j ++, List ++ )
			{
				Ob = &ObjP[*List] ;

//				ba = (u8)(  ) ;
				cr = CMKC2( Cl->Color, Ob->Alpha / 2 >= 1.0F ? Cl->Color.a : Ob->Alpha / 2 * Cl->Color.a ) ;

				// _̃Zbg
//				GP3( p2[0].x * Ob->Alpha + Ob->Pos1.x, p2[0].y * Ob->Alpha + Ob->Pos1.y, p2[0].z * Ob->Alpha + Ob->Pos1.z ) ;
				GPV3( p2[0], Ob->Pos1 ) ;	GCX( cr ) ;		GT( 0.0F, 0.0F ) ;

//				GP3( p2[1].x * Ob->Alpha + Ob->Pos1.x, p2[1].y * Ob->Alpha + Ob->Pos1.y, p2[1].z * Ob->Alpha + Ob->Pos1.z ) ;
				GPV3( p2[1], Ob->Pos1 ) ;	GCX( cr ) ;		GT( 1.0F, 0.0F ) ;

//				GP3( p2[2].x * Ob->Alpha + Ob->Pos1.x, p2[2].y * Ob->Alpha + Ob->Pos1.y, p2[2].z * Ob->Alpha + Ob->Pos1.z ) ;
				GPV3( p2[2], Ob->Pos1 ) ;	GCX( cr ) ;		GT( 1.0F, 1.0F ) ;

//				GP3( p2[3].x * Ob->Alpha + Ob->Pos1.x, p2[3].y * Ob->Alpha + Ob->Pos1.y, p2[3].z * Ob->Alpha + Ob->Pos1.z ) ;
				GPV3( p2[3], Ob->Pos1 ) ;	GCX( cr ) ;		GT( 0.0F, 1.0F ) ;

				Count ++ ;
				if( Count == DrawNum )
				{
					GXEnd() ;
					
					if( NokoriNum != 0 )
					{
						DrawNum = NokoriNum ;
						if( DrawNum * 4 > MaxVertNum ) DrawNum = MaxVertNum / 4 ;
						GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( DrawNum * 4 ) ) ;
						NokoriNum -= DrawNum ;
					}
					Count = 0 ;
				}
			}
		}
		if( Count != 0 ) GXEnd() ;
	}
	
	// I
	return 0 ;
}					

// _IuWFNgǉ
extern s8 AddCloudObject( Vec Pos1, Vec Pos2, EFFECT *Effect )
{
	CLOUDEFFECT *Cl = ( CLOUDEFFECT * )Effect->Data ;
	CLOUDOBJECT *Ob ;
	
	// ǉ
	if( Cl->ObjNum != Cl->MaxObjNum )
	{
		// gĂȂJf[^T
		for( Ob = &Cl->ObjP[Cl->ValidCounter] ; Ob->ValidFlag == TRUE ; )
		{
			Cl->ValidCounter ++ ;
			Ob ++ ;
			if( Cl->ValidCounter == Cl->MaxObjNum )
			{
				Ob = Cl->ObjP ;
				Cl->ValidCounter = 0 ;
			}
		}

		Cl->RenderList[Cl->RenderNum] = (u16)Cl->ValidCounter ;
		Cl->RenderNum ++ ;
		
		Cl->ValidCounter ++ ;
		if( Cl->ValidCounter == Cl->MaxObjNum ) Cl->ValidCounter = 0 ;

		// LtO𗧂Ă
		Ob->ValidFlag = TRUE ;

		// 𑝂₷
		Cl->ObjNum ++ ;

		// ̃Zbg
		Ob->Pos1 = Pos1 ;
		Ob->Pos2 = Pos2 ;
		Ob->Alpha = Cl->InitAlpha ;
	}
	
	// I
	return 0 ;
}



