///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCloud
//
// YK7EffectCloud.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 02/05/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTCLOUD_H
#define __YK7EFFECTCLOUD_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// _GtFNgʃf[^
typedef struct tagCLOUDUNION
{
	u8 Dummy ;
} CLOUDUNION ;

// _IuWFNgf[^
typedef struct tagCLOUDOBJECT
{
	u8 ValidFlag ;				// LtO
	Vec Pos1, Pos2 ;			// W
	f32 Alpha ;					// At@l
} CLOUDOBJECT ;

// _GtFNgf[^
typedef struct tagCLOUDEFFECT
{
	CLOUDOBJECT *ObjP ;				// _IuWFNgf[^zւ̃|C^
	u16 *RenderList ;				// `惊Xg
	u16 RenderNum ;					// `搔
	u16 ObjNum ;					// _IuWFNg̐
	u8 Mode ;						// `惂[h(0:Add  1:Alpha)

	f32 Size ;						// 傫
	u16 MaxObjNum ;					// IuWFNg̍ő吔
	f32 AlphaDownSpeed ;			// At@l鑬x
	f32 InitAlpha ;					// At@l
	GXColor Color ;					// F

	s32 ValidCounter ;
	s32 VertCounter ;				// _JE^[
} CLOUDEFFECT ;

// _GtFNg^XNɓnf[^
typedef struct tagCLOUDEFFECTTACKPARAM
{
	f32 Size ;						// 傫
	u16 MaxObjNum ;					// IuWFNg̍ő吔
	f32 AlphaDownSpeed ;			// At@l鑬x
	f32 InitAlpha ;					// At@l
	GXColor Color ;					// F
} CLOUDEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitCloudData( void ) ;				// _GtFNg̋ʃf[^
extern s8 CheckCloudData( void ) ;				// _tFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndCloudData( void ) ;					// _GtFNg̋ʃf[^n

extern EFFECT *CreateCloudEffect(	f32 Size,						// 傫
								 	u16 MaxObjNum,					// IuWFNg̍ő吔
									f32 AlphaDownSpeed,				// At@l鑬x
									f32 InitAlpha,					// At@l
									GXColor Color,					// F
									s32 Priority = -2 ) ;			// _̃GtFNg쐬
extern s8 ReleaseCloudEffect( EFFECT *Effect ) ;					// _̃GtFNǧns
extern s8 MoveCloudEffect( EFFECT *Effect ) ;						// _̃GtFNgPt[
extern s8 DrawCloudEffect( EFFECT *Effect ) ;						// _̃GtFNg`悷

extern s8 AddCloudObject( Vec Pos1, Vec Pos2, EFFECT *Effect ) ;	// _IuWFNgǉ

#endif

