///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectConveConveBlood2
//
// YK7EffectConveConveBlood2.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/23/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTCONVEBLOOD2_H
#define __YK7EFFECTCONVEBLOOD2_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

// data type ------------------------------------

// QGtFNgʃf[^
typedef struct tagCONVEBLOOD2UNION
{
	Vec StartPos ;
	bool StartPosFlag ;
	
	u32 color1, color2 ;
	bool colorvalid ;
	
	u8 ConveTime ;
	f32 ConveSpeed ;			// 悤Ƃ
	
	s32 TexNumber ;				// eNX`io[
} CONVEBLOOD2UNION ;

// QIuWFNgf[^
typedef struct tagCONVEBLOOD2OBJECT
{
	u8 vflag ;			// LtO
	u8 mode ;			// [h( 0:ڕWWֈړ  1:V )
	Vec pos, apos ;		// ڕWWA΍W
	Vec dir ;			// ڕW
	f32 len ;			// ڕW܂ł̋
	f32 speed ;			// x
	Vec speed2 ;
	f32 size ;			// TCY

	u8 wait ;			// ҂
	f32 u, v ;			// ̃p^[̃eNX`W
	u8 rot ;			// ]px(0:0 1:90 2:180 3:270)
	GXColor color ;		// F
} CONVEBLOOD2OBJECT ;

// QGtFNgf[^
typedef struct tagCONVEBLOOD2EFFECT
{
	CONVEBLOOD2OBJECT *Obj ;		// IuWFNgւ̃|C^
	u32 ObjNum ;					// IuWFNg̐
	u32 EndNum ;					// IIuWFNg̐

	f32 rot ;						// ]JE^
	f32 MaxLen, MinLen ;			// 
	u32 counter ;					// ėpJE^[
	f32 FloatObjNum ;				// Ɏgps_^̃IuWFNg̐
	f32 speed ;						// 鑬x
	f32 size ;						// TCY
	f32 rate ;						// ʐϕӂ̃IuWFNg̍쐬
	WK7JObj *Target ;				// ڕW̃bV

	EFFECT *MeshEffect ;			// bVGtFNgւ̃|C^
	s32 MeshAlpha ;					// bVGtFNg̃At@
	u8 Mode ;						// ̐

	u8 ConveTime ;					// Ɋ|鎞
	f32 ConveSpeed ;				// 悤Ƃ
	
	s32 TexNumber ;					// eNX`io[
} CONVEBLOOD2EFFECT ;

// prototype ------------------------------------

extern s8 InitConveBlood2Data( void ) ;				// QGtFNg̋ʃf[^
extern s8 CheckConveBlood2Data( void ) ;			// QGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndConveBlood2Data( void ) ;				// QGtFNg̋ʃf[^n

extern EFFECT *CreateConveBlood2EffectKamen( 
												WK7JObj *Target,			// ڕW̃bV
												f32 x, f32 y,				// JnW
												s32 Priority = -130 ) ;		// lʗpȈՊ֐

extern EFFECT *CreateConveBlood2Effect( 
										WK7JObj *Target,			// ڕW̃bV
										f32 MaxLen, f32 MinLen,		// 
										f32 speed,					// 鑬x
										f32 size,					// TCY
										f32 rate,					// ʐϕӂ̃IuWFNg̍쐬
										s32 Priority = -130 ) ;				// QGtFNg쐬
extern s8 ReleaseConveBlood2Effect( EFFECT *Effect ) ;						// QGtFNǧns
extern s8 MoveConveBlood2Effect( EFFECT *Effect ) ;							// QGtFNgPt[
extern s8 DrawConveBlood2Effect( EFFECT *Effect ) ;							// QGtFNg`悷

extern s8 GetConveBlood2EffectState( EFFECT *Effect ) ;				// Ԃ𓾂( 0:W 1:I )
extern s8 SetConveBlood2StartPosition( Vec Pos, bool ValidFlag ) ;	// w̍W猌oݒs
extern s8 SetConveBlood2ConveTime( u8 Time ) ;						// Ɋ|鎞Ԃݒ肷
extern s8 SetConveBlood2ConveSpeed( f32 ConveSpeed ) ;				// gpƂ͂ݒ肷

extern s8 SetConveBlood2TextureID( s32 TexNumber ) ;				// gp錌eNX`̔ԍݒ肷
extern s8 SetConveBlood2Color( u32 color1, u32 color2 ) ;			// ̐Fݒ肷

#endif	// __YK7EFFECTCONVEBLOOD2_H




