///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectDamage
//
// YK7EffectDamage.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/06/2003
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectDamage.h"
#include "./YK7EffectFlyBlood.h"

// define ---------------------------------------

#define PR1			VParam[ED_DAMAGE]
#define PR2			VParam[ED_DAMAGE2]
#define PR3			VParam[ED_FLYBLOOD2]
#define PR4			VParam[ED_FLYBLOOD]

// datatype -------------------------------------

// data -----------------------------------------

DAMAGEUNION DamUnion ;

// function proto type --------------------------

static void DamageNumScanCallBack( WK7JObj *JObj, void *Data ) ;			// |S̐𐔂邽߂̃R[obN
static void DamageObjectScanCallBack( WK7JObj *JObj, void *Data ) ;		// IuWFNg̈ʒuݒ肷邽߂̃R[obN
static s8 DamageObjectScanPolyCallBack( Vec **Point, void *Data ) ;		// IuWFNg̈ʒuݒ肷邽߂̃|SXLR[obN֐

//static void DamageLengthScanCallBack( WK7JObj *JObj, void *Data ) ;		// Cӂ̍Wƒ_Ƃ̋v邽߂̃R[obN֐
//static void DamageLengthPolyScanCallBack( Vec *Point, void *Data ) ;		// Cӂ̍Wƒ_Ƃ̋v邽߂̃R[obN֐(|Sp)

// function code --------------------------------

// _[WGtFNg̋ʃf[^
extern s8 InitDamageData( void )
{
	MEMINIT( DamUnion ) ;

	// I
	return 0 ;
}


// _[WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckDamageData( void )
{
	return TRUE ;
}

// _[WGtFNg̋ʃf[^n
extern s8 EndDamageData( void )
{
	MEMINIT( DamUnion ) ;

	// I
	return 0 ;
}



// |S̐𐔂邽߂̃R[obN
static void DamageNumScanCallBack( WK7JObj *JObj, void *Data )
{
	DAMAGEEFFECTINIT *InitData = ( DAMAGEEFFECTINIT * )Data ;
	s32 hr ;
	
	// |S̐Z
	hr = GetJObjMeshPolygonNum( JObj->GetJObj() ) ;
	if( hr < -1 ) return ;
	InitData->PolygonNum += hr ;
}

// IuWFNg̈ʒuݒ肷邽߂̃R[obN
static void DamageObjectScanCallBack( WK7JObj *JObj, void *Data )
{
	DAMAGEEFFECTINIT *InitData = ( DAMAGEEFFECTINIT * )Data ;
	MESH *Mesh ;
	BASICMESH *BasM ;
	HSD_DObj *dobj ;

	if( ( dobj = GetHaveMeshDObj( JObj->GetJObj() ) ) == NULL ) return ;

	// bVf[^̍쐬
	if( CreatePrimitiveMeshData( JObj->GetJObj(), dobj, dobj->pobj, &Mesh, FALSE, TRUE, FALSE, FALSE, TRUE ) == -1 ) return ;
	if( CreateBasicPrimitiveMeshData( Mesh, &BasM, TRUE, FALSE, TRUE, TRUE ) == -1 )
	{
		DeletePrimitiveMeshData( Mesh ) ;
		return ;
	}
	
	// JObj Zbg
	InitData->ActJObj = JObj ;
	InitData->Counter = 0 ;

	// |S𑖍
	ScanMeshPrimitive( BasM, DamageObjectScanPolyCallBack, Data ) ;
	
	// bVf[^̉
	DeleteBasicMeshData( BasM ) ;
	DeletePrimitiveMeshData( Mesh ) ;
}

// IuWFNg̈ʒuݒ肷邽߂̃|SXLR[obN֐
static s8 DamageObjectScanPolyCallBack( Vec **Point, void *Data )
{
	DAMAGEEFFECTINIT *InitData = ( DAMAGEEFFECTINIT * )Data ;
	DAMAGEEFFECT *Damage = InitData->Data ;
	DAMAGEOBJECT *Obj ;

	Point = Point ;

	// ̊mőI肳
	if( InitData->HitRate > (f32)rand()	/ RAND_MAX )
//	if( rand() * ( InitData->PolygonNum / InitData->MaxObjectNum ) / RAND_MAX == 0 )
	{
//		Vec /*Pos,*/ Normal, d1, d2 ;
//		Mtx mtx ;
//		HSD_JObj *JObj ;
		
		// ɃIuWFNgς牽I
		if( Damage->ObjectNum >= MAX_OBJECTNUM ) return -1 ;

		// I肳ꂽ炻̃|Sʂ̖@𓾂
/*		PSVECSubtract( Point[1], Point[0], &d1 ) ;
		PSVECSubtract( Point[2], Point[0], &d2 ) ;
		PSVECCrossProduct( &d1, &d2, &Normal ) ;
		PSVECNormalize( &Normal, &Normal ) ;
*/
		// W̃Zbg		
//		Pos.x = ( Point[0].x + Point[1].x + Point[2].x ) / 3.0F  ; 
//		Pos.y = ( Point[0].y + Point[1].y + Point[2].y ) / 3.0F  ; 
//		Pos.z = ( Point[0].z + Point[1].z + Point[2].z ) / 3.0F  ; 
//		Pos = *Point[0] ;
			
		// WƖ@A]{[̃[JɗƂ
/*		{
			JObj = InitData->ActJObj->GetJObj() ;
			
			// vZĂȂƂ܂̂Łc
			HSD_JObjSetupMatrix( JObj ) ;

			if( JObj->envelopemtx == NULL )
			{
				if( MTXInverse( JObj->mtx, mtx ) == 0 ) return ;
			}
			else
			{
				memcpy( mtx, JObj->envelopemtx, sizeof( mtx ) ) ;
			}
			MTXMultVec( mtx, &Pos, &Pos ) ;
			mtx[0][3] = mtx[1][3] = mtx[2][3] = 0.0F ;
			MTXMultVec( mtx, &Normal, &Normal ) ;
		}
*/

		// VIuWFNgǉ
		Obj = &Damage->Object[Damage->ObjectNum] ;
		
		// IuWFNg̏Zbg
		Obj->JObj = InitData->ActJObj ;
		Obj->Counter = 0 ;
		Obj->VertexNumber = InitData->Counter ;
		Obj->WaitCounter = 1 ; 
//		Obj->Direction = Normal ;
//		Obj->Position = Pos ;

		// IuWFNg̐𑝂₷
		Damage->ObjectNum ++ ;
	}
	InitData->Counter ++ ;
	
	return 0 ;
}



// _[WGtFNg쐬
extern EFFECT *CreateDamageEffect( WK7JObj *JObj, s32 MaxWait, s32 MaxTime, s32 AllTime, f32 YukaY, s32 Priority )
{
	EFFECT *Effect ;
	DAMAGEEFFECT *DamageP ;
	DAMAGEEFFECTINIT InitData ;
	
	// V_[Wf[^쐬
	Effect = AddEffectData( EFF_DAMAGE, (void**)&DamageP, Priority ) ;
	if( Effect == NULL ) return NULL ;
	memset( DamageP, 0, sizeof( DAMAGEEFFECT ) ) ;

	// _[WGtFNg̃f[^
	DamageP->JObj = JObj ;
	DamageP->ObjectNum = 0 ;
	DamageP->MaxWait = MaxWait ;
	DamageP->MaxTime = MaxTime ;
	DamageP->AllTime = (u8)( AllTime + 2 ) ;
	DamageP->Counter = 0 ;
	DamageP->YukaY = YukaY ;

	// f[^̏
	InitData.Data = DamageP ;
	InitData.PolygonNum = 0 ;
	InitData.MaxObjectNum = MAX_OBJECTNUM ;
	
	// ׂẴbV𑖍
	ScanPrimitiveJObj( JObj, DamageNumScanCallBack, &InitData ) ;
//	InitData.PolygonNum = GetJObjMeshPolygonNum( JObj->GetJObj() ) ;

	// IuWFNgˌɑI肳mZbg
	InitData.HitRate = ( (f32)InitData.MaxObjectNum / InitData.PolygonNum ) ;
	
	// ĂтׂẴbV𑖍
	ScanPrimitiveJObj( JObj, DamageObjectScanCallBack, &InitData ) ;

	// I
	return Effect ;
}

// _[WGtFNǧns
extern s8 ReleaseDamageEffect( EFFECT *Effect )
{
	DAMAGEEFFECT *DamageEffect = ( DAMAGEEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// _[WGtFNgPt[
extern s8 MoveDamageEffect( EFFECT *Effect )
{
	DAMAGEEFFECT *Damage = ( DAMAGEEFFECT * )Effect->Data ;
	DAMAGEOBJECT *Obj ;
	u32 i ;
	
//	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	Damage->Counter ++ ;
	if( Damage->Counter >= Damage->AllTime )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// ׂẴIuWFNgs
	Obj = Damage->Object ;
	for( i = 0 ; i < Damage->ObjectNum ; i ++, Obj ++ )
	{
//		// JE^ÔƂ̂ݔ
//		if( Obj->Counter == 0 )

		// ҂Ԃo߂甭˂
		Obj->WaitCounter -- ;
		if( Obj->WaitCounter <= 0 )
		{
			GXColor Color ;
			Vec Point, Dir ;
			
			Obj->WaitCounter = Damage->MaxTime * rand() / RAND_MAX + 3 ;

			Color.r = (u8)PR4[14] ;
			Color.g = (u8)PR4[15] ;
			Color.b = (u8)PR4[16] ;
			Point.x = PR4[8] ;
			Point.y = PR4[9] ;
			Point.z = PR4[10] ;
			Dir.x = -PR4[11] * 0.1F ;
			Dir.y = PR4[12] * 0.1F ;
			Dir.z = 0/*PR4[13]*/ * 0.1F ;
			CreateFlyBloodEffect( Point, Dir, PI / 40 * PR4[2], PR4[0] * 0.1F, PR4[1] * 0.1F,  
									PI / 40 * PR4[6], PI / 40 * PR4[7], PR4[4] * 0.01F,
									1.0F - PR4[5] * 0.001F, PR4[18] * 0.001F, (u8)PR4[3], Damage->YukaY + 0.5F,
									PR4[19], PR4[20],
									Color, (u8)PR4[17],
									PR4[22] * 0.001f, (s16)Obj->WaitCounter/*(s16)PR4[23]*/, Obj->JObj, Obj->VertexNumber,
									0.0F, 0,
									PR1[3], PR1[4] ) ;

//			Obj->WaitCounter += Damage->MaxWait * rand() / RAND_MAX + 3 ;
			Obj->WaitCounter = 100000 ;
		}
		
//		Obj->Counter ++ ;
	}
	
	// JEgi߂
//	Damage->Counter ++ ;

	// I
	return 0 ;
}

// _[WGtFNg`悷
extern s8 DrawDamageEffect( EFFECT *Effect )
{
	DAMAGEEFFECT *DamageEffect = ( DAMAGEEFFECT * )Effect->Data ;
	
	// I
	return 0 ;
}

/*
// Cӂ̍Wƒ_Ƃ̋v邽߂̃R[obN֐
static void DamageLengthScanCallBack( WK7JObj *JObj, void *Data )
{
	MESH *Mesh ;
	BASICMESH *BasM ;
	DAMAGEEFFECTFUNC *LengthInfo = ( DAMAGEEFFECTFUNC * )Data ;
	s8 Result ;
	
	// bVf[^̍쐬
	if( CreatePrimitiveMeshData( JObj->GetJObj(), JObj->GetJObj()->u.dobj->pobj, &Mesh, FALSE, TRUE, FALSE, FALSE ) == -1 ) return ;
	Result = CreateBasicPrimitiveMeshData( Mesh, &BasM, TRUE, FALSE, TRUE ) ;
	DeletePrimitiveMeshData( Mesh ) ;
	if( Result == -1 ) return ;

	// bVf[^̑
	LengthInfo->JObj = JObj ;
	LengthInfo->PointCounter = 0 ;
	ScanMeshPrimitive( BasM, DamageLengthPolyScanCallBack, Data ) ;

	// bVf[^̉
	DeleteBasicMeshData( BasM ) ;
}

// Cӂ̍Wƒ_Ƃ̋v邽߂̃R[obN֐(|Sp)
static void DamageLengthPolyScanCallBack( Vec *Point, void *Data )
{
	s32 i ;
	f32 Length ;
	DAMAGEEFFECTFUNC *LengthInfo = ( DAMAGEEFFECTFUNC * )Data ;

	for( i = 0 ; i < 3 ; i ++, LengthInfo->PointCounter ++ )
	{
		// 擾
		Length = PSVECDistance( &Point[i], &LengthInfo->Point ) ;
		
		// ră\[g
		{
			DAMAGEEFFECTFUNCCHIP *Chip1, *Chip2, *Chip ;
			
			Chip1 = &LengthInfo->Chip[0] ;
			Chip2 = NULL ;
			while( Chip1 != NULL && Chip1->Length <= Length )
			{
				Chip2 = Chip1 ;
				Chip1 = Chip1->Next ;
			}
			if( Chip1 == NULL )
			{
				if( LengthInfo->MaxNum == LengthInfo->Num ) continue ;
				
				Chip = &LengthInfo->Chip[ LengthInfo->Num ] ;
				LengthInfo->Num ++ ;

				Chip->Back = Chip2 ;
				Chip->Next = NULL ;
				Chip2->Next = Chip ;				

				LengthInfo->LastChip = Chip ;
			}
			else
			{
				// Sꍇ͒e
				if( Chip1->Length == Length ) continue ;

				if( LengthInfo->MaxNum == LengthInfo->Num )
				{
					Chip = LengthInfo->LastChip ;
					Chip->Back->Next = NULL ;
					LengthInfo->LastChip = Chip->Back ;
				}
				else
				{
					Chip = &LengthInfo->Chip[ LengthInfo->Num ] ;
					LengthInfo->Num ++ ;
				}

				Chip->Back = Chip2 ;
				if( Chip1 == Chip )
				{
					Chip->Next = NULL ;
					LengthInfo->LastChip = Chip ;
				}
				else
				{
					Chip->Next = Chip1 ;
					Chip1->Back = Chip ;
				}
				Chip2->Next = Chip ;
			}

			Chip->Length = Length ;
			Chip->JObj = LengthInfo->JObj ;
			Chip->Number = LengthInfo->PointCounter ;
		}
	}
}
*/

// _[WGtFNg̏ꏊw^
extern EFFECT *CreateDamageBlood( WK7JObj *JObj, Vec Point, u8 Num, f32 YukaY, s32 Time, f32 Power, u8 Type  )
{
	EFFECT *pRetEffect;
	LENGTHLIST LengthInfo ;
	s32 T = Time ;
	
	WK7RenderObjEffectInfo	info;
	
	// XL
	CreateLengthList( JObj, Point, &LengthInfo, Num ) ;

/*	// ṽf[^
	memset( &LengthInfo, 0, sizeof( DAMAGEEFFECTFUNC ) ) ;
	LengthInfo.Num = 1 ;
	LengthInfo.MaxNum = Num + 1 ;
	LengthInfo.Point = Point ;
	LengthInfo.LastChip = &LengthInfo.Chip[0] ;
	Chip = &LengthInfo.Chip[0] ;
	Chip->Length = -1000.0F ;
	Chip->JObj = NULL ;
	Chip->Number = 0 ;
	Chip->Next = Chip->Back = NULL ;
	
	// bVׂĂ JObj 񋓂
	ScanPrimitiveJObj( JObj, DamageLengthScanCallBack, &LengthInfo ) ;
*/
	
	// XLɌ򖗃GtFNg쐬
	{
		s32 i ;
		LENGTHLISTCHIP *Chip ;

		Chip = LengthInfo.Chip[0].Next ;
		for( i = 0 ; i < LengthInfo.Num - 1 ; i ++, Chip = Chip->Next )
		{
			info.Create();
			
			switch( Type )
			{
			case 0 :
				{
					GXColor Color ;
					Vec Point, Dir ;
					f32 P ;
					s16 Time ;

					P = ( rand() * ( ( PR2[2] - PR2[3] ) * 0.1F ) / RAND_MAX + PR2[3] * 0.1F ) * Power ;
					if( T == -1 )
						Time = (s16)( rand() * ( PR2[0] - PR2[1] ) / RAND_MAX + PR2[1] ) ;
					else
						Time = (s16)T ;

					Color.r = (u8)PR3[14] ;
					Color.g = (u8)PR3[15] ;
					Color.b = (u8)PR3[16] ;
					Point.x = PR3[8] ;
					Point.y = PR3[9] ;
					Point.z = PR3[10] ;
					Dir.x = -PR3[11] * 0.1F ;
					Dir.y = PR3[12] * 0.1F ;
					Dir.z = 0/*PR4[13]*/ * 0.1F ;
					pRetEffect = CreateFlyBloodEffect( Point, Dir, PI / 40 * PR3[2], PR3[0] * 0.1F, P,  
											PI / 40 * PR3[6], PI / 40 * PR3[7], PR3[4] * 0.01F,
											1.0F - PR3[5] * 0.001F, PR3[18] * 0.001F, (u8)PR3[3], YukaY + 0.5F,
											PR3[19], PR3[20],
											Color, (u8)PR3[17],
											PR3[22] * 0.001f, Time, Chip->JObj, (u32)Chip->Number,
											0.0F, 0,
											80, 80 ) ;
				}
				break ;

			case 1 :
				{
					GXColor Color ;
					Vec Point, Dir ;
					f32 P ;
					s16 Time ;

					P = rand() * ( ( PR2[2] - PR2[3] ) * 0.1F ) / RAND_MAX + PR2[3] * 0.1F ;
					if( T == -1 )
						Time = (s16)( rand() * ( PR2[0] - PR2[1] ) / RAND_MAX + PR2[1] ) ;
					else
						Time = (s16)T ;

					Color.r = (u8)PR3[14] ;
					Color.g = (u8)PR3[15] ;
					Color.b = (u8)PR3[16] ;
					Point.x = PR3[8] ;
					Point.y = PR3[9] ;
					Point.z = PR3[10] ;
					Dir.x = -PR3[11] * 0.1F ;
					Dir.y = PR3[12] * 0.1F ;
					Dir.z = 0/*PR4[13]*/ * 0.1F ;
					pRetEffect = CreateFlyBloodEffect( Point, Dir, PI / 180 * PR2[5], ( PR3[0] * 0.1F ) * Power, P,  
											PI / 180 * PR2[4], PI / 40 * PR2[6], PR3[4] * 0.01F,
											1.0F - PR3[5] * 0.001F, PR3[18] * 0.001F, (u8)PR3[3], YukaY + 0.5F,
											PR3[19], PR3[20],
											Color, (u8)PR3[17],
											PR3[22] * 0.001f, Time, Chip->JObj, (u32)Chip->Number,
											0.0F, 0,
											80, 80 ) ;
				}
				break ;
				
			default :
				break ;
			}
		}
	}

	if( pRetEffect!=NULL ){ info.Parent(pRetEffect); }
	
	// I
	return pRetEffect;
	
}