///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectDamageBlood
//
// YK7EffectDamageBlood.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 11/05/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTDAMAGEBLOOD_H
#define __YK7EFFECTDAMAGEBLOOD_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define MAXROLLLINE_NUM			1000				// C̍ő吔

enum
{
	DMGBLD_NORMAL = 0,		// 0:W
	DMGBLD_HNG_MISS,		// 1:F~Xqbg
	DMGBLD_HNG_SUCCESS,		// 2:Fqbg
	DMGBLD_HNG_DAMAGE,		// 3:F_[Wqbg
	DMGBLD_HNG_LASTHIT,		// 4:FŌ̃qbg
	DMGBLD_AK2_NORMAL,		// 5:F_[Wqbg
	DMGBLD_KVN_INVALID,		// 6:PrFqbg
} ;

// datatype -------------------------------------

// _[W򖗃GtFNgʃf[^
typedef struct tagDAMAGEBLOODUNION
{
	u8 Dummy ;
} DAMAGEBLOODUNION ;

// CIuWFNgf[^
typedef struct tagDAMAGEBLOODOBJECT
{
	u8 EndFlag ;				// IĂ邩tO

	f32 Length 	;				// C̒
	GXColor Color ;				// F
	f32 Rot ;					// \ʒu

	f32 Point ;					// S_n_܂ł̋
	u8 Mode ;					// n_ǂɂ邩( 0:  1:O )
	f32 LengthParam ;			// ̒( 1.0F:LтĂ  0.0F:k݂Ă )

	f32 Speed ;					// ˏɍLĂx
	f32 LengthSpeed ;			// ̐Lk̑x
} DAMAGEBLOODOBJECT ;

// _[W򖗃GtFNgf[^
typedef struct tagDAMAGEBLOODEFFECT
{
	DAMAGEBLOODOBJECT *Obj ;			// ̃f[^ւ̃|C^
	s32 ObjNum ;						// ̐
	s32 EndObjNum ;						// I̐

	u8 LineWidth ;						// ̑
	Vec Point ;							// oW
} DAMAGEBLOODEFFECT ;

// _[W򖗃GtFNg^XNɓnf[^
typedef struct tagDAMAGEBLOODEFFECTTACKPARAM
{
	s32 LineNum ;							// ̐
	Vec Point ;								// oW
	f32 MaxSpeed, MinSpeed ;				// ̍ő呬xƍŏx
	f32 MaxLength, MinLength ;				// ̍ő咷ƍŒZ
	f32 MaxLengthSpeed, MinLengthSpeed ;	// ̍őLяkݑxƍŏLяkݑx
	u8 LineWidth ;							// ̑
	GXColor Color ;							// F
} DAMAGEBLOODEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitDamageBloodData( void ) ;					// _[W򖗃GtFNg̋ʃf[^
extern s8 CheckDamageBloodData( void ) ;				// _[W򖗃GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndDamageBloodData( void ) ;					// _[W򖗃GtFNg̋ʃf[^n


extern EFFECT *CreateDamageBloodEffect( u8 Type, Vec Pos, u32 *Color = NULL ) ;		// ȈՔ

extern EFFECT *CreateDamageBloodEffect( s32 LineNum, Vec Point,
										f32 MaxSpeed, f32 MinSpeed,
										f32 MaxLength, f32 MinLength,
										f32 MaxLengthSpeed, f32 MinLengthSpeed,
										u8 LineWidth, GXColor Color, s32 Priority = 2000 ) ;	// _[W򖗃GtFNg쐬
extern s8 ReleaseDamageBloodEffect( EFFECT *Effect ) ;						// _[W򖗃GtFNǧns
extern s8 MoveDamageBloodEffect( EFFECT *Effect ) ;							// _[W򖗃GtFNgPt[
extern s8 DrawDamageBloodEffect( EFFECT *Effect ) ;							// _[W򖗃GtFNg`悷

#endif
