///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectEneShot
//
// YK7EffectEneShot.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/28/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTENESHOT_H
#define __YK7EFFECTENESHOT_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define ENE_AIMAGENUM		(8)

// datatype -------------------------------------

// GlM[VbgGtFNgʃf[^
typedef struct tagENESHOTUNION
{
//	u8 Dummy ;
	s32 AImageNum ;						// c
	bool NotSizeControl ;				// TCYȂtO
	bool NotBom ;						// ȂtO
	f32 InitSpeed ;						// Xs[h
} ENESHOTUNION ;

// CIuWFNgf[^
typedef struct tagENESHOTOBJECT
{
	u8 vflag ;					// LtO
	u8 mode ;					// 0:]  1:
	f32 xz, oir, rot;
	f32 bxz[ENE_AIMAGENUM], boir[ENE_AIMAGENUM], brot[ENE_AIMAGENUM] ;
	u8 bnum ;
	f32 xzsp, oirsp ;
	f32 r ;

	f32 size ;

	Vec apos, bapos[ENE_AIMAGENUM] ;
	Vec pos, mode1pos, speed ;
	f32 alpha ;
	f32 fadesp ;	
} ENESHOTOBJECT ;

// GlM[VbgGtFNgf[^
typedef struct tagENESHOTEFFECT
{
	EFFECT *CentLight2 ;			// ߃GtFNg
	u32 CentLight2EffectID ;

	ENESHOTOBJECT *CentObj ;		// S̃f[^ւ̃|C^
	s32 CentObjNum ;				// S̐
	s32 MaxCentObjNum ;				// SIuWFNg̍ő吔

	ENESHOTOBJECT *OutObj ;			// Õf[^ւ̃|C^
	s32 OutObjNum ;					// O̐
	s32 MaxOutObjNum ;				// OIuWFNg̍ő吔

	Vec StartPos, TargetPos ;		// ˍWƖڕWW

	f32 OutRate ;						// E

	f32 CentMaxSize, CentMinSize ;		// SIuWFNgőTCYƍŏTCY
	f32 CentMaxSpeed, CentMinSpeed ;	// SIuWFNgő呬xƍŏx
	f32 CentR ;							// SIuWFNg̈ړa

	f32 OutMaxSize, OutMinSize ;		// OIuWFNgőTCYƍŏTCY
	f32 OutMaxSpeed, OutMinSpeed ;		// OIuWFNgő呬xƍŏx
	f32 MaxOutR, MinOutR ;				// OIuWFNg̈ړa

	f32 OutFadeSpeed ;					// ẼAt@ľ鑬x
	f32 SSpeed ;						// x
	u32 Color ;							// F
	f32 Gravi ;							// d
	
	u8 Mode ;							// ( 0:҂ 1:˒ 2:B )
	u32 Counter ;						// JE^[

	f32 rotcounter ;
	f32 chargerate ;
	
	Vec pos, dir ;						// S_̌ƍW
	f32 speed, len ;					// Xs[hƋ
	
	f32 Size, SizeCount ;

	u32 AImageNum ;						// c̐	
	bool NotSizeControl ;				// TCY|Ȃ
	bool NotBom ;						// ȂtO
	
	HSD_JObj *PosJObj ;					// ܂ŒǏ]JObj
} ENESHOTEFFECT ;

// GlM[VbgGtFNg^XNɓnf[^
typedef struct tagENESHOTEFFECTTACKPARAM
{
	s32 MaxCentObjNum ;				// SIuWFNg̍ő吔
	s32 MaxOutObjNum2 ;				// OIuWFNg̍ő吔

	Vec StartPos, TargetPos ;		// ˍWƖڕWW

	f32 OutRate ;						// E
	
	f32 CentMaxSize, CentMinSize ;		// SIuWFNgőTCYƍŏTCY
	f32 CentMaxSpeed, CentMinSpeed ;	// SIuWFNgő呬xƍŏx
	f32 CentR ; 						// SIuWFNg̈ړa

	f32 OutMaxSize, OutMinSize ;		// OIuWFNgőTCYƍŏTCY
	f32 OutMaxSpeed, OutMinSpeed ;		// OIuWFNgő呬xƍŏx
	f32 MaxOutR, MinOutR ;				// OIuWFNg̈ړa

	f32 OutFadeSpeed ;					// ẼAt@ľ鑬x
	f32 SSpeed ;						// x

	f32 Gravi ;							// d
	u32 Color ;							// F
} ENESHOTEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitEneShotData( void ) ;				// GlM[VbgGtFNg̋ʃf[^
extern s8 CheckEneShotData( void ) ;				// GlM[VbgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndEneShotData( void ) ;				// GlM[VbgGtFNg̋ʃf[^n

extern EFFECT *CreateEneShotEffect( 				// GlM[VbgGtFNg쐬
						s32 MaxCentObjNum,				// SIuWFNg̍ő吔
						s32 MaxOutObjNum,				// OIuWFNg̍ő吔

						Vec StartPos, Vec TargetPos,		// ˍWƖڕWW

						f32 OutRate,						// E
						
						f32 CentMaxSize, f32 CentMinSize,	// SIuWFNgőTCYƍŏTCY
						f32 CentMaxSpeed, f32 CentMinSpeed,	// SIuWFNgő呬xƍŏx
						f32 CentR,	 						// SIuWFNg̈ړa

						f32 OutMaxSize, f32 OutMinSize,		// OIuWFNgőTCYƍŏTCY
						f32 OutMaxSpeed, f32 OutMinSpeed,	// OIuWFNgő呬xƍŏx
						f32 MaxOutR, f32 MinOutR,			// OIuWFNg̈ړa

						f32 OutFadeSpeed,					// ẼAt@ľ鑬x
						f32 SSpeed,							// x
						u32 Color,							// F
						f32 Gravi, 							// d
						s32 Priority = 2000 ) ;	
extern s8 ReleaseEneShotEffect( EFFECT *Effect ) ;						// GlM[VbgGtFNǧns
extern s8 MoveEneShotEffect( EFFECT *Effect ) ;							// GlM[VbgGtFNgPt[
extern s8 DrawEneShotEffect( EFFECT *Effect ) ;							// GlM[VbgGtFNg`悷

extern s8 SetEneShotPos( Vec Pos, EFFECT *Effect ) ;				// GtFNg̍WύX
extern s8 SetEneShotChargeRate( f32 Rate, EFFECT *Effect ) ;		// ߗݒ肷
extern s8 RunEneShot( EFFECT *Effect ) ;							// ło
extern s8 HitCheckEneShot( EFFECT *Effect ) ;						// ڕWWɓBǂ擾( TRUE:B  FALSE:܂ )

extern s8 SetEneShotPosJObj( HSD_JObj *PosJObj, EFFECT *Effect ) ;	// ܂ŒǏ] JObj ݒ肷
extern s8 SetEneShotTargetPos( Vec TargetPos, EFFECT *Effect ) ;	// ^[Qbg|WVύX
extern s8 CompEneShotEffect( EFFECT *Effect ) ;						// GlM[Vbg

extern s8 SetEneShotAImageNum( u32 AImageNum ) ;	// GlM[Vbg̎c̐Zbg(ݒŏ CreateEneShotEffect ̂ݗL)
extern void SetEneShotNotSizeControl( void ) ;		// ɍ쐬GlM[VbgɃTCY|Ȃ
extern void SetEneShotNotBom( void ) ;				// ɍ쐬GlM[Vbg͔GtFNgoȂ
extern void SetEneShotInitSpeed( f32 initspeed ) ;		// ɍ쐬GlM[Vbgɏxݒ肷

#endif
