///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectEyeScan
//
// YK7EffectEyeScan.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/10/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectEyeScan.h"
#include "../Matsu/mk7Sound.h"

// define ---------------------------------------

#define EYESCAN_TEX		"/Yam/Effect/EyeScan/y_iris001.BIN"

#define SPEED	(2)

// datatype -------------------------------------

// data -----------------------------------------

EYESCANUNION escu ;

// function code --------------------------------

// ԖF؃GtFNg̋ʃf[^
extern s8 InitEyeScanData( void )
{
	MEMINIT(escu) ;
	
	// I
	return 0 ;
}

// ԖF؃GtFNg̏풓f[^̓ǂݍ݂ǂ𓾂
extern s8 CheckEyeScanData( void )
{
	// ɂȂ
	return TRUE ;
}


// ԖF؃GtFNg̋ʃf[^n
extern s8 EndEyeScanData( void )
{
	ReleaseEyeScanTex() ;
	
	MEMINIT(escu) ;
	
	// I
	return 0 ;
}

// ԖF؃GtFNg̏s
extern s8 LoadEyeScanTex( void )
{
	if( escu.setupstate != 0 ) return 0 ; 

	TexLoadSet( EYESCAN_TEX, &escu.tex ) ;
	escu.setupstate = 1 ;
	
	return 0 ;
}


// ԖF؃GtFNg̏I̊mFs( TRUE:  FALSE: )
extern s8 CheckEyeScanTex( void )
{
	switch( escu.setupstate )
	{
	case 0 : return FALSE ;
	case 1 :
		if( TexLoadChk( &escu.tex ) == TRUE )
		escu.setupstate = 2 ;
		return TRUE ;
	case 2 : return TRUE ;
	}

	return FALSE ;
}


// ԖF؃GtFNǧns
extern s8 ReleaseEyeScanTex( void )
{
	if( escu.setupstate == 0 ) return 0 ;
	
	TexRelease( &escu.tex ) ;
	escu.setupstate = 0 ;
	
	return 0 ;
}


// ԖF؃GtFNg쐬
extern EFFECT *CreateEyeScanEffect( s32 Priority )
{
	EYESCANEFFECT *ec ;
	EFFECT *Effect ;

	// VԖF؃GtFNgf[^쐬
	Effect = AddEffectData( EFF_EYESCAN, (void**)&ec, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// ԖF؃GtFNgf[^
	ec->mode = 0 ;
	ec->counter = 0 ;
	ec->endflag = false ;

	// I
	return Effect ;
}

// ԖF؃GtFNǧns
extern s8 ReleaseEyeScanEffect( EFFECT *Effect )
{
	EYESCANEFFECT *ec = ( EYESCANEFFECT * )Effect->Data ;
	
	// ɂ邱ƂȂ
	return 0 ;
}

// ԖF؃GtFNgPt[
extern s8 MoveEyeScanEffect( EFFECT *Effect )
{
	EYESCANEFFECT *ec = ( EYESCANEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( ec->endflag == true ) return 0 ;
	
	switch( ec->mode )
	{
	case 0 :
		ec->counter ++ ;
		if( ec->counter == VParam[ED_EYESCAN][1] )
		{
			ec->mode ++ ;
			ec->counter = 0 ;
			PlayEffectSE( SFX_SCE3_CUR_RETINACHECK_SEARCH/*SFX_BT_SCAN_RELEASE*/ ) ;
		}
		break ;
		
	case 1 :
		u32 h ;

		h = escu.tex.Data.Header->mHeight ;
		ec->counter ++ ;
		if( ec->counter * VParam[ED_EYESCAN][0] >= h )
		{
			gpSound->mStopSE( SFX_SCE3_CUR_RETINACHECK_SEARCH ) ;
		
			ec->mode ++ ;
			ec->counter = 0 ;
		}
		break ;
		
	case 2 :
		ec->counter ++ ;
		if( ec->counter == VParam[ED_EYESCAN][2] )
		{
			ec->endflag = true ;
		}
		break ;
	}
	
	// I
	return 0 ;
}

// ԖF؃GtFNg`悷
extern s8 DrawEyeScanEffect( EFFECT *Effect )
{
	EYESCANEFFECT *ec = ( EYESCANEFFECT * )Effect->Data ;
	u32 w, h, cr ;
	u32 l, t, r, b ;
	
	if( escu.setupstate != 2 ) return 0 ;
	
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;

	w = escu.tex.Data.Header->mWidth ;
	h = escu.tex.Data.Header->mHeight ;
	cr = 0xff ;
	l = 320 - w / 2 ;
	t = 240 - h / 2 ;
	r = 320 + w / 2 ;
	b = 240 + h / 2 ;
	
	DrawBox( 0, 0, SCW, t, cr ) ;
	DrawBox( 0, t, l, b, cr ) ;
	DrawBox( r, t, SCW, b, cr ) ;
	DrawBox( 0, b, SCW, SCH, cr ) ;

	DrawBox( l, t, r, b, CMK( VParam[ED_EYESCAN][3], VParam[ED_EYESCAN][4], VParam[ED_EYESCAN][5], VParam[ED_EYESCAN][6] ) ) ;  
	DrawTex( l, t, &escu.tex, 0xffffffff ) ;
	if( ec->mode == 1 )
	{
		s32 y ;
	
		y = (s32)( t + ec->counter * VParam[ED_EYESCAN][0] ) ;
		DrawLine( l, y, r, y, CMK( VParam[ED_EYESCAN][7], VParam[ED_EYESCAN][8], VParam[ED_EYESCAN][9], VParam[ED_EYESCAN][10] ) ) ;  
	}

	// I
	return 0 ;
}

// ԖF؃GtFNgI`FbN( true:I  false:܂ )
extern bool GetEyeScanEndState( EFFECT *Effect )
{
	EYESCANEFFECT *ec = ( EYESCANEFFECT * )Effect->Data ;

	return ec->endflag ;	
}


