///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFade
//
// YK7EffectFade.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 02/04/2004
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectFade.h"

// define ---------------------------------------

// data -----------------------------------------

FADEUNION FdUnion ;

// datatype -------------------------------------

// function code --------------------------------

// tF[hGtFNg̋ʃf[^
extern s8 InitFadeData( void )
{
	MEMINIT( FdUnion ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}

// tF[hGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckFadeData( void )
{
	return TRUE ;
}

// tF[hGtFNg̋ʃf[^n
extern s8 EndFadeData( void )
{
	MEMINIT( FdUnion ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// tF[hGtFNg쐬
extern EFFECT *CreateFadeEffect( GXColor Color, f32 AlphaSpeed, s32 Priority )
{
	EFFECT *Effect ;
	FADEEFFECT *Fd ;
	
	// VtF[hf[^쐬
	Effect = AddEffectData( EFF_FADE, (void**)&Fd, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// tF[hf[^
	Fd->Color = Color ;
	Fd->AlphaSpeed = AlphaSpeed ;
	Fd->Alpha = 0.0F ;
	Fd->FadeFlag = FALSE ;

	// I
	return Effect ;
}

// tF[hGtFNǧns
extern s8 ReleaseFadeEffect( EFFECT *Effect )
{
	FADEEFFECT *FadeEffect = ( FADEEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ

	// I
	return 0 ;
}

// tF[hGtFNgPt[
extern s8 MoveFadeEffect( EFFECT *Effect )
{
	FADEEFFECT *Fd = ( FADEEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( Effect->DelReqFlag == TRUE ) 
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// At@ω
	if( Fd->FadeFlag == TRUE )
	{
		Fd->Alpha += Fd->AlphaSpeed ;
		if( Fd->Alpha > 1.0F ) Fd->Alpha = 1.0F ;
	}
	else
	{
		Fd->Alpha -= Fd->AlphaSpeed ;
		if( Fd->Alpha < 0.0F ) Fd->Alpha = 0.0F ;
	}

	// I
	return 0 ;
}

// tF[hGtFNg`悷
extern s8 DrawFadeEffect( EFFECT *Effect )
{
	FADEEFFECT *Fd = ( FADEEFFECT * )Effect->Data ;

	// `̏
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;
	
	// `
	if( Fd->Alpha != 0.0F )
	DrawBox( 0, 0, SCW, SCH, CMKC2( Fd->Color, Fd->Alpha * Fd->Color.a ) ) ;
/*
	{
		GXBegin( GX_QUADS, GX_VTXFMT0, 4 ) ;
		{
			a = (u8)( Fd->Alpha * Fd->Color.a ) ;
			GP3( 0, 0 ) ;		GC4( Fd->Color.r, Fd->Color.g, Fd->Color.b, a ) ;
			GP3( SCW, 0 ) ;		GC4( Fd->Color.r, Fd->Color.g, Fd->Color.b, a ) ;
			GP3( SCW, SCH ) ;	GC4( Fd->Color.r, Fd->Color.g, Fd->Color.b, a ) ;
			GP3( 0, SCH ) ;		GC4( Fd->Color.r, Fd->Color.g, Fd->Color.b, a ) ;
		}
		GXEnd() ;
	}
*/

	// I
	return 0 ;
}					


// tF[h邩ǂ̃tOZbg
extern s8 SetFadeEffectFlag( s8 Flag, EFFECT *Effect )
{
	FADEEFFECT *Fade = ( FADEEFFECT * )Effect->Data ;
	
	Fade->FadeFlag = (u8)Flag ;
	
	// I
	return 0 ;
}

// tF[h̃At@̕ωxύX
extern s8 SetFadeEffectAlphaSpeed( f32 AlphaSpeed, EFFECT *Effect )
{
	FADEEFFECT *Fade = ( FADEEFFECT * )Effect->Data ;
	
	Fade->AlphaSpeed = AlphaSpeed ;
	
	// I
	return 0 ;
}


// tF[h̏Ԃ擾( TRUE:tF[h؂Ă  FALSE:tF[hĂȂ )
extern s8 GetFadeEffectState( EFFECT *Effect )
{
	FADEEFFECT *Fade = ( FADEEFFECT * )Effect->Data ;
	
	return (s8)( Fade->FadeFlag == TRUE ? ( Fade->Alpha == 1.0F ? TRUE : FALSE ) : FALSE ) ;
}


