///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFlash
//
// YK7EffectFlash.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/04/2003
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectFlash.h"

// define ---------------------------------------

// data -----------------------------------------

FLASHUNION FlUnion ;

// datatype -------------------------------------

// function code --------------------------------

/*
// tbVGtFNg^XN
extern void FlashEffectTask( ghmGcTask *pTask )
{
	FLASHEFFECTTASKPARAM *FEP = ( FLASHEFFECTTASKPARAM * )GHMGCTASK_GETPARAM(0) ;
	EFFECT *Effect ;

	pTask = pTask ;

	// tbVGtFNgǉ
	Effect = CreateFlashEffect( FEP->Point, FEP->Color, FEP->UpFrame, FEP->DownFrame, pTask, 100 ) ;
	if( Effect == NULL ) return ;

	// ̊J
	K7AppSmallMemFree( FEP ) ;

	// [v
	while( Effect != NULL && GetEffectValidState( Effect ) == 1 )
	{
		MoveEffect( Effect ) ;
		if( GetEffectValidState( Effect ) == 1 ) DrawEffect( Effect ) ;

		GHMGCTASK_RETSYS() ;
	}

	// I
	return ;
}
*/

// tbVGtFNg̋ʃf[^
extern s8 InitFlashData( void )
{
	MEMINIT( FlUnion ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}

// tbVGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckFlashData( void )
{
	return TRUE ;
}

// tbVGtFNg̋ʃf[^n
extern s8 EndFlashData( void )
{
	MEMINIT( FlUnion ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// tbVGtFNg쐬
extern EFFECT *CreateFlashEffect( u8 Point2DFlag, Vec Point, f32 Size, GXColor Color,
									 u8 UpFrame, u8 DownFrame, u8 AddBlendFlag, s32 Priority )
{
	EFFECT *Effect ;
	FLASHEFFECT *FlashP ;
	
	// VtbVf[^쐬
	Effect = AddEffectData( EFF_FLASH, (void**)&FlashP, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// tbVf[^
	FlashP->Point2DFlag = Point2DFlag ;
	FlashP->Color = Color ;
	FlashP->Point = Point ;
	FlashP->Size = Size ;
	FlashP->UpFrame = UpFrame ;
	FlashP->DownFrame = DownFrame ;
	FlashP->AddBlendFlag = AddBlendFlag ;
	FlashP->Counter = 0 ;

	// I
	return Effect ;
}

// tbVGtFNǧns
extern s8 ReleaseFlashEffect( EFFECT *Effect )
{
	FLASHEFFECT *FlashEffect = ( FLASHEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ

	// I
	return 0 ;
}

// tbVGtFNgPt[
extern s8 MoveFlashEffect( EFFECT *Effect )
{
	FLASHEFFECT *FlashEffect = ( FLASHEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( FlashEffect->DownFrame == 0 && FlashEffect->UpFrame == 0 )
	{
		if( FlashEffect->Counter == 1 )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		FlashEffect->Counter ++ ;
	}
	else
	{
		// wt[𒴂I
		if( FlashEffect->DownFrame + FlashEffect->UpFrame == FlashEffect->Counter )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		else
		{
			// JEg
			FlashEffect->Counter ++ ;
		}
	}

	// I
	return 0 ;
}

// tbVGtFNg`悷
extern s8 DrawFlashEffect( EFFECT *Effect )
{
	FLASHEFFECT *FlashEffect = ( FLASHEFFECT * )Effect->Data ;
	u8 r, g, b, a ;
	f32 Counter ;
//	int DrawNum ;
	FLASHUNION *FlashUnion = &FlUnion ;
	
	EffectRenderSetup( FlashEffect->Point2DFlag == TRUE ? EF_PROJECT_ORTHO : EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;
	// Zobt@̓샂[hݒ肷
//	GXSetZMode( GX_FALSE, GX_LESS, GX_FALSE ) ;
	GXSetZMode( GX_TRUE, GX_LESS, GX_FALSE ) ;

	// TEVݒ
	GXSetNumTevStages(1);
	GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC ) ; 
    GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_2, GX_TRUE, GX_TEVPREV ) ;
	GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_RASA ) ; 
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, FlashEffect->AddBlendFlag == TRUE ? GX_CS_SCALE_2 : GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV ) ;

	// F̋Zo
	if( FlashEffect->DownFrame == 0 && FlashEffect->UpFrame == 0 )
	{
		f32 B ;
		B = (f32)FlashEffect->Color.r * 2 ;
		r = (u8)( B > 255 ? 255 : ( B < 0 ? 0 : (u8)B ) ) ;
		B = (f32)FlashEffect->Color.g * 2 ;
		g = (u8)( B > 255 ? 255 : ( B < 0 ? 0 : (u8)B ) ) ;
		B = (f32)FlashEffect->Color.b * 2 ;
		b = (u8)( B > 255 ? 255 : ( B < 0 ? 0 : (u8)B ) ) ;
		a = (u8)FlashEffect->Color.a ;
	}
	else
	{
		Counter = FlashEffect->Counter - 1 ;
		if( Counter < FlashEffect->UpFrame )
		{
			f32 B ;
			B = (f32)FlashEffect->Color.r * 2 ;
			r = (u8)( B > 255 ? 255 : ( B < 0 ? 0 : (u8)B ) ) ;
			B = (f32)FlashEffect->Color.g * 2 ;
			g = (u8)( B > 255 ? 255 : ( B < 0 ? 0 : (u8)B ) ) ;
			B = (f32)FlashEffect->Color.b * 2 ;
			b = (u8)( B > 255 ? 255 : ( B < 0 ? 0 : (u8)B ) ) ;
			B = ( (f32)FlashEffect->Color.a ) * ( Counter + 0.5F ) / FlashEffect->UpFrame ;
			a = (u8)( B > 255 ? 255 : ( B < 0 ? 0 : (u8)B ) ) ;
		}
		else
		{
			Counter -= FlashEffect->UpFrame ;
			if( Counter <= FlashEffect->DownFrame )
			{
				f32 B ;
			
				B = (f32)FlashEffect->Color.r * 2 ;
				r = (u8)( B > 255 ? 255 : ( B < 0 ? 0 : (u8)B ) ) ;
				B = (f32)FlashEffect->Color.g * 2 ;
				g = (u8)( B > 255 ? 255 : ( B < 0 ? 0 : (u8)B ) ) ;
				B = (f32)FlashEffect->Color.b * 2 ;
				b = (u8)( B > 255 ? 255 : ( B < 0 ? 0 : (u8)B ) ) ;
				B = ( (f32)FlashEffect->Color.a ) - ( (s32)0xff * ( Counter ) / FlashEffect->DownFrame ) ;
				a = (u8)( B > 255 ? 255 : ( B < 0 ? 0 : (u8)B ) ) ;
			}
			else
			{
				return 0 ;
			}
		}
	}

	// QcRcŏ𕪊
#define DIVNUM	20
//#define R WK7_SCREEN_WIDTH
	if( FlashEffect->Point2DFlag == TRUE )
	{
		// Qc̎̏
		GXBegin( GX_TRIANGLEFAN, GX_VTXFMT0, 4 ) ;
		{
			GP2( 0, 				0 ) ;					GC4( r, g, b, a ) ; 
			GP2( WK7_SCREEN_WIDTH, 	0 ) ;					GC4( r, g, b, a ) ; 
			GP2( WK7_SCREEN_WIDTH,  WK7_SCREEN_HEIGHT ) ;	GC4( r, g, b, a ) ; 
			GP2( 0, 				WK7_SCREEN_HEIGHT ) ;	GC4( r, g, b, a ) ; 
		}
		GXEnd() ;
	}
	else
	{
		Mtx Mtemp ;
		Vec p ;
		u8 j ;
	
		// Rc̎̏
		
		// r[s̓]ns𓾂
		EffectGetInvViewMatrix( Mtemp ) ;

		// uh[h̃Zbg
		if( FlashEffect->AddBlendFlag == TRUE )
		{
			GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_ONE, GX_LO_SET );
		}
		else
		{	
			GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_SET );
		}

		// ʂςɃtbVGtFNg`
		for( j = 0 ; j < 1 ; j ++ )
		{
			GXBegin( GX_TRIANGLEFAN, GX_VTXFMT0, DIVNUM + 2 ) ;
			{
				u32 i ;
			
				GP3( FlashEffect->Point.x, FlashEffect->Point.y, FlashEffect->Point.z ) ;
				GC4( r, g, b, a ) ; 

				for( i = 0 ; i < DIVNUM + 1 ; i ++ )
				{
					p.x = sin( PI * 2 / DIVNUM * i ) * FlashEffect->Size ;
					p.y = cos( PI * 2 / DIVNUM * i ) * FlashEffect->Size ;
					p.z = 0.0F ;
					MTXMultVec( Mtemp, &p, &p ) ;

					GP3( p.x + FlashEffect->Point.x, p.y + FlashEffect->Point.y, p.z + FlashEffect->Point.z ) ;
					GC4( 0, 0, 0, 0 ) ;
				}
			}
			GXEnd() ;
		}
	}

	// I
	return 0 ;
}					







