///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFlyBullet
//
// YK7EffectFlyBullet.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/02/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectFlyBullet.h"
//#include "./YK7EffectBlood.h"
#include "./YK7EffectLine.h"
#include "./YK7EffectFlash.h"
#include "../matsu/mk7Sound.h"
#include "../matsu/se/seBattle.h"
#include "./YK7EffectStaticData.h"
#include "./YK7EffectBullet.h"
#include "./YK7EffectEasyAnim.h"

// define ---------------------------------------

#define DEBRISTEX		"/Yam/Effect/FlyBullet/BulletHitDebris_P1.BIN"
#define DEFNUM		5

#define PRM			VParam[ED_FLYBULLET]

// datatype -------------------------------------

typedef struct tagFLYBULLETDEF
{
	f32 Length ;
	f32 Num ;
	f32 Size ;
} FLYBULLETDEF ;

// data -----------------------------------------

FLYBULLETUNION FlyUnion ;

FLYBULLETDEF FlyBulletDefTable[] =
{
//		Length			Num				Size
	{	20.0F,			1.0F,			1.0F	},
	{	40.0F,			1.0F,			1.6666F	},
	{	82.0F,			1.0F,			2.5F	},
	{	155.390366F,	1.0F,			3.3333F	},
	{	231.325882F,	1.0F,			4.8333F	},
} ;
	

// function code --------------------------------

// eGtFNg̋ʃf[^
extern s8 InitFlyBulletData( void )
{
	MEMINIT(FlyUnion) ;
	
	// jЂ̃eNX`[ǂݍ
//	TexLoadSet( DEBRISTEX, &FlyUnion.DebrisTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_BulletHitDebris_P1 ), &FlyUnion.DebrisTex ) ;

	// I
	return 0 ;
}

// eGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckFlyBulletData( void )
{
//	if( TexLoadChk( &FlyUnion.DebrisTex ) == FALSE ) return FALSE ;
	
	return TRUE ;
}


// eGtFNg̋ʃf[^n
extern s8 EndFlyBulletData( void )
{
//	TexRelease( &FlyUnion.DebrisTex ) ;

	MEMINIT(FlyUnion) ;
	
	// I
	return 0 ;
}




// eGtFNg쐬
extern EFFECT *CreateFlyBulletEffect(
									 Vec 		Point,
									 GXColor 	Color,
									 f32 		Power,
									 f32 		Gravity,
									 f32 		YukaY,
									 f32 		Bias,
									 u32 		FlashColor,
									 s32 Priority )
{
	EFFECT *Effect ;
	s32 Num ;
	f32 Size ;
	
	// ẽeNX`ǂݍ܂ĂȂ牽I
	if( CheckFlyBulletData() == FALSE ) return 0 ;

#ifdef YAMADADEBUG
//	CreateBulletEffect( BL_MARK, Point, NULL, 0.0F, 0.3F ) ; 						// qbgW
/*
	CreateBulletEffect( BL_INV_MSK_NRM, Point, NULL, 0.0F, 0.3F ) ;
	CreateBulletEffect( BL_INV_MSK_NRM, Point, NULL, 0.0F, 0.3F ) ;
	CreateBulletEffect( BL_INV_MSK_NRM, Point, NULL, 0.0F, 0.3F ) ;
	CreateBulletEffect( BL_INV_MSK_NRM, Point, NULL, 0.0F, 0.3F ) ;
	CreateBulletEffect( BL_INV_MSK_NRM, Point, NULL, 0.0F, 0.3F ) ;
	CreateBulletEffect( BL_INV_MSK_NRM, Point, NULL, 0.0F, 0.3F ) ;
	CreateBulletEffect( BL_INV_MSK_NRM, Point, NULL, 0.0F, 0.3F ) ;
	CreateBulletEffect( BL_INV_MSK_NRM, Point, NULL, 0.0F, 0.3F ) ;
	CreateBulletEffect( BL_INV_MSK_NRM, Point, NULL, 0.0F, 0.3F ) ;
	CreateBulletEffect( BL_INV_MSK_NRM, Point, NULL, 0.0F, 0.3F ) ;
	CreateBulletEffect( BL_INV_MSK_NRM, Point, NULL, 0.0F, 0.3F ) ;
	CreateBulletEffect( BL_INV_MSK_NRM, Point, NULL, 0.0F, 0.3F ) ;
*/
/*
{
	Vec Size = {2.0f,2.0f,2.0f} ;
	CreateEasyAnimEffect2(ANIMID_SMALLLIGHT,
		                                Point,
		                               Size,
		                                true,-1);
}*/
	return NULL ;
#endif

	// t@C
//	CLOSECHK( FlyUnion.DebrisTexFile ) ;
	
	// ʉ炷  modify 03/10/13 matsuzaki
//	if( GetEffectSoundOffFlag() == FALSE ) PlayEffectSE3DP( SFX_BT_TYOUDAN, Point, (s16)((HSD_Randi(10)-6)*100) ) ;
	
	// F擾
	{
		Vec Pos ;
		u32 ColorB ;
		u8 Rate ;
		
		GetScreenPosition( &Point, &Pos ) ;
		if( Pos.x > 0 && Pos.x < 639 && Pos.y > 0 && Pos.y < 480 )
		{ 
			GXPeekARGB( (u16)Pos.x, (u16)Pos.y, &ColorB ) ;
			
			Rate = Color.r ;
			Color.r = (u8)( ( ( ColorB & 0xff0000 ) >> 16 ) * Rate >> 8 ) ;
			Color.g = (u8)( ( ( ColorB & 0xff00 ) >> 8 ) * Rate >> 8 ) ;
			Color.b = (u8)( ( ( ColorB & 0xff ) ) * Rate >> 8 ) ;
			Color.a = 0xff ;
			
			if( Color.r < 128 ) Color.r = 128 ;
			if( Color.g < 128 ) Color.g = 128 ;
			if( Color.b < 128 ) Color.b = 128 ;
		}
	}		
		
	
	// 𑪂ăp[^
	Num = PRM[0] ;
	Size = PRM[3] * 0.01F ;
	{
		Vec FPoint, CPoint ;
		f32 Length, f ;
		FLYBULLETDEF TFDef ;
		s32 i ;
		
		FPoint = Point ;

		HSD_CObjGetEyePosition( GetEffectCamera(), &CPoint ) ;
		Length = sqrt( VECSquareDistance( &FPoint, &CPoint ) ) ;
		
		// ǂ̃e[uɓ邩o
		for( i = 0 ; i < DEFNUM && Length > FlyBulletDefTable[i].Length ; i ++ ){}
		if( i == DEFNUM )
		{
			TFDef = FlyBulletDefTable[i-1] ;
		}
		else
		if( i == 0 )
		{
			TFDef = FlyBulletDefTable[0] ;
		}
		else
		{
			FLYBULLETDEF *FDef1, *FDef2 ;
			
			FDef2 = &FlyBulletDefTable[i] ;
			FDef1 = &FlyBulletDefTable[i-1] ;
			
			f = ( Length - FDef1->Length ) / ( FDef2->Length - FDef1->Length ) ;
			TFDef.Size = f * ( FDef2->Size - FDef1->Size ) + FDef1->Size ;
			TFDef.Num = f * ( FDef2->Num - FDef1->Num ) + FDef1->Num ;
		}

		// ␳
		Num = (s32)( Num * TFDef.Num ) ;
		if( Num == 0 ) Num = 1 ;
		Size *= TFDef.Size ;
	}
	Size *= Bias ;
	Power *= Bias ;
	
	// jЂюU点
	Effect = CreateLineEffect( FALSE, 0, Color, Point,
								 0, Size, 1, 
								 Power, Power * 0.1F, (Vec){0.0F,0.0F,0.0F},
								 1.0F, 1.0F, Gravity,
								 (u16)( (f32)Num * Bias ), PRM[1], PRM[2],
								 TRUE, LINE_TYPE_NORMAL, 200, YukaY, &FlyUnion.DebrisTex.Data, 0, Priority ) ;

	// tbV
	{
		u32 Color ;

		Color = CMK( PRM[13], PRM[14], PRM[15], 200 ) ;
		CreateFlashEffect( 
							FALSE,						// Pos2DFlag 
							Point,						// Pos
							PRM[12] * 0.1F * Bias,		// Size
//							*((GXColor *)&Color),		// Color
							*((GXColor *)&FlashColor),	// Color
							(u8)PRM[16],				// UpFrame
							(u8)PRM[17],				// DownFrame
							FALSE,						// AddBlendFlag
							1000 ) ;
//		Color = CMK( PRM[13] * 0.1F, PRM[14] * 0.1F, PRM[15] * 0.1F, 200 ) ;
		FlashColor = CMK( 	( ( FlashColor >> 24 ) & 0xff ) * 0.1F,
							( ( FlashColor >> 16 ) & 0xff ) * 0.1F,
							( ( FlashColor >> 8 ) & 0xff ) * 0.1F,
							( ( FlashColor >> 0 ) & 0xff ) * 0.1F ) ;
		CreateFlashEffect(
							FALSE,						// Pos2DFlag 
							Point,						// Pos
							PRM[12] * 0.1F * Bias,		// Size
//							*((GXColor *)&Color),		// Color
							*((GXColor *)&FlashColor),	// Color
							(u8)PRM[16],				// UpFrame
							(u8)PRM[17],				// DownFrame
							FALSE,						// AddBlendFlag
							1001 ) ;
							
							
	}

	// I
	return Effect ;
}

// eGtFNǧns
extern s8 ReleaseFlyBulletEffect( EFFECT *Effect )
{
	FLYBULLETEFFECT *FlyBulletEffect = ( FLYBULLETEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// eGtFNgPt[
extern s8 MoveFlyBulletEffect( EFFECT *Effect )
{
	FLYBULLETEFFECT *FlyBulletEffect = ( FLYBULLETEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// eGtFNg`悷
extern s8 DrawFlyBulletEffect( EFFECT *Effect )
{
	FLYBULLETEFFECT *FlyBulletEffect = ( FLYBULLETEFFECT * )Effect->Data ;
	
	// I
	return 0 ;
}					

