///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFootPaint
//
// YK7EffectFootPaint.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/30/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTFOOTPAINT_H
#define __YK7EFFECTFOOTPAINT_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define FOOTPAINT_MAXNUM			10			// Ղ̍ő吔

enum
{
	FOOT_LEFT = 0,
	FOOT_RIGHT = 1,
} ;

// datatype -------------------------------------

// ՃGtFNgʃf[^
typedef struct tagFOOTPAINTUNION
{
	TEXDATA FootPaintTex ;
} FOOTPAINTUNION ;

// ՃIuWFNgf[^
typedef struct tagFOOTPAINTOBJECT
{
	u8 vflag ;					// LtO
	Vec pos ;					// W
	u16 rot ;					// \
	f32 alpha ;					// At@l
	u8 type ;					// E
} FOOTPAINTOBJECT ;

// ՃGtFNgf[^
typedef struct tagFOOTPAINTEFFECT
{
	FOOTPAINTOBJECT Obj[FOOTPAINT_MAXNUM] ;		// ̃f[^ւ̃|C^
	s32 ObjNum ;								// Ղ̐

	u32 DrawTime ;					// \
	u32 Color ;						// F
	f32 Size ;						// TCY
} FOOTPAINTEFFECT ;

// ՃGtFNg^XNɓnf[^
typedef struct tagFOOTPAINTEFFECTTACKPARAM
{
	u32 Color ;							// F
	f32 Size ;							// TCY
	u32 DrawTime ;						// \
} FOOTPAINTEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitFootPaintData( void ) ;				// ՃGtFNg̋ʃf[^
extern s8 CheckFootPaintData( void ) ;				// ՃGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndFootPaintData( void ) ;				// ՃGtFNg̋ʃf[^n

extern EFFECT *CreateFootPaintEffect( 				// ՃGtFNg쐬
						f32 Size = -1.0F,			// TCY
						u32 DrawTime = 60,			// \
						u32 Color = 0x000000ff,		// F
						s32 Priority = -3 ) ;	
extern s8 ReleaseFootPaintEffect( EFFECT *Effect ) ;						// ՃGtFNǧns
extern s8 MoveFootPaintEffect( EFFECT *Effect ) ;							// ՃGtFNgPt[
extern s8 DrawFootPaintEffect( EFFECT *Effect ) ;							// ՃGtFNg`悷

extern s8 AddFootPaint( EFFECT *Effect, Vec *Pos, f32 Dir, u8 FootType = FOOT_LEFT ) ;		// ՃGtFNgǉ

#endif
