///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectGore
//
// YK7EffectGore.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 07/24/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectGore.h"
#include "../matsu/mk7Sound.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

// ЃOtBbÑeNX`t@C
#define GORETEXNAME 	"/Yam/Effect/Gore/Kekkon.BIN" 				// ЃeNX`t@C

// datatype -------------------------------------

// data -----------------------------------------

GOREUNION GoUnion ;

// function proto type --------------------------

// function code --------------------------------

// ЃGtFNg̋ʃf[^
extern s8 InitGoreData( void )
{
	MEMINIT( GoUnion ) ;
	
	// ЃeNX`ǂݍ
//	TexLoadSet( GORETEXNAME, &GoUnion.GoreTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_Kekkon ), &GoUnion.GoreTex ) ;
	
	// I
	return 0 ;
}

// ЃGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckGoreData( void )
{
	if( TexLoadChk( &GoUnion.GoreTex ) == FALSE ) return FALSE ;
	
	return TRUE ;
}

// ЃGtFNg̋ʃf[^n
extern s8 EndGoreData( void )
{
	GOREUNION *GoreUnion = &GoUnion ;

	// t@CAJ
	TexRelease( &GoUnion.GoreTex ) ;

	// I
	return 0 ;
}

// ЃGtFNg쐬
extern EFFECT *CreateGoreEffect( Vec Point, f32 Width, f32 Height, u16 UpTime, s32 Priority )
{
	EFFECT *Effect ;
	GOREEFFECT *Gor ;

	// VЃf[^쐬
	Effect = AddEffectData( EFF_GORE, (void**)&Gor, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// pϐ̏
	Gor->Mode = 0 ;
	Gor->Counter1 = Gor->Counter2 = 0 ;
	Gor->alpha = 0 ;
	Gor->UpTime = UpTime ;
	Gor->Point = Point ;
	Gor->Width = Width ;
	Gor->Height = Height ;
	
	// ʉ̍Đ
	if( GetEffectSoundOffFlag() == FALSE ) PlayEffectSE( SFX_BT_HS_BLOWBLOOD, SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;

	// I
	return Effect ;
}

// Ђ̃GtFNǧns
extern s8 ReleaseGoreEffect( EFFECT *Effect )
{
	GOREEFFECT *Gor = ( GOREEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ

	// I
	return 0 ;
}

// Ђ̃GtFNgPt[
extern s8 MoveGoreEffect( EFFECT *Effect )
{
	GOREEFFECT *Gor = ( GOREEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// eNX`ǂݍݏIĖ牽I
	if( CheckGoreData() == FALSE ) return 0 ;

	// [hɂď𕪊
	switch( Gor->Mode )
	{
	case 0 :		// ЂZ
		Gor->Counter1 ++ ;
		
		// WZo
		Gor->alpha = (u16)( 255 * Gor->Counter1 / Gor->UpTime ) ;
		if( Gor->Counter1 == Gor->UpTime )
		{
			Gor->Mode ++ ;
			Gor->Counter1 = 0 ;
		}
		break ;
		
	case 1 :		// 폜܂ő҂
		break ;
	}

	// I
	return 0 ;
}
			

// Ђ̃GtFNg`悷
extern s8 DrawGoreEffect( EFFECT *Effect )
{
	GOREEFFECT *Gor = ( GOREEFFECT * )Effect->Data ;

	// eNX`ǂݍݏIĖ牽I
	if( CheckGoreData() == FALSE ) return 0 ;

	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;					// `揀
	DrawTex( Gor->Point.x, Gor->Point.y, &GoUnion.GoreTex, CMK2( 255, Gor->alpha ) ) ;  	// Ђ̕`
	
	// I
	return 0 ;
}

