///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectGravity
//
// YK7EffectGravity.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/13/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTGRAVITY_H
#define __YK7EFFECTGRAVITY_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define GRAV_ELECMAXNUM		(20)

// datatype -------------------------------------

// d̓GtFNgʃf[^
typedef struct tagGRAVITYUNION
{
	u8 dummy ;
} GRAVITYUNION ;

// d̓GtFNgf[^
typedef struct tagGRAVITYEFFECT
{
	EFFECT *elec[GRAV_ELECMAXNUM] ;		// dGtFNg
	u32 elecid[GRAV_ELECMAXNUM] ;		// dGtFNĝhc
	s32 elecnum ;						// d̐
	EFFECT *whirl ;						// ˂GtFNg
	u32 whirlid ;						// ˂GtFNĝhc

	Vec pos ;

	f32 size ;				// TCY
	s32 con ;
} GRAVITYEFFECT ;

// prototype ------------------------------------

extern s8 InitGravityData( void ) ;				// d̓GtFNg̋ʃf[^
extern s8 CheckGravityData( void ) ;			// d̓GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndGravityData( void ) ;				// d̓GtFNg̋ʃf[^n

extern EFFECT *CreateGravityEffect(
								Vec pos,					// W
								s32 Priority = -2 ) ;		// d̓GtFNg쐬

extern s8 ReleaseGravityEffect( EFFECT *Effect ) ;			// d̓GtFNǧns
extern s8 MoveGravityEffect( EFFECT *Effect ) ;				// d̓GtFNgPt[
extern s8 DrawGravityEffect( EFFECT *Effect ) ;				// d̓GtFNg`悷

#endif

