///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectHSExplode
//
// YK7EffectHSExplode.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/18/2003
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectHSExplode.h"
//#include "./YK7EffectLine.h"
#include "./YK7EffectSmoke.h"
//#include "./YK7EffectWave.h"
#include "./YK7EffectWhirl.h"
#include "./YK7EffectFlash.h"
#include "./YK7EffectImpact.h"
#include "./YK7EffectWave.h"
#include "./YK7EffectFlashLine.h"
#include "./YK7EffectExplode.h"
#include "./YK7EffectHeliExp.h"

#include "../matsu/mk7Sound.h"

// define ---------------------------------------

// wuX}CƂ̐F
GXColor HSColor[] =
{
	{98,115,140},
	{64, 69, 63},
	{80, 88,105},
	{119, 59, 49},
	{123,116,103},
	{ 65, 58, 54},
	{ 65, 60, 44},
	{ 90,106, 64},
	{129,129,129},
	{ 86, 94,109},
	{144,120,119},
	{163, 68, 21},
	{179,103, 41},
	{ 95, 30,  8},
	{ 91,159,194},
	{105,101, 89},
} ;

// datatype -------------------------------------

// data -----------------------------------------

HSEXPLODEUNION HSExpUnion ;

// function proto type --------------------------

// function code --------------------------------

// grGtFNg̋ʃf[^
extern s8 InitHSExplodeData( void )
{
	MEMINIT( HSExpUnion ) ;

	// I
	return 0 ;
}

// grGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckHSExplodeData( void )
{
	return TRUE ;
}

// grGtFNg̋ʃf[^n
extern s8 EndHSExplodeData( void )
{
	MEMINIT( HSExpUnion ) ;

	// I
	return 0 ;
}


// grGtFNg쐬
extern EFFECT *CreateHSExplodeEffect( u16 HSID, Vec Point, f32 Size, s32 Priority )
{
	GXColor Color1, Color2, Color3 ;
	
	// F̃Zbg
//	Color2.r = (u8)( HSColor[HSID].r / 5 ) ;
//	Color2.g = (u8)( HSColor[HSID].g / 5 ) ;
//	Color2.b = (u8)( HSColor[HSID].b / 5 ) ;
	HSID = HSID ;
	Color2.r = (u8)( HSColor[0].r / 5 ) ;
	Color2.g = (u8)( HSColor[0].g / 5 ) ;
	Color2.b = (u8)( HSColor[0].b / 5 ) ;
	
	Color1.r = (u8)VParam[ED_HSEXP1][0] ;
	Color1.g = (u8)VParam[ED_HSEXP1][1] ;
	Color1.b = (u8)VParam[ED_HSEXP1][2] ;
	
	Color3.r = (u8)VParam[ED_HSEXP1][6] ;
	Color3.g = (u8)VParam[ED_HSEXP1][7] ;
	Color3.b = (u8)VParam[ED_HSEXP1][8] ;
	
	// grGtFNg쐬
	return CreateHSExplodeEffect2( Point, Size,
									(u8)VParam[ED_HSEXP1][12], (u8)VParam[ED_HSEXP1][13], (u8)VParam[ED_HSEXP1][14],
									(u8)VParam[ED_HSEXP1][15], (u8)VParam[ED_HSEXP1][18],
									VParam[ED_HSEXP1][16] * 2, VParam[ED_HSEXP2][0], VParam[ED_HSEXP2][22] * 0.1F,
									Color1, Color2, Color3,
									VParam[ED_HSEXP2][2], (u8)VParam[ED_HSEXP2][4], VParam[ED_HSEXP2][3], VParam[ED_HSEXP2][2],
									180, 140, (u8)VParam[ED_HSEXP1][9],
									(u8)VParam[ED_HSEXP2][0], (u8)VParam[ED_HSEXP1][17],
									TRUE, TRUE, TRUE, TRUE, TRUE, TRUE,
									FALSE, 1.0F,
									FALSE, (u8)0,
									Color1, Color2, Color3, 1,
									Priority ) ;
}			
	


// grGtFNg쐬邻̂Q
extern EFFECT *CreateHSExplodeEffect2( /*u16 HSID,*/ Vec Point, f32 Size,
										u8 FlashOnTime, u8 TwistOnTime, u8 SmokeOnTime,
										u8 ImpactOnTime, u8 ExplodeOnTime,
										f32 TwistSizeSpeed, f32 ImpactPower, f32 ExplodeY,
										GXColor SmokeColor1, GXColor SmokeColor2, GXColor SmokeColor3, 
										f32 SmokeSize, u8 SmokeMoveTime, u16 SmokeNum, f32 SmokeAreaSize,
										u16 SmokeMaxTime, u16 SmokeMinTime, u8 SmokeAlpha,
										u8 ImpactTime, u8 FlashTime,
										u8 ImpactFlag, u8 TwistFlag, u8 SmokeFlag, u8 FlashFlag, u8 FlashLineFlag, u8 ExplodeFlag,
										u8 SmokeAddBlendFlag, f32 SmokeMoveArea,
										u8 SmokeAddBlendPhase2Flag, u8 SmokePhaseMoveAlpha,
										GXColor SmokeColor21, GXColor SmokeColor22, GXColor SmokeColor23, u8 SmokeMode,
										s32 Priority )
{
	EFFECT *Effect ;
	HSEXPLODEEFFECT *hse ;
	bool AreaSizeFlag ;
	f32 AreaSize ;
	bool SmokeAlphaX4Flag ;
	
	AreaSizeFlag = HSExpUnion.SmokeAreaSizeFlag ;
	AreaSize = HSExpUnion.SmokeAreaSize ;
	HSExpUnion.SmokeAreaSizeFlag = false ;
	
	SmokeAlphaX4Flag = HSExpUnion.SmokeAlphaX4Flag ;
	HSExpUnion.SmokeAlphaX4Flag = false ;

	// Vgrf[^쐬
	Effect = AddEffectData( EFF_HSEXPLODE, (void**)&hse, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// p[^ۑ
	hse->SmokeAlphaX4Flag = SmokeAlphaX4Flag ;
	hse->AreaSize = AreaSize ;
	hse->AreaSizeFlag = AreaSizeFlag ;
	hse->Point = Point ;
	hse->Size = Size ;
	hse->Counter = 0 ;
	hse->Mode = 0 ;
//	hse->HSID = HSID ;
	hse->FlashOnTime = FlashOnTime ;
	hse->TwistOnTime = TwistOnTime ;
	hse->SmokeOnTime = SmokeOnTime ;
	hse->ImpactOnTime = ImpactOnTime ;
	hse->ExplodeOnTime = ExplodeOnTime ;

	hse->TwistSizeSpeed = TwistSizeSpeed ;
	hse->ImpactPower = ImpactPower ;
	hse->ExplodeY = ExplodeY ;
	hse->SmokeColor1 = SmokeColor1 ;
	hse->SmokeColor2 = SmokeColor2 ;
	hse->SmokeColor3 = SmokeColor3 ;
	hse->SmokeAlpha = SmokeAlpha ;
	hse->SmokeAreaSize = SmokeAreaSize ;
	hse->SmokeMoveTime = SmokeMoveTime ;
	hse->SmokeNum = SmokeNum ;
	hse->SmokeSize = SmokeSize ;
	hse->FlashTime = FlashTime ;
	hse->ImpactTime = ImpactTime ;

	hse->ImpactFlag = ImpactFlag ;
	hse->TwistFlag = TwistFlag ;
	hse->SmokeFlag = SmokeFlag ;
	hse->FlashFlag = FlashFlag ;
	hse->FlashLineFlag = FlashLineFlag ;
	hse->ExplodeFlag = ExplodeFlag ;
	hse->SmokeAddBlendFlag = SmokeAddBlendFlag ;
	hse->SmokeMaxTime = SmokeMaxTime ;
	hse->SmokeMinTime = SmokeMinTime ;
	
	hse->SmokeMoveArea = SmokeMoveArea ;
	hse->SmokeAddBlendPhase2Flag = SmokeAddBlendPhase2Flag ;
	hse->SmokePhaseMoveAlpha = SmokePhaseMoveAlpha ;
	hse->SmokeColor21 = SmokeColor21 ;
	hse->SmokeColor22 = SmokeColor22 ;
	hse->SmokeColor23 = SmokeColor23 ;
	hse->SmokeMode = SmokeMode ;

	hse->WhirlEffectID = 0 ;		hse->WhirlEffect = NULL ;
	hse->SmokeEffectID = 0 ;		hse->SmokeEffect = NULL ;
	hse->FlashEffect1ID = 0 ;		hse->FlashEffect1 = NULL ;
	hse->FlashEffect2ID = 0 ;		hse->FlashEffect2 = NULL ;
	hse->ImpactEffectID = 0 ;		hse->ImpactEffect = NULL ;
	hse->FlashLineEffectID = 0 ;	hse->FlashLineEffect = NULL ;
	
	hse->SoundOffFlag = HSExpUnion.SoundOffFlag ;
	HSExpUnion.SoundOffFlag = false ;

	// ɕω炷			
//	PlayEffectSE( SFX_BT_WEAK_DEATH ) ;

#if FUJITA
	hse->gen = 0;
#endif
	// I
	return Effect ;
}

// grGtFNǧns
extern s8 ReleaseHSExplodeEffect( EFFECT *Effect )
{
	HSEXPLODEEFFECT *hse = ( HSEXPLODEEFFECT * )Effect->Data ;
	
	if( CheckEffectValidState( hse->WhirlEffect, hse->WhirlEffectID ) == TRUE ) DeleteEffect( hse->WhirlEffect ) ;
	if( CheckEffectValidState( hse->SmokeEffect, hse->SmokeEffectID ) == TRUE ) DeleteEffect( hse->SmokeEffect ) ;
	if( CheckEffectValidState( hse->FlashEffect1, hse->FlashEffect1ID ) == TRUE ) DeleteEffect( hse->FlashEffect1 ) ;
	if( CheckEffectValidState( hse->FlashEffect2, hse->FlashEffect2ID ) == TRUE ) DeleteEffect( hse->FlashEffect2 ) ;
	if( CheckEffectValidState( hse->ImpactEffect, hse->ImpactEffectID ) == TRUE ) DeleteEffect( hse->ImpactEffect ) ;
	if( CheckEffectValidState( hse->FlashLineEffect, hse->FlashLineEffectID ) == TRUE ) DeleteEffect( hse->FlashLineEffect ) ;

#if FUJITA
	if( hse->gen ) delete hse->gen;
#endif	
	// I
	return 0 ;
}

// grGtFNgPt[
extern s8 MoveHSExplodeEffect( EFFECT *Effect )
{
	HSEXPLODEEFFECT *hse = ( HSEXPLODEEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

#if 1
	if( hse->Counter == hse->FlashOnTime /*VParam[ED_HSEXP1][12]*/ &&
		hse->FlashFlag == TRUE )
	{
		// tbVI
//		CreateFlashEffect( FALSE, hse->Point, hse->Size * 12.0F, (GXColor){170,140,80,140}, 3, 10, FALSE, 1000 ) ; 
//		CreateFlashEffect( FALSE, hse->Point, hse->Size * 34.0F, (GXColor){130,106,60,140}, 3, 15, TRUE, 1001 ) ; 
		hse->FlashEffect1 = CreateFlashEffect( FALSE, hse->Point, hse->Size * 12.0F, (GXColor){170,140,80,140}, 3, (u8)( hse->FlashTime /*VParam[ED_HSEXP1][17]*/ ), FALSE, 1000 ) ; 
		if( hse->FlashEffect1 != NULL ) hse->FlashEffect1ID = GetEffectID( hse->FlashEffect1 ) ;
		hse->FlashEffect2 = CreateFlashEffect( FALSE, hse->Point, hse->Size * 34.0F, (GXColor){130,106,60,140}, 3, (u8)( hse->FlashTime /*VParam[ED_HSEXP1][17]*/ * 1.5F ), TRUE, 1001 ) ; 
		if( hse->FlashEffect2 != NULL ) hse->FlashEffect2ID = GetEffectID( hse->FlashEffect2 ) ;

		// C΂
		if( hse->FlashLineFlag == TRUE )
		{
			hse->FlashLineEffect = 
					CreateFlashLineEffect( 1, hse->Point, 10,
											0, 3, 10.0F,
											12.0F, 80.0F,
											5, 5.0F,
											0,
											12.0F, 9.0F, 4,
											0.5F, 0.5F,
											0x80, 0x80, 0x80 ) ;
			if( hse->FlashLineEffect != NULL ) hse->FlashLineEffectID = GetEffectID( hse->FlashLineEffect ) ;
		}
							
		hse->Mode ++ ;
		
		// tbV炷
//		PlayEffectSE( SFX_BT_PIKIIN  ) ;
	}
	
	if( hse->Counter == hse->TwistOnTime /*VParam[ED_HSEXP1][13]*/ && 
		hse->TwistFlag == TRUE )
	{
#ifdef FRAME_30
		// ˂ꏈ
		 hse->WhirlEffect = 
		 		CreateWhirlEffect( hse->Point, 16.0F * hse->Size, hse->TwistSizeSpeed/*VParam[ED_HSEXP1][16] * 2*/,
		 							PI_2 * 2, 80.0F, 0.0F,
		 							30, 0, 0.0F,
		 							8.4F, 0, 5000 ) ;
		if( hse->WhirlEffect != NULL ) hse->WhirlEffectID = GetEffectID( hse->WhirlEffect ) ;
#else
		// ˂ꏈ
		 hse->WhirlEffect = 
				 CreateWhirlEffect( hse->Point, 16.0F * hse->Size, hse->TwistSizeSpeed/*VParam[ED_HSEXP1][16]*/,
				 					PI_2 * 2, 40.0F, 0.0F,
				 					60, 0, 0.0F,
				 					6.4F, 0, 5000 ) ;
		if( hse->WhirlEffect != NULL ) hse->WhirlEffectID = GetEffectID( hse->WhirlEffect ) ;
#endif		
		hse->Mode ++ ;
		
		// ˂ꉹ炷
		if( GetEffectSoundOffFlag() == FALSE && hse->SoundOffFlag == false ) PlayEffectSE3D( SFX_BT_GUNYO, hse->Point, 3, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;
	}
	
	if( hse->Counter == hse->ImpactOnTime/*VParam[ED_HSEXP1][15]*/ && 
		hse->ImpactFlag == TRUE )
	{
		// ʗh炵
		
		// ʂGtFNg쐬
		#define MAX_LENGTH 30.0F 
		#define MIN_LENGTH 10.0F
		#define MAX_POWER 100.0F 
		#define MIN_POWER 10.0F
		{
			f32 dx, dy, dz, r, Power ;
			Mtx View ;
			
			// r[s擾
			HSD_CObjGetViewingMtx( GetEffectCamera(), View ) ; 
			dx = hse->Point.x - View[0][3] ;
			dy = hse->Point.y - View[1][3] ;
			dz = hse->Point.z - View[2][3] ;
			r = sqrt( dx * dx + dy * dy + dz * dz ) ;
			if( r > MAX_LENGTH ) Power = MIN_POWER ;
			else if( r < MIN_LENGTH ) Power = MAX_POWER ;
			else Power = ( MAX_POWER - MIN_POWER ) * ( ( MAX_LENGTH - MIN_LENGTH ) - ( r - MIN_LENGTH ) ) /
						 ( MAX_LENGTH - MIN_LENGTH ) + MIN_POWER ;
						 
			Power *= /*(f32)VParam[ED_HSEXP2][0]*/ hse->ImpactPower / 10.0F ;
			hse->ImpactEffect = 
					CreateImpactEffect( Power * hse->Size,
									   ( Power - Power ) * hse->Size / 2,
									   (Vec){0.0F, 0.0F, 0.0F}, hse->ImpactTime/*VParam[ED_HSEXP2][0]*/, 0, TRUE, 600 ) ;
			if( hse->ImpactEffect != NULL ) hse->ImpactEffectID = GetEffectID( hse->ImpactEffect ) ;
		}
		hse->Mode ++ ;

		// 炷
		if( GetEffectSoundOffFlag() == FALSE && hse->SoundOffFlag == false ) PlayEffectSE3D( SFX_BT_BOMB_SMILE, hse->Point, 3, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;
	}

	if( hse->Counter == hse->ExplodeOnTime /*VParam[ED_HSEXP1][18]*/ && 
		hse->ExplodeFlag == TRUE )
	{
		Vec Point ;
		
		Point = hse->Point ;
		Point.y += hse->ExplodeY/*VParam[ED_HSEXP2][22] * 0.1F*/ ;
		CreateHSExpEffect( Point, 10000 ) ;
		hse->Mode ++ ;
	}
	
	if( hse->Counter == hse->SmokeOnTime /*VParam[ED_HSEXP1][14]*/ && 
		hse->SmokeFlag == TRUE )
	{
//		GXColor Color, Color1, Color3 ;
		
//		Color.r = (u8)( HSColor[hse->HSID].r / 5 ) ;
//		Color.g = (u8)( HSColor[hse->HSID].g / 5 ) ;
//		Color.b = (u8)( HSColor[hse->HSID].b / 5 ) ;
	
//		Color1.r = (u8)VParam[ED_HSEXP1][0] ;
//		Color1.g = (u8)VParam[ED_HSEXP1][1] ;
//		Color1.b = (u8)VParam[ED_HSEXP1][2] ;
	
//		Color3.r = (u8)VParam[ED_HSEXP1][6] ;
//		Color3.g = (u8)VParam[ED_HSEXP1][7] ;
//		Color3.b = (u8)VParam[ED_HSEXP1][8] ;
		
		// KX
		if( hse->SmokeMode == 0 )
		{
//#if 0
			if( hse->SmokeAlphaX4Flag ) SetSmokeAlphaX4Flag() ;
			hse->SmokeEffect = 
					CreateSmokeEffect( 	1,				// Mode
									hse->Point,		// Point
									
									// Power
									12.10000038146973F * hse->Size * ( hse->SmokeAreaSize / 10.0F ),
									5.0F, 2.0F,									// HPower  VPower
									0.1F * ( hse->SmokeMoveTime / 10.0F ),		// ResistPower
									hse->SmokeNum,								// SmokeNum
									(Vec){0.0F,0.0F,0.0F}, 0.0F,				// Direction, DirectionRange
									PI_2 / 720.0F, PI_2 / 720.0F,				// MaxRotSPeed, MinRotSpeed
									8.0F * hse->Size, 6.0F * hse->Size * ( hse->SmokeSize / 10.0F ),	// MaxXSize, MinXSize
									8.0F * hse->Size, 6.0F * hse->Size * ( hse->SmokeSize / 10.0F ),	// MaxYSize, MinYSize
									hse->SmokeMaxTime, hse->SmokeMinTime,		// MaxLifeTime, MinLifeTime
									hse->AreaSizeFlag ? hse->AreaSize : 0.0F,	// AreaSize
									hse->SmokeColor1, hse->SmokeColor2, hse->SmokeColor3, hse->SmokeAlpha,	// Color1, Color2, Color3, SmokeAlpha
									PI / 2, -PI / 2,							// MaxOir, MinOir
									hse->SmokeAddBlendFlag,						// AddBlendFlag
									hse->SmokeMoveTime,							// StopTime
									hse->SmokeMoveArea,							// MoveArea
									hse->SmokeAddBlendPhase2Flag, hse->SmokePhaseMoveAlpha,		// AddBlendPhase2Flag, PhaseMoveAlpha
									hse->SmokeColor21, hse->SmokeColor22, hse->SmokeColor23, 	// Color21, Color22, Color23
									0.01F,										// LowSpeed
									-130 ) ; 
			if( hse->SmokeEffect != NULL ) hse->SmokeEffectID = GetEffectID( hse->SmokeEffect ) ;
		}
//		CreateExplodeEffect( hse->Point, VParam[ED_HSEXP2][6] / 10.0F, 100000 ) ;
//		CreateHSExpEffect( hse->Point, 10000 ) ;
//#endif
//#if FUJITA
		//RcNցB
		//{c͉CɓȂ炵̂ŁAf[^܂B
		//dvddata/blood.*updateĂB
		else
		{
		  Vec pos = hse->Point;
		  pos.y -= 3.f;
		  hse->gen = new C_Generator( pos, 13 ) ;
		  if( hse->gen ) hse->gen->Fire();
		}
//#endif

		hse->Mode ++ ;
	}
	hse->Counter ++ ;
	

	
	// ׂďoĂI
	if( hse->Mode == ( hse->ImpactFlag + hse->TwistFlag + hse->SmokeFlag +
							 hse->FlashFlag + hse->ExplodeFlag ) )
	{
		if( CheckEffectValidState( hse->WhirlEffect, hse->WhirlEffectID ) == FALSE &&
			CheckEffectValidState( hse->SmokeEffect, hse->SmokeEffectID ) == FALSE &&
			CheckEffectValidState( hse->FlashEffect1, hse->FlashEffect1ID ) == FALSE &&
			CheckEffectValidState( hse->FlashEffect2, hse->FlashEffect2ID ) == FALSE &&
			CheckEffectValidState( hse->ImpactEffect, hse->ImpactEffectID ) == FALSE &&
			CheckEffectValidState( hse->FlashLineEffect, hse->FlashLineEffectID ) == FALSE )
		{
#if FUJITA
			if( hse->gen ){
				//NB
				if( !(hse->gen->IsAlive()) ) DeleteEffect( Effect ) ;
			}else{
				//NɎsĂB
				DeleteEffect( Effect ) ;
			}
#else
			DeleteEffect( Effect ) ;
#endif
			return 0 ;
		}
	}
		
#else
	// [hɂď𕪊
	switch( hse->Mode )
	{
	case 0 :	// ŏɃtbVI
		CreateFlashEffect( FALSE, hse->Point, hse->Size * 12.0F, (GXColor){170,140,80,140}, 3, 10, FALSE, 1000 ) ; 
		CreateFlashEffect( FALSE, hse->Point, hse->Size * 34.0F, (GXColor){130,106,60,140}, 3, 15, TRUE, 1001 ) ; 

		// C΂
		CreateFlashLineEffect( 1, hse->Point, 10,
							0, 3, 10.0F,
							12.0F, 80.0F,
							5, 5.0F,
							0,
							12.0F, 9.0F, 4,
							0.5F, 0.5F,
							0x80, 0x80, 0x80 ) ;
		
		hse->Mode ++ ;
		break ;
	
	case 1 :	// Rt[ɂ˂Jn
		if( hse->Counter == 0 )
		{
			hse->WhirlEffect =
							 CreateWhirlEffect( hse->Point, 16.0F * hse->Size, 3.0F, PI_2 * 2,
												40.0F, 0.0F, 60,
												0,
												0.0F, 6.4F, 0,
												5000 ) ;
			
			hse->Mode ++ ;
			hse->Counter = 0 ;
		}
		else
		{
			hse->Counter ++ ;
		}
		break ;
		
	case 2 :	// ˂IƂƂɃKXro
//		if( GetEffectValidState( hse->WhirlEffect ) == FALSE )
		if( hse->Counter == 11 )
		{
			// KX
			CreateSmokeEffect( 1, hse->Point, 12.10000038146973F * hse->Size,
								5.0F, 2.0F,
								0.1F, 100,
								(Vec){0.0F,0.0F,0.0F}, 0.0F,
								PI_2 / 720.0F, PI_2 / 720.0F,
								8.0F * hse->Size, 4.0F * hse->Size,
								8.0F * hse->Size, 4.0F * hse->Size,
								180, 140, 0.0F,
								(GXColor){255,0,0},(GXColor){0,0,0},(GXColor){0,0,255},
								PI / 2, -PI / 2, FALSE, 0.01F, 500 ) ; 
								
			// ʗh炵
			{
				// ʂGtFNg쐬
				#define MAX_LENGTH 30.0F 
				#define MIN_LENGTH 10.0F
				#define MAX_POWER 100.0F 
				#define MIN_POWER 10.0F
				{
					f32 dx, dy, dz, r, Power ;
					Mtx View ;
					
					// r[s擾
					HSD_CObjGetViewingMtx( GetEffectCamera(), View ) ; 
					dx = hse->Point.x - View[0][3] ;
					dy = hse->Point.y - View[1][3] ;
					dz = hse->Point.z - View[2][3] ;
					r = sqrt( dx * dx + dy * dy + dz * dz ) ;
					if( r > MAX_LENGTH ) Power = MIN_POWER ;
					else if( r < MIN_LENGTH ) Power = MAX_POWER ;
					else Power = ( MAX_POWER - MIN_POWER ) * ( ( MAX_LENGTH - MIN_LENGTH ) - ( r - MIN_LENGTH ) ) /
								 ( MAX_LENGTH - MIN_LENGTH ) + MIN_POWER ;
					CreateImpactEffect( Power * hse->Size,
									   ( Power - Power ) * hse->Size / 2,
									   (Vec){0.0F, 0.0F, 0.0F}, 15, 0, TRUE, 600 ) ;
				}
//				SetScreenEffectTime( 30 ) ;
			}
			
			// g
/*			CreateWaveEffect( hse->Point,
								50.0F * hse->Size, 2.0F * hse->Size,
								40.0F * hse->Size, 0.0F,
								4.0F * hse->Size, 0.000F, 600 ) ;
*/
			// GtFNg̍폜
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		else
		{
			hse->Counter ++ ;
		}
		break ;
	}
#endif

	// I
	return 0 ;
}

// grGtFNg`悷
extern s8 DrawHSExplodeEffect( EFFECT *Effect )
{
	HSEXPLODEEFFECT *hse = ( HSEXPLODEEFFECT * )Effect->Data ;
	
	// I
	return 0 ;
}					


// grGtFNg̉炷炳Ȃ̃tOZbg
extern s8 SetHSExplodeEffectSoundOffFlag( bool flag )
{
	HSExpUnion.SoundOffFlag = flag ;
	
	return 0 ;	
}

// grGtFNg̉̔ł͈͂ݒ肷
extern s8 SetHSExplodeEffectSmokeAreaSize( f32 AreaSize )
{
	HSExpUnion.SmokeAreaSize = AreaSize ;
	HSExpUnion.SmokeAreaSizeFlag = true ;
	
	return 0 ;
}

// grGtFNg̉̃At@lS邩ǂ̃tOZbg
extern s8 SetHSExplodeEffectSmokeAlphaX4Flag( void )
{
	HSExpUnion.SmokeAlphaX4Flag = true ;
	
	return 0 ;
}



