///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectHSExplode
//
// YK7EffectHSExplode.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/18/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTHSEXPLODE_H
#define __YK7EFFECTHSEXPLODE_H

// include --------------------------------------
#include "./YK7Effect.h"

#if FUJITA
#include "../fujita/c_particle.h"
#endif
// define ---------------------------------------

// datatype -------------------------------------

// grGtFNgʃf[^
typedef struct tagHSEXPLODEUNION
{
	bool SoundOffFlag ;
	
	f32 SmokeAreaSize ;
	bool SmokeAreaSizeFlag ;
	bool SmokeAlphaX4Flag ;
} HSEXPLODEUNION ;

// grGtFNgf[^
typedef struct tagHSEXPLODEEFFECT
{
	Vec Point ;				// W
	f32 Size ;				// ̃TCY
	u16 Counter ;			// JE^[
	u16 Mode ;				// [h
	u16 HSID ;				// wuX}Ĉhc
	
	EFFECT *WhirlEffect ;	// ˂GtFNg̃|C^
	u32 WhirlEffectID ;		// ˂GtFNĝhc
	EFFECT *SmokeEffect ;	// GtFNg̃|C^
	u32 SmokeEffectID ;		// GtFNĝhc
	EFFECT *FlashEffect1 ;	// tbVGtFNgP̃|C^
	u32 FlashEffect1ID ;	// tbVGtFNgP̂hc
	EFFECT *FlashEffect2 ;	// tbVGtFNgQ̃|C^
	u32 FlashEffect2ID ;	// tbVGtFNgQ̂hc
	EFFECT *ImpactEffect ;	// ʗhGtFNg̃|C^
	u32 ImpactEffectID ;	// ʗhGtFNĝhc
	EFFECT *FlashLineEffect ;	// GtFNg̃|C^
	u32 FlashLineEffectID ;		// GtFNĝhc
	
	u8 FlashOnTime ;		// GtFNgtbV܂ł̎
	u8 TwistOnTime ;		// GtFNgʂ˂GtFNg܂ł̎
	u8 SmokeOnTime ;		// GtFNg牌˂܂ł̎
	u8 ImpactOnTime ;		// GtFNgʗh炵GtFNg܂ł̎
	u8 ExplodeOnTime ;		// GtFNg甚GtFNg܂ł̎
	
	f32 TwistSizeSpeed ;	// ˂GtFNg̔ȃ傫Ȃ鑬x
	f32 ImpactPower ;		// ʗh炵GtFNg̉ʂh炷
	f32 ExplodeY ;			// GtFNg̑΂xW
	GXColor SmokeColor1 ;	// GtFNg̐F
	GXColor SmokeColor2 ;
	GXColor SmokeColor3 ;
	u8 SmokeAlpha ;			// ̊{At@l
	f32 SmokeSize ;			// r{[h̑傫
	u8 SmokeMoveTime ;		// ړ鎞
	u16 SmokeNum ;			// ̐
	f32 SmokeAreaSize ;		// ̑傫
	u16 SmokeMaxTime ;		// ܂ł̍ő厞
	u16 SmokeMinTime ;		// ܂ł̍ŒZ
	u8 FlashTime ;			// tbV鎞
	u8 ImpactTime ;			// ʂh炵鎞
	
	u8 ImpactFlag ;			// ʗh炵stO
	u8 TwistFlag ;			// ʂ˂GtFNgstO
	u8 SmokeFlag ;			// 𔭐邩tO
	u8 FlashFlag ;			// tbV邩tO
	u8 FlashLineFlag ;		// tbVC`悷邩tO
	u8 ExplodeFlag ;		// GtFNgstO
	
	u8 SmokeAddBlendFlag ;	// ɉZstO
	f32 SmokeMoveArea ;		// ł͈(1.0F:ő򋗗`O̊  0.5F:ő򋗗`ő򋗗w0.5܂ł̊)
	u8 SmokeAddBlendPhase2Flag ;	// At@llɒBAFQ̃At@uhɈڍs邩tO
	u8 SmokePhaseMoveAlpha ;		// ZuhAt@uhɏڍsAt@臒l
	GXColor SmokeColor21 ;			// ̐FAPF[̐F QFS̐F RFE[̐F
	GXColor SmokeColor22 ;
	GXColor SmokeColor23 ;

	bool SoundOffFlag ;

	f32 AreaSize ;
	bool AreaSizeFlag ;
	bool SmokeAlphaX4Flag ;
	
	u8 SmokeMode ;			// [h
#if FUJITA
	C_Generator *gen;			//030901p̉B
#endif
} HSEXPLODEEFFECT ;

// grGtFNg^XNɓnf[^
typedef struct tagHSEXPLODEEFFECTTACKPARAM
{
	Vec Point ;				// W
	f32 Size ;				// ̃TCY
//	u16 HSID ;				// wuX}Ĉhc
	
	u8 FlashOnTime ;		// GtFNgtbV܂ł̎
	u8 TwistOnTime ;		// GtFNgʂ˂GtFNg܂ł̎
	u8 SmokeOnTime ;		// GtFNg牌˂܂ł̎
	u8 ImpactOnTime ;		// GtFNgʗh炵GtFNg܂ł̎
	u8 ExplodeOnTime ;		// GtFNg甚GtFNg܂ł̎
	
	f32 TwistSizeSpeed ;	// ˂GtFNg̔ȃ傫Ȃ鑬x
	f32 ImpactPower ;		// ʗh炵GtFNg̉ʂh炷
	f32 ExplodeY ;			// GtFNg̑΂xW
	GXColor SmokeColor1 ;	// GtFNg̐F
	GXColor SmokeColor2 ;
	GXColor SmokeColor3 ;
	u8 SmokeAlpha ;			// ̊{At@l
	f32 SmokeSize ;			// r{[h̑傫
	u8 SmokeMoveTime ;		// ړ鎞
	u16 SmokeNum ;			// ̐
	f32 SmokeAreaSize ;		// ̑傫
	u16 SmokeMaxTime ;		// ܂ł̍ő厞
	u16 SmokeMinTime ;		// ܂ł̍ŒZ
	u8 FlashTime ;			// tbV鎞
	u8 ImpactTime ;			// ʂh炵鎞
	
	u8 ImpactFlag ;			// ʗh炵stO
	u8 TwistFlag ;			// ʂ˂GtFNgstO
	u8 SmokeFlag ;			// 𔭐邩tO
	u8 FlashFlag ;			// tbV邩tO
	u8 FlashLineFlag ;		// tbVC`悷邩tO
	u8 ExplodeFlag ;		// GtFNgstO
	
	u8 SmokeAddBlendFlag ;			// ɉZstO
	f32 SmokeMoveArea ;				// ł͈(1.0F:ő򋗗`O̊  0.5F:ő򋗗`ő򋗗w0.5܂ł̊)
	u8 SmokeAddBlendPhase2Flag ;	// At@llɒBAFQ̃At@uhɈڍs邩tO
	u8 SmokePhaseMoveAlpha ;		// ZuhAt@uhɏڍsAt@臒l
	GXColor SmokeColor21 ;			// ̐FAPF[̐F QFS̐F RFE[̐F
	GXColor SmokeColor22 ;
	GXColor SmokeColor23 ;

	u8 SmokeMode ;			// [h
} HSEXPLODEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitHSExplodeData( void ) ;				// grGtFNg̋ʃf[^
extern s8 CheckHSExplodeData( void ) ;				// grGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndHSExplodeData( void ) ;				// grGtFNg̋ʃf[^n

//extern void HSExplodeEffectTask( ghmGcTask *pTask ) ;								// grGtFNg^XN

extern EFFECT *CreateHSExplodeEffect( u16 HSID, Vec Point, f32 Size, s32 Priority = 100 ) ;	// grGtFNg쐬
extern EFFECT *CreateHSExplodeEffect2( /*u16 HSID,*/  Vec Point, f32 Size,
										u8 FlashOnTime, u8 TwistOnTime, u8 SmokeOnTime,
										u8 ImpactOnTime, u8 ExplodeOnTime,
										f32 TwistSizeSpeed, f32 ImpactPower, f32 ExplodeY,
										GXColor SmokeColor1, GXColor SmokeColor2, GXColor SmokeColor3, 
										f32 SmokeSize, u8 SmokeMoveTime, u16 SmokeNum, f32 SmokeAreaSize,
										u16 SmokeMaxTime, u16 SmokeMinTime, u8 SmokeAlpha,
										u8 ImpactTime, u8 FlashTime,
										u8 ImpactFlag, u8 TwistFlag, u8 SmokeFlag, u8 FlashFlag, u8 FlashLineFlag, u8 ExplodeFlag,
										u8 SmokeAddBlendFlag, f32 SmokeMoveArea,
										u8 SmokeAddBlendPhase2Flag, u8 SmokePhaseMoveAlpha,
										GXColor SmokeColor21, GXColor SmokeColor22, GXColor SmokeColor23, u8 SmokeMode,
										s32 Priority = -1 ) ;	// grGtFNg쐬
extern s8 ReleaseHSExplodeEffect( EFFECT *Effect ) ;								// grGtFNǧns
extern s8 MoveHSExplodeEffect( EFFECT *Effect ) ;									// grGtFNgPt[
extern s8 DrawHSExplodeEffect( EFFECT *Effect ) ;									// grGtFNg`悷

extern s8 SetHSExplodeEffectSoundOffFlag( bool flag ) ;			// grGtFNg̉炷炳Ȃ̃tOZbg
extern s8 SetHSExplodeEffectSmokeAreaSize( f32 AreaSize ) ;		// grGtFNg̉̔ł͈͂ݒ肷
extern s8 SetHSExplodeEffectSmokeAlphaX4Flag( void ) ;			// grGtFNg̉̃At@lS邩ǂ̃tOZbg

#endif
