///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectHitNum
//
// YK7EffectHitNum.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTHITNUM_H
#define __YK7EFFECTHITNUM_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// qbg\GtFNgʃf[^
typedef struct tagHITNUMUNION
{
	u8 dummy ;
} HITNUMUNION ;

// qbg̕\pf[^
typedef struct tagHITNUMOBJECT
{
	s32 hitnum ;
	s32 mode, counter ;			// ( 0:\  1:m[}  2:g  3:傫h )
} HITNUMOBJECT ;

// qbg\GtFNgf[^
typedef struct tagHITNUMEFFECT
{
	s32 mode1, mode2, counter ;

	HITNUMOBJECT playhit, enemhit ;		// qbg̏
	s8 windir ;							// ( 0:vC[̏  1:G̏ )
	f32 winpos[3] ;						// ̈ʒu( 0.0F:B  1.0F:ԗĂ )
	f32 winblur ;
	s32 playnum, enemnum ;

/*
	f32 playerwin, enemywin ;
	s32 playernum, enemynum ;
	s32 pnumcon[3], enumcon[3] ;
	s32 phitcon[3], ehitcon[3] ;
	s32 con ;
*/	
	f32 alpha ;
} HITNUMEFFECT ;

// qbg\GtFNg^XNɓnf[^
typedef struct tagHITNUMEFFECTTACKPARAM
{
	s32 playernum, enemynum ;		// vC[ƓĜꂼ̃qbg
} HITNUMEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitHitNumData( void ) ;			// qbg\GtFNg̋ʃf[^
extern s8 CheckHitNumData( void ) ;			// qbg\GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndHitNumData( void ) ;				// qbg\GtFNg̋ʃf[^n

extern EFFECT *CreateHitNumEffect(
									s32 playernum, s32 enemynum,		// vC[ƓĜꂼ̃qbg
									s32 Priority = -1 ) ;				// qbg\GtFNg쐬

extern s8 ReleaseHitNumEffect( EFFECT *Effect ) ;	// qbg\GtFNǧns
extern s8 MoveHitNumEffect( EFFECT *Effect ) ;		// qbg\GtFNgPt[
extern s8 DrawHitNumEffect( EFFECT *Effect ) ;		// qbg\GtFNg`悷

extern s8 GetHitNumEffectState( EFFECT *Effect ) ;		// qbgGtFNg̏Ԃ𓾂( 0:ʂ삯  1:~ )

#endif

