///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectKunSmoke
//
// YK7EffectKunSmoke.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectKunSmoke.h"
#include "./YK7EffectExplode.h"
#include "./YK7EffectCharGeki.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

KUNSMOKEUNION KSUnion ;

// function proto type --------------------------

s8 KunSmokeTexLoadCheck( void ) ;				// [hǂ𒲂ׂ

// function code --------------------------------

// [hǂ𒲂ׂ
s8 KunSmokeTexLoadCheck( void )
{
	// I
	return TRUE ;
}



// NEGtFNg̋ʃf[^
extern s8 InitKunSmokeData( void )
{
	MEMINIT( KSUnion ) ;
	
	// I
	return 0 ;
}

// NEGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckKunSmokeData( void )
{
	return TRUE ;
}



// NEGtFNg̋ʃf[^n
extern s8 EndKunSmokeData( void )
{
	MEMINIT( KSUnion ) ;
	
	// I
	return 0 ;
}


// NẼGtFNg쐬
extern EFFECT *CreateKunSmokeEffect( Vec Pos, s32 Priority )
{
	KUNSMOKEEFFECT *KS ;
	EFFECT *Effect ;

	// VNEf[^쐬
	Effect = AddEffectData( EFF_KUNSMOKE, (void**)&KS, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// NEf[^
	KS->Counter = 0 ;
	KS->Pos = Pos ;
	
	SetCharGekiKunSmokePoint( Effect ) ;

	// I
	return Effect ;
}

// NẼGtFNǧns
extern s8 ReleaseKunSmokeEffect( EFFECT *Effect )
{
	KUNSMOKEEFFECT *KS = ( KUNSMOKEEFFECT * )Effect->Data ;

	// GtFNgׂč폜
	DeleteOptionIDEffect( EFF_SMOKE ) ;

	// ɂ邱ƂȂ
	return 0 ;
}

// NẼGtFNgPt[
extern s8 MoveKunSmokeEffect( EFFECT *Effect )
{
	KUNSMOKEEFFECT *KS = ( KUNSMOKEEFFECT * )Effect->Data ;

	if( (KUNSMOKEEFFECT *)NULL == KS ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( KunSmokeTexLoadCheck() == FALSE ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE )
	{
		if( GetOptionIDEffectNum( EFF_SMOKE ) == 0 )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}
	else
	{
		KS->Counter ++ ;
		if( KS->Counter >= VParam[ED_KUNSMOKE][24] )
		{
			CreateSmokeExplodeEffect( KS->Pos, 2.0F, 3 ) ;
			KS->Counter = 0 ;
		}
	}
	
	// I
	return 0 ;
}
	
// NẼGtFNg`悷
extern s8 DrawKunSmokeEffect( EFFECT *Effect )
{
	KUNSMOKEEFFECT *KS = ( KUNSMOKEEFFECT * )Effect->Data ;

	if( (KUNSMOKEEFFECT *)NULL == KS ) return 0 ;
	if( KunSmokeTexLoadCheck() == FALSE ) return 0 ;

	// I
	return 0 ;
}






