///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLaser2
//
// YK7EffectLaser2.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/07/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTLASER2_H
#define __YK7EFFECTLASER2_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// [U[QGtFNgʃf[^
typedef struct tagLASER2UNION
{
	u8 DivNum ;				// 
	f32 Width ;				// 
} LASER2UNION ;

// [U[QGtFNgf[^
typedef struct tagLASER2EFFECT
{
	Vec StartPos, EndPos ;	// ˈʒuƖڕWʒu
	Vec Dir ;				// ڕWʒu甭ˈʒuւ̕
	f32 Len ;				// ˈʒuڕWʒu܂ł̋
	f32 p1, p2 ;			// n_̈ʒuƏI_̈ʒu( StartPosEndPos = 0.0F |EndPos - StartPos| )
	f32 speed ;				// x

	f32 Width ;				// 
	u8 DivNum ;				// 
	u32 color ;				// F
} LASER2EFFECT ;

// [U[QGtFNg^XNɓnf[^
typedef struct tagLASER2EFFECTTACKPARAM
{
	Vec StartPos, EndPos ;	// ˈʒuƖڕWʒu
	f32 speed ;				// x
	GXColor color ;			// F
} LASER2EFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitLaser2Data( void ) ;				// [U[QGtFNg̋ʃf[^
extern s8 CheckLaser2Data( void ) ;				// [U[QGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndLaser2Data( void ) ;				// [U[QGtFNg̋ʃf[^n

extern EFFECT *CreateLaser2Effect(
									Vec StartPos, Vec EndPos,	// ˈʒuƖڕWʒu
									f32 speed,					// x
									GXColor color,				// F
									s32 Priority = -1 ) ;		// [U[QGtFNg쐬
extern s8 ReleaseLaser2Effect( EFFECT *Effect ) ;				// [U[QGtFNǧns
extern s8 MoveLaser2Effect( EFFECT *Effect ) ;					// [U[QGtFNgPt[
extern s8 DrawLaser2Effect( EFFECT *Effect ) ;					// [U[QGtFNg`悷

extern bool GetLaser2HitState( EFFECT *Effect ) ;				// [U[^[QbgɓBǂ𓾂( true:B  false:܂ )

#endif

