///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMessage
//
// YK7EffectMessage.cpp
//
// Creator	   : Takumi Yamada (GHM)
// Creation Date : 07/23/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

#define ___3D
//#define __OLDMODE

#ifdef YAMADADEBUG 
//	#define __ALLLOAD
#endif

#define NO_CODE

// include --------------------------------------
#include "./YK7EffectMessage.h"
#include "../matsu/mK7Jimaku.h"
#include "../matsu/mk7Sound.h"
#include "../Wat/WK7SelectIF.h"

// define ---------------------------------------

#define GETVEC3( xx, yy, Dest ) 			\
		GetXYVectConv( &MsUnion.PlXVec3, &MsUnion.PlYVec3, &MsUnion.PlStPoint3, Dest, (f32)(xx) / VParam[ED_MESSAGE3][5], (f32)(yy) / VParam[ED_MESSAGE3][5] ) ;

#define SETVEC3( xx, yy )			\
		GetXYVectConv( &MsUnion.PlXVec3, &MsUnion.PlYVec3, &MsUnion.PlStPoint3, &Dest, (f32)(xx) / VParam[ED_MESSAGE3][5], (f32)(yy) / VParam[ED_MESSAGE3][5] ) ;		\
		GP3( Dest.x, Dest.y, Dest.z )


#define GETVEC2( xx, yy, Dest ) 			\
		GetXYVectConv( &MsUnion.PlXVec2, &MsUnion.PlYVec2, &MsUnion.PlStPoint2, Dest, (f32)(xx) / VParam[ED_MESSAGE2][15], (f32)(yy) / VParam[ED_MESSAGE2][15] ) ;

#define SETVEC2( xx, yy )			\
		GetXYVectConv( &MsUnion.PlXVec2, &MsUnion.PlYVec2, &MsUnion.PlStPoint2, &Dest, (f32)(xx) / VParam[ED_MESSAGE2][15], (f32)(yy) / VParam[ED_MESSAGE2][15] ) ;		\
		GP3( Dest.x, Dest.y, Dest.z )

#define GETVEC( xx, yy, Dest ) 			\
		GetXYVectConv( &MsUnion.PlXVec, &MsUnion.PlYVec, &MsUnion.PlStPoint, Dest, (f32)(xx) / VParam[ED_MESSAGE2][5], (f32)(yy) / VParam[ED_MESSAGE2][5] ) ;

#define SETVEC( xx, yy )			\
		GetXYVectConv( &MsUnion.PlXVec, &MsUnion.PlYVec, &MsUnion.PlStPoint, &Dest, (f32)(xx) / VParam[ED_MESSAGE2][5], (f32)(yy) / VParam[ED_MESSAGE2][5] ) ;		\
		GP3( Dest.x, Dest.y, Dest.z )


#define ARROW_INITSP			30				// ȍXs[h
#define ARROW_INTIME			15				// 󂪏oāAʒ[ɕKvȕc܂ł̎
#define ARROW_INWAIT			4				// 󂪏oĂ҂
#define BOTTOMLINE_INSP			8				// ỏXs[h
#define BOTTOMLINE_INWAIT		4				// ̃CLтĂ҂
#define POINTLINE_INSPEED		0				// _т鑬A̓_\邽тɑ҂
#define POINTLINE_INWAIT		4				// _Lѐ؂Ă҂
#define MESSAGE_INIITSP			30				// bZ[WĂ鏉Xs[h
#define MESSAGE_INTIME			15				// bZ[WĂ鎞
#define MESSAGE_INWAIT			37				// bZ[W\Ă҂
#define STATE_OUTSP				8				// bZ[WĂɍɋčs̉x
#define STATE_OUTWAIT			8				// bZ[Wčs̑҂
#define BOTTOMLINE_OUTINITSP	30				// ̃CEɋĂ̏x
#define BOTTOMLINE_OUTTIME		15				// ̃CEɋĂ̎

// bZ[WOtBbÑeNX`t@C
#define MES_MESTEXNAME 	"/Yam/Message/Message" 				// bZ[WeNX`t@C
#define MES_ICONTEXNAME "/Yam/Message/Message_Icon.BIN"		// bZ[WACReNX`t@C
#define MES_ARROWTEXNAME "/Yam/Message/Message_Arrow.BIN"	// bZ[W̖eNX`t@C
#define MES_TESTICON	"/Yam/Message/ICON.BIN"				// eXgpACRt@C
#define MES_ICONPATH	"/Yam/Message/ICON/ICON"			// ACRt@C{pX

#define BOTTOM_LINE_X	42/*177*/								// C̊_wW

#define ARROW_PW		( WK7_SCREEN_WIDTH * 2 )
#define ARROW_W			548										// OtBbN̕
#define ARROW_H			39										// OtBbN̍
#define ARROW_ALLL		( ARROW_PW + ARROW_W )					// ̃vO`悷钷܂߂
#define ARROW_AMARI		50/*185*/								// ̃OtBbNŉʂɎc镝

#define SUKIMA			25

//#define ICON_PITCH		1									// ACReNX`PC̃ACR̐
#define ICON_SIZE		32										// ACRe̃sNZ
#define ICON_X			( ARROW_ALLL + 4 ) 						// ACR̊_wW
#define ICON_Y			( ( ARROW_H - ICON_SIZE ) / 2 )

#define MESSAGE_W			347									// bZ[WOtBbN̕
#define MESSAGE_H			17									// bZ[WOtBbN̍
#define MESSAGE_ASOBI		38
#define MESSAGE_WAIT		( ARROW_H + 2 )						// ㉺ɃbZ[W񂾏ꍇ̃bZ[WƃbZ[W̊Ԋu
//#define MESSAGE_Y			( ( ARROW_H - MESSAGE_H ) / 2 )
#define MESSAGE_Y			( ARROW_H / 2 )

#define TENLINE_LENGTH		7									// _̈̓_̒
#define TENLINE_WIDTH		2									// _̑
#define TENLINE_WAIT		2									// _Ɠ_̊Ԋu
#define TENLINE_X			( ICON_X + ICON_SIZE + 4 )			// _̊_wW
#define TENLINE_Y			( ( ARROW_H - TENLINE_WIDTH ) / 2 )	// _̊_xW

#define TICKTIME			4800
#define ICONCHK(x)			( (x)->IconID != -1 ? (x)->IconID == (s32)ICONID_NONE : GetNoneIconCheck( (s8)(x)->PackID, (s8)(x)->MessageID ) )

#define FOV					(33.300000F)	
#define ASPECT				(1.333333F)

// ACRhc
enum
{
	ICONID_KEY = 2,				// ACR
	ICONID_CARD = 1,			// J[hACR
	ICONID_NONE = 0,			// ACRȂ
	ICONID_MEMO = 3,			// ACR
	ICONID_NUM = 4,				// ACRhc̐
} ;

// e[u
static u32 SoundTable[] =
{
	SFX_SYS_KEY_GET,				// ɓꂽƂ̉
	SFX_SYS_KEY_GET,				// grhcɓꂽƂ̉
	SFX_SYS_KEY_GET,				// ėprd
} ;

// bZ[Wf[^e[u( 0:ACR̂hc  1:bZ[W̃hbg  2:ʉhc@)
static u32 MesDataTable[MES_NUM][3] =
{
	ICONID_KEY,	124, 	SFX_SYS_KEY_GET,			// ɓꂽbZ[W
	ICONID_CARD, 159,	SFX_SYS_KEY_GET,			// grhcɓꂽbZ[W
} ;


// datatype -------------------------------------

// data -----------------------------------------

MESSAGEUNION MsUnion ;

#ifndef NO_CODE

static u8 ColorTable[3][50][3] =
{
	{ 84,117,43,   112,117,43,  69,99,122,   0,105,89,    92,112,94,   36,97,71,    31,97,87,    94,102,56,   79,110,94,   36,97,71,
	  33,66,48,    31,56,46,    41,71,61,    26,48,36,    28,69,56,    64,79,33,    61,71,33,    64,71,20,    94,92,15,    74,69,18,  },
	{112,64,94,   130,28,107,  110,38,54,   135,74,77,   105,51,43,   117,41,41,   156,48,26,   92,48,33,    125,77,56,   153,79,20,
	 143,92,48,   107,74,28,   148,128,10,  99,84,18,    84,64,31,    77,38,18,    97,51,20,    82,41,28,    79,51,36,    105,46,31  },
	{0,184,224,   0,153,171,   0,166,222,   0,156,163,   0,163,224,   0,189,181,   0,179,143,   10,148,214,  120,179,224, 51,66,181, 
	 87,138,214,  26,117,207,  0,89,156,    87,138,214,  0,156,163,    51,66,181,   176,217,230,  102,125,209, 148,181,224, 122,171,222,
	  173,207,230, 87,181,224,  87,191,227,  105,204,230, 173,219,227, 176,217,230, 133,199,227, 119,217,230, 158,191,227, 186,196,227},
//	{255,28,56,   255,0,71,    227,13,64,   255,13,46,   255,46,56,   255,38,41,   255,64,41,   255,79,0,    255,99,59,   255,128,133,
//	 255,99,120,  255,140,161, 255,117,148, 255,153,181, 255,156,168, 255,122,163, 255,122,176, 255,110,173, 255,3,92,    255,23,148 },
//	{232,227,217, 173,161,148, 230,219,209, 209,209,204, 217,201,199, 217,214,209, 209,204,196, 212,201,189, 207,196,186, 209,201,189,
//	 189,176,166, 186,181,168, 191,186,181, 201,201,196, 207,186,186, 186,189,186, 222,214,204, 163,148,135, 219,217,209, 163,161,158},
} ;

static u8 ColorTable2[3][3] =
{
	{ 1,175,111 },  { 255,0,0 },  {0,49,220},
} ;

static u8 ColorTable3[3][3] =
{
	{ 0, 0, 0 }, { 0, 0, 0 }, { 100, 21, 23 }
} ; 
#endif

// function proto type --------------------------

static s8 GetMessagePost( void ) ;				// bZ[W|Xg𓾂
static s8 ReleaseMessagePost( s8 PostID ) ;		// bZ[W|XgJ

static s16 GetWaitCount( void ) ;							// ҂Ԃ𓾂
static s16 RenderMessage( s8 PackID, s8 MessageID, s16 x, s16 y, GXColor Color, 
							u8 DrawFlag = TRUE, s8 LeftFlag = FALSE, s8 MesType = 2,
							f32 Size = 1.0F, f32 ExRate = 0.0F, f32 Asobi = MESSAGE_ASOBI,
							GXColor *C2 = NULL, s8 TableIndex = -1, s8 MesType2 = 0,
							f32 *RandMap = NULL, s32 MaxHeight = -1 ) ;	// w̃bZ[W`悷

static s8 SetupIconTex( s8 IconID ) ;								// w̃ACR̃ZbgAbv(̊֐ĂԂƎQƐAQƐO̎Ƀ[h)
static s8 ReleaseIconTex( s8 IconID ) ;								// w̃ACR̉(̊֐ĂԂƎQƐAQƐOɂȂeNX`̉s)
static s8 CheckIconTex( s8 IconID ) ;								// w̃ACR̃ZbgAbvIĂ邩`FbN(TRUE:IĂ  FALSE:܂)

static s8 SetupPlaneInfo( void ) ;									// Cӂ̕ʂɕ`悷邽߂̏
static s8 GetXYVectConv( Vec *XVec, Vec *YVec, Vec *StartVec,
									 Vec *Dest, f32 x, f32 y ) ;			// Cӂ̂Qʏ̓̍W𓾂
static s8 GetXYZVectConv( Vec *XVec, Vec *YVec, Vec *ZVec, Vec *StartVec,
									 Vec *Dest, f32 x, f32 y, f32 z ) ;		// Cӂ̂Rԏ̓̍W𓾂

static s8 Draw3DLine( Vec *V, s8 PlaneNumber, s8 LeftFlag ) ;				// RcԂɘg`悷

static s8 SetPos( f32 x, f32 y, s8 Type ) ;						// WZbg
static s8 SetPos2( f32 x, f32 y, s8 Type ) ;					// WZbgQ
static s8 SetPos3( f32 x, f32 y, s8 Type ) ;					// WZbgR

// function code --------------------------------

#ifndef NO_CODE

// WZbg
static s8 SetPos( f32 x, f32 y, s8 Type )
{
	Vec Dest ;

	switch( Type )
	{
	case 2 :
	case 0 : GP2( x, y ) ; break ;
	case 1 : SETVEC( x, y ) ; break ;
	}

	// I
	return 0 ;
}

// WZbgQ
static s8 SetPos2( f32 x, f32 y, s8 Type )
{
	Vec Dest ;
	
	switch( Type )
	{
	case 2 :
	case 0 : GP2( x, y ) ; break ;
	case 1 : SETVEC2( x, y ) ; break ;
	}
	
	// I
	return 0 ;
}

// WZbgR
static s8 SetPos3( f32 x, f32 y, s8 Type )
{
	Vec Dest ;

	switch( Type )
	{
	case 2 :
	case 0 : GP2( SCW - x, y ) ; break ;
	case 1 : SETVEC3( x, y ) ; break ;
	}
	
	// I
	return 0 ;
}


// RcԂɃC`悷
static s8 Draw3DLine( Vec *V, s8 PlaneNumber, s8 LeftFlag )
{
	Vec Src[4], Dest[4] ;
	
	{
		HSD_CObj *Camera ;
		Vec PlaneNormal, PlanePoint ;

		// eNX`̃[h
		GTLOAD( &MsUnion.ArrowTex.Obj ) ;
	
		EffectProjectSetup( EF_PROJECT_PERS ) ;
	
		// near ʏ̍W擾
		{
			f32 n ;
			Vec V ;
		
			// J̏擾
			Camera = GetEffectCamera() ;
			
			// near ʂ܂ł̋𓾂
			n = HSD_CObjGetNear( Camera );
			
			// J̎xNg near ʂ̖@
			HSD_CObjGetEyeVector( Camera, &PlaneNormal ) ;
			
			// near ̈_擾
			HSD_CObjGetEyePosition( Camera, &PlanePoint ) ;
			VECScale( &PlaneNormal, &V, n ) ;
			VECAdd( &PlanePoint, &V, &PlanePoint ) ;
		}
		
		// ׂĂ̒_ʂOĂȂꍇ̂ݕ`悷悤ɂ
		{
			Vec Srcc[4],V80[4]  ;
			s8 Rettt ;

			if( PlaneNumber == 0 )
			{
				if( LeftFlag == TRUE )
				{
					GETVEC3( V[0].x, V[0].y, &Srcc[0] ) ;
					GETVEC3( V[1].x, V[1].y, &Srcc[1] ) ;
					GETVEC3( V[2].x, V[2].y, &Srcc[2] ) ;
					GETVEC3( V[3].x, V[3].y, &Srcc[3] ) ;
				}
				else
				{
					GETVEC( V[0].x, V[0].y, &Srcc[0] ) ;
					GETVEC( V[1].x, V[1].y, &Srcc[1] ) ;
					GETVEC( V[2].x, V[2].y, &Srcc[2] ) ;
					GETVEC( V[3].x, V[3].y, &Srcc[3] ) ;
				}
			}
			else
			{
				GETVEC2( V[0].x, V[0].y, &Srcc[0] ) ;
				GETVEC2( V[1].x, V[1].y, &Srcc[1] ) ;
				GETVEC2( V[2].x, V[2].y, &Srcc[2] ) ;
				GETVEC2( V[3].x, V[3].y, &Srcc[3] ) ;
			}


			if( ( ( Rettt = CheckCrossVectPlane( &PlaneNormal, &PlanePoint, &Srcc[0], &Srcc[1], &Srcc[0] ) ) & 1 ) == 1 )
			{
//					return 0 ;
			}
			if( ( ( Rettt = CheckCrossVectPlane( &PlaneNormal, &PlanePoint, &Srcc[1], &Srcc[2], &V80[1] ) ) & 1 ) == 1 )
			{
				return 0 ;
			}
			if( ( ( Rettt = CheckCrossVectPlane( &PlaneNormal, &PlanePoint, &Srcc[2], &Srcc[3], &Srcc[3] ) ) & 1 ) == 1 )
			{
//					return 0 ;
			}
			
			Src[0] = Srcc[0] ;
			Src[1] = Srcc[1] ;
			Src[2] = Srcc[2] ;
			Src[3] = Srcc[3] ;
		}
	}
	
	EffectProjectSetup( EF_PROJECT_ORTHO ) ;
	{
		CalcParallelFramePosition( Src, Dest, 4, (f32)VParam[ED_MESSAGE2][7] ) ;

		GBGN( GX_TRIANGLESTRIP, 4 * 2 ) ;
		{
			GPV2( Src[0] ) ; 	GCX( 0xffffffff ) ; GT( 0.0F, 0.0F ) ;
			GPV2( Dest[0] ) ; 	GCX( 0xffffffff ) ; GT( 0.0F, 0.0F ) ;

			GPV2( Src[1] ) ; 	GCX( 0xffffffff ) ; GT( 0.0F, 0.0F ) ;
			GPV2( Dest[1] ) ; 	GCX( 0xffffffff ) ; GT( 0.0F, 0.0F ) ;

			GPV2( Src[2] ) ; 	GCX( 0xffffffff ) ; GT( 0.0F, 0.0F ) ;
			GPV2( Dest[2] ) ; 	GCX( 0xffffffff ) ; GT( 0.0F, 0.0F ) ;

			GPV2( Src[3] ) ; 	GCX( 0xffffffff ) ; GT( 0.0F, 0.0F ) ;
			GPV2( Dest[3] ) ; 	GCX( 0xffffffff ) ; GT( 0.0F, 0.0F ) ;
		}
		GXEnd() ;
	}
	
	EffectProjectSetup( EF_PROJECT_PERS ) ;
	
	// I
	return 0 ;
}



// Cӂ̂Rԏ̓̍W𓾂
static s8 GetXYZVectConv( Vec *XVec, Vec *YVec, Vec *ZVec, Vec *StartVec,
									 Vec *Dest, f32 x, f32 y, f32 z )
{
	Vec X, Y, Z ;

	VECScale( XVec, &X, x ) ;
	VECScale( YVec, &Y, y ) ;
	VECScale( ZVec, &Z, z ) ;

	Dest->x = X.x + Y.x + Z.x + StartVec->x ;
	Dest->y = X.y + Y.y + Z.y + StartVec->y ;
	Dest->z = X.z + Y.z + Z.z + StartVec->z ;

	// I
	return 0 ;
}

								 
// Cӂ̂Qʏ̓̍W𓾂
static s8 GetXYVectConv( Vec *XVec, Vec *YVec, Vec *StartVec, Vec *Dest, f32 x, f32 y )
{
	Vec X, Y ;
	
	VECScale( XVec, &X, x ) ;
	VECScale( YVec, &Y, y ) ;
	
	Dest->x = X.x + Y.x + StartVec->x ;
	Dest->y = X.y + Y.y + StartVec->y ;
	Dest->z = X.z + Y.z + StartVec->z ;
	
	// I
	return 0 ;
}
	
	

// Cӂ̕ʂɕ`悷邽߂̏
static s8 SetupPlaneInfo( void )
{
	Vec CamX, CamY, CamZ, CamP ;

	// J猩wxyƃJ̍W𓾂
	HSD_CObjGetLeftVector( GetEffectCamera(), &CamX ) ;
	HSD_CObjGetUpVector( GetEffectCamera(), &CamY ) ;
	HSD_CObjGetEyeVector( GetEffectCamera(), &CamZ ) ;
	HSD_CObjGetEyePosition( GetEffectCamera(), &CamP ) ;

	{
		// `敽ʂ̌_WZo
		GetXYZVectConv( &CamX, &CamY, &CamZ, &CamP,
							&MsUnion.PlStPoint, 
							VParam[ED_MESSAGE2][2] * 0.01F,
							VParam[ED_MESSAGE2][3] * 0.01F,
							VParam[ED_MESSAGE2][4] * 0.1F ) ;

		// `敽ʂ̂wx̕Zo
		{
			Vec XVec, YVec, TempYVec, TempV ;
		
			GetXYZVectConv( &CamX, &CamY, &CamZ, &CamP,
								&XVec, 
								VParam[ED_MESSAGE2][2] * 0.01F - VParam[ED_MESSAGE2][0] * 0.01F,
								VParam[ED_MESSAGE2][3] * 0.01F - VParam[ED_MESSAGE2][6] * 0.01F,
								VParam[ED_MESSAGE2][4] * 0.1F - VParam[ED_MESSAGE2][1] * 0.01F ) ;
			GetXYZVectConv( &CamX, &CamY, &CamZ, &CamP,
								&TempYVec,
								VParam[ED_MESSAGE2][2] * 0.01F,
								VParam[ED_MESSAGE2][3] * 0.01F - 1.0F,
								VParam[ED_MESSAGE2][4] * 0.1F ) ;
			VECSubtract( &XVec, &MsUnion.PlStPoint, &XVec ) ;
			VECSubtract( &TempYVec, &MsUnion.PlStPoint, &TempYVec ) ;
			
			VECCrossProduct( &XVec, &TempYVec, &TempV ) ;
			VECCrossProduct( &TempV, &XVec, &YVec ) ;

			VECNormalize( &YVec, &MsUnion.PlYVec ) ;
			VECNormalize( &XVec, &MsUnion.PlXVec ) ;
		}
	}

	{
		// `敽ʂ̌_WZo
		GetXYZVectConv( &CamX, &CamY, &CamZ, &CamP,
							&MsUnion.PlStPoint2, 
							VParam[ED_MESSAGE2][12] * 0.01F,
							VParam[ED_MESSAGE2][13] * 0.01F,
							VParam[ED_MESSAGE2][14] * 0.1F ) ;

		// `敽ʂ̂wx̕Zo
		{
			Vec XVec, YVec, TempYVec, TempV ;
		
			GetXYZVectConv( &CamX, &CamY, &CamZ, &CamP,
								&XVec, 
								VParam[ED_MESSAGE2][12] * 0.01F - ( (f32)VParam[ED_MESSAGE2][10] - 200 ) * 0.01F,
								VParam[ED_MESSAGE2][13] * 0.01F - VParam[ED_MESSAGE2][16] * 0.01F,
								VParam[ED_MESSAGE2][14] * 0.1F - VParam[ED_MESSAGE2][11] * 0.01F ) ;
			GetXYZVectConv( &CamX, &CamY, &CamZ, &CamP,
								&TempYVec,
								VParam[ED_MESSAGE2][12] * 0.01F,
								VParam[ED_MESSAGE2][13] * 0.01F - 1.0F,
								VParam[ED_MESSAGE2][14] * 0.1F ) ;
			VECSubtract( &XVec, &MsUnion.PlStPoint2, &XVec ) ;
			VECSubtract( &TempYVec, &MsUnion.PlStPoint2, &TempYVec ) ;

			VECCrossProduct( &XVec, &TempYVec, &TempV ) ;
			VECCrossProduct( &TempV, &XVec, &YVec ) ;

			VECNormalize( &YVec, &MsUnion.PlYVec2 ) ;
			VECNormalize( &XVec, &MsUnion.PlXVec2 ) ;
		}
	}

	{
		// `敽ʂ̌_WZo
		GetXYZVectConv( &CamX, &CamY, &CamZ, &CamP,
							&MsUnion.PlStPoint3, 
							( -(f32)VParam[ED_MESSAGE3][2] ) * 0.01F,
							VParam[ED_MESSAGE3][3] * 0.01F,
							VParam[ED_MESSAGE3][4] * 0.1F ) ;

		// `敽ʂ̂wx̕Zo
		{
			Vec XVec, YVec, TempYVec, TempV ;

			GetXYZVectConv( &CamX, &CamY, &CamZ, &CamP,
								&XVec, 
								( -(f32)VParam[ED_MESSAGE3][2] ) * 0.01F - ( -(f32)VParam[ED_MESSAGE3][0] ) * 0.01F,
								VParam[ED_MESSAGE3][3] * 0.01F - VParam[ED_MESSAGE3][6] * 0.01F,
								VParam[ED_MESSAGE3][4] * 0.1F - VParam[ED_MESSAGE3][1] * 0.01F ) ;
			GetXYZVectConv( &CamX, &CamY, &CamZ, &CamP,
								&TempYVec,
								( -(f32)VParam[ED_MESSAGE3][2] ) * 0.01F,
								VParam[ED_MESSAGE3][3] * 0.01F - 1.0F,
								VParam[ED_MESSAGE3][4] * 0.1F ) ;
			VECSubtract( &XVec, &MsUnion.PlStPoint3, &XVec ) ;
			VECSubtract( &TempYVec, &MsUnion.PlStPoint3, &TempYVec ) ;

			VECCrossProduct( &XVec, &TempYVec, &TempV ) ;
			VECCrossProduct( &TempV, &XVec, &YVec ) ;

			VECNormalize( &YVec, &MsUnion.PlYVec3 ) ;
			VECNormalize( &XVec, &MsUnion.PlXVec3 ) ;
		}
	}
	
	// I
	return 0 ;
}

#endif
	


// w̃bZ[WACRL肩ǂ𒲂ׂ
extern s8 GetNoneIconCheck( s8 PackID, s8 MessageID )
{
	MESSAGEPACK *MesP ;
	stSentence *Head ;
	stOneSentence *OneS ;
	stJimaku *Jimaku ;

	MesP = &MsUnion.MesPack[PackID] ;
	Head = ( stSentence * )MesP->JmbData ;
	OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + MessageID * sizeof( stOneSentence ) ) ;
	Jimaku = &OneS->jimaku[0] ;

	// Ԃ
	return ( Jimaku->wait / TICKTIME ) == ICONID_NONE ;
}

// w̔ԍ̃bZ[WTEhhc擾
extern s32 GetMessageSoundID( s8 PackID, s8 MessageID )
{
	MESSAGEPACK *MesP ;
	stSentence *Head ;
	stOneSentence *OneS ;
	stJimaku *Jimaku ;

	MesP = &MsUnion.MesPack[PackID] ;
	Head = ( stSentence * )MesP->JmbData ;
	OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + MessageID * sizeof( stOneSentence ) ) ;
	Jimaku = &OneS->jimaku[0] ;

	return (s32)SoundTable[Jimaku->disptime / TICKTIME] ;
}

// w̃bZ[Wɑw肪邩ǂ擾( TRUE: FALSE:Ȃ )
extern s8 GetMessageContinueState( s8 PackID, s8 MessageID, s8 LineNo )
{
	MESSAGEPACK *MesP ;
	stSentence *Head ;
	GhmGcTexHeader *Tex ;
	stOneSentence *OneS ;
	stJimaku *Jimaku ;
	stFontParam *UvStart ;
	stRubiDat *Rubi ;

	// ̏
	MesP = &MsUnion.MesPack[PackID] ;
	Head = ( stSentence * )MesP->JmbData ;
	OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + MessageID * sizeof( stOneSentence ) ) ;
	Jimaku = &OneS->jimaku[LineNo] ;
	
	if( Jimaku->chardat[0] == JIMAKU_NO_FONT ) return -1 ;
	
	UvStart = ( stFontParam * )( (u8 *)MesP->JmbData + Head->charOffset ) ;
	Tex = ( GhmGcTexHeader * )( ( u8 * )MesP->JmbData + Head->texOffset ) ;
	Rubi = Jimaku->rubidat ;

	// r
	{
		s32 i ;

		for( i = 0 ; i < JIMAKU_RUBI_MAX && Rubi->charID[0] >= 0 ; i ++, Rubi ++ )
		{
			// }N𒲂ׂ
			if( Rubi->charID[0] == MES_MACRO )
			{
				// }N̏ꍇ͏
				switch( Rubi->charID[1] )
				{
				case MES_MACRO_CONTINUE :
					// Ȁꍇ
					{
						// Ƃm点ďI
						return TRUE ;
					}
					break ;
				}
			}
		}
	}
	
	// ɗ瑱ȂƂ
	return FALSE ;
}

	



// w̃ACR̃ZbgAbv
// (̊֐ĂԂƎQƐAQƐO̎Ƀ[h)
static s8 SetupIconTex( s8 IconID )
{
	// QƐO̎̂݃ZbgAbvs
	if( MsUnion.IconTexCount[IconID] == 0 && IconID != ICONID_NONE )
	{
		char FilePath[128] ;

		// t@C쐬
		sprintf( FilePath, "%s%03d.BIN", MES_ICONPATH, IconID ) ;
		
		// t@Cǂݍ݂̃ZbgAbv
		TexLoadSet( FilePath, &MsUnion.IconTexList[IconID] ) ;
	}
	
	// QƐ𑝂₷
	MsUnion.IconTexCount[IconID] ++ ;

	// I
	return 0 ;
}

// w̃ACR̉
// (̊֐ĂԂƎQƐAQƐOɂȂeNX`̉s)
static s8 ReleaseIconTex( s8 IconID )
{
	// ɎQƐOG[
	if( MsUnion.IconTexCount[IconID] == 0 ) return -1 ;

	// QƐ炷
	MsUnion.IconTexCount[IconID] -- ;
	
	// QƐOɂȂeNX`
	if( MsUnion.IconTexCount[IconID] == 0 ) TexRelease( &MsUnion.IconTexList[IconID] ) ;

	// I
	return 0 ;
}

// w̃ACR̃ZbgAbvIĂ邩`FbN
// (TRUE:IĂ  FALSE:܂)
static s8 CheckIconTex( s8 IconID )
{
	// eNX`ZbgAbṽ`FbNlԂ
	return TexLoadChk( &MsUnion.IconTexList[IconID] ) ;
}



#ifndef NO_CODE

// w̃bZ[W`悷
static s16 RenderMessage( s8 PackID, s8 MessageID, s16 x, s16 y, GXColor Color, 
							u8 DrawFlag, s8 LeftFlag, s8 MesType,
							f32 Size, f32 ExRate, f32 Asobi,
							GXColor *C2, s8 TableIndex, s8 MesType2,
							f32 *RandMap, s32 MaxHeight )
{
	MESSAGEPACK *MesP ;
	stSentence *Head ;
	GhmGcTexHeader *Tex ;
	stOneSentence *OneS ;
	stJimaku *Jimaku ;
	stFontParam *UvStart, *Uv ;
	f32 U, V, Ul, Vl ;
	u32 StrLen, SpaceNum, GraphLength ;
	s32 i ;
//	Vec Dest ;
	GXColor Color2 ;

	if( C2 != NULL )
	{
		Color2 = *C2 ;
	}
	else
	{
		Color2 = Color ;
	}

	// ̏
	MesP = &MsUnion.MesPack[PackID] ;
	Head = ( stSentence * )MesP->JmbData ;
	OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + MessageID * sizeof( stOneSentence ) ) ;
	Jimaku = &OneS->jimaku[0] ;
	UvStart = ( stFontParam * )( (u8 *)MesP->JmbData + Head->charOffset ) ;
	Tex = ( GhmGcTexHeader * )( ( u8 * )MesP->JmbData + Head->texOffset ) ;

	// `̏
	if( DrawFlag == TRUE )
	{
		// Zobt@̏sݒ
		// rsȂ̂ŃeNX`̂ƂɎs邱Ƃɂ܂
		GXSetZCompLoc( GX_FALSE ) ;

		// Zobt@̓샂[hݒ肷
		GXSetZMode( GX_FALSE, GX_LESS, GX_FALSE ) ;

		switch( MesType )
		{
		case 0 :
		case 2 :
			// ˉeXe[^Xݒ肷
			{
				Mtx44 mt ;
				
				// ˉes쐬
				MTXOrtho( mt, WK7_SCREEN_HEIGHT, 0.0F,
								WK7_SCREEN_WIDTH, 0.0F, 0, -1000000 ) ;
				GXSetProjection( mt, GX_ORTHOGRAPHIC ) ;
			}

			// r[}gbNXZbg
			{
				Mtx View ;
			
				// PʍsZbg
				MTXIdentity( View ) ; 
			
				// }gbNXZbg
				GXLoadPosMtxImm( View, 0 ) ;
				GXLoadNrmMtxImm( View, 0 ) ;
				GXSetCurrentMtx( 0 ) ;
			}
			break ;
			
		case 1 :
			HSD_CObj *Camera ;
			Mtx View ;
			
			// J̏擾
			Camera = GetEffectCamera() ;
			
			// J̎ˉeXe[^Xݒ肷
			{
				f32 fov, aspect, n, f ;
				Mtx44 mt ;
			
				// 擾
	//			HSD_CObjGetPerspective( Camera, &fov, &aspect );
				aspect = ASPECT ;
				fov = FOV ;
				n = HSD_CObjGetNear( Camera );
				f = HSD_CObjGetFar( Camera );
				
				// ˉes쐬
				MTXPerspective( mt, fov, aspect, n, f ) ;
				GXSetProjection( mt, GX_PERSPECTIVE ) ;
			}
			
			// r[}gbNXZbg
			{
				// r[s擾
				HSD_CObjGetViewingMtx( Camera, View ) ; 
			
				// }gbNXZbg
				GXLoadPosMtxImm( View, 0 ) ;
				GXLoadNrmMtxImm( View, 0 ) ;
				GXSetCurrentMtx( 0 ) ;
			}
			break ;
		}
		
		// Abvf[gݒ
		GXSetAlphaUpdate( GX_FALSE ) ;
		GXSetColorUpdate( GX_TRUE ) ;

		// JO̐ݒ
		GXSetCullMode( GX_CULL_NONE ) ;

		// uh[h̃Zbg
		GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_SET);

		// J[̐ݒ
		GXSetAlphaCompare( GX_ALWAYS, 0, GX_AOP_OR, GX_ALWAYS, 0);
		GXSetNumChans(1);
		GXSetChanAmbColor( GX_COLOR0A0, (GXColor){128, 128, 128, 255} ) ;
		GXSetChanMatColor( GX_COLOR0A0, (GXColor){128, 128, 128, 255} ) ;
		GXSetChanCtrl( GX_COLOR0A0, GX_DISABLE, GX_SRC_VTX, GX_SRC_VTX,
						GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE ) ;

		// eNX`Wݒ
		GXSetNumTexGens(1);
		GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY ) ;

		// TEVݒ
		GXSetNumTevStages(1);
		
		// _tH[}bg̃Zbg
		GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS, GX_POS_XYZ, GX_F32, 0 ) ;
		GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 ) ;
		GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, UVSHFTBIT ) ;

		// GXFIFOɓnf[^̃Zbg	
		GXClearVtxDesc();
		GXSetVtxDesc(GX_VA_POS, GX_DIRECT) ;
		GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT) ;
		GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT) ;

		// Tevݒ
		GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );
		GXSetTevOp( GX_TEVSTAGE0, GX_MODULATE ) ;
	}

	// ̒ƃXy[X̐𐔂
	{
		for( SpaceNum = 0, StrLen = 0 ;
			 (u16)Jimaku->chardat[StrLen] != JIMAKU_NO_FONT ; StrLen ++ )
		{
			if( (u16)Jimaku->chardat[StrLen] == 0xfffe || 
				(u16)Jimaku->chardat[StrLen] == 0xfffd ||
				(u16)Jimaku->chardat[StrLen] == 0xfffc )	SpaceNum ++ ;
		}
	}

	// eNX`̃[h
	if( DrawFlag == TRUE ) GTLOAD( &MesP->TexObj ) ;

	// `揈
	{
		s16 Length, x2, y2, k ;
		f32 Rate, w, h ;
		u8 r, g, b ;

		if( DrawFlag == TRUE )
		{
			GBGN( GX_QUADS, ( StrLen - SpaceNum ) * 4 ) ;
			Length = RenderMessage( PackID, MessageID, x, y, Color, FALSE, LeftFlag, MesType, Size, ExRate, Asobi, C2, TableIndex, MesType2, RandMap, MaxHeight ) ;

			x2 = 0 ;
			GraphLength = 0 ;
			i = ( LeftFlag == FALSE ) ? (s32)( StrLen - 1 ) : 0 ;
			k = 0 ;
R1 :
			if( ( LeftFlag == FALSE && i >= 0 ) ||
				( LeftFlag == TRUE && i < StrLen ) ) goto R2 ;
			goto LOOPEND ;
R2 :
			{
				// ł͖珈Ȃ
				if( (u16)Jimaku->chardat[i] == 0xffff || 
					(u16)Jimaku->chardat[i] == 0xfffe ||
					(u16)Jimaku->chardat[i] == 0xfffd || 
					(u16)Jimaku->chardat[i] == 0xfffc ) goto R3 ;

				// tulZo
				Uv = UvStart + ( (u16)Jimaku->chardat[i] & 0xfff ) ;
				U = (f32)Uv->u / Tex->mWidth ;								V = (f32)Uv->v / Tex->mHeight ;
				Ul = (f32)( Uv->w ) / Tex->mWidth ;		Vl = (f32)Uv->h / Tex->mHeight ;

				Rate = Size - ( ( WK7_SCREEN_WIDTH - ( x - ( x2 - Asobi ) ) ) * ExRate ) ;
				if( MesType2 == 2 ) Rate *= RandMap[i] ;
				w = Uv->w * Rate ;					h = Uv->h * Rate ;

				if( TableIndex == -1 )
				{
					r = (u8)( ( (f32)GraphLength / Length ) * Color2.r + ( 1.0F - ( (f32)GraphLength / Length ) ) * Color.r ) ;
					g = (u8)( ( (f32)GraphLength / Length ) * Color2.g + ( 1.0F - ( (f32)GraphLength / Length ) ) * Color.g ) ;
					b = (u8)( ( (f32)GraphLength / Length ) * Color2.b + ( 1.0F - ( (f32)GraphLength / Length ) ) * Color.b ) ;
				}
				else
				{
					if( Color.r + Color.g + Color.b == 0 )
					{
						r = g = b = 0 ;
					}
					else
					{
						r = ColorTable[TableIndex][i][0] ;
						g = ColorTable[TableIndex][i][1] ;
						b = ColorTable[TableIndex][i][2] ;
					}
				}

				// Wo
				{
					y2 = (s16)( ( MesType == 2 ) ? y : y - h / 2.0F ) ;
					if( MesType2 == 0 ) y2 -= VParam[ED_MESSAGE4][5+i] ;
					if( MesType2 == 1 ) y2 += VParam[ED_MESSAGE4][9+i] ;
					if( MesType2 == 2 ) y2 += ( MaxHeight - h ) / 2.0F ;

					switch( MesType2 )
					{
					case 0 :
					case 2 :
						{
							if( LeftFlag == TRUE )
							{
								SetPos3( x - x2, 		y2, 	MesType ) ; 		GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U, V ) ;
								SetPos3( x - x2 - w,	y2, 	MesType ) ; 		GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U + Ul, V ) ;
								SetPos3( x - x2 - w, 	y2 + h, MesType ) ;		GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U + Ul, V + Vl ) ;
								SetPos3( x - x2,		y2 + h, MesType ) ; 	GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U, V + Vl ) ;
							}
							else
							{
								SetPos( x - x2 - w, 	y2, 	MesType ) ;		GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U, V ) ;
								SetPos( x - x2, 		y2, 	MesType ) ;		GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U + Ul, V ) ;
								SetPos( x - x2, 		y2 + h, MesType ) ; 	GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U + Ul, V + Vl ) ;
								SetPos( x - x2 - w, 	y2 + h, MesType ) ; 	GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U, V + Vl ) ;
							}
						}
						break ;
						
					case 1 :
						{
							if( LeftFlag == TRUE )
							{
								SetPos3( x - x2, 		y2 - h, MesType ) ;		GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U, V ) ;
								SetPos3( x - x2 - w,	y2 - h, MesType ) ;		GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U + Ul, V ) ;
								SetPos3( x - x2 - w, 	y2, 	MesType ) ;		GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U + Ul, V + Vl ) ;
								SetPos3( x - x2,		y2, 	MesType ) ; 	GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U, V + Vl ) ;
							}
							else
							{
								SetPos( x - x2 - w, 	y2 - h, MesType ) ;		GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U, V ) ;
								SetPos( x - x2, 		y2 - h, MesType ) ;		GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U + Ul, V ) ;
								SetPos( x - x2, 		y2, 	MesType ) ; 	GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U + Ul, V + Vl ) ;
								SetPos( x - x2 - w, 	y2, 	MesType ) ; 	GXColor4u8( r, g, b, Color.a ) ; GXTexCoord2f32( U, V + Vl ) ;
							}
						}
						break ;
					}
				}

				GraphLength += w ;				// OtBbN̒ύX
				x2 += w ;						// `Jnʒu̕ύX
			}
R3 :
			if( LeftFlag == FALSE )
			{
				i -- ;
			}
			else
			{
				i ++ ;
			}
			k ++ ;
			goto R1 ;
LOOPEND :
			GXEnd() ;
		}
		else
		{
			for( x2 = 0, GraphLength = 0, i = (s32)( StrLen - 1 ) ; i >= 0 ; i -- )
			{
				// ł͖珈Ȃ
				if( (u16)Jimaku->chardat[i] == 0xffff || 
					(u16)Jimaku->chardat[i] == 0xfffe ||
					(u16)Jimaku->chardat[i] == 0xfffd || 
					(u16)Jimaku->chardat[i] == 0xfffc ) continue ;

				// tulZo
				Uv = UvStart + ( (u16)Jimaku->chardat[i] & 0xfff ) ;
				U = (f32)Uv->u / Tex->mWidth ;								V = (f32)Uv->v / Tex->mHeight ;
				Ul = (f32)( Uv->w ) / Tex->mWidth ;		Vl = (f32)Uv->h / Tex->mHeight ;

				Rate = Size - ( ( WK7_SCREEN_WIDTH - ( x - ( x2 - Asobi ) ) ) * ExRate ) ;
				if( MesType2 == 2 ) Rate *= RandMap[i] ;
				w = ( Uv->w ) * Rate ;					h = Uv->h * Rate ;

				GraphLength += w ;				// OtBbN̒ύX
				x2 += w ;						// `Jnʒu̕ύX
			}
		}
	}

	// OtBbN̒Ԃ
	return (s16)GraphLength ;
}	
		
#endif
		
		
		
	


// bZ[WpbNf[^(jmbǂݍ)
extern s8 LoadMessagePack( char *FilePath )
{
	s8 NewPackID ;
	MESSAGEPACK *MesP ;
	s32 Size ;
	char NameBuf[64] ;

	// Ƀ[hĂ鐔ςς牽I
	if( MsUnion.MesPackNum == MAX_LOADPACKNUM ) return -1 ;

	// gĂȂpbNf[^T
	for( NewPackID = 0, MesP = MsUnion.MesPack ;
			MesP->UseFlag == TRUE ; MesP ++, NewPackID ++ ){}

	// ghmGcFile IuWFNg쐬			
	ghmGcMemSetAllocName("YLdMesPk");
	if( ( MesP->JmbFile = new ghmGcFile ) == NULL ) return -1;

	// t@CJ
	if( MesP->JmbFile->Open( FilePath ) == false )
	{
		delete MesP->JmbFile ;
		MesP->JmbFile = NULL ;
		return -1 ;
	}

	// t@C̃TCY𓾂
	Size = (s32)OSRoundUp32B( MesP->JmbFile->GetLength(true) ) ;

	// t@C쐬
	{
		strcpy( NameBuf, "Y_" ) ;
		GetFileName( FilePath, &NameBuf[2] ) ;
	}
	
	// mۂ
	MesP->JmbData = ghmGcMemAllocName( Size, NameBuf ) ;
	if( MesP->JmbData == NULL )
	{
		delete MesP->JmbFile ;
		MesP->JmbFile = NULL ;
		return -1 ;
	}

	// ۂƃ[h
	MesP->JmbFile->Read( MesP->JmbData, 0, Size ) ;
	
	// eNX`IuWFNg NULL Zbg
	memset( &MesP->TexObj, 0, sizeof( MesP->TexObj ) ) ;

	// t@Cǂݍ񂾃tO𗧂Ă
	MesP->FileFlag = TRUE ;

	// gptO𗧂Ă
	MesP->UseFlag = TRUE ;
	
	// ZbgAbvItO|
	MesP->SetupFlag = FALSE ;
	
	// gp̃f[^̐𑝂₷
	MsUnion.MesPackNum ++ ;
	
	// pbNhcԂ
	return NewPackID ;
}

// bZ[WpbNf[^(jmb)Zbg(Rs[͂܂̂ ReleaseMessagePack ܂œnf[^͉Ȃł)
extern s8 SetupMessagePack( void *JmbData )
{
	s8 NewPackID ;
	MESSAGEPACK *MesP ;

	// Ƀ[hĂ鐔ςς牽I
	if( MsUnion.MesPackNum == MAX_LOADPACKNUM ) return -1 ;

	// gĂȂpbNf[^T
	for( NewPackID = 0, MesP = MsUnion.MesPack ;
			MesP->UseFlag == TRUE ; MesP ++, NewPackID ++ ){}
	
	// f[^AhXZbg
	MesP->JmbData = JmbData ;

	// gȂ̂ NULL Zbg
	MesP->JmbFile = NULL  ;

	// eNX`̃ZbgAbvs
	{
		stSentence *Head = ( stSentence * )MesP->JmbData ;
		GhmGcTexHeader *Tex = ( GhmGcTexHeader * )( ( u8 * )MesP->JmbData + Head->texOffset ) ;

		// eNX`̃ZbgAbv
		
		// eNX`쐬
		GXInitTexObj( &MesP->TexObj, GHMGCTEX_GETIMAGE(Tex),
						 Tex->mWidth, Tex->mHeight, Tex->mFormat,
						  GX_CLAMP, GX_CLAMP, GX_FALSE ) ;
		GXInitTexObjLOD( &MesP->TexObj, GX_LINEAR, GX_LINEAR, Tex->mMinLOD, Tex->mMaxLOD, 0.0F,
							GX_FALSE, GX_FALSE, GX_ANISO_1 ) ;
	}

	// t@Cǂݍ񂾃tO|
	MesP->FileFlag = FALSE ;

	// gptO𗧂Ă
	MesP->UseFlag = TRUE ;
	
	// gp̃f[^̐𑝂₷
	MsUnion.MesPackNum ++ ;
	
	// pbNhcԂ
	return NewPackID ;
}

// bZ[WpbNf[^
extern s8 ReleaseMessagePack( s8 PackID )
{
	MESSAGEPACK *MesP ;
	
	MesP = &MsUnion.MesPack[PackID] ;
	
	// ɎgĂȂ牽I
	if( MesP->UseFlag == FALSE ) return 0 ;
	
	// gpĂACRׂĉ
	// ACR̃ZbgAbv܂n߂ĂȂꍇ̓ZbgAbvJn
	if( MesP->SetupFlag >= 1 )
	{
		s32 i ;
		stSentence *Head ;
		stOneSentence *OneS ;
		stJimaku *Jimaku ;
		
		Head = ( stSentence * )MesP->JmbData ;
		
		// ͂̐JԂ
		OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset ) ;
		for( i = 0 ; i < Head->num ; i ++, OneS ++ )
		{
			Jimaku = &OneS->jimaku[0] ;
			
			if( ( Jimaku->wait / TICKTIME ) != ICONID_NONE ) ReleaseIconTex( (s8)( Jimaku->wait / TICKTIME ) ) ;
		}

		// ACR̃ZbgAbvI؋c
		MesP->SetupFlag = 0 ;
	}
	
	// t@Cǂݍ܂Ă邩tOĂ邩ǂŏ𕪊
	if( MesP->FileFlag == TRUE )
	{
		// t@C
		CLOSECHK( MesP->JmbFile ) ;
		
		// 
		CHKMEMFREE( MesP->JmbData ) ;
	}
	
	// gptO|
	MesP->UseFlag = FALSE ;
	
	// gp̃f[^̐炷
	MsUnion.MesPackNum -- ;
	
	// I
	return 0 ;
}
	

#ifndef NO_CODE

// ҂Ԃ𓾂
static s16 GetWaitCount( void )
{
	return 0 ;
//	return MsUnion.WaitTime ;
}

// ҂ԂZbg
extern u8 ResetMessageWaitCount( void )
{
	MsUnion.WaitTime = (u8)VParam[ED_MESSAGE][21] ;
	
	// I
	return 0 ;
}

// ҂ԏ
extern u8 FrameProcessMessageWaitCount( void )
{
	MsUnion.WaitTime -- ;
	if( MsUnion.WaitTime < 0 ) MsUnion.WaitTime = 0 ;
	
	// I
	return 0 ;
}

#endif

// bZ[W|Xg𓾂
static s8 GetMessagePost( void )
{
	u8 i ;

	// ɂׂẴbZ[W|XggĂG[
	if( MsUnion.ObjectNum == MAX_MESSAGENUM )
		return -1 ;
	
	// gĂȂ|XgT
	for( i = 0 ; MsUnion.Object[i] != FALSE ; i ++ ){}
	
	// |XgɃZbg
	MsUnion.Object[i] = TRUE ;
	
	// LĂ|Xg̐𑝂₷
	MsUnion.ObjectNum ++ ;
	
	// |XghcԂ
	return (s8)i ;
}

// bZ[W|XgJ
static s8 ReleaseMessagePost( s8 PostID )
{
	// ɖɂȂĂ牽I
	if( MsUnion.Object[PostID] == FALSE ) return -1 ;
	
	// |XgJ
	MsUnion.Object[PostID] = FALSE ;
	
	// LĂ|Xg̐炷
	MsUnion.ObjectNum -- ;
	
	// I
	return 0 ;
}


// bZ[WGtFNg̋ʃf[^
extern s8 InitMessageData( void )
{
//	u8 i ;
//	char Str[128] ;
	MEMINIT( MsUnion ) ;
	
	// r̃eNX`ǂݍ
////	TexLoadSet( "/Yam/Message/rubi_05.BIN" /*"/item/hato/memorubi.BIN"*/, &MsUnion.RubiTex ) ;
	
	// eeNX`ǂݍ
/*	for( i = 0 ; i < MES_NUM ; i ++ )
	{
		sprintf( Str, "%s%d.BIN", MES_MESTEXNAME, i ) ;  
		TexLoad( Str, &MsUnion.MessageTex[i], &MsUnion.MessageTexFile[i] ) ;
	}
*/

//	TexLoad( MES_ICONTEXNAME, &MsUnion.IconTex, &MsUnion.IconTexFile ) ;
//	TexLoad( MES_ARROWTEXNAME, &MsUnion.ArrowTex, &MsUnion.ArrowTexFile ) ;
	
//	TexLoadSet( MES_TESTICON, &MsUnion.TestIconTex ) ;

#ifdef __ALLLOAD
	// Ƃ肠ׂẴACRǂݍ
	{
		s32 i ;
		
		for( i = 0 ; i < ICON_NUM ; i ++ )
		{
			if( i != ICONID_NONE ) SetupIconTex( (s8)i ) ;
		}
	}
#endif
			
	MsUnion.WaitTime = 0 ;
	
	// I
	return 0 ;
}

// bZ[WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckMessageData( void )
{
////	if( TexLoadChk( &MsUnion.RubiTex ) == FALSE ) return FALSE ;
	
	return TRUE ;
}


// bZ[WGtFNg̋ʃf[^n
extern s8 EndMessageData( void )
{
	MESSAGEUNION *MessageUnion = &MsUnion ;
	u8 i ;

////	TexRelease( &MsUnion.RubiTex ) ;
//	TexRelease( &MsUnion.TestIconTex ) ;

	// ׂẴbZ[WpbN
	for( i = 0 ; i < MAX_LOADPACKNUM ; i ++ )
		ReleaseMessagePack( (s8)i ) ;

#ifdef __ALLLOAD
	// Ƃ肠ׂẴACR
	{
		s32 i ;
		
		for( i = 0 ; i < ICON_NUM ; i ++ )
		{
			if( i != ICONID_NONE )
				ReleaseIconTex( (s8)i ) ;
		}
	}
#endif

	// t@CAJ
/*	for( i = 0 ; i < MES_NUM ; i ++ )
	{
		CLOSECHK( MsUnion.MessageTexFile[i] ) ;
		CHKMEMFREE( MsUnion.MessageTex[i].Header ) ;
	}
*/
//	CLOSECHK( MsUnion.IconTexFile ) ;
//	CHKMEMFREE( MsUnion.IconTex.Header ) ;
//	CLOSECHK( MsUnion.ArrowTexFile ) ;
//	CHKMEMFREE( MsUnion.ArrowTex.Header ) ;

	// I
	return 0 ;
}

// bZ[WGtFNg쐬
extern EFFECT *CreateMessageEffect( s8 PackID, u16 MessageID,
									s32 IconID, s32 SoundID,
									s8 LeftFlag, s16 y, 
									s8 StopFlag,
									f32 Size, f32 ExRate,
									s8 MesType, GXColor *Color,
									s8 ColorTableIndex, s8 MesType2,
									s8 BottanCancelFlag, s32 Priority )
{
#ifndef NO_CODE

	MESSAGEEFFECT *Mes ;
	EFFECT *Effect ;
	s8 PostID ;

	TexLoadChk( &MsUnion.TestIconTex ) ;

	// |Xghc𓾂
	PostID = GetMessagePost() ;
	if( PostID == -1 ) return NULL ;

	// VbZ[Wf[^쐬
	Effect = AddEffectData( EFF_MESSAGE, (void**)&Mes, Priority ) ;
	if( Effect == NULL )
	{
		ReleaseMessagePost( PostID ) ;
		return NULL ;
	}
	
	// ACRƃTEĥhcۑ
	Mes->IconID = IconID ;
	Mes->SoundID = SoundID ;
	
	// pbNhcۑ
	Mes->PackID = PackID ;

	// ҂ԂQbg
	Mes->WaitTime = GetWaitCount() ;
	
	// ҂ԃZbg
	ResetMessageWaitCount() ;

	// |Xghcۑ
	Mes->PostID = PostID ;

	// bZ[Whcۑ
	Mes->MessageID = MessageID ;

	// pϐ̏
	Mes->Mode = 0 ;
	Mes->Counter1 = Mes->Counter2 = 0 ;
	Mes->ArrowX = WK7_SCREEN_WIDTH ;
	Mes->BotLineX = WK7_SCREEN_WIDTH ;
	Mes->BotLineLength = 0 ;
	Mes->MesX = -10000 ;
	Mes->PointLineNum = 0 ;
	Mes->PointLineX = TENLINE_X ;
	Mes->PointLineGradFlag = FALSE ;
	Mes->LeftFlag = LeftFlag ;
	Mes->y = y ;
	Mes->StopFlag2 = Mes->StopFlag = StopFlag ;
	Mes->Size = Size ;
	Mes->ExRate = ExRate ;
	Mes->MesType = MesType ;
	Mes->Length = 0 ;
	Mes->SoundFlag = FALSE ;
	Mes->ColorTableIndex = ColorTableIndex ;
	Mes->MesType2 = MesType2 ;
	Mes->BottanCancelFlag = BottanCancelFlag ;

	Mes->IconMode = -1 ;
	Mes->IconCounter1 = 0 ;
	Mes->IconCounter2 = 0 ;
	Mes->IconX = 0 ;
	Mes->IconDrawFlag = TRUE ;
	
	if( Color == NULL )
	{
		Mes->Color.r = (u8)VParam[ED_MESSAGE][16] ;
		Mes->Color.g = (u8)VParam[ED_MESSAGE][17] ;
		Mes->Color.b = (u8)VParam[ED_MESSAGE][18] ;
		Mes->Color.a = (u8)VParam[ED_MESSAGE][22] ;
	}
	else
	{
		Mes->Color = *Color ;
	}

	{
		s32 i ;
		f32 MaxHeight, Height ;
		MESSAGEPACK *MesP ;
		stSentence *Head ;
		stOneSentence *OneS ;
		stJimaku *Jimaku ;
		stFontParam *UvStart, *Uv ;

		MesP = &MsUnion.MesPack[Mes->PackID] ;
		Head = ( stSentence * )MesP->JmbData ;
		OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + Mes->MessageID * sizeof( stOneSentence ) ) ;
		Jimaku = &OneS->jimaku[0] ;
		UvStart = ( stFontParam * )( (u8 *)MesP->JmbData + Head->charOffset ) ;

		MaxHeight = 0 ;		
		for( i = 0 ; i < MAX_STRLENGTH ; i ++ )
		{
			Mes->RandMap[i] = ( rand() * ( VParam[ED_MESSAGE5][10] - VParam[ED_MESSAGE5][11] ) / RAND_MAX + VParam[ED_MESSAGE5][11] ) * 0.01F ;
			if( ( Jimaku->chardat[0] & 0xfff0 ) == 0xfff0 ) continue ;
			Uv = UvStart + ( (u16)Jimaku->chardat[0] & 0xfff ) ;
			Height = Uv->h * Mes->RandMap[i] ;
			if( Height > MaxHeight ) MaxHeight = Height ;
		}
		
		Mes->MaxHeight = (s32)MaxHeight ;
	}

	// J[e[u쐬
/*	{
		s32 i ;
		f32 f, j ;
		f32 r, g, b ;
		
		for( i = 0 ; i < MAX_STRLENGTH ; i ++ )
		{
			r = Mes->Color.r ;
			g = Mes->Color.g ;
			b = Mes->Color.b ;
		
			f = ( rand() * VParam[ED_MESSAGE4][2] / RAND_MAX - VParam[ED_MESSAGE4][2] / 2.0F ) / 100.0F + 1.0F ;
			j = (f32)( r * f ) ; 
			if( j > 255 ) j = 255 ; else if( j < 0 ) j = 0 ;
			Mes->ColorTable[i].r = (u8)( r = j ) ;

			f = ( rand() * VParam[ED_MESSAGE4][2] / RAND_MAX - VParam[ED_MESSAGE4][2] / 2.0F ) / 100.0F + 1.0F ;
			j = (f32)( g * f ) ; 
			if( j > 255 ) j = 255 ; else if( j < 0 ) j = 0 ;
			Mes->ColorTable[i].g = (u8)( g = j ) ;

			f = ( rand() * VParam[ED_MESSAGE4][2] / RAND_MAX - VParam[ED_MESSAGE4][2] / 2.0F ) / 100.0F + 1.0F ;
			j = (f32)( b * f ) ; 
			if( j > 255 ) j = 255 ; else if( j < 0 ) j = 0 ;
			Mes->ColorTable[i].b = (u8)( b = j ) ;
		}
	}
*/
	// I
	return Effect ;
#else
	PackID = PackID ;
	MessageID = MessageID ;
	IconID = IconID ;
	SoundID = SoundID ;
	LeftFlag = LeftFlag ;
	y = y ;
	StopFlag = StopFlag ;
	Size = Size ;
	ExRate = ExRate ;
	MesType = MesType ;
	Color = Color ;
	ColorTableIndex = ColorTableIndex ;
	MesType2 = MesType2 ;
	BottanCancelFlag = BottanCancelFlag ;
	Priority = Priority ;
	return NULL ;
#endif
}

// bZ[W̃GtFNǧns
extern s8 ReleaseMessageEffect( EFFECT *Effect )
{
	MESSAGEEFFECT *Mes = ( MESSAGEEFFECT * )Effect->Data ;

#ifndef NO_CODE

	// |XgJ
	ReleaseMessagePost( Mes->PostID ) ;
#endif

	// I
	return 0 ;
}

// bZ[W̃GtFNgPt[
extern s8 MoveMessageEffect( EFFECT *Effect )
{
	MESSAGEEFFECT *Mes = ( MESSAGEEFFECT * )Effect->Data ;
//	u8 i ;

#ifndef NO_CODE
	
#ifndef __OLDMODE
	return 0 ;
#else
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// eNX`ǂݍݏIĖ牽I
//	for( i = 0 ; i < MES_NUM ; i ++ ) if( CHKFILELOAD( MsUnion.MessageTexFile[i] ) == FALSE ) return 0 ;
	if( MsUnion.MesPack[Mes->PackID].UseFlag == FALSE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	if( CHKFILELOAD( MsUnion.MesPack[Mes->PackID].JmbFile ) == FALSE ) return 0 ;
	if( CHKFILELOAD( MsUnion.ArrowTexFile ) == FALSE ) return 0 ;
	if( CHKFILELOAD( MsUnion.IconTexFile ) == FALSE ) return 0 ;
	if( CheckMessagePackLoadComp( Mes->PackID ) == FALSE ) return 0 ;
	
	// eNX`ZbgAbv`FbN
	{
		MESSAGEPACK *MesP = &MsUnion.MesPack[Mes->PackID] ;

		// ܂ JmbFile ɂmtkkĂȂꍇ
		// eNX`̃ZbgAbvsĂȂ؋		
		if( MesP->JmbFile != NULL )
		{
			stSentence *Head = ( stSentence * )MesP->JmbData ;
			GhmGcTexHeader *Tex = ( GhmGcTexHeader * )( (u8 *)MesP->JmbData + Head->texOffset ) ;
		
			// eNX`̃ZbgAbv
			
			// eNX`쐬
			GXInitTexObj( &MesP->TexObj, GHMGCTEX_GETIMAGE(Tex),
							 Tex->mWidth, Tex->mHeight, Tex->mFormat,
							  GX_CLAMP, GX_CLAMP, GX_FALSE ) ;
			GXInitTexObjLOD( &MesP->TexObj, GX_LINEAR, GX_LINEAR, Tex->mMinLOD, Tex->mMaxLOD, 0.0F,
								GX_FALSE, GX_FALSE, GX_ANISO_1 ) ;

			// t@C
			CLOSECHK( MesP->JmbFile ) ;
			
			// mtkkZbg
			MesP->JmbFile = NULL ;
		}
	}
			
	
	// ҂Ԃ҂
	if( Mes->WaitTime != 0 )
	{
		Mes->WaitTime -- ;
		if( Mes->WaitTime < 0 ) Mes->WaitTime = 0;
		return 0 ;
	}
	
	// t@C
//	for( i = 0 ; i < MES_NUM ; i ++ ) CLOSECHK( MsUnion.MessageTexFile[i] ) ;
//	CLOSECHK( MsUnion.ArrowTexFile ) ;
//	CLOSECHK( MsUnion.IconTexFile ) ;

	// ACR\
	if( Mes->IconMode != -1 )
	{
		GhmGcTexHeader *Tex ;
	
		// eNX`̃[h
		{
			MESSAGEPACK *MesP ;
			stSentence *Head ;
			stOneSentence *OneS ;
			stJimaku *Jimaku ;

			MesP = &MsUnion.MesPack[Mes->PackID] ;
			Head = ( stSentence * )MesP->JmbData ;
			OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + Mes->MessageID * sizeof( stOneSentence ) ) ;
			Jimaku = &OneS->jimaku[0] ;

			Tex = MsUnion.IconTexList[Jimaku->wait / TICKTIME].Data.Header ;
		}
				
		switch( Mes->IconMode )
		{
		case 0 :
			Mes->IconX += (s32)VParam[ED_MESSAGE5][0] ;
			if( Mes->IconX >= (s32)VParam[ED_MESSAGE5][7] + (s32)VParam[ED_MESSAGE5][9] * 2 )
			{
				Mes->IconX = (s32)VParam[ED_MESSAGE5][7] + (s32)VParam[ED_MESSAGE5][9] * 2 ;
				Mes->IconMode ++ ;
				Mes->IconCounter1 = 0 ;
				Mes->IconCounter2 = 0 ;
			}
			break ;
			
		case 1 :
			Mes->IconCounter1 ++ ;
			if( ( Mes->IconDrawFlag == TRUE && Mes->IconCounter1 == (s32)VParam[ED_MESSAGE5][1] ) ||
				( Mes->IconDrawFlag == FALSE && Mes->IconCounter1 == (s32)VParam[ED_MESSAGE5][2] ) )
			{
				Mes->IconCounter1 = 0 ;
				if( Mes->IconDrawFlag == FALSE )
				{
					Mes->IconCounter2 ++ ;
					Mes->IconDrawFlag = TRUE ;
				}
				else
				{
					if( Mes->IconCounter2 == (s32)VParam[ED_MESSAGE5][3] )
					{
						Mes->IconMode ++ ;
						Mes->IconCounter1 = 0 ;
						Mes->IconCounter2 = 0 ;
					}
					else
					{
						Mes->IconDrawFlag = FALSE ;
					}
				}
			}
			break ;
			
		case 2 :
			Mes->IconCounter1 ++ ;
			if( Mes->IconCounter1 == (s32)VParam[ED_MESSAGE5][5] )
			{
				Mes->IconMode ++ ;
				Mes->IconCounter1 = 0 ;
			}
			break ;

		case 3 :
			Mes->IconX -= (s32)VParam[ED_MESSAGE5][4] ;
			if( Mes->IconX <= 0 )
			{
				Mes->IconX = 0 ;
				Mes->IconMode = -1 ;
				Mes->IconDrawFlag = FALSE ;
			}
			break ;
		}
	}
					
R1 :
	// [hɂď𕪊
	switch( Mes->Mode )
	{
	case 0 :		// o
		switch( Mes->MesType )
		{
		case 0 :
			Mes->Counter1 ++ ;
			
			// WZo
			Mes->ArrowX = ( -ARROW_ALLL + ARROW_AMARI ) +
								GetSanjiFunction( -((s16)VParam[ED_MESSAGE][1]),
												 WK7_SCREEN_WIDTH + ARROW_ALLL - ARROW_AMARI,
												 VParam[ED_MESSAGE][2],
												 (f32)Mes->Counter1 ) ;
			if( Mes->Counter1 >= VParam[ED_MESSAGE][2] )
			{
				Mes->Mode ++ ;
				Mes->Counter1 = 0 ;
			}
			break ;
		
		case 1 :
		case 2 : 
			// WZo
			Mes->Counter1 = VParam[ED_MESSAGE][2] ;
			Mes->ArrowX = ( -ARROW_ALLL + ARROW_AMARI ) +
								GetSanjiFunction( -((s16)VParam[ED_MESSAGE][1]),
												 WK7_SCREEN_WIDTH + ARROW_ALLL - ARROW_AMARI,
												 VParam[ED_MESSAGE][2],
												 (f32)Mes->Counter1 ) ;
			Mes->Mode ++ ;
			Mes->Counter1 = 0 ;
			
			goto R1 ;
			break ;
		}
		break ;
		
	case 1 :		// ҂
		switch( Mes->MesType )
		{
		case 0 :
		case 1 :
			Mes->Counter1 ++ ;
			if( Mes->Counter1 >= VParam[ED_MESSAGE][3] )
			{
				Mes->Mode ++ ;
				Mes->Counter1 = 0 ;
				Mes->BotLineX = BOTTOM_LINE_X ;
			}
			break ;
			
		case 2 :
			Mes->Mode ++ ;
			Mes->Counter1 = 0 ;
			Mes->BotLineX = BOTTOM_LINE_X ;
			goto R1 ;
			break ;
		}
			
		break ;
		
	case 2 :		// ̃Cт鏈
		switch( Mes->MesType )
		{
		case 0 :
		case 1 :
			Mes->Counter1 += VParam[ED_MESSAGE][4] ;
			Mes->BotLineLength += Mes->Counter1 / 10.0F ;
			if( Mes->BotLineLength >= WK7_SCREEN_WIDTH + BOTTOM_LINE_X/*- BOTTOM_LINE_X*/ )
			{
				Mes->Mode ++ ;
				Mes->Counter1 = 0 ;
			}
			break ;
			
		case 2 :
			Mes->BotLineLength = WK7_SCREEN_WIDTH + BOTTOM_LINE_X ;
			Mes->Mode ++ ;
			Mes->Counter1 = 0 ;
			goto R1 ;
			break ;
		}
			
		break ;
		
	case 3 :		// ҂
		switch( Mes->MesType )
		{
		case 0 :
		case 1 :
			Mes->Counter1 ++ ;
			if( Mes->Counter1 >= VParam[ED_MESSAGE][6] )
			{
				Mes->Mode ++ ;
				Mes->Counter1 = 0 ;
			}
			break ;
			
		case 2 :
			Mes->Mode ++ ;
			Mes->Counter1 = 0 ;
			goto R1 ;
			break ;
		}
		
		break ;
		
	case 4 :		// _т鏈
		switch( Mes->MesType )
		{
		case 0 :
		case 1 :
			Mes->Counter1 ++ ;
			if( Mes->Counter1 >= VParam[ED_MESSAGE][7] )
			{
				Mes->Counter1 = 0 ;
				Mes->PointLineNum += VParam[ED_MESSAGE][19] ;
				if( (s32)( Mes->PointLineNum * ( TENLINE_LENGTH + TENLINE_WAIT ) ) >=
					 WK7_SCREEN_WIDTH - ( Mes->ArrowX + ( TENLINE_X - ( ICONCHK(Mes) ? ICON_SIZE : 0 ) ) ) )
				{
					Mes->Mode ++ ;
				}
			}
			break ;
			
		case 2 :
			Mes->Mode ++ ;
			goto R1 ;
			break ;
		}

		break ;
		
	case 5 :		// ҂
		if( Mes->MesType != 2 )
		{
			Mes->Counter1 ++ ;
			if( Mes->Counter1 >= VParam[ED_MESSAGE][8] )
			{
				Mes->Mode ++ ;
				Mes->Counter1 = 0 ;
				Mes->Counter2 = 0 ;
			}
		}
		else
		{
			Mes->Mode ++ ;
			Mes->Counter1 = 0 ;
			Mes->Counter2 = 0 ;
			goto R1 ;
		}
		break ;

	case 6 :		// bZ[Wo
		// ŏ̃t[̏ꍇ͌ʉ炷
		if( Mes->SoundFlag == FALSE &&
			Mes->MesX + Mes->Length > 0 )
		{
			MESSAGEPACK *MesP ;
			stSentence *Head ;
			stOneSentence *OneS ;
			stJimaku *Jimaku ;
		
			MesP = &MsUnion.MesPack[Mes->PackID] ;
			Head = ( stSentence * )MesP->JmbData ;
			OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + Mes->MessageID * sizeof( stOneSentence ) ) ;
			Jimaku = &OneS->jimaku[0] ;
			if( GetEffectSoundOffFlag() == FALSE ) PlayEffectSE( Mes->SoundID != -1 ? Mes->SoundID : (s32)SoundTable[Jimaku->disptime / TICKTIME],
								SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackSystemOverlap, eSEGroupSystem00 ) ;
//			PlayEffectSE( (s32)MesDataTable[Mes->MessageID][2], SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackSystemOverlap, eSEGroupSystem00 ) ;
			Mes->SoundFlag = TRUE ;
		}

		if( ( Mes->MesType != 2 && Mes->Counter1 < VParam[ED_MESSAGE][10] ) ||
			( Mes->MesType != 0 && Mes->Counter1 < VParam[ED_MESSAGE3][21] ) ) Mes->Counter1 ++ ;
		if( Mes->Counter2 < VParam[ED_MESSAGE2][21] ) Mes->Counter2 ++ ;
		
		// bZ[WWZo
		{
//			f32 Length ;

			if( Mes->MesType == 2 )
			{
				Mes->MesX = MESSAGE_ASOBI 
							- GetSanjiFunction( -VParam[ED_MESSAGE][9],
												 1500,
												 VParam[ED_MESSAGE3][21],
												 (f32)Mes->Counter1 ) ;
				Mes->MaxLength = RenderMessage( (s8)Mes->PackID, (s8)Mes->MessageID,
										(s16)( WK7_SCREEN_WIDTH - MESSAGE_ASOBI ),
										0,
										(GXColor){0}, FALSE, Mes->LeftFlag, Mes->MesType, Mes->Size, Mes->ExRate, MESSAGE_ASOBI,
										NULL, -1, Mes->MesType2, Mes->RandMap, Mes->MaxHeight ) ;
				Mes->Length2 = RenderMessage( (s8)Mes->PackID, (s8)Mes->MessageID,
										(s16)( WK7_SCREEN_WIDTH - ( Mes->MesX < 0 ? 0 : Mes->MesX ) ),
										0,
										(GXColor){0}, FALSE, Mes->LeftFlag, Mes->MesType, Mes->Size, Mes->ExRate, MESSAGE_ASOBI,
										NULL, -1, Mes->MesType2, Mes->RandMap, Mes->MaxHeight ) ;
				Mes->Length = (s16)( WK7_SCREEN_WIDTH * ( Mes->Length2 / Mes->MaxLength ) ) ;
			}
			else
			{
				Mes->Length = RenderMessage( (s8)Mes->PackID, (s8)Mes->MessageID,
										0,
										0,
										(GXColor){0}, FALSE, Mes->LeftFlag, Mes->MesType, 1.0F, 0.0F, MESSAGE_ASOBI ) ;
				Mes->MesX = MESSAGE_ASOBI 
							- GetSanjiFunction( -VParam[ED_MESSAGE][9],
												 Mes->Length,
												 VParam[ED_MESSAGE][10],
												 (f32)Mes->Counter1 ) ;
			}
		}
		
		// ACeWZo
		{
			f32 Length ;
			
			Length = (f32)VParam[ED_MESSAGE2][24] * 1.5F ;
			Mes->ItemX = -Length + 
						GetSanjiFunction( -VParam[ED_MESSAGE2][20],
											 Length,
											 VParam[ED_MESSAGE2][21],
											 (f32)Mes->Counter2 ) ;
		}
/*		Mes->MesX = ( MesDataTable[Mes->MessageID][1] + MESSAGE_ASOBI ) - 
					GetSanjiFunction( -VParam[ED_MESSAGE][9],
										 MesDataTable[Mes->MessageID][1] + MESSAGE_ASOBI,
										 VParam[ED_MESSAGE][10],
										 (f32)Mes->Counter1 ) ;
*/
		// _̓_̐Zo
		Mes->PointLineNum = (s16)( ( ( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length ) ) - ( Mes->ArrowX + TENLINE_X - ( ICONCHK(Mes) ? ICON_SIZE : 0 ) ) ) / ( TENLINE_LENGTH + TENLINE_WAIT ) ) ;
		if( ( Mes->Counter1 >= VParam[ED_MESSAGE][10] && Mes->MesType == 0 ) ||
			( Mes->Counter1 >= VParam[ED_MESSAGE3][21] && Mes->MesType == 2 ) ||
			( Mes->Counter1 >= VParam[ED_MESSAGE][10] && Mes->Counter2 >= VParam[ED_MESSAGE2][21] && Mes->MesType == 1 ) )
		{
			Mes->Mode ++ ;
			Mes->Counter1 = 0 ;
			Mes->Counter2 = 0 ;
		}
		break ;
		
	case 7 :		// ҂
		
		if( Mes->MesType == 2 && Mes->MesType2 == 2 && ICONCHK(Mes) == FALSE )
		{
			if( Mes->Counter1 == 0 )
			{
				Mes->IconMode = 0 ;
				Mes->Counter1 = 1 ;
			}
			
			if( Mes->IconMode == -1 && Mes->StopFlag == FALSE )
			{
				Mes->Mode ++ ;
				Mes->Counter1 = 0 ;
			}
		}
		else
		{
			u32 Input ;
		
			Mes->Counter1 ++ ;
			Input = HSD_PadGetTrigger(0) ;
			if( ( Mes->BottanCancelFlag == TRUE &&
					( ( ( Input & PAD_BUTTON_A ) != 0 ) || ( ( Input & PAD_BUTTON_B ) != 0 ) ) ) ||
				( Mes->StopFlag2 == FALSE && Mes->Counter1 >= VParam[ED_MESSAGE][11] ) ||
				( Mes->StopFlag2 == TRUE && Mes->StopFlag == FALSE ) )
			{
				Mes->Mode ++ ;
				Mes->Counter1 = 0 ;
			}
		}
		break ;

	case 8 :		// Xe[^Xޏo
		switch( Mes->MesType )
		{
		case 2 :
		case 0 :
			Mes->Counter1 += Mes->MesType == 0 ? VParam[ED_MESSAGE][12] : VParam[ED_MESSAGE3][22] * 10 ;
			Mes->Counter2 += Mes->Counter1 ;
			Mes->MesX += Mes->Counter1 / 10.0F * ( Mes->MesType == 2 ? -1 : 1 ) ;
			if( Mes->MesType == 2 )
			{
				Mes->Length = RenderMessage( (s8)Mes->PackID, (s8)Mes->MessageID,
						(s16)( WK7_SCREEN_WIDTH - Mes->MesX ),
						0,
						(GXColor){0}, FALSE, Mes->LeftFlag, Mes->MesType, Mes->Size, Mes->ExRate, MESSAGE_ASOBI,
						NULL, -1, Mes->MesType2, Mes->RandMap, Mes->MaxHeight ) ;
			}
			Mes->BotLineX -= Mes->Counter1 / 10.0F ;
			Mes->BotLineLength += Mes->Counter1 / 10.0F ;
			Mes->ArrowX -= Mes->Counter1 / 10.0F ;
			Mes->PointLineX -= Mes->Counter1 / 10.0F ;
			if( ( Mes->MesType == 0 && Mes->Counter2 >= WK7_SCREEN_WIDTH * 10 ) ||
				( Mes->MesType == 2 && Mes->MesX + Mes->Length < 0 ) )
			{
				Mes->Counter1 = 0 ;
				Mes->Counter2 = 0 ;
				Mes->Mode ++ ;
				
				// ^CvQ獟ŏI
				if( Mes->MesType == 2 )
				{
					DeleteEffect( Effect ) ;
					return 0 ;
				}
			}
			break ;
			
		case 1 :
			Mes->Counter1 = 0 ;
			Mes->Counter2 = 0 ;
			Mes->Mode ++ ;
			break ;
		}
		break ;
		
	case 9 :		// ҂
		Mes->Counter1 ++ ;
		if( Mes->Counter1 >= VParam[ED_MESSAGE][13] )
		{
			Mes->Mode ++ ;
			Mes->Counter1 = 0 ;
			Mes->Counter2 = 0 ;
			Mes->PointLineGradFlag = TRUE ;
		}
		break ;

	case 10 :		// ёޏo
		Mes->Counter1 ++ ;

		// эWvZ
		Mes->BotLineX = ( WK7_SCREEN_WIDTH + VParam[ED_MESSAGE][20] ) -
										 GetSanjiFunction( -VParam[ED_MESSAGE][14],
															 WK7_SCREEN_WIDTH + VParam[ED_MESSAGE][20],
															 VParam[ED_MESSAGE][15],
															 (f32)Mes->Counter1 ) ;

		if( Mes->Counter1 > VParam[ED_MESSAGE2][22] )
		{
			Mes->ItemX = /*(f32)VParam[ED_MESSAGE2][24] +*/
											 GetSanjiFunction( VParam[ED_MESSAGE][14],
																 -(f32)VParam[ED_MESSAGE2][24] * 1.5F,
																 VParam[ED_MESSAGE][15] - VParam[ED_MESSAGE2][22],
																 (f32)( Mes->Counter1 - VParam[ED_MESSAGE2][22] ) ) ;
		}
															 
		if( Mes->Counter1 >= VParam[ED_MESSAGE][15] )
		{
			Mes->Mode ++ ;
			Mes->Counter1 = 0 ;
		}
		break ;
	
	case 11 :		// I
		DeleteEffect( Effect ) ;
		break ;
	}
	
#endif
#endif
	// I
	return 0 ;
}
			


// bZ[W̃GtFNg`悷
extern s8 DrawMessageEffect( EFFECT *Effect )
{
//	Vec Dest ;
	MESSAGEEFFECT *Mes = ( MESSAGEEFFECT * )Effect->Data ;
#ifndef NO_CODE

#ifndef __OLDMODE
	return 0 ;
#else
//	u8 i ;
	f32 y ;

	// ̕`̏
	SetupPlaneInfo() ;

	// eNX`ǂݍݏIĖ牽I
//	for( i = 0 ; i < MES_NUM ; i ++ ) if( CHKFILELOAD( MsUnion.MessageTexFile[i] ) == FALSE ) return 0 ;
	if( MsUnion.MesPack[Mes->PackID].UseFlag == FALSE ) return 0 ;
	if( CHKFILELOAD( MsUnion.MesPack[Mes->PackID].JmbFile ) == FALSE && MsUnion.MesPack[Mes->PackID].JmbFile == NULL ) return 0 ;
	if( CHKFILELOAD( MsUnion.ArrowTexFile ) == FALSE ) return 0 ;
	if( CHKFILELOAD( MsUnion.IconTexFile ) == FALSE ) return 0 ;
	if( CheckMessagePackLoadComp( Mes->PackID ) == FALSE ) return 0 ;

	// NbsOȂ
//	GXSetClipMode( GX_CLIP_DISABLE ) ;

	// Zobt@̏sݒ
	// rsȂ̂ŃeNX`̂ƂɎs邱Ƃɂ܂
	GXSetZCompLoc( GX_FALSE ) ;

	// Zobt@̓샂[hݒ肷
	GXSetZMode( GX_FALSE, GX_LESS, GX_FALSE ) ;

	switch( Mes->MesType )
	{
	case 0 :
	case 2 :
		// ˉeXe[^Xݒ肷
		{
			Mtx44 mt ;
			
			// ˉes쐬
			MTXOrtho( mt, WK7_SCREEN_HEIGHT, 0.0F,
							WK7_SCREEN_WIDTH, 0.0F, 0, -1000000 ) ;
			GXSetProjection( mt, GX_ORTHOGRAPHIC ) ;
		}

		// r[}gbNXZbg
		{
			Mtx View ;
		
			// PʍsZbg
			MTXIdentity( View ) ; 
		
			// }gbNXZbg
			GXLoadPosMtxImm( View, 0 ) ;
			GXLoadNrmMtxImm( View, 0 ) ;
			GXSetCurrentMtx( 0 ) ;
		}
		break ;
		
	case 1 :
		HSD_CObj *Camera ;
		Mtx View ;
		
		// J̏擾
		Camera = GetEffectCamera() ;
		
		// J̎ˉeXe[^Xݒ肷
		{
			f32 fov, aspect, n, f ;
			Mtx44 mt ;
		
			// 擾
	//		HSD_CObjGetPerspective( Camera, &fov, &aspect );
	//		n = HSD_CObjGetNear( Camera );
	//		f = HSD_CObjGetFar( Camera );

			aspect = ASPECT ;
			fov = FOV ;
			n = 0.1000000014901161F ;
			f = 100000.000000000F ;

			// ˉes쐬
			MTXPerspective( mt, fov, aspect, n, f ) ;
			GXSetProjection( mt, GX_PERSPECTIVE ) ;
		}
		
		// r[}gbNXZbg
		{
			// r[s擾
			HSD_CObjGetViewingMtx( Camera, View ) ; 
		
			// }gbNXZbg
			GXLoadPosMtxImm( View, 0 ) ;
			GXLoadNrmMtxImm( View, 0 ) ;
			GXSetCurrentMtx( 0 ) ;
		}
		break ;
	}
	
	// Abvf[gݒ
	GXSetAlphaUpdate( GX_FALSE ) ;
	GXSetColorUpdate( GX_TRUE ) ;

	// JO̐ݒ
//	GXSetCullMode( GX_CULL_BACK ) ;
	GXSetCullMode( GX_CULL_NONE ) ;

	// uh[h̃Zbg
	GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_SET);

	// J[̐ݒ
	GXSetAlphaCompare( GX_ALWAYS, 0, GX_AOP_OR, GX_ALWAYS, 0);
	GXSetNumChans(1);
	GXSetChanAmbColor( GX_COLOR0A0, (GXColor){128, 128, 128, 255} ) ;
	GXSetChanMatColor( GX_COLOR0A0, (GXColor){128, 128, 128, 255} ) ;
	GXSetChanCtrl( GX_COLOR0A0, GX_DISABLE, GX_SRC_VTX, GX_SRC_VTX,
					GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE ) ;

	// eNX`Wݒ
	GXSetNumTexGens(1);
//	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY ) ;

	// TEVݒ
	GXSetNumTevStages(1);
	
	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS, GX_POS_XYZ, GX_F32, 0 ) ;
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 ) ;
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, UVSHFTBIT ) ;

	// GXFIFOɓnf[^̃Zbg	
	GXClearVtxDesc();
	GXSetVtxDesc(GX_VA_POS, GX_DIRECT) ;
	GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT) ;
	GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT) ;

	// C̕`
	if( Mes->MesType == 0 || Mes->MesType == 1 )
	{
		u8 a ;

		a = (u8)VParam[ED_MESSAGE][23] ;

		GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP_NULL, GX_COLOR0A0 );
		GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC ) ; 
		GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
		GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_RASA ) ; 
		GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
		
		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)4 ) ;
		{
			if( Mes->LeftFlag == FALSE )
			{
				SetPos( Mes->BotLineX, 							( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ), Mes->MesType ) ;	GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 0, 0 ) ;
				SetPos( ( Mes->BotLineX + Mes->BotLineLength ), ( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ), Mes->MesType ) ;	GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 1.0F, 0 ) ;
				SetPos( ( Mes->BotLineX + Mes->BotLineLength ), ( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + ARROW_H, Mes->MesType ) ;	GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
				SetPos( Mes->BotLineX, 							( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + ARROW_H, Mes->MesType ) ;	GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 0, 1.0F ) ;
			}
			else
			{
				SetPos3( Mes->BotLineX, 							( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ), Mes->MesType ) ;	GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 0, 0 ) ;
				SetPos3( ( Mes->BotLineX + Mes->BotLineLength ), 	( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ), Mes->MesType ) ;	GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 1.0F, 0 ) ;
				SetPos3( ( Mes->BotLineX + Mes->BotLineLength ), 	( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + ARROW_H, Mes->MesType ) ;	GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
				SetPos3( Mes->BotLineX, 							( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + ARROW_H, Mes->MesType ) ;	GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 0, 1.0F ) ;
			}
		}
		GXEnd() ;
		
		if( Mes->MesType == 0 )
		{
			if( Mes->PointLineGradFlag == TRUE )
			{
				GXBegin( GX_QUADS, GX_VTXFMT0, (u16)4 ) ;
				{
					SetPos( ( Mes->BotLineX - VParam[ED_MESSAGE][20] ), Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA, Mes->MesType ) ;				GXColor4u8( 0, 0, 0, 0 ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( ( Mes->BotLineX ), 							Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA, Mes->MesType ) ;				GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 1.0F, 0 ) ;
					SetPos( ( Mes->BotLineX ), 							( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + ARROW_H, Mes->MesType ) ;	GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
					SetPos( ( Mes->BotLineX - VParam[ED_MESSAGE][20] ), ( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + ARROW_H, Mes->MesType ) ;	GXColor4u8( 0, 0, 0, 0 ) ; GXTexCoord2f32( 0, 1.0F ) ;
				}
				GXEnd() ;
			}
		}
	}
	
	if( Mes->MesType == 2 )
	{
		u8 r, g, b, a ;
		MESSAGEPACK *MesP ;
		stSentence *Head ;
		GhmGcTexHeader *Tex ;
		stOneSentence *OneS ;
		stJimaku *Jimaku ;
		stFontParam *UvStart, *Uv ;
		u32 StrLen, SpaceNum, h ;
		f32 StH, EndH ;
		f32 d ;

		// ̏
		MesP = &MsUnion.MesPack[Mes->PackID] ;
		Head = ( stSentence * )MesP->JmbData ;
		OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + Mes->MessageID * sizeof( stOneSentence ) ) ;
		Jimaku = &OneS->jimaku[0] ;
		UvStart = ( stFontParam * )( (u8 *)MesP->JmbData + Head->charOffset ) ;
		Tex = ( GhmGcTexHeader * )( ( u8 * )MesP->JmbData + Head->texOffset ) ;
	
		// ̒ƃXy[X̐𐔂
		{
			for( SpaceNum = 0, StrLen = 0 ;
				 (u16)Jimaku->chardat[StrLen] != JIMAKU_NO_FONT ; StrLen ++ )
			{
				if( (u16)Jimaku->chardat[StrLen] == 0xfffe || 
					(u16)Jimaku->chardat[StrLen] == 0xfffd ||
					(u16)Jimaku->chardat[StrLen] == 0xfffc )	SpaceNum ++ ;
			}
		}
		
		// tulZo
		if( Mes->LeftFlag == FALSE )
		{
			Uv = UvStart + ( (u16)Jimaku->chardat[StrLen-2] & 0xfff ) ;
			h = Uv->h ;
			if( Mes->MesType2 == 0 ) h -= VParam[ED_MESSAGE4][5+(StrLen-2)] ;
			if( Mes->MesType2 == 1 ) h -= VParam[ED_MESSAGE4][9+(StrLen-2)] ;
			EndH = h * Mes->Size ;

			Uv = UvStart + ( (u16)Jimaku->chardat[0] & 0xfff ) ;
			h = Uv->h ;
			if( Mes->MesType2 == 0 ) h -= VParam[ED_MESSAGE4][5] ;
			if( Mes->MesType2 == 1 ) h -= VParam[ED_MESSAGE4][9] ;
			StH = h * ( Mes->Size - Mes->Length2 * Mes->ExRate ) ;
			
			// X𓾂
			d = ( EndH - StH ) / Mes->Length2 ;
			EndH += d * MESSAGE_ASOBI ;
			StH -= d * ( Mes->Length - Mes->Length2 ) ;
		}
		else
		{
			Uv = UvStart + ( (u16)Jimaku->chardat[0] & 0xfff ) ;
			h = Uv->h ;
			if( Mes->MesType2 == 0 ) h -= VParam[ED_MESSAGE4][5] ;
			if( Mes->MesType2 == 1 ) h -= VParam[ED_MESSAGE4][9] ;
			StH = h * Mes->Size ;

			Uv = UvStart + ( (u16)Jimaku->chardat[StrLen-2] & 0xfff ) ;
			h = Uv->h ;
			if( Mes->MesType2 == 0 ) h -= VParam[ED_MESSAGE4][5+(StrLen-2)] ;
			if( Mes->MesType2 == 1 ) h -= VParam[ED_MESSAGE4][9+(StrLen-2)] ;
			EndH = h * ( Mes->Size - Mes->Length2 * Mes->ExRate ) ;
			
			// X𓾂
			d = ( EndH - StH ) / Mes->Length2 ;
			StH -= d * MESSAGE_ASOBI ;
			EndH += d * ( Mes->Length - Mes->Length2 ) ;
		}
		if( Mes->MesType2 != 2 )
		{
			StH *= VParam[ED_MESSAGE4][19] * 0.01F ;
			EndH *= VParam[ED_MESSAGE4][19] * 0.01F ;
		}
		else
		{
			EndH = StH = Mes->MaxHeight ;
			StH *= VParam[ED_MESSAGE4][20] * 0.01F ;
			EndH *= VParam[ED_MESSAGE4][20] * 0.01F ;
		}

		// uh[h̃Zbg
		GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_SET);
	
		GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP_NULL, GX_COLOR0A0 );
		GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC ) ; 
		GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
		GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_RASA ) ; 
		GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;

		a = (u8)VParam[ED_MESSAGE][23] ;
		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)4 ) ;
		{
			r = ColorTable3[Mes->MesType2][0] ;
			g = ColorTable3[Mes->MesType2][1] ;
			b = ColorTable3[Mes->MesType2][2] ;
			y = ( Mes->y != -1 ? Mes->y : Mes->PostID * VParam[ED_MESSAGE4][17] + VParam[ED_MESSAGE4][18] ) + VParam[ED_MESSAGE4][1] ;
			if( Mes->LeftFlag == TRUE )
			{
				if( Mes->MesType2 == 0 || Mes->MesType2 == 2 )
				{
					SetPos( Mes->MesX + Mes->Length, 	y - VParam[ED_MESSAGE3][8], Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( 0, 							y - VParam[ED_MESSAGE3][8],	Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 1.0F, 0 ) ;
					SetPos( 0, 							y + EndH, 					Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
					SetPos( Mes->MesX + Mes->Length,  	y + StH, 					Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 0, 1.0F ) ;
				}
				else
				{
					SetPos( Mes->MesX + Mes->Length, 	y - EndH,					Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( 0, 							y - StH,					Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 1.0F, 0 ) ;
					SetPos( 0, 							y + VParam[ED_MESSAGE3][8], Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
					SetPos( Mes->MesX + Mes->Length,  	y + VParam[ED_MESSAGE3][8], Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 0, 1.0F ) ;
				}
			}
			else
			{
				if( Mes->MesType2 == 0 || Mes->MesType2 == 2 )
				{
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length ), y - VParam[ED_MESSAGE3][8], 	Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( WK7_SCREEN_WIDTH, 								y - VParam[ED_MESSAGE3][8],		Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 1.0F, 0 ) ;
					SetPos( WK7_SCREEN_WIDTH, 								y + EndH, 						Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length ), y + StH, 						Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 0, 1.0F ) ;
				}
				else
				{
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length ), y - StH,					Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( WK7_SCREEN_WIDTH, 								y - EndH,					Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 1.0F, 0 ) ;
					SetPos( WK7_SCREEN_WIDTH, 								y + VParam[ED_MESSAGE3][8], Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length ), y + VParam[ED_MESSAGE3][8], Mes->MesType ) ;	GXColor4u8( r, g, b, a) ; GXTexCoord2f32( 0, 1.0F ) ;
				}
			}
		}
		GXEnd() ;
	}
		
	
	switch( Mes->MesType )
	{
	case 0 :
		// ̕`
		{
			// eNX`̃[h
			GTLOAD( &MsUnion.ArrowTex.Obj ) ;

			GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );
			GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC ) ; 
			GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
			GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_TEXA, GX_CA_RASA, GX_CA_ZERO) ; 
			GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
		
			GBGN( GX_QUADS, 4 * 2 ) ;
			{
				// vO_O`
				SetPos( Mes->ArrowX, 					Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA, Mes->MesType ) ;				GXColor4u8( 205, 0, 126, 255 ) ; GXTexCoord2f32( 0, 0 ) ;
				SetPos( ( Mes->ArrowX + ARROW_PW ), 	Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA, Mes->MesType ) ;				GXColor4u8( 205, 0, 126, 255 ) ; GXTexCoord2f32( 0.0F, 0 ) ;
				SetPos( ( Mes->ArrowX + ARROW_PW ), 	( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + ARROW_H, Mes->MesType ) ;	GXColor4u8( 205, 0, 126, 255 ) ; GXTexCoord2f32( 0.0F, 1.0F ) ;
				SetPos( Mes->ArrowX, 					( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + ARROW_H, Mes->MesType ) ;	GXColor4u8( 205, 0, 126, 255 ) ; GXTexCoord2f32( 0, 1.0F ) ;

				// eNX`_O`
				SetPos( ( Mes->ArrowX + ARROW_PW ), 			Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA, Mes->MesType ) ;				GXColor4u8( 205, 0, 126, 255 ) ; GXTexCoord2f32( 0, 0 ) ;
				SetPos( ( Mes->ArrowX + ARROW_PW + ARROW_W ),	Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA, Mes->MesType ) ;				GXColor4u8( 205, 0, 126, 255 ) ; GXTexCoord2f32( 1.0F, 0 ) ;
				SetPos( ( Mes->ArrowX + ARROW_PW + ARROW_W ),	( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + ARROW_H, Mes->MesType ) ;	GXColor4u8( 205, 0, 126, 255 ) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
				SetPos( ( Mes->ArrowX + ARROW_PW ), 			( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + ARROW_H, Mes->MesType ) ;	GXColor4u8( 205, 0, 126, 255 ) ; GXTexCoord2f32( 0, 1.0F ) ;
			}
			GXEnd() ;
		}
		break ;
		
	case 1 :

		if( Mes->BotLineLength != 0.0F )
		{
			Vec Src[4] ;

			Src[0].x = ( Mes->BotLineX + Mes->BotLineLength ) ;		Src[0].y = ( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) ;
			Src[1].x = Mes->BotLineX ;								Src[1].y = ( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) ;
			Src[2].x = Mes->BotLineX ; 								Src[2].y = ( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + ARROW_H ;
			Src[3].x = ( Mes->BotLineX + Mes->BotLineLength ) ;		Src[3].y = ( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + ARROW_H ;
			Draw3DLine( Src, 0, Mes->LeftFlag ) ;


			// ACR\̎w肪ꍇ̂݃ACR̕`揈s
			if( ICONCHK(Mes) == FALSE )
			{
				Src[0].x = ( Mes->ItemX + VParam[ED_MESSAGE2][23] + VParam[ED_MESSAGE2][23] * 3 ) ;		Src[0].y = 0.0F ;
				Src[1].x = Mes->ItemX + VParam[ED_MESSAGE2][23]	;										Src[1].y = 0.0F ;
				Src[2].x = Mes->ItemX + VParam[ED_MESSAGE2][23] ; 										Src[2].y = VParam[ED_MESSAGE2][23] ;
				Src[3].x = ( Mes->ItemX + VParam[ED_MESSAGE2][23] + VParam[ED_MESSAGE2][23] * 3 ) ;		Src[3].y = VParam[ED_MESSAGE2][23] ;
				
				u8 a ;
			
				a = (u8)VParam[ED_MESSAGE][23] ;
				
				GXBegin( GX_QUADS, GX_VTXFMT0, (u16)4 ) ;
				{
					SetPos2( Src[0].x, Src[0].y, Mes->MesType ) ;	GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos2( Src[1].x, Src[1].y, Mes->MesType ) ;	GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos2( Src[2].x, Src[2].y, Mes->MesType ) ;	GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos2( Src[3].x, Src[3].y, Mes->MesType ) ;	GXColor4u8( 0, 0, 0, a ) ; GXTexCoord2f32( 0, 0 ) ;
				}
				GXEnd() ;
				
				Draw3DLine( Src, 1, Mes->LeftFlag ) ;
				
				Src[0].x = ( Mes->ItemX + VParam[ED_MESSAGE2][23] + VParam[ED_MESSAGE2][23] ) ;		Src[0].y = 0.0F ;
				Src[1].x = Mes->ItemX + VParam[ED_MESSAGE2][23]	;									Src[1].y = 0.0F ;
				Src[2].x = Mes->ItemX + VParam[ED_MESSAGE2][23] ; 									Src[2].y = VParam[ED_MESSAGE2][23] ;
				Src[3].x = ( Mes->ItemX + VParam[ED_MESSAGE2][23] + VParam[ED_MESSAGE2][23] ) ;		Src[3].y = VParam[ED_MESSAGE2][23] ;
				
				// eNX`̃[h
				{
					MESSAGEPACK *MesP ;
					stSentence *Head ;
					stOneSentence *OneS ;
					stJimaku *Jimaku ;

					MesP = &MsUnion.MesPack[Mes->PackID] ;
					Head = ( stSentence * )MesP->JmbData ;
					OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + Mes->MessageID * sizeof( stOneSentence ) ) ;
					Jimaku = &OneS->jimaku[0] ;

					GTLOAD2( MsUnion.IconTexList[Jimaku->wait / TICKTIME] ) ;
				}
				
				GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );
				GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC ) ; 
				GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
				GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_TEXA, GX_CA_RASA, GX_CA_ZERO) ; 
				GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
				
				GXBegin( GX_QUADS, GX_VTXFMT0, (u16)4 ) ;
				{
					SetPos2( Src[0].x, Src[0].y, Mes->MesType ) ;	GXColor4u8( 255, 255, 255, a ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos2( Src[1].x, Src[1].y, Mes->MesType ) ;	GXColor4u8( 255, 255, 255, a ) ; GXTexCoord2f32( 1.0F, 0 ) ;
					SetPos2( Src[2].x, Src[2].y, Mes->MesType ) ;	GXColor4u8( 255, 255, 255, a ) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
					SetPos2( Src[3].x, Src[3].y, Mes->MesType ) ;	GXColor4u8( 255, 255, 255, a ) ; GXTexCoord2f32( 0, 1.0F ) ;
				}
				GXEnd() ;
				
				GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP_NULL, GX_COLOR0A0 );
				GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC ) ; 
				GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
				GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_RASA ) ; 
				GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
				
				// eNX`̃[h
				GTLOAD( &MsUnion.ArrowTex.Obj ) ;
			}
		}
		break ;
		
	case 2 :
		{
			u8 r, g, b ;
			f32 y ;
		
			// uh[h̃Zbg
			GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_SET);
		
			GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP_NULL, GX_COLOR0A0 );
			GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC ) ; 
			GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
			GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_RASA ) ; 
			GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;

			y = ( Mes->y != -1 ? Mes->y : Mes->PostID * VParam[ED_MESSAGE4][17] + VParam[ED_MESSAGE4][18] ) ;
				
			// ACR̕`
			if( ICONCHK(Mes) == FALSE && Mes->MesType2 == 2 && Mes->IconMode != -1 )
			{
				s32 w, h ;
				f32 uh ;
				u8 r, g, b, a ;
			
				r = ColorTable3[Mes->MesType2][0] ;
				g = ColorTable3[Mes->MesType2][1] ;
				b = ColorTable3[Mes->MesType2][2] ;
				a = (u8)VParam[ED_MESSAGE][23] ;
				w = (s32)VParam[ED_MESSAGE5][6] ;
				h = (s32)VParam[ED_MESSAGE5][7] ;
				
				GXBegin( GX_QUADS, GX_VTXFMT0, (u16)4 ) ;
				{
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ),										y - Mes->IconX,		Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + w + (s32)VParam[ED_MESSAGE5][8] * 2,	y - Mes->IconX, 	Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + w + (s32)VParam[ED_MESSAGE5][8] * 2,	y, 					Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ),										y,					Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;
				}
				GXEnd() ;

				GXBegin( GX_QUADS, GX_VTXFMT0, (u16)4 * 2 /** 3*/ ) ;
				{
					r = (u8)VParam[ED_MESSAGE4][21] ;
					g = (u8)VParam[ED_MESSAGE4][22] ;
					b = (u8)VParam[ED_MESSAGE4][23] ;
					a = 255 ;
				
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + VParam[ED_MESSAGE4][0],				y + VParam[ED_MESSAGE4][1] - Mes->IconX,							Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + (s32)VParam[ED_MESSAGE5][8] * 2 + w,	y + VParam[ED_MESSAGE4][1] - Mes->IconX, 							Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + (s32)VParam[ED_MESSAGE5][8] * 2 + w,	y + VParam[ED_MESSAGE4][1] - Mes->IconX + VParam[ED_MESSAGE3][8], 	Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + VParam[ED_MESSAGE4][0],				y + VParam[ED_MESSAGE4][1] - Mes->IconX + VParam[ED_MESSAGE3][8],	Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;

					r = ColorTable2[Mes->ColorTableIndex][0] ;
					g = ColorTable2[Mes->ColorTableIndex][1] ;
					b = ColorTable2[Mes->ColorTableIndex][2] ;
					a = 255 ;
					
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ),										y - Mes->IconX,								Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + (s32)VParam[ED_MESSAGE5][8] * 2 + w,	y - Mes->IconX, 							Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + (s32)VParam[ED_MESSAGE5][8] * 2 + w,	y - Mes->IconX + VParam[ED_MESSAGE3][8], 	Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;
					SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ),										y - Mes->IconX + VParam[ED_MESSAGE3][8],	Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;
				}
				GXEnd() ;
				
				// eNX`̃[h
				{
					MESSAGEPACK *MesP ;
					stSentence *Head ;
					stOneSentence *OneS ;
					stJimaku *Jimaku ;

					MesP = &MsUnion.MesPack[Mes->PackID] ;
					Head = ( stSentence * )MesP->JmbData ;
					OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + Mes->MessageID * sizeof( stOneSentence ) ) ;
					Jimaku = &OneS->jimaku[0] ;

					GTLOAD( MsUnion.IconTexList[Jimaku->wait / TICKTIME] ) ;
				}
				
				if( Mes->IconDrawFlag == TRUE && Mes->IconX > VParam[ED_MESSAGE5][9] )
				{
					f32 h2 ;
				
					uh = ( Mes->IconX - VParam[ED_MESSAGE5][9] ) / (f32)VParam[ED_MESSAGE5][7] ;
					if( uh > 1.0F ) uh = 1.0F ;
					h2 = uh * VParam[ED_MESSAGE5][7] ;

					GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );
					GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC ) ; 
					GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
					GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_TEXA, GX_CA_RASA, GX_CA_ZERO) ; 
					GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
					
					GXBegin( GX_QUADS, GX_VTXFMT0, (u16)4 * 2 ) ;
					{
						r = (u8)VParam[ED_MESSAGE4][21] ;
						g = (u8)VParam[ED_MESSAGE4][22] ;
						b = (u8)VParam[ED_MESSAGE4][23] ;
						a = 255 ;
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + VParam[ED_MESSAGE4][0] + (s32)VParam[ED_MESSAGE5][8],		y - Mes->IconX + VParam[ED_MESSAGE4][1] + (s32)VParam[ED_MESSAGE5][9],		Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + VParam[ED_MESSAGE4][0] + (s32)VParam[ED_MESSAGE5][8] + w,	y - Mes->IconX + VParam[ED_MESSAGE4][1] + (s32)VParam[ED_MESSAGE5][9], 		Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 1.0F, 0 ) ;
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + VParam[ED_MESSAGE4][0] + (s32)VParam[ED_MESSAGE5][8] + w,	y - Mes->IconX + VParam[ED_MESSAGE4][1] + (s32)VParam[ED_MESSAGE5][9] + h2, 	Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 1.0F, uh ) ;
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + VParam[ED_MESSAGE4][0] + (s32)VParam[ED_MESSAGE5][8],		y - Mes->IconX + VParam[ED_MESSAGE4][1] + (s32)VParam[ED_MESSAGE5][9] + h2,	Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, uh ) ;
						
						r = ColorTable2[Mes->ColorTableIndex][0] ;
						g = ColorTable2[Mes->ColorTableIndex][1] ;
						b = ColorTable2[Mes->ColorTableIndex][2] ;
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + (s32)VParam[ED_MESSAGE5][8],		y - Mes->IconX + (s32)VParam[ED_MESSAGE5][9],		Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, 0 ) ;
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + (s32)VParam[ED_MESSAGE5][8] + w,	y - Mes->IconX + (s32)VParam[ED_MESSAGE5][9], 		Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 1.0F, 0 ) ;
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + (s32)VParam[ED_MESSAGE5][8] + w,	y - Mes->IconX + (s32)VParam[ED_MESSAGE5][9] + h2, 	Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 1.0F, uh ) ;
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length2 ) + (s32)VParam[ED_MESSAGE5][8],		y - Mes->IconX + (s32)VParam[ED_MESSAGE5][9] + h2,	Mes->MesType ) ;	GXColor4u8( r, g, b, a ) ; GXTexCoord2f32( 0, uh ) ;
					}
					GXEnd() ;

					GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP_NULL, GX_COLOR0A0 );
					GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC ) ; 
					GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
					GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_RASA ) ; 
					GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
				}
			}

			// ㉺C̕`		
			GXBegin( GX_QUADS, GX_VTXFMT0, (u16)8 ) ;
			{
				if( Mes->LeftFlag == TRUE )
				{
					r = (u8)VParam[ED_MESSAGE4][21] ;
					g = (u8)VParam[ED_MESSAGE4][22] ;
					b = (u8)VParam[ED_MESSAGE4][23] ;
					if( Mes->MesType2 == 0 || Mes->MesType2 == 2 )
					{
						SetPos( Mes->MesX + Mes->Length + VParam[ED_MESSAGE4][0], 	y - VParam[ED_MESSAGE3][8] + VParam[ED_MESSAGE4][1],	Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 0 ) ;
						SetPos( VParam[ED_MESSAGE4][0], 							y - VParam[ED_MESSAGE3][8] + VParam[ED_MESSAGE4][1],	Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 0 ) ;
						SetPos( VParam[ED_MESSAGE4][0], 							y + VParam[ED_MESSAGE4][1], 							Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
						SetPos( Mes->MesX + Mes->Length + VParam[ED_MESSAGE4][0], 	y + VParam[ED_MESSAGE4][1],								Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 1.0F ) ;
					}
					else
					{
						SetPos( Mes->MesX + Mes->Length + VParam[ED_MESSAGE4][0], 	y + VParam[ED_MESSAGE4][1],								Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 0 ) ;
						SetPos( VParam[ED_MESSAGE4][0], 							y + VParam[ED_MESSAGE4][1],								Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 0 ) ;
						SetPos( VParam[ED_MESSAGE4][0], 							y + VParam[ED_MESSAGE4][1] + VParam[ED_MESSAGE3][8],	Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
						SetPos( Mes->MesX + Mes->Length + VParam[ED_MESSAGE4][0], 	y + VParam[ED_MESSAGE4][1] + VParam[ED_MESSAGE3][8],	Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 1.0F ) ;
					}

					r = ColorTable2[Mes->ColorTableIndex][0] ;
					g = ColorTable2[Mes->ColorTableIndex][1] ;
					b = ColorTable2[Mes->ColorTableIndex][2] ;
					if( Mes->MesType2 == 0 || Mes->MesType2 == 2 )
					{
						SetPos( Mes->MesX + Mes->Length, 	y - VParam[ED_MESSAGE3][8], Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 0 ) ;
						SetPos( 0, 							y - VParam[ED_MESSAGE3][8],	Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 0 ) ;
						SetPos( 0, 							y, 							Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
						SetPos( Mes->MesX + Mes->Length,  	y, 							Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 1.0F ) ;
					}
					else
					{
						SetPos( Mes->MesX + Mes->Length, 	y,							Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 0 ) ;
						SetPos( 0, 							y,							Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 0 ) ;
						SetPos( 0, 							y + VParam[ED_MESSAGE3][8], Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
						SetPos( Mes->MesX + Mes->Length,  	y + VParam[ED_MESSAGE3][8], Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 1.0F ) ;
					}
				}
				else
				{
					r = (u8)VParam[ED_MESSAGE4][21] ;
					g = (u8)VParam[ED_MESSAGE4][22] ;
					b = (u8)VParam[ED_MESSAGE4][23] ;
					if( Mes->MesType2 == 0 || Mes->MesType2 == 2 )
					{
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length ) + VParam[ED_MESSAGE4][0], 	y - VParam[ED_MESSAGE3][8] + VParam[ED_MESSAGE4][1],	Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 0 ) ;
						SetPos( WK7_SCREEN_WIDTH + VParam[ED_MESSAGE4][0], 									y - VParam[ED_MESSAGE3][8] + VParam[ED_MESSAGE4][1],	Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 0 ) ;
						SetPos( WK7_SCREEN_WIDTH + VParam[ED_MESSAGE4][0], 									y + VParam[ED_MESSAGE4][1], 							Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length ) + VParam[ED_MESSAGE4][0], 	y + VParam[ED_MESSAGE4][1],								Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 1.0F ) ;
					}
					else
					{
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length ) + VParam[ED_MESSAGE4][0], 	y + VParam[ED_MESSAGE4][1],								Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 0 ) ;
						SetPos( WK7_SCREEN_WIDTH + VParam[ED_MESSAGE4][0], 									y + VParam[ED_MESSAGE4][1],								Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 0 ) ;
						SetPos( WK7_SCREEN_WIDTH + VParam[ED_MESSAGE4][0], 									y + VParam[ED_MESSAGE4][1] + VParam[ED_MESSAGE3][8], 	Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length ) + VParam[ED_MESSAGE4][0], 	y + VParam[ED_MESSAGE4][1] + VParam[ED_MESSAGE3][8],	Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 1.0F ) ;
					}
					

					r = ColorTable2[Mes->ColorTableIndex][0] ;
					g = ColorTable2[Mes->ColorTableIndex][1] ;
					b = ColorTable2[Mes->ColorTableIndex][2] ;
					if( Mes->MesType2 == 0 || Mes->MesType2 == 2 )
					{
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length ), y - VParam[ED_MESSAGE3][8], Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 0 ) ;
						SetPos( WK7_SCREEN_WIDTH, 								y - VParam[ED_MESSAGE3][8],	Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 0 ) ;
						SetPos( WK7_SCREEN_WIDTH, 								y, 							Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length ), y, 							Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 1.0F ) ;
					}
					else
					{
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length ), y,							Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 0 ) ;
						SetPos( WK7_SCREEN_WIDTH, 								y,							Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 0 ) ;
						SetPos( WK7_SCREEN_WIDTH, 								y + VParam[ED_MESSAGE3][8], Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 1.0F, 1.0F ) ;
						SetPos( WK7_SCREEN_WIDTH - ( Mes->MesX + Mes->Length ), y + VParam[ED_MESSAGE3][8], Mes->MesType ) ;	GXColor4u8( r, g, b, 255) ; GXTexCoord2f32( 0, 1.0F ) ;
					}
				}
			}
			GXEnd() ;
		}
		break ;
		
	}
	
	if( Mes->MesType == 0 || Mes->MesType == 1 )
	{
		// ACR̕`
		{
			f32 IconX ;
			MESSAGEPACK *MesP ;
			stSentence *Head ;
			stOneSentence *OneS ;
			stJimaku *Jimaku ;
		
			// eNX`̃[h
			GTLOAD( &MsUnion.IconTex.Obj ) ;
			
			MesP = &MsUnion.MesPack[Mes->PackID] ;
			Head = ( stSentence * )MesP->JmbData ;
			OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + Mes->MessageID * sizeof( stOneSentence ) ) ;
			Jimaku = &OneS->jimaku[0] ;

			if( ( Mes->IconID != -1 ? Mes->IconID : Jimaku->wait / TICKTIME ) != ICONID_NONE )
			{
				IconX = (f32)( Mes->IconID != -1 ? Mes->IconID : Jimaku->wait / TICKTIME ) / ICONID_NUM ;
	//			IconX = (f32)MesDataTable[Mes->MessageID][0] / ICONID_NUM ;

				GXBegin( GX_QUADS, GX_VTXFMT0, (u16)4 ) ;
				{		
					SetPos( ( Mes->ArrowX + ICON_X ),				Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA + ICON_Y, Mes->MesType ) ;				GXColor4u8( 255, 255, 255, 255 ) ; GXTexCoord2f32( IconX, 0.0F ) ;
					SetPos( ( Mes->ArrowX + ICON_X + ICON_SIZE ),	Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA + ICON_Y, Mes->MesType ) ;				GXColor4u8( 255, 255, 255, 255 ) ; GXTexCoord2f32( IconX + ( 1.0F / ICONID_NUM ), 0.0F ) ;
					SetPos( ( Mes->ArrowX + ICON_X + ICON_SIZE ), 	( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA + ICON_Y ) + ICON_SIZE, Mes->MesType ) ;	GXColor4u8( 255, 255, 255, 255 ) ; GXTexCoord2f32( IconX + ( 1.0F / ICONID_NUM ), 1.0F ) ;
					SetPos( ( Mes->ArrowX + ICON_X ),				( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA + ICON_Y ) + ICON_SIZE, Mes->MesType ) ;	GXColor4u8( 255, 255, 255, 255 ) ; GXTexCoord2f32( IconX, 1.0F ) ;
				}
				GXEnd() ;
			}
		}
	}

	// bZ[W̕`
	{
		GXColor Color1, Color2 ;
		s32 x ;

		x = 0 ;
		if( Mes->MesType == 1 ) x = (s32)Mes->BotLineX ;

		Color1.r = (u8)VParam[ED_MESSAGE4][21] ;		Color1.g = (u8)VParam[ED_MESSAGE4][22] ;
		Color1.b = (u8)VParam[ED_MESSAGE4][23] ;		Color1.a = (u8)255 ;
		Color2.r = (u8)VParam[ED_MESSAGE4][21] ;		Color2.g = (u8)VParam[ED_MESSAGE4][22] ;
		Color2.b = (u8)VParam[ED_MESSAGE4][23] ;		Color2.a = (u8)255 ;
		
		s16 Len = RenderMessage( (s8)Mes->PackID, (s8)Mes->MessageID,
						(s16)( WK7_SCREEN_WIDTH - Mes->MesX + x + VParam[ED_MESSAGE4][0] ),
						(s16)( ( Mes->y != -1 ? Mes->y : Mes->PostID * VParam[ED_MESSAGE4][17] + VParam[ED_MESSAGE4][18] ) + VParam[ED_MESSAGE4][1] ),
						Color1/*Mes->Color*/, TRUE, Mes->LeftFlag, Mes->MesType, Mes->Size, Mes->ExRate, MESSAGE_ASOBI, &Color2, -1, Mes->MesType2,
						Mes->RandMap, Mes->MaxHeight ) ;

		Color1.r = (u8)VParam[ED_MESSAGE3][10] ;
		Color1.g = (u8)VParam[ED_MESSAGE3][11] ;
		Color1.b = (u8)VParam[ED_MESSAGE3][12] ;
		Color1.a = (u8)VParam[ED_MESSAGE3][13] ;
		Color2.r = (u8)VParam[ED_MESSAGE3][14] ;
		Color2.g = (u8)VParam[ED_MESSAGE3][15] ;
		Color2.b = (u8)VParam[ED_MESSAGE3][16] ;
		Color2.a = (u8)VParam[ED_MESSAGE3][13] ;
						
		Len = RenderMessage( (s8)Mes->PackID, (s8)Mes->MessageID,
						(s16)( WK7_SCREEN_WIDTH - Mes->MesX + x ),
						(s16)( ( Mes->y != -1 ? Mes->y : Mes->PostID * VParam[ED_MESSAGE4][17] + VParam[ED_MESSAGE4][18] ) ),
						Color1/*Mes->Color*/, TRUE, Mes->LeftFlag, Mes->MesType, Mes->Size, Mes->ExRate, MESSAGE_ASOBI, &Color2, Mes->ColorTableIndex, Mes->MesType2,
						Mes->RandMap, Mes->MaxHeight ) ;
		Len = 10 ;
	}

	// _̕`
	if( Mes->MesType == 0 || Mes->MesType == 1 )
	{
		if( 2 * Mes->PointLineNum != 0 )
		{
			u16 x ;
			u8 i ;
			u8 r, g, b ;

			// ̑Zbg
			GXSetLineWidth( 6 * TENLINE_WIDTH, GX_TO_ONE ) ;

			GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP_NULL, GX_COLOR0A0 );
			GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC ) ; 
			GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
			GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_RASA ) ; 
			GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;

			r = (u8)VParam[ED_MESSAGE][16] ;
			g = (u8)VParam[ED_MESSAGE][17] ;
			b = (u8)VParam[ED_MESSAGE][18] ;
			GXBegin( GX_LINES, GX_VTXFMT0, (u16)( 2 * Mes->PointLineNum ) ) ;
			{
				x = (u16)( TENLINE_X - ( ICONCHK(Mes) ? ICON_SIZE : 0 ) ) ;
				if( Mes->MesType == 1 ) x += Mes->BotLineX ;

				for( i = 0 ; i < Mes->PointLineNum ; i ++, x += TENLINE_LENGTH + TENLINE_WAIT )
				{
					if( Mes->LeftFlag )
					{
						SetPos3( ( Mes->ArrowX + x ),					( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + TENLINE_Y, Mes->MesType ) ;	GXColor4u8( r, g, b, 119 ) ; GXTexCoord2f32( 0.0F, 0.0F ) ;
						SetPos3( ( Mes->ArrowX + x + TENLINE_LENGTH ),	( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + TENLINE_Y, Mes->MesType ) ;	GXColor4u8( r, g, b, 119 ) ; GXTexCoord2f32( 0.0F, 0.0F ) ;
					}
					else
					{
						SetPos( ( Mes->ArrowX + x ),					( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + TENLINE_Y, Mes->MesType ) ;	GXColor4u8( r, g, b, 119 ) ; GXTexCoord2f32( 0.0F, 0.0F ) ;
						SetPos( ( Mes->ArrowX + x + TENLINE_LENGTH ),	( Mes->y != -1 ? Mes->y : Mes->PostID * MESSAGE_WAIT + SUKIMA ) + TENLINE_Y, Mes->MesType ) ;	GXColor4u8( r, g, b, 119 ) ; GXTexCoord2f32( 0.0F, 0.0F ) ;
					}
				}
			}
			GXEnd() ;
		}
	}
	
#endif
#endif
	// I
	return 0 ;
}

// bZ[WpbNf[^t@CǂݍݏIǂ擾( TREU:ǂݍ݊  FALSE:ǂݍݒ )
extern s8 CheckMessagePackLoadComp( s8 PackID )
{
	MESSAGEPACK *Pack ;
	stSentence *Head ;
	stOneSentence *OneS ;
	stJimaku *Jimaku ;
	s32 i ;

	Pack = &MsUnion.MesPack[PackID] ;

	// pbNgĂȂ牽I
	if( Pack->UseFlag == FALSE ) return TRUE ;
	
	// ZbgAbvIĂ邩ǂŏ𕪊
	if( Pack->SetupFlag == 2 ) return TRUE ;
	
	// t@CǂݍݏIĂȂꍇ̓t@C̓ǂݍ݂`FbN
	if( Pack->SetupFlag == 0 && CHKFILELOAD( Pack->JmbFile ) == FALSE ) return FALSE ;
	
	// ACR̃ZbgAbv܂n߂ĂȂꍇ̓ZbgAbvJn
	if( Pack->SetupFlag == 0 )
	{
		Head = ( stSentence * )Pack->JmbData ;
		
		// ͂̐JԂ
		OneS = ( stOneSentence * )( ( u8 * )Pack->JmbData + Head->offset ) ;
		for( i = 0 ; i < Head->num ; i ++, OneS ++ )
		{
			Jimaku = &OneS->jimaku[0] ;
			
			if( ( Jimaku->wait / TICKTIME ) != ICONID_NONE ) SetupIconTex( (s8)( Jimaku->wait / TICKTIME ) ) ;
		}

		// ACR̃ZbgAbvJn؋c
		Pack->SetupFlag = 1 ;
		
		// I
		return FALSE ;
	}

	// ACR̃ZbgAbvn߂Ăꍇ̓ZbgAbvǂ`FbN
	Head = ( stSentence * )Pack->JmbData ;
	
	// ͂̐JԂ
	OneS = ( stOneSentence * )( ( u8 * )Pack->JmbData + Head->offset ) ;
	for( i = 0 ; i < Head->num ; i ++, OneS ++ )
	{
		Jimaku = &OneS->jimaku[0] ;
		
		if( ( Jimaku->wait / TICKTIME ) != ICONID_NONE )
			if( CheckIconTex( (s8)( Jimaku->wait / TICKTIME ) ) == FALSE ) return FALSE ;
	}
	
	// eNX`̃ZbgAbv
	{
		// ܂ JmbFile ɂmtkkĂȂꍇ
		// eNX`̃ZbgAbvsĂȂ؋		
		if( Pack->JmbFile != NULL )
		{
			stSentence *Head = ( stSentence * )Pack->JmbData ;
			GhmGcTexHeader *Tex = ( GhmGcTexHeader * )( (u8 *)Pack->JmbData + Head->texOffset ) ;
		
			// eNX`̃ZbgAbv
			
			// eNX`쐬
			GXInitTexObj( &Pack->TexObj, GHMGCTEX_GETIMAGE(Tex),
							 Tex->mWidth, Tex->mHeight, Tex->mFormat,
							  GX_CLAMP, GX_CLAMP, GX_FALSE ) ;
			GXInitTexObjLOD( &Pack->TexObj, GX_LINEAR, GX_LINEAR, Tex->mMinLOD, Tex->mMaxLOD, 0.0F,
								GX_FALSE, GX_FALSE, GX_ANISO_1 ) ;

			// t@C
			CLOSECHK( Pack->JmbFile ) ;
			
			// mtkkZbg
			Pack->JmbFile = NULL ;
		}
	}
	
	// ǂݍ݂؋c
	Pack->SetupFlag = 2 ;

	// I		
	return TRUE ;
}

// bZ[WpbNf[^̃AhX擾
extern MESSAGEPACK *GetMessagePack( s8 PackID )
{
	return &MsUnion.MesPack[PackID] ;
}

// bZ[WpbNf[^̃eNX`wb_̃AhX擾
extern GhmGcTexHeader *GetMessageTexHeader( s8 PackID )
{
	MESSAGEPACK *MesP ;
	stSentence *Head ;
	GhmGcTexHeader *Tex ;
	
	// ̏
	MesP = &MsUnion.MesPack[PackID] ;
	Head = ( stSentence * )MesP->JmbData ;
	Tex = ( GhmGcTexHeader * )( ( u8 * )MesP->JmbData + Head->texOffset ) ;

	// I	
	return Tex ;
}
	

// bZ[W̃eNX`̗擾
extern s32 GetMessageStringUvInfo( s8 PackID, s8 MessageID, s8 LineNo,
									stFontParam **FontParamBuffer, u16 *CharIDBuf,
									MESSAGELINE *MesLine, MESSAGERUBI *RubiBuf )
{
	MESSAGEPACK *MesP ;
	stSentence *Head ;
	GhmGcTexHeader *Tex, *RubiTex ;
	stOneSentence *OneS ;
	stJimaku *Jimaku ;
	stFontParam *UvStart ;
	s32 StrLen, DrawStrLen ;
	stRubiDat *Rubi ;
	
	// ̏
	MesP = &MsUnion.MesPack[PackID] ;
	Head = ( stSentence * )MesP->JmbData ;
	OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + MessageID * sizeof( stOneSentence ) ) ;
	Jimaku = &OneS->jimaku[LineNo] ;
	RubiTex = gpJimaku->mGetRubiTexPtr() ;

	// 񂪖牽I
	if( (u16)Jimaku->chardat[0] == JIMAKU_NO_FONT ) return -1 ;
	
	UvStart = ( stFontParam * )( (u8 *)MesP->JmbData + Head->charOffset ) ;
	Tex = ( GhmGcTexHeader * )( ( u8 * )MesP->JmbData + Head->texOffset ) ;
	Rubi = Jimaku->rubidat ;
	
	if( RubiBuf != NULL )
	{
		RubiBuf->fromNum = -1 ;
		RubiBuf->toNum = -1 ;
	}
	
	// ̃p[^̏񋓂
	{
		DrawStrLen = 0 ;
		
		if( MesLine != NULL )
		{
			MesLine->Width = MesLine->Height = 0 ;
		}
		for( StrLen = 0 ; (u16)Jimaku->chardat[StrLen] != JIMAKU_RETURN ; StrLen ++ )
		{
			if( (u16)Jimaku->chardat[StrLen] == 0xfffe || 
				(u16)Jimaku->chardat[StrLen] == 0xfffd ||
				(u16)Jimaku->chardat[StrLen] == 0xfffc )
			{
				if( FontParamBuffer != NULL ) FontParamBuffer[StrLen] = FONT_NULLPOINT ;
				if( MesLine != NULL )
				{
					MesLine->Width += (s32)VParam[ED_MES_V2_2][2] ;
					MesLine->TexPos[StrLen] = FONT_NULLPOINT ;
				}
			}
			else
			{
				if( FontParamBuffer != NULL ) FontParamBuffer[StrLen] = UvStart + ( (u16)Jimaku->chardat[StrLen] & 0xfff ) ;
				if( MesLine != NULL )
				{
					MesLine->TexPos[StrLen] = UvStart + ( (u16)Jimaku->chardat[StrLen] & 0xfff ) ;
					if( MesLine->TexPos[StrLen]->h > MesLine->Height ) MesLine->Height = MesLine->TexPos[StrLen]->h ;
					MesLine->Width += (s32)MesLine->TexPos[StrLen]->w ;
				}
				DrawStrLen ++ ;
			}

			if( CharIDBuf != NULL )
			{
				CharIDBuf[StrLen] = 0 ;
			} 
		}
		if( FontParamBuffer != NULL ) FontParamBuffer[StrLen] = NULL ;
		if( MesLine != NULL ) MesLine->TexPos[StrLen] = NULL ;
	}
	
	// r
	if( FontParamBuffer != NULL && CharIDBuf != NULL )
	{
		s32 i, j ;

		for( i = 0 ; i < JIMAKU_RUBI_MAX && Rubi->charID[0] >= 0 ; i ++, Rubi ++ )
		{
			// }N𒲂ׂ
			if( Rubi->charID[0] == MES_MACRO )
			{
				// }N̏ꍇ͏
				switch( Rubi->charID[1] )
				{
				case MES_MACRO_ITEM :
					// ACȅꍇ
					{
						for( j = Rubi->fromNum ; j < Rubi->fromNum + Rubi->toNum ; j ++ )
						{
							if( FontParamBuffer[j] != FONT_NULLPOINT )
							{
								CharIDBuf[j] = CHARID_ITEM ;
							}
						}
					}
					break ;

				default :
					break ;
				}
			}
			else
			{
				// ȊȌꍇ̓f[^i[
				if( RubiBuf != NULL )
				{
					s16 *charID ;
					MESSAGEUV *uv ;
					
					RubiBuf->fromNum = Rubi->fromNum ;
					RubiBuf->toNum = Rubi->toNum ;
					uv = RubiBuf->CharUv ;
					RubiBuf->rNum = 0 ;
					GetMessageRubiTexData() ;
					for( charID = Rubi->charID ; *charID != -1 ; RubiBuf->rNum ++, charID ++, uv ++ )
					{
						uv->u = (f32)( ( *charID % JIMAKU_RUBI_W_NUM ) * JIMAKU_RUBI_W ) / (f32)MsUnion.RubiTex.Data.Header->mWidth ;
						uv->v = (f32)( ( *charID / JIMAKU_RUBI_W_NUM ) * JIMAKU_RUBI_H ) / (f32)MsUnion.RubiTex.Data.Header->mHeight ;
					}
				}
			}
			if( RubiBuf != NULL ) RubiBuf ++ ;
		}
		if( RubiBuf != NULL )
		{
			RubiBuf->fromNum = -1 ;
			RubiBuf->toNum = -1 ;
		}
	}

	if( MesLine != NULL )
	{
		MesLine->StrLen = StrLen ;
		MesLine->DrawStrLen = DrawStrLen ;
	}
		
	// Ԃ
	return StrLen ;
}




// bZ[W̕`掞̕擾
extern s32 GetMessageStringLength( s8 PackID, s8 MessageID, s8 LineNo )
{
//	stFontParam *ParamBuf[256] ;
	MESSAGELINE Line ;
//	s32 Width, i ;

	// 擾
	GetMessageStringUvInfo( PackID, MessageID, LineNo, NULL, NULL, &Line ) ;

	// Ŝ̕擾
/*	Width = 0 ;
	for( i = 0 ; ParamBuf[i] != NULL ; i ++ )
	{
		if( ParamBuf[i] == FONT_NULLPOINT )
		{
			Width += (s32)VParam[ED_MES_V2_2][2] ;
		}
		else
		{
			Width += ParamBuf[i]->w ;
		}
	}
*/

	// Ԃ
	return Line.Width ;
}

// bZ[W̕`掞̍擾
extern s32 GetMessageStringHeight( s8 PackID, s8 MessageID, s8 LineNo )
{
	MESSAGELINE Line ;

	// 擾
	GetMessageStringUvInfo( PackID, MessageID, LineNo, NULL, NULL, &Line ) ;

	// ̍Ԃ
	return Line.Height ;
}

// bZ[W̃eNX`IuWFNg擾
extern GXTexObj *GetMessageTexObj( s8 PackID )
{
	return &GetMessagePack( PackID )->TexObj ;
}

// bZ[W̃reNX`IuWFNg擾
extern TEXDATA *GetMessageRubiTexData( void )
{
	if( MsUnion.RubiTex.File != (ghmGcFile * )1 )
	{
		TEXTURE *Tex ;

		MsUnion.RubiTex.Data.Header = gpJimaku->mGetRubiTexPtr() ;
		Tex = &MsUnion.RubiTex.Data ;

		// eNX`쐬
		GXInitTexObj( &Tex->Obj, GHMGCTEX_GETIMAGE(Tex->Header),
						 Tex->Header->mWidth, Tex->Header->mHeight, Tex->Header->mFormat,
						  GX_CLAMP, GX_CLAMP, GX_FALSE ) ;
		GXInitTexObjLOD( &Tex->Obj, GX_LINEAR, GX_LINEAR,
							Tex->Header->mMinLOD, Tex->Header->mMaxLOD, 0.0F,
							GX_FALSE, GX_FALSE, GX_ANISO_1 ) ;
							
		MsUnion.RubiTex.File = (ghmGcFile * )1 ;
	}
	return &MsUnion.RubiTex ;
}


// ~Ԃ
extern u8 StopReleaseMessageEffect( EFFECT *Effect )
{
	MESSAGEEFFECT *Mes = ( MESSAGEEFFECT * )Effect->Data ;

	Mes->StopFlag = FALSE ;

	// I
	return 0 ;
}
	
// ~Ԃł邩ǂ擾( TRUE:~ FALSE: )
extern s8 GetStopStateMessageEffect( EFFECT *Effect )
{
	MESSAGEEFFECT *Mes = ( MESSAGEEFFECT * )Effect->Data ;
	
	// lԂ
	return (s8)( Mes->Mode == 7 ? TRUE : FALSE ) ;
}

// bZ[WɑΉACR̃eNX`Ԃ
extern GXTexObj *GetMessageIconTexObj( s8 PackID, s8 MessageID )
{
	MESSAGEPACK *MesP ;
	stSentence *Head ;
	stOneSentence *OneS ;
	stJimaku *Jimaku ;

	MesP = &MsUnion.MesPack[PackID] ;
	Head = ( stSentence * )MesP->JmbData ;
	OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + MessageID * sizeof( stOneSentence ) ) ;
	Jimaku = &OneS->jimaku[0] ;
	
	TEXDATA *Tem = &MsUnion.IconTexList[Jimaku->wait / TICKTIME] ;

	return &MsUnion.IconTexList[Jimaku->wait / TICKTIME].Data.Obj ;
}

// w̃bZ[WɑΉACR̃eNX`f[^擾
extern TEXDATA  *GetMessageIconTex( s8 PackID, s8 MessageID )
{
	MESSAGEPACK *MesP ;
	stSentence *Head ;
	stOneSentence *OneS ;
	stJimaku *Jimaku ;

	MesP = &MsUnion.MesPack[PackID] ;
	Head = ( stSentence * )MesP->JmbData ;
	OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + MessageID * sizeof( stOneSentence ) ) ;
	Jimaku = &OneS->jimaku[0] ;
	
	TEXDATA *Tem = &MsUnion.IconTexList[Jimaku->wait / TICKTIME] ;

	return &MsUnion.IconTexList[Jimaku->wait / TICKTIME] ;
}

// w̃bZ[WɑΉACR̔ԍ擾
extern s8 GetMessageIconNumber( s8 PackID, s8 MessageID )
{
	MESSAGEPACK *MesP ;
	stSentence *Head ;
	stOneSentence *OneS ;
	stJimaku *Jimaku ;

	MesP = &MsUnion.MesPack[PackID] ;
	Head = ( stSentence * )MesP->JmbData ;
	OneS = ( stOneSentence * )( ( u8 * )MesP->JmbData + Head->offset + MessageID * sizeof( stOneSentence ) ) ;
	Jimaku = &OneS->jimaku[0] ;
	
	TEXDATA *Tem = &MsUnion.IconTexList[Jimaku->wait / TICKTIME] ;

	return (s8)( Jimaku->wait / TICKTIME ) ;
}


// w̃ACRԍ̃ACReNX`f[^擾
extern TEXDATA	*GetMessageIconTex( s8 IconID )
{
	return &MsUnion.IconTexList[IconID] ;
}


// w̃ACRԍ̃ACReNX`擾
extern GXTexObj *GetMessageIconTexObj( s8 IconID )
{
	return &MsUnion.IconTexList[IconID].Data.Obj ;
}

