///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMoon
//
// YK7EffectMoon.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/23/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectMoon.h"

// define ---------------------------------------

#define MOON_FILENAME			"/Yam/Effect/Moon/Moon_"

// datatype -------------------------------------

// data -----------------------------------------

MOONUNION MonUnion ;

// function proto type --------------------------

s8 MoonTexLoadCheck( void ) ;				// [hǂ𒲂ׂ

// function code --------------------------------

// [hǂ𒲂ׂ
s8 MoonTexLoadCheck( void )
{
	s32 i ;
	
	for( i = 0 ; i < MOON_IMG_NUM ; i ++ )
	{
		if( TexLoadChk( &MonUnion.Moon[i] ) == FALSE ) return FALSE ;
	}
	
	// I
	return TRUE ;
}



// GtFNg̋ʃf[^
extern s8 InitMoonData( void )
{
	MEMINIT( MonUnion ) ;
	
/*	// eNX`ǂݍ
	{
		s32 i ;
		char FileName[64] ;
		
		for( i = 0 ; i < MOON_IMG_NUM ; i ++ )
		{
			sprintf( FileName, "%s%.2d.BIN", MOON_FILENAME, i ) ;
			TexLoadSet( FileName, &MonUnion.Moon[i] ) ;
		}
	}
*/
	// I
	return 0 ;
}

// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckMoonData( void )
{
	return TRUE ;
}



// GtFNg̋ʃf[^n
extern s8 EndMoonData( void )
{
	MEMINIT( MonUnion ) ;
	
	// eNX`
/*	{
		s32 i ;
		
		for( i = 0 ; i < MOON_IMG_NUM ; i ++ )
		{
			TexRelease( &MonUnion.Moon[i] ) ;
		}
	}
*/
	// I
	return 0 ;
}


// ̃GtFNg쐬
extern EFFECT *CreateMoonEffect( f32 CycleSpeed, s32 Priority )
{
	MOONEFFECT *Moon ;
	EFFECT *Effect ;
	
	// Vf[^쐬
	Effect = AddEffectData( EFF_MOON, (void**)&Moon, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// f[^
	Moon->Rate = 0.5F ;
	Moon->RateSpeed = CycleSpeed ;
	Moon->FlashFlag = FALSE ;	

	Moon->Mode = 0 ;
	Moon->DrawCounter = 0 ;

	Moon->RedPlaneAlpha = 0.0F ;
	Moon->RedPlaneAlphaCounter = 0 ;
	Moon->MoonAlpha = 0.0F ;
	Moon->MoonAlphaCounter = 0 ;

	Moon->DrawFlag = FALSE ;

	// I
	return Effect ;
}

// ̃GtFNǧns
extern s8 ReleaseMoonEffect( EFFECT *Effect )
{
	MOONEFFECT *Moon = ( MOONEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ
	return 0 ;
}

// ̃GtFNgPt[
extern s8 MoveMoonEffect( EFFECT *Effect )
{
	MOONEFFECT *Moon = ( MOONEFFECT * )Effect->Data ;

	if( (MOONEFFECT *)NULL == Moon ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( MoonTexLoadCheck() == FALSE ) return 0 ;
	
	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// `tOĂ邩ǂŏ𕪊
	if( Moon->DrawFlag == TRUE )
	{
		if( (s32)( Moon->Rate * MOON_IMG_NUM ) == 0 )
		{
			Moon->FlashFlag = TRUE ;
		}
		
		// ̃At@l̏
		if( Moon->MoonAlphaCounter == VParam[ED_MOON][2] )
		{
			Moon->MoonAlpha += (f32)VParam[ED_MOON][1] / 255.0F ;
			if( Moon->MoonAlpha > 1.0F ) Moon->MoonAlpha = 1.0F ;
		}
		else
		{
			Moon->MoonAlphaCounter ++ ;
		}
		
		// bhv[̃At@l̏
		{
			Moon->RedPlaneAlpha += (f32)VParam[ED_MOON][0] / 255.0F ;
			if( Moon->RedPlaneAlpha > 1.0F ) Moon->RedPlaneAlpha = 1.0F ;
		}
	}
	else
	{
		if( (s32)( Moon->Rate * MOON_IMG_NUM ) != 0 )
		{
			Moon->FlashFlag = FALSE ;
		}

		// ̃At@l̏
		{
			Moon->MoonAlpha -= (f32)VParam[ED_MOON][1] / 255.0F ;
			if( Moon->MoonAlpha < 0.0F ) Moon->MoonAlpha = 0.0F ;
		}
		
		// bhv[̃At@l̏
		if( Moon->RedPlaneAlphaCounter == VParam[ED_MOON][3] )
		{
			Moon->RedPlaneAlpha -= (f32)VParam[ED_MOON][3] / 255.0F ;
			if( Moon->RedPlaneAlpha < 0.0F ) Moon->RedPlaneAlpha = 0.0F ;
		}
		else
		{
			Moon->RedPlaneAlphaCounter ++ ;
		}
	}
	
	// I
	return 0 ;
}
	
// ̃GtFNg`悷
extern s8 DrawMoonEffect( EFFECT *Effect )
{
	MOONEFFECT *Moon = ( MOONEFFECT * )Effect->Data ;
	u32 color ;
 
	if( (MOONEFFECT *)NULL == Moon ) return 0 ;

	if( MoonTexLoadCheck() == FALSE ) return 0 ;

	// Ԗʂ̕`
	if( Moon->RedPlaneAlpha != 0.0F )
	{
		EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;

		color = CMK( VParam[ED_MOON][4], VParam[ED_MOON][5], VParam[ED_MOON][6], 255 * Moon->RedPlaneAlpha ) ;
		GBGN( GX_QUADS, 4 ) ;
		{
			GP2( 0, 	0 ) ;	GCX( color ) ;
			GP2( SCW, 	0 ) ;	GCX( color ) ;
			GP2( SCW, 	SCH ) ;	GCX( color ) ;
			GP2( 0, 	SCH ) ;	GCX( color ) ;
		}
		GXEnd() ;
	}
	
	// ̕`
	if( Moon->MoonAlpha != 0.0F )
	{
		EffectTevSetup( EF_TEV_USETEX ) ;
		DrawTex( 0, 0, &MonUnion.Moon[(s32)( Moon->Rate * MOON_IMG_NUM )], CMK2( 255, 255 * Moon->MoonAlpha ) ) ;
	}

	// I
	return 0 ;
}

// Zbg
extern s8 SetMoonEffectRate( f32 MoonRate, EFFECT *Effect )
{
	MOONEFFECT *Moon = ( MOONEFFECT * )Effect->Data ;
	
	Moon->Rate = fmod( MoonRate, 1.0F ) ;

	// I
	return 0 ;
}

// u\
extern s8 MoonEffectFlash( EFFECT *Effect )
{
	MOONEFFECT *Moon = ( MOONEFFECT * )Effect->Data ;
	
	Moon->DrawFlag = FALSE ;
	Moon->RedPlaneAlpha = 1.0F ;
	Moon->RedPlaneAlphaCounter = 0 ;
	Moon->MoonAlpha = 1.0F ;
	Moon->MoonAlphaCounter = 0 ;

	// I
	return 0 ;
}

// \邩ǂ̃tOZbg
extern s8 SetMoonEffectDrawFlag( s8 Flag, EFFECT *Effect )
{
	MOONEFFECT *Moon = ( MOONEFFECT * )Effect->Data ;
	
	Moon->DrawFlag = (u8)Flag ;
	
	// I
	return 0 ;
}


// ̃JE^i߂
extern s8 MoonEffectCycleProcess( EFFECT *Effect )
{
	MOONEFFECT *Moon = ( MOONEFFECT * )Effect->Data ;
	
	Moon->Rate = fmod( Moon->Rate + Moon->RateSpeed, 1.0F ) ;
	if( (s32)( Moon->Rate * MOON_IMG_NUM ) == 0 &&
		Moon->FlashFlag == FALSE &&
		Moon->DrawFlag == FALSE )
	{
		MoonEffectFlash( Effect ) ;
		Moon->FlashFlag = TRUE ;
	}

	// I
	return 0 ;
}

// ̖̑Zbg
extern s8 SetMoonEffectCycleSpped( f32 Speed, EFFECT *Effect )
{
	MOONEFFECT *Moon = ( MOONEFFECT * )Effect->Data ;
	
	Moon->RateSpeed = Speed ;

	// I
	return 0 ;
}

// ̃TCNZbg( 錎ɂ )
extern s8 MoonEffectCycleReset( EFFECT *Effect )
{
	MOONEFFECT *Moon = ( MOONEFFECT * )Effect->Data ;
	
	Moon->Rate = 0.5F ;

	// I
	return 0 ;
}
	
// ł邩ǂ擾( TRUE:  FALSE:ł͂Ȃ )
extern s8 GetMoonEffectFullMoonCheck( EFFECT *Effect )
{
	MOONEFFECT *Moon = ( MOONEFFECT * )Effect->Data ;
	
	// lԂ
	return (s8)( (s32)( Moon->Rate * MOON_IMG_NUM ) == 0 ? TRUE : FALSE ) ;
}



