///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectRope
//
// YK7EffectRope.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectRope.h"

// define ---------------------------------------

// data -----------------------------------------

ROPEUNION ropu ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// [vGtFNg̋ʃf[^
extern s8 InitRopeData( void )
{
	MEMINIT( ropu ) ;
	
	return 0 ;
}

// [vGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckRopeData( void )
{
	return TRUE ;
}

// [vGtFNg̋ʃf[^n
extern s8 EndRopeData( void )
{
	MEMINIT( ropu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// [vGtFNg쐬
extern EFFECT *CreateRopeEffect(	Vec *Pos1, Vec *Pos2,
									WK7JObj *JObj1, WK7JObj *JObj2,		// [v𒣂in
									s32 Priority )
{
	EFFECT *Effect ;
	ROPEEFFECT *bl ;
	
	if( ( Pos1 == NULL && JObj1 == NULL ) ||
		( Pos2 == NULL && JObj2 == NULL ) ) return NULL ;
	
	// V[vf[^쐬
	Effect = AddEffectData( EFF_ROPE, (void**)&bl, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// ̏
	if( Pos1 ) bl->Pos1 = *Pos1 ;
	if( Pos2 ) bl->Pos2 = *Pos2 ;
	bl->JObj1 = JObj1 ;
	bl->JObj2 = JObj2 ;

	// I
	return Effect ;
}

// [vGtFNǧns
extern s8 ReleaseRopeEffect( EFFECT *Effect )
{
	ROPEEFFECT *bl = ( ROPEEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// [vGtFNgPt[
extern s8 MoveRopeEffect( EFFECT *Effect )
{
	ROPEEFFECT *bl = ( ROPEEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// I
	return 0 ;
}

// [vGtFNg`悷
#define WIDTH	(0.05F)
#define COLOR	(0x404040ff)
extern s8 DrawRopeEffect( EFFECT *Effect )
{
	ROPEEFFECT *bl = ( ROPEEFFECT * )Effect->Data ;
	DIR3 axis ;
	Vec pos1, pos2, dir, tv ;
	
	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;
	
	if( bl->JObj1 == NULL ) pos1 = bl->Pos1 ;
	else GetJObjPos( bl->JObj1->GetJObj(), &pos1 ) ;

	if( bl->JObj2 == NULL ) pos2 = bl->Pos2 ;
	else GetJObjPos( bl->JObj2->GetJObj(), &pos2 ) ;

	VECSubtract( &pos2, &pos1, &dir ) ;
	GetDir3( dir, &axis ) ;

	GBGN( GX_QUADS, 8 ) ;
	{
		GetDirPos( &axis, &tv, -WIDTH, 0.0F, 0.0F ) ;		GPV3( tv, pos2 ) ;	GCX( COLOR ) ;
		GetDirPos( &axis, &tv, +WIDTH, 0.0F, 0.0F ) ;		GPV3( tv, pos2 ) ;	GCX( COLOR ) ;
		GetDirPos( &axis, &tv, +WIDTH, 0.0F, 0.0F ) ;		GPV3( tv, pos1 ) ;	GCX( COLOR ) ;
		GetDirPos( &axis, &tv, -WIDTH, 0.0F, 0.0F ) ;		GPV3( tv, pos1 ) ;	GCX( COLOR ) ;

		GetDirPos( &axis, &tv, 0.0F, -WIDTH, 0.0F ) ;		GPV3( tv, pos2 ) ;	GCX( COLOR ) ;
		GetDirPos( &axis, &tv, 0.0F, +WIDTH, 0.0F ) ;		GPV3( tv, pos2 ) ;	GCX( COLOR ) ;
		GetDirPos( &axis, &tv, 0.0F, +WIDTH, 0.0F ) ;		GPV3( tv, pos1 ) ;	GCX( COLOR ) ;
		GetDirPos( &axis, &tv, 0.0F, -WIDTH, 0.0F ) ;		GPV3( tv, pos1 ) ;	GCX( COLOR ) ;
	}
	GEND() ;

	// I
	return 0 ;
}

