///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSkillExe
//
// YK7EffectSkillExe.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 08/30/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSKILLEXE_H
#define __YK7EFFECTSKILLEXE_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// \͔GtFNgʃf[^
typedef struct tagSKILLEXEUNION
{
	u8 Dummy ;
} SKILLEXEUNION ;

// \͔GtFNgf[^
typedef struct tagSKILLEXEEFFECT
{
	u8 Type ;				// ^Cv
	Vec Point ;				// ̒SW

	f32 Wait ;				// ̔g܂ł̑҂
	f32 WaitSub ;			// ̔g܂ł̑҂Ԃ̌
	f32 WaitCounter ;		// ҂ԃJE^
	
	f32 Speed ;				// Xs[h
	f32 AddSpeed ;			// 񂲂ƂɑXs[h̊

	u8 Num ;				// 
	u8 NumCounter ;			// 񐔃JE^
} SKILLEXEEFFECT ;

// \͔GtFNgf[^p\
typedef struct tagSKILLEXEEFFECTTASKPARAM
{
	Vec Point ;				// ̒SW
	u8 Type ;				// GtFNg̃^Cv
} SKILLEXEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitSkillExeData( void ) ;			// \͔GtFNg̋ʃf[^
extern s8 CheckSkillExeData( void ) ;			// \͔GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSkillExeData( void ) ;				// \͔GtFNg̋ʃf[^n

extern EFFECT *CreateSkillExeEffect( Vec Point, u8 Type, s32 Priority = 2000 ) ;	// \͔GtFNg쐬
extern s8 ReleaseSkillExeEffect( EFFECT *Effect ) ;						// \͔GtFNǧns
extern s8 MoveSkillExeEffect( EFFECT *Effect ) ;						// \͔GtFNgPt[
extern s8 DrawSkillExeEffect( EFFECT *Effect ) ;						// \͔GtFNg`悷

#endif