///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSkillExe2
//
// YK7EffectSkillExe2.cpp
//
// Creator	   : Takumi Yamada (GHM)
// Creation Date : 12/09/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectSkillExe2.h"
#include "./YK7EffectScreen.h"
#include "../matsu/mk7Sound.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

SKILLEXE2UNION Sk2Union ;

// function proto type --------------------------

// function code --------------------------------

// \͔QGtFNg̋ʃf[^
extern s8 InitSkillExe2Data( void )
{
	MEMINIT( Sk2Union ) ;
	
	// I
	return 0 ;
}

// \͔QGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSkillExe2Data( void )
{
	return TRUE ;
}

// \͔QGtFNg̋ʃf[^n
extern s8 EndSkillExe2Data( void )
{
	MEMINIT( Sk2Union ) ;

	// I
	return 0 ;
}

// \͔QGtFNg쐬
extern EFFECT *CreateSkillExe2Effect( s32 Priority )
{
	SKILLEXE2EFFECT *Skx2 ;
	EFFECT *Effect, *Screen ;

	// ʃGtFNg쐬
	Screen = CreateScreenEffect() ;
	if( Screen == NULL ) return NULL ;
	SetScreenEffectDrawFlag( Screen, TRUE ) ;
	SetScreenEffectAlpha( Screen, 0.0F ) ;
	SetScreenEffectExRate( Screen, 1.0F ) ;
	SetScreenEffectAddFlag( Screen, TRUE ) ;

	// V\͔Qf[^쐬
	Effect = AddEffectData( EFF_SKILLEXE2, (void**)&Skx2, Priority ) ;
	if( Effect == NULL )
	{
		DeleteEffect( Screen ) ;
		return NULL ;
	}

	// ۑ
	Skx2->Mode = 0 ;
	Skx2->ScreenEffect = Screen ;
	Skx2->ExRate = 0.0F ;
	Skx2->Alpha = 0.0F ;
	Skx2->ScreenEffectID = GetEffectID( Screen ) ;

	// I
	return Effect ;
}

// \͔Q̃GtFNǧns
extern s8 ReleaseSkillExe2Effect( EFFECT *Effect )
{
	SKILLEXE2EFFECT *Skx2 = ( SKILLEXE2EFFECT * )Effect->Data ;

	// XN[GtFNg폜
	if( CheckEffectValidState( Skx2->ScreenEffect, Skx2->ScreenEffectID ) == TRUE )
	{
		DeleteEffect( Skx2->ScreenEffect ) ;
	}

	// I
	return 0 ;
}

// \͔Q̃GtFNgPt[
extern s8 MoveSkillExe2Effect( EFFECT *Effect )
{
	SKILLEXE2EFFECT *Skx2 = ( SKILLEXE2EFFECT * )Effect->Data ;

	if( Effect->DelReqFlag == TRUE && CheckEffectValidState( Skx2->ScreenEffect, Skx2->ScreenEffectID ) == FALSE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	switch( Skx2->Mode )
	{
	case 0 :
		{
			if( Skx2->ExRate < VParam[ED_SCREEN][5] * 0.01F )
			{
				Skx2->ExRate += VParam[ED_SCREEN][4] * 0.0003F ;
				if( Skx2->ExRate >= VParam[ED_SCREEN][5] * 0.01F )
				{
					Skx2->ExRate = VParam[ED_SCREEN][5] * 0.01F ;
				}
			}
			if( Skx2->Alpha < VParam[ED_SCREEN][7] / 255.0F )
			{
				Skx2->Alpha += VParam[ED_SCREEN][6] / 255.0F ;
				if( Skx2->Alpha >= VParam[ED_SCREEN][7] / 255.0F )
				{
					Skx2->Alpha = VParam[ED_SCREEN][7] / 255.0F ;
				}
			}
			SetScreenEffectAddFlag( Skx2->ScreenEffect, TRUE ) ;
			SetScreenEffectAlpha( Skx2->ScreenEffect, Skx2->Alpha ) ;
			SetScreenEffectExRate( Skx2->ScreenEffect, Skx2->ExRate + 1.0F ) ;
		}
		break ;
		
	case 1 :
		{
			Skx2->ExRate = VParam[ED_SCREEN][9] * 0.01F ;
			Skx2->Alpha = VParam[ED_SCREEN][8] / 255.0F ;

			SetScreenEffectAddFlag( Skx2->ScreenEffect, FALSE ) ;
			SetScreenEffectAlpha( Skx2->ScreenEffect, Skx2->Alpha ) ;
			SetScreenEffectExRate( Skx2->ScreenEffect, Skx2->ExRate + 1.0F ) ;
		}
		break ;
	}

	// I
	return 0 ;
}
			


// \͔Q̃GtFNg`悷
extern s8 DrawSkillExe2Effect( EFFECT *Effect )
{
	SKILLEXE2EFFECT *Skx2 = ( SKILLEXE2EFFECT * )Effect->Data ;
	
	// I
	return 0 ;
}


// 폜NGXgs
extern s8 DelReqSkillExe2Effect( EFFECT *Effect )
{
	SKILLEXE2EFFECT *Skx2 = ( SKILLEXE2EFFECT * )Effect->Data ;

	DelReqEffect( Skx2->ScreenEffect ) ;
//	Effect->DelReqFlag = TRUE ;
	
	// I
	return 0 ;
}
	
// 샂[hύX( 0:ヂ[h  1:[h )
extern s8 SetSkillExe2EffectMode( EFFECT *Effect, s8 Mode )
{
	SKILLEXE2EFFECT *Skx2 = ( SKILLEXE2EFFECT * )Effect->Data ;

	Skx2->Mode = Mode ;
	
	// I
	return 0 ;
}

