///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSmoke
//
// YK7EffectSmoke.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/16/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSMOKE_H
#define __YK7EFFECTSMOKE_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// GtFNgʃf[^
typedef struct tagSMOKEUNION
{
	TEXDATA SmokeTexAlpha ;		// ̃At@eNX`f[^
	TEXTURE SmokeTexRgb ;		// ̂qfaeNX`f[^
	ghmGcFile *TexFileRgb ;		// ̂qfaeNX`p ghmGcFile
	
	bool AlphaX4Flag ;			// At@l x4 tO
} SMOKEUNION ;

// IuWFNgf[^
typedef struct tagSMOKEOBJECT
{
	u8 Mode ;					// `惂[h(0:Add  1:Alpha)
	u8 Alpha, Alpha2 ;			// At@l
	Vec Point ;					// W
	Vec Direction ;				// 
	f32 Power ;					// łXs[h
	f32 SubPower ;				// x
	s16 LifeTime, Counter ;		// ݂Ăc莞
	s16 Counter2 ;				// ݂Ăc莞
	f32 XSize, YSize ;			// r{[h̏cƉ̃TCY
	f32 Rotate, RotSpeed ;		// ݂̉]pxƉ]x
	u8 RotDirection ;			// ]
	f32 ColorRatio[3] ;			// F̕ϓx
} SMOKEOBJECT ;

// GtFNgf[^
typedef struct tagSMOKEEFFECT
{
	SMOKEOBJECT *ObjP ;				// IuWFNgf[^zւ̃|C^
	u8 Mode ;						// 0:Direction̕ɉro
									// 1:grp[h
	Vec Point ;						// GtFNg郏[hW
	f32 Power ;						// röЗ
	f32 HPower ;					// ɑ΂锚(5)(Mode:1̂Ƃ̂ݗL)
	f32 VPower ;					// ɑ΂锚(3)(Mode:1̂Ƃ̂ݗL)
	f32 ResistPower ;				// CR̋
	u16 SmokeNum ;					// ̐
	u16 PhaseSmoke2Num ;			// At@uhɈڍs̐
	Vec Direction ;					// (Mode:0̂Ƃ̂ݗL)
	f32 DirectionRange ;			// ̂Ԃꕝ(Mode:0̂Ƃ̂ݗL)
	f32 MaxRotSpeed, MinRotSpeed ;	// ]x̍őlƍŏl
	f32 MaxXSize, MinXSize ;		// ̕ƍ̍őTCYƍŏTCY
	f32 MaxYSize, MinYSize ;
	u16 MaxLifeTime, MinLifeTime ;	// ݂Ăő厞Ԃƍŏ
	f32 AreaSize ;					// Ԃ̃TCY(0ŎZo)
	GXColor Color1, Color2, Color3;	// ̐FAPF[̐F QFS̐F RFE[̐F
	u8 SmokeAlpha ;					// ̃x[XAt@l
	f32 MaxOir, MinOir ;			// őIC[pƍŏIC[p(-/2 ` /2)
	
	u32 Counter ;					// JE^[
	u8 AddBlendFlag ;				// ZuhtO
	f32 MoveArea ;					// ł͈(1.0F:ő򋗗`O̊  0.5F:ő򋗗`ő򋗗w0.5܂ł̊)

	u8 AddBlendPhase2Flag ;			// At@llɒBAFQ̃At@uhɈڍs邩tO
	u8 PhaseMoveAlpha ;				// ZuhAt@uhɏڍsAt@臒l
	GXColor Color21, Color22, Color23;	// ̐FAPF[̐F QFS̐F RFE[̐F

	f32 LowSpeed ;					// ȏ͒xȂȂƂXs[h
	bool AlphaX4Flag ;				// At@l x4 tO
} SMOKEEFFECT ;

// GtFNg^XNɓnf[^
typedef struct tagSMOKEEFFECTTACKPARAM
{
	u8 Mode ;						// 0:Direction̕ɉro
									// 1:grp[h
	Vec Point ;						// GtFNg郏[hW
	f32 Power ;						// röЗ(Mode:0̂Ƃ̂ݗL)
	f32 HPower ;					// ɑ΂锚(5)(Mode:1̂Ƃ̂ݗL)
	f32 VPower ;					// ɑ΂锚(3)(Mode:1̂Ƃ̂ݗL)
	f32 ResistPower ;				// CR̋
	u16 SmokeNum ;					// ̐
	Vec Direction ;					// (Mode:0̂Ƃ̂ݗL)
	f32 DirectionRange ;			// ̂Ԃꕝ(Mode:0̂Ƃ̂ݗL)
	f32 MaxRotSpeed, MinRotSpeed ;	// ]x̍őlƍŏl
	f32 MaxXSize, MinXSize ;		// ̕ƍ̍őTCYƍŏTCY
	f32 MaxYSize, MinYSize ;
	u16 MaxLifeTime, MinLifeTime ;	// ݂Ăő厞Ԃƍŏ
	f32 AreaSize ;					// Ԃ̃TCY
	GXColor Color1, Color2, Color3;	// ̐FAPF[̐F QFS̐F RFE[̐F
	u8 SmokeAlpha ;					// ̃x[XAt@l
	f32 MaxOir, MinOir ;			// őIC[pƍŏIC[p(-/2 ` /2)( Mode:1 ̎̂ݗL )
	u8 AddBlendFlag ;				// ZuhtO
	u8 StopTime ;					// ~܂܂ł̎
	f32 MoveArea ;					// ł͈(1.0F:ő򋗗`O̊  0.5F:ő򋗗`ő򋗗w0.5܂ł̊)

	u8 AddBlendPhase2Flag ;			// At@llɒBAFQ̃At@uhɈڍs邩tO
	u8 PhaseMoveAlpha ;				// ZuhAt@uhɏڍsAt@臒l
	GXColor Color21, Color22, Color23;	// ̐FAPF[̐F QFS̐F RFE[̐F
	
	f32 LowSpeed ;					// ȏ͒xȂȂƂXs[h
} SMOKEEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitSmokeData( void ) ;				// GtFNg̋ʃf[^
extern s8 CheckSmokeData( void ) ;				// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSmokeData( void ) ;				// GtFNg̋ʃf[^n

extern EFFECT *CreateSmokeEffect( u8 Mode,
									Vec Point,
									 f32 Power,
									 f32 HPower, f32 VPower,
									 f32 ResistPower/*gp*/,
									 u16 SmokeNum,
									 Vec Direction, 	f32 DirectionRange,
									 f32 MaxRotSpeed, 	f32 MinRotSpeed,
									 f32 MaxXSize, 		f32 MinXSize, 
									 f32 MaxYSize, 		f32 MinYSize,
									 u16 MaxLifeTime, 	u16 MinLifeTime,
									 f32 AreaSize,
									 GXColor Color1, GXColor Color2, GXColor Color3, u8 SmokeAlpha,
									 f32 MaxOir, f32 MinOir,
									 u8 AddBlendFlag,
									 u8 StopTime,
									 f32 MoveArea,
									 u8 AddBlendPhase2Flag/*FALSE*/, u8 PhaseMoveAlpha/*0 łnj*/,
									 GXColor Color21, GXColor Color22, GXColor Color23,
									 f32 LowSpeed,
									 s32 Priority = -130 ) ;				// ̃GtFNg쐬
extern s8 ReleaseSmokeEffect( EFFECT *Effect ) ;							// ̃GtFNǧns
extern s8 MoveSmokeEffect( EFFECT *Effect ) ;								// ̃GtFNgPt[
extern s8 DrawSmokeEffect( EFFECT *Effect ) ;								// ̃GtFNg`悷

extern GXTexObj *GetSmokeTex( void ) ;										// ̃eNX`擾
extern s8 SetSmokeAlphaX4Flag( void ) ;										// ̃eNX``悷ۂɃ X4 ŕ`ǂ̃tOZbg

#endif
