///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSmoke2
//
// YK7EffectSmoke2.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/09/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSMOKE2_H
#define __YK7EFFECTSMOKE2_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// QGtFNgʃf[^
typedef struct tagSMOKE2UNION
{
	u8 dummy ;
} SMOKE2UNION ;

// QGtFNgIuWFNgf[^
typedef struct tagSMOKE2OBJECT
{
	u8 vflag ;		// LtO

	Vec pos ;
	Vec speed ;
	f32 alpha ;
	f32 maxalpha ;
	
	u32 color ;
	
	f32 downalphaspeed ;
	f32 upalphaspeed ;
	
	u8 maxalphaflag ;
} SMOKE2OBJECT ;

// QGtFNgf[^
typedef struct tagSMOKE2EFFECT
{
	Vec pos ;

	SMOKE2OBJECT *obj ;
	s32 num ;
	s32 maxnum ;
	
	f32 maxalphacon ;

	f32 yspeed ;
	f32 xspeed ;
	f32 rot1, rot2 ;
	f32 rot1sp, rot2sp ;

	f32 crerate ;
	f32 crecounter ;
	
	f32 size ;

	f32 maxalpha ;
	f32 upalphaspeed ;
	f32 downalphaspeed ;
	
	f32 alpha ;
	
	s32 dietime ;
	s32 diecounter ;
	
	u32 color ;
	f32 createarea ;
} SMOKE2EFFECT ;

// prototype ------------------------------------

extern s8 InitSmoke2Data( void ) ;			// QGtFNg̋ʃf[^
extern s8 CheckSmoke2Data( void ) ;			// QGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSmoke2Data( void ) ;			// QGtFNg̋ʃf[^n

extern EFFECT *CreateSmoke2Effect(
								Vec pos,				// W
								s32 maxnum,				// IuWFNg̍ő吔

								f32 yspeed,				// ㏸x
								f32 xspeed,				// ɐiޑ
								f32 rot1sp, f32 rot2sp,	// x

								f32 crerate,			// 쐬x
								
								f32 size,				// PIuWFNg̃TCY

								f32 maxalpha,			// ő̃At@l
								f32 upalphaspeed,		// At@l㏸鑬x
								f32 downalphaspeed,		// At@l~鑬x

								u32 color,				// F
								f32 createarea,			// 쐬͈

								s32 dietime,			// GtFNĝ܂ł̎
								s32 Priority = -1 ) ;			// QGtFNg쐬

extern s8 ReleaseSmoke2Effect( EFFECT *Effect ) ;				// QGtFNǧns
extern s8 MoveSmoke2Effect( EFFECT *Effect ) ;				// QGtFNgPt[
extern s8 DrawSmoke2Effect( EFFECT *Effect ) ;				// QGtFNg`悷

extern s8 SetSmoke2EffectPos( EFFECT *Effect, Vec pos ) ;	// QGtFNg𔭐WύX

#endif

