///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSmokeObj
//
// YK7EffectSmokeObj.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/31/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectSmokeObj.h"
#include "./YK7File.h"
#include "./YK7EffectSmoke.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_SMOKEOBJ]


// data -----------------------------------------

SMOKEOBJUNION sbu ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// IuWFNgGtFNg̋ʃf[^
extern s8 InitSmokeObjData( void )
{
	MEMINIT( sbu ) ;

	return 0 ;
}

// IuWFNgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSmokeObjData( void )
{
	return TRUE ;
}

// IuWFNgGtFNg̋ʃf[^n
extern s8 EndSmokeObjData( void )
{
	MEMINIT( sbu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}



// IuWFNgGtFNg쐬
extern EFFECT *CreateSmokeObjEffect(
								s32 maxnum,				// ő吔

								Vec pos,				// ʒu
								f32 area,				// TCY
								u32 color,				// F

//								f32 maxsize, minsize ;	// őTCYƍŏTCY
								f32 size,				// TCY
								f32 maxspeed, f32 minspeed,	// ő呬xŏx
								f32 maxupalphaspeed, f32 minupalphaspeed, 		// ㏸ő僿xƍŏx
								f32 maxdownalphaspeed, f32 mindownalphaspeed,	// ~ő僿xƍŏx
								f32 maxalpha,			// őAt@l
								f32 createrate,			// 쐬[g
								bool postype, 			// W^Cv(true:΍W  false:΍W)
								s32 dietime,			// S
								s32 Priority )
{
	EFFECT *Effect ;
	SMOKEOBJEFFECT *sb ;
	SMOKEOBJOBJECT *ob ;
	
	ob = ( SMOKEOBJOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( SMOKEOBJOBJECT ) * maxnum ), "Y_SMOOB" ) ;
	if( ob == NULL ) return NULL ;
	memset( ob, 0, sizeof( SMOKEOBJOBJECT ) * maxnum ) ;

	// VIuWFNgf[^쐬
	Effect = AddEffectData( EFF_SMOKEOBJ, (void**)&sb, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( ob ) ;
		return NULL ;
	}
	
	// lۑ
	sb->obj			= ob ;
	sb->num			= 0 ;
	sb->maxnum		= maxnum ;
	
	sb->pos 				= pos ;
	sb->area 				= area ;
	sb->color 				= color ;
	sb->size 				= size ;
	sb->maxspeed 			= maxspeed ;
	sb->minspeed 			= minspeed ;
	sb->maxupalphaspeed		= maxupalphaspeed ;
	sb->minupalphaspeed 	= minupalphaspeed ;
	sb->maxdownalphaspeed 	= maxdownalphaspeed ;
	sb->mindownalphaspeed 	= mindownalphaspeed ;
	sb->maxalpha			= maxalpha ;
	sb->crerate 			= createrate ;
	sb->crecounter			= 0.0F ;
	sb->postype				= postype ;
	sb->dietime				= dietime ;
	sb->diecounter			= 0 ;

	// I
	return Effect ;
}

// IuWFNgGtFNǧns
extern s8 ReleaseSmokeObjEffect( EFFECT *Effect )
{
	SMOKEOBJEFFECT *sb = ( SMOKEOBJEFFECT * )Effect->Data ;
	
	if( sb->obj != NULL ) K7AppSmallMemFree( sb->obj ) ;

	// I
	return 0 ;
}

// IuWFNgGtFNgPt[
extern s8 MoveSmokeObjEffect( EFFECT *Effect )
{
	SMOKEOBJEFFECT *sb = ( SMOKEOBJEFFECT * )Effect->Data ;
	SMOKEOBJOBJECT *ob ;
	s32 i, num ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE && sb->num == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	if( Effect->DelReqFlag == FALSE && sb->dietime != -1 )
	{
		sb->diecounter ++ ;
		if( sb->dietime <= sb->diecounter )
		{
			DelReqEffect( Effect ) ;
		}
	}

	// S̃IuWFNg
	num = sb->num ;
	ob = sb->obj ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->vflag == FALSE ) continue ;
		
		i ++ ;
		
		ob->pos.x += ob->speed.x ;
		ob->pos.y += ob->speed.y ;
		ob->pos.z += ob->speed.z ;
		
		if( ob->maxalphaflag == TRUE )
		{
			ob->alpha -= ob->downalphasp ;
			if( ob->alpha <= 0.0F )
			{
				ob->vflag = FALSE ;
				sb->num -- ;
			}
		}
		else
		{
			ob->alpha += ob->upalphasp ;
			if( ob->alpha >= sb->maxalpha )
			{
				ob->maxalphaflag = TRUE ;
			}
		}
	}
	
	// IuWFNg̒ǉ
	if( Effect->DelReqFlag == FALSE && sb->num < sb->maxnum )
	{
		sb->crecounter += 1.0F ;
		while( sb->crecounter >= sb->crerate && sb->num < sb->maxnum )
		{
			sb->crecounter -= sb->crerate ;
			sb->num ++ ;
		
			for( ob = sb->obj ; ob->vflag ; ob ++ ){}
			
			// f[^
			ob->vflag = TRUE ;
			{
				f32 f ;
				
				GetDirVec( &ob->pos, GetRandFNum( PI ) - PI / 2.0F, GetRandFNum( PI_2 ) ) ;
				f = GetRandFNum( sb->area ) ;
				if( sb->postype == true )
				{
					ob->pos.x = ob->pos.x * f + sb->pos.x ;
					ob->pos.y = ob->pos.y * f + sb->pos.y ;
					ob->pos.z = ob->pos.z * f + sb->pos.z ;
				}
				else
				{
					ob->pos.x = ob->pos.x * f ;
					ob->pos.y = ob->pos.y * f ;
					ob->pos.z = ob->pos.z * f ;
				}
				f = GetRandF2Num( sb->maxspeed, sb->minspeed ) ;
				GetDirVec( &ob->speed, GetRandFNum( PI ) - PI / 2.0F, GetRandFNum( PI_2 ) ) ;
				ob->speed.x *= f ;		ob->speed.y *= f ;		ob->speed.z *= f ;
			}
			ob->alpha = 0.0F ;
			ob->maxalphaflag = FALSE ;
			ob->upalphasp = GetRandF2Num( sb->maxupalphaspeed, sb->minupalphaspeed ) ;
			ob->downalphasp = GetRandF2Num( sb->maxdownalphaspeed, sb->mindownalphaspeed ) ;
		}
	}

	// I
	return 0 ;
}

// IuWFNgGtFNg`悷
extern s8 DrawSmokeObjEffect( EFFECT *Effect )
{
	SMOKEOBJEFFECT *sb = ( SMOKEOBJEFFECT * )Effect->Data ;
	SMOKEOBJOBJECT *ob ;
	Mtx mt ;
	Vec tv[4] ;
	u32 cr ;
	s32 i ;

	// `̏
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX, TRUE ) ;
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_2, GX_TRUE, GX_TEVPREV ) ;

	// eNX`̃[h
	GTLOAD( GetSmokeTex() ) ;

	// ts̎擾
	EffectGetInvViewMatrix( mt ) ;

	// _̏
	CreateBillVert( mt, tv, sb->size, sb->size ) ;

	// `揈
	if( sb->num == 0 ) return 0 ;
	GBGN( GX_QUADS, sb->num * 4 ) ;
	{
		if( sb->postype == true )
		{
			// ΍W
			ob = sb->obj ;
			for( i = 0 ; i < sb->num ; ob ++ )
			{
				if( ob->vflag == FALSE ) continue ;
				
				i ++ ;

				cr = CMKC2( sb->color, ob->alpha > 1.0F ? ( sb->color & 0xff ) : ob->alpha * ( sb->color & 0xff ) ) ;
				GPV3( ob->pos, tv[0] ) ;	GCX( cr ) ;		GT( 0.0F, 0.0F ) ;
				GPV3( ob->pos, tv[1] ) ;	GCX( cr ) ;		GT( 1.0F, 0.0F ) ;
				GPV3( ob->pos, tv[2] ) ;	GCX( cr ) ;		GT( 1.0F, 1.0F ) ;
				GPV3( ob->pos, tv[3] ) ;	GCX( cr ) ;		GT( 0.0F, 1.0F ) ;
			}
		}
		else
		{
			f32 x, y, z ;
		
			// ΍W
			ob = sb->obj ;
			x = sb->pos.x ;	y = sb->pos.y ;	z = sb->pos.z ;
			for( i = 0 ; i < sb->num ; ob ++ )
			{
				if( ob->vflag == FALSE ) continue ;
				
				i ++ ;

				cr = CMKC2( sb->color, ob->alpha > 1.0F ? ( sb->color & 0xff ) : ob->alpha * ( sb->color & 0xff ) ) ;
				GP3( ob->pos.x + x + tv[0].x, ob->pos.y + y + tv[0].y, ob->pos.z + z + tv[0].z ) ;	GCX( cr ) ;		GT( 0.0F, 0.0F ) ;
				GP3( ob->pos.x + x + tv[1].x, ob->pos.y + y + tv[1].y, ob->pos.z + z + tv[1].z ) ;	GCX( cr ) ;		GT( 1.0F, 0.0F ) ;
				GP3( ob->pos.x + x + tv[2].x, ob->pos.y + y + tv[2].y, ob->pos.z + z + tv[2].z ) ;	GCX( cr ) ;		GT( 1.0F, 1.0F ) ;
				GP3( ob->pos.x + x + tv[3].x, ob->pos.y + y + tv[3].y, ob->pos.z + z + tv[3].z ) ;	GCX( cr ) ;		GT( 0.0F, 1.0F ) ;
			}
		}
	}
	GEND() ;

	// I
	return 0 ;
}

const u16 _SBTable[][20] =
{
	{	// 
		100, 10, 128, 0, 0,
		255, 35, 68, 30, 30,

		10, 10, 8, 10, 20,
		0, 0,
	},

	{	// 
		100, 3, 128, 0, 0,
		255, 35, 68, 30, 30,

		10, 10, 8, 10, 20,
		0, 0,
	},
} ;


// IuWFNgGtFNg쐬
extern EFFECT *CreateSmokeObjEffect(
								u8 type, Vec pos,
								s32 dietime,				// S
								s32 Priority )
{
	if( type < 2 )
	{
#ifdef	YAMADADEBUG
		OSReport( "	{\n" ) ;
		OSReport( "		%d, %d, %d, %d, %d,\n", PRM[0], PRM[1], PRM[2], PRM[3], PRM[4] ) ;
		OSReport( "		%d, %d, %d, %d, %d,\n", PRM[5], PRM[6], PRM[7], PRM[8], PRM[9] ) ;
		OSReport( "\n" ) ;
		OSReport( "		%d, %d, %d, %d, %d,\n", PRM[10], PRM[11], PRM[12], PRM[13], PRM[14] ) ;
		OSReport( "		%d, %d,\n", PRM[15], PRM[16] ) ;
		OSReport( "	},\n" ) ;
#endif
	
		if( type == 0 )
			return CreateSmokeObjEffect(
									PRM[0] * 10,				// ő吔
									
									pos,				// ʒu
									PRM[1] * 1.0F,			// TCY
									CMK( PRM[2],PRM[3],PRM[4],PRM[5] ),				// F
									
								//	f32 maxsize, minsize ;	// őTCYƍŏTCY
									PRM[6] * 0.1F,				// TCY
									PRM[7] * 0.01F, PRM[8] * 0.01F,	// ő呬xŏx
									PRM[9] * 0.01F, PRM[10] * 0.01F, 		// ㏸ő僿xƍŏx
									PRM[11] * 0.01F, PRM[12] * 0.01F,	// ~ő僿xƍŏx
									PRM[13] * 0.1F,			// őAt@l
									1.0F / PRM[14],			// 쐬[g
									(bool)false,			// W^Cv
									dietime, 
									Priority ) ;			// IuWFNgGtFNg쐬
		else
			return CreateSmokeObjEffect(
									PRM[0] * 10,				// ő吔
									
									pos,				// ʒu
									PRM[1] * 1.0F,			// TCY
									CMK( PRM[2],PRM[3],PRM[4],PRM[5] ),				// F
									
								//	f32 maxsize, minsize ;	// őTCYƍŏTCY
									PRM[6] * 0.1F,				// TCY
									PRM[7] * 0.01F, PRM[8] * 0.01F,	// ő呬xŏx
									PRM[9] * 0.01F, PRM[10] * 0.01F, 		// ㏸ő僿xƍŏx
									PRM[11] * 0.01F, PRM[12] * 0.01F,	// ~ő僿xƍŏx
									PRM[13] * 0.1F,			// őAt@l
									1.0F / PRM[14],			// 쐬[g
									(bool)true,			// W^Cv
									dietime,
									Priority ) ;			// IuWFNgGtFNg쐬
	}
	else
	{
		type -= 2 ;

		return CreateSmokeObjEffect(
								_SBTable[type][0] * 10,				// ő吔
								
								pos,				// ʒu
								_SBTable[type][1] * 1.0F,			// TCY
								CMK( _SBTable[type][2],_SBTable[type][3],_SBTable[type][4],_SBTable[type][5] ),				// F
								
							//	f32 maxsize, minsize ;	// őTCYƍŏTCY
								_SBTable[type][6] * 0.1F,				// TCY
								_SBTable[type][7] * 0.01F, _SBTable[type][8] * 0.01F,	// ő呬xŏx
								_SBTable[type][9] * 0.01F, _SBTable[type][10] * 0.01F, 		// ㏸ő僿xƍŏx
								_SBTable[type][11] * 0.01F, _SBTable[type][12] * 0.01F,	// ~ő僿xƍŏx
								_SBTable[type][13] * 0.1F,			// őAt@l
								1.0F / _SBTable[type][14],			// 쐬[g
								(bool)true,			// W^Cv
								dietime,
								
								Priority ) ;			// IuWFNgGtFNg쐬
	}
	
	return NULL ;
}


// IuWFNgGtFNg̔WύX
extern s8 SetSmokeObjEffectPos( EFFECT *Effect, Vec pos )
{
	SMOKEOBJEFFECT *sb = ( SMOKEOBJEFFECT * )Effect->Data ;
	
	sb->pos = pos ;

	// I
	return 0 ;	
}


