///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSpSkillGage
//
// YK7EffectSpSkillGage.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 08/21/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSPSKILLGAGE_H
#define __YK7EFFECTSPSKILLGAGE_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define LINE_DIVNUM		40			// C̕
#define SIN_NUM			10

enum
{
	GAGE_SAERCH = 0,
	GAGE_RELEASE = 1,
} ;

// datatype -------------------------------------

// XLQ[Wʃf[^
typedef struct tagSPSKILLGAGEUNION
{
	TEXDATA SaerchTex ;				// wSaerchx̃eNX`f[^
	TEXDATA ReleaseTex ;			// wReleasexeNX`f[^
} SPSKILLGAGEUNION ;

// XLQ[Wf[^
typedef struct tagSPSKILLGAGEEFFECT
{
	u8 Type ;						// ^Cv(0:Saerch  1:Release)
	Vec Point ;						// `悷W

	f32 LineGage ;					// ͂Ă̏(0.0F:Ȃ 4.0F:͂Ă)
									// オ_ŁAv
	f32 ChargeState ;				// `[W(0.0F:܂ĂȂ 1.0F:܂Ă)

	f32 DivTable[LINE_DIVNUM] ;		// Cl炠l܂łwĂ邩Ã}bv
	
	f32 RenderCounter ;				// ȍp̕_JE^

	u8 RenderFlag ;					// `tO

	f32 Bright ;					// 邳(1.0F:255  0.0F:0%)
	s32 BrightAdd ;					// 邳̐is

	f32 SinSpeed[SIN_NUM] ;			// TC̃Xs[h
	u32 SinCounter ;				// TCJE^[
	
	u32 Pi2Time ;					// ]܂ł̃t[
	f32 BrightHeight ;				// őPx
	u32 BrightCounter ;				// JE^
	
	f32 SinCount ;				// TCJE^[
} SPSKILLGAGEEFFECT ;

// XLQ[Wf[^p\
typedef struct tagSPSKILLGAGEEFFECTTASKPARAM
{
	u8 Type ;						// ^Cv(0:Saerch  1:Release)
} SPSKILLGAGEEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitSpSkillGageData( void ) ;				// XLQ[W̋ʃf[^
extern s8 CheckSpSkillGageData( void ) ;			// XLQ[WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSpSkillGageData( void ) ;				// XLQ[W̋ʃf[^n

//extern EFFECT *CreateSpSkillGageEffect( Vec Point, u8 Type, s32 Priority = 3000 ) ;	// XLQ[W쐬
extern s8 ReleaseSpSkillGageEffect( EFFECT *Effect ) ;					// XLQ[W̌ns
extern s8 MoveSpSkillGageEffect( EFFECT *Effect ) ;						// XLQ[WPt[
extern s8 DrawSpSkillGageEffect( EFFECT *Effect ) ;						// XLQ[W`悷

extern s8 SetSpSkillGageRate( f32 GageRate, EFFECT *Effect ) ;			// `[WZbg(1.0F:őlBҋ@   0.0F:܂ĂȂ)
extern s8 SetSpSkillGageRenderFlag( u8 RenderFlag, EFFECT *Effect ) ;	// XLQ[W`悷邩ǂ̃tOZbg

#endif