///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSpotLight
//
// YK7EffectSpotLight.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 02/02/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSPOTLIGHT_H
#define __YK7EFFECTSPOTLIGHT_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

// datatype -------------------------------------

// X|bgCgGtFNgʃf[^
typedef struct tagSPOTLIGHTUNION
{
	u8 Dummy ;
} SPOTLIGHTUNION ;

// X|bgCgGtFNgf[^
typedef struct tagSPOTLIGHTEFFECT
{
	WK7ScreenImage *Image ;			// ʃC[W
	WK7JObj *JObj ;					// `悷郂f
	EFFECT *Noise ;					// mCYGtFNg
	s32 Counter ;					// JE^[
} SPOTLIGHTEFFECT ;

// X|bgCgGtFNgf[^p\
typedef struct tagSPOTLIGHTEFFECTTASKPARAM
{
	u8 Dummy ;
} SPOTLIGHTEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitSpotLightData( void ) ;			// X|bgCgGtFNg̋ʃf[^
extern s8 CheckSpotLightData( void ) ;			// X|bgCgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndSpotLightData( void ) ;				// X|bgCgGtFNg̋ʃf[^n

extern EFFECT *CreateSpotLightEffect( WK7JObj *JObj, s32 Priority = 2000 ) ;		// X|bgCgGtFNg쐬
extern s8 ReleaseSpotLightEffect( EFFECT *Effect ) ;								// X|bgCgGtFNǧns
extern s8 MoveSpotLightEffect( EFFECT *Effect ) ;								// X|bgCgGtFNgPt[
extern s8 DrawSpotLightEffect( EFFECT *Effect ) ;								// X|bgCgGtFNg`悷

#endif
