///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectStick
//
// YK7EffectStick.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/07/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSTICK_H
#define __YK7EFFECTSTICK_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7Break.h"

// define ---------------------------------------

// datatype -------------------------------------

// hGtFNgʃf[^
typedef struct tagSTICKUNION
{
	f32 Size ;				// TCY
	f32 Length ;			// 

	f32 Alpha ;				// 
	f32 AlphaSpeed ;		// Xs[h	
} STICKUNION ;

// hGtFNgf[^
typedef struct tagSTICKEFFECT
{
	VERTEXHOMING PosInfo ;
	u32 color ;				// F

	f32 Alpha ;				// 
	f32 AlphaSpeed ;		// Xs[h	
	f32 Size ;				// TCY
	f32 Length ;			// 
} STICKEFFECT ;

// hGtFNg^XNɓnf[^
typedef struct tagSTICKEFFECTTACKPARAM
{
	WK7JObj *JObj ;		// hIuWFNg JObj
	Vec Pos ;			// GtFNgoW
	u32 color ;			// F
} STICKEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitStickData( void ) ;				// hGtFNg̋ʃf[^
extern s8 CheckStickData( void ) ;				// hGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndStickData( void ) ;				// hGtFNg̋ʃf[^n

extern EFFECT *CreateStickEffect(
									WK7JObj *JObj,				// hIuWFNg JObj
									Vec Pos,					// GtFNgoW
									GXColor color,				// F
									s32 Priority = -1 ) ;		// hGtFNg쐬
extern s8 ReleaseStickEffect( EFFECT *Effect ) ;										// hGtFNǧns
extern s8 MoveStickEffect( EFFECT *Effect ) ;											// hGtFNgPt[
extern s8 DrawStickEffect( EFFECT *Effect ) ;											// hGtFNg`悷

extern void SetStickLength( f32 len ) ;								// hIuWFNg̒ύX
extern void SetStickWidth( f32 width ) ;							// hIuWFNg̕ύX
extern void SetStickDrawTime( u8 Time, f32 AlphaSpeed = -1.0F ) ;	// hIuWFNg\鎞Ԋ֌Wݒ肷

#endif

