///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectString
//
// YK7EffectString.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/10/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectString.h"
#include "./YK7EffectStaticData.h"
#include "./Wat/WK7GameInfo.h"

// define ---------------------------------------

#define FONTPATH		"/Yam/effect/BloodPack/BloodFont_GC.BIN"	// ɎgtHg̃pX
#define OUT_WAITTIME	(60)										// 񂪑ޏo܂ł̎
#define OUT_Y			(480)										// ޏon߂xW
#define ONE_HEIGHT		(28)										// sӂ̍
#define SCROLL_SPEED	(1.5F)										// XN[x

// data -----------------------------------------

STRINGUNION stru ;

// function proto type --------------------------

static void __AddString( EFFECT *Effect ) ;		// ǉ
static void __SubString( EFFECT *Effect ) ;		// ̍폜
static void __StringFrame( void ) ;				// ̃t[vZX

// function code --------------------------------

// ǉ
static void __AddString( EFFECT *Effect )
{
	STRINGEFFECT *str ;
	s32 i, j ;
	
	// Ɉtłꍇ͉ʈԉɂ̂XgǕ
	if( stru.num == STR_MAXNUM )
	{
		f32 maxy ;
		s32 ind, i, j ;

		// ʈԉɑ݂镶		
		maxy = 0.0F ;
		for( i = 0, j = 0 ; i < stru.num ; j ++ )
		{
			if( stru.list[j] == NULL ) continue ;
			
			i ++ ;
			str = ( STRINGEFFECT * )stru.list[j]->Data ;
			if( str->y > maxy )
			{
				maxy = str->y ;
				ind = j ;
			}
		}
		
		// ޏo
		(( STRINGEFFECT * )stru.list[ind]->Data)->outflag = true ;
		stru.list[ind] = NULL ;
		
		// 炷
		stru.num -- ;
	}
	
	// ɂ镶̑SĂ񕪉ɂ炷
	for( i = 0, j = 0 ; j < stru.num ; i ++ )
	{
		if( stru.list[i] == NULL ) continue ;
		
		j ++ ;
		str = ( STRINGEFFECT * )stru.list[i]->Data ;
		str->movey += ONE_HEIGHT ;
	} 

	// gĂȂCfbNXT
	for( i = 0 ; stru.list[i] != NULL ; i ++ ){}

	// Xgɒǉ
	stru.list[i] = Effect ;
	
	// 𑝂₷
	stru.num ++ ;
	
	// JE^Zbg
	stru.con = 0 ;
}

// ̍폜
static void __SubString( EFFECT *Effect )
{
	s32 i, j ;
	
	for( i = 0, j = 0 ; j < stru.num ; i ++ )
	{
		if( stru.list[i] == NULL ) continue ;
		
		if( stru.list[i] == Effect ) break ;
		j ++ ;
	}
	if( j == stru.num ) return ;
	
	// XgO
	stru.list[i] = NULL ;
	
	// 炷
	stru.num -- ;
}

// ̃t[vZX
static void __StringFrame( void )
{
	s32 i, j ;
	STRINGEFFECT *str ;
	
	if( GetEffectTime() == stru.NowTime ) return ;
	if( stru.num == 0 )
	{
		stru.con = 0 ;
		return ;
	}

	stru.NowTime = GetEffectTime() ;
	
	// ԂCNg
	stru.con ++ ;
	
	// 莞Ԃ߂SẴGtFNgޏo
	if( stru.con < OUT_WAITTIME ) return ;
	
	// SĂ̕ɑޏotO𗧂Ă
	for( j = 0, i = 0 ; j < stru.num ; i ++ )
	{
		if( stru.list[i] == NULL ) continue ;
		
		j ++ ;
		str = ( STRINGEFFECT * )stru.list[i]->Data ;
		str->outflag = true ;
		stru.list[i] = NULL ;
	}

	// Xgɗ܂ĂGtFNg̐Oɂ
	stru.num = 0 ;
	stru.con = 0 ;
}



// GtFNg̋ʃf[^
extern s8 InitStringData( void )
{
	MEMINIT( stru ) ;

	// tHg[h
//	if( stru.font.Load( FONTPATH ) == false )
	if( stru.font.LoadMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_BloodFont_GC ) ) == false )
	{
		OSReport( "BloodFont_GC load error\n" ) ;
		return -1 ;
	}
	
	// I
	return 0 ;
}

// GtFNg̏풓f[^̓ǂݍ݊𒲂ׂ( TRUE: FALSE:܂ )
extern s8 CheckStringData( void )
{
	// tHg̃[h̊`FbN
	if( stru.font.LoadCheck() == false ) return FALSE ;

	return TRUE ;
}

// GtFNg̋ʃf[^n
extern s8 EndStringData( void )
{
	// tHg̏J
	stru.font.Release() ;
	
	// [
	MEMINIT( stru ) ;

	// I
	return 0 ;
}


// GtFNg쐬
extern EFFECT *CreateStringEffect( char *string, u32 color, f32 exX, f32 exY, s32 Priority )
{
	EFFECT *Effect ;
	STRINGEFFECT *str ;
	
	// Vf[^쐬
	Effect = AddEffectData( EFF_STRING, (void**)&str, Priority ) ;
	if( Effect == NULL ) return NULL ;
//	memset( str, 0, sizeof( STRINGEFFECT ) ) ;

	// f[^̕ۑ
	strcpy( str->str, string ) ;
	str->pos.init() ;
	str->pos.spos( 0.0F ) ;
	str->mode = 1 ;
	str->count = 0 ;
	str->outflag = false ;
	str->movey = 0.0F ;
	str->y = 0.0F ;
	str->color = color ;
	str->exX = exX ;
	str->exY = exY ;
	
	// Xgɒǉ
	__AddString( Effect ) ;

	// I
	return Effect ;
}

// ̃GtFNǧns
extern s8 ReleaseStringEffect( EFFECT *Effect )
{
	STRINGEFFECT *str = ( STRINGEFFECT * )Effect->Data ;

	// XgO
	__SubString( Effect ) ;

	// I
	return 0 ;
}

// ̃GtFNgPt[
extern s8 MoveStringEffect( EFFECT *Effect )
{
	STRINGEFFECT *str = ( STRINGEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( GameInfo.GetMode() == WK7GameInfo::ZAN ||
		GameInfo.GetMode() == WK7GameInfo::PLAY )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	__StringFrame() ;
	
	// xWύX
	if( str->movey != 0.0F )
	{
		f32 addy ;
		
		addy = str->movey / SCROLL_SPEED ;
		if( addy < 0.001F )
		{
			addy = str->movey ;
			str->movey = 0.0F ;
		}
		else
		{
			str->movey -= addy ;
		}
	
		str->y += addy ;
	}

	// bZ[W̏
	str->pos.proc() ;
	switch( str->mode )
	{
	case 0 : break ;
	
	case 1 : 
		str->pos.mov( 8, VParam[ED_BLOODPACK][9], 1.0F ) ;
		str->mode ++ ;
		str->count = 0 ;
		break ;
		
	case 2 :
		if( str->pos.eop() == true )
		{
//			str->count ++ ;
//			if( str->count == 60 )
			if( str->outflag == true )
			{
				str->pos.mov( (u8)VParam[ED_BLOODPACK][11], VParam[ED_BLOODPACK][9], 0.0F ) ;
				str->mode ++ ;
			}
		}
		break ;

	case 3 :
		if( str->pos.eop() )
		{
			str->mode = 0 ;
			DeleteEffect( Effect ) ;
		}
		break ;
	}
	
	// I
	return 0 ;
}


// ̃GtFNg`悷
extern s8 DrawStringEffect( EFFECT *Effect )
{
	STRINGEFFECT *str = ( STRINGEFFECT * )Effect->Data ;

	// bZ[W̕`
	{
		f32 width, x, y ;

		stru.font.DrawSetup() ;
		stru.font.SetColor2( 0xffffffff ) ;
		stru.font.SetExRate2( str->exX, str->exY ) ;

		width = stru.font.DrawSStr( 0, 0, str->str, false, false )  ;
		x = SCW - ( width + VParam[ED_BLOODPACK][12] ) * str->pos.x ;
		y = VParam[ED_BLOODPACK][13] + str->y ;
		{
			f32 zSiro, zKuro ;
			u32 len ;
			
			zSiro = (f32)VParam[ED_BLOODPACK][15] * 0.1F ;
			zKuro = (f32)VParam[ED_BLOODPACK][16] * 0.1F ;
			stru.font.SetColor2( CMK( 0,0,0,255 ) ) ;
			stru.font.DrawSetup() ;
			len = (u32)stru.font.GetDrawNum( str->str ) ;
			GBGN( GX_QUADS, len * 4 * 12 ) ; 
			stru.font.DrawSStr( x+zKuro, y+zKuro, str->str, false, true, false ) ;
			stru.font.DrawSStr( x+zKuro, y-zKuro, str->str, false, true, false ) ;
			stru.font.DrawSStr( x-zKuro, y+zKuro, str->str, false, true, false ) ;
			stru.font.DrawSStr( x-zKuro, y-zKuro, str->str, false, true, false ) ;
			stru.font.DrawSStr( x+zKuro, 	y, 			str->str, false, true, false ) ;
			stru.font.DrawSStr( x, 			y+zKuro, 	str->str, false, true, false ) ;
			stru.font.DrawSStr( x-zKuro, 	y, 			str->str, false, true, false ) ;
			stru.font.DrawSStr( x, 			y-zKuro, 	str->str, false, true, false ) ;
			stru.font.SetColor2( str->color ) ;
			stru.font.DrawSStr( x+zSiro, y+zSiro, str->str, false, true, false ) ;
			stru.font.DrawSStr( x+zSiro, y-zSiro, str->str, false, true, false ) ;
			stru.font.DrawSStr( x-zSiro, y+zSiro, str->str, false, true, false ) ;
			stru.font.DrawSStr( x-zSiro, y-zSiro, str->str, false, true, false ) ;
			GEND() ;
		}
//		stru.font.DrawSStr( - width + ( width + VParam[ED_BLOODPACK][12] ) *  str->pos.x,
//								Param[ED_BLOODPACK][13], str->str ) ;
	}

	// I
	return 0 ;
}					
