///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectTime
//
// YK7EffectTime.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectTime.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define TEXPATH			"/Yam/Effect/Number/"
#define SECFRAME		(30)						// bӂ̃t[
#define FRAMETIME		((f32)1000/SECFRAME)		// Pt[ӂ̎(~b)

#define SECTENX			(232)
#define SECTENY			(50)
#define SECONEX			(285)
#define SECONEY			(53)

#define COLONX			(321)
#define COLONY			(50)

#define MTENX			(357)
#define MTENY			(53)
#define MONEX			(401)
#define MONEY			(53)

#define F_SIZE			(64)
#define F_BIG			((f32)64.0F / F_SIZE)
#define F_SML			((f32)50.0F / F_SIZE)

VIBTABLE __VibTable[VIBTIME] =
{
	0.0F, 0, 0,
	0.1F, 4, 8,
	0.0F, -11, 1 ,
	0.03F, -8, 8,
	-0.05F, 0, 5,
	0.0F, 0, 0
} ;

// data -----------------------------------------

TIMEUNION timu ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// ԕ\GtFNg̋ʃf[^
extern s8 InitTimeData( void )
{
	s32 i ;
//	char path[128] ;

	MEMINIT( timu ) ;
	
	// eNX`̓ǂݍ
	for( i = 0 ; i < 9 ; i ++ )
	{
//		sprintf( path, "%sfont_%02d.BIN", TEXPATH, i + 1 ) ;
//		TexLoadSet( path, &timu.numtex[1][i] ) ;
		TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_TIMER )->GetResource( STDAT_TIM_font_01 + i ), &timu.numtex[1][i] ) ;

//		sprintf( path, "%sfont_%02d_blur.BIN", TEXPATH, i + 1 ) ;
//		TexLoadSet( path, &timu.numtex[0][i] ) ;
		TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_TIMER )->GetResource( STDAT_TIM_font_01_blur + i ), &timu.numtex[0][i] ) ;
	}
	for( i = 0 ; i < 4 ; i ++ )
	{
//		sprintf( path, "%sfont_00%c.BIN", TEXPATH, 'a' + i ) ;
//		TexLoadSet( path, &timu.num0tex[i] ) ;
		TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_TIMER )->GetResource( STDAT_TIM_font_00a + i ), &timu.num0tex[i] ) ;
	}
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_TIMER )->GetResource( STDAT_TIM_font_00_blur ), &timu.num0blur ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_TIMER )->GetResource( STDAT_TIM_hit ),  &timu.hittex[1] ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_TIMER )->GetResource( STDAT_TIM_hit_blur ), &timu.hittex[0] ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_TIMER )->GetResource( STDAT_TIM_font_colon ), &timu.colontex[1] ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_TIMER )->GetResource( STDAT_TIM_font_colon_blur ), &timu.colontex[0] ) ;
//	TexLoadSet( TEXPATH "font_00_blur.BIN", &timu.num0blur ) ;
//	TexLoadSet( TEXPATH "hit.BIN", &timu.hittex[1] ) ;
//	TexLoadSet( TEXPATH "hit_blur.BIN", &timu.hittex[0] ) ;
//	TexLoadSet( TEXPATH "font_colon.BIN", &timu.colontex[1] ) ;
//	TexLoadSet( TEXPATH "font_colon_blur.BIN", &timu.colontex[0] ) ;

	return 0 ;
}

// ԕ\GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckTimeData( void )
{
//	s32 i ;

/*
	for( i = 0 ; i < 9 ; i ++ )
	{
		if( TexLoadChk( &timu.numtex[1][i] ) == FALSE ) return FALSE ;
		if( TexLoadChk( &timu.numtex[0][i] ) == FALSE ) return FALSE ;
	}
	for( i = 0 ; i < 4 ; i ++ )
	{
		if( TexLoadChk( &timu.num0tex[i] ) == FALSE ) return FALSE ;
	}
	if( TexLoadChk( &timu.num0blur ) == FALSE ) return FALSE ;
	if( TexLoadChk( &timu.hittex[1] ) == FALSE ) return FALSE ;
	if( TexLoadChk( &timu.hittex[0] ) == FALSE ) return FALSE ;
	if( TexLoadChk( &timu.colontex[1] ) == FALSE ) return FALSE ;
	if( TexLoadChk( &timu.colontex[0] ) == FALSE ) return FALSE ;
*/

	return TRUE ;
}

// ԕ\GtFNg̋ʃf[^n
extern s8 EndTimeData( void )
{
	s32 i ;

	for( i = 0 ; i < 9 ; i ++ )
	{
		TexRelease( &timu.numtex[1][i] ) ;
		TexRelease( &timu.numtex[0][i] ) ;
	}
	for( i = 0 ; i < 4 ; i ++ )
	{
		TexRelease( &timu.num0tex[i] ) ;
	}
	TexRelease( &timu.num0blur ) ;
	TexRelease( &timu.hittex[1] ) ;
	TexRelease( &timu.hittex[0] ) ;
	TexRelease( &timu.colontex[1] ) ;
	TexRelease( &timu.colontex[0] ) ;

	MEMINIT( timu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// ԕ\GtFNg쐬
extern EFFECT *CreateTimeEffect(
									u32 Time,				// b
									s32 Priority )			// ԕ\GtFNg쐬
{
	EFFECT *Effect ;
	TIMEEFFECT *tm ;
	
	// Vԕ\f[^쐬
	Effect = AddEffectData( EFF_TIME, (void**)&tm, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// ̏
	tm->frame = (s32)( Time * SECFRAME ) ;
	tm->vibcounter = 0 ;
	tm->vibflag = tm->frame % SECFRAME == 0 ;
	tm->exrate = 1.0F ;
	tm->endflag = false ;
	tm->brinktime = VParam[ED_TIME][6] ;
	tm->alpha = 0.0F ;
	tm->stopflag = true ;

	// I
	return Effect ;
}

// ԕ\GtFNǧns
extern s8 ReleaseTimeEffect( EFFECT *Effect )
{
	TIMEEFFECT *tm = ( TIMEEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// ԕ\GtFNgPt[
extern s8 MoveTimeEffect( EFFECT *Effect )
{
	TIMEEFFECT *tm = ( TIMEEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( Effect->DelReqFlag == TRUE )
	{
		tm->alpha -= 0.1F ;
		if( tm->alpha <= 0.0F )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}
	else
	{
		tm->alpha += 0.1F ;
		if( tm->alpha >= 1.0F ) tm->alpha = 1.0F ;
	}
	
	if( tm->stopflag == true ) return 0 ;

	if( tm->endflag == false ) tm->frame -- ;

	if( tm->vibflag == true )
	{
		tm->vibcounter ++ ;
		if( tm->vibcounter == VIBTIME )
		{
			tm->vibflag = false ;
			tm->vibcounter = 0 ;
		}
	}
	else
	{
		if( tm->endflag == false )
		{
			if( ( ( tm->frame - VParam[ED_TIME][4] ) % ( SECFRAME * 10 ) == 0 ) || tm->frame == 0 )
			{
				tm->vibflag = true ;
				tm->vibcounter = 0 ;
				tm->posvibflag = true ;
				tm->exrate = (f32)VParam[ED_TIME][2] * 0.1F ;

				tm->brinktime -= VParam[ED_TIME][7] ;
			}
			else
			if( tm->frame % SECFRAME == 0 )
			{
				tm->vibflag = true ;
				tm->vibcounter = 0 ;
				tm->posvibflag = false ;
				tm->exrate = (f32)VParam[ED_TIME][0] * 0.1F ;
			}
		}
	}

	if( tm->frame == 0 )
	{
		tm->endflag = true ;
	}

	// I
	return 0 ;
}

// ԕ\GtFNg`悷
extern s8 DrawTimeEffect( EFFECT *Effect )
{
	TIMEEFFECT *tm = ( TIMEEFFECT * )Effect->Data ;
	s32 frame, SecTen, SecOne, MTen, MOne, msec ;
	f32 adx, ady ;
	f32 ex ;
	u32 cr ;

	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_USETEX ) ;
	
	if( tm->vibflag )
	{
		adx = __VibTable[tm->vibcounter].x ;
		ady = __VibTable[tm->vibcounter].y ;
		ex = __VibTable[tm->vibcounter].ex ;

		if( tm->posvibflag == false )
		{
			adx = 0.0F ;
			ady = 0.0F ;
		}
				
		ex *= tm->exrate ;
		ex += 1.0F ;
	}
	else
	{
		adx = 0.0F ;
		ady = 0.0F ;
		ex = 1.0F ;
	}

	// \鐔̊o
	{
		frame = tm->frame ;
		
		SecTen = frame / ( SECFRAME * 10 ) ;
		frame -= SecTen * SECFRAME * 10 ;
		
		SecOne = frame / SECFRAME ;
		frame -= SecOne * SECFRAME ;

		msec = (s32)( frame * FRAMETIME ) ;
		
		MTen = msec / 100 ;
		msec -= MTen * 100 ;
		
		MOne = msec / 10 ;
		msec -= MOne * 10 ;
	}

	cr = CMK( 255, 255, 255, 255 * tm->alpha ) ;
	
	// `
	if( VParam[ED_TIME][3] )
	{
		EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
		GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ONE ) ; 
		DrawExTex( SECTENX + adx + ( SecTen == 1 ? VParam[ED_TIME][1] : 0 ), SECTENY + ady, F_BIG * ex, true, SecTen == 0 ? &timu.num0tex[0] : &timu.numtex[1][SecTen-1], cr ) ;
		DrawExTex( SECONEX + adx, SECONEY + ady, F_SML * ex, true, SecOne == 0 ? &timu.num0tex[1] : &timu.numtex[1][SecOne-1], cr ) ;
		if( ( tm->frame % ( tm->brinktime * 2 ) < tm->brinktime ) || tm->endflag )
			DrawExTex( COLONX + adx, COLONY + ady, 1.0F, true, &timu.colontex[1], cr ) ;
		DrawExTex( MTENX + adx, MTENY + ady, F_SML * ex, true, MTen == 0 ? &timu.num0tex[2] : &timu.numtex[1][MTen-1], cr ) ;
		DrawExTex( MONEX + adx, MONEY + ady, F_SML * ex, true, MOne == 0 ? &timu.num0tex[3] : &timu.numtex[1][MOne-1], cr ) ;
	}

	EffectBlendModeSetup( VParam[ED_TIME][5] == 0 ? EF_BLEND_ALPHA : EF_BLEND_ADD ) ;
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ONE ) ; 
	DrawExTex( SECTENX + adx + ( SecTen == 1 ? VParam[ED_TIME][1] : 0 ), SECTENY + ady, F_BIG * ex, true, SecTen == 0 ? &timu.num0blur : &timu.numtex[0][SecTen-1], cr ) ;
	DrawExTex( SECONEX + adx, SECONEY + ady, F_SML * ex, true, SecOne == 0 ? &timu.num0blur : &timu.numtex[0][SecOne-1], cr ) ;
	if( ( tm->frame % ( tm->brinktime * 2 ) < tm->brinktime ) || tm->endflag )
		DrawExTex( COLONX + adx, COLONY + ady, ex, true, &timu.colontex[0], cr ) ;
	DrawExTex( MTENX + adx, MTENY + ady, F_SML * ex, true, MTen == 0 ? &timu.num0blur : &timu.numtex[0][MTen-1], cr ) ;
	DrawExTex( MONEX + adx, MONEY + ady, F_SML * ex, true, MOne == 0 ? &timu.num0blur : &timu.numtex[0][MOne-1], cr ) ;

	// I
	return 0 ;
}

// ԕ\GtFNg̏Ԃ𓾂( 0:X^[g҂  1:JEg_E  2:~ )
extern s8 GetTimeEffectState( EFFECT *Effect )
{
	TIMEEFFECT *tm = ( TIMEEFFECT * )Effect->Data ;
	
	return (s8)( tm->stopflag == true ? 0 : ( tm->endflag == true ? 2 : 1 ) ) ;
}

// JEgJn
extern s8 StartTimeEffect( EFFECT *Effect )
{
	TIMEEFFECT *tm = ( TIMEEFFECT * )Effect->Data ;
	
	tm->stopflag = false ;
	return 0 ;
}

// JEgꎞ~
extern s8 PauseTimeEffect( EFFECT *Effect )
{
	TIMEEFFECT *tm = ( TIMEEFFECT * )Effect->Data ;
	
	tm->stopflag = true ;
	return 0 ;
}



