///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectTuba
//
// YK7EffectTuba.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/24/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectTuba.h"
#include "./YK7EffectBillboard.h"

// define ---------------------------------------

#define TUBA_FILENAME			"/Yam/Effect/Tuba/Tuba_"

// datatype -------------------------------------

// data -----------------------------------------

TUBAUNION TubUnion ;

// function code --------------------------------

// ΃GtFNg̋ʃf[^
extern s8 InitTubaData( void )
{
	MEMINIT( TubUnion ) ;

	SetupBillboardEffectID( BILLEFF_TUBA ) ;

	// I
	return 0 ;
}

// ΃GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckTubaData( void )
{
	return TRUE ;
}


// ΃GtFNg̋ʃf[^n
extern s8 EndTubaData( void )
{
	MEMINIT( TubUnion ) ;

	ReleaseBillboardEffectID( BILLEFF_TUBA ) ;

	// I
	return 0 ;
}


// ΂̃GtFNg쐬
extern EFFECT *CreateTubaEffect( WK7JObj *JObj, f32 YukaY, s32 Priority )
{
	TUBAEFFECT *Tuba ;
	EFFECT *Effect, *Bill ;
	Vec Point, Dir ;
	
	JObj = JObj->GetObj( "Mouth" ) ;
	if( JObj == NULL ) 
	{
		return NULL ;
	}
	
	// Wƕ擾
	{
		HSD_JObj *Obj ;
		Mtx mtx ;
		
		Obj = JObj->GetJObj() ;
		Point.x = Obj->mtx[0][3] ;
		Point.y = Obj->mtx[1][3] ;
		Point.z = Obj->mtx[2][3] ;
		
		memcpy( mtx, Obj->mtx, sizeof( Mtx ) ) ;
		mtx[0][3] = 0.0F ;		mtx[1][3] = 0.0F ;		mtx[2][3] = 0.0F ;
		
		Dir.x = 0.0F ;
		Dir.y = 0.0F ;
		Dir.z = 1.0F ;
		MTXMultVec( mtx, &Dir, &Dir ) ;
	}
	
	// r{[hGtFNg̍쐬
	Bill = CreateBillboardEffect2( BILLEFF_TUBA, Point, YukaY ) ;
	if( Bill == NULL ) return NULL ;
	
	// V΃f[^쐬
	Effect = AddEffectData( EFF_TUBA, (void**)&Tuba, Priority ) ;
	if( Effect == NULL )
	{
		DeleteEffect( Bill ) ;
		return NULL ;
	}
	
	// f[^̏
	Tuba->TubaID = GetEffectID( Bill ) ;
	Tuba->Tuba = Bill ;
	
	// ΂̒ǉ
	AddBillboardEffectObject( Tuba->Tuba, Point, &Dir ) ;
	
	// I
	return Effect ;
}

// ΂̃GtFNǧns
extern s8 ReleaseTubaEffect( EFFECT *Effect )
{
	TUBAEFFECT *Tuba = ( TUBAEFFECT * )Effect->Data ;

	if( CheckEffectValidState( Tuba->Tuba, Tuba->TubaID ) == TRUE )
	{
		DeleteEffect( Tuba->Tuba ) ;
	}

	// ɂ邱ƂȂ
	return 0 ;
}

// ΂̃GtFNgPt[
extern s8 MoveTubaEffect( EFFECT *Effect )
{
	TUBAEFFECT *Tuba = ( TUBAEFFECT * )Effect->Data ;

	if( (TUBAEFFECT *)NULL == Tuba ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE || GetBillboardEffectObjectNum( Tuba->Tuba ) == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// I
	return 0 ;
}
	
// ΂̃GtFNg`悷
extern s8 DrawTubaEffect( EFFECT *Effect )
{
	TUBAEFFECT *Tuba = ( TUBAEFFECT * )Effect->Data ;
 
	if( (TUBAEFFECT *)NULL == Tuba ) return 0 ;

	// I
	return 0 ;
}

	
