///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectWhirl
//
// YK7EffectWhirl.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/06/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectWhirl.h"
#include "../Wat/WK7MainTask.h"

// define ---------------------------------------

#define CIRCLE_VDIVNUM			60			// ~ɑ債Đȕւ̕
#define CIRCLE_RDIVNUM			30			// ~̉]ɑ΂镪

// datatype -------------------------------------

// data -----------------------------------------

WHIRLUNION WhiUnion ;

// function code --------------------------------

// ʂ˂GtFNg̋ʃf[^
extern s8 InitWhirlData( void )
{
	MEMINIT( WhiUnion ) ;

	// I
	return 0 ;
}

// ʂ˂GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckWhirlData( void )
{
	return TRUE ;
}

// ʂ˂GtFNg̋ʃf[^n
extern s8 EndWhirlData( void )
{
	MEMINIT( WhiUnion ) ;

	// I
	return 0 ;
}


// ʂ˂̃GtFNg쐬
extern EFFECT *CreateWhirlEffect( Vec Point, f32 Radius, f32 RadiusSpeed, f32 Rotate, f32 WhirlSpeed, f32 WhirlAddSpeed,
									u16 WhirlTime, u16 WhirlWait, f32 WhirlFinishSpeed, f32 WhirlFinishAddSpeed,
									u16 WhirlFinishTime, s32 Priority )
{
	WHIRLEFFECT *Whirl ;
	EFFECT *Effect ;
	
	// Vʂ˂f[^쐬
	Effect = AddEffectData( EFF_WHIRL, (void**)&Whirl, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// ʂ˂f[^
	Whirl->Point = Point ;
	Whirl->Radius = Radius ;
	Whirl->RadiusSpeed = RadiusSpeed ;
	Whirl->Rotate = Rotate ;
	Whirl->WhirlSpeed = WhirlSpeed ;
	Whirl->WhirlAddSpeed = WhirlAddSpeed ;
	Whirl->WhirlTime = WhirlTime ;
	Whirl->WhirlWait = WhirlWait ;
	Whirl->WhirlFinishSpeed = WhirlFinishSpeed ;
	Whirl->WhirlFinishAddSpeed = WhirlFinishAddSpeed ;
	Whirl->WhirlFinishTime = WhirlFinishTime ;
	Whirl->Mode = 0 ;
	Whirl->Counter = 0 ;
	Whirl->RotCounter = 0.0F ;
/*	if( Whirl->WhirlAddSpeed == 0.0F )
	{
		Whirl->WhirlAddSpeed = -( Whirl->WhirlSpeed / ( 2 * 100.0F / Whirl->WhirlSpeed ) ) ;
		Whirl->WhirlAddSpeed -= Whirl->WhirlAddSpeed / 100.F ;
	}
*/
	// ʎ荞݂悤NX̃ZbgAbv
//	screenImageFullColor.SetFormat(GX_TF_RGBA8);		// tH[}bgw肷
//	screenImageFullColor.AllocBuffer();					// tH[}bgɂ킹ăĎ擾

//	Whirl->ScreenImage = new WK7ScreenImage ;
//	Whirl->ScreenImage->SetFormat(GX_TF_ARGB);			// tH[}bgw肷
//	Whirl->ScreenImage->AllocBuffer();					// tH[}bgɂ킹ăĎ擾

//	Whirl->ScreenImage->InitTexObj() ;					// eNX`̏

	// I
	return Effect ;
}

// ʂ˂̃GtFNǧns
extern s8 ReleaseWhirlEffect( EFFECT *Effect )
{
	WHIRLEFFECT *WhirlEffect = ( WHIRLEFFECT * )Effect->Data ;

//	delete WhirlEffect->ScreenImage ;

	// ɂ邱ƂȂ
	return 0 ;
}

// ʂ˂̃GtFNgPt[
extern s8 MoveWhirlEffect( EFFECT *Effect )
{
	WHIRLEFFECT *WhirlEffect = ( WHIRLEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// [hɂď𕪊
	switch( WhirlEffect->Mode )
	{
	case 0 : // ˂ꂳ鏈
		if( WhirlEffect->WhirlTime == 0 )
		{
			WhirlEffect->RotCounter += WhirlEffect->WhirlSpeed ;
			WhirlEffect->WhirlSpeed += WhirlEffect->WhirlAddSpeed ;
			WhirlEffect->WhirlAddSpeed += WhirlEffect->WhirlAddSpeed / 3.0F ; 
			if( WhirlEffect->RotCounter > 100.0F )
			{
				WhirlEffect->RotCounter = 100.0F ;
				WhirlEffect->Mode ++ ;
			}
		}
		else
		{
			f32 sp, time, x ;

			sp = WhirlEffect->WhirlSpeed ;
//			time = WhirlEffect->WhirlTime ;
			time = ( 100.0F * 2 ) / sp ;
			x = WhirlEffect->Counter ;
			WhirlEffect->RotCounter = ( ( sp + ( sp - ( sp / time ) * x ) ) * x ) / 2 ;
			WhirlEffect->Radius += WhirlEffect->RadiusSpeed ;

			// K^C烂[hς
			if( WhirlEffect->Counter > time )
			{
				WhirlEffect->Mode ++ ;
				WhirlEffect->Counter = 0 ;
			}
			else
			{
				WhirlEffect->Counter ++ ;
			}
		}
		break ;
		
	case 1 : // ˂ꂳԂő҂

		// K^C邩폜]烂[hς
		WhirlEffect->RotCounter = 100.0F ;
		if( WhirlEffect->Counter == WhirlEffect->WhirlWait ||
			Effect->DelReqFlag == TRUE )
		{
			WhirlEffect->Mode ++ ;
			WhirlEffect->Counter = 0 ;
		}
		else
		{
			WhirlEffect->Counter ++ ;
		}
		break ;
		
	case 2 : // ˂ꂳԂ߂鏈
		if( WhirlEffect->WhirlFinishTime == 0 )
		{
			WhirlEffect->RotCounter -= WhirlEffect->WhirlFinishSpeed ;
			WhirlEffect->WhirlFinishSpeed += WhirlEffect->WhirlFinishAddSpeed ;
			if( WhirlEffect->RotCounter < 0.0F )
			{
				WhirlEffect->RotCounter = 0.0F ;
				DeleteEffect( Effect ) ;
				return 0 ;
			}
		}
		else
		{
			f32 sp, time, x ;

			sp = WhirlEffect->WhirlFinishSpeed ;
//			time = WhirlEffect->WhirlTime ;
			time = ( 100.0F * 2 ) / sp ;
			x = WhirlEffect->Counter ;
			WhirlEffect->RotCounter = 100.0F - ( ( sp + ( sp - ( sp / time ) * x ) ) * x ) / 2 ;

			// K^CGtFNg폜
			if( WhirlEffect->Counter > time )
			{
				DeleteEffect( Effect ) ;
				return 0 ;
			}
			else
			{
				WhirlEffect->Counter ++ ;
			}
		}
		break ;
	}
	
	// I
	return 0 ;
}
	
// ʂ˂̃GtFNg`悷
extern s8 DrawWhirlEffect( EFFECT *Effect )
{
	WHIRLEFFECT *Wl = ( WHIRLEFFECT * )Effect->Data ;
//	int DrawNum ;
	WHIRLUNION *WhirlUnion = &WhiUnion ;
//	static Vec Map[CIRCLE_VDIVNUM][CIRCLE_RDIVNUM] ;
//	static f32 UV[CIRCLE_VDIVNUM][CIRCLE_RDIVNUM][2] ;
	Vec (*Map)[CIRCLE_RDIVNUM] = (Vec (*)[CIRCLE_RDIVNUM])&WorkBuffer[0] ;
	f32 (*UV)[CIRCLE_RDIVNUM][2] = (f32 (*)[CIRCLE_RDIVNUM][2])&WorkBuffer[sizeof( Vec ) * CIRCLE_VDIVNUM * CIRCLE_RDIVNUM] ;
	Vec Point ;
	f32 Size ;
	
	// TCYƈʒuZo
	{
		GetScreenPosition( &Wl->Point, &Point ) ;
		if( Point.z > 1.0F ) return -1 ;
		Size = GetScreenSize( &Wl->Point, Wl->Radius / 2 ) ;
	}

	// ʂ̕`Ԃ擾鏈
	{
		screenImageFullColor.ScreenCopy() ;
		GTLOAD( screenImageFullColor.GetTexObj() ) ;
	}

	// `揀
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_NONE, EF_TEV_USETEX ) ;

	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGB, GX_RGB565, 0 ) ;
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;

	// iq̒_f[^p
	{
		f32 rot, A, r, /*ssp, msp, sssp, mssp,*/ msssp, rot2 ;
		u32 i, j, rt ;
		Vec *V ;
		f32 *T ;

		// ڏԂɂď𕪊
		rot = Wl->RotCounter / 100.0F ;
		msssp = ( Wl->Rotate * 4 ) / ( CIRCLE_VDIVNUM * CIRCLE_VDIVNUM * CIRCLE_VDIVNUM ) ;
		A = msssp / CIRCLE_VDIVNUM ;

		// ꒸_}bv쐬
		V = &Map[0][0] ;
		T = &UV[0][0][0] ;
		for( i = 0 ; i < CIRCLE_VDIVNUM ; i ++ )
		{
			r = Size - Size * ( (f32)i / CIRCLE_VDIVNUM ) ;
			rot2 = ( A / 4.0F ) * i * i * i * i ; 
			rt = (u32)( rot2 * rot * PI2DIV / PI_2 ) ;
			for( j = 0 ; j < CIRCLE_RDIVNUM ; j ++, V ++, T += 2 )
			{
				V->x = ( r * -COS(rt + j * PI2DIV / CIRCLE_RDIVNUM) + Point.x ) ;
				V->y = ( r * SIN(rt + j * PI2DIV / CIRCLE_RDIVNUM) + Point.y ) ;
				T[0] = ( ( r * -COS( j * PI2DIV / CIRCLE_RDIVNUM) + Point.x ) / SCW ) * UVSCALE ;
				T[1] = ( ( r * SIN( j * PI2DIV / CIRCLE_RDIVNUM) + Point.y ) / SCH ) * UVSCALE ;
			}
		}
	}

	// `揈
	{
		u16 i, j, Color ;

		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( CIRCLE_VDIVNUM * CIRCLE_RDIVNUM * 4 ) ) ;
		{
			Color = GXPackedRGBA4( 255, 255, 255, 255 ) ;

			// Ő[̉~ȊỎ~`
			{
				// ̐JԂ
				for( i = 0 ; i < CIRCLE_VDIVNUM - 1 ; i ++ )
				{
					for( j = 0 ; j < CIRCLE_RDIVNUM - 1 ; j ++ )
					{
						// W̏o
						GPV2( Map[i][j] ) ;		GXColor1u16( Color ) ;   GT2( UV[i][j][0], UV[i][j][1] ) ; 
						GPV2( Map[i][j+1] ) ;	GXColor1u16( Color ) ;   GT2( UV[i][j+1][0], UV[i][j+1][1] ) ; 
						GPV2( Map[i+1][j+1] ) ;	GXColor1u16( Color ) ;   GT2( UV[i+1][j+1][0], UV[i+1][j+1][1] ) ; 
						GPV2( Map[i+1][j] ) ;	GXColor1u16( Color ) ;   GT2( UV[i+1][j][0], UV[i+1][j][1] ) ; 
					}

					// [̍W̏o
					GPV2( Map[i][j] ) ;		GXColor1u16( Color ) ;   GT2( UV[i][j][0], UV[i][j][1] ) ; 
					GPV2( Map[i][0] ) ;		GXColor1u16( Color ) ;   GT2( UV[i][0][0], UV[i][0][1] ) ; 
					GPV2( Map[i+1][0] ) ;	GXColor1u16( Color ) ;   GT2( UV[i+1][0][0], UV[i+1][0][1] ) ; 
					GPV2( Map[i+1][j] ) ;	GXColor1u16( Color ) ;   GT2( UV[i+1][j][0], UV[i+1][j][1] ) ; 
				}
			}

			// Ő[̉~`
			{
				for( j = 0 ; j < CIRCLE_RDIVNUM - 1 ; j ++ )
				{
					// W̏o
					GPV2( Map[i][j] ) ;		GXColor1u16( Color ) ;   GT2( UV[i][j][0], UV[i][j][1] ) ; 
					GPV2( Map[i][j+1] ) ;	GXColor1u16( Color ) ;   GT2( UV[i][j+1][0], UV[i][j+1][1] ) ; 
					GPV2( Point ) ;			GXColor1u16( Color ) ;   GT2( (u16)( Wl->Point.x * UVSCALE / SCW ), (u16)( Wl->Point.y * UVSCALE / SCH ) ) ; 
					GPV2( Point ) ;			GXColor1u16( Color ) ;   GT2( (u16)( Wl->Point.x * UVSCALE / SCW ), (u16)( Wl->Point.y * UVSCALE / SCH ) ) ; 
				}

				// [̍W̏o
				GPV2( Map[i][j] ) ;	GXColor1u16( Color ) ;   GT2( UV[i][j][0], UV[i][j][1] ) ; 
				GPV2( Map[i][0] ) ;	GXColor1u16( Color ) ;   GT2( UV[i][0][0], UV[i][0][1] ) ; 
				GPV2( Point ) ;		GXColor1u16( Color ) ;   GT2( (u16)( Wl->Point.x * UVSCALE / SCW ), (u16)( Wl->Point.y * UVSCALE / SCH ) ) ; 
				GPV2( Point ) ;		GXColor1u16( Color ) ;   GT2( (u16)( Wl->Point.x * UVSCALE / SCW ), (u16)( Wl->Point.y * UVSCALE / SCH ) ) ; 
			}
		}
		GXEnd() ;
	}
	
	// I
	return 0 ;
}

// ˂ꂳ锼aύX
extern s8 SetWhirlEffectRadius( EFFECT *Effect, f32 Radius )
{
	WHIRLEFFECT *Wl = ( WHIRLEFFECT * )Effect->Data ;

	Wl->Radius = Radius ;
	
	return 0 ;	
}

