// ============================================================================
//
//		Ԑڏ⏕NX
//
//	YK7Move.h
//
//	Creator			: Takumi Yamada(GHM)
//	Creation Date	: 02/24/04
//
// ============================================================================

// include --------------------------------------
#include "./YK7Move.h"
#include <string.h>

// define ---------------------------------------

// e[uLqȗ}N
#define CMOVFP(x)	{ CMov::x##init, CMov::x##proc, CMov::x##eop },


// data type ------------------------------------

// data -----------------------------------------

// ڏ֐e[u
static CMOVFUNC _MovFuncTable[] =
{
	CMOVFP(m1)		// w莞ԓ`ړ
	CMOVFP(m2)		// Zړ
	CMOVFP(m3)		// wXs[h`ړ
	CMOVFP(m4)		// ړ
	CMOVFP(m5)		// wxړ
	CMOVFP(m6)		// ړ㊄Zړ
	CMOVFP(m7)		// ʂ߂ړ
	CMOVFP(m8)		// ړ
	CMOVFP(m9)		// ʂ߂ړ2
	CMOVFP(m10)		// ʂ߂ړ3
	CMOVFP(m11)		// I_ړ
	CMOVFP(m12)		// I_ړ
} ;

// class ----------------------------------------

// 삵Ȃ悤ɂ
void CMov::init( bool singleflag )
{
	memset( this, 0, sizeof( CMov ) ) ;
	if( singleflag ) setSingle() ;
}

// ړJn
void CMov::mov( u8 type, f32 Time, f32 X, f32 Y, f32 Z )
{
	// ep[^Ƃ肠ۑ
	Type = type ;
	time = Time ;
	mx = X ;
	if( singlef )
	{
		y = 0.0F ; z = 0.0F ;
		my = 0.0F ; mz = 0.0F ;
	}
	else
	{
		my = Y ; mz = Z ;
	}

	// Ԑڏ֐Q|C^\̂ւ̃|C^Zbg֐Ă
	( func = &::_MovFuncTable[type] )->init( this ) ;

	// I
}

// ڕWl܂ł̒𓾂
f32 CMov::getlen( void )
{
	f32 sx, sy, sz ;

	getsa( sx, sy, sz ) ;
	return singlef ? fabsf(sx) : sqrtf( sx * sx + sy * sy + sz * sz ) ;
}

// ڕWlƌݒn̍𓾂
void CMov::getsa( f32 &sx, f32 &sy, f32 &sz )
{
	sx = mx - x ;
	if( singlef ) return ;
	sy = my - y ; sz = mz - z ;
}

// ڕWlɌKꂽxNg𓾂
void CMov::getdir( f32 &dx, f32 &dy, f32 &dz )
{
	f32 sx, sy, sz, len  ;

	getsa( sx, sy, sz ) ;
	if( singlef )
	{
		dx = sx > 0 ? 1.0F : -1.0F ;
	}
	else
	{
		len = sqrtf( sx * sx + sy * sy + sz * sz ) ;
		dx = sx / len ;		dy = sy / len ;		dz = sz / len ;
	}
}

// ڕWlɌĎw苗ړ
void CMov::movpos( f32 len )
{
	f32 dx, dy, dz ;

	getdir( dx, dy, dz ) ;
	x += dx * len ;
	if( singlef ) return ;
	y += dy * len ;		z += dz * len ;
}

// ړI
void CMov::movend( void )
{
	x = mx ; y = my ; z = mz ;
	func = NULL ;
}

// qg߂̃ZbgAbvs
void CMov::csetup( void )
{
	memset( buf, 0, sizeof( buf ) ) ;
	c = ( CMov * )buf ;
	c->singlef = singlef ;
}

// q̈ړ⏕NX̍Wëړ⏕NXɃRs[
void CMov::copycpos( void )
{
	x = c->x ;	y = c->y ;	z = c->z ;
}



// w莞ԓ`ړ
	void CMov::m1init( CMov *cm )
	{
		cm->speed = cm->getlen() / cm->time ;
	}

	void CMov::m1proc( CMov *cm )
	{
		cm->getlen() < cm->speed ? cm->movend() : cm->movpos( cm->speed ) ;
	}

	bool CMov::m1eop( CMov * )
	{
		return false ;
	}



// Zړ
	void CMov::m2init( CMov *cm )
	{
		cm->speed = 1.0F / cm->time ;
	}

	void CMov::m2proc( CMov *cm )
	{
		cm->getlen() < 0.0001F ? cm->movend() : cm->movpos( cm->getlen() * cm->speed ) ;
	}

	bool CMov::m2eop( CMov * )
	{
		return false ;
	}



// wXs[h`ړ
	void CMov::m3init( CMov *cm )
	{
		cm->speed = cm->time ;
	}

	void CMov::m3proc( CMov *cm )
	{
		cm->getlen() < cm->speed ? cm->movend() : cm->movpos( cm->speed ) ;
	}

	bool CMov::m3eop( CMov * )
	{
		return false ;
	}


// ړ
	void CMov::m4init( CMov *cm )
	{
		cm->speed = 0.0F ;
		
		// xZo( Op`̖ʐς߂鎮̕ό` )
		cm->sspeed = ( 2 * cm->getlen() ) / ( cm->time * cm->time ) ;
	}

	void CMov::m4proc( CMov *cm )
	{
		// Eړ
		cm->speed += cm->sspeed ;
		cm->getlen() < cm->speed ? cm->movend() : cm->movpos( cm->speed ) ;
	}

	bool CMov::m4eop( CMov * )
	{
		return false ;
	}


// wxړ
	void CMov::m5init( CMov *cm )
	{
		cm->speed = 0.0F ;
		cm->sspeed = cm->time ;
	}

	void CMov::m5proc( CMov *cm )
	{
		// Eړ
		cm->speed += cm->sspeed ;
		cm->getlen() < cm->speed ? cm->movend() : cm->movpos( cm->speed ) ;
	}

	bool CMov::m5eop( CMov * )
	{
		return false ;
	}


// ړ㊄Zړ
	void CMov::m6init( CMov *cm )
	{
		cm->csetup() ;
		cm->count = 0.0F ;
		cm->c->spos( cm->x, cm->y, cm->z ) ;
		cm->c->mov( 3, cm->time, cm->mx, cm->my, cm->mz ) ;
		cm->state = 0 ;
	}

	void CMov::m6proc( CMov *cm )
	{
		cm->c->proc() ;
		cm->copycpos() ;
		
		switch( cm->state )
		{
		case 0 :
			cm->count += 1.0F ;
			if( cm->count > cm->time / 3.0F )
			{
				cm->mov( 1, cm->time / 3 * 2, cm->mx, cm->my, cm->mz  ) ;
				cm->state ++ ;
			}
			break ;

		case 1 :
			if( cm->c->eop() == true )
			{
				cm->movend() ;
			}
			break ;
		}
	}

	bool CMov::m6eop( CMov * )
	{
		return false ;
	}



// ʂ߂ړ
	void CMov::m7init( CMov *cm )
	{
		f32 len, dx, dy, dz ;

		len = cm->getlen() ;

		cm->csetup() ;
		cm->getdir( dx, dy, dz ) ;
		dx *= len * 0.2F ;	dy *= len * 0.2F ;	dz *= len * 0.2F ;
		cm->c->spos( cm->x, cm->y, cm->z ) ;
		cm->c->mov( 3, cm->time, cm->mx + dx, cm->my + dy, cm->mz + dz ) ;
	}

	void CMov::m7proc( CMov *cm )
	{
		cm->c->proc() ;
		cm->copycpos() ;

		if( cm->c->eop() == true )
		{
			f32 len, dx, dy, dz ;

			len = cm->getlen() ;
/*			if( len < 1.0F )
			{
				cm->movend() ;
				return ;
			}
			else
*/			{
				cm->csetup() ;
				cm->getdir( dx, dy, dz ) ;
				dx *= len * 0.2F ;	dy *= len * 0.2F ;	dz *= len * 0.2F ;
				cm->c->spos( cm->x, cm->y, cm->z ) ;
				cm->c->mov( 3, cm->time, cm->mx + dx, cm->my + dy, cm->mz + dz ) ;
			}
		}
	}

	bool CMov::m7eop( CMov * )
	{
		return false ;
	}



// ړ
	void CMov::m8init( CMov *cm )
	{
		cm->count = 0.0F ;
		cm->xt = cm->x ;	cm->yt = cm->y ;	cm->zt = cm->z ;

		// xZo
		cm->speed = ( 2 * cm->getlen() ) / cm->time ;

		// xZo( Op`̖ʐς߂鎮̕ό` )
		cm->sspeed = cm->speed / cm->time ;
	}

	void CMov::m8proc( CMov *cm )
	{
		if( (u8)cm->count == (u8)cm->time )
		{
			cm->movend() ;
			return ;
		}
		else
		{
			cm->count ++ ;
		}
		
		// WZo( `̖ʐς߂鎮 )
		f32 len = ( ( cm->speed + ( cm->speed - cm->sspeed * cm->count ) ) * cm->count ) / 2.0F ;

		// ݂̃t[ł̍WɈړ
		cm->x = cm->xt ;	cm->y = cm->yt ;	cm->z = cm->zt ;
		cm->movpos( len ) ;
	}

	bool CMov::m8eop( CMov * )
	{
		return false ;
	}



// ʂ߂^2
	void CMov::m9init( CMov *cm )
	{
		cm->count = 0.0F ;
		cm->xt = cm->x ;	cm->yt = cm->y ;	cm->zt = cm->z ;

		// xZo
		cm->speed = cm->getlen() / cm->time / 2.0F ;
	}

	void CMov::m9proc( CMov *cm )
	{
		f32 len = cm->getlen() ;
	
		if( len < 0.0001F ){ cm->movend() ; return ; }
	
		cm->movpos( cm->speed ) ;
		if( len < cm->speed )
		{
			cm->speed *= 0.7F ;
		}
		cm->speed += cm->getlen() / 30.0F ;
	}

	bool CMov::m9eop( CMov * )
	{
		return false ;
	}



// ʂ߂^3
	void CMov::m10init( CMov *cm )
	{
		cm->count = 0.0F ;
		cm->xt = cm->x ;	cm->yt = cm->y ;	cm->zt = cm->z ;

		// xZo
		cm->speed = cm->getlen() / cm->time / 2.0F ;
	}

	void CMov::m10proc( CMov *cm )
	{
		f32 len = cm->getlen() ;
	
		if( len < 0.0001F ){ cm->movend() ; return ; }
	
		cm->movpos( cm->speed ) ;
		if( len < cm->speed )
		{
			cm->speed *= -0.7F ;
		}
		cm->speed += cm->getlen() / 30.0F ;
	}

	bool CMov::m10eop( CMov * )
	{
		return false ;
	}


// I_ړ
	void CMov::m11init( CMov *cm )
	{
		// xZbg
		cm->speed = cm->time ;
	}

	void CMov::m11proc( CMov *cm )
	{
		f32 dx, dy, dz ;
		
		cm->getdir( dx, dy, dz ) ;
		cm->mx += dx * cm->speed ;
		cm->my += dy * cm->speed ;
		cm->mz += dz * cm->speed ;
		cm->movpos( cm->speed ) ;
	}

	bool CMov::m11eop( CMov * )
	{
		return false ;
	}



// I_ړ
	void CMov::m12init( CMov *cm )
	{
		// xZbg
		cm->speed = 0.0f ;
		cm->sspeed = cm->time * 0.01f ;
	}

	void CMov::m12proc( CMov *cm )
	{
		f32 dx, dy, dz ;
		
		cm->getdir( dx, dy, dz ) ;
		cm->mx += dx * cm->speed ;
		cm->my += dy * cm->speed ;
		cm->mz += dz * cm->speed ;
		
		cm->movpos( cm->speed ) ;
		cm->speed += cm->sspeed ;
	}

	bool CMov::m12eop( CMov * )
	{
		return false ;
	}

