#ifndef ___C_CHILD_H___
#define ___C_CHILD_H___
//#include "common.h"
#include "c_vec.h"

class C_Child{
 public:
  //RXgN^
  C_Child( HSD_JObj *_jobj, Vec *_pos, Vec *_dir ){
	//_jobj ẽ}gNXB
	//_pos ꏊB([hj
	//_dir p[eBN̎ˏoBi[hj
	Mtx imtx;
	Vec pos,dir,up={0.f,1.f,0.f},right;
	
	//eQƁB
	parent = _jobj;
	HSD_JObjRef( parent );

	//q擾B
	child = HSD_JObjAlloc();

	//parent̋t}gNX擾B
	HSD_JObjSetupMatrix( parent );
	MTXInverse( HSD_JObjGetMtxPtr( parent ), imtx );

	//[hłposAparent̃[JɕϊB
	MTXMultVec( imtx, _pos, &pos );
	//[hłdirAparent̃[JɕϊB
	imtx[0][3] = imtx[1][3] = imtx[2][3] = 0.f;
	MTXMultVec( imtx, _dir, &dir );
	VECNormalize( &dir, &dir );

	//child̃[Jparent̃[Jɂ}gNXB
	VECCrossProduct( &dir, &up, &right );
	VECCrossProduct( &right, &dir, &up );
	ofst_mtx[0][0] = right.x;	ofst_mtx[0][1] = right.y;	ofst_mtx[0][2] = right.z;
	ofst_mtx[1][0] = up.x;		ofst_mtx[1][1] = up.y;		ofst_mtx[1][2] = up.z;
	ofst_mtx[2][0] = dir.x;		ofst_mtx[2][1] = dir.y;		ofst_mtx[2][2] = dir.z;
	MTXTranspose( ofst_mtx, ofst_mtx );
	ofst_mtx[0][3] = pos.x;		ofst_mtx[1][3] = pos.y;		ofst_mtx[2][3] = pos.z;
  }
  //fXgN^
  ~C_Child(){
	HSD_JObjUnref( child );
	HSD_JObjUnref( parent );
  }
  //t[ĂŁAchild̃}gNXB
  void Proc( void ){
	HSD_JObjSetupMatrix( parent );
	MTXConcat( HSD_JObjGetMtxPtr( parent ), ofst_mtx, HSD_JObjGetMtxPtr( child ) );
  }
  //WFl[^[ɓnĂB
  HSD_JObj *GetJObj( void ){
	return child;
  }
  C_Vec &GetPos( void ){
	HSD_MtxGetTranslate(HSD_JObjGetMtxPtr( child ), &pos);
	//HSD_DmpVector( "", &pos );
	return pos;
  }
 private:
  HSD_JObj *parent, *child;
  Mtx ofst_mtx;
  C_Vec pos;
};
#endif
