#ifndef ___C_HEAP_H___
#define ___C_HEAP_H___

#include "..\Lib\ghmGcMem.h"

#if 0

//RpCnew̎𖳎B
//#define __new__
#define _NEW

extern "C" {
#include "dolphin.h"
  //łꂪ͕̂sB
#include "baselib.h"
}
//#include "common.h"

//n[hłRQoCg̃ACgvꍇ邽߁A
//RQoCgPʂłubN擾łȂ悤ɂĂB
//n[hɓnKv̂Ȃ̈̏ꍇAʂoB
//ōlĂB
class C_Heap {
 public:
  C_Heap(void* start, void* end);
  virtual ~C_Heap();

  //̃q[vƂɂ͂gB
  static C_Heap* GetCurrent(void)	{ return(current); }
  C_Heap* SetCurrent(void){
	C_Heap*			heap = current;
	current = this;
	return(heap);
  }

  static void* Alloc(size_t size);
  static void Free(void* p);

  //utility
  static s16 Set(s16 id){ s16 t = C_Heap::id; C_Heap::id = id; return t;}
  static const char* Set(const char* name){ 
	const char *n = C_Heap::name; C_Heap::name = name; return n; }

 private:
  enum BLOCK_ID{
	TOP_ID = -1,
	FREE_ID,
	DEFAULT_ID 
  };
  //ubNB
  //eubN̐擪ɂ͕KꂪB
  struct Block {
	u8				magic_no;	// }WbNio[
	u8				flag;	// gptO
	s16				id;			// ID
	u32				size;		// ubNTCY
	const char*		name;		// ubN
	Block*			prev;		// ÕubNւ̃|C^
	Block*			next;
	u32				pad[3];		// 32byteACg
  };
  static const u8		magic_no;
  static C_Heap*		current;
  static s16			id;	
  static const char*	name;
  Block					top;	// 擪ubN
  u32					size;	// q[vTCY

  static void SetFree( Block *b ){
	b->flag = false;
	b->id = C_Heap::FREE_ID;
	b->name = "FREE";
  }
  static void SetFree( Block *b, u32 s, Block *p, Block *n ){
	b->magic_no = C_Heap::magic_no;
	b->size = s;
	b->prev = p;
	b->next = n;
	SetFree( b );
  }


};

//ubNIDƖOZbgČɖ߂̃NXB
//ʂɎgȂĂǁAfobOɕ֗B
class C_UseHeap{
 public:
  C_UseHeap( s16 id, char* name ){
	c = C_Heap::GetCurrent();
	old_id = c->Set( id );
	old_name = c->Set( name );
  }
  ~C_UseHeap(){
	c->Set( old_id );
	c->Set( old_name );
  }
 private:
  C_Heap* c;
  s16 old_id;
  const char* old_name;
};

//ASẴt@CŃCN[h鎖ŁA
//new, delete肷B
//jSTLgꍇ́AOɃCN[h鎖B
inline void* operator new(size_t size)			{ return(C_Heap::Alloc(size)); }
inline void* operator new[](size_t size)		{ return(C_Heap::Alloc(size)); }
inline void* operator new(size_t size, void* p)	{ size = 0; return(p); }
inline void operator delete(void* p)			{ C_Heap::Free(p); }
inline void operator delete[](void* p)			{ C_Heap::Free(p); }

#endif

#endif

